/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/auxiliaryWindow","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(Z){for(var e=[],P=0,A=Z.length;P<A;P++)e[P]=te[Z[P]];return e};define(te[132],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function P(b,m,$){const u=A(b,m);if(u!==-1)return b[u]}e.$eb=P;function A(b,m,$=b.length-1){for(let u=$;u>=0;u--){const l=b[u];if(m(l))return u}return-1}e.$fb=A;function s(b,m){const $=M(b,m);return $===-1?void 0:b[$]}e.$gb=s;function M(b,m,$=0,u=b.length){let l=$,E=u;for(;l<E;){const h=Math.floor((l+E)/2);m(b[h])?l=h+1:E=h}return l-1}e.$hb=M;function D(b,m){const $=S(b,m);return $===b.length?void 0:b[$]}e.$ib=D;function S(b,m,$=0,u=b.length){let l=$,E=u;for(;l<E;){const h=Math.floor((l+E)/2);m(b[h])?E=h:l=h+1}return l}e.$jb=S;function f(b,m,$=0,u=b.length){const l=S(b,m,$,u);return l===b.length?-1:l}e.$kb=f;class c{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(c.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!m(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const $=M(this.e,m,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$lb=c;function g(b,m){if(b.length===0)return;let $=b[0];for(let u=1;u<b.length;u++){const l=b[u];m(l,$)>0&&($=l)}return $}e.$mb=g;function w(b,m){if(b.length===0)return;let $=b[0];for(let u=1;u<b.length;u++){const l=b[u];m(l,$)>=0&&($=l)}return $}e.$nb=w;function y(b,m){return g(b,($,u)=>-m($,u))}e.$ob=y;function d(b,m){if(b.length===0)return-1;let $=0;for(let u=1;u<b.length;u++){const l=b[u];m(l,b[$])>0&&($=u)}return $}e.$pb=d;function v(b,m){for(const $ of b){const u=m($);if(u!==void 0)return u}}e.$qb=v}),define(te[133],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function P(D,S){const f=Object.create(null);for(const c of D){const g=S(c);let w=f[g];w||(w=f[g]=[]),w.push(c)}return f}e.$J=P;function A(D,S){const f=[],c=[];for(const g of D)S.has(g)||f.push(g);for(const g of S)D.has(g)||c.push(g);return{removed:f,added:c}}e.$K=A;function s(D,S){const f=[],c=[];for(const[g,w]of D)S.has(g)||f.push(w);for(const[g,w]of S)D.has(g)||c.push(w);return{removed:f,added:c}}e.$L=s;function M(D,S){const f=new Set;for(const c of S)D.has(c)&&f.add(c);return f}e.$M=M}),define(te[134],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=e.$Qs=void 0;function P(S,f){const c=Math.pow(10,f);return Math.round(S*c)/c}class A{constructor(f,c,g,w=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=P(Math.max(Math.min(1,w),0),3)}static equals(f,c){return f.r===c.r&&f.g===c.g&&f.b===c.b&&f.a===c.a}}e.$Qs=A;class s{constructor(f,c,g,w){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,c),0),3),this.l=P(Math.max(Math.min(1,g),0),3),this.a=P(Math.max(Math.min(1,w),0),3)}static equals(f,c){return f.h===c.h&&f.s===c.s&&f.l===c.l&&f.a===c.a}static fromRGBA(f){const c=f.r/255,g=f.g/255,w=f.b/255,y=f.a,d=Math.max(c,g,w),v=Math.min(c,g,w);let b=0,m=0;const $=(v+d)/2,u=d-v;if(u>0){switch(m=Math.min($<=.5?u/(2*$):u/(2-2*$),1),d){case c:b=(g-w)/u+(g<w?6:0);break;case g:b=(w-c)/u+2;break;case w:b=(c-g)/u+4;break}b*=60,b=Math.round(b)}return new s(b,m,$,y)}static i(f,c,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?f+(c-f)*6*g:g<1/2?c:g<2/3?f+(c-f)*(2/3-g)*6:f}static toRGBA(f){const c=f.h/360,{s:g,l:w,a:y}=f;let d,v,b;if(g===0)d=v=b=w;else{const m=w<.5?w*(1+g):w+g-w*g,$=2*w-m;d=s.i($,m,c+1/3),v=s.i($,m,c),b=s.i($,m,c-1/3)}return new A(Math.round(d*255),Math.round(v*255),Math.round(b*255),y)}}e.$Rs=s;class M{constructor(f,c,g,w){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,c),0),3),this.v=P(Math.max(Math.min(1,g),0),3),this.a=P(Math.max(Math.min(1,w),0),3)}static equals(f,c){return f.h===c.h&&f.s===c.s&&f.v===c.v&&f.a===c.a}static fromRGBA(f){const c=f.r/255,g=f.g/255,w=f.b/255,y=Math.max(c,g,w),d=Math.min(c,g,w),v=y-d,b=y===0?0:v/y;let m;return v===0?m=0:y===c?m=((g-w)/v%6+6)%6:y===g?m=(w-c)/v+2:m=(c-g)/v+4,new M(Math.round(m*60),b,y,f.a)}static toRGBA(f){const{h:c,s:g,v:w,a:y}=f,d=w*g,v=d*(1-Math.abs(c/60%2-1)),b=w-d;let[m,$,u]=[0,0,0];return c<60?(m=d,$=v):c<120?(m=v,$=d):c<180?($=d,u=v):c<240?($=v,u=d):c<300?(m=v,u=d):c<=360&&(m=d,u=v),m=Math.round((m+b)*255),$=Math.round(($+b)*255),u=Math.round((u+b)*255),new A(m,$,u,y)}}e.$Ss=M;class D{static fromHex(f){return D.Format.CSS.parseHex(f)||D.red}static equals(f,c){return!f&&!c?!0:!f||!c?!1:f.equals(c)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof A)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof M)this.j=f,this.rgba=M.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&A.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&M.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=D.k(this.rgba.r),c=D.k(this.rgba.g),g=D.k(this.rgba.b),w=.2126*f+.7152*c+.0722*g;return P(w,4)}static k(f){const c=f/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(f){const c=this.getRelativeLuminance(),g=f.getRelativeLuminance();return c>g?(c+.05)/(g+.05):(g+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const c=this.getRelativeLuminance(),g=f.getRelativeLuminance();return c>g}isDarkerThan(f){const c=this.getRelativeLuminance(),g=f.getRelativeLuminance();return c<g}lighten(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:c,g,b:w,a:y}=this.rgba;return new D(new A(c,g,w,y*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const c=f.rgba,g=this.rgba.a,w=c.a,y=g+w*(1-g);if(y<1e-6)return D.transparent;const d=this.rgba.r*g/y+c.r*w*(1-g)/y,v=this.rgba.g*g/y+c.g*w*(1-g)/y,b=this.rgba.b*g/y+c.b*w*(1-g)/y;return new D(new A(d,v,b,y))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:c,g,b:w,a:y}=this.rgba;return new D(new A(f.rgba.r-y*(f.rgba.r-c),f.rgba.g-y*(f.rgba.g-g),f.rgba.b-y*(f.rgba.b-w),1))}flatten(...f){const c=f.reduceRight((g,w)=>D.o(w,g));return D.o(this,c)}static o(f,c){const g=1-f.rgba.a;return new D(new A(g*c.rgba.r+f.rgba.a*f.rgba.r,g*c.rgba.g+f.rgba.a*f.rgba.g,g*c.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(f,c,g){if(f.isLighterThan(c))return f;g=g||.5;const w=f.getRelativeLuminance(),y=c.getRelativeLuminance();return g=g*(y-w)/y,f.lighten(g)}static getDarkerColor(f,c,g){if(f.isDarkerThan(c))return f;g=g||.5;const w=f.getRelativeLuminance(),y=c.getRelativeLuminance();return g=g*(w-y)/w,f.darken(g)}static{this.white=new D(new A(255,255,255,1))}static{this.black=new D(new A(0,0,0,1))}static{this.red=new D(new A(255,0,0,1))}static{this.blue=new D(new A(0,0,255,1))}static{this.green=new D(new A(0,255,0,1))}static{this.cyan=new D(new A(0,255,255,1))}static{this.lightgrey=new D(new A(211,211,211,1))}static{this.transparent=new D(new A(0,0,0,0))}}e.$Ts=D,function(S){let f;(function(c){let g;(function(w){function y(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:S.Format.CSS.formatRGBA(i)}w.formatRGB=y;function d(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}w.formatRGBA=d;function v(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(i)}w.formatHSL=v;function b(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}w.formatHSLA=b;function m(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function $(i){return`#${m(i.rgba.r)}${m(i.rgba.g)}${m(i.rgba.b)}`}w.formatHex=$;function u(i,a=!1){return a&&i.rgba.a===1?S.Format.CSS.formatHex(i):`#${m(i.rgba.r)}${m(i.rgba.g)}${m(i.rgba.b)}${m(Math.round(i.rgba.a*255))}`}w.formatHexA=u;function l(i){return i.isOpaque()?S.Format.CSS.formatHex(i):S.Format.CSS.formatRGBA(i)}w.format=l;function E(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const o=16*h(i.charCodeAt(1))+h(i.charCodeAt(2)),t=16*h(i.charCodeAt(3))+h(i.charCodeAt(4)),n=16*h(i.charCodeAt(5))+h(i.charCodeAt(6));return new S(new A(o,t,n,1))}if(a===9){const o=16*h(i.charCodeAt(1))+h(i.charCodeAt(2)),t=16*h(i.charCodeAt(3))+h(i.charCodeAt(4)),n=16*h(i.charCodeAt(5))+h(i.charCodeAt(6)),r=16*h(i.charCodeAt(7))+h(i.charCodeAt(8));return new S(new A(o,t,n,r/255))}if(a===4){const o=h(i.charCodeAt(1)),t=h(i.charCodeAt(2)),n=h(i.charCodeAt(3));return new S(new A(16*o+o,16*t+t,16*n+n))}if(a===5){const o=h(i.charCodeAt(1)),t=h(i.charCodeAt(2)),n=h(i.charCodeAt(3)),r=h(i.charCodeAt(4));return new S(new A(16*o+o,16*t+t,16*n+n,(16*r+r)/255))}return null}w.parseHex=E;function h(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=c.CSS||(c.CSS={}))})(f=S.Format||(S.Format={}))}(D||(e.$Ts=D={}))}),define(te[54],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function P(D){return(S,f,c)=>{let g=null,w=null;if(typeof c.value=="function"?(g="value",w=c.value):typeof c.get=="function"&&(g="get",w=c.get),!w)throw new Error("not supported");c[g]=D(w,f)}}function A(D,S,f){let c=null,g=null;if(typeof f.value=="function"?(c="value",g=f.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(c="get",g=f.get),!g)throw new Error("not supported");const w=`$memoize$${S}`;f[c]=function(...y){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,y)}),this[w]}}e.$fh=A;function s(D,S,f){return P((c,g)=>{const w=`$debounce$${g}`,y=`$debounce$result$${g}`;return function(...d){this[y]||(this[y]=f?f():void 0),clearTimeout(this[w]),S&&(this[y]=S(this[y],...d),d=[this[y]]),this[w]=setTimeout(()=>{c.apply(this,d),this[y]=f?f():void 0},D)}})}e.$gh=s;function M(D,S,f){return P((c,g)=>{const w=`$throttle$timer$${g}`,y=`$throttle$result$${g}`,d=`$throttle$lastRun$${g}`,v=`$throttle$pending$${g}`;return function(...b){if(this[y]||(this[y]=f?f():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),S&&(this[y]=S(this[y],...b)),this[v])return;const m=this[d]+D;m<=Date.now()?(this[d]=Date.now(),c.apply(this,[this[y]]),this[y]=f?f():void 0):(this[v]=!0,this[w]=setTimeout(()=>{this[v]=!1,this[d]=Date.now(),c.apply(this,[this[y]]),this[y]=f?f():void 0},m-Date.now()))}})}e.$hh=M}),define(te[14],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class P{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?l.isErrorNoTelemetry(i)?new l(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(a=>{a(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$V=P,e.$W=new P;function A(h){e.$W.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=A;function s(h){if(!h||typeof h!="object")return!1;const i=h;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Y=s;function M(h){c(h)||e.$W.onUnexpectedError(h)}e.$Z=M;function D(h){c(h)||e.$W.onUnexpectedExternalError(h)}e.$1=D;function S(h){if(h instanceof Error){const{name:i,message:a}=h,o=h.stacktrace||h.stack;return{$isError:!0,name:i,message:a,stack:o,noTelemetry:l.isErrorNoTelemetry(h)}}return h}e.$2=S;const f="Canceled";function c(h){return h instanceof g?!0:h instanceof Error&&h.name===f&&h.message===f}e.$3=c;class g extends Error{constructor(){super(f),this.name=this.message}}e.$4=g;function w(){const h=new Error(f);return h.name=h.message,h}e.$5=w;function y(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.$6=y;function d(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.$7=d;class v extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=v;function b(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.$9=b;class m extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=m;class $ extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=$;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=u;class l extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof l)return i;const a=new l;return a.message=i.message,a.stack=i.stack,a}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=l;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$bb=E}),define(te[23],ie([0,1,14,132]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function s(W,T=0){return W[W.length-(1+T)]}e.$rb=s;function M(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.$sb=M;function D(W,T,V=(ce,de)=>ce===de){if(W===T)return!0;if(!W||!T||W.length!==T.length)return!1;for(let ce=0,de=W.length;ce<de;ce++)if(!V(W[ce],T[ce]))return!1;return!0}e.$tb=D;function S(W,T){const V=W.length-1;T<V&&(W[T]=W[V]),W.pop()}e.$ub=S;function f(W,T,V){return c(W.length,ce=>V(W[ce],T))}e.$vb=f;function c(W,T){let V=0,ce=W-1;for(;V<=ce;){const de=(V+ce)/2|0,ue=T(de);if(ue<0)V=de+1;else if(ue>0)ce=de-1;else return de}return-(V+1)}e.$wb=c;function g(W,T,V){if(W=W|0,W>=T.length)throw new TypeError("invalid index");const ce=T[Math.floor(T.length*Math.random())],de=[],ue=[],fe=[];for(const ye of T){const be=V(ye,ce);be<0?de.push(ye):be>0?ue.push(ye):fe.push(ye)}return W<de.length?g(W,de,V):W<de.length+fe.length?fe[0]:g(W-(de.length+fe.length),ue,V)}e.$xb=g;function w(W,T){const V=[];let ce;for(const de of W.slice(0).sort(T))!ce||T(ce[0],de)!==0?(ce=[de],V.push(ce)):ce.push(de);return V}e.$yb=w;function*y(W,T){let V,ce;for(const de of W)ce!==void 0&&T(ce,de)?V.push(de):(V&&(yield V),V=[de]),ce=de;V&&(yield V)}e.$zb=y;function d(W,T){for(let V=0;V<=W.length;V++)T(V===0?void 0:W[V-1],V===W.length?void 0:W[V])}e.$Ab=d;function v(W,T){for(let V=0;V<W.length;V++)T(V===0?void 0:W[V-1],W[V],V+1===W.length?void 0:W[V+1])}e.$Bb=v;function b(W,T,V){const ce=[];function de(ye,be,pe){if(be===0&&pe.length===0)return;const Ce=ce[ce.length-1];Ce&&Ce.start+Ce.deleteCount===ye?(Ce.deleteCount+=be,Ce.toInsert.push(...pe)):ce.push({start:ye,deleteCount:be,toInsert:pe})}let ue=0,fe=0;for(;;){if(ue===W.length){de(ue,0,T.slice(fe));break}if(fe===T.length){de(ue,W.length-ue,[]);break}const ye=W[ue],be=T[fe],pe=V(ye,be);pe===0?(ue+=1,fe+=1):pe<0?(de(ue,1,[]),ue+=1):pe>0&&(de(ue,0,[be]),fe+=1)}return ce}e.$Cb=b;function m(W,T,V){const ce=b(W,T,V),de=[],ue=[];for(const fe of ce)de.push(...W.slice(fe.start,fe.start+fe.deleteCount)),ue.push(...fe.toInsert);return{removed:de,added:ue}}e.$Db=m;function $(W,T,V){if(V===0)return[];const ce=W.slice(0,V).sort(T);return l(W,T,ce,V,W.length),ce}e.top=$;function u(W,T,V,ce,de){return V===0?Promise.resolve([]):new Promise((ue,fe)=>{(async()=>{const ye=W.length,be=W.slice(0,V).sort(T);for(let pe=V,Ce=Math.min(V+ce,ye);pe<ye;pe=Ce,Ce=Math.min(Ce+ce,ye)){if(pe>V&&await new Promise(We=>setTimeout(We)),de&&de.isCancellationRequested)throw new P.$4;l(W,T,be,pe,Ce)}return be})().then(ue,fe)})}e.$Fb=u;function l(W,T,V,ce,de){for(const ue=V.length;ce<de;ce++){const fe=W[ce];if(T(fe,V[ue-1])<0){V.pop();const ye=(0,A.$jb)(V,be=>T(fe,be)<0);V.splice(ye,0,fe)}}}function E(W){return W.filter(T=>!!T)}e.$Gb=E;function h(W){let T=0;for(let V=0;V<W.length;V++)W[V]&&(W[T]=W[V],T+=1);W.length=T}e.$Hb=h;function i(W,T,V){W.splice(V,0,W.splice(T,1)[0])}e.$Ib=i;function a(W){return!Array.isArray(W)||W.length===0}e.$Jb=a;function o(W){return Array.isArray(W)&&W.length>0}e.$Kb=o;function t(W,T=V=>V){const V=new Set;return W.filter(ce=>{const de=T(ce);return V.has(de)?!1:(V.add(de),!0)})}e.$Lb=t;function n(W){const T=new Set;return V=>{const ce=W(V);return T.has(ce)?!1:(T.add(ce),!0)}}e.$Mb=n;function r(W,T){return W.length>0?W[0]:T}e.$Nb=r;function p(W,T){return W.length>0?W[W.length-1]:T}e.$Ob=p;function C(W,T,V=(ce,de)=>ce===de){let ce=0;for(let de=0,ue=Math.min(W.length,T.length);de<ue&&V(W[de],T[de]);de++)ce++;return ce}e.$Pb=C;function R(W){return[].concat(...W)}e.$Qb=R;function k(W,T){let V=typeof T=="number"?W:0;typeof T=="number"?V=W:(V=0,T=W);const ce=[];if(V<=T)for(let de=V;de<T;de++)ce.push(de);else for(let de=V;de>T;de--)ce.push(de);return ce}e.$Rb=k;function I(W,T,V){return W.reduce((ce,de)=>(ce[T(de)]=V?V(de):de,ce),Object.create(null))}e.$Sb=I;function L(W,T){return W.push(T),()=>N(W,T)}e.$Tb=L;function N(W,T){const V=W.indexOf(T);if(V>-1)return W.splice(V,1),T}e.$Ub=N;function z(W,T,V){const ce=W.slice(0,T),de=W.slice(T);return ce.concat(V,de)}e.$Vb=z;function ne(W,T){let V;if(typeof T=="number"){let ce=T;V=()=>{const de=Math.sin(ce++)*179426549;return de-Math.floor(de)}}else V=Math.random;for(let ce=W.length-1;ce>0;ce-=1){const de=Math.floor(V()*(ce+1)),ue=W[ce];W[ce]=W[de],W[de]=ue}}e.$Wb=ne;function _(W,T){const V=W.indexOf(T);V>-1&&(W.splice(V,1),W.unshift(T))}e.$Xb=_;function ae(W,T){const V=W.indexOf(T);V>-1&&(W.splice(V,1),W.push(T))}e.$Yb=ae;function se(W,T){for(const V of T)W.push(V)}e.$Zb=se;function oe(W,T){return Array.isArray(W)?W.map(T):T(W)}e.$1b=oe;function J(W){return Array.isArray(W)?W:[W]}e.$2b=J;function K(W){return W[Math.floor(Math.random()*W.length)]}e.$3b=K;function G(W,T,V){const ce=q(W,T),de=W.length,ue=V.length;W.length=de+ue;for(let fe=de-1;fe>=ce;fe--)W[fe+ue]=W[fe];for(let fe=0;fe<ue;fe++)W[fe+ce]=V[fe]}e.$4b=G;function U(W,T,V,ce){const de=q(W,T);let ue=W.splice(de,V);return ue===void 0&&(ue=[]),G(W,de,ce),ue}e.$5b=U;function q(W,T){return T<0?Math.max(T+W.length,0):Math.min(T,W.length)}var X;(function(W){function T(ue){return ue<0}W.isLessThan=T;function V(ue){return ue<=0}W.isLessThanOrEqual=V;function ce(ue){return ue>0}W.isGreaterThan=ce;function de(ue){return ue===0}W.isNeitherLessOrGreaterThan=de,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(X||(e.CompareResult=X={}));function H(W,T){return(V,ce)=>T(W(V),W(ce))}e.$6b=H;function Q(...W){return(T,V)=>{for(const ce of W){const de=ce(T,V);if(!X.isNeitherLessOrGreaterThan(de))return de}return X.neitherLessOrGreaterThan}}e.$7b=Q;const re=(W,T)=>W-T;e.$8b=re;const F=(W,T)=>(0,e.$8b)(W?1:0,T?1:0);e.$9b=F;function O(W){return(T,V)=>-W(T,V)}e.$0b=O;class j{constructor(T){this.g=T,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(T){let V=this.c;for(;V<this.g.length&&T(this.g[V]);)V++;const ce=V===this.c?null:this.g.slice(this.c,V);return this.c=V,ce}takeFromEndWhile(T){let V=this.d;for(;V>=0&&T(this.g[V]);)V--;const ce=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,ce}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const T=this.g[this.c];return this.c++,T}removeLast(){const T=this.g[this.d];return this.d--,T}takeCount(T){const V=this.g.slice(this.c,this.c+T);return this.c+=T,V}}e.$$b=j;class B{static{this.empty=new B(T=>{})}constructor(T){this.iterate=T}forEach(T){this.iterate(V=>(T(V),!0))}toArray(){const T=[];return this.iterate(V=>(T.push(V),!0)),T}filter(T){return new B(V=>this.iterate(ce=>T(ce)?V(ce):!0))}map(T){return new B(V=>this.iterate(ce=>V(T(ce))))}some(T){let V=!1;return this.iterate(ce=>(V=T(ce),!V)),V}findFirst(T){let V;return this.iterate(ce=>T(ce)?(V=ce,!1):!0),V}findLast(T){let V;return this.iterate(ce=>(T(ce)&&(V=ce),!0)),V}findLastMaxBy(T){let V,ce=!0;return this.iterate(de=>((ce||X.isGreaterThan(T(de,V)))&&(ce=!1,V=de),!0)),V}}e.$_b=B}),define(te[135],ie([0,1,14]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function A(f,c){if(!f)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=A;function s(f,c="Unreachable"){throw new Error(c)}e.$3c=s;function M(f){if(!f)throw new P.$bb("Assertion Failed")}e.$4c=M;function D(f){if(!f()){debugger;f(),(0,P.$Z)(new P.$bb("Assertion Failed"))}}e.$5c=D;function S(f,c){let g=0;for(;g<f.length-1;){const w=f[g],y=f[g+1];if(!c(w,y))return!1;g++}return!0}e.$6c=S}),define(te[83],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function P(A){const s=this;let M=!1,D;return function(){return M||(M=!0,D=A.apply(s,arguments)),D}}e.$cb=P}),define(te[70],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(A){function s(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}A.is=s;const M=Object.freeze([]);function D(){return M}A.empty=D;function*S(h){yield h}A.single=S;function f(h){return s(h)?h:S(h)}A.wrap=f;function c(h){return h||M}A.from=c;function*g(h){for(let i=h.length-1;i>=0;i--)yield h[i]}A.reverse=g;function w(h){return!h||h[Symbol.iterator]().next().done===!0}A.isEmpty=w;function y(h){return h[Symbol.iterator]().next().value}A.first=y;function d(h,i){for(const a of h)if(i(a))return!0;return!1}A.some=d;function v(h,i){for(const a of h)if(i(a))return a}A.find=v;function*b(h,i){for(const a of h)i(a)&&(yield a)}A.filter=b;function*m(h,i){let a=0;for(const o of h)yield i(o,a++)}A.map=m;function*$(...h){for(const i of h)for(const a of i)yield a}A.concat=$;function u(h,i,a){let o=a;for(const t of h)o=i(o,t);return o}A.reduce=u;function*l(h,i,a=h.length){for(i<0&&(i+=h.length),a<0?a+=h.length:a>h.length&&(a=h.length);i<a;i++)yield h[i]}A.slice=l;function E(h,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,h];const o=h[Symbol.iterator]();for(let t=0;t<i;t++){const n=o.next();if(n.done)return[a,A.empty()];a.push(n.value)}return[a,{[Symbol.iterator](){return o}}]}A.consume=E})(P||(e.Iterable=P={}))}),define(te[44],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var s;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function D(i,a=!1){let o=0;const t=i.length;let n="",r=0,p=16,C=0;function R(_){let ae=0,se=0;for(;ae<_;){const oe=i.charCodeAt(o);if(oe>=48&&oe<=57)se=se*16+oe-48;else if(oe>=65&&oe<=70)se=se*16+oe-65+10;else if(oe>=97&&oe<=102)se=se*16+oe-97+10;else break;o++,ae++}return ae<_&&(se=-1),se}function k(_){o=_,n="",r=0,p=16,C=0}function I(){const _=o;if(i.charCodeAt(o)===48)o++;else for(o++;o<i.length&&c(i.charCodeAt(o));)o++;if(o<i.length&&i.charCodeAt(o)===46)if(o++,o<i.length&&c(i.charCodeAt(o)))for(o++;o<i.length&&c(i.charCodeAt(o));)o++;else return C=3,i.substring(_,o);let ae=o;if(o<i.length&&(i.charCodeAt(o)===69||i.charCodeAt(o)===101))if(o++,(o<i.length&&i.charCodeAt(o)===43||i.charCodeAt(o)===45)&&o++,o<i.length&&c(i.charCodeAt(o))){for(o++;o<i.length&&c(i.charCodeAt(o));)o++;ae=o}else C=3;return i.substring(_,ae)}function L(){let _="",ae=o;for(;;){if(o>=t){_+=i.substring(ae,o),C=2;break}const se=i.charCodeAt(o);if(se===34){_+=i.substring(ae,o),o++;break}if(se===92){if(_+=i.substring(ae,o),o++,o>=t){C=2;break}switch(i.charCodeAt(o++)){case 34:_+='"';break;case 92:_+="\\";break;case 47:_+="/";break;case 98:_+="\b";break;case 102:_+="\f";break;case 110:_+=`
`;break;case 114:_+="\r";break;case 116:_+="	";break;case 117:{const J=R(4);J>=0?_+=String.fromCharCode(J):C=4;break}default:C=5}ae=o;continue}if(se>=0&&se<=31)if(f(se)){_+=i.substring(ae,o),C=2;break}else C=6;o++}return _}function N(){if(n="",C=0,r=o,o>=t)return r=t,p=17;let _=i.charCodeAt(o);if(S(_)){do o++,n+=String.fromCharCode(_),_=i.charCodeAt(o);while(S(_));return p=15}if(f(_))return o++,n+=String.fromCharCode(_),_===13&&i.charCodeAt(o)===10&&(o++,n+=`
`),p=14;switch(_){case 123:return o++,p=1;case 125:return o++,p=2;case 91:return o++,p=3;case 93:return o++,p=4;case 58:return o++,p=6;case 44:return o++,p=5;case 34:return o++,n=L(),p=10;case 47:{const ae=o-1;if(i.charCodeAt(o+1)===47){for(o+=2;o<t&&!f(i.charCodeAt(o));)o++;return n=i.substring(ae,o),p=12}if(i.charCodeAt(o+1)===42){o+=2;const se=t-1;let oe=!1;for(;o<se;){if(i.charCodeAt(o)===42&&i.charCodeAt(o+1)===47){o+=2,oe=!0;break}o++}return oe||(o++,C=1),n=i.substring(ae,o),p=13}return n+=String.fromCharCode(_),o++,p=16}case 45:if(n+=String.fromCharCode(_),o++,o===t||!c(i.charCodeAt(o)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=I(),p=11;default:for(;o<t&&z(_);)o++,_=i.charCodeAt(o);if(r!==o){switch(n=i.substring(r,o),n){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return n+=String.fromCharCode(_),o++,p=16}}function z(_){if(S(_)||f(_))return!1;switch(_){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let _;do _=N();while(_>=12&&_<=15);return _}return{setPosition:k,getPosition:()=>o,scan:a?ne:N,getToken:()=>p,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>o-r,getTokenError:()=>C}}e.$Qm=D;function S(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function c(i){return i>=48&&i<=57}var g;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(g||(g={}));function w(i,a){const o=[],t=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function C(R,k,I,L){r.value=R,r.offset=k,r.length=I,r.type=L,r.colonOffset=void 0,n=r}try{l(i,{onObjectBegin:(R,k)=>{if(a<=R)throw t;n=void 0,p=a>R,o.push("")},onObjectProperty:(R,k,I)=>{if(a<k||(C(R,k,I,"property"),o[o.length-1]=R,a<=k+I))throw t},onObjectEnd:(R,k)=>{if(a<=R)throw t;n=void 0,o.pop()},onArrayBegin:(R,k)=>{if(a<=R)throw t;n=void 0,o.push(0)},onArrayEnd:(R,k)=>{if(a<=R)throw t;n=void 0,o.pop()},onLiteralValue:(R,k,I)=>{if(a<k||(C(R,k,I,h(R)),a<=k+I))throw t},onSeparator:(R,k,I)=>{if(a<=k)throw t;if(R===":"&&n&&n.type==="property")n.colonOffset=k,p=!1,n=void 0;else if(R===","){const L=o[o.length-1];typeof L=="number"?o[o.length-1]=L+1:(p=!0,o[o.length-1]=""),n=void 0}}})}catch(R){if(R!==t)throw R}return{path:o,previousNode:n,isAtPropertyKey:p,matches:R=>{let k=0;for(let I=0;k<R.length&&I<o.length;I++)if(R[k]===o[I]||R[k]==="*")k++;else if(R[k]!=="**")return!1;return k===R.length}}}e.$Rm=w;function y(i,a=[],o=M.DEFAULT){let t=null,n=[];const r=[];function p(R){Array.isArray(n)?n.push(R):t!==null&&(n[t]=R)}return l(i,{onObjectBegin:()=>{const R={};p(R),r.push(n),n=R,t=null},onObjectProperty:R=>{t=R},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const R=[];p(R),r.push(n),n=R,t=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:p,onError:(R,k,I)=>{a.push({error:R,offset:k,length:I})}},o),n[0]}e.$Sm=y;function d(i,a=[],o=M.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(R){t.type==="property"&&(t.length=R-t.offset,t=t.parent)}function r(R){return t.children.push(R),R}l(i,{onObjectBegin:R=>{t=r({type:"object",offset:R,length:-1,parent:t,children:[]})},onObjectProperty:(R,k,I)=>{t=r({type:"property",offset:k,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:R,offset:k,length:I,parent:t})},onObjectEnd:(R,k)=>{t.length=R+k-t.offset,t=t.parent,n(R+k)},onArrayBegin:(R,k)=>{t=r({type:"array",offset:R,length:-1,parent:t,children:[]})},onArrayEnd:(R,k)=>{t.length=R+k-t.offset,t=t.parent,n(R+k)},onLiteralValue:(R,k,I)=>{r({type:h(R),offset:k,length:I,parent:t,value:R}),n(k+I)},onSeparator:(R,k,I)=>{t.type==="property"&&(R===":"?t.colonOffset=k:R===","&&n(k))},onError:(R,k,I)=>{a.push({error:R,offset:k,length:I})}},o);const C=t.children[0];return C&&delete C.parent,C}e.$Tm=d;function v(i,a){if(!i)return;let o=i;for(const t of a)if(typeof t=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let n=!1;for(const r of o.children)if(Array.isArray(r.children)&&r.children[0].value===t){o=r.children[1],n=!0;break}if(!n)return}else{const n=t;if(o.type!=="array"||n<0||!Array.isArray(o.children)||n>=o.children.length)return;o=o.children[n]}return o}e.$Um=v;function b(i){if(!i.parent||!i.parent.children)return[];const a=b(i.parent);if(i.parent.type==="property"){const o=i.parent.children[0].value;a.push(o)}else if(i.parent.type==="array"){const o=i.parent.children.indexOf(i);o!==-1&&a.push(o)}return a}e.$Vm=b;function m(i){switch(i.type){case"array":return i.children.map(m);case"object":{const a=Object.create(null);for(const o of i.children){const t=o.children[1];t&&(a[o.children[0].value]=m(t))}return a}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$Wm=m;function $(i,a,o=!1){return a>=i.offset&&a<i.offset+i.length||o&&a===i.offset+i.length}e.$Xm=$;function u(i,a,o=!1){if($(i,a,o)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=a;n++){const r=u(t[n],a,o);if(r)return r}return i}}e.$Ym=u;function l(i,a,o=M.DEFAULT){const t=D(i,!1);function n(H){return H?()=>H(t.getTokenOffset(),t.getTokenLength()):()=>!0}function r(H){return H?Q=>H(Q,t.getTokenOffset(),t.getTokenLength()):()=>!0}const p=n(a.onObjectBegin),C=r(a.onObjectProperty),R=n(a.onObjectEnd),k=n(a.onArrayBegin),I=n(a.onArrayEnd),L=r(a.onLiteralValue),N=r(a.onSeparator),z=n(a.onComment),ne=r(a.onError),_=o&&o.disallowComments,ae=o&&o.allowTrailingComma;function se(){for(;;){const H=t.scan();switch(t.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:_||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(H){case 12:case 13:_?oe(10):z();break;case 16:oe(1);break;case 15:case 14:break;default:return H}}}function oe(H,Q=[],re=[]){if(ne(H),Q.length+re.length>0){let F=t.getToken();for(;F!==17;){if(Q.indexOf(F)!==-1){se();break}else if(re.indexOf(F)!==-1)break;F=se()}}}function J(H){const Q=t.getTokenValue();return H?L(Q):C(Q),se(),!0}function K(){switch(t.getToken()){case 11:{let H=0;try{H=JSON.parse(t.getTokenValue()),typeof H!="number"&&(oe(2),H=0)}catch{oe(2)}L(H);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return se(),!0}function G(){return t.getToken()!==10?(oe(3,[],[2,5]),!1):(J(!1),t.getToken()===6?(N(":"),se(),X()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function U(){p(),se();let H=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(H||oe(4,[],[]),N(","),se(),t.getToken()===2&&ae)break}else H&&oe(6,[],[]);G()||oe(4,[],[2,5]),H=!0}return R(),t.getToken()!==2?oe(7,[2],[]):se(),!0}function q(){k(),se();let H=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(H||oe(4,[],[]),N(","),se(),t.getToken()===4&&ae)break}else H&&oe(6,[],[]);X()||oe(4,[],[4,5]),H=!0}return I(),t.getToken()!==4?oe(8,[4],[]):se(),!0}function X(){switch(t.getToken()){case 3:return q();case 1:return U();case 10:return J(!0);default:return K()}}return se(),t.getToken()===17?o.allowEmptyContent?!0:(oe(4,[],[]),!1):X()?(t.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.$Zm=l;function E(i,a){const o=D(i),t=[];let n,r=0,p;do switch(p=o.getPosition(),n=o.scan(),n){case 12:case 13:case 17:r!==p&&t.push(i.substring(r,p)),a!==void 0&&t.push(o.getTokenValue().replace(/[^\r\n]/g,a)),r=o.getPosition();break}while(n!==17);return t.join("")}e.$1m=E;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$2m=h}),define(te[136],ie([0,1,44]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VS=e.$US=e.$TS=e.$SS=void 0;function A(c,g,w){let y,d,v,b,m;if(g){for(b=g.offset,m=b+g.length,v=b;v>0&&!f(c,v-1);)v--;let p=m;for(;p<c.length&&!f(c,p);)p++;d=c.substring(v,p),y=D(d,w)}else d=c,y=0,v=0,b=0,m=c.length;const $=S(w,c);let u=!1,l=0,E;w.insertSpaces?E=M(" ",w.tabSize||4):E="	";const h=(0,P.$Qm)(d,!1);let i=!1;function a(){return $+M(E,y+l)}function o(){let p=h.scan();for(u=!1;p===15||p===14;)u=u||p===14,p=h.scan();return i=p===16||h.getTokenError()!==0,p}const t=[];function n(p,C,R){!i&&C<m&&R>b&&c.substring(C,R)!==p&&t.push({offset:C,length:R-C,content:p})}let r=o();if(r!==17){const p=h.getTokenOffset()+v,C=M(E,y);n(C,v,p)}for(;r!==17;){let p=h.getTokenOffset()+h.getTokenLength()+v,C=o(),R="";for(;!u&&(C===12||C===13);){const I=h.getTokenOffset()+v;n(" ",p,I),p=h.getTokenOffset()+h.getTokenLength()+v,R=C===12?a():"",C=o()}if(C===2)r!==1&&(l--,R=a());else if(C===4)r!==3&&(l--,R=a());else{switch(r){case 3:case 1:l++,R=a();break;case 5:case 12:R=a();break;case 13:u?R=a():R=" ";break;case 6:R=" ";break;case 10:if(C===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:C===12||C===13?R=" ":C!==5&&C!==17&&(i=!0);break;case 16:i=!0;break}u&&(C===12||C===13)&&(R=a())}const k=h.getTokenOffset()+v;n(R,p,k),r=C}return t}e.$SS=A;function s(c,g){const w=JSON.stringify(c,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?w.replace(/\r\n|\r|\n/g,g.eol):w}e.$TS=s;function M(c,g){let w="";for(let y=0;y<g;y++)w+=c;return w}function D(c,g){let w=0,y=0;const d=g.tabSize||4;for(;w<c.length;){const v=c.charAt(w);if(v===" ")y++;else if(v==="	")y+=d;else break;w++}return Math.floor(y/d)}function S(c,g){for(let w=0;w<g.length;w++){const y=g.charAt(w);if(y==="\r")return w+1<g.length&&g.charAt(w+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return c&&c.eol||`
`}e.$US=S;function f(c,g){return`\r
`.indexOf(c.charAt(g))!==-1}e.$VS=f}),define(te[137],ie([0,1,44,136]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1S=e.$ZS=e.$YS=e.$XS=e.$WS=void 0;function s(c,g,w){return M(c,g,void 0,w)}e.$WS=s;function M(c,g,w,y,d){const v=g.slice(),b=[],m=(0,P.$Tm)(c,b);let $,u;for(;v.length>0&&(u=v.pop(),$=(0,P.$Um)(m,v),$===void 0&&w!==void 0);)typeof u=="string"?w={[u]:w}:w=[w];if($)if($.type==="object"&&typeof u=="string"&&Array.isArray($.children)){const l=(0,P.$Um)($,[u]);if(l!==void 0)if(w===void 0){if(!l.parent)throw new Error("Malformed AST");const E=$.children.indexOf(l.parent);let h,i=l.parent.offset+l.parent.length;if(E>0){const a=$.children[E-1];h=a.offset+a.length}else h=$.offset+1,$.children.length>1&&(i=$.children[1].offset);return D(c,{offset:h,length:i-h,content:""},y)}else return D(c,{offset:l.offset,length:l.length,content:JSON.stringify(w)},y);else{if(w===void 0)return[];const E=`${JSON.stringify(u)}: ${JSON.stringify(w)}`,h=d?d($.children.map(a=>a.children[0].value)):$.children.length;let i;if(h>0){const a=$.children[h-1];i={offset:a.offset+a.length,length:0,content:","+E}}else $.children.length===0?i={offset:$.offset+1,length:0,content:E}:i={offset:$.offset+1,length:0,content:E+","};return D(c,i,y)}}else if($.type==="array"&&typeof u=="number"&&Array.isArray($.children))if(w!==void 0){const l=`${JSON.stringify(w)}`;let E;if($.children.length===0||u===0)E={offset:$.offset+1,length:0,content:$.children.length===0?l:l+","};else{const h=u===-1||u>$.children.length?$.children.length:u,i=$.children[h-1];E={offset:i.offset+i.length,length:0,content:","+l}}return D(c,E,y)}else{const l=u,E=$.children[l];let h;if($.children.length===1)h={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===l){const i=$.children[l-1],a=i.offset+i.length,o=$.offset+$.length;h={offset:a,length:o-2-a,content:""}}else h={offset:E.offset,length:$.children[l+1].offset-E.offset,content:""};return D(c,h,y)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${$.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return D(c,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(w)},y)}}e.$XS=M;function D(c,g,w){let y=S(c,g),d=g.offset,v=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;d>0&&!(0,A.$VS)(y,d-1);)d--;for(;v<y.length&&!(0,A.$VS)(y,v);)v++}const b=(0,A.$SS)(y,{offset:d,length:v-d},w);for(let $=b.length-1;$>=0;$--){const u=b[$];y=S(y,u),d=Math.min(d,u.offset),v=Math.max(v,u.offset+u.length),v+=u.content.length-u.length}const m=c.length-(y.length-v)-d;return[{offset:d,length:m,content:y.substring(d,v)}]}e.$YS=D;function S(c,g){return c.substring(0,g.offset)+g.content+c.substring(g.offset+g.length)}e.$ZS=S;function f(c,g){const w=g.slice(0).sort((d,v)=>{const b=d.offset-v.offset;return b===0?d.length-v.length:b});let y=c.length;for(let d=w.length-1;d>=0;d--){const v=w[d];if(v.offset+v.length<=y)c=S(c,v);else throw new Error("Overlapping edit");y=v.offset}return c}e.$1S=f}),define(te[71],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=P}),define(te[101],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(M){this.element=M,this.next=P.Undefined,this.prev=P.Undefined}}class A{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let M=this.a;for(;M!==P.Undefined;){const D=M.next;M.prev=P.Undefined,M.next=P.Undefined,M=D}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,D){const S=new P(M);if(this.a===P.Undefined)this.a=S,this.b=S;else if(D){const c=this.b;this.b=S,S.prev=c,c.next=S}else{const c=this.a;this.a=S,S.next=c,c.prev=S}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(S))}}shift(){if(this.a!==P.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==P.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==P.Undefined&&M.next!==P.Undefined){const D=M.prev;D.next=M.next,M.next.prev=D}else M.prev===P.Undefined&&M.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):M.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):M.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==P.Undefined;)yield M.element,M=M.next}}e.$1c=A}),define(te[31],ie([0,1]),function(Z,e){"use strict";var P,A,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function M(u,l,E){let h=u.get(l);return h===void 0&&(h=E,u.set(l,h)),h}e.$wc=M;function D(u){const l=[];return u.forEach((E,h)=>{l.push(`${h} => ${E}`)}),`Map(${u.size}) {${l.join(", ")}}`}e.$xc=D;function S(u){const l=[];return u.forEach(E=>{l.push(E)}),`Set(${u.size}) {${l.join(", ")}}`}e.$yc=S;class f{constructor(l,E){this.uri=l,this.value=E}}function c(u){return Array.isArray(u)}class g{static{this.a=l=>l.toString()}constructor(l,E){if(this[P]="ResourceMap",l instanceof g)this.b=new Map(l.b),this.c=E??g.a;else if(c(l)){this.b=new Map,this.c=E??g.a;for(const[h,i]of l)this.set(h,i)}else this.b=new Map,this.c=l??g.a}set(l,E){return this.b.set(this.c(l),new f(l,E)),this}get(l){return this.b.get(this.c(l))?.value}has(l){return this.b.has(this.c(l))}get size(){return this.b.size}clear(){this.b.clear()}delete(l){return this.b.delete(this.c(l))}forEach(l,E){typeof E<"u"&&(l=l.bind(E));for(const[h,i]of this.b)l(i.value,i.uri,this)}*values(){for(const l of this.b.values())yield l.value}*keys(){for(const l of this.b.values())yield l.uri}*entries(){for(const l of this.b.values())yield[l.uri,l.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.b)yield[l.uri,l.value]}}e.$zc=g;class w{constructor(l,E){this[A]="ResourceSet",!l||typeof l=="function"?this.a=new g(l):(this.a=new g(E),l.forEach(this.add,this))}get size(){return this.a.size}add(l){return this.a.set(l,l),this}clear(){this.a.clear()}delete(l){return this.a.delete(l)}forEach(l,E){this.a.forEach((h,i)=>l.call(E,i,i,this))}has(l){return this.a.has(l)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=w;var y;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class d{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(l){return this.a.has(l)}get(l,E=0){const h=this.a.get(l);if(h)return E!==0&&this.j(h,E),h.value}set(l,E,h=0){let i=this.a.get(l);if(i)i.value=E,h!==0&&this.j(i,h);else{switch(i={key:l,value:E,next:void 0,previous:void 0},h){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(l,i),this.d++}return this}delete(l){return!!this.remove(l)}remove(l){const E=this.a.get(l);if(E)return this.a.delete(l),this.i(E),this.d--,E.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const l=this.b;return this.a.delete(l.key),this.i(l),this.d--,l.value}forEach(l,E){const h=this.e;let i=this.b;for(;i;){if(E?l.bind(E)(i.value,i.key,this):l(i.value,i.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const l=this,E=this.e;let h=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(h){const a={value:h.key,done:!1};return h=h.next,a}else return{value:void 0,done:!0}}};return i}values(){const l=this,E=this.e;let h=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(h){const a={value:h.value,done:!1};return h=h.next,a}else return{value:void 0,done:!0}}};return i}entries(){const l=this,E=this.e;let h=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(h){const a={value:[h.key,h.value],done:!1};return h=h.next,a}else return{value:void 0,done:!0}}};return i}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(l){if(l>=this.size)return;if(l===0){this.clear();return}let E=this.b,h=this.size;for(;E&&h>l;)this.a.delete(E.key),E=E.next,h--;this.b=E,this.d=h,E&&(E.previous=void 0),this.e++}g(l){if(!this.b&&!this.c)this.c=l;else if(this.b)l.next=this.b,this.b.previous=l;else throw new Error("Invalid list");this.b=l,this.e++}h(l){if(!this.b&&!this.c)this.b=l;else if(this.c)l.previous=this.c,this.c.next=l;else throw new Error("Invalid list");this.c=l,this.e++}i(l){if(l===this.b&&l===this.c)this.b=void 0,this.c=void 0;else if(l===this.b){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.b=l.next}else if(l===this.c){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.c=l.previous}else{const E=l.next,h=l.previous;if(!E||!h)throw new Error("Invalid list");E.previous=h,h.next=E}l.next=void 0,l.previous=void 0,this.e++}j(l,E){if(!this.b||!this.c)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(l===this.b)return;const h=l.next,i=l.previous;l===this.c?(i.next=void 0,this.c=i):(h.previous=i,i.next=h),l.previous=void 0,l.next=this.b,this.b.previous=l,this.b=l,this.e++}else if(E===2){if(l===this.c)return;const h=l.next,i=l.previous;l===this.b?(h.previous=void 0,this.b=h):(h.previous=i,i.next=h),l.next=void 0,l.previous=this.c,this.c.next=l,this.c=l,this.e++}}}toJSON(){const l=[];return this.forEach((E,h)=>{l.push([h,E])}),l}fromJSON(l){this.clear();for(const[E,h]of l)this.set(E,h)}}e.$Bc=d;class v extends d{constructor(l,E=1){super(),this.k=l,this.l=Math.min(Math.max(0,E),1)}get limit(){return this.k}set limit(l){this.k=l,this.m()}get ratio(){return this.l}set ratio(l){this.l=Math.min(Math.max(0,l),1),this.m()}get(l,E=2){return super.get(l,E)}peek(l){return super.get(l,0)}set(l,E){return super.set(l,E,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=v;class b{constructor(){this.a=new Map}add(l){return this.a.set(l,(this.a.get(l)||0)+1),this}delete(l){let E=this.a.get(l)||0;return E===0?!1:(E--,E===0?this.a.delete(l):this.a.set(l,E),!0)}has(l){return this.a.has(l)}}e.$Dc=b;class m{constructor(l){if(this.a=new Map,this.b=new Map,l)for(const[E,h]of l)this.set(E,h)}clear(){this.a.clear(),this.b.clear()}set(l,E){this.a.set(l,E),this.b.set(E,l)}get(l){return this.a.get(l)}getKey(l){return this.b.get(l)}delete(l){const E=this.a.get(l);return E===void 0?!1:(this.a.delete(l),this.b.delete(E),!0)}forEach(l,E){this.a.forEach((h,i)=>{l.call(E,h,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=m;class ${constructor(){this.a=new Map}add(l,E){let h=this.a.get(l);h||(h=new Set,this.a.set(l,h)),h.add(E)}delete(l,E){const h=this.a.get(l);h&&(h.delete(E),h.size===0&&this.a.delete(l))}forEach(l,E){const h=this.a.get(l);h&&h.forEach(E)}get(l){const E=this.a.get(l);return E||new Set}}e.$Fc=$}),define(te[2],ie([0,1,23,133,31,83,70]),function(Z,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const S=!1;let f=null;class c{constructor(){this.b=new Map}static{this.a=0}c(I){let L=this.b.get(I);return L||(L={parent:null,source:null,isSingleton:!1,value:I,idx:c.a++},this.b.set(I,L)),L}trackDisposable(I){const L=this.c(I);L.source||(L.source=new Error().stack)}setParent(I,L){const N=this.c(I);N.parent=L}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,L){const N=L.get(I);if(N)return N;const z=I.parent?this.f(this.c(I.parent),L):I;return L.set(I,z),z}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,I).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(I=10,L){let N;if(L)N=L;else{const se=new Map,oe=[...this.b.values()].filter(K=>K.source!==null&&!this.f(K,se).isSingleton);if(oe.length===0)return;const J=new Set(oe.map(K=>K.value));if(N=oe.filter(K=>!(K.parent&&J.has(K.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function z(se){function oe(K,G){for(;K.length>0&&G.some(U=>typeof U=="string"?U===K[0]:K[0].match(U));)K.shift()}const J=se.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return oe(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const ne=new s.$Fc;for(const se of N){const oe=z(se);for(let J=0;J<=oe.length;J++)ne.add(oe.slice(0,J).join(`
`),se)}N.sort((0,P.$6b)(se=>se.idx,P.$8b));let _="",ae=0;for(const se of N.slice(0,I)){ae++;const oe=z(se),J=[];for(let K=0;K<oe.length;K++){let G=oe[K];G=`(shared with ${ne.get(oe.slice(0,K+1).join(`
`)).size}/${N.length} leaks) at ${G}`;const q=ne.get(oe.slice(0,K).join(`
`)),X=(0,A.$J)([...q].map(H=>z(H)[K]),H=>H);delete X[oe[K]];for(const[H,Q]of Object.entries(X))J.unshift(`    - stacktraces of ${Q.length} other leaks continue with ${H}`);J.unshift(G)}_+=`


==================== Leaking disposable ${ae}/${N.length}: ${se.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return N.length>I&&(_+=`


... and ${N.length-I} more leaking disposables

`),{leaks:N,details:_}}}e.$Gc=c;function g(k){f=k}if(e.$Hc=g,S){const k="__is_disposable_tracked__";g(new class{trackDisposable(I){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[k]||console.log(L)},3e3)}setParent(I,L){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsDisposed(I){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsSingleton(I){}})}function w(k){return f?.trackDisposable(k),k}e.$Ic=w;function y(k){f?.markAsDisposed(k)}e.$Jc=y;function d(k,I){f?.setParent(k,I)}function v(k,I){if(f)for(const L of k)f.setParent(L,I)}function b(k){return f?.markAsSingleton(k),k}e.$Kc=b;function m(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Lc=m;function $(k){if(D.Iterable.is(k)){const I=[];for(const L of k)if(L)try{L.dispose()}catch(N){I.push(N)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Mc=$;function u(k){for(const I of k)m(I)&&I.dispose();return[]}e.$Nc=u;function l(...k){const I=E(()=>$(k));return v(k,I),I}e.$Oc=l;function E(k){const I=w({dispose:(0,M.$cb)(()=>{y(I),k()})});return I}e.$Pc=E;class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,w(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return d(I,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),d(I,null))}}e.$Qc=h;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,w(this),d(this.q,this)}dispose(){y(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Rc=i;class a{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&d(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&d(I,null),I}}e.$Sc=a;class o{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=o;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(I){let L=I;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,y(this))},this}}e.$Uc=t;class n{constructor(){this.a=new Map}acquire(I,...L){let N=this.a.get(I);N||(N={counter:0,object:this.b(I,...L)},this.a.set(I,N));const{object:z}=N,ne=(0,M.$cb)(()=>{--N.counter===0&&(this.c(I,N.object),this.a.delete(I))});return N.counter++,{object:z,dispose:ne}}}e.$Vc=n;class r{constructor(I){this.a=I}async acquire(I,...L){const N=this.a.acquire(I,...L);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(z){throw N.dispose(),z}}}e.$Wc=r;class p{constructor(I){this.object=I}dispose(){}}e.$Xc=p;function C(k){const I=new h;try{k(I)}finally{I.dispose()}}e.$Yc=C;class R{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,L,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(I)?.dispose(),this.a.set(I,L)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=R}),define(te[84],ie([0,1,31]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nl=e.$ml=e.$ll=void 0;const A=new P.$Cc(1e4);function s(c){return f(c,"NFC",A)}e.$ll=s;const M=new P.$Cc(1e4);function D(c){return f(c,"NFD",M)}e.$ml=D;const S=/[^\u0000-\u0080]/;function f(c,g,w){if(!c)return c;const y=w.get(c);if(y)return y;let d;return S.test(c)?d=c.normalize(g):d=c,w.set(c,d),d}e.$nl=function(){const c=/[\u0300-\u036f]/g;return function(g){return D(g).replace(c,"")}}()}),define(te[138],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Nl=e.rot=e.$Ll=void 0;function P(S,f,c){return Math.min(Math.max(S,f),c)}e.$Ll=P;function A(S,f){return(f+S%f)%f}e.rot=A;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Nl=s;class M{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ol=M;class D{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const c=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pl=D}),function(){function Z(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function D(f){M.push(f,Date.now())}function S(){const f=[];for(let c=0;c<M.length;c+=2)f.push({name:M[c],startTime:M[c+1]});return f}return{mark:D,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(s+D.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=P(A))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var A in P)(typeof exports=="object"?exports:Z)[A]=P[A]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function P(A){if(e[A])return e[A].exports;var s=e[A]={i:A,l:!1,exports:{}};return Z[A].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=Z,P.c=e,P.d=function(A,s,M){P.o(A,s)||Object.defineProperty(A,s,{enumerable:!0,get:M})},P.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},P.t=function(A,s){if(1&s&&(A=P(A)),8&s||4&s&&typeof A=="object"&&A&&A.__esModule)return A;var M=Object.create(null);if(P.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:A}),2&s&&typeof A!="string")for(var D in A)P.d(M,D,function(S){return A[S]}.bind(null,D));return M},P.n=function(A){var s=A&&A.__esModule?function(){return A.default}:function(){return A};return P.d(s,"a",s),s},P.o=function(A,s){return Object.prototype.hasOwnProperty.call(A,s)},P.p="",P(P.s=0)}([function(Z,e,P){(function(A){var s;e=Z.exports=re,s=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],f=e.src=[],c=0,g=c++;f[g]="0|[1-9]\\d*";var w=c++;f[w]="[0-9]+";var y=c++;f[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;f[d]="("+f[g]+")\\.("+f[g]+")\\.("+f[g]+")";var v=c++;f[v]="("+f[w]+")\\.("+f[w]+")\\.("+f[w]+")";var b=c++;f[b]="(?:"+f[g]+"|"+f[y]+")";var m=c++;f[m]="(?:"+f[w]+"|"+f[y]+")";var $=c++;f[$]="(?:-("+f[b]+"(?:\\."+f[b]+")*))";var u=c++;f[u]="(?:-?("+f[m]+"(?:\\."+f[m]+")*))";var l=c++;f[l]="[0-9A-Za-z-]+";var E=c++;f[E]="(?:\\+("+f[l]+"(?:\\."+f[l]+")*))";var h=c++,i="v?"+f[d]+f[$]+"?"+f[E]+"?";f[h]="^"+i+"$";var a="[v=\\s]*"+f[v]+f[u]+"?"+f[E]+"?",o=c++;f[o]="^"+a+"$";var t=c++;f[t]="((?:<|>)?=?)";var n=c++;f[n]=f[w]+"|x|X|\\*";var r=c++;f[r]=f[g]+"|x|X|\\*";var p=c++;f[p]="[v=\\s]*("+f[r]+")(?:\\.("+f[r]+")(?:\\.("+f[r]+")(?:"+f[$]+")?"+f[E]+"?)?)?";var C=c++;f[C]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[u]+")?"+f[E]+"?)?)?";var R=c++;f[R]="^"+f[t]+"\\s*"+f[p]+"$";var k=c++;f[k]="^"+f[t]+"\\s*"+f[C]+"$";var I=c++;f[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=c++;f[L]="(?:~>?)";var N=c++;f[N]="(\\s*)"+f[L]+"\\s+",S[N]=new RegExp(f[N],"g");var z=c++;f[z]="^"+f[L]+f[p]+"$";var ne=c++;f[ne]="^"+f[L]+f[C]+"$";var _=c++;f[_]="(?:\\^)";var ae=c++;f[ae]="(\\s*)"+f[_]+"\\s+",S[ae]=new RegExp(f[ae],"g");var se=c++;f[se]="^"+f[_]+f[p]+"$";var oe=c++;f[oe]="^"+f[_]+f[C]+"$";var J=c++;f[J]="^"+f[t]+"\\s*("+a+")$|^$";var K=c++;f[K]="^"+f[t]+"\\s*("+i+")$|^$";var G=c++;f[G]="(\\s*)"+f[t]+"\\s*("+a+"|"+f[p]+")",S[G]=new RegExp(f[G],"g");var U=c++;f[U]="^\\s*("+f[p]+")\\s+-\\s+("+f[p]+")\\s*$";var q=c++;f[q]="^\\s*("+f[C]+")\\s+-\\s+("+f[C]+")\\s*$";var X=c++;f[X]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)s(H,f[H]),S[H]||(S[H]=new RegExp(f[H]));function Q(Y,le){if(Y instanceof re)return Y;if(typeof Y!="string"||Y.length>M||!(le?S[o]:S[h]).test(Y))return null;try{return new re(Y,le)}catch{return null}}function re(Y,le){if(Y instanceof re){if(Y.loose===le)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof re))return new re(Y,le);s("SemVer",Y,le),this.loose=le;var ge=Y.trim().match(le?S[o]:S[h]);if(!ge)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var De=+Re;if(De>=0&&De<D)return De}return Re}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=Q,e.valid=function(Y,le){var ge=Q(Y,le);return ge?ge.version:null},e.clean=function(Y,le){var ge=Q(Y.trim().replace(/^[=v]+/,""),le);return ge?ge.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(Y){return s("SemVer.compare",this.version,this.loose,Y),Y instanceof re||(Y=new re(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},re.prototype.compareMain=function(Y){return Y instanceof re||(Y=new re(Y,this.loose)),O(this.major,Y.major)||O(this.minor,Y.minor)||O(this.patch,Y.patch)},re.prototype.comparePre=function(Y){if(Y instanceof re||(Y=new re(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var le=0;do{var ge=this.prerelease[le],Re=Y.prerelease[le];if(s("prerelease compare",le,ge,Re),ge===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(ge===void 0)return-1;if(ge!==Re)return O(ge,Re)}while(++le)},re.prototype.inc=function(Y,le){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,le,ge,Re){typeof ge=="string"&&(Re=ge,ge=void 0);try{return new re(Y,ge).inc(le,Re).version}catch{return null}},e.diff=function(Y,le){if(T(Y,le))return null;var ge=Q(Y),Re=Q(le);if(ge.prerelease.length||Re.prerelease.length){for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Re[De])return"pre"+De;return"prerelease"}for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Re[De])return De},e.compareIdentifiers=O;var F=/^[0-9]+$/;function O(Y,le){var ge=F.test(Y),Re=F.test(le);return ge&&Re&&(Y=+Y,le=+le),ge&&!Re?-1:Re&&!ge?1:Y<le?-1:Y>le?1:0}function j(Y,le,ge){return new re(Y,ge).compare(new re(le,ge))}function B(Y,le,ge){return j(Y,le,ge)>0}function W(Y,le,ge){return j(Y,le,ge)<0}function T(Y,le,ge){return j(Y,le,ge)===0}function V(Y,le,ge){return j(Y,le,ge)!==0}function ce(Y,le,ge){return j(Y,le,ge)>=0}function de(Y,le,ge){return j(Y,le,ge)<=0}function ue(Y,le,ge,Re){var De;switch(le){case"===":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),De=Y===ge;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),De=Y!==ge;break;case"":case"=":case"==":De=T(Y,ge,Re);break;case"!=":De=V(Y,ge,Re);break;case">":De=B(Y,ge,Re);break;case">=":De=ce(Y,ge,Re);break;case"<":De=W(Y,ge,Re);break;case"<=":De=de(Y,ge,Re);break;default:throw new TypeError("Invalid operator: "+le)}return De}function fe(Y,le){if(Y instanceof fe){if(Y.loose===le)return Y;Y=Y.value}if(!(this instanceof fe))return new fe(Y,le);s("comparator",Y,le),this.loose=le,this.parse(Y),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(Y,le){return O(le,Y)},e.major=function(Y,le){return new re(Y,le).major},e.minor=function(Y,le){return new re(Y,le).minor},e.patch=function(Y,le){return new re(Y,le).patch},e.compare=j,e.compareLoose=function(Y,le){return j(Y,le,!0)},e.rcompare=function(Y,le,ge){return j(le,Y,ge)},e.sort=function(Y,le){return Y.sort(function(ge,Re){return e.compare(ge,Re,le)})},e.rsort=function(Y,le){return Y.sort(function(ge,Re){return e.rcompare(ge,Re,le)})},e.gt=B,e.lt=W,e.eq=T,e.neq=V,e.gte=ce,e.lte=de,e.cmp=ue,e.Comparator=fe;var ye={};function be(Y,le){if(Y instanceof be)return Y.loose===le?Y:new be(Y.raw,le);if(Y instanceof fe)return new be(Y.value,le);if(!(this instanceof be))return new be(Y,le);if(this.loose=le,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function pe(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function Ce(Y,le,ge,Re,De,Ne,Oe,ze,Te,x,he,me,ve){return((le=pe(ge)?"":pe(Re)?">="+ge+".0.0":pe(De)?">="+ge+"."+Re+".0":">="+le)+" "+(ze=pe(Te)?"":pe(x)?"<"+(+Te+1)+".0.0":pe(he)?"<"+Te+"."+(+x+1)+".0":me?"<="+Te+"."+x+"."+he+"-"+me:"<="+ze)).trim()}function We(Y,le){for(var ge=0;ge<Y.length;ge++)if(!Y[ge].test(le))return!1;if(le.prerelease.length){for(ge=0;ge<Y.length;ge++)if(s(Y[ge].semver),Y[ge].semver!==ye&&Y[ge].semver.prerelease.length>0){var Re=Y[ge].semver;if(Re.major===le.major&&Re.minor===le.minor&&Re.patch===le.patch)return!0}return!1}return!0}function $e(Y,le,ge){try{le=new be(le,ge)}catch{return!1}return le.test(Y)}function we(Y,le,ge,Re){var De,Ne,Oe,ze,Te;switch(Y=new re(Y,Re),le=new be(le,Re),ge){case">":De=B,Ne=de,Oe=W,ze=">",Te=">=";break;case"<":De=W,Ne=ce,Oe=B,ze="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(Y,le,Re))return!1;for(var x=0;x<le.set.length;++x){var he=le.set[x],me=null,ve=null;if(he.forEach(function(Ae){Ae.semver===ye&&(Ae=new fe(">=0.0.0")),me=me||Ae,ve=ve||Ae,De(Ae.semver,me.semver,Re)?me=Ae:Oe(Ae.semver,ve.semver,Re)&&(ve=Ae)}),me.operator===ze||me.operator===Te||(!ve.operator||ve.operator===ze)&&Ne(Y,ve.semver)||ve.operator===Te&&Oe(Y,ve.semver))return!1}return!0}fe.prototype.parse=function(Y){var le=this.loose?S[J]:S[K],ge=Y.match(le);if(!ge)throw new TypeError("Invalid comparator: "+Y);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new re(ge[2],this.loose):this.semver=ye},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(Y){return s("Comparator.test",Y,this.loose),this.semver===ye||(typeof Y=="string"&&(Y=new re(Y,this.loose)),ue(Y,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(Y,le){if(!(Y instanceof fe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(Y.value,le),$e(this.value,ge,le);if(Y.operator==="")return ge=new be(this.value,le),$e(Y.semver,ge,le);var Re=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Ne=this.semver.version===Y.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),ze=ue(this.semver,"<",Y.semver,le)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Te=ue(this.semver,">",Y.semver,le)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Re||De||Ne&&Oe||ze||Te},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Y){var le=this.loose;Y=Y.trim(),s("range",Y,le);var ge=le?S[q]:S[U];Y=Y.replace(ge,Ce),s("hyphen replace",Y),Y=Y.replace(S[G],"$1$2$3"),s("comparator trim",Y,S[G]),Y=(Y=(Y=Y.replace(S[N],"$1~")).replace(S[ae],"$1^")).split(/\s+/).join(" ");var Re=le?S[J]:S[K],De=Y.split(" ").map(function(Ne){return function(Oe,ze){return s("comp",Oe),Oe=function(Te,x){return Te.trim().split(/\s+/).map(function(he){return function(me,ve){s("caret",me,ve);var Ae=ve?S[oe]:S[se];return me.replace(Ae,function(Fe,Le,Ue,Be,He){var Ge;return s("caret",me,Fe,Le,Ue,Be,He),pe(Le)?Ge="":pe(Ue)?Ge=">="+Le+".0.0 <"+(+Le+1)+".0.0":pe(Be)?Ge=Le==="0"?">="+Le+"."+Ue+".0 <"+Le+"."+(+Ue+1)+".0":">="+Le+"."+Ue+".0 <"+(+Le+1)+".0.0":He?(s("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ge=Le==="0"?Ue==="0"?">="+Le+"."+Ue+"."+Be+He+" <"+Le+"."+Ue+"."+(+Be+1):">="+Le+"."+Ue+"."+Be+He+" <"+Le+"."+(+Ue+1)+".0":">="+Le+"."+Ue+"."+Be+He+" <"+(+Le+1)+".0.0"):(s("no pr"),Ge=Le==="0"?Ue==="0"?">="+Le+"."+Ue+"."+Be+" <"+Le+"."+Ue+"."+(+Be+1):">="+Le+"."+Ue+"."+Be+" <"+Le+"."+(+Ue+1)+".0":">="+Le+"."+Ue+"."+Be+" <"+(+Le+1)+".0.0"),s("caret return",Ge),Ge})}(he,x)}).join(" ")}(Oe,ze),s("caret",Oe),Oe=function(Te,x){return Te.trim().split(/\s+/).map(function(he){return function(me,ve){var Ae=ve?S[ne]:S[z];return me.replace(Ae,function(Fe,Le,Ue,Be,He){var Ge;return s("tilde",me,Fe,Le,Ue,Be,He),pe(Le)?Ge="":pe(Ue)?Ge=">="+Le+".0.0 <"+(+Le+1)+".0.0":pe(Be)?Ge=">="+Le+"."+Ue+".0 <"+Le+"."+(+Ue+1)+".0":He?(s("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ge=">="+Le+"."+Ue+"."+Be+He+" <"+Le+"."+(+Ue+1)+".0"):Ge=">="+Le+"."+Ue+"."+Be+" <"+Le+"."+(+Ue+1)+".0",s("tilde return",Ge),Ge})}(he,x)}).join(" ")}(Oe,ze),s("tildes",Oe),Oe=function(Te,x){return s("replaceXRanges",Te,x),Te.split(/\s+/).map(function(he){return function(me,ve){me=me.trim();var Ae=ve?S[k]:S[R];return me.replace(Ae,function(Fe,Le,Ue,Be,He,Ge){s("xRange",me,Fe,Le,Ue,Be,He,Ge);var xe=pe(Ue),Ye=xe||pe(Be),it=Ye||pe(He);return Le==="="&&it&&(Le=""),xe?Fe=Le===">"||Le==="<"?"<0.0.0":"*":Le&&it?(Ye&&(Be=0),it&&(He=0),Le===">"?(Le=">=",Ye?(Ue=+Ue+1,Be=0,He=0):it&&(Be=+Be+1,He=0)):Le==="<="&&(Le="<",Ye?Ue=+Ue+1:Be=+Be+1),Fe=Le+Ue+"."+Be+"."+He):Ye?Fe=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":it&&(Fe=">="+Ue+"."+Be+".0 <"+Ue+"."+(+Be+1)+".0"),s("xRange return",Fe),Fe})}(he,x)}).join(" ")}(Oe,ze),s("xrange",Oe),Oe=function(Te,x){return s("replaceStars",Te,x),Te.trim().replace(S[X],"")}(Oe,ze),s("stars",Oe),Oe}(Ne,le)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Ne){return!!Ne.match(Re)})),De=De.map(function(Ne){return new fe(Ne,le)})},be.prototype.intersects=function(Y,le){if(!(Y instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Re){return Y.set.some(function(De){return De.every(function(Ne){return Re.intersects(Ne,le)})})})})},e.toComparators=function(Y,le){return new be(Y,le).set.map(function(ge){return ge.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new re(Y,this.loose));for(var le=0;le<this.set.length;le++)if(We(this.set[le],Y))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(Y,le,ge){var Re=null,De=null;try{var Ne=new be(le,ge)}catch{return null}return Y.forEach(function(Oe){Ne.test(Oe)&&(Re&&De.compare(Oe)!==-1||(De=new re(Re=Oe,ge)))}),Re},e.minSatisfying=function(Y,le,ge){var Re=null,De=null;try{var Ne=new be(le,ge)}catch{return null}return Y.forEach(function(Oe){Ne.test(Oe)&&(Re&&De.compare(Oe)!==1||(De=new re(Re=Oe,ge)))}),Re},e.validRange=function(Y,le){try{return new be(Y,le).range||"*"}catch{return null}},e.ltr=function(Y,le,ge){return we(Y,le,"<",ge)},e.gtr=function(Y,le,ge){return we(Y,le,">",ge)},e.outside=we,e.prerelease=function(Y,le){var ge=Q(Y,le);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Y,le,ge){return Y=new be(Y,ge),le=new be(le,ge),Y.intersects(le)},e.coerce=function(Y){if(Y instanceof re)return Y;if(typeof Y!="string")return null;var le=Y.match(S[I]);return le==null?null:Q((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,P(1))},function(Z,e){var P,A,s=Z.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function S(m){if(P===setTimeout)return setTimeout(m,0);if((P===M||!P)&&setTimeout)return P=setTimeout,setTimeout(m,0);try{return P(m,0)}catch{try{return P.call(null,m,0)}catch{return P.call(this,m,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:M}catch{P=M}try{A=typeof clearTimeout=="function"?clearTimeout:D}catch{A=D}})();var f,c=[],g=!1,w=-1;function y(){g&&f&&(g=!1,f.length?c=f.concat(c):w=-1,c.length&&d())}function d(){if(!g){var m=S(y);g=!0;for(var $=c.length;$;){for(f=c,c=[];++w<$;)f&&f[w].run();w=-1,$=c.length}f=null,g=!1,function(u){if(A===clearTimeout)return clearTimeout(u);if((A===D||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(u);try{A(u)}catch{try{return A.call(null,u)}catch{return A.call(this,u)}}}(m)}}function v(m,$){this.fun=m,this.array=$}function b(){}s.nextTick=function(m){var $=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)$[u-1]=arguments[u];c.push(new v(m,$)),c.length!==1||g||S(d)},v.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=b,s.addListener=b,s.once=b,s.off=b,s.removeListener=b,s.removeAllListeners=b,s.emit=b,s.prependListener=b,s.prependOnceListener=b,s.listeners=function(m){return[]},s.binding=function(m){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(m){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(te[139],ie([0,1]),function(Z,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;class A{constructor(S,f,c){this.level=S,this.key=f,this.value=c,this.forward=[]}}const s=void 0;class M{constructor(S,f=2**16){this.comparator=S,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new A(this.c,s,s)}get size(){return this.f}clear(){this.e=new A(this.c,s,s),this.f=0}has(S){return!!M.g(this,S,this.comparator)}get(S){return M.g(this,S,this.comparator)?.value}set(S,f){return M.h(this,S,f,this.comparator)&&(this.f+=1),this}delete(S){const f=M.k(this,S,this.comparator);return f&&(this.f-=1),f}forEach(S,f){let c=this.e.forward[0];for(;c;)S.call(f,c.value,c.key,this),c=c.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",f=this.e.forward[0];for(;f;)S+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return S}static g(S,f,c){let g=S.e;for(let w=S.d-1;w>=0;w--)for(;g.forward[w]&&c(g.forward[w].key,f)<0;)g=g.forward[w];if(g=g.forward[0],g&&c(g.key,f)===0)return g}static h(S,f,c,g){const w=[];let y=S.e;for(let d=S.d-1;d>=0;d--){for(;y.forward[d]&&g(y.forward[d].key,f)<0;)y=y.forward[d];w[d]=y}if(y=y.forward[0],y&&g(y.key,f)===0)return y.value=c,!1;{const d=M.j(S);if(d>S.d){for(let v=S.d;v<d;v++)w[v]=S.e;S.d=d}y=new A(d,f,c);for(let v=0;v<d;v++)y.forward[v]=w[v].forward[v],w[v].forward[v]=y;return!0}}static j(S,f=.5){let c=1;for(;Math.random()<f&&c<S.c;)c+=1;return c}static k(S,f,c){const g=[];let w=S.e;for(let y=S.d-1;y>=0;y--){for(;w.forward[y]&&c(w.forward[y].key,f)<0;)w=w.forward[y];g[y]=w}if(w=w.forward[0],!w||c(w.key,f)!==0)return!1;for(let y=0;y<S.d&&g[y].forward[y]===w;y++)g[y].forward[y]=w.forward[y];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$vr=M}),define(te[72],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(M){return new A(M)}constructor(M){this.c=P&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Id=A}),define(te[3],ie([0,1,14,83,2,101,72]),function(Z,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.Event=void 0;const S=!1,f=!1;var c;(function(R){R.None=()=>s.$Rc.None;function k(ue){if(f){const{onDidAddListener:fe}=ue,ye=v.create();let be=0;ue.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ye.print()),fe?.()}}}function I(ue,fe){return K(ue,()=>{},0,void 0,!0,void 0,fe)}R.defer=I;function L(ue){return(fe,ye=null,be)=>{let pe=!1,Ce;return Ce=ue(We=>{if(!pe)return Ce?Ce.dispose():pe=!0,fe.call(ye,We)},null,be),pe&&Ce.dispose(),Ce}}R.once=L;function N(ue,fe,ye){return oe((be,pe=null,Ce)=>ue(We=>be.call(pe,fe(We)),null,Ce),ye)}R.map=N;function z(ue,fe,ye){return oe((be,pe=null,Ce)=>ue(We=>{fe(We),be.call(pe,We)},null,Ce),ye)}R.forEach=z;function ne(ue,fe,ye){return oe((be,pe=null,Ce)=>ue(We=>fe(We)&&be.call(pe,We),null,Ce),ye)}R.filter=ne;function _(ue){return ue}R.signal=_;function ae(...ue){return(fe,ye=null,be)=>{const pe=(0,s.$Oc)(...ue.map(Ce=>Ce(We=>fe.call(ye,We))));return J(pe,be)}}R.any=ae;function se(ue,fe,ye,be){let pe=ye;return N(ue,Ce=>(pe=fe(pe,Ce),pe),be)}R.reduce=se;function oe(ue,fe){let ye;const be={onWillAddFirstListener(){ye=ue(pe.fire,pe)},onDidRemoveLastListener(){ye?.dispose()}};fe||k(be);const pe=new l(be);return fe?.add(pe),pe.event}function J(ue,fe){return fe instanceof Array?fe.push(ue):fe&&fe.add(ue),ue}function K(ue,fe,ye=100,be=!1,pe=!1,Ce,We){let $e,we,Y,le=0,ge;const Re={leakWarningThreshold:Ce,onWillAddFirstListener(){$e=ue(Ne=>{le++,we=fe(we,Ne),be&&!Y&&(De.fire(we),we=void 0),ge=()=>{const Oe=we;we=void 0,Y=void 0,(!be||le>1)&&De.fire(Oe),le=0},typeof ye=="number"?(clearTimeout(Y),Y=setTimeout(ge,ye)):Y===void 0&&(Y=0,queueMicrotask(ge))})},onWillRemoveListener(){pe&&le>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,$e.dispose()}};We||k(Re);const De=new l(Re);return We?.add(De),De.event}R.debounce=K;function G(ue,fe=0,ye){return R.debounce(ue,(be,pe)=>be?(be.push(pe),be):[pe],fe,void 0,!0,void 0,ye)}R.accumulate=G;function U(ue,fe=(be,pe)=>be===pe,ye){let be=!0,pe;return ne(ue,Ce=>{const We=be||!fe(Ce,pe);return be=!1,pe=Ce,We},ye)}R.latch=U;function q(ue,fe,ye){return[R.filter(ue,fe,ye),R.filter(ue,be=>!fe(be),ye)]}R.split=q;function X(ue,fe=!1,ye=[],be){let pe=ye.slice(),Ce=ue(we=>{pe?pe.push(we):$e.fire(we)});be&&be.add(Ce);const We=()=>{pe?.forEach(we=>$e.fire(we)),pe=null},$e=new l({onWillAddFirstListener(){Ce||(Ce=ue(we=>$e.fire(we)),be&&be.add(Ce))},onDidAddFirstListener(){pe&&(fe?setTimeout(We):We())},onDidRemoveLastListener(){Ce&&Ce.dispose(),Ce=null}});return be&&be.add($e),$e.event}R.buffer=X;function H(ue,fe){return(be,pe,Ce)=>{const We=fe(new re);return ue(function($e){const we=We.evaluate($e);we!==Q&&be.call(pe,we)},void 0,Ce)}}R.chain=H;const Q=Symbol("HaltChainable");class re{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(ye=>(fe(ye),ye)),this}filter(fe){return this.f.push(ye=>fe(ye)?ye:Q),this}reduce(fe,ye){let be=ye;return this.f.push(pe=>(be=fe(be,pe),be)),this}latch(fe=(ye,be)=>ye===be){let ye=!0,be;return this.f.push(pe=>{const Ce=ye||!fe(pe,be);return ye=!1,be=pe,Ce?pe:Q}),this}evaluate(fe){for(const ye of this.f)if(fe=ye(fe),fe===Q)break;return fe}}function F(ue,fe,ye=be=>be){const be=(...$e)=>We.fire(ye(...$e)),pe=()=>ue.on(fe,be),Ce=()=>ue.removeListener(fe,be),We=new l({onWillAddFirstListener:pe,onDidRemoveLastListener:Ce});return We.event}R.fromNodeEventEmitter=F;function O(ue,fe,ye=be=>be){const be=(...$e)=>We.fire(ye(...$e)),pe=()=>ue.addEventListener(fe,be),Ce=()=>ue.removeEventListener(fe,be),We=new l({onWillAddFirstListener:pe,onDidRemoveLastListener:Ce});return We.event}R.fromDOMEventEmitter=O;function j(ue){return new Promise(fe=>L(ue)(fe))}R.toPromise=j;function B(ue){const fe=new l;return ue.then(ye=>{fe.fire(ye)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}R.fromPromise=B;function W(ue,fe){return fe(void 0),ue(ye=>fe(ye))}R.runAndSubscribe=W;function T(ue,fe){let ye=null;function be(Ce){ye?.dispose(),ye=new s.$Qc,fe(Ce,ye)}be(void 0);const pe=ue(Ce=>be(Ce));return(0,s.$Pc)(()=>{pe.dispose(),ye?.dispose()})}R.runAndSubscribeWithStore=T;class V{constructor(fe,ye){this._observable=fe,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};ye||k(be),this.emitter=new l(be),ye&&ye.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,ye){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ce(ue,fe){return new V(ue,fe).emitter.event}R.fromObservable=ce;function de(ue){return fe=>{let ye=0,be=!1;const pe={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(ue.reportChanges(),be&&(be=!1,fe()))},handlePossibleChange(){},handleChange(){be=!0}};return ue.addObserver(pe),ue.reportChanges(),{dispose(){ue.removeObserver(pe)}}}}R.fromObservableLight=de})(c||(e.Event=c={}));class g{static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${g.f++}`,g.all.add(this)}start(k){this.g=new D.$Id,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Kd=g;let w=-1;function y(R){const k=w;return w=R,{dispose(){w=k}}}e.$Ld=y;class d{constructor(k,I=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=I,this.g=0}dispose(){this.f?.clear()}check(k,I){const L=this.threshold;if(L<=0||I<L)return;this.f||(this.f=new Map);const N=this.f.get(k.value)||0;if(this.f.set(k.value,N+1),this.g-=1,this.g<=0){this.g=L*.5;let z,ne=0;for(const[_,ae]of this.f)(!z||ne<ae)&&(z=_,ne=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${ne}):`),console.warn(z)}return()=>{const z=this.f.get(k.value)||0;this.f.set(k.value,z-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class m{constructor(k){this.value=k,this.id=b++}}const $=2,u=(R,k)=>{if(R instanceof m)k(R);else for(let I=0;I<R.length;I++){const L=R[I];L&&k(L)}};class l{constructor(k){this.w=0,this.f=k,this.g=w>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new g(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const k=this.t;queueMicrotask(()=>{u(k,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,I,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Rc.None;if(this.m)return s.$Rc.None;I&&(k=k.bind(I));const N=new m(k);let z,ne;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=v.create(),z=this.g.check(N.stack,this.w+1)),S&&(N.stack=ne??v.create()),this.t?this.t instanceof m?(this.u??=new h,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const _=(0,s.$Pc)(()=>{z?.(),this.x(N)});return L instanceof s.$Qc?L.add(_):Array.isArray(L)&&L.push(_),_},this.q}x(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,L=I.indexOf(k);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[L]=void 0;const N=this.u.current===this;if(this.w*$<=I.length){let z=0;for(let ne=0;ne<I.length;ne++)I[ne]?I[z++]=I[ne]:N&&(this.u.end--,z<this.u.i&&this.u.i--);I.length=z}}y(k,I){if(!k)return;const L=this.f?.onListenerError||P.$Z;if(!L){k.value(I);return}try{k.value(I)}catch(N){L(N)}}z(k){const I=k.current.t;for(;k.i<k.end;)this.y(I[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,k);else{const I=this.u;I.enqueue(this,k,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Md=l;const E=()=>new h;e.$Nd=E;class h{constructor(){this.i=-1,this.end=0}enqueue(k,I,L){this.i=0,this.end=L,this.current=k,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends l{async fireAsync(k,I,L){if(this.t)for(this.h||(this.h=new M.$1c),u(this.t,N=>this.h.push([N.value,k]));this.h.size>0&&!I.isCancellationRequested;){const[N,z]=this.h.shift(),ne=[],_={...z,token:I,waitUntil:ae=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");L&&(ae=L(ae,N)),ne.push(ae)}};try{N(_)}catch(ae){(0,P.$Z)(ae);continue}Object.freeze(ne),await Promise.allSettled(ne).then(ae=>{for(const se of ae)se.status==="rejected"&&(0,P.$Z)(se.reason)})}}}e.$Od=i;class a extends l{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new M.$1c,this.A=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.A(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.w&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Pd=a;class o extends a{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Qd=o;class t extends l{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$Rd=t;class n{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const I={event:k,listener:null};this.h.push(I),this.g&&this.m(I);const L=()=>{this.g&&this.o(I);const N=this.h.indexOf(I);this.h.splice(N,1)};return(0,s.$Pc)((0,A.$cb)(L))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(I=>this.f.fire(I))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Sd=n;class r{constructor(k,I,L,N){this.f=new s.$Qc;const z=this.f.add(new n),ne=this.f.add(new s.$Zc);function _(ae){ne.set(ae,z.add(N(ae)))}for(const ae of k)_(ae);this.f.add(I(ae=>{_(ae)})),this.f.add(L(ae=>{ne.deleteAndDispose(ae)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Td=r;class p{constructor(){this.f=[]}wrapEvent(k){return(I,L,N)=>k(z=>{const ne=this.f[this.f.length-1];ne?ne.push(()=>I.call(L,z)):I.call(L,z)},void 0,N)}bufferEvents(k){const I=[];this.f.push(I);const L=k();return this.f.pop(),I.forEach(N=>N()),L}}e.$Ud=p;class C{constructor(){this.f=!1,this.g=c.None,this.h=s.$Rc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Vd=C}),define(te[22],ie([0,1,3]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.CancellationToken=void 0;const A=Object.freeze(function(S,f){const c=setTimeout(S.bind(f),0);return{dispose(){clearTimeout(c)}}});var s;(function(S){function f(c){return c===S.None||c===S.Cancelled||c instanceof M?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}S.isCancellationToken=f,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new P.$Md),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$Wd=D}),define(te[140],ie([0,1,22]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=void 0;class A{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new P.$Wd,f=this.b(S.token);return this.a={promise:f,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$ve=A;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const f=JSON.stringify(S);return this.b!==f&&(this.b=f,this.a=this.c(S)),this.a}}e.$we=s;class M{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const f=this.b(S);return this.a.set(S,f),f}}e.$xe=M}),define(te[62],ie([0,1,14,2]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function s(E){const h=E;return h?typeof h.read=="function":!1}e.$Xd=s;function M(E){const h=E;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$Yd=M;function D(E){const h=E;return h?M(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$Zd=D;function S(E,h){return new f(E,h)}e.$1d=S;class f{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,P.$Z)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let a;switch(h){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const o=a.indexOf(i);o>=0&&a.splice(o,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(E,h){const i=[];let a;for(;(a=E.read())!==null;)i.push(a);return h(i)}e.$2d=c;function g(E,h,i){const a=[];let o;for(;(o=E.read())!==null&&a.length<i;)a.push(o);return o===null&&a.length>0?h(a):{read:()=>{if(a.length>0)return a.shift();if(typeof o<"u"){const t=o;return o=void 0,t}return E.read()}}}e.$3d=g;function w(E,h){return new Promise((i,a)=>{const o=[];y(E,{onData:t=>{h&&o.push(t)},onError:t=>{h?a(t):i(void 0)},onEnd:()=>{i(h?h(o):void 0)}})})}e.$4d=w;function y(E,h,i){E.on("error",a=>{i?.isCancellationRequested||h.onError(a)}),E.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),E.on("data",a=>{i?.isCancellationRequested||h.onData(a)})}e.$5d=y;function d(E,h){return new Promise((i,a)=>{const o=new A.$Qc,t=[],n=C=>{if(t.push(C),t.length>h)return o.dispose(),E.pause(),i({stream:E,buffer:t,ended:!1})},r=C=>(o.dispose(),a(C)),p=()=>(o.dispose(),i({stream:E,buffer:t,ended:!0}));o.add((0,A.$Pc)(()=>E.removeListener("error",r))),E.on("error",r),o.add((0,A.$Pc)(()=>E.removeListener("end",p))),E.on("end",p),o.add((0,A.$Pc)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$6d=d;function v(E,h){const i=S(h);return i.end(E),i}e.$7d=v;function b(){const E=S(()=>{throw new Error("not supported")});return E.end(),E}e.$8d=b;function m(E){let h=!1;return{read:()=>h?null:(h=!0,E)}}e.$9d=m;function $(E,h,i){const a=S(i);return y(E,{onData:o=>a.write(h.data(o)),onError:o=>a.error(h.error?h.error(o):o),onEnd:()=>a.end()}),a}e.$0d=$;function u(E,h,i){let a=!1;return{read:()=>{const o=h.read();return a?o:(a=!0,o!==null?i([E,o]):E)}}}e.$$d=u;function l(E,h,i){let a=!1;const o=S(i);return y(h,{onData:t=>a?o.write(t):(a=!0,o.write(i([E,t]))),onError:t=>o.error(t),onEnd:()=>{a||(a=!0,o.write(E)),o.end()}}),o}e.$_d=l}),define(te[18],ie([0,1,71,62]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const s=typeof Buffer<"u",M=new P.$U(()=>new Uint8Array(256));let D,S;class f{static alloc(I){return s?new f(Buffer.allocUnsafe(I)):new f(new Uint8Array(I))}static wrap(I){return s&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new f(I)}static fromString(I,L){return!(L?.dontUseNodeBuffer||!1)&&s?new f(Buffer.from(I)):(D||(D=new TextEncoder),new f(D.encode(I)))}static fromByteArray(I){const L=f.alloc(I.length);for(let N=0,z=I.length;N<z;N++)L.buffer[N]=I[N];return L}static concat(I,L){if(typeof L>"u"){L=0;for(let ne=0,_=I.length;ne<_;ne++)L+=I[ne].byteLength}const N=f.alloc(L);let z=0;for(let ne=0,_=I.length;ne<_;ne++){const ae=I[ne];N.set(ae,z),z+=ae.byteLength}return N}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=f.alloc(this.byteLength);return I.set(this),I}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(I,L){return new f(this.buffer.subarray(I,L))}set(I,L){if(I instanceof f)this.buffer.set(I.buffer,L);else if(I instanceof Uint8Array)this.buffer.set(I,L);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),L);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return y(this.buffer,I)}writeUInt32BE(I,L){d(this.buffer,I,L)}readUInt32LE(I){return v(this.buffer,I)}writeUInt32LE(I,L){b(this.buffer,I,L)}readUInt8(I){return m(this.buffer,I)}writeUInt8(I,L){$(this.buffer,I,L)}indexOf(I,L=0){return c(this.buffer,I instanceof f?I.buffer:I,L)}}e.$ae=f;function c(k,I,L=0){const N=I.byteLength,z=k.byteLength;if(N===0)return 0;if(N===1)return k.indexOf(I[0]);if(N>z-L)return-1;const ne=M.value;ne.fill(I.length);for(let oe=0;oe<I.length;oe++)ne[I[oe]]=I.length-oe-1;let _=L+I.length-1,ae=_,se=-1;for(;_<z;)if(k[_]===I[ae]){if(ae===0){se=_;break}_--,ae--}else _+=Math.max(I.length-ae,ne[k[_]]),ae=I.length-1;return se}e.$be=c;function g(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0}e.$ce=g;function w(k,I,L){k[L+0]=I&255,I=I>>>8,k[L+1]=I&255}e.$de=w;function y(k,I){return k[I]*2**24+k[I+1]*2**16+k[I+2]*2**8+k[I+3]}e.$ee=y;function d(k,I,L){k[L+3]=I,I=I>>>8,k[L+2]=I,I=I>>>8,k[L+1]=I,I=I>>>8,k[L]=I}e.$fe=d;function v(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0|k[I+2]<<16>>>0|k[I+3]<<24>>>0}e.$ge=v;function b(k,I,L){k[L+0]=I&255,I=I>>>8,k[L+1]=I&255,I=I>>>8,k[L+2]=I&255,I=I>>>8,k[L+3]=I&255}e.$he=b;function m(k,I){return k[I]}e.$ie=m;function $(k,I,L){k[L]=I}e.$je=$;function u(k){return A.$2d(k,I=>f.concat(I))}e.$ke=u;function l(k){return A.$9d(k)}e.$le=l;function E(k){return A.$4d(k,I=>f.concat(I))}e.$me=E;async function h(k){return k.ended?f.concat(k.buffer):f.concat([...k.buffer,await E(k.stream)])}e.$ne=h;function i(k){return A.$7d(k,I=>f.concat(I))}e.$oe=i;function a(k){return A.$0d(k,{data:I=>typeof I=="string"?f.fromString(I):f.wrap(I)},I=>f.concat(I))}e.$pe=a;function o(k){return A.$1d(I=>f.concat(I),k)}e.$qe=o;function t(k,I){return A.$$d(k,I,L=>f.concat(L))}e.$re=t;function n(k,I){return A.$_d(k,I,L=>f.concat(L))}e.$se=n;function r(k){let I=0,L=0,N=0;const z=new Uint8Array(Math.floor(k.length/4*3)),ne=ae=>{switch(L){case 3:z[N++]=I|ae,L=0;break;case 2:z[N++]=I|ae>>>2,I=ae<<6,L=3;break;case 1:z[N++]=I|ae>>>4,I=ae<<4,L=2;break;default:I=ae<<2,L=1}};for(let ae=0;ae<k.length;ae++){const se=k.charCodeAt(ae);if(se>=65&&se<=90)ne(se-65);else if(se>=97&&se<=122)ne(se-97+26);else if(se>=48&&se<=57)ne(se-48+52);else if(se===43||se===45)ne(62);else if(se===47||se===95)ne(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ae]}`)}}const _=N;for(;L>0;)ne(0);return f.wrap(z).slice(0,_)}e.$te=r;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:k},I=!0,L=!1){const N=L?C:p;let z="";const ne=k.byteLength%3;let _=0;for(;_<k.byteLength-ne;_+=3){const ae=k[_+0],se=k[_+1],oe=k[_+2];z+=N[ae>>>2],z+=N[(ae<<4|se>>>4)&63],z+=N[(se<<2|oe>>>6)&63],z+=N[oe&63]}if(ne===1){const ae=k[_+0];z+=N[ae>>>2],z+=N[ae<<4&63],I&&(z+="==")}else if(ne===2){const ae=k[_+0],se=k[_+1];z+=N[ae>>>2],z+=N[(ae<<4|se>>>4)&63],z+=N[se<<2&63],I&&(z+="=")}return z}e.$ue=R}),define(te[27],ie([0,1,140,71]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wf=e.$vf=e.$uf=e.$tf=e.GraphemeBreakType=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function s(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.$Ae=s;const M=/{(\d+)}/g;function D(x,...he){return he.length===0?x:x.replace(M,function(me,ve){const Ae=parseInt(ve,10);return isNaN(Ae)||Ae<0||Ae>=he.length?me:he[Ae]})}e.$Be=D;const S=/{([^}]+)}/g;function f(x,he){return x.replace(S,(me,ve)=>he[ve]??me)}e.$Ce=f;function c(x){return x.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.$De=c;function g(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ee=g;function w(x,he){let me=0;const ve=he.charCodeAt(0);for(let Ae=x.length-1;Ae>=0;Ae--)x.charCodeAt(Ae)===ve&&me++;return me}e.$Fe=w;function y(x,he,me="\u2026"){return x.length<=he?x:`${x.substr(0,he)}${me}`}e.$Ge=y;function d(x,he=" "){const me=v(x,he);return b(me,he)}e.$He=d;function v(x,he){if(!x||!he)return x;const me=he.length;if(me===0||x.length===0)return x;let ve=0;for(;x.indexOf(he,ve)===ve;)ve=ve+me;return x.substring(ve)}e.$Ie=v;function b(x,he){if(!x||!he)return x;const me=he.length,ve=x.length;if(me===0||ve===0)return x;let Ae=ve,Fe=-1;for(;Fe=x.lastIndexOf(he,Ae-1),!(Fe===-1||Fe+me!==Ae);){if(Fe===0)return"";Ae=Fe}return x.substring(0,Ae)}e.$Je=b;function m(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ke=m;function $(x){return x.replace(/\*/g,"")}e.$Le=$;function u(x,he,me={}){if(!x)throw new Error("Cannot create regex from empty string");he||(x=g(x)),me.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let ve="";return me.global&&(ve+="g"),me.matchCase||(ve+="i"),me.multiline&&(ve+="m"),me.unicode&&(ve+="u"),new RegExp(x,ve)}e.$Me=u;function l(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.$Ne=l;function E(x){return x.split(/\r\n|\r|\n/)}e.$Oe=E;function h(x){for(let he=0,me=x.length;he<me;he++){const ve=x.charCodeAt(he);if(ve!==32&&ve!==9)return he}return-1}e.$Pe=h;function i(x,he=0,me=x.length){for(let ve=he;ve<me;ve++){const Ae=x.charCodeAt(ve);if(Ae!==32&&Ae!==9)return x.substring(he,ve)}return x.substring(he,me)}e.$Qe=i;function a(x,he=x.length-1){for(let me=he;me>=0;me--){const ve=x.charCodeAt(me);if(ve!==32&&ve!==9)return me}return-1}e.$Re=a;function o(x,he,me){const ve=[];let Ae=0;for(const Fe of x.matchAll(he)){if(ve.push(x.slice(Ae,Fe.index)),Fe.index===void 0)throw new Error("match.index should be defined");Ae=Fe.index+Fe[0].length,ve.push(me(Fe[0],...Fe.slice(1),Fe.index,x,Fe.groups))}return ve.push(x.slice(Ae)),Promise.all(ve).then(Fe=>Fe.join(""))}e.$Se=o;function t(x,he){return x<he?-1:x>he?1:0}e.$Te=t;function n(x,he,me=0,ve=x.length,Ae=0,Fe=he.length){for(;me<ve&&Ae<Fe;me++,Ae++){const Be=x.charCodeAt(me),He=he.charCodeAt(Ae);if(Be<He)return-1;if(Be>He)return 1}const Le=ve-me,Ue=Fe-Ae;return Le<Ue?-1:Le>Ue?1:0}e.$Ue=n;function r(x,he){return p(x,he,0,x.length,0,he.length)}e.$Ve=r;function p(x,he,me=0,ve=x.length,Ae=0,Fe=he.length){for(;me<ve&&Ae<Fe;me++,Ae++){let Be=x.charCodeAt(me),He=he.charCodeAt(Ae);if(Be===He)continue;if(Be>=128||He>=128)return n(x.toLowerCase(),he.toLowerCase(),me,ve,Ae,Fe);R(Be)&&(Be-=32),R(He)&&(He-=32);const Ge=Be-He;if(Ge!==0)return Ge}const Le=ve-me,Ue=Fe-Ae;return Le<Ue?-1:Le>Ue?1:0}e.$We=p;function C(x){return x>=48&&x<=57}e.$Xe=C;function R(x){return x>=97&&x<=122}e.$Ye=R;function k(x){return x>=65&&x<=90}e.$Ze=k;function I(x,he){return x.length===he.length&&p(x,he)===0}e.$1e=I;function L(x,he){const me=he.length;return he.length>x.length?!1:p(x,he,0,me)===0}e.$2e=L;function N(x,he){const me=Math.min(x.length,he.length);let ve;for(ve=0;ve<me;ve++)if(x.charCodeAt(ve)!==he.charCodeAt(ve))return ve;return me}e.$3e=N;function z(x,he){const me=Math.min(x.length,he.length);let ve;const Ae=x.length-1,Fe=he.length-1;for(ve=0;ve<me;ve++)if(x.charCodeAt(Ae-ve)!==he.charCodeAt(Fe-ve))return ve;return me}e.$4e=z;function ne(x){return 55296<=x&&x<=56319}e.$5e=ne;function _(x){return 56320<=x&&x<=57343}e.$6e=_;function ae(x,he){return(x-55296<<10)+(he-56320)+65536}e.$7e=ae;function se(x,he,me){const ve=x.charCodeAt(me);if(ne(ve)&&me+1<he){const Ae=x.charCodeAt(me+1);if(_(Ae))return ae(ve,Ae)}return ve}e.$8e=se;function oe(x,he){const me=x.charCodeAt(he-1);if(_(me)&&he>1){const ve=x.charCodeAt(he-2);if(ne(ve))return ae(ve,me)}return me}class J{get offset(){return this.e}constructor(he,me=0){this.c=he,this.d=he.length,this.e=me}setOffset(he){this.e=he}prevCodePoint(){const he=oe(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=se(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.$9e=J;class K{get offset(){return this.c.offset}constructor(he,me=0){this.c=new J(he,me)}nextGraphemeLength(){const he=le.getInstance(),me=this.c,ve=me.offset;let Ae=he.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Fe=me.offset,Le=he.getGraphemeBreakType(me.nextCodePoint());if(we(Ae,Le)){me.setOffset(Fe);break}Ae=Le}return me.offset-ve}prevGraphemeLength(){const he=le.getInstance(),me=this.c,ve=me.offset;let Ae=he.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Fe=me.offset,Le=he.getGraphemeBreakType(me.prevCodePoint());if(we(Le,Ae)){me.setOffset(Fe);break}Ae=Le}return ve-me.offset}eol(){return this.c.eol()}}e.$0e=K;function G(x,he){return new K(x,he).nextGraphemeLength()}e.$$e=G;function U(x,he){return new K(x,he).prevGraphemeLength()}e.$_e=U;function q(x,he){he>0&&_(x.charCodeAt(he))&&he--;const me=he+G(x,he);return[me-U(x,me),me]}e.$af=q;function X(x){const he=new K(x);let me=0;for(;!he.eol();)me++,he.nextGraphemeLength();return me}e.$bf=X;let H;function Q(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function re(x){return H||(H=Q()),H.test(x)}e.$cf=re;const F=/^[\t\n\r\x20-\x7E]*$/;function O(x){return F.test(x)}e.$df=O,e.$ef=/[\u2028\u2029]/;function j(x){return e.$ef.test(x)}e.$ff=j;function B(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.$gf=B;function W(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}e.$hf=W;function T(x,he){if(x.length<he)return x;const me=/\b/g;let ve=0;for(;me.test(x)&&!(x.length-me.lastIndex<he);)ve=me.lastIndex,me.lastIndex+=1;return x.substring(ve).replace(/^\s/,"")}e.$if=T;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function de(x){return x&&(x=x.replace(V,"").replace(ce,"")),x}e.$jf=de,e.$kf=String.fromCharCode(65279);function ue(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.$lf=ue;function fe(x){return ue(x)?x.substr(1):x}e.$mf=fe;function ye(x,he){if(!x||!he||x.length<he.length)return!1;const me=he.length,ve=x.toLowerCase();let Ae=0,Fe=-1;for(;Ae<me;){const Le=ve.indexOf(he[Ae],Fe+1);if(Le<0)return!1;Fe=Le,Ae++}return!0}e.$nf=ye;function be(x,he=!1){return x?(he&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.$of=be;function pe(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.$pf=pe;function Ce(x,he=1){if(he===0)return"";let me=-1;do me=x.indexOf(`
`,me+1),he--;while(he>0&&me>=0);return me===-1?x:(x[me-1]==="\r"&&me--,x.substr(0,me))}e.$qf=Ce;function We(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}e.$rf=We;function $e(x){return le.getInstance().getGraphemeBreakType(x)}e.$sf=$e;function we(x,he){return x===0?he!==5&&he!==7:x===2&&he===3?!1:x===4||x===2||x===3||he===4||he===2||he===3?!0:!(x===8&&(he===8||he===9||he===11||he===12)||(x===11||x===9)&&(he===9||he===10)||(x===12||x===10)&&he===10||he===5||he===13||he===7||x===1||x===13&&he===14||x===6&&he===6)}var Y;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(Y||(e.GraphemeBreakType=Y={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=ge()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const me=this.d,ve=me.length/3;let Ae=1;for(;Ae<=ve;)if(he<me[3*Ae])Ae=2*Ae;else if(he>me[3*Ae+1])Ae=2*Ae+1;else return me[3*Ae+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(x,he){if(x===0)return 0;const me=De(x,he);if(me!==void 0)return me;const ve=new J(he,x);return ve.prevCodePoint(),ve.offset}e.$tf=Re;function De(x,he){const me=new J(he,x);let ve=me.prevCodePoint();for(;Ne(ve)||ve===65039||ve===8419;){if(me.offset===0)return;ve=me.prevCodePoint()}if(!W(ve))return;let Ae=me.offset;return Ae>0&&me.prevCodePoint()===8205&&(Ae=me.offset),Ae}function Ne(x){return 127995<=x&&x<=127999}var Oe;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$uf="\xA0";class ze{static{this.c=new A.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$we(he=>{function me(Ge){const xe=new Map;for(let Ye=0;Ye<Ge.length;Ye+=2)xe.set(Ge[Ye],Ge[Ye+1]);return xe}function ve(Ge,xe){const Ye=new Map(Ge);for(const[it,nt]of xe)Ye.set(it,nt);return Ye}function Ae(Ge,xe){if(!Ge)return xe;const Ye=new Map;for(const[it,nt]of Ge)xe.has(it)&&Ye.set(it,nt);return Ye}const Fe=this.c.value;let Le=he.filter(Ge=>!Ge.startsWith("_")&&Ge in Fe);Le.length===0&&(Le=["_default"]);let Ue;for(const Ge of Le){const xe=me(Fe[Ge]);Ue=Ae(Ue,xe)}const Be=me(Fe._common),He=ve(Be,Ue);return new ze(He)})}static getInstance(he){return ze.d.get(Array.from(he))}static{this.e=new A.$U(()=>Object.keys(ze.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return ze.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$vf=ze;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(he){return Te.e().has(he)}static get codePoints(){return Te.e()}}e.$wf=Te}),define(te[55],ie([0,1,27]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=void 0;function A($){return s($,0)}e.$Bi=A;function s($,u){switch(typeof $){case"object":return $===null?M(349,u):Array.isArray($)?f($,u):c($,u);case"string":return S($,u);case"boolean":return D($,u);case"number":return M($,u);case"undefined":return M(937,u);default:return M(617,u)}}e.$Ci=s;function M($,u){return(u<<5)-u+$|0}e.$Di=M;function D($,u){return M($?433:863,u)}function S($,u){u=M(149417,u);for(let l=0,E=$.length;l<E;l++)u=M($.charCodeAt(l),u);return u}e.$Ei=S;function f($,u){return u=M(104579,u),$.reduce((l,E)=>s(E,l),u)}function c($,u){return u=M(181387,u),Object.keys($).sort().reduce((l,E)=>(l=S(E,l),s($[E],l)),u)}class g{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=s(u,this.g),this.g}}e.$Fi=g;var w;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function y($,u,l=32){const E=l-u,h=~((1<<E)-1);return($<<u|(h&$)>>>E)>>>0}function d($,u=0,l=$.byteLength,E=0){for(let h=0;h<l;h++)$[u+h]=E}function v($,u,l="0"){for(;$.length<u;)$=l+$;return $}function b($,u=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(l=>l.toString(16).padStart(2,"0")).join(""):v(($>>>0).toString(16),u/4)}e.$Gi=b;class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const l=u.length;if(l===0)return;const E=this.p;let h=this.r,i=this.u,a,o;for(i!==0?(a=i,o=-1,i=0):(a=u.charCodeAt(0),o=0);;){let t=a;if(P.$5e(a))if(o+1<l){const n=u.charCodeAt(o+1);P.$6e(n)?(o++,t=P.$7e(a,n)):t=65533}else{i=a;break}else P.$6e(a)&&(t=65533);if(h=this.w(E,h,t),o++,o<l)a=u.charCodeAt(o);else break}this.r=h,this.u=i}w(u,l,E){return E<128?u[l++]=E:E<2048?(u[l++]=192|(E&1984)>>>6,u[l++]=128|(E&63)>>>0):E<65536?(u[l++]=224|(E&61440)>>>12,u[l++]=128|(E&4032)>>>6,u[l++]=128|(E&63)>>>0):(u[l++]=240|(E&1835008)>>>18,u[l++]=128|(E&258048)>>>12,u[l++]=128|(E&4032)>>>6,u[l++]=128|(E&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=m.g,l=this.q;for(let p=0;p<64;p+=4)u.setUint32(p,l.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)u.setUint32(p,y(u.getUint32(p-12,!1)^u.getUint32(p-32,!1)^u.getUint32(p-56,!1)^u.getUint32(p-64,!1),1),!1);let E=this.h,h=this.l,i=this.m,a=this.n,o=this.o,t,n,r;for(let p=0;p<80;p++)p<20?(t=h&i|~h&a,n=1518500249):p<40?(t=h^i^a,n=1859775393):p<60?(t=h&i|h&a|i&a,n=2400959708):(t=h^i^a,n=3395469782),r=y(E,5)+t+o+n+u.getUint32(p*4,!1)&4294967295,o=a,a=i,i=y(h,30),h=E,E=r;this.h=this.h+E&4294967295,this.l=this.l+h&4294967295,this.m=this.m+i&4294967295,this.n=this.n+a&4294967295,this.o=this.o+o&4294967295}}e.$Hi=m}),define(te[73],ie([0,1,27]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(A||(A={})),function(s){const M="error",D="warning",S="warn",f="info",c="ignore";function g(y){return y?P.$1e(M,y)?s.Error:P.$1e(D,y)||P.$1e(S,y)?s.Warning:P.$1e(f,y)?s.Info:s.Ignore:s.Ignore}s.fromValue=g;function w(y){switch(y){case s.Error:return M;case s.Warning:return D;case s.Info:return f;default:return c}}s.toString=w}(A||(A={})),e.default=A}),define(te[141],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Jd=Symbol("MicrotaskDelay")}),define(te[56],ie([0,1,23,27]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class s{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const v=d.charCodeAt(0),b=this.b.charCodeAt(this.c);return v-b}value(){return this.b[this.c]}}e.$Ph=s;class M{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,A.$Ue)(d,this.b,0,d.length,this.c,this.d):(0,A.$We)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Qh=M;class D{constructor(d=!0,v=!0){this.f=d,this.g=v}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let v=d.length-1;v>=0;v--,this.c--){const b=this.b.charCodeAt(v);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,A.$Ue)(d,this.b,0,d.length,this.d,this.e):(0,A.$We)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Rh=D;var S;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(S||(S={}));class f{constructor(d,v){this.f=d,this.g=v,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,A.$Ve)(d,this.c.scheme);if(this.d[this.e]===2)return(0,A.$Ve)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,A.$Te)(d,this.c.query);if(this.d[this.e]===5)return(0,A.$Te)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Sh=f;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(g||(g={}));class w{static forUris(d=()=>!1,v=()=>!1){return new w(new f(d,v))}static forPaths(d=!1){return new w(new D(void 0,!d))}static forStrings(){return new w(new s)}static forConfigKeys(){return new w(new M)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,v){if(v){const b=v.slice(0);(0,P.$Wb)(b);for(const m of b)this.set(m,d)}else{const b=d.slice(0);(0,P.$Wb)(b);for(const m of b)this.set(m[0],m[1])}}set(d,v){const b=this.b.reset(d);let m;this.c||(this.c=new c,this.c.segment=b.value());const $=[];for(m=this.c;;){const l=b.cmp(m.segment);if(l>0)m.left||(m.left=new c,m.left.segment=b.value()),$.push([-1,m]),m=m.left;else if(l<0)m.right||(m.right=new c,m.right.segment=b.value()),$.push([1,m]),m=m.right;else if(b.hasNext())b.next(),m.mid||(m.mid=new c,m.mid.segment=b.value()),$.push([0,m]),m=m.mid;else break}const u=m.value;m.value=v,m.key=d;for(let l=$.length-1;l>=0;l--){const E=$[l][1];E.updateHeight();const h=E.balanceFactor();if(h<-1||h>1){const i=$[l][0],a=$[l+1][0];if(i===1&&a===1)$[l][1]=E.rotateLeft();else if(i===-1&&a===-1)$[l][1]=E.rotateRight();else if(i===1&&a===-1)E.right=$[l+1][1]=$[l+1][1].rotateRight(),$[l][1]=E.rotateLeft();else if(i===-1&&a===1)E.left=$[l+1][1]=$[l+1][1].rotateLeft(),$[l][1]=E.rotateRight();else throw new Error;if(l>0)switch($[l-1][0]){case-1:$[l-1][1].left=$[l][1];break;case 1:$[l-1][1].right=$[l][1];break;case 0:$[l-1][1].mid=$[l][1];break}else this.c=$[0][1]}}return u}get(d){return this.d(d)?.value}d(d){const v=this.b.reset(d);let b=this.c;for(;b;){const m=v.cmp(b.segment);if(m>0)b=b.left;else if(m<0)b=b.right;else if(v.hasNext())v.next(),b=b.mid;else break}return b}has(d){const v=this.d(d);return!(v?.value===void 0&&v?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,v){const b=this.b.reset(d),m=[];let $=this.c;for(;$;){const u=b.cmp($.segment);if(u>0)m.push([-1,$]),$=$.left;else if(u<0)m.push([1,$]),$=$.right;else if(b.hasNext())b.next(),m.push([0,$]),$=$.mid;else break}if($){if(v?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const u=this.f($.right);if(u.key){const{key:l,value:E,segment:h}=u;this.e(u.key,!1),$.key=l,$.value=E,$.segment=h}}else{const u=$.left??$.right;if(m.length>0){const[l,E]=m[m.length-1];switch(l){case-1:E.left=u;break;case 0:E.mid=u;break;case 1:E.right=u;break}}else this.c=u}for(let u=m.length-1;u>=0;u--){const l=m[u][1];l.updateHeight();const E=l.balanceFactor();if(E>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),m[u][1]=l.rotateLeft()):E<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),m[u][1]=l.rotateRight()),u>0)switch(m[u-1][0]){case-1:m[u-1][1].left=m[u][1];break;case 1:m[u-1][1].right=m[u][1];break;case 0:m[u-1][1].mid=m[u][1];break}else this.c=m[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const v=this.b.reset(d);let b=this.c,m;for(;b;){const $=v.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(v.hasNext())v.next(),m=b.value||m,b=b.mid;else break}return b&&b.value||m}findSuperstr(d){return this.g(d,!1)}g(d,v){const b=this.b.reset(d);let m=this.c;for(;m;){const $=b.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(b.hasNext())b.next(),m=m.mid;else return m.mid?this.h(m.mid):v?m.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[v,b]of this)d(b,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const v=[];return this.j(d,v),v[Symbol.iterator]()}j(d,v){d&&(d.left&&this.j(d.left,v),d.value&&v.push([d.key,d.value]),d.mid&&this.j(d.mid,v),d.right&&this.j(d.right,v))}_isBalanced(){const d=v=>{if(!v)return!0;const b=v.balanceFactor();return b<-1||b>1?!1:d(v.left)&&d(v.right)};return d(this.c)}}e.$Th=w}),define(te[12],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=void 0;function P(h){return typeof h=="string"}e.$xf=P;function A(h){return Array.isArray(h)&&h.every(i=>P(i))}e.$yf=A;function s(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.$zf=s;function M(h){const i=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof i}e.$Af=M;function D(h){return typeof h=="number"&&!isNaN(h)}e.$Bf=D;function S(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.$Cf=S;function f(h){return h===!0||h===!1}e.$Df=f;function c(h){return typeof h>"u"}e.$Ef=c;function g(h){return!w(h)}e.$Ff=g;function w(h){return c(h)||h===null}e.$Gf=w;function y(h,i){if(!h)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$Hf=y;function d(h){if(w(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.$If=d;function v(...h){const i=[];for(let a=0;a<h.length;a++){const o=h[a];if(w(o))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);i.push(o)}return i}e.$Jf=v;const b=Object.prototype.hasOwnProperty;function m(h){if(!s(h))return!1;for(const i in h)if(b.call(h,i))return!1;return!0}e.$Kf=m;function $(h){return typeof h=="function"}e.$Lf=$;function u(...h){return h.length>0&&h.every($)}e.$Mf=u;function l(h,i){const a=Math.min(h.length,i.length);for(let o=0;o<a;o++)E(h[o],i[o])}e.$Nf=l;function E(h,i){if(P(i)){if(typeof h!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if($(i)){try{if(h instanceof i)return}catch{}if(!w(h)&&h.constructor===i||i.length===1&&i.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Of=E}),define(te[74],ie([0,1,12]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=void 0;const A=Object.create(null);function s(S,f){if((0,P.$xf)(f)){const c=A[f];if(c===void 0)throw new Error(`${S} references an unknown codicon: ${f}`);f=c}return A[S]=f,{id:S}}function M(){return A}e.$Qj=M;function D(){return Object.values(e.$Sj)}e.$Rj=D,e.$Sj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,12]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=void 0;function A($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const u=Array.isArray($)?[]:{};return Object.entries($).forEach(([l,E])=>{u[l]=E&&typeof E=="object"?A(E):E}),u}e.$3m=A;function s($){if(!$||typeof $!="object")return $;const u=[$];for(;u.length>0;){const l=u.shift();Object.freeze(l);for(const E in l)if(M.call(l,E)){const h=l[E];typeof h=="object"&&!Object.isFrozen(h)&&!(0,P.$Af)(h)&&u.push(h)}}return $}e.$4m=s;const M=Object.prototype.hasOwnProperty;function D($,u){return S($,u,new Set)}e.$5m=D;function S($,u,l){if((0,P.$Gf)($))return $;const E=u($);if(typeof E<"u")return E;if(Array.isArray($)){const h=[];for(const i of $)h.push(S(i,u,l));return h}if((0,P.$zf)($)){if(l.has($))throw new Error("Cannot clone recursive data-structure");l.add($);const h={};for(const i in $)M.call($,i)&&(h[i]=S($[i],u,l));return l.delete($),h}return $}function f($,u,l=!0){return(0,P.$zf)($)?((0,P.$zf)(u)&&Object.keys(u).forEach(E=>{E in $?l&&((0,P.$zf)($[E])&&(0,P.$zf)(u[E])?f($[E],u[E],l):$[E]=u[E]):$[E]=u[E]}),$):u}e.$6m=f;function c($,u){if($===u)return!0;if($==null||u===null||u===void 0||typeof $!=typeof u||typeof $!="object"||Array.isArray($)!==Array.isArray(u))return!1;let l,E;if(Array.isArray($)){if($.length!==u.length)return!1;for(l=0;l<$.length;l++)if(!c($[l],u[l]))return!1}else{const h=[];for(E in $)h.push(E);h.sort();const i=[];for(E in u)i.push(E);if(i.sort(),!c(h,i))return!1;for(l=0;l<h.length;l++)if(!c($[h[l]],u[h[l]]))return!1}return!0}e.$7m=c;function g($){const u=new Set;return JSON.stringify($,(l,E)=>{if((0,P.$zf)(E)||Array.isArray(E)){if(u.has(E))return"[Circular]";u.add(E)}return E})}e.$8m=g;function w($,u){const l=Object.create(null);return!$||!u||Object.keys(u).forEach(h=>{const i=$[h],a=u[h];c(i,a)||(l[h]=a)}),l}e.$9m=w;function y($,u){const l=u.toLowerCase(),E=Object.keys($).find(h=>h.toLowerCase()===l);return E?$[E]:$[u]}e.$0m=y;function d($,u){const l=Object.create(null);for(const[E,h]of Object.entries($))u(E,h)&&(l[E]=h);return l}e.$$m=d;function v($){let u=[];for(;Object.prototype!==$;)u=u.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return u}e.$_m=v;function b($){const u=[];for(const l of v($))typeof $[l]=="function"&&u.push(l);return u}e.$an=b;function m($,u){const l=h=>function(){const i=Array.prototype.slice.call(arguments,0);return u(h,i)},E={};for(const h of $)E[h]=l(h);return E}e.$bn=m}),define(te[102],ie([0,1,74]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Tj=e.ThemeColor=void 0;var A;(function(D){function S(f){return f&&typeof f=="object"&&typeof f.id=="string"}D.isThemeColor=S})(A||(e.ThemeColor=A={}));function s(D){return{id:D}}e.$Tj=s;var M;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function f(u){const l=S.exec(u.id);if(!l)return f(P.$Sj.error);const[,E,h]=l,i=["codicon","codicon-"+E];return h&&i.push("codicon-modifier-"+h.substring(1)),i}D.asClassNameArray=f;function c(u){return f(u).join(" ")}D.asClassName=c;function g(u){return"."+f(u).join(".")}D.asCSSSelector=g;function w(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||A.isThemeColor(u.color))}D.isThemeIcon=w;const y=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function d(u){const l=y.exec(u);if(!l)return;const[,E]=l;return{id:E}}D.fromString=d;function v(u){return{id:u}}D.fromId=v;function b(u,l){let E=u.id;const h=E.lastIndexOf("~");return h!==-1&&(E=E.substring(0,h)),l&&(E=`${E}~${l}`),{id:E}}D.modify=b;function m(u){const l=u.id.lastIndexOf("~");if(l!==-1)return u.id.substring(l+1)}D.getModifier=m;function $(u,l){return u.id===l.id&&u.color?.id===l.color?.id}D.isEqual=$})(M||(e.ThemeIcon=M={}))}),define(te[32],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(s){return P.test(s)}e.$cg=A,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let f=0;f<S.length;f++)S[f]=Math.floor(Math.random()*256);return S};const M=new Uint8Array(16),D=[];for(let S=0;S<256;S++)D.push(S.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let f=0,c="";return c+=D[M[f++]],c+=D[M[f++]],c+=D[M[f++]],c+=D[M[f++]],c+="-",c+=D[M[f++]],c+=D[M[f++]],c+="-",c+=D[M[f++]],c+=D[M[f++]],c+="-",c+=D[M[f++]],c+=D[M[f++]],c+="-",c+=D[M[f++]],c+=D[M[f++]],c+=D[M[f++]],c+=D[M[f++]],c+=D[M[f++]],c+=D[M[f++]],c}}()}),define(te[142],ie([0,1,85,45,83]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$S=void 0;async function M(D,S){if(await new Promise((g,w)=>{const y=A.createReadStream(D),d=P.createHash("sha1");y.pipe(d);const v=(0,s.$cb)((b,m)=>{y.removeAllListeners(),d.removeAllListeners(),b?w(b):g(m)});y.once("error",v),y.once("end",v),d.once("error",v),d.once("data",b=>v(void 0,b.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$$S=M}),define(te[143],ie([0,1,28]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const S=D.replace(/\-/g,":").toLowerCase();return!A.has(S)}function M(){const D=(0,P.networkInterfaces)();for(const S in D){const f=D[S];if(f){for(const{mac:c}of f)if(s(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Nm=M}),define(te[86],ie([0,1,28,56,32,143]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=void 0,e.$Om=new class{c(c){return this.a||(this.a=A.$Th.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(c)}value(){if(this.b===void 0){let c=0,g=0;const w=(0,P.networkInterfaces)();for(const y in w){const d=w[y];if(d)for(const{mac:v,internal:b}of d)b||(g+=1,this.c(v.toUpperCase())&&(c+=1))}this.b=g>0?c/g:0}return this.b}};let D;async function S(c){return D||(D=(async()=>await f(c)||s.$dg())()),D}e.$Pm=S;async function f(c){try{const g=await new Promise((y,d)=>{Z(["crypto"],y,d)}),w=(0,M.$Nm)();return g.createHash("sha256").update(w,"utf8").digest("hex")}catch(g){c(g);return}}}),define(te[103],ie([0,1,87]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.$gg=e.$fg=void 0;function A(S,f,c,g=1){let w=!1;return new Promise(y=>{const d=setTimeout(()=>{if(!w)return w=!0,y(0)},c);s(S,f,g,v=>{if(!w)return w=!0,clearTimeout(d),y(v)})})}e.$fg=A;function s(S,f,c,g){if(f===0)return g(0);const w=new P.Socket;w.once("connect",()=>(D(w),s(S+c,f-1,c,g))),w.once("data",()=>{}),w.once("error",y=>(D(w),y.code!=="ECONNREFUSED"?s(S+c,f-1,c,g):g(S))),w.connect(S,"127.0.0.1")}e.$gg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(S,f,c,g="127.0.0.1"){let w=!1,y,d=1;const v=P.createServer({pauseOnConnect:!0});function b(m,$){w||(w=!0,v.removeAllListeners(),v.close(),y&&clearTimeout(y),$(m))}return new Promise(m=>{y=setTimeout(()=>{b(0,m)},c),v.on("listening",()=>{b(S,m)}),v.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&d<f?(S++,d++,v.listen(S,g)):b(0,m)}),v.on("close",()=>{b(0,m)}),v.listen(S,g)})}e.$hg=M;function D(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(f){console.error(f)}}}),function(){function Z(){function e(){return process.uncHostAllowlist}function P(f){const c=new Set;if(Array.isArray(f))for(const g of f)typeof g=="string"&&c.add(g);return Array.from(c)}function A(){const f=e();return f?Array.from(f):[]}function s(f){if(process.platform!=="win32")return;const c=e();if(c)if(typeof f=="string")c.add(f.toLowerCase());else for(const g of P(f))s(g)}function M(f){if(typeof f!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const w of c){if(f.indexOf(w)!==0)continue;const d=f.indexOf("\\",w.length);if(d===-1)continue;const v=f.substring(w.length,d);if(v){g=v;break}}return g}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:A,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Z()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Z():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[144],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cT=e.$bT=void 0,e.$bT="vscode:contextmenu",e.$cT="vscode:onCloseContextMenu"}),define(te[145],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jT=void 0;class P{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$jT=P}),define(te[146],ie([11,10]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(te[147],ie([0,1,146]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=void 0;const A=60,s=A*60,M=s*24,D=M*7,S=M*30,f=M*365;function c(w,y,d,v){typeof w!="number"&&(w=w.getTime());const b=Math.round((new Date().getTime()-w)/1e3);if(b<-30)return(0,P.localize)(0,null,c(new Date().getTime()+b*1e3,!1));if(!v&&b<30)return(0,P.localize)(1,null);let m;return b<A?(m=b,y?m===1?d?(0,P.localize)(2,null,m):(0,P.localize)(3,null,m):d?(0,P.localize)(4,null,m):(0,P.localize)(5,null,m):m===1?d?(0,P.localize)(6,null,m):(0,P.localize)(7,null,m):d?(0,P.localize)(8,null,m):(0,P.localize)(9,null,m)):b<s?(m=Math.floor(b/A),y?m===1?d?(0,P.localize)(10,null,m):(0,P.localize)(11,null,m):d?(0,P.localize)(12,null,m):(0,P.localize)(13,null,m):m===1?d?(0,P.localize)(14,null,m):(0,P.localize)(15,null,m):d?(0,P.localize)(16,null,m):(0,P.localize)(17,null,m)):b<M?(m=Math.floor(b/s),y?m===1?d?(0,P.localize)(18,null,m):(0,P.localize)(19,null,m):d?(0,P.localize)(20,null,m):(0,P.localize)(21,null,m):m===1?d?(0,P.localize)(22,null,m):(0,P.localize)(23,null,m):d?(0,P.localize)(24,null,m):(0,P.localize)(25,null,m)):b<D?(m=Math.floor(b/M),y?m===1?(0,P.localize)(26,null,m):(0,P.localize)(27,null,m):m===1?(0,P.localize)(28,null,m):(0,P.localize)(29,null,m)):b<S?(m=Math.floor(b/D),y?m===1?d?(0,P.localize)(30,null,m):(0,P.localize)(31,null,m):d?(0,P.localize)(32,null,m):(0,P.localize)(33,null,m):m===1?d?(0,P.localize)(34,null,m):(0,P.localize)(35,null,m):d?(0,P.localize)(36,null,m):(0,P.localize)(37,null,m)):b<f?(m=Math.floor(b/S),y?m===1?d?(0,P.localize)(38,null,m):(0,P.localize)(39,null,m):d?(0,P.localize)(40,null,m):(0,P.localize)(41,null,m):m===1?d?(0,P.localize)(42,null,m):(0,P.localize)(43,null,m):d?(0,P.localize)(44,null,m):(0,P.localize)(45,null,m)):(m=Math.floor(b/f),y?m===1?d?(0,P.localize)(46,null,m):(0,P.localize)(47,null,m):d?(0,P.localize)(48,null,m):(0,P.localize)(49,null,m):m===1?d?(0,P.localize)(50,null,m):(0,P.localize)(51,null,m):d?(0,P.localize)(52,null,m):(0,P.localize)(53,null,m))}e.$am=c;function g(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$bm=g}),define(te[148],ie([11,10]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(te[49],ie([0,1,23,12,148]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function M(w,y){return y&&(w.stack||w.stacktrace)?s.localize(0,null,S(w),D(w.stack)||D(w.stacktrace)):S(w)}function D(w){return Array.isArray(w)?w.join(`
`):w}function S(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?s.localize(1,null,w.message):w.message||s.localize(2,null)}function f(w=null,y=!1){if(!w)return s.localize(3,null);if(Array.isArray(w)){const d=P.$Gb(w),v=f(d[0],y);return d.length>1?s.localize(4,null,v,d.length):v}if(A.$xf(w))return w;if(w.detail){const d=w.detail;if(d.error)return M(d.error,y);if(d.exception)return M(d.exception,y)}return w.stack?M(w,y):w.message?w.message:s.localize(5,null)}e.$yi=f;function c(w){const y=w;return y instanceof Error&&Array.isArray(y.actions)}e.$zi=c;function g(w,y){let d;return typeof w=="string"?d=new Error(w):d=w,d.actions=y,d}e.$Ai=g}),define(te[149],ie([11,10]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(te[150],ie([0,1,149]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;function A(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.$tp=A}),define(te[151],ie([11,10]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,151]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let A=!1,s=!1,M=!1,D=!1,S=!1,f=!1,c=!1,g=!1,w=!1,y=!1,d,v=e.$g,b=e.$g,m,$;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?u=e.$h.vscode.process:typeof process<"u"&&(u=process);const l=typeof u?.versions?.electron=="string",E=l&&u?.type==="renderer";if(typeof navigator=="object"&&!E)$=navigator.userAgent,A=$.indexOf("Windows")>=0,s=$.indexOf("Macintosh")>=0,g=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=$.indexOf("Linux")>=0,y=$?.indexOf("Mobi")>=0,f=!0,d=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,v=d,b=navigator.language;else if(typeof u=="object"){A=u.platform==="win32",s=u.platform==="darwin",M=u.platform==="linux",D=M&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,c=l,w=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$g,v=e.$g;const C=u.env.VSCODE_NLS_CONFIG;if(C)try{const R=JSON.parse(C),k=R.availableLanguages["*"];d=R.locale,b=R.osLocale,v=k||e.$g,m=R._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var h;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(h||(e.Platform=h={}));function i(C){switch(C){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=i;let a=0;s?a=1:A?a=3:M&&(a=2),e.$j=A,e.$k=s,e.$l=M,e.$m=D,e.$n=S,e.$o=c,e.$p=f,e.$q=f&&typeof e.$h.importScripts=="function",e.$r=g,e.$s=y,e.$t=w,e.$u=a,e.$v=$,e.$w=v;var o;(function(C){function R(){return e.$w}C.value=R;function k(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}C.isDefaultVariant=k;function I(){return e.$w==="en"}C.isDefault=I})(o||(e.Language=o={})),e.$x=d,e.$y=b,e.$z=m,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const C=[];e.$h.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let I=0,L=C.length;I<L;I++){const N=C[I];if(N.id===k.data.vscodeScheduleAsyncWork){C.splice(I,1),N.callback();return}}});let R=0;return k=>{const I=++R;C.push({id:I,callback:k}),e.$h.postMessage({vscodeScheduleAsyncWork:I},"*")}}return C=>setTimeout(C)})();var t;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=s||g?2:A?1:3;let n=!0,r=!1;function p(){if(!r){r=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,n=new Uint16Array(C.buffer)[0]===(2<<8)+1}return n}e.$D=p,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(te[35],ie([0,1,4]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let A;if(typeof P.$h.vscode<"u"&&typeof P.$h.vscode.process<"u"){const s=P.$h.vscode.process;A={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return P.$j?"win32":P.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$cc=A.platform,e.$dc=A.arch}),define(te[9],ie([0,1,35]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const A=65,s=97,M=90,D=122,S=46,f=47,c=92,g=58,w=63;class y extends Error{constructor(a,o,t){let n;typeof o=="string"&&o.indexOf("not ")===0?(n="must not be",o=o.replace(/^not /,"")):n="must be";const r=a.indexOf(".")!==-1?"property":"argument";let p=`The "${a}" ${r} ${n} of type ${o}`;p+=`. Received type ${typeof t}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function d(i,a){if(i===null||typeof i!="object")throw new y(a,"Object",i)}function v(i,a){if(typeof i!="string")throw new y(a,"string",i)}const b=P.$cc==="win32";function m(i){return i===f||i===c}function $(i){return i===f}function u(i){return i>=A&&i<=M||i>=s&&i<=D}function l(i,a,o,t){let n="",r=0,p=-1,C=0,R=0;for(let k=0;k<=i.length;++k){if(k<i.length)R=i.charCodeAt(k);else{if(t(R))break;R=f}if(t(R)){if(!(p===k-1||C===1))if(C===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const I=n.lastIndexOf(o);I===-1?(n="",r=0):(n=n.slice(0,I),r=n.length-1-n.lastIndexOf(o)),p=k,C=0;continue}else if(n.length!==0){n="",r=0,p=k,C=0;continue}}a&&(n+=n.length>0?`${o}..`:"..",r=2)}else n.length>0?n+=`${o}${i.slice(p+1,k)}`:n=i.slice(p+1,k),r=k-p-1;p=k,C=0}else R===S&&C!==-1?++C:C=-1}return n}function E(i,a){d(a,"pathObject");const o=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return o?o===a.root?`${o}${t}`:`${o}${i}${t}`:t}e.$ec={resolve(...i){let a="",o="",t=!1;for(let n=i.length-1;n>=-1;n--){let r;if(n>=0){if(r=i[n],v(r,"path"),r.length===0)continue}else a.length===0?r=P.cwd():(r=P.env[`=${a}`]||P.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===c)&&(r=`${a}\\`));const p=r.length;let C=0,R="",k=!1;const I=r.charCodeAt(0);if(p===1)m(I)&&(C=1,k=!0);else if(m(I))if(k=!0,m(r.charCodeAt(1))){let L=2,N=L;for(;L<p&&!m(r.charCodeAt(L));)L++;if(L<p&&L!==N){const z=r.slice(N,L);for(N=L;L<p&&m(r.charCodeAt(L));)L++;if(L<p&&L!==N){for(N=L;L<p&&!m(r.charCodeAt(L));)L++;(L===p||L!==N)&&(R=`\\\\${z}\\${r.slice(N,L)}`,C=L)}}}else C=1;else u(I)&&r.charCodeAt(1)===g&&(R=r.slice(0,2),C=2,p>2&&m(r.charCodeAt(2))&&(k=!0,C=3));if(R.length>0)if(a.length>0){if(R.toLowerCase()!==a.toLowerCase())continue}else a=R;if(t){if(a.length>0)break}else if(o=`${r.slice(C)}\\${o}`,t=k,k&&a.length>0)break}return o=l(o,!t,"\\",m),t?`${a}\\${o}`:`${a}${o}`||"."},normalize(i){v(i,"path");const a=i.length;if(a===0)return".";let o=0,t,n=!1;const r=i.charCodeAt(0);if(a===1)return $(r)?"\\":i;if(m(r))if(n=!0,m(i.charCodeAt(1))){let C=2,R=C;for(;C<a&&!m(i.charCodeAt(C));)C++;if(C<a&&C!==R){const k=i.slice(R,C);for(R=C;C<a&&m(i.charCodeAt(C));)C++;if(C<a&&C!==R){for(R=C;C<a&&!m(i.charCodeAt(C));)C++;if(C===a)return`\\\\${k}\\${i.slice(R)}\\`;C!==R&&(t=`\\\\${k}\\${i.slice(R,C)}`,o=C)}}}else o=1;else u(r)&&i.charCodeAt(1)===g&&(t=i.slice(0,2),o=2,a>2&&m(i.charCodeAt(2))&&(n=!0,o=3));let p=o<a?l(i.slice(o),!n,"\\",m):"";return p.length===0&&!n&&(p="."),p.length>0&&m(i.charCodeAt(a-1))&&(p+="\\"),t===void 0?n?`\\${p}`:p:n?`${t}\\${p}`:`${t}${p}`},isAbsolute(i){v(i,"path");const a=i.length;if(a===0)return!1;const o=i.charCodeAt(0);return m(o)||a>2&&u(o)&&i.charCodeAt(1)===g&&m(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,o;for(let r=0;r<i.length;++r){const p=i[r];v(p,"path"),p.length>0&&(a===void 0?a=o=p:a+=`\\${p}`)}if(a===void 0)return".";let t=!0,n=0;if(typeof o=="string"&&m(o.charCodeAt(0))){++n;const r=o.length;r>1&&m(o.charCodeAt(1))&&(++n,r>2&&(m(o.charCodeAt(2))?++n:t=!1))}if(t){for(;n<a.length&&m(a.charCodeAt(n));)n++;n>=2&&(a=`\\${a.slice(n)}`)}return e.$ec.normalize(a)},relative(i,a){if(v(i,"from"),v(a,"to"),i===a)return"";const o=e.$ec.resolve(i),t=e.$ec.resolve(a);if(o===t||(i=o.toLowerCase(),a=t.toLowerCase(),i===a))return"";let n=0;for(;n<i.length&&i.charCodeAt(n)===c;)n++;let r=i.length;for(;r-1>n&&i.charCodeAt(r-1)===c;)r--;const p=r-n;let C=0;for(;C<a.length&&a.charCodeAt(C)===c;)C++;let R=a.length;for(;R-1>C&&a.charCodeAt(R-1)===c;)R--;const k=R-C,I=p<k?p:k;let L=-1,N=0;for(;N<I;N++){const ne=i.charCodeAt(n+N);if(ne!==a.charCodeAt(C+N))break;ne===c&&(L=N)}if(N!==I){if(L===-1)return t}else{if(k>I){if(a.charCodeAt(C+N)===c)return t.slice(C+N+1);if(N===2)return t.slice(C+N)}p>I&&(i.charCodeAt(n+N)===c?L=N:N===2&&(L=3)),L===-1&&(L=0)}let z="";for(N=n+L+1;N<=r;++N)(N===r||i.charCodeAt(N)===c)&&(z+=z.length===0?"..":"\\..");return C+=L,z.length>0?`${z}${t.slice(C,R)}`:(t.charCodeAt(C)===c&&++C,t.slice(C,R))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=e.$ec.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===c){if(a.charCodeAt(1)===c){const o=a.charCodeAt(2);if(o!==w&&o!==S)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(u(a.charCodeAt(0))&&a.charCodeAt(1)===g&&a.charCodeAt(2)===c)return`\\\\?\\${a}`;return i},dirname(i){v(i,"path");const a=i.length;if(a===0)return".";let o=-1,t=0;const n=i.charCodeAt(0);if(a===1)return m(n)?i:".";if(m(n)){if(o=t=1,m(i.charCodeAt(1))){let C=2,R=C;for(;C<a&&!m(i.charCodeAt(C));)C++;if(C<a&&C!==R){for(R=C;C<a&&m(i.charCodeAt(C));)C++;if(C<a&&C!==R){for(R=C;C<a&&!m(i.charCodeAt(C));)C++;if(C===a)return i;C!==R&&(o=t=C+1)}}}}else u(n)&&i.charCodeAt(1)===g&&(o=a>2&&m(i.charCodeAt(2))?3:2,t=o);let r=-1,p=!0;for(let C=a-1;C>=t;--C)if(m(i.charCodeAt(C))){if(!p){r=C;break}}else p=!1;if(r===-1){if(o===-1)return".";r=o}return i.slice(0,r)},basename(i,a){a!==void 0&&v(a,"ext"),v(i,"path");let o=0,t=-1,n=!0,r;if(i.length>=2&&u(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(o=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let p=a.length-1,C=-1;for(r=i.length-1;r>=o;--r){const R=i.charCodeAt(r);if(m(R)){if(!n){o=r+1;break}}else C===-1&&(n=!1,C=r+1),p>=0&&(R===a.charCodeAt(p)?--p===-1&&(t=r):(p=-1,t=C))}return o===t?t=C:t===-1&&(t=i.length),i.slice(o,t)}for(r=i.length-1;r>=o;--r)if(m(i.charCodeAt(r))){if(!n){o=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":i.slice(o,t)},extname(i){v(i,"path");let a=0,o=-1,t=0,n=-1,r=!0,p=0;i.length>=2&&i.charCodeAt(1)===g&&u(i.charCodeAt(0))&&(a=t=2);for(let C=i.length-1;C>=a;--C){const R=i.charCodeAt(C);if(m(R)){if(!r){t=C+1;break}continue}n===-1&&(r=!1,n=C+1),R===S?o===-1?o=C:p!==1&&(p=1):o!==-1&&(p=-1)}return o===-1||n===-1||p===0||p===1&&o===n-1&&o===t+1?"":i.slice(o,n)},format:E.bind(null,"\\"),parse(i){v(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const o=i.length;let t=0,n=i.charCodeAt(0);if(o===1)return m(n)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(m(n)){if(t=1,m(i.charCodeAt(1))){let L=2,N=L;for(;L<o&&!m(i.charCodeAt(L));)L++;if(L<o&&L!==N){for(N=L;L<o&&m(i.charCodeAt(L));)L++;if(L<o&&L!==N){for(N=L;L<o&&!m(i.charCodeAt(L));)L++;L===o?t=L:L!==N&&(t=L+1)}}}}else if(u(n)&&i.charCodeAt(1)===g){if(o<=2)return a.root=a.dir=i,a;if(t=2,m(i.charCodeAt(2))){if(o===3)return a.root=a.dir=i,a;t=3}}t>0&&(a.root=i.slice(0,t));let r=-1,p=t,C=-1,R=!0,k=i.length-1,I=0;for(;k>=t;--k){if(n=i.charCodeAt(k),m(n)){if(!R){p=k+1;break}continue}C===-1&&(R=!1,C=k+1),n===S?r===-1?r=k:I!==1&&(I=1):r!==-1&&(I=-1)}return C!==-1&&(r===-1||I===0||I===1&&r===C-1&&r===p+1?a.base=a.name=i.slice(p,C):(a.name=i.slice(p,r),a.base=i.slice(p,C),a.ext=i.slice(r,C))),p>0&&p!==t?a.dir=i.slice(0,p-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(b){const i=/\\/g;return()=>{const a=P.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>P.cwd()})();e.$fc={resolve(...i){let a="",o=!1;for(let t=i.length-1;t>=-1&&!o;t--){const n=t>=0?i[t]:h();v(n,"path"),n.length!==0&&(a=`${n}/${a}`,o=n.charCodeAt(0)===f)}return a=l(a,!o,"/",$),o?`/${a}`:a.length>0?a:"."},normalize(i){if(v(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===f,o=i.charCodeAt(i.length-1)===f;return i=l(i,!a,"/",$),i.length===0?a?"/":o?"./":".":(o&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return v(i,"path"),i.length>0&&i.charCodeAt(0)===f},join(...i){if(i.length===0)return".";let a;for(let o=0;o<i.length;++o){const t=i[o];v(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.$fc.normalize(a)},relative(i,a){if(v(i,"from"),v(a,"to"),i===a||(i=e.$fc.resolve(i),a=e.$fc.resolve(a),i===a))return"";const o=1,t=i.length,n=t-o,r=1,p=a.length-r,C=n<p?n:p;let R=-1,k=0;for(;k<C;k++){const L=i.charCodeAt(o+k);if(L!==a.charCodeAt(r+k))break;L===f&&(R=k)}if(k===C)if(p>C){if(a.charCodeAt(r+k)===f)return a.slice(r+k+1);if(k===0)return a.slice(r+k)}else n>C&&(i.charCodeAt(o+k)===f?R=k:k===0&&(R=0));let I="";for(k=o+R+1;k<=t;++k)(k===t||i.charCodeAt(k)===f)&&(I+=I.length===0?"..":"/..");return`${I}${a.slice(r+R)}`},toNamespacedPath(i){return i},dirname(i){if(v(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===f;let o=-1,t=!0;for(let n=i.length-1;n>=1;--n)if(i.charCodeAt(n)===f){if(!t){o=n;break}}else t=!1;return o===-1?a?"/":".":a&&o===1?"//":i.slice(0,o)},basename(i,a){a!==void 0&&v(a,"ext"),v(i,"path");let o=0,t=-1,n=!0,r;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let p=a.length-1,C=-1;for(r=i.length-1;r>=0;--r){const R=i.charCodeAt(r);if(R===f){if(!n){o=r+1;break}}else C===-1&&(n=!1,C=r+1),p>=0&&(R===a.charCodeAt(p)?--p===-1&&(t=r):(p=-1,t=C))}return o===t?t=C:t===-1&&(t=i.length),i.slice(o,t)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===f){if(!n){o=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":i.slice(o,t)},extname(i){v(i,"path");let a=-1,o=0,t=-1,n=!0,r=0;for(let p=i.length-1;p>=0;--p){const C=i.charCodeAt(p);if(C===f){if(!n){o=p+1;break}continue}t===-1&&(n=!1,t=p+1),C===S?a===-1?a=p:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||t===-1||r===0||r===1&&a===t-1&&a===o+1?"":i.slice(a,t)},format:E.bind(null,"/"),parse(i){v(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const o=i.charCodeAt(0)===f;let t;o?(a.root="/",t=1):t=0;let n=-1,r=0,p=-1,C=!0,R=i.length-1,k=0;for(;R>=t;--R){const I=i.charCodeAt(R);if(I===f){if(!C){r=R+1;break}continue}p===-1&&(C=!1,p=R+1),I===S?n===-1?n=R:k!==1&&(k=1):n!==-1&&(k=-1)}if(p!==-1){const I=r===0&&o?1:r;n===-1||k===0||k===1&&n===p-1&&n===r+1?a.base=a.name=i.slice(I,p):(a.name=i.slice(I,n),a.base=i.slice(I,p),a.ext=i.slice(n,p))}return r>0?a.dir=i.slice(0,r-1):o&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=b?e.$ec.normalize:e.$fc.normalize,e.$hc=b?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=b?e.$ec.join:e.$fc.join,e.$jc=b?e.$ec.resolve:e.$fc.resolve,e.$kc=b?e.$ec.relative:e.$fc.relative,e.$lc=b?e.$ec.dirname:e.$fc.dirname,e.$mc=b?e.$ec.basename:e.$fc.basename,e.$nc=b?e.$ec.extname:e.$fc.extname,e.$oc=b?e.$ec.format:e.$fc.format,e.$pc=b?e.$ec.parse:e.$fc.parse,e.$qc=b?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=b?e.$ec.sep:e.$fc.sep,e.$sc=b?e.$ec.delimiter:e.$fc.delimiter}),define(te[33],ie([0,1,9,4,27,12]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=void 0;function D(r){return r===47||r===92}e.$Pf=D;function S(r){return r.replace(/[\\/]/g,P.$fc.sep)}e.$Qf=S;function f(r){return r.indexOf("/")===-1&&(r=S(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Rf=f;function c(r,p=P.$fc.sep){if(!r)return"";const C=r.length,R=r.charCodeAt(0);if(D(R)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let I=3;const L=I;for(;I<C&&!D(r.charCodeAt(I));I++);if(L!==I&&!D(r.charCodeAt(I+1))){for(I+=1;I<C;I++)if(D(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,p)}}return p}else if($(R)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+p:r.slice(0,2);let k=r.indexOf("://");if(k!==-1){for(k+=3;k<C;k++)if(D(r.charCodeAt(k)))return r.slice(0,k+1)}return""}e.$Sf=c;function g(r){if(!A.$j||!r||r.length<5)return!1;let p=r.charCodeAt(0);if(p!==92||(p=r.charCodeAt(1),p!==92))return!1;let C=2;const R=C;for(;C<r.length&&(p=r.charCodeAt(C),p!==92);C++);return!(R===C||(p=r.charCodeAt(C+1),isNaN(p)||p===92))}e.$Tf=g;const w=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(r,p=A.$j){const C=p?w:y;return!(!r||r.length===0||/^\s+$/.test(r)||(C.lastIndex=0,C.test(r))||p&&d.test(r)||r==="."||r===".."||p&&r[r.length-1]==="."||p&&r.length!==r.trim().length||r.length>255)}e.$Uf=v;function b(r,p,C){const R=r===p;return!C||R?R:!r||!p?!1:(0,s.$1e)(r,p)}e.$Vf=b;function m(r,p,C,R=P.sep){if(r===p)return!0;if(!r||!p||p.length>r.length)return!1;if(C){if(!(0,s.$2e)(r,p))return!1;if(p.length===r.length)return!0;let I=p.length;return p.charAt(p.length-1)===R&&I--,r.charAt(I)===R}return p.charAt(p.length-1)!==R&&(p+=R),r.indexOf(p)===0}e.$Wf=m;function $(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Xf=$;function u(r,p){return A.$j&&r.endsWith(":")&&(r+=P.sep),(0,P.$hc)(r)||(r=(0,P.$ic)(p,r)),r=(0,P.$gc)(r),A.$j?(r=(0,s.$Je)(r,P.sep),r.endsWith(":")&&(r+=P.sep)):(r=(0,s.$Je)(r,P.sep),r||(r=P.sep)),r}e.$Yf=u;function l(r){const p=(0,P.$gc)(r);return A.$j?r.length>3?!1:E(p)&&(r.length===2||p.charCodeAt(2)===92):p===P.$fc.sep}e.$Zf=l;function E(r,p=A.$j){return p?$(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$1f=E;function h(r,p=A.$j){return E(r,p)?r[0]:void 0}e.$2f=h;function i(r,p,C){return p.length>r.length?-1:r===p?0:(C&&(r=r.toLowerCase(),p=p.toLowerCase()),r.indexOf(p))}e.$3f=i;function a(r){const p=r.split(":");let C,R,k;for(const I of p){const L=Number(I);(0,M.$Bf)(L)?R===void 0?R=L:k===void 0&&(k=L):C=C?[C,I].join(":"):I}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:R!==void 0?R:void 0,column:k!==void 0?k:R!==void 0?1:void 0}}e.$4f=a;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(r,p,C=8){let R="";for(let I=0;I<C;I++){let L;I===0&&A.$j&&!p&&(C===3||C===4)?L=t:L=o,R+=L.charAt(Math.floor(Math.random()*L.length))}let k;return p?k=`${p}-${R}`:k=R,r?(0,P.$ic)(r,k):k}e.$5f=n}),define(te[75],ie([0,1,4]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=e.TerminateResponseCode=e.Source=void 0;var A;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(A||(e.Source=A={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(S,...f){const c=f.reduce((y,d)=>(y[d]=!0,y),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(y=>!c[y]).forEach(y=>{for(let d=0;d<g.length;d++)if(y.search(g[d])!==-1){delete S[y];break}})}e.$wl=M;function D(S){S&&(delete S.DEBUG,P.$k&&delete S.DYLD_LIBRARY_PATH,P.$l&&delete S.LD_PRELOAD)}e.$xl=D}),define(te[7],ie([0,1,9,4]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,D=/^\/\//;function S(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!s.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!M.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(t,n){return!t&&!n?"file":t}function c(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const g="",w="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(n){return n instanceof d?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,r,p,C,R,k=!1){typeof n=="object"?(this.scheme=n.scheme||g,this.authority=n.authority||g,this.path=n.path||g,this.query=n.query||g,this.fragment=n.fragment||g):(this.scheme=f(n,k),this.authority=r||g,this.path=c(this.scheme,p||g),this.query=C||g,this.fragment=R||g,S(this,k))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:p,path:C,query:R,fragment:k}=n;return r===void 0?r=this.scheme:r===null&&(r=g),p===void 0?p=this.authority:p===null&&(p=g),C===void 0?C=this.path:C===null&&(C=g),R===void 0?R=this.query:R===null&&(R=g),k===void 0?k=this.fragment:k===null&&(k=g),r===this.scheme&&p===this.authority&&C===this.path&&R===this.query&&k===this.fragment?this:new m(r,p,C,R,k)}static parse(n,r=!1){const p=y.exec(n);return p?new m(p[2]||g,o(p[4]||g),o(p[5]||g),o(p[7]||g),o(p[9]||g),r):new m(g,g,g,g,g)}static file(n){let r=g;if(A.$j&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const p=n.indexOf(w,2);p===-1?(r=n.substring(2),n=w):(r=n.substring(2,p),n=n.substring(p)||w)}return new m("file",r,n,g,g)}static from(n,r){return new m(n.scheme,n.authority,n.path,n.query,n.fragment,r)}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return A.$j&&n.scheme==="file"?p=d.file(P.$ec.join(E(n,!0),...r)).path:p=P.$fc.join(n.path,...r),n.with({path:p})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof d)return n;{const r=new m(n);return r._formatted=n.external??null,r._fsPath=n._sep===b?n.fsPath??null:null,r}}else return n}}e.URI=d;function v(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$uc=v;const b=A.$j?1:void 0;class m extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=b),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const $={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,n,r){let p,C=-1;for(let R=0;R<t.length;R++){const k=t.charCodeAt(R);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47||r&&k===91||r&&k===93||r&&k===58)C!==-1&&(p+=encodeURIComponent(t.substring(C,R)),C=-1),p!==void 0&&(p+=t.charAt(R));else{p===void 0&&(p=t.substr(0,R));const I=$[k];I!==void 0?(C!==-1&&(p+=encodeURIComponent(t.substring(C,R)),C=-1),p+=I):C===-1&&(C=R)}}return C!==-1&&(p+=encodeURIComponent(t.substring(C))),p!==void 0?p:t}function l(t){let n;for(let r=0;r<t.length;r++){const p=t.charCodeAt(r);p===35||p===63?(n===void 0&&(n=t.substr(0,r)),n+=$[p]):n!==void 0&&(n+=t[r])}return n!==void 0?n:t}function E(t,n){let r;return t.authority&&t.path.length>1&&t.scheme==="file"?r=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?r=t.path.substr(1):r=t.path[1].toLowerCase()+t.path.substr(2):r=t.path,A.$j&&(r=r.replace(/\//g,"\\")),r}e.$vc=E;function h(t,n){const r=n?l:u;let p="",{scheme:C,authority:R,path:k,query:I,fragment:L}=t;if(C&&(p+=C,p+=":"),(R||C==="file")&&(p+=w,p+=w),R){let N=R.indexOf("@");if(N!==-1){const z=R.substr(0,N);R=R.substr(N+1),N=z.lastIndexOf(":"),N===-1?p+=r(z,!1,!1):(p+=r(z.substr(0,N),!1,!1),p+=":",p+=r(z.substr(N+1),!1,!0)),p+="@"}R=R.toLowerCase(),N=R.lastIndexOf(":"),N===-1?p+=r(R,!1,!0):(p+=r(R.substr(0,N),!1,!0),p+=R.substr(N))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const N=k.charCodeAt(1);N>=65&&N<=90&&(k=`/${String.fromCharCode(N+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const N=k.charCodeAt(0);N>=65&&N<=90&&(k=`${String.fromCharCode(N+32)}:${k.substr(2)}`)}p+=r(k,!0,!1)}return I&&(p+="?",p+=r(I,!1,!1)),L&&(p+="#",p+=n?L:u(L,!1,!1)),p}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(t){return t.match(a)?t.replace(a,n=>i(n)):t}}),define(te[152],ie([0,1,7]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Wp=e.$Vp=e.$Up=void 0;function A(c){const g=c;return g&&typeof g.type=="string"&&typeof g.severity=="string"}e.$Up=A;function s(c){const g=[];let w;try{const y=JSON.parse(c.arguments),d=y[y.length-1];d&&d.__$stack&&(y.pop(),w=d.__$stack),g.push(...y)}catch{g.push("Unable to log remote console arguments",c.arguments)}return{args:g,stack:w}}e.$Vp=s;function M(c){if(typeof c!="string")return M(s(c).stack);const g=c;if(g){const w=D(g),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(y&&y.length===4)return{uri:P.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$Wp=M;function D(c){if(!c)return c;const g=c.indexOf(`
`);return g===-1?c:c.substring(0,g)}function S(c,g){const{args:w,stack:y}=s(c),d=typeof w[0]=="string"&&w.length===1;let v=D(y);v&&(v=`(${v.trim()})`);let b=[];if(typeof w[0]=="string"?v&&d?b=[`%c[${g}] %c${w[0]} %c${v}`,f("blue"),f(""),f("grey")]:b=[`%c[${g}] %c${w[0]}`,f("blue"),f(""),...w.slice(1)]:b=[`%c[${g}]%`,f("blue"),...w],v&&!d&&b.push(v),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,b)}e.log=S;function f(c){return`color: ${c}`}}),define(te[76],ie([0,1,18,7]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function s(f){return JSON.stringify(f,D)}e.$ih=s;function M(f){let c=JSON.parse(f);return c=S(c),c}e.$jh=M;function D(f,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function S(f,c=0){if(!f||c>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return A.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof P.$ae||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let g=0;g<f.length;++g)f[g]=S(f[g],c+1);else for(const g in f)Object.hasOwnProperty.call(f,g)&&(f[g]=S(f[g],c+1))}return f}e.$kh=S}),define(te[13],ie([0,1,14,4,7]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.Schemas=void 0;var M;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$6f="vscode-tkn",e.$7f="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g){this.f=`${g}/${M.vscodeRemoteResource}`}set(g,w,y){this.a[g]=w,this.b[g]=y}setConnectionToken(g,w){this.c[g]=w}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(m){return P.$Z(m),g}const w=g.authority;let y=this.a[w];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const d=this.b[w],v=this.c[w];let b=`path=${encodeURIComponent(g.path)}`;return typeof v=="string"&&(b+=`&${e.$7f}=${encodeURIComponent(v)}`),s.URI.from({scheme:A.$p?this.d:M.vscodeRemoteResource,authority:`${y}:${d}`,path:this.f,query:b})}}e.$8f=new D,e.$9f="vs/../../extensions",e.$0f="vs/../../node_modules",e.$$f="vs/../../node_modules.asar",e.$_f="vs/../../node_modules.asar.unpacked",e.$ag="vscode-app";class S{static{this.a=e.$ag}asBrowserUri(g){const w=this.b(g,Z);return this.uriToBrowserUri(w)}uriToBrowserUri(g){return g.scheme===M.vscodeRemote?e.$8f.rewrite(g):g.scheme===M.file&&(A.$n||A.$q&&A.$h.origin===`${M.vscodeFileResource}://${S.a}`)?g.with({scheme:M.vscodeFileResource,authority:g.authority||S.a,query:null,fragment:null}):g}asFileUri(g){const w=this.b(g,Z);return this.uriToFileUri(w)}uriToFileUri(g){return g.scheme===M.vscodeFileResource?g.with({scheme:M.file,authority:g.authority!==S.a?g.authority:null,query:null,fragment:null}):g}b(g,w){return s.URI.isUri(g)?g:s.URI.parse(w.toUrl(g))}}e.$bg=new S;var f;(function(c){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(g.get("3"));const w="vscode-coi";function y(v){let b;typeof v=="string"?b=new URL(v).searchParams:v instanceof URL?b=v.searchParams:s.URI.isUri(v)&&(b=new URL(v.toString(!0)).searchParams);const m=b?.get(w);if(m)return g.get(m)}c.getHeadersFromQuery=y;function d(v,b,m){if(!globalThis.crossOriginIsolated)return;const $=b&&m?"3":m?"2":"1";v instanceof URLSearchParams?v.set(w,$):v[w]=$}c.addSearchParam=d})(f||(e.COI=f={}))}),define(te[19],ie([0,1,33,13,9,4,27,7]),function(Z,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.DataUri=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function f(d){return(0,S.$vc)(d,!0)}e.$ig=f;class c{constructor(v){this.a=v}compare(v,b,m=!1){return v===b?0:(0,D.$Te)(this.getComparisonKey(v,m),this.getComparisonKey(b,m))}isEqual(v,b,m=!1){return v===b?!0:!v||!b?!1:this.getComparisonKey(v,m)===this.getComparisonKey(b,m)}getComparisonKey(v,b=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,b,m=!1){if(v.scheme===b.scheme){if(v.scheme===A.Schemas.file)return P.$Wf(f(v),f(b),this.a(v))&&v.query===b.query&&(m||v.fragment===b.fragment);if((0,e.$zg)(v.authority,b.authority))return P.$Wf(v.path,b.path,this.a(v),"/")&&v.query===b.query&&(m||v.fragment===b.fragment)}return!1}joinPath(v,...b){return S.URI.joinPath(v,...b)}basenameOrAuthority(v){return(0,e.$rg)(v)||v.authority}basename(v){return s.$fc.basename(v.path)}extname(v){return s.$fc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let b;return v.scheme===A.Schemas.file?b=S.URI.file(s.$lc(f(v))).path:(b=s.$fc.dirname(v.path),v.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),b="/")),v.with({path:b})}normalizePath(v){if(!v.path.length)return v;let b;return v.scheme===A.Schemas.file?b=S.URI.file(s.$gc(f(v))).path:b=s.$fc.normalize(v.path),v.with({path:b})}relativePath(v,b){if(v.scheme!==b.scheme||!(0,e.$zg)(v.authority,b.authority))return;if(v.scheme===A.Schemas.file){const u=s.$kc(f(v),f(b));return M.$j?P.$Qf(u):u}let m=v.path||"/";const $=b.path||"/";if(this.a(v)){let u=0;for(const l=Math.min(m.length,$.length);u<l&&!(m.charCodeAt(u)!==$.charCodeAt(u)&&m.charAt(u).toLowerCase()!==$.charAt(u).toLowerCase());u++);m=$.substr(0,u)+m.substr(u)}return s.$fc.relative(m,$)}resolvePath(v,b){if(v.scheme===A.Schemas.file){const m=S.URI.file(s.$jc(f(v),b));return v.with({authority:m.authority,path:m.path})}return b=P.$Rf(b),v.with({path:s.$fc.resolve(v.path,b)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,b){return v===b||v!==void 0&&b!==void 0&&(0,D.$1e)(v,b)}hasTrailingPathSeparator(v,b=s.sep){if(v.scheme===A.Schemas.file){const m=f(v);return m.length>P.$Sf(m).length&&m[m.length-1]===b}else{const m=v.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,b=s.sep){return(0,e.$Ag)(v,b)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,b=s.sep){let m=!1;if(v.scheme===A.Schemas.file){const $=f(v);m=$!==void 0&&$.length===P.$Sf($).length&&$[$.length-1]===b}else{b="/";const $=v.path;m=$.length===1&&$.charCodeAt($.length-1)===47}return!m&&!(0,e.$Ag)(v,b)?v.with({path:v.path+"/"}):v}}e.$jg=c,e.$kg=new c(()=>!1),e.$lg=new c(d=>d.scheme===A.Schemas.file?!M.$l:!0),e.$mg=new c(d=>!0),e.$ng=e.$kg.isEqual.bind(e.$kg),e.$og=e.$kg.isEqualOrParent.bind(e.$kg),e.$pg=e.$kg.getComparisonKey.bind(e.$kg),e.$qg=e.$kg.basenameOrAuthority.bind(e.$kg),e.$rg=e.$kg.basename.bind(e.$kg),e.$sg=e.$kg.extname.bind(e.$kg),e.$tg=e.$kg.dirname.bind(e.$kg),e.$ug=e.$kg.joinPath.bind(e.$kg),e.$vg=e.$kg.normalizePath.bind(e.$kg),e.$wg=e.$kg.relativePath.bind(e.$kg),e.$xg=e.$kg.resolvePath.bind(e.$kg),e.$yg=e.$kg.isAbsolutePath.bind(e.$kg),e.$zg=e.$kg.isEqualAuthority.bind(e.$kg),e.$Ag=e.$kg.hasTrailingPathSeparator.bind(e.$kg),e.$Bg=e.$kg.removeTrailingPathSeparator.bind(e.$kg),e.$Cg=e.$kg.addTrailingPathSeparator.bind(e.$kg);function g(d,v){const b=[];for(let m=0;m<d.length;m++){const $=v(d[m]);d.some((u,l)=>l===m?!1:(0,e.$og)($,v(u)))||b.push(d[m])}return b}e.$Dg=g;var w;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function v(b){const m=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(l=>{const[E,h]=l.split(":");E&&h&&m.set(E,h)});const u=b.path.substring(0,b.path.indexOf(";"));return u&&m.set(d.META_DATA_MIME,u),m}d.parseMetaData=v})(w||(e.DataUri=w={}));function y(d,v,b){if(v){let m=d.path;return m&&m[0]!==s.$fc.sep&&(m=s.$fc.sep+m),d.with({scheme:b,authority:v,path:m})}return d.with({scheme:b})}e.$Eg=y}),define(te[8],ie([0,1,22,14,3,2,19,4,141]),function(Z,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eh=e.$dh=e.$ch=e.Promises=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function c(O){return!!O&&typeof O.then=="function"}e.$Fg=c;function g(O){const j=new P.$Wd,B=O(j.token),W=new Promise((T,V)=>{const ce=j.token.onCancellationRequested(()=>{ce.dispose(),j.dispose(),V(new A.$4)});Promise.resolve(B).then(de=>{ce.dispose(),j.dispose(),T(de)},de=>{ce.dispose(),j.dispose(),V(de)})});return new class{cancel(){j.cancel()}then(T,V){return W.then(T,V)}catch(T){return this.then(void 0,T)}finally(T){return W.finally(T)}}}e.$Gg=g;function w(O,j,B){return new Promise((W,T)=>{const V=j.onCancellationRequested(()=>{V.dispose(),W(B)});O.then(W,T).finally(()=>V.dispose())})}e.$Hg=w;function y(O,j){return new Promise((B,W)=>{const T=j.onCancellationRequested(()=>{T.dispose(),W(new A.$4)});O.then(B,W).finally(()=>T.dispose())})}e.$Ig=y;async function d(O){let j=-1;const B=O.map((W,T)=>W.then(V=>(j=T,V)));try{return await Promise.race(B)}finally{O.forEach((W,T)=>{T!==j&&W.cancel()})}}e.$Jg=d;function v(O,j,B){let W;const T=setTimeout(()=>{W?.(void 0),B?.()},j);return Promise.race([O.finally(()=>clearTimeout(T)),new Promise(V=>W=V)])}e.$Kg=v;function b(O){return new Promise((j,B)=>{const W=O();c(W)?W.then(j,B):j(W)})}e.$Lg=b;class m{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(j){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=j,!this.b){const B=()=>{if(this.b=null,this.f)return;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(B,B).then(W)})}return new Promise((B,W)=>{this.b.then(B,W)})}return this.a=j(),new Promise((B,W)=>{this.a.then(T=>{this.a=null,B(T)},T=>{this.a=null,W(T)})})}dispose(){this.f=!0}}e.$Mg=m;class ${constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.$Ng=$;class u{constructor(){this.a=new Map}queue(j,B){const T=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.a.get(j)===T&&this.a.delete(j)});return this.a.set(j,T),T}}e.$Og=u;const l=(O,j)=>{let B=!0;const W=setTimeout(()=>{B=!1,j()},O);return{isTriggered:()=>B,dispose:()=>{clearTimeout(W),B=!1}}},E=O=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,O())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class h{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,B=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((T,V)=>{this.d=T,this.f=V}).then(()=>{if(this.b=null,this.d=null,this.g){const T=this.g;return this.g=null,T()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=B===f.$Jd?E(W):l(B,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Pg=h;class i{constructor(j){this.a=new h(j),this.b=new m}trigger(j,B){return this.a.trigger(()=>this.b.queue(j),B)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Qg=i;class a{constructor(){this.a=!1,this.b=new Promise((j,B)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Rg=a;class o extends a{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.$Sg=o;function t(O,j){return j?new Promise((B,W)=>{const T=setTimeout(()=>{V.dispose(),B()},O),V=j.onCancellationRequested(()=>{clearTimeout(T),V.dispose(),W(new A.$4)})}):g(B=>t(O,B))}e.$Tg=t;function n(O,j=0,B){const W=setTimeout(()=>{O(),B&&T.dispose()},j),T=(0,M.$Pc)(()=>{clearTimeout(W),B?.deleteAndLeak(T)});return B?.add(T),T}e.$Ug=n;function r(O){const j=[];let B=0;const W=O.length;function T(){return B<W?O[B++]():null}function V(ce){ce!=null&&j.push(ce);const de=T();return de?de.then(V):Promise.resolve(j)}return Promise.resolve(null).then(V)}e.$Vg=r;function p(O,j=W=>!!W,B=null){let W=0;const T=O.length,V=()=>{if(W>=T)return Promise.resolve(B);const ce=O[W++];return Promise.resolve(ce()).then(ue=>j(ue)?Promise.resolve(ue):V())};return V()}e.$Wg=p;function C(O,j=W=>!!W,B=null){if(O.length===0)return Promise.resolve(B);let W=O.length;const T=()=>{W=-1;for(const V of O)V.cancel?.()};return new Promise((V,ce)=>{for(const de of O)de.then(ue=>{--W>=0&&j(ue)?(T(),V(ue)):W===0&&V(B)}).catch(ue=>{--W>=0&&(T(),ce(ue))})})}e.$Xg=C;class R{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new s.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((B,W)=>{this.f.push({factory:j,c:B,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const B=j.factory();B.then(j.c,j.e),B.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Yg=R;class k extends R{constructor(){super(1)}}e.$Zg=k;class I{constructor(){this.a=new K,this.b=0}queue(j){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,j())):this.a.run(this.b++,j())}}e.$1g=I;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const j=new q;return this.b.add(j),j.p}g(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,B=D.$kg){const W=B.getComparisonKey(j);let T=this.a.get(W);if(!T){T=new k;const V=this.f++,ce=s.Event.once(T.onDrained)(()=>{T?.dispose(),this.a.delete(W),this.h(),this.d?.deleteAndDispose(V),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$Zc),this.d.set(V,ce),this.a.set(W,T)}return T}h(){this.g()&&this.j()}j(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$2g=L;class N{constructor(j,B){this.a=-1,typeof j=="function"&&typeof B=="number"&&this.setIfNotSet(j,B)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,B){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},B)}setIfNotSet(j,B){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},B))}}e.$3g=N;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,B){this.cancel(),this.a=setInterval(()=>{j()},B)}}e.$4g=z;class ne{constructor(j,B){this.b=-1,this.a=j,this.d=B,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$5g=ne;class _{constructor(j,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.a=j,this.b=B,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$6g=_;class ae extends ne{constructor(j,B){super(j,B),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.$7g=ae;class se extends M.$Rc{constructor(j,B){super(),this.g=j,this.h=B,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const B of j)this.a.push(B);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$8g=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$9g=O=>{(0,S.$B)(()=>{if(j)return;const B=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.$9g=(O,j)=>{const B=requestIdleCallback(O,typeof j=="number"?{timeout:j}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(B))}}}}();class oe{constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(B){this.g=B}finally{this.d=!0}},this.b=(0,e.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$0g=oe;async function J(O,j,B){let W;for(let T=0;T<B;T++)try{return await O()}catch(V){W=V,await t(j)}throw W}e.$$g=J;class K{isRunning(j){return typeof j=="number"?this.a?.taskId===j:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(j,B,W){return this.a={taskId:j,cancel:()=>W?.(),promise:B},B.then(()=>this.d(j),()=>this.d(j)),B}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this.b)this.b.run=j;else{let B,W;const T=new Promise((V,ce)=>{B=V,W=ce});this.b={run:j,promise:T,promiseResolve:B,promiseReject:W}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$_g=K;class G{constructor(j,B=()=>Date.now()){this.d=j,this.f=B,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.$ah=G;var U;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(U||(U={}));class q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((j,B)=>{this.a=j,this.b=B})}complete(j){return new Promise(B=>{this.a(j),this.d={outcome:0,value:j},B()})}error(j){return new Promise(B=>{this.b(j),this.d={outcome:1,value:j},B()})}cancel(){return this.error(new A.$4)}}e.$bh=q;var X;(function(O){async function j(W){let T;const V=await Promise.all(W.map(ce=>ce.then(de=>de,de=>{T||(T=de)})));if(typeof T<"u")throw T;return V}O.settled=j;function B(W){return new Promise(async(T,V)=>{try{await W(T,V)}catch(ce){V(ce)}})}O.withAsyncBody=B})(X||(e.Promises=X={}));var H;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(H||(H={}));class Q{static fromArray(j){return new Q(B=>{B.emitMany(j)})}static fromPromise(j){return new Q(async B=>{B.emitMany(await j)})}static fromPromises(j){return new Q(async B=>{await Promise.all(j.map(async W=>B.emitOne(await W)))})}static merge(j){return new Q(async B=>{await Promise.all(j.map(async W=>{for await(const T of W)B.emitOne(T)}))})}static{this.EMPTY=Q.fromArray([])}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new s.$Md,queueMicrotask(async()=>{const B={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(j(B)),this.j()}catch(W){this.k(W)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(j,B){return new Q(async W=>{for await(const T of j)W.emitOne(B(T))})}map(j){return Q.map(this,j)}static filter(j,B){return new Q(async W=>{for await(const T of j)B(T)&&W.emitOne(T)})}filter(j){return Q.filter(this,j)}static coalesce(j){return Q.filter(j,B=>!!B)}coalesce(){return Q.coalesce(this)}static async toPromise(j){const B=[];for await(const W of j)B.push(W);return B}toPromise(){return Q.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}e.$ch=Q;class re extends Q{constructor(j,B){super(B),this.l=j}cancel(){this.l.cancel()}}e.$dh=re;function F(O){const j=new P.$Wd,B=O(j.token);return new re(j,async W=>{const T=j.token.onCancellationRequested(()=>{T.dispose(),j.dispose(),W.reject(new A.$4)});try{for await(const V of B){if(j.token.isCancellationRequested)return;W.emitOne(V)}T.dispose(),j.dispose()}catch(V){T.dispose(),j.dispose(),W.reject(V)}})}e.$eh=F}),define(te[104],ie([0,1,23,8,33,31,9,4,27]),function(Z,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0;function c(){return Object.create(null)}e.$pj=c,e.$qj="**",e.$rj="/";const g="[/\\\\]",w="[^/\\\\]",y=/\//g;function d(K,G){switch(K){case 0:return"";case 1:return`${w}*?`;default:return`(?:${g}|${w}+${g}${G?`|${g}${w}+`:""})*?`}}function v(K,G){if(!K)return[];const U=[];let q=!1,X=!1,H="";for(const Q of K){switch(Q){case G:if(!q&&!X){U.push(H),H="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":X=!0;break;case"]":X=!1;break}H+=Q}return H&&U.push(H),U}e.$sj=v;function b(K){if(!K)return"";let G="";const U=v(K,e.$rj);if(U.every(q=>q===e.$qj))G=".*";else{let q=!1;U.forEach((X,H)=>{if(X===e.$qj){if(q)return;G+=d(2,H===U.length-1)}else{let Q=!1,re="",F=!1,O="";for(const j of X){if(j!=="}"&&Q){re+=j;continue}if(F&&(j!=="]"||!O)){let B;j==="-"?B=j:(j==="^"||j==="!")&&!O?B="^":j===e.$rj?B="":B=(0,f.$Ee)(j),O+=B;continue}switch(j){case"{":Q=!0;continue;case"[":F=!0;continue;case"}":{const W=`(?:${v(re,",").map(T=>b(T)).join("|")})`;G+=W,Q=!1,re="";break}case"]":{G+="["+O+"]",F=!1,O="";break}case"?":G+=w;continue;case"*":G+=d(1);continue;default:G+=(0,f.$Ee)(j)}}H<U.length-1&&(U[H+1]!==e.$qj||H+2<U.length)&&(G+=g)}q=X===e.$qj})}return G}const m=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Cc(1e4),a=function(){return!1},o=function(){return null};function t(K,G){if(!K)return o;let U;typeof K!="string"?U=K.pattern:U=K,U=U.trim();const q=`${U}_${!!G.trimForExclusions}`;let X=i.get(q);if(X)return n(X,K);let H;return m.test(U)?X=p(U.substr(4),U):(H=$.exec(r(U,G)))?X=C(H[1],U):(G.trimForExclusions?l:u).test(U)?X=R(U,G):(H=E.exec(r(U,G)))?X=k(H[1].substr(1),U,!0):(H=h.exec(r(U,G)))?X=k(H[1],U,!1):X=I(U),i.set(q,X),n(X,K)}function n(K,G){if(typeof G=="string")return K;const U=function(q,X){return(0,s.$Wf)(q,G.base,!S.$l)?K((0,f.$Ie)(q.substr(G.base.length),D.sep),X):null};return U.allBasenames=K.allBasenames,U.allPaths=K.allPaths,U.basenames=K.basenames,U.patterns=K.patterns,U}function r(K,G){return G.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function p(K,G){return function(U,q){return typeof U=="string"&&U.endsWith(K)?G:null}}function C(K,G){const U=`/${K}`,q=`\\${K}`,X=function(Q,re){return typeof Q!="string"?null:re?re===K?G:null:Q===K||Q.endsWith(U)||Q.endsWith(q)?G:null},H=[K];return X.basenames=H,X.patterns=[G],X.allBasenames=H,X}function R(K,G){const U=oe(K.slice(1,-1).split(",").map(re=>t(re,G)).filter(re=>re!==o),K),q=U.length;if(!q)return o;if(q===1)return U[0];const X=function(re,F){for(let O=0,j=U.length;O<j;O++)if(U[O](re,F))return K;return null},H=U.find(re=>!!re.allBasenames);H&&(X.allBasenames=H.allBasenames);const Q=U.reduce((re,F)=>F.allPaths?re.concat(F.allPaths):re,[]);return Q.length&&(X.allPaths=Q),X}function k(K,G,U){const q=D.sep===D.$fc.sep,X=q?K:K.replace(y,D.sep),H=D.sep+X,Q=D.$fc.sep+K;let re;return U?re=function(F,O){return typeof F=="string"&&(F===X||F.endsWith(H)||!q&&(F===K||F.endsWith(Q)))?G:null}:re=function(F,O){return typeof F=="string"&&(F===X||!q&&F===K)?G:null},re.allPaths=[(U?"*/":"./")+K],re}function I(K){try{const G=new RegExp(`^${b(K)}$`);return function(U){return G.lastIndex=0,typeof U=="string"&&G.test(U)?K:null}}catch{return o}}function L(K,G,U){return!K||typeof G!="string"?!1:N(K)(G,void 0,U)}e.$tj=L;function N(K,G={}){if(!K)return a;if(typeof K=="string"||z(K)){const U=t(K,G);if(U===o)return a;const q=function(X,H){return!!U(X,H)};return U.allBasenames&&(q.allBasenames=U.allBasenames),U.allPaths&&(q.allPaths=U.allPaths),q}return ae(K,G)}e.$uj=N;function z(K){const G=K;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$vj=z;function ne(K){return K.allBasenames||[]}e.$wj=ne;function _(K){return K.allPaths||[]}e.$xj=_;function ae(K,G){const U=oe(Object.getOwnPropertyNames(K).map(re=>se(re,K[re],G)).filter(re=>re!==o)),q=U.length;if(!q)return o;if(!U.some(re=>!!re.requiresSiblings)){if(q===1)return U[0];const re=function(j,B){let W;for(let T=0,V=U.length;T<V;T++){const ce=U[T](j,B);if(typeof ce=="string")return ce;(0,A.$Fg)(ce)&&(W||(W=[]),W.push(ce))}return W?(async()=>{for(const T of W){const V=await T;if(typeof V=="string")return V}return null})():null},F=U.find(j=>!!j.allBasenames);F&&(re.allBasenames=F.allBasenames);const O=U.reduce((j,B)=>B.allPaths?j.concat(B.allPaths):j,[]);return O.length&&(re.allPaths=O),re}const X=function(re,F,O){let j,B;for(let W=0,T=U.length;W<T;W++){const V=U[W];V.requiresSiblings&&O&&(F||(F=(0,D.$mc)(re)),j||(j=F.substr(0,F.length-(0,D.$nc)(re).length)));const ce=V(re,F,j,O);if(typeof ce=="string")return ce;(0,A.$Fg)(ce)&&(B||(B=[]),B.push(ce))}return B?(async()=>{for(const W of B){const T=await W;if(typeof T=="string")return T}return null})():null},H=U.find(re=>!!re.allBasenames);H&&(X.allBasenames=H.allBasenames);const Q=U.reduce((re,F)=>F.allPaths?re.concat(F.allPaths):re,[]);return Q.length&&(X.allPaths=Q),X}function se(K,G,U){if(G===!1)return o;const q=t(K,U);if(q===o)return o;if(typeof G=="boolean")return q;if(G){const X=G.when;if(typeof X=="string"){const H=(Q,re,F,O)=>{if(!O||!q(Q,re))return null;const j=X.replace("$(basename)",()=>F),B=O(j);return(0,A.$Fg)(B)?B.then(W=>W?K:null):B?K:null};return H.requiresSiblings=!0,H}}return q}function oe(K,G){const U=K.filter(re=>!!re.basenames);if(U.length<2)return K;const q=U.reduce((re,F)=>{const O=F.basenames;return O?re.concat(O):re},[]);let X;if(G){X=[];for(let re=0,F=q.length;re<F;re++)X.push(G)}else X=U.reduce((re,F)=>{const O=F.patterns;return O?re.concat(O):re},[]);const H=function(re,F){if(typeof re!="string")return null;if(!F){let j;for(j=re.length;j>0;j--){const B=re.charCodeAt(j-1);if(B===47||B===92)break}F=re.substr(j)}const O=q.indexOf(F);return O!==-1?X[O]:null};H.basenames=q,H.patterns=X,H.allBasenames=q;const Q=K.filter(re=>!re.basenames);return Q.push(H),Q}function J(K,G){return(0,P.$tb)(K,G,(U,q)=>typeof U=="string"&&typeof q=="string"?U===q:typeof U!="string"&&typeof q!="string"?U.base===q.base&&U.pattern===q.pattern:!1)}e.$yj=J}),define(te[46],ie([0,1,23,33,9,4,19,27]),function(Z,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=void 0;function f(t,n){const{os:r,tildify:p,relative:C}=n;if(C){const I=c(t,C,r);if(typeof I=="string")return I}let R=t.fsPath;if(r===1&&!M.$j?R=R.replace(/\//g,"\\"):r!==1&&M.$j&&(R=R.replace(/\\/g,"/")),r!==1&&p?.userHome){const I=p.userHome.fsPath;let L;t.scheme!==p.userHome.scheme&&t.path.startsWith(s.$fc.sep)?L=p.userHome.with({path:t.path}).fsPath:L=t.fsPath,R=y(L,I,r)}return(r===1?s.$ec:s.$fc).normalize(g(R,r===1))}e.$mv=f;function c(t,n,r){const p=r===1?s.$ec:s.$fc,C=r===3?D.$kg:D.$mg,R=n.getWorkspace(),k=(0,P.$Nb)(R.folders);if(!k)return;t.scheme!==k.uri.scheme&&t.path.startsWith(s.$fc.sep)&&(t=k.uri.with({path:t.path}));const I=n.getWorkspaceFolder(t);if(!I)return;let L;if(C.isEqual(I.uri,t)?L="":L=C.relativePath(I.uri,t)??"",L&&(L=p.normalize(L)),R.folders.length>1&&!n.noPrefix){const N=I.name?I.name:C.basenameOrAuthority(I.uri);L=L?`${N} \u2022 ${L}`:N}return L}function g(t,n=M.$j){return(0,A.$1f)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$nv=g;let w=Object.create(null);function y(t,n,r=M.OS){if(r===1||!t||!n)return t;let p=w.original===n?w.normalized:void 0;p||(p=n,M.$j&&(p=(0,A.$Qf)(p)),p=`${(0,S.$Je)(p,s.$fc.sep)}${s.$fc.sep}`,w={original:n,normalized:p});let C=t;return M.$j&&(C=(0,A.$Qf)(C)),(r===3?C.startsWith(p):(0,S.$2e)(C,p))?`~/${C.substr(p.length)}`:t}e.$ov=y;function d(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.$pv=d;const v="\u2026",b="\\\\",m="~";function $(t,n=s.sep){const r=new Array(t.length);let p=!1;for(let C=0;C<t.length;C++){const R=t[C];if(R===""){r[C]=`.${n}`;continue}if(!R){r[C]=R;continue}p=!0;let k="",I=R;I.indexOf(b)===0?(k=I.substr(0,I.indexOf(b)+b.length),I=I.substr(I.indexOf(b)+b.length)):I.indexOf(n)===0?(k=I.substr(0,I.indexOf(n)+n.length),I=I.substr(I.indexOf(n)+n.length)):I.indexOf(m)===0&&(k=I.substr(0,I.indexOf(m)+m.length),I=I.substr(I.indexOf(m)+m.length));const L=I.split(n);for(let N=1;p&&N<=L.length;N++)for(let z=L.length-N;p&&z>=0;z--){p=!1;let ne=L.slice(z,z+N).join(n);for(let _=0;!p&&_<t.length;_++)if(_!==C&&t[_]&&t[_].indexOf(ne)>-1){const ae=z+N===L.length,se=z>0&&t[_].indexOf(n)>-1?n+ne:ne,oe=t[_].endsWith(se);p=!ae||oe}if(!p){let _="";(L[0].endsWith(":")||k!=="")&&(z===1&&(z=0,N++,ne=L[0]+n+ne),z>0&&(_=L[0]+n),_=k+_),z>0&&(_=_+v+n),_=_+ne,z+N<L.length&&(_=_+n+v),r[C]=_}}p&&(r[C]=R)}return r}e.$qv=$;var u;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function l(t,n=Object.create(null)){const r=[];let p=!1,C="";for(const R of t)if(R==="$"||p&&R==="{")C&&r.push({value:C,type:u.TEXT}),C="",p=!0;else if(R==="}"&&p){const k=n[C];if(typeof k=="string")k.length&&r.push({value:k,type:u.VARIABLE});else if(k){const I=r[r.length-1];(!I||I.type!==u.SEPARATOR)&&r.push({value:k.label,type:u.SEPARATOR})}C="",p=!1}else C+=R;return C&&!p&&r.push({value:C,type:u.TEXT}),r.filter((R,k)=>{if(R.type===u.SEPARATOR){const I=r[k-1],L=r[k+1];return[I,L].every(N=>N&&(N.type===u.VARIABLE||N.type===u.TEXT)&&N.value.length>0)}return!0}).map(R=>R.value).join("")}e.$rv=l;function E(t,n){return M.$k||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$k?"&":"&&"):t.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.$sv=E;function h(t,n){return M.$k||n?t.replace(/\(&&\w\)|&&/g,""):M.$j?t.replace(/&&|&/g,r=>r==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$tv=h;function i(t){return t.replace(/&/g,"&&")}e.$uv=i;function a(t){if(t.endsWith("]")){const n=t.lastIndexOf(" [",t.length-2);if(n!==-1){const r=o(t.substring(0,n));return{name:r.name,parentPath:r.parentPath+t.substring(n)}}}return o(t)}e.$vv=a;function o(t){const n=t.indexOf("/")!==-1?s.$fc:s.$ec,r=n.basename(t),p=n.dirname(t);return r.length?{name:r,parentPath:p}:{name:p,parentPath:""}}}),define(te[153],ie([0,1,18,7]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=void 0;function s(w){return w.toJSON()}class M{constructor(y){this.a=y}transformIncoming(y){const d=this.a.transformIncoming(y);return d===y?y:s(A.URI.from(d))}transformOutgoing(y){const d=this.a.transformOutgoing(y);return d===y?y:s(A.URI.from(d))}transformOutgoingURI(y){const d=this.a.transformOutgoing(y);return d===y?y:A.URI.from(d)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$Im=M,e.$Jm=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function D(w,y,d){if(!w||d>200)return null;if(typeof w=="object"){if(w instanceof A.URI)return y.transformOutgoing(w);for(const v in w)if(Object.hasOwnProperty.call(w,v)){const b=D(w[v],y,d+1);b!==null&&(w[v]=b)}}return null}function S(w,y){const d=D(w,y,0);return d===null?w:d}e.$Km=S;function f(w,y,d,v){if(!w||v>200)return null;if(typeof w=="object"){if(w.$mid===1)return d?A.URI.revive(y.transformIncoming(w)):y.transformIncoming(w);if(w instanceof P.$ae)return null;for(const b in w)if(Object.hasOwnProperty.call(w,b)){const m=f(w[b],y,d,v+1);m!==null&&(w[b]=m)}}return null}function c(w,y){const d=f(w,y,!1,0);return d===null?w:d}e.$Lm=c;function g(w,y){const d=f(w,y,!0,0);return d===null?w:d}e.$Mm=g}),define(te[21],ie([0,1,45,28,154,8,33,84,9,4,19,7]),function(Z,e,P,A,s,M,D,S,f,c,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function d(se,oe=y.UNLINK,J){if((0,D.$Zf)(se))throw new Error("rimraf - will refuse to recursively delete root");return oe===y.UNLINK?b(se):v(se,J)}async function v(se,oe=(0,D.$5f)((0,A.tmpdir)())){try{try{await P.promises.rename(se,oe)}catch(J){return J.code==="ENOENT"?void 0:b(se)}b(oe).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function b(se){return(0,s.promisify)(P.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function m(se){if((0,D.$Zf)(se))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function $(se,oe){return E(await(oe?u(se):(0,s.promisify)(P.readdir)(se)))}async function u(se){try{return await(0,s.promisify)(P.readdir)(se,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const oe=[],J=await $(se);for(const K of J){let G=!1,U=!1,q=!1;try{const X=await e.Promises.lstat((0,f.$ic)(se,K));G=X.isFile(),U=X.isDirectory(),q=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}oe.push({name:K,isFile:()=>G,isDirectory:()=>U,isSymbolicLink:()=>q})}return oe}function l(se){return E(P.readdirSync(se))}e.readdirSync=l;function E(se){return se.map(oe=>typeof oe=="string"?c.$k?(0,S.$ll)(oe):oe:(oe.name=c.$k?(0,S.$ll)(oe.name):oe.name,oe))}async function h(se){const oe=await $(se),J=[];for(const K of oe)await a.existsDirectory((0,f.$ic)(se,K))&&J.push(K);return J}function i(se,oe=1e3){return new Promise(J=>{let K=!1;const G=setInterval(()=>{K||(K=!0,P.access(se,U=>{K=!1,U&&(clearInterval(G),J(void 0))}))},oe)})}e.whenDeleted=i;var a;(function(se){async function oe(G){let U;try{if(U=await e.Promises.lstat(G),!U.isSymbolicLink())return{stat:U}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(c.$j&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw X}throw q}}se.stat=oe;async function J(G){try{const{stat:U,symbolicLink:q}=await se.stat(G);return U.isFile()&&q?.dangling!==!0}catch{}return!1}se.existsFile=J;async function K(G){try{const{stat:U,symbolicLink:q}=await se.stat(G);return U.isDirectory()&&q?.dangling!==!0}catch{}return!1}se.existsDirectory=K})(a||(e.SymlinkSupport=a={}));const o=new M.$2g;function t(se,oe,J){return o.queueFor(w.URI.file(se),g.$lg).queue(()=>{const K=R(J);return new Promise((G,U)=>p(se,oe,K,q=>q?U(q):G()))})}let n=!0;function r(se){n=se}e.configureFlushOnWrite=r;function p(se,oe,J,K){if(!n)return P.writeFile(se,oe,{mode:J.mode,flag:J.flag},K);P.open(se,J.flag,J.mode,(G,U)=>{if(G)return K(G);P.writeFile(U,oe,q=>{if(q)return P.close(U,()=>K(q));P.fdatasync(U,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),r(!1)),P.close(U,H=>K(H))))})})}function C(se,oe,J){const K=R(J);if(!n)return P.writeFileSync(se,oe,{mode:K.mode,flag:K.flag});const G=P.openSync(se,K.flag,K.mode);try{P.writeFileSync(G,oe);try{P.fdatasyncSync(G)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),r(!1)}}finally{P.closeSync(G)}}e.writeFileSync=C;function R(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function k(se,oe,J=6e4){if(se!==oe)try{c.$j&&typeof J=="number"?await I(se,oe,Date.now(),J):await(0,s.promisify)(P.rename)(se,oe)}catch(K){if(se.toLowerCase()!==oe.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await L(se,oe,{preserveSymlinks:!1}),await d(se,y.MOVE);else throw K}}async function I(se,oe,J,K,G=0){try{return await(0,s.promisify)(P.rename)(se,oe)}catch(U){if(U.code!=="EACCES"&&U.code!=="EPERM"&&U.code!=="EBUSY")throw U;if(Date.now()-J>=K)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${U}`),U;if(G===0){let q=!1;try{const{stat:X}=await a.stat(oe);X.isFile()||(q=!0)}catch{}if(q)throw U}return await(0,M.$Tg)(Math.min(100,G*10)),I(se,oe,J,K,G+1)}}async function L(se,oe,J){return z(se,oe,{root:{source:se,target:oe},options:J,handledSourcePaths:new Set})}const N=511;async function z(se,oe,J){if(J.handledSourcePaths.has(se))return;J.handledSourcePaths.add(se);const{stat:K,symbolicLink:G}=await a.stat(se);if(G){if(J.options.preserveSymlinks)try{return await ae(se,oe,J)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(G.dangling)return}return K.isDirectory()?ne(se,oe,K.mode&N,J):_(se,oe,K.mode&N)}async function ne(se,oe,J,K){await e.Promises.mkdir(oe,{recursive:!0,mode:J});const G=await $(se);for(const U of G)await z((0,f.$ic)(se,U),(0,f.$ic)(oe,U),K)}async function _(se,oe,J){await e.Promises.copyFile(se,oe),await e.Promises.chmod(oe,J)}async function ae(se,oe,J){let K=await e.Promises.readlink(se);(0,D.$Wf)(K,J.root.source,!c.$l)&&(K=(0,f.$ic)(J.root.target,K.substr(J.root.source.length+1))),await e.Promises.symlink(K,oe)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(se,oe,J,K,G)=>new Promise((U,q)=>{P.read(se,oe,J,K,G,(X,H,Q)=>X?q(X):U({bytesRead:H,buffer:Q}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(se,oe,J,K,G)=>new Promise((U,q)=>{P.write(se,oe,J,K,G,(X,H,Q)=>X?q(X):U({bytesWritten:H,buffer:Q}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return h}get writeFile(){return t}get rm(){return d}get rename(){return k}get copy(){return L}}}),define(te[105],ie([0,1,45,9,4,27,21]),function(Z,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=e.$3p=e.$2p=void 0;function S(y){if(s.$l)return y;const d=(0,A.$lc)(y);if(y===d)return y;const v=((0,A.$mc)(y)||y).toLowerCase();try{const m=(0,D.readdirSync)(d).filter($=>$.toLowerCase()===v);if(m.length===1){const $=S(d);if($)return(0,A.$ic)($,m[0])}else if(m.length>1){const $=m.indexOf(v);if($>=0){const u=S(d);if(u)return(0,A.$ic)(u,m[$])}}}catch{}return null}e.$2p=S;async function f(y){if(s.$l)return y;const d=(0,A.$lc)(y);if(y===d)return y;const v=((0,A.$mc)(y)||y).toLowerCase();try{const m=(await D.Promises.readdir(d)).filter($=>$.toLowerCase()===v);if(m.length===1){const $=await f(d);if($)return(0,A.$ic)($,m[0])}else if(m.length>1){const $=m.indexOf(v);if($>=0){const u=await f(d);if(u)return(0,A.$ic)(u,m[$])}}}catch{}return null}e.$3p=f;async function c(y){try{return await D.Promises.realpath(y)}catch{const v=w(y);return await D.Promises.access(v,P.constants.R_OK),v}}e.$4p=c;function g(y){try{return P.realpathSync(y)}catch{const v=w(y);return P.accessSync(v,P.constants.R_OK),v}}e.$5p=g;function w(y){return(0,M.$Je)((0,A.$gc)(y),A.sep)}}),define(te[106],ie([0,1,28,9,21]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=void 0;const M=/^\d+$/,D=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var f;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(f||(f={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class w{constructor(h,i,a){this.exePath=h,this.displayName=i,this.a=a}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:E=!1}={}){return E?c===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:E=!1,findPreview:h=!1}={}){const i=y({useAlternateBitness:E});if(!i)return null;const a=A.$ic(i,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(a))return null;let o=-1,t=null;for(const p of await s.Promises.readdir(a)){let C=-1;if(h){const k=p.indexOf("-");if(k<0)continue;const I=p.substring(0,k);if(!M.test(I)||p.substring(k+1)!=="preview")continue;C=parseInt(I,10)}else{if(!M.test(p))continue;C=parseInt(p,10)}if(C<=o)continue;const R=A.$ic(a,p,"pwsh.exe");await s.SymlinkSupport.existsFile(R)&&(t=R,o=C)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",r=h?" Preview":"";return new w(t,`PowerShell${r}${n}`,!0)}async function v({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const h=A.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:i,pwshMsixName:a}=E?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const o of await s.Promises.readdir(h))if(i.test(o)){const t=A.$ic(h,o,"pwsh.exe");return new w(t,a)}return null}function b(){const E=A.$ic(P.homedir(),".dotnet","tools","pwsh.exe");return new w(E,".NET Core PowerShell Global Tool")}function m(){const E=A.$ic(process.env.windir,c===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(E,"Windows PowerShell",!0)}async function*$(){let E=await d();E&&(yield E),E=await d({useAlternateBitness:!0}),E&&(yield E),E=await v(),E&&(yield E),E=b(),E&&(yield E),E=await d({findPreview:!0}),E&&(yield E),E=await v({findPreview:!0}),E&&(yield E),E=await d({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=m(),E&&(yield E)}async function*u(){for await(const E of $())await E.exists()&&(yield E)}e.$ul=u;async function l(){for await(const E of u())return E;return null}e.$vl=l}),define(te[88],ie([0,1,9,4,35,75,12,21]),function(Z,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$zl=e.$yl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function f(w=s.env){return w.comspec||"cmd.exe"}e.$yl=f;function c(w){let y=[],d=!1;const v=function(b){if(d){y.push(b);return}(!w.send(b,$=>{if($&&console.error($),d=!1,y.length>0){const u=y.slice(0);y=[],u.forEach(l=>v(l))}})||A.$j)&&(d=!0)};return{send:v}}e.$zl=c;var g;(function(w){async function y(d,v,b){if(P.$hc(d))return d;if(v===void 0&&(v=s.cwd()),P.$lc(d)!=="."||(b===void 0&&D.$xf(s.env.PATH)&&(b=s.env.PATH.split(P.$sc)),b===void 0||b.length===0))return P.$ic(v,d);async function $(u){if(await S.Promises.exists(u)){let l;try{l=await S.Promises.stat(u)}catch(E){E.message.startsWith("EACCES")&&(l=await S.Promises.lstat(u))}return l?!l.isDirectory():!1}return!1}for(const u of b){let l;if(P.$hc(u)?l=P.$ic(u,d):l=P.$ic(v,u,d),await $(l))return l;let E=l+".com";if(await $(E)||(E=l+".exe",await $(E)))return E}return P.$ic(v,d)}w.findExecutable=y})(g||(e.win32=g={}))}),define(te[107],ie([0,1,47,13]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;function s(D){return new Promise((S,f)=>{let c;const g=new Map;function w(d,v,b,m,$){const u=g.get(v);if(d===D||u){const l={name:y(b),cmd:b,pid:d,ppid:v,load:m,mem:$};g.set(d,l),d===D&&(c=l),u&&(u.children||(u.children=[]),u.children.push(l),u.children.length>1&&(u.children=u.children.sort((E,h)=>E.pid-h.pid)))}}function y(d){const v=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,m=/--crashes-directory/i,$=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,l=/--type=([a-zA-Z-]+)/;if(m.exec(d))return"electron-crash-reporter";if($.exec(d))return"winpty-agent";if(u.exec(d))return"conpty-agent";let E=l.exec(d);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?v.exec(d)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const h=/[a-zA-Z-]+\.js/g;let i="";do E=h.exec(d),E&&(i+=E+" ");while(E);return i&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${i})`:b.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substring(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substring(5):v;new Promise((v,b)=>{Z(["@vscode/windows-process-tree"],v,b)}).then(v=>{v.getProcessList(D,b=>{if(!b){f(new Error(`Root process ${D} not found`));return}v.getProcessCpuUsage(b,m=>{const $=new Map;m.forEach(u=>{const l=d(u.commandLine||"");$.set(u.pid,{name:y(l),cmd:l,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),c=$.get(D),c?($.forEach(u=>{const l=$.get(u.ppid);l&&(l.children||(l.children=[]),l.children.push(u))}),$.forEach(u=>{u.children&&(u.children=u.children.sort((l,E)=>l.pid-E.pid))}),S(c)):f(new Error(`Root process ${D} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{let d=function(){let v=[c];const b=[];for(;v.length;){const $=v.shift();$&&(b.push($.pid),$.children&&(v=v.concat($.children)))}let m=JSON.stringify(A.$bg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+b.join(" "),(0,P.exec)(m,{},($,u,l)=>{if($||l)f($||new Error(l.toString()));else{const E=u.toString().split(`
`);for(let h=0;h<b.length;h++){const i=g.get(b[h]);i.load=parseFloat(E[h])}if(!c){f(new Error(`Root process ${D} not found`));return}S(c)}})};(0,P.exec)("which ps",{},(v,b,m)=>{if(v||m)if(process.platform!=="linux")f(v||new Error(m.toString()));else{const $=JSON.stringify(A.$bg.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)($,{},(u,l,E)=>{u||E?f(u||new Error(E.toString())):(M(l,w),d())})}else{const $=b.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${$} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,E,h)=>{l||h&&!h.includes("screen size is bogus")?f(l||new Error(h.toString())):(M(E,w),process.platform==="linux"?d():c?S(c):f(new Error(`Root process ${D} not found`)))})}})}})}e.$zr=s;function M(D,S){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=D.toString().split(`
`);for(const g of c){const w=f.exec(g.trim());w&&w.length===6&&S(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(te[108],ie([0,1,28,4,106,88]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0;async function D(w,y){return w===1?A.$j?g():M.$yl(y):f(w,y)}e.$Al=D;let S=null;function f(w,y){if(A.$l&&w===2||A.$k&&w===3)return"/bin/bash";if(!S){let d;if(A.$j)d="/bin/bash";else{if(d=y.SHELL,!d)try{d=(0,P.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}S=d}return S}let c=null;async function g(){return c||(c=(await(0,s.$vl)()).exePath),c}});var ke=this&&this.__decorate||function(Z,e,P,A){var s=arguments.length,M=s<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,P):A,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(Z,e,P,A);else for(var S=Z.length-1;S>=0;S--)(D=Z[S])&&(M=(s<3?D(M):s>3?D(e,P,M):D(e,P))||M);return s>3&&M&&Object.defineProperty(e,P,M),M};define(te[42],ie([0,1,23,8,18,22,54,14,3,2,76,27,12]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.ProxyChannel=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.RequestInitiator=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0;var d;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(d||(d={}));function v(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(b||(b={}));function m(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})($||($={}));function u(G){let U=0;for(let q=0;;q+=7){const X=G.read(1);if(U|=(X.buffer[0]&127)<<q,!(X.buffer[0]&128))return U}}const l=o(0);function E(G,U){if(U===0){G.write(l);return}let q=0;for(let H=U;H!==0;H=H>>>7)q++;const X=s.$ae.alloc(q);for(let H=0;U!==0;H++)X.buffer[H]=U&127,U=U>>>7,U>0&&(X.buffer[H]|=128);G.write(X)}class h{constructor(U){this.b=U,this.a=0}read(U){const q=this.b.slice(this.a,this.a+U);return this.a+=q.byteLength,q}}e.$lh=h;class i{constructor(){this.a=[]}get buffer(){return s.$ae.concat(this.a)}write(U){this.a.push(U)}}e.$mh=i;var a;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(a||(a={}));function o(G){const U=s.$ae.alloc(1);return U.writeUInt8(G,0),U}const t={Undefined:o(a.Undefined),String:o(a.String),Buffer:o(a.Buffer),VSBuffer:o(a.VSBuffer),Array:o(a.Array),Object:o(a.Object),Uint:o(a.Int)},n=typeof Buffer<"u";function r(G,U){if(typeof U>"u")G.write(t.Undefined);else if(typeof U=="string"){const q=s.$ae.fromString(U);G.write(t.String),E(G,q.byteLength),G.write(q)}else if(n&&Buffer.isBuffer(U)){const q=s.$ae.wrap(U);G.write(t.Buffer),E(G,q.byteLength),G.write(q)}else if(U instanceof s.$ae)G.write(t.VSBuffer),E(G,U.byteLength),G.write(U);else if(Array.isArray(U)){G.write(t.Array),E(G,U.length);for(const q of U)r(G,q)}else if(typeof U=="number"&&(U|0)===U)G.write(t.Uint),E(G,U);else{const q=s.$ae.fromString(JSON.stringify(U));G.write(t.Object),E(G,q.byteLength),G.write(q)}}e.$nh=r;function p(G){switch(G.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return G.read(u(G)).toString();case a.Buffer:return G.read(u(G)).buffer;case a.VSBuffer:return G.read(u(G));case a.Array:{const q=u(G),X=[];for(let H=0;H<q;H++)X.push(p(G));return X}case a.Object:return JSON.parse(G.read(u(G)).toString());case a.Int:return u(G)}}e.$oh=p;class C{constructor(U,q,X=null,H=1e3){this.h=U,this.j=q,this.k=X,this.l=H,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(U,q){this.b.set(U,q),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const q=this.o([U.type]);this.k?.logOutgoing(q,0,1,m(U.type));return}case 201:case 202:case 204:case 203:{const q=this.o([U.type,U.id],U.data);this.k?.logOutgoing(q,U.id,1,m(U.type),U.data);return}}}o(U,q=void 0){const X=new i;return r(X,U),r(X,q),this.p(X.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const q=new h(U),X=p(q),H=p(q),Q=X[0];switch(Q){case 100:return this.k?.logIncoming(U.byteLength,X[1],1,`${v(Q)}: ${X[2]}.${X[3]}`,H),this.s({type:Q,id:X[1],channelName:X[2],name:X[3],arg:H});case 102:return this.k?.logIncoming(U.byteLength,X[1],1,`${v(Q)}: ${X[2]}.${X[3]}`,H),this.t({type:Q,id:X[1],channelName:X[2],name:X[3],arg:H});case 101:return this.k?.logIncoming(U.byteLength,X[1],1,`${v(Q)}`),this.u({type:Q,id:X[1]});case 103:return this.k?.logIncoming(U.byteLength,X[1],1,`${v(Q)}`),this.u({type:Q,id:X[1]})}}s(U){const q=this.b.get(U.channelName);if(!q){this.v(U);return}const X=new M.$Wd;let H;try{H=q.call(this.j,U.name,U.arg,X.token)}catch(F){H=Promise.reject(F)}const Q=U.id;H.then(F=>{this.m({id:Q,data:F,type:201})},F=>{F instanceof Error?this.m({id:Q,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:Q,data:F,type:203})}).finally(()=>{re.dispose(),this.d.delete(U.id)});const re=(0,c.$Pc)(()=>X.cancel());this.d.set(U.id,re)}t(U){const q=this.b.get(U.channelName);if(!q){this.v(U);return}const X=U.id,Q=q.listen(this.j,U.name,U.arg)(re=>this.m({id:X,data:re,type:204}));this.d.set(U.id,Q)}u(U){const q=this.d.get(U.id);q&&(q.dispose(),this.d.delete(U.id))}v(U){let q=this.g.get(U.channelName);q||(q=[],this.g.set(U.channelName,q));const X=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:U,timeoutTimer:X})}w(U){const q=this.g.get(U);if(q){for(const X of q)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$ph=C;var R;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class k{constructor(U,q=null){this.l=U,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$Md,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=q}getChannel(U){const q=this;return{call(X,H,Q){return q.a?Promise.reject(new S.$4):q.m(U,X,H,Q)},listen(X,H){return q.a?f.Event.None:q.o(U,X,H)}}}m(U,q,X,H=M.CancellationToken.None){const Q=this.g++,F={id:Q,type:100,channelName:U,name:q,arg:X};if(H.isCancellationRequested)return Promise.reject(new S.$4);let O;return new Promise((B,W)=>{if(H.isCancellationRequested)return W(new S.$4);const T=()=>{const ue=fe=>{switch(fe.type){case 201:this.f.delete(Q),B(fe.data);break;case 202:{this.f.delete(Q);const ye=new Error(fe.data.message);ye.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ye.name=fe.data.name,W(ye);break}case 203:this.f.delete(Q),W(fe.data);break}};this.f.set(Q,ue),this.p(F)};let V=null;this.b===$.Idle?T():(V=(0,A.$Gg)(ue=>this.u()),V.then(()=>{V=null,T()}));const ce=()=>{V?(V.cancel(),V=null):this.p({id:Q,type:101}),W(new S.$4)},de=H.onCancellationRequested(ce);O=(0,c.$Oc)((0,c.$Pc)(ce),de),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(U,q,X){const H=this.g++,re={id:H,type:102,channelName:U,name:q,arg:X};let F=null;const O=new f.$Md({onWillAddFirstListener:()=>{F=(0,A.$Gg)(B=>this.u()),F.then(()=>{F=null,this.d.add(O),this.p(re)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(O),this.p({id:H,type:103}))}}),j=B=>O.fire(B.data);return this.f.set(H,j),O.event}p(U){switch(U.type){case 100:case 102:{const q=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(q,U.id,0,`${v(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const q=this.q([U.type,U.id]);this.j?.logOutgoing(q,U.id,0,v(U.type));return}}}q(U,q=void 0){const X=new i;return r(X,U),r(X,q),this.r(X.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const q=new h(U),X=p(q),H=p(q),Q=X[0];switch(Q){case 200:return this.j?.logIncoming(U.byteLength,0,0,m(Q)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,X[1],0,m(Q),H),this.t({type:X[0],id:X[1],data:H})}}t(U){if(U.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$qh=k,ke([D.$fh],k.prototype,"onDidInitializePromise",null);class I{get connections(){const U=[];return this.f.forEach(q=>U.push(q)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new f.$Md,this.onDidAddConnection=this.g.event,this.h=new f.$Md,this.onDidRemoveConnection=this.h.event,this.j=new c.$Qc,this.j.add(U(({protocol:q,onDidClientDisconnect:X})=>{const H=f.Event.once(q.onMessage);this.j.add(H(Q=>{const re=new h(Q),F=p(re),O=new C(q,F),j=new k(q);this.a.forEach((W,T)=>O.registerChannel(T,W));const B={channelServer:O,channelClient:j,ctx:F};this.f.add(B),this.g.fire(B),this.j.add(X(()=>{O.dispose(),j.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(U,q){const X=this;return{call(H,Q,re){let F;if((0,y.$Lf)(q)){const j=(0,P.$3b)(X.connections.filter(q));F=j?Promise.resolve(j):f.Event.toPromise(f.Event.filter(X.onDidAddConnection,q))}else F=q.routeCall(X,H,Q);const O=F.then(j=>j.channelClient.getChannel(U));return N(O).call(H,Q,re)},listen(H,Q){if((0,y.$Lf)(q))return X.k(U,q,H,Q);const re=q.routeEvent(X,H,Q).then(F=>F.channelClient.getChannel(U));return N(re).listen(H,Q)}}}k(U,q,X,H){const Q=this;let re;const F=new f.$Md({onWillAddFirstListener:()=>{re=new c.$Qc;const O=new f.$Sd,j=new Map,B=T=>{const ce=T.channelClient.getChannel(U).listen(X,H),de=O.add(ce);j.set(T,de)},W=T=>{const V=j.get(T);V&&(V.dispose(),j.delete(T))};Q.connections.filter(q).forEach(B),f.Event.filter(Q.onDidAddConnection,q)(B,void 0,re),Q.onDidRemoveConnection(W,void 0,re),O.event(F.fire,F,re),re.add(O)},onDidRemoveLastListener:()=>{re?.dispose(),re=void 0}});return F.event}registerChannel(U,q){this.a.set(U,q);for(const X of this.f)X.channelServer.registerChannel(U,q)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$rh=I;class L{constructor(U,q,X=null){const H=new i;r(H,q),U.send(H.buffer),this.a=new k(U,X),this.d=new C(U,q,X)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,q){this.d.registerChannel(U,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$sh=L;function N(G){return{call(U,q,X){return G.then(H=>H.call(U,q,X))},listen(U,q){const X=new f.$Vd;return G.then(H=>X.input=H.listen(U,q)),X.event}}}e.$th=N;function z(G){let U=!1;return{call(q,X,H){return U?G.call(q,X,H):(0,A.$Tg)(0).then(()=>U=!0).then(()=>G.call(q,X,H))},listen(q,X){if(U)return G.listen(q,X);const H=new f.$Vd;return(0,A.$Tg)(0).then(()=>U=!0).then(()=>H.input=G.listen(q,X)),H.event}}}e.$uh=z;class ne{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const q of U.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await f.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$vh=ne;var _;(function(G){function U(Q,re,F){const O=Q,j=F&&F.disableMarshalling,B=new Map;for(const W in O)X(W)&&B.set(W,f.Event.buffer(O[W],!0,void 0,re));return new class{listen(W,T,V){const ce=B.get(T);if(ce)return ce;if(H(T)){const de=O[T];if(typeof de=="function")return de.call(O,V)}throw new S.$ab(`Event not found: ${T}`)}call(W,T,V){const ce=O[T];if(typeof ce=="function"){if(!j&&Array.isArray(V))for(let ue=0;ue<V.length;ue++)V[ue]=(0,g.$kh)(V[ue]);let de=ce.apply(O,V);return de instanceof Promise||(de=Promise.resolve(de)),de}throw new S.$ab(`Method not found: ${T}`)}}}G.fromService=U;function q(Q,re){const F=re&&re.disableMarshalling;return new Proxy({},{get(O,j){if(typeof j=="string")return re?.properties?.has(j)?re.properties.get(j):H(j)?function(B){return Q.listen(j,B)}:X(j)?Q.listen(j):async function(...B){let W;re&&!(0,y.$Gf)(re.context)?W=[re.context,...B]:W=B;const T=await Q.call(j,W);return F?T:(0,g.$kh)(T)};throw new S.$ab(`Property not found: ${String(j)}`)}})}G.toService=q;function X(Q){return Q[0]==="o"&&Q[1]==="n"&&w.$Ze(Q.charCodeAt(2))}function H(Q){return/^onDynamic/.test(Q)&&w.$Ze(Q.charCodeAt(9))}})(_||(e.ProxyChannel=_={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const U=G.toString();if(U!=="[object Object]")return U}return G}function oe(G){return Array.isArray(G)?G.map(se):se(G)}function J(G,U,q,X,H,Q,re){re=oe(re);const F=ae[H],O=F[X%F.length];let j=[`%c[${G}]%c[${String(U).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(Q)?(j=j.concat(re),j.push(")")):j.push(re),console.log.apply(console,j)}class K{constructor(U,q){this.d=U,this.f=q,this.a=0,this.b=0}logOutgoing(U,q,X,H,Q){this.b+=U,J(this.d,this.b,U,q,X,H,Q)}logIncoming(U,q,X,H,Q){this.a+=U,J(this.f,this.a,U,q,X,H,Q)}}e.$wh=K}),define(te[155],ie([0,1,18,3,42]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hT=e.$gT=void 0;class M{constructor(f){this.a=f,this.onMessage=A.Event.fromDOMEventEmitter(this.a,"message",c=>P.$ae.wrap(c.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$gT=M;class D extends s.$sh{constructor(f,c){const g=new M(f);super(g,c),this.b=g}dispose(){this.b.disconnect(),super.dispose()}}e.$hT=D}),define(te[109],ie([0,1,18,3,2,42]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e.$yh=e.ProtocolConstants=e.$xh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var S;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let r=0;function p(R,k){if(!n.has(R)){const I=String(++r);n.set(R,I)}return n.get(R)}function C(R,k,I,L){if(!t.enableDiagnostics)return;const N=p(R,k);if(L instanceof P.$ae||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const z=P.$ae.alloc(L.byteLength);z.set(L),t.records.push({timestamp:Date.now(),id:N,label:k,type:I,buff:z})}else t.records.push({timestamp:Date.now(),id:N,label:k,type:I,data:L})}t.traceSocketEvent=C})(S||(e.SocketDiagnostics=S={}));var f;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let c=null;function g(){return c||(c=P.$ae.alloc(0)),c}class w{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,r){if(n===0)return g();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return r&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return r&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const p=P.$ae.alloc(n);let C=0,R=0;for(;n>0;){const k=this.a[R];if(k.byteLength>n){const I=k.slice(0,n);p.set(I,C),C+=n,r&&(this.a[R]=k.slice(n),this.b-=n),n-=n}else p.set(k,C),C+=k.byteLength,r?(this.a.shift(),this.b-=k.byteLength):R++,n-=k.byteLength}return p}}e.$xh=w;var y;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(y||(y={}));function d(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class b{constructor(n,r,p,C){this.type=n,this.id=r,this.ack=p,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends s.$Rc{constructor(n){super(),this.f=this.B(new A.$Md),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new w,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,C=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new b(p,C,R,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=P.$ae.alloc(13);r.writeUInt8(n.type,0),r.writeUInt32BE(n.id,1),r.writeUInt32BE(n.ack,5),r.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(r,n.data)}g(n,r){const p=this.f===0;return this.d.push(n,r),this.f+=n.byteLength+r.byteLength,p}h(){const n=P.$ae.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,r){this.g(n,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class u extends s.$Rc{constructor(n){super(),this.f=new A.$Md,this.onMessage=this.f.event,this.g=new A.$Md,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new $(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new b(1,0,0,n))}}e.$yh=u;class l extends M.$sh{static fromSocket(n,r){return new l(new u(n),r)}get onDidDispose(){return this.b.onDidDispose}constructor(n,r,p=null){super(n,r,p),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$zh=l;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$Md({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Ah=E;class h{constructor(n){this.data=n,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let n=0,r=this.a;for(;r;)r=r.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let r=0,p=this.a;for(;p;)n[r++]=p.data,p=p.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const r=new h(n);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const n=Date.now();for(let r=0;r<a.a;r++)this.c[r]=n-1e3*r;setInterval(()=>{for(let r=a.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),r=(1+a.a)*1e3;let p=0;for(let C=0;C<a.a;C++)n-this.c[C]<=r&&p++;return 1-p/a.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??a.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Qc,this.o=n.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new b(5,0,0,g());this.p.write(n),this.p.flush()}sendPause(){const n=new b(7,0,0,g());this.p.write(n)}sendResume(){const n=new b(8,0,0,g());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,r){this.a=!0,this.r.dispose(),this.r=new s.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new b(3,0,this.h,g());this.p.write(n);const r=this.b.toArray();for(let p=0,C=r.length;p<C;p++)this.p.write(r[p]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const r=this.b.peek();if(r&&r.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new b(6,0,0,g())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let p=0,C=r.length;p<C;p++)this.p.write(r[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const r=++this.c;this.h=this.g;const p=new b(1,r,this.h,n);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(n){const r=new b(2,0,0,n);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),r=Date.now()-n.writtenTime,p=Date.now()-this.q.lastReadTime,C=Date.now()-this.n;if(r>=2e4&&p>=2e4&&C>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:p});return}const R=Math.max(2e4-r,2e4-p,2e4-C,500);this.f=setTimeout(()=>{this.f=null,this.B()},R)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new b(3,0,this.h,g());this.p.write(n)}D(){this.h=this.g;const n=new b(9,0,this.h,g());this.p.write(n)}}e.$Bh=o}),define(te[38],ie([0,1,15,14,13]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dT=void 0;class M{constructor(){this.a=new WeakMap}on(S,f){const c=(g,...w)=>{this.b(S,g)&&f(g,...w)};return this.a.set(f,c),P.ipcMain.on(S,c),this}once(S,f){return P.ipcMain.once(S,(c,...g)=>{this.b(S,c)&&f(c,...g)}),this}handle(S,f){return P.ipcMain.handle(S,(c,...g)=>this.b(S,c)?f(c,...g):Promise.reject(`Invalid channel '${S}' or sender for ipcMain.handle() usage.`)),this}removeHandler(S){return P.ipcMain.removeHandler(S),this}removeListener(S,f){const c=this.a.get(f);return c&&(P.ipcMain.removeListener(S,c),this.a.delete(f)),this}b(S,f){if(!S||!S.startsWith("vscode:"))return(0,A.$Z)(`Refused to handle ipcMain event for channel '${S}' because the channel is unknown.`),!1;const c=f.senderFrame,g=c.url;if(!g||g==="about:blank")return!0;let w="unknown";try{w=new URL(g).host}catch{return(0,A.$Z)(`Refused to handle ipcMain event for channel '${S}' because of a malformed URL '${g}'.`),!1}return w!==s.$ag?((0,A.$Z)(`Refused to handle ipcMain event for channel '${S}' because of a bad origin of '${w}'.`),!1):c.parent!==null?((0,A.$Z)(`Refused to handle ipcMain event for channel '${S}' because sender of origin '${w}' is not a main frame.`),!1):!0}}e.$dT=new M}),define(te[156],ie([0,1,15,38,144]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eT=void 0;function M(){A.$dT.on(s.$bT,(S,f,c,g,w)=>{const y=D(S,g,c);y.popup({x:w?w.x:void 0,y:w?w.y:void 0,positioningItem:w?w.positioningItem:void 0,callback:()=>{y&&S.sender.send(s.$cT,f)}})})}e.$eT=M;function D(S,f,c){const g=new P.Menu;return c.forEach(w=>{let y;w.type==="separator"?y=new P.MenuItem({type:w.type}):Array.isArray(w.submenu)?y=new P.MenuItem({submenu:D(S,f,w.submenu),label:w.label}):y=new P.MenuItem({label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:w.enabled,visible:w.visible,click:(d,v,b)=>S.sender.send(f,w.id,b)}),g.append(y)}),g}}),define(te[157],ie([0,1,38,18,3,2,42,145]),function(Z,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kT=void 0;function f(g,w){const y=s.Event.fromNodeEventEmitter(P.$dT,w,(v,b)=>({event:v,message:b})),d=s.Event.filter(y,({event:v})=>v.sender.id===g);return s.Event.map(d,({message:v})=>v&&A.$ae.wrap(v))}class c extends D.$rh{static{this.b=new Map}static d(){const w=s.Event.fromNodeEventEmitter(P.$dT,"vscode:hello",({sender:y})=>y);return s.Event.map(w,y=>{const d=y.id;c.b.get(d)?.dispose();const b=new s.$Md;c.b.set(d,(0,M.$Pc)(()=>b.fire()));const m=f(d,"vscode:message"),$=s.Event.any(s.Event.signal(f(d,"vscode:disconnect")),b.event);return{protocol:new S.$jT(y,m),onDidClientDisconnect:$}})}constructor(){super(c.d())}}e.$kT=c}),define(te[110],ie([0,1,38,3,32,155]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mT=e.$lT=void 0;class D extends M.$hT{constructor(c,g){super({addEventListener:(w,y)=>c.addListener(w,y),removeEventListener:(w,y)=>c.removeListener(w,y),postMessage:w=>c.postMessage(w),start:()=>c.start(),close:()=>c.close()},g)}}e.$lT=D;async function S(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,s.$dg)();f.webContents.send("vscode:createMessageChannel",c);const g=A.Event.fromNodeEventEmitter(P.$dT,"vscode:createMessageChannelResult",(y,d)=>({nonce:d,port:y.ports[0]})),{port:w}=await A.Event.toPromise(A.Event.once(A.Event.filter(g,y=>y.nonce===c)));return w}e.$mT=S}),define(te[158],ie([0,1,47,8,18,22,152,14,3,2,37,88,75,42]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0;class v extends d.$ph{constructor($){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",u=>s.$ae.wrap(Buffer.from(u,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$Yp=v;class b{constructor($,u){this.i=$,this.j=u,this.c=new Set,this.g=new Map,this.h=new f.$Md,this.onDidProcessExit=this.h.event;const l=u&&u.timeout?u.timeout:6e4;this.b=new A.$Pg(l),this.d=null,this.f=null}getChannel($){const u=this;return{call(l,E,h){return u.k($,l,E,h)},listen(l,E){return u.l($,l,E)}}}k($,u,l,E=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(S.$5());this.b.cancel();const h=this.n($),i=(0,A.$Gg)(t=>h.call(u,l,t)),a=E.onCancellationRequested(()=>i.cancel()),o=(0,c.$Pc)(()=>i.cancel());return this.c.add(o),i.finally(()=>{a.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l($,u,l){if(!this.b)return f.Event.None;this.b.cancel();let E;const h=new f.$Md({onWillAddFirstListener:()=>{E=this.n($).listen(u,l)(h.fire,h),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,g.$3m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,y.$xl)(u.env),this.d=(0,P.fork)(this.i,$,u);const l=new f.$Md;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$Up)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}l.fire(s.$ae.wrap(Buffer.from(n,"base64")))});const h=this.j.useQueue?(0,w.$zl)(this.d):this.d,i=n=>this.d&&this.d.connected&&h.send(n.buffer.toString("base64")),a=l.event,o={send:i,onMessage:a};this.f=new d.$qh(o);const t=()=>this.o();process.once("exit",t),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",t),this.c.forEach(p=>(0,c.$Mc)(p)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n($){let u=this.g.get($);return u||(u=this.m.getChannel($),this.g.set($,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Zp=b}),define(te[111],ie([0,1,8,3,2,76,12]),function(Z,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.StorageState=e.$Xo=e.StorageHint=void 0;var S;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function f(y){const d=y;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$Xo=f;var c;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(c||(e.StorageState=c={}));class g extends s.$Rc{static{this.a=100}constructor(d,v=Object.create(null)){super(),this.r=d,this.s=v,this.b=this.B(new A.$Pd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new P.$Qg(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((v,b)=>this.w(b,v)),d.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(d,v){if(this.c===c.Closed)return;let b=!1;(0,D.$Gf)(v)?b=this.f.delete(d):this.f.get(d)!==v&&(this.f.set(d,v),b=!0),b&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,v){const b=this.f.get(d);return(0,D.$Gf)(b)?v:b}getBoolean(d,v){const b=this.get(d);return(0,D.$Gf)(b)?v:b==="true"}getNumber(d,v){const b=this.get(d);return(0,D.$Gf)(b)?v:parseInt(b,10)}getObject(d,v){const b=this.get(d);return(0,D.$Gf)(b)?v:(0,M.$jh)(b)}async set(d,v,b=!1){if(this.c===c.Closed)return;if((0,D.$Gf)(v))return this.delete(d,b);const m=(0,D.$zf)(v)||Array.isArray(v)?(0,M.$ih)(v):String(v);if(this.f.get(d)!==m)return this.f.set(d,m),this.j.set(d,m),this.h.delete(d),this.b.fire({key:d,external:b}),this.D()}async delete(d,v=!1){if(!(this.c===c.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:v}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$Yo=g;class w{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((v,b)=>this.a.set(b,v)),d.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$Zo=w}),define(te[159],ie([0,1,8,3,31,9,21]),function(Z,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IT=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return A.Event.None}static{this.a=2e3}static{this.b=256}constructor(g,w=Object.create(null)){this.g=g,this.h=w,this.c=(0,M.$mc)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const g=await this.f,w=new Map;return(await this.s(g,"SELECT * FROM ItemTable")).forEach(d=>w.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${w.size} rows`),w}async updateItems(g){const w=await this.f;return this.j(w,g)}j(g,w){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${w.insert?(0,s.$xc)(w.insert):"0"}), delete(${w.delete?(0,s.$yc)(w.delete):"0"})`),this.t(g,()=>{const y=w.insert,d=w.delete;if(y&&y.size>0){const v=[];v.push([]);let b=0;y.forEach((m,$)=>{let u=v[b];u.length>S.b&&(b++,u=[],v.push(u)),u.push($,m)}),v.forEach(m=>{this.u(g,`INSERT INTO ItemTable VALUES ${new Array(m.length/2).fill("(?,?)").join(",")}`,$=>$.run(m),()=>{const $=[];let u=0;return y.forEach((l,E)=>{$.push(E),u+=l.length}),`Keys: ${$.join(", ")} Length: ${u}`})})}if(d&&d.size){const v=[];v.push([]);let b=0;d.forEach(m=>{let $=v[b];$.length>S.b&&(b++,$=[],v.push($)),$.push(m)}),v.forEach(m=>{this.u(g,`DELETE FROM ItemTable WHERE key IN (${new Array(m.length).fill("?").join(",")})`,$=>$.run(m),()=>{const $=[];return d.forEach(u=>{$.push(u)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const g=await this.f;return this.q(g,"VACUUM")}async close(g){this.d.trace(`[storage ${this.c}] close()`);const w=await this.f;return this.k(w,g)}k(g,w){return new Promise((y,d)=>{g.db.close(v=>(v&&this.o(g,`[storage ${this.c}] close(): ${v}`),this.g===S.IN_MEMORY_PATH?y():!g.isErroneous&&!g.isInMemory?this.l().then(y,b=>(this.d.error(`[storage ${this.c}] backup(): ${b}`),y())):typeof w=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(b=>{const m=()=>this.k(b,void 0);return this.j(b,{insert:w()}).then(()=>m(),$=>(m(),Promise.reject($)))})).then(y,d):d(v||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const g=this.m(this.g);return D.Promises.copy(this.g,g,{preserveSymlinks:!1})}m(g){return`${g}.backup`}async checkIntegrity(g){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${g})`);const w=await this.f,y=await this.r(w,g?"PRAGMA integrity_check":"PRAGMA quick_check"),d=g?y.integrity_check:y.quick_check;return w.isErroneous?`${d} (last error: ${w.lastError})`:w.isInMemory?`${d} (in-memory!)`:d}async n(g,w=!0){this.d.trace(`[storage ${this.c}] open(${g}, retryOnBusy: ${w})`);try{return await this.p(g)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&w)return await(0,P.$Tg)(S.a),this.n(g,!1);try{await D.Promises.unlink(g);try{await D.Promises.rename(this.m(g),g,!1)}catch{}return await this.p(g)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(S.IN_MEMORY_PATH)}}}o(g,w){g.isErroneous=!0,g.lastError=w,this.d.error(w)}p(g){return new Promise((w,y)=>{new Promise((d,v)=>{Z(["@vscode/sqlite3"],d,v)}).then(d=>{const v={db:new(this.d.isTracing?d.verbose().Database:d.Database)(g,b=>b?v.db&&b.code!=="SQLITE_CANTOPEN"?v.db.close(()=>y(b)):y(b):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>w(v),m=>v.db.close(()=>y(m)))),isInMemory:g===S.IN_MEMORY_PATH};v.db.on("error",b=>this.o(v,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&v.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},y)})}q(g,w){return new Promise((y,d)=>{g.db.exec(w,v=>v?(this.o(g,`[storage ${this.c}] exec(): ${v}`),d(v)):y())})}r(g,w){return new Promise((y,d)=>{g.db.get(w,(v,b)=>v?(this.o(g,`[storage ${this.c}] get(): ${v}`),d(v)):y(b))})}s(g,w){return new Promise((y,d)=>{g.db.all(w,(v,b)=>v?(this.o(g,`[storage ${this.c}] all(): ${v}`),d(v)):y(b))})}t(g,w){return new Promise((y,d)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),w(),g.db.run("END TRANSACTION",v=>v?(this.o(g,`[storage ${this.c}] transaction(): ${v}`),d(v)):y())})})}u(g,w,y,d){const v=g.db.prepare(w),b=m=>{this.o(g,`[storage ${this.c}] prepare(): ${m} (${w}). Details: ${d()}`)};v.on("error",b),y(v),v.finalize(m=>{m&&b(m),v.removeListener("error",b)})}}e.$IT=S;class f{static{this.a="VSCODE_TRACE_STORAGE"}constructor(g){g&&typeof g.logTrace=="function"&&process.env[f.a]&&(this.b=g.logTrace),g&&typeof g.logError=="function"&&(this.c=g.logError)}get isTracing(){return!!this.b}trace(g){this.b?.(g)}error(g){this.c?.(g)}}}),define(te[160],ie([11,10]),function(Z,e){return Z.create("vs/code/electron-main/app",e)}),define(te[161],ie([11,10]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[162],ie([11,10]),function(Z,e){return Z.create("vs/platform/contextkey/common/contextkey",e)}),define(te[163],ie([11,10]),function(Z,e){return Z.create("vs/platform/contextkey/common/scanner",e)}),define(te[164],ie([11,10]),function(Z,e){return Z.create("vs/platform/dialogs/common/dialogs",e)}),define(te[165],ie([11,10]),function(Z,e){return Z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[166],ie([11,10]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(te[167],ie([11,10]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(te[168],ie([11,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[169],ie([11,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[170],ie([11,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[171],ie([11,10]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[172],ie([11,10]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[173],ie([11,10]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(te[174],ie([11,10]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(te[175],ie([11,10]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(te[176],ie([11,10]),function(Z,e){return Z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[177],ie([11,10]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[178],ie([11,10]),function(Z,e){return Z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[179],ie([11,10]),function(Z,e){return Z.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[180],ie([11,10]),function(Z,e){return Z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[181],ie([11,10]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(te[182],ie([11,10]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(te[183],ie([11,10]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[184],ie([11,10]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[185],ie([11,10]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[186],ie([11,10]),function(Z,e){return Z.create("vs/platform/update/common/update.config.contribution",e)}),define(te[187],ie([11,10]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[188],ie([11,10]),function(Z,e){return Z.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[189],ie([11,10]),function(Z,e){return Z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[190],ie([11,10]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(te[191],ie([11,10]),function(Z,e){return Z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[192],ie([11,10]),function(Z,e){return Z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[193],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zU=e.$yU=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.$yU=P;function A(s){return s&&s.hasOwnProperty("workspace")}e.$zU=A}),define(te[194],ie([0,1,7]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j6b=e.$i6b=e.$h6b=void 0;function A(D){return typeof D?.backupFolder=="string"}e.$h6b=A;function s(D){let S=[];try{Array.isArray(D.workspaces)&&(S=D.workspaces.map(f=>({workspace:{id:f.id,configPath:P.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$i6b=s;function M(D){let S=[];try{Array.isArray(D.folders)&&(S=D.folders.map(f=>({folderUri:P.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$j6b=M}),define(te[195],ie([0,1,14,163]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var s;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...c){switch(c.length){case 1:return(0,A.localize)(0,null,c[0]);case 2:return(0,A.localize)(1,null,c[0],c[1]);case 3:return(0,A.localize)(2,null,c[0],c[1],c[2]);default:return}}const D=(0,A.localize)(3,null),S=(0,A.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(g){switch(g.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return g.isTripleEq?"===":"==";case 4:return g.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return g.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return g.lexeme;case 18:return g.lexeme;case 19:return g.lexeme;case 20:return"EOF";default:throw(0,P.$7)(`unhandled token type: ${JSON.stringify(g)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(g){return this.c=g,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const w=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:w})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const w=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:w})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(g){return this.r()||this.c.charCodeAt(this.e)!==g?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(g){this.f.push({type:g,offset:this.d})}l(g){const w=this.d,y=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:y};this.g.push({offset:w,lexeme:y,additionalInfo:g}),this.f.push(d)}n(){this.m.lastIndex=this.d;const g=this.m.exec(this.c);if(g){this.e=this.d+g[0].length;const w=this.c.substring(this.d,this.e),y=f.b.get(w);y?this.k(y):this.f.push({type:17,lexeme:w,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let g=this.e,w=!1,y=!1;for(;;){if(g>=this.c.length){this.e=g,this.l(S);return}const v=this.c.charCodeAt(g);if(w)w=!1;else if(v===47&&!y){g++;break}else v===91?y=!0:v===92?w=!0:v===93&&(y=!1);g++}for(;g<this.c.length&&f.a.has(this.c.charCodeAt(g));)g++;this.e=g;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=f}),define(te[196],ie([0,1,3,2]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=void 0;class s{constructor(){this.a=new P.$Md,this.b=new P.$Md,this.c=new P.$Md,this.d=new P.$Md}static{this.ChannelName="extensionhostdebugservice"}call(S,f,c){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(S,f,c){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$In=s;class M extends A.$Rc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,f,c){this.b.call("attach",[S,f,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,f){this.b.call("terminate",[S,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,f){return this.b.call("openExtensionDevelopmentHostWindow",[S,f])}}e.$Jn=M}),define(te[197],ie([0,1,147,54,13,9,35,19,7]),function(Z,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,M.$lc)(s.$bg.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,M.$ic)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,S.$ug)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$ug)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,P.$bm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$ic)(this.userDataPath,"logs",d)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$ug)(f.URI.file((0,M.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$ug)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$ug)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$ug)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=D.env.VSCODE_PORTABLE;return d?f.URI.file((0,M.$ic)(d,"argv.json")):(0,S.$ug)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,M.$jc)(d):(0,M.$gc)((0,M.$ic)(s.$bg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?f.URI.file((0,M.$jc)(d)):f.URI.file((0,M.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,M.$jc)(d);const v=D.env.VSCODE_EXTENSIONS;if(v)return v;const b=D.env.VSCODE_PORTABLE;return b?(0,M.$ic)(b,"extensions"):(0,S.$ug)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(v=>/^[^:/?#]+?:\/\//.test(v)?f.URI.parse(v):f.URI.file((0,M.$gc)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,M.$gc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$cm.test(d))}get extensionLogLevel(){const d=[];for(const v of this.args.log||[]){const b=e.$cm.exec(v);b&&b[1]&&b[2]&&d.push([b[1],b[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,S.$ug)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=D.env.VSCODE_PORTABLE;return d?f.URI.file((0,M.$ic)(d,"policy.json")):(0,S.$ug)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,v,b){this.a=d,this.b=v,this.c=b,this.editSessionId=this.args.editSessionId}}e.$dm=c,ke([A.$fh],c.prototype,"appRoot",null),ke([A.$fh],c.prototype,"userHome",null),ke([A.$fh],c.prototype,"userDataPath",null),ke([A.$fh],c.prototype,"appSettingsHome",null),ke([A.$fh],c.prototype,"tmpDir",null),ke([A.$fh],c.prototype,"cacheHome",null),ke([A.$fh],c.prototype,"stateResource",null),ke([A.$fh],c.prototype,"userRoamingDataHome",null),ke([A.$fh],c.prototype,"userDataSyncHome",null),ke([A.$fh],c.prototype,"sync",null),ke([A.$fh],c.prototype,"machineSettingsResource",null),ke([A.$fh],c.prototype,"workspaceStorageHome",null),ke([A.$fh],c.prototype,"localHistoryHome",null),ke([A.$fh],c.prototype,"keyboardLayoutResource",null),ke([A.$fh],c.prototype,"argvResource",null),ke([A.$fh],c.prototype,"isExtensionDevelopment",null),ke([A.$fh],c.prototype,"untitledWorkspacesHome",null),ke([A.$fh],c.prototype,"builtinExtensionsPath",null),ke([A.$fh],c.prototype,"extensionsPath",null),ke([A.$fh],c.prototype,"extensionDevelopmentLocationURI",null),ke([A.$fh],c.prototype,"extensionDevelopmentKind",null),ke([A.$fh],c.prototype,"extensionTestsLocationURI",null),ke([A.$fh],c.prototype,"debugExtensionHost",null),ke([A.$fh],c.prototype,"logLevel",null),ke([A.$fh],c.prototype,"extensionLogLevel",null),ke([A.$fh],c.prototype,"serviceMachineIdResource",null),ke([A.$fh],c.prototype,"disableTelemetry",null),ke([A.$fh],c.prototype,"disableWorkspaceTrust",null),ke([A.$fh],c.prototype,"useInMemorySecretStorage",null),ke([A.$fh],c.prototype,"policyFile",null);function g(y,d){return w(y["inspect-extensions"],y["inspect-brk-extensions"],5870,d,y.debugId,y.extensionEnvironment)}e.$em=g;function w(y,d,v,b,m,$){const l=Number(d||y)||(b?null:v),E=l?!!d:!1;let h;if($)try{h=JSON.parse($)}catch{}return{port:l,break:E,debugId:m,env:h}}e.$fm=w}),define(te[112],ie([0,1,307,4,166]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Bl=["tunnel","serve-web"],e.$Cl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(b,m,$=D){const u=b.find(r=>r.length>0&&r[0]!=="-"),l={},E=["_"],h=[],i={};let a;for(const r in m){const p=m[r];p.type==="subcommand"?r===u&&(a=p):(p.alias&&(l[r]=p.alias),p.type==="string"||p.type==="string[]"?(E.push(r),p.deprecates&&E.push(...p.deprecates)):p.type==="boolean"&&(h.push(r),p.deprecates&&h.push(...p.deprecates)),p.global&&(i[r]=p))}if(a&&u){const r=i;for(const k in a.options)r[k]=a.options[k];const p=b.filter(k=>k!==u),C=$.getSubcommandReporter?$.getSubcommandReporter(u):void 0,R=S(p,r,C);return{[u]:R,_:[]}}const o=P(b,{string:E,boolean:h,alias:l}),t={},n=o;t._=o._.map(r=>String(r)).filter(r=>r.length>0),delete n._;for(const r in m){const p=m[r];if(p.type==="subcommand")continue;p.alias&&delete n[p.alias];let C=n[r];if(p.deprecates)for(const R of p.deprecates)n.hasOwnProperty(R)&&(C||(C=n[R],C&&$.onDeprecatedOption(R,p.deprecationMessage||(0,s.localize)(37,null,r))),delete n[R]);if(typeof C<"u"){if(p.type==="string[]"){if(Array.isArray(C)||(C=[C]),!p.allowEmptyValue){const R=C.filter(k=>k.length>0);R.length!==C.length&&($.onEmptyValue(r),C=R.length>0?R:void 0)}}else p.type==="string"&&(Array.isArray(C)?(C=C.pop(),$.onMultipleValues(r,C)):!C&&!p.allowEmptyValue&&($.onEmptyValue(r),C=void 0));t[r]=C,p.deprecationMessage&&$.onDeprecatedOption(r,p.deprecationMessage)}delete n[r]}for(const r in n)$.onUnknownOption(r);return t}e.$Dl=S;function f(b,m){let $="";return m.args&&(Array.isArray(m.args)?$=` <${m.args.join("> <")}>`:$=` <${m.args}>`),m.alias?`-${m.alias} --${b}${$}`:`--${b}${$}`}function c(b,m){const $=[];for(const u in b){const l=b[u],E=f(u,l);$.push([E,l.description])}return g($,m)}e.$El=c;function g(b,m){const u=b.reduce((h,i)=>Math.max(h,i[0].length),12)+2+1;if(m-u<25)return b.reduce((h,i)=>h.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const l=m-u-1,E=[];for(const h of b){const i=h[0],a=y(h[1],l),o=w(u-i.length-2);E.push("  "+i+o+a[0]);for(let t=1;t<a.length;t++)E.push(w(u)+a[t])}return E}function w(b){return" ".repeat(b)}function y(b,m){const $=[];for(;b.length;){const u=b.length<m?b.length:b.lastIndexOf(" ",m),l=b.slice(0,u).trim();b=b.slice(u),$.push(l)}return $}function d(b,m,$,u,l){const E=process.stdout.isTTY&&process.stdout.columns||80,h=l?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",i=[`${b} ${$}`];i.push(""),i.push(`${(0,s.localize)(39,null)}: ${m} [${(0,s.localize)(40,null)}]${h}`),i.push(""),l?.noPipe!==!0&&(A.$j?i.push((0,s.localize)(41,null,m)):i.push((0,s.localize)(42,null,m)),i.push(""));const a={},o=[];for(const t in u){const n=u[t];if(n.type==="subcommand")n.description&&o.push({command:t,description:n.description});else if(n.description&&n.cat){let r=a[n.cat];r||(a[n.cat]=r={}),r[t]=n}}for(const t in a){const n=t,r=a[n];r&&(i.push(M[n]),i.push(...c(r,E)),i.push(""))}return o.length&&(i.push((0,s.localize)(43,null)),i.push(...g(o.map(t=>[t.command,t.description]),E)),i.push("")),i.join(`
`)}e.$Fl=d;function v(b,m){return`${b||(0,s.localize)(44,null)}
${m||(0,s.localize)(45,null)}
${process.arch}`}e.$Gl=v}),define(te[198],ie([0,1,87,196,112]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=void 0;class M extends A.$In{constructor(S){super(),this.f=S}call(S,f,c){return f==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(S,f,c)}async g(S,f){const c=(0,s.$Dl)(S,s.$Cl);c.debugRenderer=f;const g=c.extensionDevelopmentPath;if(!g)return{success:!1};const[w]=await this.f.openExtensionDevelopmentHostWindow(g,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!f)return{success:!0};const y=w.win;if(!y)return{success:!0};const d=y.webContents.debugger;let v=d.isAttached()?1/0:0;const b=(0,P.createServer)(m=>{v++===0&&d.attach();let $=!1;const u=h=>{$||m.write(JSON.stringify(h)+"\0")},l=(h,i,a,o)=>u({method:i,params:a,sessionId:o});y.on("close",()=>{d.removeListener("message",l),m.end(),$=!0}),d.addListener("message",l);let E=Buffer.alloc(0);m.on("data",h=>{E=Buffer.concat([E,h]);for(let i=E.indexOf(0);i!==-1;i=E.indexOf(0)){let a;try{const o=E.slice(0,i).toString("utf8");E=E.slice(i+1),a=JSON.parse(o)}catch(o){console.error("error reading cdp line",o)}d.sendCommand(a.method,a.params,a.sessionId).then(o=>u({id:a.id,sessionId:a.sessionId,result:o})).catch(o=>u({id:a.id,sessionId:a.sessionId,error:{code:0,message:o.message}}))}}),m.on("error",h=>{console.error("error on cdp pipe:",h)}),m.on("close",()=>{$=!0,--v===0&&d.detach()})});return await new Promise(m=>b.listen(0,m)),y.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.$q6b=M}),define(te[63],ie([0,1,308,167,112]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.$Hl=void 0;function M(w,y){const d=(l,E)=>{console.warn((0,A.localize)(0,null,l,E))},v=l=>{console.warn((0,A.localize)(1,null,l))},b=(l,E)=>{console.warn((0,A.localize)(2,null,l,E))},m=l=>({onUnknownOption:E=>{s.$Bl.includes(l)||console.warn((0,A.localize)(3,null,E,l))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:b,getSubcommandReporter:s.$Bl.includes(l)?m:void 0}),$={onUnknownOption:l=>{console.warn((0,A.localize)(4,null,l))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:b,getSubcommandReporter:m},u=(0,s.$Dl)(w,s.$Cl,y?$:void 0);return u.goto&&u._.forEach(l=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(l),(0,A.localize)(5,null))),u}function D(w){const y=w.findIndex(d=>!/^-/.test(d));if(y>-1)return[...w.slice(0,y),...w.slice(y+1)]}function S(w){let[,...y]=w;process.env.VSCODE_DEV&&(y=D(y)||[]);const d=!g(process.env);return M(y,d)}e.$Hl=S;function f(w){let[,,...y]=w;return process.env.VSCODE_DEV&&(y=D(y)||[]),M(y,!0)}e.$Il=f;function c(w,...y){const d=w.indexOf("--");return d===-1?w.push(...y):w.splice(d,0,...y),w}e.$Jl=c;function g(w){return w.VSCODE_CLI==="1"}e.$Kl=g}),function(){"use strict";function Z(e,P,A){function s(D,S){const f=M(D,S),c=[f];return e.isAbsolute(f)||c.unshift(A),e.resolve(...c)}function M(D,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,S);const g=D["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(w,"AppData","Roaming")}break;case"darwin":c=e.join(P.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,S)}return{getUserDataPath:s}}if(typeof define=="function")define(te[199],ie([113,28,35]),function(e,P,A){return Z(e,P,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=Z(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[89],ie([0,1,28,197,199]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=void 0;class M extends A.$dm{constructor(c,g){super(c,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(c,g.nameShort)},g)}}e.$gm=M;function D(f,c){return(0,A.$fm)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,c,f.extensionEnvironment)}e.$hm=D;function S(f,c){return(0,A.$fm)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,c,f.extensionEnvironment)}e.$im=S}),define(te[200],ie([0,1,45,28,33]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R7b=void 0;function M(D){const S=(0,s.$5f)((0,A.tmpdir)());try{return(0,P.writeFileSync)(S,""),D&&console.log(`Marker file for --wait created: ${S}`),S}catch(f){D&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$R7b=M}),define(te[201],ie([0,1,12,169]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;function s(D,S,f,c){try{M(D,S,f,c)}catch(g){D.error(g?.message??g)}return S}e.$up=s;function M(D,S,f,c){const g=(w,y,d)=>{const v=w[y];if((0,P.$xf)(v)){const b=v,m=b.length;if(m>1&&b[0]==="%"&&b[m-1]==="%"){const $=b.substr(1,m-2);let u=f[$];u===void 0&&c&&(u=c[$]);const l=typeof u=="string"?u:u?.message,E=c?.[$],h=typeof E=="string"?E:E?.message;if(!l){h||D.warn(`[${S.name}]: ${(0,A.localize)(0,null,$)}`);return}if(d&&(y==="title"||y==="category")&&h&&h!==l){const i={value:l,original:h};w[y]=i}else w[y]=l}}else if((0,P.$zf)(v))for(const b in v)v.hasOwnProperty(b)&&(b==="commands"?g(v,b,!0):g(v,b,d));else if(Array.isArray(v))for(let b=0;b<v.length;b++)g(v,b,d)};for(const w in S)S.hasOwnProperty(w)&&g(S,w)}}),define(te[202],ie([0,1,19,73,171,203]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function f($){return $=$.trim(),$==="*"||D.test($)}e.$Io=f;function c($){if(!f($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=$.match(D);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$Jo=c;function g($){if(!$)return null;const u=$.majorBase,l=$.majorMustEqual,E=$.minorBase;let h=$.minorMustEqual;const i=$.patchBase;let a=$.patchMustEqual;$.hasCaret&&(u===0||(h=!1),a=!1);let o=0;if($.preRelease){const t=S.exec($.preRelease);if(t){const[,n,r,p]=t;o=Date.UTC(Number(n),Number(r)-1,Number(p))}}return{majorBase:u,majorMustEqual:l,minorBase:E,minorMustEqual:h,patchBase:i,patchMustEqual:a,isMinimum:$.hasGreaterEquals,notBefore:o}}e.$Ko=g;function w($,u,l){let E;typeof $=="string"?E=g(c($)):E=$;let h;u instanceof Date?h=u.getTime():typeof u=="string"&&(h=new Date(u).getTime());let i;if(typeof l=="string"?i=g(c(l)):i=l,!E||!i)return!1;const a=E.majorBase,o=E.minorBase,t=E.patchBase;let n=i.majorBase,r=i.minorBase,p=i.patchBase;const C=i.notBefore;let R=i.majorMustEqual,k=i.minorMustEqual,I=i.patchMustEqual;return i.isMinimum?a>n?!0:a<n?!1:o>r?!0:o<r||h&&h<C?!1:t>=p:(a===1&&n===0&&(!R||!k||!I)&&(n=1,r=0,p=0,R=!0,k=!1,I=!1),a<n?!1:a>n?!R:o<r?!1:o>r?!k:t<p?!1:t>p?!I:!(h&&h<C))}e.$Lo=w;function y($,u,l,E,h){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([A.default.Error,s.localize(0,null)]),i;if(typeof E.name!="string")return i.push([A.default.Error,s.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([A.default.Error,s.localize(2,null,"version")]),i;if(!E.engines)return i.push([A.default.Error,s.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([A.default.Error,s.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!m(E.extensionDependencies))return i.push([A.default.Error,s.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!m(E.activationEvents))return i.push([A.default.Error,s.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([A.default.Error,s.localize(7,null,"activationEvents","main","browser")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([A.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([A.default.Error,s.localize(9,null,"main")]),i;{const t=(0,P.$ug)(l,E.main);(0,P.$og)(t,l)||i.push([A.default.Warning,s.localize(10,null,t.path,l.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([A.default.Error,s.localize(11,null,"browser")]),i;{const t=(0,P.$ug)(l,E.browser);(0,P.$og)(t,l)||i.push([A.default.Warning,s.localize(12,null,t.path,l.path)])}}if(!M.valid(E.version))return i.push([A.default.Error,s.localize(13,null)]),i;const a=[];if(!d($,u,E,h,a))for(const t of a)i.push([A.default.Error,t]);return i}e.$Mo=y;function d($,u,l,E,h){return E||typeof l.main>"u"&&typeof l.browser>"u"?!0:b($,u,l.engines.vscode,h)}e.$No=d;function v($,u,l){return $==="*"||b(u,l,$)}e.$Oo=v;function b($,u,l,E=[]){const h=g(c(l));if(!h)return E.push(s.localize(14,null,l)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return E.push(s.localize(15,null,l)),!1}else if(!h.majorMustEqual)return E.push(s.localize(16,null,l)),!1;return w($,u,h)?!0:(E.push(s.localize(17,null,$,l)),!1)}function m($){if(!Array.isArray($))return!1;for(let u=0,l=$.length;u<l;u++)if(typeof $[u]!="string")return!1;return!0}}),define(te[204],ie([0,1,18,32]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=void 0;async function s(M,D,S){let f=S&&S.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const g=(await D.readFile(M.serviceMachineIdResource)).value.toString();f=(0,A.$cg)(g)?g:null}catch{f=null}if(!f){f=(0,A.$dg)();try{await D.writeFile(M.serviceMachineIdResource,P.$ae.fromString(f))}catch{}}return S?.store("storage.serviceMachineId",f,-1,1),f}e.$9o=s}),define(te[77],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class P{constructor(s,M=[],D=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.$Kh=P}),define(te[205],ie([0,1,77]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.InstantiationType=void 0;const A=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(S,f,c){f instanceof P.$Kh||(f=new P.$Kh(f,[],!!c)),A.push([S,f])}e.$tr=M;function D(){return A}e.$ur=D}),define(te[206],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=void 0;class P{constructor(M,D){this.key=M,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$$p=P;class A{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const D of this.a.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const S=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(D);S.outgoing.set(f.key,f),f.incoming.set(S.key,S)}removeNode(M){const D=this.b(M);this.a.delete(D);for(const S of this.a.values())S.outgoing.delete(D),S.incoming.delete(D)}lookupOrInsertNode(M){const D=this.b(M);let S=this.a.get(D);return S||(S=new P(D,M),this.a.set(D,S)),S}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[D,S]of this.a)M.push(`${D}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this.a){const S=new Set([M]),f=this.c(D,S);if(f)return f}}c(M,D){for(const[S,f]of M.outgoing){if(D.has(S))return[...D,S].join(" -> ");D.add(S);const c=this.c(f,D);if(c)return c;D.delete(S)}}}e.$_p=A}),define(te[6],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e._util=void 0;var P;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(f){return f[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(P||(e._util=P={})),e.$Mh=s("instantiationService");function A(D,S,f){S[P.DI_TARGET]===S?S[P.DI_DEPENDENCIES].push({id:D,index:f}):(S[P.DI_DEPENDENCIES]=[{id:D,index:f}],S[P.DI_TARGET]=S)}function s(D){if(P.serviceIds.has(D))return P.serviceIds.get(D);const S=function(f,c,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(S,f,g)};return S.toString=()=>D,P.serviceIds.set(D,S),S}e.$Nh=s;function M(D){return D}e.$Oh=M}),define(te[64],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k6b=void 0,e.$k6b=(0,P.$Nh)("backupMainService")}),define(te[17],ie([0,1,12,7,6]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,s.$Nh)("configurationService");function M($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof A.URI)}e.$ii=M;function D($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof A.URI)}e.$ji=D;var S;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function f($){switch($){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=f;function c($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}e.$li=c;function g($,u){const l=Object.create(null);for(const E in $)w(l,E,$[E],u);return l}e.$mi=g;function w($,u,l,E){const h=u.split("."),i=h.pop();let a=$;for(let o=0;o<h.length;o++){const t=h[o];let n=a[t];switch(typeof n){case"undefined":n=a[t]=Object.create(null);break;case"object":break;default:E(`Ignoring ${u} as ${h.slice(0,o+1).join(".")} is ${JSON.stringify(n)}`);return}a=n}if(typeof a=="object"&&a!==null)try{a[i]=l}catch{E(`Ignoring ${u} as ${h.join(".")} is ${JSON.stringify(a)}`)}else E(`Ignoring ${u} as ${h.join(".")} is ${JSON.stringify(a)}`)}e.$ni=w;function y($,u){const l=u.split(".");d($,l)}e.$oi=y;function d($,u){const l=u.shift();if(u.length===0){delete $[l];return}if(Object.keys($).indexOf(l)!==-1){const E=$[l];typeof E=="object"&&!Array.isArray(E)&&(d(E,u),Object.keys(E).length===0&&delete $[l])}}function v($,u,l){function E(a,o){let t=a;for(const n of o){if(typeof t!="object"||t===null)return;t=t[n]}return t}const h=u.split("."),i=E($,h);return typeof i>"u"?l:i}e.$pi=v;function b($,u,l){Object.keys(u).forEach(E=>{E!=="__proto__"&&(E in $?P.$zf($[E])&&P.$zf(u[E])?b($[E],u[E],l):l&&($[E]=u[E]):$[E]=u[E])})}e.$qi=b;function m($){return $.replace(/[\[\]]/g,"")}e.$ri=m}),define(te[114],ie([0,1,4,27,195,6,162,14]),function(Z,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",P.$k),f.set("isLinux",P.$l),f.set("isWindows",P.$j),f.set("isWeb",P.$p),f.set("isMacNative",P.$k&&!P.$p),f.set("isEdge",P.$H),f.set("isFirefox",P.$F),f.set("isChrome",P.$E),f.set("isSafari",P.$G);function c(F,O){if(f.get(F)!==void 0)throw(0,S.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(F,O)}e.$Ji=c;const g=Object.prototype.hasOwnProperty;var w;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const y={regexParsingWithErrorRecovery:!0},d=(0,D.localize)(0,null),v=(0,D.localize)(1,null),b=(0,D.localize)(2,null),m=(0,D.localize)(3,null),$=(0,D.localize)(4,null),u=(0,D.localize)(5,null),l=(0,D.localize)(6,null),E=(0,D.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=y){this.k=O,this.d=new s.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const B=this.D(),W=B.type===17?u:void 0;throw this.h.push({message:$,offset:B.offset,lexeme:s.$Ii.getLexeme(B),additionalInfo:W}),h.c}return j}catch(j){if(j!==h.c)throw j;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const j=this.o();O.push(j)}return O.length===1?O[0]:i.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const j=this.s();O.push(j)}return O.length===1?O[0]:i.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,m),j?.negate()}case 17:return this.z(),L.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const j=this.l();return this.A(1,m),j}case 17:{const j=O.lexeme;if(this.z(),this.y(9)){const W=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),W.type!==10)throw this.B("REGEX",W);const T=W.lexeme,V=T.lastIndexOf("/"),ce=V===T.length-1?void 0:this.w(T.substring(V+1));let de;try{de=new RegExp(T.substring(1,V),ce)}catch{throw this.B("REGEX",W)}return se.create(j,de)}switch(W.type){case 10:case 19:{const T=[W.lexeme];this.z();let V=this.D(),ce=0;for(let be=0;be<W.lexeme.length;be++)W.lexeme.charCodeAt(be)===40?ce++:W.lexeme.charCodeAt(be)===41&&ce--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let be=0;be<V.lexeme.length;be++)V.lexeme.charCodeAt(be)===40?ce++:W.lexeme.charCodeAt(be)===41&&ce--}if(ce<0)break;T.push(s.$Ii.getLexeme(V)),this.z(),V=this.D()}const de=T.join(""),ue=de.lastIndexOf("/"),fe=ue===de.length-1?void 0:this.w(de.substring(ue+1));let ye;try{ye=new RegExp(de.substring(1,ue),fe)}catch{throw this.B("REGEX",W)}return i.regex(j,ye)}case 18:{const T=W.lexeme;this.z();let V=null;if(!(0,A.$Ae)(T)){const ce=T.indexOf("/"),de=T.lastIndexOf("/");if(ce!==de&&ce>=0){const ue=T.slice(ce+1,de),fe=T[de+1]==="i"?"i":"";try{V=new RegExp(ue,fe)}catch{throw this.B("REGEX",W)}}}if(V===null)throw this.B("REGEX",W);return se.create(j,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const W=this.u();return i.notIn(j,W)}switch(this.D().type){case 3:{this.z();const W=this.u();if(this.x().type===18)return i.equals(j,W);switch(W){case"true":return i.has(j);case"false":return i.not(j);default:return i.equals(j,W)}}case 4:{this.z();const W=this.u();if(this.x().type===18)return i.notEquals(j,W);switch(W){case"true":return i.not(j);case"false":return i.has(j);default:return i.notEquals(j,W)}}case 5:return this.z(),_.create(j,this.u());case 6:return this.z(),ae.create(j,this.u());case 7:return this.z(),z.create(j,this.u());case 8:return this.z(),ne.create(j,this.u());case 13:return this.z(),i.in(j,this.u());default:return i.has(j)}}case 20:throw this.h.push({message:l,offset:O.offset,lexeme:"",additionalInfo:E}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,j){if(this.C(O))return this.z();throw this.B(j,this.D())}B(O,j,B){const W=(0,D.localize)(8,null,O,s.$Ii.getLexeme(j)),T=j.offset,V=s.$Ii.getLexeme(j);return this.h.push({message:W,offset:T,lexeme:V,additionalInfo:B}),h.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=h;class i{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(O){return p.create(O)}static equals(O,j){return C.create(O,j)}static notEquals(O,j){return I.create(O,j)}static regex(O,j){return se.create(O,j)}static in(O,j){return R.create(O,j)}static notIn(O,j){return k.create(O,j)}static not(O){return L.create(O)}static and(...O){return K.create(O,null,!0)}static or(...O){return G.create(O,null,!0)}static greater(O,j){return z.create(O,j)}static greaterEquals(O,j){return ne.create(O,j)}static smaller(O,j){return _.create(O,j)}static smallerEquals(O,j){return ae.create(O,j)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Li=i;function a(F){const O=new h({regexParsingWithErrorRecovery:!1});return F.map(j=>(O.parse(j),O.lexingErrors.length>0?O.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,D.localize)(9,null,B.additionalInfo):(0,D.localize)(10,null),offset:B.offset,length:B.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$Mi=a;function o(F,O){const j=F?F.substituteConstants():void 0,B=O?O.substituteConstants():void 0;return!j&&!B?!0:!j||!B?!1:j.equals(B)}e.$Ni=o;function t(F,O){return F.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return r.INSTANCE}}e.$Oi=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$Pi=r;class p{static create(O,j=null){const B=f.get(O);return typeof B=="boolean"?B?r.INSTANCE:n.INSTANCE:new p(O,j)}constructor(O,j){this.key=O,this.c=j,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:q(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=f.get(this.key);return typeof O=="boolean"?O?r.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Qi=p;class C{static create(O,j,B=null){if(typeof j=="boolean")return j?p.create(O,B):L.create(O,B);const W=f.get(O);return typeof W=="boolean"?j===(W?"true":"false")?r.INSTANCE:n.INSTANCE:new C(O,j,B)}constructor(O,j,B){this.c=O,this.d=j,this.f=B,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?r.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ri=C;class R{static create(O,j){return new R(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:X(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.f),B=O.getValue(this.d);return Array.isArray(j)?j.includes(B):typeof B=="string"&&typeof j=="object"&&j!==null?g.call(j,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Si=R;class k{static create(O,j){return new k(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=11,this.c=R.create(O,j)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=k;class I{static create(O,j,B=null){if(typeof j=="boolean")return j?L.create(O,B):p.create(O,B);const W=f.get(O);return typeof W=="boolean"?j===(W?"true":"false")?n.INSTANCE:r.INSTANCE:new I(O,j,B)}constructor(O,j,B){this.c=O,this.d=j,this.f=B,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?n.INSTANCE:r.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Ui=I;class L{static create(O,j=null){const B=f.get(O);return typeof B=="boolean"?B?n.INSTANCE:r.INSTANCE:new L(O,j)}constructor(O,j){this.c=O,this.d=j,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:q(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=f.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:r.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$Vi=L;function N(F,O){if(typeof F=="string"){const j=parseFloat(F);isNaN(j)||(F=j)}return typeof F=="string"||typeof F=="number"?O(F):n.INSTANCE}class z{static create(O,j,B=null){return N(j,W=>new z(O,W,B))}constructor(O,j,B){this.c=O,this.d=j,this.f=B,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Wi=z;class ne{static create(O,j,B=null){return N(j,W=>new ne(O,W,B))}constructor(O,j,B){this.c=O,this.d=j,this.f=B,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Xi=ne;class _{static create(O,j,B=null){return N(j,W=>new _(O,W,B))}constructor(O,j,B){this.c=O,this.d=j,this.f=B,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Yi=_;class ae{static create(O,j,B=null){return N(j,W=>new ae(O,W,B))}constructor(O,j,B){this.c=O,this.d=j,this.f=B,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Zi=ae;class se{static create(O,j){return new se(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const j=this.f?this.f.source:"",B=O.f?O.f.source:"";return j<B?-1:j>B?1:0}equals(O){if(O.type===this.type){const j=this.f?this.f.source:"",B=O.f?O.f.source:"";return this.d===O.d&&j===B}return!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=oe.create(this)),this.c}}e.$1i=se;class oe{static create(O){return new oe(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new oe(this.c.map(O))}negate(){return this.c}}e.$2i=oe;function J(F){let O=null;for(let j=0,B=F.length;j<B;j++){const W=F[j].substituteConstants();if(F[j]!==W&&O===null){O=[];for(let T=0;T<j;T++)O[T]=F[T]}O!==null&&(O[j]=W)}return O===null?F:O}class K{static create(O,j,B){return K.d(O,j,B)}constructor(O,j){this.expr=O,this.c=j,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,B=this.expr.length;j<B;j++){const W=t(this.expr[j],O.expr[j]);if(W!==0)return W}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,B=this.expr.length;j<B;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=J(this.expr);return O===this.expr?this:K.create(O,this.c,!1)}evaluate(O){for(let j=0,B=this.expr.length;j<B;j++)if(!this.expr[j].evaluate(O))return!1;return!0}static d(O,j,B){const W=[];let T=!1;for(const V of O)if(V){if(V.type===1){T=!0;continue}if(V.type===0)return n.INSTANCE;if(V.type===6){W.push(...V.expr);continue}W.push(V)}if(W.length===0&&T)return r.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(t);for(let V=1;V<W.length;V++)W[V-1].equals(W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0];for(;W.length>1;){const V=W[W.length-1];if(V.type!==9)break;W.pop();const ce=W.pop(),de=W.length===0,ue=G.create(V.expr.map(fe=>K.create([fe,ce],null,B)),null,de);ue&&(W.push(ue),W.sort(t))}if(W.length===1)return W[0];if(B){for(let V=0;V<W.length;V++)for(let ce=V+1;ce<W.length;ce++)if(W[V].negate().equals(W[ce]))return n.INSTANCE;if(W.length===1)return W[0]}return new K(W,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new K(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());this.c=G.create(O,this,!0)}return this.c}}e.$3i=K;class G{static create(O,j,B){return G.d(O,j,B)}constructor(O,j){this.expr=O,this.c=j,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,B=this.expr.length;j<B;j++){const W=t(this.expr[j],O.expr[j]);if(W!==0)return W}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,B=this.expr.length;j<B;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=J(this.expr);return O===this.expr?this:G.create(O,this.c,!1)}evaluate(O){for(let j=0,B=this.expr.length;j<B;j++)if(this.expr[j].evaluate(O))return!0;return!1}static d(O,j,B){let W=[],T=!1;if(O){for(let V=0,ce=O.length;V<ce;V++){const de=O[V];if(de){if(de.type===0){T=!0;continue}if(de.type===1)return r.INSTANCE;if(de.type===9){W=W.concat(de.expr);continue}W.push(de)}}if(W.length===0&&T)return n.INSTANCE;W.sort(t)}if(W.length!==0){if(W.length===1)return W[0];for(let V=1;V<W.length;V++)W[V-1].equals(W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0];if(B){for(let V=0;V<W.length;V++)for(let ce=V+1;ce<W.length;ce++)if(W[V].negate().equals(W[ce]))return r.INSTANCE;if(W.length===1)return W[0]}return new G(W,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new G(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());for(;O.length>1;){const j=O.shift(),B=O.shift(),W=[];for(const T of re(j))for(const V of re(B))W.push(K.create([T,V],null,!1));O.unshift(G.create(W,null,!1))}this.c=G.create(O,this,!0)}return this.c}}e.$4i=G;class U extends p{static{this.d=[]}static all(){return U.d.values()}constructor(O,j,B){super(O,null),this.f=j,typeof B=="object"?U.d.push({...B,key:O}):B!==!0&&U.d.push({key:O,description:B,type:j!=null?typeof j:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return C.create(this.key,O)}notEqualsTo(O){return I.create(this.key,O)}}e.$5i=U,e.$6i=(0,M.$Nh)("contextKeyService");function q(F,O){return F<O?-1:F>O?1:0}function X(F,O,j,B){return F<j?-1:F>j?1:O<B?-1:O>B?1:0}function H(F,O){if(F.type===0||O.type===1)return!0;if(F.type===9)return O.type===9?Q(F.expr,O.expr):!1;if(O.type===9){for(const j of O.expr)if(H(F,j))return!0;return!1}if(F.type===6){if(O.type===6)return Q(O.expr,F.expr);for(const j of F.expr)if(H(j,O))return!0;return!1}return F.equals(O)}e.$7i=H;function Q(F,O){let j=0,B=0;for(;j<F.length&&B<O.length;){const W=F[j].cmp(O[B]);if(W<0)return!1;W===0&&j++,B++}return j===F.length}function re(F){return F.type===9?F.expr:[F]}}),define(te[90],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=e.ID=void 0,e.ID="diagnosticsService",e.$nm=(0,P.$Nh)(e.ID);function A(M){return!!M.hostName&&!!M.errorMessage}e.$om=A;class s{async getPerformanceInfo(D,S){return{}}async getSystemInfo(D,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,S){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$pm=s}),define(te[115],ie([0,1,19,73,164,6,46,4,37]),function(Z,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.ConfirmResult=e.$yv=e.$xv=e.$wv=void 0,e.$wv=(0,M.$Nh)("dialogService");var c;(function(b){b[b.Confirmation=1]="Confirmation",b[b.Prompt=2]="Prompt",b[b.Input=3]="Input"})(c||(c={}));class g{a(m){return this.d(m,c.Confirmation)}b(m){return this.d(m,c.Prompt)}c(m){return this.d(m,c.Input)}d(m,$){const u=[];switch($){case c.Confirmation:{const l=m;l.primaryButton?u.push(l.primaryButton):u.push((0,s.localize)(0,null)),l.cancelButton?u.push(l.cancelButton):u.push((0,s.localize)(1,null));break}case c.Prompt:{const l=m;Array.isArray(l.buttons)&&l.buttons.length>0&&u.push(...l.buttons.map(E=>E.label)),l.cancelButton&&(l.cancelButton===!0?u.push((0,s.localize)(2,null)):typeof l.cancelButton=="string"?u.push(l.cancelButton):l.cancelButton.label?u.push(l.cancelButton.label):u.push((0,s.localize)(3,null))),u.length===0&&u.push((0,s.localize)(4,null));break}case c.Input:{const l=m;l.primaryButton?u.push(l.primaryButton):u.push((0,s.localize)(5,null)),l.cancelButton?u.push(l.cancelButton):u.push((0,s.localize)(6,null));break}}return u}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===A.default.Info?"info":m===A.default.Error?"error":m===A.default.Warning?"warning":"none"}f(m,$,u){const l=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&l.push(m.cancelButton);let E=l[$]?.run({checkboxChecked:u});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:u}}}e.$xv=g,e.$yv=(0,M.$Nh)("fileDialogService");var w;(function(b){b[b.SAVE=0]="SAVE",b[b.DONT_SAVE=1]="DONT_SAVE",b[b.CANCEL=2]="CANCEL"})(w||(e.ConfirmResult=w={}));const y=10;function d(b){const m=[];return m.push(...b.slice(0,y).map($=>typeof $=="string"?$:(0,P.$rg)($))),b.length>y&&(b.length-y===1?m.push((0,s.localize)(7,null)):m.push((0,s.localize)(8,null,b.length-y))),m.push(""),m.join(`
`)}e.$zv=d;function v(b,m){const $=(0,f.$3m)(b);let u=($.buttons??[]).map(i=>(0,D.$tv)(i)),l=(b.buttons||[]).map((i,a)=>a),E=0,h=$.cancelId??u.length-1;if(u.length>1){const i=typeof h=="number"?u[h]:void 0;if(S.$l||S.$k){if(typeof i=="string"&&u.length>1&&h!==1){u.splice(h,1),u.splice(1,0,i);const a=l[h];l.splice(h,1),l.splice(1,0,a),h=1}S.$l&&u.length>1&&(u=u.reverse(),l=l.reverse(),E=u.length-1,typeof i=="string"&&(h=E-1))}else if(S.$j&&typeof i=="string"&&u.length>1&&h!==u.length-1){u.splice(h,1),u.push(i);const a=l[h];l.splice(h,1),l.push(a),h=u.length-1}}return $.buttons=u,$.defaultId=E,$.cancelId=h,$.noLink=!0,$.title=$.title||m.nameLong,{options:$,buttonIndeces:l}}e.$Av=v}),define(te[116],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZT=e.$YT=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$XT=e.$WT=void 0,e.$WT=(0,P.$Nh)("encryptionService"),e.$XT=(0,P.$Nh)("encryptionMainService");var A;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(A||(e.PasswordStoreCLIOption=A={}));var s;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$YT=M;function D(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$ZT=D}),define(te[36],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,P.$Nh)("environmentService"),e.$Vh=(0,P.$Oh)(e.$Uh)}),define(te[117],ie([0,1,168,6]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$7n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=void 0,e.$Tn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Un=new RegExp(e.$Tn),e.$Vn="__web_extension",e.$Wn="skipWalkthrough",e.$Xn="extensionsSync",e.$Yn="dependecyOrPackExtensionInstall";function s(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Zn=s;function M(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$1n=M;function D(u,l){switch(u){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$2n=D;function S(u,l){return l==="web"&&!u.includes("web")}e.$3n=S;function f(u,l,E){return S(l,E)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===E?!0:c(E).includes(u)}e.$4n=f;function c(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$5n=c;function g(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$6n=g;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var y;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var v;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$7n=(0,A.$Nh)("extensionGalleryService");var b;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var m;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(m||(e.ExtensionSignaturetErrorCode=m={}));class $ extends Error{constructor(l,E){super(l),this.code=E,this.name=E}}e.$8n=$,e.$9n=(0,A.$Nh)("extensionManagementService"),e.$0n="extensionsIdentifiers/disabled",e.$$n="extensionsIdentifiers/enabled",e.$_n=(0,A.$Nh)("IGlobalExtensionEnablementService"),e.$ao=(0,A.$Nh)("IExtensionTipsService"),e.$bo=(0,P.localize)(0,null),e.$co={value:e.$bo,original:"Extensions"},e.$do={value:(0,P.localize)(1,null),original:"Preferences"}}),define(te[207],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F6b=e.$E6b=void 0,e.$E6b=(0,P.$Nh)("extensionHostStarter"),e.$F6b="extensionHostStarter"}),define(te[208],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YXb=e.$XXb=void 0,e.$XXb=(0,P.$Nh)("externalTerminal"),e.$YXb="Terminal.app"}),define(te[209],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H6b=void 0,e.$H6b=(0,P.$Nh)("externalTerminal")}),define(te[210],ie([0,1,47,13,9,4,75,21,88,172,208]),function(Z,e,P,A,s,M,D,S,f,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=e.$J6b=e.$I6b=void 0;const w=c.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends y{static{this.b="cmd.exe"}openTerminal(E,h){return this.spawnTerminal(P,E,f.$yl(),h)}spawnTerminal(E,h,i,a){const o=h.windowsExec||d.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const t=s.$mc(o,".exe").toLowerCase();if(t==="cmder")return E.spawn(o,a?[a]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return o.indexOf(" ")>=0&&n.push('""'),n.push(o),t==="wt"&&n.push("-d ."),new Promise((r,p)=>{const C=m(process),R=E.spawn(i,n,{cwd:a,env:C});R.on("error",p),R.on("exit",()=>r())})}runInTerminal(E,h,i,a,o){const t="windowsExec"in o&&o.windowsExec?o.windowsExec:d.getDefaultTerminalWindows();return new Promise((n,r)=>{const p=`"${h} - ${w}"`,C=`""${i.join('" "')}" & pause"`,R=Object.assign({},m(process),a);Object.keys(R).filter(z=>R[z]===null).forEach(z=>delete R[z]);const k={cwd:h,env:R,windowsVerbatimArguments:!0};let I,L;s.$mc(t,".exe")==="wt"?(I=t,L=["-d",".",d.b,"/c",C]):(I=d.b,L=["/c","start",p,"/wait",t,"/c",C]),P.spawn(I,L,k).on("error",z=>{r($(z))}),n(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return d.d}}e.$I6b=d;class v extends y{static{this.b="/usr/bin/osascript"}openTerminal(E,h){return this.spawnTerminal(P,E,h)}runInTerminal(E,h,i,a,o){const t=o.osxExec||g.$YXb;return new Promise((n,r)=>{if(t===g.$YXb||t==="iTerm.app"){const p=t===g.$YXb?"TerminalHelper":"iTermHelper",R=[A.$bg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${p}.scpt`).fsPath,"-t",E||w,"-w",h];for(const L of i)R.push("-a"),R.push(L);if(a){const L=Object.assign({},m(process),a);for(const N in L){const z=L[N];z===null?(R.push("-u"),R.push(N)):(R.push("-e"),R.push(`${N}=${z}`))}}let k="";const I=P.spawn(v.b,R);I.on("error",L=>{r($(L))}),I.stderr.on("data",L=>{k+=L.toString()}),I.on("exit",L=>{if(L===0)n(void 0);else if(k){const N=k.split(`
`,1);r(new Error(N[0]))}else r(new Error(c.localize(1,null,p,L)))})}else r(new Error(c.localize(2,null,t)))})}spawnTerminal(E,h,i){const a=h.osxExec||g.$YXb;return new Promise((o,t)=>{const n=["-a",a];i&&n.push(i);const r=m(process),p=E.spawn("/usr/bin/open",n,{cwd:i,env:r});p.on("error",t),p.on("exit",()=>o())})}}e.$J6b=v;class b extends y{static{this.b=c.localize(3,null)}openTerminal(E,h){return this.spawnTerminal(P,E,h)}runInTerminal(E,h,i,a,o){const t=o.linuxExec?Promise.resolve(o.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((n,r)=>{const p=[];t.then(C=>{C.indexOf("gnome-terminal")>=0?p.push("-x"):p.push("-e"),p.push("bash"),p.push("-c");const R=`${u(i)}; echo; read -p "${b.b}" -n1;`;p.push(`''${R}''`);const k=Object.assign({},m(process),a);Object.keys(k).filter(z=>k[z]===null).forEach(z=>delete k[z]);const I={cwd:h,env:k};let L="";const N=P.spawn(C,p,I);N.on("error",z=>{r($(z))}),N.stderr.on("data",z=>{L+=z.toString()}),N.on("exit",z=>{if(z===0)n(void 0);else if(L){const ne=L.split(`
`,1);r(new Error(ne[0]))}else r(new Error(c.localize(4,null,C,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!b.d)if(!M.$l)b.d=Promise.resolve("xterm");else{const E=await S.Promises.exists("/etc/debian_version");b.d=new Promise(h=>{E?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return b.d}spawnTerminal(E,h,i){const a=h.linuxExec?Promise.resolve(h.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((o,t)=>{a.then(n=>{const r=m(process),p=E.spawn(n,[],{cwd:i,env:r});p.on("error",t),p.on("exit",()=>o())})})}}e.$K6b=b;function m(l){const E={...l.env};return(0,D.$wl)(E),E}function $(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(c.localize(5,null,l.path)):l}function u(l){let E="";for(const h of l)h.indexOf(" ")>=0?E+='"'+h+'"':E+=h,E+=" ";return E}}),define(te[16],ie([0,1,56,9,27,12,7,174,6,4,13,71]),function(Z,e,P,A,s,M,D,S,f,c,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileKind=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileOperationResult=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileChangeType=e.$ok=e.FileOperation=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.FileSystemProviderErrorCode=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.FileSystemProviderCapabilities=e.$$j=e.FilePermission=e.FileType=e.$0j=e.$9j=void 0,e.$9j=(0,f.$Nh)("fileService");function y(H){return H.create===!0}e.$0j=y;var d;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(d||(e.FileType=d={}));var v;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function b(H){const Q=H;return!!Q&&typeof Q.onDidChange=="function"}e.$$j=b;var m;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function $(H){return!!(H.capabilities&2)}e.$_j=$;function u(H){return!!(H.capabilities&8)}e.$ak=u;function l(H){return!!(H.capabilities&131072)}e.$bk=l;function E(H){return!!(H.capabilities&4)}e.$ck=E;function h(H){return!!(H.capabilities&16)}e.$dk=h;function i(H){return $(H)?!!(H.capabilities&16384):!1}e.$ek=i;function a(H){return $(H)?!!(H.capabilities&32768):!1}e.$fk=a;function o(H){return!!(H.capabilities&65536)}e.$gk=o;function t(H){return!!(H.capabilities&2048)}e.$hk=t;var n;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class r extends Error{static create(Q,re){const F=new r(Q.toString(),re);return R(F,re),F}constructor(Q,re){super(Q),this.code=re}}e.$ik=r;function p(H,Q){return r.create(H,Q)}e.$jk=p;function C(H){return H||p((0,S.localize)(0,null),n.Unknown)}e.$kk=C;function R(H,Q){return H.name=Q?`${Q} (FileSystemError)`:"FileSystemError",H}e.$lk=R;function k(H){if(!H)return n.Unknown;if(H instanceof r)return H.code;const Q=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!Q)return n.Unknown;switch(Q[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$mk=k;function I(H){if(H instanceof ae)return H.fileOperationResult;switch(k(H)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$nk=I;var L;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class N{constructor(Q,re,F){this.resource=Q,this.operation=re,this.target=F}isOperation(Q){return this.operation===Q}}e.$ok=N;var z;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class ne{static{this.a=null}constructor(Q,re){this.c=re,this.b=void 0,this.d=new w.$U(()=>{const F=P.$Th.forUris(()=>this.c);return F.fill(this.rawAdded.map(O=>[O,!0])),F}),this.f=new w.$U(()=>{const F=P.$Th.forUris(()=>this.c);return F.fill(this.rawUpdated.map(O=>[O,!0])),F}),this.g=new w.$U(()=>{const F=P.$Th.forUris(()=>this.c);return F.fill(this.rawDeleted.map(O=>[O,!0])),F}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const F of Q){switch(F.type){case 1:this.rawAdded.push(F.resource);break;case 0:this.rawUpdated.push(F.resource);break;case 2:this.rawDeleted.push(F.resource);break}this.b!==ne.a&&(typeof F.cId=="number"?this.b===void 0?this.b=F.cId:this.b!==F.cId&&(this.b=ne.a):this.b!==void 0&&(this.b=ne.a))}}contains(Q,...re){return this.h(Q,{includeChildren:!1},...re)}affects(Q,...re){return this.h(Q,{includeChildren:!0},...re)}h(Q,re,...F){if(!Q)return!1;const O=F.length>0;return!!((!O||F.includes(1))&&(this.d.value.get(Q)||re.includeChildren&&this.d.value.findSuperstr(Q))||(!O||F.includes(0))&&(this.f.value.get(Q)||re.includeChildren&&this.f.value.findSuperstr(Q))||(!O||F.includes(2))&&(this.g.value.findSubstr(Q)||re.includeChildren&&this.g.value.findSuperstr(Q)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Q){return this.b===Q}hasCorrelation(){return typeof this.b=="number"}}e.$pk=ne;function _(H,Q,re){return!H||!Q||H===Q||Q.length>H.length?!1:(Q.charAt(Q.length-1)!==A.sep&&(Q+=A.sep),re?(0,s.$2e)(H,Q):H.indexOf(Q)===0)}e.$qk=_;class ae extends Error{constructor(Q,re,F){super(Q),this.fileOperationResult=re,this.options=F}}e.$rk=ae;class se extends ae{constructor(Q,re,F,O){super(Q,re,O),this.fileOperationResult=re,this.size=F}}e.$sk=se;class oe extends ae{constructor(Q,re,F){super(Q,2,F),this.stat=re}}e.$tk=oe;var J;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$uk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$vk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$wk="files.associations",e.$xk="files.exclude",e.$yk="files.readonlyInclude",e.$zk="files.readonlyExclude",e.$Ak="files.readonlyFromPermissions";var K;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$Bk="";function G(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.$Ck=G;async function U(H,Q){if(!Q.hasProvider(D.URI.from({scheme:H.scheme})))return new Promise(re=>{const F=Q.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===H.scheme&&O.added&&(F.dispose(),re())})})}e.$Dk=U;class q{static{this.KB=1024}static{this.MB=q.KB*q.KB}static{this.GB=q.MB*q.KB}static{this.TB=q.GB*q.KB}static formatSize(Q){return(0,M.$Bf)(Q)||(Q=0),Q<q.KB?(0,S.localize)(1,null,Q.toFixed(0)):Q<q.MB?(0,S.localize)(2,null,(Q/q.KB).toFixed(2)):Q<q.GB?(0,S.localize)(3,null,(Q/q.MB).toFixed(2)):Q<q.TB?(0,S.localize)(4,null,(Q/q.GB).toFixed(2)):(0,S.localize)(5,null,(Q/q.TB).toFixed(2))}}e.$Ek=q;function X(H){const Q=typeof H=="string"||H?.scheme===g.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===g.Schemas.file?1024*q.MB:Q?10*q.MB:c.$p?50*q.MB:1024*q.MB}e.$Fk=X}),define(te[118],ie([0,1,18,14,175,16]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;async function D(g,w,y,d,v,b){let m;try{await S(g,w,y,d,v,b)}catch($){m=$}finally{m&&v.errorTransformer&&(m=v.errorTransformer(m)),typeof m<"u"&&y.error(m),y.end()}}e.$Jp=D;async function S(g,w,y,d,v,b){f(b);const m=await g.open(w,{create:!1});try{f(b);let $=0,u=0,l=v&&typeof v.length=="number"?v.length:void 0,E=P.$ae.alloc(Math.min(v.bufferSize,typeof l=="number"?l:v.bufferSize)),h=v&&typeof v.position=="number"?v.position:0,i=0;do u=await g.read(m,h,E.buffer,i,E.byteLength-i),h+=u,i+=u,$+=u,typeof l=="number"&&(l-=u),i===E.byteLength&&(await y.write(d(E)),E=P.$ae.alloc(Math.min(v.bufferSize,typeof l=="number"?l:v.bufferSize)),i=0);while(u>0&&(typeof l!="number"||l>0)&&f(b)&&c($,v));if(i>0){let a=i;typeof l=="number"&&(a=Math.min(i,l)),y.write(d(E.slice(0,a)))}}catch($){throw(0,M.$kk)($)}finally{await g.close(m)}}function f(g){if(g.isCancellationRequested)throw(0,A.$5)();return!0}function c(g,w){if(typeof w?.limits?.size=="number"&&g>w.limits.size)throw(0,M.$jk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[65],ie([0,1,104,2,9,4,7,16]),function(Z,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=e.$Qp=e.$Pp=e.$Op=e.$Np=e.$Mp=e.$Lp=void 0;function f($){return $.recursive===!0}e.$Lp=f;class c extends A.$Rc{static{this.a=5}constructor(u,l,E,h){super(),this.h=u,this.j=l,this.m=E,this.n=h,this.c=this.B(new A.$Sc),this.f=void 0,this.g=0}s(){const u=new A.$Qc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(l=>this.h(l))),u.add(this.b.onDidLogMessage(l=>this.j(l))),u.add(this.b.onDidError(l=>this.t(l)))}t(u){this.n.restartOnError?this.g<c.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Mp=c;class g extends c{constructor(u,l,E){super(u,l,E,{type:"node.js",restartOnError:!1})}}e.$Np=g;class w extends c{constructor(u,l,E){super(u,l,E,{type:"universal",restartOnError:!0})}}e.$Op=w;function y($){return $.map(u=>({type:u.type,resource:D.URI.revive(u.resource),cId:u.cId}))}e.$Pp=y;function d($){const u=new m;for(const l of $)u.processEvent(l);return u.coalesce()}e.$Qp=d;function v($,u){return typeof u=="string"&&!u.startsWith(P.$qj)&&!(0,s.$hc)(u)?{base:$,pattern:u}:u}e.$Rp=v;function b($,u){const l=[];for(const E of u)l.push((0,P.$uj)(v($,E)));return l}e.$Sp=b;class m{constructor(){this.a=new Set,this.b=new Map}c(u){return M.$l?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const l=this.b.get(this.c(u));let E=!1;if(l){const h=l.type,i=u.type;l.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?E=!0:h===1&&i===2?(this.b.delete(this.c(u)),this.a.delete(l)):h===2&&i===1?l.type=0:h===1&&i===0||(l.type=i)}else E=!0;E&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],l=[];return Array.from(this.a).filter(E=>E.type!==2?(u.push(E),!1):!0).sort((E,h)=>E.resource.fsPath.length-h.resource.fsPath.length).filter(E=>l.some(h=>(0,S.$qk)(E.resource.fsPath,h,!M.$l))?!1:(l.push(E.resource.fsPath),!0)).concat(u)}}}),define(te[211],ie([0,1,18,49,14,3,2,62,32,16,65]),function(Z,e,P,A,s,M,D,S,f,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0,e.$gN="localFilesystem";class w extends D.$Rc{constructor(d,v){super(),this.a=d,this.b=v,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$Md),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$Md),this.onDidWatchError=this.g.event,this.h=(0,f.$dg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,v){const{buffer:b}=await this.a.call("readFile",[d,v]);return b}readFileStream(d,v,b){const m=(0,S.$1d)(u=>P.$ae.concat(u.map(l=>P.$ae.wrap(l))).buffer),$=new D.$Qc;return $.add(this.a.listen("readFileStream",[d,v])(u=>{if(u instanceof P.$ae)m.write(u.buffer);else{if(u==="end")m.end();else{let l;if(u instanceof Error)l=u;else{const E=u;l=(0,c.$jk)(E.message??(0,A.$yi)(E),E.code??c.FileSystemProviderErrorCode.Unknown)}m.error(l),m.end()}$.dispose()}})),$.add(b.onCancellationRequested(()=>{m.error((0,s.$5)()),m.end(),$.dispose()})),m}writeFile(d,v,b){return this.a.call("writeFile",[d,P.$ae.wrap(v),b])}open(d,v){return this.a.call("open",[d,v])}close(d){return this.a.call("close",[d])}async read(d,v,b,m,$){const[u,l]=await this.a.call("read",[d,v,$]);return b.set(u.buffer.slice(0,l),m),l}write(d,v,b,m,$){return this.a.call("write",[d,v,P.$ae.wrap(b),m,$])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,v){return this.a.call("delete",[d,v])}rename(d,v,b){return this.a.call("rename",[d,v,b])}copy(d,v,b){return this.a.call("copy",[d,v,b])}cloneFile(d,v){return this.a.call("cloneFile",[d,v])}j(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const v=d;this.f.fire((0,g.$Pp)(v))}else{const v=d;this.g.fire(v)}}))}watch(d,v){const b=(0,f.$dg)();return this.a.call("watch",[this.h,b,d,v]),(0,D.$Pc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$hN=w}),define(te[212],ie([0,1,45,8,22,33,2,84,9,4,19,7,105,21,65]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class b extends D.$Rc{static{this.a=100}static{this.b=75}constructor(u,l,E,h){super(),this.m=u,this.n=l,this.r=E,this.s=h,this.c=this.B(new A.$8g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new A.$7g(i=>this.z(i),b.b)),this.g=(0,v.$Sp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,v.$Sp)(this.m.path,this.m.includes):void 0,this.j=new s.$Wd,this.ready=this.t()}async t(){try{const u=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const l=await d.Promises.stat(u);this.B(await this.w(u,l.isDirectory()))}catch(u){u.code!=="ENOENT"?this.D(u):this.G(u)}}async u(u){let l=u.path;try{l=await d.Promises.realpath(u.path),u.path===l&&(l=await(0,y.$3p)(u.path)??u.path),u.path!==l&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${l})`)}catch{}return l}async w(u,l){if(c.$k&&(0,M.$Wf)(u,"/Volumes/",!0))return this.D(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Rc.None;const E=new s.$Wd(this.j.token),h=new D.$Qc;try{const i=w.URI.file(this.m.path),a=(0,f.$mc)(u),o=(0,P.watch)(u);h.add((0,D.$Pc)(()=>{o.removeAllListeners(),o.close()})),this.G(`Started watching: '${u}'`);const t=new Set;if(l)try{for(const r of await d.Promises.readdir(u))t.add(r)}catch(r){this.D(r)}const n=new Map;h.add((0,D.$Pc)(()=>{for(const[,r]of n)r.dispose();n.clear()})),o.on("error",(r,p)=>{this.D(`Failed to watch ${u} for changes using fs.watch() (${r}, ${p})`),this.dispose()}),o.on("change",(r,p)=>{if(E.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${p}`);let C="";if(p&&(C=p.toString(),c.$k&&(C=(0,S.$ll)(C))),!(!C||r!=="change"&&r!=="rename"))if(l)if(r==="rename"){n.get(C)?.dispose();const R=setTimeout(async()=>{if(n.delete(C),C===a&&!await d.Promises.exists(u)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,f.$ic)(u,C));if(E.token.isCancellationRequested)return;let I;k?t.has(C)?I=0:(I=1,t.add(C)):(t.delete(C),I=2),this.y({resource:(0,g.$ug)(i,C),type:I,cId:this.m.correlationId})},b.a);n.set(C,(0,D.$Pc)(()=>clearTimeout(R)))}else{let R;t.has(C)?R=0:(R=1,t.add(C)),this.y({resource:(0,g.$ug)(i,C),type:R,cId:this.m.correlationId})}else if(r==="rename"||C!==a){const R=setTimeout(async()=>{const k=await d.Promises.exists(u);E.token.isCancellationRequested||(k?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),h.add(await this.w(u,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},b.a);h.clear(),h.add((0,D.$Pc)(()=>clearTimeout(R)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await d.Promises.exists(u)&&!E.token.isCancellationRequested&&this.D(`Failed to watch ${u} for changes using fs.watch() (${i.toString()})`)}return(0,D.$Pc)(()=>{E.dispose(!0),h.dispose()})}y(u,l=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!l&&this.g.some(E=>E(u.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${u.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(E=>E(u.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}z(u){const l=(0,v.$Qp)(u);if(l.length>0){if(this.s)for(const h of l)this.G(` >> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(u){if(c.$l)return d.Promises.exists(u);try{const l=(0,f.$mc)(u);return(await d.Promises.readdir((0,f.$lc)(u))).some(h=>h===l)}catch(l){return this.G(l),!1}}setVerboseLogging(u){this.s=u}D(u){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}F(u){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}G(u){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$6p=b;async function m($,u,l,E,h=512){const i=await d.Promises.open($,"r"),a=Buffer.allocUnsafe(h),o=new s.$Wd(E);let t,n=!1;const r={path:$,excludes:[],recursive:!1},p=new b(r,C=>{(async()=>{for(const{type:R}of C)if(R===0){if(n)return;n=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:k}=await d.Promises.read(i,a,0,h,null);if(!k||o.token.isCancellationRequested)break;u(a.slice(0,k))}}catch(k){t=new Error(k),o.dispose(!0)}finally{n=!1}}})()});return await p.ready,l(),new Promise((C,R)=>{o.token.onCancellationRequested(async()=>{p.dispose();try{await d.Promises.close(i)}catch(k){t=new Error(k)}t?R(t):C()})})}e.$7p=m}),define(te[213],ie([0,1,3,104,2,4,212]),function(Z,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class S extends s.$Rc{constructor(){super(...arguments),this.a=this.B(new P.$Md),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$Md),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(c){const g=this.j(c),w=g.filter(d=>{const v=this.c.get(d.path);return v?!(0,A.$yj)(v.request.excludes,d.excludes)||!(0,A.$yj)(v.request.includes,d.includes):!0}),y=Array.from(this.c.values()).filter(({request:d})=>!g.find(v=>v.path===d.path&&(0,A.$yj)(v.excludes,d.excludes)&&(0,A.$yj)(v.includes,d.includes))).map(({request:d})=>d.path);w.length&&this.m(`Request to start watching: ${w.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`).join(",")}`),y.length&&this.m(`Request to stop watching: ${y.join(",")}`);for(const d of y)this.h(d);for(const d of w)this.g(d)}g(c){const g=new D.$6p(c,y=>this.a.fire(y),y=>this.b.fire(y),this.f),w={request:c,instance:g};this.c.set(c.path,w)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const g=this.c.get(c);g&&(this.c.delete(c),g.instance.dispose())}j(c){const g=new Map;for(const w of c){const y=M.$l?w.path:w.path.toLowerCase();let d=g.get(w.correlationId);d||(d=new Map,g.set(w.correlationId,d)),d.set(y,w)}return Array.from(g.values()).map(w=>Array.from(w.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,g]of this.c)g.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,g){return g?`[File Watcher (node.js)] ${c} (path: ${g.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$8p=S}),define(te[214],ie([0,1,65,213]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class s extends P.$Np{constructor(D,S,f){super(D,S,f),this.s()}r(D){return D.add(new A.$8p)}}e.$9p=s}),define(te[215],ie([0,1,13,42,158,65]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class D extends M.$Op{constructor(f,c,g){super(f,c,g),this.s()}r(f){const c=f.add(new s.$Zp(P.$bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(c.onDidProcessExit(({code:g,signal:w})=>this.t(`terminated by itself with code ${g}, signal: ${w}`))),A.ProxyChannel.toService((0,A.$uh)(c.getChannel("watcher")))}}e.$1p=D}),define(te[91],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class P{constructor(...s){this.a=new Map;for(const[M,D]of s)this.set(M,D)}set(s,M){const D=this.a.get(s);return this.a.set(s,M),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Lh=P}),define(te[216],ie([0,1,8,14,2,77,206,6,91,101]),function(Z,e,P,A,s,M,D,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;const g=!1;class w extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class y{constructor(m=new f.$Lh,$=!1,u,l=g){this.f=m,this.g=$,this.h=u,this.i=l,this.o=new Set,this.f.set(S.$Mh,this),this._globalGraph=l?u?._globalGraph??new D.$_p(E=>E):void 0}createChild(m){return new y(m,this.g,this,this.i)}invokeFunction(m,...$){const u=v.traceInvocation(this.i,m);let l=!1;try{return m({get:h=>{if(l)throw(0,A.$7)("service accessor is only valid during the invocation of its target method");const i=this.m(h,u);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...$)}finally{l=!0,u.stop()}}createInstance(m,...$){let u,l;return m instanceof M.$Kh?(u=v.traceCreation(this.i,m.ctor),l=this.j(m.ctor,m.staticArguments.concat($),u)):(u=v.traceCreation(this.i,m),l=this.j(m,$,u)),u.stop(),l}j(m,$=[],u){const l=S._util.getServiceDependencies(m).sort((i,a)=>i.index-a.index),E=[];for(const i of l){const a=this.m(i.id,u);a||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(a)}const h=l.length>0?l[0].index:$.length;if($.length!==h){console.trace(`[createInstance] First service dependency of ${m.name} at position ${h+1} conflicts with ${$.length} static arguments`);const i=h-$.length;i>0?$=$.concat(new Array(i)):$=$.slice(0,h)}return Reflect.construct(m,$.concat(E))}k(m,$){if(this.f.get(m)instanceof M.$Kh)this.f.set(m,$);else if(this.h)this.h.k(m,$);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const $=this.f.get(m);return!$&&this.h?this.h.l(m):$}m(m,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const u=this.l(m);return u instanceof M.$Kh?this.q(m,u,$.branch(m,!0)):($.branch(m,!1),u)}q(m,$,u){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,$,u)}finally{this.o.delete(m)}}r(m,$,u){const l=new D.$_p(i=>i.id.toString());let E=0;const h=[{id:m,desc:$,_trace:u}];for(;h.length;){const i=h.pop();if(l.lookupOrInsertNode(i),E++>1e3)throw new w(l);for(const a of S._util.getServiceDependencies(i.desc.ctor)){const o=this.l(a.id);if(o||this.u(`[createInstance] ${m} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(a.id)),o instanceof M.$Kh){const t={id:a.id,desc:o,_trace:i._trace.branch(a.id,!0)};l.insertEdge(i,t),h.push(t)}}}for(;;){const i=l.roots();if(i.length===0){if(!l.isEmpty())throw new w(l);break}for(const{data:a}of i){if(this.l(a.id)instanceof M.$Kh){const t=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,t)}l.removeNode(a)}}return this.l(m)}s(m,$,u=[],l,E){if(this.f.get(m)instanceof M.$Kh)return this.t(m,$,u,l,E);if(this.h)return this.h.s(m,$,u,l,E);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}t(m,$,u=[],l,E){if(l){const h=new y(void 0,this.g,this,this.i);h.c=String(m);const i=new Map,a=new P.$0g(()=>{const o=h.j($,u,E);for(const[t,n]of i){const r=o[t];if(typeof r=="function")for(const p of n)r.apply(o,p)}return i.clear(),o});return new Proxy(Object.create(null),{get(o,t){if(!a.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let p=i.get(t);return p||(p=new c.$1c,i.set(t,p)),(R,k,I)=>{const L=p.push([R,k,I]);return(0,s.$Pc)(L)}}if(t in o)return o[t];const n=a.value;let r=n[t];return typeof r!="function"||(r=r.bind(n),o[t]=r),r},set(o,t,n){return a.value[t]=n,!0},getPrototypeOf(o){return $.prototype}})}else return this.j($,u,E)}u(m,$){if($&&console.warn(m),this.g)throw new Error(m)}}e.$aq=y;var d;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(d||(d={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,$){return m?new v(2,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(m,$){return m?new v(1,$.name):v.c}static{this.f=0}constructor(m,$){this.type=m,this.name=$,this.g=Date.now(),this.h=[]}branch(m,$){const u=new v(3,m.toString());return this.h.push([m,$,u]),u}stop(){const m=Date.now()-this.g;v.f+=m;let $=!1;function u(E,h){const i=[],a=new Array(E+1).join("	");for(const[o,t,n]of h.h)if(t&&n){$=!0,i.push(`${a}CREATES -> ${o}`);const r=u(E+1,n);r&&i.push(r)}else i.push(`${a}uses -> ${o}`);return i.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(m>2||$)&&v.all.add(l.join(`
`))}}e.$bq=v}),define(te[217],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vwb=e.IssueType=void 0;var A;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(A||(e.IssueType=A={})),e.$Vwb=(0,P.$Nh)("issueService")}),define(te[5],ie([0,1,49,3,55,2,31,4,19,12,7,114,6]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,y.$Nh)("logService"),e.$9i=(0,y.$Nh)("loggerService");function d(){return new Date().toISOString()}function v(R){return(0,c.$Bf)(R)}e.$0i=v;var b;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$$i=b.Info;function m(R,k,I){switch(k){case b.Trace:R.trace(I);break;case b.Debug:R.debug(I);break;case b.Info:R.info(I);break;case b.Warning:R.warn(I);break;case b.Error:R.error(I);break;case b.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=m;function $(R,k=!1){let I="";for(let L=0;L<R.length;L++){let N=R[L];if(N instanceof Error&&(N=(0,P.$yi)(N,k)),typeof N=="object")try{N=JSON.stringify(N)}catch{}I+=(L>0?" ":"")+N}return I}class u extends M.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new A.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==b.Off&&this.b<=k}}e.$aj=u;class l extends u{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...I){this.f(b.Trace)&&this.g(b.Trace,$([k,...I],!0))}debug(k,...I){this.f(b.Debug)&&this.g(b.Debug,$([k,...I]))}info(k,...I){this.f(b.Info)&&this.g(b.Info,$([k,...I]))}warn(k,...I){this.f(b.Warning)&&this.g(b.Warning,$([k,...I]))}error(k,...I){if(this.f(b.Error))if(k instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=k.stack,this.g(b.Error,$(L))}else this.g(b.Error,$([k,...I]))}flush(){}}e.$bj=l;class E extends u{constructor(k=e.$$i){super(),this.setLevel(k),this.g=!S.$j}trace(k,...I){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...I):console.log(`[main ${d()}]`,k,...I))}debug(k,...I){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...I):console.log(`[main ${d()}]`,k,...I))}info(k,...I){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...I):console.log(`[main ${d()}]`,k,...I))}warn(k,...I){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,k,...I):console.warn(`[main ${d()}]`,k,...I))}error(k,...I){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,k,...I):console.error(`[main ${d()}]`,k,...I))}dispose(){}flush(){}}e.$cj=E;class h extends u{constructor(k=e.$$i,I=!0){super(),this.g=I,this.setLevel(k)}trace(k,...I){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...I):console.log(k,...I))}debug(k,...I){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...I):console.log(k,...I))}info(k,...I){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...I):console.log(k,...I))}warn(k,...I){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...I):console.log(k,...I))}error(k,...I){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...I):console.error(k,...I))}dispose(){}flush(){}}e.$dj=h;class i extends u{constructor(k,I=e.$$i){super(),this.g=k,this.setLevel(I)}trace(k,...I){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(k),...I])}debug(k,...I){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(k),...I])}info(k,...I){this.f(b.Info)&&this.g.log(b.Info,[this.h(k),...I])}warn(k,...I){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(k),...I])}error(k,...I){this.f(b.Error)&&this.g.log(b.Error,[this.h(k),...I])}h(k){return typeof k=="string"?k:(0,P.$yi)(k,this.f(b.Trace))}dispose(){}flush(){}}e.$ej=i;class a extends u{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const I of this.g)I.setLevel(k);super.setLevel(k)}trace(k,...I){for(const L of this.g)L.trace(k,...I)}debug(k,...I){for(const L of this.g)L.debug(k,...I)}info(k,...I){for(const L of this.g)L.info(k,...I)}warn(k,...I){for(const L of this.g)L.warn(k,...I)}error(k,...I){for(const L of this.g)L.error(k,...I)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$fj=a;class o extends M.$Rc{constructor(k,I,L){if(super(),this.h=k,this.j=I,this.b=new D.$zc,this.c=this.B(new A.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$Md),this.onDidChangeVisibility=this.g.event,L)for(const N of L)this.b.set(N.resource,{logger:void 0,info:N})}m(k){return(0,c.$xf)(k)?[...this.b.values()].find(I=>I.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,I){const L=this.n(k),N=(0,c.$xf)(k)?k:I?.id??(0,s.$Bi)(L.toString()).toString(16);let z=this.b.get(L)?.logger;const ne=I?.logLevel==="always"?b.Trace:I?.logLevel;z||(z=this.s(L,ne??this.getLogLevel(L)??this.h,{...I,id:N}));const _={logger:z,info:{resource:L,id:N,logLevel:ne,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(_.info),this.b.set(L,_),z}n(k){return(0,c.$xf)(k)?(0,f.$ug)(this.j,`${k}.log`):k}setLogLevel(k,I){if(g.URI.isUri(k)){const L=k,N=I,z=this.b.get(L);z&&N!==z.info.logLevel&&(z.info.logLevel=N===this.h?void 0:N,z.logger?.setLevel(N),this.b.set(z.info.resource,z),this.f.fire([L,N]))}else{this.h=k;for(const[L,N]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,I){const L=this.m(k);L&&I!==!L.info.hidden&&(L.info.hidden=!I,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,I]))}getLogLevel(k){let I;return k&&(I=this.b.get(k)?.info.logLevel),I??this.h}registerLogger(k){const I=this.b.get(k.resource);I?I.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const I=this.b.get(k);I&&(I.logger&&I.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=o;class t{constructor(){this.onDidChangeLogLevel=new A.$Md().event}setLevel(k){}getLevel(){return b.Info}trace(k,...I){}debug(k,...I){}info(k,...I){}warn(k,...I){}error(k,...I){}critical(k,...I){}dispose(){}flush(){}}e.$hj=t;class n extends t{}e.$ij=n;function r(R){if(R.verbose)return b.Trace;if(typeof R.logLevel=="string"){const k=C(R.logLevel.toLowerCase());if(k!==void 0)return k}return e.$$i}e.$jj=r;function p(R){switch(R){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.$kj=p;function C(R){switch(R){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$lj=C,e.$mj=new w.$5i("logLevel",p(b.Info))});var ee=this&&this.__param||function(Z,e){return function(P,A){e(P,A,Z)}};define(te[218],ie([0,1,15,4,5]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D6b=void 0;const M=P.safeStorage;let D=class{constructor(f){this.a=f,P.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(M.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(f){let c;try{if(c=JSON.parse(f),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const g=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const w=M.decryptString(g);return this.a.trace("[EncryptionMainService] Decrypted value."),w}catch(g){throw this.a.error(g),g}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(A.$j)return Promise.resolve("dpapi");if(A.$k)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const f=M.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(A.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(A.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$D6b=D,e.$D6b=D=ke([ee(0,s.$8i)],D)}),define(te[219],ie([0,1,23,8,14,3,2,9,65,5]),function(Z,e,P,A,s,M,D,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class g extends D.$Rc{constructor(y,d){super(),this.a=y,this.b=d,this.c=this.B(new M.$Md),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Md),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$Qg(0)),this.w=[],this.y=this.B(new A.$Qg(0))}watch(y,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(y,d):this.z(y,d)}n(y,d){const v={path:this.H(y),excludes:d.excludes,includes:d.includes,recursive:d.recursive,correlationId:d.correlationId},b=(0,P.$Tb)(this.j,v);return this.r(),(0,D.$Pc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,s.$Z)(y))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,f.$Pp)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const d of this.j)(0,f.$Lp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const d of this.j)(0,f.$Lp)(d)&&y.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,d){const v={path:this.H(y),excludes:d.excludes,includes:d.includes,recursive:!1,correlationId:d.correlationId},b=(0,P.$Tb)(this.w,v);return this.C(),(0,D.$Pc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,s.$Z)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,f.$Pp)(y)),y=>this.G(y),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}H(y){return(0,S.$gc)(y.fsPath)}}e.$Tp=g}),define(te[220],ie([0,1,23,8,18,22,3,55,70,2,56,13,66,19,62,173,16,118,5,14]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u,l){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;let h=class extends c.$Rc{static{E=this}constructor(a){super(),this.b=a,this.a=256*1024,this.c=this.B(new D.$Md),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Md),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Md),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Md),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Md),this.Y=this.B(new D.$Md),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Md),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$2g)}registerProvider(a,o){if(this.h.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${a}`);const t=new c.$Qc;return this.h.set(a,o),this.c.fire({added:!0,scheme:a,provider:o}),t.add(o.onDidChangeFile(n=>{const r=new m.$pk(n,!this.S(o));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof o.onDidWatchError=="function"&&t.add(o.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:a}))),(0,c.$Pc)(()=>{this.c.fire({added:!1,scheme:a,provider:o}),this.h.delete(a),(0,c.$Mc)(t)})}getProvider(a){return this.h.get(a)}async activateProvider(a){const o=[];this.f.fire({scheme:a,join(t){o.push(t)}}),!this.h.has(a)&&await A.Promises.settled(o)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.h.has(a.scheme)}hasCapability(a,o){const t=this.h.get(a.scheme);return!!(t&&t.capabilities&o)}listCapabilities(){return f.Iterable.map(this.h,([a,o])=>({scheme:a,capabilities:o.capabilities}))}async j(a){if(!(0,d.$yg)(a))throw new m.$rk((0,b.localize)(0,null,this.sb(a)),8);await this.activateProvider(a.scheme);const o=this.h.get(a.scheme);if(!o){const t=new l.$ab;throw t.message=(0,b.localize)(1,null,a.toString()),t}return o}async m(a){const o=await this.j(a);if((0,m.$ck)(o)||(0,m.$_j)(o)||(0,m.$dk)(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(a){const o=await this.j(a);if((0,m.$ck)(o)||(0,m.$_j)(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,o){try{return await this.s(a,o)}catch(t){throw(0,m.$mk)(t)===m.FileSystemProviderErrorCode.FileNotFound?new m.$rk((0,b.localize)(2,null,this.sb(a)),1):(0,m.$kk)(t)}}async s(a,o){const t=await this.j(a),n=this.S(t),r=o?.resolveTo,p=o?.resolveSingleChildDescendants,C=o?.resolveMetadata,R=await t.stat(a);let k;return this.t(t,a,R,void 0,!!C,(I,L)=>(k||(k=g.$Th.forUris(()=>!n),k.set(a,!0),r&&k.fill(!0,r)),k.get(I.resource)||k.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&p?L===1:!1))}async t(a,o,t,n,r,p){const{providerExtUri:C}=this.R(a),R={resource:o,name:C.basename(o),isFile:(t.type&m.FileType.File)!==0,isDirectory:(t.type&m.FileType.Directory)!==0,isSymbolicLink:(t.type&m.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&m.FilePermission.Readonly)||!!(a.capabilities&2048),locked:!!((t.permissions??0)&m.FilePermission.Locked),etag:(0,m.$Ck)({mtime:t.mtime,size:t.size}),children:void 0};if(R.isDirectory&&p(R,n)){try{const k=await a.readdir(o),I=await A.Promises.settled(k.map(async([L,N])=>{try{const z=C.joinPath(o,L),ne=r?await a.stat(z):{type:N};return await this.t(a,z,ne,k.length,r,p)}catch(z){return this.b.trace(z),null}}));R.children=(0,P.$Gb)(I)}catch(k){this.b.trace(k),R.children=[]}return R}return R}async resolveAll(a){return A.Promises.settled(a.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(a){const o=await this.j(a),t=await o.stat(a);return this.t(o,a,t,void 0,!0,()=>!1)}async exists(a){const o=await this.j(a);try{return!!await o.stat(a)}catch{return!1}}async canCreateFile(a,o){try{await this.u(a,o)}catch(t){return t}return!0}async u(a,o){if(!o?.overwrite&&await this.exists(a))throw new m.$rk((0,b.localize)(3,null,this.sb(a)),3,o)}async createFile(a,o=s.$ae.fromString(""),t){await this.u(a,t);const n=await this.writeFile(a,o);return this.r.fire(new m.$ok(a,0,n)),n}async writeFile(a,o,t){const n=this.qb(await this.n(a),a),{providerExtUri:r}=this.R(n);let p=t;if((0,m.$fk)(n)&&!p?.atomic){const C=n.enforceAtomicWriteFile?.(a);C&&(p={...t,atomic:C})}try{await this.w(n,a,p)||await this.U(n,r.dirname(a));let R;if((0,m.$_j)(n)&&!(o instanceof s.$ae))if((0,v.$Yd)(o)){const k=await(0,v.$6d)(o,3);k.ended?R=s.$ae.concat(k.buffer):R=k}else R=(0,v.$3d)(o,k=>s.$ae.concat(k),3);else R=o;!(0,m.$ck)(n)||(0,m.$_j)(n)&&R instanceof s.$ae||(0,m.$_j)(n)&&(0,m.$fk)(n)&&p?.atomic?await this.hb(n,a,p,R):await this.db(n,a,p,R instanceof s.$ae?(0,s.$le)(R):R),this.r.fire(new m.$ok(a,4))}catch(C){throw new m.$rk((0,b.localize)(4,null,this.sb(a),(0,m.$kk)(C).toString()),(0,m.$nk)(C),p)}return this.resolve(a,{resolveMetadata:!0})}async w(a,o,t){const n=!!t?.unlock;if(n&&!(a.capabilities&8192))throw new Error((0,b.localize)(5,null,this.sb(o)));if(!!t?.atomic){if(!(a.capabilities&32768))throw new Error((0,b.localize)(6,null,this.sb(o)));if(!(a.capabilities&2))throw new Error((0,b.localize)(7,null,this.sb(o)));if(n)throw new Error((0,b.localize)(8,null,this.sb(o)))}let p;try{p=await a.stat(o)}catch{return}if(p.type&m.FileType.Directory)throw new m.$rk((0,b.localize)(9,null,this.sb(o)),0,t);if(this.rb(o,p),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==m.$Bk&&typeof p.mtime=="number"&&typeof p.size=="number"&&t.mtime<p.mtime&&t.etag!==(0,m.$Ck)({mtime:t.mtime,size:p.size}))throw new m.$rk((0,b.localize)(10,null),3,t);return p}async readFile(a,o,t){const n=await this.m(a);return o?.atomic?this.z(n,a,o,t):this.C(n,a,o,t)}async z(a,o,t,n){return new Promise((r,p)=>{this.cb.queueFor(o,this.R(a).providerExtUri).queue(async()=>{try{const C=await this.C(a,o,t,n);r(C)}catch(C){p(C)}})})}async C(a,o,t,n){const r=await this.D(a,o,{...t,preferUnbuffered:!0},n);return{...r,value:await(0,s.$me)(r.value)}}async readFileStream(a,o,t){const n=await this.m(a);return this.D(n,a,o,t)}async D(a,o,t,n){const r=new M.$Wd(n);let p=t;(0,m.$ek)(a)&&a.enforceAtomicReadFile?.(o)&&(p={...t,atomic:!0});const C=this.J(o,p).then(k=>k,k=>{throw r.dispose(!0),k});let R;try{return typeof p?.etag=="string"&&p.etag!==m.$Bk&&await C,p?.atomic&&(0,m.$ek)(a)||!((0,m.$ck)(a)||(0,m.$dk)(a))||(0,m.$_j)(a)&&p?.preferUnbuffered?R=this.I(a,o,p):(0,m.$dk)(a)?R=this.G(a,o,r.token,p):R=this.H(a,o,r.token,p),R.on("end",()=>r.dispose()),R.on("error",()=>r.dispose()),{...await C,value:R}}catch(k){throw R&&await(0,v.$4d)(R),this.F(k,o,p)}}F(a,o,t){const n=(0,b.localize)(11,null,this.sb(o),(0,m.$kk)(a).toString());return a instanceof m.$tk?new m.$tk(n,a.stat,t):a instanceof m.$sk?new m.$sk(n,a.fileOperationResult,a.size,a.options):new m.$rk(n,(0,m.$nk)(a),t)}G(a,o,t,n=Object.create(null)){const r=a.readFileStream(o,n,t);return(0,v.$0d)(r,{data:p=>p instanceof s.$ae?p:s.$ae.wrap(p),error:p=>this.F(p,o,n)},p=>s.$ae.concat(p))}H(a,o,t,n=Object.create(null)){const r=(0,s.$qe)();return(0,$.$Jp)(a,o,r,p=>p,{...n,bufferSize:this.a,errorTransformer:p=>this.F(p,o,n)},t),r}I(a,o,t){const n=(0,v.$1d)(r=>s.$ae.concat(r));return(async()=>{try{let r;t?.atomic&&(0,m.$ek)(a)?r=await a.readFile(o,{atomic:!0}):r=await a.readFile(o),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.L(o,r.byteLength,t),n.end(s.$ae.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(a,o){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new m.$rk((0,b.localize)(12,null,this.sb(a)),0,o);if(typeof o?.etag=="string"&&o.etag!==m.$Bk&&o.etag===t.etag)throw new m.$tk((0,b.localize)(13,null),t,o);return this.L(a,t.size,o),t}L(a,o,t){if(typeof t?.limits?.size=="number"&&o>t.limits.size)throw new m.$sk((0,b.localize)(14,null,this.sb(a)),7,o,t)}async canMove(a,o,t){return this.M(a,o,"move",t)}async canCopy(a,o,t){return this.M(a,o,"copy",t)}async M(a,o,t,n){if(a.toString()!==o.toString())try{const r=t==="move"?this.qb(await this.n(a),a):await this.m(a),p=this.qb(await this.n(o),o);await this.Q(r,a,p,o,t,n)}catch(r){return r}return!0}async move(a,o,t){const n=this.qb(await this.n(a),a),r=this.qb(await this.n(o),o),p=await this.N(n,a,r,o,"move",!!t),C=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new m.$ok(a,p==="move"?2:3,C)),C}async copy(a,o,t){const n=await this.m(a),r=this.qb(await this.n(o),o),p=await this.N(n,a,r,o,"copy",!!t),C=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new m.$ok(a,p==="copy"?3:2,C)),C}async N(a,o,t,n,r,p){if(o.toString()===n.toString())return r;const{exists:C,isSameResourceWithDifferentPathCase:R}=await this.Q(a,o,t,n,r,p);if(C&&!R&&p&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),r==="copy"){if(a===t&&(0,m.$ak)(a))await a.copy(o,n,{overwrite:p});else{const k=await this.resolve(o);k.isDirectory?await this.P(a,k,t,n):await this.O(a,o,t,n)}return r}else return a===t?(await a.rename(o,n,{overwrite:p}),r):(await this.N(a,o,t,n,"copy",p),await this.del(o,{recursive:!0}),"copy")}async O(a,o,t,n){if((0,m.$ck)(a)&&(0,m.$ck)(t))return this.jb(a,o,t,n);if((0,m.$ck)(a)&&(0,m.$_j)(t))return this.pb(a,o,t,n);if((0,m.$_j)(a)&&(0,m.$ck)(t))return this.nb(a,o,t,n);if((0,m.$_j)(a)&&(0,m.$_j)(t))return this.lb(a,o,t,n)}async P(a,o,t,n){await t.mkdir(n),Array.isArray(o.children)&&await A.Promises.settled(o.children.map(async r=>{const p=this.R(t).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(a,await this.resolve(r.resource),t,p):this.O(a,r.resource,t,p)}))}async Q(a,o,t,n,r,p){let C=!1;if(a===t){const{providerExtUri:k,isPathCaseSensitive:I}=this.R(a);if(I||(C=k.isEqual(o,n)),C&&r==="copy")throw new Error((0,b.localize)(15,null,this.sb(o),this.sb(n)));if(!C&&k.isEqualOrParent(n,o))throw new Error((0,b.localize)(16,null,this.sb(o),this.sb(n)))}const R=await this.exists(n);if(R&&!C){if(!p)throw new m.$rk((0,b.localize)(17,null,this.sb(o),this.sb(n)),4);if(a===t){const{providerExtUri:k}=this.R(a);if(k.isEqualOrParent(o,n))throw new Error((0,b.localize)(18,null,this.sb(o),this.sb(n)))}}return{exists:R,isSameResourceWithDifferentPathCase:C}}R(a){const o=this.S(a);return{providerExtUri:o?d.$kg:d.$mg,isPathCaseSensitive:o}}S(a){return!!(a.capabilities&1024)}async createFolder(a){const o=this.qb(await this.j(a),a);await this.U(o,a);const t=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new m.$ok(a,0,t)),t}async U(a,o){const t=[],{providerExtUri:n}=this.R(a);for(;!n.isEqual(o,n.dirname(o));)try{if(!((await a.stat(o)).type&m.FileType.Directory))throw new Error((0,b.localize)(19,null,this.sb(o)));break}catch(r){if((0,m.$mk)(r)!==m.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(n.basename(o)),o=n.dirname(o)}for(let r=t.length-1;r>=0;r--){o=n.joinPath(o,t[r]);try{await a.mkdir(o)}catch(p){if((0,m.$mk)(p)!==m.FileSystemProviderErrorCode.FileExists)throw p}}}async canDelete(a,o){try{await this.W(a,o)}catch(t){return t}return!0}async W(a,o){const t=this.qb(await this.j(a),a),n=!!o?.useTrash;if(n&&!(t.capabilities&4096))throw new Error((0,b.localize)(20,null,this.sb(a)));const r=o?.atomic;if(r&&!(t.capabilities&65536))throw new Error((0,b.localize)(21,null,this.sb(a)));if(n&&r)throw new Error((0,b.localize)(22,null,this.sb(a)));let p;try{p=await t.stat(a)}catch{}if(p)this.rb(a,p);else throw new m.$rk((0,b.localize)(23,null,this.sb(a)),1);if(!!!o?.recursive){const R=await this.resolve(a);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,b.localize)(24,null,this.sb(a)))}return t}async del(a,o){const t=await this.W(a,o);let n=o;if((0,m.$gk)(t)&&!n?.atomic){const R=t.enforceAtomicDelete?.(a);R&&(n={...o,atomic:R})}const r=!!n?.useTrash,p=!!n?.recursive,C=n?.atomic??!1;await t.delete(a,{recursive:p,useTrash:r,atomic:C}),this.r.fire(new m.$ok(a,1))}async cloneFile(a,o){const t=await this.j(a),n=this.qb(await this.n(o),o);if(t===n&&this.R(t).providerExtUri.isEqual(a,o))return;if(t===n&&(0,m.$bk)(t))return t.cloneFile(a,o);await this.U(n,this.R(n).providerExtUri.dirname(o));const r=this.cb.queueFor(a,this.R(t).providerExtUri);return t===n&&(0,m.$ak)(t)?r.queue(()=>t.copy(a,o,{overwrite:!0})):r.queue(()=>this.O(t,a,n,o))}static{this.ab=0}createWatcher(a,o){return this.watch(a,{...o,correlationId:E.ab++})}watch(a,o={recursive:!1,excludes:[]}){const t=new c.$Qc;let n=!1,r=()=>{n=!0};t.add((0,c.$Pc)(()=>r())),(async()=>{try{const C=await this.bb(a,o);n?(0,c.$Mc)(C):r=()=>(0,c.$Mc)(C)}catch(C){this.b.error(C)}})();const p=o.correlationId;if(typeof p=="number"){const C=t.add(new D.$Md);return t.add(this.X.event(k=>{k.correlates(p)&&C.fire(k)})),{onDidChange:C.event,dispose:()=>t.dispose()}}return t}async bb(a,o){const t=await this.j(a),n=(0,S.$Bi)([this.R(t).providerExtUri.getComparisonKey(a),o]);let r=this.$.get(n);return r||(r={count:0,disposable:t.watch(a,o)},this.$.set(n,r)),r.count+=1,(0,c.$Pc)(()=>{r&&(r.count--,r.count===0&&((0,c.$Mc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,a]of this.$)(0,c.$Mc)(a.disposable);this.$.clear()}async db(a,o,t,n){return this.cb.queueFor(o,this.R(a).providerExtUri).queue(async()=>{const r=await a.open(o,{create:!0,unlock:t?.unlock??!1});try{(0,v.$Yd)(n)||(0,v.$Zd)(n)?await this.eb(a,r,n):await this.fb(a,r,n)}catch(p){throw(0,m.$kk)(p)}finally{await a.close(r)}})}async eb(a,o,t){let n=0,r;if((0,v.$Zd)(t)){if(t.buffer.length>0){const p=s.$ae.concat(t.buffer);await this.gb(a,o,p,p.byteLength,n,0),n+=p.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((p,C)=>{(0,v.$5d)(r,{onData:async R=>{r.pause();try{await this.gb(a,o,R,R.byteLength,n,0)}catch(k){return C(k)}n+=R.byteLength,setTimeout(()=>r.resume())},onError:R=>C(R),onEnd:()=>p()})})}async fb(a,o,t){let n=0,r;for(;(r=t.read())!==null;)await this.gb(a,o,r,r.byteLength,n,0),n+=r.byteLength}async gb(a,o,t,n,r,p){let C=0;for(;C<n;){const R=await a.write(o,r+C,t.buffer,p+C,n-C);C+=R}}async hb(a,o,t,n){return this.cb.queueFor(o,this.R(a).providerExtUri).queue(()=>this.ib(a,o,t,n))}async ib(a,o,t,n){let r;n instanceof s.$ae?r=n:(0,v.$Yd)(n)?r=await(0,s.$me)(n):(0,v.$Zd)(n)?r=await(0,s.$ne)(n):r=(0,s.$ke)(n),await a.writeFile(o,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(a,o,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.kb(a,o,t,n))}async kb(a,o,t,n){let r,p;try{r=await a.open(o,{create:!1}),p=await t.open(n,{create:!0,unlock:!1});const C=s.$ae.alloc(this.a);let R=0,k=0,I=0;do I=await a.read(r,R,C.buffer,k,C.byteLength-k),await this.gb(t,p,C,I,R,k),R+=I,k+=I,k===C.byteLength&&(k=0);while(I>0)}catch(C){throw(0,m.$kk)(C)}finally{await A.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof p=="number"?t.close(p):Promise.resolve()])}}async lb(a,o,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.mb(a,o,t,n))}async mb(a,o,t,n){return t.writeFile(n,await a.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(a,o,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.ob(a,o,t,n))}async ob(a,o,t,n){const r=await t.open(n,{create:!0,unlock:!1});try{const p=await a.readFile(o);await this.gb(t,r,s.$ae.wrap(p),p.byteLength,0,0)}catch(p){throw(0,m.$kk)(p)}finally{await t.close(r)}}async pb(a,o,t,n){const r=await(0,s.$me)(this.H(a,o,M.CancellationToken.None));await this.hb(t,n,void 0,r)}qb(a,o){if(a.capabilities&2048)throw new m.$rk((0,b.localize)(25,null,this.sb(o)),6);return a}rb(a,o){if((o.permissions??0)&m.FilePermission.Readonly)throw new m.$rk((0,b.localize)(26,null,this.sb(a)),6)}sb(a){return a.scheme===w.Schemas.file?a.fsPath:a.toString(!0)}};e.$Kp=h,e.$Kp=h=E=ke([ee(0,u.$8i)],h)}),define(te[92],ie([0,1,45,309,8,31,18,3,33,2,9,4,19,62,21,177,16,118,219,49,215,214]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u,l,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0,(()=>{try{(0,A.gracefulify)(P)}catch(a){console.error(`Error enabling graceful-fs: ${(0,l.$yi)(a)}`)}})();class i extends u.$Tp{static{this.I=!1}constructor(o,t){super(o,t),this.onDidChangeCapabilities=S.Event.None,this.N=new M.$zc(n=>y.$lg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,w.$l&&(this.J|=1024)),this.J}async stat(o){try{const{stat:t,symbolicLink:n}=await v.SymlinkSupport.stat(this.H(o));return{type:this.M(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:m.FilePermission.Locked}}catch(t){throw this.fb(t)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const t=await v.Promises.readdir(this.H(o),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async r=>{try{let p;r.isSymbolicLink()?p=(await this.stat((0,y.$ug)(o,r.name))).type:p=this.M(r),n.push([r.name,p])}catch(p){this.a.trace(p)}})),n}catch(t){throw this.fb(t)}}M(o,t){let n;return t?.dangling?n=m.FileType.Unknown:o.isFile()?n=m.FileType.File:o.isDirectory()?n=m.FileType.Directory:n=m.FileType.Unknown,t&&(n|=m.FileType.SymbolicLink),n}async O(o){const t=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const r=new s.$Rg;return this.N.set(o,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,c.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.N.get(o)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),r.open()})}async readFile(o,t){let n;try{t?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),n=await this.O(o));const r=this.H(o);return await v.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(o){i.I&&this.a.trace(o)}readFileStream(o,t,n){const r=(0,d.$1d)(p=>D.$ae.concat(p.map(C=>D.$ae.wrap(C))).buffer);return(0,$.$Jp)(this,o,r,p=>p.buffer,{...t,bufferSize:256*1024},n),r}async writeFile(o,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,y.$ug)((0,y.$tg)(o),`${(0,y.$rg)(o)}${n.atomic.postfix}`),t,n):this.S(o,t,n)}async Q(o){try{const t=this.H(o),{symbolicLink:n}=await v.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async R(o,t,n,r){const p=new c.$Qc;try{p.add(await this.O(o)),p.add(await this.O(t)),await this.S(t,n,r,!0);try{await this.rename(t,o,{overwrite:!0})}catch(C){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{p.dispose()}}async S(o,t,n,r){let p;try{const C=this.H(o);if(!n.create||!n.overwrite){if(await v.Promises.exists(C)){if(!n.overwrite)throw(0,m.$jk)((0,b.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,m.$jk)((0,b.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(o,{create:!0,unlock:n.unlock},r),await this.write(p,0,t,0,t.byteLength)}catch(C){throw await this.gb(o,C)}finally{typeof p=="number"&&await this.close(p)}}static{this.Y=!0}static configureFlushOnWrite(o){i.Y=o}async open(o,t,n){const r=this.H(o);let p;(0,m.$0j)(t)&&!n&&(p=await this.O(o));let C;try{if((0,m.$0j)(t)&&t.unlock)try{const{stat:k}=await v.SymlinkSupport.stat(r);k.mode&128||await v.Promises.chmod(r,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let R;if((0,m.$0j)(t)){if(w.$j)try{await v.Promises.truncate(r,0),R="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}R||(R="w")}else R="r";C=await v.Promises.open(r,R)}catch(R){throw p?.dispose(),(0,m.$0j)(t)?await this.gb(o,R):this.fb(R)}if(this.U.set(C,0),(0,m.$0j)(t)&&this.X.set(C,o),p){const R=this.W.get(C);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${r})`),this.W.set(C,p),R&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${r})`),R.dispose())}return C}async close(o){const t=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&i.Y)try{await v.Promises.fdatasync(o)}catch(n){i.configureFlushOnWrite(!1),this.a.error(n)}return await v.Promises.close(o)}catch(n){throw this.fb(n)}finally{t&&(this.W.get(o)===t&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),t.dispose())}}async read(o,t,n,r,p){const C=this.Z(o,t);let R=null;try{R=(await v.Promises.read(o,n,r,p,C)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(o,C,R)}return R}Z(o,t){return t===this.U.get(o)?null:t}$(o,t,n){const r=this.U.get(o);typeof r=="number"&&(typeof t=="number"||(typeof n=="number"?this.U.set(o,r+n):this.U.delete(o)))}async write(o,t,n,r,p){return(0,s.$$g)(()=>this.ab(o,t,n,r,p),100,3)}async ab(o,t,n,r,p){const C=this.Z(o,t);let R=null;try{R=(await v.Promises.write(o,n,r,p,C)).bytesWritten}catch(k){throw await this.gb(this.X.get(o),k)}finally{this.$(o,C,R)}return R}async mkdir(o){try{await v.Promises.mkdir(this.H(o))}catch(t){throw this.fb(t)}}async delete(o,t){try{const n=this.H(o);if(t.recursive){let r;t?.atomic!==!1&&t.atomic.postfix&&(r=(0,g.$ic)((0,g.$lc)(n),`${(0,g.$mc)(n)}${t.atomic.postfix}`)),await v.Promises.rm(n,v.RimRafMode.MOVE,r)}else try{await v.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let p=!1;try{const{stat:C,symbolicLink:R}=await v.SymlinkSupport.stat(n);p=C.isDirectory()&&!R}catch{}if(p)await v.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(o,t,n){const r=this.H(o),p=this.H(t);if(r!==p)try{await this.bb(o,t,"move",n.overwrite),await v.Promises.rename(r,p)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,b.localize)(2,null,(0,g.$mc)(r),(0,g.$mc)((0,g.$lc)(p)),C.toString()))),this.fb(C)}}async copy(o,t,n){const r=this.H(o),p=this.H(t);if(r!==p)try{await this.bb(o,t,"copy",n.overwrite),await v.Promises.copy(r,p,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,b.localize)(3,null,(0,g.$mc)(r),(0,g.$mc)((0,g.$lc)(p)),C.toString()))),this.fb(C)}}async bb(o,t,n,r){const p=this.H(o),C=this.H(t);let R=!1;if(!!(this.capabilities&1024)||(R=(0,f.$Vf)(p,C,!0)),R){if(n==="copy")throw(0,m.$jk)((0,b.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const I=await this.L(o);if(!I)throw(0,m.$jk)((0,b.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(t);if(L){if(!r)throw(0,m.$jk)((0,b.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);I.type&m.FileType.File&&L.type&m.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,t){return this.cb(o,t,!1)}async cb(o,t,n){const r=this.H(o),p=this.H(t),C=!!(this.capabilities&1024);if((0,f.$Vf)(r,p,!C))return;const R=new c.$Qc;try{R.add(await this.O(o)),R.add(await this.O(t)),n&&await v.Promises.mkdir((0,g.$lc)(p),{recursive:!0}),await v.Promises.copyFile(r,p)}catch(k){if(k.code==="ENOENT"&&!n)return this.cb(o,t,!0);throw this.fb(k)}finally{R.dispose()}}t(o,t,n){return new E.$1p(r=>o(r),r=>t(r),n)}F(o,t,n){return new h.$9p(r=>o(r),r=>t(r),n)}fb(o){if(o instanceof m.$ik)return o;let t=o,n;switch(o.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=m.FileSystemProviderErrorCode.Unknown;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.$jk)(t,n)}async gb(o,t){let n=this.fb(t);if(o&&n.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await v.SymlinkSupport.stat(this.H(o));r.mode&128||(n=(0,m.$jk)(t,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$0p=i}),define(te[221],ie([0,1,3,92,2,18,62,22]),function(Z,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=e.$Fr=void 0;class f extends s.$Rc{constructor(w,y){super(),this.a=w,this.b=y,this.F=new Map,this.G=new Map}call(w,y,d){const v=this.c(w);switch(y){case"stat":return this.g(v,d[0]);case"readdir":return this.h(v,d[0]);case"open":return this.r(v,d[0],d[1]);case"close":return this.s(d[0]);case"read":return this.t(d[0],d[1],d[2]);case"readFile":return this.j(v,d[0],d[1]);case"write":return this.u(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.n(v,d[0],d[1],d[2]);case"rename":return this.z(v,d[0],d[1],d[2]);case"copy":return this.C(v,d[0],d[1],d[2]);case"cloneFile":return this.D(v,d[0],d[1]);case"mkdir":return this.w(v,d[0]);case"delete":return this.y(v,d[0],d[1]);case"watch":return this.I(v,d[0],d[1],d[2],d[3]);case"unwatch":return this.J(d[0],d[1])}throw new Error(`IPC Command ${y} not found`)}listen(w,y,d){const v=this.c(w);switch(y){case"fileChange":return this.H(v,d[0]);case"readFileStream":return this.m(v,d[0],d[1])}throw new Error(`Unknown event ${y}`)}g(w,y){const d=this.f(w,y,!0);return this.a.stat(d)}h(w,y){const d=this.f(w,y);return this.a.readdir(d)}async j(w,y,d){const v=this.f(w,y,!0),b=await this.a.readFile(v,d);return M.$ae.wrap(b)}m(w,y,d){const v=this.f(w,y,!0),b=new S.$Wd,m=new P.$Md({onDidRemoveLastListener:()=>{b.cancel()}}),$=this.a.readFileStream(v,d,b.token);return(0,D.$5d)($,{onData:u=>m.fire(M.$ae.wrap(u)),onError:u=>m.fire(u),onEnd:()=>{m.fire("end"),m.dispose(),b.dispose()}}),m.event}n(w,y,d,v){const b=this.f(w,y);return this.a.writeFile(b,d.buffer,v)}r(w,y,d){const v=this.f(w,y,!0);return this.a.open(v,d)}s(w){return this.a.close(w)}async t(w,y,d){const v=M.$ae.alloc(d),b=0,m=await this.a.read(w,y,v.buffer,b,d);return[v,m]}u(w,y,d,v,b){return this.a.write(w,y,d.buffer,v,b)}w(w,y){const d=this.f(w,y);return this.a.mkdir(d)}y(w,y,d){const v=this.f(w,y);return this.a.delete(v,d)}z(w,y,d,v){const b=this.f(w,y),m=this.f(w,d);return this.a.rename(b,m,v)}C(w,y,d,v){const b=this.f(w,y),m=this.f(w,d);return this.a.copy(b,m,v)}D(w,y,d){const v=this.f(w,y),b=this.f(w,d);return this.a.cloneFile(v,b)}H(w,y){const d=new P.$Md({onWillAddFirstListener:()=>{this.F.set(y,this.L(w,d))},onDidRemoveLastListener:()=>{(0,s.$Mc)(this.F.get(y)),this.F.delete(y)}});return d.event}async I(w,y,d,v,b){const m=this.F.get(y);if(m){const $=this.f(w,v),u=m.watch(d,$,b);this.G.set(y+d,u)}}async J(w,y){const d=w+y,v=this.G.get(d);v&&((0,s.$Mc)(v),this.G.delete(d))}dispose(){super.dispose();for(const[,w]of this.G)w.dispose();this.G.clear();for(const[,w]of this.F)w.dispose();this.F.clear()}}e.$Fr=f;class c extends s.$Rc{constructor(w,y,d,v){super(),this.c=w,this.f=d,this.g=v,this.a=new Map,this.b=this.B(new A.$0p(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(y)}h(w){const y=this.B(new P.$Md);this.B(y.event(d=>{w.fire(d.map(v=>({resource:this.c.transformOutgoingURI(v.resource),type:v.type,cId:v.cId})))})),this.B(this.b.onDidChangeFile(d=>y.fire(d))),this.B(this.b.onDidWatchError(d=>w.fire(d)))}j(w){}m(w){}watch(w,y,d){const v=this.m(this.g);return Array.isArray(v)&&(d.excludes=[...d.excludes,...v]),this.a.set(w,this.b.watch(y,d)),(0,s.$Pc)(()=>{(0,s.$Mc)(this.a.get(w)),this.a.delete(w)})}dispose(){for(const[,w]of this.a)w.dispose();this.a.clear(),super.dispose()}}e.$Gr=c}),define(te[222],ie([0,1,15,176,4,7,16,9,221,153]),function(Z,e,P,A,s,M,D,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L6b=void 0;class g extends f.$Fr{constructor(d,v,b){super(d,v),this.M=b}c(d){return c.$Jm}f(d,v){return M.URI.revive(v)}async y(d,v,b){if(!b.useTrash)return super.y(d,v,b);const m=this.f(d,v),$=(0,S.$gc)(m.fsPath);try{await P.shell.trashItem($)}catch{throw(0,D.$jk)(s.$j?(0,A.localize)(0,null,(0,S.$mc)($)):(0,A.localize)(1,null,(0,S.$mc)($)),D.FileSystemProviderErrorCode.Unknown)}}L(d,v){return new w(d,v,this.b,this.M)}}e.$L6b=g;class w extends f.$Gr{watch(d,v,b){if(b.recursive)throw(0,D.$jk)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(d,v,b)}}}),define(te[223],ie([0,1,5]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J3b=void 0;class A extends P.$bj{constructor(M=P.$$i){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(D=>{this.n?.setLevel(D)}))}set logger(M){this.n=M;for(const{level:D,message:S}of this.m)(0,P.log)(M,D,S);this.m=[]}g(M,D){this.n?(0,P.log)(this.n,M,D):this.getLevel()<=M&&this.m.push({level:M,message:D})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$J3b=A}),define(te[224],ie([0,1,7,3,5,2]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=void 0;class D extends s.$gj{constructor(w,y,d,v,b){super(y,d,v),this.r=w,this.t=b,this.B(b.listen("onDidChangeLogLevel",w)(m=>{(0,s.$0i)(m)?super.setLogLevel(m):super.setLogLevel(P.URI.revive(m[0]),m[1])})),this.B(b.listen("onDidChangeVisibility",w)(([m,$])=>super.setVisibility(P.URI.revive(m),$))),this.B(b.listen("onDidChangeLoggers",w)(({added:m,removed:$})=>{for(const u of m)super.registerLogger({...u,resource:P.URI.revive(u.resource)});for(const u of $)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new s.$ej({log:(w,y)=>{this.t.call("consoleLog",[w,y])}})}registerLogger(w){super.registerLogger(w),this.t.call("registerLogger",[w,this.r])}deregisterLogger(w){super.deregisterLogger(w),this.t.call("deregisterLogger",[w,this.r])}setLogLevel(w,y){super.setLogLevel(w,y),this.t.call("setLogLevel",[w,y])}setVisibility(w,y){super.setVisibility(w,y),this.t.call("setVisibility",[this.n(w),y])}s(w,y,d){return new S(this.t,w,y,d,this.r)}static setLogLevel(w,y,d){return w.call("setLogLevel",[y,d])}}e.$8q=D;class S extends s.$bj{constructor(w,y,d,v,b){super(v?.logLevel==="always"),this.r=w,this.s=y,this.m=!1,this.n=[],this.setLevel(d),this.r.call("createLogger",[y,v,b]).then(()=>{this.u(this.n),this.m=!0})}g(w,y){const d=[[w,y]];this.m?this.u(d):this.n.push(...d)}u(w){this.r.call("log",[this.s,w])}}class f{constructor(w,y){this.a=w,this.b=y}listen(w,y){const d=this.b(w);switch(y){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,v=>({added:[...v.added].map(b=>this.c(b,d)),removed:[...v.removed].map(b=>this.c(b,d))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,v=>[d.transformOutgoingURI(v[0]),v[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,v=>(0,s.$0i)(v)?v:[d.transformOutgoingURI(v[0]),v[1]])}throw new Error(`Event not found: ${y}`)}async call(w,y,d){const v=this.b(w);switch(y){case"setLogLevel":return(0,s.$0i)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(P.URI.revive(v.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,v)))}throw new Error(`Call not found: ${y}`)}c(w,y){return{...w,resource:y.transformOutgoingURI(w.resource)}}}e.$9q=f;class c extends M.$Rc{constructor(w,y){super(),y.call("setLogLevel",[w.getLogLevel()]),this.B(w.onDidChangeLogLevel(d=>y.call("setLogLevel",[d]))),y.call("getRegisteredLoggers").then(d=>{for(const v of d)w.registerLogger({...v,resource:P.URI.revive(v.resource)})}),this.B(y.listen("onDidChangeVisibility")(([d,v])=>w.setVisibility(P.URI.revive(d),v))),this.B(y.listen("onDidChangeLoggers")(({added:d,removed:v})=>{for(const b of d)w.registerLogger({...b,resource:P.URI.revive(b.resource)});for(const b of v)w.deregisterLogger(b.resource)}))}}e.$0q=c}),define(te[225],ie([0,1,2,5]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=void 0;class s extends P.$Rc{constructor(D,S=[]){super(),this.a=new A.$fj([D,...S]),this.B(D.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...S){this.a.trace(D,...S)}debug(D,...S){this.a.debug(D,...S)}info(D,...S){this.a.info(D,...S)}warn(D,...S){this.a.warn(D,...S)}error(D,...S){this.a.error(D,...S)}flush(){this.a.flush()}}e.$yN=s}),define(te[226],ie([0,1,31,7,5]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H7b=void 0;class M{constructor(S){this.b=S,this.a=new P.$zc}listen(S,f,c){switch(f){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(S,f,c){switch(f){case"createLogger":this.c(A.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(A.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,s.$0i)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(A.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(A.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:A.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(A.URI.revive(c[0]))}throw new Error(`Call not found: ${f}`)}c(S,f,c){this.a.set(S,this.b.createLogger(S,f,c))}d(S,f){let c=console.log;switch(S){case s.LogLevel.Error:c=console.error;break;case s.LogLevel.Warning:c=console.warn;break;case s.LogLevel.Info:c=console.info;break}c.call(console,...f)}e(S,f){const c=this.a.get(S);if(!c)throw new Error("Create the logger before logging");for(const[g,w]of f)(0,s.log)(c,g,w)}}e.$H7b=M}),define(te[227],ie([0,1,16,5]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=void 0;var s;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(s||(s={}));async function M(c,g,w,y,d){try{const v=await new Promise((m,$)=>{Z(["@vscode/spdlog"],m,$)});v.setFlushOn(s.Trace);const b=await v.createAsyncRotatingLogger(c,g,w,y);return d?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(v){console.error(v)}return null}function D(c,g,w){switch(g){case A.LogLevel.Trace:c.trace(w);break;case A.LogLevel.Debug:c.debug(w);break;case A.LogLevel.Info:c.info(w);break;case A.LogLevel.Warning:c.warn(w);break;case A.LogLevel.Error:c.error(w);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function S(c,g){switch(g){case A.LogLevel.Trace:c.setLevel(s.Trace);break;case A.LogLevel.Debug:c.setLevel(s.Debug);break;case A.LogLevel.Info:c.setLevel(s.Info);break;case A.LogLevel.Warning:c.setLevel(s.Warning);break;case A.LogLevel.Error:c.setLevel(s.Error);break;case A.LogLevel.Off:c.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class f extends A.$bj{constructor(g,w,y,d,v){super(),this.m=[],this.setLevel(v),this.n=this.s(g,w,y,d),this.B(this.onDidChangeLogLevel(b=>{this.r&&S(this.r,b)}))}async s(g,w,y,d){const v=y?6:1,b=30/v*P.$Ek.MB,m=await M(g,w,b,v,d);if(m){this.r=m,S(this.r,this.getLevel());for(const{level:$,message:u}of this.m)D(this.r,$,u);this.m=[]}}g(g,w){this.r?D(this.r,g,w):this.getLevel()<=g&&this.m.push({level:g,message:w})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$nN=f}),define(te[228],ie([0,1,32,5,227]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=void 0;class M extends A.$gj{s(S,f,c){return new s.$nN((0,P.$dg)(),S.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,f)}}e.$oN=M}),define(te[67],ie([0,1,31,3,6,5,228]),function(Z,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=e.$86b=void 0,e.$86b=(0,s.$Oh)(M.$9i);class S extends D.$oN{constructor(){super(...arguments),this.u=new P.$zc}createLogger(c,g,w){w!==void 0&&this.u.set(this.n(c),w);try{return super.createLogger(c,g)}catch(y){throw this.u.delete(this.n(c)),y}}registerLogger(c,g){g!==void 0&&this.u.set(c.resource,g),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const g=[];for(const w of super.getRegisteredLoggers())c===this.u.get(w.resource)&&g.push(w);return g}getOnDidChangeLogLevelEvent(c){return A.Event.filter(this.onDidChangeLogLevel,g=>(0,M.$0i)(g)||this.w(g[0],c))}getOnDidChangeVisibilityEvent(c){return A.Event.filter(this.onDidChangeVisibility,([g])=>this.w(g,c))}getOnDidChangeLoggersEvent(c){return A.Event.filter(A.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(y=>this.w(y.resource,c)),removed:[...g.removed].filter(y=>this.w(y.resource,c))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(c){for(const[g,w]of this.u)w===c&&this.deregisterLogger(g)}w(c,g){const w=this.u.get(c);return w===void 0||w===g}dispose(){super.dispose(),this.u.clear()}}e.$96b=S}),define(te[229],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$26b=e.$16b=e.$Z6b=e.$Y6b=void 0;function P(D){return D.submenu!==void 0}e.$Y6b=P;function A(D){return D.id==="vscode.menubar.separator"}e.$Z6b=A;function s(D){return D.uri!==void 0}e.$16b=s;function M(D){return!P(D)&&!A(D)&&!s(D)}e.$26b=M}),define(te[39],ie([0,1,3,70,2,6]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=void 0,e.$en=(0,M.$Nh)("policy");class D extends s.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$Md),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const g=Object.keys(this.f).length;return this.f={...c,...this.f},g!==Object.keys(this.f).length&&await this.j(c),A.Iterable.reduce(this.g.entries(),(w,[y,d])=>({...w,[y]:d}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(c,[g,w])=>({...c,[g]:{definition:w,value:this.g.get(g)}}),{})}}e.$fn=D;class S{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$gn=S}),define(te[230],ie([0,1,8,3,70,12,16,5,39]),function(Z,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=void 0;function c(w,y){const d=[];for(const v of new Set(s.Iterable.concat(w.keys(),y.keys())))w.get(v)!==y.get(v)&&d.push(v);return d}let g=class extends f.$fn{constructor(y,d,v){super(),this.m=y,this.n=d,this.s=v,this.c=this.B(new P.$Qg(500));const b=A.Event.filter(d.onDidFilesChange,m=>m.affects(y));this.B(d.watch(y)),this.B(b(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const d=await this.n.readFile(this.m),v=JSON.parse(d.value.toString());if(!(0,M.$zf)(v))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(v))this.f[b]&&y.set(b,v[b])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return y}async w(){const y=await this.u(),d=c(this.g,y);this.g=y,d.length>0&&this.h.fire(d)}};e.$17b=g,e.$17b=g=ke([ee(1,D.$9j),ee(2,S.$8i)],g)}),define(te[231],ie([0,1,3,2,39]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7b=e.$A7b=void 0;class M{constructor(f){this.b=f,this.a=new A.$Qc}listen(f,c){switch(c){case"onDidChange":return P.Event.map(this.b.onDidChange,g=>g.reduce((w,y)=>({...w,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(f,c,g){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$A7b=M;class D extends s.$fn{constructor(f,c){super(),this.a=c;for(const g in f){const{definition:w,value:y}=f[g];this.f[g]=w,y!==void 0&&this.g.set(g,y)}this.a.listen("onDidChange")(g=>{for(const w in g){const y=g[w];y===null?this.g.delete(w):this.g.set(w,y)}this.h.fire(Object.keys(g))})}async j(f){const c=await this.a.call("updatePolicyDefinitions",f);for(const g in c)this.g.set(g,c[g])}}e.$B7b=D}),define(te[232],ie([0,1,39,8,310,2,5]),function(Z,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z7b=void 0;let S=class extends P.$fn{constructor(c,g){super(),this.m=c,this.n=g,this.a=new A.$Mg,this.b=this.B(new M.$Sc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((g,w)=>{try{this.b.value=(0,s.createWatcher)(this.n,c,y=>{this.t(y),g()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),w(y)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const g in c){const w=c[g];w===void 0?this.g.delete(g):this.g.set(g,w)}this.h.fire(Object.keys(c))}};e.$Z7b=S,e.$Z7b=S=ke([ee(0,D.$8i)],S)}),define(te[78],ie([0,1,4,35]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof P.$h.vscode<"u"&&typeof P.$h.vscode.context<"u"){const M=P.$h.vscode.context.configuration();if(M)s=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:M.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(te[24],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,P.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"}),define(te[233],ie([0,1,8,5]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O6b=void 0;let s=class{constructor(D,S,f){this.a=D,this.b=S,this.c=f}async inspect(D){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.$Tg)(D);const f=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$O6b=s,e.$O6b=s=ke([ee(2,A.$8i)],s)}),define(te[79],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R6b=void 0,e.$R6b=(0,P.$Nh)("protocolMainService")}),define(te[43],ie([0,1,135,12]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0;class s{constructor(){this.a=new Map}add(D,S){P.ok(A.$xf(D)),P.ok(A.$zf(S)),P.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$cn=new s}),define(te[234],ie([0,1,3,43]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=void 0,e.$dn={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class M{constructor(){this.b=new P.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,c){this.a[s(f)]=c,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const D=new M;A.$cn.add(e.$dn.JSONContribution,D)}),define(te[57],ie([0,1,23,3,12,161,17,234,43]),function(Z,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.ConfigurationScope=e.$hn=e.EditPresentationTypes=void 0;var c;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$hn={Configuration:"base.contributions.configuration"};var g;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on="vscode://schemas/settings/resourceLanguage",e.$pn="vscode://schemas/settings/configurationDefaults";const w=f.$cn.as(S.$dn.JSONContribution);class y{constructor(){this.h=new Set,this.i=new A.$Md,this.onDidSchemaChange=this.i.event,this.j=new A.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.$on,this.g),this.v()}registerConfiguration(i,a=!0){this.registerConfigurations([i],a)}registerConfigurations(i,a=!0){const o=new Set;this.n(i,a,o),w.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(i){const a=new Set;this.o(i,a),w.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:i,remove:a}){const o=new Set;this.o(a,o),this.n(i,!1,o),w.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(i){const a=new Set;this.k(i,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(i,a){const o=[];for(const{overrides:t,source:n}of i)for(const r in t)if(a.add(r),e.$rn.test(r)){const p=this.a.get(r),C=p?.valuesSources??new Map;if(n)for(const L of Object.keys(t[r]))C.set(L,n);const R={...p?.value||{},...t[r]};this.a.set(r,{source:n,value:R,valuesSources:C});const k=(0,D.$ri)(r),I={type:"object",default:R,description:M.localize(1,null,k),$ref:e.$on,defaultDefaultValue:R,source:s.$xf(n)?void 0:n,defaultValueSource:n};o.push(...b(r)),this.d[r]=I,this.b.properties[r]=I}else{this.a.set(r,{value:t[r],source:n});const p=this.d[r];p&&(this.w(r,p),this.r(r,p))}this.m(o)}deregisterDefaultConfigurations(i){const a=new Set;this.l(i,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(i,a){for(const{overrides:o,source:t}of i)for(const n in o){const r=this.a.get(n),p=s.$xf(t)?t:t?.id,C=s.$xf(r?.source)?r?.source:r?.source?.id;if(p===C)if(a.add(n),this.a.delete(n),e.$rn.test(n))delete this.d[n],delete this.b.properties[n];else{const R=this.d[n];R&&(this.w(n,R),this.r(n,R))}}this.u()}deltaConfiguration(i){let a=!1;const o=new Set;i.removedDefaults&&(this.l(i.removedDefaults,o),a=!0),i.addedDefaults&&(this.k(i.addedDefaults,o),a=!0),i.removedConfigurations&&this.o(i.removedConfigurations,o),i.addedConfigurations&&this.n(i.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const a of i)this.h.add(a);this.u()}n(i,a,o){i.forEach(t=>{this.p(t,a,t.extensionInfo,t.restrictedProperties,void 0,o),this.c.push(t),this.q(t)})}o(i,a){const o=t=>{if(t.properties)for(const n in t.properties){a.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>o(n))};for(const t of i){o(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(i,a=!0,o,t,n=3,r){n=s.$Gf(i.scope)?n:i.scope;const p=i.properties;if(p)for(const R in p){const k=p[R];if(a&&l(R,k)){delete p[R];continue}if(k.source=o,k.defaultDefaultValue=p[R].default,this.w(R,k),e.$rn.test(R)?k.scope=void 0:(k.scope=s.$Gf(k.scope)?n:k.scope,k.restricted=s.$Gf(k.restricted)?!!t?.includes(R):k.restricted),p[R].hasOwnProperty("included")&&!p[R].included){this.f[R]=p[R],delete p[R];continue}else this.d[R]=p[R],p[R].policy?.name&&this.e.set(p[R].policy.name,R);!p[R].deprecationMessage&&p[R].markdownDeprecationMessage&&(p[R].deprecationMessage=p[R].markdownDeprecationMessage),r.add(R)}const C=i.allOf;if(C)for(const R of C)this.p(R,a,o,t,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const a=o=>{const t=o.properties;if(t)for(const r in t)this.r(r,t[r]);o.allOf?.forEach(a)};a(i)}r(i,a){switch(e.$in.properties[i]=a,a.scope){case 1:e.$jn.properties[i]=a;break;case 2:e.$kn.properties[i]=a;break;case 6:e.$ln.properties[i]=a;break;case 3:e.$mn.properties[i]=a;break;case 4:e.$nn.properties[i]=a;break;case 5:e.$nn.properties[i]=a,this.g.properties[i]=a;break}}s(i,a){switch(delete e.$in.properties[i],a.scope){case 1:delete e.$jn.properties[i];break;case 2:delete e.$kn.properties[i];break;case 6:delete e.$ln.properties[i];break;case 3:delete e.$mn.properties[i];break;case 4:case 5:delete e.$nn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const a=`[${i}]`,o={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$on};this.w(a,o),e.$in.properties[a]=o,e.$jn.properties[a]=o,e.$kn.properties[a]=o,e.$ln.properties[a]=o,e.$mn.properties[a]=o,e.$nn.properties[a]=o}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$on};e.$in.patternProperties[e.$qn]=i,e.$jn.patternProperties[e.$qn]=i,e.$kn.patternProperties[e.$qn]=i,e.$ln.patternProperties[e.$qn]=i,e.$mn.patternProperties[e.$qn]=i,e.$nn.patternProperties[e.$qn]=i,this.i.fire()}w(i,a){const o=this.a.get(i);let t=o?.value,n=o?.source;s.$Ef(t)&&(t=a.defaultDefaultValue,n=void 0),s.$Ef(t)&&(t=$(a.type)),a.default=t,a.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",v=new RegExp(d,"g");e.$qn=`^(${d})+$`,e.$rn=new RegExp(e.$qn);function b(h){const i=[];if(e.$rn.test(h)){let a=v.exec(h);for(;a?.length;){const o=a[1].trim();o&&i.push(o),a=v.exec(h)}}return(0,P.$Lb)(i)}e.$sn=b;function m(h){return h.reduce((i,a)=>`${i}[${a}]`,"")}e.$tn=m;function $(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$un=$;const u=new y;f.$cn.add(e.$hn.Configuration,u);function l(h,i){return h.trim()?e.$rn.test(h)?M.localize(7,null,h):u.getConfigurationProperties()[h]!==void 0?M.localize(8,null,h):i.policy?.name&&u.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,h,i.policy?.name,u.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$vn=l;function E(){const h=[],i=u.getConfigurationProperties();for(const a of Object.keys(i))h.push([a,i[a].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$wn=E}),define(te[119],ie([0,1,23,3,44,2,31,37,12,7,17,57,43]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=void 0;function d(a){return Object.isFrozen(a)?a:S.$4m(a)}class v{constructor(o={},t=[],n=[],r){this.b=o,this.c=t,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(t=>{if(t instanceof v)return t;const n=new b("");return n.parseRaw(t),n.configurationModel});this.f=o.reduce((t,n)=>n===t?n:t.merge(n),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,g.$pi)(this.contents,o):this.contents}inspect(o,t){const n=this.rawConfiguration.getValue(o),r=t?this.rawConfiguration.getOverrideValue(o,t):void 0,p=t?this.rawConfiguration.override(t).getValue(o):n;return{value:n,override:r,merged:p}}getOverrideValue(o,t){const n=this.i(t);return n?o?(0,g.$pi)(n,o):n:void 0}getKeysForOverrideIdentifier(o){const t=[];for(const n of this.overrides)n.identifiers.includes(o)&&t.push(...n.keys);return P.$Lb(t)}getAllOverrideIdentifiers(){const o=[];for(const t of this.overrides)o.push(...t.identifiers);return P.$Lb(o)}override(o){let t=this.a.get(o);return t||(t=this.g(o),this.a.set(o,t)),t}merge(...o){const t=S.$3m(this.contents),n=S.$3m(this.overrides),r=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const C of o)if(p.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(t,C.contents);for(const R of C.overrides){const[k]=n.filter(I=>P.$tb(I.identifiers,R.identifiers));k?(this.h(k.contents,R.contents),k.keys.push(...R.keys),k.keys=P.$Lb(k.keys)):n.push(S.$3m(R))}for(const R of C.keys)r.indexOf(R)===-1&&r.push(R)}return new v(t,r,n,p.every(C=>C instanceof v)?void 0:p)}g(o){const t=this.i(o);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const n={};for(const r of P.$Lb([...Object.keys(this.contents),...Object.keys(t)])){let p=this.contents[r];const C=t[r];C&&(typeof p=="object"&&typeof C=="object"?(p=S.$3m(p),this.h(p,C)):p=C),n[r]=p}return new v(n,this.keys,this.overrides)}h(o,t){for(const n of Object.keys(t)){if(n in o&&f.$zf(o[n])&&f.$zf(t[n])){this.h(o[n],t[n]);continue}o[n]=S.$3m(t[n])}}i(o){let t=null,n=null;const r=p=>{p&&(n?this.h(n,p):n=S.$3m(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===o?t=p.contents:p.identifiers.includes(o)&&r(p.contents);return r(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,t){this.j(o,t,!0)}setValue(o,t){this.j(o,t,!1)}removeValue(o){const t=this.keys.indexOf(o);t!==-1&&(this.keys.splice(t,1),(0,g.$oi)(this.contents,o),w.$rn.test(o)&&this.overrides.splice(this.overrides.findIndex(n=>P.$tb(n.identifiers,(0,w.$sn)(o))),1))}j(o,t,n){(0,g.$ni)(this.contents,o,t,r=>console.error(r)),n=n||this.keys.indexOf(o)===-1,n&&this.keys.push(o),w.$rn.test(o)&&this.overrides.push({identifiers:(0,w.$sn)(o),keys:Object.keys(this.contents[o]),contents:(0,g.$mi)(this.contents[o],r=>console.error(r))})}}e.$xn=v;class b{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,t){if(!f.$Gf(o)){const n=this.g(o);this.parseRaw(n,t)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,t){this.a=o;const{contents:n,keys:r,overrides:p,restricted:C,hasExcludedProperties:R}=this.h(o,t);this.b=new v(n,r,p,R?[o]:void 0),this.c=C||[]}g(o){let t={},n=null,r=[];const p=[],C=[];function R(I){Array.isArray(r)?r.push(I):n!==null&&(r[n]=I)}const k={onObjectBegin:()=>{const I={};R(I),p.push(r),r=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{r=p.pop()},onArrayBegin:()=>{const I=[];R(I),p.push(r),r=I,n=null},onArrayEnd:()=>{r=p.pop()},onLiteralValue:R,onError:(I,L,N)=>{C.push({error:I,offset:L,length:N})}};if(o)try{s.$Zm(o,k),t=r[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return t}h(o,t){const n=y.$cn.as(w.$hn.Configuration).getConfigurationProperties(),r=this.i(o,n,!0,t);o=r.raw;const p=(0,g.$mi)(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),C=Object.keys(o),R=this.j(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:p,keys:C,overrides:R,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(o,t,n,r){let p=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:p};const C={},R=[];for(const k in o)if(w.$rn.test(k)&&n){const I=this.i(o[k],t,!1,r);C[k]=I.raw,p=p||I.hasExcludedProperties,R.push(...I.restricted)}else{const I=t[k],L=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&R.push(k),!r.exclude?.includes(k)&&(r.include?.includes(k)||(L===void 0||r.scopes===void 0||r.scopes.includes(L))&&!(r.skipRestricted&&I?.restricted))?C[k]=o[k]:p=!0}return{raw:C,restricted:R,hasExcludedProperties:p}}j(o,t){const n=[];for(const r of Object.keys(o))if(w.$rn.test(r)){const p={};for(const C in o[r])p[C]=o[r][C];n.push({identifiers:(0,w.$sn)(r),keys:Object.keys(p),contents:(0,g.$mi)(p,t)})}return n}}e.$yn=b;class m extends M.$Rc{constructor(o,t,n,r){super(),this.c=o,this.f=t,this.g=r,this.b=this.B(new A.$Md),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&n.isEqual(p.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zn=m;class ${constructor(o,t,n,r,p,C,R,k,I,L,N,z,ne){this.a=o,this.b=t,this.c=n,this.overrideIdentifiers=r,this.d=p,this.f=C,this.g=R,this.h=k,this.i=I,this.j=L,this.k=N,this.l=z,this.m=ne}get value(){return d(this.c)}n(o,t,n){const r=o.inspect(t,n);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(o,t,n,r,p=new v,C=new v,R=new D.$zc,k=new v,I=new D.$zc){this.c=o,this.d=t,this.f=n,this.g=r,this.h=p,this.i=C,this.j=R,this.l=k,this.m=I,this.a=null,this.b=new D.$zc,this.n=null}getValue(o,t,n){return this.q(o,t,n).getValue(o)}updateValue(o,t,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new v,this.m.set(n.resource,r))):r=this.l,t===void 0?r.removeValue(o):r.setValue(o,t),n.resource||(this.a=null)}inspect(o,t,n){const r=this.q(o,t,n),p=this.u(t.resource,n),C=t.resource?this.m.get(t.resource)||this.l:this.l,R=new Set;for(const k of r.overrides)for(const I of k.identifiers)r.getOverrideValue(o,I)!==void 0&&R.add(I);return new $(o,t,r.getValue(o),R.size?[...R]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,p||void 0,C)}keys(o){const t=this.u(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,t){this.j.set(o,t),this.b.delete(o)}deleteFolderConfiguration(o){this.p.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,t){const n=[];if(!t){const{added:r,updated:p,removed:C}=h(this.c,o);t=[...r,...p,...C]}for(const r of t)for(const p of(0,w.$sn)(r)){const C=this.c.getKeysForOverrideIdentifier(p),R=o.getKeysForOverrideIdentifier(p),k=[...R.filter(I=>C.indexOf(I)===-1),...C.filter(I=>R.indexOf(I)===-1),...C.filter(I=>!S.$7m(this.c.override(p).getValue(I),o.override(p).getValue(I)))];n.push([p,k])}return this.updateDefaultConfiguration(o),{keys:t,overrides:n}}compareAndUpdatePolicyConfiguration(o){const{added:t,updated:n,removed:r}=h(this.d,o),p=[...t,...n,...r];return p.length&&this.updatePolicyConfiguration(o),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=h(this.applicationConfiguration,o),C=[...t,...n,...r];return C.length&&this.updateApplicationConfiguration(o),{keys:C,overrides:p}}compareAndUpdateLocalUserConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=h(this.localUserConfiguration,o),C=[...t,...n,...r];return C.length&&this.updateLocalUserConfiguration(o),{keys:C,overrides:p}}compareAndUpdateRemoteUserConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=h(this.remoteUserConfiguration,o),C=[...t,...n,...r];return C.length&&this.updateRemoteUserConfiguration(o),{keys:C,overrides:p}}compareAndUpdateWorkspaceConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=h(this.workspaceConfiguration,o),C=[...t,...n,...r];return C.length&&this.updateWorkspaceConfiguration(o),{keys:C,overrides:p}}compareAndUpdateFolderConfiguration(o,t){const n=this.p.get(o),{added:r,updated:p,removed:C,overrides:R}=h(n,t),k=[...r,...p,...C];return(k.length||!n)&&this.updateFolderConfiguration(o,t),{keys:k,overrides:R}}compareAndDeleteFolderConfiguration(o){const t=this.p.get(o);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:n,updated:r,removed:p,overrides:C}=h(t,void 0);return{keys:[...n,...r,...p],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(o,t,n){let r=this.r(t,n);return t.overrideIdentifier&&(r=r.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(r=r.merge(this.d)),r}r({resource:o},t){let n=this.s();if(t&&o){const r=t.getFolder(o);r&&(n=this.t(r.uri)||n);const p=this.m.get(o);p&&(n=n.merge(p))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(o){let t=this.b.get(o);if(!t){const n=this.s(),r=this.j.get(o);r?(t=n.merge(r),this.b.set(o,t)):t=n}return t}u(o,t){if(t&&o){const n=t.getFolder(o);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,t)=>{const{contents:n,overrides:r,keys:p}=this.j.get(t);return o.push([t,{contents:n,overrides:r,keys:p}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(t=>o.add(t)),this.userConfiguration.keys.forEach(t=>o.add(t)),this.i.keys.forEach(t=>o.add(t)),this.j.forEach(t=>t.keys.forEach(n=>o.add(n))),[...o.values()]}v(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(n=>o.add(n))),[...o.values()]}w(o){const t=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(n=>t.add(n)),this.i.getKeysForOverrideIdentifier(o).forEach(n=>t.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(o).forEach(r=>t.add(r))),[...t.values()]}static parse(o){const t=this.x(o.defaults),n=this.x(o.policy),r=this.x(o.application),p=this.x(o.user),C=this.x(o.workspace),R=o.folders.reduce((k,I)=>(k.set(c.URI.revive(I[0]),this.x(I[1])),k),new D.$zc);return new u(t,n,r,p,new v,C,R,new v,new D.$zc)}static x(o){return new v(o.contents,o.keys,o.overrides)}}e.$An=u;function l(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const o=new Set,t=new Map;for(const r of a)r.keys.forEach(p=>o.add(p)),r.overrides.forEach(([p,C])=>{const R=(0,D.$wc)(t,p,new Set);C.forEach(k=>R.add(k))});const n=[];return t.forEach((r,p)=>n.push([p,[...r.values()]])),{keys:[...o.values()],overrides:n}}e.$Bn=l;class E{constructor(o,t,n,r){this.change=o,this.f=t,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const p of o.keys)this.affectedKeys.add(p);for(const[,p]of o.overrides)for(const C of p)this.affectedKeys.add(C);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(o,t){const n=this.a+o,r=this.d.indexOf(n);if(r<0)return!1;const p=r+n.length;if(p>=this.d.length)return!1;const C=this.d.charCodeAt(p);if(C!==this.b&&C!==this.c)return!1;if(t){const R=this.previousConfiguration?this.previousConfiguration.getValue(o,t,this.f?.workspace):void 0,k=this.g.getValue(o,t,this.h);return!S.$7m(R,k)}return!0}}e.$Cn=E;function h(a,o){const{added:t,removed:n,updated:r}=i(o?.rawConfiguration,a?.rawConfiguration),p=[],C=a?.getAllOverrideIdentifiers()||[],R=o?.getAllOverrideIdentifiers()||[];if(o){const k=R.filter(I=>!C.includes(I));for(const I of k)p.push([I,o.getKeysForOverrideIdentifier(I)])}if(a){const k=C.filter(I=>!R.includes(I));for(const I of k)p.push([I,a.getKeysForOverrideIdentifier(I)])}if(o&&a){for(const k of C)if(R.includes(k)){const I=i({contents:a.getOverrideValue(void 0,k)||{},keys:a.getKeysForOverrideIdentifier(k)},{contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)});p.push([k,[...I.added,...I.removed,...I.updated]])}}return{added:t,removed:n,updated:r,overrides:p}}function i(a,o){const t=a?o?a.keys.filter(p=>o.keys.indexOf(p)===-1):[...a.keys]:[],n=o?a?o.keys.filter(p=>a.keys.indexOf(p)===-1):[...o.keys]:[],r=[];if(a&&o){for(const p of o.keys)if(a.keys.indexOf(p)!==-1){const C=(0,g.$pi)(o.contents,p),R=(0,g.$pi)(a.contents,p);S.$7m(C,R)||r.push(p)}}return{added:t,removed:n,updated:r}}}),define(te[235],ie([0,1,23,3,2,37,12,119,57,5,39,43]),function(Z,e,P,A,s,M,D,S,f,c,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=void 0;class y extends s.$Rc{constructor(){super(...arguments),this.a=this.B(new A.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new S.$xn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.$cn.as(f.$hn.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:$})=>this.c(Array.from(m),$))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(m,$){this.h(m,w.$cn.as(f.$hn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}g(){this.b=new S.$xn;const m=w.$cn.as(f.$hn.Configuration).getConfigurationProperties();this.h(Object.keys(m),m)}h(m,$){const u=this.f();for(const l of m){const E=u[l],h=$[l];E!==void 0?this.b.addValue(l,E):h?this.b.addValue(l,h.default):this.b.removeValue(l)}}}e.$Dn=y;class d{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new S.$xn}async initialize(){return this.configurationModel}}e.$En=d;let v=class extends s.$Rc{get configurationModel(){return this.b}constructor(m,$,u){super(),this.c=m,this.f=$,this.g=u,this.a=this.B(new A.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new S.$xn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const $={},u=[],l=w.$cn.as(f.$hn.Configuration).getConfigurationProperties();for(const E of m){const h=l[E];if(!h){u.push(E);continue}if(h.policy){if(h.type!=="string"&&h.type!=="number"){this.g.warn(`Policy ${h.policy.name} has unsupported type ${h.type}`);continue}u.push(E),$[h.policy.name]={type:h.type}}}return(0,D.$Kf)($)||await this.f.updatePolicyDefinitions($),u}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const $=w.$cn.as(f.$hn.Configuration).getPolicyConfigurations(),u=(0,P.$Gb)(m.map(l=>$.get(l)));this.m(u,!0)}m(m,$){this.g.trace("PolicyConfiguration#update",m);const u=w.$cn.as(f.$hn.Configuration).getConfigurationProperties(),l=[],E=this.b.isEmpty();for(const h of m){const i=u[h]?.policy?.name;if(i){const a=this.f.getPolicyValue(i);(E?a!==void 0:!(0,M.$7m)(this.b.getValue(h),a))&&l.push([h,a])}else this.b.getValue(h)!==void 0&&l.push([h,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const h=this.b;this.b=new S.$xn;for(const i of h.keys)this.b.setValue(i,h.getValue(i));for(const[i,a]of l)a===void 0?this.b.removeValue(i):this.b.setValue(i,a);$&&this.a.fire(this.b)}}};e.$Fn=v,e.$Fn=v=ke([ee(1,g.$en),ee(2,c.$8i)],v)}),define(te[236],ie([0,1,8,3,2,19,17,119,235,39]),function(Z,e,P,A,s,M,D,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0;class g extends s.$Rc{constructor(y,d,v,b){super(),this.j=y,this.h=this.B(new A.$Md),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$Dn),this.c=v instanceof c.$gn?new f.$En:this.B(new f.$Fn(this.b,v,b)),this.f=this.B(new S.$zn(this.j,{},M.$lg,d)),this.a=new S.$An(this.b.configurationModel,this.c.configurationModel,new S.$xn,new S.$xn),this.g=this.B(new P.$5g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:m,properties:$})=>this.n(m,$))),this.B(this.c.onDidChangeConfiguration(m=>this.r(m))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,d,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$An(y,d,new S.$xn,v)}getConfigurationData(){return this.a.toData()}getValue(y,d){const v=typeof y=="string"?y:void 0,b=(0,D.$ii)(y)?y:(0,D.$ii)(d)?d:{};return this.a.getValue(v,b,void 0)}updateValue(y,d,v,b){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.m(y)}m(y){const d=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(y);this.s(v,d,2)}n(y,d){const v=this.a.toData(),b=this.a.compareAndUpdateDefaultConfiguration(y,d);this.s(b,v,7)}r(y){const d=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(y);this.s(v,d,7)}s(y,d,v){const b=new S.$Cn(y,{data:d},this.a);b.source=v,b.sourceConfig=this.t(v),this.h.fire(b)}t(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Gn=g}),define(te[237],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O7b=e.$N7b=e.$M7b=void 0,e.$M7b="request",e.$N7b="remoteResourceHandler";class P{async routeCall(s,M,D){if(M!==e.$M7b)throw new Error(`Call not found: ${M}`);const S=D[0];if(S?.authority){const f=s.connections.find(c=>c.ctx===S.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$O7b=P}),define(te[238],ie([0,1,14,6]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.RemoteAuthorityResolverErrorCode=e.$Pk=e.$Ok=e.RemoteConnectionType=e.$Nk=void 0,e.$Nk=(0,A.$Nh)("remoteAuthorityResolverService");var s;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(w){this.id=w,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ok=M;class D{constructor(w,y){this.host=w,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Pk=D;var S;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class f extends P.$ab{static isNotAvailable(w){return w instanceof f&&w._code===S.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof f&&w._code===S.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof f&&w._code===S.NoResolverFound}static isInvalidAuthority(w){return w instanceof f&&w._code===S.InvalidAuthority}static isHandled(w){return w instanceof f&&w.isHandled}constructor(w,y=S.Unknown,d){super(w),this._message=w,this._code=y,this._detail=d,this.isHandled=y===S.NotAvailable&&d===!0,Object.setPrototypeOf(this,f.prototype)}}e.$Qk=f;function c(g){const w=g.indexOf("+");return w===-1?g:g.substring(0,w)}e.$Rk=c}),define(te[58],ie([0,1,13]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=void 0;function A(c){return c.scheme===P.Schemas.vscodeRemote?c.authority:void 0}e.$Sk=A;function s(c){if(!c)return;const g=c.indexOf("+");return g<0?c:c.substr(0,g)}e.$Tk=s;function M(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Uk=M;function D(c){const{host:g,port:w}=f(c);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:g,port:w}}e.$Vk=D;function S(c,g){let{host:w,port:y}=f(c);return typeof y>"u"&&(y=g),{host:w,port:y}}e.$Wk=S;function f(c){const g=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const w=c.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const y=c.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:c,port:void 0}}}),define(te[120],ie([0,1,27,6,58]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.TargetPlatform=e.ExtensionType=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=void 0,e.$Wl="extensions.user.cache",e.$Xl="extensions.builtin.cache",e.$Yl="undefined_publisher",e.$Zl=["ui","workspace","web"];function M(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$1l=M,e.$2l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D||(e.ExtensionType=D={}));var S;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class f{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,$){if(typeof m>"u"||m===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof m=="string"||typeof $=="string"){const u=typeof m=="string"?m:m.value,l=typeof $=="string"?$:$.value;return P.$1e(u,l)}return m._lower===$._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$3l=f;class c{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const $ of m)this.add($)}add(m){this.c.add(f.toKey(m))}delete(m){return this.c.delete(f.toKey(m))}has(m){return this.c.has(f.toKey(m))}}e.$4l=c;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(f.toKey(m))}get(m){return this.c.get(f.toKey(m))}has(m){return this.c.has(f.toKey(m))}set(m,$){this.c.set(f.toKey(m),$)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$5l=g;function w(b){return y(b)}e.$6l=w;function y(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.$7l=y;function d(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.$8l=d;function v(b,m){if(m){const $=`onResolveRemoteAuthority:${(0,s.$Tk)(m)}`;return!!b.activationEvents?.includes($)}return!1}e.$9l=v,e.$0l=(0,A.$Nh)("IBuiltinExtensionsScannerService")}),define(te[239],ie([0,1,8,18,22,14,3,2,66,72,32,109,238,58]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.PersistentConnectionEventType=e.$4k=e.$3k=e.$2k=e.ConnectionType=void 0;const v=30*1e3;var b;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function m(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function $(F){const O=new s.$Wd;return setTimeout(()=>O.cancel(),F),O.token}function u(F,O){if(F.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const j=new s.$Wd;return F.onCancellationRequested(()=>j.cancel()),O.onCancellationRequested(()=>j.cancel()),j.token}class l{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new S.$Qc,this.promise=new Promise((j,B)=>{this.f=j,this.g=B}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function E(F,O){const j=new l(O);return j.registerDisposable(F.onControlMessage(B=>{const W=JSON.parse(B.toString()),T=U(W);T?j.reject(T):j.resolve(W)})),j.promise}function h(F,O,j,B,W,T,V,ce){const de=new l(ce),ue=c.$Id.create(!1);return F.info(`Creating a socket (${V})...`),f.mark(`code/willCreateSocket/${T}`),O.connect(j,B,W,V).then(fe=>{de.didTimeout?(f.mark(`code/didCreateSocketError/${T}`),F.info(`Creating a socket (${V}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(f.mark(`code/didCreateSocketOK/${T}`),F.info(`Creating a socket (${V}) was successful after ${ue.elapsed()} ms.`),de.resolve(fe))},fe=>{f.mark(`code/didCreateSocketError/${T}`),F.info(`Creating a socket (${V}) returned an error after ${ue.elapsed()} ms.`),F.error(fe),de.reject(fe)}),de.promise}function i(F,O){const j=new l(O);return F.then(B=>{j.didTimeout||j.resolve(B)},B=>{j.didTimeout||j.reject(B)}),j.promise}async function a(F,O,j,B){const W=Q(F,O);F.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let T;try{T=await h(F.logService,F.remoteSocketFactoryService,F.connectTo,(0,d.$Uk)(F),`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,m(O),`renderer-${m(O)}-${F.reconnectionToken}`,B)}catch(fe){throw F.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),F.logService.error(fe),fe}F.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let V,ce;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(T,null),V=F.reconnectionProtocol,ce=!1):(V=new w.$Bh({socket:T}),ce=!0),F.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const de=await i(F.signService.createNewMessage((0,g.$dg)()),B),ue={type:"auth",auth:F.connectionToken||"00000000000000000000",data:de.data};V.sendControl(A.$ae.fromString(JSON.stringify(ue)));try{const fe=await E(V,u(B,$(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(F.logService.trace(`${W} 4/6. received SignRequest control message.`),!await i(F.signService.validate(de,fe.signedData),B)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const be=await i(F.signService.sign(fe.data),B),pe={type:"connectionType",commit:F.commit,signedData:be,desiredConnectionType:O};return j&&(pe.args=j),F.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(A.$ae.fromString(JSON.stringify(pe))),{protocol:V,ownsProtocol:ce}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(F.logService.error(`${W} the handshake timed out. Error:`),F.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${W} received error control message when negotiating connection. Error:`),F.logService.error(fe)),ce&&G(V),fe}}async function o(F,O,j,B){const W=Date.now(),T=Q(F,O),{protocol:V,ownsProtocol:ce}=await a(F,O,j,B),de=new l(B);return de.registerDisposable(V.onControlMessage(ue=>{const fe=JSON.parse(ue.toString()),ye=U(fe);ye?(F.logService.error(`${T} received error control message when negotiating connection. Error:`),F.logService.error(ye),ce&&G(V),de.reject(ye)):(F.reconnectionProtocol?.endAcceptReconnection(),F.logService.trace(`${T} 6/6. handshake finished, connection is up and running after ${re(W)}!`),de.resolve({protocol:V,firstMessage:fe}))})),de.promise}async function t(F,O){const{protocol:j}=await o(F,1,void 0,O);return{protocol:j}}async function n(F,O,j){const{protocol:B,firstMessage:W}=await o(F,2,O,j),T=W&&W.debugPort;return{protocol:B,debugPort:T}}async function r(F,O,j){const B=Date.now(),W=Q(F,3),{protocol:T}=await a(F,3,O,j);return F.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${re(B)}!`),T}async function p(F,O,j){const{connectTo:B,connectionToken:W}=await F.addressProvider.getAddress();return{commit:F.commit,quality:F.quality,connectTo:B,connectionToken:W,reconnectionToken:O,reconnectionProtocol:j,remoteSocketFactoryService:F.remoteSocketFactoryService,signService:F.signService,logService:F.logService}}async function C(F,O,j){return k(F,async B=>{const{protocol:W}=await t(B,s.CancellationToken.None);return new J(F,O,j,B.reconnectionToken,W)})}e.$2k=C;async function R(F,O){return k(F,async j=>{const{protocol:B,debugPort:W}=await n(j,O,s.CancellationToken.None);return new K(F,O,j.reconnectionToken,B,W)})}e.$3k=R;async function k(F,O){for(let B=1;;B++)try{const W=(0,g.$dg)(),T=await p(F,W,null);return await O(T)}catch(W){if(B<5)F.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),F.logService.error(W);else throw F.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),F.logService.error(W),oe.triggerPermanentFailure(0,0,y.$Qk.isHandled(W)),W}}async function I(F,O,j){const B=await p(F,(0,g.$dg)(),null);return await r(B,{host:O,port:j},s.CancellationToken.None)}e.$4k=I;function L(F){return(0,P.$Gg)(O=>new Promise((j,B)=>{const W=setTimeout(j,F*1e3);O.onCancellationRequested(()=>{clearTimeout(W),j()})}))}var N;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class z{constructor(O,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.type=0}}e.$5k=z;class ne{constructor(O,j,B,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.durationSeconds=B,this.c=W,this.type=1}skipWait(){this.c.cancel()}}e.$6k=ne;class _{constructor(O,j,B){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=B,this.type=2}}e.$7k=_;class ae{constructor(O,j,B){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=B,this.type=4}}e.$8k=ae;class se{constructor(O,j,B,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=B,this.handled=W,this.type=3}}e.$9k=se;class oe extends S.$Rc{static triggerPermanentFailure(O,j,B){this._permanentFailure=!0,this.f=O,this.g=j,this.h=B,this.j.forEach(W=>W.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||oe._permanentFailure}constructor(O,j,B,W,T){super(),this.t=O,this.u=j,this.reconnectionToken=B,this.protocol=W,this.w=T,this.m=this.B(new D.$Md),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(W.onSocketClose(V=>{const ce=H(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${ce} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${ce} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${ce} received socket close event.`),this.y()})),this.B(W.onSocketTimeout(V=>{const ce=H(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),oe.j.push(this),this.B((0,S.$Pc)(()=>{const V=oe.j.indexOf(this);V>=0&&oe.j.splice(V,1)})),this.n&&this.D(oe.f,oe.g,oe.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=H(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const W=B<j.length?j[B]:j[j.length-1];try{if(W>0){const V=L(W);this.m.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,V)),this.u.logService.info(`${O} waiting for ${W} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${O} resolving connection...`);const T=await p(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${T.connectTo}...`),await this.G(T,$(v)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(T){if(T.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(T),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(T),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(y.$Qk.isTemporarilyNotAvailable(T)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(T);continue}if((T.code==="ETIMEDOUT"||T.code==="ENETUNREACH"||T.code==="ECONNREFUSED"||T.code==="ECONNRESET")&&T.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(T);continue}if((0,M.$3)(T)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(T);continue}if(T instanceof y.$Qk){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(T),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,y.$Qk.isHandled(T));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(T),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(O,j,B){this.w?oe.triggerPermanentFailure(O,j,B):this.D(O,j,B)}D(O,j,B){this.m.fire(new se(this.reconnectionToken,O,j,B)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$0k=oe;class J extends oe{constructor(O,j,B,W,T){super(1,O,W,T,!0),this.client=this.B(new w.$zh(T,{remoteAuthority:j,clientId:B},O.ipcLogger))}async G(O,j){await t(O,j)}}e.$$k=J;class K extends oe{constructor(O,j,B,W,T){super(2,O,B,W,!1),this.H=j,this.debugPort=T}async G(O,j){await n(O,this.H,j)}}e.$_k=K;function G(F){try{F.acceptDisconnect();const O=F.getSocket();F.dispose(),O.dispose()}catch(O){(0,M.$Z)(O)}}function U(F){if(F&&F.type==="error"){const O=new Error(`Connection error: ${F.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function q(F,O){for(;F.length<O;)F+=" ";return F}function X(F,O){return`[remote-connection][${q(m(F),13)}][${O.substr(0,5)}\u2026]`}function H(F,O,j){return`${X(F,O)}[${j?"reconnect":"initial"}]`}function Q(F,O){return`${H(O,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.connectTo}]`}function re(F){return`${Date.now()-F} ms`}}),define(te[240],ie([0,1,2,6]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=void 0,e.$Xk=(0,A.$Nh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,S){return this.a[D]??=[],this.a[D].push(S),(0,P.$Pc)(()=>{const f=this.a[D]?.indexOf(S);typeof f=="number"&&f>=0&&this.a[D]?.splice(f,1)})}b(D){return(this.a[D.type]||[]).find(f=>f.supports(D))}connect(D,S,f,c){const g=this.b(D);if(!g)throw new Error(`No socket factory found for ${D}`);return g.connect(D,S,f,c)}}e.$Yk=s}),define(te[241],ie([0,1,28,47,21,113]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N6b=void 0;let D;async function S(d=!1){return(D===void 0||d)&&(D=f()),D}e.$N6b=S;async function f(){const d=c();if(d===void 0)return!1;if(d>=22e3){const v=w();if(v)return new Promise(b=>{A.execFile(v,["--status"],m=>b(!m))})}else{const v=y();if(v)try{if((await s.Promises.stat(v)).isFile())return!0}catch{}}return!1}function c(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(d)return parseInt(d[3])}function g(d){const v=process.env.SystemRoot;if(v){const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(v,b?"Sysnative":"System32",d)}}function w(){return g("wsl.exe")}function y(){return g("lxss\\LxssManager.dll")}}),define(te[50],ie([0,1,18,14,2,181,57,6,5,43]),function(Z,e,P,A,s,M,D,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0,e.$Po=(0,S.$Nh)("requestService");class g{constructor(h){this.b=h}toJSON(){if(!this.a){const h=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?h[i]="*****":h[i]=this.b[i];this.a=h}return this.a}}class w extends s.$Rc{constructor(h){super(),this.b=0,this.a=h.createLogger("network",{name:(0,M.localize)(0,null),when:f.$mj.isEqualTo((0,f.$kj)(f.LogLevel.Trace)).serialize()})}async c(h,i,a){const o=`${h} #${++this.b}: ${i.url}`;this.a.trace(`${o} - begin`,i.type,new g(i.headers??{}));try{const t=await a();return this.a.trace(`${o} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${o} - error`,i.type,(0,A.$9)(t)),t}}}e.$Qo=w;function y(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$Ro=y;function d(E){return E.res.statusCode===204}e.$So=d;async function v(E){return d(E)?null:(await(0,P.$me)(E.stream)).toString()}e.$To=v;async function b(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);return v(E)}e.$Uo=b;async function m(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);if(d(E))return null;const i=(await(0,P.$me)(E.stream)).toString();try{return JSON.parse(i)}catch(a){throw a.message+=`:
`+i,a}}e.$Vo=m;function $(E){l(E)}e.$Wo=$;let u;function l(E){const h=c.$cn.as(D.$hn.Configuration),i=u;u={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},h.updateConfigurations({add:[u],remove:i?[i]:[]})}l(1)}),define(te[242],ie([0,1,18,22]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=void 0;class s{constructor(S){this.a=S}listen(S,f){throw new Error("Invalid listen")}call(S,f,c,g=A.CancellationToken.None){switch(f){case"request":return this.a.request(c[0],g).then(async({res:w,stream:y})=>{const d=await(0,P.$me)(y);return[{statusCode:w.statusCode,headers:w.headers},d]});case"resolveProxy":return this.a.resolveProxy(c[0])}throw new Error("Invalid call")}}e.$Sq=s;class M{constructor(S){this.a=S}async request(S,f){const[c,g]=await this.a.call("request",[S],f);return{res:c,stream:(0,P.$oe)(g)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}}e.$Tq=M}),define(te[243],ie([0,1,244,12]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;function s(D,S){return D.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:D.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function M(D,S,f={}){const c=(0,P.parse)(D),g=f.proxyUrl||s(c,S);if(!g)return null;const w=(0,P.parse)(g);if(!/^https?:$/.test(w.protocol||""))return null;const y={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,A.$Df)(f.strictSSL)?f.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((d,v)=>{Z(["http-proxy-agent"],d,v)}))(y):new(await new Promise((d,v)=>{Z(["https-proxy-agent"],d,v)}))(y)}e.$Uq=M}),define(te[245],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6b=e.$$6b=e.$06b=void 0,e.$06b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$$6b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$_6b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(te[93],ie([0,1,47,9,182,22,49,14,4,32,108,63,8,138]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=void 0;let v;async function b($,u,l,E){return l["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$j?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.$Kl)(E)&&!l["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.$Kl)(E)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=y.Promises.withAsyncBody(async(h,i)=>{const a=new M.$Wd;let o=1e4;const t=$.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(o=(0,d.$Ll)(t,1,120)*1e3);const n=setTimeout(()=>{a.dispose(!0),i(new Error((0,s.localize)(0,null)))},o);try{h(await m(u,a.token))}catch(r){!(0,S.$3)(r)&&!a.token.isCancellationRequested?i(new Error((0,s.localize)(1,null,(0,D.$yi)(r)))):h({})}finally{clearTimeout(n),a.dispose()}})),v)}e.$Ql=b;async function m($,u){const l=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",l);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",E);const h=(0,c.$dg)().replace(/-/g,"").substr(0,12),i=new RegExp(h+"({.*})"+h),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",a);const o=await(0,g.$Al)(f.OS,a);return $.trace("getUnixShellEnvironment#shell",o),new Promise((t,n)=>{if(u.isCancellationRequested)return n(new S.$4);const r=(0,A.$mc)(o);let p,C;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(p=`& '${process.execPath}' ${R} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,C=["-Login","-Command"]):r==="nu"?(p=`^'${process.execPath}' ${R} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,C=["-i","-l","-c"]):(p=`'${process.execPath}' ${R} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,r==="tcsh"||r==="csh"?C=["-ic"]:C=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(C),p);const k=(0,P.spawn)(o,[...C,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});u.onCancellationRequested(()=>(k.kill(),n(new S.$4))),k.on("error",N=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,D.$yi)(N)),n(N)});const I=[];k.stdout.on("data",N=>I.push(N));const L=[];k.stderr.on("data",N=>L.push(N)),k.on("close",(N,z)=>{const ne=Buffer.concat(I).toString("utf8");$.trace("getUnixShellEnvironment#raw",ne);const _=Buffer.concat(L).toString("utf8");if(_.trim()&&$.trace("getUnixShellEnvironment#stderr",_),N||z)return n(new Error((0,s.localize)(2,null,N,z)));const ae=i.exec(ne),se=ae?ae[1]:"{}";try{const oe=JSON.parse(se);l?oe.ELECTRON_RUN_AS_NODE=l:delete oe.ELECTRON_RUN_AS_NODE,E?oe.ELECTRON_NO_ATTACH_CONSOLE=E:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",oe),t(oe)}catch(oe){$.error("getUnixShellEnvironment#errorCaught",(0,D.$yi)(oe)),n(oe)}})})}}),define(te[246],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$2b=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const D=String(P.a++);return this.b.set(D,M),{id:D,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(M)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$$2b=P}),define(te[94],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=void 0,e.$Zk="signService",e.$1k=(0,P.$Nh)(e.$Zk)}),define(te[247],ie([0,1,246]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0;class A extends P.$$2b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(D=>new D.signer().sign(M))}h(){return new Promise((M,D)=>Z(["vsda"],M,D))}}e.$Y7b=A}),define(te[34],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=void 0,e.$pN=(0,P.$Nh)("stateReadService"),e.$qN=(0,P.$Nh)("stateService")}),define(te[121],ie([0,1,8,18,2,12,36,16,5]),function(Z,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=e.$sN=e.$rN=e.SaveStrategy=void 0;var c;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class g extends s.$Rc{constructor(v,b,m,$){super(),this.h=v,this.j=m,this.m=$,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=b===0?void 0:this.B(new P.$Qg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.j.error(v)}}getItem(v,b){const m=this.a[v];return(0,M.$Gf)(m)?b:m}setItem(v,b){this.setItems([{key:v,data:b}])}setItems(v){let b=!1;for(const{key:m,data:$}of v)this.a[m]!==$&&((0,M.$Gf)($)?(0,M.$Ef)(this.a[m])||(this.a[m]=void 0,b=!0):(this.a[m]=$,b=!0));b&&this.r()}removeItem(v){(0,M.$Ef)(this.a[v])||(this.a[v]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.m.writeFile(this.h,A.$ae.fromString(v),{atomic:{postfix:".vsctmp"}}),this.b=v}catch(b){this.j.error(b)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$rN=g;let w=class extends s.$Rc{constructor(v,b,m,$){super(),this.a=this.B(new g(b.stateResource,v,m,$))}async init(){await this.a.init()}getItem(v,b){return this.a.getItem(v,b)}};e.$sN=w,e.$sN=w=ke([ee(1,D.$Uh),ee(2,f.$8i),ee(3,S.$9j)],w);class y extends w{setItem(v,b){this.a.setItem(v,b)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.$tN=y}),define(te[122],ie([0,1,4,35,32]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=void 0;function M(f){if(P.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function D(f,c,g,w,y,d,v,b){const m=Object.create(null);m["common.machineId"]=d,m.sessionID=(0,s.$dg)()+Date.now(),m.commitHash=w,m.version=y,m["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,P.$i)(P.$u),m["common.nodePlatform"]=A.$cc,m["common.nodeArch"]=g,m["common.product"]=b||"desktop",v&&(m["common.msftInternal"]=v);let $=0;const u=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>$++,enumerable:!0}}),P.$m&&(m["common.snap"]="true");const l=M(c);return l&&(m["common.platformDetail"]=l),m}e.$eo=D;function S(f){const c=A.env.USERDNSDOMAIN;if(!c)return!1;const g=c.toLowerCase();return f.some(w=>g===w)}e.$fo=S}),define(te[26],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0,e.$al=(0,P.$Nh)("telemetryService"),e.$bl=(0,P.$Nh)("customEndpointTelemetryService"),e.$cl="telemetry.currentSessionDate",e.$dl="telemetry.firstSessionDate",e.$el="telemetry.lastSessionDate",e.$fl="telemetry.machineId",e.$gl="telemetry",e.$hl="telemetry.telemetryLevel",e.$il="telemetry.enableCrashReporter",e.$jl="telemetry.enableTelemetry";var A;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(te[248],ie([0,1,28,8,44,13,9,4,7,86,21,107,90,16,24,26]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.$Br=e.$Ar=void 0;const m=new Map;async function $(i,a){const o=`${i}::${a.join(":")}`,t=m.get(o);if(t)return t;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,p=new Map,C=2e4;function R(I,L,N,z){const ne=L.substring(I.length+1);return A.Promises.withAsyncBody(async _=>{let ae;try{ae=await g.Promises.readdir(L,{withFileTypes:!0})}catch{_();return}if(z.count>=C){z.count+=ae.length,z.maxReached=!0,_();return}let se=ae.length;if(se===0){_();return}let oe=ae;z.count+ae.length>C&&(z.maxReached=!0,se=C-z.count,oe=ae.slice(0,se)),z.count+=ae.length;for(const J of oe)if(J.isDirectory()){if(N.includes(J.name)||await R(I,(0,D.$ic)(L,J.name),N,z),--se===0){_();return}}else{const K=J.name.lastIndexOf(".");if(K>=0){const G=J.name.substring(K+1);G&&r.set(G,(r.get(G)??0)+1)}for(const G of n)G.relativePathPattern?.test(ne)!==!1&&G.filePattern.test(J.name)&&p.set(G.tag,(p.get(G.tag)??0)+1);if(--se===0){_();return}}})}const k=A.Promises.withAsyncBody(async I=>{const L={count:0,maxReached:!1};await R(i,i,a,L);const N=await E(i);I({configFiles:u(p),fileTypes:u(r),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:N})});return m.set(o,k),k}e.$Ar=$;function u(i){return Array.from(i.entries(),([a,o])=>({name:a,count:o})).sort((a,o)=>o.count-a.count)}function l(){const i={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/d.$Ek.GB).toFixed(2)}GB (${(P.freemem()/d.$Ek.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$Om.value()*100)}%`},a=P.cpus();return a&&a.length>0&&(i.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),i}e.$Br=l;async function E(i){try{const a=new Map,o=(0,D.$ic)(i,".vscode","launch.json"),t=await g.Promises.readFile(o),n=[],r=(0,s.$Sm)(t.toString(),n);if(n.length)return console.log(`Unable to parse ${o}`),[];if((0,s.$2m)(r)==="object"&&r.configurations)for(const p of r.configurations){const C=p.type;C&&(a.has(C)?a.set(C,a.get(C)+1):a.set(C,1))}return u(a)}catch{return[]}}e.$Cr=E;let h=class{constructor(a,o){this.c=a,this.d=o}f(a){const o=[];return o.push(`OS Version:       ${a.os}`),o.push(`CPUs:             ${a.cpus}`),o.push(`Memory (System):  ${a.memory}`),o.push(`VM:               ${a.vmHint}`),o.join(`
`)}g(a){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const t=P.cpus();return t&&t.length>0&&o.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),o.push(`Memory (System):  ${(P.totalmem()/d.$Ek.GB).toFixed(2)}GB (${(P.freemem()/d.$Ek.GB).toFixed(2)}GB free)`),S.$j||o.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),o.push(`VM:               ${Math.round(c.$Om.value()*100)}%`),o.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${a.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(a,o){return Promise.all([(0,w.$zr)(a.mainPID),this.k(a)]).then(async t=>{let[n,r]=t,p=this.m(a,n);return o.forEach(C=>{if((0,y.$om)(C))p+=`
${C.errorMessage}`,r+=`
${C.errorMessage}`;else if(p+=`

Remote: ${C.hostName}`,C.processes&&(p+=`
${this.m(a,C.processes)}`),C.workspaceMetadata){r+=`
|  Remote: ${C.hostName}`;for(const R of Object.keys(C.workspaceMetadata)){const k=C.workspaceMetadata[R];let I=`${k.fileCount} files`;k.maxFilesReached&&(I=`more than ${I}`),r+=`|    Folder (${R}): ${I}`,r+=this.h(k)}}}),{processInfo:p,workspaceInfo:r}})}async getSystemInfo(a,o){const{memory:t,vmHint:n,os:r,cpus:p}=l(),C={os:r,memory:t,cpus:p,vmHint:n,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:o};return S.$j||(C.load=`${P.loadavg().map(R=>Math.round(R)).join(", ")}`),S.$l&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(a,o){const t=[];return(0,w.$zr)(a.mainPID).then(async n=>(t.push(""),t.push(this.g(a)),t.push(""),t.push(this.m(a,n)),a.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(a))),o.forEach(r=>{if((0,y.$om)(r))t.push(`
${r.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${r.hostName}`),t.push(this.f(r.machineInfo)),r.processes&&t.push(this.m(a,r.processes)),r.workspaceMetadata)for(const p of Object.keys(r.workspaceMetadata)){const C=r.workspaceMetadata[p];let R=`${C.fileCount} files`;C.maxFilesReached&&(R=`more than ${R}`),t.push(`Folder (${p}): ${R}`),t.push(this.h(C))}}),t.push(""),t.push(""),t.join(`
`)))}h(a){const o=[];let n=0;const r=(k,I)=>{const L=` ${k}(${I})`;n+L.length>60?(o.push(p),p="|                 ",n=p.length):n+=L.length,p+=L};let p="|      File types:";const C=10,R=a.fileTypes.length>C?C:a.fileTypes.length;for(let k=0;k<R;k++){const I=a.fileTypes[k];r(I.name,I.count)}if(o.push(p),a.configFiles.length>=0&&(p="|      Conf files:",n=0,a.configFiles.forEach(k=>{r(k.name,k.count)}),o.push(p)),a.launchConfigFiles.length>0){let k="|      Launch Configs:";a.launchConfigFiles.forEach(I=>{const L=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;k+=L}),o.push(k)}return o.join(`
`)}j(a){const o=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(o-t.length)}  ${a[t]}`).join(`
                  `)}k(a){const o=[],t=[];return a.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(o.push(`|  Window (${n.title})`),n.folderURIs.forEach(r=>{const p=f.URI.revive(r);if(p.scheme===M.Schemas.file){const C=p.fsPath;t.push($(C,["node_modules",".git"]).then(R=>{let k=`${R.fileCount} files`;R.maxFilesReached&&(k=`more than ${k}`),o.push(`|    Folder (${(0,D.$mc)(C)}): ${k}`),o.push(this.h(R))}).catch(R=>{o.push(`|      Error: Unable to collect workspace stats for folder ${C} (${R.toString()})`)}))}else o.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(n=>o.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(a,o){const t=new Map;a.windows.forEach(r=>t.set(r.pid,`window [${r.id}] (${r.title})`)),a.pidToNames.forEach(({pid:r,name:p})=>t.set(r,p));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),o&&this.n(a.mainPID,t,n,o,0),n.join(`
`)}n(a,o,t,n,r){const p=r===0;let C;p?C=n.pid===a?`${this.d.applicationName} main`:"remote agent":o.has(n.pid)?C=o.get(n.pid):C=`${"  ".repeat(r)} ${n.name}`;const R=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);t.push(`${n.load.toFixed(0).padStart(5," ")}	${(R/d.$Ek.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(n.children)&&n.children.forEach(k=>this.n(a,o,t,k,r+1))}async getWorkspaceFileExtensions(a){const o=new Set;for(const{uri:t}of a.folders){const n=f.URI.revive(t);if(n.scheme!==M.Schemas.file)continue;const r=n.fsPath;try{(await $(r,["node_modules",".git"])).fileTypes.forEach(C=>o.add(C.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(a){for(const{uri:o}of a.folders){const t=f.URI.revive(o);if(t.scheme!==M.Schemas.file)continue;const n=t.fsPath;try{const r=await $(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),r.fileTypes.forEach(p=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:p.name,count:p.count})}),r.launchConfigFiles.forEach(p=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:p.name,count:p.count})}),r.configFiles.forEach(p=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.$Dr=h,e.$Dr=h=ke([ee(0,b.$al),ee(1,v.$nj)],h)}),define(te[249],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d7b=e.$c7b=void 0;class P{constructor(M){this.b=M}listen(M,D){throw new Error(`Event not found: ${D}`)}call(M,D,{eventName:S,data:f}){return this.b.forEach(c=>c.log(S,f)),Promise.resolve(null)}}e.$c7b=P;class A{constructor(M){this.b=M}log(M,D){return this.b.call("log",{eventName:M,data:D}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$d7b=A}),define(te[51],ie([0,1,37,12,3,17,58,122,26]),function(Z,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$go=c;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ho=g,e.$io=new g;class w{async publicLog(n,r,p){}async publicLogError(n,r,p){}}e.$jo=w,e.$ko="telemetry",e.$lo="extensionTelemetryLog",e.$mo={log:()=>null,flush:()=>Promise.resolve(null)};function y(t,n){return s.Event.debounce(n.onDidChangeConfiguration,(p,C)=>{const R=p?new Set([...p.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:R}},1e3,!0)(p=>{p.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,M.$ki)(p.source),configurationKeys:Array.from(p.affectedKeys)})})}e.$no=y;function d(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}e.$oo=d;function v(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$po=v;function b(t){const n=t.getValue(f.$hl),r=t.getValue(f.$il);if(t.getValue(f.$jl)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$qo=b;function m(t){const n={},r={},p={};l(t,p);for(let C in p){C=C.length>150?C.substr(C.length-149):C;const R=p[C];typeof R=="number"?r[C]=R:typeof R=="boolean"?r[C]=R?1:0:typeof R=="string"?(R.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${R.length}`),n[C]=R.substring(0,8191)):typeof R<"u"&&R!==null&&(n[C]=R)}return{properties:n,measurements:r}}e.$ro=m;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const n=(0,D.$Tk)(t);return $.has(n)?n:"other"}e.$so=u;function l(t,n,r=0,p){if(t)for(const C of Object.getOwnPropertyNames(t)){const R=t[C],k=p?p+C:C;Array.isArray(R)?n[k]=(0,P.$8m)(R):R instanceof Date?n[k]=R.toISOString():(0,A.$zf)(R)?r<2?l(R,n,r+1,k+"."):n[k]=(0,P.$8m)(R):n[k]=R}}function E(t,n){const r=t.msftInternalDomains||[],p=n.getValue("telemetry.internalTesting");return(0,S.$fo)(r)||p}e.$to=E;function h(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$uo=h;function i(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const p=[];for(const I of n)for(;;){const L=I.exec(t);if(!L)break;p.push([L.index,I.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,R=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(r="";;){const I=R.exec(t);if(!I)break;const L=p.some(([N,z])=>I.index<z&&N<R.lastIndex);!C.test(I[0])&&!L&&(r+=t.substring(k,I.index)+"<REDACTED: user-file-path>",k=R.lastIndex)}return k<t.length&&(r+=t.substr(k)),r}function a(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function o(t,n){return(0,P.$5m)(t,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let p=r.replaceAll("%20"," ");p=i(p,n);for(const C of n)p=p.replace(C,"");return p=a(p),p}})}e.$vo=o}),define(te[123],ie([0,1,27,117,120,4,7,14,35,51]),function(Z,e,P,A,s,M,D,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0;function g(o,t){return o.uuid&&t.uuid?o.uuid===t.uuid:o.id===t.id?!0:(0,P.$Ve)(o.id,t.id)===0}e.$wo=g;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(t){const n=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new y(t.identifier,n,r)}static parse(t){const n=w.exec(t);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof y?g(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$xo=y;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(o){const t=d.exec(o);return t&&t[1]?[m(t[1]),t[2]]:[m(o),void 0]}e.$yo=v;function b(o,t){return`${o}.${t}`}e.$zo=b;function m(o){return o.toLowerCase()}e.$Ao=m;function $(o,t){return m(b(o??s.$Yl,t))}e.$Bo=$;function u(o,t){const n=[],r=p=>{for(const C of n)if(C.some(R=>g(t(R),t(p))))return C;return null};for(const p of o){const C=r(p);C?C.push(p):n.push([p])}return n}e.$Co=u;function l(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$Do=l;function E(o){return{id:new c.$go(o.identifier.id),name:new c.$go(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Eo=E,e.$Fo=new s.$3l("pprice.better-merge");function h(o,t){const n=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const p=r.shift();if(p&&n.every(C=>!g(C.identifier,{id:p}))){const C=o.filter(R=>g(R.identifier,{id:p}));C.length===1&&(n.push(C[0]),r.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Go=h;async function i(o,t){if(!M.$l)return!1;let n;try{n=(await o.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await o.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){t.debug("Error while getting the os-release file.",(0,S.$9)(p))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(o,t){const n=await i(o,t),r=(0,A.$2n)(n?"alpine":M.$u,f.$dc);return t.debug("ComputeTargetPlatform:",r),r}e.$Ho=a}),define(te[250],ie([0,1,204,51]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=void 0;async function s(M,D,S,f,c,g,w){const y={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${D.nameShort})`};if((0,A.$oo)(D,S)&&(0,A.$qo)(f)===3){const d=await(0,P.$9o)(S,c,g);y["X-Market-User-Id"]=d,y["VSCode-SessionId"]=w.machineId||d}return y}e.$0o=s}),define(te[251],ie([0,1,2,37,4,27,183,17,57,78,24,43,26,51]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,u,l){this.k=u,this.l=l,this.d={},this.i=new P.$Qc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=3,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,M.$Ee)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Ee)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(y.$hl)||E.affectsConfiguration(y.$jl)||E.affectsConfiguration(y.$il))&&this.m()}))}setExperimentProperty($,u){this.d[$]=u}m(){let $=(0,d.$qo)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const l=u.usage?3:u.error?2:0;$=Math.min($,l)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,u,l){this.g<u||(l=(0,A.$6m)(l,this.d),l=(0,d.$vo)(l,this.j),l=(0,A.$6m)(l,this.c),this.b.forEach(E=>E.log($,l)))}publicLog($,u){this.n($,3,u)}publicLog2($,u){this.publicLog($,u)}publicLogError($,u){this.h&&this.n($,2,u)}publicLogError2($,u){this.publicLogError($,u)}};e.$Xq=v,e.$Xq=v=ke([ee(1,S.$hi),ee(2,g.$nj)],v);function b(){const m=(0,D.localize)(0,null,c.default.nameLong),$=c.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=s.$p?"":(0,D.localize)(3,null),l=(0,D.localize)(4,null),E=(0,D.localize)(5,null),h=(0,D.localize)(6,null),i=(0,D.localize)(7,null),a=`
|       | ${l} | ${E} | ${h} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,D.localize)(8,null);return`
${m} ${$} ${u}

&nbsp;

${i}
${a}

&nbsp;

${o}
`}w.$cn.as(f.$hn.Configuration).registerConfiguration({id:y.$gl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[y.$hl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.$cn.as(f.$hn.Configuration).registerConfiguration({id:y.$gl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[y.$jl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,D.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,D.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${y.$hl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[252],ie([0,1,4,86,26]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=void 0;async function M(D,S){let f=D.getItem(s.$fl);return(typeof f!="string"||P.$k&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,A.$Pm)(S.error.bind(S))),f}e.$F7b=M}),define(te[253],ie([0,1,26,252]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=void 0;async function s(M,D){const S=await(0,A.$F7b)(M,D);return M.setItem(P.$fl,S),S}e.$G7b=s}),define(te[124],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(te[254],ie([0,1,4,124]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;const s=new Map([[A.EnvironmentVariableMutatorType.Append,"APPEND"],[A.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[A.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(g){this.collections=g,this.a=new Map,this.b=new Map,g.forEach((w,y)=>{this.d(w,y);const d=w.map.entries();let v=d.next();for(;!v.done;){const b=v.value[1],m=v.value[0];let $=this.a.get(m);if($||($=[],this.a.set(m,$)),$.length>0&&$[0].type===A.EnvironmentVariableMutatorType.Replace){v=d.next();continue}const u={extensionIdentifier:y,value:b.value,type:b.type,scope:b.scope,variable:b.variable,options:b.options};u.scope||delete u.scope,$.unshift(u),v=d.next()}})}async applyToProcessEnvironment(g,w,y){let d;P.$j&&(d={},Object.keys(g).forEach(v=>d[v.toLowerCase()]=v));for(const[v,b]of this.getVariableMap(w)){const m=P.$j&&d[v.toLowerCase()]||v;for(const $ of b){const u=y?await y($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case A.EnvironmentVariableMutatorType.Append:g[m]=(g[m]||"")+u;break;case A.EnvironmentVariableMutatorType.Prepend:g[m]=u+(g[m]||"");break;case A.EnvironmentVariableMutatorType.Replace:g[m]=u;break}if($.options?.applyAtShellIntegration??!1){const l=`VSCODE_ENV_${s.get($.type)}`;g[l]=(g[l]?g[l]+":":"")+v+"="+this.c(u)}}}}c(g){return g.replaceAll(":","\\x3a")}diff(g,w){const y=new Map,d=new Map,v=new Map;if(g.getVariableMap(w).forEach((b,m)=>{const $=this.getVariableMap(w).get(m),u=S(b,$);u&&y.set(m,u)}),this.getVariableMap(w).forEach((b,m)=>{const $=g.getVariableMap(w).get(m),u=S(b,$);u&&v.set(m,u)}),this.getVariableMap(w).forEach((b,m)=>{const $=g.getVariableMap(w).get(m),u=f(b,$);u&&d.set(m,u)}),!(y.size===0&&d.size===0&&v.size===0))return{added:y,changed:d,removed:v}}getVariableMap(g){const w=new Map;for(const y of this.a.values()){const d=y.filter(v=>D(v,g));d.length>0&&w.set(d[0].variable,d)}return w}getDescriptionMap(g){const w=new Map;for(const y of this.b.values()){const d=y.filter(v=>D(v,g,!0));for(const v of d)w.set(v.extensionIdentifier,v.description)}return w}d(g,w){if(!g.descriptionMap)return;const y=g.descriptionMap.entries();let d=y.next();for(;!d.done;){const v=d.value[1],b=d.value[0];let m=this.b.get(b);m||(m=[],this.b.set(b,m));const $={extensionIdentifier:w,scope:v.scope,description:v.description};$.scope||delete $.scope,m.push($),d=y.next()}}}e.$nr=M;function D(c,g,w=!1){return c.scope?!!(c.scope.workspaceFolder&&g?.workspaceFolder&&c.scope.workspaceFolder.index===g.workspaceFolder.index):w?g===c.scope:!0}function S(c,g){if(!g)return c;const w=new Set;g.forEach(d=>w.add(d.extensionIdentifier));const y=[];return c.forEach(d=>{w.has(d.extensionIdentifier)||y.push(d)}),y.length===0?void 0:y}function f(c,g){if(!g)return;const w=new Map;g.forEach(d=>w.set(d.extensionIdentifier,d));const y=[];return c.forEach(d=>{const v=w.get(d.extensionIdentifier);v&&(d.type!==v.type||d.value!==v.value||d.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index)&&y.push(v)}),y.length===0?void 0:y}}),define(te[255],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=e.$kr=e.$jr=e.$ir=e.$hr=void 0;function P(f){return[...f.entries()]}e.$hr=P;function A(f){return f?[...f.entries()]:[]}e.$ir=A;function s(f){return new Map(f)}e.$jr=s;function M(f){return new Map(f??[])}e.$kr=M;function D(f){return Array.from(f.entries()).map(c=>[c[0],P(c[1].map),A(c[1].descriptionMap)])}e.$lr=D;function S(f){return new Map(f.map(c=>[c[0],{map:s(c[1]),descriptionMap:M(c[2])}]))}e.$mr=S}),define(te[256],ie([0,1,8,22,3,2,5]),function(Z,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;let S=class extends M.$Rc{constructor(c,g){super(),this.h=g,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Md),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,M.$Pc)(()=>{for(const w of this.f.values())(0,M.$Mc)(w)}))}createRequest(c){return new Promise((g,w)=>{const y=++this.a;this.c.set(y,g),this.g.fire({requestId:y,...c});const d=new A.$Wd;(0,P.$Tg)(this.b,d.token).then(()=>w(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,M.$Pc)(()=>d.cancel())])})}acceptReply(c,g){const w=this.c.get(c);w?(this.c.delete(c),(0,M.$Mc)(this.f.get(c)||[]),this.f.delete(c),w(g)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$$q=S,e.$$q=S=ke([ee(1,D.$8i)],S)}),define(te[125],ie([0,1,6,114,43]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$4q=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$3q=void 0,e.$3q=new A.$5i("terminalTabFocusMode",!1,!0);var M;(function(h){h.AutomationProfile="terminal.integrated.automationProfile.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var D;(function(h){h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsDefaultColor="terminal.integrated.tabs.defaultColor",h.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.TabStopWidth="terminal.integrated.tabStopWidth",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorStyleInactive="terminal.integrated.cursorStyleInactive",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.TabFocusMode="terminal.integrated.tabFocusMode",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.HideOnStartup="terminal.integrated.hideOnStartup",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",h.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",h.EnableImages="terminal.integrated.enableImages",h.SmoothScrolling="terminal.integrated.smoothScrolling",h.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",h.FocusAfterRun="terminal.integrated.focusAfterRun",h.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",h.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",h.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",h.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var S;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh"})(S||(e.PosixShellType=S={}));var f;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var c;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var g;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.PtyHostWindow="ptyHostWindow",h.Logger="logger",h.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var w;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation",h.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.$4q=(0,P.$Nh)("ptyService");var y;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var d;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var v;(function(h){h.TerminalView="view",h.Editor="editor"})(v||(e.TerminalLocationString=v={}));var b;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(b||(e.LocalReconnectConstants=b={}));var m;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var $;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var u;(function(h){h[h.Off=0]="Off",h[h.FinalTerm=1]="FinalTerm",h[h.VSCode=2]="VSCode"})(u||(e.ShellIntegrationStatus=u={}));var l;(function(h){h[h.Unknown=0]="Unknown",h[h.Shutdown=1]="Shutdown",h[h.Process=2]="Process",h[h.User=3]="User",h[h.Extension=4]="Extension"})(l||(e.TerminalExitReason=l={})),e.$5q={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const a=this.b(i.remoteAuthority);if(this.a.has(a))throw new Error(`A terminal backend with remote authority '${a}' was already registered.`);this.a.set(a,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}s.$cn.add(e.$5q.Backend,new E),e.$6q=(0,P.$Nh)("localPtyService"),e.$7q=(0,P.$Nh)("terminalLogService")}),define(te[257],ie([0,1,74,7,185,102]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=e.$ar=e.$_q=void 0;function D(y,d){const v=[{name:null,description:(0,s.localize)(0,null)}];return v.push(...y.map(b=>({name:b.profileName,description:S(b)}))),d&&v.push(...d.map(b=>({name:b.title,description:f(b)}))),{values:v.map(b=>b.name),markdownDescriptions:v.map(b=>b.description)}}e.$_q=D;function S(y){let d=`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:P.$Sj.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?d+=`
- args: "${y.args}"`:d+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(d+=`
- overrideName: ${y.overrideName}`),y.color&&(d+=`
- color: ${y.color}`),y.env&&(d+=`
- env: ${JSON.stringify(y.env)}`),d}function f(y){return`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:P.$Sj.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function c(y,d){if(!y&&!d)return!0;if(typeof y=="string"&&typeof d=="string")return y===d;if(Array.isArray(y)&&Array.isArray(d)){if(y.length!==d.length)return!1;for(let v=0;v<y.length;v++)if(y[v]!==d[v])return!1;return!0}return!1}e.$ar=c;function g(y,d){if(!y&&!d)return!0;if(!y||!d)return!1;if(M.ThemeIcon.isThemeIcon(y)&&M.ThemeIcon.isThemeIcon(d))return y.id===d.id&&y.color===d.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof d=="object"&&"light"in d&&"dark"in d){const v=y,b=d;if((A.URI.isUri(v.light)||w(v.light))&&(A.URI.isUri(v.dark)||w(v.dark))&&(A.URI.isUri(b.light)||w(b.light))&&(A.URI.isUri(b.dark)||w(b.dark)))return v.light.path===b.light.path&&v.dark.path===b.dark.path}if(A.URI.isUri(y)&&A.URI.isUri(d)||w(y)||w(d)){const v=y,b=d;return v.path===b.path&&v.scheme===b.scheme}return!1}e.$br=g;function w(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.$cr=w}),define(te[258],ie([0,1,74,4,184,57,43,257]),function(Z,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=e.$er=e.$dr=void 0,e.$dr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$er={type:"string",enum:Array.from((0,P.$Rj)(),m=>m.id),markdownEnumDescriptions:Array.from((0,P.$Rj)(),m=>`$(${m.id})`)};const f={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$er},color:{description:(0,s.localize)(3,null),...e.$dr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},g={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function w(m){const $=m===2?"linux":m===1?"osx":"windows";return(0,s.localize)(7,null,(0,A.$i)(m),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:w(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...f}},{type:"null"},c]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:w(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...f}},{type:"null"},c]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:w(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...f}},{type:"null"},c]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){D.$cn.as(M.$hn.Configuration).registerConfiguration(y),b()}e.$fr=d;let v;function b(m,$){const u=D.$cn.as(M.$hn.Configuration);let l;m&&(l=(0,S.$_q)(m?.profiles,$));const E=v;v={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:m?.os===3?l?.values:void 0,markdownEnumDescriptions:m?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:m?.os===2?l?.values:void 0,markdownEnumDescriptions:m?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:m?.os===1?l?.values:void 0,markdownEnumDescriptions:m?.os===1?l?.markdownDescriptions:void 0}}},u.updateConfigurations({add:[v],remove:E?[E]:[]})}e.$gr=b}),define(te[259],ie([0,1,28,13,37,9,4,35,27,12,21,124,255,254]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=e.$or=void 0;function v(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return t&&t.length===4&&(n=parseInt(t[3])),n}e.$or=v;async function b(t,n,r,p=S.env,C=g.Promises.exists){if(M.$hc(t))return await C(t)?t:void 0;if(n===void 0&&(n=S.cwd()),M.$lc(t)!=="."){const L=M.$ic(n,t);return await C(L)?L:void 0}const k=(0,s.$0m)(p,"PATH");if(r===void 0&&(0,c.$xf)(k)&&(r=k.split(M.$sc)),r===void 0||r.length===0){const L=M.$ic(n,t);return await C(L)?L:void 0}for(const L of r){let N;if(M.$hc(L)?N=M.$ic(L,t):N=M.$ic(n,L,t),await C(N))return N;if(D.$j){let z=N+".com";if(await C(z)||(z=N+".exe",await C(z)))return z}}const I=M.$ic(n,t);return await C(I)?I:void 0}e.$pr=b;function m(t,n,r,p,C){const R=D.$j&&(!n.windowsEnableConpty||v()<18309);if(!n.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||R)return;const k=t.args,I=S.$cc==="win32"?M.$mc(t.executable).toLowerCase():M.$mc(t.executable),L=M.$lc(A.$bg.asFileUri("").fsPath);let N;const z={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(z.VSCODE_NONCE=n.shellIntegration.nonce),D.$j){if(I==="pwsh.exe"||I==="powershell.exe")return!k||a(k)?N=l.get(u.WindowsPwsh):i(k)&&(N=l.get(u.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,f.$Be)(N[N.length-1],L,""),{newArgs:N,envMixin:z}):void 0;p.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(I){case"bash":return!k||k.length===0?N=l.get(u.Bash):o(k)&&(z.VSCODE_SHELL_LOGIN="1",$(n,z),N=l.get(u.Bash)),N?(N=[...N],N[N.length-1]=(0,f.$Be)(N[N.length-1],L),{newArgs:N,envMixin:z}):void 0;case"fish":{const ne=r?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",_=M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${ne}:${_}`,$(n,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!k||a(k)?N=l.get(u.Pwsh):i(k)&&(N=l.get(u.PwshLogin)),N?(N=[...N],N[N.length-1]=(0,f.$Be)(N[N.length-1],L,""),{newArgs:N,envMixin:z}):void 0;case"zsh":{if(!k||k.length===0?N=l.get(u.Zsh):o(k)?(N=l.get(u.ZshLogin),$(n,z)):(k===l.get(u.Zsh)||k===l.get(u.ZshLogin))&&(N=k),!N)return;N=[...N],N[N.length-1]=(0,f.$Be)(N[N.length-1],L);let ne;try{ne=P.userInfo().username}catch{ne="unknown"}const _=M.$ic(P.tmpdir(),`${ne}-${C.applicationName}-zsh`);z.ZDOTDIR=_;const ae=r?.ZDOTDIR??P.homedir()??"~";z.USER_ZDOTDIR=ae;const se=[];return se.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$ic(_,".zshrc")}),se.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$ic(_,".zprofile")}),se.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$ic(_,".zshenv")}),se.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$ic(_,".zlogin")}),{newArgs:N,envMixin:z,filesToCopy:se}}}p.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.$qr=m;function $(t,n){if(D.$k&&t.environmentVariableCollections){const r=(0,y.$mr)(t.environmentVariableCollections),C=new d.$nr(r).getVariableMap({workspaceFolder:t.workspaceFolder}).get("PATH"),R=[];if(C)for(const k of C)k.type===w.EnvironmentVariableMutatorType.Prepend&&R.push(k.value);R.length>0&&(n.VSCODE_PATH_PREFIX=R.join(""))}}var u;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(u||(u={}));const l=new Map;l.set(u.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(u.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),l.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),l.set(u.Zsh,["-i"]),l.set(u.ZshLogin,["-il"]),l.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],h=["-nol","-nologo"];function i(t){return typeof t=="string"?E.includes(t.toLowerCase()):t.length===1&&E.includes(t[0].toLowerCase())||t.length===2&&(E.includes(t[0].toLowerCase())||E.includes(t[1].toLowerCase()))&&(h.includes(t[0].toLowerCase())||h.includes(t[1].toLowerCase()))}function a(t){return typeof t=="string"?h.includes(t.toLowerCase()):t.length===0||t?.length===1&&h.includes(t[0].toLowerCase())}function o(t){return t==="string"&&E.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&E.includes(t[0].toLowerCase())}}),define(te[260],ie([0,1,47,74,9,4,12,21,106,259,113]),function(Z,e,P,A,s,M,D,S,f,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;let w,y=!0;function d(n,r,p,C,R=process.env,k,I,L,N){return k=k||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},M.$j?v(p,k,R,I,C.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:C.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:C.getValue("terminal.integrated.defaultProfile.windows"),N,L):a(k,I,p,n&&typeof n=="object"?{...n}:C.getValue(M.$l?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:C.getValue(M.$l?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),N,L,R)}e.$rr=d;async function v(n,r,p,C,R,k,I,L,N){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ne=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let _=!1;(0,c.$or)()>=16299&&(_=!0),await u(L);const ae=new Map;if(n){ae.set("PowerShell",{source:"PowerShell",icon:A.$Sj.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${ne}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.$Sj.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${ne}\\cmd.exe`,icon:A.$Sj.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:A.$Sj.terminalBash,isAutoDetected:!0});const oe=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${ne}\\cmd.exe`,args:["/K",oe],requiresPath:process.env.CMDER_ROOT?oe:{path:oe,isUnsafe:!0},isAutoDetected:!0})}o(k,ae);const se=await b(ae.entries(),I,r,p,C,N);if(n&&R)try{const oe=await h(`${ne}\\${_?"wsl":"bash"}.exe`,I);for(const J of oe)(!k||!(J.profileName in k))&&se.push(J)}catch{y&&(C?.info("WSL is not installed, so could not detect WSL profiles"),y=!1)}return se}async function b(n,r,p,C=process.env,R,k){const I=[];for(const[L,N]of n)I.push(m(L,N,r,p,C,R,k));return(await Promise.all(I)).filter(L=>!!L)}async function m(n,r,p,C,R=process.env,k,I){if(r===null)return;let L,N,z;if("source"in r&&!("path"in r)){const se=w?.get(r.source);if(!se)return;L=se.paths,N=r.args||se.args,r.icon?z=$(r.icon):se.icon&&(z=se.icon)}else L=Array.isArray(r.path)?r.path:[r.path],N=M.$j||Array.isArray(r.args)?r.args:void 0,z=$(r.icon);let ne;if(I){const se=L.map(J=>typeof J=="string"?J:J.path),oe=await I(se);ne=new Array(L.length);for(let J=0;J<L.length;J++)typeof L[J]=="string"?ne[J]=oe[J]:ne[J]={path:oe[J],isUnsafe:!0}}else ne=L.slice();let _;if(r.requiresPath){let se;if((0,D.$xf)(r.requiresPath)?se=r.requiresPath:(se=r.requiresPath.path,r.requiresPath.isUnsafe&&(_=se)),!await C.existsFile(se))return}const ae=await t(n,p,ne,C,R,N,r.env,r.overrideName,r.isAutoDetected,_);if(!ae){k?.debug("Terminal profile not validated",n,L);return}return ae.isAutoDetected=r.isAutoDetected,ae.icon=z,ae.color=r.color,ae}function $(n){return typeof n=="string"?{id:n}:n}async function u(n){if(w&&!n)return;const[r,p]=await Promise.all([l(),n||E()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:r,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:p,icon:A.$Sj.terminalPowershell})}async function l(){const n=new Set,r=await(0,c.$pr)("git.exe");if(r){const R=(0,g.dirname)(r);n.add((0,g.resolve)(R,"../.."))}function p(R,k){k&&R.add(k)}p(n,process.env.ProgramW6432),p(n,process.env.ProgramFiles),p(n,process.env["ProgramFiles(X86)"]),p(n,`${process.env.LocalAppData}\\Program`);const C=[];for(const R of n)C.push(`${R}\\Git\\bin\\bash.exe`,`${R}\\Git\\usr\\bin\\bash.exe`,`${R}\\usr\\bin\\bash.exe`);return C.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),C.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),C}async function E(){const n=[];for await(const r of(0,f.$ul)())n.push(r.exePath);return n}async function h(n,r){const p=[],C=await new Promise((I,L)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(N,z)=>{if(N)return L("Problem occurred when getting wsl distros");I(z)})});if(!C)return[];const R=new RegExp(/[\r?\n]/),k=C.split(R).filter(I=>I.trim().length>0&&I!=="");for(const I of k){if(I===""||I.startsWith("docker-desktop"))continue;const L=`${I} (WSL)`,N={profileName:L,path:n,args:["-d",`${I}`],isDefault:L===r,icon:i(I),isAutoDetected:!1};p.push(N)}return p}function i(n){return n.includes("Ubuntu")?A.$Sj.terminalUbuntu:n.includes("Debian")?A.$Sj.terminalDebian:A.$Sj.terminalLinux}async function a(n,r,p,C,R,k,I,L){const N=new Map;if(p){const z=(await n.readFile("/etc/shells")).toString(),ne=(k||z.split(`
`)).map(ae=>{const se=ae.indexOf("#");return se===-1?ae:ae.substring(0,se)}).filter(ae=>ae.trim().length>0),_=new Map;for(const ae of ne){let se=(0,s.$mc)(ae),oe=_.get(se)||0;oe++,oe>1&&(se=`${se} (${oe})`),_.set(se,oe),N.set(se,{path:ae,isAutoDetected:!0})}}return o(C,N),await b(N.entries(),R,n,L,r,I)}function o(n,r){if(n)for(const[p,C]of Object.entries(n))C===null||typeof C!="object"||!("path"in C)&&!("source"in C)?r.delete(p):(C.icon=C.icon||r.get(p)?.icon,r.set(p,C))}async function t(n,r,p,C,R,k,I,L,N,z){if(p.length===0)return Promise.resolve(void 0);const ne=p.shift();if(ne==="")return t(n,r,p,C,R,k,I,L,N);const _=typeof ne!="string"&&ne.isUnsafe,ae=typeof ne=="string"?ne:ne.path,se={profileName:n,path:ae,args:k,env:I,overrideName:L,isAutoDetected:N,isDefault:n===r,isUnsafePath:_,requiresUnsafePath:z};if((0,s.$mc)(ae)===ae){const J=R.PATH?R.PATH.split(s.$sc):void 0,K=await(0,c.$pr)(ae,void 0,J,void 0,C.existsFile);return K?(se.path=K,se.isFromPath=!0,se):t(n,r,p,C,R,k)}return await C.existsFile((0,s.$gc)(ae))?se:t(n,r,p,C,R,k,I,L,N)}}),define(te[261],ie([0,1,3,2,4,42,17,5,224,93,256,125,258,260,108,72]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;var m;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let $=class extends A.$Rc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(l,E,h,i){super(),this.M=l,this.N=E,this.O=h,this.P=i,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new P.$Md),this.onPtyHostExit=this.u.event,this.w=this.B(new P.$Md),this.onPtyHostStart=this.w.event,this.y=this.B(new P.$Md),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new P.$Md),this.onPtyHostResponsive=this.z.event,this.C=this.B(new P.$Md),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new P.$Md),this.onProcessData=this.D.event,this.F=this.B(new P.$Md),this.onProcessReady=this.F.event,this.G=this.B(new P.$Md),this.onProcessReplay=this.G.event,this.H=this.B(new P.$Md),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new P.$Md),this.onDidRequestDetach=this.I.event,this.J=this.B(new P.$Md),this.onDidChangeProperty=this.J.event,this.L=this.B(new P.$Md),this.onProcessExit=this.L.event,(0,y.$fr)(),this.B(this.M),this.B((0,A.$Pc)(()=>this.W())),this.j=this.B(new g.$$q(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&P.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$j)return process.env;try{return await(0,c.$Ql)(this.N,this.O,{_:[]},process.env)}catch(l){return this.O.error("ptyHost was unable to resolve shell environment",l),{}}}U(){const l=this.M.start(),E=l.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(l.onDidProcessExit(a=>{this.u.fire(a.code),!this.m&&!this.q.isDisposed&&(this.n<=m.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const i=M.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.PtyHost));return this.B(i.onProcessData(a=>this.D.fire(a))),this.B(i.onProcessReady(a=>this.F.fire(a))),this.B(i.onProcessExit(a=>this.L.fire(a))),this.B(i.onDidChangeProperty(a=>this.J.fire(a))),this.B(i.onProcessReplay(a=>this.G.fire(a))),this.B(i.onProcessOrphanQuestion(a=>this.H.fire(a))),this.B(i.onDidRequestDetach(a=>this.I.fire(a))),this.B(new f.$0q(this.P,E.getChannel(w.TerminalIpcChannels.Logger))),this.a=l,this.b=i,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[l,i]}async createProcess(l,E,h,i,a,o,t,n,r,p,C){const R=setTimeout(()=>this.$(),w.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(l,E,h,i,a,o,t,n,r,p,C);return clearTimeout(R),k}updateTitle(l,E,h){return this.f.updateTitle(l,E,h)}updateIcon(l,E,h,i){return this.f.updateIcon(l,E,h,i)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,E){return this.f.detachFromProcess(l,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,E){return this.f.shutdown(l,E)}input(l,E){return this.f.input(l,E)}processBinary(l,E){return this.f.processBinary(l,E)}resize(l,E,h){return this.f.resize(l,E,h)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,E){return this.f.acknowledgeDataEvent(l,E)}setUnicodeVersion(l,E){return this.f.setUnicodeVersion(l,E)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}async getLatency(){const l=new b.$Id,E=await this.f.getLatency();return l.stop(),[{label:"ptyhostservice<->ptyhost",latency:l.elapsed()},...E]}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,E){return this.f.installAutoReply(l,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.g?.getDefaultSystemShell(l)??(0,v.$Al)(l??s.OS,process.env)}async getProfiles(l,E,h,i=!1){const a=await this.S();return(0,d.$rr)(E,h,i,this.N,a,void 0,this.O,this.bb.bind(this,l))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(l,E){return this.f.getWslPath(l,E)}getRevivedPtyNewId(l,E){return this.f.getRevivedPtyNewId(l,E)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return this.g?.getTerminalLayoutInfo(l)}async requestDetachInstance(l,E){return this.f.requestDetachInstance(l,E)}async acceptDetachInstanceReply(l,E){return this.f.acceptDetachInstanceReply(l,E)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,E,h){return this.f.reviveTerminalProcesses(l,E,h)}async refreshProperty(l,E){return this.f.refreshProperty(l,E)}async updateProperty(l,E,h){return this.f.updateProperty(l,E,h)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(l){this.ab(),this.s=setTimeout(()=>this.Y(),l?w.HeartbeatConstants.ConnectingBeatInterval:w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier+w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${w.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(l,E){return this.j.createRequest({workspaceId:l,originalText:E})}async acceptPtyHostResolvedVariables(l,E){this.j.acceptReply(l,E)}};e.$sr=$,e.$sr=$=ke([ee(1,D.$hi),ee(2,S.$8i),ee(3,S.$9i)],$)}),define(te[68],ie([0,1,15,3,2,4,17,6,34]),function(Z,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d6b=e.$c6b=void 0;const c="#FFFFFF",g="#1E1E1E",w="#000000",y="#FFFFFF",d="theme",v="themeBackground",b="windowSplash";e.$c6b=(0,S.$Nh)("themeMainService");let m=class extends s.$Rc{constructor(u,l){super(),this.b=u,this.c=l,this.a=this.B(new A.$Md),this.onDidChangeColorScheme=this.a.event,P.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$j){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$k){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$l&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const u=this.getColorScheme();if(u.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return u.dark?w:y;let l=this.b.getItem(v,null);if(!l)switch(this.b.getItem(d,"vs-dark").split(" ")[0]){case"vs":l=c;break;case"hc-black":l=w;break;case"hc-light":l=y;break;default:l=g}return M.$k&&l.toUpperCase()===g&&(l="#171717"),l}saveWindowSplash(u,l){this.b.setItems([{key:d,data:l.baseTheme},{key:v,data:l.colorInfo.background},{key:b,data:l}]),typeof u=="number"&&this.f(u,l)}f(u,l){for(const E of P.BrowserWindow.getAllWindows())if(E.id===u){E.setBackgroundColor(l.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(b)}};e.$d6b=m,e.$d6b=m=ke([ee(0,f.$qN),ee(1,D.$hi)],m)}),define(te[126],ie([0,1,3,17,6,5]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.ProvidedOnAutoForward=e.$7u=e.TunnelPrivacyId=e.TunnelProtocol=e.$6u=e.$5u=void 0,e.$5u=(0,s.$Nh)("tunnelService"),e.$6u=(0,s.$Nh)("sharedTunnelsService");var D;(function(m){m.Http="http",m.Https="https"})(D||(e.TunnelProtocol=D={}));var S;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(S||(e.TunnelPrivacyId=S={}));function f(m){return!!m.forwardPort}e.$7u=f;var c;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function g(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const $=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if($)return{address:$[1],port:+$[2]}}e.$8u=g,e.$9u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(m){return e.$9u.indexOf(m)>=0}e.$0u=w,e.$$u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(m){return e.$$u.indexOf(m)>=0}e.$_u=y;function d(m,$,u,l){if(u===1)return!1;if(u===2&&y($)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(E?.length===4&&parseInt(E[1])>=18)return!1}return m<1024}e.$av=d;class v{constructor($,u,l){this.remoteAddress=$,this.localAddress=u,this.b=l,this.a=new P.$Md,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$bv=v;let b=class{constructor($,u){this.j=$,this.k=u,this.a=new P.$Md,this.onTunnelOpened=this.a.event,this.b=new P.$Md,this.onTunnelClosed=this.b.event,this.c=new P.$Md,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const $=this.k.getValue("remote.localPortHost");return!$||$==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider($){return this.f=$,$?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures($){this.g=$.elevation,this.h=$.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const $=[],u=Array.from(this.e.values());for(const l of u){const E=Array.from(l.values());for(const h of E){const i=await h.value;i&&typeof i!="string"&&$.push(i)}}return $}async dispose(){for(const $ of this.e.values()){for(const{value:u}of $.values())await u.then(l=>typeof l!="string"?l?.dispose():void 0);$.clear()}this.e.clear()}setEnvironmentTunnel($,u,l,E,h){this.p($,u,Promise.resolve({tunnelRemoteHost:$,tunnelRemotePort:u,localAddress:l,privacy:E,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel($,u){(y($)||w($))&&($=e.$9u[0]);const l=this.r($,u);if(l)return++l.refcount,l.value}openTunnel($,u,l,E,h,i=!1,a,o){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${l} on local port ${h}.`);const t=this.f??$;if(!t)return;if(u||(u="localhost"),E||(E=this.l),this.f&&this.i.has(l)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(t,u,l,E,h,i,a,o);return n?n.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(u,l),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(u,l);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.n(r);return(r.tunnelRemoteHost!==u||r.tunnelRemotePort!==l)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&r.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n($){return{tunnelRemotePort:$.tunnelRemotePort,tunnelRemoteHost:$.tunnelRemoteHost,tunnelLocalPort:$.tunnelLocalPort,localAddress:$.localAddress,privacy:$.privacy,protocol:$.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${$.tunnelRemoteHost}:${$.tunnelRemotePort} `);const u=this.e.get($.tunnelRemoteHost);if(u){const l=u.get($.tunnelRemotePort);l&&(l.refcount--,await this.o($.tunnelRemoteHost,$.tunnelRemotePort,l))}}}}async o($,u,l){if(l.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${$}:${u}.`);const E=l.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has($)&&this.e.get($).delete(u),E}}async closeTunnel($,u){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${$}:${u} `);const l=this.e.get($);if(l&&l.has(u)){const E=l.get(u);E.refcount=0,await this.o($,u,E)}}p($,u,l){this.e.has($)||this.e.set($,new Map),this.e.get($).set(u,{refcount:1,value:l})}async q($,u){const l=this.e.get($);if(l){const E=l.get(u),h=E?await E.value:void 0;(!h||typeof h=="string")&&l.delete(u),l.size===0&&this.e.delete($)}}r($,u){const l=[$];w($)?(l.push(...e.$9u),l.push(...e.$$u)):y($)&&l.push(...e.$$u);const E=l.map(h=>this.e.get(h));for(const h of E){const i=h?.get(u);if(i)return i}}canTunnel($){return!!g($)}t($,u,l,E,h,i,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${l} on local port ${E}.`);const o=l;this.i.add(o);const t=E===void 0?l:E,n={elevationRequired:h?this.isPortPrivileged(t):!1},r={remoteAddress:{host:u,port:l},localAddressPort:E,privacy:i,public:i?i!==S.Private:void 0,protocol:a},p=$.forwardPort(r,n);return p?(this.p(u,l,p),p.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(o)})):this.i.delete(o),p}};e.$cv=b,e.$cv=b=ke([ee(0,M.$8i),ee(1,A.$hi)],b)}),define(te[48],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dU=e.$cU=e.DisablementReason=e.UpdateType=e.StateType=void 0;var A;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(A||(e.StateType=A={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$cU={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,S)=>({type:"idle",updateType:D,error:S}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$dU=(0,P.$Nh)("updateService")}),define(te[262],ie([0,1,4,186,57,43]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$cn.as(s.$hn.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:P.$j&&!P.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[263],ie([0,1,3,48]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=e.$e7b=void 0;class s{constructor(S){this.a=S}listen(S,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(S,f,c){switch(f){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${f}`)}}e.$e7b=s;class M{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new P.$Md,this.onStateChange=this.a.event,this.b=A.$cU.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$f7b=M}),define(te[40],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=void 0,e.$Gk=(0,P.$Nh)("IUriIdentityService")}),define(te[264],ie([0,1,40,205,16,19,139,3,2]),function(Z,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;class c{static{this._clock=0}constructor(y){this.uri=y,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let g=class{constructor(y){this.g=y,this.c=new f.$Qc,this.f=2**16;const d=new Map,v=b=>{let m=d.get(b.scheme);return m===void 0&&(m=y.hasProvider(b)&&!this.g.hasCapability(b,1024),d.set(b.scheme,m)),m};this.c.add(S.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(b=>{d.delete(b.scheme)})),this.extUri=new M.$jg(v),this.d=new D.$vr((b,m)=>this.extUri.compare(b,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,M.$vg)(y));const d=this.d.get(y);return d?d.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new c(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((v,b)=>v[1].time<b[1].time?1:v[1].time>b[1].time?-1:0);c._clock=0,this.d.clear();const d=this.f*.5;for(let v=0;v<d;v++)this.d.set(y[v][0],y[v][1].touch())}};e.$wr=g,e.$wr=g=ke([ee(0,s.$9j)],g),(0,A.$tr)(P.$Gk,g,1)}),define(te[127],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4T=void 0,e.$4T=(0,P.$Nh)("urlService")}),define(te[265],ie([0,1,7]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o7b=e.$n7b=e.$m7b=void 0;class A{constructor(S){this.a=S}listen(S,f){throw new Error(`Event not found: ${f}`)}call(S,f,c){switch(f){case"handleURL":return this.a.handleURL(P.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${f}`)}}e.$m7b=A;class s{constructor(S){this.a=S}handleURL(S,f){return this.a.call("handleURL",[S.toJSON(),f])}}e.$n7b=s;class M{constructor(S,f){this.a=S,this.b=f}async routeCall(S,f,c,g){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(c)&&c.length>0){const w=P.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",w.toString(!0)),w.query){const y=/\bwindowId=(\d+)/.exec(w.query);if(y){const d=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,w.toString(!0));const v=new RegExp(`window:${d}`),b=S.connections.find(m=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",m.ctx),v.test(m.ctx)));if(b)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",w.toString(!0)),b;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",w.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",w.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,f,c,g)}routeEvent(S,f){throw new Error(`Event not found: ${f}`)}}e.$o7b=M}),define(te[266],ie([0,1,8,2,7,24]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6T=e.$5T=void 0;class D extends A.$Rc{constructor(){super(...arguments),this.a=new Set}open(c,g){const w=[...this.a.values()];return(0,P.$Wg)(w.map(y=>()=>y.handleURL(c,g)),void 0,!1).then(y=>y||!1)}registerHandler(c){return this.a.add(c),(0,A.$Pc)(()=>this.a.delete(c))}}e.$5T=D;let S=class extends D{constructor(c){super(),this.b=c}create(c){let{authority:g,path:w,query:y,fragment:d}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&w&&w.indexOf("/")!==0&&(w=`/${w}`),s.URI.from({scheme:this.b.urlProtocol,authority:g,path:w,query:y,fragment:d})}};e.$6T=S,e.$6T=S=ke([ee(0,M.$nj)],S)}),define(te[267],ie([0,1,15,8,3,2,4,7]),function(Z,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=void 0;class f extends M.$Rc{constructor(g,w,y,d,v,b){if(super(),this.c=w,this.f=b,this.a=[],this.b=0,g&&(b.trace("ElectronURLListener initialUrisToHandle:",g.map(u=>u.originalUrl)),this.a=g),D.$j){const u=d.isBuilt?[]:[`"${d.appRoot}"`];u.push("--open-url","--"),P.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,u)}const m=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(u,l)=>({event:u,url:l})),({event:u,url:l})=>(u.preventDefault(),l));this.B(m(u=>{const l=this.g(u);l&&this.c.open(l,{originalUrl:u})})),y.getWindows().filter(u=>u.isReady).length>0?(b.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(b.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(y.onDidSignalReadyWindow)(()=>this.h())))}g(g){try{return S.URI.parse(g)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const w of this.a)await this.c.open(w.uri,{originalUrl:w.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",w.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",w.originalUrl),g.push(w));g.length!==0&&(this.a=g,(0,A.$Ug)(()=>this.h(),500,this.q))}}e.$p7b=f}),define(te[268],ie([0,1,3,2,16,56,31]),function(Z,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=void 0;class S extends A.$Rc{constructor(c,g,w,y,d,v){super(),this.f=c,this.g=g,this.h=w,this.j=y,this.m=d,this.n=v,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$Md),this.onDidChangeFile=this.a.event,this.b=M.$Th.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Ac(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,g){return this.g.open(this.t(c),g)}close(c){return this.g.close(c)}read(c,g,w,y,d){return this.g.read(c,g,w,y,d)}write(c,g,w,y,d){return this.g.write(c,g,w,y,d)}watch(c,g){this.b.set(c,c);const w=this.g.watch(this.t(c),g);return(0,A.$Pc)(()=>{this.b.delete(c),w.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,g,w){return this.g.rename(this.t(c),this.t(g),w)}readFile(c,g){return this.g.readFile(this.t(c),g)}readFileStream(c,g,w){return this.g.readFileStream(this.t(c),g,w)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,g,w){return this.g.writeFile(this.t(c),g,w)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,g){return this.g.delete(this.t(c),g)}copy(c,g,w){if((0,s.$ak)(this.g))return this.g.copy(this.t(c),this.t(g),w);throw new Error("copy not supported")}cloneFile(c,g){if((0,s.$bk)(this.g))return this.g.cloneFile(this.t(c),this.t(g));throw new Error("clone not supported")}s(c){const g=[];for(const w of c){if(w.resource.scheme!==this.f)continue;const y=this.u(w.resource);this.b.findSubstr(y)&&g.push({resource:y,type:w.type,cId:w.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$27b=S}),define(te[269],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I7b=void 0,e.$I7b="utilityProcessWorker"}),define(te[270],ie([0,1,6]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=void 0,e.$q7b=(0,P.$Nh)("webviewManagerService")}),define(te[271],ie([0,1,15,2,13,7]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r7b=void 0;class D extends A.$Rc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,c){try{const g=M.URI.parse(f.url),w=D.a.get(g.path);if(typeof w=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${w}`,d=s.$bg.asFileUri(y);return c({path:d.fsPath,headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$r7b=D}),define(te[59],ie([0,1,4]),function(Z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=void 0,e.$WC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(g){return!!g.workspaceUri}e.$XC=A;function s(g){return!!g.folderUri}e.$YC=s;function M(g){return!!g.fileUri}e.$ZC=M;function D(g){const w=S(g),y=g.getValue("window.menuBarVisibility");return y==="default"||w==="native"&&y==="compact"||P.$k&&P.$n?"classic":y}e.$1C=D;function S(g){if(P.$p)return"custom";const w=g.getValue("window");if(w){if(P.$k&&w.nativeTabs===!0||P.$k&&w.nativeFullScreen===!1)return"native";const v=w.titleBarStyle;if(v==="native"||v==="custom")return v}return P.$l?"native":"custom"}e.$2C=S;function f(g){return!(!P.$j||P.$p||S(g)==="native")}e.$3C=f;function c(g=0){return Math.pow(1.2,g)}e.$4C=c}),define(te[95],ie([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Z5b=e.UnloadReason=e.LoadReason=void 0;var P;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var A;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(A||(e.UnloadReason=A={}));const s=function(S=1){return{width:1024,height:768,mode:S}};e.$Z5b=s;var M;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var D;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(te[272],ie([0,1,8,3,2]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=void 0;class M extends s.$Rc{constructor({onDidOpenWindow:S,onDidFocusWindow:f,getActiveWindowId:c}){super(),this.a=this.B(new s.$Qc),A.Event.latch(A.Event.any(S,f))(this.f,this,this.a),this.b=(0,P.$Gg)(()=>c()),(async()=>{try{const w=await this.b;this.c=typeof this.c=="number"?this.c:w}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$y7b=M}),define(te[29],ie([0,1,190,9,56,19,7,6,13]),function(Z,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,S.$Nh)("contextService");function c(t){const n=t;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$Xh=c;function g(t){return typeof t?.id=="string"&&!c(t)&&!y(t)}e.$Yh=g,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function w(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,A.$mc)(t)}:n?e.$Zh:e.$1h;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$2h=w;function y(t){const n=t;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$3h=y;function d(t){const n=t;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}e.$4h=d;var v;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function b(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$5h=b;function m(t){const n=t;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$6h=m;class ${constructor(n,r,p,C,R){this.h=n,this.j=p,this.k=C,this.l=R,this.c=s.$Th.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Th.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=$;class u{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$ug)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=u;function l(t){return new u({uri:t,index:0,name:(0,M.$qg)(t)},{uri:t.toString()})}e.$9h=l,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,P.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function E(t,n){return M.$lg.isEqualOrParent(t,n.untitledWorkspacesHome)}e.$bi=E;function h(t){let n;return D.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===f.Schemas.tmp}e.$ci=h,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$di}e.$ei=i;function a(t,n){return!E(t,n)&&!h(t)}e.$fi=a;function o(t){return(typeof t=="string"?(0,A.$nc)(t):(0,M.$sg)(t))===e.$$h}e.$gi=o}),define(te[60],ie([0,1,15,8,55,46,2,84,4,21,165,115,6,5,24,29]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s6b=e.$r6b=void 0,e.$r6b=(0,y.$Nh)("dialogMainService");let m=class{constructor(u,l){this.d=u,this.e=l,this.a=new Map,this.b=new Map,this.c=new A.$Zg}pickFileFolder(u,l){return this.f({...u,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},l)}pickFolder(u,l){return this.f({...u,pickFolders:!0,title:(0,g.localize)(1,null)},l)}pickFile(u,l){return this.f({...u,pickFiles:!0,title:(0,g.localize)(2,null)},l)}pickWorkspace(u,l){const E=(0,g.localize)(3,null),h=(0,M.$tv)((0,g.localize)(4,null)),i=b.$_h;return this.f({...u,pickFiles:!0,title:E,filters:i,buttonLabel:h},l)}async f(u,l){const E={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(E.properties=void 0,u.pickFiles&&u.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$k&&E.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(E,(l||P.BrowserWindow.getFocusedWindow())??void 0);if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}g(u){if(u){let l=this.b.get(u.id);return l||(l=new A.$Zg,this.b.set(u.id,l)),l}else return this.c}showMessageBox(u,l){return this.g(l).queue(async()=>{const{options:E,buttonIndeces:h}=(0,w.$Av)(u,this.e);let i;return l?i=await P.dialog.showMessageBox(l,E):i=await P.dialog.showMessageBox(E),{response:h[i.response],checkboxChecked:i.checkboxChecked}})}async showSaveDialog(u,l){const E=this.j(u,l);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(l).queue(async()=>{let h;return l?h=await P.dialog.showSaveDialog(l,u):h=await P.dialog.showSaveDialog(u),h.filePath=this.h(h.filePath),h})}finally{(0,D.$Mc)(E)}}h(u){return u&&f.$k&&(u=(0,S.$ll)(u)),u}i(u){return u.map(l=>this.h(l))}async showOpenDialog(u,l){u.defaultPath&&(await c.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const E=this.j(u,l);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(l).queue(async()=>{let h;return l?h=await P.dialog.showOpenDialog(l,u):h=await P.dialog.showOpenDialog(u),h.filePaths=this.i(h.filePaths),h})}finally{(0,D.$Mc)(E)}}j(u,l){if(!l)return D.$Rc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let E=this.a.get(l.id);E||(E=new Set,this.a.set(l.id,E));const h=(0,s.$Bi)(u);if(!E.has(h))return this.d.trace("[DialogMainService]: new file dialog lock created",u),E.add(h),(0,D.$Pc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),E?.delete(h),E?.size===0&&this.a.delete(l.id)})}};e.$s6b=m,e.$s6b=m=ke([ee(0,d.$8i),ee(1,v.$nj)],m)}),define(te[273],ie([0,1,3,2,76,29]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b7b=void 0;class D extends A.$Rc{static{this.a=100}constructor(f,c){super(),this.f=f,this.g=c,this.b=this.B(new P.$Md),this.c=new Map,this.h(c.applicationStorage,this.b)}h(f,c){this.B(P.Event.debounce(f.onDidChangeStorage,(g,w)=>(g?g.push(w):g=[w],g),D.a)(g=>{g.length&&c.fire(this.j(g,f))}))}j(f,c){const g=new Map,w=new Set;return f.forEach(y=>{const d=c.get(y.key);typeof d=="string"?g.set(y.key,d):w.add(y.key)}),{changed:Array.from(g.entries()),deleted:Array.from(w.values())}}listen(f,c,g){switch(c){case"onDidChangeStorage":{const w=g.profile?(0,s.$kh)(g.profile):void 0;if(!w)return this.b.event;let y=this.c.get(w.id);return y||(y=this.B(new P.$Md),this.h(this.g.profileStorage(w),y),this.c.set(w.id,y)),y.event}}throw new Error(`Event not found: ${c}`)}async call(f,c,g){const w=g.profile?(0,s.$kh)(g.profile):void 0,y=(0,M.$4h)(g.workspace),d=await this.m(w,y);switch(c){case"getItems":return Array.from(d.items.entries());case"updateItems":{const v=g;if(v.insert)for(const[b,m]of v.insert)d.set(b,m);v.delete?.forEach(b=>d.delete(b));break}case"optimize":return d.optimize();case"isUsed":{const v=g.payload;if(typeof v=="string")return this.g.isUsed(v)}default:throw new Error(`Call not found: ${c}`)}}async m(f,c){let g;c?g=this.g.workspaceStorage(c):f?g=this.g.profileStorage(f):g=this.g.applicationStorage;try{await g.init()}catch(w){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":f?"profile":"application"} storage due to ${w}`)}return g}}e.$b7b=D}),define(te[41],ie([0,1,55,3,2,19,7,187,36,16,6,5,29,31,40,8,32,27,12]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.ProfileResourceType=void 0;var l;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function E(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$Hk=E,e.$Ik=(0,g.$Nh)("IUserDataProfilesService");function h(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:D.URI.revive(t.location).with({scheme:n}),globalStorageHome:D.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.$Jk=h;function i(t,n,r,p,C,R){return{id:t,name:n,location:r,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:R&&C?.useDefaultFlags?.globalState?R.globalStorageHome:(0,M.$ug)(r,"globalStorage"),settingsResource:R&&C?.useDefaultFlags?.settings?R.settingsResource:(0,M.$ug)(r,"settings.json"),keybindingsResource:R&&C?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,M.$ug)(r,"keybindings.json"),tasksResource:R&&C?.useDefaultFlags?.tasks?R.tasksResource:(0,M.$ug)(r,"tasks.json"),snippetsHome:R&&C?.useDefaultFlags?.snippets?R.snippetsHome:(0,M.$ug)(r,"snippets"),extensionsResource:R&&C?.useDefaultFlags?.extensions?R.extensionsResource:(0,M.$ug)(r,"extensions.json"),cacheHome:(0,M.$ug)(p,t),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.$Kk=i;let a=class extends s.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,p,C){super(),this.t=n,this.u=r,this.w=p,this.y=C,this.f=!0,this.h=this.B(new A.$Md),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$Md),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$Md),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$Md),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$zc,emptyWindows:new Map},this.profilesHome=(0,M.$ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,u.$xf)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}r.push(i((0,M.$rg)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},n))}}catch(R){this.y.error(R)}const p=new d.$zc,C=new Map;if(r.length)try{const R=this.Q();if(R.workspaces)for(const[k,I]of Object.entries(R.workspaces)){const L=D.URI.parse(k),N=r.find(z=>z.id===I);N&&p.set(L,N)}if(R.emptyWindows)for(const[k,I]of Object.entries(R.emptyWindows)){const L=r.find(N=>N.id===I);L&&C.set(k,L)}}catch(R){this.y.error(R)}this.z={profiles:r,workspaces:p,emptyWindows:C}}return this.z}D(){const n=i("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",p=new RegExp(`${(0,$.$Ee)(r)}\\s(\\d+)`);let C=0;for(const k of this.profiles){const I=p.exec(k.name),L=I?parseInt(I[1]):0;C=L>C?L:C}const R=`${r} ${C+1}`;return this.createProfile((0,P.$Bi)((0,m.$dg)()).toString(16),R,{transient:!0},n)}async createNamedProfile(n,r,p){return this.createProfile((0,P.$Bi)((0,m.$dg)()).toString(16),n,r,p)}async createProfile(n,r,p,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(n,r,p);return C&&await this.setProfileForWorkspace(C,R),R}async F(n,r,p){if(!(0,u.$xf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.r.get(r);return C||(C=(async()=>{try{const R=this.profiles.find(L=>L.name===r||L.id===n);if(R)return R;const k=i(n,r,(0,M.$ug)(this.profilesHome,n),this.g,p,this.defaultProfile);await this.u.createFolder(k.location);const I=[];return this.j.fire({profile:k,join(L){I.push(L)}}),await b.Promises.settled(I),this.I([k],[],[]),k}finally{this.r.delete(r)}})(),this.r.set(r,C)),C}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(C=>C.id===n.id);if(!p)throw new Error(`Profile '${n.name}' does not exist`);return p=i(p.id,r.name??p.name,p.location,this.g,{shortName:r.shortName??p.shortName,icon:r.icon===null?void 0:r.icon??p.icon,transient:r.transient??p.isTransient,useDefaultFlags:r.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(C=>C.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const p=[];this.m.fire({profile:r,join(C){p.push(C)}});try{await Promise.allSettled(p)}catch(C){this.y.error(C)}for(const C of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(C)?.id&&this.C.emptyWindows.delete(C);for(const C of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(C)?.id&&this.C.workspaces.delete(C);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(C){(0,c.$nk)(C)!==1&&this.y.error(C)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(C=>C.id===r.id);if(!p)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,p)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return D.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,y.$Xh)(n)?n.uri:(0,y.$3h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,p){const C=[...this.profiles,...n],R=[];this.s.profiles=[];for(let k of C)k.isDefault||r.some(I=>k.id===I.id)||(k=p.find(I=>k.id===I.id)??k,k.isTransient?this.s.profiles.push(k):R.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(R),this.z=void 0,this.J(n,r,p)}J(n,r,p){this.h.fire({added:n,removed:r,updated:p,all:this.profiles})}L(n,r,p){p=r?.isTransient?!0:p,p||this.L(n,void 0,!0);const C=this.G(n),R=p?this.s:this.C;D.URI.isUri(C)?(R.workspaces.delete(C),r&&R.workspaces.set(C,r)):(R.emptyWindows.delete(C),r&&R.emptyWindows.set(C,r)),p||this.M()}M(){const n={};for(const[p,C]of this.C.workspaces.entries())n[p.toString()]=C.id;const r={};for(const[p,C]of this.C.emptyWindows.entries())r[p.toString()]=C.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},p=this.D();if(n.workspaces)for(const[R,k]of Object.entries(n.workspaces)){const I=D.URI.parse(k);r[R]=this.w.extUri.isEqual(I,p.location)?p.id:this.w.extUri.basename(I)}const C={};if(n.emptyWindows)for(const[R,k]of Object.entries(n.emptyWindows)){const I=D.URI.parse(k);C[R]=this.w.extUri.isEqual(I,p.location)?p.id:this.w.extUri.basename(I)}return{workspaces:r,emptyWindows:C}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Lk=a,e.$Lk=a=ke([ee(0,f.$Uh),ee(1,c.$9j),ee(2,v.$Gk),ee(3,w.$8i)],a);class o extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Mk=o}),define(te[80],ie([0,1,8,18,2,3,31,7,117,123,16,6,5,41,40,12,14,26]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class l extends Error{constructor(o,t){super(o),this.code=t}}e.$qp=l,e.$rp=(0,w.$Nh)("IExtensionsProfileScannerService");let E=class extends s.$Rc{constructor(o,t,n,r,p,C){super(),this.j=o,this.m=t,this.n=n,this.r=r,this.s=p,this.t=C,this.b=this.B(new M.$Md),this.onAddExtensions=this.b.event,this.c=this.B(new M.$Md),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$Md),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$Md),this.onDidRemoveExtensions=this.g.event,this.h=new D.$zc}scanProfileExtensions(o,t){return this.u(o,void 0,t)}async addExtensionsToProfile(o,t){const n=[],r=[];try{return await this.u(t,p=>{const C=[];for(const R of p)o.some(([k])=>(0,c.$wo)(k.identifier,R.identifier)&&k.manifest.version!==R.version)?n.push(R):C.push(R);for(const[R,k]of o){const I=C.findIndex(N=>(0,c.$wo)(N.identifier,R.identifier)&&N.version===R.manifest.version),L={identifier:R.identifier,version:R.manifest.version,location:R.location,metadata:k};I===-1?(r.push(L),C.push(L)):C.splice(I,1,L)}return r.length&&this.b.fire({extensions:r,profileLocation:t}),n.length&&this.f.fire({extensions:n,profileLocation:t}),C}),r.length&&this.c.fire({extensions:r,profileLocation:t}),n.length&&this.g.fire({extensions:n,profileLocation:t}),r}catch(p){throw r.length&&this.c.fire({extensions:r,error:p,profileLocation:t}),n.length&&this.g.fire({extensions:n,error:p,profileLocation:t}),p}}async updateMetadata(o,t){const n=[];return await this.u(t,r=>{const p=[];for(const C of r){const R=o.find(([k])=>(0,c.$wo)(k.identifier,C.identifier)&&k.manifest.version===C.version);R&&(C.metadata={...C.metadata,...R[1]},n.push(C)),p.push(C)}return p}),n}async removeExtensionFromProfile(o,t){const n=[];try{await this.u(t,r=>{const p=[];for(const C of r)(0,c.$wo)(C.identifier,o.identifier)?n.push(C):p.push(C);return n.length&&this.f.fire({extensions:n,profileLocation:t}),p}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:t}),r}}async u(o,t,n){return this.F(o).queue(async()=>{let r=[],p;try{const C=await this.m.readFile(o);p=JSON.parse(C.value.toString().trim()||"[]")}catch(C){if((0,g.$nk)(C)!==1)throw C;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(p=await this.D()),!p&&n?.bailOutWhenFileNotFound)throw new l((0,m.$9)(C),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.w(o);let C=!1;for(const R of p){h(R)||this.w(o);let k;if((0,b.$xf)(R.relativeLocation)&&R.relativeLocation)k=this.z(R.relativeLocation);else if((0,b.$xf)(R.location))k=this.z(R.location),C=!0,R.relativeLocation=R.location,R.location=k.toJSON();else{k=S.URI.revive(R.location);const I=this.y(k);I&&(C=!0,R.relativeLocation=I)}r.push({identifier:R.identifier,location:k,version:R.version,metadata:R.metadata})}C&&await this.m.writeFile(o,A.$ae.fromString(JSON.stringify(p)))}if(t){r=t(r);const C=r.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(o,A.$ae.fromString(JSON.stringify(C)))}return r})}w(o){const t=new l(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(o)).value.toString()}catch(p){if((0,g.$nk)(p)===1)return;throw p}this.t.info("Migrating extensions from old default profile location",o.toString());let r;try{const p=JSON.parse(n);Array.isArray(p)&&p.every(C=>h(C))?r=p:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.t.error(p)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$ae.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(p){if((0,g.$nk)(p)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw p}try{await this.m.del(o)}catch(p){(0,g.$nk)(p)!==1&&this.t.error(p)}try{await this.m.del(t)}catch(p){(0,g.$nk)(p)!==1&&this.t.error(p)}return r})()),this.C}F(o){let t=this.h.get(o);return t||(t=new P.$Zg,this.h.set(o,t)),t}};e.$sp=E,e.$sp=E=ke([ee(1,g.$9j),ee(2,d.$Ik),ee(3,v.$Gk),ee(4,$.$al),ee(5,y.$8i)],E);function h(a){return(0,b.$zf)(a)&&(0,f.$6n)(a.identifier)&&(i(a.location)||(0,b.$xf)(a.location)&&a.location)&&((0,b.$Ef)(a.relativeLocation)||(0,b.$xf)(a.relativeLocation))&&a.version&&(0,b.$xf)(a.version)}function i(a){return a?(0,b.$xf)(a.path)&&(0,b.$xf)(a.scheme):!1}}),define(te[128],ie([0,1,23,8,37,18,14,44,150,2,13,9,4,19,203,73,12,7,170,36,123,120,202,16,6,5,24,3,76,80,41,40,201]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u,l,E,h,i,a,o,t,n,r,p,C,R,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.Translations=void 0;var L;(function(oe){function J(K,G){if(K===G)return!0;const U=Object.keys(K),q=new Set;for(const X of Object.keys(G))q.add(X);if(U.length!==q.size)return!1;for(const X of U){if(K[X]!==G[X])return!1;q.delete(X)}return q.size===0}oe.equals=J})(L||(e.Translations=L={})),e.$vp=(0,o.$Nh)("IExtensionsScannerService");let N=class extends c.$Rc{constructor(J,K,G,U,q,X,H,Q,re,F,O,j){super(),this.systemExtensionsLocation=J,this.userExtensionsLocation=K,this.r=G,this.s=U,this.t=q,this.u=X,this.w=H,this.y=Q,this.z=re,this.C=F,this.D=O,this.F=j,this.g=this.B(new r.$Md),this.onDidChangeCache=this.g.event,this.h=(0,d.$ug)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(_,this.s,this.h)),this.m=this.B(this.F.createInstance(_,this.s,this.h)),this.n=this.B(this.F.createInstance(ne,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Ho)(this.w,this.y)),this.G}async scanAllExtensions(J,K,G){const[U,q]=await Promise.all([this.scanSystemExtensions(J),this.scanUserExtensions(K)]),X=G?await this.scanExtensionsUnderDevelopment(J,[...U,...q]):[];return this.L(U,q,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(J){const K=[];K.push(this.M(!!J.useCache,J.language)),K.push(this.N(J.language,!!J.checkControlFile));const[G,U]=await Promise.all(K);return this.J([...G,...U],0,J,!1)}async scanUserExtensions(J){const K=J.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const G=this.D.extUri.isEqual(J.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(K,!!J.profileLocation,1,!J.includeUninstalled,J.language,!0,G),q=J.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let X;try{X=await q.scanExtensions(U)}catch(H){if(H instanceof C.$qp&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await q.scanExtensions(U);else throw H}return X=await this.J(X,1,J,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(J,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===g.Schemas.file).map(async U=>{const q=await this.P(U,!1,1,!0,J.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(q)).map(H=>(H.type=K.find(Q=>(0,E.$wo)(Q.identifier,H.identifier))?.type??H.type,this.n.validate(H,q)))}))).flat();return this.J(G,"development",J,!0)}return[]}async scanExistingExtension(J,K,G){const U=await this.P(J,!1,K,!0,G.language,!0,void 0),q=await this.n.scanExtension(U);return!q||!G.includeInvalid&&!q.isValid?null:q}async scanOneOrMultipleExtensions(J,K,G){const U=await this.P(J,!1,K,!0,G.language,!0,void 0),q=await this.n.scanOneOrMultipleExtensions(U);return this.J(q,K,G,!0)}async scanMetadata(J){const K=(0,d.$ug)(J,"package.json"),G=(await this.w.readFile(K)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(J,K){const G=(0,d.$ug)(J,"package.json"),U=(await this.w.readFile(G)).value.toString(),q=JSON.parse(U);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,q.__metadata={...q.__metadata,...K},await this.w.writeFile((0,d.$ug)(J,"package.json"),M.$ae.fromString(JSON.stringify(q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(J){if(J instanceof C.$qp&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw J}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const J=await this.scanUserExtensions({includeInvalid:!0});if(J.length)await this.u.addExtensionsToProfile(J.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$ae.fromString(JSON.stringify([])))}catch(K){(0,a.$nk)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$9)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(J){this.y.error(J)}finally{this.H=void 0}})()),this.H}async J(J,K,G,U){return G.includeAllVersions||(J=this.L(K===0?J:void 0,K===1?J:void 0,K==="development"?J:void 0,await this.getTargetPlatform(),U)),G.includeInvalid||(J=J.filter(q=>q.isValid)),J.sort((q,X)=>{const H=w.$mc(q.location.fsPath),Q=w.$mc(X.location.fsPath);return H<Q?-1:H>Q?1:0})}L(J,K,G,U,q){const X=(Q,re,F)=>{if(Q.isValid&&!re.isValid)return!1;if(Q.isValid===re.isValid){if(q&&v.gt(Q.manifest.version,re.manifest.version))return this.y.debug(`Skipping extension ${re.location.path} with lower version ${re.manifest.version} in favour of ${Q.location.path} with version ${Q.manifest.version}`),!1;if(v.eq(Q.manifest.version,re.manifest.version)){if(Q.type===0)return this.y.debug(`Skipping extension ${re.location.path} in favour of system extension ${Q.location.path} with same version`),!1;if(Q.targetPlatform===U)return this.y.debug(`Skipping extension ${re.location.path} from different target platform ${re.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${Q.location.path} with ${re.location.path}.`):this.y.debug(`Overwriting user extension ${Q.location.path} with ${re.location.path}.`),!0},H=new h.$5l;return J?.forEach(Q=>{const re=H.get(Q.identifier.id);(!re||X(re,Q,!1))&&H.set(Q.identifier.id,Q)}),K?.forEach(Q=>{const re=H.get(Q.identifier.id);if(!re&&J&&Q.type===0){this.y.debug(`Skipping obsolete system extension ${Q.location.path}.`);return}(!re||X(re,Q,!1))&&H.set(Q.identifier.id,Q)}),G?.forEach(Q=>{const re=H.get(Q.identifier.id);(!re||X(re,Q,!0))&&H.set(Q.identifier.id,Q),H.set(Q.identifier.id,Q)}),[...H.values()]}async M(J,K){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),q=await(J&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",q.length),q}async N(J,K){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const U=K?await this.O():{},q=[],X=$.URI.file(w.$gc(w.$ic(g.$bg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Q of G){const re=U[Q.name]||"marketplace";switch(re){case"disabled":break;case"marketplace":q.push((0,d.$ug)(X,Q.name));break;default:q.push($.URI.file(re));break}}const H=await Promise.all(q.map(async Q=>this.n.scanExtension(await this.P(Q,!1,0,!0,J,!0,void 0))));return this.y.trace("Scanned dev system extensions:",H.length),(0,P.$Gb)(H)}async O(){try{const J=await this.w.readFile(this.r);return JSON.parse(J.value.toString())}catch{return{}}}async P(J,K,G,U,q,X,H){const Q=await this.f(q??y.$w),re=await this.Q(J),F=K&&!this.D.extUri.isEqual(J,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=F?await this.Q(F):void 0;return new z(J,re,F,O,K,H,G,U,X,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,q,Q)}async Q(J){try{const K=await this.w.stat(J);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$wp=N,e.$wp=N=ke([ee(4,R.$Ik),ee(5,C.$rp),ee(6,a.$9j),ee(7,t.$8i),ee(8,l.$Uh),ee(9,n.$nj),ee(10,k.$Gk),ee(11,o.$Mh)],N);class z{constructor(J,K,G,U,q,X,H,Q,re,F,O,j,B,W,T){this.location=J,this.mtime=K,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=U,this.profile=q,this.profileScanOptions=X,this.type=H,this.excludeObsolete=Q,this.validate=re,this.productVersion=F,this.productDate=O,this.productCommit=j,this.devMode=B,this.language=W,this.translations=T}static createNlsConfiguration(J){return{language:J.language,pseudo:J.language==="pseudo",devMode:J.devMode,translations:J.translations}}static equals(J,K){return(0,d.$ng)(J.location,K.location)&&J.mtime===K.mtime&&(0,d.$ng)(J.applicationExtensionslocation,K.applicationExtensionslocation)&&J.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&J.profile===K.profile&&s.$7m(J.profileScanOptions,K.profileScanOptions)&&J.type===K.type&&J.excludeObsolete===K.excludeObsolete&&J.validate===K.validate&&J.productVersion===K.productVersion&&J.productDate===K.productDate&&J.productCommit===K.productCommit&&J.devMode===K.devMode&&J.language===K.language&&L.equals(J.translations,K.translations)}}e.$xp=z;let ne=class extends c.$Rc{constructor(J,K,G,U,q){super(),this.f=J,this.g=K,this.h=G,this.j=U,this.m=q}async scanExtensions(J){const K=J.profile?await this.r(J):await this.n(J);let G={};if(J.excludeObsolete&&J.type===1)try{const U=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(U)}catch{}return(0,m.$Kf)(G)?K:K.filter(U=>!G[E.$xo.create(U).toString()])}async n(J){const K=await this.j.resolve(J.location);if(!K.children?.length)return[];const G=await Promise.all(K.children.map(async U=>{if(!U.isDirectory||J.type===1&&(0,d.$rg)(U.resource).indexOf(".")===0)return null;const q=new z(U.resource,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(q)}));return(0,P.$Gb)(G).sort((U,q)=>U.location.path<q.location.path?-1:1)}async r(J){let K=await this.s(J.location,()=>!0,J);if(J.applicationExtensionslocation&&!this.h.extUri.isEqual(J.location,J.applicationExtensionslocation)){K=K.filter(U=>!U.metadata?.isApplicationScoped);const G=await this.s(J.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,J);K.push(...G)}return K}async s(J,K,G){const U=await this.g.scanProfileExtensions(J,G.profileScanOptions);if(!U.length)return[];const q=await Promise.all(U.map(async X=>{if(K(X)){const H=new z(X.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(H,X.metadata)}return null}));return(0,P.$Gb)(q)}async scanOneOrMultipleExtensions(J){try{if(await this.j.exists((0,d.$ug)(J.location,"package.json"))){const K=await this.scanExtension(J);return K?[K]:[]}else return await this.scanExtensions(J)}catch(K){return this.m.error(`Error scanning extensions at ${J.location.path}:`,(0,D.$9)(K)),[]}}async scanExtension(J,K){try{let G=await this.scanExtensionManifest(J.location);if(G){G.publisher||(G.publisher=h.$Yl),K=K??G.__metadata,delete G.__metadata;const U=(0,E.$Bo)(G.publisher,G.name),q=K?.id?{id:U,uuid:K.id}:{id:U},X=K?.isSystem?0:J.type,H=X===0||!!K?.isBuiltin;G=await this.t(J.location,G,z.createNlsConfiguration(J));const Q={type:X,identifier:q,manifest:G,location:J.location,isBuiltin:H,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return J.validate?this.validate(Q,J):Q}}catch(G){J.type!==0&&this.m.error(G)}return null}validate(J,K){let G=!0;const U=(0,i.$Mo)(K.productVersion,K.productDate,K.location,J.manifest,J.isBuiltin);for(const[q,X]of U)q===b.default.Error&&(G=!1,this.m.error(this.z(K.location,X)));return J.isValid=G,J.validations=U,J}async scanExtensionManifest(J){const K=(0,d.$ug)(J,"package.json");let G;try{G=(await this.j.readFile(K)).value.toString()}catch(q){return(0,a.$nk)(q)!==1&&this.m.error(this.z(J,(0,u.localize)(0,null,K.path,q.message))),null}let U;try{U=JSON.parse(G)}catch{const X=[];(0,S.$Sm)(G,X);for(const H of X)this.m.error(this.z(J,(0,u.localize)(1,null,K.path,H.offset,H.length,(0,f.$tp)(H.error))));return null}return(0,S.$2m)(U)!=="object"?(this.m.error(this.z(J,(0,u.localize)(2,null,K.path))),null):U}async t(J,K,G){const U=await this.u(J,K,G);if(U)try{const q=[],X=await this.w(U.default,q);if(q.length>0)return q.forEach(Q=>{this.m.error(this.z(J,(0,u.localize)(3,null,U.default?.path,(0,f.$tp)(Q.error))))}),K;if((0,S.$2m)(U)!=="object")return this.m.error(this.z(J,(0,u.localize)(4,null,U.default?.path))),K;const H=U.values||Object.create(null);return(0,I.$up)(this.m,K,H,X)}catch{}return K}async u(J,K,G){const U=(0,d.$ug)(J,"package.nls.json"),q=(re,F)=>{F.forEach(O=>{this.m.error(this.z(J,(0,u.localize)(5,null,re?.path,(0,f.$tp)(O.error))))})},X=re=>{this.m.error(this.z(J,(0,u.localize)(6,null,re?.path)))},H=`${K.publisher}.${K.name}`,Q=G.translations[H];if(Q)try{const re=$.URI.file(Q),F=(await this.j.readFile(re)).value.toString(),O=[],j=(0,S.$Sm)(F,O);return O.length>0?(q(re,O),{values:void 0,default:U}):(0,S.$2m)(j)!=="object"?(X(re),{values:void 0,default:U}):{values:j.contents?j.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let F;try{F=await this.y(J,G)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const O=(await this.j.readFile(F.localized)).value.toString(),j=[],B=(0,S.$Sm)(O,j);return j.length>0?(q(F.localized,j),{values:void 0,default:F.original}):(0,S.$2m)(B)!=="object"?(X(F.localized),{values:void 0,default:F.original}):{values:B,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(J,K){if(J)try{const G=(await this.j.readFile(J)).value.toString();return(0,S.$Sm)(G,K)}catch{}}y(J,K){return new Promise((G,U)=>{const q=X=>{const H=(0,d.$ug)(J,`package.nls.${X}.json`);this.j.exists(H).then(Q=>{Q&&G({localized:H,original:(0,d.$ug)(J,"package.nls.json")});const re=X.lastIndexOf("-");re===-1?G({localized:(0,d.$ug)(J,"package.nls.json"),original:null}):(X=X.substring(0,re),q(X))})};if(K.devMode||K.pseudo||!K.language)return G({localized:(0,d.$ug)(J,"package.nls.json"),original:null});q(K.language)})}z(J,K){return`[${J.path}]: ${K}`}};ne=ke([ee(1,C.$rp),ee(2,k.$Gk),ee(3,a.$9j),ee(4,t.$8i)],ne);let _=class extends ne{constructor(J,K,G,U,q,X,H){super(K,U,q,X,H),this.G=J,this.H=G,this.D=this.B(new A.$Qg(3e3)),this.F=this.B(new r.$Md),this.onDidChangeCache=this.F.event}async scanExtensions(J){const K=this.M(J),G=await this.I(K);if(this.C=J,G&&G.input&&z.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",J.location.toString()),this.D.trigger(()=>this.L()),G.result.map(q=>(q.location=$.URI.revive(q.location),q));const U=await super.scanExtensions(J);return await this.J(K,{input:J,result:U}),U}async I(J){try{const K=await this.j.readFile(J),G=JSON.parse(K.value.toString());return{result:G.result,input:(0,p.$kh)(G.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",J.path,(0,D.$9)(K))}return null}async J(J,K){try{await this.j.writeFile(J,M.$ae.fromString(JSON.stringify(K)))}catch(G){this.m.debug("Error while writing the extension cache file:",J.path,(0,D.$9)(G))}}async L(){if(!this.C)return;const J=this.M(this.C),K=await this.I(J);if(!K)return;const G=K.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$7m(U,G))try{this.m.info("Invalidating Cache",G,U),await this.j.del(J),this.F.fire()}catch(q){this.m.error(q)}}M(J){const K=this.N(J);return this.h.extUri.joinPath(K.cacheHome,J.type===0?h.$Xl:h.$Wl)}N(J){return J.type===0?this.H.defaultProfile:J.profile?this.h.extUri.isEqual(J.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(J.location,K.extensionsResource))??this.G:this.H.defaultProfile}};_=ke([ee(2,R.$Ik),ee(3,C.$rp),ee(4,k.$Gk),ee(5,a.$9j),ee(6,t.$8i)],_);function ae(oe,J){const K=(0,E.$zo)(oe.manifest.publisher,oe.manifest.name);return{id:K,identifier:new h.$3l(K),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:J,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}e.$yp=ae;class se extends N{constructor(J,K,G,U,q,X,H,Q,re,F,O,j){super(J,K,(0,d.$ug)(G,".vscode-oss-dev","extensions","control.json"),U,q,X,H,Q,re,F,O,j),this.R=(async()=>{if(y.$z)try{const B=await this.w.readFile($.URI.file(y.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(J){return this.R}}e.$zp=se}),define(te[274],ie([0,1,5,41,40,26,80,16,36,7]),function(Z,e,P,A,s,M,D,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=void 0;let g=class extends D.$sp{constructor(y,d,v,b,m,$){super(c.URI.file(y.extensionsPath),d,v,b,m,$)}};e.$xN=g,e.$xN=g=ke([ee(0,f.$Vh),ee(1,S.$9j),ee(2,A.$Ik),ee(3,s.$Gk),ee(4,M.$al),ee(5,P.$8i)],g)}),define(te[275],ie([0,1,7,36,80,128,16,6,5,24,40,41]),function(Z,e,P,A,s,M,D,S,f,c,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=void 0;let y=class extends M.$zp{constructor(v,b,m,$,u,l,E,h){super(P.URI.file(u.builtinExtensionsPath),P.URI.file(u.extensionsPath),u.userHome,v.defaultProfile,v,b,m,$,u,l,E,h)}};e.$C7b=y,e.$C7b=y=ke([ee(0,w.$Ik),ee(1,s.$rp),ee(2,D.$9j),ee(3,f.$8i),ee(4,A.$Vh),ee(5,c.$nj),ee(6,g.$Gk),ee(7,S.$Mh)],y)}),define(te[276],ie([0,1,15,2,13,9,4,56,7,32,38,36,5,41]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7b=void 0;let v=class extends A.$Rc{constructor(m,$,u){super(),this.c=m,this.f=u,this.a=S.$Th.forPaths(!D.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(m.appRoot),this.addValidFileRoot(m.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(m.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:m}=P.session;m.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,($,u)=>this.j($,u)),m.protocol.interceptFileProtocol(s.Schemas.file,($,u)=>this.h($,u)),this.B((0,A.$Pc)(()=>{m.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),m.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(m){const $=(0,M.$gc)(m);return this.a.get($)?A.$Rc.None:(this.a.set($,!0),(0,A.$Pc)(()=>this.a.delete($)))}h(m,$){const u=f.URI.parse(m.url);return this.f.error(`Refused to load resource ${u.fsPath} from ${s.Schemas.file}: protocol (original URL: ${m.url})`),$({error:-3})}j(m,$){const u=this.m(m);let l;return this.c.crossOriginIsolated&&((0,M.$mc)(u)==="workbench.html"||(0,M.$mc)(u)==="workbench-dev.html"?l=s.COI.CoopAndCoep:l=s.COI.getHeadersFromQuery(m.url)),this.a.findSubstr(u)?$({path:u,headers:l}):this.b.has((0,M.$nc)(u).toLowerCase())?$({path:u}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${u} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${m.url})`),$({error:-3}))}m(m){const $=f.URI.parse(m.url),u=s.$bg.uriToFileUri($);return(0,M.$gc)(u.fsPath)}createIPCObjectUrl(){let m;const $=f.URI.from({scheme:"vscode",path:(0,c.$dg)()}),u=$.toString(),l=async()=>m;return g.$dT.handle(u,l),this.f.trace(`IPC Object URL: Registered new channel ${u}.`),{resource:$,update:E=>m=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${u}.`),g.$dT.removeHandler(u)}}}};e.$S7b=v,e.$S7b=v=ke([ee(0,w.$Vh),ee(1,d.$Ik),ee(2,y.$8i)],v)}),define(te[96],ie([0,1,8,3,2,66,12,111,6,41]),function(Z,e,P,A,s,M,D,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$3o=e.$2o=e.$1o=void 0,e.$1o="__$__isNewStorageMarker",e.$2o="__$__targetStorageMarker",e.$3o=(0,f.$Nh)("storageService");var g;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var w;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var y;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function d(u){const l=u.get(e.$2o);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}e.$4o=d;class v extends s.$Rc{static{this.a=60*1e3}constructor(l={flushInterval:v.a}){super(),this.m=l,this.b=this.B(new A.$Pd),this.c=this.B(new A.$Pd),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$Md),this.onWillSaveState=this.f.event,this.h=this.B(new P.$5g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,E,h){return A.Event.filter(this.b.event,i=>i.scope===l&&(E===void 0||i.key===E),h)}n(){this.j.value=(0,P.$9g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,E){const{key:h,external:i}=E;if(h===e.$2o){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:h,target:this.J(l)[h],external:i})}w(l){this.f.fire({reason:l})}get(l,E,h){return this.P(E)?.get(l,h)}getBoolean(l,E,h){return this.P(E)?.getBoolean(l,h)}getNumber(l,E,h){return this.P(E)?.getNumber(l,h)}getObject(l,E,h){return this.P(E)?.getObject(l,h)}storeAll(l,E){this.y(()=>{for(const h of l)this.store(h.key,h.value,h.scope,h.target,E)})}store(l,E,h,i,a=!1){if((0,D.$Gf)(E)){this.remove(l,h,a);return}this.y(()=>{this.z(l,h,i),this.P(h)?.set(l,E,a)})}remove(l,E,h=!1){this.y(()=>{this.z(l,E,void 0),this.P(E)?.delete(l,h)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,E){const h=[],i=this.J(l);for(const a of Object.keys(i))i[a]===E&&h.push(a);return h}z(l,E,h,i=!1){const a=this.J(E);typeof h=="number"?a[l]!==h&&(a[l]=h,this.P(E)?.set(e.$2o,JSON.stringify(a),i)):typeof a[l]=="number"&&(delete a[l],this.P(E)?.set(e.$2o,JSON.stringify(a),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const E=this.P(l);return E?d(E):Object.create(null)}isNew(l){return this.getBoolean(e.$1o,l)===!0}async flush(l=g.NONE){this.f.fire({reason:l});const E=this.P(-1),h=this.P(0),i=this.P(1);switch(l){case g.NONE:await P.Promises.settled([E?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await P.Promises.settled([E?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return $(l,E,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,E){return this.w(g.NONE),(0,c.$Hk)(l)?this.R(l,E):this.S(l,E)}M(l,E){return!(l.id===E.id||b(E)&&b(l))}N(l,E,h){this.y(()=>{const i=new Set;for(const[a,o]of l)i.add(a),E.get(a)!==o&&this.u(h,{key:a,external:!0});for(const[a]of E.items)i.has(a)||this.u(h,{key:a,external:!0})})}}e.$5o=v;function b(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$6o=b;class m extends v{constructor(){super(),this.U=this.B(new S.$Yo(new S.$Zo,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$Yo(new S.$Zo,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$Yo(new S.$Zo,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$7o=m;async function $(u,l,E,h,i,a){const o=L=>{try{return JSON.parse(L)}catch{return L}},t=new Map,n=new Map;u.forEach((L,N)=>{t.set(N,L),n.set(N,o(L))});const r=new Map,p=new Map;l.forEach((L,N)=>{r.set(N,L),p.set(N,o(L))});const C=new Map,R=new Map;E.forEach((L,N)=>{C.set(N,L),R.set(N,o(L))}),console.group(h!==i?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const k=[];if(t.forEach((L,N)=>{k.push({key:N,value:L})}),console.table(k),console.groupEnd(),console.log(n),h!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const L=[];r.forEach((N,z)=>{L.push({key:z,value:N})}),console.table(L),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${a})`);const I=[];C.forEach((L,N)=>{I.push({key:N,value:L})}),console.table(I),console.groupEnd(),console.log(R)}e.$8o=$}),define(te[277],ie([0,1,23,8,3,2,9,72,7,21,111,159,5,96,26,29,13]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$85b=e.$75b=e.$65b=e.$55b=void 0;class $ extends M.$Rc{static{this.a=2e3}get storage(){return this.f}constructor(o,t){super(),this.m=o,this.n=t,this.b=this.B(new s.$Md),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Md),this.onDidCloseStorage=this.c.event,this.f=this.B(new g.$Yo(new g.$Zo,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new A.$bh,this.whenInit=this.h.p,this.j=g.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===g.StorageState.None)try{const o=this.B(await this.t());this.f.dispose(),this.f=o,this.B(o.onDidChangeStorage(n=>this.b.fire(n))),await this.s(o);const t=o.getBoolean(d.$1o);t===void 0?o.set(d.$1o,!0):t&&o.set(d.$1o,!1)}catch(o){this.m.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.j=g.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===y.LogLevel.Trace?o=>this.m.trace(o):void 0,logError:o=>this.m.error(o)}}s(o){return o.init()}get items(){return this.f.items}get(o,t){return this.f.get(o,t)}set(o,t){return this.f.set(o,t)}delete(o){return this.f.delete(o)}optimize(){return this.f.optimize()}async close(){const o=new S.$Id(!1);await this.w(),o.stop(),o.elapsed()>$.a&&await this.u(o),this.c.fire()}async u(o){if(this.path)try{const t=(0,P.top)(Array.from(this.f.items.entries()).map(([r,p])=>({key:r,length:p.length})),(r,p)=>p.length-r.length,5).map(r=>`${r.key}:${r.length}`).join(", "),n=(await this.n.stat(f.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${n}b, Large Keys: ${t}`)}catch(t){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async w(){this.g&&await this.g,this.j=g.StorageState.Closed,await this.f.close()}}class u extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,D.$ic)(this.z.globalStorageHome.with({scheme:m.Schemas.file}).fsPath,u.y)}constructor(o,t,n,r){super(n,r),this.z=o,this.C=t}async t(){return new g.$Yo(new w.$IT(this.path??w.$IT.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:g.StorageHint.STORAGE_IN_MEMORY})}}class l extends u{constructor(o,t,n,r){super(o,t,n,r)}}e.$55b=l;class E extends u{constructor(o,t,n,r){super(t.defaultProfile,o,n,r)}async s(o){await super.s(o),this.G(o)}G(o){o.get(v.$dl,void 0)===void 0&&o.set(v.$dl,new Date().toUTCString());const n=o.get(v.$cl,void 0),r=new Date().toUTCString();o.set(v.$el,typeof n>"u"?null:n),o.set(v.$cl,r)}}e.$65b=E;class h extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,D.$ic)(this.F.workspaceStorageHome.with({scheme:m.Schemas.file}).fsPath,this.C.id,h.y)}constructor(o,t,n,r,p){super(n,p),this.C=o,this.D=t,this.F=r}async t(){const{storageFilePath:o,wasCreated:t}=await this.H();return new g.$Yo(new w.$IT(o,{logging:this.r()}),{hint:this.D.useInMemoryStorage?g.StorageHint.STORAGE_IN_MEMORY:t?g.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:w.$IT.IN_MEMORY_PATH,wasCreated:!0};const o=(0,D.$ic)(this.F.workspaceStorageHome.with({scheme:m.Schemas.file}).fsPath,this.C.id),t=(0,D.$ic)(o,h.y);return await c.Promises.exists(o)?{storageFilePath:t,wasCreated:!1}:(await c.Promises.mkdir(o,{recursive:!0}),this.I(o),{storageFilePath:t,wasCreated:!0})}async I(o){let t;if((0,b.$Xh)(this.C)?t={folder:this.C.uri.toString()}:(0,b.$3h)(this.C)&&(t={workspace:this.C.configPath.toString()}),t)try{const n=(0,D.$ic)(o,h.z);await c.Promises.exists(n)||await c.Promises.writeFile(n,JSON.stringify(t,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$75b=h;class i extends ${get path(){}async t(){return new g.$Yo(new g.$Zo,{hint:g.StorageHint.STORAGE_IN_MEMORY})}}e.$85b=i}),define(te[278],ie([0,1,3,2,96]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E7b=void 0;class M extends A.$Rc{constructor(S,f,c){super(),this.b=S,this.c=f,this.f=c;const g=this.B(new A.$Sc);this.a=this.B(new P.$Md({onWillAddFirstListener:()=>g.value=this.g(),onDidRemoveLastListener:()=>g.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new A.$Qc;return S.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,c)=>(f?f.push(c.key):f=[c.key],f),100)(f=>this.h(f))),S.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(f,c)=>{f||(f=new Map);let g=f.get(c.profile.id);return g||f.set(c.profile.id,g={profile:c.profile,keys:[],storage:c.storage}),g.keys.push(c.key),f},100)(f=>this.j(f))),S}h(S){const f=S.includes(s.$2o)?[this.c.defaultProfile]:[],c=[];if(S=S.filter(g=>g!==s.$2o),S.length){const g=(0,s.$4o)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:S.map(w=>({key:w,scope:0,target:g[w]}))})}this.m(f,c)}j(S){const f=[],c=new Map;for(const[g,w]of S.entries()){w.keys.includes(s.$2o)&&f.push(w.profile);const y=w.keys.filter(d=>d!==s.$2o);if(y.length){const d=(0,s.$4o)(w.storage.storage);c.set(g,{profile:w.profile,changes:y.map(v=>({key:v,scope:0,target:d[v]}))})}}this.m(f,[...c.values()])}m(S,f){(S.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:S})}listen(S,f,c){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(S,f){throw new Error(`Call not found: ${f}`)}}e.$E7b=M}),define(te[279],ie([0,1,7,36,16,5,34,40,41,12,121]),function(Z,e,P,A,s,M,D,S,f,c,g){"use strict";var w,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=e.$uN=void 0;let d=class extends f.$Lk{static{w=this}static{this.a="profileAssociationsMigration"}constructor($,u,l,E,h){super(l,E,u,h),this.U=$,this.W=l}O(){return this.U.getItem(w.b,[]).map(u=>({...u,location:(0,c.$xf)(u.location)?this.w.extUri.joinPath(this.profilesHome,u.location):P.URI.revive(u.location)}))}Q(){const $=this.U.getItem(w.c,{});return this.U.getItem(w.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$uN=d,e.$uN=d=w=ke([ee(0,D.$pN),ee(1,S.$Gk),ee(2,A.$Vh),ee(3,s.$9j),ee(4,M.$8i)],d);let v=y=class extends d{constructor($,u,l,E,h){super($,u,l,E,h),this.$=$}P($){$.length?this.$.setItem(y.b,$.map(u=>({...u,location:this.w.extUri.basename(u.location)}))):this.$.removeItem(y.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(y.c,$):this.$.removeItem(y.c)}Q(){const $="workspaceAndProfileInfo",u=this.$.getItem($,void 0);if(u){this.$.removeItem($);const E=u.reduce((h,{workspace:i,profile:a})=>(h[P.URI.revive(i).toString()]=P.URI.revive(a).toString(),h),{});this.$.setItem(y.c,{workspaces:E})}const l=super.Q();return this.$.getItem(y.a,!1)||(this.R(l),this.$.setItem(y.a,!0)),l}};e.$vN=v,e.$vN=v=y=ke([ee(0,D.$qN),ee(1,S.$Gk),ee(2,A.$Vh),ee(3,s.$9j),ee(4,M.$8i)],v);let b=class extends v{constructor($,u,l,E){super(new g.$tN(0,u,E,l),$,u,l,E)}async init(){return await this.$.init(),super.init()}};e.$wN=b,e.$wN=b=ke([ee(0,S.$Gk),ee(1,A.$Vh),ee(2,s.$9j),ee(3,M.$8i)],b)}),define(te[52],ie([0,1,36,16,6,5,40,41,279,34]),function(Z,e,P,A,s,M,D,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=e.$95b=void 0,e.$95b=(0,s.$Oh)(S.$Ik);let g=class extends f.$vN{constructor(y,d,v,b,m){super(y,d,v,b,m)}getAssociatedEmptyWindows(){const y=[];for(const d of this.C.emptyWindows.keys())y.push({id:d});return y}};e.$05b=g,e.$05b=g=ke([ee(0,c.$qN),ee(1,D.$Gk),ee(2,P.$Vh),ee(3,A.$9j),ee(4,M.$8i)],g)}),define(te[129],ie([0,1,19,7,29]),function(Z,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v6b=e.$u6b=e.$t6b=void 0;async function M(f,c,g){for(const y of f){const d=y.openedWorkspace;if((0,s.$3h)(d)){const v=await g(d);if(v){if(v.folders.some(b=>P.$lg.isEqualOrParent(c,b.uri)))return y}else if(P.$lg.isEqualOrParent(c,d.configPath))return y}}const w=f.filter(y=>(0,s.$Xh)(y.openedWorkspace)&&P.$lg.isEqualOrParent(c,y.openedWorkspace.uri));if(w.length)return w.sort((y,d)=>-(y.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.$t6b=M;function D(f,c){for(const g of f)if((0,s.$3h)(g.openedWorkspace)&&P.$lg.isEqual(g.openedWorkspace.configPath,c)||(0,s.$Xh)(g.openedWorkspace)&&P.$lg.isEqual(g.openedWorkspace.uri,c))return g}e.$u6b=D;function S(f,c){const g=w=>c.some(y=>P.$lg.isEqual(A.URI.file(y),A.URI.file(w)));for(const w of f)if(w.config?.extensionDevelopmentPath?.some(y=>g(y)))return w}e.$v6b=S}),define(te[97],ie([0,1,33,44,137,46,13,9,4,19,7,6,58,29]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JU=e.$IU=e.$HU=e.$GU=e.$FU=e.$EU=e.$DU=e.$CU=e.$BU=e.$AU=void 0,e.$AU=(0,w.$Nh)("workspacesService");function v(R){return R.hasOwnProperty("workspace")}e.$BU=v;function b(R){return R.hasOwnProperty("folderUri")}e.$CU=b;function m(R){return R.hasOwnProperty("fileUri")}e.$DU=m;function $(R){return u(R)||l(R)}e.$EU=$;function u(R){const k=R;return typeof k?.path=="string"&&(!k.name||typeof k.name=="string")}function l(R){const k=R;return typeof k?.uri=="string"&&(!k.name||typeof k.name=="string")}function E(R,k,I,L,N){if(R.scheme!==L.scheme)return{name:I,uri:R.toString(!0)};let z=k?void 0:N.relativePath(L,R);if(z!==void 0)z.length===0?z=".":f.$j&&(z=h(z));else if(R.scheme===D.Schemas.file)z=R.fsPath,f.$j&&(z=h(z));else if(N.isEqualAuthority(R.authority,L.authority))z=R.path;else return{name:I,uri:R.toString(!0)};return{name:I,path:z}}e.$FU=E;function h(R){return R=(0,M.$nv)(R),(0,P.$Tf)(R)||(R=(0,P.$Qf)(R)),R}function i(R,k,I){const L=[],N=new Set,z=I.dirname(k);for(const ne of R){let _;if(u(ne))ne.path&&(_=I.resolvePath(z,ne.path));else if(l(ne))try{_=g.URI.parse(ne.uri),_.path[0]!==S.$fc.sep&&(_=_.with({path:S.$fc.sep+_.path}))}catch(ae){console.warn(ae)}if(_){const ae=I.getComparisonKey(_);if(!N.has(ae)){N.add(ae);const se=ne.name||I.basenameOrAuthority(_);L.push(new d.$8h({uri:_,name:se,index:L.length},ne))}}}return L}e.$GU=i;function a(R,k,I,L,N){const z=o(k,R),ne=N.dirname(k),_=N.dirname(L),ae=[];for(const K of z.folders){const G=u(K)?N.resolvePath(ne,K.path):g.URI.parse(K.uri);let U;I?U=!1:U=!u(K)||(0,S.$hc)(K.path),ae.push(E(G,U,K.name,_,N))}const se={insertSpaces:!1,tabSize:4,eol:f.$l||f.$k?`
`:`\r
`},oe=s.$XS(R,["folders"],ae,se);let J=s.$1S(R,oe);return(0,c.$zg)(z.remoteAuthority,(0,y.$Sk)(L))&&(J=s.$1S(J,s.$WS(J,["remoteAuthority"],se))),J}e.$HU=a;function o(R,k){const I=A.$Sm(k);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(L=>$(L));else throw new Error(`${R} looks like an invalid workspace file.`);return I}function t(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function n(R){return typeof R.folderUri=="string"}function r(R){return typeof R.fileUri=="string"}function p(R,k){const I={workspaces:[],files:[]};if(R){const L=function(z,ne){for(let _=0;_<z.length;_++)try{ne(z[_],_)}catch(ae){k.warn(`Error restoring recent entry ${JSON.stringify(z[_])}: ${ae.toString()}. Skip entry.`)}},N=R;Array.isArray(N.entries)&&L(N.entries,z=>{const ne=z.label,_=z.remoteAuthority;t(z)?I.workspaces.push({label:ne,remoteAuthority:_,workspace:{id:z.workspace.id,configPath:g.URI.parse(z.workspace.configPath)}}):n(z)?I.workspaces.push({label:ne,remoteAuthority:_,folderUri:g.URI.parse(z.folderUri)}):r(z)&&I.files.push({label:ne,remoteAuthority:_,fileUri:g.URI.parse(z.fileUri)})})}return I}e.$IU=p;function C(R){const k={entries:[]};for(const I of R.workspaces)b(I)?k.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):k.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of R.files)k.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return k}e.$JU=C}),define(te[98],ie([0,1,85,13,4,19]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o6b=e.$n6b=e.$m6b=e.$l6b=void 0,e.$l6b=128/4;function D(c){function g(){let w=c.scheme===A.Schemas.file?(0,M.$ig)(c):c.toString();return s.$l||(w=w.toLowerCase()),(0,P.createHash)("md5").update(w).digest("hex")}return{id:g(),configPath:c}}e.$m6b=D;function S(c,g){function w(){if(c.scheme!==A.Schemas.file)return(0,P.createHash)("md5").update(c.toString()).digest("hex");if(!g)return;let d;return s.$l?d=g.ino:s.$k?d=g.birthtime.getTime():s.$j&&(typeof g.birthtimeMs=="number"?d=Math.floor(g.birthtimeMs):d=g.birthtime.getTime()),(0,P.createHash)("md5").update(c.fsPath).update(d?String(d):"").digest("hex")}const y=w();if(typeof y=="string")return{id:y,uri:c}}e.$n6b=S;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$o6b=f}),define(te[99],ie([0,1,85,87,28,280,18,14,3,2,9,4,32,42,109]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class b{traceSocketEvent(k,I){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,I)}constructor(k,I=""){this.f=!0,this.debugLabel=I,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,S.$Z)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const I=L=>{this.traceSocketEvent("read",L),k(D.$ae.wrap(L))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(k){const I=L=>{k({type:0,hadError:L,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(k){const I=()=>{k()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,S.$Z)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,S.$Z)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$Ch=b;var m;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize",R[R.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var $;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})($||($={}));class u extends c.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,I){this.socket.traceSocketEvent(k,I)}constructor(k,I,L,N){super(),this.f=this.B(new f.$Md),this.g=this.B(new f.$Md),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:L?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new l(this,I,L,N,this.f,(z,ne)=>this.m(z,ne))),this.B(this.a.onError(z=>{console.error(z),(0,S.$Z)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new v.$xh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let I=0;for(;I<k.byteLength;)this.a.writeMessage(k.slice(I,Math.min(I+262144,k.byteLength)),{compressed:!0,opcode:2}),I+=262144}m(k,{compressed:I,opcode:L}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let N=2;k.byteLength<126?N+=0:k.byteLength<2**16?N+=2:N+=8;const z=D.$ae.alloc(N),ne=I?64:0,_=L&15;if(z.writeUInt8(128|ne|_,0),k.byteLength<126)z.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){z.writeUInt8(126,1);let ae=1;z.writeUInt8(k.byteLength>>>8&255,++ae),z.writeUInt8(k.byteLength>>>0&255,++ae)}else{z.writeUInt8(127,1);let ae=1;z.writeUInt8(0,++ae),z.writeUInt8(0,++ae),z.writeUInt8(0,++ae),z.writeUInt8(0,++ae),z.writeUInt8(k.byteLength>>>24&255,++ae),z.writeUInt8(k.byteLength>>>16&255,++ae),z.writeUInt8(k.byteLength>>>8&255,++ae),z.writeUInt8(k.byteLength>>>0&255,++ae)}this.socket.write(D.$ae.concat([z,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const I=this.b.peek(this.j.readLen),L=I.readUInt8(0),N=(L&128)>>>7,z=(L&64)>>>6,ne=L&15,_=I.readUInt8(1),ae=(_&128)>>>7,se=_&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(se===126?2:0)+(se===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=ne,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const I=this.b.read(this.j.readLen),L=I.readUInt8(1),N=(L&128)>>>7;let z=L&127,ne=1;z===126?z=I.readUInt8(++ne)*2**8+I.readUInt8(++ne):z===127&&(z=I.readUInt8(++ne)*0+I.readUInt8(++ne)*0+I.readUInt8(++ne)*0+I.readUInt8(++ne)*0+I.readUInt8(++ne)*2**24+I.readUInt8(++ne)*2**16+I.readUInt8(++ne)*2**8+I.readUInt8(++ne));let _=0;N&&(_=I.readUInt8(++ne)*2**24+I.readUInt8(++ne)*2**16+I.readUInt8(++ne)*2**8+I.readUInt8(++ne)),this.j.state=3,this.j.readLen=z,this.j.mask=_,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const I=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),i(I,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(I,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(I,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Dh=u;class l extends c.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$ae.alloc(0)}constructor(k,I,L,N,z,ne){super(),this.n=k,this.r=z,this.s=ne,this.a=this.B(new f.$Md),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$Md),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new f.$Md),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,I?(this.b=this.B(new E(this.n,N,L,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(_=>this.a.fire(_))),this.B(this.f.onError(_=>this.a.fire(_)))):(this.b=null,this.f=null)}writeMessage(k,I){this.g.push({data:k,options:I}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:I}=this.g.shift();if(this.f&&I.compressed){const L=await this.w(this.f,k);this.s(L,I)}else this.s(k,{...I,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,I){return new Promise((L,N)=>{k.write(I),k.flush(z=>L(z))})}acceptFrame(k,I,L){this.h.push({data:k,isCompressed:I,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const I=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(I)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,I,L){return new Promise((N,z)=>{k.write(I),L&&k.write(D.$ae.fromByteArray([0,0,255,255])),k.flush(ne=>N(ne))})}}class E extends c.$Rc{get recordedInflateBytes(){return this.j?D.$ae.concat(this.f):D.$ae.alloc(0)}constructor(k,I,L,N){super(),this.h=k,this.j=I,this.a=this.B(new f.$Md),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(N),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(D.$ae.wrap(z))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const I=D.$ae.concat(this.g);this.g.length=0,k(I)})}}class h extends c.$Rc{constructor(k,I){super(),this.g=k,this.a=this.B(new f.$Md),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(D.$ae.wrap(L))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let I=D.$ae.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),k(I)})}}function i(R,k){if(k===0)return;const I=R.byteLength>>>2;for(let ae=0;ae<I;ae++){const se=R.readUInt32BE(ae*4);R.writeUInt32BE(se^k,ae*4)}const L=I*4,N=R.byteLength-L,z=k>>>24&255,ne=k>>>16&255,_=k>>>8&255;N>=1&&R.writeUInt8(R.readUInt8(L)^z,L),N>=2&&R.writeUInt8(R.readUInt8(L+1)^ne,L+1),N>=3&&R.writeUInt8(R.readUInt8(L+2)^_,L+2)}e.$Eh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function o(){const R=(0,y.$dg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;const k=process.platform!=="darwin"&&e.$Eh?e.$Eh:(0,s.tmpdir)(),I=(0,g.$ic)(k,`vscode-ipc-${R}.sock`);return n(I),I}e.$Fh=o;function t(R,k,I){const L=(0,P.createHash)("md5").update(R).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${I}-${k}-sock`;const N=I.substr(0,4),z=k.substr(0,6),ne=L.substr(0,8);let _;return process.platform!=="darwin"&&e.$Eh&&!process.env.VSCODE_PORTABLE?_=(0,g.$ic)(e.$Eh,`vscode-${ne}-${N}-${z}.sock`):_=(0,g.$ic)(R,`${N}-${z}.sock`),n(_),_}e.$Gh=t;function n(R){const k=a[w.$u];typeof k=="number"&&R.length>=k&&console.warn(`WARNING: IPC handle "${R}" is longer than ${k} chars, try a shorter --user-data-dir`)}class r extends d.$rh{static b(k){const I=f.Event.fromNodeEventEmitter(k,"connection");return f.Event.map(I,L=>({protocol:new v.$yh(new b(L,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(L,"close"))}))}constructor(k){super(r.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Hh=r;function p(R){return new Promise((k,I)=>{const L=(0,A.createServer)();L.on("error",I),L.listen(R,()=>{L.removeListener("error",I),k(new r(L))})})}e.$Ih=p;function C(R,k){return new Promise((I,L)=>{const N=(0,A.createConnection)(R,()=>{N.removeListener("error",L),I(v.$zh.fromSocket(new b(N,`ipc-client${k}`),k))});N.once("error",L)})}e.$Jh=C}),define(te[25],ie([0,1,54,9,4,99,36,89,6]),function(Z,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$25b=e.$15b=void 0,e.$15b=(0,f.$Oh)(D.$Uh);class c extends S.$gm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,A.$ic)(this.userDataPath,"clp")}get backupHome(){return(0,A.$ic)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$Gh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,A.$ic)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$l){for(const w in process.env)if(w.endsWith("_VSCODE_SNAP_ORIG")){const y=w.slice(0,-17);if(this.d[y])continue;process.env[y]&&(this.d[y]=process.env[y]),process.env[w]?process.env[y]=process.env[w]:delete process.env[y]}}}restoreSnapExportedVariables(){if(s.$l)for(const w in this.d)process.env[w]=this.d[w],delete this.d[w]}}e.$25b=c,ke([P.$fh],c.prototype,"cachedLanguagesPath",null),ke([P.$fh],c.prototype,"backupHome",null),ke([P.$fh],c.prototype,"mainIPCHandle",null),ke([P.$fh],c.prototype,"mainLockfile",null),ke([P.$fh],c.prototype,"disableUpdates",null),ke([P.$fh],c.prototype,"crossOriginIsolated",null),ke([P.$fh],c.prototype,"codeCachePath",null),ke([P.$fh],c.prototype,"useCodeCache",null)}),define(te[281],ie([0,1,85,33,13,9,4,19,21,194,17,25,34,16,5,193,29,98]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$p6b=void 0;let l=class{static{u=this}static{this.a="backupWorkspaces"}constructor(h,i,a,o){this.j=h,this.k=i,this.l=a,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$lg,this.i={isEqual:(t,n)=>(0,A.$Vf)(t,n,!D.$l)}}async initialize(){const h=this.m.getItem(u.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(h.emptyWindows),this.d=await this.u((0,c.$i6b)(h)),this.e=await this.v((0,c.$j6b)(h)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==d.$vk.OFF}q(){return this.s()===d.$vk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||d.$vk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(h,i){this.d.some(o=>h.workspace.id===o.workspace.id)||(this.d.push(h),this.C());const a=(0,M.$ic)(this.c,h.workspace.id);return i?this.t(a,i).then(()=>a):a}async t(h,i){if(await f.Promises.exists(h)&&await this.z(h),await f.Promises.exists(i))try{await f.Promises.rename(i,h,!1)}catch(a){this.l.error(`Backup: Could not move backup folder to new location: ${a.toString()}`)}}registerFolderBackup(h){return this.e.some(i=>this.h.isEqual(h.folderUri,i.folderUri))||(this.e.push(h),this.C()),(0,M.$ic)(this.c,this.D(h))}registerEmptyWindowBackup(h){return this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,h.backupFolder))||(this.g.push(h),this.C()),(0,M.$ic)(this.c,h.backupFolder)}async u(h){if(!Array.isArray(h))return[];const i=new Set,a=[];for(const o of h){const t=o.workspace;if(!(0,m.$3h)(t))return[];if(!i.has(t.id)){i.add(t.id);const n=(0,M.$ic)(this.c,t.id);await this.B(n)?t.configPath.scheme!==s.Schemas.file||await f.Promises.exists(t.configPath.fsPath)?a.push(o):await this.z(n):await this.x(n)}}return a}async v(h){if(!Array.isArray(h))return[];const i=[],a=new Set;for(const o of h){const t=o.folderUri,n=this.h.getComparisonKey(t);if(!a.has(n)){a.add(n);const r=(0,M.$ic)(this.c,this.D(o));await this.B(r)?t.scheme!==s.Schemas.file||await f.Promises.exists(t.fsPath)?i.push(o):await this.z(r):await this.x(r)}}return i}async w(h){if(!Array.isArray(h))return[];const i=[],a=new Set;for(const o of h){const t=o.backupFolder;if(typeof t!="string")return[];if(!a.has(t)){a.add(t);const n=(0,M.$ic)(this.c,t);await this.B(n)?i.push(o):await this.x(n)}}return i}async x(h){try{await f.Promises.rm(h,f.RimRafMode.MOVE)}catch(i){this.l.error(`Backup: Could not delete stale backup: ${i.toString()}`)}}y(){let h=(0,$.$o6b)();for(;this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,h.id));)h=(0,$.$o6b)();return{backupFolder:h.id}}async z(h){const i=this.y(),a=(0,M.$ic)(this.c,i.backupFolder);try{await f.Promises.rename(h,a,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(i),!0}async getDirtyWorkspaces(){const h=[];for(const i of this.d)await this.A(i)&&h.push(i);for(const i of this.e)await this.A(i)&&h.push(i);return h}A(h){let i;return(0,c.$h6b)(h)?i=(0,M.$ic)(this.c,h.backupFolder):(0,b.$yU)(h)?i=(0,M.$ic)(this.c,this.D(h)):i=(0,M.$ic)(this.c,h.workspace.id),this.B(i)}async B(h){try{const i=await f.Promises.readdir(h);for(const a of i)try{if((await f.Promises.readdir((0,M.$ic)(h,a))).length>0)return!0}catch{}}catch{}return!1}C(){const h={workspaces:this.d.map(({workspace:i,remoteAuthority:a})=>{const o={id:i.id,configURIPath:i.configPath.toString()};return a&&(o.remoteAuthority=a),o}),folders:this.e.map(({folderUri:i,remoteAuthority:a})=>{const o={folderUri:i.toString()};return a&&(o.remoteAuthority=a),o}),emptyWindows:this.g.map(({backupFolder:i,remoteAuthority:a})=>{const o={backupFolder:i};return a&&(o.remoteAuthority=a),o})};this.m.setItem(u.a,h)}D(h){const i=h.folderUri;let a;return i.scheme===s.Schemas.file?a=D.$l?i.fsPath:i.fsPath.toLowerCase():a=i.toString().toLowerCase(),(0,P.createHash)("md5").update(a).digest("hex")}};e.$p6b=l,e.$p6b=l=u=ke([ee(0,w.$15b),ee(1,g.$hi),ee(2,v.$8i),ee(3,y.$qN)],l)}),define(te[20],ie([0,1,15,38,8,3,2,4,35,12,6,5,34,25]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$45b=e.LifecycleMainPhase=e.ShutdownReason=e.$35b=void 0,e.$35b=(0,g.$Nh)("lifecycleMainService");var b;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(b||(e.ShutdownReason=b={}));var m;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(m||(e.LifecycleMainPhase=m={}));let $=class extends D.$Rc{static{v=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(l,E,h){super(),this.F=l,this.G=E,this.H=h,this.c=this.B(new M.$Md),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$Md),this.onWillShutdown=this.f.event,this.g=this.B(new M.$Md),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$Md),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(v.b),this.m&&this.G.removeItem(v.b)}J(){const l=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$k&&this.t===0&&this.L(1))};P.app.addListener("before-quit",l);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!S.$k)&&P.app.quit()};P.app.addListener("window-all-closed",E),P.app.once("will-quit",h=>{this.S("Lifecycle#app.on(will-quit) - begin"),h.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),P.app.removeListener("before-quit",l),P.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}L(l){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const h=[];return this.f.fire({reason:l,join(i,a){E.trace(`Lifecycle#onWillShutdown - begin '${i}'`),h.push(a.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(h)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(l){if(l<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===l)return;this.S(`lifecycle (main): phase changed (value: ${l})`),this.n=l;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when(l){if(l<=this.n)return;let E=this.C.get(l);E||(E=new s.$Rg,this.C.set(l,E)),await E.wait()}registerWindow(l){const E=new D.$Qc;this.t++,E.add(l.onWillLoad(i=>this.g.fire({window:l,workspace:i.workspace,reason:i.reason})));const h=(0,c.$If)(l.win);h.on("close",i=>{const a=l.id;if(this.r.has(a)){this.r.delete(a);return}this.S(`Lifecycle#window.on('close') - window ID ${l.id}`),i.preventDefault(),this.unload(l,1).then(o=>{if(o){this.r.delete(a);return}this.r.add(a),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this.h.fire(l),l.close()})}),h.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${l.id}`),this.t--,E.dispose(),this.t===0&&(!S.$k||this.j)&&this.L(1)})}async reload(l,E){await this.unload(l,3)||l.reload(E)}unload(l,E){const h=this.z.get(l.id);if(h)return h;const i=this.M(l,E).finally(()=>{this.z.delete(l.id)});return this.z.set(l.id,i),i}async M(l,E){if(!l.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${l.id}`);const h=this.j?2:E,i=await this.P(l,h);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${l.id})`),this.N(i)):(await this.Q(l,h),!1)}N(l){return l?(this.O(!0),this.j=!1,!0):!1}O(l){this.w&&(this.w(l),this.w=void 0,this.u=void 0)}P(l,E){return new Promise(h=>{const i=this.s++,a=`vscode:ok${i}`,o=`vscode:cancel${i}`;A.$dT.once(a,()=>{h(!1)}),A.$dT.once(o,()=>{h(!0)}),l.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:o,reason:E})})}Q(l,E){return new Promise(h=>{const a=`vscode:reply${this.s++}`;A.$dT.once(a,()=>h()),l.send("vscode:onWillUnload",{replyChannel:a,reason:E})})}quit(l){return this.R(l).then(E=>{if(!E&&l)try{if(S.$j){const h=(0,f.cwd)();h!==process.cwd()&&process.chdir(h)}}catch(h){this.F.error(h)}return E})}R(l){return this.S(`Lifecycle#quit() - begin (willRestart: ${l})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(l&&this.G.setItem(v.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.u)}S(l){this.H.args["enable-smoke-test-driver"]?this.F.info(l):this.F.trace(l)}setRelaunchHandler(l){this.D=l}async relaunch(l){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if(l?.addArgs&&E.push(...l.addArgs),l?.removeArgs)for(const a of l.removeArgs){const o=E.indexOf(a);o>=0&&E.splice(o,1)}const h=()=>{this.D?.handleRelaunch(l)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:E}))};P.app.once("quit",h),await this.quit(!0)&&P.app.removeListener("quit",h)}async kill(l){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Tg)(1e3),(async()=>{for(const E of P.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let h;E.webContents&&!E.webContents.isDestroyed()?h=new Promise(i=>E.once("closed",i)):h=Promise.resolve(),E.destroy(),await h}})()]),P.app.exit(l)}};e.$45b=$,e.$45b=$=v=ke([ee(0,w.$8i),ee(1,y.$qN),ee(2,d.$15b)],$)}),define(te[282],ie([0,1,4,3,2,6,20]),function(Z,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U6b=e.$T6b=void 0,e.$T6b=(0,M.$Nh)("keyboardLayoutMainService");let S=class extends s.$Rc{constructor(g){super(),this.a=this.B(new A.$Md),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,g.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const g=await new Promise((w,y)=>{Z(["native-keymap"],w,y)});this.c=f(g),P.$t||g.onDidChangeKeyboardLayout(()=>{this.c=f(g),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$U6b=S,e.$U6b=S=ke([ee(0,D.$35b)],S);function f(c){const g=c.getKeyMap(),w=c.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:w}}}),define(te[283],ie([0,1,244,8,18,14,12,17,36,93,5,50,243,280]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=void 0;let v=class extends w.$Qo{constructor(u,l,E,h){super(h),this.m=u,this.n=l,this.r=E,this.s(),this.B(u.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const u=this.m.getValue("http");this.f=u?.proxy,this.g=!!u?.proxyStrictSSL,this.h=u?.proxyAuthorization}async request(u,l){const{f:E,g:h}=this;let i;try{i=await(0,c.$Ql)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$9)(t)))}const a={...process.env,...i},o=u.agent?u.agent:await(0,y.$Uq)(u.url||"",a,{proxyUrl:E,strictSSL:h});return u.agent=o,u.strictSSL=h,this.h&&(u.headers={...u.headers||{},"Proxy-Authorization":this.h}),this.c(u.isChromiumNetwork?"electron":"node",u,()=>m(u,l))}async resolveProxy(u){}};e.$Vq=v,e.$Vq=v=ke([ee(0,S.$hi),ee(1,f.$Vh),ee(2,g.$8i),ee(3,g.$9i)],v);async function b($){return((0,P.parse)($.url).protocol==="https:"?await new Promise((E,h)=>{Z(["https"],E,h)}):await new Promise((E,h)=>{Z(["http"],E,h)})).request}async function m($,u){return A.Promises.withAsyncBody(async(l,E)=>{const h=(0,P.parse)($.url),i=$.getRawRequest?$.getRawRequest($):await b($),a={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,D.$Df)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(a.auth=$.user+":"+$.password);const o=i(a,t=>{const n=(0,D.$Bf)($.followRedirects)?$.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)m({...$,url:t.headers.location,followRedirects:n-1},u).then(l,E);else{let r=t;!$.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(r=t.pipe((0,d.createGunzip)())),l({res:t,stream:(0,s.$pe)(r)})}});o.on("error",E),$.timeout&&o.setTimeout($.timeout),$.isChromiumNetwork&&o.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&o.write($.data),o.end(),u.onCancellationRequested(()=>{o.abort(),E(new M.$4)})})}e.$Wq=m}),define(te[284],ie([0,1,15,283]),function(Z,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X7b=void 0;function s(D){return P.net.request}class M extends A.$Vq{request(S,f){return super.request({...S||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.$X7b=M}),define(te[81],ie([0,1,7,3,2,36,16,6,20,5,96,277,41,52,40,13]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b6b=e.$a6b=e.$_5b=e.$$5b=void 0,e.$$5b=(0,S.$Nh)("storageMainService");let m=class extends s.$Rc{constructor(l,E,h,i,a,o){super(),this.c=l,this.f=E,this.g=h,this.h=i,this.j=a,this.m=o,this.a=void 0,this.b=this.B(new A.$Md),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(l=>{l.window.profile&&this.profileStorage(l.window.profile).init(),l.workspace&&this.workspaceStorage(l.workspace).init()})),this.B(this.h.onWillShutdown(l=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=l.reason,l.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)l.join("profileStorage",E.close());for(const[,E]of this.w)l.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(l=>{l.join((async()=>{await this.j.exists(l.profile.globalStorageHome)||await this.j.createFolder(l.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(l=>{const E=this.t.get(l.profile.id);E&&l.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const l=new w.$65b(this.n(),this.g,this.c,this.j);return this.B(A.Event.once(l.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),l}profileStorage(l){if((0,g.$6o)(l))return this.applicationStorage;let E=this.t.get(l.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${l.name})`),E=this.B(this.u(l)),this.t.set(l.id,E);const h=this.B(E.onDidChangeStorage(i=>this.b.fire({...i,storage:E,profile:l})));this.B(A.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${l.name})`),this.t.delete(l.id),h.dispose()}))}return E}u(l){return this.a===2?new w.$85b(this.c,this.j):new w.$55b(l,this.n(),this.c,this.j)}workspaceStorage(l){let E=this.w.get(l.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${l.id})`),E=this.B(this.y(l)),this.w.set(l.id,E),this.B(A.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${l.id})`),this.w.delete(l.id)}))),E}y(l){return this.a===2?new w.$85b(this.c,this.j):new w.$75b(l,this.n(),this.c,this.f,this.j)}isUsed(l){const E=P.URI.file(l);for(const h of[this.applicationStorage,...this.t.values(),...this.w.values()])if(h.path&&this.m.extUri.isEqualOrParent(P.URI.file(h.path),E))return!0;return!1}};e.$_5b=m,e.$_5b=m=ke([ee(0,c.$8i),ee(1,M.$Uh),ee(2,d.$95b),ee(3,f.$35b),ee(4,D.$9j),ee(5,v.$Gk)],m),e.$a6b=(0,S.$Nh)("applicationStorageMainService");let $=class extends g.$5o{constructor(l,E){super(),this.s=l,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(l){if(l===-1)return this.U.applicationStorage.storage}Q(l){if(l===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:b.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$b6b=$,e.$b6b=$=ke([ee(0,y.$Ik),ee(1,e.$$5b)],$)}),define(te[285],ie([0,1,87,28,103,99,8,2,4,17,5,24,239,240,94,126,18]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W7b=e.$V7b=e.$U7b=e.$T7b=void 0;async function $(i,a,o,t,n){let r;for(let p=3;p&&(r?.dispose(),r=await new u(i,a,o,t,n).waitForReady(),!(n&&s.$gg[n]||!s.$gg[r.tunnelLocalPort]));p--);return r}class u extends S.$Rc{constructor(a,o,t,n,r){super(),this.m=o,this.n=r,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=a,this.b=P.createServer(),this.c=new D.$Rg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=p=>this.r(p),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const a=this.n??this.tunnelRemotePort,o=(0,b.$_u)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,s.$hg)(a,2,1e3,o),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(a){a.pause();const o=(0,b.$0u)(this.tunnelRemoteHost)||(0,b.$_u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,y.$4k)(this.a,o,this.tunnelRemotePort),n=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&a.write(r.buffer),a.on("end",()=>{a.localAddress&&this.j.delete(a.localAddress),n.end()}),a.on("close",()=>n.end()),a.on("error",()=>{a.localAddress&&this.j.delete(a.localAddress),n instanceof M.$Ch?n.socket.destroy():n.end()}),n instanceof M.$Ch?this.t(a,n):this.s(a,n),a.localAddress&&this.j.set(a.localAddress,()=>{a.end(),n.end()})}s(a,o){o.onClose(()=>a.destroy()),o.onEnd(()=>a.end()),o.onData(t=>a.write(t.buffer)),a.on("data",t=>o.write(m.$ae.wrap(t))),a.resume()}t(a,o){const t=o.socket;t.on("end",()=>a.end()),t.on("close",()=>a.end()),t.on("error",()=>{a.destroy()}),t.pipe(a),a.pipe(t)}}e.$T7b=u;let l=class extends b.$cv{constructor(a,o,t,n,r){super(o,r),this.u=a,this.v=t,this.w=n}isPortPrivileged(a){return(0,b.$av)(a,this.l,f.OS,A.release())}s(a,o,t,n,r,p,C,R){const k=this.r(o,t);if(k)return++k.refcount,k.value;if((0,b.$7u)(a))return this.t(a,o,t,r,p,C,R);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${t} on local port ${r}.`);const I={commit:this.w.commit,quality:this.w.quality,addressProvider:a,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=$(I,n,o,t,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(o,t,L),L}}};e.$U7b=l,e.$U7b=l=ke([ee(0,d.$Xk),ee(1,g.$8i),ee(2,v.$1k),ee(3,w.$nj),ee(4,c.$hi)],l);let E=class extends l{constructor(a,o,t,n,r){super(a,o,t,n,r)}};e.$V7b=E,e.$V7b=E=ke([ee(0,d.$Xk),ee(1,g.$8i),ee(2,v.$1k),ee(3,w.$nj),ee(4,c.$hi)],E);let h=class extends S.$Rc{constructor(a,o,t,n,r){super(),this.b=a,this.c=o,this.f=t,this.g=n,this.h=r,this.a=new Map}async openTunnel(a,o,t,n,r,p,C,R,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${p}.`),!this.a.has(a)){const I=new E(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(a,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(o,t,n,r,p,C,R,k)}};e.$W7b=h,e.$W7b=h=ke([ee(0,d.$Xk),ee(1,g.$8i),ee(2,w.$nj),ee(3,v.$1k),ee(4,c.$hi)],h)}),define(te[100],ie([0,1,8,22,3,17,25,20,5,24,50,48]),function(Z,e,P,A,s,M,D,S,f,c,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=e.$g7b=void 0;function y(v,b,m){return`${m.updateUrl}/api/update/${v}/${b}/${m.commit}`}e.$g7b=y;let d=class{get state(){return this.b}d(b){this.j.info("update#setState",b.type),this.b=b,this.c.fire(b)}constructor(b,m,$,u,l,E){this.f=b,this.g=m,this.h=$,this.i=u,this.j=l,this.k=E,this.b=w.$cU.Uninitialized,this.c=new s.$Md,this.onStateChange=this.c.event,b.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(w.$cU.Disabled(0));return}if(this.h.disableUpdates){this.d(w.$cU.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(w.$cU.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.g.getValue("update.mode"),m=this.m(b);if(!m){this.d(w.$cU.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(m),!this.a){this.d(w.$cU.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(w.$cU.Idle(this.q())),b==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(b){return b==="none"?void 0:this.k.quality}n(b=60*60*1e3){return(0,P.$Tg)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(b){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(b)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(b){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},A.CancellationToken.None)).res.statusCode===204}catch(m){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(m);return}}async _applySpecificUpdate(b){}q(){return 1}r(){}};e.$h7b=d,e.$h7b=d=ke([ee(0,S.$35b),ee(1,M.$hi),ee(2,D.$15b),ee(3,g.$Po),ee(4,f.$8i),ee(5,c.$nj)],d)}),define(te[286],ie([0,1,15,54,3,2,17,25,20,5,24,50,26,48,100]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i7b=void 0;let b=class extends v.$h7b{get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",($,u)=>u)}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",($,u,l)=>({url:u,version:l,productVersion:l}))}get y(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",($,u,l,E)=>({releaseNotes:u,version:l,productVersion:l,date:E}))}constructor($,u,l,E,h,i,a){super($,u,E,h,i,a),this.z=l,this.u=new M.$Qc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.j.error("UpdateService error:",$);const u=this.state.type==="checking for updates"&&this.state.explicit?$:void 0;this.d(d.$cU.Idle(1,u))}s($){let u;this.k.darwinUniversalAssetId?u=this.k.darwinUniversalAssetId:u=process.arch==="x64"?"darwin":"darwin-arm64";const l=(0,v.$g7b)(u,$,this.k);try{P.autoUpdater.setFeedURL({url:l})}catch(E){this.j.error("Failed to set update feed URL",E);return}return l}t($){this.d(d.$cU.CheckingForUpdates($)),P.autoUpdater.checkForUpdates()}E($){this.state.type==="checking for updates"&&this.d(d.$cU.Downloading($))}F($){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:$.version}),this.d(d.$cU.Ready($)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.$cU.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$i7b=b,ke([A.$fh],b.prototype,"v",null),ke([A.$fh],b.prototype,"w",null),ke([A.$fh],b.prototype,"x",null),ke([A.$fh],b.prototype,"y",null),e.$i7b=b=ke([ee(0,f.$35b),ee(1,D.$hi),ee(2,y.$al),ee(3,S.$15b),ee(4,w.$Po),ee(5,c.$8i),ee(6,g.$nj)],b)}),define(te[287],ie([0,1,47,45,8,3,9,25,20,5,26,48]),function(Z,e,P,A,s,M,D,S,f,c,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7b=void 0;let y=class{get state(){return this.a}d(b){this.g.info("update#setState",b.type),this.a=b,this.b.fire(b)}constructor(b,m,$){if(this.f=b,this.g=$,this.a=w.$cU.Uninitialized,this.b=new M.$Md,this.onStateChange=this.b.event,m.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(w.$cU.Idle(this.k())),this.h(30*1e3).then(void 0,u=>this.g.error(u))}h(b=60*60*1e3){return(0,s.$Tg)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(b){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(b)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(b){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(b){}};y=ke([ee(0,f.$35b),ee(1,S.$15b),ee(2,c.$8i)],y);let d=class extends y{constructor(b,m,$,u,l,E){super($,u,l),this.o=b,this.p=m,this.q=E;const h=(0,A.watch)(D.$lc(this.o)),i=M.Event.fromNodeEventEmitter(h,"change",(n,r)=>r),a=M.Event.filter(i,n=>n==="current"),t=M.Event.debounce(a,(n,r)=>r,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{t.dispose(),h.close()})}m(){this.d(w.$cU.CheckingForUpdates(!1)),this.u().then(b=>{b?this.d(w.$cU.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$cU.Idle(2)))},b=>{this.g.error(b),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$cU.Idle(2,b.message||b))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+D.$mc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const b=await new Promise(($,u)=>(0,A.realpath)(`${D.$lc(this.o)}/current`,(l,E)=>l?u(l):$(E))),m=D.$mc(b);return this.p!==m}isLatestVersion(){return this.u().then(void 0,b=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$k7b=d,e.$k7b=d=ke([ee(2,f.$35b),ee(3,S.$15b),ee(4,c.$8i),ee(5,g.$al)],d)}),define(te[30],ie([0,1,4,6,95,59,68,24,17,25,9]),function(Z,e,P,A,s,M,D,S,f,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f6b=e.OpenContext=e.$e6b=void 0,e.$e6b=(0,A.$Nh)("windowsMainService");var w;(function(d){d[d.CLI=0]="CLI",d[d.DOCK=1]="DOCK",d[d.MENU=2]="MENU",d[d.DIALOG=3]="DIALOG",d[d.DESKTOP=4]="DESKTOP",d[d.API=5]="API"})(w||(e.OpenContext=w={}));function y(d,v=(0,s.$Z5b)(),b){const m=d.get(D.$c6b),$=d.get(S.$nj),u=d.get(f.$hi),l=d.get(c.$15b),E=u.getValue("window"),h={width:v.width,height:v.height,x:v.x,y:v.y,backgroundColor:m.getBackgroundColor(),minWidth:M.$WC.WIDTH,minHeight:M.$WC.HEIGHT,title:$.nameLong,...b,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.$4C)(E?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...b?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return P.$l?h.icon=(0,g.$ic)(l.appRoot,"resources/linux/code.png"):P.$j&&!l.isBuilt&&(h.icon=(0,g.$ic)(l.appRoot,"resources/win32/code_150x150.png")),P.$k&&(h.acceptFirstMouse=!0,E?.clickThroughInactive===!1&&(h.acceptFirstMouse=!1)),h}e.$f6b=y}),define(te[288],ie([0,1,15,22,3,55,2,32,116,5,81,30]),function(Z,e,P,A,s,M,D,S,f,c,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g6b=void 0;var y;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let d=class extends D.$Rc{constructor(b,m,$,u){super(),this.g=b,this.h=m,this.j=$,this.m=u,this.a="proxy-credentials://",this.b=void 0,this.c=y.Initial,this.f=void 0,this.n()}n(){const b=s.Event.fromNodeEventEmitter(P.app,"login",(m,$,u,l,E)=>({event:m,webContents:$,req:u,authInfo:l,callback:E}));this.B(b(this.r,this))}async r({event:b,authInfo:m,req:$,callback:u}){if(!m.isProxy)return;if(!this.b&&this.c===y.LoginDialogShown&&$.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let l;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(m);try{l=await this.b}finally{this.b=void 0}}u(l?.username,l?.password)}async s(b){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const m=await this.t(b);if(m)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),m;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(b){this.g.trace("auth#doResolveProxyCredentials - enter",b);const m=String((0,M.$Bi)({scheme:b.scheme,host:b.host,port:b.port}));let $,u;try{const i=this.m.get(this.a+m,-1);if(i){const a=JSON.parse(await this.j.decrypt(i));$=a.username,u=a.password}}catch(i){this.g.error(i)}if(this.c!==y.StoredCredentialsUsed&&typeof $=="string"&&typeof u=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=y.StoredCredentialsUsed,{username:$,password:u};const l=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!l){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${l.id} to handle proxy login`);const E={authInfo:b,username:this.f?.username??$,password:this.f?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,S.$dg)()}`};l.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,E),this.c=y.LoginDialogShown;const h=await new Promise(i=>{const a=async(o,t,n)=>{if(t===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${l.id}`),l.win?.webContents.off("ipc-message",a),n){const r={username:n.username,password:n.password};try{if(n.remember){const p=await this.j.encrypt(JSON.stringify(r));this.m.store(this.a+m,p,-1,1)}else this.m.remove(this.a+m,-1)}catch(p){this.g.error(p)}i({username:r.username,password:r.password})}else i(void 0)};l.win?.webContents.on("ipc-message",a)});return this.f=h,h}};e.$g6b=d,e.$g6b=d=ke([ee(0,c.$8i),ee(1,w.$e6b),ee(2,f.$XT),ee(3,g.$a6b)],d)}),define(te[289],ie([0,1,15,23,4,7,21,17,63,6,5,127,30]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=e.$W6b=e.ID=void 0,e.ID="launchMainService",e.$W6b=(0,c.$Nh)(e.ID);let d=class{constructor(b,m,$,u){this.a=b,this.b=m,this.c=$,this.d=u}async start(b,m){this.a.trace("Received data from other instance: ",b,m),s.$k&&P.app.focus({steal:!0});const $=this.e(b);if($.length){let u=Promise.resolve();if(this.b.getWindowCount()===0){const l=(0,A.$Nb)(await this.b.openEmptyWindow({context:4}));l&&(u=l.ready())}u.then(()=>{for(const{uri:l,originalUrl:E}of $)this.c.open(l,{originalUrl:E})})}else return this.f(b,m)}e(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,A.$Gb)(b._urls.map(m=>{try{return{uri:M.URI.parse(m),originalUrl:m}}catch{return null}})):[]}async f(b,m){const $=(0,f.$Kl)(m)?0:4;let u=[];const l=b.wait&&b.waitMarkerFilePath?M.URI.file(b.waitMarkerFilePath):void 0,E=b.remote||void 0,h={context:$,cli:b,userEnv:m,waitMarkerFileURI:l,remoteAuthority:E,forceProfile:b.profile,forceTempProfile:b["profile-temp"]};if(b.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,h);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let i=!1;if(b["new-window"]||b["unity-launch"]||h.forceProfile||h.forceTempProfile)i=!0;else if(b["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!s.$k}if(i)u=await this.b.open({...h,forceNewWindow:!0,forceEmpty:!0});else{const a=this.b.getLastActiveWindow();a?(this.b.openExistingWindow(a,h),u=[a]):u=await this.b.open({...h,forceEmpty:!0})}}else u=await this.b.open({...h,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if(l&&u.length===1&&u[0])return Promise.race([u[0].whenClosedOrLoaded,(0,D.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$X6b=d,e.$X6b=d=ke([ee(0,g.$8i),ee(1,y.$e6b),ee(2,w.$4T),ee(3,S.$hi)],d)}),define(te[290],ie([0,1,2,20,52,29,8,30]),function(Z,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=void 0;let f=class extends P.$Rc{constructor(g,w,y){super(),this.a=w,this.b=y,this.B(g.onWillLoadWindow(d=>{d.reason===2&&this.c(d.window)})),this.B(g.onBeforeCloseWindow(d=>this.c(d))),this.B(new D.$5g(()=>this.g(),30*1e3)).schedule()}async c(g){const w=this.f(g),y=this.a.getProfileForWorkspace(w);y?.isTransient&&(this.a.unsetWorkspace(w,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(g){return g.openedWorkspace??(0,M.$2h)(g.backupPath,g.isExtensionDevelopmentHost)}g(){const g=this.a.getAssociatedEmptyWindows();if(g.length===0)return;const w=this.b.getWindows().map(y=>this.f(y));for(const y of g)w.some(d=>d.id===y.id)||this.a.unsetWorkspace(y,!1)}};e.$D7b=f,e.$D7b=f=ke([ee(0,A.$35b),ee(1,s.$95b),ee(2,S.$e6b)],f)}),define(te[61],ie([0,1,15,2,3,5,311,8,13,30,73,26,20,75,37,4,130]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$z6b=e.$y6b=void 0;function u(h){return typeof h.responseWindowId=="number"}let l=class extends A.$Rc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(i,a,o){super(),this.t=i,this.u=a,this.w=o,this.c=String(++$.a),this.f=this.B(new s.$Md),this.onStdout=this.f.event,this.g=this.B(new s.$Md),this.onStderr=this.g.event,this.h=this.B(new s.$Md),this.onMessage=this.h.event,this.j=this.B(new s.$Md),this.onExit=this.j.event,this.m=this.B(new s.$Md),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(i,a){let o;switch(this.s?.correlationId?o=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`:o=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`,a){case g.default.Error:this.t.error(o);break;case g.default.Warning:this.t.warn(o);break;case g.default.Info:this.t.trace(o);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(i){const a=this.C(i);return a&&i.payload&&this.postMessage(i.payload),a}C(i){if(!this.z())return!1;this.s=i;const a=`${this.s.type}-${this.c}`,o=f.$bg.asFileUri("bootstrap-fork.js").fsPath,t=this.s.args??[],n=this.s.execArgv??[],r=this.s.allowLoadingUnsignedLibraries,p=this.s.forceAllocationsToV8Sandbox,C="pipe",R=this.D(i);return this.y("creating new...",g.default.Info),this.n=P.utilityProcess.fork(o,t,{serviceName:a,env:R,execArgv:n,allowLoadingUnsignedLibraries:r,forceAllocationsToV8Sandbox:p,stdio:C}),this.F(this.n,this.s,a),!0}D(i){const a=i.env?{...i.env}:{...(0,v.$3m)(process.env)};a.VSCODE_AMD_ENTRYPOINT=i.entryPoint,typeof i.parentLifecycleBound=="number"&&(a.VSCODE_PARENT_PID=String(i.parentLifecycleBound)),a.VSCODE_CRASH_REPORTER_PROCESS_TYPE=i.type,b.$j&&((0,m.isUNCAccessRestrictionsDisabled)()?a.NODE_DISABLE_UNC_ACCESS_CHECKS="1":a.NODE_UNC_HOST_ALLOWLIST=(0,m.getUNCHostAllowlist)().join("\\")),(0,d.$xl)(a);for(const o of Object.keys(a))a[o]=String(a[o]);return a}F(i,a,o){if(i.stdout){const t=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:t.write(n))))}if(i.stderr){const t=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:t.write(n))))}this.B(s.Event.fromNodeEventEmitter(i,"message")(t=>this.h.fire(t))),this.B(s.Event.fromNodeEventEmitter(i,"spawn")(()=>{this.r=i.pid,typeof i.pid=="number"&&$.b.set(i.pid,{pid:i.pid,name:u(a)?`${a.type} [${a.responseWindowId}]`:a.type}),this.y("successfully created",g.default.Info)})),this.B(s.Event.fromNodeEventEmitter(i,"exit")(t=>{this.y(`received exit event with code ${t}`,g.default.Info),this.j.fire({pid:this.r,code:t,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(t,n)=>({event:t,details:n}))(({details:t})=>{t.type==="Utility"&&t.name===o&&(this.y(`crashed with code ${t.exitCode} and reason '${t.reason}'`,g.default.Error),this.u.publicLog2("utilityprocesscrash",{type:a.type,reason:t.reason,code:t.exitCode}),this.m.fire({pid:this.r,code:t.exitCode,reason:t.reason}),this.G())}))}once(i,a){const o=this.B(this.h.event(t=>{t===i&&(o.dispose(),a())}))}postMessage(i,a){this.n&&this.n.postMessage(i,a)}connect(i){const{port1:a,port2:o}=new P.MessageChannelMain;return this.postMessage(i,[o]),a}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",g.default.Info);const i=process;return typeof i._debugProcess=="function"?(i._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",g.default.Info),this.n.kill()?(this.y("successfully killed the process",g.default.Info),this.G()):this.y("unable to kill the process",g.default.Warning)}G(){typeof this.r=="number"&&$.b.delete(this.r),this.n=void 0}async waitForExit(i){this.n&&(this.y("waiting to exit...",g.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,S.$Tg)(i)]),this.n&&(this.y(`did not exit within ${i}ms, will kill it now...`,g.default.Info),this.kill()))}};e.$y6b=l,e.$y6b=l=$=ke([ee(0,M.$8i),ee(1,w.$al),ee(2,y.$35b)],l);let E=class extends l{constructor(i,a,o,t){super(i,o,t),this.H=a}start(i){const a=this.H.getWindowById(i.responseWindowId);if(!a?.win||a.win.isDestroyed()||a.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.C(i))return!1;this.I(a.win,i);const t=this.connect(i.payload);return a.win.webContents.postMessage(i.responseChannel,i.responseNonce,[t]),!0}I(i,a){a.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,o=>o.window.win===i)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(i,"closed")(()=>this.kill())))}};e.$z6b=E,e.$z6b=E=ke([ee(0,M.$8i),ee(1,c.$e6b),ee(2,w.$al),ee(3,y.$35b)],E)}),define(te[291],ie([0,1,14,5,20,8,61,30,26]),function(Z,e,P,A,s,M,D,S,f){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$G6b=void 0;let g=class{static{c=this}static{this.a=0}constructor(y,d,v,b){this.d=y,this.f=d,this.g=v,this.h=b,this.b=new Map,this.c=!1,this.f.onWillShutdown(m=>{this.c=!0,m.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(y){const d=this.b.get(y);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout(y){return this.i(y).onStdout}onDynamicStderr(y){return this.i(y).onStderr}onDynamicMessage(y){return this.i(y).onMessage}onDynamicExit(y){return this.i(y).onExit}async createExtensionHost(){if(this.c)throw(0,P.$5)();const y=String(++c.a),d=new D.$z6b(this.d,this.g,this.h,this.f);return this.b.set(y,d),d.onExit(({pid:v,code:b,signal:m})=>{this.d.info(`Extension host with pid ${v} exited with code: ${b}, signal: ${m}.`),setTimeout(()=>{d.dispose(),this.b.delete(y)})}),{id:y}}async start(y,d){if(this.c)throw(0,P.$5)();this.i(y).start({...d,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:d.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:y})}async enableInspectPort(y){if(this.c)throw(0,P.$5)();const d=this.b.get(y);return d?d.enableInspectPort():!1}async kill(y){if(this.c)throw(0,P.$5)();const d=this.b.get(y);d&&d.kill()}async _killAllNow(){for(const[,y]of this.b)y.kill()}async _waitForAllExit(y){const d=[];for(const[,v]of this.b)d.push(v.waitForExit(y));return M.Promises.settled(d).then(()=>{})}};e.$G6b=g,e.$G6b=g=c=ke([ee(0,A.$8i),ee(1,s.$35b),ee(2,S.$e6b),ee(3,f.$al)],g)}),define(te[292],ie([0,1,38,8,2,25,20,5,41,39,67,61,51,89,12,245,24]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=void 0;let $=class extends s.$Rc{constructor(l,E,h,i,a,o,t,n){super(),this.c=l,this.f=E,this.g=h,this.h=i,this.j=a,this.m=o,this.n=t,this.r=n,this.a=new A.$Rg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){P.$dT.on(b.$$6b.request,(l,E)=>this.t(l,E,b.$$6b.response)),P.$dT.on(b.$_6b.request,(l,E)=>this.t(l,E,b.$_6b.response)),this.B(this.h.onWillShutdown(()=>this.u()))}async t(l,E,h){this.j.trace(`[SharedProcess] onWindowConnection for: ${h}`),this.a.isOpen()||this.a.open(),await this.whenReady();const i=await this.connect(h);if(l.sender.isDestroyed())return i.close();l.sender.postMessage(h,E,[i])}u(){this.j.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(b.$06b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const l=new A.$bh;this.b?this.b.once(b.$06b.initDone,()=>l.complete()):P.$dT.once(b.$06b.initDone,()=>l.complete()),await l.p,this.j.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const l=new A.$bh;this.b?this.b.once(b.$06b.ipcReady,()=>l.complete()):P.$dT.once(b.$06b.ipcReady,()=>l.complete()),await l.p,this.j.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new w.$y6b(this.j,y.$io,this.h));const l=(0,d.$im)(this.f.args,this.f.isBuilt);let E;l.port&&(E=["--nolazy"],l.break?E.push(`--inspect-brk=${l.port}`):E.push(`--inspect=${l.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:E,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.r.quality!=="stable"})}D(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.m.getLogLevel(),loggers:this.m.getRegisteredLoggers(),policiesData:this.n.serialize()}}async connect(l){return await this.z,(0,v.$If)(this.b).connect(l)}};e.$a7b=$,e.$a7b=$=ke([ee(1,M.$15b),ee(2,f.$Ik),ee(3,D.$35b),ee(4,S.$8i),ee(5,g.$86b),ee(6,c.$en),ee(7,m.$nj)],$)}),define(te[293],ie([0,1,25,89,20,5,51,61,110,38,2,3,37,17,13]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=void 0;let b=class extends g.$Rc{constructor($,u,l,E,h){super(),this.f=$,this.g=u,this.h=l,this.j=E,this.m=h,this.a=void 0,this.b=new w.$Md,this.onRequestConnection=this.b.event,this.c=new w.$Md,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$dT.on("vscode:createPtyHostMessageChannel",(i,a)=>this.r(i,a)),this.B((0,g.$Pc)(()=>{c.$dT.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$y6b(this.m,D.$io,this.j);const $=(0,A.$hm)(this.h.args,this.h.isBuilt),u=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:u,args:["--logsPath",this.h.logsHome.with({scheme:v.Schemas.file}).fsPath],env:this.n()});const l=this.a.connect(),E=new f.$lT(l,"ptyHost"),h=new g.$Qc;return h.add(E),h.add((0,g.$Pc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:h,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,y.$3m)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},u=this.g.getValue("terminal.integrated.developer.ptyHost.latency");u&&typeof u=="number"&&($.VSCODE_LATENCY=String(u));const l=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return l&&typeof l=="number"&&($.VSCODE_STARTUP_DELAY=String(l)),this.h.restoreSnapExportedVariables(),$}r($,u){this.b.fire();const l=this.a.connect();if($.sender.isDestroyed()){l.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",u,[l])}};e.$L7b=b,e.$L7b=b=ke([ee(1,d.$hi),ee(2,P.$15b),ee(3,s.$35b),ee(4,M.$8i)],b)}),define(te[294],ie([0,1,2,6,5,30,61,26,55,3,8,20]),function(Z,e,P,A,s,M,D,S,f,c,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K7b=e.$J7b=void 0,e.$J7b=(0,A.$Nh)("utilityProcessWorker");let y=class extends P.$Rc{constructor(b,m,$,u){super(),this.b=b,this.c=m,this.f=$,this.g=u,this.a=new Map}async createWorker(b){const m=`window: ${b.reply.windowId}, moduleId: ${b.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${m})`);const $=this.h(b);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${m})`),this.disposeWorker(b));const u=new d(this.b,this.c,this.f,this.g,b);if(!u.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,u);const l=new g.$bh;return c.Event.once(u.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete($),l.complete({reason:E})}),l.p}h(b){return(0,f.$Bi)({moduleId:b.process.moduleId,windowId:b.reply.windowId})}async disposeWorker(b){const m=this.h(b),$=this.a.get(m);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${b.reply.windowId}, moduleId: ${b.process.moduleId})`),$.kill(),this.a.delete(m))}};e.$K7b=y,e.$K7b=y=ke([ee(0,s.$8i),ee(1,M.$e6b),ee(2,S.$al),ee(3,w.$35b)],y);let d=class extends P.$Rc{constructor(b,m,$,u,l){super(),this.c=b,this.f=m,this.g=$,this.h=u,this.j=l,this.a=this.B(new c.$Md),this.onDidTerminate=this.a.event,this.b=new D.$z6b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(b=>this.a.fire({code:b.code,signal:b.signal}))),this.B(this.b.onCrash(b=>this.a.fire({code:b.code,signal:"ECRASH"})))}spawn(){const m=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:m,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};d=ke([ee(0,s.$8i),ee(1,M.$e6b),ee(2,S.$al),ee(3,w.$35b)],d)}),define(te[295],ie([0,1,15,3,2,271,30]),function(Z,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=void 0;let S=class extends s.$Rc{constructor(c){super(),this.b=c,this.a=this.B(new A.$Md),this.onFoundInFrame=this.a.event,this.B(new M.$r7b)}async setIgnoreMenuShortcuts(c,g){let w;if(typeof c.windowId=="number"){const{windowId:y}=c,d=this.b.getWindowById(y);if(!d?.win)throw new Error(`Invalid windowId: ${y}`);w=d.win.webContents}else{const{webContentsId:y}=c;if(w=P.webContents.fromId(y),!w)throw new Error(`Invalid webContentsId: ${y}`)}w.isDestroyed()||w.setIgnoreMenuShortcuts(g)}async findInFrame(c,g,w,y){const v=this.c(c,g);if(typeof v.findInFrame=="function"){v.findInFrame(w,{findNext:y.findNext,forward:y.forward});const b=(m,$)=>{$.finalUpdate&&(this.a.fire($),v.removeListener("found-in-frame",b))};v.on("found-in-frame",b)}}async stopFindInFrame(c,g,w){const d=this.c(c,g);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(w.keepSelection?"keepSelection":"clearSelection")}c(c,g){const w=this.b.getWindowById(c.windowId);if(!w?.win)throw new Error(`Invalid windowId: ${c}`);const y=w.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===g);if(!y)throw new Error(`Unknown frame: ${g}`);return y}};e.$s7b=S,e.$s7b=S=ke([ee(0,D.$e6b)],S)}),define(te[296],ie([0,1,15,13,17,25,59,30]),function(Z,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=void 0;let f=class{static open(g){return g.invokeFunction(S.$f6b,void 0,{webPreferences:{preload:A.$bg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-slim.js").fsPath}})}constructor(g,w,y){this.a=g,this.b=w,this.c=y,this.d(),this.e()}d(){this.a.on("dom-ready",()=>{const g=this.b.getValue("window")?.zoomLevel??0;this.a.setZoomLevel(g),this.a.setZoomFactor((0,D.$4C)(g))}),this.c.args["open-devtools"]===!0&&this.a.openDevTools({mode:"bottom"})}e(){this.a.ipc.on("vscode:focusAuxiliaryWindow",()=>{this.f(g=>g.focus(),!0)}),this.a.ipc.on("vscode:moveAuxiliaryWindowTop",()=>{this.f(g=>g.moveTop(),!0)})}f(g,w){const y=P.BrowserWindow.fromWebContents(this.a);y&&(w&&y.isMinimized()&&y.restore(),g(y))}};e.$P7b=f,e.$P7b=f=ke([ee(1,s.$hi),ee(2,M.$15b)],f)}),define(te[297],ie([0,1,15,2,4,19,7,17,20,5,34,30,95,29]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=e.$v7b=e.$u7b=void 0;let b=class extends A.$Rc{static{v=this}static{this.a="windowsState"}get state(){return this.b}constructor(h,i,a,o,t){super(),this.g=h,this.h=i,this.j=a,this.m=o,this.n=t,this.b=m(this.h.getItem(v.a)),this.c=void 0,this.f=!1,this.r()}r(){P.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(h=>this.u(h)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(h=>this.u(h))}s(){this.f=!0,this.t()}t(){const h=new Set,i={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!i.lastActiveWindow){let t=this.g.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(i.lastActiveWindow=this.w(t),i.lastActiveWindow.uiState.mode===3&&h.add(i.lastActiveWindow.uiState.display))}const a=this.g.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);a&&(i.lastPluginDevelopmentHostWindow=this.w(a),i.lastPluginDevelopmentHostWindow.uiState.mode===3&&(h.has(i.lastPluginDevelopmentHostWindow.uiState.display)?s.$k&&!a.win?.isSimpleFullScreen()&&(i.lastPluginDevelopmentHostWindow.uiState.mode=1):h.add(i.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(i.openedWindows=this.g.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>{const n=this.w(t);return n.uiState.mode===3&&(h.has(n.uiState.display)?s.$k&&n.windowId!==i.lastActiveWindow?.windowId&&!t.win?.isSimpleFullScreen()&&(n.uiState.mode=1):h.add(n.uiState.display)),n}));const o=u(i);this.h.setItem(v.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(h){if(this.j.quitRequested)return;const i=this.w(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=i:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this.b.openedWindows.forEach(a=>{const o=(0,d.$3h)(h.openedWorkspace)&&a.workspace?.id===h.openedWorkspace.id,t=(0,d.$Xh)(h.openedWorkspace)&&a.folderUri&&M.$lg.isEqual(a.folderUri,h.openedWorkspace.uri);(o||t)&&(a.uiState=i.uiState)}),this.g.getWindowCount()===1&&(this.c=i)}w(h){return{windowId:h.id,workspace:(0,d.$3h)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,d.$Xh)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const i=this.z(h),a=this.n.getValue("window");if(i.mode===3){let o;i.hasDefaultState?o=!!(a?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(a.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||a?.restoreFullscreen),o||(i.mode=1)}return i}z(h){const i=this.g.getLastActiveWindow();if(!h.extensionTestsPath){if(h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const p=h.workspace;if((0,d.$3h)(p)){const R=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===p.id).map(k=>k.uiState);if(R.length)return R[0]}if((0,d.$Xh)(p)){const R=this.state.openedWindows.filter(k=>k.folderUri&&M.$lg.isEqual(k.folderUri,p.uri)).map(k=>k.uiState);if(R.length)return R[0]}else if(h.backupPath){const R=this.state.openedWindows.filter(k=>k.backupPath===h.backupPath).map(k=>k.uiState);if(R.length)return R[0]}const C=this.c||this.state.lastActiveWindow;if(!i&&C)return C.uiState}let a;const o=P.screen.getAllDisplays();if(o.length===1)a=o[0];else{if(s.$k){const p=P.screen.getCursorScreenPoint();a=P.screen.getDisplayNearestPoint(p)}!a&&i&&(a=P.screen.getDisplayMatching(i.getBounds())),a||(a=P.screen.getPrimaryDisplay()||o[0])}let t=(0,y.$Z5b)();t.x=Math.round(a.bounds.x+a.bounds.width/2-t.width/2),t.y=Math.round(a.bounds.y+a.bounds.height/2-t.height/2);const n=this.n.getValue("window");let r=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")t.mode=0,r=!1;else if(n.newWindowDimensions==="fullscreen")t.mode=3,r=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&i){const p=i.serializeWindowState();p.mode===3?t.mode=3:t=p,r=t.mode!==3&&n.newWindowDimensions==="offset"}}return r&&(t=this.C(t)),t.hasDefaultState=!0,t}C(h){if(this.g.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const i=this.g.getWindows().map(a=>a.getBounds());for(;i.some(a=>a.x===h.x||a.y===h.y);)h.x+=30,h.y+=30;return h}};e.$u7b=b,e.$u7b=b=v=ke([ee(0,w.$e6b),ee(1,g.$qN),ee(2,f.$35b),ee(3,c.$8i),ee(4,S.$hi)],b);function m(E){const h={openedWindows:[]},i=E||{openedWindows:[]};return i.lastActiveWindow&&(h.lastActiveWindow=$(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=$(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(h.openedWindows=i.openedWindows.map(a=>$(a))),h}e.$v7b=m;function $(E){const h={uiState:E.uiState};return E.backupPath&&(h.backupPath=E.backupPath),E.remoteAuthority&&(h.remoteAuthority=E.remoteAuthority),E.folder&&(h.folderUri=D.URI.parse(E.folder)),E.workspaceIdentifier&&(h.workspace={id:E.workspaceIdentifier.id,configPath:D.URI.parse(E.workspaceIdentifier.configURIPath)}),h}function u(E){return{lastActiveWindow:E.lastActiveWindow&&l(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&l(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(h=>l(h))}}e.$w7b=u;function l(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(te[53],ie([0,1,15,3,44,2,13,9,19,21,192,64,60,25,6,5,52,129,29,97,98]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x6b=e.$w6b=void 0,e.$w6b=(0,v.$Nh)("workspacesManagementMainService");let h=class extends M.$Rc{constructor(a,o,t,n,r){super(),this.g=a,this.h=o,this.j=t,this.m=n,this.n=r,this.a=this.B(new A.$Md),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new A.$Md),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const a=(await c.Promises.readdir(this.c.with({scheme:D.Schemas.file}).fsPath)).map(o=>(0,f.$ug)(this.c,o,u.$ai));for(const o of a){const t=(0,E.$m6b)(o),n=await this.resolveLocalWorkspace(o);n?this.f.push({workspace:t,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(t)}}catch(a){a.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${a}).`)}}resolveLocalWorkspace(a){return this.r(a,o=>c.Promises.readFile(o,"utf8"))}r(a,o){if(this.s(a)&&a.scheme===D.Schemas.file)try{const t=o(a.fsPath);return t instanceof Promise?t.then(n=>this.t(a,n),n=>{}):this.t(a,t)}catch{return}}s(a){return(0,u.$bi)(a,this.g)||(0,u.$gi)(a)}t(a,o){try{const t=this.u(a,o),n=(0,E.$m6b)(a);return{id:n.id,configPath:n.configPath,folders:(0,l.$GU)(t.folders,n.configPath,f.$lg),remoteAuthority:t.remoteAuthority,transient:t.transient}}catch(t){this.h.warn(t.toString())}}u(a,o){const t=(0,s.$Sm)(o);if(t&&Array.isArray(t.folders))t.folders=t.folders.filter(n=>(0,l.$EU)(n));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return t}async createUntitledWorkspace(a,o){const{workspace:t,storedWorkspace:n}=this.w(a,o),r=t.configPath.fsPath;return await c.Promises.mkdir((0,S.$lc)(r),{recursive:!0}),await c.Promises.writeFile(r,JSON.stringify(n,null,"	")),this.f.push({workspace:t,remoteAuthority:o}),t}w(a=[],o){const t=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.$ug)(this.c,t),r=(0,f.$ug)(n,u.$ai),p=[];for(const C of a)p.push((0,l.$FU)(C.uri,!0,C.name,n,f.$lg));return{workspace:(0,E.$m6b)(r),storedWorkspace:{folders:p,remoteAuthority:o}}}async getWorkspaceIdentifier(a){return(0,E.$m6b)(a)}isUntitledWorkspace(a){return(0,u.$bi)(a.configPath,this.g)}async deleteUntitledWorkspace(a){this.isUntitledWorkspace(a)&&(await this.y(a),this.j.isEnabled()&&this.j.unsetWorkspace(a),this.a.fire(a))}async y(a){const o=(0,f.$ig)(a.configPath);try{await c.Promises.rm((0,S.$lc)(o));const t=(0,S.$ic)(this.g.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,a.id);await c.Promises.exists(t)&&await c.Promises.writeFile((0,S.$ic)(t,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==a.id)}catch(t){this.h.warn(`Unable to delete untitled workspace ${o} (${t}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(a,o,t){if(!a||!a.win||!a.isReady||!await this.z(a,o,t))return;const r=await this.C(a,(0,E.$m6b)(t));if(r)return this.b.fire({window:a,workspace:r.workspace}),r}async z(a,o,t){return t?(0,u.$3h)(a.openedWorkspace)&&f.$lg.isEqual(a.openedWorkspace.configPath,t)?!1:(0,$.$u6b)(o,t)?(await this.n.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:(0,g.localize)(1,null,(0,f.$rg)(t)),detail:(0,g.localize)(2,null)},P.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(a,o){if(!a.config)return;a.focus();let t;return a.config.extensionDevelopmentPath||(a.config.backupPath?t=await this.m.registerWorkspaceBackup({workspace:o,remoteAuthority:a.remoteAuthority},a.config.backupPath):t=this.m.registerWorkspaceBackup({workspace:o,remoteAuthority:a.remoteAuthority})),(0,u.$3h)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&await this.deleteUntitledWorkspace(a.openedWorkspace),a.config.workspace=o,a.config.backupPath=t,{workspace:o,backupPath:t}}};e.$x6b=h,e.$x6b=h=ke([ee(0,d.$15b),ee(1,b.$8i),ee(2,m.$95b),ee(3,w.$k6b),ee(4,y.$r6b)],h)}),define(te[131],ie([0,1,15,38,22,6,30,29,53,12,5,61]),function(Z,e,P,A,s,M,D,S,f,c,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C6b=e.$B6b=e.ID=void 0,e.ID="diagnosticsMainService",e.$B6b=(0,M.$Nh)(e.ID);let y=class{constructor(v,b,m){this.a=v,this.b=b,this.c=m}async getRemoteDiagnostics(v){const b=this.a.getWindows();return(await Promise.all(b.map(async $=>{const u=$.remoteAuthority;if(!u)return;const l=`vscode:getDiagnosticInfoResponse${$.id}`,E={includeProcesses:v.includeProcesses,folders:v.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(h=>{$.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:l,args:E}),A.$dT.once(l,(i,a)=>{a||h({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),h(a)}),setTimeout(()=>{h({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const v=[];for(const m of P.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(m.id);$?v.push(await this.d($)):v.push(this.e(m))}const b=[];for(const{pid:m,name:$}of w.$y6b.getAll())b.push({pid:m,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:v,pidToNames:b,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(v){const b=await this.f(v),m=(0,c.$If)(v.win);return this.e(m,b,v.remoteAuthority)}e(v,b=[],m){return{id:v.id,pid:v.webContents.getOSProcessId(),title:v.getTitle(),folderURIs:b,remoteAuthority:m}}async f(v){const b=[],m=v.openedWorkspace;if((0,S.$Xh)(m))b.push(m.uri);else if((0,S.$3h)(m)){const $=await this.b.resolveLocalWorkspace(m.configPath);$&&$.folders.forEach(l=>{b.push(l.uri)})}return b}};e.$C6b=y,e.$C6b=y=ke([ee(0,D.$e6b),ee(1,f.$w6b),ee(2,g.$8i)],y)}),define(te[69],ie([0,1,47,15,28,154,54,3,2,13,9,4,7,105,86,21,103,180,60,25,6,20,5,24,68,30,29,53,18,241,233]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u,l,E,h,i,a,o,t,n,r,p,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=e.$P6b=void 0,e.$P6b=(0,E.$Nh)("nativeHostMainService");let k=class extends f.$Rc{constructor(L,N,z,ne,_,ae,se,oe){super(),this.a=L,this.b=N,this.c=z,this.f=ne,this.g=_,this.h=ae,this.j=se,this.m=oe,this.onDidOpenWindow=S.Event.map(this.a.onDidOpenWindow,J=>J.id),this.onDidTriggerSystemContextMenu=S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:J,x:K,y:G})=>({windowId:J.id,x:K,y:G})),({windowId:J})=>!!this.a.getWindowById(J)),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(A.app,"browser-window-maximize",(J,K)=>K.id),J=>!!this.a.getWindowById(J)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(A.app,"browser-window-unmaximize",(J,K)=>K.id),J=>!!this.a.getWindowById(J)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(J,K)=>K.id),J=>!!this.a.getWindowById(J)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),J=>!!J),J=>J.id),S.Event.filter(S.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(J,K)=>K.id),J=>!!this.a.getWindowById(J))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.n=this.B(new S.$Md),this.onDidChangePassword=this.n.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(J,K,G)=>G),J=>!(Array.isArray(J)&&J.length===1&&J[0]==="workArea")),S.Event.fromNodeEventEmitter(A.screen,"display-added"),S.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(N=>({id:N.id,workspace:N.openedWorkspace??(0,n.$2h)(N.backupPath,N.isExtensionDevelopmentHost),title:N.win?.getTitle()??"",filename:N.getRepresentedFilename(),dirty:N.isDocumentEdited()}))}async getWindowCount(L){return this.a.getWindowCount()}async getActiveWindowId(L){const N=A.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(N)return N.id}openWindow(L,N,z){return Array.isArray(N)?this.r(L,N,z):this.s(L,N)}async r(L,N,z=Object.create(null)){N.length>0&&await this.a.open({context:5,contextWindowId:L,urisToOpen:N,cli:this.f.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async s(L,N){await this.a.openEmptyWindow({context:5,contextWindowId:L},N)}async toggleFullScreen(L){this.C(L)?.toggleFullScreen()}async handleTitleDoubleClick(L){this.C(L)?.handleTitleDoubleClick()}async isMaximized(L){const N=this.C(L);return N?.win?N.win.isMaximized():!1}async maximizeWindow(L){const N=this.C(L);N?.win&&N.win.maximize()}async unmaximizeWindow(L){const N=this.C(L);N?.win&&N.win.unmaximize()}async minimizeWindow(L){const N=this.C(L);N?.win&&N.win.minimize()}async moveWindowTop(L){const N=this.C(L);N?.win&&N.win.moveTop()}async updateWindowControls(L,N){const z=this.C(L);z&&z.updateWindowControls(N)}async focusWindow(L,N){N&&typeof N.windowId=="number"&&(L=N.windowId),this.C(L)?.focus({force:N?.force??!1})}async setMinimumSize(L,N,z){const ne=this.C(L);if(ne?.win){const[_,ae]=ne.win.getSize(),[se,oe]=ne.win.getMinimumSize(),[J,K]=[N??se,z??oe],[G,U]=[Math.max(_,J),Math.max(ae,K)];(se!==J||oe!==K)&&ne.win.setMinimumSize(J,K),(_!==G||ae!==U)&&ne.win.setSize(G,U)}}async saveWindowSplash(L,N){this.j.saveWindowSplash(L,N)}async installShellCommand(L){const{source:N,target:z}=await this.t();try{const{symbolicLink:ne}=await b.SymlinkSupport.stat(N);if(ne&&!ne.dangling){const _=await(0,d.$4p)(N);if(z===_)return}await b.Promises.unlink(N)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await b.Promises.symlink(z,N)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:_}=await this.showMessageBox(L,{type:"info",message:(0,$.localize)(0,null,this.h.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(_===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${N}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ae)}catch{throw new Error((0,$.localize)(3,null,N))}}}async uninstallShellCommand(L){const{source:N}=await this.t();try{await b.Promises.unlink(N)}catch(z){switch(z.code){case"EACCES":{const{response:ne}=await this.showMessageBox(L,{type:"info",message:(0,$.localize)(4,null,this.h.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(ne===0)try{const _=`osascript -e "do shell script \\"rm '${N}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(_)}catch{throw new Error((0,$.localize)(7,null,N))}break}case"ENOENT":break;default:throw z}}}async t(){const L=(0,g.$jc)(this.f.appRoot,"bin","code"),N=`/usr/local/bin/${this.h.applicationName}`;if(!await b.Promises.exists(L))throw new Error((0,$.localize)(8,null,L));return{source:N,target:L}}async showMessageBox(L,N){return this.b.showMessageBox(N,this.u(L))}async showSaveDialog(L,N){return this.b.showSaveDialog(N,this.u(L))}async showOpenDialog(L,N){return this.b.showOpenDialog(N,this.u(L))}u(L){const N=this.C(L);if(N?.win)return N.win}async pickFileFolderAndOpen(L,N){const z=await this.b.pickFileFolder(N);z&&await this.w(await Promise.all(z.map(async ne=>await b.SymlinkSupport.existsDirectory(ne)?{folderUri:y.URI.file(ne)}:{fileUri:y.URI.file(ne)})),N,L)}async pickFolderAndOpen(L,N){const z=await this.b.pickFolder(N);z&&await this.w(z.map(ne=>({folderUri:y.URI.file(ne)})),N,L)}async pickFileAndOpen(L,N){const z=await this.b.pickFile(N);z&&await this.w(z.map(ne=>({fileUri:y.URI.file(ne)})),N,L)}async pickWorkspaceAndOpen(L,N){const z=await this.b.pickWorkspace(N);z&&await this.w(z.map(ne=>({workspaceUri:y.URI.file(ne)})),N,L)}async w(L,N,z){await this.a.open({context:3,contextWindowId:z,cli:this.f.args,urisToOpen:L,forceNewWindow:N.forceNewWindow})}async showItemInFolder(L,N){A.shell.showItemInFolder(N)}async setRepresentedFilename(L,N){this.C(L)?.setRepresentedFilename(N)}async setDocumentEdited(L,N){this.C(L)?.setDocumentEdited(N)}async openExternal(L,N){return this.f.unsetSnapExportedVariables(),A.shell.openExternal(N),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(L,N){return A.shell.trashItem(N)}async isAdmin(){let L;return w.$j?L=(await new Promise((N,z)=>{Z(["native-is-elevated"],N,z)}))():L=process.getuid?.()===0,L}async writeElevated(L,N,z,ne){const _=await new Promise((ae,se)=>{Z(["@vscode/sudo-prompt"],ae,se)});return new Promise((ae,se)=>{const oe=[`"${this.z}"`];ne?.unlock&&oe.push("--file-chmod"),oe.push("--file-write",`"${N.fsPath}"`,`"${z.fsPath}"`);const J={name:this.h.nameLong.replace("-",""),icns:w.$k&&this.f.isBuilt?(0,g.$ic)((0,g.$lc)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};_.exec(oe.join(" "),J,(K,G,U)=>{G&&this.g.trace(`[sudo-prompt] received stdout: ${G}`),U&&this.g.trace(`[sudo-prompt] received stderr: ${U}`),K?se(K):ae(void 0)})})}async isRunningUnderARM64Translation(){return w.$l||w.$j?!1:A.app.runningUnderARM64Translation}get z(){return w.$j?this.f.isBuilt?(0,g.$ic)((0,g.$lc)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,g.$ic)(this.f.appRoot,"scripts","code-cli.bat"):w.$l?this.f.isBuilt?(0,g.$ic)((0,g.$lc)(process.execPath),"bin",`${this.h.applicationName}`):(0,g.$ic)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,g.$ic)(this.f.appRoot,"bin","code"):(0,g.$ic)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return v.$Om.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return w.$j&&(0,C.$N6b)()}async killProcess(L,N,z){process.kill(N,z)}async readClipboardText(L,N){return A.clipboard.readText(N)}async writeClipboardText(L,N,z){return A.clipboard.writeText(N,z)}async readClipboardFindText(L){return A.clipboard.readFindText()}async writeClipboardFindText(L,N){return A.clipboard.writeFindText(N)}async writeClipboardBuffer(L,N,z,ne){return A.clipboard.writeBuffer(N,Buffer.from(z.buffer),ne)}async readClipboardBuffer(L,N){return p.$ae.wrap(A.clipboard.readBuffer(N))}async hasClipboard(L,N,z){return A.clipboard.has(N,z)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,N){this.C(L)?.updateTouchBar(N)}async notifyReady(L){this.C(L)?.setReady()}async relaunch(L,N){return this.c.relaunch(N)}async reload(L,N){const z=this.C(L);if(z){if((0,n.$3h)(z.openedWorkspace)){const ne=z.openedWorkspace.configPath;if(ne.scheme===c.Schemas.file&&(await this.m.resolveLocalWorkspace(ne))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.c.reload(z,N?.disableExtensions!==void 0?{_:[],"disable-extensions":N.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,N){const z=this.C(N);if(z?.win)return z.win.close()}async quit(L){const N=this.a.getLastActiveWindow();N?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&N.win?N.win.close():this.c.quit()}async exit(L,N){await this.c.kill(N)}async resolveProxy(L,N){return this.C(L)?.win?.webContents?.session?.resolveProxy(N)}findFreePort(L,N,z,ne,_=1){return(0,m.$fg)(N,z,ne,_)}async openDevTools(L,N){const z=this.C(L);z?.win&&z.win.webContents.openDevTools(N)}async toggleDevTools(L){const N=this.C(L);N?.win&&N.win.webContents.toggleDevTools();for(const z of A.BrowserWindow.getAllWindows())z.webContents.getURL()==="about:blank"&&z.webContents.toggleDevTools()}async sendInputEvent(L,N){const z=this.C(L);z?.win&&(N.type==="mouseDown"||N.type==="mouseUp")&&z.win.webContents.sendInputEvent(N)}async profileRenderer(L,N,z){const ne=this.C(L);if(!ne||!ne.win)throw new Error;return await new R.$O6b(ne.win,N,this.g).inspect(z)}async windowsGetStringRegKey(L,N,z,ne){if(!w.$j)return;const _=await new Promise((ae,se)=>{Z(["@vscode/windows-registry"],ae,se)});try{return _.GetStringRegKey(N,z,ne)}catch{return}}C(L){if(typeof L=="number")return this.a.getWindowById(L)}};e.$Q6b=k,ke([D.$fh],k.prototype,"z",null),e.$Q6b=k=ke([ee(0,t.$e6b),ee(1,u.$r6b),ee(2,h.$35b),ee(3,l.$15b),ee(4,i.$8i),ee(5,a.$nj),ee(6,o.$c6b),ee(7,r.$w6b)],k)}),define(te[298],ie([0,1,15,38,28,2,13,4,107,178,90,131,60,25,5,69,78,24,79,59,33,34,61,22,7,30,8]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u,l,E,h,i,a,o,t,n){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$S6b=void 0;const p="issue.processExplorerWindowState";let C=class{static{r=this}static{this.a="#1E1E1E"}constructor(I,L,N,z,ne,_,ae,se,oe,J,K){this.g=I,this.h=L,this.i=N,this.j=z,this.k=ne,this.l=_,this.m=ae,this.n=se,this.o=oe,this.p=J,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){A.$dT.on("vscode:listProcesses",async I=>{const L=[];try{L.push({name:(0,c.localize)(0,null),rootProcess:await(0,f.$zr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(z=>{(0,g.$om)(z)?L.push({name:z.hostName,rootProcess:z}):z.processes&&L.push({name:z.hostName,rootProcess:z.processes})})}catch(N){this.i.error(`Listing processes failed: ${N}`)}this.t(I,"vscode:listProcessesResponse",L)}),A.$dT.on("vscode:workbenchCommand",(I,L)=>{const{id:N,from:z,args:ne}=L;let _;switch(z){case"processExplorer":_=this.f;break;default:throw new Error(`Unexpected command source: ${z}`)}_?.webContents.send("vscode:runAction",{id:N,from:z,args:ne})}),A.$dT.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),A.$dT.on("vscode:pidToNameRequest",async I=>{const L=await this.k.getMainDiagnostics(),N=[];for(const z of L.windows)N.push([z.pid,`window [${z.id}] (${z.title})`]);for(const{pid:z,name:ne}of i.$y6b.getAll())N.push([z,ne]);this.t(I,"vscode:pidToNameResponse",N)})}async openReporter(I){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const L=new M.$Qc,N=L.add(this.n.createIPCObjectUrl()),z=this.v(this.c,700,800);this.b=this.u(z,N,{backgroundColor:I.styles.backgroundColor,title:(0,c.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),N.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:m.default}),this.b.loadURL(D.$bg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,L.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,L.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(I){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const L=new M.$Qc,N=L.add(this.n.createIPCObjectUrl()),z=this.p.getItem(p,void 0),ne=R(z)?z:this.v(this.f,800,500);this.d=this.u(ne,N,{backgroundColor:I.styles.backgroundColor,title:(0,c.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),N.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:m.default}),this.d.loadURL(D.$bg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,L.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,L.dispose())});const _=()=>{if(!this.d)return;const ae=this.d.getSize(),se=this.d.getPosition();if(!ae||!se)return;const oe={width:ae[0],height:ae[1],x:se[0],y:se[1]};this.p.setItem(p,oe)};this.d.on("moved",_),this.d.on("resized",_)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await P.contentTracing.stopRecording(`${(0,E.$5f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,c.localize)(3,null),detail:(0,c.localize)(4,null,I),buttons:[(0,c.localize)(5,null)]},P.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,L)}async $getSystemInfo(){const[I,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,L)}async $getPerformanceInfo(){try{const[I,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,L)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(6,null),buttons:[(0,c.localize)(7,null),(0,c.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(9,null),buttons:[(0,c.localize)(10,null),(0,c.localize)(11,null)]},this.b);return I===0}return!1}async $getIssueReporterUri(I){if(!this.c)throw new Error("Issue reporter window not available");const L=this.q.getWindowById(this.c.id);if(!L)throw new Error("Window not found");const N=`vscode:triggerIssueUriRequestHandlerResponse${L.id}`;return n.Promises.withAsyncBody(async(z,ne)=>{const _=new a.$Wd;L.sendWhenReady("vscode:triggerIssueUriRequestHandler",_.token,{replyChannel:N,extensionId:I}),A.$dT.once(N,(ae,se)=>{z(o.URI.parse(se))});try{await(0,n.$Tg)(5e3),_.cancel(),ne(new Error("Timed out waiting for issue reporter URI"))}finally{A.$dT.removeHandler(N)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,L,...N){I.sender.isDestroyed()||I.sender.send(L,...N)}u(I,L,N,z){const ne=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:N.title,backgroundColor:N.backgroundColor||r.a,webPreferences:{preload:D.$bg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${L.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,l.$4C)(N.zoomLevel),sandbox:!0},alwaysOnTop:N.alwaysOnTop,experimentalDarkMode:!0});return ne.setMenuBarVisibility(!1),ne}v(I,L,N){let z;const ne=P.screen.getAllDisplays();if(ne.length===1)z=ne[0];else{if(S.$k){const se=P.screen.getCursorScreenPoint();z=P.screen.getDisplayNearestPoint(se)}!z&&I&&(z=P.screen.getDisplayMatching(I.getBounds())),z||(z=P.screen.getPrimaryDisplay()||ne[0])}const _=z.bounds,ae={width:L,height:N,x:_.x+_.width/2-L/2,y:_.y+_.height/2-N/2};return _.width>0&&_.height>0&&(ae.x<_.x&&(ae.x=_.x),ae.y<_.y&&(ae.y=_.y),ae.x>_.x+_.width&&(ae.x=_.x),ae.y>_.y+_.height&&(ae.y=_.y),ae.width>_.width&&(ae.width=_.width),ae.height>_.height&&(ae.height=_.height)),ae}};e.$S6b=C,e.$S6b=C=r=ke([ee(1,d.$15b),ee(2,v.$8i),ee(3,g.$nm),ee(4,w.$B6b),ee(5,y.$r6b),ee(6,b.$P6b),ee(7,u.$R6b),ee(8,$.$nj),ee(9,h.$qN),ee(10,t.$e6b)],C);function R(k){return typeof k!="object"||k===null?!1:"x"in k&&"y"in k&&"width"in k&&"height"in k}}),define(te[299],ie([0,1,22,17,25,20,5,69,24,50,26,48,100]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=void 0;let d=class extends y.$h7b{constructor(b,m,$,u,l,E,h,i){super(b,m,u,l,E,i),this.e=$,this.u=h}s(b){return(0,y.$g7b)(`linux-${process.arch}`,b,this.k)}t(b){this.a&&(this.d(w.$cU.CheckingForUpdates(b)),this.i.request({url:this.a},P.CancellationToken.None).then(c.$Vo).then(m=>{!m||!m.url||!m.version||!m.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!b}),this.d(w.$cU.Idle(1))):this.d(w.$cU.AvailableForDownload(m))}).then(void 0,m=>{this.j.error(m),this.e.publicLog2("update:notAvailable",{explicit:!!b});const $=b?m.message||m:void 0;this.d(w.$cU.Idle(1,$))}))}async o(b){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):b.update.url&&this.u.openExternal(void 0,b.update.url),this.d(w.$cU.Idle(1))}};e.$j7b=d,e.$j7b=d=ke([ee(0,M.$35b),ee(1,A.$hi),ee(2,g.$al),ee(3,s.$15b),ee(4,c.$Po),ee(5,D.$8i),ee(6,S.$P6b),ee(7,f.$nj)],d)}),define(te[300],ie([0,1,47,45,28,8,22,54,9,7,142,21,17,25,16,20,5,69,24,50,26,48,100]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u,l,E,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l7b=void 0;async function a(r,p=1e3){for(;!r();)await(0,M.$Tg)(p)}let o;function t(){return typeof o>"u"&&(o=A.existsSync(f.$ic(f.$lc(process.execPath),"unins000.exe"))?0:1),o}let n=class extends i.$h7b{get cachePath(){const p=f.$ic((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return w.Promises.mkdir(p,{recursive:!0}).then(()=>p)}constructor(p,C,R,k,I,L,N,z,ne){super(p,C,k,I,L,ne),this.u=R,this.v=N,this.w=z,p.setRelaunchHandler(this)}handleRelaunch(p){return p?.addArgs||p?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(h.$cU.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(p){let C="win32";return process.arch!=="ia32"&&(C+=`-${process.arch}`),t()===1?C+="-archive":this.k.target==="user"&&(C+="-user"),(0,i.$g7b)(C,p,this.k)}t(p){this.a&&(this.d(h.$cU.CheckingForUpdates(p)),this.i.request({url:this.a},D.CancellationToken.None).then(l.$Vo).then(C=>{const R=t();return!C||!C.url||!C.version||!C.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!p}),this.d(h.$cU.Idle(R)),Promise.resolve(null)):R===1?(this.d(h.$cU.AvailableForDownload(C)),Promise.resolve(null)):(this.d(h.$cU.Downloading(C)),this.C(C.version).then(()=>this.B(C.version).then(k=>w.Promises.exists(k).then(I=>{if(I)return Promise.resolve(k);const L=C.url,N=C.hash,z=`${k}.tmp`;return this.i.request({url:L},D.CancellationToken.None).then(ne=>this.v.writeFile(c.URI.file(z),ne.stream)).then(N?()=>(0,g.$$S)(z,C.hash):()=>{}).then(()=>w.Promises.rename(z,k,!1)).then(()=>k)})).then(k=>{const I=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:k},I?this.k.target==="user"?this.p():this.d(h.$cU.Downloaded(C)):this.d(h.$cU.Ready(C))})))}).then(void 0,C=>{this.j.error(C),this.u.publicLog2("update:notAvailable",{explicit:!!p});const R=p?C.message||C:void 0;this.d(h.$cU.Idle(t(),R))}))}async o(p){p.update.url&&this.w.openExternal(void 0,p.update.url),this.d(h.$cU.Idle(t()))}async B(p){const C=await this.cachePath;return f.$ic(C,`CodeSetup-${this.k.quality}-${p}.exe`)}async C(p=null){const C=p?L=>!new RegExp(`${this.k.quality}-${p}\\.exe$`).test(L):()=>!0,R=await this.cachePath,I=(await w.Promises.readdir(R)).filter(C).map(async L=>{try{await w.Promises.unlink(f.$ic(R,L))}catch{}});await Promise.all(I)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const p=this.state.update;this.d(h.$cU.Updating(p));const C=await this.cachePath;this.e.updateFilePath=f.$ic(C,`CodeSetup-${this.k.quality}-${p.version}.flag`),await w.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(h.$cU.Idle(t()))});const k=`${this.k.win32MutexName}-ready`,I=await new Promise((L,N)=>{Z(["@vscode/windows-mutex"],L,N)});a(()=>I.isActive(k)).then(()=>this.d(h.$cU.Ready(p)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?A.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return t()}async _applySpecificUpdate(p){if(this.state.type!=="idle")return;const C=this.g.getValue("update.enableWindowsBackgroundUpdates"),R={version:"unknown",productVersion:"unknown"};this.d(h.$cU.Downloading(R)),this.e={packagePath:p},C?this.k.target==="user"?this.p():this.d(h.$cU.Downloaded(R)):this.d(h.$cU.Ready(R))}};e.$l7b=n,ke([S.$fh],n.prototype,"cachePath",null),e.$l7b=n=ke([ee(0,b.$35b),ee(1,y.$hi),ee(2,E.$al),ee(3,d.$15b),ee(4,l.$Po),ee(5,m.$8i),ee(6,v.$9j),ee(7,$.$P6b),ee(8,u.$nj)],n)}),define(te[301],ie([0,1,15,8,22,49,3,2,13,66,4,7,188,64,17,60,25,63,16,20,5,24,79,250,81,26,102,68,59,30,29,53,95,134,39,34,52,67,23,6]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u,l,E,h,i,a,o,t,n,r,p,C,R,k,I,L,N,z,ne,_,ae,se){"use strict";var oe;Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=void 0;var J;(function(G){G[G.NONE=0]="NONE",G[G.NAVIGATING=1]="NAVIGATING",G[G.READY=2]="READY"})(J||(J={}));let K=class extends S.$Rc{static{oe=this}static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.m}get lastFocusTime(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const U=this.R.profiles.find(q=>q.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&U?U:this.R.getProfileForWorkspace(this.config.workspace??(0,R.$2h)(this.backupPath,this.isExtensionDevelopmentHost))??this.R.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(U,q,X,H,Q,re,F,O,j,B,W,T,V,ce,de,ue,fe,ye,be,pe,Ce){super(),this.N=q,this.O=X,this.P=H,this.Q=Q,this.R=re,this.S=F,this.U=O,this.W=j,this.X=B,this.Y=W,this.Z=T,this.$=V,this.ab=ce,this.bb=de,this.db=ue,this.eb=fe,this.fb=ye,this.gb=be,this.hb=pe,this.b=this.B(new D.$Md),this.onWillLoad=this.b.event,this.c=this.B(new D.$Md),this.onDidSignalReady=this.c.event,this.f=this.B(new D.$Md),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new D.$Md),this.onDidClose=this.g.event,this.h=this.B(new D.$Md),this.onDidDestroy=this.h.event,this.n=-1,this.u=void 0,this.w=void 0,this.D=!1,this.F=[],this.G=[],this.H=void 0,this.I=void 0,this.J=this.B(this.fb.createIPCObjectUrl()),this.M=!1,this.jb=0;{const[We,$e]=this.tb(U.state);this.s=We,this.N.trace("window#ctor: using window state",We);const we=this.s.mode===0||this.s.mode===3,Y=this.X.getValue("window"),le=Ce.invokeFunction(C.$f6b,this.s,{show:!we,webPreferences:{preload:f.$bg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.J.resource.toString()}`],v8CacheOptions:this.P.useCodeCache?"bypassHeatCheck":"none"}});g.$k&&!this.Ab()&&(le.fullscreenable=!1);const ge=g.$k&&Y?.nativeTabs===!0;ge&&(le.tabbingIdentifier=this.eb.nameShort);const Re=(0,p.$2C)(this.X)==="custom";if(Re&&(le.titleBarStyle="hidden",g.$k||(le.frame=!1),(0,p.$3C)(this.X))){const De=this.Y.getWindowSplash()?.colorInfo.titleBarBackground??this.Y.getBackgroundColor(),Ne=L.$Ts.fromHex(De).isDarker()?"#FFFFFF":"#000000";le.titleBarOverlay={height:29,color:De,symbolColor:Ne},this.D=!0}if((0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new P.BrowserWindow(le),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.j=this.m.id,g.$k&&Re&&this.m.setSheetOffset(22),Re&&(g.$j&&(0,p.$3C)(this.X)||g.$k)){const De=this.hb.getItem(oe.a);De&&this.updateWindowControls({height:De})}g.$j&&Re&&this.m.hookWindowMessage(278,()=>{const[Ne,Oe]=this.m.getPosition(),ze=P.screen.getCursorScreenPoint(),Te=ze.x-Ne,x=ze.y-Oe;return(()=>!(Te>30&&x>=0&&x<=Math.max(this.m.getBounds().height*.15,35)))()||(this.m.setEnabled(!1),this.m.setEnabled(!0),this.f.fire({x:Te,y:x})),0}),(g.$k||g.$j)&&$e&&(!ge||P.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(De=>typeof De=="number")&&this.m.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),we&&((0,c.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.s.mode===3?(this.ib("WindowMode.Fullscreen"),this.wb(!0)):this.ib("WindowMode.Maximized"),this.m.show(),(0,c.mark)("code/didMaximizeCodeWindow")),this.n=Date.now()}this.P.args["open-devtools"]===!0&&this.m.webContents.openDevTools(),this.qb(),this.Eb(),this.kb()}ib(U){this.X.getValue("window.logFullScreenTransitions")&&this.N.info(`window-fullscreen-bug: ${U})`)}setRepresentedFilename(U){g.$k?this.m.setRepresentedFilename(U):this.z=U}getRepresentedFilename(){return g.$k?this.m.getRepresentedFilename():this.z}setDocumentEdited(U){g.$k&&this.m.setDocumentEdited(U),this.C=U}isDocumentEdited(){return g.$k?this.m.isDocumentEdited():!!this.C}focus(U){g.$k&&U?.force&&P.app.focus({steal:!0}),this.m&&(this.m.isMinimized()&&this.m.restore(),this.m.focus())}setReady(){for(this.N.trace(`window#load: window reported ready (id: ${this.j})`),this.jb=2;this.F.length;)this.F.pop()(this);this.c.fire()}ready(){return new Promise(U=>{if(this.isReady)return U(this);this.F.push(U)})}get isReady(){return this.jb===2}get whenClosedOrLoaded(){return new Promise(U=>{function q(){X.dispose(),H.dispose(),U()}const X=this.onDidClose(()=>q()),H=this.onWillLoad(()=>q())})}kb(){this.m.on("unresponsive",()=>this.nb(1)),this.m.webContents.on("render-process-gone",(q,X)=>this.nb(2,{...X})),this.m.webContents.on("did-fail-load",(q,X,H)=>this.nb(3,{reason:H,exitCode:X})),this.m.webContents.on("will-prevent-unload",q=>{q.preventDefault()}),this.m.on("closed",()=>{this.g.fire(),this.dispose()}),this.m.webContents.on("did-finish-load",()=>{this.L&&(this.r=this.L,this.L=void 0)}),this.m.on("focus",()=>{this.n=Date.now()}),this.m.on("maximize",q=>{this.r&&(this.r.maximized=!0),P.app.emit("browser-window-maximize",q,this.m)}),this.m.on("unmaximize",q=>{this.r&&(this.r.maximized=!1),P.app.emit("browser-window-unmaximize",q,this.m)}),this.m.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.ib(`enter-full-screen: ${Date.now()}`),this.w?.complete(),this.w=void 0}),this.m.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.ib(`leave-full-screen: ${Date.now()}`),this.w?.complete(),this.w=void 0}),this.B(this.X.onDidChangeConfiguration(q=>this.qb(q))),this.B(this.Z.onDidDeleteUntitledWorkspace(q=>this.pb(q)));const U=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:U},async(q,X)=>{const H=await this.mb();X({cancel:!1,requestHeaders:Object.assign(q.requestHeaders,H)})})}mb(){return this.lb||(this.lb=(0,a.$0o)(this.eb.version,this.eb,this.P,this.X,this.S,this.U,this.ab)),this.lb}async nb(U,q){switch(U){case 2:this.N.error(`CodeWindow: renderer process gone (reason: ${q?.reason||"<unknown>"}, code: ${q?.exitCode||"<unknown>"})`);break;case 1:this.N.error("CodeWindow: detected unresponsive");break;case 3:this.N.error(`CodeWindow: failed to load (reason: ${q?.reason||"<unknown>"}, code: ${q?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:U,reason:q?.reason,code:q?.exitCode}),U){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.P.args["enable-smoke-test-driver"]){await this.ob(!1,!1),this.db.quit();return}if(U===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:X,checkboxChecked:H}=await this.bb.showMessageBox({type:"warning",buttons:[(0,y.localize)(0,null),(0,y.localize)(1,null),(0,y.localize)(2,null)],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),checkboxLabel:this.r?.workspace?(0,y.localize)(5,null):void 0},this.m);if(X!==2){const Q=X===0;await this.ob(Q,H)}}else if(U===2){let X;q?X=(0,y.localize)(7,null,q.reason,q.exitCode??"<unknown>"):X=(0,y.localize)(6,null);const{response:H,checkboxChecked:Q}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,y.localize)(8,null):(0,y.localize)(9,null),(0,y.localize)(10,null)],message:X,detail:this.r?.workspace?(0,y.localize)(11,null):(0,y.localize)(12,null),checkboxLabel:this.r?.workspace?(0,y.localize)(13,null):void 0},this.m),re=H===0;await this.ob(re,Q)}break}}async ob(U,q){const X=this.r?.workspace;if(q&&X)try{const H=this.W.workspaceStorage(X);await H.init(),H.delete("memento/workbench.parts.editor"),await H.close()}catch(H){this.N.error(H)}if(this.h.fire(),this.m?.destroy(),U&&this.r){let H,Q;(0,R.$Xh)(X)?H={folderUri:X.uri}:(0,R.$3h)(X)?H={workspaceUri:X.configPath}:Q=!0,(0,ae.$Nb)(await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.P.args,_:[]},urisToOpen:H?[H]:void 0,forceEmpty:Q,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}pb(U){this.r?.workspace?.id===U.id&&(this.r.workspace=void 0)}qb(U){if(!U||U.affectsConfiguration("window.menuBarVisibility")){const q=this.Bb();q!==this.t&&(this.t=q,this.Cb(q))}if(!U||U.affectsConfiguration("http.proxy")){let q=(this.X.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;q?.endsWith("/")&&(q=q.substr(0,q.length-1));const X=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((q||"").indexOf("@")===-1&&(q!==this.H||X!==this.I)){this.H=q,this.I=X;const H=q||"",Q=X?`${X},<local>`:"<local>";this.N.trace(`Setting proxy to '${H}', bypassing '${Q}'`),this.m.webContents.session.setProxy({proxyRules:H,proxyBypassRules:Q,pacScript:""})}}}addTabbedWindow(U){g.$k&&U.win&&this.m.addTabbedWindow(U.win)}load(U,q=Object.create(null)){this.N.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!q.isReload||!this.$.isHotExitEnabled())&&this.setDocumentEdited(!1),q.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.eb.nameLong)),this.rb(U,q),this.jb===0?this.r=U:this.L=U,this.jb=1,this.m.loadURL(f.$bg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.P.isBuilt?"":"-dev"}.html`).toString(!0));const X=this.M;this.M=!0,!this.P.isBuilt&&!this.P.extensionTestsLocationURI&&this.B(new A.$5g(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:U.workspace,reason:q.isReload?3:X?2:1})}rb(U,q){const X=(this.r??this.L)?.userEnv;if(X){const H=(0,$.$Kl)(X)&&!(0,$.$Kl)(U.userEnv),Q=this.isExtensionDevelopmentHost;(H||Q)&&(U.userEnv={...X,...U.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(U.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),q.disableExtensions!==void 0&&(U["disable-extensions"]=q.disableExtensions),U.fullscreen=this.isFullScreen,U.maximized=this.m.isMaximized(),U.partsSplash=this.Y.getWindowSplash(),(0,c.mark)("code/willOpenNewWindow"),U.perfMarks=(0,c.getMarks)(),this.J.update(U)}async reload(U){const q=Object.assign({},this.r);q.workspace=await this.sb(q),delete q.filesToOpenOrCreate,delete q.filesToDiff,delete q.filesToMerge,delete q.filesToWait,this.isExtensionDevelopmentHost&&U&&(q.verbose=U.verbose,q.debugId=U.debugId,q.extensionEnvironment=U.extensionEnvironment,q["inspect-extensions"]=U["inspect-extensions"],q["inspect-brk-extensions"]=U["inspect-brk-extensions"],q["extensions-dir"]=U["extensions-dir"]),q.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),q.isInitialStartup=!1,q.policiesData=this.Q.serialize(),q.continueOn=this.P.continueOn,q.profiles={all:this.R.profiles,profile:this.profile||this.R.defaultProfile,home:this.R.profilesHome},q.logLevel=this.O.getLogLevel(),q.loggers={window:this.O.getRegisteredLoggers(this.id),global:this.O.getRegisteredLoggers()},this.load(q,{isReload:!0,disableExtensions:U?.["disable-extensions"]})}async sb(U){if((0,R.$3h)(U.workspace)){const q=U.workspace.configPath;if(q.scheme===f.Schemas.file&&!await this.S.exists(q))return}else if((0,R.$Xh)(U.workspace)){const q=U.workspace.uri;if(q.scheme===f.Schemas.file&&!await this.S.exists(q))return}return U.workspace}serializeWindowState(){if(!this.m)return(0,I.$Z5b)();if(this.isFullScreen){let X;try{X=P.screen.getDisplayMatching(this.getBounds())}catch{}const H=(0,I.$Z5b)();return{mode:3,display:X?X.id:void 0,width:this.s.width||H.width,height:this.s.height||H.height,x:this.s.x||0,y:this.s.y||0}}const U=Object.create(null);let q;if(!g.$k&&this.m.isMaximized()?q=0:q=1,q===0?U.mode=0:U.mode=1,q===1||q===0){let X;q===1?X=this.getBounds():X=this.m.getNormalBounds(),U.x=X.x,U.y=X.y,U.width=X.width,U.height=X.height}return U}updateWindowControls(U){if(U.height&&this.hb.setItem(oe.a,U.height),g.$j&&this.D)this.m.setTitleBarOverlay({color:U.backgroundColor?.trim()===""?void 0:U.backgroundColor,symbolColor:U.foregroundColor?.trim()===""?void 0:U.foregroundColor,height:U.height?U.height-1:void 0});else if(g.$k&&U.height!==void 0){const q=(U.height-15)/2;q?this.m.setWindowButtonPosition({x:q,y:q}):this.m.setWindowButtonPosition(null)}}tb(U){(0,c.mark)("code/willRestoreCodeWindowState");let q=!1;if(U)try{const X=P.screen.getAllDisplays();q=X.length>1,U=this.ub(U,X)}catch(X){this.N.warn(`Unexpected error validating window state: ${X}
${X.stack}`)}return(0,c.mark)("code/didRestoreCodeWindowState"),[U||(0,I.$Z5b)(),q]}ub(U,q){if(this.N.trace(`window#validateWindowState: validating window state on ${q.length} display(s)`,U),typeof U.x!="number"||typeof U.y!="number"||typeof U.width!="number"||typeof U.height!="number"){this.N.trace("window#validateWindowState: unexpected type of state values");return}if(U.width<=0||U.height<=0){this.N.trace("window#validateWindowState: unexpected negative values");return}if(q.length===1){const Q=this.vb(q[0]);if(Q){let re=function(){!U||typeof U.x!="number"||typeof U.y!="number"||!Q||(U.x<Q.x&&(U.x=Q.x),U.y<Q.y&&(U.y=Q.y))};this.N.trace("window#validateWindowState: 1 monitor working area",Q),re(),U.width>Q.width&&(U.width=Q.width),U.height>Q.height&&(U.height=Q.height),U.x>Q.x+Q.width-128&&(U.x=Q.x+Q.width-U.width),U.y>Q.y+Q.height-128&&(U.y=Q.y+Q.height-U.height),re()}return U}if(U.display&&U.mode===3){const Q=q.find(re=>re.id===U.display);if(Q&&typeof Q.bounds?.x=="number"&&typeof Q.bounds?.y=="number"){this.N.trace("window#validateWindowState: restoring fullscreen to previous display");const re=(0,I.$Z5b)(3);return re.x=Q.bounds.x,re.y=Q.bounds.y,re}}let X,H;try{X=P.screen.getDisplayMatching({x:U.x,y:U.y,width:U.width,height:U.height}),H=this.vb(X)}catch{}if(X&&H&&U.x+U.width>H.x&&U.y+U.height>H.y&&U.x<H.x+H.width&&U.y<H.y+H.height)return this.N.trace("window#validateWindowState: multi-monitor working area",H),U}vb(U){if(U.workArea.width>0&&U.workArea.height>0)return U.workArea;if(U.bounds.width>0&&U.bounds.height>0)return U.bounds}getBounds(){const[U,q]=this.m.getPosition(),[X,H]=this.m.getSize();return{x:U,y:q,width:X,height:H}}toggleFullScreen(){this.wb(!this.isFullScreen)}wb(U){this.Ab()?this.xb(U):this.zb(U),this.sendWhenReady(U?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.t&&this.Cb(this.t,!1)}get isFullScreen(){if(this.ib(`isFullScreen(): begin at ${Date.now()}`),g.$k&&typeof this.u=="boolean")return this.ib(`isFullScreen(): returning transientIsNativeFullScreen = ${this.u}`),this.u;const U=this.m.isFullScreen(),q=this.m.isSimpleFullScreen();return this.ib(`isFullScreen(): returning natively, isFullScreen = ${U}, isSimpleFullScreen = ${q}`),U||q}xb(U){this.m.isSimpleFullScreen()&&this.m.setSimpleFullScreen(!1),this.yb(U)}yb(U){g.$k&&(this.ib(`doSetNativeFullScreen(${U}): begin at ${Date.now()}`),this.u=U,this.w=new A.$bh,Promise.race([this.w.p,(0,A.$Tg)(1e3)]).finally(()=>{this.ib(`doSetNativeFullScreen(${U}): finish at ${Date.now()}`),this.u=void 0})),this.m.setFullScreen(U)}zb(U){this.m.isFullScreen()&&this.yb(!1),this.m.setSimpleFullScreen(U),this.m.webContents.focus()}Ab(){const U=this.X.getValue("window");return!U||typeof U.nativeFullScreen!="boolean"||U.nativeTabs?!0:U.nativeFullScreen!==!1}isMinimized(){return this.m.isMinimized()}Bb(){let U=(0,p.$1C)(this.X);return["visible","toggle","hidden"].indexOf(U)<0&&(U="classic"),U}Cb(U,q=!0){g.$k||(U==="toggle"&&q&&this.send("vscode:showInfoMessage",(0,y.localize)(14,null)),U==="hidden"?setTimeout(()=>{this.Db(U)}):this.Db(U))}Db(U){const q=this.isFullScreen;switch(U){case"classic":this.m.setMenuBarVisibility(!q),this.m.autoHideMenuBar=q;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.$k)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.m.minimize();break;case"None":break;case"Maximize":default:this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}else this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}close(){this.m?.close()}sendWhenReady(U,q,...X){this.isReady?this.send(U,...X):this.ready().then(()=>{q.isCancellationRequested||this.send(U,...X)})}send(U,...q){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.N.warn(`Sending IPC message to channel '${U}' for window that is destroyed`);return}try{this.m.webContents.send(U,...q)}catch(X){this.N.warn(`Error sending IPC message to channel '${U}' of window ${this.j}: ${(0,M.$yi)(X)}`)}}}updateTouchBar(U){g.$k&&this.G.forEach((q,X)=>{const H=U[X];q.segments=this.Gb(H)})}Eb(){if(g.$k){for(let U=0;U<10;U++){const q=this.Fb();this.G.push(q)}this.m.setTouchBar(new P.TouchBar({items:this.G}))}}Fb(U=[]){const q=this.Gb(U),X=new P.TouchBar.TouchBarSegmentedControl({segments:q,mode:"buttons",segmentStyle:"automatic",change:H=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:X.segments[H].id,from:"touchbar"})}});return X}Gb(U=[]){return U.map(X=>{let H;X.icon&&!n.ThemeIcon.isThemeIcon(X.icon)&&X.icon?.dark?.scheme===f.Schemas.file&&(H=P.nativeImage.createFromPath(w.URI.revive(X.icon.dark).fsPath),H.isEmpty()&&(H=void 0));let Q;return typeof X.title=="string"?Q=X.title:Q=X.title.value,{id:X.id,label:H?void 0:Q,icon:H}})}dispose(){super.dispose(),this.O.deregisterLoggers(this.id),this.m=null}};e.$t7b=K,e.$t7b=K=oe=ke([ee(1,E.$8i),ee(2,_.$86b),ee(3,m.$15b),ee(4,N.$en),ee(5,ne.$95b),ee(6,u.$9j),ee(7,o.$a6b),ee(8,o.$$5b),ee(9,v.$hi),ee(10,r.$c6b),ee(11,k.$w6b),ee(12,d.$k6b),ee(13,t.$al),ee(14,b.$r6b),ee(15,l.$35b),ee(16,h.$nj),ee(17,i.$R6b),ee(18,C.$e6b),ee(19,z.$qN),ee(20,se.$Mh)],K)}),define(te[82],ie([0,1,15,23,8,3,46,2,13,4,19,7,21,191,6,20,5,81,97,29,53,31]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u,l,E,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$46b=e.$36b=void 0,e.$36b=(0,v.$Nh)("workspacesHistoryMainService");let a=class extends S.$Rc{static{i=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(t,n,r,p){super(),this.f=t,this.g=n,this.h=r,this.j=p,this.c=this.B(new M.$Md),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Qg(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(t=>this.addRecentlyOpened([{workspace:t.workspace,remoteAuthority:t.window.remoteAuthority}])))}async addRecentlyOpened(t){let n=[],r=[];for(const C of t)if((0,u.$BU)(C))!this.g.isUntitledWorkspace(C.workspace)&&!this.u(n,C.workspace)&&n.push(C);else if((0,u.$CU)(C))this.w(n,C.folderUri)||n.push(C);else{const R=this.y(r,C.fileUri),k=C.fileUri.scheme===f.Schemas.file&&i.F.indexOf((0,g.$rg)(C.fileUri))>=0;!R&&!k&&(r.push(C),c.$j&&C.fileUri.scheme===f.Schemas.file&&P.app.addRecentDocument(C.fileUri.fsPath))}const p=await this.n({workspaces:n,files:r});n=p.workspaces,r=p.files,n.length>i.a&&(n.length=i.a),r.length>i.a&&(r.length=i.a),await this.s({workspaces:n,files:r}),this.c.fire(),c.$k&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(t){const n=R=>{const k=this.t(R);for(const I of t)if(g.$lg.isEqual(I,k))return!1;return!0},r=await this.getRecentlyOpened(),p=r.workspaces.filter(n),C=r.files.filter(n);(p.length!==r.workspaces.length||C.length!==r.files.length)&&(await this.s({files:C,workspaces:p}),this.c.fire(),c.$k&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(t){const n=new h.$zc(C=>g.$lg.getComparisonKey(C));if(t?.workspaces)for(const C of t.workspaces)n.set(this.t(C),C);const r=new h.$zc(C=>g.$lg.getComparisonKey(C));if(t?.files)for(const C of t.files)r.set(this.t(C),C);const p=await this.r();for(const C of p.workspaces){const R=n.get(this.t(C));R?R.label=R.label??C.label:n.set(this.t(C),C)}for(const C of p.files){const R=r.get(this.t(C));R?R.label=R.label??C.label:r.set(this.t(C),C)}return{workspaces:[...n.values()],files:[...r.values()]}}async r(){await this.j.whenReady;let t;const n=this.j.get(i.b,-1);if(typeof n=="string")try{t=JSON.parse(n)}catch(r){this.f.error("Unexpected error parsing opened paths list",r)}return(0,u.$IU)(t,this.f)}async s(t){await this.j.whenReady,this.j.store(i.b,JSON.stringify((0,u.$JU)(t)),-1,1)}t(t){return(0,u.$CU)(t)?t.folderUri:(0,u.$DU)(t)?t.fileUri:t.workspace.configPath}u(t,n){return!!t.find(r=>(0,u.$BU)(r)&&r.workspace.id===n.id)}w(t,n){return!!t.find(r=>(0,u.$CU)(r)&&g.$lg.isEqual(r.folderUri,n))}y(t,n){return!!t.find(r=>g.$lg.isEqual(r.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){c.$j&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!c.$j)return;const t=[];if(t.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const C of P.app.getJumpListSettings().removedItems){const R=C.args;if(R){const k=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(R);k&&n.push(w.URI.parse(k[2]))}}await this.removeRecentlyOpened(n);let r=!1;const p=(0,A.$Gb)((await this.getRecentlyOpened()).workspaces.slice(0,i.D).map(C=>{const R=(0,u.$BU)(C)?C.workspace:C.folderUri,{title:k,description:I}=this.J(R,C.label);let L;return w.URI.isUri(R)?L=`--folder-uri "${R.toString()}"`:(r=!0,L=`--file-uri "${R.configPath.toString()}"`),{type:"task",title:k.substr(0,255),description:I.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));p.length>0&&t.push({type:"custom",name:r?(0,d.localize)(2,null):(0,d.localize)(3,null),items:p})}t.push({type:"recent"});try{const n=P.app.setJumpList(t);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(t,n){if(n)return{title:(0,D.$vv)(n).name,description:n};if(w.URI.isUri(t))return{title:(0,g.$rg)(t),description:this.L(t)};if(this.g.isUntitledWorkspace(t))return{title:(0,d.localize)(4,null),description:""};let r=(0,g.$rg)(t.configPath);return r.endsWith(l.$0h)&&(r=r.substr(0,r.length-l.$0h.length-1)),{title:(0,d.localize)(5,null,r),description:this.L(t.configPath)}}L(t){return t.scheme==="file"?(0,D.$nv)(t.fsPath):t.toString()}async M(){if(!c.$k)return;P.app.clearRecentDocuments();const t=await this.getRecentlyOpened(),n=[];let r=0;for(let C=0;C<t.workspaces.length&&r<i.z;C++){const R=this.t(t.workspaces[C]);if(R.scheme===f.Schemas.file){const k=(0,g.$ig)(R);await y.Promises.exists(k)&&(n.push(k),r++)}}const p=[];for(let C=0;C<t.files.length&&r<i.C;C++){const R=this.t(t.files[C]);if(R.scheme===f.Schemas.file){const k=(0,g.$ig)(R);if(i.F.includes((0,g.$rg)(R))||n.includes(k))continue;await y.Promises.exists(k)&&(p.push(k),r++)}}p.reverse().forEach(C=>P.app.addRecentDocument(C)),n.reverse().forEach(C=>P.app.addRecentDocument(C))}};e.$46b=a,e.$46b=a=i=ke([ee(0,m.$8i),ee(1,E.$w6b),ee(2,b.$35b),ee(3,$.$a6b)],a)}),define(te[302],ie([0,1,15,8,22,46,4,7,179,17,25,20,5,229,69,24,34,26,48,59,30,82]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u,l,E,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=void 0;const a="menu";let o=class{static{i=this}static{this.a="lastKnownMenubarData"}constructor(r,p,C,R,k,I,L,N,z,ne,_){this.n=r,this.o=p,this.p=C,this.q=R,this.r=k,this.s=I,this.t=L,this.u=N,this.v=z,this.w=ne,this.x=_,this.m=Object.create(null),this.g=new A.$5g(()=>this.E(),0),this.h=new A.$5g(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$k||(0,l.$2C)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const r=this.t.getItem(i.a);r&&(r.menus&&(this.k=r.menus),r.keybindings&&(this.l=r.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(I,L,N)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.newWindow"]=(I,L,N)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.files.openFileFolder"]=(I,L,N)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:a}}),this.m["workbench.action.files.openFolder"]=(I,L,N)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:a}}),this.m["workbench.action.openWorkspace"]=(I,L,N)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:a}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const r=this.x.youTubeUrl;r&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(r,"openYouTubeUrl"));const p=this.x.requestFeatureUrl;p&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(p,"openUserVoiceUrl"));const C=this.x.reportIssueUrl;C&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(C,"openReportIssues"));const R=this.x.licenseUrl;R&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$w){const I=R.indexOf("?")>0?"&":"?";this.Z(`${R}${I}lang=${D.$w}`,"openLicenseUrl")}else this.Z(R,"openLicenseUrl")});const k=this.x.privacyStatementUrl;k&&R&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(k,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(r=>this.F(r)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const r=this.o.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get C(){if(!D.$k)return!1;const r=this.o.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,p){this.k=r.menus,this.l=r.keybindings,this.t.setItem(i.a,r),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(r){D.$k&&(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.d=r.newCount===0,this.D())}G(){D.$k&&(this.f=!P.BrowserWindow.getFocusedWindow(),this.D())}H(){const r=P.Menu.getApplicationMenu();if(r&&this.j.push(r),Object.keys(this.k).length===0){P.Menu.setApplicationMenu(D.$k?new P.Menu:null);return}const p=new P.Menu;let C;if(D.$k){const k=new P.Menu;C=new P.MenuItem({label:this.x.nameShort,submenu:k}),this.I(k),p.append(C)}if(D.$k&&!this.c){this.c=!0;const k=new P.Menu;k.append(new P.MenuItem({label:this.ab(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(k)}if(this.K("File")){const k=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(1,null)),submenu:k});this.M(k,"File"),p.append(I)}if(this.K("Edit")){const k=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(2,null)),submenu:k});this.M(k,"Edit"),p.append(I)}if(this.K("Selection")){const k=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(3,null)),submenu:k});this.M(k,"Selection"),p.append(I)}if(this.K("View")){const k=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(4,null)),submenu:k});this.M(k,"View"),p.append(I)}if(this.K("Go")){const k=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(5,null)),submenu:k});this.M(k,"Go"),p.append(I)}if(this.K("Run")){const k=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(6,null)),submenu:k});this.M(k,"Run"),p.append(I)}if(this.K("Terminal")){const k=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(7,null)),submenu:k});this.M(k,"Terminal"),p.append(I)}let R;if(this.K("Window")){const k=new P.Menu;R=new P.MenuItem({label:this.ab(f.localize(8,null)),submenu:k,role:"window"}),this.S(k)}if(R&&p.append(R),this.K("Help")){const k=new P.Menu,I=new P.MenuItem({label:this.ab(f.localize(9,null)),submenu:k,role:"help"});this.M(k,"Help"),p.append(I)}p.items&&p.items.length>0?P.Menu.setApplicationMenu(p):P.Menu.setApplicationMenu(null),this.h.schedule()}I(r){const p=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),C=this.T();let R;if(this.K("Preferences")){const ae=new P.Menu;this.M(ae,"Preferences"),R=new P.MenuItem({label:this.ab(f.localize(11,null)),submenu:ae})}const k=new P.Menu,I=new P.MenuItem({label:f.localize(12,null),role:"services",submenu:k}),L=new P.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),N=new P.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new P.MenuItem({label:f.localize(15,null),role:"unhide"}),ne=new P.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(ae,se,oe)=>{const J=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||J?.isMinimized())&&await this.J(oe)&&this.w.quit(void 0)}})),_=[p];_.push(...C),R&&_.push(t(),R),_.push(t(),I,t(),L,N,z,t(),ne),_.forEach(ae=>r.append(ae))}async J(r){if(this.p.getWindowCount()===0)return!0;const p=this.o.getValue("window.confirmBeforeClose");if(p==="always"||p==="keyboardOnly"&&this.Q(r)){const{response:C}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return C===0}return!0}K(r){if(!D.$k&&(0,l.$2C)(this.o)==="custom")return!1;switch(r){case"File":case"Help":if(D.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[r];case"Window":if(D.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[r]}}L(r,p){p.forEach(C=>{if((0,d.$Z6b)(C))r.append(t());else if((0,d.$Y6b)(C)){const R=new P.Menu,k=new P.MenuItem({label:this.ab(C.label),submenu:R});this.L(R,C.submenu.items),r.append(k)}else(0,d.$16b)(C)?r.append(this.O(C)):(0,d.$26b)(C)&&(C.id==="workbench.action.showAboutDialog"&&this.N(r),D.$k?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[C.id]?r.append(new P.MenuItem(this.Y(C.id,{label:this.ab(C.label),click:this.m[C.id]}))):r.append(this.U(C.label,C.id,!1,C.checked)):r.append(this.U(C.label,C.id,C.enabled!==!1,!!C.checked)):r.append(this.U(C.label,C.id,C.enabled!==!1,!!C.checked)))})}M(r,p){this.k&&this.k[p]&&this.L(r,this.k[p].items)}N(r){const p=this.T();p.length&&(p.forEach(C=>r.append(C)),r.append(t()))}O(r){const p=S.URI.revive(r.uri),C=r.id,R=C==="openRecentFile"?{fileUri:p}:C==="openRecentWorkspace"?{workspaceUri:p}:{folderUri:p};return new P.MenuItem(this.Y(C,{label:r.label,click:async(k,I,L)=>{const N=this.P(L);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[R],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:r.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([p])}},!1))}P(r){return!!(r&&(!D.$k&&(r.ctrlKey||r.shiftKey)||D.$k&&(r.metaKey||r.altKey)))}Q(r){return!!(r.triggeredByAccelerator||r.altKey||r.ctrlKey||r.metaKey||r.shiftKey)}R(r,p,C){const R={label:this.ab(r),role:C,enabled:!0};return new P.MenuItem(this.X(p,R))}S(r){const p=new P.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),C=new P.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),R=new P.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),k=this.U(f.localize(23,null),"workbench.action.switchWindow"),I=[];this.C&&(I.push(t()),I.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),I.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),I.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),I.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),I.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[p,C,t(),k,...I,t(),R].forEach(L=>r.append(L))}T(){switch(this.n.state.type){case"idle":return[new P.MenuItem({label:this.ab(f.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.ab(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.ab(f.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.ab(f.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(r,p,C,R){const k=this.ab(r),I=typeof p=="function"?p:(_,ae,se)=>{const oe=_?_.userSettingsLabel:null;let J=p;Array.isArray(p)&&(J=this.P(se)?p[1]:p[0]),oe&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:oe}):this.W({type:"commandId",commandId:J})},L=typeof C=="boolean"?C:this.p.getWindowCount()>0,N=typeof R=="boolean"?R:!1,z={label:k,click:I,enabled:L};N&&(z.type="checkbox",z.checked=N);let ne;return typeof p=="string"?ne=p:Array.isArray(p)&&(ne=p[0]),D.$k&&(ne==="editor.action.clipboardCutAction"?z.role="cut":ne==="editor.action.clipboardCopyAction"?z.role="copy":ne==="editor.action.clipboardPasteAction"&&(z.role="paste"),ne==="undo"?z.click=this.V(I,{inDevTools:_=>_.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):ne==="redo"?z.click=this.V(I,{inDevTools:_=>_.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):ne==="editor.action.selectAll"&&(z.click=this.V(I,{inDevTools:_=>_.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.X(ne,z))}V(r,p){return(C,R,k)=>{const I=P.BrowserWindow.getFocusedWindow();if(!I)return p.inNoWindow();if(I.webContents.isDevToolsFocused()&&I.webContents.devToolsWebContents)return p.inDevTools(I.webContents.devToolsWebContents);r(C,R||I,k)}}W(r){let p=P.BrowserWindow.getFocusedWindow();if(!p){const R=this.p.getLastActiveWindow();R?.isMinimized()&&(p=R.win)}const C=p?this.p.getWindowById(p.id):void 0;if(C){if(this.v.trace("menubar#runActionInRenderer",r),D.$k&&!this.q.isBuilt&&!C.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const R={id:r.commandId,from:"menu"};C.sendWhenReady("vscode:runAction",s.CancellationToken.None,R)}else{const R={userSettingsLabel:r.userSettingsLabel};C.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,R)}}else this.v.trace("menubar#runActionInRenderer: no active window found",r)}X(r,p){const C=typeof r=="string"?this.l[r]:void 0;if(C?.label){if(C.isNative!==!1)p.accelerator=C.label,p.userSettingsLabel=C.userSettingsLabel;else if(typeof p.label=="string"){const R=p.label.indexOf("[");R>=0?p.label=`${p.label.substr(0,R)} [${C.label}]`:p.label=`${p.label} [${C.label}]`}}else p.accelerator=void 0;return p}Y(r,p,C=!p.accelerator){C&&(p=this.X(r,p));const R=p.click;return p.click=(k,I,L)=>{this.$(r),R?.(k,I,L)},p}Z(r,p){this.w.openExternal(void 0,r),this.$(p)}$(r){this.r.publicLog2("workbenchActionExecuted",{id:r,from:a})}ab(r){return(0,M.$sv)(r,!this.B)}};e.$56b=o,e.$56b=o=i=ke([ee(0,u.$dU),ee(1,c.$hi),ee(2,E.$e6b),ee(3,g.$15b),ee(4,$.$al),ee(5,h.$36b),ee(6,m.$qN),ee(7,w.$35b),ee(8,y.$8i),ee(9,v.$P6b),ee(10,b.$nj)],o);function t(){return new P.MenuItem({type:"separator"})}}),define(te[303],ie([0,1,6,20,5,302]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=e.$66b=void 0,e.$66b=(0,P.$Nh)("menubarMainService");let D=class{constructor(f,c,g){this.b=f,this.c=c,this.d=g,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$56b)}async updateMenubar(f,c){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(c,f)}};e.$76b=D,e.$76b=D=ke([ee(0,P.$Mh),ee(1,A.$35b),ee(2,s.$8i)],D)}),define(te[304],ie([0,1,15,21,130,28,23,22,3,33,46,2,13,9,66,4,35,19,12,7,189,64,17,60,25,16,6,20,5,78,79,58,34,59,301,129,297,29,98,82,53,68,39,52,67]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u,l,E,h,i,a,o,t,n,r,p,C,R,k,I,L,N,z,ne,_,ae,se,oe,J,K,G,U){"use strict";var q;Object.defineProperty(e,"__esModule",{value:!0}),e.$x7b=void 0;function X(re){return(0,_.$3h)(re?.workspace)}function H(re){return(0,_.$Xh)(re?.workspace)}let Q=class extends w.$Rc{static{q=this}static{this.a=[]}constructor(F,O,j,B,W,T,V,ce,de,ue,fe,ye,be,pe,Ce,We,$e,we){super(),this.m=F,this.n=O,this.r=j,this.s=B,this.t=W,this.u=T,this.w=V,this.z=ce,this.C=de,this.D=ue,this.F=fe,this.G=ye,this.H=be,this.I=pe,this.J=Ce,this.L=We,this.M=$e,this.N=we,this.b=this.B(new f.$Md),this.onDidOpenWindow=this.b.event,this.c=this.B(new f.$Md),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new f.$Md),this.onDidDestroyWindow=this.f.event,this.g=this.B(new f.$Md),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new f.$Md),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ne.$u7b(this,this.t,this.C,this.r,this.F)),this.O()}O(){this.B(this.H.onDidEnterWorkspace(F=>this.c.fire(F.window))),this.B(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const O=new w.$Qc;if(O.add(f.Event.any(F.onDidClose,F.onDidDestroy)(()=>O.dispose())),F.config.extensionDevelopmentPath)for(const j of F.config.extensionDevelopmentPath)O.add(this.M.addValidFileRoot(j));F.config.extensionTestsPath&&O.add(this.M.addValidFileRoot(F.config.extensionTestsPath))}}))}openEmptyWindow(F,O){const j=this.w.args,B=O?.remoteAuthority||void 0,W=!0,T=O?.forceReuseWindow,V=!T;return this.open({...F,cli:j,forceEmpty:W,forceNewWindow:V,forceReuseWindow:T,remoteAuthority:B})}openExistingWindow(F,O){F.focus(),this.P(O,[F])}async open(F){this.r.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const O=[],j=[],B=[],W=[],T=[];let V,ce=0;const de=await this.X(F);this.r.trace("windowsManager#open pathsToOpen",de);for(const pe of de)H(pe)?F.addMode?O.push(pe):j.push(pe):X(pe)?B.push(pe):pe.fileUri?(V||(V={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:pe.remoteAuthority}),V.filesToOpenOrCreate.push(pe)):pe.backupPath?T.push({backupFolder:(0,d.$mc)(pe.backupPath),remoteAuthority:pe.remoteAuthority}):ce++;F.diffMode&&V&&V.filesToOpenOrCreate.length>=2&&(V.filesToDiff=V.filesToOpenOrCreate.slice(0,2),V.filesToOpenOrCreate=[]),F.mergeMode&&V&&V.filesToOpenOrCreate.length===4&&(V.filesToMerge=V.filesToOpenOrCreate.slice(0,4),V.filesToOpenOrCreate=[],V.filesToDiff=[]),V&&F.waitMarkerFileURI&&(V.filesToWait={paths:(0,D.$Gb)([...V.filesToDiff,V.filesToMerge[3],...V.filesToOpenOrCreate]),waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(W.push(...this.H.getUntitledWorkspaces()),B.push(...W),T.push(...this.D.getEmptyWindowBackups())):T.length=0;const{windows:ue,filesOpenedInWindow:fe}=await this.Q(F,B,j,T,ce,V,O);if(this.r.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${B.length}, foldersToOpen: ${j.length}, emptyToRestore: ${T.length}, emptyToOpen: ${ce})`),ue.length>1)if(fe)fe.focus();else{const pe=this.j.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let Ce=!0,We=!0;if(pe){const $e=ue.filter(we=>this.j.state.lastActiveWindow&&we.backupPath===this.j.state.lastActiveWindow.backupPath);$e.length&&($e[0].focus(),Ce=!1,We=!1)}if(Ce)for(let $e=ue.length-1;$e>=0;$e--){const we=ue[$e];if(!(we.openedWorkspace&&W.some(Y=>we.openedWorkspace&&Y.workspace.id===we.openedWorkspace.id)||we.backupPath&&T.some(Y=>we.backupPath&&Y.backupFolder===(0,d.$mc)(we.backupPath)))){we.focus(),We=!1;break}}We&&ue[ue.length-1].focus()}const ye=V&&V.filesToDiff.length>0,be=V&&V.filesToMerge.length>0;if(!ue.some(pe=>pe.isExtensionDevelopmentHost)&&!ye&&!be&&!F.noRecentEntry){const pe=[];for(const Ce of de)X(Ce)&&!Ce.transient?pe.push({label:Ce.label,workspace:Ce.workspace,remoteAuthority:Ce.remoteAuthority}):H(Ce)?pe.push({label:Ce.label,folderUri:Ce.workspace.uri,remoteAuthority:Ce.remoteAuthority}):Ce.fileUri&&pe.push({label:Ce.label,fileUri:Ce.fileUri,remoteAuthority:Ce.remoteAuthority});this.G.addRecentlyOpened(pe)}return this.P(F,ue),ue}P(F,O){const j=F.waitMarkerFileURI;F.context===0&&j&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.L.del(j)}catch{}})()}async Q(F,O,j,B,W,T,V){const ce=[];let de;function ue($e,we){ce.push($e),we&&(de=$e,T=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:ye}=this.ib(F);if(!F.initialStartup&&V.length>0){const $e=V[0].remoteAuthority,we=this.nb($e);we&&ue(this.S(we,V.map(Y=>Y.workspace.uri)))}const be=j.length+O.length+B.length;if(T&&be===0){const $e=T.filesToOpenOrCreate[0]||T.filesToDiff[0]||T.filesToMerge[3],we=this.getWindows().filter(le=>T&&(0,$.$zg)(le.remoteAuthority,T.remoteAuthority));let Y;$e?.fileUri&&!ye&&((F.context===4||F.context===0||F.context===1)&&(Y=await(0,z.$t6b)(we,$e.fileUri,async le=>le.configPath.scheme===y.Schemas.file?this.H.resolveLocalWorkspace(le.configPath):void 0)),Y||(Y=this.ob(we))),Y?(0,_.$3h)(Y.openedWorkspace)?O.push({workspace:Y.openedWorkspace,remoteAuthority:Y.remoteAuthority}):(0,_.$Xh)(Y.openedWorkspace)?j.push({workspace:Y.openedWorkspace,remoteAuthority:Y.remoteAuthority}):ue(this.R(F,Y,T),!0):ue(await this.jb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:T,forceNewWindow:!0,remoteAuthority:T.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile}),!0)}const pe=(0,D.$Lb)(O,$e=>$e.workspace.id);if(pe.length>0){const $e=(0,D.$Gb)(pe.map(we=>(0,z.$u6b)(this.getWindows(),we.workspace.configPath)));if($e.length>0){const we=$e[0],Y=(0,$.$zg)(T?.remoteAuthority,we.remoteAuthority)?T:void 0;ue(this.R(F,we,Y),!!Y),fe=!0}for(const we of pe){if($e.some(ge=>ge.openedWorkspace&&ge.openedWorkspace.id===we.workspace.id))continue;const Y=we.remoteAuthority,le=(0,$.$zg)(T?.remoteAuthority,Y)?T:void 0;ue(await this.W(F,we,fe,le),!!le),fe=!0}}const Ce=(0,D.$Lb)(j,$e=>$.$lg.getComparisonKey($e.workspace.uri));if(Ce.length>0){const $e=(0,D.$Gb)(Ce.map(we=>(0,z.$u6b)(this.getWindows(),we.workspace.uri)));if($e.length>0){const we=$e[0],Y=(0,$.$zg)(T?.remoteAuthority,we.remoteAuthority)?T:void 0;ue(this.R(F,we,Y),!!Y),fe=!0}for(const we of Ce){if($e.some(ge=>(0,_.$Xh)(ge.openedWorkspace)&&$.$lg.isEqual(ge.openedWorkspace.uri,we.workspace.uri)))continue;const Y=we.remoteAuthority,le=(0,$.$zg)(T?.remoteAuthority,Y)?T:void 0;ue(await this.W(F,we,fe,le),!!le),fe=!0}}const We=(0,D.$Lb)(B,$e=>$e.backupFolder);if(We.length>0)for(const $e of We){const we=$e.remoteAuthority,Y=(0,$.$zg)(T?.remoteAuthority,we)?T:void 0;ue(await this.U(F,!0,we,Y,$e),!!Y),fe=!0}if(ce.length===0||T){T&&!W&&W++;const $e=T?T.remoteAuthority:F.remoteAuthority;for(let we=0;we<W;we++)ue(await this.U(F,fe,$e,T),!!T),fe=!0}return{windows:(0,D.$Lb)(ce),filesOpenedInWindow:de}}R(F,O,j){this.r.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:j}),O.focus();const B={filesToOpenOrCreate:j?.filesToOpenOrCreate,filesToDiff:j?.filesToDiff,filesToMerge:j?.filesToMerge,filesToWait:j?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",S.CancellationToken.None,B),O}S(F,O){this.r.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),F.focus();const j={foldersToAdd:O};return F.sendWhenReady("vscode:addFolders",S.CancellationToken.None,j),F}U(F,O,j,B,W){this.r.trace("windowsManager#doOpenEmpty",{restore:!!W,remoteAuthority:j,filesToOpen:B,forceNewWindow:O});let T;return!O&&typeof F.contextWindowId=="number"&&(T=this.getWindowById(F.contextWindowId)),this.jb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:j,forceNewWindow:O,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:B,windowToUse:T,emptyWindowBackupInfo:W,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}W(F,O,j,B,W){return this.r.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:B}),!j&&!W&&typeof F.contextWindowId=="number"&&(W=this.getWindowById(F.contextWindowId)),this.jb({workspace:O.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:j,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:B,windowToUse:W,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}async X(F){let O,j=!1,B=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(O=await this.Y(F),j=!0):F.forceEmpty?O=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(O=await this.Z(F.cli),O.length===0&&O.push(Object.create(null)),j=!0):(O=await this.ab(),O.length===0&&O.push(Object.create(null)),B=!0),!F.addMode&&j){const W=O.filter(T=>H(T));if(W.length>1){const T=W[0].remoteAuthority;if(W.every(V=>(0,$.$zg)(V.remoteAuthority,T))){const V=await this.H.createUntitledWorkspace(W.map(ce=>({uri:ce.workspace.uri})));O.push({workspace:V,remoteAuthority:T}),O=O.filter(ce=>!H(ce))}}}if(F.initialStartup&&!B&&this.F.getValue("window")?.restoreWindows==="preserve"){const W=await this.ab();O.unshift(...W.filter(T=>X(T)||H(T)||T.backupPath))}return O}async Y(F){const O={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority},j=await Promise.all((0,D.$Gb)(F.urisToOpen||[]).map(async B=>{const W=await this.cb(B,O);if(W)return W.label=B.label,W;const T=this.eb(B);this.J.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:T.scheme===y.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:T.scheme===y.Schemas.file?(0,E.localize)(3,null,(0,g.$mv)(T,{os:b.OS,tildify:this.w})):(0,E.localize)(4,null,T.toString(!0))},P.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$Gb)(j)}async Z(F){const O=[],j={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:F.diff&&F._.length===2||F.merge&&F._.length===4},B=F["folder-uri"];if(B){const V=await Promise.all(B.map(ce=>{const de=this.$(ce);if(de)return this.cb({folderUri:de},j)}));O.push(...(0,D.$Gb)(V))}const W=F["file-uri"];if(W){const V=await Promise.all(W.map(ce=>{const de=this.$(ce);if(de)return this.cb((0,_.$gi)(ce)?{workspaceUri:de}:{fileUri:de},j)}));O.push(...(0,D.$Gb)(V))}const T=await Promise.all(F._.map(V=>j.remoteAuthority?this.hb(V,j):this.fb(V,j)));return O.push(...(0,D.$Gb)(T)),O}$(F){try{const O=l.URI.parse(F);if(!O.scheme){this.r.error(`Invalid URI input string, scheme missing: ${F}`);return}return O.path?O:O.with({path:"/"})}catch(O){this.r.error(`Invalid URI input string: ${F}, ${O.message}`)}}async ab(){const F=this.bb();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];F!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const j=await Promise.all(O.map(async B=>{if(B.workspace){const W=await this.cb({workspaceUri:B.workspace.configPath},{remoteAuthority:B.remoteAuthority,rejectTransientWorkspaces:!0});if(X(W))return W}else if(B.folderUri){const W=await this.cb({folderUri:B.folderUri},{remoteAuthority:B.remoteAuthority});if(H(W))return W}else if(F!=="folders"&&B.backupPath)return{backupPath:B.backupPath,remoteAuthority:B.remoteAuthority}}));return(0,D.$Gb)(j)}}}bb(){let F;return this.C.wasRestarted?F="all":(F=this.F.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}async cb(F,O=Object.create(null)){const j=this.eb(F);return j.scheme===y.Schemas.file?((0,L.$ZC)(F)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.fb(j.fsPath,O)):this.db(F,O)}db(F,O){let j=this.eb(F);const B=(0,k.$Sk)(j)||O.remoteAuthority;if(j=(0,$.$Bg)((0,$.$vg)(j)),(0,L.$ZC)(F)){if(O.gotoLineMode){const{path:W,line:T,column:V}=(0,c.$4f)(j.path);return{fileUri:j.with({path:W}),options:{selection:T?{startLineNumber:T,startColumn:V||1}:void 0},remoteAuthority:B}}return{fileUri:j,remoteAuthority:B}}else if((0,L.$XC)(F))return{workspace:(0,ae.$m6b)(j),remoteAuthority:B};return{workspace:(0,ae.$n6b)(j),remoteAuthority:B}}eb(F){return(0,L.$XC)(F)?F.workspaceUri:(0,L.$YC)(F)?F.folderUri:F.fileUri}async fb(F,O,j){let B,W;O.gotoLineMode&&({path:F,line:B,column:W}=(0,c.$4f)(F)),F=(0,c.$Yf)((0,d.$gc)(F),(0,m.cwd)());try{const T=await A.Promises.stat(F);if(T.isFile()){if(!O.forceOpenWorkspaceAsFile){const V=await this.H.resolveLocalWorkspace(l.URI.file(F));if(V)return V.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:t.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:l.URI.file(F),type:t.FileType.File,exists:!0,options:{selection:B?{startLineNumber:B,startColumn:W||1}:void 0}}}else{if(T.isDirectory())return{workspace:(0,ae.$n6b)(l.URI.file(F),T),type:t.FileType.Directory,exists:!0};if(!b.$j&&F==="/dev/null")return{fileUri:l.URI.file(F),type:t.FileType.File,exists:!0}}}catch(T){if(T.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!j)return this.gb(F,O);const V=l.URI.file(F);if(this.G.removeRecentlyOpened([V]),O.ignoreFileNotFound)return{fileUri:V,type:t.FileType.File,exists:!1}}}async gb(F,O){const j=l.URI.file(F),{response:B,checkboxChecked:W}=await this.J.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,j.authority),detail:(0,E.localize)(9,null,(0,g.$mv)(j,{os:b.OS,tildify:this.w})),checkboxLabel:(0,E.localize)(10,null,j.authority),cancelId:1});if(B===0)return(0,s.addUNCHostToAllowlist)(j.authority),W&&this.sendToOpeningWindow("vscode:configureAllowedUNCHost",j.authority),this.fb(F,O,!0);if(B===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.gb(F,O)}hb(F,O){const j=F.charCodeAt(0),B=O.remoteAuthority;let W,T;O.gotoLineMode&&({path:F,line:W,column:T}=(0,c.$4f)(F)),j!==47&&((0,c.$Xf)(j)&&F.charCodeAt(F.charCodeAt(1))===58&&(F=(0,c.$Qf)(F)),F=`/${F}`);const V=l.URI.from({scheme:y.Schemas.vscodeRemote,authority:B,path:F});if(F.charCodeAt(F.length-1)!==47){if((0,_.$gi)(F))return O.forceOpenWorkspaceAsFile?{fileUri:V,options:{selection:W?{startLineNumber:W,startColumn:T||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ae.$m6b)(V),remoteAuthority:B};if(O.gotoLineMode||d.$fc.basename(F).indexOf(".")!==-1)return{fileUri:V,options:{selection:W?{startLineNumber:W,startColumn:T||1}:void 0},remoteAuthority:B}}return{workspace:(0,ae.$n6b)(V),remoteAuthority:B}}ib(F){const O=this.F.getValue("window"),j=O?.openFoldersInNewWindow||"default",B=O?.openFilesInNewWindow||"off";let W=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(j==="on"||j==="off")&&(W=j==="on");let T=!1;return F.forceNewWindow||F.forceReuseWindow?T=!!F.forceNewWindow&&!F.forceReuseWindow:(b.$k?F.context===1&&(T=!0):F.context!==3&&F.context!==2&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(T=!0),!F.cli.extensionDevelopmentPath&&(B==="on"||B==="off")&&(T=B==="on")),{openFolderInNewWindow:!!W,openFilesInNewWindow:T}}async openExtensionDevelopmentHostWindow(F,O){const j=(0,z.$v6b)(this.getWindows(),F);if(j)return this.C.reload(j,O.cli),j.focus(),[j];let B=O.cli["folder-uri"]||[],W=O.cli["file-uri"]||[],T=O.cli._;if(!T.length&&!B.length&&!W.length&&!O.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,ue=de?.workspace??de?.folderUri;ue&&(l.URI.isUri(ue)?ue.scheme===y.Schemas.file?T=[ue.fsPath]:B=[ue.toString()]:ue.configPath.scheme===y.Schemas.file?T=[(0,$.$ig)(ue.configPath)]:W=[ue.configPath.toString()])}let V=O.remoteAuthority;for(const de of F)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=l.URI.parse(de),fe=(0,k.$Sk)(ue);fe&&(V?(0,$.$zg)(fe,V)||this.r.error("more than one extension development path authority"):V=fe)}T=T.filter(de=>{const ue=l.URI.file(de);return(0,z.$u6b)(this.getWindows(),ue)?!1:(0,$.$zg)((0,k.$Sk)(ue),V)}),B=B.filter(de=>{const ue=this.$(de);return ue&&(0,z.$u6b)(this.getWindows(),ue)?!1:ue?(0,$.$zg)((0,k.$Sk)(ue),V):!1}),W=W.filter(de=>{const ue=this.$(de);return ue&&(0,z.$u6b)(this.getWindows(),ue)?!1:ue?(0,$.$zg)((0,k.$Sk)(ue),V):!1}),O.cli._=T,O.cli["folder-uri"]=B,O.cli["file-uri"]=W;const ce={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!T.length&&!B.length&&!W.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:V,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(ce)}async jb(F){const O=this.F.getValue("window"),j=this.getLastActiveWindow(),B=j?.profile??this.z.defaultProfile;let W;!F.forceNewWindow&&!F.forceNewTabbedWindow&&(W=F.windowToUse||j,W&&W.focus());const T={...this.w.args,...F.cli,machineId:this.m,windowId:-1,mainPid:process.pid,appRoot:this.w.appRoot,execPath:process.execPath,codeCachePath:this.w.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,d.$ic)(this.w.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.z.profilesHome,all:this.z.profiles,profile:B},homeDir:this.w.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.w.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.w.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.n,...F.userEnv},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToMerge:F.filesToOpen?.filesToMerge,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.s.getLogLevel(),loggers:{window:[],global:this.s.getRegisteredLoggers()},logsPath:this.w.logsHome.with({scheme:y.Schemas.file}).fsPath,product:C.default,isInitialStartup:F.initialStartup,perfMarks:(0,v.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.N.getColorScheme(),policiesData:this.u.serialize(),continueOn:this.w.continueOn};if(W){const V=W.config;!T.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(T.extensionDevelopmentPath=V.extensionDevelopmentPath,T.extensionDevelopmentKind=V.extensionDevelopmentKind,T["enable-proposed-api"]=V["enable-proposed-api"],T.verbose=V.verbose,T["inspect-extensions"]=V["inspect-extensions"],T["inspect-brk-extensions"]=V["inspect-brk-extensions"],T.debugId=V.debugId,T.extensionEnvironment=V.extensionEnvironment,T["extensions-dir"]=V["extensions-dir"],T["disable-extensions"]=V["disable-extensions"]),T.loggers={global:T.loggers.global,window:V?.loggers.window??T.loggers.window}}else{const V=this.j.getNewWindowState(T);(0,v.mark)("code/willCreateCodeWindow");const ce=W=this.I.createInstance(N.$t7b,{state:V,extensionDevelopmentPath:T.extensionDevelopmentPath,isExtensionTestHost:!!T.extensionTestsPath});(0,v.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ce),q.a.push(ce),this.b.fire(ce),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const de=new w.$Qc;de.add(ce.onDidSignalReady(()=>this.c.fire(ce))),de.add(f.Event.once(ce.onDidClose)(()=>this.mb(ce,de))),de.add(f.Event.once(ce.onDidDestroy)(()=>this.f.fire(ce))),de.add(ce.onDidTriggerSystemContextMenu(({x:fe,y:ye})=>this.h.fire({window:ce,x:fe,y:ye})));const ue=(0,u.$If)(ce.win?.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.C.reload(ce)),this.C.registerWindow(ce)}return T.windowId=W.id,W.isReady?this.C.unload(W,4).then(async V=>{V||await this.kb(W,T,F,B)}):await this.kb(W,T,F,B),W}async kb(F,O,j,B){if(O.extensionDevelopmentPath||((0,_.$3h)(O.workspace)?O.backupPath=this.D.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,_.$Xh)(O.workspace)?O.backupPath=this.D.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.D.registerEmptyWindowBackup({backupFolder:j.emptyWindowBackupInfo?.backupFolder??(0,ae.$o6b)().id,remoteAuthority:O.remoteAuthority})),this.z.isEnabled()){const W=O.workspace??(0,_.$2h)(O.backupPath,!1),T=this.lb(j,W,B),V=T instanceof Promise?await T:T;O.profiles.profile=V,O.extensionDevelopmentPath||await this.z.setProfileForWorkspace(W,V)}F.load(O)}lb(F,O,j){return F.forceProfile?this.z.profiles.find(B=>B.name===F.forceProfile)??this.z.createNamedProfile(F.forceProfile):F.forceTempProfile?this.z.createTransientProfile():this.z.getProfileForWorkspace(O)??j}mb(F,O){const j=q.a.indexOf(F);q.a.splice(j,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),O.dispose()}getFocusedWindow(){const F=P.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.ob(this.getWindows())}nb(F){return this.ob(this.getWindows().filter(O=>(0,$.$zg)(O.remoteAuthority,F)))}ob(F){const O=Math.max.apply(Math,F.map(j=>j.lastFocusTime));return F.find(j=>j.lastFocusTime===O)}sendToFocused(F,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(F,S.CancellationToken.None,...O)}sendToOpeningWindow(F,...O){this.B(f.Event.once(this.onDidSignalReadyWindow)(j=>{j.sendWhenReady(F,S.CancellationToken.None,...O)}))}sendToAll(F,O,j){for(const B of this.getWindows())j&&j.indexOf(B.id)>=0||B.sendWhenReady(F,S.CancellationToken.None,O)}getWindows(){return q.a}getWindowCount(){return q.a.length}getWindowById(F){const O=this.getWindows().filter(j=>j.id===F);return(0,D.$Nb)(O)}getWindowByWebContents(F){const O=P.BrowserWindow.fromWebContents(F);if(O)return this.getWindowById(O.id)}};e.$x7b=Q,e.$x7b=Q=q=ke([ee(2,p.$8i),ee(3,U.$86b),ee(4,I.$qN),ee(5,K.$en),ee(6,o.$15b),ee(7,G.$95b),ee(8,r.$35b),ee(9,h.$k6b),ee(10,i.$hi),ee(11,se.$36b),ee(12,oe.$w6b),ee(13,n.$Mh),ee(14,a.$r6b),ee(15,t.$9j),ee(16,R.$R6b),ee(17,J.$c6b)],Q)}),define(te[305],ie([0,1,64,30,82,53]),function(Z,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0;let D=class{constructor(f,c,g,w){this.a=f,this.b=c,this.c=g,this.d=w,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,c){const g=this.b.getWindowById(f);if(g)return this.a.enterWorkspace(g,this.b.getWindows(),c)}createUntitledWorkspace(f,c,g){return this.a.createUntitledWorkspace(c,g)}deleteUntitledWorkspace(f,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(f,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(f,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$z7b=D,e.$z7b=D=ke([ee(0,M.$w6b),ee(1,A.$e6b),ee(2,s.$36b),ee(3,P.$k6b)],D)}),define(te[306],ie([0,1,15,130,38,28,18,49,14,33,3,44,46,2,13,9,4,12,7,32,156,42,157,110,288,160,64,281,17,198,90,131,60,116,218,25,63,93,207,291,209,210,211,16,222,92,77,6,91,217,298,282,289,20,5,303,69,24,58,292,94,34,273,81,122,26,249,251,51,48,263,286,299,287,300,127,265,266,267,270,295,30,304,272,29,97,82,305,53,39,231,52,242,50,80,128,275,290,278,8,253,274,226,67,294,269,23,125,293,261,237,71,296]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u,l,E,h,i,a,o,t,n,r,p,C,R,k,I,L,N,z,ne,_,ae,se,oe,J,K,G,U,q,X,H,Q,re,F,O,j,B,W,T,V,ce,de,ue,fe,ye,be,pe,Ce,We,$e,we,Y,le,ge,Re,De,Ne,Oe,ze,Te,x,he,me,ve,Ae,Fe,Le,Ue,Be,He,Ge,xe,Ye,it,nt,$t,wt,bt,pt,yt,vt,kt,rt,Et,Pt,St,It,ot,Ct,ht,at,Rt,Dt,ct,At,ft){"use strict";var lt;Object.defineProperty(e,"__esModule",{value:!0}),e.$Q7b=void 0;let ut=class extends d.$Rc{static{lt=this}static{this.a={[v.Schemas.file]:"security.promptForLocalFileProtocolHandling",[v.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Se,Ie,Ee,Pe,Me,je,qe,Ze,Je,Ve,Ke,Xe){super(),this.f=Se,this.g=Ie,this.h=Ee,this.j=Pe,this.m=Me,this.n=je,this.s=qe,this.t=Ze,this.u=Je,this.w=Ve,this.y=Ke,this.z=Xe,this.C(),this.D()}C(){const Se=Ve=>Ve?.startsWith(`${v.Schemas.vscodeWebview}://`),Ie=new Set(this.y.quality==="stable"?[]:["media"]),Ee=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Ve,Ke,Xe,Qe)=>Se(Qe.requestingUrl)?Xe(Ee.has(Ke)):Qe.isMainFrame&&Qe.securityOrigin===`${v.Schemas.vscodeFileResource}://${v.$ag}/`?Xe(Ie.has(Ke)):Xe(!1)),P.session.defaultSession.setPermissionCheckHandler((Ve,Ke,Xe,Qe)=>Se(Qe.requestingUrl)?Ee.has(Ke):Qe.isMainFrame&&Qe.securityOrigin===`${v.Schemas.vscodeFileResource}://${v.$ag}/`?Ie.has(Ke):!1);const Pe=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),Me=Ve=>{for(let Ke=Ve;Ke;Ke=Ke.parent)if(Ke.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},je=Ve=>Ve.resourceType==="xhr"||Me(Ve.frame),qe=Ve=>{const Ke=Ve.frame;if(!Ke||!this.b)return!1;const Xe=P.BrowserWindow.getAllWindows();for(const Qe of Xe)if(Ke.processId===Qe.webContents.mainFrame.processId)return!0;return!1},Ze=(Ve,Ke)=>{if(Ve.path!=="/index.html")return!0;const Xe=Ke.frame;if(!Xe||!this.b)return!1;for(const Qe of this.b.getWindows())if(Qe.win&&Xe.processId===Qe.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Ve,Ke)=>{const Xe=u.URI.parse(Ve.url);return Xe.scheme===v.Schemas.vscodeWebview&&!Ze(Xe,Ve)?(this.j.error("Blocked vscode-webview request",Ve.url),Ke({cancel:!0})):Xe.scheme===v.Schemas.vscodeFileResource&&!qe(Ve)?(this.j.error("Blocked vscode-file request",Ve.url),Ke({cancel:!0})):Xe.path.endsWith(".svg")&&!Pe.has(Xe.scheme)?Ke({cancel:!je(Ve)}):Ke({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Ve,Ke)=>{const Xe=Ve.responseHeaders,Qe=Xe["content-type"]||Xe["Content-Type"];if(Qe&&Array.isArray(Qe)){const _e=u.URI.parse(Ve.url);if(_e.path.endsWith(".svg")&&Pe.has(_e.scheme))return Xe["Content-Type"]=["image/svg+xml"],Ke({cancel:!1,responseHeaders:Xe});if(!_e.path.endsWith(v.Schemas.vscodeRemoteResource)&&Qe.some(et=>et.toLowerCase().includes("image/svg")))return Ke({cancel:!je(Ve)})}return Ke({cancel:!1})});const Je=P.session.defaultSession;typeof Je.setCodeCachePath=="function"&&this.n.codeCachePath&&Je.setCodeCachePath((0,b.$ic)(this.n.codeCachePath,"chrome")),m.$j&&(this.t.getValue("security.restrictUNCAccess")===!1?(0,A.disableUNCAccessRestrictions)():(0,A.addUNCHostToAllowlist)(this.t.getValue("security.allowedUNCHosts")))}D(){(0,f.setUnexpectedErrorHandler)(Ee=>this.G(Ee)),process.on("uncaughtException",Ee=>{(0,f.$Y)(Ee)||(0,f.$Z)(Ee)}),process.on("unhandledRejection",Ee=>(0,f.$Z)(Ee)),this.s.onWillShutdown(()=>this.dispose()),(0,E.$eT)(),P.app.on("accessibility-support-changed",(Ee,Pe)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",Pe)}),P.app.on("activate",async(Ee,Pe)=>{this.j.trace("app#activate"),Pe||await this.b?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(Ee,Pe)=>{Pe?.opener?.url.startsWith(`${v.Schemas.vscodeFileResource}://${v.$ag}/`)&&this.h.createInstance(ft.$P7b,Pe),Pe.on("will-navigate",je=>{this.j.error("webContents#will-navigate: Prevented webcontent navigation"),je.preventDefault()}),Pe.setWindowOpenHandler(je=>je.url==="about:blank"?(this.j.trace("webContents#setWindowOpenHandler: Allowing about:blank window to open"),{action:"allow",overrideBrowserWindowOptions:ft.$P7b.open(this.h)}):(this.j.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${je.url}}`),this.c?.openExternal(void 0,je.url),{action:"deny"}))});let Se=[],Ie;P.app.on("open-file",(Ee,Pe)=>{this.j.trace("app#open-file: ",Pe),Ee.preventDefault(),Se.push((0,Ue.$gi)(Pe)?{workspaceUri:u.URI.file(Pe)}:{fileUri:u.URI.file(Pe)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.b?.open({context:1,cli:this.n.args,urisToOpen:Se,gotoLineMode:!1,preferNewWindow:!0}),Se=[],Ie=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$dT.handle("vscode:fetchShellEnv",Ee=>{const Pe=this.b?.getWindowByWebContents(Ee.sender);let Me,je;return Pe?.config?(Me=Pe.config,je={...process.env,...Pe.config.userEnv}):(Me=this.n.args,je=process.env),this.W(Me,je,!1)}),s.$dT.handle("vscode:writeNlsFile",(Ee,Pe,Me)=>{const je=this.F([Pe]);if(!je||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.w.writeFile(je,D.$ae.fromString(Me))}),s.$dT.handle("vscode:readNlsFile",async(Ee,...Pe)=>{const Me=this.F(Pe);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.w.readFile(Me)).value.toString()}),s.$dT.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),s.$dT.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),s.$dT.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}F(Se){let Ie;for(const Ee of Se)typeof Ee=="string"&&(typeof Ie!="string"?Ie=Ee:Ie=(0,b.$ic)(Ie,Ee));if(!(typeof Ie!="string"||!(0,b.$hc)(Ie)||!(0,c.$Wf)(Ie,this.n.cachedLanguagesPath,!m.$l)))return u.URI.file(Ie)}G(Se){if(Se){const Ie={message:`[uncaught exception in main]: ${Se.message}`,stack:Se.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.j.error(`[uncaught exception in main]: ${Se}`),Se.stack&&this.j.error(Se.stack)}async startup(){this.j.debug("Starting VS Code"),this.j.debug(`from: ${this.n.appRoot}`),this.j.debug("args:",this.n.args);const Se=this.y.win32AppUserModelId;m.$j&&Se&&P.app.setAppUserModelId(Se);try{m.$k&&this.t.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Je){this.j.error(Je)}const Ie=new i.$kT;this.s.onWillShutdown(Je=>{Je.reason===2&&Ie.dispose()}),this.j.trace("Resolving machine identifier...");const Ee=await(0,Et.$G7b)(this.u,this.j);this.j.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcessReady:Pe,sharedProcessClient:Me}=this.O(Ee),je=await this.P(Ee,Pe);this.B(je.createInstance(o.$g6b)),this.B(je.createInstance(vt.$D7b)),je.invokeFunction(Je=>this.Q(Je,Ie,Me));const qe=await je.invokeFunction(Je=>this.H(Je,Ie));this.I(Ie),this.s.phase=2,await je.invokeFunction(Je=>this.R(Je,qe)),this.s.phase=3,this.S(),this.B(new rt.$5g(()=>{this.B((0,rt.$9g)(()=>this.s.phase=4,2500))},2500)).schedule()}async H(Se,Ie){const Ee=this.b=Se.get(Ae.$e6b),Pe=Se.get(ze.$4T),Me=this.c=Se.get(V.$P6b),je=Se.get(I.$r6b),qe=this;Pe.registerHandler({async handleURL(Qe,_e){return qe.N(Ee,je,Pe,Qe,_e)}});const Ze=this.B(new Le.$y7b({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),Je=new h.$vh(Qe=>Ze.getActiveClientId().then(_e=>Qe===_e)),Ve=new Te.$o7b(Je,this.j),Ke=Ie.getChannel("urlHandler",Ve);Pe.registerHandler(new Te.$n7b(Ke));const Xe=await this.J(Ee,je);return this.B(new he.$p7b(Xe?.urls,Pe,Ee,this.n,this.y,this.j)),Xe}I(Se){const Ie=()=>({statusCode:404,data:"Not found"}),Ee=new At.$U(()=>Se.getChannel(ct.$N7b,new ct.$O7b));P.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(Pe,Me)=>{const je=u.URI.parse(Pe.url);if(!je.authority.startsWith("window:"))return Me(Ie());Ee.value.call(ct.$M7b,[je]).then(qe=>Me({...qe,data:Buffer.from(qe.body,"base64")}),qe=>{this.j.warn("error dispatching remote resource call",qe),Me({statusCode:500,data:String(qe)})})})}async J(Se,Ie){const Ee=this.n.args["open-url"]?this.n.args._urls||[]:[];Ee.length>0&&this.j.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ee);const Pe=global.getOpenUrls()||[];if(Pe.length>0&&this.j.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Pe),Ee.length+Pe.length===0)return;const Me=[...Ee,...Pe].map(Ze=>{try{return{uri:u.URI.parse(Ze),originalUrl:Ze}}catch{this.j.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ze);return}}),je=[],qe=[];for(const Ze of Me){if(!Ze)continue;if(await this.L(Ze.uri,Se,Ie)){this.j.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ze.uri.toString(!0));continue}const Je=this.M(Ze.uri);Je?(this.j.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ze.uri.toString(!0),Je),je.push(Je)):(this.j.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ze.uri.toString(!0)),qe.push(Ze))}return{urls:qe,openables:je}}async L(Se,Ie,Ee){if(Se.authority!==v.Schemas.file&&Se.authority!==v.Schemas.vscodeRemote||this.t.getValue(lt.a[Se.authority])===!1)return!1;const{response:Me,checkboxChecked:je}=await Ee.showMessageBox({type:"warning",buttons:[(0,t.localize)(0,null),(0,t.localize)(1,null)],message:(0,t.localize)(2,null,Se.authority===v.Schemas.file?(0,y.$mv)(Se,{os:m.OS,tildify:this.n}):Se.toString(!0),this.y.nameShort),detail:(0,t.localize)(3,null),checkboxLabel:(0,t.localize)(4,null),cancelId:1});return Me!==0?!0:(je&&Ie.sendToOpeningWindow("vscode:disablePromptForProtocolHandling",Se.authority===v.Schemas.file?"local":"remote"),!1)}M(Se){if(Se.path){if(Se.authority===v.Schemas.file){const Ie=u.URI.file(Se.fsPath);return(0,Ue.$gi)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Se.authority===v.Schemas.vscodeRemote){const Ie=Se.path.indexOf(b.$fc.sep,1);if(Ie!==-1){const Ee=Se.path.substring(1,Ie),Pe=Se.path.substring(Ie);let Me=Se.query;const je=new URLSearchParams(Se.query);je.get("windowId")==="_blank"&&(je.delete("windowId"),Me=je.toString());const qe=u.URI.from({scheme:v.Schemas.vscodeRemote,authority:Ee,path:Pe,query:Me,fragment:Se.fragment});return(0,Ue.$gi)(Pe)?{workspaceUri:qe}:/:[\d]+$/.test(Pe)?{fileUri:qe}:{folderUri:qe}}}}}async N(Se,Ie,Ee,Pe,Me){if(this.j.trace("app#handleProtocolUrl():",Pe.toString(!0),Me),Pe.scheme===this.y.urlProtocol&&Pe.path==="workspace"&&(Pe=Pe.with({authority:"file",path:u.URI.parse(Pe.query).path,query:""})),await this.L(Pe,Se,Ie))return this.j.trace("app#handleProtocolUrl() protocol url was blocked:",Pe.toString(!0)),!0;let je=!1;const qe=new URLSearchParams(Pe.query);qe.get("windowId")==="_blank"?(this.j.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Pe.toString(!0)),qe.delete("windowId"),Pe=Pe.with({query:qe.toString()}),je=!0):m.$k&&Se.getWindowCount()===0&&(this.j.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Pe.toString(!0)),je=!0);const Ze=qe.get("continueOn");Ze!==null&&(this.j.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Pe.toString(!0)),qe.delete("continueOn"),Pe=Pe.with({query:qe.toString()}),this.n.continueOn=Ze??void 0);const Je=this.M(Pe);return Je?(this.j.trace("app#handleProtocolUrl() opening protocol url as window:",Je,Pe.toString(!0)),(0,ht.$Nb)(await Se.open({context:5,cli:{...this.n.args},urisToOpen:[Je],forceNewWindow:je,gotoLineMode:!0}))?.focus(),!0):je?(this.j.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Pe.toString(!0)),await(0,ht.$Nb)(await Se.open({context:5,cli:{...this.n.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.$Sk)(Pe)}))?.ready(),Ee.open(Pe,Me)):(this.j.trace("app#handleProtocolUrl(): not handled",Pe.toString(!0),Me),!1)}O(Se){const Ie=this.B(this.h.createInstance(ue.$a7b,Se)),Ee=(async()=>{this.j.trace("Main->SharedProcess#connect");const Me=await Ie.connect();return this.j.trace("Main->SharedProcess#connect: connection established"),new a.$lT(Me,"main")})();return{sharedProcessReady:(async()=>(await Ie.whenReady(),Ee))(),sharedProcessClient:Ee}}async P(Se,Ie){const Ee=new Q.$Lh;switch(process.platform){case"win32":Ee.set(le.$dU,new X.$Kh(Oe.$l7b));break;case"linux":m.$m?Ee.set(le.$dU,new X.$Kh(Ne.$k7b,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(le.$dU,new X.$Kh(De.$j7b));break;case"darwin":Ee.set(le.$dU,new X.$Kh(Re.$i7b));break}Ee.set(Ae.$e6b,new X.$Kh(Fe.$x7b,[Se,this.g],!1));const Pe=new I.$s6b(this.j,this.y);Ee.set(I.$r6b,Pe),Ee.set(j.$W6b,new X.$Kh(j.$X6b,void 0,!1)),Ee.set(k.$B6b,new X.$Kh(k.$C6b,void 0,!1)),Ee.set(R.$nm,h.ProxyChannel.toService((0,h.$th)(Ie.then(Je=>Je.getChannel("diagnostics"))))),Ee.set(re.$Vwb,new X.$Kh(F.$S6b,[this.g])),Ee.set(L.$XT,new X.$Kh(N.$D6b)),Ee.set(O.$T6b,new X.$Kh(O.$U6b)),Ee.set(V.$P6b,new X.$Kh(V.$Q6b,void 0,!1)),Ee.set(me.$q7b,new X.$Kh(ve.$s7b)),Ee.set(T.$66b,new X.$Kh(T.$76b)),Ee.set(ae.$E6b,new X.$Kh(se.$G6b)),Ee.set(pe.$$5b,new X.$Kh(pe.$_5b)),Ee.set(pe.$a6b,new X.$Kh(pe.$b6b));const Me=new Rt.$L7b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.t.getValue("terminal.integrated.persistentSessionScrollback")??100},this.t,this.n,this.s,this.j),je=new Dt.$sr(Me,this.t,this.j,this.m);Ee.set(at.$6q,je),m.$j?Ee.set(oe.$H6b,new X.$Kh(J.$I6b)):m.$k?Ee.set(oe.$H6b,new X.$Kh(J.$J6b)):m.$l&&Ee.set(oe.$H6b,new X.$Kh(J.$K6b));const qe=new r.$p6b(this.n,this.t,this.j,this.u);Ee.set(n.$k6b,qe);const Ze=new xe.$x6b(this.n,this.j,this.z,qe,Pe);if(Ee.set(xe.$w6b,Ze),Ee.set(Be.$AU,new X.$Kh(Ge.$z7b,void 0,!1)),Ee.set(He.$36b,new X.$Kh(He.$46b,void 0,!1)),Ee.set(ze.$4T,new X.$Kh(x.$6T,void 0,!1)),(0,Y.$oo)(this.y,this.n)){const Je=(0,Y.$to)(this.y,this.t),Ve=(0,h.$th)(Ie.then(et=>et.getChannel("telemetryAppender"))),Ke=new $e.$d7b(Ve),Xe=(0,Ce.$eo)((0,M.release)(),(0,M.hostname)(),process.arch,this.y.commit,this.y.version,Se,Je),Qe=(0,Y.$uo)(this.n),_e={appenders:[Ke],commonProperties:Xe,piiPaths:Qe,sendErrorTelemetry:!0};Ee.set(We.$al,new X.$Kh(we.$Xq,[_e],!1))}else Ee.set(We.$al,Y.$io);return Ee.set(bt.$rp,new X.$Kh(Pt.$xN,void 0,!0)),Ee.set(pt.$vp,new X.$Kh(yt.$C7b,void 0,!0)),Ee.set(ot.$J7b,new X.$Kh(ot.$K7b,void 0,!0)),await rt.Promises.settled([qe.initialize(),Ze.initialize()]),this.h.createChild(Ee)}Q(Se,Ie,Ee){const Pe=this.B(new d.$Qc),Me=h.ProxyChannel.fromService(Se.get(j.$W6b),Pe,{disableMarshalling:!0});this.f.registerChannel("launch",Me);const je=h.ProxyChannel.fromService(Se.get(k.$B6b),Pe,{disableMarshalling:!0});this.f.registerChannel("diagnostics",je);const qe=new it.$A7b(Se.get(Ye.$en));Ie.registerChannel("policy",qe),Ee.then(tt=>tt.registerChannel("policy",qe));const Ze=this.w.getProvider(v.Schemas.file);(0,$.$Hf)(Ze instanceof q.$0p);const Je=new U.$L6b(Ze,this.j,this.n);Ie.registerChannel(K.$gN,Je),Ee.then(tt=>tt.registerChannel(K.$gN,Je));const Ve=h.ProxyChannel.fromService(Se.get(nt.$95b),Pe);Ie.registerChannel("userDataProfiles",Ve),Ee.then(tt=>tt.registerChannel("userDataProfiles",Ve));const Ke=new $t.$Sq(Se.get(wt.$Po));Ee.then(tt=>tt.registerChannel("request",Ke));const Xe=new ge.$e7b(Se.get(le.$dU));Ie.registerChannel("update",Xe);const Qe=h.ProxyChannel.fromService(Se.get(re.$Vwb),Pe);Ie.registerChannel("issue",Qe);const _e=h.ProxyChannel.fromService(Se.get(L.$XT),Pe);Ie.registerChannel("encryption",_e);const et=h.ProxyChannel.fromService(Se.get(fe.$1k),Pe);Ie.registerChannel("sign",et);const st=h.ProxyChannel.fromService(Se.get(O.$T6b),Pe);Ie.registerChannel("keyboardLayout",st),this.c=Se.get(V.$P6b);const dt=h.ProxyChannel.fromService(this.c,Pe);Ie.registerChannel("nativeHost",dt),Ee.then(tt=>tt.registerChannel("nativeHost",dt));const Ot=h.ProxyChannel.fromService(Se.get(Be.$AU),Pe);Ie.registerChannel("workspaces",Ot);const Mt=h.ProxyChannel.fromService(Se.get(T.$66b),Pe);Ie.registerChannel("menubar",Mt);const Lt=h.ProxyChannel.fromService(Se.get(ze.$4T),Pe);Ie.registerChannel("url",Lt);const jt=h.ProxyChannel.fromService(Se.get(me.$q7b),Pe);Ie.registerChannel("webview",jt);const gt=this.B(new be.$b7b(this.j,Se.get(pe.$$5b)));Ie.registerChannel("storage",gt),Ee.then(tt=>tt.registerChannel("storage",gt));const Ut=this.B(new kt.$E7b(Se.get(pe.$$5b),Se.get(nt.$95b),this.j));Ee.then(tt=>tt.registerChannel("profileStorageListener",Ut));const Nt=h.ProxyChannel.fromService(Se.get(at.$6q),Pe);Ie.registerChannel(at.TerminalIpcChannels.LocalPty,Nt);const Ft=h.ProxyChannel.fromService(Se.get(oe.$H6b),Pe);Ie.registerChannel("externalTerminal",Ft);const mt=new St.$H7b(Se.get(It.$86b));Ie.registerChannel("logger",mt),Ee.then(tt=>tt.registerChannel("logger",mt));const Wt=new C.$q6b(Se.get(Ae.$e6b));Ie.registerChannel("extensionhostdebugservice",Wt);const Tt=h.ProxyChannel.fromService(Se.get(ae.$E6b),Pe);Ie.registerChannel(ae.$F6b,Tt);const zt=h.ProxyChannel.fromService(Se.get(ot.$J7b),Pe);Ie.registerChannel(Ct.$I7b,zt)}async R(Se,Ie){const Ee=this.b=Se.get(Ae.$e6b),Pe=(0,ne.$Kl)(process.env)?0:4,Me=this.n.args;if(Ie){if(Ie.openables.length>0)return Ee.open({context:Pe,cli:Me,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const et of Ie.urls){const st=new URLSearchParams(et.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),et.originalUrl=et.uri.toString(!0),et.uri=et.uri.with({query:st.toString()}),Ee.open({context:Pe,cli:Me,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const je=global.macOpenFiles,qe=Me._.length,Ze=!!Me["folder-uri"],Je=!!Me["file-uri"],Ve=Me["skip-add-to-recently-opened"]===!0,Ke=Me.wait&&Me.waitMarkerFilePath?u.URI.file(Me.waitMarkerFilePath):void 0,Xe=Me.remote||void 0,Qe=Me.profile,_e=Me["profile-temp"];if(!qe&&!Ze&&!Je){if(Me["new-window"]||Qe||_e)return Ee.open({context:Pe,cli:Me,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:Ke,initialStartup:!0,remoteAuthority:Xe,forceProfile:Qe,forceTempProfile:_e});if(je.length)return Ee.open({context:1,cli:Me,urisToOpen:je.map(et=>(0,Ue.$gi)(et)?{workspaceUri:u.URI.file(et)}:{fileUri:u.URI.file(et)}),noRecentEntry:Ve,waitMarkerFileURI:Ke,initialStartup:!0})}return Ee.open({context:Pe,cli:Me,forceNewWindow:Me["new-window"]||!qe&&Me["unity-launch"],diffMode:Me.diff,mergeMode:Me.merge,noRecentEntry:Ve,waitMarkerFileURI:Ke,gotoLineMode:Me.goto,initialStartup:!0,remoteAuthority:Xe,forceProfile:Qe,forceTempProfile:_e})}S(){this.U(),P.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Se,Ie)=>{Ie({url:Se.url.replace(/^vscode-remote-resource:/,"http:"),method:Se.method})}),this.W(this.n.args,process.env,!0),this.X(),m.$k&&P.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const Se=this.y.win32MutexName;if(m.$j&&Se)try{const Ie=await new Promise((Pe,Me)=>{Z(["@vscode/windows-mutex"],Pe,Me)}),Ee=new Ie.Mutex(Se);g.Event.once(this.s.onWillShutdown)(()=>Ee.release())}catch(Ie){this.j.error(Ie)}}async W(Se,Ie,Ee){try{return await(0,_.$Ql)(this.t,this.j,Se,Ie)}catch(Pe){const Me=(0,S.$yi)(Pe);Ee?this.b?.sendToFocused("vscode:showResolveShellEnvError",Me):this.j.error(Me)}return{}}async X(){try{const Ie=(await this.w.readFile(this.n.argvResource)).value.toString(),Ee=JSON.parse((0,w.$1m)(Ie)),Me=(0,Y.$qo)(this.t)>=1;if(Ee["enable-crash-reporter"]===void 0){const je=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,l.$dg)()}"`,"}"],qe=Ie.substring(0,Ie.length-2).concat(`,
`,je.join(`
`));await this.w.writeFile(this.n.argvResource,D.$ae.fromString(qe))}else{const je=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Me},`);je!==Ie&&await this.w.writeFile(this.n.argvResource,D.$ae.fromString(je))}}catch(Se){this.j.error(Se)}}};e.$Q7b=ut,e.$Q7b=ut=lt=ke([ee(2,H.$Mh),ee(3,W.$8i),ee(4,W.$9i),ee(5,z.$15b),ee(6,B.$35b),ee(7,p.$hi),ee(8,ye.$qN),ee(9,G.$9j),ee(10,ce.$nj),ee(11,nt.$95b)],ut)}),define(te[312],ie([0,1,15,45,7,23,8,49,14,33,3,46,13,9,66,4,35,27,21,42,99,306,10,17,236,248,25,63,200,16,220,92,77,216,91,20,223,5,78,24,79,276,126,285,50,284,94,247,34,51,68,52,39,232,230,2,40,264,67,225,115,121,268,262]),function(Z,e,P,A,s,M,D,S,f,c,g,w,y,d,v,b,m,$,u,l,E,h,i,a,o,t,n,r,p,C,R,k,I,L,N,z,ne,_,ae,se,oe,J,K,G,U,q,X,H,Q,re,F,O,j,B,W,T,V,ce,de,ue,fe,ye,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class pe{main(){try{this.a()}catch($e){console.error($e.message),P.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[$e,we,Y,le,ge,Re,De,Ne]=this.b();try{try{await this.d(Y,Ne,le,ge,De)}catch(Oe){throw this.f(Y,De,Oe),Oe}await $e.invokeFunction(async Oe=>{const ze=Oe.get(_.$8i),Te=Oe.get(z.$35b),x=Oe.get(C.$9j),he=Oe.get(_.$9i),me=await this.e(ze,Y,Te,$e,De,!0);return u.Promises.writeFile(Y.mainLockfile,String(process.pid)).catch(ve=>{ze.warn(`app#startup(): Error writing main lockfile: ${ve.stack}`)}),Re.logger=he.createLogger("main",{name:(0,i.localize)(0,null)}),g.Event.once(Te.onWillShutdown)(ve=>{x.dispose(),le.dispose(),ve.join("instanceLockfile",u.Promises.unlink(Y.mainLockfile).catch(()=>{}))}),$e.createInstance(h.$Q7b,me,we).startup()})}catch(Oe){$e.invokeFunction(this.i,Oe)}}b(){const $e=new N.$Lh,we=new T.$Qc;process.once("exit",()=>we.dispose());const Y={_serviceBrand:void 0,...ae.default};$e.set(se.$nj,Y);const le=new n.$25b(this.j(),Y),ge=this.c(le);$e.set(n.$15b,le);const Re=new de.$96b((0,_.$jj)(le),le.logsHome);$e.set(de.$86b,Re);const De=new ne.$J3b(Re.getLogLevel()),Ne=we.add(new ue.$yN(De,[new _.$cj(Re.getLogLevel())]));$e.set(_.$8i,Ne);const Oe=new R.$Kp(Ne);$e.set(C.$9j,Oe);const ze=new k.$0p(Ne);Oe.registerProvider(y.Schemas.file,ze);const Te=new ce.$wr(Oe);$e.set(V.$Gk,Te);const x=new ye.$tN(1,le,Ne,Oe);$e.set(Q.$pN,x),$e.set(Q.$qN,x);const he=new O.$05b(x,Te,le,Oe,Ne);$e.set(O.$95b,he),Oe.registerProvider(y.Schemas.vscodeUserData,new be.$27b(y.Schemas.file,ze,y.Schemas.vscodeUserData,he,Te,Ne));const me=b.$j&&Y.win32RegValueName?we.add(new B.$Z7b(Ne,Y.win32RegValueName)):le.policyFile?we.add(new W.$17b(le.policyFile,Oe,Ne)):new j.$gn;$e.set(j.$en,me);const ve=new o.$Gn(he.defaultProfile.settingsResource,Oe,me,Ne);return $e.set(a.$hi,ve),$e.set(z.$35b,new I.$Kh(z.$45b,void 0,!1)),$e.set(U.$Po,new I.$Kh(q.$X7b,void 0,!0)),$e.set(F.$c6b,new I.$Kh(F.$d6b)),$e.set(X.$1k,new I.$Kh(H.$Y7b,void 0,!1)),$e.set(K.$5u,new I.$Kh(G.$V7b)),$e.set(oe.$R6b,new J.$S7b(le,he,Ne)),[new L.$aq($e,!0),ge,le,ve,x,De,Y,he]}c($e){const we={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Y=>{const le=process.env[Y];typeof le=="string"&&(we[Y]=le)}),Object.assign(process.env,we),we}async d($e,we,Y,le,ge){await D.Promises.settled([Promise.all([$e.extensionsPath,$e.codeCachePath,$e.logsHome.with({scheme:y.Schemas.file}).fsPath,we.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:y.Schemas.file}).fsPath,$e.backupHome].map(Re=>Re?u.Promises.mkdir(Re,{recursive:!0}):void 0)),le.init(),Y.initialize()]),we.init()}async e($e,we,Y,le,ge,Re){let De;try{(0,v.mark)("code/willStartMainServer"),De=await(0,E.$Ih)(we.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),g.Event.once(Y.onWillShutdown)(()=>De.dispose())}catch(Ne){if(Ne.code!=="EADDRINUSE")throw this.f(we,ge,Ne),Ne;let Oe;try{Oe=await(0,E.$Jh)(we.mainIPCHandle,"main")}catch(he){if(!Re||b.$j||he.code!=="ECONNREFUSED")throw he.code==="EPERM"&&this.g((0,i.localize)(1,null,ge.nameShort),(0,i.localize)(2,null),ge),he;try{(0,A.unlinkSync)(we.mainIPCHandle)}catch(me){throw $e.warn("Could not delete obsolete instance handle",me),me}return this.e($e,we,Y,le,ge,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const he=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw $e.error(he),Oe.dispose(),new Error(he)}let ze;!we.args.wait&&!we.args.status&&(ze=setTimeout(()=>{this.g((0,i.localize)(3,null,ge.nameShort),(0,i.localize)(4,null),ge)},1e4));const Te=l.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),x=l.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return le.invokeFunction(async()=>{const he=new t.$Dr(re.$io,ge),me=await x.getMainDiagnostics(),ve=await x.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ae=await he.getDiagnostics(me,ve);throw console.log(Ae),new f.$_});throw b.$j&&await this.h(Te,$e),$e.trace("Sending env to running instance..."),await Te.start(we.args,process.env),Oe.dispose(),ze&&clearTimeout(ze),new f.$_("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,i.localize)(5,null,ge.nameShort)),new f.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),De}f($e,we,Y){if(Y.code==="EACCES"||Y.code==="EPERM"){const le=(0,M.$Gb)([$e.userDataPath,$e.extensionsPath,E.$Eh]).map(ge=>(0,w.$mv)(s.URI.file(ge),{os:b.OS,tildify:$e}));this.g((0,i.localize)(6,null),(0,i.localize)(7,null,(0,S.$yi)(Y),le.join(`
`)),we)}}g($e,we,Y){P.dialog.showMessageBoxSync((0,fe.$Av)({type:"warning",buttons:[(0,i.localize)(8,null)],message:$e,detail:we},Y).options)}async h($e,we){if(b.$j){const Y=await $e.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Y);try{(await new Promise((le,ge)=>{Z(["windows-foreground-love"],le,ge)})).allowSetForegroundWindow(Y)}catch(le){we.error(le)}}}i($e,we){const Y=$e.get(_.$8i),le=$e.get(z.$35b);let ge=0;we&&(we.isExpected?we.message&&Y.trace(we.message):(ge=1,we.stack?Y.error(we.stack):Y.error(`Startup error: ${we.toString()}`))),le.kill(ge)}j(){const $e=this.k((0,r.$Hl)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const we=(0,p.$R7b)($e.verbose);we&&((0,r.$Jl)(process.argv,"--waitMarkerFilePath",we),$e.waitMarkerFilePath=we)}return $e}k($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const we=this.l($e._,$e.goto);$e._=we}return $e}l($e,we){const Y=(0,m.cwd)(),le=$e.map(De=>{let Ne=String(De),Oe;we&&(Oe=(0,c.$4f)(Ne),Ne=Oe.path),Ne&&(Ne=this.m(Y,Ne));const ze=(0,c.$Yf)(Ne,Y),Te=(0,d.$mc)(ze);return Te&&!(0,c.$Uf)(Te)?null:we&&Oe?(Oe.path=ze,this.n(Oe)):ze}),ge=b.$j||b.$k,Re=(0,M.$Lb)(le,De=>De&&ge?De.toLowerCase():De||"");return(0,M.$Gb)(Re)}m($e,we){return b.$j&&(we=(0,$.$Je)(we,'"')),we=(0,$.$He)((0,$.$He)(we," "),"	"),b.$j&&(we=(0,d.$jc)($e,we),we=(0,$.$Je)(we,".")),we}n($e){const we=[$e.path];return typeof $e.line=="number"&&we.push(String($e.line)),typeof $e.column=="number"&&we.push(String($e.column)),we.join(":")}}new pe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b63441dbc9f729977e8e97321f536a06521496f7/core/vs/code/electron-main/main.js.map
