/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(re){for(var t=[],y=0,P=re.length;y<P;y++)t[y]=be[re[y]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:jt,isFrozen:Jt,getPrototypeOf:Zt,getOwnPropertyDescriptor:ei}=Object;let{freeze:tt,seal:at,create:ti}=Object,{apply:Ft,construct:Pt}=typeof Reflect<"u"&&Reflect;Ft||(Ft=function(t,y,P){return t.apply(y,P)}),tt||(tt=function(t){return t}),at||(at=function(t){return t}),Pt||(Pt=function(t,y){return new t(...y)});const ii=rt(Array.prototype.forEach),zt=rt(Array.prototype.pop),bt=rt(Array.prototype.push),vt=rt(String.prototype.toLowerCase),Nt=rt(String.prototype.toString),ni=rt(String.prototype.match),ht=rt(String.prototype.replace),si=rt(String.prototype.indexOf),ri=rt(String.prototype.trim),st=rt(RegExp.prototype.test),$t=oi(TypeError);function rt(re){return function(t){for(var y=arguments.length,P=new Array(y>1?y-1:0),i=1;i<y;i++)P[i-1]=arguments[i];return Ft(re,t,P)}}function oi(re){return function(){for(var t=arguments.length,y=new Array(t),P=0;P<t;P++)y[P]=arguments[P];return Pt(re,y)}}function Be(re,t,y){var P;y=(P=y)!==null&&P!==void 0?P:vt,jt&&jt(re,null);let i=t.length;for(;i--;){let U=t[i];if(typeof U=="string"){const w=y(U);w!==U&&(Jt(t)||(t[i]=w),U=w)}re[U]=!0}return re}function gt(re){const t=ti(null);for(const[y,P]of Bt(re))t[y]=P;return t}function Dt(re,t){for(;re!==null;){const P=ei(re,t);if(P){if(P.get)return rt(P.get);if(typeof P.value=="function")return rt(P.value)}re=Zt(re)}function y(P){return console.warn("fallback value for",P),null}return y}const Ht=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Ot=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),li=tt(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Tt=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),ai=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ut=tt(["#text"]),Wt=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Mt=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),hi=at(/\{\{[\w\W]*|[\w\W]*\}\}/gm),ui=at(/<%[\w\W]*|[\w\W]*%>/gm),ci=at(/\${[\w\W]*}/gm),fi=at(/^data-[\-\w.\u00B7-\uFFFF]/),di=at(/^aria-[\-\w]+$/),_t=at(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),gi=at(/^(?:\w+script|data):/i),mi=at(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Vt=at(/^html$/i);var xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:hi,ERB_EXPR:ui,TMPLIT_EXPR:ci,DATA_ATTR:fi,ARIA_ATTR:di,IS_ALLOWED_URI:_t,IS_SCRIPT_OR_DATA:gi,ATTR_WHITESPACE:mi,DOCTYPE_NAME:Vt});const bi=()=>typeof window>"u"?null:window,$i=function(t,y){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let P=null;const i="data-tt-policy-suffix";y&&y.hasAttribute(i)&&(P=y.getAttribute(i));const U="dompurify"+(P?"#"+P:"");try{return t.createPolicy(U,{createHTML(w){return w},createScriptURL(w){return w}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function Kt(){let re=arguments.length>0&&arguments[0]!==void 0?arguments[0]:bi();const t=Te=>Kt(Te);if(t.version="3.0.5",t.removed=[],!re||!re.document||re.document.nodeType!==9)return t.isSupported=!1,t;const y=re.document,P=y.currentScript;let{document:i}=re;const{DocumentFragment:U,HTMLTemplateElement:w,Node:D,Element:h,NodeFilter:f,NamedNodeMap:d=re.NamedNodeMap||re.MozNamedAttrMap,HTMLFormElement:L,DOMParser:s,trustedTypes:a}=re,e=h.prototype,u=Dt(e,"cloneNode"),l=Dt(e,"nextSibling"),m=Dt(e,"childNodes"),n=Dt(e,"parentNode");if(typeof w=="function"){const Te=i.createElement("template");Te.content&&Te.content.ownerDocument&&(i=Te.content.ownerDocument)}let r,$="";const{implementation:c,createNodeIterator:o,createDocumentFragment:C,getElementsByTagName:z}=i,{importNode:I}=y;let b={};t.isSupported=typeof Bt=="function"&&typeof n=="function"&&c&&c.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:v,ERB_EXPR:B,TMPLIT_EXPR:j,DATA_ATTR:W,ARIA_ATTR:M,IS_SCRIPT_OR_DATA:F,ATTR_WHITESPACE:J}=xt;let{IS_ALLOWED_URI:ee}=xt,ne=null;const ue=Be({},[...Ht,...Ot,...Lt,...Tt,...Ut]);let le=null;const oe=Be({},[...Wt,...Mt,...qt,...yt]);let me=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Se=null,Le=null,Ne=!0,de=!0,ie=!1,fe=!0,X=!1,q=!1,G=!1,E=!1,x=!1,g=!1,p=!1,V=!0,T=!1;const N="user-content-";let O=!0,_=!1,S={},R=null;const A=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let k=null;const H=Be({},["audio","video","img","source","image","track"]);let K=null;const te=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),se="http://www.w3.org/1998/Math/MathML",ge="http://www.w3.org/2000/svg",we="http://www.w3.org/1999/xhtml";let Fe=we,Ae=!1,ve=null;const Me=Be({},[se,ge,we],Nt);let Oe;const _e=["application/xhtml+xml","text/html"],je="text/html";let Ie,Ge=null;const Z=i.createElement("form"),ae=function(ce){return ce instanceof RegExp||ce instanceof Function},pe=function(ce){if(!(Ge&&Ge===ce)){if((!ce||typeof ce!="object")&&(ce={}),ce=gt(ce),Oe=_e.indexOf(ce.PARSER_MEDIA_TYPE)===-1?Oe=je:Oe=ce.PARSER_MEDIA_TYPE,Ie=Oe==="application/xhtml+xml"?Nt:vt,ne="ALLOWED_TAGS"in ce?Be({},ce.ALLOWED_TAGS,Ie):ue,le="ALLOWED_ATTR"in ce?Be({},ce.ALLOWED_ATTR,Ie):oe,ve="ALLOWED_NAMESPACES"in ce?Be({},ce.ALLOWED_NAMESPACES,Nt):Me,K="ADD_URI_SAFE_ATTR"in ce?Be(gt(te),ce.ADD_URI_SAFE_ATTR,Ie):te,k="ADD_DATA_URI_TAGS"in ce?Be(gt(H),ce.ADD_DATA_URI_TAGS,Ie):H,R="FORBID_CONTENTS"in ce?Be({},ce.FORBID_CONTENTS,Ie):A,Se="FORBID_TAGS"in ce?Be({},ce.FORBID_TAGS,Ie):{},Le="FORBID_ATTR"in ce?Be({},ce.FORBID_ATTR,Ie):{},S="USE_PROFILES"in ce?ce.USE_PROFILES:!1,Ne=ce.ALLOW_ARIA_ATTR!==!1,de=ce.ALLOW_DATA_ATTR!==!1,ie=ce.ALLOW_UNKNOWN_PROTOCOLS||!1,fe=ce.ALLOW_SELF_CLOSE_IN_ATTR!==!1,X=ce.SAFE_FOR_TEMPLATES||!1,q=ce.WHOLE_DOCUMENT||!1,x=ce.RETURN_DOM||!1,g=ce.RETURN_DOM_FRAGMENT||!1,p=ce.RETURN_TRUSTED_TYPE||!1,E=ce.FORCE_BODY||!1,V=ce.SANITIZE_DOM!==!1,T=ce.SANITIZE_NAMED_PROPS||!1,O=ce.KEEP_CONTENT!==!1,_=ce.IN_PLACE||!1,ee=ce.ALLOWED_URI_REGEXP||_t,Fe=ce.NAMESPACE||we,me=ce.CUSTOM_ELEMENT_HANDLING||{},ce.CUSTOM_ELEMENT_HANDLING&&ae(ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(me.tagNameCheck=ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&ae(ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(me.attributeNameCheck=ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&typeof ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(me.allowCustomizedBuiltInElements=ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),X&&(de=!1),g&&(x=!0),S&&(ne=Be({},[...Ut]),le=[],S.html===!0&&(Be(ne,Ht),Be(le,Wt)),S.svg===!0&&(Be(ne,Ot),Be(le,Mt),Be(le,yt)),S.svgFilters===!0&&(Be(ne,Lt),Be(le,Mt),Be(le,yt)),S.mathMl===!0&&(Be(ne,Tt),Be(le,qt),Be(le,yt))),ce.ADD_TAGS&&(ne===ue&&(ne=gt(ne)),Be(ne,ce.ADD_TAGS,Ie)),ce.ADD_ATTR&&(le===oe&&(le=gt(le)),Be(le,ce.ADD_ATTR,Ie)),ce.ADD_URI_SAFE_ATTR&&Be(K,ce.ADD_URI_SAFE_ATTR,Ie),ce.FORBID_CONTENTS&&(R===A&&(R=gt(R)),Be(R,ce.FORBID_CONTENTS,Ie)),O&&(ne["#text"]=!0),q&&Be(ne,["html","head","body"]),ne.table&&(Be(ne,["tbody"]),delete Se.tbody),ce.TRUSTED_TYPES_POLICY){if(typeof ce.TRUSTED_TYPES_POLICY.createHTML!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ce.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');r=ce.TRUSTED_TYPES_POLICY,$=r.createHTML("")}else r===void 0&&(r=$i(a,P)),r!==null&&typeof $=="string"&&($=r.createHTML(""));tt&&tt(ce),Ge=ce}},De=Be({},["mi","mo","mn","ms","mtext"]),Ce=Be({},["foreignobject","desc","title","annotation-xml"]),Re=Be({},["title","style","font","a","script"]),ze=Be({},Ot);Be(ze,Lt),Be(ze,li);const Ye=Be({},Tt);Be(Ye,ai);const Ke=function(ce){let ye=n(ce);(!ye||!ye.tagName)&&(ye={namespaceURI:Fe,tagName:"template"});const Pe=vt(ce.tagName),qe=vt(ye.tagName);return ve[ce.namespaceURI]?ce.namespaceURI===ge?ye.namespaceURI===we?Pe==="svg":ye.namespaceURI===se?Pe==="svg"&&(qe==="annotation-xml"||De[qe]):!!ze[Pe]:ce.namespaceURI===se?ye.namespaceURI===we?Pe==="math":ye.namespaceURI===ge?Pe==="math"&&Ce[qe]:!!Ye[Pe]:ce.namespaceURI===we?ye.namespaceURI===ge&&!Ce[qe]||ye.namespaceURI===se&&!De[qe]?!1:!Ye[Pe]&&(Re[Pe]||!ze[Pe]):!!(Oe==="application/xhtml+xml"&&ve[ce.namespaceURI]):!1},Ve=function(ce){bt(t.removed,{element:ce});try{ce.parentNode.removeChild(ce)}catch{ce.remove()}},We=function(ce,ye){try{bt(t.removed,{attribute:ye.getAttributeNode(ce),from:ye})}catch{bt(t.removed,{attribute:null,from:ye})}if(ye.removeAttribute(ce),ce==="is"&&!le[ce])if(x||g)try{Ve(ye)}catch{}else try{ye.setAttribute(ce,"")}catch{}},et=function(ce){let ye,Pe;if(E)ce="<remove></remove>"+ce;else{const nt=ni(ce,/^[\r\n\t ]+/);Pe=nt&&nt[0]}Oe==="application/xhtml+xml"&&Fe===we&&(ce='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ce+"</body></html>");const qe=r?r.createHTML(ce):ce;if(Fe===we)try{ye=new s().parseFromString(qe,Oe)}catch{}if(!ye||!ye.documentElement){ye=c.createDocument(Fe,"template",null);try{ye.documentElement.innerHTML=Ae?$:qe}catch{}}const Je=ye.body||ye.documentElement;return ce&&Pe&&Je.insertBefore(i.createTextNode(Pe),Je.childNodes[0]||null),Fe===we?z.call(ye,q?"html":"body")[0]:q?ye.documentElement:Je},it=function(ce){return o.call(ce.ownerDocument||ce,ce,f.SHOW_ELEMENT|f.SHOW_COMMENT|f.SHOW_TEXT,null,!1)},ft=function(ce){return ce instanceof L&&(typeof ce.nodeName!="string"||typeof ce.textContent!="string"||typeof ce.removeChild!="function"||!(ce.attributes instanceof d)||typeof ce.removeAttribute!="function"||typeof ce.setAttribute!="function"||typeof ce.namespaceURI!="string"||typeof ce.insertBefore!="function"||typeof ce.hasChildNodes!="function")},ut=function(ce){return typeof D=="object"?ce instanceof D:ce&&typeof ce=="object"&&typeof ce.nodeType=="number"&&typeof ce.nodeName=="string"},ct=function(ce,ye,Pe){b[ce]&&ii(b[ce],qe=>{qe.call(t,ye,Pe,Ge)})},Et=function(ce){let ye;if(ct("beforeSanitizeElements",ce,null),ft(ce))return Ve(ce),!0;const Pe=Ie(ce.nodeName);if(ct("uponSanitizeElement",ce,{tagName:Pe,allowedTags:ne}),ce.hasChildNodes()&&!ut(ce.firstElementChild)&&(!ut(ce.content)||!ut(ce.content.firstElementChild))&&st(/<[/\w]/g,ce.innerHTML)&&st(/<[/\w]/g,ce.textContent))return Ve(ce),!0;if(!ne[Pe]||Se[Pe]){if(!Se[Pe]&&kt(Pe)&&(me.tagNameCheck instanceof RegExp&&st(me.tagNameCheck,Pe)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Pe)))return!1;if(O&&!R[Pe]){const qe=n(ce)||ce.parentNode,Je=m(ce)||ce.childNodes;if(Je&&qe){const nt=Je.length;for(let xe=nt-1;xe>=0;--xe)qe.insertBefore(u(Je[xe],!0),l(ce))}}return Ve(ce),!0}return ce instanceof h&&!Ke(ce)||(Pe==="noscript"||Pe==="noembed"||Pe==="noframes")&&st(/<\/no(script|embed|frames)/i,ce.innerHTML)?(Ve(ce),!0):(X&&ce.nodeType===3&&(ye=ce.textContent,ye=ht(ye,v," "),ye=ht(ye,B," "),ye=ht(ye,j," "),ce.textContent!==ye&&(bt(t.removed,{element:ce.cloneNode()}),ce.textContent=ye)),ct("afterSanitizeElements",ce,null),!1)},At=function(ce,ye,Pe){if(V&&(ye==="id"||ye==="name")&&(Pe in i||Pe in Z))return!1;if(!(de&&!Le[ye]&&st(W,ye))){if(!(Ne&&st(M,ye))){if(!le[ye]||Le[ye]){if(!(kt(ce)&&(me.tagNameCheck instanceof RegExp&&st(me.tagNameCheck,ce)||me.tagNameCheck instanceof Function&&me.tagNameCheck(ce))&&(me.attributeNameCheck instanceof RegExp&&st(me.attributeNameCheck,ye)||me.attributeNameCheck instanceof Function&&me.attributeNameCheck(ye))||ye==="is"&&me.allowCustomizedBuiltInElements&&(me.tagNameCheck instanceof RegExp&&st(me.tagNameCheck,Pe)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Pe))))return!1}else if(!K[ye]){if(!st(ee,ht(Pe,J,""))){if(!((ye==="src"||ye==="xlink:href"||ye==="href")&&ce!=="script"&&si(Pe,"data:")===0&&k[ce])){if(!(ie&&!st(F,ht(Pe,J,"")))){if(Pe)return!1}}}}}}return!0},kt=function(ce){return ce.indexOf("-")>0},St=function(ce){let ye,Pe,qe,Je;ct("beforeSanitizeAttributes",ce,null);const{attributes:nt}=ce;if(!nt)return;const xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:le};for(Je=nt.length;Je--;){ye=nt[Je];const{name:ot,namespaceURI:pt}=ye;if(Pe=ot==="value"?ye.value:ri(ye.value),qe=Ie(ot),xe.attrName=qe,xe.attrValue=Pe,xe.keepAttr=!0,xe.forceKeepAttr=void 0,ct("uponSanitizeAttribute",ce,xe),Pe=xe.attrValue,xe.forceKeepAttr||(We(ot,ce),!xe.keepAttr))continue;if(!fe&&st(/\/>/i,Pe)){We(ot,ce);continue}X&&(Pe=ht(Pe,v," "),Pe=ht(Pe,B," "),Pe=ht(Pe,j," "));const dt=Ie(ce.nodeName);if(At(dt,qe,Pe)){if(T&&(qe==="id"||qe==="name")&&(We(ot,ce),Pe=N+Pe),r&&typeof a=="object"&&typeof a.getAttributeType=="function"&&!pt)switch(a.getAttributeType(dt,qe)){case"TrustedHTML":{Pe=r.createHTML(Pe);break}case"TrustedScriptURL":{Pe=r.createScriptURL(Pe);break}}try{pt?ce.setAttributeNS(pt,ot,Pe):ce.setAttribute(ot,Pe),zt(t.removed)}catch{}}}ct("afterSanitizeAttributes",ce,null)},It=function Te(ce){let ye;const Pe=it(ce);for(ct("beforeSanitizeShadowDOM",ce,null);ye=Pe.nextNode();)ct("uponSanitizeShadowNode",ye,null),!Et(ye)&&(ye.content instanceof U&&Te(ye.content),St(ye));ct("afterSanitizeShadowDOM",ce,null)};return t.sanitize=function(Te){let ce=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ye,Pe,qe,Je;if(Ae=!Te,Ae&&(Te="<!-->"),typeof Te!="string"&&!ut(Te))if(typeof Te.toString=="function"){if(Te=Te.toString(),typeof Te!="string")throw $t("dirty is not a string, aborting")}else throw $t("toString is not a function");if(!t.isSupported)return Te;if(G||pe(ce),t.removed=[],typeof Te=="string"&&(_=!1),_){if(Te.nodeName){const ot=Ie(Te.nodeName);if(!ne[ot]||Se[ot])throw $t("root node is forbidden and cannot be sanitized in-place")}}else if(Te instanceof D)ye=et("<!---->"),Pe=ye.ownerDocument.importNode(Te,!0),Pe.nodeType===1&&Pe.nodeName==="BODY"||Pe.nodeName==="HTML"?ye=Pe:ye.appendChild(Pe);else{if(!x&&!X&&!q&&Te.indexOf("<")===-1)return r&&p?r.createHTML(Te):Te;if(ye=et(Te),!ye)return x?null:p?$:""}ye&&E&&Ve(ye.firstChild);const nt=it(_?Te:ye);for(;qe=nt.nextNode();)Et(qe)||(qe.content instanceof U&&It(qe.content),St(qe));if(_)return Te;if(x){if(g)for(Je=C.call(ye.ownerDocument);ye.firstChild;)Je.appendChild(ye.firstChild);else Je=ye;return(le.shadowroot||le.shadowrootmode)&&(Je=I.call(y,Je,!0)),Je}let xe=q?ye.outerHTML:ye.innerHTML;return q&&ne["!doctype"]&&ye.ownerDocument&&ye.ownerDocument.doctype&&ye.ownerDocument.doctype.name&&st(Vt,ye.ownerDocument.doctype.name)&&(xe="<!DOCTYPE "+ye.ownerDocument.doctype.name+`>
`+xe),X&&(xe=ht(xe,v," "),xe=ht(xe,B," "),xe=ht(xe,j," ")),r&&p?r.createHTML(xe):xe},t.setConfig=function(Te){pe(Te),G=!0},t.clearConfig=function(){Ge=null,G=!1},t.isValidAttribute=function(Te,ce,ye){Ge||pe({});const Pe=Ie(Te),qe=Ie(ce);return At(Pe,qe,ye)},t.addHook=function(Te,ce){typeof ce=="function"&&(b[Te]=b[Te]||[],bt(b[Te],ce))},t.removeHook=function(Te){if(b[Te])return zt(b[Te])},t.removeHooks=function(Te){b[Te]&&(b[Te]=[])},t.removeAllHooks=function(){b={}},t}var pi=Kt();define("vs/base/browser/dompurify/dompurify",function(){return pi}),define(be[40],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2P=t.$1P=void 0;class y{constructor(w){this.domNode=w,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(w){const D=P(w);this.a!==D&&(this.a=D,this.domNode.style.maxWidth=this.a)}setWidth(w){const D=P(w);this.b!==D&&(this.b=D,this.domNode.style.width=this.b)}setHeight(w){const D=P(w);this.c!==D&&(this.c=D,this.domNode.style.height=this.c)}setTop(w){const D=P(w);this.d!==D&&(this.d=D,this.domNode.style.top=this.d)}setLeft(w){const D=P(w);this.e!==D&&(this.e=D,this.domNode.style.left=this.e)}setBottom(w){const D=P(w);this.f!==D&&(this.f=D,this.domNode.style.bottom=this.f)}setRight(w){const D=P(w);this.g!==D&&(this.g=D,this.domNode.style.right=this.g)}setPaddingTop(w){const D=P(w);this.h!==D&&(this.h=D,this.domNode.style.paddingTop=this.h)}setPaddingLeft(w){const D=P(w);this.i!==D&&(this.i=D,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(w){const D=P(w);this.j!==D&&(this.j=D,this.domNode.style.paddingBottom=this.j)}setPaddingRight(w){const D=P(w);this.k!==D&&(this.k=D,this.domNode.style.paddingRight=this.k)}setFontFamily(w){this.l!==w&&(this.l=w,this.domNode.style.fontFamily=this.l)}setFontWeight(w){this.m!==w&&(this.m=w,this.domNode.style.fontWeight=this.m)}setFontSize(w){const D=P(w);this.n!==D&&(this.n=D,this.domNode.style.fontSize=this.n)}setFontStyle(w){this.o!==w&&(this.o=w,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(w){this.p!==w&&(this.p=w,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(w){this.q!==w&&(this.q=w,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(w){this.r!==w&&(this.r=w,this.domNode.style.textDecoration=this.r)}setLineHeight(w){const D=P(w);this.s!==D&&(this.s=D,this.domNode.style.lineHeight=this.s)}setLetterSpacing(w){const D=P(w);this.t!==D&&(this.t=D,this.domNode.style.letterSpacing=this.t)}setClassName(w){this.u!==w&&(this.u=w,this.domNode.className=this.u)}toggleClassName(w,D){this.domNode.classList.toggle(w,D),this.u=this.domNode.className}setDisplay(w){this.v!==w&&(this.v=w,this.domNode.style.display=this.v)}setPosition(w){this.w!==w&&(this.w=w,this.domNode.style.position=this.w)}setVisibility(w){this.x!==w&&(this.x=w,this.domNode.style.visibility=this.x)}setColor(w){this.y!==w&&(this.y=w,this.domNode.style.color=this.y)}setBackgroundColor(w){this.z!==w&&(this.z=w,this.domNode.style.backgroundColor=this.z)}setLayerHinting(w){this.A!==w&&(this.A=w,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(w){this.C!==w&&(this.C=w,this.domNode.style.boxShadow=w)}setContain(w){this.B!==w&&(this.B=w,this.domNode.style.contain=this.B)}setAttribute(w,D){this.domNode.setAttribute(w,D)}removeAttribute(w){this.domNode.removeAttribute(w)}appendChild(w){this.domNode.appendChild(w.domNode)}removeChild(w){this.domNode.removeChild(w.domNode)}}t.$1P=y;function P(U){return typeof U=="number"?`${U}px`:U}function i(U){return new y(U)}t.$2P=i}),define(be[67],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rO=t.$qO=void 0;let y=!1,P=null;function i(h){if(!h.parent||h.parent===h)return null;try{const f=h.location,d=h.parent.location;if(f.origin!=="null"&&d.origin!=="null"&&f.origin!==d.origin)return y=!0,null}catch{return y=!0,null}return h.parent}class U{static getSameOriginWindowChain(){if(!P){P=[];let f=window,d;do d=i(f),d?P.push({window:f,iframeElement:f.frameElement||null}):P.push({window:f,iframeElement:null}),f=d;while(f)}return P.slice(0)}static hasDifferentOriginAncestor(){return P||this.getSameOriginWindowChain(),y}static getPositionOfChildWindowRelativeToAncestorWindow(f,d){if(!d||f===d)return{top:0,left:0};let L=0,s=0;const a=this.getSameOriginWindowChain();for(const e of a){if(L+=e.window.scrollY,s+=e.window.scrollX,e.window===d||!e.iframeElement)break;const u=e.iframeElement.getBoundingClientRect();L+=u.top,s+=u.left}return{top:L,left:s}}}t.$qO=U;async function w(h,f){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const d=JSON.stringify({parentOrigin:h,salt:f}),s=new TextEncoder().encode(d),a=await crypto.subtle.digest("sha-256",s);return D(a)}t.$rO=w;function D(h){const d=Array.from(new Uint8Array(h)).map(L=>L.toString(16).padStart(2,"0")).join("");return BigInt(`0x${d}`).toString(32).padStart(52,"0")}}),define(be[68],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yQ=t.$xQ=t.$wQ=t.ListDragOverEffect=void 0;var y;(function(U){U[U.Copy=0]="Copy",U[U.Move=1]="Move"})(y||(t.ListDragOverEffect=y={})),t.$wQ={reject(){return{accept:!1}},accept(){return{accept:!0}}};class P extends Error{constructor(w,D){super(`ListError [${w}] ${D}`)}}t.$xQ=P;class i{constructor(){this.c=new WeakMap}getHeight(w){return this.c.get(w)??this.d(w)}setDynamicHeight(w,D){D>0&&this.c.set(w,D)}}t.$yQ=i}),define(be[69],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vQ=void 0;class y{constructor(i){this.a=i}splice(i,U,w){this.a.forEach(D=>D.splice(i,U,w))}}t.$vQ=y}),define(be[41],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7P=void 0;const y=20;class P{constructor(U,w,D,h,f,d){this.a=Math.round(w),this.b=Math.round(D),this.c=Math.round(U),this.d=h,this.e=f,this.f=d,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new P(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(U){const w=Math.round(U);return this.d!==w?(this.d=w,this.m(),!0):!1}setScrollSize(U){const w=Math.round(U);return this.e!==w?(this.e=w,this.m(),!0):!1}setScrollPosition(U){const w=Math.round(U);return this.f!==w?(this.f=w,this.m(),!0):!1}setScrollbarSize(U){this.a=Math.round(U)}setOppositeScrollbarSize(U){this.b=Math.round(U)}static l(U,w,D,h,f){const d=Math.max(0,D-U),L=Math.max(0,d-2*w),s=h>0&&h>D;if(!s)return{computedAvailableSize:Math.round(d),computedIsNeeded:s,computedSliderSize:Math.round(L),computedSliderRatio:0,computedSliderPosition:0};const a=Math.round(Math.max(y,Math.floor(D*L/h))),e=(L-a)/(h-D),u=f*e;return{computedAvailableSize:Math.round(d),computedIsNeeded:s,computedSliderSize:Math.round(a),computedSliderRatio:e,computedSliderPosition:Math.round(u)}}m(){const U=P.l(this.b,this.c,this.d,this.e,this.f);this.g=U.computedAvailableSize,this.h=U.computedIsNeeded,this.i=U.computedSliderSize,this.j=U.computedSliderRatio,this.k=U.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(U){if(!this.h)return 0;const w=U-this.c-this.i/2;return Math.round(w/this.j)}getDesiredScrollPositionFromOffsetPaged(U){if(!this.h)return 0;const w=U-this.c;let D=this.f;return w<this.k?D-=this.d:D+=this.d,D}getDesiredScrollPositionFromDelta(U){if(!this.h)return 0;const w=this.k+U;return Math.round(w/this.j)}}t.$7P=P}),define(be[24],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sS=t.$rS=t.$qS=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var y;(function(h){h[h.Hidden=0]="Hidden",h[h.Visible=1]="Visible",h[h.Recurse=2]="Recurse"})(y||(t.TreeVisibility=y={}));var P;(function(h){h[h.Expanded=0]="Expanded",h[h.Collapsed=1]="Collapsed",h[h.PreserveOrExpanded=2]="PreserveOrExpanded",h[h.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(P||(t.ObjectTreeElementCollapseState=P={}));var i;(function(h){h[h.Unknown=0]="Unknown",h[h.Twistie=1]="Twistie",h[h.Element=2]="Element",h[h.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var U;(function(h){h[h.Down=0]="Down",h[h.Up=1]="Up"})(U||(t.TreeDragOverBubble=U={})),t.$qS={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(h=!1){return{accept:!0,bubble:0,autoExpand:h}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(h=!1){return{accept:!0,bubble:0,effect:0,autoExpand:h}}};class w extends Error{constructor(f,d){super(`TreeError [${f}] ${d}`)}}t.$rS=w;class D{constructor(f){this.a=f,this.b=new WeakMap}map(f){let d=this.b.get(f);return d||(d=this.a(f),this.b.set(f,d)),d}}t.$sS=D}),define(be[70],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=void 0;function y(u,l,m){const n=P(u,l);if(n!==-1)return u[n]}t.$eb=y;function P(u,l,m=u.length-1){for(let n=m;n>=0;n--){const r=u[n];if(l(r))return n}return-1}t.$fb=P;function i(u,l){const m=U(u,l);return m===-1?void 0:u[m]}t.$gb=i;function U(u,l,m=0,n=u.length){let r=m,$=n;for(;r<$;){const c=Math.floor((r+$)/2);l(u[c])?r=c+1:$=c}return r-1}t.$hb=U;function w(u,l){const m=D(u,l);return m===u.length?void 0:u[m]}t.$ib=w;function D(u,l,m=0,n=u.length){let r=m,$=n;for(;r<$;){const c=Math.floor((r+$)/2);l(u[c])?$=c:r=c+1}return r}t.$jb=D;function h(u,l,m=0,n=u.length){const r=D(u,l,m,n);return r===u.length?-1:r}t.$kb=h;class f{static{this.assertInvariants=!1}constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if(f.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!l(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const m=U(this.e,l,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}t.$lb=f;function d(u,l){if(u.length===0)return;let m=u[0];for(let n=1;n<u.length;n++){const r=u[n];l(r,m)>0&&(m=r)}return m}t.$mb=d;function L(u,l){if(u.length===0)return;let m=u[0];for(let n=1;n<u.length;n++){const r=u[n];l(r,m)>=0&&(m=r)}return m}t.$nb=L;function s(u,l){return d(u,(m,n)=>-l(m,n))}t.$ob=s;function a(u,l){if(u.length===0)return-1;let m=0;for(let n=1;n<u.length;n++){const r=u[n];l(r,u[m])>0&&(m=n)}return m}t.$pb=a;function e(u,l){for(const m of u){const n=l(m);if(n!==void 0)return n}}t.$qb=e}),define(be[71],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M=t.$L=t.$K=t.$J=void 0;function y(w,D){const h=Object.create(null);for(const f of w){const d=D(f);let L=h[d];L||(L=h[d]=[]),L.push(f)}return h}t.$J=y;function P(w,D){const h=[],f=[];for(const d of w)D.has(d)||h.push(d);for(const d of D)w.has(d)||f.push(d);return{removed:h,added:f}}t.$K=P;function i(w,D){const h=[],f=[];for(const[d,L]of w)D.has(d)||h.push(L);for(const[d,L]of D)w.has(d)||f.push(L);return{removed:h,added:f}}t.$L=i;function U(w,D){const h=new Set;for(const f of D)w.has(f)&&h.add(f);return h}t.$M=U}),define(be[72],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ts=t.$Ss=t.$Rs=t.$Qs=void 0;function y(D,h){const f=Math.pow(10,h);return Math.round(D*f)/f}class P{constructor(h,f,d,L=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=y(Math.max(Math.min(1,L),0),3)}static equals(h,f){return h.r===f.r&&h.g===f.g&&h.b===f.b&&h.a===f.a}}t.$Qs=P;class i{constructor(h,f,d,L){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=y(Math.max(Math.min(1,f),0),3),this.l=y(Math.max(Math.min(1,d),0),3),this.a=y(Math.max(Math.min(1,L),0),3)}static equals(h,f){return h.h===f.h&&h.s===f.s&&h.l===f.l&&h.a===f.a}static fromRGBA(h){const f=h.r/255,d=h.g/255,L=h.b/255,s=h.a,a=Math.max(f,d,L),e=Math.min(f,d,L);let u=0,l=0;const m=(e+a)/2,n=a-e;if(n>0){switch(l=Math.min(m<=.5?n/(2*m):n/(2-2*m),1),a){case f:u=(d-L)/n+(d<L?6:0);break;case d:u=(L-f)/n+2;break;case L:u=(f-d)/n+4;break}u*=60,u=Math.round(u)}return new i(u,l,m,s)}static i(h,f,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?h+(f-h)*6*d:d<1/2?f:d<2/3?h+(f-h)*(2/3-d)*6:h}static toRGBA(h){const f=h.h/360,{s:d,l:L,a:s}=h;let a,e,u;if(d===0)a=e=u=L;else{const l=L<.5?L*(1+d):L+d-L*d,m=2*L-l;a=i.i(m,l,f+1/3),e=i.i(m,l,f),u=i.i(m,l,f-1/3)}return new P(Math.round(a*255),Math.round(e*255),Math.round(u*255),s)}}t.$Rs=i;class U{constructor(h,f,d,L){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=y(Math.max(Math.min(1,f),0),3),this.v=y(Math.max(Math.min(1,d),0),3),this.a=y(Math.max(Math.min(1,L),0),3)}static equals(h,f){return h.h===f.h&&h.s===f.s&&h.v===f.v&&h.a===f.a}static fromRGBA(h){const f=h.r/255,d=h.g/255,L=h.b/255,s=Math.max(f,d,L),a=Math.min(f,d,L),e=s-a,u=s===0?0:e/s;let l;return e===0?l=0:s===f?l=((d-L)/e%6+6)%6:s===d?l=(L-f)/e+2:l=(f-d)/e+4,new U(Math.round(l*60),u,s,h.a)}static toRGBA(h){const{h:f,s:d,v:L,a:s}=h,a=L*d,e=a*(1-Math.abs(f/60%2-1)),u=L-a;let[l,m,n]=[0,0,0];return f<60?(l=a,m=e):f<120?(l=e,m=a):f<180?(m=a,n=e):f<240?(m=e,n=a):f<300?(l=e,n=a):f<=360&&(l=a,n=e),l=Math.round((l+u)*255),m=Math.round((m+u)*255),n=Math.round((n+u)*255),new P(l,m,n,s)}}t.$Ss=U;class w{static fromHex(h){return w.Format.CSS.parseHex(h)||w.red}static equals(h,f){return!h&&!f?!0:!h||!f?!1:h.equals(f)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:U.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof P)this.rgba=h;else if(h instanceof i)this.i=h,this.rgba=i.toRGBA(h);else if(h instanceof U)this.j=h,this.rgba=U.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&P.equals(this.rgba,h.rgba)&&i.equals(this.hsla,h.hsla)&&U.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=w.k(this.rgba.r),f=w.k(this.rgba.g),d=w.k(this.rgba.b),L=.2126*h+.7152*f+.0722*d;return y(L,4)}static k(h){const f=h/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(h){const f=this.getRelativeLuminance(),d=h.getRelativeLuminance();return f>d?(f+.05)/(d+.05):(d+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const f=this.getRelativeLuminance(),d=h.getRelativeLuminance();return f>d}isDarkerThan(h){const f=this.getRelativeLuminance(),d=h.getRelativeLuminance();return f<d}lighten(h){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:f,g:d,b:L,a:s}=this.rgba;return new w(new P(f,d,L,s*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const f=h.rgba,d=this.rgba.a,L=f.a,s=d+L*(1-d);if(s<1e-6)return w.transparent;const a=this.rgba.r*d/s+f.r*L*(1-d)/s,e=this.rgba.g*d/s+f.g*L*(1-d)/s,u=this.rgba.b*d/s+f.b*L*(1-d)/s;return new w(new P(a,e,u,s))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:f,g:d,b:L,a:s}=this.rgba;return new w(new P(h.rgba.r-s*(h.rgba.r-f),h.rgba.g-s*(h.rgba.g-d),h.rgba.b-s*(h.rgba.b-L),1))}flatten(...h){const f=h.reduceRight((d,L)=>w.o(L,d));return w.o(this,f)}static o(h,f){const d=1-h.rgba.a;return new w(new P(d*f.rgba.r+h.rgba.a*h.rgba.r,d*f.rgba.g+h.rgba.a*h.rgba.g,d*f.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(h,f,d){if(h.isLighterThan(f))return h;d=d||.5;const L=h.getRelativeLuminance(),s=f.getRelativeLuminance();return d=d*(s-L)/s,h.lighten(d)}static getDarkerColor(h,f,d){if(h.isDarkerThan(f))return h;d=d||.5;const L=h.getRelativeLuminance(),s=f.getRelativeLuminance();return d=d*(L-s)/L,h.darken(d)}static{this.white=new w(new P(255,255,255,1))}static{this.black=new w(new P(0,0,0,1))}static{this.red=new w(new P(255,0,0,1))}static{this.blue=new w(new P(0,0,255,1))}static{this.green=new w(new P(0,255,0,1))}static{this.cyan=new w(new P(0,255,255,1))}static{this.lightgrey=new w(new P(211,211,211,1))}static{this.transparent=new w(new P(0,0,0,0))}}t.$Ts=w,function(D){let h;(function(f){let d;(function(L){function s(o){return o.rgba.a===1?`rgb(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b})`:D.Format.CSS.formatRGBA(o)}L.formatRGB=s;function a(o){return`rgba(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b}, ${+o.rgba.a.toFixed(2)})`}L.formatRGBA=a;function e(o){return o.hsla.a===1?`hsl(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%)`:D.Format.CSS.formatHSLA(o)}L.formatHSL=e;function u(o){return`hsla(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%, ${o.hsla.a.toFixed(2)})`}L.formatHSLA=u;function l(o){const C=o.toString(16);return C.length!==2?"0"+C:C}function m(o){return`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}`}L.formatHex=m;function n(o,C=!1){return C&&o.rgba.a===1?D.Format.CSS.formatHex(o):`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}${l(Math.round(o.rgba.a*255))}`}L.formatHexA=n;function r(o){return o.isOpaque()?D.Format.CSS.formatHex(o):D.Format.CSS.formatRGBA(o)}L.format=r;function $(o){const C=o.length;if(C===0||o.charCodeAt(0)!==35)return null;if(C===7){const z=16*c(o.charCodeAt(1))+c(o.charCodeAt(2)),I=16*c(o.charCodeAt(3))+c(o.charCodeAt(4)),b=16*c(o.charCodeAt(5))+c(o.charCodeAt(6));return new D(new P(z,I,b,1))}if(C===9){const z=16*c(o.charCodeAt(1))+c(o.charCodeAt(2)),I=16*c(o.charCodeAt(3))+c(o.charCodeAt(4)),b=16*c(o.charCodeAt(5))+c(o.charCodeAt(6)),v=16*c(o.charCodeAt(7))+c(o.charCodeAt(8));return new D(new P(z,I,b,v/255))}if(C===4){const z=c(o.charCodeAt(1)),I=c(o.charCodeAt(2)),b=c(o.charCodeAt(3));return new D(new P(16*z+z,16*I+I,16*b+b))}if(C===5){const z=c(o.charCodeAt(1)),I=c(o.charCodeAt(2)),b=c(o.charCodeAt(3)),v=c(o.charCodeAt(4));return new D(new P(16*z+z,16*I+I,16*b+b,(16*v+v)/255))}return null}L.parseHex=$;function c(o){switch(o){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=f.CSS||(f.CSS={}))})(h=D.Format||(D.Format={}))}(w||(t.$Ts=w={}))}),define(be[25],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hh=t.$gh=t.$fh=void 0;function y(w){return(D,h,f)=>{let d=null,L=null;if(typeof f.value=="function"?(d="value",L=f.value):typeof f.get=="function"&&(d="get",L=f.get),!L)throw new Error("not supported");f[d]=w(L,h)}}function P(w,D,h){let f=null,d=null;if(typeof h.value=="function"?(f="value",d=h.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(f="get",d=h.get),!d)throw new Error("not supported");const L=`$memoize$${D}`;h[f]=function(...s){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,s)}),this[L]}}t.$fh=P;function i(w,D,h){return y((f,d)=>{const L=`$debounce$${d}`,s=`$debounce$result$${d}`;return function(...a){this[s]||(this[s]=h?h():void 0),clearTimeout(this[L]),D&&(this[s]=D(this[s],...a),a=[this[s]]),this[L]=setTimeout(()=>{f.apply(this,a),this[s]=h?h():void 0},w)}})}t.$gh=i;function U(w,D,h){return y((f,d)=>{const L=`$throttle$timer$${d}`,s=`$throttle$result$${d}`,a=`$throttle$lastRun$${d}`,e=`$throttle$pending$${d}`;return function(...u){if(this[s]||(this[s]=h?h():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),D&&(this[s]=D(this[s],...u)),this[e])return;const l=this[a]+w;l<=Date.now()?(this[a]=Date.now(),f.apply(this,[this[s]]),this[s]=h?h():void 0):(this[e]=!0,this[L]=setTimeout(()=>{this[e]=!1,this[a]=Date.now(),f.apply(this,[this[s]]),this[s]=h?h():void 0},l-Date.now()))}})}t.$hh=U}),define(be[73],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ss=void 0;class y{constructor(i,U,w,D){this.originalStart=i,this.originalLength=U,this.modifiedStart=w,this.modifiedLength=D}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ss=y}),define(be[6],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.setUnexpectedErrorHandler=t.$W=t.$V=void 0;class y{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?r.isErrorNoTelemetry(o)?new r(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(C=>{C(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}t.$V=y,t.$W=new y;function P(c){t.$W.setUnexpectedErrorHandler(c)}t.setUnexpectedErrorHandler=P;function i(c){if(!c||typeof c!="object")return!1;const o=c;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}t.$Y=i;function U(c){f(c)||t.$W.onUnexpectedError(c)}t.$Z=U;function w(c){f(c)||t.$W.onUnexpectedExternalError(c)}t.$1=w;function D(c){if(c instanceof Error){const{name:o,message:C}=c,z=c.stacktrace||c.stack;return{$isError:!0,name:o,message:C,stack:z,noTelemetry:r.isErrorNoTelemetry(c)}}return c}t.$2=D;const h="Canceled";function f(c){return c instanceof d?!0:c instanceof Error&&c.name===h&&c.message===h}t.$3=f;class d extends Error{constructor(){super(h),this.name=this.message}}t.$4=d;function L(){const c=new Error(h);return c.name=c.message,c}t.$5=L;function s(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}t.$6=s;function a(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}t.$7=a;class e extends TypeError{constructor(o){super(o?`${o} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$8=e;function u(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}t.$9=u;class l extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}t.$0=l;class m extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}t.$$=m;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=n;class r extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof r)return o;const C=new r;return C.message=o.message,C.stack=o.stack,C}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}t.$ab=r;class $ extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}t.$bb=$}),define(be[11],$e([1,0,6,70]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.CompareResult=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.top=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=void 0;function i(T,N=0){return T[T.length-(1+N)]}t.$rb=i;function U(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}t.$sb=U;function w(T,N,O=(_,S)=>_===S){if(T===N)return!0;if(!T||!N||T.length!==N.length)return!1;for(let _=0,S=T.length;_<S;_++)if(!O(T[_],N[_]))return!1;return!0}t.$tb=w;function D(T,N){const O=T.length-1;N<O&&(T[N]=T[O]),T.pop()}t.$ub=D;function h(T,N,O){return f(T.length,_=>O(T[_],N))}t.$vb=h;function f(T,N){let O=0,_=T-1;for(;O<=_;){const S=(O+_)/2|0,R=N(S);if(R<0)O=S+1;else if(R>0)_=S-1;else return S}return-(O+1)}t.$wb=f;function d(T,N,O){if(T=T|0,T>=N.length)throw new TypeError("invalid index");const _=N[Math.floor(N.length*Math.random())],S=[],R=[],A=[];for(const k of N){const H=O(k,_);H<0?S.push(k):H>0?R.push(k):A.push(k)}return T<S.length?d(T,S,O):T<S.length+A.length?A[0]:d(T-(S.length+A.length),R,O)}t.$xb=d;function L(T,N){const O=[];let _;for(const S of T.slice(0).sort(N))!_||N(_[0],S)!==0?(_=[S],O.push(_)):_.push(S);return O}t.$yb=L;function*s(T,N){let O,_;for(const S of T)_!==void 0&&N(_,S)?O.push(S):(O&&(yield O),O=[S]),_=S;O&&(yield O)}t.$zb=s;function a(T,N){for(let O=0;O<=T.length;O++)N(O===0?void 0:T[O-1],O===T.length?void 0:T[O])}t.$Ab=a;function e(T,N){for(let O=0;O<T.length;O++)N(O===0?void 0:T[O-1],T[O],O+1===T.length?void 0:T[O+1])}t.$Bb=e;function u(T,N,O){const _=[];function S(k,H,K){if(H===0&&K.length===0)return;const te=_[_.length-1];te&&te.start+te.deleteCount===k?(te.deleteCount+=H,te.toInsert.push(...K)):_.push({start:k,deleteCount:H,toInsert:K})}let R=0,A=0;for(;;){if(R===T.length){S(R,0,N.slice(A));break}if(A===N.length){S(R,T.length-R,[]);break}const k=T[R],H=N[A],K=O(k,H);K===0?(R+=1,A+=1):K<0?(S(R,1,[]),R+=1):K>0&&(S(R,0,[H]),A+=1)}return _}t.$Cb=u;function l(T,N,O){const _=u(T,N,O),S=[],R=[];for(const A of _)S.push(...T.slice(A.start,A.start+A.deleteCount)),R.push(...A.toInsert);return{removed:S,added:R}}t.$Db=l;function m(T,N,O){if(O===0)return[];const _=T.slice(0,O).sort(N);return r(T,N,_,O,T.length),_}t.top=m;function n(T,N,O,_,S){return O===0?Promise.resolve([]):new Promise((R,A)=>{(async()=>{const k=T.length,H=T.slice(0,O).sort(N);for(let K=O,te=Math.min(O+_,k);K<k;K=te,te=Math.min(te+_,k)){if(K>O&&await new Promise(se=>setTimeout(se)),S&&S.isCancellationRequested)throw new y.$4;r(T,N,H,K,te)}return H})().then(R,A)})}t.$Fb=n;function r(T,N,O,_,S){for(const R=O.length;_<S;_++){const A=T[_];if(N(A,O[R-1])<0){O.pop();const k=(0,P.$jb)(O,H=>N(A,H)<0);O.splice(k,0,A)}}}function $(T){return T.filter(N=>!!N)}t.$Gb=$;function c(T){let N=0;for(let O=0;O<T.length;O++)T[O]&&(T[N]=T[O],N+=1);T.length=N}t.$Hb=c;function o(T,N,O){T.splice(O,0,T.splice(N,1)[0])}t.$Ib=o;function C(T){return!Array.isArray(T)||T.length===0}t.$Jb=C;function z(T){return Array.isArray(T)&&T.length>0}t.$Kb=z;function I(T,N=O=>O){const O=new Set;return T.filter(_=>{const S=N(_);return O.has(S)?!1:(O.add(S),!0)})}t.$Lb=I;function b(T){const N=new Set;return O=>{const _=T(O);return N.has(_)?!1:(N.add(_),!0)}}t.$Mb=b;function v(T,N){return T.length>0?T[0]:N}t.$Nb=v;function B(T,N){return T.length>0?T[T.length-1]:N}t.$Ob=B;function j(T,N,O=(_,S)=>_===S){let _=0;for(let S=0,R=Math.min(T.length,N.length);S<R&&O(T[S],N[S]);S++)_++;return _}t.$Pb=j;function W(T){return[].concat(...T)}t.$Qb=W;function M(T,N){let O=typeof N=="number"?T:0;typeof N=="number"?O=T:(O=0,N=T);const _=[];if(O<=N)for(let S=O;S<N;S++)_.push(S);else for(let S=O;S>N;S--)_.push(S);return _}t.$Rb=M;function F(T,N,O){return T.reduce((_,S)=>(_[N(S)]=O?O(S):S,_),Object.create(null))}t.$Sb=F;function J(T,N){return T.push(N),()=>ee(T,N)}t.$Tb=J;function ee(T,N){const O=T.indexOf(N);if(O>-1)return T.splice(O,1),N}t.$Ub=ee;function ne(T,N,O){const _=T.slice(0,N),S=T.slice(N);return _.concat(O,S)}t.$Vb=ne;function ue(T,N){let O;if(typeof N=="number"){let _=N;O=()=>{const S=Math.sin(_++)*179426549;return S-Math.floor(S)}}else O=Math.random;for(let _=T.length-1;_>0;_-=1){const S=Math.floor(O()*(_+1)),R=T[_];T[_]=T[S],T[S]=R}}t.$Wb=ue;function le(T,N){const O=T.indexOf(N);O>-1&&(T.splice(O,1),T.unshift(N))}t.$Xb=le;function oe(T,N){const O=T.indexOf(N);O>-1&&(T.splice(O,1),T.push(N))}t.$Yb=oe;function me(T,N){for(const O of N)T.push(O)}t.$Zb=me;function Se(T,N){return Array.isArray(T)?T.map(N):N(T)}t.$1b=Se;function Le(T){return Array.isArray(T)?T:[T]}t.$2b=Le;function Ne(T){return T[Math.floor(Math.random()*T.length)]}t.$3b=Ne;function de(T,N,O){const _=fe(T,N),S=T.length,R=O.length;T.length=S+R;for(let A=S-1;A>=_;A--)T[A+R]=T[A];for(let A=0;A<R;A++)T[A+_]=O[A]}t.$4b=de;function ie(T,N,O,_){const S=fe(T,N);let R=T.splice(S,O);return R===void 0&&(R=[]),de(T,S,_),R}t.$5b=ie;function fe(T,N){return N<0?Math.max(N+T.length,0):Math.min(N,T.length)}var X;(function(T){function N(R){return R<0}T.isLessThan=N;function O(R){return R<=0}T.isLessThanOrEqual=O;function _(R){return R>0}T.isGreaterThan=_;function S(R){return R===0}T.isNeitherLessOrGreaterThan=S,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(X||(t.CompareResult=X={}));function q(T,N){return(O,_)=>N(T(O),T(_))}t.$6b=q;function G(...T){return(N,O)=>{for(const _ of T){const S=_(N,O);if(!X.isNeitherLessOrGreaterThan(S))return S}return X.neitherLessOrGreaterThan}}t.$7b=G;const E=(T,N)=>T-N;t.$8b=E;const x=(T,N)=>(0,t.$8b)(T?1:0,N?1:0);t.$9b=x;function g(T){return(N,O)=>-T(N,O)}t.$0b=g;class p{constructor(N){this.g=N,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(N){let O=this.c;for(;O<this.g.length&&N(this.g[O]);)O++;const _=O===this.c?null:this.g.slice(this.c,O);return this.c=O,_}takeFromEndWhile(N){let O=this.d;for(;O>=0&&N(this.g[O]);)O--;const _=O===this.d?null:this.g.slice(O+1,this.d+1);return this.d=O,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const N=this.g[this.c];return this.c++,N}removeLast(){const N=this.g[this.d];return this.d--,N}takeCount(N){const O=this.g.slice(this.c,this.c+N);return this.c+=N,O}}t.$$b=p;class V{static{this.empty=new V(N=>{})}constructor(N){this.iterate=N}forEach(N){this.iterate(O=>(N(O),!0))}toArray(){const N=[];return this.iterate(O=>(N.push(O),!0)),N}filter(N){return new V(O=>this.iterate(_=>N(_)?O(_):!0))}map(N){return new V(O=>this.iterate(_=>O(N(_))))}some(N){let O=!1;return this.iterate(_=>(O=N(_),!O)),O}findFirst(N){let O;return this.iterate(_=>N(_)?(O=_,!1):!0),O}findLast(N){let O;return this.iterate(_=>(N(_)&&(O=_),!0)),O}findLastMaxBy(N){let O,_=!0;return this.iterate(S=>((_||X.isGreaterThan(N(S,O)))&&(_=!1,O=S),!0)),O}}t.$_b=V}),define(be[74],$e([1,0,6]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=t.$5c=t.$4c=t.$3c=t.ok=void 0;function P(h,f){if(!h)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}t.ok=P;function i(h,f="Unreachable"){throw new Error(f)}t.$3c=i;function U(h){if(!h)throw new y.$bb("Assertion Failed")}t.$4c=U;function w(h){if(!h()){debugger;h(),(0,y.$Z)(new y.$bb("Assertion Failed"))}}t.$5c=w;function D(h,f){let d=0;for(;d<h.length-1;){const L=h[d],s=h[d+1];if(!f(L,s))return!1;d++}return!0}t.$6c=D}),define(be[42],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function y(P){const i=this;let U=!1,w;return function(){return U||(U=!0,w=P.apply(i,arguments)),w}}t.$cb=y}),define(be[75],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hM=t.$gM=void 0;class y{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$gM=y,t.$hM=new y("id#")}),define(be[26],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var y;(function(P){function i(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}P.is=i;const U=Object.freeze([]);function w(){return U}P.empty=w;function*D(c){yield c}P.single=D;function h(c){return i(c)?c:D(c)}P.wrap=h;function f(c){return c||U}P.from=f;function*d(c){for(let o=c.length-1;o>=0;o--)yield c[o]}P.reverse=d;function L(c){return!c||c[Symbol.iterator]().next().done===!0}P.isEmpty=L;function s(c){return c[Symbol.iterator]().next().value}P.first=s;function a(c,o){for(const C of c)if(o(C))return!0;return!1}P.some=a;function e(c,o){for(const C of c)if(o(C))return C}P.find=e;function*u(c,o){for(const C of c)o(C)&&(yield C)}P.filter=u;function*l(c,o){let C=0;for(const z of c)yield o(z,C++)}P.map=l;function*m(...c){for(const o of c)for(const C of o)yield C}P.concat=m;function n(c,o,C){let z=C;for(const I of c)z=o(z,I);return z}P.reduce=n;function*r(c,o,C=c.length){for(o<0&&(o+=c.length),C<0?C+=c.length:C>c.length&&(C=c.length);o<C;o++)yield c[o]}P.slice=r;function $(c,o=Number.POSITIVE_INFINITY){const C=[];if(o===0)return[C,c];const z=c[Symbol.iterator]();for(let I=0;I<o;I++){const b=z.next();if(b.done)return[C,P.empty()];C.push(b.value)}return[C,{[Symbol.iterator](){return z}}]}P.consume=$})(y||(t.Iterable=y={}))}),define(be[43],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cq=t.KeyMod=t.KeyCodeUtils=t.$Bq=t.$Aq=t.$zq=t.$yq=t.$xq=t.ScanCode=t.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(y||(t.KeyCode=y={}));var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(P||(t.ScanCode=P={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,l){this._keyCodeToStr[u]=l,this._strToKeyCode[l.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const U=new i,w=new i,D=new i;t.$xq=new Array(230),t.$yq={};const h=[],f=Object.create(null),d=Object.create(null);t.$zq={lowerCaseToEnum:e=>d[e]||0,toEnum:e=>f[e]||0,toString:e=>h[e]||"None"},t.$Aq=[],t.$Bq=[];for(let e=0;e<=193;e++)t.$Aq[e]=-1;for(let e=0;e<=132;e++)t.$Bq[e]=-1;(function(){const e="",u=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],l=[],m=[];for(const n of u){const[r,$,c,o,C,z,I,b,v]=n;if(m[$]||(m[$]=!0,h[$]=c,f[c]=$,d[c.toLowerCase()]=$,r&&(t.$Aq[$]=o,o!==0&&o!==3&&o!==5&&o!==4&&o!==6&&o!==57&&(t.$Bq[o]=$))),!l[o]){if(l[o]=!0,!C)throw new Error(`String representation missing for key code ${o} around scan code ${c}`);U.define(o,C),w.define(o,b||C),D.define(o,v||b||C)}z&&(t.$xq[z]=o),I&&(t.$yq[I]=o)}t.$Bq[3]=46})();var L;(function(e){function u(c){return U.keyCodeToStr(c)}e.toString=u;function l(c){return U.strToKeyCode(c)}e.fromString=l;function m(c){return w.keyCodeToStr(c)}e.toUserSettingsUS=m;function n(c){return D.keyCodeToStr(c)}e.toUserSettingsGeneral=n;function r(c){return w.strToKeyCode(c)||D.strToKeyCode(c)}e.fromUserSettings=r;function $(c){if(c>=98&&c<=113)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr(c)}e.toElectronAccelerator=$})(L||(t.KeyCodeUtils=L={}));var s;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(s||(t.KeyMod=s={}));function a(e,u){const l=(u&65535)<<16>>>0;return(e|l)>>>0}t.$Cq=a}),define(be[76],$e([1,0,6]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jq=t.$Iq=t.$Hq=t.$Gq=t.$Fq=t.$Eq=t.$Dq=void 0;var P;(function(L){L[L.CtrlCmd=2048]="CtrlCmd",L[L.Shift=1024]="Shift",L[L.Alt=512]="Alt",L[L.WinCtrl=256]="WinCtrl",L[L.KeyCode=255]="KeyCode"})(P||(P={}));function i(L,s){if(typeof L=="number"){if(L===0)return null;const a=(L&65535)>>>0,e=(L&4294901760)>>>16;return e!==0?new h([U(a,s),U(e,s)]):new h([U(a,s)])}else{const a=[];for(let e=0;e<L.length;e++)a.push(U(L[e],s));return new h(a)}}t.$Dq=i;function U(L,s){const a=!!(L&2048),e=!!(L&256),u=s===2?e:a,l=!!(L&1024),m=!!(L&512),n=s===2?a:e,r=L&255;return new w(u,l,m,n,r)}t.$Eq=U;class w{constructor(s,a,e,u,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=u,this.keyCode=l}equals(s){return s instanceof w&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.keyCode===s.keyCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",u=this.metaKey?"1":"0";return`K${s}${a}${e}${u}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new h([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Fq=w;class D{constructor(s,a,e,u,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=u,this.scanCode=l}equals(s){return s instanceof D&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.scanCode===s.scanCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",u=this.metaKey?"1":"0";return`S${s}${a}${e}${u}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Gq=D;class h{constructor(s){if(s.length===0)throw(0,y.$6)("chords");this.chords=s}getHashCode(){let s="";for(let a=0,e=this.chords.length;a<e;a++)a!==0&&(s+=";"),s+=this.chords[a].getHashCode();return s}equals(s){if(s===null||this.chords.length!==s.chords.length)return!1;for(let a=0;a<this.chords.length;a++)if(!this.chords[a].equals(s.chords[a]))return!1;return!0}}t.$Hq=h;class f{constructor(s,a,e,u,l,m){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=u,this.keyLabel=l,this.keyAriaLabel=m}}t.$Iq=f;class d{}t.$Jq=d}),define(be[27],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=void 0;class y{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$U=y}),define(be[44],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=void 0;class y{static{this.Undefined=new y(void 0)}constructor(U){this.element=U,this.next=y.Undefined,this.prev=y.Undefined}}class P{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let U=this.a;for(;U!==y.Undefined;){const w=U.next;U.prev=y.Undefined,U.next=y.Undefined,U=w}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,w){const D=new y(U);if(this.a===y.Undefined)this.a=D,this.b=D;else if(w){const f=this.b;this.b=D,D.prev=f,f.next=D}else{const f=this.a;this.a=D,D.next=f,f.prev=D}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(D))}}shift(){if(this.a!==y.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==y.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==y.Undefined&&U.next!==y.Undefined){const w=U.prev;w.next=U.next,U.next.prev=w}else U.prev===y.Undefined&&U.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):U.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):U.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==y.Undefined;)yield U.element,U=U.next}}t.$1c=P}),define(be[31],$e([1,0]),function(re,t){"use strict";var y,P,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.Touch=t.$Ac=t.$zc=t.$yc=t.$xc=t.$wc=void 0;function U(n,r,$){let c=n.get(r);return c===void 0&&(c=$,n.set(r,c)),c}t.$wc=U;function w(n){const r=[];return n.forEach(($,c)=>{r.push(`${c} => ${$}`)}),`Map(${n.size}) {${r.join(", ")}}`}t.$xc=w;function D(n){const r=[];return n.forEach($=>{r.push($)}),`Set(${n.size}) {${r.join(", ")}}`}t.$yc=D;class h{constructor(r,$){this.uri=r,this.value=$}}function f(n){return Array.isArray(n)}class d{static{this.a=r=>r.toString()}constructor(r,$){if(this[y]="ResourceMap",r instanceof d)this.b=new Map(r.b),this.c=$??d.a;else if(f(r)){this.b=new Map,this.c=$??d.a;for(const[c,o]of r)this.set(c,o)}else this.b=new Map,this.c=r??d.a}set(r,$){return this.b.set(this.c(r),new h(r,$)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,$){typeof $<"u"&&(r=r.bind($));for(const[c,o]of this.b)r(o.value,o.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}t.$zc=d;class L{constructor(r,$){this[P]="ResourceSet",!r||typeof r=="function"?this.a=new d(r):(this.a=new d($),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,$){this.a.forEach((c,o)=>r.call($,o,o,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ac=L;var s;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(s||(t.Touch=s={}));class a{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,$=0){const c=this.a.get(r);if(c)return $!==0&&this.j(c,$),c.value}set(r,$,c=0){let o=this.a.get(r);if(o)o.value=$,c!==0&&this.j(o,c);else{switch(o={key:r,value:$,next:void 0,previous:void 0},c){case 0:this.h(o);break;case 1:this.g(o);break;case 2:this.h(o);break;default:this.h(o);break}this.a.set(r,o),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const $=this.a.get(r);if($)return this.a.delete(r),this.i($),this.d--,$.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,$){const c=this.e;let o=this.b;for(;o;){if($?r.bind($)(o.value,o.key,this):r(o.value,o.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const r=this,$=this.e;let c=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==$)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:c.key,done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return o}values(){const r=this,$=this.e;let c=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==$)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:c.value,done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return o}entries(){const r=this,$=this.e;let c=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==$)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:[c.key,c.value],done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return o}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let $=this.b,c=this.size;for(;$&&c>r;)this.a.delete($.key),$=$.next,c--;this.b=$,this.d=c,$&&($.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const $=r.next,c=r.previous;if(!$||!c)throw new Error("Invalid list");$.previous=c,c.next=$}r.next=void 0,r.previous=void 0,this.e++}j(r,$){if(!this.b||!this.c)throw new Error("Invalid list");if(!($!==1&&$!==2)){if($===1){if(r===this.b)return;const c=r.next,o=r.previous;r===this.c?(o.next=void 0,this.c=o):(c.previous=o,o.next=c),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if($===2){if(r===this.c)return;const c=r.next,o=r.previous;r===this.b?(c.previous=void 0,this.b=c):(c.previous=o,o.next=c),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach(($,c)=>{r.push([c,$])}),r}fromJSON(r){this.clear();for(const[$,c]of r)this.set($,c)}}t.$Bc=a;class e extends a{constructor(r,$=1){super(),this.k=r,this.l=Math.min(Math.max(0,$),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,$=2){return super.get(r,$)}peek(r){return super.get(r,0)}set(r,$){return super.set(r,$,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Cc=e;class u{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let $=this.a.get(r)||0;return $===0?!1:($--,$===0?this.a.delete(r):this.a.set(r,$),!0)}has(r){return this.a.has(r)}}t.$Dc=u;class l{constructor(r){if(this.a=new Map,this.b=new Map,r)for(const[$,c]of r)this.set($,c)}clear(){this.a.clear(),this.b.clear()}set(r,$){this.a.set(r,$),this.b.set($,r)}get(r){return this.a.get(r)}getKey(r){return this.b.get(r)}delete(r){const $=this.a.get(r);return $===void 0?!1:(this.a.delete(r),this.b.delete($),!0)}forEach(r,$){this.a.forEach((c,o)=>{r.call($,c,o,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Ec=l;class m{constructor(){this.a=new Map}add(r,$){let c=this.a.get(r);c||(c=new Set,this.a.set(r,c)),c.add($)}delete(r,$){const c=this.a.get(r);c&&(c.delete($),c.size===0&&this.a.delete(r))}forEach(r,$){const c=this.a.get(r);c&&c.forEach($)}get(r){const $=this.a.get(r);return $||new Set}}t.$Fc=m}),define(be[2],$e([1,0,11,71,31,42,26]),function(re,t,y,P,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=void 0;const D=!1;let h=null;class f{constructor(){this.b=new Map}static{this.a=0}c(F){let J=this.b.get(F);return J||(J={parent:null,source:null,isSingleton:!1,value:F,idx:f.a++},this.b.set(F,J)),J}trackDisposable(F){const J=this.c(F);J.source||(J.source=new Error().stack)}setParent(F,J){const ee=this.c(F);ee.parent=J}markAsDisposed(F){this.b.delete(F)}markAsSingleton(F){this.c(F).isSingleton=!0}f(F,J){const ee=J.get(F);if(ee)return ee;const ne=F.parent?this.f(this.c(F.parent),J):F;return J.set(F,ne),ne}getTrackedDisposables(){const F=new Map;return[...this.b.entries()].filter(([,ee])=>ee.source!==null&&!this.f(ee,F).isSingleton).flatMap(([ee])=>ee)}computeLeakingDisposables(F=10,J){let ee;if(J)ee=J;else{const me=new Map,Se=[...this.b.values()].filter(Ne=>Ne.source!==null&&!this.f(Ne,me).isSingleton);if(Se.length===0)return;const Le=new Set(Se.map(Ne=>Ne.value));if(ee=Se.filter(Ne=>!(Ne.parent&&Le.has(Ne.parent))),ee.length===0)throw new Error("There are cyclic diposable chains!")}if(!ee)return;function ne(me){function Se(Ne,de){for(;Ne.length>0&&de.some(ie=>typeof ie=="string"?ie===Ne[0]:Ne[0].match(ie));)Ne.shift()}const Le=me.source.split(`
`).map(Ne=>Ne.trim().replace("at ","")).filter(Ne=>Ne!=="");return Se(Le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Le.reverse()}const ue=new i.$Fc;for(const me of ee){const Se=ne(me);for(let Le=0;Le<=Se.length;Le++)ue.add(Se.slice(0,Le).join(`
`),me)}ee.sort((0,y.$6b)(me=>me.idx,y.$8b));let le="",oe=0;for(const me of ee.slice(0,F)){oe++;const Se=ne(me),Le=[];for(let Ne=0;Ne<Se.length;Ne++){let de=Se[Ne];de=`(shared with ${ue.get(Se.slice(0,Ne+1).join(`
`)).size}/${ee.length} leaks) at ${de}`;const fe=ue.get(Se.slice(0,Ne).join(`
`)),X=(0,P.$J)([...fe].map(q=>ne(q)[Ne]),q=>q);delete X[Se[Ne]];for(const[q,G]of Object.entries(X))Le.unshift(`    - stacktraces of ${G.length} other leaks continue with ${q}`);Le.unshift(de)}le+=`


==================== Leaking disposable ${oe}/${ee.length}: ${me.value.constructor.name} ====================
${Le.join(`
`)}
============================================================

`}return ee.length>F&&(le+=`


... and ${ee.length-F} more leaking disposables

`),{leaks:ee,details:le}}}t.$Gc=f;function d(M){h=M}if(t.$Hc=d,D){const M="__is_disposable_tracked__";d(new class{trackDisposable(F){const J=new Error("Potentially leaked disposable").stack;setTimeout(()=>{F[M]||console.log(J)},3e3)}setParent(F,J){if(F&&F!==o.None)try{F[M]=!0}catch{}}markAsDisposed(F){if(F&&F!==o.None)try{F[M]=!0}catch{}}markAsSingleton(F){}})}function L(M){return h?.trackDisposable(M),M}t.$Ic=L;function s(M){h?.markAsDisposed(M)}t.$Jc=s;function a(M,F){h?.setParent(M,F)}function e(M,F){if(h)for(const J of M)h.setParent(J,F)}function u(M){return h?.markAsSingleton(M),M}t.$Kc=u;function l(M){return typeof M.dispose=="function"&&M.dispose.length===0}t.$Lc=l;function m(M){if(w.Iterable.is(M)){const F=[];for(const J of M)if(J)try{J.dispose()}catch(ee){F.push(ee)}if(F.length===1)throw F[0];if(F.length>1)throw new AggregateError(F,"Encountered errors while disposing of store");return Array.isArray(M)?[]:M}else if(M)return M.dispose(),M}t.$Mc=m;function n(M){for(const F of M)l(F)&&F.dispose();return[]}t.$Nc=n;function r(...M){const F=$(()=>m(M));return e(M,F),F}t.$Oc=r;function $(M){const F=L({dispose:(0,U.$cb)(()=>{s(F),M()})});return F}t.$Pc=$;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,L(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(F){if(!F)return F;if(F===this)throw new Error("Cannot register a disposable on itself!");return a(F,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(F),F}delete(F){if(F){if(F===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(F),F.dispose()}}deleteAndLeak(F){F&&this.f.has(F)&&(this.f.delete(F),a(F,null))}}t.$Qc=c;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,L(this),a(this.q,this)}dispose(){s(this),this.q.dispose()}B(F){if(F===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(F)}}t.$Rc=o;class C{constructor(){this.b=!1,L(this)}get value(){return this.b?void 0:this.a}set value(F){this.b||F===this.a||(this.a?.dispose(),F&&a(F,this),this.a=F)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const F=this.a;return this.a=void 0,F&&a(F,null),F}}t.$Sc=C;class z{constructor(F){this.b=F,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Tc=z;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,L(this)}set(F){let J=F;return this.unset=()=>J=void 0,this.isset=()=>J!==void 0,this.dispose=()=>{J&&(J(),J=void 0,s(this))},this}}t.$Uc=I;class b{constructor(){this.a=new Map}acquire(F,...J){let ee=this.a.get(F);ee||(ee={counter:0,object:this.b(F,...J)},this.a.set(F,ee));const{object:ne}=ee,ue=(0,U.$cb)(()=>{--ee.counter===0&&(this.c(F,ee.object),this.a.delete(F))});return ee.counter++,{object:ne,dispose:ue}}}t.$Vc=b;class v{constructor(F){this.a=F}async acquire(F,...J){const ee=this.a.acquire(F,...J);try{return{object:await ee.object,dispose:()=>ee.dispose()}}catch(ne){throw ee.dispose(),ne}}}t.$Wc=v;class B{constructor(F){this.object=F}dispose(){}}t.$Xc=B;function j(M){const F=new c;try{M(F)}finally{F.dispose()}}t.$Yc=j;class W{constructor(){this.a=new Map,this.b=!1,L(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(F){return this.a.has(F)}get size(){return this.a.size}get(F){return this.a.get(F)}set(F,J,ee=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ee||this.a.get(F)?.dispose(),this.a.set(F,J)}deleteAndDispose(F){this.a.get(F)?.dispose(),this.a.delete(F)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$Zc=W}),function(re,t){typeof define=="function"&&define.amd?define(be[77],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(re=typeof globalThis<"u"?globalThis:re||self,t(re.marked={}))}(this,function(re){"use strict";function t(N,O){for(var _=0;_<O.length;_++){var S=O[_];S.enumerable=S.enumerable||!1,S.configurable=!0,"value"in S&&(S.writable=!0),Object.defineProperty(N,S.key,S)}}function y(N,O,_){return O&&t(N.prototype,O),_&&t(N,_),Object.defineProperty(N,"prototype",{writable:!1}),N}function P(N,O){if(N){if(typeof N=="string")return i(N,O);var _=Object.prototype.toString.call(N).slice(8,-1);if(_==="Object"&&N.constructor&&(_=N.constructor.name),_==="Map"||_==="Set")return Array.from(N);if(_==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(_))return i(N,O)}}function i(N,O){(O==null||O>N.length)&&(O=N.length);for(var _=0,S=new Array(O);_<O;_++)S[_]=N[_];return S}function U(N,O){var _=typeof Symbol<"u"&&N[Symbol.iterator]||N["@@iterator"];if(_)return(_=_.call(N)).next.bind(_);if(Array.isArray(N)||(_=P(N))||O&&N&&typeof N.length=="number"){_&&(N=_);var S=0;return function(){return S>=N.length?{done:!0}:{done:!1,value:N[S++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function w(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=w();function D(N){re.defaults=N}var h=/[&<>"']/,f=/[&<>"']/g,d=/[<>"']|&(?!#?\w+;)/,L=/[<>"']|&(?!#?\w+;)/g,s={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(O){return s[O]};function e(N,O){if(O){if(h.test(N))return N.replace(f,a)}else if(d.test(N))return N.replace(L,a);return N}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(N){return N.replace(u,function(O,_){return _=_.toLowerCase(),_==="colon"?":":_.charAt(0)==="#"?_.charAt(1)==="x"?String.fromCharCode(parseInt(_.substring(2),16)):String.fromCharCode(+_.substring(1)):""})}var m=/(^|[^\[])\^/g;function n(N,O){N=typeof N=="string"?N:N.source,O=O||"";var _={replace:function(R,A){return A=A.source||A,A=A.replace(m,"$1"),N=N.replace(R,A),_},getRegex:function(){return new RegExp(N,O)}};return _}var r=/[^\w:]/g,$=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(N,O,_){if(N){var S;try{S=decodeURIComponent(l(_)).replace(r,"").toLowerCase()}catch{return null}if(S.indexOf("javascript:")===0||S.indexOf("vbscript:")===0||S.indexOf("data:")===0)return null}O&&!$.test(_)&&(_=b(O,_));try{_=encodeURI(_).replace(/%25/g,"%")}catch{return null}return _}var o={},C=/^[^:]+:\/*[^/]*$/,z=/^([^:]+:)[\s\S]*$/,I=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(N,O){o[" "+N]||(C.test(N)?o[" "+N]=N+"/":o[" "+N]=W(N,"/",!0)),N=o[" "+N];var _=N.indexOf(":")===-1;return O.substring(0,2)==="//"?_?O:N.replace(z,"$1")+O:O.charAt(0)==="/"?_?O:N.replace(I,"$1")+O:N+O}var v={exec:function(){}};function B(N){for(var O=1,_,S;O<arguments.length;O++){_=arguments[O];for(S in _)Object.prototype.hasOwnProperty.call(_,S)&&(N[S]=_[S])}return N}function j(N,O){var _=N.replace(/\|/g,function(A,k,H){for(var K=!1,te=k;--te>=0&&H[te]==="\\";)K=!K;return K?"|":" |"}),S=_.split(/ \|/),R=0;if(S[0].trim()||S.shift(),S.length>0&&!S[S.length-1].trim()&&S.pop(),S.length>O)S.splice(O);else for(;S.length<O;)S.push("");for(;R<S.length;R++)S[R]=S[R].trim().replace(/\\\|/g,"|");return S}function W(N,O,_){var S=N.length;if(S===0)return"";for(var R=0;R<S;){var A=N.charAt(S-R-1);if(A===O&&!_)R++;else if(A!==O&&_)R++;else break}return N.slice(0,S-R)}function M(N,O){if(N.indexOf(O[1])===-1)return-1;for(var _=N.length,S=0,R=0;R<_;R++)if(N[R]==="\\")R++;else if(N[R]===O[0])S++;else if(N[R]===O[1]&&(S--,S<0))return R;return-1}function F(N){N&&N.sanitize&&!N.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function J(N,O){if(O<1)return"";for(var _="";O>1;)O&1&&(_+=N),O>>=1,N+=N;return _+N}function ee(N,O,_,S){var R=O.href,A=O.title?e(O.title):null,k=N[1].replace(/\\([\[\]])/g,"$1");if(N[0].charAt(0)!=="!"){S.state.inLink=!0;var H={type:"link",raw:_,href:R,title:A,text:k,tokens:S.inlineTokens(k)};return S.state.inLink=!1,H}return{type:"image",raw:_,href:R,title:A,text:e(k)}}function ne(N,O){var _=N.match(/^(\s+)(?:```)/);if(_===null)return O;var S=_[1];return O.split(`
`).map(function(R){var A=R.match(/^\s+/);if(A===null)return R;var k=A[0];return k.length>=S.length?R.slice(S.length):R}).join(`
`)}var ue=function(){function N(_){this.options=_||re.defaults}var O=N.prototype;return O.space=function(S){var R=this.rules.block.newline.exec(S);if(R&&R[0].length>0)return{type:"space",raw:R[0]}},O.code=function(S){var R=this.rules.block.code.exec(S);if(R){var A=R[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:R[0],codeBlockStyle:"indented",text:this.options.pedantic?A:W(A,`
`)}}},O.fences=function(S){var R=this.rules.block.fences.exec(S);if(R){var A=R[0],k=ne(A,R[3]||"");return{type:"code",raw:A,lang:R[2]?R[2].trim():R[2],text:k}}},O.heading=function(S){var R=this.rules.block.heading.exec(S);if(R){var A=R[2].trim();if(/#$/.test(A)){var k=W(A,"#");(this.options.pedantic||!k||/ $/.test(k))&&(A=k.trim())}return{type:"heading",raw:R[0],depth:R[1].length,text:A,tokens:this.lexer.inline(A)}}},O.hr=function(S){var R=this.rules.block.hr.exec(S);if(R)return{type:"hr",raw:R[0]}},O.blockquote=function(S){var R=this.rules.block.blockquote.exec(S);if(R){var A=R[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:R[0],tokens:this.lexer.blockTokens(A,[]),text:A}}},O.list=function(S){var R=this.rules.block.list.exec(S);if(R){var A,k,H,K,te,se,ge,we,Fe,Ae,ve,Me,Oe=R[1].trim(),_e=Oe.length>1,je={type:"list",raw:"",ordered:_e,start:_e?+Oe.slice(0,-1):"",loose:!1,items:[]};Oe=_e?"\\d{1,9}\\"+Oe.slice(-1):"\\"+Oe,this.options.pedantic&&(Oe=_e?Oe:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+Oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");S&&(Me=!1,!(!(R=Ie.exec(S))||this.rules.block.hr.test(S)));){if(A=R[0],S=S.substring(A.length),we=R[2].split(`
`,1)[0],Fe=S.split(`
`,1)[0],this.options.pedantic?(K=2,ve=we.trimLeft()):(K=R[2].search(/[^ ]/),K=K>4?1:K,ve=we.slice(K),K+=R[1].length),se=!1,!we&&/^ *$/.test(Fe)&&(A+=Fe+`
`,S=S.substring(Fe.length+1),Me=!0),!Me)for(var Ge=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Z=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ae=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),pe=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");S&&(Ae=S.split(`
`,1)[0],we=Ae,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ae.test(we)||pe.test(we)||Ge.test(we)||Z.test(S)));){if(we.search(/[^ ]/)>=K||!we.trim())ve+=`
`+we.slice(K);else if(!se)ve+=`
`+we;else break;!se&&!we.trim()&&(se=!0),A+=Ae+`
`,S=S.substring(Ae.length+1)}je.loose||(ge?je.loose=!0:/\n *\n *$/.test(A)&&(ge=!0)),this.options.gfm&&(k=/^\[[ xX]\] /.exec(ve),k&&(H=k[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:A,task:!!k,checked:H,loose:!1,text:ve}),je.raw+=A}je.items[je.items.length-1].raw=A.trimRight(),je.items[je.items.length-1].text=ve.trimRight(),je.raw=je.raw.trimRight();var De=je.items.length;for(te=0;te<De;te++){this.lexer.state.top=!1,je.items[te].tokens=this.lexer.blockTokens(je.items[te].text,[]);var Ce=je.items[te].tokens.filter(function(ze){return ze.type==="space"}),Re=Ce.every(function(ze){for(var Ye=ze.raw.split(""),Ke=0,Ve=U(Ye),We;!(We=Ve()).done;){var et=We.value;if(et===`
`&&(Ke+=1),Ke>1)return!0}return!1});!je.loose&&Ce.length&&Re&&(je.loose=!0,je.items[te].loose=!0)}return je}},O.html=function(S){var R=this.rules.block.html.exec(S);if(R){var A={type:"html",raw:R[0],pre:!this.options.sanitizer&&(R[1]==="pre"||R[1]==="script"||R[1]==="style"),text:R[0]};if(this.options.sanitize){var k=this.options.sanitizer?this.options.sanitizer(R[0]):e(R[0]);A.type="paragraph",A.text=k,A.tokens=this.lexer.inline(k)}return A}},O.def=function(S){var R=this.rules.block.def.exec(S);if(R){R[3]&&(R[3]=R[3].substring(1,R[3].length-1));var A=R[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:A,raw:R[0],href:R[2],title:R[3]}}},O.table=function(S){var R=this.rules.block.table.exec(S);if(R){var A={type:"table",header:j(R[1]).map(function(ge){return{text:ge}}),align:R[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:R[3]&&R[3].trim()?R[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(A.header.length===A.align.length){A.raw=R[0];var k=A.align.length,H,K,te,se;for(H=0;H<k;H++)/^ *-+: *$/.test(A.align[H])?A.align[H]="right":/^ *:-+: *$/.test(A.align[H])?A.align[H]="center":/^ *:-+ *$/.test(A.align[H])?A.align[H]="left":A.align[H]=null;for(k=A.rows.length,H=0;H<k;H++)A.rows[H]=j(A.rows[H],A.header.length).map(function(ge){return{text:ge}});for(k=A.header.length,K=0;K<k;K++)A.header[K].tokens=this.lexer.inline(A.header[K].text);for(k=A.rows.length,K=0;K<k;K++)for(se=A.rows[K],te=0;te<se.length;te++)se[te].tokens=this.lexer.inline(se[te].text);return A}}},O.lheading=function(S){var R=this.rules.block.lheading.exec(S);if(R)return{type:"heading",raw:R[0],depth:R[2].charAt(0)==="="?1:2,text:R[1],tokens:this.lexer.inline(R[1])}},O.paragraph=function(S){var R=this.rules.block.paragraph.exec(S);if(R){var A=R[1].charAt(R[1].length-1)===`
`?R[1].slice(0,-1):R[1];return{type:"paragraph",raw:R[0],text:A,tokens:this.lexer.inline(A)}}},O.text=function(S){var R=this.rules.block.text.exec(S);if(R)return{type:"text",raw:R[0],text:R[0],tokens:this.lexer.inline(R[0])}},O.escape=function(S){var R=this.rules.inline.escape.exec(S);if(R)return{type:"escape",raw:R[0],text:e(R[1])}},O.tag=function(S){var R=this.rules.inline.tag.exec(S);if(R)return!this.lexer.state.inLink&&/^<a /i.test(R[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(R[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(R[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(R[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:R[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(R[0]):e(R[0]):R[0]}},O.link=function(S){var R=this.rules.inline.link.exec(S);if(R){var A=R[2].trim();if(!this.options.pedantic&&/^</.test(A)){if(!/>$/.test(A))return;var k=W(A.slice(0,-1),"\\");if((A.length-k.length)%2===0)return}else{var H=M(R[2],"()");if(H>-1){var K=R[0].indexOf("!")===0?5:4,te=K+R[1].length+H;R[2]=R[2].substring(0,H),R[0]=R[0].substring(0,te).trim(),R[3]=""}}var se=R[2],ge="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(se);we&&(se=we[1],ge=we[3])}else ge=R[3]?R[3].slice(1,-1):"";return se=se.trim(),/^</.test(se)&&(this.options.pedantic&&!/>$/.test(A)?se=se.slice(1):se=se.slice(1,-1)),ee(R,{href:se&&se.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},R[0],this.lexer)}},O.reflink=function(S,R){var A;if((A=this.rules.inline.reflink.exec(S))||(A=this.rules.inline.nolink.exec(S))){var k=(A[2]||A[1]).replace(/\s+/g," ");if(k=R[k.toLowerCase()],!k||!k.href){var H=A[0].charAt(0);return{type:"text",raw:H,text:H}}return ee(A,k,A[0],this.lexer)}},O.emStrong=function(S,R,A){A===void 0&&(A="");var k=this.rules.inline.emStrong.lDelim.exec(S);if(k&&!(k[3]&&A.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=k[1]||k[2]||"";if(!H||H&&(A===""||this.rules.inline.punctuation.exec(A))){var K=k[0].length-1,te,se,ge=K,we=0,Fe=k[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Fe.lastIndex=0,R=R.slice(-1*S.length+K);(k=Fe.exec(R))!=null;)if(te=k[1]||k[2]||k[3]||k[4]||k[5]||k[6],!!te){if(se=te.length,k[3]||k[4]){ge+=se;continue}else if((k[5]||k[6])&&K%3&&!((K+se)%3)){we+=se;continue}if(ge-=se,!(ge>0)){if(se=Math.min(se,se+ge+we),Math.min(K,se)%2){var Ae=S.slice(1,K+k.index+se);return{type:"em",raw:S.slice(0,K+k.index+se+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}var ve=S.slice(2,K+k.index+se-1);return{type:"strong",raw:S.slice(0,K+k.index+se+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},O.codespan=function(S){var R=this.rules.inline.code.exec(S);if(R){var A=R[2].replace(/\n/g," "),k=/[^ ]/.test(A),H=/^ /.test(A)&&/ $/.test(A);return k&&H&&(A=A.substring(1,A.length-1)),A=e(A,!0),{type:"codespan",raw:R[0],text:A}}},O.br=function(S){var R=this.rules.inline.br.exec(S);if(R)return{type:"br",raw:R[0]}},O.del=function(S){var R=this.rules.inline.del.exec(S);if(R)return{type:"del",raw:R[0],text:R[2],tokens:this.lexer.inlineTokens(R[2])}},O.autolink=function(S,R){var A=this.rules.inline.autolink.exec(S);if(A){var k,H;return A[2]==="@"?(k=e(this.options.mangle?R(A[1]):A[1]),H="mailto:"+k):(k=e(A[1]),H=k),{type:"link",raw:A[0],text:k,href:H,tokens:[{type:"text",raw:k,text:k}]}}},O.url=function(S,R){var A;if(A=this.rules.inline.url.exec(S)){var k,H;if(A[2]==="@")k=e(this.options.mangle?R(A[0]):A[0]),H="mailto:"+k;else{var K;do K=A[0],A[0]=this.rules.inline._backpedal.exec(A[0])[0];while(K!==A[0]);k=e(A[0]),A[1]==="www."?H="http://"+k:H=k}return{type:"link",raw:A[0],text:k,href:H,tokens:[{type:"text",raw:k,text:k}]}}},O.inlineText=function(S,R){var A=this.rules.inline.text.exec(S);if(A){var k;return this.lexer.state.inRawBlock?k=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(A[0]):e(A[0]):A[0]:k=e(this.options.smartypants?R(A[0]):A[0]),{type:"text",raw:A[0],text:k}}},N}(),le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=n(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=n(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=n(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=n(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=n(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=B({},le),le.gfm=B({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=n(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.gfm.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",le.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=B({},le.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:n(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=n(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=n(le._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=n(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=n(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=n(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=n(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=n(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=n(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=n(oe.reflink).replace("label",oe._label).replace("ref",le._label).getRegex(),oe.nolink=n(oe.nolink).replace("ref",le._label).getRegex(),oe.reflinkSearch=n(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=B({},oe),oe.pedantic=B({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=B({},oe.normal,{escape:n(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=n(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=B({},oe.gfm,{br:n(oe.br).replace("{2,}","*").getRegex(),text:n(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function me(N){return N.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Se(N){var O="",_,S,R=N.length;for(_=0;_<R;_++)S=N.charCodeAt(_),Math.random()>.5&&(S="x"+S.toString(16)),O+="&#"+S+";";return O}var Le=function(){function N(_){this.tokens=[],this.tokens.links=Object.create(null),this.options=_||re.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var S={block:le.normal,inline:oe.normal};this.options.pedantic?(S.block=le.pedantic,S.inline=oe.pedantic):this.options.gfm&&(S.block=le.gfm,this.options.breaks?S.inline=oe.breaks:S.inline=oe.gfm),this.tokenizer.rules=S}N.lex=function(S,R){var A=new N(R);return A.lex(S)},N.lexInline=function(S,R){var A=new N(R);return A.inlineTokens(S)};var O=N.prototype;return O.lex=function(S){S=S.replace(/\r\n|\r/g,`
`),this.blockTokens(S,this.tokens);for(var R;R=this.inlineQueue.shift();)this.inlineTokens(R.src,R.tokens);return this.tokens},O.blockTokens=function(S,R){var A=this;R===void 0&&(R=[]),this.options.pedantic?S=S.replace(/\t/g,"    ").replace(/^ +$/gm,""):S=S.replace(/^( *)(\t+)/gm,function(ge,we,Fe){return we+"    ".repeat(Fe.length)});for(var k,H,K,te;S;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(k=ge.call({lexer:A},S,R))?(S=S.substring(k.raw.length),R.push(k),!0):!1}))){if(k=this.tokenizer.space(S)){S=S.substring(k.raw.length),k.raw.length===1&&R.length>0?R[R.length-1].raw+=`
`:R.push(k);continue}if(k=this.tokenizer.code(S)){S=S.substring(k.raw.length),H=R[R.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+k.raw,H.text+=`
`+k.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):R.push(k);continue}if(k=this.tokenizer.fences(S)){S=S.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.heading(S)){S=S.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.hr(S)){S=S.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.blockquote(S)){S=S.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.list(S)){S=S.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.html(S)){S=S.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.def(S)){S=S.substring(k.raw.length),H=R[R.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+k.raw,H.text+=`
`+k.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[k.tag]||(this.tokens.links[k.tag]={href:k.href,title:k.title});continue}if(k=this.tokenizer.table(S)){S=S.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.lheading(S)){S=S.substring(k.raw.length),R.push(k);continue}if(K=S,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,we=S.slice(1),Fe=void 0;A.options.extensions.startBlock.forEach(function(Ae){Fe=Ae.call({lexer:this},we),typeof Fe=="number"&&Fe>=0&&(ge=Math.min(ge,Fe))}),ge<1/0&&ge>=0&&(K=S.substring(0,ge+1))}(),this.state.top&&(k=this.tokenizer.paragraph(K))){H=R[R.length-1],te&&H.type==="paragraph"?(H.raw+=`
`+k.raw,H.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):R.push(k),te=K.length!==S.length,S=S.substring(k.raw.length);continue}if(k=this.tokenizer.text(S)){S=S.substring(k.raw.length),H=R[R.length-1],H&&H.type==="text"?(H.raw+=`
`+k.raw,H.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):R.push(k);continue}if(S){var se="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(se);break}else throw new Error(se)}}return this.state.top=!0,R},O.inline=function(S,R){return R===void 0&&(R=[]),this.inlineQueue.push({src:S,tokens:R}),R},O.inlineTokens=function(S,R){var A=this;R===void 0&&(R=[]);var k,H,K,te=S,se,ge,we;if(this.tokens.links){var Fe=Object.keys(this.tokens.links);if(Fe.length>0)for(;(se=this.tokenizer.rules.inline.reflinkSearch.exec(te))!=null;)Fe.includes(se[0].slice(se[0].lastIndexOf("[")+1,-1))&&(te=te.slice(0,se.index)+"["+J("a",se[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(se=this.tokenizer.rules.inline.blockSkip.exec(te))!=null;)te=te.slice(0,se.index)+"["+J("a",se[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(se=this.tokenizer.rules.inline.escapedEmSt.exec(te))!=null;)te=te.slice(0,se.index)+"++"+te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;S;)if(ge||(we=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(k=ve.call({lexer:A},S,R))?(S=S.substring(k.raw.length),R.push(k),!0):!1}))){if(k=this.tokenizer.escape(S)){S=S.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.tag(S)){S=S.substring(k.raw.length),H=R[R.length-1],H&&k.type==="text"&&H.type==="text"?(H.raw+=k.raw,H.text+=k.text):R.push(k);continue}if(k=this.tokenizer.link(S)){S=S.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.reflink(S,this.tokens.links)){S=S.substring(k.raw.length),H=R[R.length-1],H&&k.type==="text"&&H.type==="text"?(H.raw+=k.raw,H.text+=k.text):R.push(k);continue}if(k=this.tokenizer.emStrong(S,te,we)){S=S.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.codespan(S)){S=S.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.br(S)){S=S.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.del(S)){S=S.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.autolink(S,Se)){S=S.substring(k.raw.length),R.push(k);continue}if(!this.state.inLink&&(k=this.tokenizer.url(S,Se))){S=S.substring(k.raw.length),R.push(k);continue}if(K=S,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Me=S.slice(1),Oe=void 0;A.options.extensions.startInline.forEach(function(_e){Oe=_e.call({lexer:this},Me),typeof Oe=="number"&&Oe>=0&&(ve=Math.min(ve,Oe))}),ve<1/0&&ve>=0&&(K=S.substring(0,ve+1))}(),k=this.tokenizer.inlineText(K,me)){S=S.substring(k.raw.length),k.raw.slice(-1)!=="_"&&(we=k.raw.slice(-1)),ge=!0,H=R[R.length-1],H&&H.type==="text"?(H.raw+=k.raw,H.text+=k.text):R.push(k);continue}if(S){var Ae="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return R},y(N,null,[{key:"rules",get:function(){return{block:le,inline:oe}}}]),N}(),Ne=function(){function N(_){this.options=_||re.defaults}var O=N.prototype;return O.code=function(S,R,A){var k=(R||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(S,k);H!=null&&H!==S&&(A=!0,S=H)}return S=S.replace(/\n$/,"")+`
`,k?'<pre><code class="'+this.options.langPrefix+e(k,!0)+'">'+(A?S:e(S,!0))+`</code></pre>
`:"<pre><code>"+(A?S:e(S,!0))+`</code></pre>
`},O.blockquote=function(S){return`<blockquote>
`+S+`</blockquote>
`},O.html=function(S){return S},O.heading=function(S,R,A,k){if(this.options.headerIds){var H=this.options.headerPrefix+k.slug(A);return"<h"+R+' id="'+H+'">'+S+"</h"+R+`>
`}return"<h"+R+">"+S+"</h"+R+`>
`},O.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},O.list=function(S,R,A){var k=R?"ol":"ul",H=R&&A!==1?' start="'+A+'"':"";return"<"+k+H+`>
`+S+"</"+k+`>
`},O.listitem=function(S){return"<li>"+S+`</li>
`},O.checkbox=function(S){return"<input "+(S?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},O.paragraph=function(S){return"<p>"+S+`</p>
`},O.table=function(S,R){return R&&(R="<tbody>"+R+"</tbody>"),`<table>
<thead>
`+S+`</thead>
`+R+`</table>
`},O.tablerow=function(S){return`<tr>
`+S+`</tr>
`},O.tablecell=function(S,R){var A=R.header?"th":"td",k=R.align?"<"+A+' align="'+R.align+'">':"<"+A+">";return k+S+("</"+A+`>
`)},O.strong=function(S){return"<strong>"+S+"</strong>"},O.em=function(S){return"<em>"+S+"</em>"},O.codespan=function(S){return"<code>"+S+"</code>"},O.br=function(){return this.options.xhtml?"<br/>":"<br>"},O.del=function(S){return"<del>"+S+"</del>"},O.link=function(S,R,A){if(S=c(this.options.sanitize,this.options.baseUrl,S),S===null)return A;var k='<a href="'+e(S)+'"';return R&&(k+=' title="'+R+'"'),k+=">"+A+"</a>",k},O.image=function(S,R,A){if(S=c(this.options.sanitize,this.options.baseUrl,S),S===null)return A;var k='<img src="'+S+'" alt="'+A+'"';return R&&(k+=' title="'+R+'"'),k+=this.options.xhtml?"/>":">",k},O.text=function(S){return S},N}(),de=function(){function N(){}var O=N.prototype;return O.strong=function(S){return S},O.em=function(S){return S},O.codespan=function(S){return S},O.del=function(S){return S},O.html=function(S){return S},O.text=function(S){return S},O.link=function(S,R,A){return""+A},O.image=function(S,R,A){return""+A},O.br=function(){return""},N}(),ie=function(){function N(){this.seen={}}var O=N.prototype;return O.serialize=function(S){return S.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},O.getNextSafeSlug=function(S,R){var A=S,k=0;if(this.seen.hasOwnProperty(A)){k=this.seen[S];do k++,A=S+"-"+k;while(this.seen.hasOwnProperty(A))}return R||(this.seen[S]=k,this.seen[A]=0),A},O.slug=function(S,R){R===void 0&&(R={});var A=this.serialize(S);return this.getNextSafeSlug(A,R.dryrun)},N}(),fe=function(){function N(_){this.options=_||re.defaults,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new ie}N.parse=function(S,R){var A=new N(R);return A.parse(S)},N.parseInline=function(S,R){var A=new N(R);return A.parseInline(S)};var O=N.prototype;return O.parse=function(S,R){R===void 0&&(R=!0);var A="",k,H,K,te,se,ge,we,Fe,Ae,ve,Me,Oe,_e,je,Ie,Ge,Z,ae,pe,De=S.length;for(k=0;k<De;k++){if(ve=S[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(pe=this.options.extensions.renderers[ve.type].call({parser:this},ve),pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){A+=pe||"";continue}switch(ve.type){case"space":continue;case"hr":{A+=this.renderer.hr();continue}case"heading":{A+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,l(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{A+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Fe="",we="",te=ve.header.length,H=0;H<te;H++)we+=this.renderer.tablecell(this.parseInline(ve.header[H].tokens),{header:!0,align:ve.align[H]});for(Fe+=this.renderer.tablerow(we),Ae="",te=ve.rows.length,H=0;H<te;H++){for(ge=ve.rows[H],we="",se=ge.length,K=0;K<se;K++)we+=this.renderer.tablecell(this.parseInline(ge[K].tokens),{header:!1,align:ve.align[K]});Ae+=this.renderer.tablerow(we)}A+=this.renderer.table(Fe,Ae);continue}case"blockquote":{Ae=this.parse(ve.tokens),A+=this.renderer.blockquote(Ae);continue}case"list":{for(Me=ve.ordered,Oe=ve.start,_e=ve.loose,te=ve.items.length,Ae="",H=0;H<te;H++)Ie=ve.items[H],Ge=Ie.checked,Z=Ie.task,je="",Ie.task&&(ae=this.renderer.checkbox(Ge),_e?Ie.tokens.length>0&&Ie.tokens[0].type==="paragraph"?(Ie.tokens[0].text=ae+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=ae+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",text:ae}):je+=ae),je+=this.parse(Ie.tokens,_e),Ae+=this.renderer.listitem(je,Z,Ge);A+=this.renderer.list(Ae,Me,Oe);continue}case"html":{A+=this.renderer.html(ve.text);continue}case"paragraph":{A+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ae=ve.tokens?this.parseInline(ve.tokens):ve.text;k+1<De&&S[k+1].type==="text";)ve=S[++k],Ae+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);A+=R?this.renderer.paragraph(Ae):Ae;continue}default:{var Ce='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return A},O.parseInline=function(S,R){R=R||this.renderer;var A="",k,H,K,te=S.length;for(k=0;k<te;k++){if(H=S[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(K=this.options.extensions.renderers[H.type].call({parser:this},H),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){A+=K||"";continue}switch(H.type){case"escape":{A+=R.text(H.text);break}case"html":{A+=R.html(H.text);break}case"link":{A+=R.link(H.href,H.title,this.parseInline(H.tokens,R));break}case"image":{A+=R.image(H.href,H.title,H.text);break}case"strong":{A+=R.strong(this.parseInline(H.tokens,R));break}case"em":{A+=R.em(this.parseInline(H.tokens,R));break}case"codespan":{A+=R.codespan(H.text);break}case"br":{A+=R.br();break}case"del":{A+=R.del(this.parseInline(H.tokens,R));break}case"text":{A+=R.text(H.text);break}default:{var se='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return A},N}();function X(N,O,_){if(typeof N>"u"||N===null)throw new Error("marked(): input parameter is undefined or null");if(typeof N!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(N)+", string expected");if(typeof O=="function"&&(_=O,O=null),O=B({},X.defaults,O||{}),F(O),_){var S=O.highlight,R;try{R=Le.lex(N,O)}catch(te){return _(te)}var A=function(se){var ge;if(!se)try{O.walkTokens&&X.walkTokens(R,O.walkTokens),ge=fe.parse(R,O)}catch(we){se=we}return O.highlight=S,se?_(se):_(null,ge)};if(!S||S.length<3||(delete O.highlight,!R.length))return A();var k=0;X.walkTokens(R,function(te){te.type==="code"&&(k++,setTimeout(function(){S(te.text,te.lang,function(se,ge){if(se)return A(se);ge!=null&&ge!==te.text&&(te.text=ge,te.escaped=!0),k--,k===0&&A()})},0))}),k===0&&A();return}function H(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,O.silent)return"<p>An error occurred:</p><pre>"+e(te.message+"",!0)+"</pre>";throw te}try{var K=Le.lex(N,O);if(O.walkTokens){if(O.async)return Promise.all(X.walkTokens(K,O.walkTokens)).then(function(){return fe.parse(K,O)}).catch(H);X.walkTokens(K,O.walkTokens)}return fe.parse(K,O)}catch(te){H(te)}}X.options=X.setOptions=function(N){return B(X.defaults,N),D(X.defaults),X},X.getDefaults=w,X.defaults=re.defaults,X.use=function(){for(var N=arguments.length,O=new Array(N),_=0;_<N;_++)O[_]=arguments[_];var S=B.apply(void 0,[{}].concat(O)),R=X.defaults.extensions||{renderers:{},childTokens:{}},A;O.forEach(function(k){if(k.extensions&&(A=!0,k.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var te=R.renderers?R.renderers[K.name]:null;te?R.renderers[K.name]=function(){for(var se=arguments.length,ge=new Array(se),we=0;we<se;we++)ge[we]=arguments[we];var Fe=K.renderer.apply(this,ge);return Fe===!1&&(Fe=te.apply(this,ge)),Fe}:R.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");R[K.level]?R[K.level].unshift(K.tokenizer):R[K.level]=[K.tokenizer],K.start&&(K.level==="block"?R.startBlock?R.startBlock.push(K.start):R.startBlock=[K.start]:K.level==="inline"&&(R.startInline?R.startInline.push(K.start):R.startInline=[K.start]))}K.childTokens&&(R.childTokens[K.name]=K.childTokens)})),k.renderer&&function(){var K=X.defaults.renderer||new Ne,te=function(we){var Fe=K[we];K[we]=function(){for(var Ae=arguments.length,ve=new Array(Ae),Me=0;Me<Ae;Me++)ve[Me]=arguments[Me];var Oe=k.renderer[we].apply(K,ve);return Oe===!1&&(Oe=Fe.apply(K,ve)),Oe}};for(var se in k.renderer)te(se);S.renderer=K}(),k.tokenizer&&function(){var K=X.defaults.tokenizer||new ue,te=function(we){var Fe=K[we];K[we]=function(){for(var Ae=arguments.length,ve=new Array(Ae),Me=0;Me<Ae;Me++)ve[Me]=arguments[Me];var Oe=k.tokenizer[we].apply(K,ve);return Oe===!1&&(Oe=Fe.apply(K,ve)),Oe}};for(var se in k.tokenizer)te(se);S.tokenizer=K}(),k.walkTokens){var H=X.defaults.walkTokens;S.walkTokens=function(K){var te=[];return te.push(k.walkTokens.call(this,K)),H&&(te=te.concat(H.call(this,K))),te}}A&&(S.extensions=R),X.setOptions(S)})},X.walkTokens=function(N,O){for(var _=[],S=function(){var H=A.value;switch(_=_.concat(O.call(X,H)),H.type){case"table":{for(var K=U(H.header),te;!(te=K()).done;){var se=te.value;_=_.concat(X.walkTokens(se.tokens,O))}for(var ge=U(H.rows),we;!(we=ge()).done;)for(var Fe=we.value,Ae=U(Fe),ve;!(ve=Ae()).done;){var Me=ve.value;_=_.concat(X.walkTokens(Me.tokens,O))}break}case"list":{_=_.concat(X.walkTokens(H.items,O));break}default:X.defaults.extensions&&X.defaults.extensions.childTokens&&X.defaults.extensions.childTokens[H.type]?X.defaults.extensions.childTokens[H.type].forEach(function(Oe){_=_.concat(X.walkTokens(H[Oe],O))}):H.tokens&&(_=_.concat(X.walkTokens(H.tokens,O)))}},R=U(N),A;!(A=R()).done;)S();return _},X.parseInline=function(N,O){if(typeof N>"u"||N===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof N!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(N)+", string expected");O=B({},X.defaults,O||{}),F(O);try{var _=Le.lexInline(N,O);return O.walkTokens&&X.walkTokens(_,O.walkTokens),fe.parseInline(_,O)}catch(S){if(S.message+=`
Please report this to https://github.com/markedjs/marked.`,O.silent)return"<p>An error occurred:</p><pre>"+e(S.message+"",!0)+"</pre>";throw S}},X.Parser=fe,X.parser=fe.parse,X.Renderer=Ne,X.TextRenderer=de,X.Lexer=Le,X.lexer=Le.lex,X.Tokenizer=ue,X.Slugger=ie,X.parse=X;var q=X.options,G=X.setOptions,E=X.use,x=X.walkTokens,g=X.parseInline,p=X,V=fe.parse,T=Le.lex;re.Lexer=Le,re.Parser=fe,re.Renderer=Ne,re.Slugger=ie,re.TextRenderer=de,re.Tokenizer=ue,re.getDefaults=w,re.lexer=T,re.marked=X,re.options=q,re.parse=p,re.parseInline=g,re.parser=V,re.setOptions=G,re.use=E,re.walkTokens=x,Object.defineProperty(re,"__esModule",{value:!0})}),define(be[78],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JR=void 0;class y{constructor(i,U=0,w=i.length,D=U-1){this.a=i,this.b=U,this.c=w,this.d=D}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$JR=y}),define(be[79],$e([1,0,78]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LR=t.$KR=void 0;class P{constructor(w=[],D=10){this.h(w),this.b=D,this.d()}getHistory(){return this.j}add(w){this.a.delete(w),this.a.add(w),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(w){return this.a.has(w)}clear(){this.h([]),this.d()}d(){this.f();const w=this.j;this.c=new y.$JR(w,0,w.length,w.length)}f(){const w=this.j;w.length>this.b&&this.h(w.slice(w.length-this.b))}g(){const w=this.c.current();return w?this.j.indexOf(w):-1}h(w){this.a=new Set;for(const D of w)this.a.add(D)}get j(){const w=[];return this.a.forEach(D=>w.push(D)),w}}t.$KR=P;class i{get size(){return this.f}constructor(w,D=10){if(this.g=D,w.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:w[0],previous:void 0,next:void 0},this.a=new Set([w[0]]);for(let h=1;h<w.length;h++)this.add(w[h])}add(w){const D={value:w,previous:this.c,next:void 0};for(this.c.next=D,this.c=D,this.d=this.c,this.f++,this.a.has(w)?this.h(w):this.a.add(w);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(w){if(this.c.value===w)return w;const D=this.c.value;return this.a.delete(D),this.c.value=w,this.a.has(w)?this.h(w):this.a.add(w),D}prepend(w){if(this.f===this.g||this.a.has(w))return;const D={value:w,previous:void 0,next:this.b};this.b.previous=D,this.b=D,this.f++,this.a.add(w)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(w){return this.a.has(w)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let w=this.b;for(;w;)yield w.value,w=w.next}h(w){let D=this.b;for(;D!==this.c;)D.value===w&&(D===this.b?(this.b=this.b.next,this.b.previous=void 0):(D.previous.next=D.next,D.next.previous=D.previous),this.f--),D=D.next}}t.$LR=i}),define(be[45],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pl=t.$Ol=t.$Nl=t.rot=t.$Ll=void 0;function y(D,h,f){return Math.min(Math.max(D,h),f)}t.$Ll=y;function P(D,h){return(h+D%h)%h}t.rot=P;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Nl=i;class U{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Ol=U;class w{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const f=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Pl=w}),define(be[46],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var y;(function(P){function i(h,f){if(h.start>=f.end||f.start>=h.end)return{start:0,end:0};const d=Math.max(h.start,f.start),L=Math.min(h.end,f.end);return L-d<=0?{start:0,end:0}:{start:d,end:L}}P.intersect=i;function U(h){return h.end-h.start<=0}P.isEmpty=U;function w(h,f){return!U(i(h,f))}P.intersects=w;function D(h,f){const d=[],L={start:h.start,end:Math.min(f.start,h.end)},s={start:Math.max(f.end,h.start),end:h.end};return U(L)||d.push(L),U(s)||d.push(s),d}P.relativeComplement=D})(y||(t.Range=y={}))}),define(be[80],$e([1,0,46]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CQ=t.$BQ=t.$AQ=t.$zQ=void 0;function P(h,f){const d=[];for(const L of f){if(h.start>=L.range.end)continue;if(h.end<L.range.start)break;const s=y.Range.intersect(h,L.range);y.Range.isEmpty(s)||d.push({range:s,size:L.size})}return d}t.$zQ=P;function i({start:h,end:f},d){return{start:h+d,end:f+d}}t.$AQ=i;function U(h){const f=[];let d=null;for(const L of h){const s=L.range.start,a=L.range.end,e=L.size;if(d&&e===d.size){d.range.end=a;continue}d={range:{start:s,end:a},size:e},f.push(d)}return f}t.$BQ=U;function w(...h){return U(h.reduce((f,d)=>f.concat(d),[]))}class D{get paddingTop(){return this.c}set paddingTop(f){this.b=this.b+f-this.c,this.c=f}constructor(f){this.a=[],this.b=0,this.c=0,this.c=f??0,this.b=this.c}splice(f,d,L=[]){const s=L.length-d,a=P({start:0,end:f},this.a),e=P({start:f+d,end:Number.POSITIVE_INFINITY},this.a).map(l=>({range:i(l.range,s),size:l.size})),u=L.map((l,m)=>({range:{start:f+m,end:f+m+1},size:l.size}));this.a=w(a,u,e),this.b=this.c+this.a.reduce((l,m)=>l+m.size*(m.range.end-m.range.start),0)}get count(){const f=this.a.length;return f?this.a[f-1].range.end:0}get size(){return this.b}indexAt(f){if(f<0)return-1;if(f<this.c)return 0;let d=0,L=this.c;for(const s of this.a){const a=s.range.end-s.range.start,e=L+a*s.size;if(f<e)return d+Math.floor((f-L)/s.size);d+=a,L=e}return d}indexAfter(f){return Math.min(this.indexAt(f)+1,this.count)}positionAt(f){if(f<0)return-1;let d=0,L=0;for(const s of this.a){const a=s.range.end-s.range.start,e=L+a;if(f<e)return this.c+d+(f-L)*s.size;d+=a*s.size,L=e}return-1}}t.$CQ=D}),define(be[81],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Id=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class P{static create(U){return new P(U)}constructor(U){this.c=y&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Id=P}),define(be[3],$e([1,0,6,42,2,44,81]),function(re,t,y,P,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.Event=void 0;const D=!1,h=!1;var f;(function(W){W.None=()=>i.$Rc.None;function M(R){if(h){const{onDidAddListener:A}=R,k=e.create();let H=0;R.onDidAddListener=()=>{++H===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),k.print()),A?.()}}}function F(R,A){return Ne(R,()=>{},0,void 0,!0,void 0,A)}W.defer=F;function J(R){return(A,k=null,H)=>{let K=!1,te;return te=R(se=>{if(!K)return te?te.dispose():K=!0,A.call(k,se)},null,H),K&&te.dispose(),te}}W.once=J;function ee(R,A,k){return Se((H,K=null,te)=>R(se=>H.call(K,A(se)),null,te),k)}W.map=ee;function ne(R,A,k){return Se((H,K=null,te)=>R(se=>{A(se),H.call(K,se)},null,te),k)}W.forEach=ne;function ue(R,A,k){return Se((H,K=null,te)=>R(se=>A(se)&&H.call(K,se),null,te),k)}W.filter=ue;function le(R){return R}W.signal=le;function oe(...R){return(A,k=null,H)=>{const K=(0,i.$Oc)(...R.map(te=>te(se=>A.call(k,se))));return Le(K,H)}}W.any=oe;function me(R,A,k,H){let K=k;return ee(R,te=>(K=A(K,te),K),H)}W.reduce=me;function Se(R,A){let k;const H={onWillAddFirstListener(){k=R(K.fire,K)},onDidRemoveLastListener(){k?.dispose()}};A||M(H);const K=new r(H);return A?.add(K),K.event}function Le(R,A){return A instanceof Array?A.push(R):A&&A.add(R),R}function Ne(R,A,k=100,H=!1,K=!1,te,se){let ge,we,Fe,Ae=0,ve;const Me={leakWarningThreshold:te,onWillAddFirstListener(){ge=R(_e=>{Ae++,we=A(we,_e),H&&!Fe&&(Oe.fire(we),we=void 0),ve=()=>{const je=we;we=void 0,Fe=void 0,(!H||Ae>1)&&Oe.fire(je),Ae=0},typeof k=="number"?(clearTimeout(Fe),Fe=setTimeout(ve,k)):Fe===void 0&&(Fe=0,queueMicrotask(ve))})},onWillRemoveListener(){K&&Ae>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,ge.dispose()}};se||M(Me);const Oe=new r(Me);return se?.add(Oe),Oe.event}W.debounce=Ne;function de(R,A=0,k){return W.debounce(R,(H,K)=>H?(H.push(K),H):[K],A,void 0,!0,void 0,k)}W.accumulate=de;function ie(R,A=(H,K)=>H===K,k){let H=!0,K;return ue(R,te=>{const se=H||!A(te,K);return H=!1,K=te,se},k)}W.latch=ie;function fe(R,A,k){return[W.filter(R,A,k),W.filter(R,H=>!A(H),k)]}W.split=fe;function X(R,A=!1,k=[],H){let K=k.slice(),te=R(we=>{K?K.push(we):ge.fire(we)});H&&H.add(te);const se=()=>{K?.forEach(we=>ge.fire(we)),K=null},ge=new r({onWillAddFirstListener(){te||(te=R(we=>ge.fire(we)),H&&H.add(te))},onDidAddFirstListener(){K&&(A?setTimeout(se):se())},onDidRemoveLastListener(){te&&te.dispose(),te=null}});return H&&H.add(ge),ge.event}W.buffer=X;function q(R,A){return(H,K,te)=>{const se=A(new E);return R(function(ge){const we=se.evaluate(ge);we!==G&&H.call(K,we)},void 0,te)}}W.chain=q;const G=Symbol("HaltChainable");class E{constructor(){this.f=[]}map(A){return this.f.push(A),this}forEach(A){return this.f.push(k=>(A(k),k)),this}filter(A){return this.f.push(k=>A(k)?k:G),this}reduce(A,k){let H=k;return this.f.push(K=>(H=A(H,K),H)),this}latch(A=(k,H)=>k===H){let k=!0,H;return this.f.push(K=>{const te=k||!A(K,H);return k=!1,H=K,te?K:G}),this}evaluate(A){for(const k of this.f)if(A=k(A),A===G)break;return A}}function x(R,A,k=H=>H){const H=(...ge)=>se.fire(k(...ge)),K=()=>R.on(A,H),te=()=>R.removeListener(A,H),se=new r({onWillAddFirstListener:K,onDidRemoveLastListener:te});return se.event}W.fromNodeEventEmitter=x;function g(R,A,k=H=>H){const H=(...ge)=>se.fire(k(...ge)),K=()=>R.addEventListener(A,H),te=()=>R.removeEventListener(A,H),se=new r({onWillAddFirstListener:K,onDidRemoveLastListener:te});return se.event}W.fromDOMEventEmitter=g;function p(R){return new Promise(A=>J(R)(A))}W.toPromise=p;function V(R){const A=new r;return R.then(k=>{A.fire(k)},()=>{A.fire(void 0)}).finally(()=>{A.dispose()}),A.event}W.fromPromise=V;function T(R,A){return A(void 0),R(k=>A(k))}W.runAndSubscribe=T;function N(R,A){let k=null;function H(te){k?.dispose(),k=new i.$Qc,A(te,k)}H(void 0);const K=R(te=>H(te));return(0,i.$Pc)(()=>{K.dispose(),k?.dispose()})}W.runAndSubscribeWithStore=N;class O{constructor(A,k){this._observable=A,this.f=0,this.g=!1;const H={onWillAddFirstListener:()=>{A.addObserver(this)},onDidRemoveLastListener:()=>{A.removeObserver(this)}};k||M(H),this.emitter=new r(H),k&&k.add(this.emitter)}beginUpdate(A){this.f++}handlePossibleChange(A){}handleChange(A,k){this.g=!0}endUpdate(A){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function _(R,A){return new O(R,A).emitter.event}W.fromObservable=_;function S(R){return A=>{let k=0,H=!1;const K={beginUpdate(){k++},endUpdate(){k--,k===0&&(R.reportChanges(),H&&(H=!1,A()))},handlePossibleChange(){},handleChange(){H=!0}};return R.addObserver(K),R.reportChanges(),{dispose(){R.removeObserver(K)}}}}W.fromObservableLight=S})(f||(t.Event=f={}));class d{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${d.f++}`,d.all.add(this)}start(M){this.g=new w.$Id,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}t.$Kd=d;let L=-1;function s(W){const M=L;return L=W,{dispose(){L=M}}}t.$Ld=s;class a{constructor(M,F=Math.random().toString(18).slice(2,5)){this.threshold=M,this.name=F,this.g=0}dispose(){this.f?.clear()}check(M,F){const J=this.threshold;if(J<=0||F<J)return;this.f||(this.f=new Map);const ee=this.f.get(M.value)||0;if(this.f.set(M.value,ee+1),this.g-=1,this.g<=0){this.g=J*.5;let ne,ue=0;for(const[le,oe]of this.f)(!ne||ue<oe)&&(ne=le,ue=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${ue}):`),console.warn(ne)}return()=>{const ne=this.f.get(M.value)||0;this.f.set(M.value,ne-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let u=0;class l{constructor(M){this.value=M,this.id=u++}}const m=2,n=(W,M)=>{if(W instanceof l)M(W);else for(let F=0;F<W.length;F++){const J=W[F];J&&M(J)}};class r{constructor(M){this.w=0,this.f=M,this.g=L>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??L):void 0,this.j=this.f?._profName?new d(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(D){const M=this.t;queueMicrotask(()=>{n(M,F=>F.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,F,J)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$Rc.None;if(this.m)return i.$Rc.None;F&&(M=M.bind(F));const ee=new l(M);let ne,ue;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ee.stack=e.create(),ne=this.g.check(ee.stack,this.w+1)),D&&(ee.stack=ue??e.create()),this.t?this.t instanceof l?(this.u??=new c,this.t=[this.t,ee]):this.t.push(ee):(this.f?.onWillAddFirstListener?.(this),this.t=ee,this.f?.onDidAddFirstListener?.(this)),this.w++;const le=(0,i.$Pc)(()=>{ne?.(),this.x(ee)});return J instanceof i.$Qc?J.add(le):Array.isArray(J)&&J.push(le),le},this.q}x(M){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const F=this.t,J=F.indexOf(M);if(J===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,F[J]=void 0;const ee=this.u.current===this;if(this.w*m<=F.length){let ne=0;for(let ue=0;ue<F.length;ue++)F[ue]?F[ne++]=F[ue]:ee&&(this.u.end--,ne<this.u.i&&this.u.i--);F.length=ne}}y(M,F){if(!M)return;const J=this.f?.onListenerError||y.$Z;if(!J){M.value(F);return}try{M.value(F)}catch(ee){J(ee)}}z(M){const F=M.current.t;for(;M.i<M.end;)this.y(F[M.i++],M.value);M.reset()}fire(M){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,M);else{const F=this.u;F.enqueue(this,M,this.t.length),this.z(F)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Md=r;const $=()=>new c;t.$Nd=$;class c{constructor(){this.i=-1,this.end=0}enqueue(M,F,J){this.i=0,this.end=J,this.current=M,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends r{async fireAsync(M,F,J){if(this.t)for(this.h||(this.h=new U.$1c),n(this.t,ee=>this.h.push([ee.value,M]));this.h.size>0&&!F.isCancellationRequested;){const[ee,ne]=this.h.shift(),ue=[],le={...ne,token:F,waitUntil:oe=>{if(Object.isFrozen(ue))throw new Error("waitUntil can NOT be called asynchronous");J&&(oe=J(oe,ee)),ue.push(oe)}};try{ee(le)}catch(oe){(0,y.$Z)(oe);continue}Object.freeze(ue),await Promise.allSettled(ue).then(oe=>{for(const me of oe)me.status==="rejected"&&(0,y.$Z)(me.reason)})}}}t.$Od=o;class C extends r{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new U.$1c,this.A=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.A(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.w&&(this.h!==0?this.s.push(M):super.fire(M))}}t.$Pd=C;class z extends C{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}t.$Qd=z;class I extends r{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}t.$Rd=I;class b{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const F={event:M,listener:null};this.h.push(F),this.g&&this.m(F);const J=()=>{this.g&&this.o(F);const ee=this.h.indexOf(F);this.h.splice(ee,1)};return(0,i.$Pc)((0,P.$cb)(J))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(F=>this.f.fire(F))}o(M){M.listener&&M.listener.dispose(),M.listener=null}dispose(){this.f.dispose()}}t.$Sd=b;class v{constructor(M,F,J,ee){this.f=new i.$Qc;const ne=this.f.add(new b),ue=this.f.add(new i.$Zc);function le(oe){ue.set(oe,ne.add(ee(oe)))}for(const oe of M)le(oe);this.f.add(F(oe=>{le(oe)})),this.f.add(J(oe=>{ue.deleteAndDispose(oe)})),this.event=ne.event}dispose(){this.f.dispose()}}t.$Td=v;class B{constructor(){this.f=[]}wrapEvent(M){return(F,J,ee)=>M(ne=>{const ue=this.f[this.f.length-1];ue?ue.push(()=>F.call(J,ne)):F.call(J,ne)},void 0,ee)}bufferEvents(M){const F=[];this.f.push(F);const J=M();return this.f.pop(),F.forEach(ee=>ee()),J}}t.$Ud=B;class j{constructor(){this.f=!1,this.g=f.None,this.h=i.$Rc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Vd=j}),define(be[16],$e([1,0,3,2]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oO=t.$nO=t.$mO=t.$lO=t.$kO=t.$jO=t.$iO=t.$hO=t.$gO=t.$fO=t.$eO=t.$dO=t.$cO=t.$bO=t.$aO=t.$_N=t.$$N=t.$0N=void 0;class i{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new y.$Md,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new i}getZoomLevel(){return this.a}setZoomLevel($){this.a!==$&&(this.a=$)}getZoomFactor(){return this.b}setZoomFactor($){this.b=$}setFullscreen($){this.c!==$&&(this.c=$,this.d.fire())}isFullscreen(){return this.c}}class U extends P.$Rc{constructor(){super(),this.a=this.B(new y.$Md),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f($){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),$&&this.a.fire()}}class w extends P.$Rc{get value(){return this.b}constructor(){super(),this.a=this.B(new y.$Md),this.onDidChange=this.a.event,this.b=this.c();const $=this.B(new U);this.B($.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const $=document.createElement("canvas").getContext("2d"),c=window.devicePixelRatio||1,o=$.webkitBackingStorePixelRatio||$.mozBackingStorePixelRatio||$.msBackingStorePixelRatio||$.oBackingStorePixelRatio||$.backingStorePixelRatio||1;return c/o}}class D{constructor(){this.a=null}b(){return this.a||(this.a=(0,P.$Kc)(new w)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function h(r,$){typeof r=="string"&&(r=window.matchMedia(r)),r.addEventListener("change",$)}t.$0N=h,t.$$N=new D;function f(r){i.INSTANCE.setZoomLevel(r)}t.$_N=f;function d(){return i.INSTANCE.getZoomLevel()}t.$aO=d;function L(){return i.INSTANCE.getZoomFactor()}t.$bO=L;function s(r){i.INSTANCE.setZoomFactor(r)}t.$cO=s;function a(r){i.INSTANCE.setFullscreen(r)}t.$dO=a;function e(){return i.INSTANCE.isFullscreen()}t.$eO=e,t.$fO=i.INSTANCE.onDidChangeFullscreen;const u=navigator.userAgent;t.$gO=u.indexOf("Firefox")>=0,t.$hO=u.indexOf("AppleWebKit")>=0,t.$iO=u.indexOf("Chrome")>=0,t.$jO=!t.$iO&&u.indexOf("Safari")>=0,t.$kO=!t.$iO&&!t.$jO&&t.$hO,t.$lO=u.indexOf("Electron/")>=0,t.$mO=u.indexOf("Android")>=0;let l=!1;if(window.matchMedia){const r=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),$=window.matchMedia("(display-mode: fullscreen)");l=r.matches,h(r,({matches:c})=>{l&&$.matches||(l=c)})}function m(){return l}t.$nO=m;function n(){return navigator?.windowControlsOverlay?.visible}t.$oO=n}),define(be[21],$e([1,0,3]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rQ=void 0;class P{get event(){return this.a.event}constructor(U,w,D){const h=f=>this.a.fire(f);this.a=new y.$Md({onWillAddFirstListener:()=>U.addEventListener(w,h,D),onDidRemoveLastListener:()=>U.removeEventListener(w,h,D)})}dispose(){this.a.dispose()}}t.$rQ=P}),define(be[28],$e([1,0,3]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wd=t.CancellationToken=void 0;const P=Object.freeze(function(D,h){const f=setTimeout(D.bind(h),0);return{dispose(){clearTimeout(f)}}});var i;(function(D){function h(f){return f===D.None||f===D.Cancelled||f instanceof U?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}D.isCancellationToken=h,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(i||(t.CancellationToken=i={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?P:(this.b||(this.b=new y.$Md),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class w{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new U),this.f}cancel(){this.f?this.f instanceof U&&this.f.cancel():this.f=i.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof U&&this.f.dispose():this.f=i.None}}t.$Wd=w}),define(be[82],$e([1,0,28]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xe=t.$we=t.$ve=void 0;class P{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new y.$Wd,h=this.b(D.token);return this.a={promise:h,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}t.$ve=P;class i{constructor(D){this.c=D,this.a=void 0,this.b=void 0}get(D){const h=JSON.stringify(D);return this.b!==h&&(this.b=h,this.a=this.c(D)),this.a}}t.$we=i;class U{get cachedValues(){return this.a}constructor(D){this.b=D,this.a=new Map}get(D){if(this.a.has(D))return this.a.get(D);const h=this.b(D);return this.a.set(D,h),h}}t.$xe=U}),define(be[47],$e([1,0,3,2]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ur=t.$Tr=t.$Sr=t.$Rr=t.ScrollbarVisibility=void 0;var i;(function(a){a[a.Auto=1]="Auto",a[a.Hidden=2]="Hidden",a[a.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class U{constructor(e,u,l,m,n,r,$){this.c=e,this._scrollStateBrand=void 0,this.c&&(u=u|0,l=l|0,m=m|0,n=n|0,r=r|0,$=$|0),this.rawScrollLeft=m,this.rawScrollTop=$,u<0&&(u=0),m+u>l&&(m=l-u),m<0&&(m=0),n<0&&(n=0),$+n>r&&($=r-n),$<0&&($=0),this.width=u,this.scrollWidth=l,this.scrollLeft=m,this.height=n,this.scrollHeight=r,this.scrollTop=$}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,u){return new U(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,u?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,u?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new U(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,u){const l=this.width!==e.width,m=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,$=this.scrollHeight!==e.scrollHeight,c=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:u,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:l,scrollWidthChanged:m,scrollLeftChanged:n,heightChanged:r,scrollHeightChanged:$,scrollTopChanged:c}}}t.$Rr=U;class w extends P.$Rc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new y.$Md),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new U(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,u){const l=this.g.withScrollDimensions(e,u);this.n(l,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const u=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(u,!1)}setScrollPositionSmooth(e,u){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const l=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===l.scrollLeft&&this.h.to.scrollTop===l.scrollTop)return;let m;u?m=new d(this.h.from,l,this.h.startTime,this.h.duration):m=this.h.combine(this.g,l,this.c),this.h.dispose(),this.h=m}else{const l=this.g.withScrollPosition(e);this.h=d.start(this.g,l,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),u=this.g.withScrollPosition(e);if(this.n(u,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,u){const l=this.g;l.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(l,u)))}}t.$Sr=w;class D{constructor(e,u,l){this.scrollLeft=e,this.scrollTop=u,this.isDone=l}}t.$Tr=D;function h(a,e){const u=e-a;return function(l){return a+u*s(l)}}function f(a,e,u){return function(l){return l<u?a(l/u):e((l-u)/(1-u))}}class d{constructor(e,u,l,m){this.from=e,this.to=u,this.duration=m,this.startTime=l,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,u,l){if(Math.abs(e-u)>2.5*l){let n,r;return e<u?(n=e+.75*l,r=u-.75*l):(n=e-.75*l,r=u+.75*l),f(h(e,n),h(r,u),.33)}return h(e,u)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const u=(e-this.startTime)/this.duration;if(u<1){const l=this.c(u),m=this.d(u);return new D(l,m,!1)}return new D(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,u,l){return d.start(e,u,l)}static start(e,u,l){l=l+10;const m=Date.now()-10;return new d(e,u,m,l)}}t.$Ur=d;function L(a){return Math.pow(a,3)}function s(a){return 1-L(1-a)}}),define(be[83],$e([1,0,6,2]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=void 0;function i($){const c=$;return c?typeof c.read=="function":!1}t.$Xd=i;function U($){const c=$;return c?[c.on,c.pause,c.resume,c.destroy].every(o=>typeof o=="function"):!1}t.$Yd=U;function w($){const c=$;return c?U(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}t.$Zd=w;function D($,c){return new h($,c)}t.$1d=D;class h{constructor(c,o){this.e=c,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(o=>o(c))}h(c){this.c.error.length===0?(0,y.$Z)(c):this.c.error.slice(0).forEach(o=>o(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,o){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(c,o){if(this.a.destroyed)return;let C;switch(c){case"data":C=this.c.data;break;case"end":C=this.c.end;break;case"error":C=this.c.error;break}if(C){const z=C.indexOf(o);z>=0&&C.splice(z,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(C=>C())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f($,c){const o=[];let C;for(;(C=$.read())!==null;)o.push(C);return c(o)}t.$2d=f;function d($,c,o){const C=[];let z;for(;(z=$.read())!==null&&C.length<o;)C.push(z);return z===null&&C.length>0?c(C):{read:()=>{if(C.length>0)return C.shift();if(typeof z<"u"){const I=z;return z=void 0,I}return $.read()}}}t.$3d=d;function L($,c){return new Promise((o,C)=>{const z=[];s($,{onData:I=>{c&&z.push(I)},onError:I=>{c?C(I):o(void 0)},onEnd:()=>{o(c?c(z):void 0)}})})}t.$4d=L;function s($,c,o){$.on("error",C=>{o?.isCancellationRequested||c.onError(C)}),$.on("end",()=>{o?.isCancellationRequested||c.onEnd()}),$.on("data",C=>{o?.isCancellationRequested||c.onData(C)})}t.$5d=s;function a($,c){return new Promise((o,C)=>{const z=new P.$Qc,I=[],b=j=>{if(I.push(j),I.length>c)return z.dispose(),$.pause(),o({stream:$,buffer:I,ended:!1})},v=j=>(z.dispose(),C(j)),B=()=>(z.dispose(),o({stream:$,buffer:I,ended:!0}));z.add((0,P.$Pc)(()=>$.removeListener("error",v))),$.on("error",v),z.add((0,P.$Pc)(()=>$.removeListener("end",B))),$.on("end",B),z.add((0,P.$Pc)(()=>$.removeListener("data",b))),$.on("data",b)})}t.$6d=a;function e($,c){const o=D(c);return o.end($),o}t.$7d=e;function u(){const $=D(()=>{throw new Error("not supported")});return $.end(),$}t.$8d=u;function l($){let c=!1;return{read:()=>c?null:(c=!0,$)}}t.$9d=l;function m($,c,o){const C=D(o);return s($,{onData:z=>C.write(c.data(z)),onError:z=>C.error(c.error?c.error(z):z),onEnd:()=>C.end()}),C}t.$0d=m;function n($,c,o){let C=!1;return{read:()=>{const z=c.read();return C?z:(C=!0,z!==null?o([$,z]):$)}}}t.$$d=n;function r($,c,o){let C=!1;const z=D(o);return s(c,{onData:I=>C?z.write(I):(C=!0,z.write(o([$,I]))),onError:I=>z.error(I),onEnd:()=>{C||(C=!0,z.write($)),z.end()}}),z}t.$_d=r}),define(be[32],$e([1,0,27,83]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$ae=void 0;const i=typeof Buffer<"u",U=new y.$U(()=>new Uint8Array(256));let w,D;class h{static alloc(F){return i?new h(Buffer.allocUnsafe(F)):new h(new Uint8Array(F))}static wrap(F){return i&&!Buffer.isBuffer(F)&&(F=Buffer.from(F.buffer,F.byteOffset,F.byteLength)),new h(F)}static fromString(F,J){return!(J?.dontUseNodeBuffer||!1)&&i?new h(Buffer.from(F)):(w||(w=new TextEncoder),new h(w.encode(F)))}static fromByteArray(F){const J=h.alloc(F.length);for(let ee=0,ne=F.length;ee<ne;ee++)J.buffer[ee]=F[ee];return J}static concat(F,J){if(typeof J>"u"){J=0;for(let ue=0,le=F.length;ue<le;ue++)J+=F[ue].byteLength}const ee=h.alloc(J);let ne=0;for(let ue=0,le=F.length;ue<le;ue++){const oe=F[ue];ee.set(oe,ne),ne+=oe.byteLength}return ee}constructor(F){this.buffer=F,this.byteLength=this.buffer.byteLength}clone(){const F=h.alloc(this.byteLength);return F.set(this),F}toString(){return i?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(F,J){return new h(this.buffer.subarray(F,J))}set(F,J){if(F instanceof h)this.buffer.set(F.buffer,J);else if(F instanceof Uint8Array)this.buffer.set(F,J);else if(F instanceof ArrayBuffer)this.buffer.set(new Uint8Array(F),J);else if(ArrayBuffer.isView(F))this.buffer.set(new Uint8Array(F.buffer,F.byteOffset,F.byteLength),J);else throw new Error("Unknown argument 'array'")}readUInt32BE(F){return s(this.buffer,F)}writeUInt32BE(F,J){a(this.buffer,F,J)}readUInt32LE(F){return e(this.buffer,F)}writeUInt32LE(F,J){u(this.buffer,F,J)}readUInt8(F){return l(this.buffer,F)}writeUInt8(F,J){m(this.buffer,F,J)}indexOf(F,J=0){return f(this.buffer,F instanceof h?F.buffer:F,J)}}t.$ae=h;function f(M,F,J=0){const ee=F.byteLength,ne=M.byteLength;if(ee===0)return 0;if(ee===1)return M.indexOf(F[0]);if(ee>ne-J)return-1;const ue=U.value;ue.fill(F.length);for(let Se=0;Se<F.length;Se++)ue[F[Se]]=F.length-Se-1;let le=J+F.length-1,oe=le,me=-1;for(;le<ne;)if(M[le]===F[oe]){if(oe===0){me=le;break}le--,oe--}else le+=Math.max(F.length-oe,ue[M[le]]),oe=F.length-1;return me}t.$be=f;function d(M,F){return M[F+0]<<0>>>0|M[F+1]<<8>>>0}t.$ce=d;function L(M,F,J){M[J+0]=F&255,F=F>>>8,M[J+1]=F&255}t.$de=L;function s(M,F){return M[F]*2**24+M[F+1]*2**16+M[F+2]*2**8+M[F+3]}t.$ee=s;function a(M,F,J){M[J+3]=F,F=F>>>8,M[J+2]=F,F=F>>>8,M[J+1]=F,F=F>>>8,M[J]=F}t.$fe=a;function e(M,F){return M[F+0]<<0>>>0|M[F+1]<<8>>>0|M[F+2]<<16>>>0|M[F+3]<<24>>>0}t.$ge=e;function u(M,F,J){M[J+0]=F&255,F=F>>>8,M[J+1]=F&255,F=F>>>8,M[J+2]=F&255,F=F>>>8,M[J+3]=F&255}t.$he=u;function l(M,F){return M[F]}t.$ie=l;function m(M,F,J){M[J]=F}t.$je=m;function n(M){return P.$2d(M,F=>h.concat(F))}t.$ke=n;function r(M){return P.$9d(M)}t.$le=r;function $(M){return P.$4d(M,F=>h.concat(F))}t.$me=$;async function c(M){return M.ended?h.concat(M.buffer):h.concat([...M.buffer,await $(M.stream)])}t.$ne=c;function o(M){return P.$7d(M,F=>h.concat(F))}t.$oe=o;function C(M){return P.$0d(M,{data:F=>typeof F=="string"?h.fromString(F):h.wrap(F)},F=>h.concat(F))}t.$pe=C;function z(M){return P.$1d(F=>h.concat(F),M)}t.$qe=z;function I(M,F){return P.$$d(M,F,J=>h.concat(J))}t.$re=I;function b(M,F){return P.$_d(M,F,J=>h.concat(J))}t.$se=b;function v(M){let F=0,J=0,ee=0;const ne=new Uint8Array(Math.floor(M.length/4*3)),ue=oe=>{switch(J){case 3:ne[ee++]=F|oe,J=0;break;case 2:ne[ee++]=F|oe>>>2,F=oe<<6,J=3;break;case 1:ne[ee++]=F|oe>>>4,F=oe<<4,J=2;break;default:F=oe<<2,J=1}};for(let oe=0;oe<M.length;oe++){const me=M.charCodeAt(oe);if(me>=65&&me<=90)ue(me-65);else if(me>=97&&me<=122)ue(me-97+26);else if(me>=48&&me<=57)ue(me-48+52);else if(me===43||me===45)ue(62);else if(me===47||me===95)ue(63);else{if(me===61)break;throw new SyntaxError(`Unexpected base64 character ${M[oe]}`)}}const le=ee;for(;J>0;)ue(0);return h.wrap(ne).slice(0,le)}t.$te=v;const B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function W({buffer:M},F=!0,J=!1){const ee=J?j:B;let ne="";const ue=M.byteLength%3;let le=0;for(;le<M.byteLength-ue;le+=3){const oe=M[le+0],me=M[le+1],Se=M[le+2];ne+=ee[oe>>>2],ne+=ee[(oe<<4|me>>>4)&63],ne+=ee[(me<<2|Se>>>6)&63],ne+=ee[Se&63]}if(ue===1){const oe=M[le+0];ne+=ee[oe>>>2],ne+=ee[oe<<4&63],F&&(ne+="==")}else if(ue===2){const oe=M[le+0],me=M[le+1];ne+=ee[oe>>>2],ne+=ee[(oe<<4|me>>>4)&63],ne+=ee[me<<2&63],F&&(ne+="=")}return ne}t.$ue=W}),define(be[12],$e([1,0,82,27]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wf=t.$vf=t.$uf=t.$tf=t.GraphemeBreakType=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=t.$Ae=void 0;function i(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}t.$Ae=i;const U=/{(\d+)}/g;function w(Z,...ae){return ae.length===0?Z:Z.replace(U,function(pe,De){const Ce=parseInt(De,10);return isNaN(Ce)||Ce<0||Ce>=ae.length?pe:ae[Ce]})}t.$Be=w;const D=/{([^}]+)}/g;function h(Z,ae){return Z.replace(D,(pe,De)=>ae[De]??pe)}t.$Ce=h;function f(Z){return Z.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}t.$De=f;function d(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Ee=d;function L(Z,ae){let pe=0;const De=ae.charCodeAt(0);for(let Ce=Z.length-1;Ce>=0;Ce--)Z.charCodeAt(Ce)===De&&pe++;return pe}t.$Fe=L;function s(Z,ae,pe="\u2026"){return Z.length<=ae?Z:`${Z.substr(0,ae)}${pe}`}t.$Ge=s;function a(Z,ae=" "){const pe=e(Z,ae);return u(pe,ae)}t.$He=a;function e(Z,ae){if(!Z||!ae)return Z;const pe=ae.length;if(pe===0||Z.length===0)return Z;let De=0;for(;Z.indexOf(ae,De)===De;)De=De+pe;return Z.substring(De)}t.$Ie=e;function u(Z,ae){if(!Z||!ae)return Z;const pe=ae.length,De=Z.length;if(pe===0||De===0)return Z;let Ce=De,Re=-1;for(;Re=Z.lastIndexOf(ae,Ce-1),!(Re===-1||Re+pe!==Ce);){if(Re===0)return"";Ce=Re}return Z.substring(0,Ce)}t.$Je=u;function l(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Ke=l;function m(Z){return Z.replace(/\*/g,"")}t.$Le=m;function n(Z,ae,pe={}){if(!Z)throw new Error("Cannot create regex from empty string");ae||(Z=d(Z)),pe.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let De="";return pe.global&&(De+="g"),pe.matchCase||(De+="i"),pe.multiline&&(De+="m"),pe.unicode&&(De+="u"),new RegExp(Z,De)}t.$Me=n;function r(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}t.$Ne=r;function $(Z){return Z.split(/\r\n|\r|\n/)}t.$Oe=$;function c(Z){for(let ae=0,pe=Z.length;ae<pe;ae++){const De=Z.charCodeAt(ae);if(De!==32&&De!==9)return ae}return-1}t.$Pe=c;function o(Z,ae=0,pe=Z.length){for(let De=ae;De<pe;De++){const Ce=Z.charCodeAt(De);if(Ce!==32&&Ce!==9)return Z.substring(ae,De)}return Z.substring(ae,pe)}t.$Qe=o;function C(Z,ae=Z.length-1){for(let pe=ae;pe>=0;pe--){const De=Z.charCodeAt(pe);if(De!==32&&De!==9)return pe}return-1}t.$Re=C;function z(Z,ae,pe){const De=[];let Ce=0;for(const Re of Z.matchAll(ae)){if(De.push(Z.slice(Ce,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Ce=Re.index+Re[0].length,De.push(pe(Re[0],...Re.slice(1),Re.index,Z,Re.groups))}return De.push(Z.slice(Ce)),Promise.all(De).then(Re=>Re.join(""))}t.$Se=z;function I(Z,ae){return Z<ae?-1:Z>ae?1:0}t.$Te=I;function b(Z,ae,pe=0,De=Z.length,Ce=0,Re=ae.length){for(;pe<De&&Ce<Re;pe++,Ce++){const Ke=Z.charCodeAt(pe),Ve=ae.charCodeAt(Ce);if(Ke<Ve)return-1;if(Ke>Ve)return 1}const ze=De-pe,Ye=Re-Ce;return ze<Ye?-1:ze>Ye?1:0}t.$Ue=b;function v(Z,ae){return B(Z,ae,0,Z.length,0,ae.length)}t.$Ve=v;function B(Z,ae,pe=0,De=Z.length,Ce=0,Re=ae.length){for(;pe<De&&Ce<Re;pe++,Ce++){let Ke=Z.charCodeAt(pe),Ve=ae.charCodeAt(Ce);if(Ke===Ve)continue;if(Ke>=128||Ve>=128)return b(Z.toLowerCase(),ae.toLowerCase(),pe,De,Ce,Re);W(Ke)&&(Ke-=32),W(Ve)&&(Ve-=32);const We=Ke-Ve;if(We!==0)return We}const ze=De-pe,Ye=Re-Ce;return ze<Ye?-1:ze>Ye?1:0}t.$We=B;function j(Z){return Z>=48&&Z<=57}t.$Xe=j;function W(Z){return Z>=97&&Z<=122}t.$Ye=W;function M(Z){return Z>=65&&Z<=90}t.$Ze=M;function F(Z,ae){return Z.length===ae.length&&B(Z,ae)===0}t.$1e=F;function J(Z,ae){const pe=ae.length;return ae.length>Z.length?!1:B(Z,ae,0,pe)===0}t.$2e=J;function ee(Z,ae){const pe=Math.min(Z.length,ae.length);let De;for(De=0;De<pe;De++)if(Z.charCodeAt(De)!==ae.charCodeAt(De))return De;return pe}t.$3e=ee;function ne(Z,ae){const pe=Math.min(Z.length,ae.length);let De;const Ce=Z.length-1,Re=ae.length-1;for(De=0;De<pe;De++)if(Z.charCodeAt(Ce-De)!==ae.charCodeAt(Re-De))return De;return pe}t.$4e=ne;function ue(Z){return 55296<=Z&&Z<=56319}t.$5e=ue;function le(Z){return 56320<=Z&&Z<=57343}t.$6e=le;function oe(Z,ae){return(Z-55296<<10)+(ae-56320)+65536}t.$7e=oe;function me(Z,ae,pe){const De=Z.charCodeAt(pe);if(ue(De)&&pe+1<ae){const Ce=Z.charCodeAt(pe+1);if(le(Ce))return oe(De,Ce)}return De}t.$8e=me;function Se(Z,ae){const pe=Z.charCodeAt(ae-1);if(le(pe)&&ae>1){const De=Z.charCodeAt(ae-2);if(ue(De))return oe(De,pe)}return pe}class Le{get offset(){return this.e}constructor(ae,pe=0){this.c=ae,this.d=ae.length,this.e=pe}setOffset(ae){this.e=ae}prevCodePoint(){const ae=Se(this.c,this.e);return this.e-=ae>=65536?2:1,ae}nextCodePoint(){const ae=me(this.c,this.d,this.e);return this.e+=ae>=65536?2:1,ae}eol(){return this.e>=this.d}}t.$9e=Le;class Ne{get offset(){return this.c.offset}constructor(ae,pe=0){this.c=new Le(ae,pe)}nextGraphemeLength(){const ae=Ae.getInstance(),pe=this.c,De=pe.offset;let Ce=ae.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Re=pe.offset,ze=ae.getGraphemeBreakType(pe.nextCodePoint());if(we(Ce,ze)){pe.setOffset(Re);break}Ce=ze}return pe.offset-De}prevGraphemeLength(){const ae=Ae.getInstance(),pe=this.c,De=pe.offset;let Ce=ae.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Re=pe.offset,ze=ae.getGraphemeBreakType(pe.prevCodePoint());if(we(ze,Ce)){pe.setOffset(Re);break}Ce=ze}return De-pe.offset}eol(){return this.c.eol()}}t.$0e=Ne;function de(Z,ae){return new Ne(Z,ae).nextGraphemeLength()}t.$$e=de;function ie(Z,ae){return new Ne(Z,ae).prevGraphemeLength()}t.$_e=ie;function fe(Z,ae){ae>0&&le(Z.charCodeAt(ae))&&ae--;const pe=ae+de(Z,ae);return[pe-ie(Z,pe),pe]}t.$af=fe;function X(Z){const ae=new Ne(Z);let pe=0;for(;!ae.eol();)pe++,ae.nextGraphemeLength();return pe}t.$bf=X;let q;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function E(Z){return q||(q=G()),q.test(Z)}t.$cf=E;const x=/^[\t\n\r\x20-\x7E]*$/;function g(Z){return x.test(Z)}t.$df=g,t.$ef=/[\u2028\u2029]/;function p(Z){return t.$ef.test(Z)}t.$ff=p;function V(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}t.$gf=V;function T(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}t.$hf=T;function N(Z,ae){if(Z.length<ae)return Z;const pe=/\b/g;let De=0;for(;pe.test(Z)&&!(Z.length-pe.lastIndex<ae);)De=pe.lastIndex,pe.lastIndex+=1;return Z.substring(De).replace(/^\s/,"")}t.$if=N;const O=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,_=/\x1b\].*?\x07/g;function S(Z){return Z&&(Z=Z.replace(O,"").replace(_,"")),Z}t.$jf=S,t.$kf=String.fromCharCode(65279);function R(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}t.$lf=R;function A(Z){return R(Z)?Z.substr(1):Z}t.$mf=A;function k(Z,ae){if(!Z||!ae||Z.length<ae.length)return!1;const pe=ae.length,De=Z.toLowerCase();let Ce=0,Re=-1;for(;Ce<pe;){const ze=De.indexOf(ae[Ce],Re+1);if(ze<0)return!1;Re=ze,Ce++}return!0}t.$nf=k;function H(Z,ae=!1){return Z?(ae&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}t.$of=H;function K(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}t.$pf=K;function te(Z,ae=1){if(ae===0)return"";let pe=-1;do pe=Z.indexOf(`
`,pe+1),ae--;while(ae>0&&pe>=0);return pe===-1?Z:(Z[pe-1]==="\r"&&pe--,Z.substr(0,pe))}t.$qf=te;function se(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}t.$rf=se;function ge(Z){return Ae.getInstance().getGraphemeBreakType(Z)}t.$sf=ge;function we(Z,ae){return Z===0?ae!==5&&ae!==7:Z===2&&ae===3?!1:Z===4||Z===2||Z===3||ae===4||ae===2||ae===3?!0:!(Z===8&&(ae===8||ae===9||ae===11||ae===12)||(Z===11||Z===9)&&(ae===9||ae===10)||(Z===12||Z===10)&&ae===10||ae===5||ae===13||ae===7||Z===1||Z===13&&ae===14||Z===6&&ae===6)}var Fe;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(Fe||(t.GraphemeBreakType=Fe={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=ve()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const pe=this.d,De=pe.length/3;let Ce=1;for(;Ce<=De;)if(ae<pe[3*Ce])Ce=2*Ce;else if(ae>pe[3*Ce+1])Ce=2*Ce+1;else return pe[3*Ce+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(Z,ae){if(Z===0)return 0;const pe=Oe(Z,ae);if(pe!==void 0)return pe;const De=new Le(ae,Z);return De.prevCodePoint(),De.offset}t.$tf=Me;function Oe(Z,ae){const pe=new Le(ae,Z);let De=pe.prevCodePoint();for(;_e(De)||De===65039||De===8419;){if(pe.offset===0)return;De=pe.prevCodePoint()}if(!T(De))return;let Ce=pe.offset;return Ce>0&&pe.prevCodePoint()===8205&&(Ce=pe.offset),Ce}function _e(Z){return 127995<=Z&&Z<=127999}var je;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),t.$uf="\xA0";class Ie{static{this.c=new P.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new y.$we(ae=>{function pe(We){const et=new Map;for(let it=0;it<We.length;it+=2)et.set(We[it],We[it+1]);return et}function De(We,et){const it=new Map(We);for(const[ft,ut]of et)it.set(ft,ut);return it}function Ce(We,et){if(!We)return et;const it=new Map;for(const[ft,ut]of We)et.has(ft)&&it.set(ft,ut);return it}const Re=this.c.value;let ze=ae.filter(We=>!We.startsWith("_")&&We in Re);ze.length===0&&(ze=["_default"]);let Ye;for(const We of ze){const et=pe(Re[We]);Ye=Ce(Ye,et)}const Ke=pe(Re._common),Ve=De(Ke,Ye);return new Ie(Ve)})}static getInstance(ae){return Ie.d.get(Array.from(ae))}static{this.e=new P.$U(()=>Object.keys(Ie.c.value).filter(ae=>!ae.startsWith("_")))}static getLocales(){return Ie.e.value}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$vf=Ie;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(ae){return Ge.e().has(ae)}static get codePoints(){return Ge.e()}}t.$wf=Ge}),define(be[33],$e([1,0,31,12]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pj=t.$Oj=t.$Nj=t.$Mj=t.FuzzyScore=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Fj=t.$Ej=t.$Dj=t.$Cj=t.$Bj=t.$Aj=t.or=void 0;function i(...A){return function(k,H){for(let K=0,te=A.length;K<te;K++){const se=A[K](k,H);if(se)return se}return null}}t.or=i,t.$Aj=U.bind(void 0,!1),t.$Bj=U.bind(void 0,!0);function U(A,k,H){if(!H||H.length<k.length)return null;let K;return A?K=P.$2e(H,k):K=H.indexOf(k)===0,K?k.length>0?[{start:0,end:k.length}]:[]:null}function w(A,k){const H=k.toLowerCase().indexOf(A.toLowerCase());return H===-1?null:[{start:H,end:H+A.length}]}t.$Cj=w;function D(A,k){return h(A.toLowerCase(),k.toLowerCase(),0,0)}t.$Dj=D;function h(A,k,H,K){if(H===A.length)return[];if(K===k.length)return null;if(A[H]===k[K]){let te=null;return(te=h(A,k,H+1,K+1))?m({start:K,end:K+1},te):null}return h(A,k,H,K+1)}function f(A){return 97<=A&&A<=122}function d(A){return 65<=A&&A<=90}t.$Ej=d;function L(A){return 48<=A&&A<=57}function s(A){return A===32||A===9||A===10||A===13}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(A=>a.add(A.charCodeAt(0)));function e(A){return s(A)||a.has(A)}function u(A,k){return A===k||e(A)&&e(k)}function l(A){return f(A)||d(A)||L(A)}function m(A,k){return k.length===0?k=[A]:A.end===k[0].start?k[0].start=A.start:k.unshift(A),k}function n(A,k){for(let H=k;H<A.length;H++){const K=A.charCodeAt(H);if(d(K)||L(K)||H>0&&!l(A.charCodeAt(H-1)))return H}return A.length}function r(A,k,H,K){if(H===A.length)return[];if(K===k.length)return null;if(A[H]!==k[K].toLowerCase())return null;{let te=null,se=K+1;for(te=r(A,k,H+1,K+1);!te&&(se=n(k,se))<k.length;)te=r(A,k,H+1,se),se++;return te===null?null:m({start:K,end:K+1},te)}}function $(A){let k=0,H=0,K=0,te=0,se=0;for(let ve=0;ve<A.length;ve++)se=A.charCodeAt(ve),d(se)&&k++,f(se)&&H++,l(se)&&K++,L(se)&&te++;const ge=k/A.length,we=H/A.length,Fe=K/A.length,Ae=te/A.length;return{upperPercent:ge,lowerPercent:we,alphaPercent:Fe,numericPercent:Ae}}function c(A){const{upperPercent:k,lowerPercent:H}=A;return H===0&&k>.6}function o(A){const{upperPercent:k,lowerPercent:H,alphaPercent:K,numericPercent:te}=A;return H>.2&&k<.8&&K>.6&&te<.2}function C(A){let k=0,H=0,K=0,te=0;for(let se=0;se<A.length;se++)K=A.charCodeAt(se),d(K)&&k++,f(K)&&H++,s(K)&&te++;return(k===0||H===0)&&te===0?A.length<=30:k<=5}function z(A,k){if(!k||(k=k.trim(),k.length===0)||!C(A)||k.length>60)return null;const H=$(k);if(!o(H)){if(!c(H))return null;k=k.toLowerCase()}let K=null,te=0;for(A=A.toLowerCase();te<k.length&&(K=r(A,k,0,te))===null;)te=n(k,te+1);return K}t.$Fj=z;function I(A,k,H=!1){if(!k||k.length===0)return null;let K=null,te=0;for(A=A.toLowerCase(),k=k.toLowerCase();te<k.length&&(K=b(A,k,0,te,H))===null;)te=v(k,te+1);return K}t.$Gj=I;function b(A,k,H,K,te){if(H===A.length)return[];if(K===k.length)return null;if(u(A.charCodeAt(H),k.charCodeAt(K))){let se=null,ge=K+1;if(se=b(A,k,H+1,K+1,te),!te)for(;!se&&(ge=v(k,ge))<k.length;)se=b(A,k,H+1,ge,te),ge++;return se?A.charCodeAt(H)!==k.charCodeAt(K)?se:m({start:K,end:K+1},se):null}else return null}function v(A,k){for(let H=k;H<A.length;H++)if(e(A.charCodeAt(H))||H>0&&e(A.charCodeAt(H-1)))return H;return A.length}const B=i(t.$Bj,z,w),j=i(t.$Bj,z,D),W=new y.$Cc(1e4);function M(A,k,H=!1){if(typeof A!="string"||typeof k!="string")return null;let K=W.get(A);K||(K=new RegExp(P.$Ke(A),"i"),W.set(A,K));const te=K.exec(k);return te?[{start:te.index,end:te.index+te[0].length}]:H?j(A,k):B(A,k)}t.$Hj=M;function F(A,k){const H=V(A,A.toLowerCase(),0,k,k.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?ee(H):null}t.$Ij=F;function J(A,k,H,K,te,se){const ge=Math.min(13,A.length);for(;H<ge;H++){const we=V(A,k,H,K,te,se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,se]}t.$Jj=J;function ee(A){if(typeof A>"u")return[];const k=[],H=A[1];for(let K=A.length-1;K>1;K--){const te=A[K]+H,se=k[k.length-1];se&&se.end===te?se.end=te+1:k.push({start:te,end:te+1})}return k}t.$Kj=ee;const ne=128;function ue(){const A=[],k=[];for(let H=0;H<=ne;H++)k[H]=0;for(let H=0;H<=ne;H++)A.push(k.slice(0));return A}function le(A){const k=[];for(let H=0;H<=A;H++)k[H]=0;return k}const oe=le(2*ne),me=le(2*ne),Se=ue(),Le=ue(),Ne=ue(),de=!1;function ie(A,k,H,K,te){function se(we,Fe,Ae=" "){for(;we.length<Fe;)we=Ae+we;return we}let ge=` |   |${K.split("").map(we=>se(we,3)).join("|")}
`;for(let we=0;we<=H;we++)we===0?ge+=" |":ge+=`${k[we-1]}|`,ge+=A[we].slice(0,te+1).map(Fe=>se(Fe.toString(),3)).join("|")+`
`;return ge}function fe(A,k,H,K){A=A.substr(k),H=H.substr(K),console.log(ie(Le,A,A.length,H,H.length)),console.log(ie(Ne,A,A.length,H,H.length)),console.log(ie(Se,A,A.length,H,H.length))}function X(A,k){if(k<0||k>=A.length)return!1;const H=A.codePointAt(k);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.$hf(H)}}function q(A,k){if(k<0||k>=A.length)return!1;switch(A.charCodeAt(k)){case 32:case 9:return!0;default:return!1}}function G(A,k,H){return k[A]!==H[A]}function E(A,k,H,K,te,se,ge=!1){for(;k<H&&te<se;)A[k]===K[te]&&(ge&&(oe[k]=te),k+=1),te+=1;return k===H}t.$Lj=E;var x;(function(A){A[A.Diag=1]="Diag",A[A.Left=2]="Left",A[A.LeftLeft=3]="LeftLeft"})(x||(x={}));var g;(function(A){A.Default=[-100,0];function k(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}A.isDefault=k})(g||(t.FuzzyScore=g={}));class p{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(k,H){this.firstMatchCanBeWeak=k,this.boostFullMatch=H}}t.$Mj=p;function V(A,k,H,K,te,se,ge=p.default){const we=A.length>ne?ne:A.length,Fe=K.length>ne?ne:K.length;if(H>=we||se>=Fe||we-H>Fe-se||!E(k,H,we,te,se,Fe,!0))return;T(we,Fe,H,se,k,te);let Ae=1,ve=1,Me=H,Oe=se;const _e=[!1];for(Ae=1,Me=H;Me<we;Ae++,Me++){const ae=oe[Me],pe=me[Me],De=Me+1<we?me[Me+1]:Fe;for(ve=ae-se+1,Oe=ae;Oe<De;ve++,Oe++){let Ce=Number.MIN_SAFE_INTEGER,Re=!1;Oe<=pe&&(Ce=N(A,k,Me,H,K,te,Oe,Fe,se,Se[Ae-1][ve-1]===0,_e));let ze=0;Ce!==Number.MAX_SAFE_INTEGER&&(Re=!0,ze=Ce+Le[Ae-1][ve-1]);const Ye=Oe>ae,Ke=Ye?Le[Ae][ve-1]+(Se[Ae][ve-1]>0?-5:0):0,Ve=Oe>ae+1&&Se[Ae][ve-1]>0,We=Ve?Le[Ae][ve-2]+(Se[Ae][ve-2]>0?-5:0):0;if(Ve&&(!Ye||We>=Ke)&&(!Re||We>=ze))Le[Ae][ve]=We,Ne[Ae][ve]=3,Se[Ae][ve]=0;else if(Ye&&(!Re||Ke>=ze))Le[Ae][ve]=Ke,Ne[Ae][ve]=2,Se[Ae][ve]=0;else if(Re)Le[Ae][ve]=ze,Ne[Ae][ve]=1,Se[Ae][ve]=Se[Ae-1][ve-1]+1;else throw new Error("not possible")}}if(de&&fe(A,H,K,se),!_e[0]&&!ge.firstMatchCanBeWeak)return;Ae--,ve--;const je=[Le[Ae][ve],se];let Ie=0,Ge=0;for(;Ae>=1;){let ae=ve;do{const pe=Ne[Ae][ae];if(pe===3)ae=ae-2;else if(pe===2)ae=ae-1;else break}while(ae>=1);Ie>1&&k[H+Ae-1]===te[se+ve-1]&&!G(ae+se-1,K,te)&&Ie+1>Se[Ae][ae]&&(ae=ve),ae===ve?Ie++:Ie=1,Ge||(Ge=ae),Ae--,ve=ae-1,je.push(ve)}Fe===we&&ge.boostFullMatch&&(je[0]+=2);const Z=Ge-we;return je[0]-=Z,je}t.$Nj=V;function T(A,k,H,K,te,se){let ge=A-1,we=k-1;for(;ge>=H&&we>=K;)te[ge]===se[we]&&(me[ge]=we,ge--),we--}function N(A,k,H,K,te,se,ge,we,Fe,Ae,ve){if(k[H]!==se[ge])return Number.MIN_SAFE_INTEGER;let Me=1,Oe=!1;return ge===H-K?Me=A[H]===te[ge]?7:5:G(ge,te,se)&&(ge===0||!G(ge-1,te,se))?(Me=A[H]===te[ge]?7:5,Oe=!0):X(se,ge)&&(ge===0||!X(se,ge-1))?Me=5:(X(se,ge-1)||q(se,ge-1))&&(Me=5,Oe=!0),Me>1&&H===K&&(ve[0]=!0),Oe||(Oe=G(ge,te,se)||X(se,ge-1)||q(se,ge-1)),H===K?ge>Fe&&(Me-=Oe?3:5):Ae?Me+=Oe?2:0:Me+=Oe?0:1,ge+1===we&&(Me-=Oe?3:5),Me}function O(A,k,H,K,te,se,ge){return S(A,k,H,K,te,se,!0,ge)}t.$Oj=O;function _(A,k,H,K,te,se,ge){return S(A,k,H,K,te,se,!1,ge)}t.$Pj=_;function S(A,k,H,K,te,se,ge,we){let Fe=V(A,k,H,K,te,se,we);if(Fe&&!ge)return Fe;if(A.length>=3){const Ae=Math.min(7,A.length-1);for(let ve=H+1;ve<Ae;ve++){const Me=R(A,ve);if(Me){const Oe=V(Me,Me.toLowerCase(),H,K,te,se,we);Oe&&(Oe[0]-=3,(!Fe||Oe[0]>Fe[0])&&(Fe=Oe))}}}return Fe}function R(A,k){if(k+1>=A.length)return;const H=A[k],K=A[k+1];if(H!==K)return A.slice(0,k)+K+H+A.slice(k+2)}}),define(be[84],$e([1,0,12]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hi=t.$Gi=t.$Fi=t.$Ei=t.$Di=t.$Ci=t.$Bi=void 0;function P(m){return i(m,0)}t.$Bi=P;function i(m,n){switch(typeof m){case"object":return m===null?U(349,n):Array.isArray(m)?h(m,n):f(m,n);case"string":return D(m,n);case"boolean":return w(m,n);case"number":return U(m,n);case"undefined":return U(937,n);default:return U(617,n)}}t.$Ci=i;function U(m,n){return(n<<5)-n+m|0}t.$Di=U;function w(m,n){return U(m?433:863,n)}function D(m,n){n=U(149417,n);for(let r=0,$=m.length;r<$;r++)n=U(m.charCodeAt(r),n);return n}t.$Ei=D;function h(m,n){return n=U(104579,n),m.reduce((r,$)=>i($,r),n)}function f(m,n){return n=U(181387,n),Object.keys(m).sort().reduce((r,$)=>(r=D($,r),i(m[$],r)),n)}class d{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=i(n,this.g),this.g}}t.$Fi=d;var L;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function s(m,n,r=32){const $=r-n,c=~((1<<$)-1);return(m<<n|(c&m)>>>$)>>>0}function a(m,n=0,r=m.byteLength,$=0){for(let c=0;c<r;c++)m[n+c]=$}function e(m,n,r="0"){for(;m.length<n;)m=r+m;return m}function u(m,n=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((m>>>0).toString(16),n/4)}t.$Gi=u;class l{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const r=n.length;if(r===0)return;const $=this.p;let c=this.r,o=this.u,C,z;for(o!==0?(C=o,z=-1,o=0):(C=n.charCodeAt(0),z=0);;){let I=C;if(y.$5e(C))if(z+1<r){const b=n.charCodeAt(z+1);y.$6e(b)?(z++,I=y.$7e(C,b)):I=65533}else{o=C;break}else y.$6e(C)&&(I=65533);if(c=this.w($,c,I),z++,z<r)C=n.charCodeAt(z);else break}this.r=c,this.u=o}w(n,r,$){return $<128?n[r++]=$:$<2048?(n[r++]=192|($&1984)>>>6,n[r++]=128|($&63)>>>0):$<65536?(n[r++]=224|($&61440)>>>12,n[r++]=128|($&4032)>>>6,n[r++]=128|($&63)>>>0):(n[r++]=240|($&1835008)>>>18,n[r++]=128|($&258048)>>>12,n[r++]=128|($&4032)>>>6,n[r++]=128|($&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=l.g,r=this.q;for(let B=0;B<64;B+=4)n.setUint32(B,r.getUint32(B,!1),!1);for(let B=64;B<320;B+=4)n.setUint32(B,s(n.getUint32(B-12,!1)^n.getUint32(B-32,!1)^n.getUint32(B-56,!1)^n.getUint32(B-64,!1),1),!1);let $=this.h,c=this.l,o=this.m,C=this.n,z=this.o,I,b,v;for(let B=0;B<80;B++)B<20?(I=c&o|~c&C,b=1518500249):B<40?(I=c^o^C,b=1859775393):B<60?(I=c&o|c&C|o&C,b=2400959708):(I=c^o^C,b=3395469782),v=s($,5)+I+z+b+n.getUint32(B*4,!1)&4294967295,z=C,C=o,o=s(c,30),c=$,$=v;this.h=this.h+$&4294967295,this.l=this.l+c&4294967295,this.m=this.m+o&4294967295,this.n=this.n+C&4294967295,this.o=this.o+z&4294967295}}t.$Hi=l}),define(be[85],$e([1,0,73,84]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vs=t.$us=t.$ts=void 0;class i{constructor(s){this.a=s}getElements(){const s=this.a,a=new Int32Array(s.length);for(let e=0,u=s.length;e<u;e++)a[e]=s.charCodeAt(e);return a}}t.$ts=i;function U(L,s,a){return new d(new i(L),new i(s)).ComputeDiff(a).changes}t.$us=U;class w{static Assert(s,a){if(!s)throw new Error(a)}}class D{static Copy(s,a,e,u,l){for(let m=0;m<l;m++)e[u+m]=s[a+m]}static Copy2(s,a,e,u,l){for(let m=0;m<l;m++)e[u+m]=s[a+m]}}var h;(function(L){L[L.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(h||(h={}));class f{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new y.$ss(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.d++}AddModifiedElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class d{constructor(s,a,e=null){this.a=e,this.b=s,this.c=a;const[u,l,m]=d.o(s),[n,r,$]=d.o(a);this.d=m&&$,this.e=u,this.f=l,this.g=n,this.h=r,this.k=[],this.m=[]}static n(s){return s.length>0&&typeof s[0]=="string"}static o(s){const a=s.getElements();if(d.n(a)){const e=new Int32Array(a.length);for(let u=0,l=a.length;u<l;u++)e[u]=(0,P.$Ei)(a[u],0);return[a,e,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}p(s,a){return this.f[s]!==this.h[a]?!1:this.d?this.e[s]===this.g[a]:!0}q(s,a){if(!this.p(s,a))return!1;const e=d.r(this.b,s),u=d.r(this.c,a);return e===u}static r(s,a){return typeof s.getStrictElement=="function"?s.getStrictElement(a):null}s(s,a){return this.f[s]!==this.f[a]?!1:this.d?this.e[s]===this.e[a]:!0}u(s,a){return this.h[s]!==this.h[a]?!1:this.d?this.g[s]===this.g[a]:!0}ComputeDiff(s){return this.v(0,this.f.length-1,0,this.h.length-1,s)}v(s,a,e,u,l){const m=[!1];let n=this.w(s,a,e,u,m);return l&&(n=this.z(n)),{quitEarly:m[0],changes:n}}w(s,a,e,u,l){for(l[0]=!1;s<=a&&e<=u&&this.p(s,e);)s++,e++;for(;a>=s&&u>=e&&this.p(a,u);)a--,u--;if(s>a||e>u){let o;return e<=u?(w.Assert(s===a+1,"originalStart should only be one more than originalEnd"),o=[new y.$ss(s,0,e,u-e+1)]):s<=a?(w.Assert(e===u+1,"modifiedStart should only be one more than modifiedEnd"),o=[new y.$ss(s,a-s+1,e,0)]):(w.Assert(s===a+1,"originalStart should only be one more than originalEnd"),w.Assert(e===u+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const m=[0],n=[0],r=this.y(s,a,e,u,m,n,l),$=m[0],c=n[0];if(r!==null)return r;if(!l[0]){const o=this.w(s,$,e,c,l);let C=[];return l[0]?C=[new y.$ss($+1,a-($+1)+1,c+1,u-(c+1)+1)]:C=this.w($+1,a,c+1,u,l),this.H(o,C)}return[new y.$ss(s,a-s+1,e,u-e+1)]}x(s,a,e,u,l,m,n,r,$,c,o,C,z,I,b,v,B,j){let W=null,M=null,F=new f,J=a,ee=e,ne=z[0]-v[0]-u,ue=-1073741824,le=this.k.length-1;do{const oe=ne+s;oe===J||oe<ee&&$[oe-1]<$[oe+1]?(o=$[oe+1],I=o-ne-u,o<ue&&F.MarkNextChange(),ue=o,F.AddModifiedElement(o+1,I),ne=oe+1-s):(o=$[oe-1]+1,I=o-ne-u,o<ue&&F.MarkNextChange(),ue=o-1,F.AddOriginalElement(o,I+1),ne=oe-1-s),le>=0&&($=this.k[le],s=$[0],J=1,ee=$.length-1)}while(--le>=-1);if(W=F.getReverseChanges(),j[0]){let oe=z[0]+1,me=v[0]+1;if(W!==null&&W.length>0){const Se=W[W.length-1];oe=Math.max(oe,Se.getOriginalEnd()),me=Math.max(me,Se.getModifiedEnd())}M=[new y.$ss(oe,C-oe+1,me,b-me+1)]}else{F=new f,J=m,ee=n,ne=z[0]-v[0]-r,ue=1073741824,le=B?this.m.length-1:this.m.length-2;do{const oe=ne+l;oe===J||oe<ee&&c[oe-1]>=c[oe+1]?(o=c[oe+1]-1,I=o-ne-r,o>ue&&F.MarkNextChange(),ue=o+1,F.AddOriginalElement(o+1,I+1),ne=oe+1-l):(o=c[oe-1],I=o-ne-r,o>ue&&F.MarkNextChange(),ue=o,F.AddModifiedElement(o+1,I+1),ne=oe-1-l),le>=0&&(c=this.m[le],l=c[0],J=1,ee=c.length-1)}while(--le>=-1);M=F.getChanges()}return this.H(W,M)}y(s,a,e,u,l,m,n){let r=0,$=0,c=0,o=0,C=0,z=0;s--,e--,l[0]=0,m[0]=0,this.k=[],this.m=[];const I=a-s+(u-e),b=I+1,v=new Int32Array(b),B=new Int32Array(b),j=u-e,W=a-s,M=s-e,F=a-u,ee=(W-j)%2===0;v[j]=s,B[W]=a,n[0]=!1;for(let ne=1;ne<=I/2+1;ne++){let ue=0,le=0;c=this.J(j-ne,ne,j,b),o=this.J(j+ne,ne,j,b);for(let me=c;me<=o;me+=2){me===c||me<o&&v[me-1]<v[me+1]?r=v[me+1]:r=v[me-1]+1,$=r-(me-j)-M;const Se=r;for(;r<a&&$<u&&this.p(r+1,$+1);)r++,$++;if(v[me]=r,r+$>ue+le&&(ue=r,le=$),!ee&&Math.abs(me-W)<=ne-1&&r>=B[me])return l[0]=r,m[0]=$,Se<=B[me]&&1447>0&&ne<=1447+1?this.x(j,c,o,M,W,C,z,F,v,B,r,a,l,$,u,m,ee,n):null}const oe=(ue-s+(le-e)-ne)/2;if(this.a!==null&&!this.a(ue,oe))return n[0]=!0,l[0]=ue,m[0]=le,oe>0&&1447>0&&ne<=1447+1?this.x(j,c,o,M,W,C,z,F,v,B,r,a,l,$,u,m,ee,n):(s++,e++,[new y.$ss(s,a-s+1,e,u-e+1)]);C=this.J(W-ne,ne,W,b),z=this.J(W+ne,ne,W,b);for(let me=C;me<=z;me+=2){me===C||me<z&&B[me-1]>=B[me+1]?r=B[me+1]-1:r=B[me-1],$=r-(me-W)-F;const Se=r;for(;r>s&&$>e&&this.p(r,$);)r--,$--;if(B[me]=r,ee&&Math.abs(me-j)<=ne&&r<=v[me])return l[0]=r,m[0]=$,Se>=v[me]&&1447>0&&ne<=1447+1?this.x(j,c,o,M,W,C,z,F,v,B,r,a,l,$,u,m,ee,n):null}if(ne<=1447){let me=new Int32Array(o-c+2);me[0]=j-c+1,D.Copy2(v,c,me,1,o-c+1),this.k.push(me),me=new Int32Array(z-C+2),me[0]=W-C+1,D.Copy2(B,C,me,1,z-C+1),this.m.push(me)}}return this.x(j,c,o,M,W,C,z,F,v,B,r,a,l,$,u,m,ee,n)}z(s){for(let a=0;a<s.length;a++){const e=s[a],u=a<s.length-1?s[a+1].originalStart:this.f.length,l=a<s.length-1?s[a+1].modifiedStart:this.h.length,m=e.originalLength>0,n=e.modifiedLength>0;for(;e.originalStart+e.originalLength<u&&e.modifiedStart+e.modifiedLength<l&&(!m||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!n||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const $=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!$)break;e.originalStart++,e.modifiedStart++}const r=[null];if(a<s.length-1&&this.I(s[a],s[a+1],r)){s[a]=r[0],s.splice(a+1,1),a--;continue}}for(let a=s.length-1;a>=0;a--){const e=s[a];let u=0,l=0;if(a>0){const o=s[a-1];u=o.originalStart+o.originalLength,l=o.modifiedStart+o.modifiedLength}const m=e.originalLength>0,n=e.modifiedLength>0;let r=0,$=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let o=1;;o++){const C=e.originalStart-o,z=e.modifiedStart-o;if(C<u||z<l||m&&!this.s(C,C+e.originalLength)||n&&!this.u(z,z+e.modifiedLength))break;const b=(C===u&&z===l?5:0)+this.G(C,e.originalLength,z,e.modifiedLength);b>$&&($=b,r=o)}e.originalStart-=r,e.modifiedStart-=r;const c=[null];if(a>0&&this.I(s[a-1],s[a],c)){s[a-1]=c[0],s.splice(a,1),a++;continue}}if(this.d)for(let a=1,e=s.length;a<e;a++){const u=s[a-1],l=s[a],m=l.originalStart-u.originalStart-u.originalLength,n=u.originalStart,r=l.originalStart+l.originalLength,$=r-n,c=u.modifiedStart,o=l.modifiedStart+l.modifiedLength,C=o-c;if(m<5&&$<20&&C<20){const z=this.A(n,$,c,C,m);if(z){const[I,b]=z;(I!==u.originalStart+u.originalLength||b!==u.modifiedStart+u.modifiedLength)&&(u.originalLength=I-u.originalStart,u.modifiedLength=b-u.modifiedStart,l.originalStart=I+m,l.modifiedStart=b+m,l.originalLength=r-l.originalStart,l.modifiedLength=o-l.modifiedStart)}}}return s}A(s,a,e,u,l){if(a<l||u<l)return null;const m=s+a-l+1,n=e+u-l+1;let r=0,$=0,c=0;for(let o=s;o<m;o++)for(let C=e;C<n;C++){const z=this.B(o,C,l);z>0&&z>r&&(r=z,$=o,c=C)}return r>0?[$,c]:null}B(s,a,e){let u=0;for(let l=0;l<e;l++){if(!this.p(s+l,a+l))return 0;u+=this.e[s+l].length}return u}C(s){return s<=0||s>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[s])}D(s,a){if(this.C(s)||this.C(s-1))return!0;if(a>0){const e=s+a;if(this.C(e-1)||this.C(e))return!0}return!1}E(s){return s<=0||s>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[s])}F(s,a){if(this.E(s)||this.E(s-1))return!0;if(a>0){const e=s+a;if(this.E(e-1)||this.E(e))return!0}return!1}G(s,a,e,u){const l=this.D(s,a)?1:0,m=this.F(e,u)?1:0;return l+m}H(s,a){const e=[];if(s.length===0||a.length===0)return a.length>0?a:s;if(this.I(s[s.length-1],a[0],e)){const u=new Array(s.length+a.length-1);return D.Copy(s,0,u,0,s.length-1),u[s.length-1]=e[0],D.Copy(a,1,u,s.length,a.length-1),u}else{const u=new Array(s.length+a.length);return D.Copy(s,0,u,0,s.length),D.Copy(a,0,u,s.length,a.length),u}}I(s,a,e){if(w.Assert(s.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),w.Assert(s.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),s.originalStart+s.originalLength>=a.originalStart||s.modifiedStart+s.modifiedLength>=a.modifiedStart){const u=s.originalStart;let l=s.originalLength;const m=s.modifiedStart;let n=s.modifiedLength;return s.originalStart+s.originalLength>=a.originalStart&&(l=a.originalStart+a.originalLength-s.originalStart),s.modifiedStart+s.modifiedLength>=a.modifiedStart&&(n=a.modifiedStart+a.modifiedLength-s.modifiedStart),e[0]=new y.$ss(u,l,m,n),!0}else return e[0]=null,!1}J(s,a,e,u){if(s>=0&&s<u)return s;const l=e,m=u-e-1,n=a%2===0;if(s<0){const r=l%2===0;return n===r?0:1}else{const r=m%2===0;return n===r?u-1:u-2}}}t.$vs=d}),define(be[48],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jd=void 0,t.$Jd=Symbol("MicrotaskDelay")}),define(be[86],$e([1,0,11,12]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Th=t.$Sh=t.$Rh=t.$Qh=t.$Ph=void 0;class i{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const e=a.charCodeAt(0),u=this.b.charCodeAt(this.c);return e-u}value(){return this.b[this.c]}}t.$Ph=i;class U{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,P.$Ue)(a,this.b,0,a.length,this.c,this.d):(0,P.$We)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Qh=U;class w{constructor(a=!0,e=!0){this.f=a,this.g=e}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let e=a.length-1;e>=0;e--,this.c--){const u=this.b.charCodeAt(e);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,P.$Ue)(a,this.b,0,a.length,this.d,this.e):(0,P.$We)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Rh=w;var D;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(D||(D={}));class h{constructor(a,e){this.f=a,this.g=e,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new w(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,P.$Ve)(a,this.c.scheme);if(this.d[this.e]===2)return(0,P.$Ve)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,P.$Te)(a,this.c.query);if(this.d[this.e]===5)return(0,P.$Te)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Sh=h;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(d||(d={}));class L{static forUris(a=()=>!1,e=()=>!1){return new L(new h(a,e))}static forPaths(a=!1){return new L(new w(void 0,!a))}static forStrings(){return new L(new i)}static forConfigKeys(){return new L(new U)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,e){if(e){const u=e.slice(0);(0,y.$Wb)(u);for(const l of u)this.set(l,a)}else{const u=a.slice(0);(0,y.$Wb)(u);for(const l of u)this.set(l[0],l[1])}}set(a,e){const u=this.b.reset(a);let l;this.c||(this.c=new f,this.c.segment=u.value());const m=[];for(l=this.c;;){const r=u.cmp(l.segment);if(r>0)l.left||(l.left=new f,l.left.segment=u.value()),m.push([-1,l]),l=l.left;else if(r<0)l.right||(l.right=new f,l.right.segment=u.value()),m.push([1,l]),l=l.right;else if(u.hasNext())u.next(),l.mid||(l.mid=new f,l.mid.segment=u.value()),m.push([0,l]),l=l.mid;else break}const n=l.value;l.value=e,l.key=a;for(let r=m.length-1;r>=0;r--){const $=m[r][1];$.updateHeight();const c=$.balanceFactor();if(c<-1||c>1){const o=m[r][0],C=m[r+1][0];if(o===1&&C===1)m[r][1]=$.rotateLeft();else if(o===-1&&C===-1)m[r][1]=$.rotateRight();else if(o===1&&C===-1)$.right=m[r+1][1]=m[r+1][1].rotateRight(),m[r][1]=$.rotateLeft();else if(o===-1&&C===1)$.left=m[r+1][1]=m[r+1][1].rotateLeft(),m[r][1]=$.rotateRight();else throw new Error;if(r>0)switch(m[r-1][0]){case-1:m[r-1][1].left=m[r][1];break;case 1:m[r-1][1].right=m[r][1];break;case 0:m[r-1][1].mid=m[r][1];break}else this.c=m[0][1]}}return n}get(a){return this.d(a)?.value}d(a){const e=this.b.reset(a);let u=this.c;for(;u;){const l=e.cmp(u.segment);if(l>0)u=u.left;else if(l<0)u=u.right;else if(e.hasNext())e.next(),u=u.mid;else break}return u}has(a){const e=this.d(a);return!(e?.value===void 0&&e?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,e){const u=this.b.reset(a),l=[];let m=this.c;for(;m;){const n=u.cmp(m.segment);if(n>0)l.push([-1,m]),m=m.left;else if(n<0)l.push([1,m]),m=m.right;else if(u.hasNext())u.next(),l.push([0,m]),m=m.mid;else break}if(m){if(e?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this.f(m.right);if(n.key){const{key:r,value:$,segment:c}=n;this.e(n.key,!1),m.key=r,m.value=$,m.segment=c}}else{const n=m.left??m.right;if(l.length>0){const[r,$]=l[l.length-1];switch(r){case-1:$.left=n;break;case 0:$.mid=n;break;case 1:$.right=n;break}}else this.c=n}for(let n=l.length-1;n>=0;n--){const r=l[n][1];r.updateHeight();const $=r.balanceFactor();if($>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),l[n][1]=r.rotateLeft()):$<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),l[n][1]=r.rotateRight()),n>0)switch(l[n-1][0]){case-1:l[n-1][1].left=l[n][1];break;case 1:l[n-1][1].right=l[n][1];break;case 0:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const e=this.b.reset(a);let u=this.c,l;for(;u;){const m=e.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(e.hasNext())e.next(),l=u.value||l,u=u.mid;else break}return u&&u.value||l}findSuperstr(a){return this.g(a,!1)}g(a,e){const u=this.b.reset(a);let l=this.c;for(;l;){const m=u.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(u.hasNext())u.next(),l=l.mid;else return l.mid?this.h(l.mid):e?l.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[e,u]of this)a(u,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const e=[];return this.j(a,e),e[Symbol.iterator]()}j(a,e){a&&(a.left&&this.j(a.left,e),a.value&&e.push([a.key,a.value]),a.mid&&this.j(a.mid,e),a.right&&this.j(a.right,e))}_isBalanced(){const a=e=>{if(!e)return!0;const u=e.balanceFactor();return u<-1||u>1?!1:a(e.left)&&a(e.right)};return a(this.c)}}t.$Th=L}),define(be[7],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=void 0;function y(c){return typeof c=="string"}t.$xf=y;function P(c){return Array.isArray(c)&&c.every(o=>y(o))}t.$yf=P;function i(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.$zf=i;function U(c){const o=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof o}t.$Af=U;function w(c){return typeof c=="number"&&!isNaN(c)}t.$Bf=w;function D(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.$Cf=D;function h(c){return c===!0||c===!1}t.$Df=h;function f(c){return typeof c>"u"}t.$Ef=f;function d(c){return!L(c)}t.$Ff=d;function L(c){return f(c)||c===null}t.$Gf=L;function s(c,o){if(!c)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}t.$Hf=s;function a(c){if(L(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.$If=a;function e(...c){const o=[];for(let C=0;C<c.length;C++){const z=c[C];if(L(z))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);o.push(z)}return o}t.$Jf=e;const u=Object.prototype.hasOwnProperty;function l(c){if(!i(c))return!1;for(const o in c)if(u.call(c,o))return!1;return!0}t.$Kf=l;function m(c){return typeof c=="function"}t.$Lf=m;function n(...c){return c.length>0&&c.every(m)}t.$Mf=n;function r(c,o){const C=Math.min(c.length,o.length);for(let z=0;z<C;z++)$(c[z],o[z])}t.$Nf=r;function $(c,o){if(y(o)){if(typeof c!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(m(o)){try{if(c instanceof o)return}catch{}if(!L(c)&&c.constructor===o||o.length===1&&o.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Of=$}),define(be[17],$e([1,0,7]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sj=t.$Rj=t.$Qj=void 0;const P=Object.create(null);function i(D,h){if((0,y.$xf)(h)){const f=P[h];if(f===void 0)throw new Error(`${D} references an unknown codicon: ${h}`);h=f}return P[D]=h,{id:D}}function U(){return P}t.$Qj=U;function w(){return Object.values(t.$Sj)}t.$Rj=w,t.$Sj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(be[49],$e([1,0,7]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bn=t.$an=t.$_m=t.$$m=t.$0m=t.$9m=t.$8m=t.$7m=t.$6m=t.$5m=t.$4m=t.$3m=void 0;function P(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([r,$])=>{n[r]=$&&typeof $=="object"?P($):$}),n}t.$3m=P;function i(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const r=n.shift();Object.freeze(r);for(const $ in r)if(U.call(r,$)){const c=r[$];typeof c=="object"&&!Object.isFrozen(c)&&!(0,y.$Af)(c)&&n.push(c)}}return m}t.$4m=i;const U=Object.prototype.hasOwnProperty;function w(m,n){return D(m,n,new Set)}t.$5m=w;function D(m,n,r){if((0,y.$Gf)(m))return m;const $=n(m);if(typeof $<"u")return $;if(Array.isArray(m)){const c=[];for(const o of m)c.push(D(o,n,r));return c}if((0,y.$zf)(m)){if(r.has(m))throw new Error("Cannot clone recursive data-structure");r.add(m);const c={};for(const o in m)U.call(m,o)&&(c[o]=D(m[o],n,r));return r.delete(m),c}return m}function h(m,n,r=!0){return(0,y.$zf)(m)?((0,y.$zf)(n)&&Object.keys(n).forEach($=>{$ in m?r&&((0,y.$zf)(m[$])&&(0,y.$zf)(n[$])?h(m[$],n[$],r):m[$]=n[$]):m[$]=n[$]}),m):n}t.$6m=h;function f(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let r,$;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(r=0;r<m.length;r++)if(!f(m[r],n[r]))return!1}else{const c=[];for($ in m)c.push($);c.sort();const o=[];for($ in n)o.push($);if(o.sort(),!f(c,o))return!1;for(r=0;r<c.length;r++)if(!f(m[c[r]],n[c[r]]))return!1}return!0}t.$7m=f;function d(m){const n=new Set;return JSON.stringify(m,(r,$)=>{if((0,y.$zf)($)||Array.isArray($)){if(n.has($))return"[Circular]";n.add($)}return $})}t.$8m=d;function L(m,n){const r=Object.create(null);return!m||!n||Object.keys(n).forEach(c=>{const o=m[c],C=n[c];f(o,C)||(r[c]=C)}),r}t.$9m=L;function s(m,n){const r=n.toLowerCase(),$=Object.keys(m).find(c=>c.toLowerCase()===r);return $?m[$]:m[n]}t.$0m=s;function a(m,n){const r=Object.create(null);for(const[$,c]of Object.entries(m))n($,c)&&(r[$]=c);return r}t.$$m=a;function e(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}t.$_m=e;function u(m){const n=[];for(const r of e(m))typeof m[r]=="function"&&n.push(r);return n}t.$an=u;function l(m,n){const r=c=>function(){const o=Array.prototype.slice.call(arguments,0);return n(c,o)},$={};for(const c of m)$[c]=r(c);return $}t.$bn=l}),define(be[18],$e([1,0,17]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$Tj=t.ThemeColor=void 0;var P;(function(w){function D(h){return h&&typeof h=="object"&&typeof h.id=="string"}w.isThemeColor=D})(P||(t.ThemeColor=P={}));function i(w){return{id:w}}t.$Tj=i;var U;(function(w){w.iconNameSegment="[A-Za-z0-9]+",w.iconNameExpression="[A-Za-z0-9-]+",w.iconModifierExpression="~[A-Za-z]+",w.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${w.iconNameExpression})(${w.iconModifierExpression})?$`);function h(n){const r=D.exec(n.id);if(!r)return h(y.$Sj.error);const[,$,c]=r,o=["codicon","codicon-"+$];return c&&o.push("codicon-modifier-"+c.substring(1)),o}w.asClassNameArray=h;function f(n){return h(n).join(" ")}w.asClassName=f;function d(n){return"."+h(n).join(".")}w.asCSSSelector=d;function L(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||P.isThemeColor(n.color))}w.isThemeIcon=L;const s=new RegExp(`^\\$\\((${w.iconNameExpression}(?:${w.iconModifierExpression})?)\\)$`);function a(n){const r=s.exec(n);if(!r)return;const[,$]=r;return{id:$}}w.fromString=a;function e(n){return{id:n}}w.fromId=e;function u(n,r){let $=n.id;const c=$.lastIndexOf("~");return c!==-1&&($=$.substring(0,c)),r&&($=`${$}~${r}`),{id:$}}w.modify=u;function l(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}w.getModifier=l;function m(n,r){return n.id===r.id&&n.color?.id===r.color?.id}w.isEqual=m})(U||(t.ThemeIcon=U={}))}),define(be[34],$e([1,0,33,12,18]),function(re,t,y,P,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zj=t.$Yj=t.$Xj=t.$Wj=t.$Vj=t.$Uj=void 0;const U="$(",w=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${w.source}`,"g");function h(m){return m.replace(D,(n,r)=>r?n:`\\${n}`)}t.$Uj=h;const f=new RegExp(`\\\\${w.source}`,"g");function d(m){return m.replace(f,n=>`\\${n}`)}t.$Vj=d;const L=new RegExp(`(\\s)?(\\\\)?${w.source}(\\s)?`,"g");function s(m){return m.indexOf(U)===-1?m:m.replace(L,(n,r,$,c)=>$?n:r||c||"")}t.$Wj=s;function a(m){return m?m.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}t.$Xj=a;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(m){e.lastIndex=0;let n="";const r=[];let $=0;for(;;){const c=e.lastIndex,o=e.exec(m),C=m.substring(c,o?.index);if(C.length>0){n+=C;for(let z=0;z<C.length;z++)r.push($)}if(!o)break;$+=o[0].length}return{text:n,iconOffsets:r}}t.$Yj=u;function l(m,n,r=!1){const{text:$,iconOffsets:c}=n;if(!c||c.length===0)return(0,y.$Hj)(m,$,r);const o=(0,P.$Ie)($," "),C=$.length-o.length,z=(0,y.$Hj)(m,o,r);if(z)for(const I of z){const b=c[I.start+C]+C;I.start+=b,I.end+=b}return z}t.$Zj=l}),define(be[87],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cT=t.$bT=void 0,t.$bT="vscode:contextmenu",t.$cT="vscode:onCloseContextMenu"}),define(be[88],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jT=void 0;class y{constructor(i,U){this.a=i,this.onMessage=U}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$jT=y}),define(be[50],$e([8]),{}),define(be[89],$e([8]),{}),define(be[90],$e([8]),{}),define(be[91],$e([8]),{}),define(be[92],$e([1,0,90,91]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[93],$e([8]),{}),define(be[94],$e([8]),{}),define(be[95],$e([8]),{}),define(be[96],$e([8]),{}),define(be[97],$e([8]),{}),define(be[98],$e([8]),{}),define(be[99],$e([8]),{}),define(be[100],$e([8]),{}),define(be[101],$e([8]),{}),define(be[102],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[103],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[104],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[105],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[106],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[107],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[108],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[109],$e([13,10]),function(re,t){return re.create("vs/base/common/actions",t)}),define(be[35],$e([1,0,3,2,109]),function(re,t,y,P,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xi=t.$wi=t.$vi=t.$ui=t.$ti=t.$si=void 0;class U extends P.$Rc{constructor(s,a="",e="",u=!0,l){super(),this.h=this.B(new y.$Md),this.onDidChange=this.h.event,this.w=!0,this.j=s,this.m=a,this.u=e,this.w=u,this.C=l}get id(){return this.j}get label(){return this.m}set label(s){this.D(s)}D(s){this.m!==s&&(this.m=s,this.h.fire({label:s}))}get tooltip(){return this.n||""}set tooltip(s){this.F(s)}F(s){this.n!==s&&(this.n=s,this.h.fire({tooltip:s}))}get class(){return this.u}set class(s){this.G(s)}G(s){this.u!==s&&(this.u=s,this.h.fire({class:s}))}get enabled(){return this.w}set enabled(s){this.H(s)}H(s){this.w!==s&&(this.w=s,this.h.fire({enabled:s}))}get checked(){return this.z}set checked(s){this.I(s)}I(s){this.z!==s&&(this.z=s,this.h.fire({checked:s}))}async run(s,a){this.C&&await this.C(s)}}t.$si=U;class w extends P.$Rc{constructor(){super(...arguments),this.f=this.B(new y.$Md),this.onWillRun=this.f.event,this.m=this.B(new y.$Md),this.onDidRun=this.m.event}async run(s,a){if(!s.enabled)return;this.f.fire({action:s});let e;try{await this.u(s,a)}catch(u){e=u}this.m.fire({action:s,error:e})}async u(s,a){await s.run(a)}}t.$ti=w;class D{constructor(){this.id=D.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...s){let a=[];for(const e of s)e.length&&(a.length?a=[...a,new D,...e]:a=e);return a}static{this.ID="vs.actions.separator"}async run(){}}t.$ui=D;class h{get actions(){return this.a}constructor(s,a,e,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=s,this.label=a,this.class=u,this.a=e}async run(){}}t.$vi=h;class f extends U{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,i.localize(0,null),void 0,!1)}}t.$wi=f;function d(L){return{id:L.id,label:L.label,class:void 0,enabled:L.enabled??!0,checked:L.checked??!1,run:async(...s)=>L.run(...s),tooltip:L.label}}t.$xi=d}),define(be[110],$e([13,10]),function(re,t){return re.create("vs/base/common/platform",t)}),define(be[5],$e([1,0,110]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$h=t.$g=void 0,t.$g="en";let P=!1,i=!1,U=!1,w=!1,D=!1,h=!1,f=!1,d=!1,L=!1,s=!1,a,e=t.$g,u=t.$g,l,m;t.$h=typeof self=="object"?self:typeof global=="object"?global:{};let n;typeof t.$h.vscode<"u"&&typeof t.$h.vscode.process<"u"?n=t.$h.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",$=r&&n?.type==="renderer";if(typeof navigator=="object"&&!$)m=navigator.userAgent,P=m.indexOf("Windows")>=0,i=m.indexOf("Macintosh")>=0,d=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=m.indexOf("Linux")>=0,s=m?.indexOf("Mobi")>=0,h=!0,a=y.getConfiguredDefaultLocale(y.localize(0,null))||t.$g,e=a,u=navigator.language;else if(typeof n=="object"){P=n.platform==="win32",i=n.platform==="darwin",U=n.platform==="linux",w=U&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,f=r,L=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=t.$g,e=t.$g;const j=n.env.VSCODE_NLS_CONFIG;if(j)try{const W=JSON.parse(j),M=W.availableLanguages["*"];a=W.locale,u=W.osLocale,e=M||t.$g,l=W._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var c;(function(j){j[j.Web=0]="Web",j[j.Mac=1]="Mac",j[j.Linux=2]="Linux",j[j.Windows=3]="Windows"})(c||(t.Platform=c={}));function o(j){switch(j){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$i=o;let C=0;i?C=1:P?C=3:U&&(C=2),t.$j=P,t.$k=i,t.$l=U,t.$m=w,t.$n=D,t.$o=f,t.$p=h,t.$q=h&&typeof t.$h.importScripts=="function",t.$r=d,t.$s=s,t.$t=L,t.$u=C,t.$v=m,t.$w=e;var z;(function(j){function W(){return t.$w}j.value=W;function M(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}j.isDefaultVariant=M;function F(){return t.$w==="en"}j.isDefault=F})(z||(t.Language=z={})),t.$x=a,t.$y=u,t.$z=l,t.$A=typeof t.$h.postMessage=="function"&&!t.$h.importScripts,t.$B=(()=>{if(t.$A){const j=[];t.$h.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let F=0,J=j.length;F<J;F++){const ee=j[F];if(ee.id===M.data.vscodeScheduleAsyncWork){j.splice(F,1),ee.callback();return}}});let W=0;return M=>{const F=++W;j.push({id:F,callback:M}),t.$h.postMessage({vscodeScheduleAsyncWork:F},"*")}}return j=>setTimeout(j)})();var I;(function(j){j[j.Windows=1]="Windows",j[j.Macintosh=2]="Macintosh",j[j.Linux=3]="Linux"})(I||(t.OperatingSystem=I={})),t.OS=i||d?2:P?1:3;let b=!0,v=!1;function B(){if(!v){v=!0;const j=new Uint8Array(2);j[0]=1,j[1]=2,b=new Uint16Array(j.buffer)[0]===(2<<8)+1}return b}t.$D=B,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0)}),define(be[111],$e([1,0,16,5]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pO=t.KeyboardSupport=void 0;var i;(function(U){U[U.Always=0]="Always",U[U.FullScreen=1]="FullScreen",U[U.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.$pO={clipboard:{writeText:P.$n||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:P.$n||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>P.$n||y.$nO()?0:navigator.keyboard||y.$jO?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(be[14],$e([1,0,16,43,76,5]),function(re,t,y,P,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xO=t.$wO=t.$vO=void 0;function w(e){if(e.charCode){const l=String.fromCharCode(e.charCode).toUpperCase();return P.KeyCodeUtils.fromString(l)}const u=e.keyCode;if(u===3)return 7;if(y.$gO)switch(u){case 59:return 85;case 60:if(U.$l)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(U.$k)return 57;break}else if(y.$hO){if(U.$k&&u===93)return 57;if(!U.$k&&u===92)return 57}return P.$xq[u]||0}const D=U.$k?256:2048,h=512,f=1024,d=U.$k?2048:256;function L(e){const u=[];return e.ctrlKey&&u.push("ctrl"),e.shiftKey&&u.push("shift"),e.altKey&&u.push("alt"),e.metaKey&&u.push("meta"),`modifiers: [${u.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$vO=L;function s(e){const u=[];return e.ctrlKey&&u.push("ctrl"),e.shiftKey&&u.push("shift"),e.altKey&&u.push("alt"),e.metaKey&&u.push("meta"),`modifiers: [${u.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${P.KeyCodeUtils.toString(e.keyCode)}')`}t.$wO=s;class a{constructor(u){this._standardKeyboardEventBrand=!0;const l=u;this.browserEvent=l,this.target=l.target,this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,this.altGraphKey=l.getModifierState("AltGraph"),this.keyCode=w(l),this.code=l.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(u){return this.a===u}c(){let u=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(u=this.keyCode);let l=0;return this.ctrlKey&&(l|=D),this.altKey&&(l|=h),this.shiftKey&&(l|=f),this.metaKey&&(l|=d),l|=u,l}d(){let u=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(u=this.keyCode),new i.$Fq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,u)}}t.$xO=a}),define(be[19],$e([1,0,16,67,5]),function(re,t,y,P,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uO=t.$tO=t.$sO=void 0;class U{constructor(f){this.timestamp=Date.now(),this.browserEvent=f,this.leftButton=f.button===0,this.middleButton=f.button===1,this.rightButton=f.button===2,this.buttons=f.buttons,this.target=f.target,this.detail=f.detail||1,f.type==="dblclick"&&(this.detail=2),this.ctrlKey=f.ctrlKey,this.shiftKey=f.shiftKey,this.altKey=f.altKey,this.metaKey=f.metaKey,typeof f.pageX=="number"?(this.posx=f.pageX,this.posy=f.pageY):(this.posx=f.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=f.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const d=P.$qO.getPositionOfChildWindowRelativeToAncestorWindow(window,f.view);this.posx-=d.left,this.posy-=d.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$sO=U;class w extends U{constructor(f){super(f),this.dataTransfer=f.dataTransfer}}t.$tO=w;class D{constructor(f,d=0,L=0){if(this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=L,this.deltaX=d,f){const s=f,a=f;if(typeof s.wheelDeltaY<"u")this.deltaY=s.wheelDeltaY/120;else if(typeof a.VERTICAL_AXIS<"u"&&a.axis===a.VERTICAL_AXIS)this.deltaY=-a.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?y.$gO&&!i.$k?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof s.wheelDeltaX<"u")y.$jO&&i.$j?this.deltaX=-(s.wheelDeltaX/120):this.deltaX=s.wheelDeltaX/120;else if(typeof a.HORIZONTAL_AXIS<"u"&&a.axis===a.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?y.$gO&&!i.$k?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$uO=D}),define(be[112],$e([1,0,5]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=t.$cc=t.env=t.cwd=void 0;let P;if(typeof y.$h.vscode<"u"&&typeof y.$h.vscode.process<"u"){const i=y.$h.vscode.process;P={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return y.$j?"win32":y.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=P.cwd,t.env=P.env,t.$cc=P.platform,t.$dc=P.arch}),define(be[22],$e([1,0,112]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.sep=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=void 0;const P=65,i=97,U=90,w=122,D=46,h=47,f=92,d=58,L=63;class s extends Error{constructor(C,z,I){let b;typeof z=="string"&&z.indexOf("not ")===0?(b="must not be",z=z.replace(/^not /,"")):b="must be";const v=C.indexOf(".")!==-1?"property":"argument";let B=`The "${C}" ${v} ${b} of type ${z}`;B+=`. Received type ${typeof I}`,super(B),this.code="ERR_INVALID_ARG_TYPE"}}function a(o,C){if(o===null||typeof o!="object")throw new s(C,"Object",o)}function e(o,C){if(typeof o!="string")throw new s(C,"string",o)}const u=y.$cc==="win32";function l(o){return o===h||o===f}function m(o){return o===h}function n(o){return o>=P&&o<=U||o>=i&&o<=w}function r(o,C,z,I){let b="",v=0,B=-1,j=0,W=0;for(let M=0;M<=o.length;++M){if(M<o.length)W=o.charCodeAt(M);else{if(I(W))break;W=h}if(I(W)){if(!(B===M-1||j===1))if(j===2){if(b.length<2||v!==2||b.charCodeAt(b.length-1)!==D||b.charCodeAt(b.length-2)!==D){if(b.length>2){const F=b.lastIndexOf(z);F===-1?(b="",v=0):(b=b.slice(0,F),v=b.length-1-b.lastIndexOf(z)),B=M,j=0;continue}else if(b.length!==0){b="",v=0,B=M,j=0;continue}}C&&(b+=b.length>0?`${z}..`:"..",v=2)}else b.length>0?b+=`${z}${o.slice(B+1,M)}`:b=o.slice(B+1,M),v=M-B-1;B=M,j=0}else W===D&&j!==-1?++j:j=-1}return b}function $(o,C){a(C,"pathObject");const z=C.dir||C.root,I=C.base||`${C.name||""}${C.ext||""}`;return z?z===C.root?`${z}${I}`:`${z}${o}${I}`:I}t.$ec={resolve(...o){let C="",z="",I=!1;for(let b=o.length-1;b>=-1;b--){let v;if(b>=0){if(v=o[b],e(v,"path"),v.length===0)continue}else C.length===0?v=y.cwd():(v=y.env[`=${C}`]||y.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==C.toLowerCase()&&v.charCodeAt(2)===f)&&(v=`${C}\\`));const B=v.length;let j=0,W="",M=!1;const F=v.charCodeAt(0);if(B===1)l(F)&&(j=1,M=!0);else if(l(F))if(M=!0,l(v.charCodeAt(1))){let J=2,ee=J;for(;J<B&&!l(v.charCodeAt(J));)J++;if(J<B&&J!==ee){const ne=v.slice(ee,J);for(ee=J;J<B&&l(v.charCodeAt(J));)J++;if(J<B&&J!==ee){for(ee=J;J<B&&!l(v.charCodeAt(J));)J++;(J===B||J!==ee)&&(W=`\\\\${ne}\\${v.slice(ee,J)}`,j=J)}}}else j=1;else n(F)&&v.charCodeAt(1)===d&&(W=v.slice(0,2),j=2,B>2&&l(v.charCodeAt(2))&&(M=!0,j=3));if(W.length>0)if(C.length>0){if(W.toLowerCase()!==C.toLowerCase())continue}else C=W;if(I){if(C.length>0)break}else if(z=`${v.slice(j)}\\${z}`,I=M,M&&C.length>0)break}return z=r(z,!I,"\\",l),I?`${C}\\${z}`:`${C}${z}`||"."},normalize(o){e(o,"path");const C=o.length;if(C===0)return".";let z=0,I,b=!1;const v=o.charCodeAt(0);if(C===1)return m(v)?"\\":o;if(l(v))if(b=!0,l(o.charCodeAt(1))){let j=2,W=j;for(;j<C&&!l(o.charCodeAt(j));)j++;if(j<C&&j!==W){const M=o.slice(W,j);for(W=j;j<C&&l(o.charCodeAt(j));)j++;if(j<C&&j!==W){for(W=j;j<C&&!l(o.charCodeAt(j));)j++;if(j===C)return`\\\\${M}\\${o.slice(W)}\\`;j!==W&&(I=`\\\\${M}\\${o.slice(W,j)}`,z=j)}}}else z=1;else n(v)&&o.charCodeAt(1)===d&&(I=o.slice(0,2),z=2,C>2&&l(o.charCodeAt(2))&&(b=!0,z=3));let B=z<C?r(o.slice(z),!b,"\\",l):"";return B.length===0&&!b&&(B="."),B.length>0&&l(o.charCodeAt(C-1))&&(B+="\\"),I===void 0?b?`\\${B}`:B:b?`${I}\\${B}`:`${I}${B}`},isAbsolute(o){e(o,"path");const C=o.length;if(C===0)return!1;const z=o.charCodeAt(0);return l(z)||C>2&&n(z)&&o.charCodeAt(1)===d&&l(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let C,z;for(let v=0;v<o.length;++v){const B=o[v];e(B,"path"),B.length>0&&(C===void 0?C=z=B:C+=`\\${B}`)}if(C===void 0)return".";let I=!0,b=0;if(typeof z=="string"&&l(z.charCodeAt(0))){++b;const v=z.length;v>1&&l(z.charCodeAt(1))&&(++b,v>2&&(l(z.charCodeAt(2))?++b:I=!1))}if(I){for(;b<C.length&&l(C.charCodeAt(b));)b++;b>=2&&(C=`\\${C.slice(b)}`)}return t.$ec.normalize(C)},relative(o,C){if(e(o,"from"),e(C,"to"),o===C)return"";const z=t.$ec.resolve(o),I=t.$ec.resolve(C);if(z===I||(o=z.toLowerCase(),C=I.toLowerCase(),o===C))return"";let b=0;for(;b<o.length&&o.charCodeAt(b)===f;)b++;let v=o.length;for(;v-1>b&&o.charCodeAt(v-1)===f;)v--;const B=v-b;let j=0;for(;j<C.length&&C.charCodeAt(j)===f;)j++;let W=C.length;for(;W-1>j&&C.charCodeAt(W-1)===f;)W--;const M=W-j,F=B<M?B:M;let J=-1,ee=0;for(;ee<F;ee++){const ue=o.charCodeAt(b+ee);if(ue!==C.charCodeAt(j+ee))break;ue===f&&(J=ee)}if(ee!==F){if(J===-1)return I}else{if(M>F){if(C.charCodeAt(j+ee)===f)return I.slice(j+ee+1);if(ee===2)return I.slice(j+ee)}B>F&&(o.charCodeAt(b+ee)===f?J=ee:ee===2&&(J=3)),J===-1&&(J=0)}let ne="";for(ee=b+J+1;ee<=v;++ee)(ee===v||o.charCodeAt(ee)===f)&&(ne+=ne.length===0?"..":"\\..");return j+=J,ne.length>0?`${ne}${I.slice(j,W)}`:(I.charCodeAt(j)===f&&++j,I.slice(j,W))},toNamespacedPath(o){if(typeof o!="string"||o.length===0)return o;const C=t.$ec.resolve(o);if(C.length<=2)return o;if(C.charCodeAt(0)===f){if(C.charCodeAt(1)===f){const z=C.charCodeAt(2);if(z!==L&&z!==D)return`\\\\?\\UNC\\${C.slice(2)}`}}else if(n(C.charCodeAt(0))&&C.charCodeAt(1)===d&&C.charCodeAt(2)===f)return`\\\\?\\${C}`;return o},dirname(o){e(o,"path");const C=o.length;if(C===0)return".";let z=-1,I=0;const b=o.charCodeAt(0);if(C===1)return l(b)?o:".";if(l(b)){if(z=I=1,l(o.charCodeAt(1))){let j=2,W=j;for(;j<C&&!l(o.charCodeAt(j));)j++;if(j<C&&j!==W){for(W=j;j<C&&l(o.charCodeAt(j));)j++;if(j<C&&j!==W){for(W=j;j<C&&!l(o.charCodeAt(j));)j++;if(j===C)return o;j!==W&&(z=I=j+1)}}}}else n(b)&&o.charCodeAt(1)===d&&(z=C>2&&l(o.charCodeAt(2))?3:2,I=z);let v=-1,B=!0;for(let j=C-1;j>=I;--j)if(l(o.charCodeAt(j))){if(!B){v=j;break}}else B=!1;if(v===-1){if(z===-1)return".";v=z}return o.slice(0,v)},basename(o,C){C!==void 0&&e(C,"ext"),e(o,"path");let z=0,I=-1,b=!0,v;if(o.length>=2&&n(o.charCodeAt(0))&&o.charCodeAt(1)===d&&(z=2),C!==void 0&&C.length>0&&C.length<=o.length){if(C===o)return"";let B=C.length-1,j=-1;for(v=o.length-1;v>=z;--v){const W=o.charCodeAt(v);if(l(W)){if(!b){z=v+1;break}}else j===-1&&(b=!1,j=v+1),B>=0&&(W===C.charCodeAt(B)?--B===-1&&(I=v):(B=-1,I=j))}return z===I?I=j:I===-1&&(I=o.length),o.slice(z,I)}for(v=o.length-1;v>=z;--v)if(l(o.charCodeAt(v))){if(!b){z=v+1;break}}else I===-1&&(b=!1,I=v+1);return I===-1?"":o.slice(z,I)},extname(o){e(o,"path");let C=0,z=-1,I=0,b=-1,v=!0,B=0;o.length>=2&&o.charCodeAt(1)===d&&n(o.charCodeAt(0))&&(C=I=2);for(let j=o.length-1;j>=C;--j){const W=o.charCodeAt(j);if(l(W)){if(!v){I=j+1;break}continue}b===-1&&(v=!1,b=j+1),W===D?z===-1?z=j:B!==1&&(B=1):z!==-1&&(B=-1)}return z===-1||b===-1||B===0||B===1&&z===b-1&&z===I+1?"":o.slice(z,b)},format:$.bind(null,"\\"),parse(o){e(o,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return C;const z=o.length;let I=0,b=o.charCodeAt(0);if(z===1)return l(b)?(C.root=C.dir=o,C):(C.base=C.name=o,C);if(l(b)){if(I=1,l(o.charCodeAt(1))){let J=2,ee=J;for(;J<z&&!l(o.charCodeAt(J));)J++;if(J<z&&J!==ee){for(ee=J;J<z&&l(o.charCodeAt(J));)J++;if(J<z&&J!==ee){for(ee=J;J<z&&!l(o.charCodeAt(J));)J++;J===z?I=J:J!==ee&&(I=J+1)}}}}else if(n(b)&&o.charCodeAt(1)===d){if(z<=2)return C.root=C.dir=o,C;if(I=2,l(o.charCodeAt(2))){if(z===3)return C.root=C.dir=o,C;I=3}}I>0&&(C.root=o.slice(0,I));let v=-1,B=I,j=-1,W=!0,M=o.length-1,F=0;for(;M>=I;--M){if(b=o.charCodeAt(M),l(b)){if(!W){B=M+1;break}continue}j===-1&&(W=!1,j=M+1),b===D?v===-1?v=M:F!==1&&(F=1):v!==-1&&(F=-1)}return j!==-1&&(v===-1||F===0||F===1&&v===j-1&&v===B+1?C.base=C.name=o.slice(B,j):(C.name=o.slice(B,v),C.base=o.slice(B,j),C.ext=o.slice(v,j))),B>0&&B!==I?C.dir=o.slice(0,B-1):C.dir=C.root,C},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(u){const o=/\\/g;return()=>{const C=y.cwd().replace(o,"/");return C.slice(C.indexOf("/"))}}return()=>y.cwd()})();t.$fc={resolve(...o){let C="",z=!1;for(let I=o.length-1;I>=-1&&!z;I--){const b=I>=0?o[I]:c();e(b,"path"),b.length!==0&&(C=`${b}/${C}`,z=b.charCodeAt(0)===h)}return C=r(C,!z,"/",m),z?`/${C}`:C.length>0?C:"."},normalize(o){if(e(o,"path"),o.length===0)return".";const C=o.charCodeAt(0)===h,z=o.charCodeAt(o.length-1)===h;return o=r(o,!C,"/",m),o.length===0?C?"/":z?"./":".":(z&&(o+="/"),C?`/${o}`:o)},isAbsolute(o){return e(o,"path"),o.length>0&&o.charCodeAt(0)===h},join(...o){if(o.length===0)return".";let C;for(let z=0;z<o.length;++z){const I=o[z];e(I,"path"),I.length>0&&(C===void 0?C=I:C+=`/${I}`)}return C===void 0?".":t.$fc.normalize(C)},relative(o,C){if(e(o,"from"),e(C,"to"),o===C||(o=t.$fc.resolve(o),C=t.$fc.resolve(C),o===C))return"";const z=1,I=o.length,b=I-z,v=1,B=C.length-v,j=b<B?b:B;let W=-1,M=0;for(;M<j;M++){const J=o.charCodeAt(z+M);if(J!==C.charCodeAt(v+M))break;J===h&&(W=M)}if(M===j)if(B>j){if(C.charCodeAt(v+M)===h)return C.slice(v+M+1);if(M===0)return C.slice(v+M)}else b>j&&(o.charCodeAt(z+M)===h?W=M:M===0&&(W=0));let F="";for(M=z+W+1;M<=I;++M)(M===I||o.charCodeAt(M)===h)&&(F+=F.length===0?"..":"/..");return`${F}${C.slice(v+W)}`},toNamespacedPath(o){return o},dirname(o){if(e(o,"path"),o.length===0)return".";const C=o.charCodeAt(0)===h;let z=-1,I=!0;for(let b=o.length-1;b>=1;--b)if(o.charCodeAt(b)===h){if(!I){z=b;break}}else I=!1;return z===-1?C?"/":".":C&&z===1?"//":o.slice(0,z)},basename(o,C){C!==void 0&&e(C,"ext"),e(o,"path");let z=0,I=-1,b=!0,v;if(C!==void 0&&C.length>0&&C.length<=o.length){if(C===o)return"";let B=C.length-1,j=-1;for(v=o.length-1;v>=0;--v){const W=o.charCodeAt(v);if(W===h){if(!b){z=v+1;break}}else j===-1&&(b=!1,j=v+1),B>=0&&(W===C.charCodeAt(B)?--B===-1&&(I=v):(B=-1,I=j))}return z===I?I=j:I===-1&&(I=o.length),o.slice(z,I)}for(v=o.length-1;v>=0;--v)if(o.charCodeAt(v)===h){if(!b){z=v+1;break}}else I===-1&&(b=!1,I=v+1);return I===-1?"":o.slice(z,I)},extname(o){e(o,"path");let C=-1,z=0,I=-1,b=!0,v=0;for(let B=o.length-1;B>=0;--B){const j=o.charCodeAt(B);if(j===h){if(!b){z=B+1;break}continue}I===-1&&(b=!1,I=B+1),j===D?C===-1?C=B:v!==1&&(v=1):C!==-1&&(v=-1)}return C===-1||I===-1||v===0||v===1&&C===I-1&&C===z+1?"":o.slice(C,I)},format:$.bind(null,"/"),parse(o){e(o,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return C;const z=o.charCodeAt(0)===h;let I;z?(C.root="/",I=1):I=0;let b=-1,v=0,B=-1,j=!0,W=o.length-1,M=0;for(;W>=I;--W){const F=o.charCodeAt(W);if(F===h){if(!j){v=W+1;break}continue}B===-1&&(j=!1,B=W+1),F===D?b===-1?b=W:M!==1&&(M=1):b!==-1&&(M=-1)}if(B!==-1){const F=v===0&&z?1:v;b===-1||M===0||M===1&&b===B-1&&b===v+1?C.base=C.name=o.slice(F,B):(C.name=o.slice(F,b),C.base=o.slice(F,B),C.ext=o.slice(b,B))}return v>0?C.dir=o.slice(0,v-1):z&&(C.dir="/"),C},sep:"/",delimiter:":",win32:null,posix:null},t.$fc.win32=t.$ec.win32=t.$ec,t.$fc.posix=t.$ec.posix=t.$fc,t.$gc=u?t.$ec.normalize:t.$fc.normalize,t.$hc=u?t.$ec.isAbsolute:t.$fc.isAbsolute,t.$ic=u?t.$ec.join:t.$fc.join,t.$jc=u?t.$ec.resolve:t.$fc.resolve,t.$kc=u?t.$ec.relative:t.$fc.relative,t.$lc=u?t.$ec.dirname:t.$fc.dirname,t.$mc=u?t.$ec.basename:t.$fc.basename,t.$nc=u?t.$ec.extname:t.$fc.extname,t.$oc=u?t.$ec.format:t.$fc.format,t.$pc=u?t.$ec.parse:t.$fc.parse,t.$qc=u?t.$ec.toNamespacedPath:t.$fc.toNamespacedPath,t.sep=u?t.$ec.sep:t.$fc.sep,t.$sc=u?t.$ec.delimiter:t.$fc.delimiter}),define(be[113],$e([1,0,22,5,12,7]),function(re,t,y,P,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=void 0;function w(v){return v===47||v===92}t.$Pf=w;function D(v){return v.replace(/[\\/]/g,y.$fc.sep)}t.$Qf=D;function h(v){return v.indexOf("/")===-1&&(v=D(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}t.$Rf=h;function f(v,B=y.$fc.sep){if(!v)return"";const j=v.length,W=v.charCodeAt(0);if(w(W)){if(w(v.charCodeAt(1))&&!w(v.charCodeAt(2))){let F=3;const J=F;for(;F<j&&!w(v.charCodeAt(F));F++);if(J!==F&&!w(v.charCodeAt(F+1))){for(F+=1;F<j;F++)if(w(v.charCodeAt(F)))return v.slice(0,F+1).replace(/[\\/]/g,B)}}return B}else if(m(W)&&v.charCodeAt(1)===58)return w(v.charCodeAt(2))?v.slice(0,2)+B:v.slice(0,2);let M=v.indexOf("://");if(M!==-1){for(M+=3;M<j;M++)if(w(v.charCodeAt(M)))return v.slice(0,M+1)}return""}t.$Sf=f;function d(v){if(!P.$j||!v||v.length<5)return!1;let B=v.charCodeAt(0);if(B!==92||(B=v.charCodeAt(1),B!==92))return!1;let j=2;const W=j;for(;j<v.length&&(B=v.charCodeAt(j),B!==92);j++);return!(W===j||(B=v.charCodeAt(j+1),isNaN(B)||B===92))}t.$Tf=d;const L=/[\\/:\*\?"<>\|]/g,s=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(v,B=P.$j){const j=B?L:s;return!(!v||v.length===0||/^\s+$/.test(v)||(j.lastIndex=0,j.test(v))||B&&a.test(v)||v==="."||v===".."||B&&v[v.length-1]==="."||B&&v.length!==v.trim().length||v.length>255)}t.$Uf=e;function u(v,B,j){const W=v===B;return!j||W?W:!v||!B?!1:(0,i.$1e)(v,B)}t.$Vf=u;function l(v,B,j,W=y.sep){if(v===B)return!0;if(!v||!B||B.length>v.length)return!1;if(j){if(!(0,i.$2e)(v,B))return!1;if(B.length===v.length)return!0;let F=B.length;return B.charAt(B.length-1)===W&&F--,v.charAt(F)===W}return B.charAt(B.length-1)!==W&&(B+=W),v.indexOf(B)===0}t.$Wf=l;function m(v){return v>=65&&v<=90||v>=97&&v<=122}t.$Xf=m;function n(v,B){return P.$j&&v.endsWith(":")&&(v+=y.sep),(0,y.$hc)(v)||(v=(0,y.$ic)(B,v)),v=(0,y.$gc)(v),P.$j?(v=(0,i.$Je)(v,y.sep),v.endsWith(":")&&(v+=y.sep)):(v=(0,i.$Je)(v,y.sep),v||(v=y.sep)),v}t.$Yf=n;function r(v){const B=(0,y.$gc)(v);return P.$j?v.length>3?!1:$(B)&&(v.length===2||B.charCodeAt(2)===92):B===y.$fc.sep}t.$Zf=r;function $(v,B=P.$j){return B?m(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}t.$1f=$;function c(v,B=P.$j){return $(v,B)?v[0]:void 0}t.$2f=c;function o(v,B,j){return B.length>v.length?-1:v===B?0:(j&&(v=v.toLowerCase(),B=B.toLowerCase()),v.indexOf(B))}t.$3f=o;function C(v){const B=v.split(":");let j,W,M;for(const F of B){const J=Number(F);(0,U.$Bf)(J)?W===void 0?W=J:M===void 0&&(M=J):j=j?[j,F].join(":"):F}if(!j)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:j,line:W!==void 0?W:void 0,column:M!==void 0?M:W!==void 0?1:void 0}}t.$4f=C;const z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(v,B,j=8){let W="";for(let F=0;F<j;F++){let J;F===0&&P.$j&&!B&&(j===3||j===4)?J=I:J=z,W+=J.charAt(Math.floor(Math.random()*J.length))}let M;return B?M=`${B}-${W}`:M=W,v?(0,y.$ic)(v,M):M}t.$5f=b}),define(be[114],$e([1,0,22]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qr=t.$Pr=t.$Or=t.$Nr=t.$Mr=void 0,t.$Mr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(d){const L=(0,y.$nc)(d),s=P[L.toLowerCase()];return s!==void 0?s:w(d)}t.$Nr=U;function w(d){const L=(0,y.$nc)(d);return i[L.toLowerCase()]}t.$Or=w;function D(d){for(const L in i)if(i[L]===d)return L}t.$Pr=D;const h=/^(.+)\/(.+?)(;.+)?$/;function f(d,L){const s=h.exec(d);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:L?void 0:d}t.$Qr=f}),define(be[15],$e([1,0,22,5]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vc=t.$uc=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,U=/^\//,w=/^\/\//;function D(I,b){if(!I.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${I.authority}", path: "${I.path}", query: "${I.query}", fragment: "${I.fragment}"}`);if(I.scheme&&!i.test(I.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(I.path){if(I.authority){if(!U.test(I.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(I.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(I,b){return!I&&!b?"file":I}function f(I,b){switch(I){case"https":case"http":case"file":b?b[0]!==L&&(b=L+b):b=L;break}return b}const d="",L="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(b){return b instanceof a?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,v,B,j,W,M=!1){typeof b=="object"?(this.scheme=b.scheme||d,this.authority=b.authority||d,this.path=b.path||d,this.query=b.query||d,this.fragment=b.fragment||d):(this.scheme=h(b,M),this.authority=v||d,this.path=f(this.scheme,B||d),this.query=j||d,this.fragment=W||d,D(this,M))}get fsPath(){return $(this,!1)}with(b){if(!b)return this;let{scheme:v,authority:B,path:j,query:W,fragment:M}=b;return v===void 0?v=this.scheme:v===null&&(v=d),B===void 0?B=this.authority:B===null&&(B=d),j===void 0?j=this.path:j===null&&(j=d),W===void 0?W=this.query:W===null&&(W=d),M===void 0?M=this.fragment:M===null&&(M=d),v===this.scheme&&B===this.authority&&j===this.path&&W===this.query&&M===this.fragment?this:new l(v,B,j,W,M)}static parse(b,v=!1){const B=s.exec(b);return B?new l(B[2]||d,z(B[4]||d),z(B[5]||d),z(B[7]||d),z(B[9]||d),v):new l(d,d,d,d,d)}static file(b){let v=d;if(P.$j&&(b=b.replace(/\\/g,L)),b[0]===L&&b[1]===L){const B=b.indexOf(L,2);B===-1?(v=b.substring(2),b=L):(v=b.substring(2,B),b=b.substring(B)||L)}return new l("file",v,b,d,d)}static from(b,v){return new l(b.scheme,b.authority,b.path,b.query,b.fragment,v)}static joinPath(b,...v){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let B;return P.$j&&b.scheme==="file"?B=a.file(y.$ec.join($(b,!0),...v)).path:B=y.$fc.join(b.path,...v),b.with({path:B})}toString(b=!1){return c(this,b)}toJSON(){return this}static revive(b){if(b){if(b instanceof a)return b;{const v=new l(b);return v._formatted=b.external??null,v._fsPath=b._sep===u?b.fsPath??null:null,v}}else return b}}t.URI=a;function e(I){return!I||typeof I!="object"?!1:typeof I.scheme=="string"&&(typeof I.authority=="string"||typeof I.authority>"u")&&(typeof I.path=="string"||typeof I.path>"u")&&(typeof I.query=="string"||typeof I.query>"u")&&(typeof I.fragment=="string"||typeof I.fragment>"u")}t.$uc=e;const u=P.$j?1:void 0;class l extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=$(this,!1)),this._fsPath}toString(b=!1){return b?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const b={$mid:1};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=u),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(I,b,v){let B,j=-1;for(let W=0;W<I.length;W++){const M=I.charCodeAt(W);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||b&&M===47||v&&M===91||v&&M===93||v&&M===58)j!==-1&&(B+=encodeURIComponent(I.substring(j,W)),j=-1),B!==void 0&&(B+=I.charAt(W));else{B===void 0&&(B=I.substr(0,W));const F=m[M];F!==void 0?(j!==-1&&(B+=encodeURIComponent(I.substring(j,W)),j=-1),B+=F):j===-1&&(j=W)}}return j!==-1&&(B+=encodeURIComponent(I.substring(j))),B!==void 0?B:I}function r(I){let b;for(let v=0;v<I.length;v++){const B=I.charCodeAt(v);B===35||B===63?(b===void 0&&(b=I.substr(0,v)),b+=m[B]):b!==void 0&&(b+=I[v])}return b!==void 0?b:I}function $(I,b){let v;return I.authority&&I.path.length>1&&I.scheme==="file"?v=`//${I.authority}${I.path}`:I.path.charCodeAt(0)===47&&(I.path.charCodeAt(1)>=65&&I.path.charCodeAt(1)<=90||I.path.charCodeAt(1)>=97&&I.path.charCodeAt(1)<=122)&&I.path.charCodeAt(2)===58?b?v=I.path.substr(1):v=I.path[1].toLowerCase()+I.path.substr(2):v=I.path,P.$j&&(v=v.replace(/\//g,"\\")),v}t.$vc=$;function c(I,b){const v=b?r:n;let B="",{scheme:j,authority:W,path:M,query:F,fragment:J}=I;if(j&&(B+=j,B+=":"),(W||j==="file")&&(B+=L,B+=L),W){let ee=W.indexOf("@");if(ee!==-1){const ne=W.substr(0,ee);W=W.substr(ee+1),ee=ne.lastIndexOf(":"),ee===-1?B+=v(ne,!1,!1):(B+=v(ne.substr(0,ee),!1,!1),B+=":",B+=v(ne.substr(ee+1),!1,!0)),B+="@"}W=W.toLowerCase(),ee=W.lastIndexOf(":"),ee===-1?B+=v(W,!1,!0):(B+=v(W.substr(0,ee),!1,!0),B+=W.substr(ee))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const ee=M.charCodeAt(1);ee>=65&&ee<=90&&(M=`/${String.fromCharCode(ee+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const ee=M.charCodeAt(0);ee>=65&&ee<=90&&(M=`${String.fromCharCode(ee+32)}:${M.substr(2)}`)}B+=v(M,!0,!1)}return F&&(B+="?",B+=v(F,!1,!1)),J&&(B+="#",B+=b?J:n(J,!1,!1)),B}function o(I){try{return decodeURIComponent(I)}catch{return I.length>3?I.substr(0,3)+o(I.substr(3)):I}}const C=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function z(I){return I.match(C)?I.replace(C,b=>o(b)):I}}),define(be[51],$e([1,0,32,15]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kh=t.$jh=t.$ih=void 0;function i(h){return JSON.stringify(h,w)}t.$ih=i;function U(h){let f=JSON.parse(h);return f=D(f),f}t.$jh=U;function w(h,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function D(h,f=0){if(!h||f>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return P.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof y.$ae||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let d=0;d<h.length;++d)h[d]=D(h[d],f+1);else for(const d in h)Object.hasOwnProperty.call(h,d)&&(h[d]=D(h[d],f+1))}return h}t.$kh=D}),define(be[29],$e([1,0,6,5,15]),function(re,t,y,P,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.Schemas=void 0;var U;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(U||(t.Schemas=U={})),t.$6f="vscode-tkn",t.$7f="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d){this.f=`${d}/${U.vscodeRemoteResource}`}set(d,L,s){this.a[d]=L,this.b[d]=s}setConnectionToken(d,L){this.c[d]=L}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(l){return y.$Z(l),d}const L=d.authority;let s=this.a[L];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const a=this.b[L],e=this.c[L];let u=`path=${encodeURIComponent(d.path)}`;return typeof e=="string"&&(u+=`&${t.$7f}=${encodeURIComponent(e)}`),i.URI.from({scheme:P.$p?this.d:U.vscodeRemoteResource,authority:`${s}:${a}`,path:this.f,query:u})}}t.$8f=new w,t.$9f="vs/../../extensions",t.$0f="vs/../../node_modules",t.$$f="vs/../../node_modules.asar",t.$_f="vs/../../node_modules.asar.unpacked",t.$ag="vscode-app";class D{static{this.a=t.$ag}asBrowserUri(d){const L=this.b(d,re);return this.uriToBrowserUri(L)}uriToBrowserUri(d){return d.scheme===U.vscodeRemote?t.$8f.rewrite(d):d.scheme===U.file&&(P.$n||P.$q&&P.$h.origin===`${U.vscodeFileResource}://${D.a}`)?d.with({scheme:U.vscodeFileResource,authority:d.authority||D.a,query:null,fragment:null}):d}asFileUri(d){const L=this.b(d,re);return this.uriToFileUri(L)}uriToFileUri(d){return d.scheme===U.vscodeFileResource?d.with({scheme:U.file,authority:d.authority!==D.a?d.authority:null,query:null,fragment:null}):d}b(d,L){return i.URI.isUri(d)?d:i.URI.parse(L.toUrl(d))}}t.$bg=new D;var h;(function(f){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(d.get("3"));const L="vscode-coi";function s(e){let u;typeof e=="string"?u=new URL(e).searchParams:e instanceof URL?u=e.searchParams:i.URI.isUri(e)&&(u=new URL(e.toString(!0)).searchParams);const l=u?.get(L);if(l)return d.get(l)}f.getHeadersFromQuery=s;function a(e,u,l){if(!globalThis.crossOriginIsolated)return;const m=u&&l?"3":l?"2":"1";e instanceof URLSearchParams?e.set(L,m):e[L]=m}f.addSearchParam=a})(h||(t.COI=h={}))}),define(be[36],$e([1,0,113,29,22,5,12,15]),function(re,t,y,P,i,U,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Eg=t.DataUri=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=t.$ig=void 0;function h(a){return(0,D.$vc)(a,!0)}t.$ig=h;class f{constructor(e){this.a=e}compare(e,u,l=!1){return e===u?0:(0,w.$Te)(this.getComparisonKey(e,l),this.getComparisonKey(u,l))}isEqual(e,u,l=!1){return e===u?!0:!e||!u?!1:this.getComparisonKey(e,l)===this.getComparisonKey(u,l)}getComparisonKey(e,u=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,u,l=!1){if(e.scheme===u.scheme){if(e.scheme===P.Schemas.file)return y.$Wf(h(e),h(u),this.a(e))&&e.query===u.query&&(l||e.fragment===u.fragment);if((0,t.$zg)(e.authority,u.authority))return y.$Wf(e.path,u.path,this.a(e),"/")&&e.query===u.query&&(l||e.fragment===u.fragment)}return!1}joinPath(e,...u){return D.URI.joinPath(e,...u)}basenameOrAuthority(e){return(0,t.$rg)(e)||e.authority}basename(e){return i.$fc.basename(e.path)}extname(e){return i.$fc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let u;return e.scheme===P.Schemas.file?u=D.URI.file(i.$lc(h(e))).path:(u=i.$fc.dirname(e.path),e.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),u="/")),e.with({path:u})}normalizePath(e){if(!e.path.length)return e;let u;return e.scheme===P.Schemas.file?u=D.URI.file(i.$gc(h(e))).path:u=i.$fc.normalize(e.path),e.with({path:u})}relativePath(e,u){if(e.scheme!==u.scheme||!(0,t.$zg)(e.authority,u.authority))return;if(e.scheme===P.Schemas.file){const n=i.$kc(h(e),h(u));return U.$j?y.$Qf(n):n}let l=e.path||"/";const m=u.path||"/";if(this.a(e)){let n=0;for(const r=Math.min(l.length,m.length);n<r&&!(l.charCodeAt(n)!==m.charCodeAt(n)&&l.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);l=m.substr(0,n)+l.substr(n)}return i.$fc.relative(l,m)}resolvePath(e,u){if(e.scheme===P.Schemas.file){const l=D.URI.file(i.$jc(h(e),u));return e.with({authority:l.authority,path:l.path})}return u=y.$Rf(u),e.with({path:i.$fc.resolve(e.path,u)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,u){return e===u||e!==void 0&&u!==void 0&&(0,w.$1e)(e,u)}hasTrailingPathSeparator(e,u=i.sep){if(e.scheme===P.Schemas.file){const l=h(e);return l.length>y.$Sf(l).length&&l[l.length-1]===u}else{const l=e.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,u=i.sep){return(0,t.$Ag)(e,u)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,u=i.sep){let l=!1;if(e.scheme===P.Schemas.file){const m=h(e);l=m!==void 0&&m.length===y.$Sf(m).length&&m[m.length-1]===u}else{u="/";const m=e.path;l=m.length===1&&m.charCodeAt(m.length-1)===47}return!l&&!(0,t.$Ag)(e,u)?e.with({path:e.path+"/"}):e}}t.$jg=f,t.$kg=new f(()=>!1),t.$lg=new f(a=>a.scheme===P.Schemas.file?!U.$l:!0),t.$mg=new f(a=>!0),t.$ng=t.$kg.isEqual.bind(t.$kg),t.$og=t.$kg.isEqualOrParent.bind(t.$kg),t.$pg=t.$kg.getComparisonKey.bind(t.$kg),t.$qg=t.$kg.basenameOrAuthority.bind(t.$kg),t.$rg=t.$kg.basename.bind(t.$kg),t.$sg=t.$kg.extname.bind(t.$kg),t.$tg=t.$kg.dirname.bind(t.$kg),t.$ug=t.$kg.joinPath.bind(t.$kg),t.$vg=t.$kg.normalizePath.bind(t.$kg),t.$wg=t.$kg.relativePath.bind(t.$kg),t.$xg=t.$kg.resolvePath.bind(t.$kg),t.$yg=t.$kg.isAbsolutePath.bind(t.$kg),t.$zg=t.$kg.isEqualAuthority.bind(t.$kg),t.$Ag=t.$kg.hasTrailingPathSeparator.bind(t.$kg),t.$Bg=t.$kg.removeTrailingPathSeparator.bind(t.$kg),t.$Cg=t.$kg.addTrailingPathSeparator.bind(t.$kg);function d(a,e){const u=[];for(let l=0;l<a.length;l++){const m=e(a[l]);a.some((n,r)=>r===l?!1:(0,t.$og)(m,e(n)))||u.push(a[l])}return u}t.$Dg=d;var L;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function e(u){const l=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(r=>{const[$,c]=r.split(":");$&&c&&l.set($,c)});const n=u.path.substring(0,u.path.indexOf(";"));return n&&l.set(a.META_DATA_MIME,n),l}a.parseMetaData=e})(L||(t.DataUri=L={}));function s(a,e,u){if(e){let l=a.path;return l&&l[0]!==i.$fc.sep&&(l=i.$fc.sep+l),a.with({scheme:u,authority:e,path:l})}return a.with({scheme:u})}t.$Eg=s}),define(be[9],$e([1,0,28,6,3,2,36,5,48]),function(re,t,y,P,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eh=t.$dh=t.$ch=t.Promises=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=void 0;function f(g){return!!g&&typeof g.then=="function"}t.$Fg=f;function d(g){const p=new y.$Wd,V=g(p.token),T=new Promise((N,O)=>{const _=p.token.onCancellationRequested(()=>{_.dispose(),p.dispose(),O(new P.$4)});Promise.resolve(V).then(S=>{_.dispose(),p.dispose(),N(S)},S=>{_.dispose(),p.dispose(),O(S)})});return new class{cancel(){p.cancel()}then(N,O){return T.then(N,O)}catch(N){return this.then(void 0,N)}finally(N){return T.finally(N)}}}t.$Gg=d;function L(g,p,V){return new Promise((T,N)=>{const O=p.onCancellationRequested(()=>{O.dispose(),T(V)});g.then(T,N).finally(()=>O.dispose())})}t.$Hg=L;function s(g,p){return new Promise((V,T)=>{const N=p.onCancellationRequested(()=>{N.dispose(),T(new P.$4)});g.then(V,T).finally(()=>N.dispose())})}t.$Ig=s;async function a(g){let p=-1;const V=g.map((T,N)=>T.then(O=>(p=N,O)));try{return await Promise.race(V)}finally{g.forEach((T,N)=>{N!==p&&T.cancel()})}}t.$Jg=a;function e(g,p,V){let T;const N=setTimeout(()=>{T?.(void 0),V?.()},p);return Promise.race([g.finally(()=>clearTimeout(N)),new Promise(O=>T=O)])}t.$Kg=e;function u(g){return new Promise((p,V)=>{const T=g();f(T)?T.then(p,V):p(T)})}t.$Lg=u;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(p){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=p,!this.b){const V=()=>{if(this.b=null,this.f)return;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(V,V).then(T)})}return new Promise((V,T)=>{this.b.then(V,T)})}return this.a=p(),new Promise((V,T)=>{this.a.then(N=>{this.a=null,V(N)},N=>{this.a=null,T(N)})})}dispose(){this.f=!0}}t.$Mg=l;class m{constructor(){this.a=Promise.resolve(null)}queue(p){return this.a=this.a.then(()=>p(),()=>p())}}t.$Ng=m;class n{constructor(){this.a=new Map}queue(p,V){const N=(this.a.get(p)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.a.get(p)===N&&this.a.delete(p)});return this.a.set(p,N),N}}t.$Og=n;const r=(g,p)=>{let V=!0;const T=setTimeout(()=>{V=!1,p()},g);return{isTriggered:()=>V,dispose:()=>{clearTimeout(T),V=!1}}},$=g=>{let p=!0;return queueMicrotask(()=>{p&&(p=!1,g())}),{isTriggered:()=>p,dispose:()=>{p=!1}}};class c{constructor(p){this.defaultDelay=p,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(p,V=this.defaultDelay){this.g=p,this.h(),this.b||(this.b=new Promise((N,O)=>{this.d=N,this.f=O}).then(()=>{if(this.b=null,this.d=null,this.g){const N=this.g;return this.g=null,N()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=V===h.$Jd?$(T):r(V,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Pg=c;class o{constructor(p){this.a=new c(p),this.b=new l}trigger(p,V){return this.a.trigger(()=>this.b.queue(p),V)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Qg=o;class C{constructor(){this.a=!1,this.b=new Promise((p,V)=>{this.d=p})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Rg=C;class z extends C{constructor(p){super(),this.f=setTimeout(()=>this.open(),p)}open(){clearTimeout(this.f),super.open()}}t.$Sg=z;function I(g,p){return p?new Promise((V,T)=>{const N=setTimeout(()=>{O.dispose(),V()},g),O=p.onCancellationRequested(()=>{clearTimeout(N),O.dispose(),T(new P.$4)})}):d(V=>I(g,V))}t.$Tg=I;function b(g,p=0,V){const T=setTimeout(()=>{g(),V&&N.dispose()},p),N=(0,U.$Pc)(()=>{clearTimeout(T),V?.deleteAndLeak(N)});return V?.add(N),N}t.$Ug=b;function v(g){const p=[];let V=0;const T=g.length;function N(){return V<T?g[V++]():null}function O(_){_!=null&&p.push(_);const S=N();return S?S.then(O):Promise.resolve(p)}return Promise.resolve(null).then(O)}t.$Vg=v;function B(g,p=T=>!!T,V=null){let T=0;const N=g.length,O=()=>{if(T>=N)return Promise.resolve(V);const _=g[T++];return Promise.resolve(_()).then(R=>p(R)?Promise.resolve(R):O())};return O()}t.$Wg=B;function j(g,p=T=>!!T,V=null){if(g.length===0)return Promise.resolve(V);let T=g.length;const N=()=>{T=-1;for(const O of g)O.cancel?.()};return new Promise((O,_)=>{for(const S of g)S.then(R=>{--T>=0&&p(R)?(N(),O(R)):T===0&&O(V)}).catch(R=>{--T>=0&&(N(),_(R))})})}t.$Xg=j;class W{constructor(p){this.a=0,this.d=p,this.f=[],this.b=0,this.g=new i.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(p){return this.a++,new Promise((V,T)=>{this.f.push({factory:p,c:V,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const p=this.f.shift();this.b++;const V=p.factory();V.then(p.c,p.e),V.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$Yg=W;class M extends W{constructor(){super(1)}}t.$Zg=M;class F{constructor(){this.a=new Ne,this.b=0}queue(p){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,p())):this.a.run(this.b++,p())}}t.$1g=F;class J{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const p=new fe;return this.b.add(p),p.p}g(){for(const[,p]of this.a)if(p.size>0)return!1;return!0}queueFor(p,V=w.$kg){const T=V.getComparisonKey(p);let N=this.a.get(T);if(!N){N=new M;const O=this.f++,_=i.Event.once(N.onDrained)(()=>{N?.dispose(),this.a.delete(T),this.h(),this.d?.deleteAndDispose(O),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new U.$Zc),this.d.set(O,_),this.a.set(T,N)}return N}h(){this.g()&&this.j()}j(){for(const p of this.b)p.complete();this.b.clear()}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$2g=J;class ee{constructor(p,V){this.a=-1,typeof p=="function"&&typeof V=="number"&&this.setIfNotSet(p,V)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(p,V){this.cancel(),this.a=setTimeout(()=>{this.a=-1,p()},V)}setIfNotSet(p,V){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,p()},V))}}t.$3g=ee;class ne{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(p,V){this.cancel(),this.a=setInterval(()=>{p()},V)}}t.$4g=ne;class ue{constructor(p,V){this.b=-1,this.a=p,this.d=V,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(p=this.d){this.cancel(),this.b=setTimeout(this.f,p)}get delay(){return this.d}set delay(p){this.d=p}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$5g=ue;class le{constructor(p,V){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.a=p,this.b=V,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(p=this.b){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(p/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$6g=le;class oe extends ue{constructor(p,V){super(p,V),this.j=[]}work(p){this.j.push(p),this.isScheduled()||this.schedule()}h(){const p=this.j;this.j=[],this.a?.(p)}dispose(){this.j=[],super.dispose()}}t.$7g=oe;class me extends U.$Rc{constructor(p,V){super(),this.g=p,this.h=V,this.a=[],this.b=this.B(new U.$Sc),this.f=!1}get pending(){return this.a.length}work(p){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+p.length>this.g.maxBufferedWork)return!1}else if(this.pending+p.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const V of p)this.a.push(V);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ue(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$8g=me,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.$9g=g=>{(0,D.$B)(()=>{if(p)return;const V=Date.now()+15;g(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let p=!1;return{dispose(){p||(p=!0)}}}:t.$9g=(g,p)=>{const V=requestIdleCallback(g,typeof p=="number"?{timeout:p}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(V))}}}}();class Se{constructor(p){this.d=!1,this.a=()=>{try{this.f=p()}catch(V){this.g=V}finally{this.d=!0}},this.b=(0,t.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.$0g=Se;async function Le(g,p,V){let T;for(let N=0;N<V;N++)try{return await g()}catch(O){T=O,await I(p)}throw T}t.$$g=Le;class Ne{isRunning(p){return typeof p=="number"?this.a?.taskId===p:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(p,V,T){return this.a={taskId:p,cancel:()=>T?.(),promise:V},V.then(()=>this.d(p),()=>this.d(p)),V}d(p){this.a&&p===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const p=this.b;this.b=void 0,p.run().then(p.promiseResolve,p.promiseReject)}}queue(p){if(this.b)this.b.run=p;else{let V,T;const N=new Promise((O,_)=>{V=O,T=_});this.b={run:p,promise:N,promiseResolve:V,promiseReject:T}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$_g=Ne;class de{constructor(p,V=()=>Date.now()){this.d=p,this.f=V,this.a=0,this.b=0}increment(){const p=this.f();return p-this.a>this.d&&(this.a=p,this.b=0),this.b++,this.b}}t.$ah=de;var ie;(function(g){g[g.Resolved=0]="Resolved",g[g.Rejected=1]="Rejected"})(ie||(ie={}));class fe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((p,V)=>{this.a=p,this.b=V})}complete(p){return new Promise(V=>{this.a(p),this.d={outcome:0,value:p},V()})}error(p){return new Promise(V=>{this.b(p),this.d={outcome:1,value:p},V()})}cancel(){return this.error(new P.$4)}}t.$bh=fe;var X;(function(g){async function p(T){let N;const O=await Promise.all(T.map(_=>_.then(S=>S,S=>{N||(N=S)})));if(typeof N<"u")throw N;return O}g.settled=p;function V(T){return new Promise(async(N,O)=>{try{await T(N,O)}catch(_){O(_)}})}g.withAsyncBody=V})(X||(t.Promises=X={}));var q;(function(g){g[g.Initial=0]="Initial",g[g.DoneOK=1]="DoneOK",g[g.DoneError=2]="DoneError"})(q||(q={}));class G{static fromArray(p){return new G(V=>{V.emitMany(p)})}static fromPromise(p){return new G(async V=>{V.emitMany(await p)})}static fromPromises(p){return new G(async V=>{await Promise.all(p.map(async T=>V.emitOne(await T)))})}static merge(p){return new G(async V=>{await Promise.all(p.map(async T=>{for await(const N of T)V.emitOne(N)}))})}static{this.EMPTY=G.fromArray([])}constructor(p){this.a=0,this.b=[],this.d=null,this.f=new i.$Md,queueMicrotask(async()=>{const V={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve(p(V)),this.j()}catch(T){this.k(T)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}[Symbol.asyncIterator](){let p=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(p<this.b.length)return{done:!1,value:this.b[p++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(p,V){return new G(async T=>{for await(const N of p)T.emitOne(V(N))})}map(p){return G.map(this,p)}static filter(p,V){return new G(async T=>{for await(const N of p)V(N)&&T.emitOne(N)})}filter(p){return G.filter(this,p)}static coalesce(p){return G.filter(p,V=>!!V)}coalesce(){return G.coalesce(this)}static async toPromise(p){const V=[];for await(const T of p)V.push(T);return V}toPromise(){return G.toPromise(this)}g(p){this.a===0&&(this.b.push(p),this.f.fire())}h(p){this.a===0&&(this.b=this.b.concat(p),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(p){this.a===0&&(this.a=2,this.d=p,this.f.fire())}}t.$ch=G;class E extends G{constructor(p,V){super(V),this.l=p}cancel(){this.l.cancel()}}t.$dh=E;function x(g){const p=new y.$Wd,V=g(p.token);return new E(p,async T=>{const N=p.token.onCancellationRequested(()=>{N.dispose(),p.dispose(),T.reject(new P.$4)});try{for await(const O of V){if(p.token.isCancellationRequested)return;T.emitOne(O)}N.dispose(),p.dispose()}catch(O){N.dispose(),p.dispose(),T.reject(O)}})}t.$eh=x}),define(be[4],$e([1,0,16,111,14,19,9,6,3,115,2,29,5,15]),function(re,t,y,P,i,U,w,D,h,f,d,L,s,a){"use strict";var e;Object.defineProperty(t,"__esModule",{value:!0}),t.$VP=t.$UP=t.h=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.DetectedFullscreenMode=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$=t.Namespace=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.$VO=t.$UO=t.$TO=t.$SO=t.$RO=t.$QO=t.$PO=t.$OO=t.$NO=t.$MO=t.$LO=t.$KO=t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=t.$AO=t.$zO=t.onDidRegisterWindow=t.getWindows=t.registerWindow=void 0,e=function(){const Y=new Set([window]),Q=new h.$Md;return{onDidRegisterWindow:Q.event,registerWindow(he){if(Y.has(he))return d.$Rc.None;Y.add(he);const Ee=new d.$Qc;return Ee.add((0,d.$Pc)(()=>{Y.delete(he)})),Q.fire({window:he,disposableStore:Ee}),Ee},getWindows(){return Y}}}(),t.registerWindow=e.registerWindow,t.getWindows=e.getWindows,t.onDidRegisterWindow=e.onDidRegisterWindow;function u(Y){for(;Y.firstChild;)Y.firstChild.remove()}t.$zO=u;class l{constructor(Q,he,Ee,ke){this.f=Q,this.g=he,this.d=Ee,this.j=ke||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function m(Y,Q,he,Ee){return new l(Y,Q,he,Ee)}t.$AO=m;function n(Y){return function(Q){return Y(new U.$sO(Q))}}function r(Y){return function(Q){return Y(new i.$xO(Q))}}const $=function(Q,he,Ee,ke){let He=Ee;return he==="click"||he==="mousedown"?He=n(Ee):(he==="keydown"||he==="keypress"||he==="keyup")&&(He=r(Ee)),m(Q,he,He,ke)};t.$BO=$;const c=function(Q,he,Ee){const ke=n(he);return C(Q,ke,Ee)};t.$CO=c;const o=function(Q,he,Ee){const ke=n(he);return I(Q,ke,Ee)};t.$DO=o;function C(Y,Q,he){return m(Y,s.$r&&P.$pO.pointerEvents?t.$jP.POINTER_DOWN:t.$jP.MOUSE_DOWN,Q,he)}t.$EO=C;function z(Y,Q,he){return m(Y,s.$r&&P.$pO.pointerEvents?t.$jP.POINTER_MOVE:t.$jP.MOUSE_MOVE,Q,he)}t.$FO=z;function I(Y,Q,he){return m(Y,s.$r&&P.$pO.pointerEvents?t.$jP.POINTER_UP:t.$jP.MOUSE_UP,Q,he)}t.$GO=I;class b{constructor(Q,he=0){this.d=Q,this.priority=he,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Q){(0,D.$Z)(Q)}}static sort(Q,he){return he.priority-Q.priority}}(function(){let Y=[],Q=null,he=!1,Ee=!1;const ke=()=>{for(he=!1,Q=Y,Y=[],Ee=!0;Q.length>0;)Q.sort(b.sort),Q.shift().execute();Ee=!1};t.$IO=(He,Ue=0)=>{const Ze=new b(He,Ue);return Y.push(Ze),he||(he=!0,requestAnimationFrame(ke)),Ze},t.$HO=(He,Ue)=>{if(Ee){const Ze=new b(He,Ue);return Q.push(Ze),Ze}else return(0,t.$IO)(He,Ue)}})();function v(Y){return(0,t.$IO)(Y,1e4)}t.$JO=v;function B(Y){return(0,t.$IO)(Y,-1e4)}t.$KO=B;const j=8,W=function(Y,Q){return Q};class M extends d.$Rc{constructor(Q,he,Ee,ke=W,He=j){super();let Ue=null,Ze=0;const lt=this.B(new w.$3g),Xe=()=>{Ze=new Date().getTime(),Ee(Ue),Ue=null};this.B(m(Q,he,wt=>{Ue=ke(Ue,wt);const Ct=new Date().getTime()-Ze;Ct>=He?(lt.cancel(),Xe()):lt.setIfNotSet(Xe,He-Ct)}))}}function F(Y,Q,he,Ee,ke){return new M(Y,Q,he,Ee,ke)}t.$LO=F;function J(Y){return Y.ownerDocument.defaultView.getComputedStyle(Y,null)}t.$MO=J;function ee(Y){const Q=Y.ownerDocument,he=Q.defaultView?.window;if(Y!==Q.body)return new ue(Y.clientWidth,Y.clientHeight);if(s.$r&&he?.visualViewport)return new ue(he.visualViewport.width,he.visualViewport.height);if(he?.innerWidth&&he.innerHeight)return new ue(he.innerWidth,he.innerHeight);if(Q.body&&Q.body.clientWidth&&Q.body.clientHeight)return new ue(Q.body.clientWidth,Q.body.clientHeight);if(Q.documentElement&&Q.documentElement.clientWidth&&Q.documentElement.clientHeight)return new ue(Q.documentElement.clientWidth,Q.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$NO=ee;class ne{static d(Q,he){return parseFloat(he)||0}static f(Q,he,Ee){const ke=J(Q),He=ke?ke.getPropertyValue(he):"0";return ne.d(Q,He)}static getBorderLeftWidth(Q){return ne.f(Q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Q){return ne.f(Q,"border-right-width","borderRightWidth")}static getBorderTopWidth(Q){return ne.f(Q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Q){return ne.f(Q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Q){return ne.f(Q,"padding-left","paddingLeft")}static getPaddingRight(Q){return ne.f(Q,"padding-right","paddingRight")}static getPaddingTop(Q){return ne.f(Q,"padding-top","paddingTop")}static getPaddingBottom(Q){return ne.f(Q,"padding-bottom","paddingBottom")}static getMarginLeft(Q){return ne.f(Q,"margin-left","marginLeft")}static getMarginTop(Q){return ne.f(Q,"margin-top","marginTop")}static getMarginRight(Q){return ne.f(Q,"margin-right","marginRight")}static getMarginBottom(Q){return ne.f(Q,"margin-bottom","marginBottom")}}class ue{static{this.None=new ue(0,0)}constructor(Q,he){this.width=Q,this.height=he}with(Q=this.width,he=this.height){return Q!==this.width||he!==this.height?new ue(Q,he):this}static is(Q){return typeof Q=="object"&&typeof Q.height=="number"&&typeof Q.width=="number"}static lift(Q){return Q instanceof ue?Q:new ue(Q.width,Q.height)}static equals(Q,he){return Q===he?!0:!Q||!he?!1:Q.width===he.width&&Q.height===he.height}}t.$OO=ue;function le(Y){let Q=Y.offsetParent,he=Y.offsetTop,Ee=Y.offsetLeft;for(;(Y=Y.parentNode)!==null&&Y!==Y.ownerDocument.body&&Y!==Y.ownerDocument.documentElement;){he-=Y.scrollTop;const ke=O(Y)?null:J(Y);ke&&(Ee-=ke.direction!=="rtl"?Y.scrollLeft:-Y.scrollLeft),Y===Q&&(Ee+=ne.getBorderLeftWidth(Y),he+=ne.getBorderTopWidth(Y),he+=Y.offsetTop,Ee+=Y.offsetLeft,Q=Y.offsetParent)}return{left:Ee,top:he}}t.$PO=le;function oe(Y,Q,he){typeof Q=="number"&&(Y.style.width=`${Q}px`),typeof he=="number"&&(Y.style.height=`${he}px`)}t.$QO=oe;function me(Y,Q,he,Ee,ke,He="absolute"){typeof Q=="number"&&(Y.style.top=`${Q}px`),typeof he=="number"&&(Y.style.right=`${he}px`),typeof Ee=="number"&&(Y.style.bottom=`${Ee}px`),typeof ke=="number"&&(Y.style.left=`${ke}px`),Y.style.position=He}t.$RO=me;function Se(Y){const Q=Y.getBoundingClientRect();return{left:Q.left+(Y.ownerDocument.defaultView?.scrollX??0),top:Q.top+(Y.ownerDocument.defaultView?.scrollY??0),width:Q.width,height:Q.height}}t.$SO=Se;function Le(Y){let Q=Y,he=1;do{const Ee=J(Q).zoom;Ee!=null&&Ee!=="1"&&(he*=Ee),Q=Q.parentElement}while(Q!==null&&Q!==Q.ownerDocument.documentElement);return he}t.$TO=Le;function Ne(Y){const Q=ne.getMarginLeft(Y)+ne.getMarginRight(Y);return Y.offsetWidth+Q}t.$UO=Ne;function de(Y){const Q=ne.getBorderLeftWidth(Y)+ne.getBorderRightWidth(Y),he=ne.getPaddingLeft(Y)+ne.getPaddingRight(Y);return Y.offsetWidth-Q-he}t.$VO=de;function ie(Y){const Q=ne.getMarginLeft(Y)+ne.getMarginRight(Y);return Y.scrollWidth+Q}t.$WO=ie;function fe(Y){const Q=ne.getBorderTopWidth(Y)+ne.getBorderBottomWidth(Y),he=ne.getPaddingTop(Y)+ne.getPaddingBottom(Y);return Y.offsetHeight-Q-he}t.$XO=fe;function X(Y){const Q=ne.getMarginTop(Y)+ne.getMarginBottom(Y);return Y.offsetHeight+Q}t.$YO=X;function q(Y,Q){if(Y===null)return 0;const he=le(Y),Ee=le(Q);return he.left-Ee.left}function G(Y,Q){const he=Q.map(ke=>Math.max(ie(ke),Ne(ke))+q(ke,Y)||0);return Math.max(...he)}t.$ZO=G;function E(Y,Q){for(;Y;){if(Y===Q)return!0;Y=Y.parentNode}return!1}t.$1O=E;const x="parentFlowToElementId";function g(Y,Q){Y.dataset[x]=Q.id}t.$2O=g;function p(Y){const Q=Y.dataset[x];return typeof Q=="string"?Y.ownerDocument.getElementById(Q):null}function V(Y,Q){let he=Y;for(;he;){if(he===Q)return!0;if(he instanceof HTMLElement){const Ee=p(he);if(Ee){he=Ee;continue}}he=he.parentNode}return!1}t.$3O=V;function T(Y,Q,he){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y.classList.contains(Q))return Y;if(he){if(typeof he=="string"){if(Y.classList.contains(he))return null}else if(Y===he)return null}Y=Y.parentNode}return null}t.$4O=T;function N(Y,Q,he){return!!T(Y,Q,he)}t.$5O=N;function O(Y){return Y&&!!Y.host&&!!Y.mode}t.$6O=O;function _(Y){return!!S(Y)}t.$7O=_;function S(Y){for(;Y.parentNode;){if(Y===Y.ownerDocument?.body)return null;Y=Y.parentNode}return O(Y)?Y:null}t.$8O=S;function R(){let Y=A().activeElement;for(;Y?.shadowRoot;)Y=Y.shadowRoot.activeElement;return Y}t.$9O=R;function A(){return Array.from((0,t.getWindows)()).map(Q=>Q.document).find(Q=>Q.hasFocus())??document}t.$0O=A;function k(){return A().defaultView?.window??window}t.$$O=k;function H(Y){const Q=Y;if(Q?.ownerDocument?.defaultView)return Q.ownerDocument.defaultView.window;const he=Y;return he?.view?he.view.window:window}t.$_O=H;function K(Y){const Q=H(Y);Q!==k()&&Q.focus()}t.$aP=K;function te(Y=document.getElementsByTagName("head")[0],Q){const he=document.createElement("style");return he.type="text/css",he.media="screen",Q?.(he),Y.appendChild(he),he}t.$bP=te;function se(Y=document.getElementsByTagName("head")[0]){const Q=document.createElement("meta");return Y.appendChild(Q),Q}t.$cP=se;let ge=null;function we(){return ge||(ge=te()),ge}function Fe(Y){return Y?.sheet?.rules?Y.sheet.rules:Y?.sheet?.cssRules?Y.sheet.cssRules:[]}function Ae(Y,Q,he=we()){!he||!Q||he.sheet.insertRule(Y+"{"+Q+"}",0)}t.$dP=Ae;function ve(Y,Q=we()){if(!Q)return;const he=Fe(Q),Ee=[];for(let ke=0;ke<he.length;ke++)he[ke].selectorText.indexOf(Y)!==-1&&Ee.push(ke);for(let ke=Ee.length-1;ke>=0;ke--)Q.sheet.deleteRule(Ee[ke])}t.$eP=ve;function Me(Y){return Y instanceof MouseEvent||Y instanceof H(Y).MouseEvent}t.$fP=Me;function Oe(Y){return Y instanceof KeyboardEvent||Y instanceof H(Y).KeyboardEvent}t.$gP=Oe;function _e(Y){return Y instanceof PointerEvent||Y instanceof H(Y).PointerEvent}t.$hP=_e;function je(Y){return Y instanceof DragEvent||Y instanceof H(Y).DragEvent}t.$iP=je,t.$jP={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:y.$hO?"webkitAnimationStart":"animationstart",ANIMATION_END:y.$hO?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:y.$hO?"webkitAnimationIteration":"animationiteration"};function Ie(Y){const Q=Y;return!!(Q&&typeof Q.preventDefault=="function"&&typeof Q.stopPropagation=="function")}t.$kP=Ie,t.$lP={stop:(Y,Q)=>(Y.preventDefault(),Q&&Y.stopPropagation(),Y)};function Ge(Y){const Q=[];for(let he=0;Y&&Y.nodeType===Y.ELEMENT_NODE;he++)Q[he]=Y.scrollTop,Y=Y.parentNode;return Q}t.$mP=Ge;function Z(Y,Q){for(let he=0;Y&&Y.nodeType===Y.ELEMENT_NODE;he++)Y.scrollTop!==Q[he]&&(Y.scrollTop=Q[he]),Y=Y.parentNode}t.$nP=Z;class ae extends d.$Rc{static m(Q){if(Q instanceof HTMLElement){const he=S(Q),Ee=he?he.activeElement:Q.ownerDocument.activeElement;return E(Ee,Q)}else return E(window.document.activeElement,window.document)}constructor(Q){super(),this.f=this.B(new h.$Md),this.onDidFocus=this.f.event,this.g=this.B(new h.$Md),this.onDidBlur=this.g.event;let he=ae.m(Q),Ee=!1;const ke=()=>{Ee=!1,he||(he=!0,this.f.fire())},He=()=>{he&&(Ee=!0,window.setTimeout(()=>{Ee&&(Ee=!1,he=!1,this.g.fire())},0))};this.j=()=>{ae.m(Q)!==he&&(he?He():ke())},this.B(m(Q,t.$jP.FOCUS,ke,!0)),this.B(m(Q,t.$jP.BLUR,He,!0)),Q instanceof HTMLElement&&(this.B(m(Q,t.$jP.FOCUS_IN,()=>this.j())),this.B(m(Q,t.$jP.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function pe(Y){return new ae(Y)}t.$oP=pe;function De(Y,Q){return Y.after(Q),Q}t.$pP=De;function Ce(Y,...Q){if(Y.append(...Q),Q.length===1&&typeof Q[0]!="string")return Q[0]}t.$qP=Ce;function Re(Y,Q){return Y.insertBefore(Q,Y.firstChild),Q}t.$rP=Re;function ze(Y,...Q){Y.innerText="",Ce(Y,...Q)}t.$sP=ze;const Ye=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Ke;(function(Y){Y.HTML="http://www.w3.org/1999/xhtml",Y.SVG="http://www.w3.org/2000/svg"})(Ke||(t.Namespace=Ke={}));function Ve(Y,Q,he,...Ee){const ke=Ye.exec(Q);if(!ke)throw new Error("Bad use of emmet");const He=ke[1]||"div";let Ue;return Y!==Ke.HTML?Ue=document.createElementNS(Y,He):Ue=document.createElement(He),ke[3]&&(Ue.id=ke[3]),ke[4]&&(Ue.className=ke[4].replace(/\./g," ").trim()),he&&Object.entries(he).forEach(([Ze,lt])=>{typeof lt>"u"||(/^on\w+$/.test(Ze)?Ue[Ze]=lt:Ze==="selected"?lt&&Ue.setAttribute(Ze,"true"):Ue.setAttribute(Ze,lt))}),Ue.append(...Ee),Ue}function We(Y,Q,...he){return Ve(Ke.HTML,Y,Q,...he)}t.$=We,We.SVG=function(Y,Q,...he){return Ve(Ke.SVG,Y,Q,...he)};function et(Y,Q){const he=[];return Y.forEach((Ee,ke)=>{ke>0&&(Q instanceof Node?he.push(Q.cloneNode()):he.push(document.createTextNode(Q))),he.push(Ee)}),he}t.$uP=et;function it(Y,...Q){Y?ft(...Q):ut(...Q)}t.$vP=it;function ft(...Y){for(const Q of Y)Q.style.display="",Q.removeAttribute("aria-hidden")}t.$wP=ft;function ut(...Y){for(const Q of Y)Q.style.display="none",Q.setAttribute("aria-hidden","true")}t.$xP=ut;function ct(Y,Q){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y instanceof HTMLElement&&Y.hasAttribute(Q))return Y;Y=Y.parentNode}return null}function Et(Y){!Y||!Y.hasAttribute("tabIndex")||(Y.ownerDocument.activeElement===Y&&ct(Y.parentElement,"tabIndex")?.focus(),Y.removeAttribute("tabindex"))}t.$yP=Et;function At(Y){return Q=>{Q.preventDefault(),Q.stopPropagation(),Y(Q)}}t.$zP=At;function kt(){return new Promise(Y=>{document.readyState==="complete"||document&&document.body!==null?Y(void 0):window.addEventListener("DOMContentLoaded",Y,!1)})}t.$AP=kt;function St(Y){const Q=window.devicePixelRatio*Y;return Math.max(1,Math.floor(Q))/window.devicePixelRatio}t.$BP=St;function It(Y){window.open(Y,"_blank","noopener")}t.$CP=It;const Te=780,ce=640;function ye(Y){const Q=Math.floor(window.screenLeft+window.innerWidth/2-Te/2),he=Math.floor(window.screenTop+window.innerHeight/2-ce/2);window.open(Y,"_blank",`width=${Te},height=${ce},top=${he},left=${Q}`)}t.$DP=ye;function Pe(Y,Q=!0){const he=window.open();return he?(Q&&(he.opener=null),he.location.href=Y,!0):!1}t.$EP=Pe;function qe(Y){const Q=()=>{Y(),he=(0,t.$IO)(Q)};let he=(0,t.$IO)(Q);return(0,d.$Pc)(()=>he.dispose())}t.$FP=qe,L.$8f.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Je(Y){return Y?`url('${L.$bg.uriToBrowserUri(Y).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$GP=Je;function nt(Y){return`'${Y.replace(/'/g,"%27")}'`}t.$HP=nt;function xe(Y,Q){if(Y!==void 0){const he=Y.match(/^\s*var\((.+)\)$/);if(he){const Ee=he[1].split(",",2);return Ee.length===2&&(Q=xe(Ee[1].trim(),Q)),`var(${Ee[0]}, ${Q})`}return Y}return Q}t.$IP=xe;function ot(Y,Q){let he;if(a.URI.isUri(Y))he=Y.toString(!0);else{const ke=new Blob([Y]);he=URL.createObjectURL(ke),setTimeout(()=>URL.revokeObjectURL(he))}const Ee=document.createElement("a");document.body.appendChild(Ee),Ee.download=Q,Ee.href=he,Ee.click(),setTimeout(()=>document.body.removeChild(Ee))}t.$JP=ot;function pt(){return new Promise(Y=>{const Q=document.createElement("input");document.body.appendChild(Q),Q.type="file",Q.multiple=!0,h.Event.once(h.Event.fromDOMEventEmitter(Q,"input"))(()=>{Y(Q.files??void 0)}),Q.click(),setTimeout(()=>document.body.removeChild(Q))})}t.$KP=pt;var dt;(function(Y){Y[Y.DOCUMENT=1]="DOCUMENT",Y[Y.BROWSER=2]="BROWSER"})(dt||(t.DetectedFullscreenMode=dt={}));function Qt(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:dt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:dt.BROWSER,guess:!1}:(s.$k||s.$l)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:dt.BROWSER,guess:!0}:null}t.$LP=Qt;function Gt(Y,Q=!1){const he=document.createElement("a");return f.addHook("afterSanitizeAttributes",Ee=>{for(const ke of["href","src"])if(Ee.hasAttribute(ke)){const He=Ee.getAttribute(ke);if(ke==="href"&&He.startsWith("#"))continue;if(he.href=He,!Y.includes(he.protocol.replace(/:$/,""))){if(Q&&ke==="src"&&he.href.startsWith("data:"))continue;Ee.removeAttribute(ke)}}}),(0,d.$Pc)(()=>{f.removeHook("afterSanitizeAttributes")})}t.$MP=Gt;const vi=[L.Schemas.http,L.Schemas.https,L.Schemas.command];t.$NP=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Di=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function yi(Y,Q){const he=Gt(vi);try{const Ee=f.sanitize(Q,Di);Y.innerHTML=Ee}finally{he.dispose()}}t.$OP=yi;function Ei(Y){const Q=new Uint16Array(Y.length);for(let ke=0;ke<Q.length;ke++)Q[ke]=Y.charCodeAt(ke);let he="";const Ee=new Uint8Array(Q.buffer);for(let ke=0;ke<Ee.length;ke++)he+=String.fromCharCode(Ee[ke]);return he}function Ai(Y){return btoa(Ei(Y))}t.$PP=Ai;class mt extends h.$Md{constructor(){super(),this.o=new d.$Qc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(m(window,"keydown",Q=>{if(Q.defaultPrevented)return;const he=new i.$xO(Q);if(!(he.keyCode===6&&Q.repeat)){if(Q.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(Q.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(Q.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(Q.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(he.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=Q.altKey,this.s.ctrlKey=Q.ctrlKey,this.s.metaKey=Q.metaKey,this.s.shiftKey=Q.shiftKey,this.s.lastKeyPressed&&(this.s.event=Q,this.fire(this.s))}},!0)),this.o.add(m(window,"keyup",Q=>{Q.defaultPrevented||(!Q.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!Q.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!Q.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!Q.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=Q.altKey,this.s.ctrlKey=Q.ctrlKey,this.s.metaKey=Q.metaKey,this.s.shiftKey=Q.shiftKey,this.s.lastKeyReleased&&(this.s.event=Q,this.fire(this.s)))},!0)),this.o.add(m(document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),this.o.add(m(document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),this.o.add(m(document.body,"mousemove",Q=>{Q.buttons&&(this.s.lastKeyPressed=void 0)},!0)),this.o.add(m(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.B(),this.fire(this.s)}B(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return mt.A||(mt.A=new mt),mt.A}dispose(){super.dispose(),this.o.dispose()}}t.$QP=mt;function ki(Y){const Q=document.cookie.match("(^|[^;]+)\\s*"+Y+"\\s*=\\s*([^;]+)");return Q?Q.pop():void 0}t.$RP=ki;class Si extends d.$Rc{constructor(Q,he){super(),this.j=Q,this.m=he,this.f=0,this.g=0,this.n()}n(){this.B(m(this.j,t.$jP.DRAG_ENTER,Q=>{this.f++,this.g=Q.timeStamp,this.m.onDragEnter(Q)})),this.B(m(this.j,t.$jP.DRAG_OVER,Q=>{Q.preventDefault(),this.m.onDragOver?.(Q,Q.timeStamp-this.g)})),this.B(m(this.j,t.$jP.DRAG_LEAVE,Q=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave(Q))})),this.B(m(this.j,t.$jP.DRAG_END,Q=>{this.f=0,this.g=0,this.m.onDragEnd(Q)})),this.B(m(this.j,t.$jP.DROP,Q=>{this.f=0,this.g=0,this.m.onDrop(Q)}))}}t.$SP=Si;const Ci=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Fi(Y,...Q){let he,Ee;Array.isArray(Q[0])?(he={},Ee=Q[0]):(he=Q[0]||{},Ee=Q[1]);const ke=Ci.exec(Y);if(!ke||!ke.groups)throw new Error("Bad use of h");const He=ke.groups.tag||"div",Ue=document.createElement(He);ke.groups.id&&(Ue.id=ke.groups.id);const Ze=[];if(ke.groups.class)for(const Xe of ke.groups.class.split("."))Xe!==""&&Ze.push(Xe);if(he.className!==void 0)for(const Xe of he.className.split("."))Xe!==""&&Ze.push(Xe);Ze.length>0&&(Ue.className=Ze.join(" "));const lt={};if(ke.groups.name&&(lt[ke.groups.name]=Ue),Ee)for(const Xe of Ee)Xe instanceof HTMLElement?Ue.appendChild(Xe):typeof Xe=="string"?Ue.append(Xe):"root"in Xe&&(Object.assign(lt,Xe),Ue.appendChild(Xe.root));for(const[Xe,wt]of Object.entries(he))if(Xe!=="className")if(Xe==="style")for(const[Ct,Rt]of Object.entries(wt))Ue.style.setProperty(Yt(Ct),typeof Rt=="number"?Rt+"px":""+Rt);else Xe==="tabIndex"?Ue.tabIndex=wt:Ue.setAttribute(Yt(Xe),wt.toString());return lt.root=Ue,lt}t.h=Fi;function Yt(Y){return Y.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function Pi(Y,Q){const he=new h.$Md,Ee=new MutationObserver(ke=>{for(const He of ke)He.type==="attributes"&&He.attributeName&&he.fire(He.attributeName)});return Ee.observe(Y,{attributes:!0,attributeFilter:Q}),{onDidChangeAttribute:he.event,dispose:()=>{Ee.disconnect(),he.dispose()}}}function Xt(Y,Q){for(const{name:he,value:Ee}of Y.attributes)Q.setAttribute(he,Ee)}t.$UP=Xt;function Ni(Y,Q,he){const Ee=Y.getAttribute(he);Ee?Q.setAttribute(he,Ee):Q.removeAttribute(he)}function Oi(Y,Q,he){Xt(Y,Q);const Ee=Pi(Y,he);return(0,d.$Oc)(Ee,Ee.onDidChangeAttribute(ke=>Ni(Y,Q,ke)))}t.$VP=Oi}),define(be[52],$e([1,0,4,2,114]),function(re,t,y,P,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YP=t.$XP=t.$WP=void 0;class U extends P.$Rc{constructor(h,f){super(),this.B((0,y.$AO)(h,"dragover",d=>{d.preventDefault(),this.a||(this.a=setTimeout(()=>{f(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(d=>{this.B((0,y.$AO)(h,d,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$WP=U,t.$XP={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Mr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function w(D,h,f,d,L){const s=document.createElement("div");s.className=f,s.textContent=h,L&&(s.style.color=L),d&&(s.style.background=d),D.dataTransfer&&(document.body.appendChild(s),D.dataTransfer.setDragImage(s,-10,-10),setTimeout(()=>document.body.removeChild(s),0))}t.$YP=w}),define(be[53],$e([1,0,4]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qQ=t.$pQ=t.$oQ=void 0;function P(s,a={}){const e=U(a);return e.textContent=s,e}t.$oQ=P;function i(s,a={}){const e=U(a);return h(e,f(s,!!a.renderCodeSegments),a.actionHandler,a.renderCodeSegments),e}t.$pQ=i;function U(s){const a=s.inline?"span":"div",e=document.createElement(a);return s.className&&(e.className=s.className),e}t.$qQ=U;class w{constructor(a){this.b=a,this.c=0}eos(){return this.c>=this.b.length}next(){const a=this.peek();return this.advance(),a}peek(){return this.b[this.c]}advance(){this.c++}}var D;(function(s){s[s.Invalid=0]="Invalid",s[s.Root=1]="Root",s[s.Text=2]="Text",s[s.Bold=3]="Bold",s[s.Italics=4]="Italics",s[s.Action=5]="Action",s[s.ActionClose=6]="ActionClose",s[s.Code=7]="Code",s[s.NewLine=8]="NewLine"})(D||(D={}));function h(s,a,e,u){let l;if(a.type===2)l=document.createTextNode(a.content||"");else if(a.type===3)l=document.createElement("b");else if(a.type===4)l=document.createElement("i");else if(a.type===7&&u)l=document.createElement("code");else if(a.type===5&&e){const m=document.createElement("a");e.disposables.add(y.$BO(m,"click",n=>{e.callback(String(a.index),n)})),l=m}else a.type===8?l=document.createElement("br"):a.type===1&&(l=s);l&&s!==l&&s.appendChild(l),l&&Array.isArray(a.children)&&a.children.forEach(m=>{h(l,m,e,u)})}function f(s,a){const e={type:1,children:[]};let u=0,l=e;const m=[],n=new w(s);for(;!n.eos();){let r=n.next();const $=r==="\\"&&L(n.peek(),a)!==0;if($&&(r=n.next()),!$&&d(r,a)&&r===n.peek()){n.advance(),l.type===2&&(l=m.pop());const c=L(r,a);if(l.type===c||l.type===5&&c===6)l=m.pop();else{const o={type:c,children:[]};c===5&&(o.index=u,u++),l.children.push(o),m.push(l),l=o}}else if(r===`
`)l.type===2&&(l=m.pop()),l.children.push({type:8});else if(l.type!==2){const c={type:2,content:r};l.children.push(c),m.push(l),l=c}else l.content+=r}return l.type===2&&(l=m.pop()),m.length,e}function d(s,a){return L(s,a)!==0}function L(s,a){switch(s){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return a?7:0;default:return 0}}}),define(be[54],$e([1,0,4,2]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3P=void 0;class i{constructor(){this.a=new P.$Qc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(w,D){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const h=this.c;this.c=null,w&&h&&h(D)}isMonitoring(){return!!this.b}startMonitoring(w,D,h,f,d){this.isMonitoring()&&this.stopMonitoring(!1),this.b=f,this.c=d;let L=w;try{w.setPointerCapture(D),this.a.add((0,P.$Pc)(()=>{try{w.releasePointerCapture(D)}catch{}}))}catch{L=window}this.a.add(y.$AO(L,y.$jP.POINTER_MOVE,s=>{if(s.buttons!==h){this.stopMonitoring(!0);return}s.preventDefault(),this.b(s)})),this.a.add(y.$AO(L,y.$jP.POINTER_UP,s=>this.stopMonitoring(!0)))}}t.$3P=i});var Qe=this&&this.__decorate||function(re,t,y,P){var i=arguments.length,U=i<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,y):P,w;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(re,t,y,P);else for(var D=re.length-1;D>=0;D--)(w=re[D])&&(U=(i<3?w(U):i>3?w(t,y,U):w(t,y))||U);return i>3&&U&&Object.defineProperty(t,y,U),U};define(be[23],$e([1,0,4,11,25,2,44]),function(re,t,y,P,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZP=t.EventType=void 0;var D;(function(f){f.Tap="-monaco-gesturetap",f.Change="-monaco-gesturechange",f.Start="-monaco-gesturestart",f.End="-monaco-gesturesend",f.Contextmenu="-monaco-gesturecontextmenu"})(D||(t.EventType=D={}));class h extends U.$Rc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new w.$1c,this.h=new w.$1c,this.m={},this.j=null,this.n=0,this.B(y.$AO(document,"touchstart",d=>this.s(d),{passive:!1})),this.B(y.$AO(document,"touchend",d=>this.u(d))),this.B(y.$AO(document,"touchmove",d=>this.D(d),{passive:!1}))}static addTarget(d){if(!h.isTouchDevice())return U.$Rc.None;h.b||(h.b=(0,U.$Kc)(new h));const L=h.b.g.push(d);return(0,U.$Pc)(L)}static ignoreTarget(d){if(!h.isTouchDevice())return U.$Rc.None;h.b||(h.b=(0,U.$Kc)(new h));const L=h.b.h.push(d);return(0,U.$Pc)(L)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(d){const L=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let s=0,a=d.targetTouches.length;s<a;s++){const e=d.targetTouches.item(s);this.m[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:L,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[L],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const u=this.w(D.Start,e.target);u.pageX=e.pageX,u.pageY=e.pageY,this.z(u)}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}u(d){const L=Date.now(),s=Object.keys(this.m).length;for(let a=0,e=d.changedTouches.length;a<e;a++){const u=d.changedTouches.item(a);if(!this.m.hasOwnProperty(String(u.identifier))){console.warn("move of an UNKNOWN touch",u);continue}const l=this.m[u.identifier],m=Date.now()-l.initialTimeStamp;if(m<h.c&&Math.abs(l.initialPageX-P.$rb(l.rollingPageX))<30&&Math.abs(l.initialPageY-P.$rb(l.rollingPageY))<30){const n=this.w(D.Tap,l.initialTarget);n.pageX=P.$rb(l.rollingPageX),n.pageY=P.$rb(l.rollingPageY),this.z(n)}else if(m>=h.c&&Math.abs(l.initialPageX-P.$rb(l.rollingPageX))<30&&Math.abs(l.initialPageY-P.$rb(l.rollingPageY))<30){const n=this.w(D.Contextmenu,l.initialTarget);n.pageX=P.$rb(l.rollingPageX),n.pageY=P.$rb(l.rollingPageY),this.z(n)}else if(s===1){const n=P.$rb(l.rollingPageX),r=P.$rb(l.rollingPageY),$=P.$rb(l.rollingTimestamps)-l.rollingTimestamps[0],c=n-l.rollingPageX[0],o=r-l.rollingPageY[0],C=[...this.g].filter(z=>l.initialTarget instanceof Node&&z.contains(l.initialTarget));this.C(C,L,Math.abs(c)/$,c>0?1:-1,n,Math.abs(o)/$,o>0?1:-1,r)}this.z(this.w(D.End,l.initialTarget)),delete this.m[u.identifier]}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}w(d,L){const s=document.createEvent("CustomEvent");return s.initEvent(d,!1,!0),s.initialTarget=L,s.tapCount=0,s}z(d){if(d.type===D.Tap){const L=new Date().getTime();let s=0;L-this.n>h.r?s=1:s=2,this.n=L,d.tapCount=s}else(d.type===D.Change||d.type===D.Contextmenu)&&(this.n=0);if(d.initialTarget instanceof Node){for(const L of this.h)if(L.contains(d.initialTarget))return;for(const L of this.g)L.contains(d.initialTarget)&&(L.dispatchEvent(d),this.f=!0)}}C(d,L,s,a,e,u,l,m){this.j=y.$IO(()=>{const n=Date.now(),r=n-L;let $=0,c=0,o=!0;s+=h.a*r,u+=h.a*r,s>0&&(o=!1,$=a*s*r),u>0&&(o=!1,c=l*u*r);const C=this.w(D.Change);C.translationX=$,C.translationY=c,d.forEach(z=>z.dispatchEvent(C)),o||this.C(d,n,s,a,e+$,u,l,m+c)})}D(d){const L=Date.now();for(let s=0,a=d.changedTouches.length;s<a;s++){const e=d.changedTouches.item(s);if(!this.m.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const u=this.m[e.identifier],l=this.w(D.Change,u.initialTarget);l.translationX=e.pageX-P.$rb(u.rollingPageX),l.translationY=e.pageY-P.$rb(u.rollingPageY),l.pageX=e.pageX,l.pageY=e.pageY,this.z(l),u.rollingPageX.length>3&&(u.rollingPageX.shift(),u.rollingPageY.shift(),u.rollingTimestamps.shift()),u.rollingPageX.push(e.pageX),u.rollingPageY.push(e.pageY),u.rollingTimestamps.push(L)}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}}t.$ZP=h,Qe([i.$fh],h,"isTouchDevice",null)}),define(be[55],$e([1,0,4,89]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uQ=t.$tQ=t.$sQ=void 0;const P=2e4;let i,U,w,D,h;function f(a){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const l=document.createElement("div");return l.className="monaco-alert",l.setAttribute("role","alert"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};U=e(),w=e();const u=()=>{const l=document.createElement("div");return l.className="monaco-status",l.setAttribute("aria-live","polite"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};D=u(),h=u(),a.appendChild(i)}t.$sQ=f;function d(a){i&&(U.textContent!==a?(y.$zO(w),s(U,a)):(y.$zO(U),s(w,a)))}t.$tQ=d;function L(a){i&&(D.textContent!==a?(y.$zO(h),s(D,a)):(y.$zO(D),s(h,a)))}t.$uQ=L;function s(a,e){y.$zO(a),e.length>P&&(e=e.substr(0,P)),a.textContent=e,a.style.visibility="hidden",a.style.visibility="visible"}}),define(be[116],$e([1,0,4,18]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TQ=t.$SQ=void 0;const i=new RegExp(`(\\\\)?\\$\\((${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?)\\)`,"g");function U(D){const h=new Array;let f,d=0,L=0;for(;(f=i.exec(D))!==null;){L=f.index||0,d<L&&h.push(D.substring(d,L)),d=(f.index||0)+f[0].length;const[,s,a]=f;h.push(s?`$(${a})`:w({id:a}))}return d<D.length&&h.push(D.substring(d)),h}t.$SQ=U;function w(D){const h=y.$("span");return h.classList.add(...P.ThemeIcon.asClassNameArray(D)),h}t.$TQ=w}),define(be[117],$e([1,0,4]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DQ=void 0;function P(U){try{U.parentElement?.removeChild(U)}catch{}}class i{constructor(w){this.d=w,this.a=new Map,this.b=new Set,this.c=!1}alloc(w){let D=this.h(w).pop(),h=!1;if(D)h=this.b.has(D.domNode),h&&this.b.delete(D.domNode);else{const f=(0,y.$)(".monaco-list-row"),L=this.i(w).renderTemplate(f);D={domNode:f,templateId:w,templateData:L}}return{row:D,isReusingConnectedDomNode:h}}release(w){w&&this.f(w)}transact(w){if(this.c)throw new Error("Already in transaction");this.c=!0;try{w()}finally{for(const D of this.b)this.g(D);this.b.clear(),this.c=!1}}f(w){const{domNode:D,templateId:h}=w;D&&(this.c?this.b.add(D):this.g(D)),this.h(h).push(w)}g(w){w.classList.remove("scrolling"),P(w)}h(w){let D=this.a.get(w);return D||(D=[],this.a.set(w,D)),D}dispose(){this.a.forEach((w,D)=>{for(const h of w)this.i(D).disposeTemplate(h.templateData),h.templateData=null}),this.a.clear(),this.b.clear()}i(w){const D=this.d.get(w);if(!D)throw new Error(`No renderer found for ${w}`);return D}}t.$DQ=i}),define(be[118],$e([1,0,9,2]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8P=void 0;class i extends P.$Rc{constructor(w,D,h){super(),this.a=w,this.b=D,this.c=h,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new y.$3g)}setVisibility(w){this.a!==w&&(this.a=w,this.s())}setShouldBeVisible(w){this.g=w,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const w=this.r();this.h!==w&&(this.h=w,this.ensureVisibility())}setIsNeeded(w){this.j!==w&&(this.j=w,this.ensureVisibility())}setDomNode(w){this.f=w,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(w){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(w?" fade":"")))}}t.$8P=i}),define(be[119],$e([1,0,4,23,11,3,2,5]),function(re,t,y,P,i,U,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1Q=void 0;class h extends w.$Rc{constructor(d,L,s,a){super(),this.f=0,this.b=a||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new U.$Md),this.h=s,this.j(),this.setOptions(d,L)}j(){this.B(P.$ZP.addTarget(this.a)),[P.EventType.Tap].forEach(d=>{this.B(y.$AO(this.a,d,L=>{this.a.focus()}))}),this.B(y.$BO(this.a,"click",d=>{y.$lP.stop(d,!0)})),this.B(y.$BO(this.a,"change",d=>{this.a.title=d.target.value,this.g.fire({index:d.target.selectedIndex,selected:d.target.value})})),this.B(y.$BO(this.a,"keydown",d=>{let L=!1;D.$k?(d.keyCode===18||d.keyCode===16||d.keyCode===10)&&(L=!0):(d.keyCode===18&&d.altKey||d.keyCode===10||d.keyCode===3)&&(L=!0),L&&d.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(d,L){(!this.c||!i.$tb(this.c,d))&&(this.c=d,this.a.options.length=0,this.c.forEach((s,a)=>{this.a.add(this.m(s.text,a,s.isDisabled))})),L!==void 0&&this.select(L)}select(d){this.c.length===0?this.f=0:d>=0&&d<this.c.length?this.f=d:d>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(d){this.b.ariaLabel=d,this.a.setAttribute("aria-label",d)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(d){this.a.tabIndex=d?0:-1}render(d){d.classList.add("select-container"),d.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(d){this.h=d,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(d,L,s){const a=document.createElement("option");return a.value=d,a.text=d,a.disabled=!!s,a}}t.$1Q=h}),define(be[56],$e([1,0,24,11,9,48,85,3,26]),function(re,t,y,P,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vS=t.$uS=t.$tS=void 0;function f(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.$tS=f;function d(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.$uS=d;function L(a){return typeof a.collapsible=="boolean"}class s{constructor(e,u,l,m={}){this.o=e,this.p=u,this.rootRef=[],this.d=new D.$Ud,this.f=new D.$Md,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new D.$Md,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new D.$Md,this.onDidSplice=this.l.event,this.m=new i.$Pg(U.$Jd),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.filter,this.k=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:l,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,u,l=h.Iterable.empty(),m={}){if(e.length===0)throw new y.$rS(this.o,"Invalid tree location");m.diffIdentityProvider?this.q(m.diffIdentityProvider,e,u,l,m):this.s(e,u,l,m)}q(e,u,l,m=h.Iterable.empty(),n,r=n.diffDepth??0){const{parentNode:$}=this.G(u);if(!$.lastDiffIds)return this.s(u,l,m,n);const c=[...m],o=u[u.length-1],C=new w.$vs({getElements:()=>$.lastDiffIds},{getElements:()=>[...$.children.slice(0,o),...c,...$.children.slice(o+l)].map(B=>e.getId(B.element).toString())}).ComputeDiff(!1);if(C.quitEarly)return $.lastDiffIds=void 0,this.s(u,l,c,n);const z=u.slice(0,-1),I=(B,j,W)=>{if(r>0)for(let M=0;M<W;M++)B--,j--,this.q(e,[...z,B,0],Number.MAX_SAFE_INTEGER,c[j].children,n,r-1)};let b=Math.min($.children.length,o+l),v=c.length;for(const B of C.changes.sort((j,W)=>W.originalStart-j.originalStart))I(b,v,b-(B.originalStart+B.originalLength)),b=B.originalStart,v=B.modifiedStart-o,this.s([...z,b],B.originalLength,h.Iterable.slice(c,v,v+B.modifiedLength),n);I(b,v,b)}s(e,u,l=h.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:n,diffIdentityProvider:r}){const{parentNode:$,listIndex:c,revealed:o,visible:C}=this.G(e),z=[],I=h.Iterable.map(l,ue=>this.w(ue,$,$.visible?1:0,o,z,m)),b=e[e.length-1],v=$.children.length>0;let B=0;for(let ue=b;ue>=0&&ue<$.children.length;ue--){const le=$.children[ue];if(le.visible){B=le.visibleChildIndex;break}}const j=[];let W=0,M=0;for(const ue of I)j.push(ue),M+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=B+W++);const F=(0,P.$5b)($.children,b,u,j);r?$.lastDiffIds?(0,P.$5b)($.lastDiffIds,b,u,j.map(ue=>r.getId(ue.element).toString())):$.lastDiffIds=$.children.map(ue=>r.getId(ue.element).toString()):$.lastDiffIds=void 0;let J=0;for(const ue of F)ue.visible&&J++;if(J!==0)for(let ue=b+j.length;ue<$.children.length;ue++){const le=$.children[ue];le.visible&&(le.visibleChildIndex-=J)}if($.visibleChildrenCount+=W-J,o&&C){const ue=F.reduce((le,oe)=>le+(oe.visible?oe.renderNodeCount:0),0);this.B($,M-ue),this.p.splice(c,ue,z)}if(F.length>0&&n){const ue=le=>{n(le),le.children.forEach(ue)};F.forEach(ue)}this.l.fire({insertedNodes:j,deletedNodes:F});const ee=$.children.length>0;v!==ee&&this.setCollapsible(e.slice(0,-1),ee);let ne=$;for(;ne;){if(ne.visibility===2){this.m.trigger(()=>this.refilter());break}ne=ne.parent}}rerender(e){if(e.length===0)throw new y.$rS(this.o,"Invalid tree location");const{node:u,listIndex:l,revealed:m}=this.F(e);u.visible&&m&&this.p.splice(l,1,[u])}updateElementHeight(e,u){if(e.length===0)throw new y.$rS(this.o,"Invalid tree location");const{listIndex:l}=this.F(e);this.p.updateElementHeight(l,u)}has(e){return this.D(e)}getListIndex(e){const{listIndex:u,visible:l,revealed:m}=this.F(e);return l&&m?u:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,u){const l=this.E(e);typeof u>"u"&&(u=!l.collapsible);const m={collapsible:u};return this.d.bufferEvents(()=>this.t(e,m))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,u,l){const m=this.E(e);typeof u>"u"&&(u=!m.collapsed);const n={collapsed:u,recursive:l||!1};return this.d.bufferEvents(()=>this.t(e,n))}t(e,u){const{node:l,listIndex:m,revealed:n}=this.F(e),r=this.u(l,m,n,u);if(l!==this.c&&this.k&&r&&!L(u)&&l.collapsible&&!l.collapsed&&!u.recursive){let $=-1;for(let c=0;c<l.children.length;c++)if(l.children[c].visible)if($>-1){$=-1;break}else $=c;$>-1&&this.t([...e,$],u)}return r}u(e,u,l,m){const n=this.v(e,m,!1);if(!l||!e.visible||!n)return n;const r=e.renderNodeCount,$=this.x(e),c=r-(u===-1?0:1);return this.p.splice(u+1,c,$.slice(1)),n}v(e,u,l){let m;if(e===this.c?m=!1:(L(u)?(m=e.collapsible!==u.collapsible,e.collapsible=u.collapsible):e.collapsible?(m=e.collapsed!==u.collapsed,e.collapsed=u.collapsed):m=!1,m&&this.f.fire({node:e,deep:l})),!L(u)&&u.recursive)for(const n of e.children)m=this.v(n,u,!0)||m;return m}expandTo(e){this.d.bufferEvents(()=>{let u=this.E(e);for(;u.parent;)u=u.parent,e=e.slice(0,e.length-1),u.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,u=this.z(this.c);this.p.splice(0,e,u),this.m.cancel()}w(e,u,l,m,n,r){const $={parent:u,element:e.element,children:[],depth:u.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},c=this.C($,l);$.visibility=c,m&&n.push($);const o=e.children||h.Iterable.empty(),C=m&&c!==0&&!$.collapsed;let z=0,I=1;for(const b of o){const v=this.w(b,$,c,C,n,r);$.children.push(v),I+=v.renderNodeCount,v.visible&&(v.visibleChildIndex=z++)}return $.collapsible=$.collapsible||$.children.length>0,$.visibleChildrenCount=z,$.visible=c===2?z>0:c===1,$.visible?$.collapsed||($.renderNodeCount=I):($.renderNodeCount=0,m&&n.pop()),r?.($),$}x(e){const u=e.renderNodeCount,l=[];return this.y(e,l),this.B(e.parent,l.length-u),l}y(e,u){if(e.visible===!1)return 0;if(u.push(e),e.renderNodeCount=1,!e.collapsed)for(const l of e.children)e.renderNodeCount+=this.y(l,u);return this.g.fire(e),e.renderNodeCount}z(e){const u=e.renderNodeCount,l=[];return this.A(e,e.visible?1:0,l),this.B(e.parent,l.length-u),l}A(e,u,l,m=!0){let n;if(e!==this.c){if(n=this.C(e,u),n===0)return e.visible=!1,e.renderNodeCount=0,!1;m&&l.push(e)}const r=l.length;e.renderNodeCount=e===this.c?0:1;let $=!1;if(!e.collapsed||n!==0){let c=0;for(const o of e.children)$=this.A(o,n,l,m&&!e.collapsed)||$,o.visible&&(o.visibleChildIndex=c++);e.visibleChildrenCount=c}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=n===2?$:n===1,e.visibility=n),e.visible?e.collapsed||(e.renderNodeCount+=l.length-r):(e.renderNodeCount=0,m&&l.pop()),this.g.fire(e),e.visible}B(e,u){if(u!==0)for(;e;)e.renderNodeCount+=u,this.g.fire(e),e=e.parent}C(e,u){const l=this.j?this.j.filter(e.element,u):1;return typeof l=="boolean"?(e.filterData=void 0,l?1:0):f(l)?(e.filterData=l.data,d(l.visibility)):(e.filterData=void 0,d(l))}D(e,u=this.c){if(!e||e.length===0)return!0;const[l,...m]=e;return l<0||l>u.children.length?!1:this.D(m,u.children[l])}E(e,u=this.c){if(!e||e.length===0)return u;const[l,...m]=e;if(l<0||l>u.children.length)throw new y.$rS(this.o,"Invalid tree location");return this.E(m,u.children[l])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:u,listIndex:l,revealed:m,visible:n}=this.G(e),r=e[e.length-1];if(r<0||r>u.children.length)throw new y.$rS(this.o,"Invalid tree location");const $=u.children[r];return{node:$,listIndex:l,revealed:m,visible:n&&$.visible}}G(e,u=this.c,l=0,m=!0,n=!0){const[r,...$]=e;if(r<0||r>u.children.length)throw new y.$rS(this.o,"Invalid tree location");for(let c=0;c<r;c++)l+=u.children[c].renderNodeCount;return m=m&&!u.collapsed,n=n&&u.visible,$.length===0?{parentNode:u,listIndex:l,revealed:m,visible:n}:this.G($,u.children[r],l+1,m,n)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const u=[];let l=e;for(;l.parent;)u.push(l.parent.children.indexOf(l)),l=l.parent;return u.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,P.$sb)(e)[0]}getFirstElementChild(e){const u=this.E(e);if(u.children.length!==0)return u.children[0].element}getLastElementAncestor(e=[]){const u=this.E(e);if(u.children.length!==0)return this.H(u)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$vS=s}),define(be[120],$e([1,0,56,24,26]),function(re,t,y,P,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BS=void 0;class U{get size(){return this.d.size}constructor(D,h,f={}){this.k=D,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new y.$vS(D,h,null,f),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,f.sorter&&(this.j={compare(d,L){return f.sorter.compare(d.element,L.element)}}),this.h=f.identityProvider}setChildren(D,h=i.Iterable.empty(),f={}){const d=this.o(D);this.l(d,this.m(h),f)}l(D,h=i.Iterable.empty(),f){const d=new Set,L=new Set,s=e=>{if(e.element===null)return;const u=e;if(d.add(u.element),this.d.set(u.element,u),this.h){const l=this.h.getId(u.element).toString();L.add(l),this.f.set(l,u)}f.onDidCreateNode?.(u)},a=e=>{if(e.element===null)return;const u=e;if(d.has(u.element)||this.d.delete(u.element),this.h){const l=this.h.getId(u.element).toString();L.has(l)||this.f.delete(l)}f.onDidDeleteNode?.(u)};this.c.splice([...D,0],Number.MAX_VALUE,h,{...f,onDidCreateNode:s,onDidDeleteNode:a})}m(D=i.Iterable.empty()){return this.j&&(D=[...D].sort(this.j.compare.bind(this.j))),i.Iterable.map(D,h=>{let f=this.d.get(h.element);if(!f&&this.h){const s=this.h.getId(h.element).toString();f=this.f.get(s)}if(!f){let s;return typeof h.collapsed>"u"?s=void 0:h.collapsed===P.ObjectTreeElementCollapseState.Collapsed||h.collapsed===P.ObjectTreeElementCollapseState.PreserveOrCollapsed?s=!0:h.collapsed===P.ObjectTreeElementCollapseState.Expanded||h.collapsed===P.ObjectTreeElementCollapseState.PreserveOrExpanded?s=!1:s=!!h.collapsed,{...h,children:this.m(h.children),collapsed:s}}const d=typeof h.collapsible=="boolean"?h.collapsible:f.collapsible;let L;return typeof h.collapsed>"u"||h.collapsed===P.ObjectTreeElementCollapseState.PreserveOrCollapsed||h.collapsed===P.ObjectTreeElementCollapseState.PreserveOrExpanded?L=f.collapsed:h.collapsed===P.ObjectTreeElementCollapseState.Collapsed?L=!0:h.collapsed===P.ObjectTreeElementCollapseState.Expanded?L=!1:L=!!h.collapsed,{...h,collapsible:d,collapsed:L,children:this.m(h.children)}})}rerender(D){const h=this.o(D);this.c.rerender(h)}updateElementHeight(D,h){const f=this.o(D);this.c.updateElementHeight(f,h)}resort(D=null,h=!0){if(!this.j)return;const f=this.o(D),d=this.c.getNode(f);this.l(f,this.n(d,h),{})}n(D,h,f=!0){let d=[...D.children];return(h||f)&&(d=d.sort(this.j.compare.bind(this.j))),i.Iterable.map(d,L=>({element:L.element,collapsible:L.collapsible,collapsed:L.collapsed,children:this.n(L,h,!1)}))}getFirstElementChild(D=null){const h=this.o(D);return this.c.getFirstElementChild(h)}getLastElementAncestor(D=null){const h=this.o(D);return this.c.getLastElementAncestor(h)}has(D){return this.d.has(D)}getListIndex(D){const h=this.o(D);return this.c.getListIndex(h)}getListRenderCount(D){const h=this.o(D);return this.c.getListRenderCount(h)}isCollapsible(D){const h=this.o(D);return this.c.isCollapsible(h)}setCollapsible(D,h){const f=this.o(D);return this.c.setCollapsible(f,h)}isCollapsed(D){const h=this.o(D);return this.c.isCollapsed(h)}setCollapsed(D,h,f){const d=this.o(D);return this.c.setCollapsed(d,h,f)}expandTo(D){const h=this.o(D);this.c.expandTo(h)}refilter(){this.c.refilter()}getNode(D=null){if(D===null)return this.c.getNode(this.c.rootRef);const h=this.d.get(D);if(!h)throw new P.$rS(this.k,`Tree element not found: ${D}`);return h}getNodeLocation(D){return D.element}getParentNodeLocation(D){if(D===null)throw new P.$rS(this.k,"Invalid getParentNodeLocation call");const h=this.d.get(D);if(!h)throw new P.$rS(this.k,`Tree element not found: ${D}`);const f=this.c.getNodeLocation(h),d=this.c.getParentNodeLocation(f);return this.c.getNode(d).element}o(D){if(D===null)return[];const h=this.d.get(D);if(!h)throw new P.$rS(this.k,`Tree element not found: ${D}`);return this.c.getNodeLocation(h)}}t.$BS=U}),define(be[20],$e([1,0,4,14,19,23,2]),function(re,t,y,P,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4P=void 0;class D extends w.$Rc{f(f,d){this.B(y.$AO(f,y.$jP.CLICK,L=>d(new i.$sO(L))))}j(f,d){this.B(y.$AO(f,y.$jP.MOUSE_DOWN,L=>d(new i.$sO(L))))}m(f,d){this.B(y.$AO(f,y.$jP.MOUSE_OVER,L=>d(new i.$sO(L))))}u(f,d){this.B(y.$AO(f,y.$jP.MOUSE_LEAVE,L=>d(new i.$sO(L))))}z(f,d){this.B(y.$AO(f,y.$jP.KEY_DOWN,L=>d(new P.$xO(L))))}C(f,d){this.B(y.$AO(f,y.$jP.KEY_UP,L=>d(new P.$xO(L))))}D(f,d){this.B(y.$AO(f,y.$jP.INPUT,d))}F(f,d){this.B(y.$AO(f,y.$jP.BLUR,d))}G(f,d){this.B(y.$AO(f,y.$jP.FOCUS,d))}H(f,d){this.B(y.$AO(f,y.$jP.CHANGE,d))}I(f){return U.$ZP.ignoreTarget(f)}}t.$4P=D}),define(be[37],$e([1,0,54,20,9,18,4]),function(re,t,y,P,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6P=t.$5P=void 0,t.$5P=11;class D extends P.$4P{constructor(f){super(),this.a=f.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=f.bgWidth+"px",this.bgDomNode.style.height=f.bgHeight+"px",typeof f.top<"u"&&(this.bgDomNode.style.top="0px"),typeof f.left<"u"&&(this.bgDomNode.style.left="0px"),typeof f.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof f.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=f.className,this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(f.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$5P+"px",this.domNode.style.height=t.$5P+"px",typeof f.top<"u"&&(this.domNode.style.top=f.top+"px"),typeof f.left<"u"&&(this.domNode.style.left=f.left+"px"),typeof f.bottom<"u"&&(this.domNode.style.bottom=f.bottom+"px"),typeof f.right<"u"&&(this.domNode.style.right=f.right+"px"),this.g=this.B(new y.$3P),this.B(w.$BO(this.bgDomNode,w.$jP.POINTER_DOWN,d=>this.h(d))),this.B(w.$BO(this.domNode,w.$jP.POINTER_DOWN,d=>this.h(d))),this.b=this.B(new i.$4g),this.c=this.B(new i.$3g)}h(f){if(!f.target||!(f.target instanceof Element))return;const d=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(d,200),this.g.startMonitoring(f.target,f.pointerId,f.buttons,L=>{},()=>{this.b.cancel(),this.c.cancel()}),f.preventDefault()}}t.$6P=D}),define(be[57],$e([1,0,4,40,54,37,118,20,5]),function(re,t,y,P,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9P=void 0;const f=140;class d extends D.$4P{constructor(s){super(),this.g=s.lazyRender,this.a=s.host,this.b=s.scrollable,this.c=s.scrollByPage,this.h=s.scrollbarState,this.n=this.B(new w.$8P(s.visibility,"visible scrollbar "+s.extraScrollbarClassName,"invisible scrollbar "+s.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new i.$3P),this.s=!0,this.domNode=(0,P.$2P)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(y.$AO(this.domNode.domNode,y.$jP.POINTER_DOWN,a=>this.M(a)))}t(s){const a=this.B(new U.$6P(s));this.domNode.domNode.appendChild(a.bgDomNode),this.domNode.domNode.appendChild(a.domNode)}w(s,a,e,u){this.slider=(0,P.$2P)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(s),this.slider.setLeft(a),typeof e=="number"&&this.slider.setWidth(e),typeof u=="number"&&this.slider.setHeight(u),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(y.$AO(this.slider.domNode,y.$jP.POINTER_DOWN,l=>{l.button===0&&(l.preventDefault(),this.O(l))})),this.f(this.slider.domNode,l=>{l.leftButton&&l.stopPropagation()})}y(s){return this.h.setVisibleSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(s){return this.h.setScrollSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(s){return this.h.setScrollPosition(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(s){s.target===this.domNode.domNode&&this.N(s)}delegatePointerDown(s){const a=this.domNode.domNode.getClientRects()[0].top,e=a+this.h.getSliderPosition(),u=a+this.h.getSliderPosition()+this.h.getSliderSize(),l=this.U(s);e<=l&&l<=u?s.button===0&&(s.preventDefault(),this.O(s)):this.N(s)}N(s){let a,e;if(s.target===this.domNode.domNode&&typeof s.offsetX=="number"&&typeof s.offsetY=="number")a=s.offsetX,e=s.offsetY;else{const l=y.$SO(this.domNode.domNode);a=s.pageX-l.left,e=s.pageY-l.top}const u=this.S(a,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(u):this.h.getDesiredScrollPositionFromOffset(u)),s.button===0&&(s.preventDefault(),this.O(s))}O(s){if(!s.target||!(s.target instanceof Element))return;const a=this.U(s),e=this.W(s),u=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(s.target,s.pointerId,s.buttons,l=>{const m=this.W(l),n=Math.abs(m-e);if(h.$j&&n>f){this.P(u.getScrollPosition());return}const $=this.U(l)-a;this.P(u.getDesiredScrollPositionFromDelta($))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(s){const a={};this.writeScrollPosition(a,s),this.b.setScrollPositionNow(a)}updateScrollbarSize(s){this.X(s),this.h.setScrollbarSize(s),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$9P=d}),define(be[121],$e([1,0,19,57,37,41,17]),function(re,t,y,P,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0P=void 0;class D extends P.$9P{constructor(f,d,L){const s=f.getScrollDimensions(),a=f.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:L,scrollbarState:new U.$7P(d.horizontalHasArrows?d.arrowSize:0,d.horizontal===2?0:d.horizontalScrollbarSize,d.vertical===2?0:d.verticalScrollbarSize,s.width,s.scrollWidth,a.scrollLeft),visibility:d.horizontal,extraScrollbarClassName:"horizontal",scrollable:f,scrollByPage:d.scrollByPage}),d.horizontalHasArrows){const e=(d.arrowSize-i.$5P)/2,u=(d.horizontalScrollbarSize-i.$5P)/2;this.t({className:"scra",icon:w.$Sj.scrollbarButtonLeft,top:u,left:e,bottom:void 0,right:void 0,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$uO(null,1,0))}),this.t({className:"scra",icon:w.$Sj.scrollbarButtonRight,top:u,left:void 0,bottom:void 0,right:e,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$uO(null,-1,0))})}this.w(Math.floor((d.horizontalScrollbarSize-d.horizontalSliderSize)/2),0,void 0,d.horizontalSliderSize)}R(f,d){this.slider.setWidth(f),this.slider.setLeft(d)}Q(f,d){this.domNode.setWidth(f),this.domNode.setHeight(d),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(f){return this.s=this.J(f.scrollWidth)||this.s,this.s=this.L(f.scrollLeft)||this.s,this.s=this.y(f.width)||this.s,this.s}S(f,d){return f}U(f){return f.pageX}W(f){return f.pageY}X(f){this.slider.setHeight(f)}writeScrollPosition(f,d){f.scrollLeft=d}updateOptions(f){this.updateScrollbarSize(f.horizontal===2?0:f.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this.n.setVisibility(f.horizontal),this.c=f.scrollByPage}}t.$0P=D}),define(be[122],$e([1,0,19,57,37,41,17]),function(re,t,y,P,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$P=void 0;class D extends P.$9P{constructor(f,d,L){const s=f.getScrollDimensions(),a=f.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:L,scrollbarState:new U.$7P(d.verticalHasArrows?d.arrowSize:0,d.vertical===2?0:d.verticalScrollbarSize,0,s.height,s.scrollHeight,a.scrollTop),visibility:d.vertical,extraScrollbarClassName:"vertical",scrollable:f,scrollByPage:d.scrollByPage}),d.verticalHasArrows){const e=(d.arrowSize-i.$5P)/2,u=(d.verticalScrollbarSize-i.$5P)/2;this.t({className:"scra",icon:w.$Sj.scrollbarButtonUp,top:e,left:u,bottom:void 0,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$uO(null,0,1))}),this.t({className:"scra",icon:w.$Sj.scrollbarButtonDown,top:void 0,left:u,bottom:e,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$uO(null,0,-1))})}this.w(0,Math.floor((d.verticalScrollbarSize-d.verticalSliderSize)/2),d.verticalSliderSize,void 0)}R(f,d){this.slider.setHeight(f),this.slider.setTop(d)}Q(f,d){this.domNode.setWidth(d),this.domNode.setHeight(f),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(f){return this.s=this.J(f.scrollHeight)||this.s,this.s=this.L(f.scrollTop)||this.s,this.s=this.y(f.height)||this.s,this.s}S(f,d){return d}U(f){return f.pageY}W(f){return f.pageX}X(f){this.slider.setWidth(f)}writeScrollPosition(f,d){f.scrollTop=d}updateOptions(f){this.updateScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(f.vertical),this.c=f.scrollByPage}}t.$$P=D}),define(be[58],$e([1,0,16,4,40,19,121,122,20,9,3,2,5,47,96]),function(re,t,y,P,i,U,w,D,h,f,d,L,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=void 0;const e=500,u=50,l=!0;class m{constructor(I,b,v){this.timestamp=I,this.deltaX=b,this.deltaY=v,this.score=0}}class n{static{this.INSTANCE=new n}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let I=1,b=0,v=1,B=this.d;do{const j=B===this.c?I:Math.pow(2,-v);if(I-=j,b+=this.b[B].score*j,B===this.c)break;B=(this.a+B-1)%this.a,v++}while(!0);return b<=.5}acceptStandardWheelEvent(I){const b=window.devicePixelRatio/(0,y.$bO)();s.$j||s.$l?this.accept(Date.now(),I.deltaX/b,I.deltaY/b):this.accept(Date.now(),I.deltaX,I.deltaY)}accept(I,b,v){const B=new m(I,b,v);B.score=this.f(B),this.c===-1&&this.d===-1?(this.b[0]=B,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=B)}f(I){if(Math.abs(I.deltaX)>0&&Math.abs(I.deltaY)>0)return 1;let b=.5;const v=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(I.deltaX)||!this.g(I.deltaY))&&(b+=.25),Math.min(Math.max(b,0),1)}g(I){return Math.abs(Math.round(I)-I)<.01}}t.$_P=n;class r extends h.$4P{get options(){return this.a}constructor(I,b,v){super(),this.O=this.B(new d.$Md),this.onScroll=this.O.event,this.P=this.B(new d.$Md),this.onWillScroll=this.P.event,I.style.overflow="hidden",this.a=C(b),this.b=v,this.B(this.b.onScroll(j=>{this.P.fire(j),this.S(j),this.O.fire(j)}));const B={onMouseWheel:j=>this.R(j),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new D.$$P(this.b,this.a,B)),this.g=this.B(new w.$0P(this.b,this.a,B)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(I),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,i.$2P)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,i.$2P)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,i.$2P)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,j=>this.Z(j)),this.u(this.t,j=>this.Y(j)),this.L=this.B(new f.$3g),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,L.$Mc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(I){this.c.delegatePointerDown(I)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(I){this.b.setScrollDimensions(I,!1)}updateClassName(I){this.a.className=I,s.$k&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(I){typeof I.handleMouseWheel<"u"&&(this.a.handleMouseWheel=I.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof I.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=I.mouseWheelScrollSensitivity),typeof I.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=I.fastScrollSensitivity),typeof I.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=I.scrollPredominantAxis),typeof I.horizontal<"u"&&(this.a.horizontal=I.horizontal),typeof I.vertical<"u"&&(this.a.vertical=I.vertical),typeof I.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=I.horizontalScrollbarSize),typeof I.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=I.verticalScrollbarSize),typeof I.scrollByPage<"u"&&(this.a.scrollByPage=I.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(I){this.N=I}delegateScrollFromMouseWheelEvent(I){this.R(new U.$uO(I))}Q(I){if(this.w.length>0!==I&&(this.w=(0,L.$Mc)(this.w),I)){const v=B=>{this.R(new U.$uO(B))};this.w.push(P.$AO(this.t,P.$jP.MOUSE_WHEEL,v,{passive:!1}))}}R(I){if(I.browserEvent?.defaultPrevented)return;const b=n.INSTANCE;l&&b.acceptStandardWheelEvent(I);let v=!1;if(I.deltaY||I.deltaX){let j=I.deltaY*this.a.mouseWheelScrollSensitivity,W=I.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&W+j===0?W=j=0:Math.abs(j)>=Math.abs(W)?W=0:j=0),this.a.flipAxes&&([j,W]=[W,j]);const M=!s.$k&&I.browserEvent&&I.browserEvent.shiftKey;(this.a.scrollYToX||M)&&!W&&(W=j,j=0),I.browserEvent&&I.browserEvent.altKey&&(W=W*this.a.fastScrollSensitivity,j=j*this.a.fastScrollSensitivity);const F=this.b.getFutureScrollPosition();let J={};if(j){const ee=u*j,ne=F.scrollTop-(ee<0?Math.floor(ee):Math.ceil(ee));this.c.writeScrollPosition(J,ne)}if(W){const ee=u*W,ne=F.scrollLeft-(ee<0?Math.floor(ee):Math.ceil(ee));this.g.writeScrollPosition(J,ne)}J=this.b.validateScrollPosition(J),(F.scrollLeft!==J.scrollLeft||F.scrollTop!==J.scrollTop)&&(l&&this.a.mouseWheelSmoothScroll&&b.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(J):this.b.setScrollPositionNow(J),v=!0)}let B=v;!B&&this.a.alwaysConsumeMouseWheel&&(B=!0),!B&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(B=!0),B&&(I.preventDefault(),I.stopPropagation())}S(I){this.M=this.g.onDidScroll(I)||this.M,this.M=this.c.onDidScroll(I)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const I=this.b.getCurrentScrollPosition(),b=I.scrollTop>0,v=I.scrollLeft>0,B=v?" left":"",j=b?" top":"",W=v||b?" top-left-corner":"";this.n.setClassName(`shadow${B}`),this.r.setClassName(`shadow${j}`),this.s.setClassName(`shadow${W}${j}${B}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(I){this.J=!1,this.ab()}Z(I){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$aQ=r;class $ extends r{constructor(I,b){b=b||{},b.mouseWheelSmoothScroll=!1;const v=new a.$Sr({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>P.$IO(B)});super(I,b,v),this.B(v)}setScrollPosition(I){this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$bQ=$;class c extends r{constructor(I,b,v){super(I,b,v)}setScrollPosition(I){I.reuseAnimation?this.b.setScrollPositionSmooth(I,I.reuseAnimation):this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$cQ=c;class o extends r{constructor(I,b){b=b||{},b.mouseWheelSmoothScroll=!1;const v=new a.$Sr({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>P.$IO(B)});super(I,b,v),this.B(v),this.cb=I,this.B(this.onScroll(B=>{B.scrollTopChanged&&(this.cb.scrollTop=B.scrollTop),B.scrollLeftChanged&&(this.cb.scrollLeft=B.scrollLeft)})),this.scanDomNode()}setScrollPosition(I){this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$dQ=o;function C(z){const I={lazyRender:typeof z.lazyRender<"u"?z.lazyRender:!1,className:typeof z.className<"u"?z.className:"",useShadows:typeof z.useShadows<"u"?z.useShadows:!0,handleMouseWheel:typeof z.handleMouseWheel<"u"?z.handleMouseWheel:!0,flipAxes:typeof z.flipAxes<"u"?z.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof z.consumeMouseWheelIfScrollbarIsNeeded<"u"?z.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof z.alwaysConsumeMouseWheel<"u"?z.alwaysConsumeMouseWheel:!1,scrollYToX:typeof z.scrollYToX<"u"?z.scrollYToX:!1,mouseWheelScrollSensitivity:typeof z.mouseWheelScrollSensitivity<"u"?z.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof z.fastScrollSensitivity<"u"?z.fastScrollSensitivity:5,scrollPredominantAxis:typeof z.scrollPredominantAxis<"u"?z.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof z.mouseWheelSmoothScroll<"u"?z.mouseWheelSmoothScroll:!0,arrowSize:typeof z.arrowSize<"u"?z.arrowSize:11,listenOnDomNode:typeof z.listenOnDomNode<"u"?z.listenOnDomNode:null,horizontal:typeof z.horizontal<"u"?z.horizontal:1,horizontalScrollbarSize:typeof z.horizontalScrollbarSize<"u"?z.horizontalScrollbarSize:10,horizontalSliderSize:typeof z.horizontalSliderSize<"u"?z.horizontalSliderSize:0,horizontalHasArrows:typeof z.horizontalHasArrows<"u"?z.horizontalHasArrows:!1,vertical:typeof z.vertical<"u"?z.vertical:1,verticalScrollbarSize:typeof z.verticalScrollbarSize<"u"?z.verticalScrollbarSize:10,verticalHasArrows:typeof z.verticalHasArrows<"u"?z.verticalHasArrows:!1,verticalSliderSize:typeof z.verticalSliderSize<"u"?z.verticalSliderSize:0,scrollByPage:typeof z.scrollByPage<"u"?z.scrollByPage:!1};return I.horizontalSliderSize=typeof z.horizontalSliderSize<"u"?z.horizontalSliderSize:I.horizontalScrollbarSize,I.verticalSliderSize=typeof z.verticalSliderSize<"u"?z.verticalSliderSize:I.verticalScrollbarSize,s.$k&&(I.className+=" mac"),I}}),define(be[59],$e([1,0,52,4,21,23,58,11,9,25,3,2,46,47,80,117,6]),function(re,t,y,P,i,U,w,D,h,f,d,L,s,a,e,u,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HQ=t.$GQ=t.$FQ=t.$EQ=void 0;const m={CurrentDragAndDropData:void 0},n={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(I){return[I]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(b){this.d=b}constructor(b){this.elements=b}update(){}getData(){return this.elements}}t.$EQ=r;class ${constructor(b){this.elements=b}update(){}getData(){return this.elements}}t.$FQ=$;class c{constructor(){this.types=[],this.files=[]}update(b){if(b.types&&this.types.splice(0,this.types.length,...b.types),b.files){this.files.splice(0,this.files.length);for(let v=0;v<b.files.length;v++){const B=b.files.item(v);B&&(B.size||B.type)&&this.files.push(B)}}}getData(){return{types:this.types,files:this.files}}}t.$GQ=c;function o(I,b){return Array.isArray(I)&&Array.isArray(b)?(0,D.$tb)(I,b):I===b}class C{constructor(b){b?.getSetSize?this.getSetSize=b.getSetSize.bind(b):this.getSetSize=(v,B,j)=>j,b?.getPosInSet?this.getPosInSet=b.getPosInSet.bind(b):this.getPosInSet=(v,B)=>B+1,b?.getRole?this.getRole=b.getRole.bind(b):this.getRole=v=>"listitem",b?.isChecked?this.isChecked=b.isChecked.bind(b):this.isChecked=v=>{}}}class z{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(b){if(b!==this.O){if(b&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=b,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const v of this.d)this.Y(v);this.V(),this.q.setScrollDimensions({width:(0,P.$VO)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(b,v,B,j=n){if(this.Q=v,this.domId=`list_id_${++z.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new h.$Pg(50),this.v=!1,this.x=L.$Rc.None,this.y=0,this.G=!1,this.J=L.$Rc.None,this.K=L.$Rc.None,this.L=new L.$Qc,this.M=new d.$Md,this.N=new d.$Md,this.onDidChangeContentHeight=d.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=d.Event.latch(this.N.event,void 0,this.L),this.O=!1,j.horizontalScrolling&&j.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$CQ(j.paddingTop??0);for(const M of B)this.j.set(M.templateId,M);this.h=this.L.add(new u.$DQ(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof j.mouseSupport=="boolean"?j.mouseSupport:!0),this.O=j.horizontalScrolling??n.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof j.paddingBottom>"u"?0:j.paddingBottom,this.D=new C(j.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(j.transformOptimization??n.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(U.$ZP.addTarget(this.o)),this.p=this.L.add(new a.$Sr({forceIntegerValues:!0,smoothScrollDuration:j.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:M=>(0,P.$IO)(M)})),this.q=this.L.add(new w.$cQ(this.o,{alwaysConsumeMouseWheel:j.alwaysConsumeMouseWheel??n.alwaysConsumeMouseWheel,horizontal:1,vertical:j.verticalScrollMode??n.verticalScrollMode,useShadows:j.useShadows??n.useShadows,mouseWheelScrollSensitivity:j.mouseWheelScrollSensitivity,fastScrollSensitivity:j.fastScrollSensitivity,scrollByPage:j.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),b.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,P.$AO)(this.o,U.EventType.Change,M=>this.hb(M))),this.L.add((0,P.$AO)(this.q.getDomNode(),"scroll",M=>M.target.scrollTop=0)),this.L.add((0,P.$AO)(this.domNode,"dragover",M=>this.jb(this.fb(M)))),this.L.add((0,P.$AO)(this.domNode,"drop",M=>this.lb(this.fb(M)))),this.L.add((0,P.$AO)(this.domNode,"dragleave",M=>this.kb(this.fb(M)))),this.L.add((0,P.$AO)(this.domNode,"dragend",M=>this.mb(M))),this.z=j.setRowLineHeight??n.setRowLineHeight,this.A=j.setRowHeight??n.setRowHeight,this.B=j.supportDynamicHeights??n.supportDynamicHeights,this.F=j.dnd??this.L.add(n.dnd),this.layout(j.initialSize?.height,j.initialSize?.width)}updateOptions(b){b.paddingBottom!==void 0&&(this.C=b.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),b.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(b.smoothScrolling?125:0),b.horizontalScrolling!==void 0&&(this.P=b.horizontalScrolling);let v;if(b.scrollByPage!==void 0&&(v={...v??{},scrollByPage:b.scrollByPage}),b.mouseWheelScrollSensitivity!==void 0&&(v={...v??{},mouseWheelScrollSensitivity:b.mouseWheelScrollSensitivity}),b.fastScrollSensitivity!==void 0&&(v={...v??{},fastScrollSensitivity:b.fastScrollSensitivity}),v&&this.q.updateOptions(v),b.paddingTop!==void 0&&b.paddingTop!==this.g.paddingTop){const B=this.sb(this.k,this.m),j=b.paddingTop-this.g.paddingTop;this.g.paddingTop=b.paddingTop,this.W(B,Math.max(0,this.k+j),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(b){this.q.delegateScrollFromMouseWheelEvent(b)}delegateVerticalScrollbarPointerDown(b){this.q.delegateVerticalScrollbarPointerDown(b)}updateElementHeight(b,v,B){if(b<0||b>=this.d.length)return;const j=this.d[b].size;if(typeof v>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[b].lastDynamicHeightWidth=void 0,v=j+this.ub(b)}if(j===v)return;const W=this.sb(this.k,this.m);let M=0;b<W.start||B!==null&&B>b&&B<W.end?M=v-j:M=0,this.g.splice(b,1,[{size:v}]),this.d[b].size=v,this.W(W,Math.max(0,this.k+M),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(b,v,B=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(b,v,B)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(b,v,B=[]){const j=this.sb(this.k,this.m),W={start:b,end:b+v},M=s.Range.intersect(j,W),F=new Map;for(let q=M.end-1;q>=M.start;q--){const G=this.d[q];if(G.dragStartDisposable.dispose(),G.checkedDisposable.dispose(),G.row){let E=F.get(G.templateId);E||(E=[],F.set(G.templateId,E));const x=this.j.get(G.templateId);x&&x.disposeElement&&x.disposeElement(G.element,q,G.row.templateData,G.size),E.push(G.row)}G.row=null}const J={start:b+v,end:this.d.length},ee=s.Range.intersect(J,j),ne=s.Range.relativeComplement(J,j),ue=B.map(q=>({id:String(this.f++),element:q,templateId:this.Q.getTemplateId(q),size:this.Q.getHeight(q),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(q),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:L.$Rc.None,checkedDisposable:L.$Rc.None}));let le;b===0&&v>=this.d.length?(this.g=new e.$CQ(this.g.paddingTop),this.g.splice(0,0,ue),le=this.d,this.d=ue):(this.g.splice(b,v,ue),le=this.d.splice(b,v,...ue));const oe=B.length-v,me=this.sb(this.k,this.m),Se=(0,e.$AQ)(ee,oe),Le=s.Range.intersect(me,Se);for(let q=Le.start;q<Le.end;q++)this.Z(this.d[q],q);const Ne=s.Range.relativeComplement(Se,me);for(const q of Ne)for(let G=q.start;G<q.end;G++)this.ab(G);const de=ne.map(q=>(0,e.$AQ)(q,oe)),fe=[{start:b,end:b+B.length},...de].map(q=>s.Range.intersect(me,q)),X=this.vb(fe);for(const q of fe)for(let G=q.start;G<q.end;G++){const E=this.d[G],g=F.get(E.templateId)?.pop();this.X(G,X,g)}for(const q of F.values())for(const G of q)this.h.release(G);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),le.map(q=>q.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,P.$IO)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let b=0;for(const v of this.d)typeof v.width<"u"&&(b=Math.max(b,v.width));this.E=b,this.q.setScrollDimensions({scrollWidth:b===0?0:b+10}),this.N.fire(this.E)}updateWidth(b){if(!this.P||typeof this.E>"u")return;const v=this.d[b];this.Y(v),typeof v.width<"u"&&v.width>this.E&&(this.E=v.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const b of this.d)b.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const b=this.sb(this.k,this.m),v=this.g.positionAt(b.start),B=this.g.positionAt(b.start+1);return B!==-1&&(B-v)/2+v<this.scrollTop?b.start+1:b.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(b){return this.d[b].element}indexOf(b){return this.d.findIndex(v=>v.element===b)}domElement(b){const v=this.d[b].row;return v&&v.domNode}elementHeight(b){return this.d[b].size}elementTop(b){return this.g.positionAt(b)}indexAt(b){return this.g.indexAt(b)}indexAfter(b){return this.g.indexAfter(b)}layout(b,v){const B={height:typeof b=="number"?b:(0,P.$XO)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,B.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(B),typeof v<"u"&&(this.n=v,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof v=="number"?v:(0,P.$VO)(this.domNode)})}W(b,v,B,j,W,M=!1){const F=this.sb(v,B),J=s.Range.relativeComplement(F,b),ee=s.Range.relativeComplement(b,F),ne=this.vb(J);if(M){const ue=s.Range.intersect(b,F);for(let le=ue.start;le<ue.end;le++)this.Z(this.d[le],le)}this.h.transact(()=>{for(const ue of ee)for(let le=ue.start;le<ue.end;le++)this.ab(le);for(const ue of J)for(let le=ue.start;le<ue.end;le++)this.X(le,ne)}),j!==void 0&&(this.o.style.left=`-${j}px`),this.o.style.top=`-${v}px`,this.P&&W!==void 0&&(this.o.style.width=`${Math.max(W,this.n)}px`),this.k=v,this.m=B}X(b,v,B){const j=this.d[b];let W=!1;if(!j.row)if(B)j.row=B;else{const ne=this.h.alloc(j.templateId);j.row=ne.row,W=ne.isReusingConnectedDomNode}const M=this.D.getRole(j.element)||"listitem";j.row.domNode.setAttribute("role",M);const F=this.D.isChecked(j.element);if(typeof F=="boolean")j.row.domNode.setAttribute("aria-checked",String(!!F));else if(F){const ne=ue=>j.row.domNode.setAttribute("aria-checked",String(!!ue));ne(F.value),j.checkedDisposable=F.onDidChange(ne)}(W||!j.row.domNode.parentElement)&&(v?this.o.insertBefore(j.row.domNode,v):this.o.appendChild(j.row.domNode)),this.Z(j,b);const J=this.j.get(j.templateId);if(!J)throw new Error(`No renderer found for template id ${j.templateId}`);J?.renderElement(j.element,b,j.row.templateData,j.size);const ee=this.F.getDragURI(j.element);j.dragStartDisposable.dispose(),j.row.domNode.draggable=!!ee,ee&&(j.dragStartDisposable=(0,P.$AO)(j.row.domNode,"dragstart",ne=>this.ib(j.element,ee,ne))),this.P&&(this.Y(j),this.U())}Y(b){if(!b.row||!b.row.domNode)return;b.row.domNode.style.width="fit-content",b.width=(0,P.$VO)(b.row.domNode);const v=window.getComputedStyle(b.row.domNode);v.paddingLeft&&(b.width+=parseFloat(v.paddingLeft)),v.paddingRight&&(b.width+=parseFloat(v.paddingRight)),b.row.domNode.style.width=""}Z(b,v){b.row.domNode.style.top=`${this.elementTop(v)}px`,this.A&&(b.row.domNode.style.height=`${b.size}px`),this.z&&(b.row.domNode.style.lineHeight=`${b.size}px`),b.row.domNode.setAttribute("data-index",`${v}`),b.row.domNode.setAttribute("data-last-element",v===this.length-1?"true":"false"),b.row.domNode.setAttribute("data-parity",v%2===0?"even":"odd"),b.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(b.element,v,this.length))),b.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(b.element,v))),b.row.domNode.setAttribute("id",this.getElementDomId(v)),b.row.domNode.classList.toggle("drop-target",b.dropTarget)}ab(b){const v=this.d[b];if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const B=this.j.get(v.templateId);B&&B.disposeElement&&B.disposeElement(v.element,b,v.row.templateData,v.size),this.h.release(v.row),v.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(b,v){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:b,reuseAnimation:v})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(b){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:b})}get scrollTop(){return this.getScrollTop()}set scrollTop(b){this.setScrollTop(b)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return d.Event.map(this.L.add(new i.$rQ(this.domNode,"click")).event,b=>this.bb(b),this.L)}get onMouseDblClick(){return d.Event.map(this.L.add(new i.$rQ(this.domNode,"dblclick")).event,b=>this.bb(b),this.L)}get onMouseMiddleClick(){return d.Event.filter(d.Event.map(this.L.add(new i.$rQ(this.domNode,"auxclick")).event,b=>this.bb(b),this.L),b=>b.browserEvent.button===1,this.L)}get onMouseUp(){return d.Event.map(this.L.add(new i.$rQ(this.domNode,"mouseup")).event,b=>this.bb(b),this.L)}get onMouseDown(){return d.Event.map(this.L.add(new i.$rQ(this.domNode,"mousedown")).event,b=>this.bb(b),this.L)}get onMouseOver(){return d.Event.map(this.L.add(new i.$rQ(this.domNode,"mouseover")).event,b=>this.bb(b),this.L)}get onMouseMove(){return d.Event.map(this.L.add(new i.$rQ(this.domNode,"mousemove")).event,b=>this.bb(b),this.L)}get onMouseOut(){return d.Event.map(this.L.add(new i.$rQ(this.domNode,"mouseout")).event,b=>this.bb(b),this.L)}get onContextMenu(){return d.Event.any(d.Event.map(this.L.add(new i.$rQ(this.domNode,"contextmenu")).event,b=>this.bb(b),this.L),d.Event.map(this.L.add(new i.$rQ(this.domNode,U.EventType.Contextmenu)).event,b=>this.eb(b),this.L))}get onTouchStart(){return d.Event.map(this.L.add(new i.$rQ(this.domNode,"touchstart")).event,b=>this.db(b),this.L)}get onTap(){return d.Event.map(this.L.add(new i.$rQ(this.o,U.EventType.Tap)).event,b=>this.eb(b),this.L)}bb(b){const v=this.rb(b.target||null),B=typeof v>"u"?void 0:this.d[v],j=B&&B.element;return{browserEvent:b,index:v,element:j}}db(b){const v=this.rb(b.target||null),B=typeof v>"u"?void 0:this.d[v],j=B&&B.element;return{browserEvent:b,index:v,element:j}}eb(b){const v=this.rb(b.initialTarget||null),B=typeof v>"u"?void 0:this.d[v],j=B&&B.element;return{browserEvent:b,index:v,element:j}}fb(b){const v=this.rb(b.target||null),B=typeof v>"u"?void 0:this.d[v],j=B&&B.element;return{browserEvent:b,index:v,element:j}}gb(b){try{const v=this.sb(this.k,this.m);this.W(v,b.scrollTop,b.height,b.scrollLeft,b.scrollWidth),this.B&&this.tb(b.scrollTop,b.height,b.inSmoothScrolling)}catch(v){throw console.error("Got bad scroll event:",b),v}}hb(b){b.preventDefault(),b.stopPropagation(),this.scrollTop-=b.translationY}ib(b,v,B){if(!B.dataTransfer)return;const j=this.F.getDragElements(b);if(B.dataTransfer.effectAllowed="copyMove",B.dataTransfer.setData(y.$XP.TEXT,v),B.dataTransfer.setDragImage){let W;this.F.getDragLabel&&(W=this.F.getDragLabel(j,B)),typeof W>"u"&&(W=String(j.length));const M=(0,P.$)(".monaco-drag-image");M.textContent=W;const J=(ee=>{for(;ee&&!ee.classList.contains("monaco-workbench");)ee=ee.parentElement;return ee||document.body})(this.domNode);J.appendChild(M),B.dataTransfer.setDragImage(M,-10,-10),setTimeout(()=>J.removeChild(M),0)}this.domNode.classList.add("dragging"),this.H=new r(j),m.CurrentDragAndDropData=new $(j),this.F.onDragStart?.(this.H,B)}jb(b){if(b.browserEvent.preventDefault(),this.K.dispose(),m.CurrentDragAndDropData&&m.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(b.browserEvent),!b.browserEvent.dataTransfer))return!1;if(!this.H)if(m.CurrentDragAndDropData)this.H=m.CurrentDragAndDropData;else{if(!b.browserEvent.dataTransfer.types)return!1;this.H=new c}const v=this.F.onDragOver(this.H,b.element,b.index,b.browserEvent);if(this.G=typeof v=="boolean"?v:v.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;b.browserEvent.dataTransfer.dropEffect=typeof v!="boolean"&&v.effect===0?"copy":"move";let B;if(typeof v!="boolean"&&v.feedback?B=v.feedback:typeof b.index>"u"?B=[-1]:B=[b.index],B=(0,D.$Lb)(B).filter(j=>j>=-1&&j<this.length).sort((j,W)=>j-W),B=B[0]===-1?[-1]:B,o(this.I,B))return!0;if(this.I=B,this.J.dispose(),B[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,L.$Pc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const j of B){const W=this.d[j];W.dropTarget=!0,W.row?.domNode.classList.add("drop-target")}this.J=(0,L.$Pc)(()=>{for(const j of B){const W=this.d[j];W.dropTarget=!1,W.row?.domNode.classList.remove("drop-target")}})}return!0}kb(b){this.K.dispose(),this.K=(0,h.$Ug)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,b.element,b.index,b.browserEvent)}lb(b){if(!this.G)return;const v=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,!(!v||!b.browserEvent.dataTransfer)&&(b.browserEvent.preventDefault(),v.update(b.browserEvent.dataTransfer),this.F.drop(v,b.element,b.index,b.browserEvent))}mb(b){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(b)}nb(){this.I=void 0,this.J.dispose(),this.J=L.$Rc.None}ob(b){if(!this.w){const v=(0,P.$PO)(this.domNode).top;this.w=(0,P.$FP)(this.pb.bind(this,v))}this.x.dispose(),this.x=(0,h.$Ug)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=b.pageY}pb(b){if(this.y===void 0)return;const v=this.y-b,B=this.renderHeight-35;v<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(v-35))):v>B&&(this.scrollTop+=Math.min(14,Math.floor(.3*(v-B))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(b){const v=this.q.getDomNode();let B=b;for(;B instanceof HTMLElement&&B!==this.o&&v.contains(B);){const j=B.getAttribute("data-index");if(j){const W=Number(j);if(!isNaN(W))return W}B=B.parentElement}}sb(b,v){return{start:this.g.indexAt(b),end:this.g.indexAfter(b+v-1)}}tb(b,v,B){const j=this.sb(b,v);let W,M;b===this.elementTop(j.start)?(W=j.start,M=0):j.end-j.start>1&&(W=j.start+1,M=this.elementTop(W)-b);let F=0;for(;;){const J=this.sb(b,v);let ee=!1;for(let ne=J.start;ne<J.end;ne++){const ue=this.ub(ne);ue!==0&&this.g.splice(ne,1,[this.d[ne]]),F+=ue,ee=ee||ue!==0}if(!ee){F!==0&&this.S();const ne=s.Range.relativeComplement(j,J);for(const le of ne)for(let oe=le.start;oe<le.end;oe++)this.d[oe].row&&this.ab(oe);const ue=s.Range.relativeComplement(J,j);for(const le of ue)for(let oe=le.start;oe<le.end;oe++){const me=oe+1,Se=me<this.d.length?this.d[me].row:null,Le=Se?Se.domNode:null;this.X(oe,Le)}for(let le=J.start;le<J.end;le++)this.d[le].row&&this.Z(this.d[le],le);if(typeof W=="number"){const le=this.p.getFutureScrollPosition().scrollTop-b,oe=this.elementTop(W)-M+le;this.setScrollTop(oe,B)}this.M.fire(this.contentHeight);return}}}ub(b){const v=this.d[b];if(this.Q.getDynamicHeight){const M=this.Q.getDynamicHeight(v.element);if(M!==null){const F=v.size;return v.size=M,v.lastDynamicHeightWidth=this.n,M-F}}if(!v.hasDynamicHeight||v.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(v.element))return 0;const B=v.size;if(v.row)return v.row.domNode.style.height="",v.size=v.row.domNode.offsetHeight,v.lastDynamicHeightWidth=this.n,v.size-B;const{row:j}=this.h.alloc(v.templateId);j.domNode.style.height="",this.o.appendChild(j.domNode);const W=this.j.get(v.templateId);if(!W)throw new l.$bb("Missing renderer for templateId: "+v.templateId);return W.renderElement(v.element,b,j.templateData,void 0),v.size=j.domNode.offsetHeight,W.disposeElement?.(v.element,b,j.templateData,void 0),this.Q.setDynamicHeight?.(v.element,v.size),v.lastDynamicHeightWidth=this.n,this.o.removeChild(j.domNode),this.h.release(j),v.size-B}vb(b){const v=b[b.length-1];if(!v)return null;const B=this.d[v.end];return!B||!B.row?null:B.row.domNode}getElementDomId(b){return`${this.domId}_${b}`}dispose(){for(const b of this.d)if(b.dragStartDisposable.dispose(),b.checkedDisposable.dispose(),b.row){const v=this.j.get(b.row.templateId);v&&(v.disposeElement?.(b.element,-1,b.row.templateData,void 0),v.disposeTemplate(b.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$HQ=z,Qe([f.$fh],z.prototype,"onMouseClick",null),Qe([f.$fh],z.prototype,"onMouseDblClick",null),Qe([f.$fh],z.prototype,"onMouseMiddleClick",null),Qe([f.$fh],z.prototype,"onMouseUp",null),Qe([f.$fh],z.prototype,"onMouseDown",null),Qe([f.$fh],z.prototype,"onMouseOver",null),Qe([f.$fh],z.prototype,"onMouseMove",null),Qe([f.$fh],z.prototype,"onMouseOut",null),Qe([f.$fh],z.prototype,"onContextMenu",null),Qe([f.$fh],z.prototype,"onTouchStart",null),Qe([f.$fh],z.prototype,"onTap",null)}),define(be[38],$e([1,0,4,21,14,23,55,69,11,9,72,25,3,33,2,45,5,7,68,59,19,95]),function(re,t,y,P,i,U,w,D,h,f,d,L,s,a,e,u,l,m,n,r,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RQ=t.$QQ=t.$PQ=t.$OQ=t.$NQ=t.$MQ=t.$LQ=t.TypeNavigationMode=t.$KQ=t.$JQ=t.$IQ=void 0;class c{constructor(E){this.d=E,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(E){return E}renderElement(E,x,g){const p=this.c.findIndex(V=>V.templateData===g);if(p>=0){const V=this.c[p];this.d.unrender(g),V.index=x}else{const V={index:x,templateData:g};this.c.push(V)}this.d.renderIndex(x,g)}splice(E,x,g){const p=[];for(const V of this.c)V.index<E?p.push(V):V.index>=E+x&&p.push({index:V.index+g-x,templateData:V.templateData});this.c=p}renderIndexes(E){for(const{index:x,templateData:g}of this.c)E.indexOf(x)>-1&&this.d.renderIndex(x,g)}disposeTemplate(E){const x=this.c.findIndex(g=>g.templateData===E);x<0||this.c.splice(x,1)}}class o{get name(){return this.h}get renderer(){return new c(this)}constructor(E){this.h=E,this.c=0,this.d=[],this.f=[],this.g=new s.$Md,this.onChange=this.g.event}splice(E,x,g){x=Math.max(0,Math.min(x,this.c-E));const p=g.length-x,V=E+x,T=[];let N=0;for(;N<this.f.length&&this.f[N]<E;)T.push(this.f[N++]);for(let _=0;_<g.length;_++)g[_]&&T.push(_+E);for(;N<this.f.length&&this.f[N]>=V;)T.push(this.f[N++]+p);const O=this.c+p;if(this.f.length>0&&T.length===0&&O>0){const _=this.f.find(S=>S>=E)??O-1;T.push(Math.min(_,O-1))}this.renderer.splice(E,x,g.length),this.k(T,T),this.c=O}renderIndex(E,x){x.classList.toggle(this.h,this.contains(E))}unrender(E){E.classList.remove(this.h)}set(E,x){return this.k(E,[...E].sort(de),x)}k(E,x,g){const p=this.d,V=this.f;this.d=E,this.f=x;const T=Le(V,E);return this.renderer.renderIndexes(T),this.g.fire({indexes:E,browserEvent:g}),p}get(){return this.d}contains(E){return(0,h.$vb)(this.f,E,de)>=0}dispose(){(0,e.$Mc)(this.g)}}Qe([L.$fh],o.prototype,"renderer",null);class C extends o{constructor(E){super("selected"),this.l=E}renderIndex(E,x){super.renderIndex(E,x),this.l&&(this.contains(E)?x.setAttribute("aria-selected","true"):x.setAttribute("aria-selected","false"))}}class z{constructor(E,x,g){this.c=E,this.d=x,this.f=g}splice(E,x,g){if(!this.f)return this.c.splice(E,x,new Array(g.length).fill(!1));const p=this.c.get().map(N=>this.f.getId(this.d.element(N)).toString());if(p.length===0)return this.c.splice(E,x,new Array(g.length).fill(!1));const V=new Set(p),T=g.map(N=>V.has(this.f.getId(N).toString()));this.c.splice(E,x,T)}}function I(G){return G.tagName==="INPUT"||G.tagName==="TEXTAREA"}t.$IQ=I;function b(G){return G.classList.contains("monaco-editor")?!0:G.classList.contains("monaco-list")||!G.parentElement?!1:b(G.parentElement)}t.$JQ=b;function v(G){return G.tagName==="A"&&G.classList.contains("monaco-button")||G.tagName==="DIV"&&G.classList.contains("monaco-button-dropdown")?!0:G.classList.contains("monaco-list")||!G.parentElement?!1:v(G.parentElement)}t.$KQ=v;class B{get g(){return s.Event.chain(this.c.add(new P.$rQ(this.k.domNode,"keydown")).event,E=>E.filter(x=>!I(x.target)).map(x=>new i.$xO(x)))}constructor(E,x,g){this.h=E,this.k=x,this.c=new e.$Qc,this.d=new e.$Qc,this.f=g.multipleSelectionSupport,this.c.add(this.g(p=>{switch(p.keyCode){case 3:return this.l(p);case 16:return this.o(p);case 18:return this.p(p);case 11:return this.q(p);case 12:return this.s(p);case 9:return this.u(p);case 31:this.f&&(l.$k?p.metaKey:p.ctrlKey)&&this.t(p)}}))}updateOptions(E){E.multipleSelectionSupport!==void 0&&(this.f=E.multipleSelectionSupport)}l(E){E.preventDefault(),E.stopPropagation(),this.h.setSelection(this.h.getFocus(),E.browserEvent)}o(E){E.preventDefault(),E.stopPropagation(),this.h.focusPrevious(1,!1,E.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}p(E){E.preventDefault(),E.stopPropagation(),this.h.focusNext(1,!1,E.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}q(E){E.preventDefault(),E.stopPropagation(),this.h.focusPreviousPage(E.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}s(E){E.preventDefault(),E.stopPropagation(),this.h.focusNextPage(E.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}t(E){E.preventDefault(),E.stopPropagation(),this.h.setSelection((0,h.$Rb)(this.h.length),E.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(E){this.h.getSelection().length&&(E.preventDefault(),E.stopPropagation(),this.h.setSelection([],E.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Qe([L.$fh],B.prototype,"g",null);var j;(function(G){G[G.Automatic=0]="Automatic",G[G.Trigger=1]="Trigger"})(j||(t.TypeNavigationMode=j={}));var W;(function(G){G[G.Idle=0]="Idle",G[G.Typing=1]="Typing"})(W||(W={})),t.$LQ=new class{mightProducePrintableCharacter(G){return G.ctrlKey||G.metaKey||G.altKey?!1:G.keyCode>=31&&G.keyCode<=56||G.keyCode>=21&&G.keyCode<=30||G.keyCode>=98&&G.keyCode<=107||G.keyCode>=85&&G.keyCode<=95}};class M{constructor(E,x,g,p,V){this.o=E,this.p=x,this.q=g,this.s=p,this.t=V,this.c=!1,this.d=W.Idle,this.f=j.Automatic,this.g=!1,this.h=-1,this.k=new e.$Qc,this.l=new e.$Qc,this.updateOptions(E.options)}updateOptions(E){E.typeNavigationEnabled??!0?this.u():this.v(),this.f=E.typeNavigationMode??j.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let E=!1;const x=s.Event.chain(this.k.add(new P.$rQ(this.p.domNode,"keydown")).event,V=>V.filter(T=>!I(T.target)).filter(()=>this.f===j.Automatic||this.g).map(T=>new i.$xO(T)).filter(T=>E||this.s(T)).filter(T=>this.t.mightProducePrintableCharacter(T)).forEach(T=>y.$lP.stop(T,!0)).map(T=>T.browserEvent.key)),g=s.Event.debounce(x,()=>null,800,void 0,void 0,void 0,this.k);s.Event.reduce(s.Event.any(x,g),(V,T)=>T===null?null:(V||"")+T,void 0,this.k)(this.x,this,this.k),g(this.w,this,this.k),x(()=>E=!0,void 0,this.k),g(()=>E=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const E=this.o.getFocus();if(E.length>0&&E[0]===this.h){const x=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(E[0]));x&&(0,w.$tQ)(x)}this.h=-1}x(E){if(!E){this.d=W.Idle,this.g=!1;return}const x=this.o.getFocus(),g=x.length>0?x[0]:0,p=this.d===W.Idle?1:0;this.d=W.Typing;for(let V=0;V<this.o.length;V++){const T=(g+V+p)%this.o.length,N=this.q.getKeyboardNavigationLabel(this.p.element(T)),O=N&&N.toString();if(this.o.options.typeNavigationEnabled){if(typeof O<"u"){if((0,a.$Bj)(E,O)){this.h=g,this.o.setFocus([T]),this.o.reveal(T);return}const _=(0,a.$Ij)(E,O);if(_&&_[0].end-_[0].start>1&&_.length===1){this.h=g,this.o.setFocus([T]),this.o.reveal(T);return}}}else if(typeof O>"u"||(0,a.$Bj)(E,O)){this.h=g,this.o.setFocus([T]),this.o.reveal(T);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class F{constructor(E,x){this.d=E,this.f=x,this.c=new e.$Qc;const g=s.Event.chain(this.c.add(new P.$rQ(x.domNode,"keydown")).event,V=>V.filter(T=>!I(T.target)).map(T=>new i.$xO(T)));s.Event.chain(g,V=>V.filter(T=>T.keyCode===2&&!T.ctrlKey&&!T.metaKey&&!T.shiftKey&&!T.altKey))(this.g,this,this.c)}g(E){if(E.target!==this.f.domNode)return;const x=this.d.getFocus();if(x.length===0)return;const g=this.f.domElement(x[0]);if(!g)return;const p=g.querySelector("[tabIndex]");if(!p||!(p instanceof HTMLElement)||p.tabIndex===-1)return;const V=window.getComputedStyle(p);V.visibility==="hidden"||V.display==="none"||(E.preventDefault(),E.stopPropagation(),p.focus())}dispose(){this.c.dispose()}}function J(G){return l.$k?G.browserEvent.metaKey:G.browserEvent.ctrlKey}t.$MQ=J;function ee(G){return G.browserEvent.shiftKey}t.$NQ=ee;function ne(G){return(0,y.$fP)(G)&&G.button===2}const ue={isSelectionSingleChangeEvent:J,isSelectionRangeChangeEvent:ee};class le{constructor(E){this.k=E,this.f=new e.$Qc,this.g=new s.$Md,this.onPointer=this.g.event,E.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ue),this.d=typeof E.options.mouseSupport>"u"||!!E.options.mouseSupport,this.d&&(E.onMouseDown(this.s,this,this.f),E.onContextMenu(this.t,this,this.f),E.onMouseDblClick(this.v,this,this.f),E.onTouchStart(this.s,this,this.f),this.f.add(U.$ZP.addTarget(E.getHTMLElement()))),s.Event.any(E.onMouseClick,E.onMouseMiddleClick,E.onTap)(this.u,this,this.f)}updateOptions(E){E.multipleSelectionSupport!==void 0&&(this.c=void 0,E.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ue))}o(E){return this.c?this.c.isSelectionSingleChangeEvent(E):!1}p(E){return this.c?this.c.isSelectionRangeChangeEvent(E):!1}q(E){return this.o(E)||this.p(E)}s(E){b(E.browserEvent.target)||(0,y.$9O)()!==E.browserEvent.target&&this.k.domFocus()}t(E){if(I(E.browserEvent.target)||b(E.browserEvent.target))return;const x=typeof E.index>"u"?[]:[E.index];this.k.setFocus(x,E.browserEvent)}u(E){if(!this.d||I(E.browserEvent.target)||b(E.browserEvent.target)||E.browserEvent.isHandledByList)return;E.browserEvent.isHandledByList=!0;const x=E.index;if(typeof x>"u"){this.k.setFocus([],E.browserEvent),this.k.setSelection([],E.browserEvent),this.k.setAnchor(void 0);return}if(this.q(E))return this.w(E);this.k.setFocus([x],E.browserEvent),this.k.setAnchor(x),ne(E.browserEvent)||this.k.setSelection([x],E.browserEvent),this.g.fire(E)}v(E){if(I(E.browserEvent.target)||b(E.browserEvent.target)||this.q(E)||E.browserEvent.isHandledByList)return;E.browserEvent.isHandledByList=!0;const x=this.k.getFocus();this.k.setSelection(x,E.browserEvent)}w(E){const x=E.index;let g=this.k.getAnchor();if(this.p(E)){typeof g>"u"&&(g=this.k.getFocus()[0]??x,this.k.setAnchor(g));const p=Math.min(g,x),V=Math.max(g,x),T=(0,h.$Rb)(p,V+1),N=this.k.getSelection(),O=Se(Le(N,[g]),g);if(O.length===0)return;const _=Le(T,Ne(N,O));this.k.setSelection(_,E.browserEvent),this.k.setFocus([x],E.browserEvent)}else if(this.o(E)){const p=this.k.getSelection(),V=p.filter(T=>T!==x);this.k.setFocus([x]),this.k.setAnchor(x),p.length===V.length?this.k.setSelection([...V,x],E.browserEvent):this.k.setSelection(V,E.browserEvent)}}dispose(){this.f.dispose()}}t.$OQ=le;class oe{constructor(E,x){this.c=E,this.d=x}style(E){const x=this.d&&`.${this.d}`,g=[];E.listBackground&&g.push(`.monaco-list${x} .monaco-list-rows { background: ${E.listBackground}; }`),E.listFocusBackground&&(g.push(`.monaco-list${x}:focus .monaco-list-row.focused { background-color: ${E.listFocusBackground}; }`),g.push(`.monaco-list${x}:focus .monaco-list-row.focused:hover { background-color: ${E.listFocusBackground}; }`)),E.listFocusForeground&&g.push(`.monaco-list${x}:focus .monaco-list-row.focused { color: ${E.listFocusForeground}; }`),E.listActiveSelectionBackground&&(g.push(`.monaco-list${x}:focus .monaco-list-row.selected { background-color: ${E.listActiveSelectionBackground}; }`),g.push(`.monaco-list${x}:focus .monaco-list-row.selected:hover { background-color: ${E.listActiveSelectionBackground}; }`)),E.listActiveSelectionForeground&&g.push(`.monaco-list${x}:focus .monaco-list-row.selected { color: ${E.listActiveSelectionForeground}; }`),E.listActiveSelectionIconForeground&&g.push(`.monaco-list${x}:focus .monaco-list-row.selected .codicon { color: ${E.listActiveSelectionIconForeground}; }`),E.listFocusAndSelectionBackground&&g.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.selected.focused { background-color: ${E.listFocusAndSelectionBackground}; }
			`),E.listFocusAndSelectionForeground&&g.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.selected.focused { color: ${E.listFocusAndSelectionForeground}; }
			`),E.listInactiveFocusForeground&&(g.push(`.monaco-list${x} .monaco-list-row.focused { color:  ${E.listInactiveFocusForeground}; }`),g.push(`.monaco-list${x} .monaco-list-row.focused:hover { color:  ${E.listInactiveFocusForeground}; }`)),E.listInactiveSelectionIconForeground&&g.push(`.monaco-list${x} .monaco-list-row.focused .codicon { color:  ${E.listInactiveSelectionIconForeground}; }`),E.listInactiveFocusBackground&&(g.push(`.monaco-list${x} .monaco-list-row.focused { background-color:  ${E.listInactiveFocusBackground}; }`),g.push(`.monaco-list${x} .monaco-list-row.focused:hover { background-color:  ${E.listInactiveFocusBackground}; }`)),E.listInactiveSelectionBackground&&(g.push(`.monaco-list${x} .monaco-list-row.selected { background-color:  ${E.listInactiveSelectionBackground}; }`),g.push(`.monaco-list${x} .monaco-list-row.selected:hover { background-color:  ${E.listInactiveSelectionBackground}; }`)),E.listInactiveSelectionForeground&&g.push(`.monaco-list${x} .monaco-list-row.selected { color: ${E.listInactiveSelectionForeground}; }`),E.listHoverBackground&&g.push(`.monaco-list${x}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${E.listHoverBackground}; }`),E.listHoverForeground&&g.push(`.monaco-list${x}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${E.listHoverForeground}; }`);const p=(0,y.$IP)(E.listFocusAndSelectionOutline,(0,y.$IP)(E.listSelectionOutline,E.listFocusOutline??""));p&&g.push(`.monaco-list${x}:focus .monaco-list-row.focused.selected { outline: 1px solid ${p}; outline-offset: -1px;}`),E.listFocusOutline&&g.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.focused { outline: 1px solid ${E.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${x}.last-focused .monaco-list-row.focused { outline: 1px solid ${E.listFocusOutline}; outline-offset: -1px; }
			`);const V=(0,y.$IP)(E.listSelectionOutline,E.listInactiveFocusOutline??"");V&&g.push(`.monaco-list${x} .monaco-list-row.focused.selected { outline: 1px dotted ${V}; outline-offset: -1px; }`),E.listSelectionOutline&&g.push(`.monaco-list${x} .monaco-list-row.selected { outline: 1px dotted ${E.listSelectionOutline}; outline-offset: -1px; }`),E.listInactiveFocusOutline&&g.push(`.monaco-list${x} .monaco-list-row.focused { outline: 1px dotted ${E.listInactiveFocusOutline}; outline-offset: -1px; }`),E.listHoverOutline&&g.push(`.monaco-list${x} .monaco-list-row:hover { outline: 1px dashed ${E.listHoverOutline}; outline-offset: -1px; }`),E.listDropBackground&&g.push(`
				.monaco-list${x}.drop-target,
				.monaco-list${x} .monaco-list-rows.drop-target,
				.monaco-list${x} .monaco-list-row.drop-target { background-color: ${E.listDropBackground} !important; color: inherit !important; }
			`),E.tableColumnsBorder&&g.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${E.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),E.tableOddRowsBackgroundColor&&g.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${E.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=g.join(`
`)}}t.$PQ=oe,t.$QQ={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:d.$Ts.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:d.$Ts.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:d.$Ts.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const me={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Se(G,E){const x=G.indexOf(E);if(x===-1)return[];const g=[];let p=x-1;for(;p>=0&&G[p]===E-(x-p);)g.push(G[p--]);for(g.reverse(),p=x;p<G.length&&G[p]===E+(p-x);)g.push(G[p++]);return g}function Le(G,E){const x=[];let g=0,p=0;for(;g<G.length||p<E.length;)if(g>=G.length)x.push(E[p++]);else if(p>=E.length)x.push(G[g++]);else if(G[g]===E[p]){x.push(G[g]),g++,p++;continue}else G[g]<E[p]?x.push(G[g++]):x.push(E[p++]);return x}function Ne(G,E){const x=[];let g=0,p=0;for(;g<G.length||p<E.length;)if(g>=G.length)x.push(E[p++]);else if(p>=E.length)x.push(G[g++]);else if(G[g]===E[p]){g++,p++;continue}else G[g]<E[p]?x.push(G[g++]):p++;return x}const de=(G,E)=>G-E;class ie{constructor(E,x){this.c=E,this.d=x}get templateId(){return this.c}renderTemplate(E){return this.d.map(x=>x.renderTemplate(E))}renderElement(E,x,g,p){let V=0;for(const T of this.d)T.renderElement(E,x,g[V++],p)}disposeElement(E,x,g,p){let V=0;for(const T of this.d)T.disposeElement?.(E,x,g[V],p),V+=1}disposeTemplate(E){let x=0;for(const g of this.d)g.disposeTemplate(E[x++])}}class fe{constructor(E){this.c=E,this.templateId="a18n"}renderTemplate(E){return E}renderElement(E,x,g){const p=this.c.getAriaLabel(E);p?g.setAttribute("aria-label",p):g.removeAttribute("aria-label");const V=this.c.getAriaLevel&&this.c.getAriaLevel(E);typeof V=="number"?g.setAttribute("aria-level",`${V}`):g.removeAttribute("aria-level")}disposeTemplate(E){}}class X{constructor(E,x){this.c=E,this.d=x}getDragElements(E){const x=this.c.getSelectedElements();return x.indexOf(E)>-1?x:[E]}getDragURI(E){return this.d.getDragURI(E)}getDragLabel(E,x){if(this.d.getDragLabel)return this.d.getDragLabel(E,x)}onDragStart(E,x){this.d.onDragStart?.(E,x)}onDragOver(E,x,g,p){return this.d.onDragOver(E,x,g,p)}onDragLeave(E,x,g,p){this.d.onDragLeave?.(E,x,g,p)}onDragEnd(E){this.d.onDragEnd?.(E)}drop(E,x,g,p){this.d.drop(E,x,g,p)}dispose(){this.d.dispose()}}class q{get onDidChangeFocus(){return s.Event.map(this.g.wrapEvent(this.c.onChange),E=>this.G(E),this.y)}get onDidChangeSelection(){return s.Event.map(this.g.wrapEvent(this.d.onChange),E=>this.G(E),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let E=!1;const x=s.Event.chain(this.y.add(new P.$rQ(this.k.domNode,"keydown")).event,V=>V.map(T=>new i.$xO(T)).filter(T=>E=T.keyCode===58||T.shiftKey&&T.keyCode===68).map(T=>y.$lP.stop(T,!0)).filter(()=>!1)),g=s.Event.chain(this.y.add(new P.$rQ(this.k.domNode,"keyup")).event,V=>V.forEach(()=>E=!1).map(T=>new i.$xO(T)).filter(T=>T.keyCode===58||T.shiftKey&&T.keyCode===68).map(T=>y.$lP.stop(T,!0)).map(({browserEvent:T})=>{const N=this.getFocus(),O=N.length?N[0]:void 0,_=typeof O<"u"?this.k.element(O):void 0,S=typeof O<"u"?this.k.domElement(O):this.k.domNode;return{index:O,element:_,anchor:S,browserEvent:T}})),p=s.Event.chain(this.k.onContextMenu,V=>V.filter(T=>!E).map(({element:T,index:N,browserEvent:O})=>({element:T,index:N,anchor:new $.$sO(O),browserEvent:O})));return s.Event.any(x,g,p)}get onKeyDown(){return this.y.add(new P.$rQ(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new P.$rQ(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new P.$rQ(this.k.domNode,"keypress")).event}get onDidFocus(){return s.Event.signal(this.y.add(new P.$rQ(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return s.Event.signal(this.y.add(new P.$rQ(this.k.domNode,"blur",!0)).event)}constructor(E,x,g,p,V=me){this.A=E,this.B=V,this.c=new o("focused"),this.f=new o("anchor"),this.g=new s.$Ud,this.x="",this.y=new e.$Qc,this.z=new s.$Md,this.onDidDispose=this.z.event;const T=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new C(T!=="listbox");const N=[this.c.renderer,this.d.renderer];this.u=V.accessibilityProvider,this.u&&(N.push(new fe(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),p=p.map(_=>new ie(_.templateId,[...N,_]));const O={...V,dnd:V.dnd&&new X(this,V.dnd)};if(this.k=this.C(x,g,p,O),this.k.domNode.setAttribute("role",T),V.styleController)this.q=V.styleController(this.k.domId);else{const _=(0,y.$bP)(this.k.domNode);this.q=new oe(_,this.k.domId)}if(this.o=new D.$vQ([new z(this.c,this.k,V.identityProvider),new z(this.d,this.k,V.identityProvider),new z(this.f,this.k,V.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new F(this,this.k)),(typeof V.keyboardSupport!="boolean"||V.keyboardSupport)&&(this.v=new B(this,this.k,V),this.y.add(this.v)),V.keyboardNavigationLabelProvider){const _=V.keyboardNavigationDelegate||t.$LQ;this.t=new M(this,this.k,V.keyboardNavigationLabelProvider,V.keyboardNavigationEventFilter??(()=>!0),_),this.y.add(this.t)}this.w=this.D(V),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(E,x,g,p){return new r.$HQ(E,x,g,p)}D(E){return new le(this)}updateOptions(E={}){this.B={...this.B,...E},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(E),this.v?.updateOptions(E),this.k.updateOptions(E)}get options(){return this.B}splice(E,x,g=[]){if(E<0||E>this.k.length)throw new n.$xQ(this.A,`Invalid start index: ${E}`);if(x<0)throw new n.$xQ(this.A,`Invalid delete count: ${x}`);x===0&&g.length===0||this.g.bufferEvents(()=>this.o.splice(E,x,g))}updateWidth(E){this.k.updateWidth(E)}updateElementHeight(E,x){this.k.updateElementHeight(E,x,null)}rerender(){this.k.rerender()}element(E){return this.k.element(E)}indexOf(E){return this.k.indexOf(E)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(E){this.k.setScrollTop(E)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(E){this.k.setScrollLeft(E)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(E){this.x=E,this.k.domNode.setAttribute("aria-label",E)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(E,x){this.k.layout(E,x)}triggerTypeNavigation(){this.t?.trigger()}setSelection(E,x){for(const g of E)if(g<0||g>=this.length)throw new n.$xQ(this.A,`Invalid index ${g}`);this.d.set(E,x)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(E=>this.k.element(E))}setAnchor(E){if(typeof E>"u"){this.f.set([]);return}if(E<0||E>=this.length)throw new n.$xQ(this.A,`Invalid index ${E}`);this.f.set([E])}getAnchor(){return(0,h.$Nb)(this.f.get(),void 0)}getAnchorElement(){const E=this.getAnchor();return typeof E>"u"?void 0:this.element(E)}setFocus(E,x){for(const g of E)if(g<0||g>=this.length)throw new n.$xQ(this.A,`Invalid index ${g}`);this.c.set(E,x)}focusNext(E=1,x=!1,g,p){if(this.length===0)return;const V=this.c.get(),T=this.E(V.length>0?V[0]+E:0,x,p);T>-1&&this.setFocus([T],g)}focusPrevious(E=1,x=!1,g,p){if(this.length===0)return;const V=this.c.get(),T=this.F(V.length>0?V[0]-E:0,x,p);T>-1&&this.setFocus([T],g)}async focusNextPage(E,x){let g=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);g=g===0?0:g-1;const p=this.getFocus()[0];if(p!==g&&(p===void 0||g>p)){const V=this.F(g,!1,x);V>-1&&p!==V?this.setFocus([V],E):this.setFocus([g],E)}else{const V=this.k.getScrollTop();let T=V+this.k.renderHeight;g>p&&(T-=this.k.elementHeight(g)),this.k.setScrollTop(T),this.k.getScrollTop()!==V&&(this.setFocus([]),await(0,f.$Tg)(0),await this.focusNextPage(E,x))}}async focusPreviousPage(E,x){let g;const p=this.k.getScrollTop();p===0?g=this.k.indexAt(p):g=this.k.indexAfter(p-1);const V=this.getFocus()[0];if(V!==g&&(V===void 0||V>=g)){const T=this.E(g,!1,x);T>-1&&V!==T?this.setFocus([T],E):this.setFocus([g],E)}else{const T=p;this.k.setScrollTop(p-this.k.renderHeight),this.k.getScrollTop()!==T&&(this.setFocus([]),await(0,f.$Tg)(0),await this.focusPreviousPage(E,x))}}focusLast(E,x){if(this.length===0)return;const g=this.F(this.length-1,!1,x);g>-1&&this.setFocus([g],E)}focusFirst(E,x){this.focusNth(0,E,x)}focusNth(E,x,g){if(this.length===0)return;const p=this.E(E,!1,g);p>-1&&this.setFocus([p],x)}E(E,x=!1,g){for(let p=0;p<this.length;p++){if(E>=this.length&&!x)return-1;if(E=E%this.length,!g||g(this.element(E)))return E;E++}return-1}F(E,x=!1,g){for(let p=0;p<this.length;p++){if(E<0&&!x)return-1;if(E=(this.length+E%this.length)%this.length,!g||g(this.element(E)))return E;E--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(E=>this.k.element(E))}reveal(E,x){if(E<0||E>=this.length)throw new n.$xQ(this.A,`Invalid index ${E}`);const g=this.k.getScrollTop(),p=this.k.elementTop(E),V=this.k.elementHeight(E);if((0,m.$Bf)(x)){const T=V-this.k.renderHeight;this.k.setScrollTop(T*(0,u.$Ll)(x,0,1)+p)}else{const T=p+V,N=g+this.k.renderHeight;p<g&&T>=N||(p<g||T>=N&&V>=this.k.renderHeight?this.k.setScrollTop(p):T>=N&&this.k.setScrollTop(T-this.k.renderHeight))}}getRelativeTop(E){if(E<0||E>=this.length)throw new n.$xQ(this.A,`Invalid index ${E}`);const x=this.k.getScrollTop(),g=this.k.elementTop(E),p=this.k.elementHeight(E);if(g<x||g+p>x+this.k.renderHeight)return null;const V=p-this.k.renderHeight;return Math.abs((x-g)/V)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(E){return this.k.getElementDomId(E)}style(E){this.q.style(E)}G({indexes:E,browserEvent:x}){return{indexes:E,elements:E.map(g=>this.k.element(g)),browserEvent:x}}H(){const E=this.c.get();this.k.domNode.classList.toggle("element-focused",E.length>0),this.I()}I(){const E=this.c.get();if(E.length>0){let x;this.u?.getActiveDescendantId&&(x=this.u.getActiveDescendantId(this.k.element(E[0]))),this.k.domNode.setAttribute("aria-activedescendant",x||this.k.getElementDomId(E[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const E=this.d.get();this.k.domNode.classList.toggle("selection-none",E.length===0),this.k.domNode.classList.toggle("selection-single",E.length===1),this.k.domNode.classList.toggle("selection-multiple",E.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$RQ=q,Qe([L.$fh],q.prototype,"onDidChangeFocus",null),Qe([L.$fh],q.prototype,"onDidChangeSelection",null),Qe([L.$fh],q.prototype,"onContextMenu",null),Qe([L.$fh],q.prototype,"onKeyDown",null),Qe([L.$fh],q.prototype,"onKeyUp",null),Qe([L.$fh],q.prototype,"onKeyPress",null),Qe([L.$fh],q.prototype,"onDidFocus",null),Qe([L.$fh],q.prototype,"onDidBlur",null)}),define(be[60],$e([1,0,6,34,36,12,15]),function(re,t,y,P,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8j=t.$7j=t.$6j=t.$5j=t.$4j=t.$3j=t.$2j=t.$1j=t.MarkdownStringTextNewlineStyle=void 0;var D;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(D||(t.MarkdownStringTextNewlineStyle=D={}));class h{constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,y.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=0){return this.value+=s(this.supportThemeIcons?(0,P.$Uj)(m):m).replace(/([ \t]+)/g,(r,$)=>"&nbsp;".repeat($.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(m,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(m),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(m,n){const r=new RegExp((0,U.$Ee)(n),"g");return m.replace(r,($,c)=>m.charAt(c-1)!=="\\"?`\\${$}`:$)}}t.$1j=h;function f(l){return d(l)?!l.value:Array.isArray(l)?l.every(f):!0}t.$2j=f;function d(l){return l instanceof h?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}t.$3j=d;function L(l,m){return l===m?!0:!l||!m?!1:l.value===m.value&&l.isTrusted===m.isTrusted&&l.supportThemeIcons===m.supportThemeIcons&&l.supportHtml===m.supportHtml&&(l.baseUri===m.baseUri||!!l.baseUri&&!!m.baseUri&&(0,i.$ng)(w.URI.from(l.baseUri),w.URI.from(m.baseUri)))}t.$4j=L;function s(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$5j=s;function a(l){return l.replace(/"/g,"&quot;")}t.$6j=a;function e(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$7j=e;function u(l){const m=[],n=l.split("|").map($=>$.trim());l=n[0];const r=n[1];if(r){const $=/height=(\d+)/.exec(r),c=/width=(\d+)/.exec(r),o=$?$[1]:"",C=c?c[1]:"",z=isFinite(parseInt(C)),I=isFinite(parseInt(o));z&&m.push(`width="${C}"`),I&&m.push(`height="${o}"`)}return{href:l,dimensions:m}}t.$8j=u}),define(be[123],$e([1,0,4,115,21,53,14,19,116,6,3,60,34,75,27,2,77,51,29,49,36,12,15]),function(re,t,y,P,i,U,w,D,h,f,d,L,s,a,e,u,l,m,n,r,$,c,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YQ=t.$XQ=t.$WQ=t.$VQ=t.$UQ=void 0;const C=Object.freeze({image:(X,q,G)=>{let E=[],x=[];return X&&({href:X,dimensions:E}=(0,L.$8j)(X),x.push(`src="${(0,L.$6j)(X)}"`)),G&&x.push(`alt="${(0,L.$6j)(G)}"`),q&&x.push(`title="${(0,L.$6j)(q)}"`),E.length&&(x=x.concat(E)),"<img "+x.join(" ")+">"},paragraph:X=>`<p>${X}</p>`,link:(X,q,G)=>typeof X!="string"?"":(X===G&&(G=(0,L.$7j)(G)),q=typeof q=="string"?(0,L.$6j)((0,L.$7j)(q)):"",X=(0,L.$7j)(X),X=X.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${X}" title="${q||X}">${G}</a>`)});function z(X,q={},G={}){const E=new u.$Qc;let x=!1;const g=(0,U.$qQ)(q),p=function(k){let H;try{H=(0,m.$jh)(decodeURIComponent(k))}catch{}return H?(H=(0,r.$5m)(H,K=>{if(X.uris&&X.uris[K])return o.URI.revive(X.uris[K])}),encodeURIComponent(JSON.stringify(H))):k},V=function(k,H){const K=X.uris&&X.uris[k];let te=o.URI.revive(K);return H?k.startsWith(n.Schemas.data+":")?k:(te||(te=o.URI.parse(k)),n.$bg.uriToBrowserUri(te).toString(!0)):!te||o.URI.parse(k).toString()===te.toString()?k:(te.query&&(te=te.with({query:p(te.query)})),te.toString())},T=new l.marked.Renderer;T.image=C.image,T.link=C.link,T.paragraph=C.paragraph;const N=[],O=[];if(q.codeBlockRendererSync?T.code=(k,H)=>{const K=a.$hM.nextId(),te=q.codeBlockRendererSync(I(H),k);return O.push([K,te]),`<div class="code" data-code="${K}">${(0,c.$De)(k)}</div>`}:q.codeBlockRenderer&&(T.code=(k,H)=>{const K=a.$hM.nextId(),te=q.codeBlockRenderer(I(H),k);return N.push(te.then(se=>[K,se])),`<div class="code" data-code="${K}">${(0,c.$De)(k)}</div>`}),q.actionHandler){const k=function(te){let se=te.target;if(!(se.tagName!=="A"&&(se=se.parentElement,!se||se.tagName!=="A")))try{let ge=se.dataset.href;ge&&(X.baseUri&&(ge=b(o.URI.from(X.baseUri),ge)),q.actionHandler.callback(ge,te))}catch(ge){(0,f.$Z)(ge)}finally{te.preventDefault()}},H=q.actionHandler.disposables.add(new i.$rQ(g,"click")),K=q.actionHandler.disposables.add(new i.$rQ(g,"auxclick"));q.actionHandler.disposables.add(d.Event.any(H.event,K.event)(te=>{const se=new D.$sO(te);!se.leftButton&&!se.middleButton||k(se)})),q.actionHandler.disposables.add(y.$AO(g,"keydown",te=>{const se=new w.$xO(te);!se.equals(10)&&!se.equals(3)||k(se)}))}X.supportHtml||(G.sanitizer=k=>(X.isTrusted?k.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?k:"",G.sanitize=!0,G.silent=!0),G.renderer=T;let _=X.value??"";_.length>1e5&&(_=`${_.substr(0,1e5)}\u2026`),X.supportThemeIcons&&(_=(0,s.$Vj)(_));let S;if(q.fillInIncompleteTokens){const k={...l.marked.defaults,...G},H=l.marked.lexer(_,k),K=ne(H);S=l.marked.parser(K,k)}else S=l.marked.parse(_,G);X.supportThemeIcons&&(S=(0,h.$SQ)(S).map(H=>typeof H=="string"?H:H.outerHTML).join(""));const A=new DOMParser().parseFromString(v(X,S),"text/html");if(A.body.querySelectorAll("img").forEach(k=>{const H=k.getAttribute("src");if(H){let K=H;try{X.baseUri&&(K=b(o.URI.from(X.baseUri),K))}catch{}k.src=V(K,!0)}}),A.body.querySelectorAll("a").forEach(k=>{const H=k.getAttribute("href");if(k.setAttribute("href",""),!H||/^data:|javascript:/i.test(H)||/^command:/i.test(H)&&!X.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(H))k.replaceWith(...k.childNodes);else{let K=V(H,!1);X.baseUri&&(K=b(o.URI.from(X.baseUri),H)),k.dataset.href=K}}),g.innerHTML=v(X,A.body.innerHTML),N.length>0)Promise.all(N).then(k=>{if(x)return;const H=new Map(k),K=g.querySelectorAll("div[data-code]");for(const te of K){const se=H.get(te.dataset.code??"");se&&y.$sP(te,se)}q.asyncRenderCallback?.()});else if(O.length>0){const k=new Map(O),H=g.querySelectorAll("div[data-code]");for(const K of H){const te=k.get(K.dataset.code??"");te&&y.$sP(K,te)}}if(q.asyncRenderCallback)for(const k of g.getElementsByTagName("img")){const H=E.add(y.$AO(k,"load",()=>{H.dispose(),q.asyncRenderCallback()}))}return{element:g,dispose:()=>{x=!0,E.dispose()}}}t.$UQ=z;function I(X){if(!X)return"";const q=X.split(/[\s+|:|,|\{|\?]/,1);return q.length?q[0]:X}function b(X,q){return/^\w[\w\d+.-]*:/.test(q)?q:X.path.endsWith("/")?(0,$.$xg)(X,q).toString():(0,$.$xg)((0,$.$tg)(X),q).toString()}function v(X,q){const{config:G,allowedSchemes:E}=B(X);P.addHook("uponSanitizeAttribute",(g,p)=>{if(p.attrName==="style"||p.attrName==="class"){if(g.tagName==="SPAN"){if(p.attrName==="style"){p.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(p.attrValue);return}else if(p.attrName==="class"){p.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(p.attrValue);return}}p.keepAttr=!1;return}});const x=y.$MP(E);try{return P.sanitize(q,{...G,RETURN_TRUSTED_TYPE:!0})}finally{P.removeHook("uponSanitizeAttribute"),x.dispose()}}t.$VQ=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function B(X){const q=[n.Schemas.http,n.Schemas.https,n.Schemas.mailto,n.Schemas.data,n.Schemas.file,n.Schemas.vscodeFileResource,n.Schemas.vscodeRemote,n.Schemas.vscodeRemoteResource];return X.isTrusted&&q.push(n.Schemas.command),{config:{ALLOWED_TAGS:[...y.$NP],ALLOWED_ATTR:t.$VQ,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:q}}function j(X){return typeof X=="string"?X:W(X)}t.$WQ=j;function W(X){let q=X.value??"";q.length>1e5&&(q=`${q.substr(0,1e5)}\u2026`);const G=l.marked.parse(q,{renderer:F.value}).replace(/&(#\d+|[a-zA-Z]+);/g,E=>M.get(E)??E);return v({isTrusted:!1},G).toString()}t.$XQ=W;const M=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),F=new e.$U(()=>{const X=new l.marked.Renderer;return X.code=q=>q,X.blockquote=q=>q,X.html=q=>"",X.heading=(q,G,E)=>q+`
`,X.hr=()=>"",X.list=(q,G)=>q,X.listitem=q=>q+`
`,X.paragraph=q=>q+`
`,X.table=(q,G)=>q+G+`
`,X.tablerow=q=>q,X.tablecell=(q,G)=>q+" ",X.strong=q=>q,X.em=q=>q,X.codespan=q=>q,X.br=()=>`
`,X.del=q=>q,X.image=(q,G,E)=>"",X.text=q=>q,X.link=(q,G,E)=>E,X});function J(X){let q="";return X.forEach(G=>{q+=G.raw}),q}function ee(X){for(const q of X.tokens)if(q.type==="text"){const G=q.raw.split(`
`),E=G[G.length-1];if(E.includes("`"))return le(X);if(E.includes("**"))return Ne(X);if(E.match(/\*\w/))return oe(X);if(E.match(/(^|\s)__\w/))return de(X);if(E.match(/(^|\s)_\w/))return me(X);if(E.match(/(^|\s)\[.*\]\(\w*/))return Se(X);if(E.match(/(^|\s)\[\w/))return Le(X)}}function ne(X){let q,G;for(q=0;q<X.length;q++){const E=X[q];if(E.type==="paragraph"&&E.raw.match(/(\n|^)```/)){G=ue(X.slice(q));break}if(E.type==="paragraph"&&E.raw.match(/(\n|^)\|/)){G=fe(X.slice(q));break}if(q===X.length-1&&E.type==="paragraph"){const x=ee(E);if(x){G=[x];break}}}if(G){const E=[...X.slice(0,q),...G];return E.links=X.links,E}return X}t.$YQ=ne;function ue(X){const q=J(X);return l.marked.lexer(q+"\n```")}function le(X){return ie(X,"`")}function oe(X){return ie(X,"*")}function me(X){return ie(X,"_")}function Se(X){return ie(X,")")}function Le(X){return ie(X,"](about:blank)")}function Ne(X){return ie(X,"**")}function de(X){return ie(X,"__")}function ie(X,q){const G=J(Array.isArray(X)?X:[X]);return l.marked.lexer(G+q)[0]}function fe(X){const q=J(X),G=q.split(`
`);let E,x=!1;for(let g=0;g<G.length;g++){const p=G[g].trim();if(typeof E>"u"&&p.match(/^\s*\|/)){const V=p.match(/(\|[^\|]+)(?=\||$)/g);V&&(E=V.length)}else if(typeof E=="number")if(p.match(/^\s*\|/)){if(g!==G.length-1)return;x=!0}else return}if(typeof E=="number"&&E>0){const g=x?G.slice(0,-1).join(`
`):q,p=!!g.match(/\|\s*$/),V=g+(p?"":"|")+`
|${" --- |".repeat(E)}`;return l.marked.lexer(V)}}}),define(be[124],$e([1,0,4,9,28,60,34,2,7,105]),function(re,t,y,P,i,U,w,D,h,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iQ=t.$hQ=void 0;function d(a,e){(0,h.$xf)(e)?a.title=(0,w.$Wj)(e):e?.markdownNotSupportedFallback?a.title=e.markdownNotSupportedFallback:a.removeAttribute("title")}t.$hQ=d;class L{constructor(e,u,l){this.c=e,this.d=u,this.f=l}async update(e,u,l){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let m;if(e===void 0||(0,h.$xf)(e)||e instanceof HTMLElement)m=e;else if(!(0,h.$Lf)(e.markdown))m=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,f.localize)(0,null),u),this.b=new i.$Wd;const n=this.b.token;if(m=await e.markdown(n),m===void 0&&(m=e.markdownNotSupportedFallback),this.isDisposed||n.isCancellationRequested)return}this.g(m,u,l)}g(e,u,l){const m=this.a;if(this.h(e)){const n={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!m,...l};this.a=this.c.showHover(n,u)}m?.dispose()}h(e){return e?(0,U.$3j)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function s(a,e,u,l){let m,n;const r=(z,I)=>{const b=n!==void 0;z&&(n?.dispose(),n=void 0),I&&(m?.dispose(),m=void 0),b&&a.onDidHideHover?.()},$=(z,I,b)=>new P.$3g(async()=>{(!n||n.isDisposed)&&(n=new L(a,b||e,z>0),await n.update(u,I,l))},z),c=()=>{if(m)return;const z=new D.$Qc,I=B=>r(!1,B.fromElement===e);z.add(y.$AO(e,y.$jP.MOUSE_LEAVE,I,!0));const b=()=>r(!0,!0);z.add(y.$AO(e,y.$jP.MOUSE_DOWN,b,!0));const v={targetElements:[e],dispose:()=>{}};if(a.placement===void 0||a.placement==="mouse"){const B=j=>{v.x=j.x+10,j.target instanceof HTMLElement&&j.target.classList.contains("action-label")&&r(!0,!0)};z.add(y.$AO(e,y.$jP.MOUSE_MOVE,B,!0))}z.add($(a.delay,!1,v)),m=z},o=y.$AO(e,y.$jP.MOUSE_OVER,c,!0);return{show:z=>{r(!1,!0),$(0,z)},hide:()=>{r(!0,!0)},update:async(z,I)=>{u=z,await n?.update(u,void 0,I)},dispose:()=>{o.dispose(),r(!0,!0)}}}t.$iQ=s}),define(be[125],$e([1,0,4,21,14,123,38,11,3,43,2,5,107,98]),function(re,t,y,P,i,U,w,D,h,f,d,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZQ=void 0;const a=y.$,e="selectOption.entry.template";class u{get templateId(){return e}renderTemplate(n){const r=Object.create(null);return r.root=n,r.text=y.$qP(n,a(".option-text")),r.detail=y.$qP(n,a(".option-detail")),r.decoratorRight=y.$qP(n,a(".option-decorator-right")),r}renderElement(n,r,$){const c=$,o=n.text,C=n.detail,z=n.decoratorRight,I=n.isDisabled;c.text.textContent=o,c.detail.textContent=C||"",c.decoratorRight.innerText=z||"",I?c.root.classList.add("option-disabled"):c.root.classList.remove("option-disabled")}disposeTemplate(n){}}class l extends d.$Rc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(n,r,$,c,o){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=c,this.g=o||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=l.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new h.$Md,this.B(this.r),this.O(),this.N($),this.n=r||0,n&&this.setOptions(n,r),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(n){this.u=n,this.w=y.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=y.$qP(this.w,a(".select-box-details-pane"));const r=y.$qP(this.w,a(".select-box-dropdown-container-width-control")),$=y.$qP(r,a(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",y.$qP($,this.D),this.G=0,this.y=y.$bP(this.w),this.w.setAttribute("draggable","true"),this.B(y.$AO(this.w,y.$jP.DRAG_START,c=>{y.$lP.stop(c,!0)}))}O(){this.B(y.$BO(this.h,"change",r=>{this.n=r.target.selectedIndex,this.r.fire({index:r.target.selectedIndex,selected:r.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(y.$AO(this.h,y.$jP.CLICK,r=>{y.$lP.stop(r),this.f?this.X(!0):this.W()})),this.B(y.$AO(this.h,y.$jP.MOUSE_DOWN,r=>{y.$lP.stop(r)}));let n;this.B(y.$AO(this.h,"touchstart",r=>{n=this.f})),this.B(y.$AO(this.h,"touchend",r=>{y.$lP.stop(r),n?this.X(!0):this.W()})),this.B(y.$AO(this.h,y.$jP.KEY_DOWN,r=>{const $=new i.$xO(r);let c=!1;L.$k?($.keyCode===18||$.keyCode===16||$.keyCode===10||$.keyCode===3)&&(c=!0):($.keyCode===18&&$.altKey||$.keyCode===16&&$.altKey||$.keyCode===10||$.keyCode===3)&&(c=!0),c&&(this.W(),y.$lP.stop(r,!0))}))}get onDidSelect(){return this.r.event}setOptions(n,r){D.$tb(this.m,n)||(this.m=n,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach(($,c)=>{this.h.add(this.U($.text,c,$.isDisabled)),typeof $.description=="string"&&(this.H=!0)})),r!==void 0&&(this.select(r),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(n){n>=0&&n<this.m.length?this.n=n:n>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(n){this.g.ariaLabel=n,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(n){this.h.tabIndex=n?0:-1}render(n){this.j=n,n.classList.add("select-container"),n.appendChild(this.h),this.R()}Q(){const n=[];this.s.listFocusBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(n.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=n.join(`
`)}R(){const n=this.s.selectBackground??"",r=this.s.selectForeground??"",$=this.s.selectBorder??"";this.h.style.backgroundColor=n,this.h.style.color=r,this.h.style.borderColor=$}S(){const n=this.s.selectBackground??"",r=y.$IP(this.s.selectListBackground,n);this.C.style.backgroundColor=r,this.I.style.backgroundColor=r;const $=this.s.focusBorder??"";this.w.style.outlineColor=$,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(n,r,$){const c=document.createElement("option");return c.value=n,c.text=n,c.disabled=!!$,c}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(n){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),n&&this.h.focus(),this.u.hideContextView())}Y(n,r){return n.appendChild(this.w),this.ab(r),{dispose:()=>{try{n.removeChild(this.w)}catch{}}}}Z(){let n=0;return this.m.forEach((r,$)=>{this.hb($),this.I.offsetHeight>n&&(n=this.I.offsetHeight)}),n}ab(n){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const r=y.$SO(this.h),$=getComputedStyle(this.h),c=parseFloat($.getPropertyValue("--dropdown-padding-top"))+parseFloat($.getPropertyValue("--dropdown-padding-bottom")),o=window.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),C=r.top-l.b,z=this.h.offsetWidth,I=this.bb(this.D),b=Math.max(I,Math.round(z)).toString()+"px";this.w.style.width=b,this.z.getHTMLElement().style.height="",this.z.layout();let v=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const B=this.H?this.L:0,j=v+c+B,W=Math.floor((o-c-B)/this.getHeight()),M=Math.floor((C-c-B)/this.getHeight());if(n)return r.top+r.height>window.innerHeight-22||r.top<l.b||W<1&&M<1?!1:(W<l.c&&M>W&&this.m.length>W?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(r.top+r.height>window.innerHeight-22||r.top<l.b||this.G===0&&W<1||this.G===1&&M<1)return this.X(!0),!1;if(this.G===0){if(this.f&&W+M<1)return this.X(!0),!1;j>o&&(v=W*this.getHeight())}else j>C&&(v=M*this.getHeight());return this.z.layout(v),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=v+c+"px",this.w.style.height=""):this.w.style.height=v+c+"px",this.hb(this.n),this.w.style.width=b,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(n){let r=0;if(n){let $=0,c=0;this.m.forEach((o,C)=>{const z=o.detail?o.detail.length:0,I=o.decoratorRight?o.decoratorRight.length:0,b=o.text.length+z+I;b>c&&($=C,c=b)}),n.textContent=this.m[$].text+(this.m[$].decoratorRight?this.m[$].decoratorRight+" ":""),r=y.$UO(n)}return r}cb(n){if(this.z)return;this.C=y.$qP(n,a(".select-box-dropdown-list-container")),this.t=new u,this.z=new w.$RQ("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:c=>{let o=c.text;return c.detail&&(o+=`. ${c.detail}`),c.decoratorRight&&(o+=`. ${c.decoratorRight}`),c.description&&(o+=`. ${c.description}`),o},getWidgetAriaLabel:()=>(0,s.localize)(0,null),getRole:()=>L.$k?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const r=this.B(new P.$rQ(this.C,"keydown")),$=h.Event.chain(r.event,c=>c.filter(()=>this.z.length>0).map(o=>new i.$xO(o)));this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===3))(this.jb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===2))(this.jb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===9))(this.ib,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===16))(this.lb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===18))(this.kb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===12))(this.nb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===11))(this.mb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===14))(this.ob,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===13))(this.pb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode>=21&&o.keyCode<=56||o.keyCode>=85&&o.keyCode<=113))(this.qb,this)),this.B(y.$AO(this.z.getHTMLElement(),y.$jP.POINTER_UP,c=>this.db(c))),this.B(this.z.onMouseOver(c=>typeof c.index<"u"&&this.z.setFocus([c.index]))),this.B(this.z.onDidChangeFocus(c=>this.gb(c))),this.B(y.$AO(this.w,y.$jP.FOCUS_OUT,c=>{!this.f||y.$1O(c.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(n){if(!this.z.length)return;y.$lP.stop(n);const r=n.target;if(!r||r.classList.contains("slider"))return;const $=r.closest(".monaco-list-row");if(!$)return;const c=Number($.getAttribute("data-index")),o=$.classList.contains("option-disabled");c>=0&&c<this.m.length&&!o&&(this.n=c,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(n,r){const $=o=>{for(let C=0;C<o.childNodes.length;C++){const z=o.childNodes.item(C);(z.tagName&&z.tagName.toLowerCase())==="img"?o.removeChild(z):$(z)}},c=(0,U.$UQ)({value:n,supportThemeIcons:!0},{actionHandler:r});return c.element.classList.add("select-box-description-markdown"),$(c.element),c.element}gb(n){!this.f||!this.H||this.hb(n.indexes[0])}hb(n){this.I.innerText="";const r=this.m[n],$=r?.description??"",c=r?.descriptionIsMarkdown??!1;if($){if(c){const o=r.descriptionMarkdownActionHandler;this.I.appendChild(this.fb($,o))}else this.I.innerText=$;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(n){y.$lP.stop(n),this.select(this.F),this.X(!0)}jb(n){y.$lP.stop(n),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(n){if(this.n<this.m.length-1){y.$lP.stop(n,!0);const r=this.m[this.n+1].isDisabled;if(r&&this.m.length>this.n+2)this.n+=2;else{if(r)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(n){this.n>0&&(y.$lP.stop(n,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(n){y.$lP.stop(n),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(n){y.$lP.stop(n),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(n){y.$lP.stop(n),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(n){y.$lP.stop(n),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(n){const r=f.KeyCodeUtils.toString(n.keyCode);let $=-1;for(let c=0;c<this.m.length-1;c++)if($=(c+this.n+1)%this.m.length,this.m[$].text.charAt(0).toUpperCase()===r&&!this.m[$].isDisabled){this.select($),this.z.setFocus([$]),this.z.reveal(this.z.getFocus()[0]),y.$lP.stop(n);break}}dispose(){this.X(!1),super.dispose()}}t.$ZQ=l}),define(be[126],$e([1,0,38,125,119,20,5,97]),function(re,t,y,P,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Q=t.$2Q=void 0,t.$2Q={...y.$QQ,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class D extends U.$4P{constructor(f,d,L,s,a){super(),w.$k&&!a?.useCustomDrawn?this.a=new i.$1Q(f,d,s,a):this.a=new P.$ZQ(f,d,L,s,a),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(f,d){this.a.setOptions(f,d)}select(f){this.a.select(f)}setAriaLabel(f){this.a.setAriaLabel(f)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(f){this.a.setFocusable(f)}render(f){this.a.render(f)}}t.$3Q=D}),define(be[61],$e([1,0,16,52,4,23,124,126,35,2,5,7,102,50]),function(re,t,y,P,i,U,w,D,h,f,d,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0Q=t.$9Q=t.$8Q=void 0;class a extends f.$Rc{get action(){return this._action}constructor(m,n,r={}){super(),this.m=r,this._context=m||this,this._action=n,n instanceof h.$si&&this.B(n.onDidChange($=>{this.element&&this.t($)}))}t(m){m.enabled!==void 0&&this.u(),m.checked!==void 0&&this.G(),m.class!==void 0&&this.F(),m.label!==void 0&&(this.w(),this.C()),m.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new h.$ti)),this.j}set actionRunner(m){this.j=m}isEnabled(){return this._action.enabled}setActionContext(m){this._context=m}render(m){const n=this.element=m;this.B(U.$ZP.addTarget(m));const r=this.m&&this.m.draggable;r&&(m.draggable=!0,y.$gO&&this.B((0,i.$AO)(m,i.$jP.DRAG_START,$=>$.dataTransfer?.setData(P.$XP.TEXT,this._action.label)))),this.B((0,i.$AO)(n,U.EventType.Tap,$=>this.onClick($,!0))),this.B((0,i.$AO)(n,i.$jP.MOUSE_DOWN,$=>{r||i.$lP.stop($,!0),this._action.enabled&&$.button===0&&n.classList.add("active")})),d.$k&&this.B((0,i.$AO)(n,i.$jP.CONTEXT_MENU,$=>{$.button===0&&$.ctrlKey===!0&&this.onClick($)})),this.B((0,i.$AO)(n,i.$jP.CLICK,$=>{i.$lP.stop($,!0),this.m&&this.m.isMenu||this.onClick($)})),this.B((0,i.$AO)(n,i.$jP.DBLCLICK,$=>{i.$lP.stop($,!0)})),[i.$jP.MOUSE_UP,i.$jP.MOUSE_OUT].forEach($=>{this.B((0,i.$AO)(n,$,c=>{i.$lP.stop(c),n.classList.remove("active")}))})}onClick(m,n=!1){i.$lP.stop(m,!0);const r=L.$Gf(this._context)?this.m?.useEventAsContext?m:{preserveFocus:n}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(m){this.element&&(this.element.tabIndex=m?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const m=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(m):(this.f=(0,w.$iQ)(this.m.hoverDelegate,this.element,m),this.q.add(this.f))):this.element.title=m}D(){if(this.element){const m=this.z()??"";this.element.setAttribute("aria-label",m)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$8Q=a;class e extends a{constructor(m,n,r){super(m,n,r),this.m=r,this.m.icon=r.icon!==void 0?r.icon:!1,this.m.label=r.label!==void 0?r.label:!0,this.J=""}render(m){super.render(m),L.$Hf(this.element);const n=document.createElement("a");if(n.classList.add("action-label"),n.setAttribute("role",this.L()),this.H=n,this.element.appendChild(n),this.m.label&&this.m.keybinding){const r=document.createElement("span");r.classList.add("keybinding"),r.textContent=this.m.keybinding,this.element.appendChild(r)}this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===h.$ui.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable(m){this.H&&(this.H.tabIndex=m?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let m=null;return this.action.tooltip?m=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(m=this.action.label,this.m.keybinding&&(m=s.localize(0,null,m,this.m.keybinding))),m??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const m=this.z()??"";this.H.setAttribute("aria-label",m)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.setAttribute("aria-checked",""),this.H.setAttribute("role",this.L())))}}t.$9Q=e;class u extends a{constructor(m,n,r,$,c,o,C){super(m,n),this.b=new D.$3Q(r,$,c,o,C),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(m,n){this.b.setOptions(m,n)}select(m){this.b.select(m)}g(){this.B(this.b.onDidSelect(m=>this.n(m.selected,m.index)))}n(m,n){this.actionRunner.run(this._action,this.r(m,n))}r(m,n){return m}setFocusable(m){this.b.setFocusable(m)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(m){this.b.render(m)}}t.$0Q=u}),define(be[62],$e([1,0,4,14,61,35,3,2,7,50]),function(re,t,y,P,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kQ=t.$jQ=t.ActionsOrientation=void 0;var f;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(f||(t.ActionsOrientation=f={}));class d extends D.$Rc{constructor(a,e={}){super(),this.g=this.B(new D.$Qc),this.r=this.B(new D.$Zc),this.w=!1,this.y=!0,this.C=this.B(new w.$Md),this.onDidBlur=this.C.event,this.D=this.B(new w.$Md({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new w.$Md),this.onDidRun=this.G.event,this.H=this.B(new w.$Md),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new U.$ti,this.g.add(this.f)),this.g.add(this.f.onDidRun(m=>this.G.fire(m))),this.g.add(this.f.onWillRun(m=>this.H.fire(m))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let u,l;switch(this.m){case 0:u=[15],l=[17];break;case 1:u=[16],l=[18],this.domNode.className+=" vertical";break}this.B(y.$AO(this.domNode,y.$jP.KEY_DOWN,m=>{const n=new P.$xO(m);let r=!0;const $=typeof this.t=="number"?this.viewItems[this.t]:void 0;u&&(n.equals(u[0])||n.equals(u[1]))?r=this.P():l&&(n.equals(l[0])||n.equals(l[1]))?r=this.O():n.equals(9)&&this.F?this.D.fire():n.equals(14)?r=this.M():n.equals(13)?r=this.N():n.equals(2)&&$ instanceof i.$8Q&&$.trapsArrowNavigation?r=this.O():this.J(n)?this.n.keyDown?this.R(n):this.w=!0:r=!1,r&&(n.preventDefault(),n.stopPropagation())})),this.B(y.$AO(this.domNode,y.$jP.KEY_UP,m=>{const n=new P.$xO(m);this.J(n)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(n)),n.preventDefault(),n.stopPropagation()):(n.equals(2)||n.equals(1026))&&this.L()})),this.u=this.B(y.$oP(this.domNode)),this.B(this.u.onDidBlur(()=>{(y.$9O()===this.domNode||!y.$1O(y.$9O(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),a.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(a){a?this.z.setAttribute("aria-label",a):this.z.removeAttribute("aria-label")}setFocusable(a){if(this.y=a,this.y){const e=this.viewItems.find(u=>u instanceof i.$8Q&&u.isEnabled());e instanceof i.$8Q&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$8Q&&e.setFocusable(!1)})}J(a){let e=!1;return this.n.keys.forEach(u=>{e=e||a.equals(u)}),e}L(){for(let a=0;a<this.z.children.length;a++){const e=this.z.children[a];if(y.$1O(y.$9O(),e)){this.t=a;break}}}get context(){return this.j}set context(a){this.j=a,this.viewItems.forEach(e=>e.setActionContext(a))}get actionRunner(){return this.f}set actionRunner(a){this.f=a,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=a)}getContainer(){return this.domNode}hasAction(a){return this.viewItems.findIndex(e=>e.action.id===a.id)!==-1}getAction(a){if(typeof a=="number")return this.viewItems[a]?.action;if(a instanceof HTMLElement){for(;a.parentElement!==this.z;){if(!a.parentElement)return;a=a.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===a)return this.viewItems[e].action}}push(a,e={}){const u=Array.isArray(a)?a:[a];let l=h.$Bf(e.index)?e.index:null;u.forEach(m=>{const n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation");let r;const $={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(m,$)),r||(r=new i.$9Q(this.context,m,$)),this.b.allowContextMenu||this.r.set(r,y.$AO(n,y.$jP.CONTEXT_MENU,c=>{y.$lP.stop(c,!0)})),r.actionRunner=this.f,r.setActionContext(this.context),r.render(n),this.y&&r instanceof i.$8Q&&this.viewItems.length===0&&r.setFocusable(!0),l===null||l<0||l>=this.z.children.length?(this.z.appendChild(n),this.viewItems.push(r)):(this.z.insertBefore(n,this.z.children[l]),this.viewItems.splice(l,0,r),l++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientWidth}return 0}getHeight(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientHeight}return 0}pull(a){a>=0&&a<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[a]),this.r.deleteAndDispose(this.viewItems[a]),(0,D.$Mc)(this.viewItems.splice(a,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,D.$Mc)(this.viewItems),this.r.clearAndDisposeAll(),y.$zO(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(a){let e=!1,u;if(a===void 0?e=!0:typeof a=="number"?u=a:typeof a=="boolean"&&(e=a),e&&typeof this.t>"u"){const l=this.viewItems.findIndex(m=>m.isEnabled());this.t=l===-1?void 0:l,this.Q(void 0,void 0,!0)}else u!==void 0&&(this.t=u),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(a){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let u;do{if(!a&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,u=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!u.isEnabled()||u.action.id===U.$ui.ID));return this.Q(),!0}P(a){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let u;do{if(this.t=this.t-1,this.t<0){if(!a&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}u=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!u.isEnabled()||u.action.id===U.$ui.ID));return this.Q(!0),!0}Q(a,e,u=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const l=this.t!==void 0&&this.viewItems[this.t];if(l){let m=!0;h.$Lf(l.focus)||(m=!1),this.b.focusOnlyEnabledItems&&h.$Lf(l.isEnabled)&&!l.isEnabled()&&(m=!1),l.action.id===U.$ui.ID&&(m=!1),m?(u||this.s!==this.t)&&(l.focus(a),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(a){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof i.$8Q){const u=e._context===null||e._context===void 0?a:e._context;this.run(e._action,u)}}async run(a,e){await this.f.run(a,e)}dispose(){this.j=void 0,this.viewItems=(0,D.$Mc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$jQ=d;function L(s){if(!s.length)return s;let a=-1;for(let u=0;u<s.length;u++)if(s[u].id!==U.$ui.ID){a=u;break}if(a===-1)return[];s=s.slice(a);for(let u=s.length-1;u>=0&&s[u].id===U.$ui.ID;u--)s.splice(u,1);let e=!1;for(let u=s.length-1;u>=0;u--){const l=s[u].id===U.$ui.ID;l&&!e?s.splice(u,1):l?l&&(e=!1):e=!0}return s}t.$kQ=L}),define(be[63],$e([1,0,4,21,53,62,55,58,20,3,79,49,106,94]),function(re,t,y,P,i,U,w,D,h,f,d,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OR=t.$NR=t.$MR=t.MessageType=void 0;const a=y.$;var e;(function(m){m[m.INFO=1]="INFO",m[m.WARNING=2]="WARNING",m[m.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$MR={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class u extends h.$4P{constructor(n,r,$){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new f.$Md),this.onDidChange=this.O.event,this.P=this.B(new f.$Md),this.onDidHeightChange=this.P.event,this.a=r,this.g=$,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=y.$qP(n,a(".monaco-inputbox.idle"));const c=this.g.flexibleHeight?"textarea":"input",o=y.$qP(this.element,a(".ibwrapper"));if(this.b=y.$qP(o,a(c+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=y.$qP(o,a("div.mirror")),this.y.innerText="\xA0",this.N=new D.$bQ(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),y.$qP(n,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(I=>this.b.scrollTop=I.scrollTop));const C=this.B(new P.$rQ(document,"selectionchange")),z=f.Event.filter(C.event,()=>document.getSelection()?.anchorNode===o);this.B(z(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new U.$jQ(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(n){this.n=n,this.b.setAttribute("placeholder",n)}setTooltip(n){this.r=n,this.b.title=n}setAriaLabel(n){this.s=n,n?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(n){this.b.value!==n&&(this.b.value=n,this.Y())}get step(){return this.b.step}set step(n){this.b.step=n}get height(){return typeof this.J=="number"?this.J:y.$YO(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(n=null){this.b.select(),n&&(this.b.setSelectionRange(n.start,n.end),n.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(n){n?this.enable():this.disable()}get width(){return y.$UO(this.b)}set width(n){if(this.g.flexibleHeight&&this.g.flexibleWidth){let r=0;if(this.y){const $=parseFloat(this.y.style.paddingLeft||"")||0,c=parseFloat(this.y.style.paddingRight||"")||0;r=$+c}this.b.style.width=n-r+"px"}else this.b.style.width=n+"px";this.y&&(this.y.style.width=n+"px")}set paddingRight(n){this.b.style.width=`calc(100% - ${n}px)`,this.y&&(this.y.style.paddingRight=n+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const n=this.L,r=this.J,$=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:n,height:r}),this.N.setScrollPosition({scrollTop:$})}showMessage(n,r){if(this.w==="open"&&(0,L.$7m)(this.h,n))return;this.h=n,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(n.type));const $=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${y.$IP($.border,"transparent")}`,this.h.content&&(this.hasFocus()||r)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let n=null;return this.t&&(n=this.t(this.value),n?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(n)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),n?.type}stylesForType(n){const r=this.g.inputBoxStyles;switch(n){case 1:return{border:r.inputValidationInfoBorder,background:r.inputValidationInfoBackground,foreground:r.inputValidationInfoForeground};case 2:return{border:r.inputValidationWarningBorder,background:r.inputValidationWarningBackground,foreground:r.inputValidationWarningForeground};default:return{border:r.inputValidationErrorBorder,background:r.inputValidationErrorBackground,foreground:r.inputValidationErrorForeground}}}U(n){switch(n){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let n;const r=()=>n.style.width=y.$UO(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:c=>{if(!this.h)return null;n=y.$qP(c,a(".monaco-inputbox-container")),r();const o={inline:!0,className:"monaco-inputbox-message"},C=this.h.formatContent?(0,i.$pQ)(this.h.content,o):(0,i.$oQ)(this.h.content,o);C.classList.add(this.U(this.h.type));const z=this.stylesForType(this.h.type);return C.style.backgroundColor=z.background??"",C.style.color=z.foreground??"",C.style.border=z.border?`1px solid ${z.border}`:"",y.$qP(n,C),null},onHide:()=>{this.w="closed"},layout:r});let $;this.h.type===3?$=s.localize(0,null,this.h.content):this.h.type===2?$=s.localize(1,null,this.h.content):$=s.localize(2,null,this.h.content),w.$tQ($),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const n=this.value,$=n.charCodeAt(n.length-1)===10?" ":"";(n+$).replace(/\u000c/g,"")?this.y.textContent=n+$:this.y.innerText="\xA0",this.layout()}ab(){const n=this.g.inputBoxStyles,r=n.inputBackground??"",$=n.inputForeground??"",c=n.inputBorder??"";this.element.style.backgroundColor=r,this.element.style.color=$,this.b.style.backgroundColor="inherit",this.b.style.color=$,this.element.style.border=`1px solid ${y.$IP(c,"transparent")}`}layout(){if(!this.y)return;const n=this.L;this.L=y.$YO(this.y),n!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(n){const r=this.inputElement,$=r.selectionStart,c=r.selectionEnd,o=r.value;$!==null&&c!==null&&(this.value=o.substr(0,$)+n+o.substr(c),r.setSelectionRange($+1,$+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$NR=u;class l extends u{constructor(n,r,$){const c=s.localize(3,null),o=` or \u21C5 ${c}`,C=` (\u21C5 ${c})`;super(n,r,$),this.db=this.B(new f.$Md),this.onDidFocus=this.db.event,this.eb=this.B(new f.$Md),this.onDidBlur=this.eb.event,this.bb=new d.$KR($.history,100);const z=()=>{if($.showHistoryHint&&$.showHistoryHint()&&!this.n.endsWith(o)&&!this.n.endsWith(C)&&this.bb.getHistory().length){const I=this.n.endsWith(")")?o:C,b=this.n+I;$.showPlaceholderOnFocus&&document.activeElement!==this.b?this.n=b:this.setPlaceHolder(b)}};this.cb=new MutationObserver((I,b)=>{I.forEach(v=>{v.target.textContent||z()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>z()),this.F(this.b,()=>{const I=b=>{if(this.n.endsWith(b)){const v=this.n.slice(0,this.n.length-b.length);return $.showPlaceholderOnFocus?this.n=v:this.setPlaceHolder(v),!0}else return!1};I(C)||I(o)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(n){this.value&&(n||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(n){const r=this.getHistory();this.clearHistory(),n.forEach($=>{this.bb.add($)}),r.forEach($=>{this.bb.add($)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let n=this.jb();n&&(n=n===this.value?this.jb():n),this.value=n??"",w.$uQ(this.value?this.value:s.localize(4,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let n=this.ib();n&&(n=n===this.value?this.ib():n),n&&(this.value=n,w.$uQ(this.value))}clearHistory(){this.bb.clear()}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let n=this.bb.current();return n||(n=this.bb.last(),this.bb.next()),n}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$OR=l}),define(be[64],$e([1,0,61,20,17,18,3,99]),function(re,t,y,P,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7Q=t.$6Q=t.$5Q=t.$4Q=void 0,t.$4Q={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class D extends y.$8Q{constructor(L,s,a){super(L,s,a),this.a=this.B(new h({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:a.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:a.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:a.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(L){this.element=L,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(L){this.a.domNode.tabIndex=L?0:-1}}t.$5Q=D;class h extends P.$4P{constructor(L){super(),this.a=this.B(new w.$Md),this.onChange=this.a.event,this.b=this.B(new w.$Md),this.onKeyDown=this.b.event,this.c=L,this.s=this.c.isChecked;const s=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,s.push(...U.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&s.push(...this.c.actionClassName.split(" ")),this.s&&s.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...s),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,a=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),a.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,a=>{if(a.keyCode===10||a.keyCode===3){this.checked=!this.s,this.a.fire(!0),a.preventDefault(),a.stopPropagation();return}this.b.fire(a)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(L){this.s=L,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(L){this.g&&this.domNode.classList.remove(...U.ThemeIcon.asClassNameArray(this.g)),this.g=L,this.g&&this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(L){this.domNode.title=L,this.domNode.setAttribute("aria-label",L)}}t.$6Q=h;class f extends P.$4P{constructor(L,s,a){super(),this.c=L,this.g=s,this.a=new h({title:this.c,isChecked:this.g,icon:i.$Sj.check,actionClassName:"monaco-checkbox",...t.$4Q}),this.domNode=this.a.domNode,this.b=a,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(L){this.a.checked=L,this.h()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$7Q=f}),define(be[127],$e([1,0,64,17,104]),function(re,t,y,P,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2R=t.$1R=t.$ZR=void 0;const U=i.localize(0,null),w=i.localize(1,null),D=i.localize(2,null);class h extends y.$6Q{constructor(s){super({icon:P.$Sj.caseSensitive,title:U+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$ZR=h;class f extends y.$6Q{constructor(s){super({icon:P.$Sj.wholeWord,title:w+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$1R=f;class d extends y.$6Q{constructor(s){super({icon:P.$Sj.regex,title:D+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$2R=d}),define(be[128],$e([1,0,4,127,63,20,3,103,2,93]),function(re,t,y,P,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3R=void 0;const f=D.localize(0,null);class d extends U.$4P{static{this.OPTION_CHANGE="optionChange"}constructor(s,a,e){super(),this.n=!0,this.s=!1,this.w=this.B(new h.$Sc),this.N=[],this.O=this.B(new w.$Md),this.onDidOptionChange=this.O.event,this.P=this.B(new w.$Md),this.onKeyDown=this.P.event,this.Q=this.B(new w.$Md),this.onMouseDown=this.Q.event,this.R=this.B(new w.$Md),this.onInput=this.R.event,this.S=this.B(new w.$Md),this.onKeyUp=this.S.event,this.U=this.B(new w.$Md),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new w.$Md),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||f,this.h=!!e.showCommonFindToggles;const u=e.appendCaseSensitiveLabel||"",l=e.appendWholeWordsLabel||"",m=e.appendRegexLabel||"",n=e.history||[],r=!!e.flexibleHeight,$=!!e.flexibleWidth,c=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$OR(this.domNode,a,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:n,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:$,flexibleMaxHeight:c,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new P.$2R({appendTitle:m,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(C=>{this.O.fire(C),!C&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(C=>{this.W.fire(C)})),this.L=this.B(new P.$1R({appendTitle:l,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(C=>{this.O.fire(C),!C&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new P.$ZR({appendTitle:u,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(C=>{this.O.fire(C),!C&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(C=>{this.U.fire(C)}));const o=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,C=>{if(C.equals(15)||C.equals(17)||C.equals(9)){const z=o.indexOf(document.activeElement);if(z>=0){let I=-1;C.equals(17)?I=(z+1)%o.length:C.equals(15)&&(z===0?I=o.length-1:I=z-1),C.equals(9)?(o[z].blur(),this.inputBox.focus()):I>=0&&o[I].focus(),y.$lP.stop(C,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),s?.appendChild(this.domNode),this.B(y.$AO(this.inputBox.inputElement,"compositionstart",o=>{this.s=!0})),this.B(y.$AO(this.inputBox.inputElement,"compositionend",o=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,o=>this.P.fire(o)),this.C(this.inputBox.inputElement,o=>this.S.fire(o)),this.D(this.inputBox.inputElement,o=>this.R.fire()),this.j(this.inputBox.inputElement,o=>this.Q.fire(o))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(s){this.inputBox.layout(),this.X(s.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const s of this.N)s.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const s of this.N)s.disable()}setFocusInputOnOptionClick(s){this.n=s}setEnabled(s){s?this.enable():this.disable()}setAdditionalToggles(s){for(const a of this.N)a.domNode.remove();this.N=[],this.w.value=new h.$Qc;for(const a of s??[])this.w.value.add(a),this.y.appendChild(a.domNode),this.w.value.add(a.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(a);this.N.length>0&&(this.y.style.display=""),this.X()}X(s=!1){s?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((a,e)=>a+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(s){this.inputBox.value!==s&&(this.inputBox.value=s)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(s){this.M&&(this.M.checked=s)}getWholeWords(){return this.L?.checked??!1}setWholeWords(s){this.L&&(this.L.checked=s)}getRegex(){return this.J?.checked??!1}setRegex(s){this.J&&(this.J.checked=s,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(s){this.inputBox.showMessage(s)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$3R=d}),define(be[129],$e([1,0,4,21,14,62,128,63,59,38,64,56,24,35,11,9,17,18,31,3,33,2,45,7,108,100]),function(re,t,y,P,i,U,w,D,h,f,d,L,s,a,e,u,l,m,n,r,$,c,o,C,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AS=t.TreeFindMatchType=t.TreeFindMode=t.$zS=t.$yS=t.RenderIndentGuides=t.$xS=t.$wS=void 0;class I extends h.$EQ{set context(g){this.c.context=g}get context(){return this.c.context}constructor(g){super(g.elements.map(p=>p.element)),this.c=g}}function b(x){return x instanceof h.$EQ?new I(x):x}class v{constructor(g,p){this.d=g,this.f=p,this.b=c.$Rc.None,this.c=new c.$Qc}getDragURI(g){return this.f.getDragURI(g.element)}getDragLabel(g,p){if(this.f.getDragLabel)return this.f.getDragLabel(g.map(V=>V.element),p)}onDragStart(g,p){this.f.onDragStart?.(b(g),p)}onDragOver(g,p,V,T,N=!0){const O=this.f.onDragOver(b(g),p&&p.element,V,T),_=this.a!==p;if(_&&(this.b.dispose(),this.a=p),typeof p>"u")return O;if(_&&typeof O!="boolean"&&O.autoExpand&&(this.b=(0,u.$Ug)(()=>{const H=this.d(),K=H.getNodeLocation(p);H.isCollapsed(K)&&H.setCollapsed(K,!1),this.a=void 0},500,this.c)),typeof O=="boolean"||!O.accept||typeof O.bubble>"u"||O.feedback){if(!N){const H=typeof O=="boolean"?O:O.accept,K=typeof O=="boolean"?void 0:O.effect;return{accept:H,effect:K,feedback:[V]}}return O}if(O.bubble===1){const H=this.d(),K=H.getNodeLocation(p),te=H.getParentNodeLocation(K),se=H.getNode(te),ge=te&&H.getListIndex(te);return this.onDragOver(g,se,ge,T,!1)}const S=this.d(),R=S.getNodeLocation(p),A=S.getListIndex(R),k=S.getListRenderCount(R);return{...O,feedback:(0,e.$Rb)(A,A+k)}}drop(g,p,V,T){this.b.dispose(),this.a=void 0,this.f.drop(b(g),p&&p.element,V,T)}onDragEnd(g){this.f.onDragEnd?.(g)}dispose(){this.c.dispose(),this.f.dispose()}}function B(x,g){return g&&{...g,identityProvider:g.identityProvider&&{getId(p){return g.identityProvider.getId(p.element)}},dnd:g.dnd&&new v(x,g.dnd),multipleSelectionController:g.multipleSelectionController&&{isSelectionSingleChangeEvent(p){return g.multipleSelectionController.isSelectionSingleChangeEvent({...p,element:p.element})},isSelectionRangeChangeEvent(p){return g.multipleSelectionController.isSelectionRangeChangeEvent({...p,element:p.element})}},accessibilityProvider:g.accessibilityProvider&&{...g.accessibilityProvider,getSetSize(p){const V=x(),T=V.getNodeLocation(p),N=V.getParentNodeLocation(T);return V.getNode(N).visibleChildrenCount},getPosInSet(p){return p.visibleChildIndex+1},isChecked:g.accessibilityProvider&&g.accessibilityProvider.isChecked?p=>g.accessibilityProvider.isChecked(p.element):void 0,getRole:g.accessibilityProvider&&g.accessibilityProvider.getRole?p=>g.accessibilityProvider.getRole(p.element):()=>"treeitem",getAriaLabel(p){return g.accessibilityProvider.getAriaLabel(p.element)},getWidgetAriaLabel(){return g.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:g.accessibilityProvider&&g.accessibilityProvider.getWidgetRole?()=>g.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:g.accessibilityProvider&&g.accessibilityProvider.getAriaLevel?p=>g.accessibilityProvider.getAriaLevel(p.element):p=>p.depth,getActiveDescendantId:g.accessibilityProvider.getActiveDescendantId&&(p=>g.accessibilityProvider.getActiveDescendantId(p.element))},keyboardNavigationLabelProvider:g.keyboardNavigationLabelProvider&&{...g.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(p){return g.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(p.element)}}}}class j{constructor(g){this.a=g}getHeight(g){return this.a.getHeight(g.element)}getTemplateId(g){return this.a.getTemplateId(g.element)}hasDynamicHeight(g){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(g.element)}setDynamicHeight(g,p){this.a.setDynamicHeight?.(g.element,p)}}t.$wS=j;class W{static lift(g){return g instanceof W?g:new W(g)}static empty(g=0){return new W({focus:[],selection:[],expanded:Object.create(null),scrollTop:g})}constructor(g){if(this.focus=new Set(g.focus),this.selection=new Set(g.selection),g.expanded instanceof Array){this.expanded=Object.create(null);for(const p of g.expanded)this.expanded[p]=1}else this.expanded=g.expanded;this.expanded=g.expanded,this.scrollTop=g.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$xS=W;var M;(function(x){x.None="none",x.OnHover="onHover",x.Always="always"})(M||(t.RenderIndentGuides=M={}));class F{get elements(){return this.b}constructor(g,p=[]){this.b=p,this.a=new c.$Qc,this.onDidChange=r.Event.forEach(g,V=>this.b=V,this.a)}dispose(){this.a.dispose()}}class J{static{this.a=8}constructor(g,p,V,T,N,O={}){this.o=g,this.p=p,this.q=T,this.s=N,this.b=new Map,this.c=new Map,this.d=J.a,this.f=!1,this.g=!1,this.j=new Set,this.k=c.$Rc.None,this.m=new c.$Qc,this.templateId=g.templateId,this.updateOptions(O),r.Event.map(V,_=>_.node)(this.u,this,this.m),g.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(g={}){if(typeof g.indent<"u"){const p=(0,o.$Ll)(g.indent,0,40);if(p!==this.d){this.d=p;for(const[V,T]of this.c)this.v(V,T)}}if(typeof g.renderIndentGuides<"u"){const p=g.renderIndentGuides!==M.None;if(p!==this.g){this.g=p;for(const[V,T]of this.c)this.w(V,T);if(this.k.dispose(),p){const V=new c.$Qc;this.q.onDidChange(this.x,this,V),this.k=V,this.x(this.q.elements)}}}typeof g.hideTwistiesOfChildlessElements<"u"&&(this.f=g.hideTwistiesOfChildlessElements)}renderTemplate(g){const p=(0,y.$qP)(g,(0,y.$)(".monaco-tl-row")),V=(0,y.$qP)(p,(0,y.$)(".monaco-tl-indent")),T=(0,y.$qP)(p,(0,y.$)(".monaco-tl-twistie")),N=(0,y.$qP)(p,(0,y.$)(".monaco-tl-contents")),O=this.o.renderTemplate(N);return{container:g,indent:V,twistie:T,indentGuidesDisposable:c.$Rc.None,templateData:O}}renderElement(g,p,V,T){this.c.set(g,V),this.b.set(g.element,g),this.v(g,V),this.o.renderElement(g,p,V.templateData,T)}disposeElement(g,p,V,T){V.indentGuidesDisposable.dispose(),this.o.disposeElement?.(g,p,V.templateData,T),typeof T=="number"&&(this.c.delete(g),this.b.delete(g.element))}disposeTemplate(g){this.o.disposeTemplate(g.templateData)}t(g){const p=this.b.get(g);p&&this.u(p)}u(g){const p=this.c.get(g);p&&(this.x(this.q.elements),this.v(g,p))}v(g,p){const V=J.a+(g.depth-1)*this.d;p.twistie.style.paddingLeft=`${V}px`,p.indent.style.width=`${V+this.d-16}px`,g.collapsible?p.container.setAttribute("aria-expanded",String(!g.collapsed)):p.container.removeAttribute("aria-expanded"),p.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(l.$Sj.treeItemExpanded));let T=!1;this.o.renderTwistie&&(T=this.o.renderTwistie(g.element,p.twistie)),g.collapsible&&(!this.f||g.visibleChildrenCount>0)?(T||p.twistie.classList.add(...m.ThemeIcon.asClassNameArray(l.$Sj.treeItemExpanded)),p.twistie.classList.add("collapsible"),p.twistie.classList.toggle("collapsed",g.collapsed)):p.twistie.classList.remove("collapsible","collapsed"),this.w(g,p)}w(g,p){if((0,y.$zO)(p.indent),p.indentGuidesDisposable.dispose(),!this.g)return;const V=new c.$Qc,T=this.p();for(;;){const N=T.getNodeLocation(g),O=T.getParentNodeLocation(N);if(!O)break;const _=T.getNode(O),S=(0,y.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(_)&&S.classList.add("active"),p.indent.childElementCount===0?p.indent.appendChild(S):p.indent.insertBefore(S,p.indent.firstElementChild),this.s.add(_,S),V.add((0,c.$Pc)(()=>this.s.delete(_,S))),g=_}p.indentGuidesDisposable=V}x(g){if(!this.g)return;const p=new Set,V=this.p();g.forEach(T=>{const N=V.getNodeLocation(T);try{const O=V.getParentNodeLocation(N);T.collapsible&&T.children.length>0&&!T.collapsed?p.add(T):O&&p.add(V.getNode(O))}catch{}}),this.j.forEach(T=>{p.has(T)||this.s.forEach(T,N=>N.classList.remove("active"))}),p.forEach(T=>{this.j.has(T)||this.s.forEach(T,N=>N.classList.add("active"))}),this.j=p}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,c.$Mc)(this.m)}}class ee{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(g){this.c=g,this.d=g.toLowerCase()}constructor(g,p,V){this.g=g,this.j=p,this.k=V,this.a=0,this.b=0,this.c="",this.d="",this.f=new c.$Qc,g.onWillRefilter(this.m,this,this.f)}filter(g,p){let V=1;if(this.k){const O=this.k.filter(g,p);if(typeof O=="boolean"?V=O?1:0:(0,L.$tS)(O)?V=(0,L.$uS)(O.visibility):V=O,V===0)return!1}if(this.a++,!this.c)return this.b++,{data:$.FuzzyScore.Default,visibility:V};const T=this.j.getKeyboardNavigationLabel(g),N=Array.isArray(T)?T:[T];for(const O of N){const _=O&&O.toString();if(typeof _>"u")return{data:$.FuzzyScore.Default,visibility:V};let S;if(this.g.findMatchType===me.Contiguous){const R=_.toLowerCase().indexOf(this.d);if(R>-1){S=[Number.MAX_SAFE_INTEGER,0];for(let A=this.d.length;A>0;A--)S.push(R+A-1)}}else S=(0,$.$Nj)(this.c,this.d,0,_,_.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(S)return this.b++,N.length===1?{data:S,visibility:V}:{data:{label:_,score:S},visibility:V}}return this.g.findMode===oe.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(g):2:{data:$.FuzzyScore.Default,visibility:V}}m(){this.a=0,this.b=0}dispose(){(0,c.$Mc)(this.f)}}class ne extends d.$6Q{constructor(g){super({icon:l.$Sj.listFilter,title:(0,z.localize)(0,null),isChecked:g.isChecked??!1,inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$yS=ne;class ue extends d.$6Q{constructor(g){super({icon:l.$Sj.searchFuzzy,title:(0,z.localize)(1,null),isChecked:g.isChecked??!1,inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$zS=ue;const le={inputBoxStyles:D.$MR,toggleStyles:d.$4Q,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var oe;(function(x){x[x.Highlight=0]="Highlight",x[x.Filter=1]="Filter"})(oe||(t.TreeFindMode=oe={}));var me;(function(x){x[x.Fuzzy=0]="Fuzzy",x[x.Contiguous=1]="Contiguous"})(me||(t.TreeFindMatchType=me={}));class Se extends c.$Rc{set mode(g){this.b.checked=g===oe.Filter,this.f.inputBox.setPlaceHolder(g===oe.Filter?(0,z.localize)(2,null):(0,z.localize)(3,null))}set matchType(g){this.c.checked=g===me.Fuzzy}get value(){return this.f.inputBox.value}set value(g){this.f.inputBox.value=g}constructor(g,p,V,T,N,O){super(),this.t=p,this.a=(0,y.h)(".monaco-tree-type-filter",[(0,y.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,y.h)(".monaco-tree-type-filter-input@findInput"),(0,y.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new r.$Md,this.onDidDisable=this._onDidDisable.event,g.appendChild(this.a.root),this.B((0,c.$Pc)(()=>g.removeChild(this.a.root)));const _=O?.styles??le;_.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=_.listFilterWidgetBackground),_.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${_.listFilterWidgetShadow}`),this.b=this.B(new ne({..._.toggleStyles,isChecked:T===oe.Filter})),this.c=this.B(new ue({..._.toggleStyles,isChecked:N===me.Fuzzy})),this.onDidChangeMode=r.Event.map(this.b.onChange,()=>this.b.checked?oe.Filter:oe.Highlight,this.q),this.onDidChangeMatchType=r.Event.map(this.c.onChange,()=>this.c.checked?me.Fuzzy:me.Contiguous,this.q),this.f=this.B(new w.$3R(this.a.findInput,V,{label:(0,z.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:_.inputBoxStyles,toggleStyles:_.toggleStyles,history:O?.history})),this.g=this.B(new U.$jQ(this.a.actionbar)),this.mode=T;const S=this.B(new P.$rQ(this.f.inputBox.inputElement,"keydown")),R=r.Event.chain(S.event,K=>K.map(te=>new i.$xO(te)));this.B(R(K=>{if(K.equals(3)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(K.equals(18)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(K.equals(16)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const A=this.B(new a.$si("close",(0,z.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(A,{icon:!0,label:!1});const k=this.B(new P.$rQ(this.a.grab,"mousedown"));this.B(k.event(K=>{const te=new c.$Qc,se=te.add(new P.$rQ(window,"mousemove")),ge=te.add(new P.$rQ(window,"mouseup")),we=this.m,Fe=K.pageX,Ae=this.s,ve=K.pageY;this.a.grab.classList.add("grabbing");const Me=this.a.root.style.transition;this.a.root.style.transition="unset";const Oe=_e=>{const je=_e.pageX-Fe;this.m=we-je;const Ie=_e.pageY-ve;this.s=Ae+Ie,this.layout()};te.add(se.event(Oe)),te.add(ge.event(_e=>{Oe(_e),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Me,te.dispose()}))}));const H=r.Event.chain(this.B(new P.$rQ(this.a.grab,"keydown")).event,K=>K.map(te=>new i.$xO(te)));this.B(H(K=>{let te,se;if(K.keyCode===15?te=Number.POSITIVE_INFINITY:K.keyCode===17?te=0:K.keyCode===10&&(te=this.m===0?Number.POSITIVE_INFINITY:0),K.keyCode===16?se=0:K.keyCode===18&&(se=Number.POSITIVE_INFINITY),te!==void 0&&(K.preventDefault(),K.stopPropagation(),this.m=te,this.layout()),se!==void 0){K.preventDefault(),K.stopPropagation(),this.s=se;const ge=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ge},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(g=this.j){this.j=g,this.m=(0,o.$Ll)(this.m,0,Math.max(0,g-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,o.$Ll)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(g){this.f.showMessage(g)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,u.$Tg)(300),super.dispose()}}class Le{get pattern(){return this.b}get mode(){return this.d}set mode(g){g!==this.d&&(this.d=g,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(g))}get matchType(){return this.f}set matchType(g){g!==this.f&&(this.f=g,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(g))}constructor(g,p,V,T,N,O={}){this.t=g,this.u=V,this.v=T,this.w=N,this.x=O,this.b="",this.c="",this.j=0,this.k=new r.$Md,this.onDidChangeMode=this.k.event,this.m=new r.$Md,this.onDidChangeMatchType=this.m.event,this.o=new r.$Md,this.onDidChangePattern=this.o.event,this.p=new r.$Md,this.onDidChangeOpenState=this.p.event,this.q=new c.$Qc,this.s=new c.$Qc,this.d=g.options.defaultFindMode??oe.Highlight,this.f=g.options.defaultFindMatchType??me.Fuzzy,p.onDidSplice(this.z,this,this.s)}updateOptions(g={}){g.defaultFindMode!==void 0&&(this.mode=g.defaultFindMode),g.defaultFindMatchType!==void 0&&(this.matchType=g.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Se(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(g=>this.mode=g,void 0,this.q),this.g.onDidChangeMatchType(g=>this.matchType=g,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(g){this.b=g,this.o.fire(g),this.v.pattern=g,this.t.refilter(),g&&this.t.focusNext(0,!0,void 0,V=>!$.FuzzyScore.isDefault(V.filterData));const p=this.t.getFocus();if(p.length>0){const V=p[0];this.t.getRelativeTop(V)===null&&this.t.reveal(V,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const g=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&g?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,z.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(g){return!this.g||!this.pattern||this.d===oe.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!$.FuzzyScore.isDefault(g.filterData)}layout(g){this.j=g,this.g?.layout(g)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Ne(x){let g=s.TreeMouseEventTarget.Unknown;return(0,y.$5O)(x.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?g=s.TreeMouseEventTarget.Twistie:(0,y.$5O)(x.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?g=s.TreeMouseEventTarget.Element:(0,y.$5O)(x.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(g=s.TreeMouseEventTarget.Filter),{browserEvent:x.browserEvent,element:x.element?x.element.element:null,target:g}}function de(x){return{element:x.element?x.element.element:null,browserEvent:x.browserEvent,anchor:x.anchor}}function ie(x,g){g(x),x.children.forEach(p=>ie(p,g))}class fe{get f(){return this.d||(this.d=this.m()),this.d}constructor(g,p){this.g=g,this.j=p,this.a=[],this.c=new r.$Md,this.onDidChange=this.c.event}set(g,p){!p?.__forceEvent&&(0,e.$tb)(this.a,g)||this.k(g,!1,p)}k(g,p,V){if(this.a=[...g],this.b=void 0,this.d=void 0,!p){const T=this;this.c.fire({get elements(){return T.get()},browserEvent:V})}}get(){return this.b||(this.b=this.a.map(g=>g.element)),[...this.b]}getNodes(){return this.a}has(g){return this.f.has(g)}onDidModelSplice({insertedNodes:g,deletedNodes:p}){if(!this.j){const S=this.m(),R=A=>S.delete(A);p.forEach(A=>ie(A,R)),this.set([...S.values()]);return}const V=new Set,T=S=>V.add(this.j.getId(S.element).toString());p.forEach(S=>ie(S,T));const N=new Map,O=S=>N.set(this.j.getId(S.element).toString(),S);g.forEach(S=>ie(S,O));const _=[];for(const S of this.a){const R=this.j.getId(S.element).toString();if(!V.has(R))_.push(S);else{const k=N.get(R);k&&k.visible&&_.push(k)}}if(this.a.length>0&&_.length===0){const S=this.g();S&&_.push(S)}this.k(_,!0)}m(){const g=new Set;for(const p of this.a)g.add(p);return g}}class X extends f.$OQ{constructor(g,p){super(g),this.x=p}u(g){if((0,f.$KQ)(g.browserEvent.target)||(0,f.$IQ)(g.browserEvent.target)||(0,f.$JQ)(g.browserEvent.target)||g.browserEvent.isHandledByList)return;const p=g.element;if(!p)return super.u(g);if(this.p(g)||this.o(g))return super.u(g);const V=g.browserEvent.target,T=V.classList.contains("monaco-tl-twistie")||V.classList.contains("monaco-icon-label")&&V.classList.contains("folder-icon")&&g.browserEvent.offsetX<16;let N=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?N=this.x.expandOnlyOnTwistieClick(p.element):N=!!this.x.expandOnlyOnTwistieClick,N&&!T&&g.browserEvent.detail!==2)return super.u(g);if(!this.x.expandOnDoubleClick&&g.browserEvent.detail===2)return super.u(g);if(p.collapsible){const O=this.x.getNodeLocation(p),_=g.browserEvent.altKey;if(this.x.setFocus([O]),this.x.toggleCollapsed(O,_),N&&T){g.browserEvent.isHandledByList=!0;return}}super.u(g)}v(g){g.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||g.browserEvent.isHandledByList||super.v(g)}}class q extends f.$RQ{constructor(g,p,V,T,N,O,_,S){super(g,p,V,T,S),this.p=N,this.s=O,this.K=_}D(g){return new X(this,g.tree)}splice(g,p,V=[]){if(super.splice(g,p,V),V.length===0)return;const T=[],N=[];let O;V.forEach((_,S)=>{this.p.has(_)&&T.push(g+S),this.s.has(_)&&N.push(g+S),this.K.has(_)&&(O=g+S)}),T.length>0&&super.setFocus((0,e.$Lb)([...super.getFocus(),...T])),N.length>0&&super.setSelection((0,e.$Lb)([...super.getSelection(),...N])),typeof O=="number"&&super.setAnchor(O)}setFocus(g,p,V=!1){super.setFocus(g,p),V||this.p.set(g.map(T=>this.element(T)),p)}setSelection(g,p,V=!1){super.setSelection(g,p),V||this.s.set(g.map(T=>this.element(T)),p)}setAnchor(g,p=!1){super.setAnchor(g),p||(typeof g>"u"?this.K.set([]):this.K.set([this.element(g)]))}}class G{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return r.Event.map(this.j.onMouseClick,Ne)}get onMouseDblClick(){return r.Event.filter(r.Event.map(this.j.onMouseDblClick,Ne),g=>g.target!==s.TreeMouseEventTarget.Filter)}get onContextMenu(){return r.Event.map(this.j.onContextMenu,de)}get onTap(){return r.Event.map(this.j.onTap,Ne)}get onPointer(){return r.Event.map(this.j.onPointer,Ne)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return r.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??oe.Highlight}set findMode(g){this.x&&(this.x.mode=g)}get findMatchType(){return this.x?.matchType??me.Fuzzy}set findMatchType(g){this.x&&(this.x.matchType=g)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:r.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(g,p,V,T,N={}){this.D=g,this.E=N,this.w=new r.$Ud,this.onDidChangeFindOpenState=r.Event.None,this.A=new c.$Qc,this.B=new r.$Md,this.onWillRefilter=this.B.event,this.C=new r.$Md,this.onDidUpdateOptions=this.C.event;const O=new j(V),_=new r.$Vd,S=new r.$Vd,R=this.A.add(new F(S.event)),A=new n.$Fc;this.k=T.map(se=>new J(se,()=>this.o,_.event,R,A,N));for(const se of this.k)this.A.add(se);let k;N.keyboardNavigationLabelProvider&&(k=new ee(this,N.keyboardNavigationLabelProvider,N.filter),N={...N,filter:k},this.A.add(k)),this.p=new fe(()=>this.j.getFocusedElements()[0],N.identityProvider),this.q=new fe(()=>this.j.getSelectedElements()[0],N.identityProvider),this.u=new fe(()=>this.j.getAnchorElement(),N.identityProvider),this.j=new q(g,p,O,this.k,this.p,this.q,this.u,{...B(()=>this.o,N),tree:this}),this.o=this.I(g,this.j,N),_.input=this.o.onDidChangeCollapseState;const H=r.Event.forEach(this.o.onDidSplice,se=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(se),this.q.onDidModelSplice(se)})},this.A);H(()=>null,null,this.A);const K=this.A.add(new r.$Md),te=this.A.add(new u.$Pg(0));if(this.A.add(r.Event.any(H,this.p.onDidChange,this.q.onDidChange)(()=>{te.trigger(()=>{const se=new Set;for(const ge of this.p.getNodes())se.add(ge);for(const ge of this.q.getNodes())se.add(ge);K.fire([...se.values()])})})),S.input=K.event,N.keyboardSupport!==!1){const se=r.Event.chain(this.j.onKeyDown,ge=>ge.filter(we=>!(0,f.$IQ)(we.target)).map(we=>new i.$xO(we)));r.Event.chain(se,ge=>ge.filter(we=>we.keyCode===15))(this.F,this,this.A),r.Event.chain(se,ge=>ge.filter(we=>we.keyCode===17))(this.G,this,this.A),r.Event.chain(se,ge=>ge.filter(we=>we.keyCode===10))(this.H,this,this.A)}if((N.findWidgetEnabled??!0)&&N.keyboardNavigationLabelProvider&&N.contextViewProvider){const se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Le(this,this.o,this.j,k,N.contextViewProvider,se),this.y=ge=>this.x.shouldAllowFocus(ge),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=r.Event.None,this.onDidChangeFindMatchType=r.Event.None;this.z=(0,y.$bP)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===M.Always)}updateOptions(g={}){this.E={...this.E,...g};for(const p of this.k)p.updateOptions(g);this.j.updateOptions(this.E),this.x?.updateOptions(g),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===M.Always)}get options(){return this.E}updateWidth(g){const p=this.o.getListIndex(g);p!==-1&&this.j.updateWidth(p)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(g){this.j.scrollTop=g}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(g){this.j.scrollLeft=g}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const g=this.j.firstVisibleIndex;return g<0||g>=this.j.length?void 0:this.j.element(g).element}get lastVisibleElement(){const g=this.j.lastVisibleIndex;return this.j.element(g).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(g){this.j.ariaLabel=g}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(g,p){this.j.layout(g,p),(0,C.$Bf)(p)&&this.x?.layout(p)}style(g){const p=`.${this.j.domId}`,V=[];g.treeIndentGuidesStroke&&(V.push(`.monaco-list${p}:hover .monaco-tl-indent > .indent-guide, .monaco-list${p}.always .monaco-tl-indent > .indent-guide  { border-color: ${g.treeInactiveIndentGuidesStroke}; }`),V.push(`.monaco-list${p} .monaco-tl-indent > .indent-guide.active { border-color: ${g.treeIndentGuidesStroke}; }`)),this.z.textContent=V.join(`
`),this.j.style(g)}getParentElement(g){const p=this.o.getParentNodeLocation(g);return this.o.getNode(p).element}getFirstElementChild(g){return this.o.getFirstElementChild(g)}getNode(g){return this.o.getNode(g)}getNodeLocation(g){return this.o.getNodeLocation(g)}collapse(g,p=!1){return this.o.setCollapsed(g,!0,p)}expand(g,p=!1){return this.o.setCollapsed(g,!1,p)}toggleCollapsed(g,p=!1){return this.o.setCollapsed(g,void 0,p)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(g){return this.o.isCollapsible(g)}setCollapsible(g,p){return this.o.setCollapsible(g,p)}isCollapsed(g){return this.o.isCollapsed(g)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(g){if(typeof g>"u")return this.j.setAnchor(void 0);const p=this.o.getNode(g);this.u.set([p]);const V=this.o.getListIndex(g);V>-1&&this.j.setAnchor(V,!0)}getAnchor(){return(0,e.$Nb)(this.u.get(),void 0)}setSelection(g,p){const V=g.map(N=>this.o.getNode(N));this.q.set(V,p);const T=g.map(N=>this.o.getListIndex(N)).filter(N=>N>-1);this.j.setSelection(T,p,!0)}getSelection(){return this.q.get()}setFocus(g,p){const V=g.map(N=>this.o.getNode(N));this.p.set(V,p);const T=g.map(N=>this.o.getListIndex(N)).filter(N=>N>-1);this.j.setFocus(T,p,!0)}focusNext(g=1,p=!1,V,T=this.y){this.j.focusNext(g,p,V,T)}focusPrevious(g=1,p=!1,V,T=this.y){this.j.focusPrevious(g,p,V,T)}focusNextPage(g,p=this.y){return this.j.focusNextPage(g,p)}focusPreviousPage(g,p=this.y){return this.j.focusPreviousPage(g,p)}focusLast(g,p=this.y){this.j.focusLast(g,p)}focusFirst(g,p=this.y){this.j.focusFirst(g,p)}getFocus(){return this.p.get()}reveal(g,p){this.o.expandTo(g);const V=this.o.getListIndex(g);V!==-1&&this.j.reveal(V,p)}getRelativeTop(g){const p=this.o.getListIndex(g);return p===-1?null:this.j.getRelativeTop(p)}getViewState(g=this.options.identityProvider){if(!g)throw new s.$rS(this.D,"Can't get tree view state without an identity provider");const p=O=>g.getId(O).toString(),V=W.empty(this.scrollTop);for(const O of this.getFocus())V.focus.add(p(O));for(const O of this.getSelection())V.selection.add(p(O));const T=this.o.getNode(),N=[T];for(;N.length>0;){const O=N.shift();O!==T&&O.collapsible&&(V.expanded[p(O.element)]=O.collapsed?0:1),N.push(...O.children)}return V}F(g){g.preventDefault(),g.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const V=p[0],T=this.o.getNodeLocation(V);if(!this.o.setCollapsed(T,!0)){const O=this.o.getParentNodeLocation(T);if(!O)return;const _=this.o.getListIndex(O);this.j.reveal(_),this.j.setFocus([_])}}G(g){g.preventDefault(),g.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const V=p[0],T=this.o.getNodeLocation(V);if(!this.o.setCollapsed(T,!1)){if(!V.children.some(S=>S.visible))return;const[O]=this.j.getFocus(),_=O+1;this.j.reveal(_),this.j.setFocus([_])}}H(g){g.preventDefault(),g.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const V=p[0],T=this.o.getNodeLocation(V),N=g.browserEvent.altKey;this.o.setCollapsed(T,void 0,N)}navigate(g){return new E(this.j,this.o,g)}dispose(){(0,c.$Mc)(this.A),this.j.dispose()}}t.$AS=G;class E{constructor(g,p,V){this.b=g,this.c=p,V?this.a=this.c.getListIndex(V):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[130],$e([1,0,129,120,24,26]),function(re,t,y,P,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LS=void 0;class w extends y.$AS{constructor(h,f,d,L,s,a={}){super(h,f,d,L,a),this.f=h,this.g=s,this.d=new Map,this.c=a.identityProvider}getInput(){return this.b}setInput(h,f){if(f&&!this.c)throw new i.$rS(this.f,"Can't restore tree view state without an identity provider");if(this.b=h,!h){this.d.clear(),this.o.setChildren(null,U.Iterable.empty());return}if(!f){this.m(h);return}const d=[],L=[],s=e=>{const u=this.c.getId(e).toString();return!f.expanded[u]},a=e=>{const u=this.c.getId(e.element).toString();f.focus.has(u)&&d.push(e.element),f.selection.has(u)&&L.push(e.element)};this.m(h,s,a),this.setFocus(d),this.setSelection(L),f&&typeof f.scrollTop=="number"&&(this.scrollTop=f.scrollTop)}updateChildren(h=this.b){if(typeof this.b>"u")throw new i.$rS(this.f,"Tree input not set");let f;this.c&&(f=d=>{const L=this.c.getId(d).toString(),s=this.d.get(L);if(s)return s.collapsed}),this.m(h,f)}resort(h=this.b,f=!0){this.o.resort(h===this.b?null:h,f)}refresh(h){if(h===void 0){this.j.rerender();return}this.o.rerender(h)}m(h,f,d){let L;if(this.c){const s=new Set,a=d;d=e=>{const u=this.c.getId(e.element).toString();s.add(u),this.d.set(u,e),a?.(e)},L=e=>{const u=this.c.getId(e.element).toString();s.has(u)||this.d.delete(u)}}this.o.setChildren(h===this.b?null:h,this.s(h,f).elements,{onDidCreateNode:d,onDidDeleteNode:L})}s(h,f){const d=[...this.g.getChildren(h)];return{elements:U.Iterable.map(d,s=>{const{elements:a,size:e}=this.s(s,f),u=this.g.hasChildren?this.g.hasChildren(s):void 0,l=e===0?void 0:f&&f(s);return{element:s,children:a,collapsible:u,collapsed:l}}),size:d.length}}I(h,f,d){return new P.$BS(h,f,d)}}t.$LS=w}),define(be[65],$e([1,0,11,9,32,28,25,6,3,2,51,12,7]),function(re,t,y,P,i,U,w,D,h,f,d,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wh=t.ProxyChannel=t.$vh=t.$uh=t.$th=t.$sh=t.$rh=t.$qh=t.RequestInitiator=t.$ph=t.$oh=t.$nh=t.$mh=t.$lh=void 0;var a;(function(de){de[de.Promise=100]="Promise",de[de.PromiseCancel=101]="PromiseCancel",de[de.EventListen=102]="EventListen",de[de.EventDispose=103]="EventDispose"})(a||(a={}));function e(de){switch(de){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(de){de[de.Initialize=200]="Initialize",de[de.PromiseSuccess=201]="PromiseSuccess",de[de.PromiseError=202]="PromiseError",de[de.PromiseErrorObj=203]="PromiseErrorObj",de[de.EventFire=204]="EventFire"})(u||(u={}));function l(de){switch(de){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(de){de[de.Uninitialized=0]="Uninitialized",de[de.Idle=1]="Idle"})(m||(m={}));function n(de){let ie=0;for(let fe=0;;fe+=7){const X=de.read(1);if(ie|=(X.buffer[0]&127)<<fe,!(X.buffer[0]&128))return ie}}const r=z(0);function $(de,ie){if(ie===0){de.write(r);return}let fe=0;for(let q=ie;q!==0;q=q>>>7)fe++;const X=i.$ae.alloc(fe);for(let q=0;ie!==0;q++)X.buffer[q]=ie&127,ie=ie>>>7,ie>0&&(X.buffer[q]|=128);de.write(X)}class c{constructor(ie){this.b=ie,this.a=0}read(ie){const fe=this.b.slice(this.a,this.a+ie);return this.a+=fe.byteLength,fe}}t.$lh=c;class o{constructor(){this.a=[]}get buffer(){return i.$ae.concat(this.a)}write(ie){this.a.push(ie)}}t.$mh=o;var C;(function(de){de[de.Undefined=0]="Undefined",de[de.String=1]="String",de[de.Buffer=2]="Buffer",de[de.VSBuffer=3]="VSBuffer",de[de.Array=4]="Array",de[de.Object=5]="Object",de[de.Int=6]="Int"})(C||(C={}));function z(de){const ie=i.$ae.alloc(1);return ie.writeUInt8(de,0),ie}const I={Undefined:z(C.Undefined),String:z(C.String),Buffer:z(C.Buffer),VSBuffer:z(C.VSBuffer),Array:z(C.Array),Object:z(C.Object),Uint:z(C.Int)},b=typeof Buffer<"u";function v(de,ie){if(typeof ie>"u")de.write(I.Undefined);else if(typeof ie=="string"){const fe=i.$ae.fromString(ie);de.write(I.String),$(de,fe.byteLength),de.write(fe)}else if(b&&Buffer.isBuffer(ie)){const fe=i.$ae.wrap(ie);de.write(I.Buffer),$(de,fe.byteLength),de.write(fe)}else if(ie instanceof i.$ae)de.write(I.VSBuffer),$(de,ie.byteLength),de.write(ie);else if(Array.isArray(ie)){de.write(I.Array),$(de,ie.length);for(const fe of ie)v(de,fe)}else if(typeof ie=="number"&&(ie|0)===ie)de.write(I.Uint),$(de,ie);else{const fe=i.$ae.fromString(JSON.stringify(ie));de.write(I.Object),$(de,fe.byteLength),de.write(fe)}}t.$nh=v;function B(de){switch(de.read(1).readUInt8(0)){case C.Undefined:return;case C.String:return de.read(n(de)).toString();case C.Buffer:return de.read(n(de)).buffer;case C.VSBuffer:return de.read(n(de));case C.Array:{const fe=n(de),X=[];for(let q=0;q<fe;q++)X.push(B(de));return X}case C.Object:return JSON.parse(de.read(n(de)).toString());case C.Int:return n(de)}}t.$oh=B;class j{constructor(ie,fe,X=null,q=1e3){this.h=ie,this.j=fe,this.k=X,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(ie,fe){this.b.set(ie,fe),setTimeout(()=>this.w(ie),0)}m(ie){switch(ie.type){case 200:{const fe=this.o([ie.type]);this.k?.logOutgoing(fe,0,1,l(ie.type));return}case 201:case 202:case 204:case 203:{const fe=this.o([ie.type,ie.id],ie.data);this.k?.logOutgoing(fe,ie.id,1,l(ie.type),ie.data);return}}}o(ie,fe=void 0){const X=new o;return v(X,ie),v(X,fe),this.p(X.buffer)}p(ie){try{return this.h.send(ie),ie.byteLength}catch{return 0}}q(ie){const fe=new c(ie),X=B(fe),q=B(fe),G=X[0];switch(G){case 100:return this.k?.logIncoming(ie.byteLength,X[1],1,`${e(G)}: ${X[2]}.${X[3]}`,q),this.s({type:G,id:X[1],channelName:X[2],name:X[3],arg:q});case 102:return this.k?.logIncoming(ie.byteLength,X[1],1,`${e(G)}: ${X[2]}.${X[3]}`,q),this.t({type:G,id:X[1],channelName:X[2],name:X[3],arg:q});case 101:return this.k?.logIncoming(ie.byteLength,X[1],1,`${e(G)}`),this.u({type:G,id:X[1]});case 103:return this.k?.logIncoming(ie.byteLength,X[1],1,`${e(G)}`),this.u({type:G,id:X[1]})}}s(ie){const fe=this.b.get(ie.channelName);if(!fe){this.v(ie);return}const X=new U.$Wd;let q;try{q=fe.call(this.j,ie.name,ie.arg,X.token)}catch(x){q=Promise.reject(x)}const G=ie.id;q.then(x=>{this.m({id:G,data:x,type:201})},x=>{x instanceof Error?this.m({id:G,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.m({id:G,data:x,type:203})}).finally(()=>{E.dispose(),this.d.delete(ie.id)});const E=(0,f.$Pc)(()=>X.cancel());this.d.set(ie.id,E)}t(ie){const fe=this.b.get(ie.channelName);if(!fe){this.v(ie);return}const X=ie.id,G=fe.listen(this.j,ie.name,ie.arg)(E=>this.m({id:X,data:E,type:204}));this.d.set(ie.id,G)}u(ie){const fe=this.d.get(ie.id);fe&&(fe.dispose(),this.d.delete(ie.id))}v(ie){let fe=this.g.get(ie.channelName);fe||(fe=[],this.g.set(ie.channelName,fe));const X=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.m({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);fe.push({request:ie,timeoutTimer:X})}w(ie){const fe=this.g.get(ie);if(fe){for(const X of fe)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(ie)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Mc)(this.d.values()),this.d.clear()}}t.$ph=j;var W;(function(de){de[de.LocalSide=0]="LocalSide",de[de.OtherSide=1]="OtherSide"})(W||(t.RequestInitiator=W={}));class M{constructor(ie,fe=null){this.l=ie,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Md,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=fe}getChannel(ie){const fe=this;return{call(X,q,G){return fe.a?Promise.reject(new D.$4):fe.m(ie,X,q,G)},listen(X,q){return fe.a?h.Event.None:fe.o(ie,X,q)}}}m(ie,fe,X,q=U.CancellationToken.None){const G=this.g++,x={id:G,type:100,channelName:ie,name:fe,arg:X};if(q.isCancellationRequested)return Promise.reject(new D.$4);let g;return new Promise((V,T)=>{if(q.isCancellationRequested)return T(new D.$4);const N=()=>{const R=A=>{switch(A.type){case 201:this.f.delete(G),V(A.data);break;case 202:{this.f.delete(G);const k=new Error(A.data.message);k.stack=Array.isArray(A.data.stack)?A.data.stack.join(`
`):A.data.stack,k.name=A.data.name,T(k);break}case 203:this.f.delete(G),T(A.data);break}};this.f.set(G,R),this.p(x)};let O=null;this.b===m.Idle?N():(O=(0,P.$Gg)(R=>this.u()),O.then(()=>{O=null,N()}));const _=()=>{O?(O.cancel(),O=null):this.p({id:G,type:101}),T(new D.$4)},S=q.onCancellationRequested(_);g=(0,f.$Oc)((0,f.$Pc)(_),S),this.d.add(g)}).finally(()=>{g.dispose(),this.d.delete(g)})}o(ie,fe,X){const q=this.g++,E={id:q,type:102,channelName:ie,name:fe,arg:X};let x=null;const g=new h.$Md({onWillAddFirstListener:()=>{x=(0,P.$Gg)(V=>this.u()),x.then(()=>{x=null,this.d.add(g),this.p(E)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(g),this.p({id:q,type:103}))}}),p=V=>g.fire(V.data);return this.f.set(q,p),g.event}p(ie){switch(ie.type){case 100:case 102:{const fe=this.q([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.j?.logOutgoing(fe,ie.id,0,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const fe=this.q([ie.type,ie.id]);this.j?.logOutgoing(fe,ie.id,0,e(ie.type));return}}}q(ie,fe=void 0){const X=new o;return v(X,ie),v(X,fe),this.r(X.buffer)}r(ie){try{return this.l.send(ie),ie.byteLength}catch{return 0}}s(ie){const fe=new c(ie),X=B(fe),q=B(fe),G=X[0];switch(G){case 200:return this.j?.logIncoming(ie.byteLength,0,0,l(G)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ie.byteLength,X[1],0,l(G),q),this.t({type:X[0],id:X[1],data:q})}}t(ie){if(ie.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(ie.id)?.(ie)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Mc)(this.d.values()),this.d.clear()}}t.$qh=M,Qe([w.$fh],M.prototype,"onDidInitializePromise",null);class F{get connections(){const ie=[];return this.f.forEach(fe=>ie.push(fe)),ie}constructor(ie){this.a=new Map,this.f=new Set,this.g=new h.$Md,this.onDidAddConnection=this.g.event,this.h=new h.$Md,this.onDidRemoveConnection=this.h.event,this.j=new f.$Qc,this.j.add(ie(({protocol:fe,onDidClientDisconnect:X})=>{const q=h.Event.once(fe.onMessage);this.j.add(q(G=>{const E=new c(G),x=B(E),g=new j(fe,x),p=new M(fe);this.a.forEach((T,N)=>g.registerChannel(N,T));const V={channelServer:g,channelClient:p,ctx:x};this.f.add(V),this.g.fire(V),this.j.add(X(()=>{g.dispose(),p.dispose(),this.f.delete(V),this.h.fire(V)}))}))}))}getChannel(ie,fe){const X=this;return{call(q,G,E){let x;if((0,s.$Lf)(fe)){const p=(0,y.$3b)(X.connections.filter(fe));x=p?Promise.resolve(p):h.Event.toPromise(h.Event.filter(X.onDidAddConnection,fe))}else x=fe.routeCall(X,q,G);const g=x.then(p=>p.channelClient.getChannel(ie));return ee(g).call(q,G,E)},listen(q,G){if((0,s.$Lf)(fe))return X.k(ie,fe,q,G);const E=fe.routeEvent(X,q,G).then(x=>x.channelClient.getChannel(ie));return ee(E).listen(q,G)}}}k(ie,fe,X,q){const G=this;let E;const x=new h.$Md({onWillAddFirstListener:()=>{E=new f.$Qc;const g=new h.$Sd,p=new Map,V=N=>{const _=N.channelClient.getChannel(ie).listen(X,q),S=g.add(_);p.set(N,S)},T=N=>{const O=p.get(N);O&&(O.dispose(),p.delete(N))};G.connections.filter(fe).forEach(V),h.Event.filter(G.onDidAddConnection,fe)(V,void 0,E),G.onDidRemoveConnection(T,void 0,E),g.event(x.fire,x,E),E.add(g)},onDidRemoveLastListener:()=>{E?.dispose(),E=void 0}});return x.event}registerChannel(ie,fe){this.a.set(ie,fe);for(const X of this.f)X.channelServer.registerChannel(ie,fe)}dispose(){this.j.dispose();for(const ie of this.f)ie.channelClient.dispose(),ie.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$rh=F;class J{constructor(ie,fe,X=null){const q=new o;v(q,fe),ie.send(q.buffer),this.a=new M(ie,X),this.d=new j(ie,fe,X)}getChannel(ie){return this.a.getChannel(ie)}registerChannel(ie,fe){this.d.registerChannel(ie,fe)}dispose(){this.a.dispose(),this.d.dispose()}}t.$sh=J;function ee(de){return{call(ie,fe,X){return de.then(q=>q.call(ie,fe,X))},listen(ie,fe){const X=new h.$Vd;return de.then(q=>X.input=q.listen(ie,fe)),X.event}}}t.$th=ee;function ne(de){let ie=!1;return{call(fe,X,q){return ie?de.call(fe,X,q):(0,P.$Tg)(0).then(()=>ie=!0).then(()=>de.call(fe,X,q))},listen(fe,X){if(ie)return de.listen(fe,X);const q=new h.$Vd;return(0,P.$Tg)(0).then(()=>ie=!0).then(()=>q.input=de.listen(fe,X)),q.event}}}t.$uh=ne;class ue{constructor(ie){this.a=ie}routeCall(ie){return this.b(ie)}routeEvent(ie){return this.b(ie)}async b(ie){for(const fe of ie.connections)if(await Promise.resolve(this.a(fe.ctx)))return Promise.resolve(fe);return await h.Event.toPromise(ie.onDidAddConnection),await this.b(ie)}}t.$vh=ue;var le;(function(de){function ie(G,E,x){const g=G,p=x&&x.disableMarshalling,V=new Map;for(const T in g)X(T)&&V.set(T,h.Event.buffer(g[T],!0,void 0,E));return new class{listen(T,N,O){const _=V.get(N);if(_)return _;if(q(N)){const S=g[N];if(typeof S=="function")return S.call(g,O)}throw new D.$ab(`Event not found: ${N}`)}call(T,N,O){const _=g[N];if(typeof _=="function"){if(!p&&Array.isArray(O))for(let R=0;R<O.length;R++)O[R]=(0,d.$kh)(O[R]);let S=_.apply(g,O);return S instanceof Promise||(S=Promise.resolve(S)),S}throw new D.$ab(`Method not found: ${N}`)}}}de.fromService=ie;function fe(G,E){const x=E&&E.disableMarshalling;return new Proxy({},{get(g,p){if(typeof p=="string")return E?.properties?.has(p)?E.properties.get(p):q(p)?function(V){return G.listen(p,V)}:X(p)?G.listen(p):async function(...V){let T;E&&!(0,s.$Gf)(E.context)?T=[E.context,...V]:T=V;const N=await G.call(p,T);return x?N:(0,d.$kh)(N)};throw new D.$ab(`Property not found: ${String(p)}`)}})}de.toService=fe;function X(G){return G[0]==="o"&&G[1]==="n"&&L.$Ze(G.charCodeAt(2))}function q(G){return/^onDynamic/.test(G)&&L.$Ze(G.charCodeAt(9))}})(le||(t.ProxyChannel=le={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function me(de){if(Array.isArray(de))return de;if(de&&typeof de=="object"&&typeof de.toString=="function"){const ie=de.toString();if(ie!=="[object Object]")return ie}return de}function Se(de){return Array.isArray(de)?de.map(me):me(de)}function Le(de,ie,fe,X,q,G,E){E=Se(E);const x=oe[q],g=x[X%x.length];let p=[`%c[${de}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(fe).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${g}`];/\($/.test(G)?(p=p.concat(E),p.push(")")):p.push(E),console.log.apply(console,p)}class Ne{constructor(ie,fe){this.d=ie,this.f=fe,this.a=0,this.b=0}logOutgoing(ie,fe,X,q,G){this.b+=ie,Le(this.d,this.b,ie,fe,X,q,G)}logIncoming(ie,fe,X,q,G){this.a+=ie,Le(this.f,this.a,ie,fe,X,q,G)}}t.$wh=Ne}),define(be[30],$e([1,0,5]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$R=t.$Q=t.$P=t.$O=t.$N=void 0,t.$N=y.$h.vscode.ipcRenderer,t.$O=y.$h.vscode.ipcMessagePort,t.$P=y.$h.vscode.webFrame,t.$Q=y.$h.vscode.process,t.$R=y.$h.vscode.context}),define(be[131],$e([1,0,87,30]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fT=void 0;let i=0;function U(D,h,f){const d=[],L=i++,s=`vscode:onContextMenu${L}`,a=(e,u,l)=>{d[u].click?.(l)};P.$N.once(s,a),P.$N.once(y.$cT,(e,u)=>{u===L&&(P.$N.removeListener(s,a),f?.())}),P.$N.send(y.$bT,L,D.map(e=>w(e,d)),s,h)}t.$fT=U;function w(D,h){const f={id:h.length,label:D.label,type:D.type,accelerator:D.accelerator,checked:D.checked,enabled:typeof D.enabled=="boolean"?D.enabled:!0,visible:typeof D.visible=="boolean"?D.visible:!0};return h.push(D),Array.isArray(D.submenu)&&(f.submenu=D.submenu.map(d=>w(d,h))),f}}),define(be[132],$e([1,0,32,3,65,88,30]),function(re,t,y,P,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nT=void 0;class D extends i.$sh{static f(){const f=P.Event.fromNodeEventEmitter(w.$N,"vscode:message",(d,L)=>y.$ae.wrap(L));return w.$N.send("vscode:hello"),new U.$jT(w.$N,f)}constructor(f){const d=D.f();super(d,f),this.b=d}dispose(){this.b.disconnect()}}t.$nT=D}),define(be[133],$e([13,10]),function(re,t){return re.create("vs/platform/files/common/files",t)}),define(be[134],$e([13,10]),function(re,t){return re.create("vs/platform/theme/common/iconRegistry",t)}),define(be[39],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oh=t.$Nh=t.$Mh=t._util=void 0;var y;(function(w){w.serviceIds=new Map,w.DI_TARGET="$di$target",w.DI_DEPENDENCIES="$di$dependencies";function D(h){return h[w.DI_DEPENDENCIES]||[]}w.getServiceDependencies=D})(y||(t._util=y={})),t.$Mh=i("instantiationService");function P(w,D,h){D[y.DI_TARGET]===D?D[y.DI_DEPENDENCIES].push({id:w,index:h}):(D[y.DI_DEPENDENCIES]=[{id:w,index:h}],D[y.DI_TARGET]=D)}function i(w){if(y.serviceIds.has(w))return y.serviceIds.get(w);const D=function(h,f,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(D,h,d)};return D.toString=()=>w,y.serviceIds.set(w,D),D}t.$Nh=i;function U(w){return w}t.$Oh=U}),define(be[135],$e([1,0,39]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pm=t.$om=t.$nm=t.ID=void 0,t.ID="diagnosticsService",t.$nm=(0,y.$Nh)(t.ID);function P(U){return!!U.hostName&&!!U.errorMessage}t.$om=P;class i{async getPerformanceInfo(w,D){return{}}async getSystemInfo(w,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(w,D){return""}async getWorkspaceFileExtensions(w){return{extensions:[]}}async reportWorkspaceStats(w){}}t.$pm=i}),define(be[136],$e([1,0,86,22,12,7,15,133,39,5,29,27]),function(re,t,y,P,i,U,w,D,h,f,d,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fk=t.$Ek=t.$Dk=t.$Ck=t.$Bk=t.FileKind=t.$Ak=t.$zk=t.$yk=t.$xk=t.$wk=t.$vk=t.$uk=t.FileOperationResult=t.$tk=t.$sk=t.$rk=t.$qk=t.$pk=t.FileChangeType=t.$ok=t.FileOperation=t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.FileSystemProviderErrorCode=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=t.$ck=t.$bk=t.$ak=t.$_j=t.FileSystemProviderCapabilities=t.$$j=t.FilePermission=t.FileType=t.$0j=t.$9j=void 0,t.$9j=(0,h.$Nh)("fileService");function s(q){return q.create===!0}t.$0j=s;var a;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(a||(t.FileType=a={}));var e;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function u(q){const G=q;return!!G&&typeof G.onDidChange=="function"}t.$$j=u;var l;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(l||(t.FileSystemProviderCapabilities=l={}));function m(q){return!!(q.capabilities&2)}t.$_j=m;function n(q){return!!(q.capabilities&8)}t.$ak=n;function r(q){return!!(q.capabilities&131072)}t.$bk=r;function $(q){return!!(q.capabilities&4)}t.$ck=$;function c(q){return!!(q.capabilities&16)}t.$dk=c;function o(q){return m(q)?!!(q.capabilities&16384):!1}t.$ek=o;function C(q){return m(q)?!!(q.capabilities&32768):!1}t.$fk=C;function z(q){return!!(q.capabilities&65536)}t.$gk=z;function I(q){return!!(q.capabilities&2048)}t.$hk=I;var b;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(b||(t.FileSystemProviderErrorCode=b={}));class v extends Error{static create(G,E){const x=new v(G.toString(),E);return W(x,E),x}constructor(G,E){super(G),this.code=E}}t.$ik=v;function B(q,G){return v.create(q,G)}t.$jk=B;function j(q){return q||B((0,D.localize)(0,null),b.Unknown)}t.$kk=j;function W(q,G){return q.name=G?`${G} (FileSystemError)`:"FileSystemError",q}t.$lk=W;function M(q){if(!q)return b.Unknown;if(q instanceof v)return q.code;const G=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!G)return b.Unknown;switch(G[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}t.$mk=M;function F(q){if(q instanceof oe)return q.fileOperationResult;switch(M(q)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}t.$nk=F;var J;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(J||(t.FileOperation=J={}));class ee{constructor(G,E,x){this.resource=G,this.operation=E,this.target=x}isOperation(G){return this.operation===G}}t.$ok=ee;var ne;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(ne||(t.FileChangeType=ne={}));class ue{static{this.a=null}constructor(G,E){this.c=E,this.b=void 0,this.d=new L.$U(()=>{const x=y.$Th.forUris(()=>this.c);return x.fill(this.rawAdded.map(g=>[g,!0])),x}),this.f=new L.$U(()=>{const x=y.$Th.forUris(()=>this.c);return x.fill(this.rawUpdated.map(g=>[g,!0])),x}),this.g=new L.$U(()=>{const x=y.$Th.forUris(()=>this.c);return x.fill(this.rawDeleted.map(g=>[g,!0])),x}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const x of G){switch(x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}this.b!==ue.a&&(typeof x.cId=="number"?this.b===void 0?this.b=x.cId:this.b!==x.cId&&(this.b=ue.a):this.b!==void 0&&(this.b=ue.a))}}contains(G,...E){return this.h(G,{includeChildren:!1},...E)}affects(G,...E){return this.h(G,{includeChildren:!0},...E)}h(G,E,...x){if(!G)return!1;const g=x.length>0;return!!((!g||x.includes(1))&&(this.d.value.get(G)||E.includeChildren&&this.d.value.findSuperstr(G))||(!g||x.includes(0))&&(this.f.value.get(G)||E.includeChildren&&this.f.value.findSuperstr(G))||(!g||x.includes(2))&&(this.g.value.findSubstr(G)||E.includeChildren&&this.g.value.findSuperstr(G)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(G){return this.b===G}hasCorrelation(){return typeof this.b=="number"}}t.$pk=ue;function le(q,G,E){return!q||!G||q===G||G.length>q.length?!1:(G.charAt(G.length-1)!==P.sep&&(G+=P.sep),E?(0,i.$2e)(q,G):q.indexOf(G)===0)}t.$qk=le;class oe extends Error{constructor(G,E,x){super(G),this.fileOperationResult=E,this.options=x}}t.$rk=oe;class me extends oe{constructor(G,E,x,g){super(G,E,g),this.fileOperationResult=E,this.size=x}}t.$sk=me;class Se extends oe{constructor(G,E,x){super(G,2,x),this.stat=E}}t.$tk=Se;var Le;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Le||(t.FileOperationResult=Le={})),t.$uk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$vk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$wk="files.associations",t.$xk="files.exclude",t.$yk="files.readonlyInclude",t.$zk="files.readonlyExclude",t.$Ak="files.readonlyFromPermissions";var Ne;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Ne||(t.FileKind=Ne={})),t.$Bk="";function de(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}t.$Ck=de;async function ie(q,G){if(!G.hasProvider(w.URI.from({scheme:q.scheme})))return new Promise(E=>{const x=G.onDidChangeFileSystemProviderRegistrations(g=>{g.scheme===q.scheme&&g.added&&(x.dispose(),E())})})}t.$Dk=ie;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(G){return(0,U.$Bf)(G)||(G=0),G<fe.KB?(0,D.localize)(1,null,G.toFixed(0)):G<fe.MB?(0,D.localize)(2,null,(G/fe.KB).toFixed(2)):G<fe.GB?(0,D.localize)(3,null,(G/fe.MB).toFixed(2)):G<fe.TB?(0,D.localize)(4,null,(G/fe.GB).toFixed(2)):(0,D.localize)(5,null,(G/fe.TB).toFixed(2))}}t.$Ek=fe;function X(q){const G=typeof q=="string"||q?.scheme===d.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===d.Schemas.file?1024*fe.MB:G?10*fe.MB:f.$p?50*fe.MB:1024*fe.MB}t.$Fk=X}),define(be[137],$e([1,0,39]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$47b=t.$37b=void 0,t.$37b=(0,y.$Nh)("mainProcessService");class P{constructor(U,w){this.a=U,this.b=w}getChannel(U){return this.a.getChannel(U,this.b)}registerChannel(U,w){this.a.registerChannel(U,w)}}t.$47b=P}),define(be[138],$e([1,0,2,132]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$57b=void 0;class i extends y.$Rc{constructor(w){super(),this.a=this.B(new P.$nT(`window:${w}`))}getChannel(w){return this.a.getChannel(w)}registerChannel(w,D){this.a.registerChannel(w,D)}}t.$57b=i});var wi=this&&this.__param||function(re,t){return function(y,P){t(y,P,re)}};define(be[139],$e([1,0,65,137]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$67b=void 0;let i=class{constructor(w,D){return this.windowId=w,y.ProxyChannel.toService(D.getChannel("nativeHost"),{context:w,properties:(()=>{const h=new Map;return h.set("windowId",w),h})()})}};t.$67b=i,t.$67b=i=Qe([wi(1,P.$37b)],i)}),define(be[66],$e([1,0,74,7]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cn=void 0;class i{constructor(){this.a=new Map}add(w,D){y.ok(P.$xf(w)),y.ok(P.$zf(D)),y.ok(!this.a.has(w),"There is already an extension with this id"),this.a.set(w,D)}knows(w){return this.a.has(w)}as(w){return this.a.get(w)||null}}t.$cn=new i}),define(be[140],$e([1,0,3,66]),function(re,t,y,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dn=void 0,t.$dn={JSONContribution:"base.contributions.json"};function i(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class U{constructor(){this.b=new y.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,f){this.a[i(h)]=f,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const w=new U;P.$cn.add(t.$dn.JSONContribution,w)}),define(be[141],$e([1,0,9,17,18,3,7,15,134,140,66]),function(re,t,y,P,i,U,w,D,h,f,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8v=t.$7v=t.$6v=t.$5v=t.$4v=t.$3v=t.$2v=t.$1v=t.IconFontDefinition=t.IconContribution=t.$Zv=void 0,t.$Zv={IconContribution:"base.contributions.icons"};var L;(function($){function c(o,C){let z=o.defaults;for(;i.ThemeIcon.isThemeIcon(z);){const I=e.getIcon(z.id);if(!I)return;z=I.defaults}return z}$.getDefinition=c})(L||(t.IconContribution=L={}));var s;(function($){function c(C){return{weight:C.weight,style:C.style,src:C.src.map(z=>({format:z.format,location:z.location.toString()}))}}$.toJSONObject=c;function o(C){const z=I=>(0,w.$xf)(I)?I:void 0;if(C&&Array.isArray(C.src)&&C.src.every(I=>(0,w.$xf)(I.format)&&(0,w.$xf)(I.location)))return{weight:z(C.weight),style:z(C.style),src:C.src.map(I=>({format:I.format,location:D.URI.parse(I.location)}))}}$.fromJSONObject=o})(s||(t.IconFontDefinition=s={}));class a{constructor(){this.a=new U.$Md,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,h.localize)(0,null)},fontCharacter:{type:"string",description:(0,h.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,o,C,z){const I=this.b[c];if(I){if(C&&!I.description){I.description=C,this.d.properties[c].markdownDescription=`${C} $(${c})`;const B=this.e.enum.indexOf(c);B!==-1&&(this.e.enumDescriptions[B]=C),this.a.fire()}return I}const b={id:c,description:C,defaults:o,deprecationMessage:z};this.b[c]=b;const v={$ref:"#/definitions/icons"};return z&&(v.deprecationMessage=z),C&&(v.markdownDescription=`${C}: $(${c})`),this.d.properties[c]=v,this.e.enum.push(c),this.e.enumDescriptions.push(C||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const o=this.e.enum.indexOf(c);o!==-1&&(this.e.enum.splice(o,1),this.e.enumDescriptions.splice(o,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,o){const C=this.f[c];return C||(this.f[c]=o,this.a.fire(),o)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=(I,b)=>I.id.localeCompare(b.id),o=I=>{for(;i.ThemeIcon.isThemeIcon(I.defaults);)I=this.b[I.defaults.id];return`codicon codicon-${I?I.id:""}`},C=[];C.push("| preview     | identifier                        | default codicon ID                | description"),C.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const z=Object.keys(this.b).map(I=>this.b[I]);for(const I of z.filter(b=>!!b.description).sort(c))C.push(`|<i class="${o(I)}"></i>|${I.id}|${i.ThemeIcon.isThemeIcon(I.defaults)?I.defaults.id:I.id}|${I.description||""}|`);C.push("| preview     | identifier                        "),C.push("| ----------- | --------------------------------- |");for(const I of z.filter(b=>!i.ThemeIcon.isThemeIcon(b.defaults)).sort(c))C.push(`|<i class="${o(I)}"></i>|${I.id}|`);return C.join(`
`)}}const e=new a;d.$cn.add(t.$Zv.IconContribution,e);function u($,c,o,C){return e.registerIcon($,c,o,C)}t.$1v=u;function l(){return e}t.$2v=l;function m(){const $=(0,P.$Qj)();for(const c in $){const o="\\"+$[c].toString(16);e.registerIcon(c,{fontCharacter:o})}}m(),t.$3v="vscode://schemas/icons";const n=d.$cn.as(f.$dn.JSONContribution);n.registerSchema(t.$3v,e.getIconSchema());const r=new y.$5g(()=>n.notifySchemaChanged(t.$3v),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.$4v=u("widget-close",P.$Sj.close,(0,h.localize)(2,null)),t.$5v=u("goto-previous-location",P.$Sj.arrowUp,(0,h.localize)(3,null)),t.$6v=u("goto-next-location",P.$Sj.arrowDown,(0,h.localize)(4,null)),t.$7v=i.ThemeIcon.modify(P.$Sj.sync,"spin"),t.$8v=i.ThemeIcon.modify(P.$Sj.loading,"spin")}),define(be[142],$e([1,0,4,3,2,18,141]),function(re,t,y,P,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nCb=t.$mCb=void 0;function D(f){const d=new i.$Qc,L=d.add(new P.$Md),s=(0,w.$2v)();return d.add(s.onDidChange(()=>L.fire())),f&&d.add(f.onDidProductIconThemeChange(()=>L.fire())),{dispose:()=>d.dispose(),onDidChange:L.event,getCSS(){const a=f?f.getProductIconTheme():new h,e={},u=m=>{const n=a.getIcon(m);if(!n)return;const r=n.font;return r?(e[r.id]=r.definition,`.codicon-${m.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,y.$HP)(r.id)}; }`):`.codicon-${m.id}:before { content: '${n.fontCharacter}'; }`},l=[];for(const m of s.getIcons()){const n=u(m);n&&l.push(n)}for(const m in e){const n=e[m],r=n.weight?`font-weight: ${n.weight};`:"",$=n.style?`font-style: ${n.style};`:"",c=n.src.map(o=>`${(0,y.$GP)(o.location)} format('${o.format}')`).join(", ");l.push(`@font-face { src: ${c}; font-family: ${(0,y.$HP)(m)};${r}${$} font-display: block; }`)}return l.join(`
`)}}}t.$mCb=D;class h{getIcon(d){const L=(0,w.$2v)();let s=d.defaults;for(;U.ThemeIcon.isThemeIcon(s);){const a=L.getIcon(s.id);if(!a)return;s=a.defaults}return s}}t.$nCb=h}),define(be[143],$e([1,0,5]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4C=t.$3C=t.$2C=t.$1C=t.$ZC=t.$YC=t.$XC=t.$WC=void 0,t.$WC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function P(d){return!!d.workspaceUri}t.$XC=P;function i(d){return!!d.folderUri}t.$YC=i;function U(d){return!!d.fileUri}t.$ZC=U;function w(d){const L=D(d),s=d.getValue("window.menuBarVisibility");return s==="default"||L==="native"&&s==="compact"||y.$k&&y.$n?"classic":s}t.$1C=w;function D(d){if(y.$p)return"custom";const L=d.getValue("window");if(L){if(y.$k&&L.nativeTabs===!0||y.$k&&L.nativeFullScreen===!1)return"native";const e=L.titleBarStyle;if(e==="native"||e==="custom")return e}return y.$l?"native":"custom"}t.$2C=D;function h(d){return!(!y.$j||y.$p||D(d)==="native")}t.$3C=h;function f(d=0){return Math.pow(1.2,d)}t.$4C=f}),define(be[144],$e([1,0,16,30,143]),function(re,t,y,P,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$07b=t.$97b=t.$87b=void 0;function U(h){P.$P.setZoomLevel(h),(0,y.$cO)((0,i.$4C)(h)),(0,y.$_N)(h)}t.$87b=U;function w(){U((0,y.$aO)()+1)}t.$97b=w;function D(){U((0,y.$aO)()-1)}t.$07b=D}),define(be[145],$e([1,0,10,4,130,9,131,30,135,136,138,139,142,144,14,101,92]),function(re,t,y,P,i,U,w,D,h,f,d,L,s,a,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const u=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,l=/\s--inspect-port=(?<port>\d+)/;class m{getHeight(W){return 22}getTemplateId(W){return I(W)?"process":C(W)?"machine":(0,h.$om)(W)?"error":z(W)?"header":""}}class n{hasChildren(W){return(0,h.$om)(W)?!1:I(W)?!!W.children?.length:!0}getChildren(W){return I(W)?W.children?W.children:[]:(0,h.$om)(W)?[]:z(W)?W.processRoots.length>1?W.processRoots:[W.processRoots[0].rootProcess]:C(W)?[W.rootProcess]:[W.processes]}}class r{constructor(){this.templateId="header"}renderTemplate(W){const M=(0,P.$qP)(W,(0,P.$)(".row")),F=(0,P.$qP)(M,(0,P.$)(".nameLabel")),J=(0,P.$qP)(M,(0,P.$)(".cpu")),ee=(0,P.$qP)(M,(0,P.$)(".memory")),ne=(0,P.$qP)(M,(0,P.$)(".pid"));return{name:F,CPU:J,memory:ee,PID:ne}}renderElement(W,M,F,J){F.name.textContent=(0,y.localize)(0,null),F.CPU.textContent=(0,y.localize)(1,null),F.PID.textContent=(0,y.localize)(2,null),F.memory.textContent=(0,y.localize)(3,null)}disposeTemplate(W){}}class ${constructor(){this.templateId="machine"}renderTemplate(W){const M=Object.create(null),F=(0,P.$qP)(W,(0,P.$)(".row"));return M.name=(0,P.$qP)(F,(0,P.$)(".nameLabel")),M}renderElement(W,M,F,J){F.name.textContent=W.element.name}disposeTemplate(W){}}class c{constructor(){this.templateId="error"}renderTemplate(W){const M=Object.create(null),F=(0,P.$qP)(W,(0,P.$)(".row"));return M.name=(0,P.$qP)(F,(0,P.$)(".nameLabel")),M}renderElement(W,M,F,J){F.name.textContent=W.element.errorMessage}disposeTemplate(W){}}class o{constructor(W,M,F){this.a=W,this.b=M,this.c=F,this.templateId="process"}renderTemplate(W){const M=(0,P.$qP)(W,(0,P.$)(".row")),F=(0,P.$qP)(M,(0,P.$)(".nameLabel")),J=(0,P.$qP)(M,(0,P.$)(".cpu")),ee=(0,P.$qP)(M,(0,P.$)(".memory")),ne=(0,P.$qP)(M,(0,P.$)(".pid"));return{name:F,CPU:J,PID:ne,memory:ee}}renderElement(W,M,F,J){const{element:ee}=W,ne=ee.pid.toFixed(0);let ue=ee.name;this.c.has(ee.pid)&&(ue=this.c.get(ee.pid)),F.name.textContent=ue,F.name.title=ee.cmd,F.CPU.textContent=ee.load.toFixed(0),F.PID.textContent=ne,F.PID.parentElement.id=`pid-${ne}`;const le=this.a==="win32"?ee.mem:this.b*(ee.mem/100);F.memory.textContent=(le/f.$Ek.MB).toFixed(0)}disposeTemplate(W){}}function C(j){return!!j.name&&!!j.rootProcess}function z(j){return!!j.processRoots}function I(j){return!!j.pid}class b{constructor(W,M){this.f=M,this.b=new Map;const F=new d.$57b(W);this.c=new L.$67b(W,F),this.k(M.styles),this.g(M),D.$N.on("vscode:pidToNameResponse",(J,ee)=>{this.b=new Map;for(const[ne,ue]of ee)this.b.set(ne,ue)}),D.$N.on("vscode:listProcessesResponse",async(J,ee)=>{ee.forEach((ne,ue)=>{I(ne.rootProcess)&&(ne.rootProcess.name=ue===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:ee}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(ee),this.m(0)}),this.a=Date.now(),D.$N.send("vscode:pidToNameRequest"),D.$N.send("vscode:listProcesses")}g(W){document.onkeydown=M=>{const F=W.platform==="darwin"?M.metaKey:M.ctrlKey;F&&M.keyCode===87&&(M.stopPropagation(),M.preventDefault(),D.$N.send("vscode:closeProcessExplorer")),F&&M.keyCode===187&&(0,a.$97b)(),F&&M.keyCode===189&&(0,a.$07b)()}}async h(W){const M=document.getElementById("process-list");if(!M)return;const{totalmem:F}=await this.c.getOSStatistics(),J=[new o(this.f.platform,F,this.b),new r,new $,new c];this.d=new i.$LS("processExplorer",M,new m,J,new n,{identityProvider:{getId:ee=>I(ee)?ee.pid.toString():(0,h.$om)(ee)?ee.hostName:z(ee)?"processes":C(ee)?ee.name:"header"}}),this.d.setInput({processes:{processRoots:W}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(ee=>{const ne=new e.$xO(ee);if(ne.keyCode===35&&ne.altKey){const ue=this.n();Promise.all(ue.map(le=>this.c.killProcess(le,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(ee=>{I(ee.element)&&this.l(ee.element,!0)}),M.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{M.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(W){const M=u.exec(W);return M&&M.groups.port!=="0"||W.indexOf("node ")>=0||W.indexOf("node.exe")>=0}j(W){const M={type:"node",request:"attach",name:`process ${W.pid}`};let F=u.exec(W.cmd);F?M.port=Number(F.groups.port):M.processId=String(W.pid),F=l.exec(W.cmd),F&&(M.port=Number(F.groups.port)),D.$N.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[M]})}k(W){const M=(0,P.$bP)(),F=[];W.listFocusBackground&&(F.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${W.listFocusBackground}; }`),F.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${W.listFocusBackground}; }`)),W.listFocusForeground&&F.push(`.monaco-list:focus .monaco-list-row.focused { color: ${W.listFocusForeground}; }`),W.listActiveSelectionBackground&&(F.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${W.listActiveSelectionBackground}; }`),F.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${W.listActiveSelectionBackground}; }`)),W.listActiveSelectionForeground&&F.push(`.monaco-list:focus .monaco-list-row.selected { color: ${W.listActiveSelectionForeground}; }`),W.listHoverBackground&&F.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${W.listHoverBackground}; }`),W.listHoverForeground&&F.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${W.listHoverForeground}; }`),W.listFocusOutline&&F.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${W.listFocusOutline}; outline-offset: -1px; }`),W.listHoverOutline&&F.push(`.monaco-list-row:hover { outline: 1px dashed ${W.listHoverOutline}; outline-offset: -1px; }`),W.scrollbarShadowColor&&F.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${W.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${W.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${W.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),W.scrollbarSliderBackgroundColor&&F.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${W.scrollbarSliderBackgroundColor};
				}
			`),W.scrollbarSliderHoverBackgroundColor&&F.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${W.scrollbarSliderHoverBackgroundColor};
				}
			`),W.scrollbarSliderActiveBackgroundColor&&F.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${W.scrollbarSliderActiveBackgroundColor};
				}
			`),M.textContent=F.join(`
`),W.color&&(document.body.style.color=W.color)}l(W,M){const F=[],J=Number(W.pid);M&&(F.push({accelerator:"Alt+E",label:(0,y.localize)(4,null),click:()=>{this.c.killProcess(J,"SIGTERM")}}),F.push({label:(0,y.localize)(5,null),click:()=>{this.c.killProcess(J,"SIGKILL")}}),F.push({type:"separator"})),F.push({label:(0,y.localize)(6,null),click:()=>{const ee=this.n();ee?.includes(J)||(ee.length=0,ee.push(J));const ne=ee?.map(ue=>document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(ne){const ue=ne.map(le=>le.innerText).filter(le=>!!le);this.c.writeClipboardText(ue.join(`
`))}}}),F.push({label:(0,y.localize)(7,null),click:()=>{const ee=document.getElementById("process-list");ee&&this.c.writeClipboardText(ee.innerText)}}),W&&M&&this.i(W.cmd)&&(F.push({type:"separator"}),F.push({label:(0,y.localize)(8,null),click:()=>{this.j(W)}})),(0,w.$fT)(F)}m(W){setTimeout(()=>{const M=Date.now(),F=W+M-this.a;this.a=M,F>1e3?(D.$N.send("vscode:pidToNameRequest"),D.$N.send("vscode:listProcesses")):this.m(F)},200)}n(){return this.d?.getSelection()?.map(W=>{if(!(!W||!("pid"in W)))return W.pid}).filter(W=>!!W)}}function v(){const j=(0,P.$bP)();j.id="codiconStyles";const W=(0,s.$mCb)(void 0);function M(){j.textContent=W.getCSS()}const F=new U.$5g(M,0);W.onDidChange(()=>F.schedule()),F.schedule()}function B(j){const W=j.data.platform==="win32"?"windows":j.data.platform==="linux"?"linux":"mac";document.body.classList.add(W),v(),(0,a.$87b)(j.data.zoomLevel),new b(j.windowId,j.data)}t.startup=B})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b63441dbc9f729977e8e97321f536a06521496f7/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
