/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(J){for(var e=[],L=0,D=J.length;L<D;L++)e[L]=ne[J[L]];return e};define(ne[70],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class L{static get(){const N=new Map,A=new Map,j=new Map,b=new Map;function u(d,k){d.has(k.detail)||d.set(k.detail,-k.timestamp)}function c(d,k){const v=d.get(k.detail);v&&(v>=0||d.set(k.detail,v+k.timestamp))}let E=[];typeof J=="function"&&typeof J.getStats=="function"&&(E=J.getStats().slice(0).sort((d,k)=>d.timestamp-k.timestamp));for(const d of E)switch(d.type){case 10:u(N,d);break;case 11:case 12:c(N,d);break;case 21:u(A,d);break;case 22:c(A,d);break;case 33:u(j,d);break;case 34:c(j,d);break;case 31:u(b,d);break;case 32:c(b,d);break}let O=0;j.forEach(d=>O+=d);function m(d){const k=[];return d.forEach((v,$)=>k.push([$,v])),k}return{amdLoad:m(N),amdInvoke:m(A),nodeRequire:m(j),nodeEval:m(b),nodeRequireTotal:O}}static toMarkdownTable(N,A){let j="";const b=[];return N.forEach((u,c)=>{b[c]=u.length}),A.forEach(u=>{u.forEach((c,E)=>{typeof c>"u"&&(c=u[E]="-");const O=c.toString().length;b[E]=Math.max(O,b[E])})}),N.forEach((u,c)=>{j+=`| ${u+" ".repeat(b[c]-u.toString().length)} `}),j+=`|
`,N.forEach((u,c)=>{j+=`| ${"-".repeat(b[c])} `}),j+=`|
`,A.forEach(u=>{u.forEach((c,E)=>{typeof c<"u"&&(j+=`| ${c+" ".repeat(b[E]-c.toString().length)} `)}),j+=`|
`}),j}}e.$T=L}),define(ne[52],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function L(j){return(b,u,c)=>{let E=null,O=null;if(typeof c.value=="function"?(E="value",O=c.value):typeof c.get=="function"&&(E="get",O=c.get),!O)throw new Error("not supported");c[E]=j(O,u)}}function D(j,b,u){let c=null,E=null;if(typeof u.value=="function"?(c="value",E=u.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",E=u.get),!E)throw new Error("not supported");const O=`$memoize$${b}`;u[c]=function(...m){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,m)}),this[O]}}e.$fh=D;function N(j,b,u){return L((c,E)=>{const O=`$debounce$${E}`,m=`$debounce$result$${E}`;return function(...d){this[m]||(this[m]=u?u():void 0),clearTimeout(this[O]),b&&(this[m]=b(this[m],...d),d=[this[m]]),this[O]=setTimeout(()=>{c.apply(this,d),this[m]=u?u():void 0},j)}})}e.$gh=N;function A(j,b,u){return L((c,E)=>{const O=`$throttle$timer$${E}`,m=`$throttle$result$${E}`,d=`$throttle$lastRun$${E}`,k=`$throttle$pending$${E}`;return function(...v){if(this[m]||(this[m]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...v)),this[k])return;const $=this[d]+j;$<=Date.now()?(this[d]=Date.now(),c.apply(this,[this[m]]),this[m]=u?u():void 0):(this[k]=!0,this[O]=setTimeout(()=>{this[k]=!1,this[d]=Date.now(),c.apply(this,[this[m]]),this[m]=u?u():void 0},$-Date.now()))}})}e.$hh=A}),define(ne[71],re([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function D(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=D;function N(u,c="Unreachable"){throw new Error(c)}e.$3c=N;function A(u){if(!u)throw new L.$bb("Assertion Failed")}e.$4c=A;function j(u){if(!u()){debugger;u(),(0,L.$Z)(new L.$bb("Assertion Failed"))}}e.$5c=j;function b(u,c){let E=0;for(;E<u.length-1;){const O=u[E],m=u[E+1];if(!c(O,m))return!1;E++}return!0}e.$6c=b}),define(ne[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var N;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(N||(e.ParseErrorCode=N={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function j(s,o=!1){let t=0;const i=s.length;let n="",r=0,l=16,P=0;function y(te){let ae=0,le=0;for(;ae<te;){const ie=s.charCodeAt(t);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;t++,ae++}return ae<te&&(le=-1),le}function w(te){t=te,n="",r=0,l=16,P=0}function R(){const te=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&c(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&c(s.charCodeAt(t)))for(t++;t<s.length&&c(s.charCodeAt(t));)t++;else return P=3,s.substring(te,t);let ae=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&c(s.charCodeAt(t))){for(t++;t<s.length&&c(s.charCodeAt(t));)t++;ae=t}else P=3;return s.substring(te,ae)}function W(){let te="",ae=t;for(;;){if(t>=i){te+=s.substring(ae,t),P=2;break}const le=s.charCodeAt(t);if(le===34){te+=s.substring(ae,t),t++;break}if(le===92){if(te+=s.substring(ae,t),t++,t>=i){P=2;break}switch(s.charCodeAt(t++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const q=y(4);q>=0?te+=String.fromCharCode(q):P=4;break}default:P=5}ae=t;continue}if(le>=0&&le<=31)if(u(le)){te+=s.substring(ae,t),P=2;break}else P=6;t++}return te}function _(){if(n="",P=0,r=t,t>=i)return r=i,l=17;let te=s.charCodeAt(t);if(b(te)){do t++,n+=String.fromCharCode(te),te=s.charCodeAt(t);while(b(te));return l=15}if(u(te))return t++,n+=String.fromCharCode(te),te===13&&s.charCodeAt(t)===10&&(t++,n+=`
`),l=14;switch(te){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,n=W(),l=10;case 47:{const ae=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!u(s.charCodeAt(t));)t++;return n=s.substring(ae,t),l=12}if(s.charCodeAt(t+1)===42){t+=2;const le=i-1;let ie=!1;for(;t<le;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,ie=!0;break}t++}return ie||(t++,P=1),n=s.substring(ae,t),l=13}return n+=String.fromCharCode(te),t++,l=16}case 45:if(n+=String.fromCharCode(te),t++,t===i||!c(s.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),l=11;default:for(;t<i&&Y(te);)t++,te=s.charCodeAt(t);if(r!==t){switch(n=s.substring(r,t),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(te),t++,l=16}}function Y(te){if(b(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let te;do te=_();while(te>=12&&te<=15);return te}return{setPosition:w,getPosition:()=>t,scan:o?ue:_,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>t-r,getTokenError:()=>P}}e.$Qm=j;function b(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function u(s){return s===10||s===13||s===8232||s===8233}function c(s){return s>=48&&s<=57}var E;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(E||(E={}));function O(s,o){const t=[],i=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(y,w,R,W){r.value=y,r.offset=w,r.length=R,r.type=W,r.colonOffset=void 0,n=r}try{I(s,{onObjectBegin:(y,w)=>{if(o<=y)throw i;n=void 0,l=o>y,t.push("")},onObjectProperty:(y,w,R)=>{if(o<w||(P(y,w,R,"property"),t[t.length-1]=y,o<=w+R))throw i},onObjectEnd:(y,w)=>{if(o<=y)throw i;n=void 0,t.pop()},onArrayBegin:(y,w)=>{if(o<=y)throw i;n=void 0,t.push(0)},onArrayEnd:(y,w)=>{if(o<=y)throw i;n=void 0,t.pop()},onLiteralValue:(y,w,R)=>{if(o<w||(P(y,w,R,S(y)),o<=w+R))throw i},onSeparator:(y,w,R)=>{if(o<=w)throw i;if(y===":"&&n&&n.type==="property")n.colonOffset=w,l=!1,n=void 0;else if(y===","){const W=t[t.length-1];typeof W=="number"?t[t.length-1]=W+1:(l=!0,t[t.length-1]=""),n=void 0}}})}catch(y){if(y!==i)throw y}return{path:t,previousNode:n,isAtPropertyKey:l,matches:y=>{let w=0;for(let R=0;w<y.length&&R<t.length;R++)if(y[w]===t[R]||y[w]==="*")w++;else if(y[w]!=="**")return!1;return w===y.length}}}e.$Rm=O;function m(s,o=[],t=A.DEFAULT){let i=null,n=[];const r=[];function l(y){Array.isArray(n)?n.push(y):i!==null&&(n[i]=y)}return I(s,{onObjectBegin:()=>{const y={};l(y),r.push(n),n=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const y=[];l(y),r.push(n),n=y,i=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:l,onError:(y,w,R)=>{o.push({error:y,offset:w,length:R})}},t),n[0]}e.$Sm=m;function d(s,o=[],t=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function r(y){return i.children.push(y),y}I(s,{onObjectBegin:y=>{i=r({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,w,R)=>{i=r({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:w,length:R,parent:i})},onObjectEnd:(y,w)=>{i.length=y+w-i.offset,i=i.parent,n(y+w)},onArrayBegin:(y,w)=>{i=r({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,w)=>{i.length=y+w-i.offset,i=i.parent,n(y+w)},onLiteralValue:(y,w,R)=>{r({type:S(y),offset:w,length:R,parent:i,value:y}),n(w+R)},onSeparator:(y,w,R)=>{i.type==="property"&&(y===":"?i.colonOffset=w:y===","&&n(w))},onError:(y,w,R)=>{o.push({error:y,offset:w,length:R})}},t);const P=i.children[0];return P&&delete P.parent,P}e.$Tm=d;function k(s,o){if(!s)return;let t=s;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const r of t.children)if(Array.isArray(r.children)&&r.children[0].value===i){t=r.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.$Um=k;function v(s){if(!s.parent||!s.parent.children)return[];const o=v(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;o.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&o.push(t)}return o}e.$Vm=v;function $(s){switch(s.type){case"array":return s.children.map($);case"object":{const o=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(o[t.children[0].value]=$(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$Wm=$;function h(s,o,t=!1){return o>=s.offset&&o<s.offset+s.length||t&&o===s.offset+s.length}e.$Xm=h;function f(s,o,t=!1){if(h(s,o,t)){const i=s.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const r=f(i[n],o,t);if(r)return r}return s}}e.$Ym=f;function I(s,o,t=A.DEFAULT){const i=j(s,!1);function n(x){return x?()=>x(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(x){return x?Q=>x(Q,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(o.onObjectBegin),P=r(o.onObjectProperty),y=n(o.onObjectEnd),w=n(o.onArrayBegin),R=n(o.onArrayEnd),W=r(o.onLiteralValue),_=r(o.onSeparator),Y=n(o.onComment),ue=r(o.onError),te=t&&t.disallowComments,ae=t&&t.allowTrailingComma;function le(){for(;;){const x=i.scan();switch(i.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(x){case 12:case 13:te?ie(10):Y();break;case 16:ie(1);break;case 15:case 14:break;default:return x}}}function ie(x,Q=[],F=[]){if(ue(x),Q.length+F.length>0){let z=i.getToken();for(;z!==17;){if(Q.indexOf(z)!==-1){le();break}else if(F.indexOf(z)!==-1)break;z=le()}}}function q(x){const Q=i.getTokenValue();return x?W(Q):P(Q),le(),!0}function G(){switch(i.getToken()){case 11:{let x=0;try{x=JSON.parse(i.getTokenValue()),typeof x!="number"&&(ie(2),x=0)}catch{ie(2)}W(x);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return le(),!0}function T(){return i.getToken()!==10?(ie(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(_(":"),le(),Z()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function U(){l(),le();let x=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(x||ie(4,[],[]),_(","),le(),i.getToken()===2&&ae)break}else x&&ie(6,[],[]);T()||ie(4,[],[2,5]),x=!0}return y(),i.getToken()!==2?ie(7,[2],[]):le(),!0}function B(){w(),le();let x=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(x||ie(4,[],[]),_(","),le(),i.getToken()===4&&ae)break}else x&&ie(6,[],[]);Z()||ie(4,[],[4,5]),x=!0}return R(),i.getToken()!==4?ie(8,[4],[]):le(),!0}function Z(){switch(i.getToken()){case 3:return B();case 1:return U();case 10:return q(!0);default:return G()}}return le(),i.getToken()===17?t.allowEmptyContent?!0:(ie(4,[],[]),!1):Z()?(i.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$Zm=I;function p(s,o){const t=j(s),i=[];let n,r=0,l;do switch(l=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:r!==l&&i.push(s.substring(r,l)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),r=t.getPosition();break}while(n!==17);return i.join("")}e.$1m=p;function S(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$2m=S}),define(ne[72],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Nl=e.rot=e.$Ll=void 0;function L(b,u,c){return Math.min(Math.max(b,u),c)}e.$Ll=L;function D(b,u){return(u+b%u)%u}e.rot=D;class N{constructor(){this.a=0}getNext(){return this.a++}}e.$Nl=N;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ol=A;class j{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pl=j}),function(){function J(N){const A=[];typeof N=="number"&&A.push("code/timeOrigin",N);function j(u){A.push(u,Date.now())}function b(){const u=[];for(let c=0;c<A.length;c+=2)u.push({name:A[c],startTime:A[c+1]});return u}return{mark:j,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(N){performance.mark(N)},getMarks(){let N=performance.timeOrigin;typeof N!="number"&&(N=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(N)}];for(const j of performance.getEntriesByType("mark"))A.push({name:j.name,startTime:Math.round(N+j.startTime)});return A}};if(typeof process=="object"){const N=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(N)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(N){return N.MonacoPerformanceMarks||(N.MonacoPerformanceMarks=e()),N.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:J)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(D){if(e[D])return e[D].exports;var N=e[D]={i:D,l:!1,exports:{}};return J[D].call(N.exports,N,N.exports,L),N.l=!0,N.exports}return L.m=J,L.c=e,L.d=function(D,N,A){L.o(D,N)||Object.defineProperty(D,N,{enumerable:!0,get:A})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,N){if(1&N&&(D=L(D)),8&N||4&N&&typeof D=="object"&&D&&D.__esModule)return D;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:D}),2&N&&typeof D!="string")for(var j in D)L.d(A,j,function(b){return D[b]}.bind(null,j));return A},L.n=function(D){var N=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(N,"a",N),N},L.o=function(D,N){return Object.prototype.hasOwnProperty.call(D,N)},L.p="",L(L.s=0)}([function(J,e,L){(function(D){var N;e=J.exports=F,N=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],u=e.src=[],c=0,E=c++;u[E]="0|[1-9]\\d*";var O=c++;u[O]="[0-9]+";var m=c++;u[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;u[d]="("+u[E]+")\\.("+u[E]+")\\.("+u[E]+")";var k=c++;u[k]="("+u[O]+")\\.("+u[O]+")\\.("+u[O]+")";var v=c++;u[v]="(?:"+u[E]+"|"+u[m]+")";var $=c++;u[$]="(?:"+u[O]+"|"+u[m]+")";var h=c++;u[h]="(?:-("+u[v]+"(?:\\."+u[v]+")*))";var f=c++;u[f]="(?:-?("+u[$]+"(?:\\."+u[$]+")*))";var I=c++;u[I]="[0-9A-Za-z-]+";var p=c++;u[p]="(?:\\+("+u[I]+"(?:\\."+u[I]+")*))";var S=c++,s="v?"+u[d]+u[h]+"?"+u[p]+"?";u[S]="^"+s+"$";var o="[v=\\s]*"+u[k]+u[f]+"?"+u[p]+"?",t=c++;u[t]="^"+o+"$";var i=c++;u[i]="((?:<|>)?=?)";var n=c++;u[n]=u[O]+"|x|X|\\*";var r=c++;u[r]=u[E]+"|x|X|\\*";var l=c++;u[l]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[h]+")?"+u[p]+"?)?)?";var P=c++;u[P]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[f]+")?"+u[p]+"?)?)?";var y=c++;u[y]="^"+u[i]+"\\s*"+u[l]+"$";var w=c++;u[w]="^"+u[i]+"\\s*"+u[P]+"$";var R=c++;u[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=c++;u[W]="(?:~>?)";var _=c++;u[_]="(\\s*)"+u[W]+"\\s+",b[_]=new RegExp(u[_],"g");var Y=c++;u[Y]="^"+u[W]+u[l]+"$";var ue=c++;u[ue]="^"+u[W]+u[P]+"$";var te=c++;u[te]="(?:\\^)";var ae=c++;u[ae]="(\\s*)"+u[te]+"\\s+",b[ae]=new RegExp(u[ae],"g");var le=c++;u[le]="^"+u[te]+u[l]+"$";var ie=c++;u[ie]="^"+u[te]+u[P]+"$";var q=c++;u[q]="^"+u[i]+"\\s*("+o+")$|^$";var G=c++;u[G]="^"+u[i]+"\\s*("+s+")$|^$";var T=c++;u[T]="(\\s*)"+u[i]+"\\s*("+o+"|"+u[l]+")",b[T]=new RegExp(u[T],"g");var U=c++;u[U]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var B=c++;u[B]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var Z=c++;u[Z]="(<|>)?=?\\s*\\*";for(var x=0;x<35;x++)N(x,u[x]),b[x]||(b[x]=new RegExp(u[x]));function Q(V,K){if(V instanceof F)return V;if(typeof V!="string"||V.length>A||!(K?b[t]:b[S]).test(V))return null;try{return new F(V,K)}catch{return null}}function F(V,K){if(V instanceof F){if(V.loose===K)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof F))return new F(V,K);N("SemVer",V,K),this.loose=K;var ee=V.trim().match(K?b[t]:b[S]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<j)return ye}return $e}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=Q,e.valid=function(V,K){var ee=Q(V,K);return ee?ee.version:null},e.clean=function(V,K){var ee=Q(V.trim().replace(/^[=v]+/,""),K);return ee?ee.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(V){return N("SemVer.compare",this.version,this.loose,V),V instanceof F||(V=new F(V,this.loose)),this.compareMain(V)||this.comparePre(V)},F.prototype.compareMain=function(V){return V instanceof F||(V=new F(V,this.loose)),a(this.major,V.major)||a(this.minor,V.minor)||a(this.patch,V.patch)},F.prototype.comparePre=function(V){if(V instanceof F||(V=new F(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var K=0;do{var ee=this.prerelease[K],$e=V.prerelease[K];if(N("prerelease compare",K,ee,$e),ee===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ee===void 0)return-1;if(ee!==$e)return a(ee,$e)}while(++K)},F.prototype.inc=function(V,K){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,K,ee,$e){typeof ee=="string"&&($e=ee,ee=void 0);try{return new F(V,ee).inc(K,$e).version}catch{return null}},e.diff=function(V,K){if(X(V,K))return null;var ee=Q(V),$e=Q(K);if(ee.prerelease.length||$e.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return ye},e.compareIdentifiers=a;var z=/^[0-9]+$/;function a(V,K){var ee=z.test(V),$e=z.test(K);return ee&&$e&&(V=+V,K=+K),ee&&!$e?-1:$e&&!ee?1:V<K?-1:V>K?1:0}function g(V,K,ee){return new F(V,ee).compare(new F(K,ee))}function M(V,K,ee){return g(V,K,ee)>0}function C(V,K,ee){return g(V,K,ee)<0}function X(V,K,ee){return g(V,K,ee)===0}function H(V,K,ee){return g(V,K,ee)!==0}function ce(V,K,ee){return g(V,K,ee)>=0}function oe(V,K,ee){return g(V,K,ee)<=0}function me(V,K,ee,$e){var ye;switch(K){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=X(V,ee,$e);break;case"!=":ye=H(V,ee,$e);break;case">":ye=M(V,ee,$e);break;case">=":ye=ce(V,ee,$e);break;case"<":ye=C(V,ee,$e);break;case"<=":ye=oe(V,ee,$e);break;default:throw new TypeError("Invalid operator: "+K)}return ye}function de(V,K){if(V instanceof de){if(V.loose===K)return V;V=V.value}if(!(this instanceof de))return new de(V,K);N("comparator",V,K),this.loose=K,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,N("comp",this)}e.rcompareIdentifiers=function(V,K){return a(K,V)},e.major=function(V,K){return new F(V,K).major},e.minor=function(V,K){return new F(V,K).minor},e.patch=function(V,K){return new F(V,K).patch},e.compare=g,e.compareLoose=function(V,K){return g(V,K,!0)},e.rcompare=function(V,K,ee){return g(K,V,ee)},e.sort=function(V,K){return V.sort(function(ee,$e){return e.compare(ee,$e,K)})},e.rsort=function(V,K){return V.sort(function(ee,$e){return e.rcompare(ee,$e,K)})},e.gt=M,e.lt=C,e.eq=X,e.neq=H,e.gte=ce,e.lte=oe,e.cmp=me,e.Comparator=de;var ge={};function fe(V,K){if(V instanceof fe)return V.loose===K?V:new fe(V.raw,K);if(V instanceof de)return new fe(V.value,K);if(!(this instanceof fe))return new fe(V,K);if(this.loose=K,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,K,ee,$e,ye,Ne,Se,Le,Ie,Ae,Fe,Oe,je){return((K=he(ee)?"":he($e)?">="+ee+".0.0":he(ye)?">="+ee+"."+$e+".0":">="+K)+" "+(Le=he(Ie)?"":he(Ae)?"<"+(+Ie+1)+".0.0":he(Fe)?"<"+Ie+"."+(+Ae+1)+".0":Oe?"<="+Ie+"."+Ae+"."+Fe+"-"+Oe:"<="+Le)).trim()}function be(V,K){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(K))return!1;if(K.prerelease.length){for(ee=0;ee<V.length;ee++)if(N(V[ee].semver),V[ee].semver!==ge&&V[ee].semver.prerelease.length>0){var $e=V[ee].semver;if($e.major===K.major&&$e.minor===K.minor&&$e.patch===K.patch)return!0}return!1}return!0}function Pe(V,K,ee){try{K=new fe(K,ee)}catch{return!1}return K.test(V)}function Me(V,K,ee,$e){var ye,Ne,Se,Le,Ie;switch(V=new F(V,$e),K=new fe(K,$e),ee){case">":ye=M,Ne=oe,Se=C,Le=">",Ie=">=";break;case"<":ye=C,Ne=ce,Se=M,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe(V,K,$e))return!1;for(var Ae=0;Ae<K.set.length;++Ae){var Fe=K.set[Ae],Oe=null,je=null;if(Fe.forEach(function(De){De.semver===ge&&(De=new de(">=0.0.0")),Oe=Oe||De,je=je||De,ye(De.semver,Oe.semver,$e)?Oe=De:Se(De.semver,je.semver,$e)&&(je=De)}),Oe.operator===Le||Oe.operator===Ie||(!je.operator||je.operator===Le)&&Ne(V,je.semver)||je.operator===Ie&&Se(V,je.semver))return!1}return!0}de.prototype.parse=function(V){var K=this.loose?b[q]:b[G],ee=V.match(K);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new F(ee[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return N("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new F(V,this.loose)),me(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,K){if(!(V instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,K),Pe(this.value,ee,K);if(V.operator==="")return ee=new fe(this.value,K),Pe(V.semver,ee,K);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Ne=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=me(this.semver,"<",V.semver,K)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=me(this.semver,">",V.semver,K)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||ye||Ne&&Se||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var K=this.loose;V=V.trim(),N("range",V,K);var ee=K?b[B]:b[U];V=V.replace(ee,we),N("hyphen replace",V),V=V.replace(b[T],"$1$2$3"),N("comparator trim",V,b[T]),V=(V=(V=V.replace(b[_],"$1~")).replace(b[ae],"$1^")).split(/\s+/).join(" ");var $e=K?b[q]:b[G],ye=V.split(" ").map(function(Ne){return function(Se,Le){return N("comp",Se),Se=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Fe){return function(Oe,je){N("caret",Oe,je);var De=je?b[ie]:b[le];return Oe.replace(De,function(Ue,ve,Ee,ke,Re){var ze;return N("caret",Oe,Ue,ve,Ee,ke,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(ke)?ze=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Re?(N("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+ke+Re+" <"+ve+"."+Ee+"."+(+ke+1):">="+ve+"."+Ee+"."+ke+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+ke+Re+" <"+(+ve+1)+".0.0"):(N("no pr"),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+ke+" <"+ve+"."+Ee+"."+(+ke+1):">="+ve+"."+Ee+"."+ke+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+ke+" <"+(+ve+1)+".0.0"),N("caret return",ze),ze})}(Fe,Ae)}).join(" ")}(Se,Le),N("caret",Se),Se=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Fe){return function(Oe,je){var De=je?b[ue]:b[Y];return Oe.replace(De,function(Ue,ve,Ee,ke,Re){var ze;return N("tilde",Oe,Ue,ve,Ee,ke,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(ke)?ze=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Re?(N("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=">="+ve+"."+Ee+"."+ke+Re+" <"+ve+"."+(+Ee+1)+".0"):ze=">="+ve+"."+Ee+"."+ke+" <"+ve+"."+(+Ee+1)+".0",N("tilde return",ze),ze})}(Fe,Ae)}).join(" ")}(Se,Le),N("tildes",Se),Se=function(Ie,Ae){return N("replaceXRanges",Ie,Ae),Ie.split(/\s+/).map(function(Fe){return function(Oe,je){Oe=Oe.trim();var De=je?b[w]:b[y];return Oe.replace(De,function(Ue,ve,Ee,ke,Re,ze){N("xRange",Oe,Ue,ve,Ee,ke,Re,ze);var qe=he(Ee),Ce=qe||he(ke),Te=Ce||he(Re);return ve==="="&&Te&&(ve=""),qe?Ue=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Ce&&(ke=0),Te&&(Re=0),ve===">"?(ve=">=",Ce?(Ee=+Ee+1,ke=0,Re=0):Te&&(ke=+ke+1,Re=0)):ve==="<="&&(ve="<",Ce?Ee=+Ee+1:ke=+ke+1),Ue=ve+Ee+"."+ke+"."+Re):Ce?Ue=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ue=">="+Ee+"."+ke+".0 <"+Ee+"."+(+ke+1)+".0"),N("xRange return",Ue),Ue})}(Fe,Ae)}).join(" ")}(Se,Le),N("xrange",Se),Se=function(Ie,Ae){return N("replaceStars",Ie,Ae),Ie.trim().replace(b[Z],"")}(Se,Le),N("stars",Se),Se}(Ne,K)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Ne){return!!Ne.match($e)})),ye=ye.map(function(Ne){return new de(Ne,K)})},fe.prototype.intersects=function(V,K){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function($e){return V.set.some(function(ye){return ye.every(function(Ne){return $e.intersects(Ne,K)})})})})},e.toComparators=function(V,K){return new fe(V,K).set.map(function(ee){return ee.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new F(V,this.loose));for(var K=0;K<this.set.length;K++)if(be(this.set[K],V))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function(V,K,ee){var $e=null,ye=null;try{var Ne=new fe(K,ee)}catch{return null}return V.forEach(function(Se){Ne.test(Se)&&($e&&ye.compare(Se)!==-1||(ye=new F($e=Se,ee)))}),$e},e.minSatisfying=function(V,K,ee){var $e=null,ye=null;try{var Ne=new fe(K,ee)}catch{return null}return V.forEach(function(Se){Ne.test(Se)&&($e&&ye.compare(Se)!==1||(ye=new F($e=Se,ee)))}),$e},e.validRange=function(V,K){try{return new fe(V,K).range||"*"}catch{return null}},e.ltr=function(V,K,ee){return Me(V,K,"<",ee)},e.gtr=function(V,K,ee){return Me(V,K,">",ee)},e.outside=Me,e.prerelease=function(V,K){var ee=Q(V,K);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,K,ee){return V=new fe(V,ee),K=new fe(K,ee),V.intersects(K)},e.coerce=function(V){if(V instanceof F)return V;if(typeof V!="string")return null;var K=V.match(b[R]);return K==null?null:Q((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,L(1))},function(J,e){var L,D,N=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function b($){if(L===setTimeout)return setTimeout($,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{D=typeof clearTimeout=="function"?clearTimeout:j}catch{D=j}})();var u,c=[],E=!1,O=-1;function m(){E&&u&&(E=!1,u.length?c=u.concat(c):O=-1,c.length&&d())}function d(){if(!E){var $=b(m);E=!0;for(var h=c.length;h;){for(u=c,c=[];++O<h;)u&&u[O].run();O=-1,h=c.length}u=null,E=!1,function(f){if(D===clearTimeout)return clearTimeout(f);if((D===j||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(f);try{D(f)}catch{try{return D.call(null,f)}catch{return D.call(this,f)}}}($)}}function k($,h){this.fun=$,this.array=h}function v(){}N.nextTick=function($){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];c.push(new k($,h)),c.length!==1||E||b(d)},k.prototype.run=function(){this.fun.apply(null,this.array)},N.title="browser",N.browser=!0,N.env={},N.argv=[],N.version="",N.versions={},N.on=v,N.addListener=v,N.once=v,N.off=v,N.removeListener=v,N.removeAllListeners=v,N.emit=v,N.prependListener=v,N.prependOnceListener=v,N.listeners=function($){return[]},N.binding=function($){throw new Error("process.binding is not supported")},N.cwd=function(){return"/"},N.chdir=function($){throw new Error("process.chdir is not supported")},N.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;class D{constructor(b,u,c){this.level=b,this.key=u,this.value=c,this.forward=[]}}const N=void 0;class A{constructor(b,u=2**16){this.comparator=b,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,N,N)}get size(){return this.f}clear(){this.e=new D(this.c,N,N),this.f=0}has(b){return!!A.g(this,b,this.comparator)}get(b){return A.g(this,b,this.comparator)?.value}set(b,u){return A.h(this,b,u,this.comparator)&&(this.f+=1),this}delete(b){const u=A.k(this,b,this.comparator);return u&&(this.f-=1),u}forEach(b,u){let c=this.e.forward[0];for(;c;)b.call(u,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",u=this.e.forward[0];for(;u;)b+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return b}static g(b,u,c){let E=b.e;for(let O=b.d-1;O>=0;O--)for(;E.forward[O]&&c(E.forward[O].key,u)<0;)E=E.forward[O];if(E=E.forward[0],E&&c(E.key,u)===0)return E}static h(b,u,c,E){const O=[];let m=b.e;for(let d=b.d-1;d>=0;d--){for(;m.forward[d]&&E(m.forward[d].key,u)<0;)m=m.forward[d];O[d]=m}if(m=m.forward[0],m&&E(m.key,u)===0)return m.value=c,!1;{const d=A.j(b);if(d>b.d){for(let k=b.d;k<d;k++)O[k]=b.e;b.d=d}m=new D(d,u,c);for(let k=0;k<d;k++)m.forward[k]=O[k].forward[k],O[k].forward[k]=m;return!0}}static j(b,u=.5){let c=1;for(;Math.random()<u&&c<b.c;)c+=1;return c}static k(b,u,c){const E=[];let O=b.e;for(let m=b.d-1;m>=0;m--){for(;O.forward[m]&&c(O.forward[m].key,u)<0;)O=O.forward[m];E[m]=O}if(O=O.forward[0],!O||c(O.key,u)!==0)return!1;for(let m=0;m<b.d&&E[m].forward[m]===O;m++)E[m].forward[m]=O.forward[m];for(;b.d>0&&b.e.forward[b.d-1]===N;)b.d-=1;return!0}}e.$vr=A}),define(ne[45],re([0,1,9,2]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function N(p){const S=p;return S?typeof S.read=="function":!1}e.$Xd=N;function A(p){const S=p;return S?[S.on,S.pause,S.resume,S.destroy].every(s=>typeof s=="function"):!1}e.$Yd=A;function j(p){const S=p;return S?A(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$Zd=j;function b(p,S){return new u(p,S)}e.$1d=b;class u{constructor(S,s){this.e=S,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(s=>s(S))}h(S){this.c.error.length===0?(0,L.$Z)(S):this.c.error.slice(0).forEach(s=>s(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,s){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(S,s){if(this.a.destroyed)return;let o;switch(S){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(s);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(p,S){const s=[];let o;for(;(o=p.read())!==null;)s.push(o);return S(s)}e.$2d=c;function E(p,S,s){const o=[];let t;for(;(t=p.read())!==null&&o.length<s;)o.push(t);return t===null&&o.length>0?S(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return p.read()}}}e.$3d=E;function O(p,S){return new Promise((s,o)=>{const t=[];m(p,{onData:i=>{S&&t.push(i)},onError:i=>{S?o(i):s(void 0)},onEnd:()=>{s(S?S(t):void 0)}})})}e.$4d=O;function m(p,S,s){p.on("error",o=>{s?.isCancellationRequested||S.onError(o)}),p.on("end",()=>{s?.isCancellationRequested||S.onEnd()}),p.on("data",o=>{s?.isCancellationRequested||S.onData(o)})}e.$5d=m;function d(p,S){return new Promise((s,o)=>{const t=new D.$Qc,i=[],n=P=>{if(i.push(P),i.length>S)return t.dispose(),p.pause(),s({stream:p,buffer:i,ended:!1})},r=P=>(t.dispose(),o(P)),l=()=>(t.dispose(),s({stream:p,buffer:i,ended:!0}));t.add((0,D.$Pc)(()=>p.removeListener("error",r))),p.on("error",r),t.add((0,D.$Pc)(()=>p.removeListener("end",l))),p.on("end",l),t.add((0,D.$Pc)(()=>p.removeListener("data",n))),p.on("data",n)})}e.$6d=d;function k(p,S){const s=b(S);return s.end(p),s}e.$7d=k;function v(){const p=b(()=>{throw new Error("not supported")});return p.end(),p}e.$8d=v;function $(p){let S=!1;return{read:()=>S?null:(S=!0,p)}}e.$9d=$;function h(p,S,s){const o=b(s);return m(p,{onData:t=>o.write(S.data(t)),onError:t=>o.error(S.error?S.error(t):t),onEnd:()=>o.end()}),o}e.$0d=h;function f(p,S,s){let o=!1;return{read:()=>{const t=S.read();return o?t:(o=!0,t!==null?s([p,t]):p)}}}e.$$d=f;function I(p,S,s){let o=!1;const t=b(s);return m(S,{onData:i=>o?t.write(i):(o=!0,t.write(s([p,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(p)),t.end()}}),t}e.$_d=I}),define(ne[14],re([0,1,164,45]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const N=typeof Buffer<"u",A=new L.$U(()=>new Uint8Array(256));let j,b;class u{static alloc(R){return N?new u(Buffer.allocUnsafe(R)):new u(new Uint8Array(R))}static wrap(R){return N&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new u(R)}static fromString(R,W){return!(W?.dontUseNodeBuffer||!1)&&N?new u(Buffer.from(R)):(j||(j=new TextEncoder),new u(j.encode(R)))}static fromByteArray(R){const W=u.alloc(R.length);for(let _=0,Y=R.length;_<Y;_++)W.buffer[_]=R[_];return W}static concat(R,W){if(typeof W>"u"){W=0;for(let ue=0,te=R.length;ue<te;ue++)W+=R[ue].byteLength}const _=u.alloc(W);let Y=0;for(let ue=0,te=R.length;ue<te;ue++){const ae=R[ue];_.set(ae,Y),Y+=ae.byteLength}return _}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=u.alloc(this.byteLength);return R.set(this),R}toString(){return N?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(R,W){return new u(this.buffer.subarray(R,W))}set(R,W){if(R instanceof u)this.buffer.set(R.buffer,W);else if(R instanceof Uint8Array)this.buffer.set(R,W);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),W);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),W);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return m(this.buffer,R)}writeUInt32BE(R,W){d(this.buffer,R,W)}readUInt32LE(R){return k(this.buffer,R)}writeUInt32LE(R,W){v(this.buffer,R,W)}readUInt8(R){return $(this.buffer,R)}writeUInt8(R,W){h(this.buffer,R,W)}indexOf(R,W=0){return c(this.buffer,R instanceof u?R.buffer:R,W)}}e.$ae=u;function c(w,R,W=0){const _=R.byteLength,Y=w.byteLength;if(_===0)return 0;if(_===1)return w.indexOf(R[0]);if(_>Y-W)return-1;const ue=A.value;ue.fill(R.length);for(let ie=0;ie<R.length;ie++)ue[R[ie]]=R.length-ie-1;let te=W+R.length-1,ae=te,le=-1;for(;te<Y;)if(w[te]===R[ae]){if(ae===0){le=te;break}te--,ae--}else te+=Math.max(R.length-ae,ue[w[te]]),ae=R.length-1;return le}e.$be=c;function E(w,R){return w[R+0]<<0>>>0|w[R+1]<<8>>>0}e.$ce=E;function O(w,R,W){w[W+0]=R&255,R=R>>>8,w[W+1]=R&255}e.$de=O;function m(w,R){return w[R]*2**24+w[R+1]*2**16+w[R+2]*2**8+w[R+3]}e.$ee=m;function d(w,R,W){w[W+3]=R,R=R>>>8,w[W+2]=R,R=R>>>8,w[W+1]=R,R=R>>>8,w[W]=R}e.$fe=d;function k(w,R){return w[R+0]<<0>>>0|w[R+1]<<8>>>0|w[R+2]<<16>>>0|w[R+3]<<24>>>0}e.$ge=k;function v(w,R,W){w[W+0]=R&255,R=R>>>8,w[W+1]=R&255,R=R>>>8,w[W+2]=R&255,R=R>>>8,w[W+3]=R&255}e.$he=v;function $(w,R){return w[R]}e.$ie=$;function h(w,R,W){w[W]=R}e.$je=h;function f(w){return D.$2d(w,R=>u.concat(R))}e.$ke=f;function I(w){return D.$9d(w)}e.$le=I;function p(w){return D.$4d(w,R=>u.concat(R))}e.$me=p;async function S(w){return w.ended?u.concat(w.buffer):u.concat([...w.buffer,await p(w.stream)])}e.$ne=S;function s(w){return D.$7d(w,R=>u.concat(R))}e.$oe=s;function o(w){return D.$0d(w,{data:R=>typeof R=="string"?u.fromString(R):u.wrap(R)},R=>u.concat(R))}e.$pe=o;function t(w){return D.$1d(R=>u.concat(R),w)}e.$qe=t;function i(w,R){return D.$$d(w,R,W=>u.concat(W))}e.$re=i;function n(w,R){return D.$_d(w,R,W=>u.concat(W))}e.$se=n;function r(w){let R=0,W=0,_=0;const Y=new Uint8Array(Math.floor(w.length/4*3)),ue=ae=>{switch(W){case 3:Y[_++]=R|ae,W=0;break;case 2:Y[_++]=R|ae>>>2,R=ae<<6,W=3;break;case 1:Y[_++]=R|ae>>>4,R=ae<<4,W=2;break;default:R=ae<<2,W=1}};for(let ae=0;ae<w.length;ae++){const le=w.charCodeAt(ae);if(le>=65&&le<=90)ue(le-65);else if(le>=97&&le<=122)ue(le-97+26);else if(le>=48&&le<=57)ue(le-48+52);else if(le===43||le===45)ue(62);else if(le===47||le===95)ue(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${w[ae]}`)}}const te=_;for(;W>0;)ue(0);return u.wrap(Y).slice(0,te)}e.$te=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:w},R=!0,W=!1){const _=W?P:l;let Y="";const ue=w.byteLength%3;let te=0;for(;te<w.byteLength-ue;te+=3){const ae=w[te+0],le=w[te+1],ie=w[te+2];Y+=_[ae>>>2],Y+=_[(ae<<4|le>>>4)&63],Y+=_[(le<<2|ie>>>6)&63],Y+=_[ie&63]}if(ue===1){const ae=w[te+0];Y+=_[ae>>>2],Y+=_[ae<<4&63],R&&(Y+="==")}else if(ue===2){const ae=w[te+0],le=w[te+1];Y+=_[ae>>>2],Y+=_[(ae<<4|le>>>4)&63],Y+=_[le<<2&63],R&&(Y+="=")}return Y}e.$ue=y}),define(ne[41],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=void 0;function D(h){return N(h,0)}e.$Bi=D;function N(h,f){switch(typeof h){case"object":return h===null?A(349,f):Array.isArray(h)?u(h,f):c(h,f);case"string":return b(h,f);case"boolean":return j(h,f);case"number":return A(h,f);case"undefined":return A(937,f);default:return A(617,f)}}e.$Ci=N;function A(h,f){return(f<<5)-f+h|0}e.$Di=A;function j(h,f){return A(h?433:863,f)}function b(h,f){f=A(149417,f);for(let I=0,p=h.length;I<p;I++)f=A(h.charCodeAt(I),f);return f}e.$Ei=b;function u(h,f){return f=A(104579,f),h.reduce((I,p)=>N(p,I),f)}function c(h,f){return f=A(181387,f),Object.keys(h).sort().reduce((I,p)=>(I=b(p,I),N(h[p],I)),f)}class E{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=N(f,this.g),this.g}}e.$Fi=E;var O;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function m(h,f,I=32){const p=I-f,S=~((1<<p)-1);return(h<<f|(S&h)>>>p)>>>0}function d(h,f=0,I=h.byteLength,p=0){for(let S=0;S<I;S++)h[f+S]=p}function k(h,f,I="0"){for(;h.length<f;)h=I+h;return h}function v(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(I=>I.toString(16).padStart(2,"0")).join(""):k((h>>>0).toString(16),f/4)}e.$Gi=v;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const I=f.length;if(I===0)return;const p=this.p;let S=this.r,s=this.u,o,t;for(s!==0?(o=s,t=-1,s=0):(o=f.charCodeAt(0),t=0);;){let i=o;if(L.$5e(o))if(t+1<I){const n=f.charCodeAt(t+1);L.$6e(n)?(t++,i=L.$7e(o,n)):i=65533}else{s=o;break}else L.$6e(o)&&(i=65533);if(S=this.w(p,S,i),t++,t<I)o=f.charCodeAt(t);else break}this.r=S,this.u=s}w(f,I,p){return p<128?f[I++]=p:p<2048?(f[I++]=192|(p&1984)>>>6,f[I++]=128|(p&63)>>>0):p<65536?(f[I++]=224|(p&61440)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0):(f[I++]=240|(p&1835008)>>>18,f[I++]=128|(p&258048)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0),I>=64&&(this.y(),I-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=$.g,I=this.q;for(let l=0;l<64;l+=4)f.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)f.setUint32(l,m(f.getUint32(l-12,!1)^f.getUint32(l-32,!1)^f.getUint32(l-56,!1)^f.getUint32(l-64,!1),1),!1);let p=this.h,S=this.l,s=this.m,o=this.n,t=this.o,i,n,r;for(let l=0;l<80;l++)l<20?(i=S&s|~S&o,n=1518500249):l<40?(i=S^s^o,n=1859775393):l<60?(i=S&s|S&o|s&o,n=2400959708):(i=S^s^o,n=3395469782),r=m(p,5)+i+t+n+f.getUint32(l*4,!1)&4294967295,t=o,o=s,s=m(S,30),S=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+S&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.$Hi=$}),define(ne[54],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(N){N[N.Ignore=0]="Ignore",N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(D||(D={})),function(N){const A="error",j="warning",b="warn",u="info",c="ignore";function E(m){return m?L.$1e(A,m)?N.Error:L.$1e(j,m)||L.$1e(b,m)?N.Warning:L.$1e(u,m)?N.Info:N.Ignore:N.Ignore}N.fromValue=E;function O(m){switch(m){case N.Error:return A;case N.Warning:return j;case N.Info:return u;default:return c}}N.toString=O}(D||(D={})),e.default=D}),define(ne[30],re([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=void 0;function D(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([I,p])=>{f[I]=p&&typeof p=="object"?D(p):p}),f}e.$3m=D;function N(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const I=f.shift();Object.freeze(I);for(const p in I)if(A.call(I,p)){const S=I[p];typeof S=="object"&&!Object.isFrozen(S)&&!(0,L.$Af)(S)&&f.push(S)}}return h}e.$4m=N;const A=Object.prototype.hasOwnProperty;function j(h,f){return b(h,f,new Set)}e.$5m=j;function b(h,f,I){if((0,L.$Gf)(h))return h;const p=f(h);if(typeof p<"u")return p;if(Array.isArray(h)){const S=[];for(const s of h)S.push(b(s,f,I));return S}if((0,L.$zf)(h)){if(I.has(h))throw new Error("Cannot clone recursive data-structure");I.add(h);const S={};for(const s in h)A.call(h,s)&&(S[s]=b(h[s],f,I));return I.delete(h),S}return h}function u(h,f,I=!0){return(0,L.$zf)(h)?((0,L.$zf)(f)&&Object.keys(f).forEach(p=>{p in h?I&&((0,L.$zf)(h[p])&&(0,L.$zf)(f[p])?u(h[p],f[p],I):h[p]=f[p]):h[p]=f[p]}),h):f}e.$6m=u;function c(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let I,p;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(I=0;I<h.length;I++)if(!c(h[I],f[I]))return!1}else{const S=[];for(p in h)S.push(p);S.sort();const s=[];for(p in f)s.push(p);if(s.sort(),!c(S,s))return!1;for(I=0;I<S.length;I++)if(!c(h[S[I]],f[S[I]]))return!1}return!0}e.$7m=c;function E(h){const f=new Set;return JSON.stringify(h,(I,p)=>{if((0,L.$zf)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.$8m=E;function O(h,f){const I=Object.create(null);return!h||!f||Object.keys(f).forEach(S=>{const s=h[S],o=f[S];c(s,o)||(I[S]=o)}),I}e.$9m=O;function m(h,f){const I=f.toLowerCase(),p=Object.keys(h).find(S=>S.toLowerCase()===I);return p?h[p]:h[f]}e.$0m=m;function d(h,f){const I=Object.create(null);for(const[p,S]of Object.entries(h))f(p,S)&&(I[p]=S);return I}e.$$m=d;function k(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.$_m=k;function v(h){const f=[];for(const I of k(h))typeof h[I]=="function"&&f.push(I);return f}e.$an=v;function $(h,f){const I=S=>function(){const s=Array.prototype.slice.call(arguments,0);return f(S,s)},p={};for(const S of h)p[S]=I(S);return p}e.$bn=$}),define(ne[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(N){return L.test(N)}e.$cg=D,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let N;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?N=crypto.getRandomValues.bind(crypto):N=function(b){for(let u=0;u<b.length;u++)b[u]=Math.floor(Math.random()*256);return b};const A=new Uint8Array(16),j=[];for(let b=0;b<256;b++)j.push(b.toString(16).padStart(2,"0"));return function(){N(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,c="";return c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c}}()}),define(ne[74],re([0,1,33]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function N(j){const b=j.replace(/\-/g,":").toLowerCase();return!D.has(b)}function A(){const j=(0,L.networkInterfaces)();for(const b in j){const u=j[b];if(u){for(const{mac:c}of u)if(N(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Nm=A}),define(ne[75],re([0,1,33,46,28,74]),function(J,e,L,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=void 0,e.$Om=new class{c(c){return this.a||(this.a=D.$Th.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(c)}value(){if(this.b===void 0){let c=0,E=0;const O=(0,L.networkInterfaces)();for(const m in O){const d=O[m];if(d)for(const{mac:k,internal:v}of d)v||(E+=1,this.c(k.toUpperCase())&&(c+=1))}this.b=E>0?c/E:0}return this.b}};let j;async function b(c){return j||(j=(async()=>await u(c)||N.$dg())()),j}e.$Pm=b;async function u(c){try{const E=await new Promise((m,d)=>{J(["crypto"],m,d)}),O=(0,A.$Nm)();return E.createHash("sha256").update(O,"utf8").digest("hex")}catch(E){c(E);return}}}),define(ne[76],re([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[77],re([0,1,76]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=void 0;const D=60,N=D*60,A=N*24,j=A*7,b=A*30,u=A*365;function c(O,m,d,k){typeof O!="number"&&(O=O.getTime());const v=Math.round((new Date().getTime()-O)/1e3);if(v<-30)return(0,L.localize)(0,null,c(new Date().getTime()+v*1e3,!1));if(!k&&v<30)return(0,L.localize)(1,null);let $;return v<D?($=v,m?$===1?d?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):d?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?d?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):d?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):v<N?($=Math.floor(v/D),m?$===1?d?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):d?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?d?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):d?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):v<A?($=Math.floor(v/N),m?$===1?d?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):d?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?d?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):d?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):v<j?($=Math.floor(v/A),m?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):v<b?($=Math.floor(v/j),m?$===1?d?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):d?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?d?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):d?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):v<u?($=Math.floor(v/b),m?$===1?d?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):d?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?d?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):d?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(v/u),m?$===1?d?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):d?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?d?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):d?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$am=c;function E(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$bm=E}),define(ne[78],re([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,78]),function(J,e,L,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function A(O,m){return m&&(O.stack||O.stacktrace)?N.localize(0,null,b(O),j(O.stack)||j(O.stacktrace)):b(O)}function j(O){return Array.isArray(O)?O.join(`
`):O}function b(O){return O.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${O.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof O.code=="string"&&typeof O.errno=="number"&&typeof O.syscall=="string"?N.localize(1,null,O.message):O.message||N.localize(2,null)}function u(O=null,m=!1){if(!O)return N.localize(3,null);if(Array.isArray(O)){const d=L.$Gb(O),k=u(d[0],m);return d.length>1?N.localize(4,null,k,d.length):k}if(D.$xf(O))return O;if(O.detail){const d=O.detail;if(d.error)return A(d.error,m);if(d.exception)return A(d.exception,m)}return O.stack?A(O,m):O.message?O.message:N.localize(5,null)}e.$yi=u;function c(O){const m=O;return m instanceof Error&&Array.isArray(m.actions)}e.$zi=c;function E(O,m){let d;return typeof O=="string"?d=new Error(O):d=O,d.actions=m,d}e.$Ai=E}),define(ne[79],re([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],re([0,1,79]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;function D(N){switch(N){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$tp=D}),define(ne[55],re([0,1,13]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=e.TerminateResponseCode=e.Source=void 0;var D;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(D||(e.Source=D={}));var N;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(N||(e.TerminateResponseCode=N={}));function A(b,...u){const c=u.reduce((m,d)=>(m[d]=!0,m),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!c[m]).forEach(m=>{for(let d=0;d<E.length;d++)if(m.search(E[d])!==-1){delete b[m];break}})}e.$wl=A;function j(b){b&&(delete b.DEBUG,L.$k&&delete b.DYLD_LIBRARY_PATH,L.$l&&delete b.LD_PRELOAD)}e.$xl=j}),define(ne[81],re([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Wp=e.$Vp=e.$Up=void 0;function D(c){const E=c;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.$Up=D;function N(c){const E=[];let O;try{const m=JSON.parse(c.arguments),d=m[m.length-1];d&&d.__$stack&&(m.pop(),O=d.__$stack),E.push(...m)}catch{E.push("Unable to log remote console arguments",c.arguments)}return{args:E,stack:O}}e.$Vp=N;function A(c){if(typeof c!="string")return A(N(c).stack);const E=c;if(E){const O=j(E),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(m&&m.length===4)return{uri:L.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$Wp=A;function j(c){if(!c)return c;const E=c.indexOf(`
`);return E===-1?c:c.substring(0,E)}function b(c,E){const{args:O,stack:m}=N(c),d=typeof O[0]=="string"&&O.length===1;let k=j(m);k&&(k=`(${k.trim()})`);let v=[];if(typeof O[0]=="string"?k&&d?v=[`%c[${E}] %c${O[0]} %c${k}`,u("blue"),u(""),u("grey")]:v=[`%c[${E}] %c${O[0]}`,u("blue"),u(""),...O.slice(1)]:v=[`%c[${E}]%`,u("blue"),...O],k&&!d&&v.push(k),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,v)}e.log=b;function u(c){return`color: ${c}`}}),define(ne[47],re([0,1,14,11]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function N(u){return JSON.stringify(u,j)}e.$ih=N;function A(u){let c=JSON.parse(u);return c=b(c),c}e.$jh=A;function j(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function b(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof L.$ae||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let E=0;E<u.length;++E)u[E]=b(u[E],c+1);else for(const E in u)Object.hasOwnProperty.call(u,E)&&(u[E]=b(u[E],c+1))}return u}e.$kh=b}),define(ne[82],re([0,1,70,15,13,11]),function(J,e,L,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hC=void 0;class j{constructor(m,d,k){this.id=m,this.dependencies=d,this.callback=k}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,d,k)=>{typeof m!="string"&&(k=d,d=m,m=null),(typeof d!="object"||!Array.isArray(d))&&(k=d,d=null),this.c.push(new j(m,d,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const d=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!d)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(m){return new Promise((d,k)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const $=()=>{v.removeEventListener("load",h),v.removeEventListener("error",f)},h=I=>{$(),d(this.c.pop())},f=I=>{$(),k(I)};v.addEventListener("load",h),v.addEventListener("error",f),this.f&&(m=this.f.createScriptURL(m)),v.setAttribute("src",m),document.getElementsByTagName("head")[0].appendChild(v)})}i(m){return new Promise((d,k)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),d(this.c.pop())}catch(v){k(v)}})}async j(m){try{const d=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(m).fsPath,h=d.readFileSync($).toString(),f=v.wrap(h.replace(/^#!.*/,""));return new k.Script(f).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const u=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function E(O,m,d){if(L.$S){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[O]&&(O=c[O]);const k=`${O}/${m}`;if(u.has(k))return u.get(k);let v;if(/^\w[\w\d+.-]*:\/\//.test(k))v=k;else{const I=`${d&&!N.$p?D.$$f:D.$0f}/${k}`;v=D.$bg.asBrowserUri(I).toString(!0)}const $=b.INSTANCE.load(v);return u.set(k,$),$}else return await new Promise((k,v)=>{J([O],k,v)})}e.$hC=E}),define(ne[83],re([0,1,33,16,24]),function(J,e,L,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=void 0;const A=/^\d+$/,j=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class O{constructor(S,s,o){this.exePath=S,this.displayName=s,this.a=o}async exists(){return this.a===void 0&&(this.a=await N.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:p=!1}={}){return p?c===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:p=!1,findPreview:S=!1}={}){const s=m({useAlternateBitness:p});if(!s)return null;const o=D.$ic(s,"PowerShell");if(!await N.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const l of await N.Promises.readdir(o)){let P=-1;if(S){const w=l.indexOf("-");if(w<0)continue;const R=l.substring(0,w);if(!A.test(R)||l.substring(w+1)!=="preview")continue;P=parseInt(R,10)}else{if(!A.test(l))continue;P=parseInt(l,10)}if(P<=t)continue;const y=D.$ic(o,l,"pwsh.exe");await N.SymlinkSupport.existsFile(y)&&(i=y,t=P)}if(!i)return null;const n=s.includes("x86")?" (x86)":"",r=S?" Preview":"";return new O(i,`PowerShell${r}${n}`,!0)}async function k({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const S=D.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await N.SymlinkSupport.existsDirectory(S))return null;const{pwshMsixDirRegex:s,pwshMsixName:o}=p?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const t of await N.Promises.readdir(S))if(s.test(t)){const i=D.$ic(S,t,"pwsh.exe");return new O(i,o)}return null}function v(){const p=D.$ic(L.homedir(),".dotnet","tools","pwsh.exe");return new O(p,".NET Core PowerShell Global Tool")}function $(){const p=D.$ic(process.env.windir,c===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(p,"Windows PowerShell",!0)}async function*h(){let p=await d();p&&(yield p),p=await d({useAlternateBitness:!0}),p&&(yield p),p=await k(),p&&(yield p),p=v(),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await k({findPreview:!0}),p&&(yield p),p=await d({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=$(),p&&(yield p)}async function*f(){for await(const p of h())await p.exists()&&(yield p)}e.$ul=f;async function I(){for await(const p of f())return p;return null}e.$vl=I}),define(ne[56],re([0,1,16,13,35,55,3,24]),function(J,e,L,D,N,A,j,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$zl=e.$yl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(O=N.env){return O.comspec||"cmd.exe"}e.$yl=u;function c(O){let m=[],d=!1;const k=function(v){if(d){m.push(v);return}(!O.send(v,h=>{if(h&&console.error(h),d=!1,m.length>0){const f=m.slice(0);m=[],f.forEach(I=>k(I))}})||D.$j)&&(d=!0)};return{send:k}}e.$zl=c;var E;(function(O){async function m(d,k,v){if(L.$hc(d))return d;if(k===void 0&&(k=N.cwd()),L.$lc(d)!=="."||(v===void 0&&j.$xf(N.env.PATH)&&(v=N.env.PATH.split(L.$sc)),v===void 0||v.length===0))return L.$ic(k,d);async function h(f){if(await b.Promises.exists(f)){let I;try{I=await b.Promises.stat(f)}catch(p){p.message.startsWith("EACCES")&&(I=await b.Promises.lstat(f))}return I?!I.isDirectory():!1}return!1}for(const f of v){let I;if(L.$hc(f)?I=L.$ic(f,d):I=L.$ic(k,f,d),await h(I))return I;let p=I+".com";if(await h(p)||(p=I+".exe",await h(p)))return p}return L.$ic(k,d)}O.findExecutable=m})(E||(e.win32=E={}))}),define(ne[84],re([0,1,33,13,83,56]),function(J,e,L,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0;async function j(O,m){return O===1?D.$j?E():A.$yl(m):u(O,m)}e.$Al=j;let b=null;function u(O,m){if(D.$l&&O===2||D.$k&&O===3)return"/bin/bash";if(!b){let d;if(D.$j)d="/bin/bash";else{if(d=m.SHELL,!d)try{d=(0,L.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}b=d}return b}let c=null;async function E(){return c||(c=(await(0,N.$vl)()).exePath),c}});var pe=this&&this.__decorate||function(J,e,L,D){var N=arguments.length,A=N<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,L,D);else for(var b=J.length-1;b>=0;b--)(j=J[b])&&(A=(N<3?j(A):N>3?j(e,L,A):j(e,L))||A);return N>3&&A&&Object.defineProperty(e,L,A),A};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,47,29,3]),function(J,e,L,D,N,A,j,b,u,c,E,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.ProxyChannel=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.RequestInitiator=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0;var d;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(d||(d={}));function k(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(v||(v={}));function $(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(h||(h={}));function f(T){let U=0;for(let B=0;;B+=7){const Z=T.read(1);if(U|=(Z.buffer[0]&127)<<B,!(Z.buffer[0]&128))return U}}const I=t(0);function p(T,U){if(U===0){T.write(I);return}let B=0;for(let x=U;x!==0;x=x>>>7)B++;const Z=N.$ae.alloc(B);for(let x=0;U!==0;x++)Z.buffer[x]=U&127,U=U>>>7,U>0&&(Z.buffer[x]|=128);T.write(Z)}class S{constructor(U){this.b=U,this.a=0}read(U){const B=this.b.slice(this.a,this.a+U);return this.a+=B.byteLength,B}}e.$lh=S;class s{constructor(){this.a=[]}get buffer(){return N.$ae.concat(this.a)}write(U){this.a.push(U)}}e.$mh=s;var o;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(o||(o={}));function t(T){const U=N.$ae.alloc(1);return U.writeUInt8(T,0),U}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},n=typeof Buffer<"u";function r(T,U){if(typeof U>"u")T.write(i.Undefined);else if(typeof U=="string"){const B=N.$ae.fromString(U);T.write(i.String),p(T,B.byteLength),T.write(B)}else if(n&&Buffer.isBuffer(U)){const B=N.$ae.wrap(U);T.write(i.Buffer),p(T,B.byteLength),T.write(B)}else if(U instanceof N.$ae)T.write(i.VSBuffer),p(T,U.byteLength),T.write(U);else if(Array.isArray(U)){T.write(i.Array),p(T,U.length);for(const B of U)r(T,B)}else if(typeof U=="number"&&(U|0)===U)T.write(i.Uint),p(T,U);else{const B=N.$ae.fromString(JSON.stringify(U));T.write(i.Object),p(T,B.byteLength),T.write(B)}}e.$nh=r;function l(T){switch(T.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return T.read(f(T)).toString();case o.Buffer:return T.read(f(T)).buffer;case o.VSBuffer:return T.read(f(T));case o.Array:{const B=f(T),Z=[];for(let x=0;x<B;x++)Z.push(l(T));return Z}case o.Object:return JSON.parse(T.read(f(T)).toString());case o.Int:return f(T)}}e.$oh=l;class P{constructor(U,B,Z=null,x=1e3){this.h=U,this.j=B,this.k=Z,this.l=x,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(U,B){this.b.set(U,B),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const B=this.o([U.type]);this.k?.logOutgoing(B,0,1,$(U.type));return}case 201:case 202:case 204:case 203:{const B=this.o([U.type,U.id],U.data);this.k?.logOutgoing(B,U.id,1,$(U.type),U.data);return}}}o(U,B=void 0){const Z=new s;return r(Z,U),r(Z,B),this.p(Z.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const B=new S(U),Z=l(B),x=l(B),Q=Z[0];switch(Q){case 100:return this.k?.logIncoming(U.byteLength,Z[1],1,`${k(Q)}: ${Z[2]}.${Z[3]}`,x),this.s({type:Q,id:Z[1],channelName:Z[2],name:Z[3],arg:x});case 102:return this.k?.logIncoming(U.byteLength,Z[1],1,`${k(Q)}: ${Z[2]}.${Z[3]}`,x),this.t({type:Q,id:Z[1],channelName:Z[2],name:Z[3],arg:x});case 101:return this.k?.logIncoming(U.byteLength,Z[1],1,`${k(Q)}`),this.u({type:Q,id:Z[1]});case 103:return this.k?.logIncoming(U.byteLength,Z[1],1,`${k(Q)}`),this.u({type:Q,id:Z[1]})}}s(U){const B=this.b.get(U.channelName);if(!B){this.v(U);return}const Z=new A.$Wd;let x;try{x=B.call(this.j,U.name,U.arg,Z.token)}catch(z){x=Promise.reject(z)}const Q=U.id;x.then(z=>{this.m({id:Q,data:z,type:201})},z=>{z instanceof Error?this.m({id:Q,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:Q,data:z,type:203})}).finally(()=>{F.dispose(),this.d.delete(U.id)});const F=(0,c.$Pc)(()=>Z.cancel());this.d.set(U.id,F)}t(U){const B=this.b.get(U.channelName);if(!B){this.v(U);return}const Z=U.id,Q=B.listen(this.j,U.name,U.arg)(F=>this.m({id:Z,data:F,type:204}));this.d.set(U.id,Q)}u(U){const B=this.d.get(U.id);B&&(B.dispose(),this.d.delete(U.id))}v(U){let B=this.g.get(U.channelName);B||(B=[],this.g.set(U.channelName,B));const Z=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:U,timeoutTimer:Z})}w(U){const B=this.g.get(U);if(B){for(const Z of B)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$ph=P;var y;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class w{constructor(U,B=null){this.l=U,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$Md,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=B}getChannel(U){const B=this;return{call(Z,x,Q){return B.a?Promise.reject(new b.$4):B.m(U,Z,x,Q)},listen(Z,x){return B.a?u.Event.None:B.o(U,Z,x)}}}m(U,B,Z,x=A.CancellationToken.None){const Q=this.g++,z={id:Q,type:100,channelName:U,name:B,arg:Z};if(x.isCancellationRequested)return Promise.reject(new b.$4);let a;return new Promise((M,C)=>{if(x.isCancellationRequested)return C(new b.$4);const X=()=>{const me=de=>{switch(de.type){case 201:this.f.delete(Q),M(de.data);break;case 202:{this.f.delete(Q);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,C(ge);break}case 203:this.f.delete(Q),C(de.data);break}};this.f.set(Q,me),this.p(z)};let H=null;this.b===h.Idle?X():(H=(0,D.$Gg)(me=>this.u()),H.then(()=>{H=null,X()}));const ce=()=>{H?(H.cancel(),H=null):this.p({id:Q,type:101}),C(new b.$4)},oe=x.onCancellationRequested(ce);a=(0,c.$Oc)((0,c.$Pc)(ce),oe),this.d.add(a)}).finally(()=>{a.dispose(),this.d.delete(a)})}o(U,B,Z){const x=this.g++,F={id:x,type:102,channelName:U,name:B,arg:Z};let z=null;const a=new u.$Md({onWillAddFirstListener:()=>{z=(0,D.$Gg)(M=>this.u()),z.then(()=>{z=null,this.d.add(a),this.p(F)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(a),this.p({id:x,type:103}))}}),g=M=>a.fire(M.data);return this.f.set(x,g),a.event}p(U){switch(U.type){case 100:case 102:{const B=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(B,U.id,0,`${k(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const B=this.q([U.type,U.id]);this.j?.logOutgoing(B,U.id,0,k(U.type));return}}}q(U,B=void 0){const Z=new s;return r(Z,U),r(Z,B),this.r(Z.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const B=new S(U),Z=l(B),x=l(B),Q=Z[0];switch(Q){case 200:return this.j?.logIncoming(U.byteLength,0,0,$(Q)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,Z[1],0,$(Q),x),this.t({type:Z[0],id:Z[1],data:x})}}t(U){if(U.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$qh=w,pe([j.$fh],w.prototype,"onDidInitializePromise",null);class R{get connections(){const U=[];return this.f.forEach(B=>U.push(B)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new u.$Md,this.onDidAddConnection=this.g.event,this.h=new u.$Md,this.onDidRemoveConnection=this.h.event,this.j=new c.$Qc,this.j.add(U(({protocol:B,onDidClientDisconnect:Z})=>{const x=u.Event.once(B.onMessage);this.j.add(x(Q=>{const F=new S(Q),z=l(F),a=new P(B,z),g=new w(B);this.a.forEach((C,X)=>a.registerChannel(X,C));const M={channelServer:a,channelClient:g,ctx:z};this.f.add(M),this.g.fire(M),this.j.add(Z(()=>{a.dispose(),g.dispose(),this.f.delete(M),this.h.fire(M)}))}))}))}getChannel(U,B){const Z=this;return{call(x,Q,F){let z;if((0,m.$Lf)(B)){const g=(0,L.$3b)(Z.connections.filter(B));z=g?Promise.resolve(g):u.Event.toPromise(u.Event.filter(Z.onDidAddConnection,B))}else z=B.routeCall(Z,x,Q);const a=z.then(g=>g.channelClient.getChannel(U));return _(a).call(x,Q,F)},listen(x,Q){if((0,m.$Lf)(B))return Z.k(U,B,x,Q);const F=B.routeEvent(Z,x,Q).then(z=>z.channelClient.getChannel(U));return _(F).listen(x,Q)}}}k(U,B,Z,x){const Q=this;let F;const z=new u.$Md({onWillAddFirstListener:()=>{F=new c.$Qc;const a=new u.$Sd,g=new Map,M=X=>{const ce=X.channelClient.getChannel(U).listen(Z,x),oe=a.add(ce);g.set(X,oe)},C=X=>{const H=g.get(X);H&&(H.dispose(),g.delete(X))};Q.connections.filter(B).forEach(M),u.Event.filter(Q.onDidAddConnection,B)(M,void 0,F),Q.onDidRemoveConnection(C,void 0,F),a.event(z.fire,z,F),F.add(a)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return z.event}registerChannel(U,B){this.a.set(U,B);for(const Z of this.f)Z.channelServer.registerChannel(U,B)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$rh=R;class W{constructor(U,B,Z=null){const x=new s;r(x,B),U.send(x.buffer),this.a=new w(U,Z),this.d=new P(U,B,Z)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,B){this.d.registerChannel(U,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$sh=W;function _(T){return{call(U,B,Z){return T.then(x=>x.call(U,B,Z))},listen(U,B){const Z=new u.$Vd;return T.then(x=>Z.input=x.listen(U,B)),Z.event}}}e.$th=_;function Y(T){let U=!1;return{call(B,Z,x){return U?T.call(B,Z,x):(0,D.$Tg)(0).then(()=>U=!0).then(()=>T.call(B,Z,x))},listen(B,Z){if(U)return T.listen(B,Z);const x=new u.$Vd;return(0,D.$Tg)(0).then(()=>U=!0).then(()=>x.input=T.listen(B,Z)),x.event}}}e.$uh=Y;class ue{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const B of U.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await u.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$vh=ue;var te;(function(T){function U(Q,F,z){const a=Q,g=z&&z.disableMarshalling,M=new Map;for(const C in a)Z(C)&&M.set(C,u.Event.buffer(a[C],!0,void 0,F));return new class{listen(C,X,H){const ce=M.get(X);if(ce)return ce;if(x(X)){const oe=a[X];if(typeof oe=="function")return oe.call(a,H)}throw new b.$ab(`Event not found: ${X}`)}call(C,X,H){const ce=a[X];if(typeof ce=="function"){if(!g&&Array.isArray(H))for(let me=0;me<H.length;me++)H[me]=(0,E.$kh)(H[me]);let oe=ce.apply(a,H);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new b.$ab(`Method not found: ${X}`)}}}T.fromService=U;function B(Q,F){const z=F&&F.disableMarshalling;return new Proxy({},{get(a,g){if(typeof g=="string")return F?.properties?.has(g)?F.properties.get(g):x(g)?function(M){return Q.listen(g,M)}:Z(g)?Q.listen(g):async function(...M){let C;F&&!(0,m.$Gf)(F.context)?C=[F.context,...M]:C=M;const X=await Q.call(g,C);return z?X:(0,E.$kh)(X)};throw new b.$ab(`Property not found: ${String(g)}`)}})}T.toService=B;function Z(Q){return Q[0]==="o"&&Q[1]==="n"&&O.$Ze(Q.charCodeAt(2))}function x(Q){return/^onDynamic/.test(Q)&&O.$Ze(Q.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const U=T.toString();if(U!=="[object Object]")return U}return T}function ie(T){return Array.isArray(T)?T.map(le):le(T)}function q(T,U,B,Z,x,Q,F){F=ie(F);const z=ae[x],a=z[Z%z.length];let g=[`%c[${T}]%c[${String(U).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(Q)?(g=g.concat(F),g.push(")")):g.push(F),console.log.apply(console,g)}class G{constructor(U,B){this.d=U,this.f=B,this.a=0,this.b=0}logOutgoing(U,B,Z,x,Q){this.b+=U,q(this.d,this.b,U,B,Z,x,Q)}logIncoming(U,B,Z,x,Q){this.a+=U,q(this.f,this.a,U,B,Z,x,Q)}}e.$wh=G}),define(ne[85],re([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0;class k extends d.$ph{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>N.$ae.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Yp=k;class v{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$Md,this.onDidProcessExit=this.h.event;const I=f&&f.timeout?f.timeout:6e4;this.b=new D.$Pg(I),this.d=null,this.f=null}getChannel(h){const f=this;return{call(I,p,S){return f.k(h,I,p,S)},listen(I,p){return f.l(h,I,p)}}}k(h,f,I,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(b.$5());this.b.cancel();const S=this.n(h),s=(0,D.$Gg)(i=>S.call(f,I,i)),o=p.onCancellationRequested(()=>s.cancel()),t=(0,c.$Pc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(h,f,I){if(!this.b)return u.Event.None;this.b.cancel();let p;const S=new u.$Md({onWillAddFirstListener:()=>{p=this.n(h).listen(f,I)(S.fire,S),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return S.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,E.$3m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,m.$xl)(f.env),this.d=(0,L.fork)(this.i,h,f);const I=new u.$Md;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,j.$Up)(n)){(0,j.log)(n,`IPC Library: ${this.j.serverName}`);return}I.fire(N.$ae.wrap(Buffer.from(n,"base64")))});const S=this.j.useQueue?(0,O.$zl)(this.d):this.d,s=n=>this.d&&this.d.connected&&S.send(n.buffer.toString("base64")),o=I.event,t={send:s,onMessage:o};this.f=new d.$qh(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,c.$Mc)(l)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Zp=v}),define(ne[86],re([0,1,8,4,2,47,3]),function(J,e,L,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.StorageState=e.$Xo=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function u(m){const d=m;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$Xo=u;var c;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(c||(e.StorageState=c={}));class E extends N.$Rc{static{this.a=100}constructor(d,k=Object.create(null)){super(),this.r=d,this.s=k,this.b=this.B(new D.$Pd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$Qg(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((k,v)=>this.w(v,k)),d.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(d,k){if(this.c===c.Closed)return;let v=!1;(0,j.$Gf)(k)?v=this.f.delete(d):this.f.get(d)!==k&&(this.f.set(d,k),v=!0),v&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,k){const v=this.f.get(d);return(0,j.$Gf)(v)?k:v}getBoolean(d,k){const v=this.get(d);return(0,j.$Gf)(v)?k:v==="true"}getNumber(d,k){const v=this.get(d);return(0,j.$Gf)(v)?k:parseInt(v,10)}getObject(d,k){const v=this.get(d);return(0,j.$Gf)(v)?k:(0,A.$jh)(v)}async set(d,k,v=!1){if(this.c===c.Closed)return;if((0,j.$Gf)(k))return this.delete(d,v);const $=(0,j.$zf)(k)||Array.isArray(k)?(0,A.$ih)(k):String(k);if(this.f.get(d)!==$)return this.f.set(d,$),this.j.set(d,$),this.h.delete(d),this.b.fire({key:d,external:v}),this.D()}async delete(d,k=!1){if(!(this.c===c.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:k}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Yo=E;class O{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((k,v)=>this.a.set(v,k)),d.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$Zo=O}),define(ne[87],re([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var N;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(N||(e.TokenType=N={}));function A(...c){switch(c.length){case 1:return(0,D.localize)(0,null,c[0]);case 2:return(0,D.localize)(1,null,c[0],c[1]);case 3:return(0,D.localize)(2,null,c[0],c[1],c[2]);default:return}}const j=(0,D.localize)(3,null),b=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return E.isTripleEq?"===":"==";case 4:return E.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,L.$7)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const O=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:O})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const O=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:O})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const O=this.d,m=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:m};this.g.push({offset:O,lexeme:m,additionalInfo:E}),this.f.push(d)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const O=this.c.substring(this.d,this.e),m=u.b.get(O);m?this.k(m):this.f.push({type:17,lexeme:O,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,O=!1,m=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(b);return}const k=this.c.charCodeAt(E);if(O)O=!1;else if(k===47&&!m){E++;break}else k===91?m=!0:k===92?O=!0:k===93&&(m=!1);E++}for(;E<this.c.length&&u.a.has(this.c.charCodeAt(E));)E++;this.e=E;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=u}),define(ne[109],re([0,1,77,52,15,16,35,17,11]),function(J,e,L,D,N,A,j,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.$lc)(N.$bg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$ic)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,b.$ug)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,b.$ug)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,L.$bm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ic)(this.userDataPath,"logs",d)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.$ug)(u.URI.file((0,A.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.$ug)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.$ug)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.$ug)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=j.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$ic)(d,"argv.json")):(0,b.$ug)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.$jc)(d):(0,A.$gc)((0,A.$ic)(N.$bg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?u.URI.file((0,A.$jc)(d)):u.URI.file((0,A.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.$jc)(d);const k=j.env.VSCODE_EXTENSIONS;if(k)return k;const v=j.env.VSCODE_PORTABLE;return v?(0,A.$ic)(v,"extensions"):(0,b.$ug)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(k=>/^[^:/?#]+?:\/\//.test(k)?u.URI.parse(k):u.URI.file((0,A.$gc)(k)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,A.$gc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$cm.test(d))}get extensionLogLevel(){const d=[];for(const k of this.args.log||[]){const v=e.$cm.exec(k);v&&v[1]&&v[2]&&d.push([v[1],v[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,b.$ug)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=j.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$ic)(d,"policy.json")):(0,b.$ug)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,k,v){this.a=d,this.b=k,this.c=v,this.editSessionId=this.args.editSessionId}}e.$dm=c,pe([D.$fh],c.prototype,"appRoot",null),pe([D.$fh],c.prototype,"userHome",null),pe([D.$fh],c.prototype,"userDataPath",null),pe([D.$fh],c.prototype,"appSettingsHome",null),pe([D.$fh],c.prototype,"tmpDir",null),pe([D.$fh],c.prototype,"cacheHome",null),pe([D.$fh],c.prototype,"stateResource",null),pe([D.$fh],c.prototype,"userRoamingDataHome",null),pe([D.$fh],c.prototype,"userDataSyncHome",null),pe([D.$fh],c.prototype,"sync",null),pe([D.$fh],c.prototype,"machineSettingsResource",null),pe([D.$fh],c.prototype,"workspaceStorageHome",null),pe([D.$fh],c.prototype,"localHistoryHome",null),pe([D.$fh],c.prototype,"keyboardLayoutResource",null),pe([D.$fh],c.prototype,"argvResource",null),pe([D.$fh],c.prototype,"isExtensionDevelopment",null),pe([D.$fh],c.prototype,"untitledWorkspacesHome",null),pe([D.$fh],c.prototype,"builtinExtensionsPath",null),pe([D.$fh],c.prototype,"extensionsPath",null),pe([D.$fh],c.prototype,"extensionDevelopmentLocationURI",null),pe([D.$fh],c.prototype,"extensionDevelopmentKind",null),pe([D.$fh],c.prototype,"extensionTestsLocationURI",null),pe([D.$fh],c.prototype,"debugExtensionHost",null),pe([D.$fh],c.prototype,"logLevel",null),pe([D.$fh],c.prototype,"extensionLogLevel",null),pe([D.$fh],c.prototype,"serviceMachineIdResource",null),pe([D.$fh],c.prototype,"disableTelemetry",null),pe([D.$fh],c.prototype,"disableWorkspaceTrust",null),pe([D.$fh],c.prototype,"useInMemorySecretStorage",null),pe([D.$fh],c.prototype,"policyFile",null);function E(m,d){return O(m["inspect-extensions"],m["inspect-brk-extensions"],5870,d,m.debugId,m.extensionEnvironment)}e.$em=E;function O(m,d,k,v,$,h){const I=Number(d||m)||(v?null:k),p=I?!!d:!1;let S;if(h)try{S=JSON.parse(h)}catch{}return{port:I,break:p,debugId:$,env:S}}e.$fm=O}),function(){"use strict";function J(e,L,D){function N(j,b){const u=A(j,b),c=[u];return e.isAbsolute(u)||c.unshift(D),e.resolve(...c)}function A(j,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,b);const E=j["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(O,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,b)}return{getUserDataPath:N}}if(typeof define=="function")define(ne[110],re([165,33,35]),function(e,L,D){return J(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,33,109,110]),function(J,e,L,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=void 0;class A extends D.$dm{constructor(c,E){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,N.getUserDataPath)(c,E.nameShort)},E)}}e.$gm=A;function j(u,c){return(0,D.$fm)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}e.$hm=j;function b(u,c){return(0,D.$fm)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}e.$im=b}),define(ne[112],re([0,1,3,94]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;function N(j,b,u,c){try{A(j,b,u,c)}catch(E){j.error(E?.message??E)}return b}e.$up=N;function A(j,b,u,c){const E=(O,m,d)=>{const k=O[m];if((0,L.$xf)(k)){const v=k,$=v.length;if($>1&&v[0]==="%"&&v[$-1]==="%"){const h=v.substr(1,$-2);let f=u[h];f===void 0&&c&&(f=c[h]);const I=typeof f=="string"?f:f?.message,p=c?.[h],S=typeof p=="string"?p:p?.message;if(!I){S||j.warn(`[${b.name}]: ${(0,D.localize)(0,null,h)}`);return}if(d&&(m==="title"||m==="category")&&S&&S!==I){const s={value:I,original:S};O[m]=s}else O[m]=I}}else if((0,L.$zf)(k))for(const v in k)k.hasOwnProperty(v)&&(v==="commands"?E(k,v,!0):E(k,v,d));else if(Array.isArray(k))for(let v=0;v<k.length;v++)E(k,v,d)};for(const O in b)b.hasOwnProperty(O)&&E(b,O)}}),define(ne[48],re([0,1,17,54,98,42]),function(J,e,L,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=void 0;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function u(h){return h=h.trim(),h==="*"||j.test(h)}e.$Io=u;function c(h){if(!u(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(j);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$Jo=c;function E(h){if(!h)return null;const f=h.majorBase,I=h.majorMustEqual,p=h.minorBase;let S=h.minorMustEqual;const s=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(f===0||(S=!1),o=!1);let t=0;if(h.preRelease){const i=b.exec(h.preRelease);if(i){const[,n,r,l]=i;t=Date.UTC(Number(n),Number(r)-1,Number(l))}}return{majorBase:f,majorMustEqual:I,minorBase:p,minorMustEqual:S,patchBase:s,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:t}}e.$Ko=E;function O(h,f,I){let p;typeof h=="string"?p=E(c(h)):p=h;let S;f instanceof Date?S=f.getTime():typeof f=="string"&&(S=new Date(f).getTime());let s;if(typeof I=="string"?s=E(c(I)):s=I,!p||!s)return!1;const o=p.majorBase,t=p.minorBase,i=p.patchBase;let n=s.majorBase,r=s.minorBase,l=s.patchBase;const P=s.notBefore;let y=s.majorMustEqual,w=s.minorMustEqual,R=s.patchMustEqual;return s.isMinimum?o>n?!0:o<n?!1:t>r?!0:t<r||S&&S<P?!1:i>=l:(o===1&&n===0&&(!y||!w||!R)&&(n=1,r=0,l=0,y=!0,w=!1,R=!1),o<n?!1:o>n?!y:t<r?!1:t>r?!w:i<l?!1:i>l?!R:!(S&&S<P))}e.$Lo=O;function m(h,f,I,p,S){const s=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return s.push([D.default.Error,N.localize(0,null)]),s;if(typeof p.name!="string")return s.push([D.default.Error,N.localize(1,null,"name")]),s;if(typeof p.version!="string")return s.push([D.default.Error,N.localize(2,null,"version")]),s;if(!p.engines)return s.push([D.default.Error,N.localize(3,null,"engines")]),s;if(typeof p.engines.vscode!="string")return s.push([D.default.Error,N.localize(4,null,"engines.vscode")]),s;if(typeof p.extensionDependencies<"u"&&!$(p.extensionDependencies))return s.push([D.default.Error,N.localize(5,null,"extensionDependencies")]),s;if(typeof p.activationEvents<"u"){if(!$(p.activationEvents))return s.push([D.default.Error,N.localize(6,null,"activationEvents")]),s;if(typeof p.main>"u"&&typeof p.browser>"u")return s.push([D.default.Error,N.localize(7,null,"activationEvents","main","browser")]),s}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&s.push([D.default.Warning,N.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return s.push([D.default.Error,N.localize(9,null,"main")]),s;{const i=(0,L.$ug)(I,p.main);(0,L.$og)(i,I)||s.push([D.default.Warning,N.localize(10,null,i.path,I.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return s.push([D.default.Error,N.localize(11,null,"browser")]),s;{const i=(0,L.$ug)(I,p.browser);(0,L.$og)(i,I)||s.push([D.default.Warning,N.localize(12,null,i.path,I.path)])}}if(!A.valid(p.version))return s.push([D.default.Error,N.localize(13,null)]),s;const o=[];if(!d(h,f,p,S,o))for(const i of o)s.push([D.default.Error,i]);return s}e.$Mo=m;function d(h,f,I,p,S){return p||typeof I.main>"u"&&typeof I.browser>"u"?!0:v(h,f,I.engines.vscode,S)}e.$No=d;function k(h,f,I){return h==="*"||v(f,I,h)}e.$Oo=k;function v(h,f,I,p=[]){const S=E(c(I));if(!S)return p.push(N.localize(14,null,I)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return p.push(N.localize(15,null,I)),!1}else if(!S.majorMustEqual)return p.push(N.localize(16,null,I)),!1;return O(h,f,S)?!0:(p.push(N.localize(17,null,h,I)),!1)}function $(h){if(!Array.isArray(h))return!1;for(let f=0,I=h.length;f<I;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,28]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=void 0;async function N(A,j,b){let u=b&&b.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const E=(await j.readFile(A.serviceMachineIdResource)).value.toString();u=(0,D.$cg)(E)?E:null}catch{u=null}if(!u){u=(0,D.$dg)();try{await j.writeFile(A.serviceMachineIdResource,L.$ae.fromString(u))}catch{}}return b?.store("storage.serviceMachineId",u,-1,1),u}e.$9o=N}),define(ne[49],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class L{constructor(N,A=[],j=!1){this.ctor=N,this.staticArguments=A,this.supportsDelayedInstantiation=j}}e.$Kh=L}),define(ne[114],re([0,1,49]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.InstantiationType=void 0;const D=[];var N;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(N||(e.InstantiationType=N={}));function A(b,u,c){u instanceof L.$Kh||(u=new L.$Kh(u,[],!!c)),D.push([b,u])}e.$tr=A;function j(){return D}e.$ur=j}),define(ne[115],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=void 0;class L{constructor(A,j){this.key=A,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$$p=L;class D{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const j of this.a.values())j.outgoing.size===0&&A.push(j);return A}insertEdge(A,j){const b=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(j);b.outgoing.set(u.key,u),u.incoming.set(b.key,b)}removeNode(A){const j=this.b(A);this.a.delete(j);for(const b of this.a.values())b.outgoing.delete(j),b.incoming.delete(j)}lookupOrInsertNode(A){const j=this.b(A);let b=this.a.get(j);return b||(b=new L(j,A),this.a.set(j,b)),b}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[j,b]of this.a)A.push(`${j}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,j]of this.a){const b=new Set([A]),u=this.c(j,b);if(u)return u}}c(A,j){for(const[b,u]of A.outgoing){if(j.has(b))return[...j,b].join(" -> ");j.add(b);const c=this.c(u,j);if(c)return c;j.delete(b)}}}e.$_p=D}),define(ne[25],re([0,1,3,11,10]),function(J,e,L,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,N.$Nh)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof D.URI)}e.$ii=A;function j(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof D.URI)}e.$ji=j;var b;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function u(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=u;function c(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$li=c;function E(h,f){const I=Object.create(null);for(const p in h)O(I,p,h[p],f);return I}e.$mi=E;function O(h,f,I,p){const S=f.split("."),s=S.pop();let o=h;for(let t=0;t<S.length;t++){const i=S[t];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:p(`Ignoring ${f} as ${S.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[s]=I}catch{p(`Ignoring ${f} as ${S.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${f} as ${S.join(".")} is ${JSON.stringify(o)}`)}e.$ni=O;function m(h,f){const I=f.split(".");d(h,I)}e.$oi=m;function d(h,f){const I=f.shift();if(f.length===0){delete h[I];return}if(Object.keys(h).indexOf(I)!==-1){const p=h[I];typeof p=="object"&&!Array.isArray(p)&&(d(p,f),Object.keys(p).length===0&&delete h[I])}}function k(h,f,I){function p(o,t){let i=o;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const S=f.split("."),s=p(h,S);return typeof s>"u"?I:s}e.$pi=k;function v(h,f,I){Object.keys(f).forEach(p=>{p!=="__proto__"&&(p in h?L.$zf(h[p])&&L.$zf(f[p])?v(h[p],f[p],I):I&&(h[p]=f[p]):h[p]=f[p])})}e.$qi=v;function $(h){return h.replace(/[\[\]]/g,"")}e.$ri=$}),define(ne[116],re([0,1,13,29,108,10,89,9]),function(J,e,L,D,N,A,j,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$k),u.set("isLinux",L.$l),u.set("isWindows",L.$j),u.set("isWeb",L.$p),u.set("isMacNative",L.$k&&!L.$p),u.set("isEdge",L.$H),u.set("isFirefox",L.$F),u.set("isChrome",L.$E),u.set("isSafari",L.$G);function c(z,a){if(u.get(z)!==void 0)throw(0,b.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(z,a)}e.$Ji=c;const E=Object.prototype.hasOwnProperty;var O;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(O||(e.ContextKeyExprType=O={}));const m={regexParsingWithErrorRecovery:!0},d=(0,j.localize)(0,null),k=(0,j.localize)(1,null),v=(0,j.localize)(2,null),$=(0,j.localize)(3,null),h=(0,j.localize)(4,null),f=(0,j.localize)(5,null),I=(0,j.localize)(6,null),p=(0,j.localize)(7,null);class S{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=m){this.k=a,this.d=new N.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const g=this.l();if(!this.E()){const M=this.D(),C=M.type===17?f:void 0;throw this.h.push({message:h,offset:M.offset,lexeme:N.$Ii.getLexeme(M),additionalInfo:C}),S.c}return g}catch(g){if(g!==S.c)throw g;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const g=this.o();a.push(g)}return a.length===1?a[0]:s.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const g=this.s();a.push(g)}return a.length===1?a[0]:s.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const g=this.l();return this.A(1,$),g?.negate()}case 17:return this.z(),W.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const g=this.l();return this.A(1,$),g}case 17:{const g=a.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const X=C.lexeme,H=X.lastIndexOf("/"),ce=H===X.length-1?void 0:this.w(X.substring(H+1));let oe;try{oe=new RegExp(X.substring(1,H),ce)}catch{throw this.B("REGEX",C)}return le.create(g,oe)}switch(C.type){case 10:case 19:{const X=[C.lexeme];this.z();let H=this.D(),ce=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let fe=0;fe<H.lexeme.length;fe++)H.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--}if(ce<0)break;X.push(N.$Ii.getLexeme(H)),this.z(),H=this.D()}const oe=X.join(""),me=oe.lastIndexOf("/"),de=me===oe.length-1?void 0:this.w(oe.substring(me+1));let ge;try{ge=new RegExp(oe.substring(1,me),de)}catch{throw this.B("REGEX",C)}return s.regex(g,ge)}case 18:{const X=C.lexeme;this.z();let H=null;if(!(0,D.$Ae)(X)){const ce=X.indexOf("/"),oe=X.lastIndexOf("/");if(ce!==oe&&ce>=0){const me=X.slice(ce+1,oe),de=X[oe+1]==="i"?"i":"";try{H=new RegExp(me,de)}catch{throw this.B("REGEX",C)}}}if(H===null)throw this.B("REGEX",C);return le.create(g,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const C=this.u();return s.notIn(g,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return s.equals(g,C);switch(C){case"true":return s.has(g);case"false":return s.not(g);default:return s.equals(g,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return s.notEquals(g,C);switch(C){case"true":return s.not(g);case"false":return s.has(g);default:return s.notEquals(g,C)}}case 5:return this.z(),te.create(g,this.u());case 6:return this.z(),ae.create(g,this.u());case 7:return this.z(),Y.create(g,this.u());case 8:return this.z(),ue.create(g,this.u());case 13:return this.z(),s.in(g,this.u());default:return s.has(g)}}case 20:throw this.h.push({message:I,offset:a.offset,lexeme:"",additionalInfo:p}),S.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,g){if(this.C(a))return this.z();throw this.B(g,this.D())}B(a,g,M){const C=(0,j.localize)(8,null,a,N.$Ii.getLexeme(g)),X=g.offset,H=N.$Ii.getLexeme(g);return this.h.push({message:C,offset:X,lexeme:H,additionalInfo:M}),S.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=S;class s{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(a){return l.create(a)}static equals(a,g){return P.create(a,g)}static notEquals(a,g){return R.create(a,g)}static regex(a,g){return le.create(a,g)}static in(a,g){return y.create(a,g)}static notIn(a,g){return w.create(a,g)}static not(a){return W.create(a)}static and(...a){return G.create(a,null,!0)}static or(...a){return T.create(a,null,!0)}static greater(a,g){return Y.create(a,g)}static greaterEquals(a,g){return ue.create(a,g)}static smaller(a,g){return te.create(a,g)}static smallerEquals(a,g){return ae.create(a,g)}static{this.c=new S({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$Li=s;function o(z){const a=new S({regexParsingWithErrorRecovery:!1});return z.map(g=>(a.parse(g),a.lexingErrors.length>0?a.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,j.localize)(9,null,M.additionalInfo):(0,j.localize)(10,null),offset:M.offset,length:M.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}e.$Mi=o;function t(z,a){const g=z?z.substituteConstants():void 0,M=a?a.substituteConstants():void 0;return!g&&!M?!0:!g||!M?!1:g.equals(M)}e.$Ni=t;function i(z,a){return z.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return r.INSTANCE}}e.$Oi=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.$Pi=r;class l{static create(a,g=null){const M=u.get(a);return typeof M=="boolean"?M?r.INSTANCE:n.INSTANCE:new l(a,g)}constructor(a,g){this.key=a,this.c=g,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=u.get(this.key);return typeof a=="boolean"?a?r.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.$Qi=l;class P{static create(a,g,M=null){if(typeof g=="boolean")return g?l.create(a,M):W.create(a,M);const C=u.get(a);return typeof C=="boolean"?g===(C?"true":"false")?r.INSTANCE:n.INSTANCE:new P(a,g,M)}constructor(a,g,M){this.c=a,this.d=g,this.f=M,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:Z(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=u.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?r.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Ri=P;class y{static create(a,g){return new y(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:Z(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.f),M=a.getValue(this.d);return Array.isArray(g)?g.includes(M):typeof M=="string"&&typeof g=="object"&&g!==null?E.call(g,M):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$Si=y;class w{static create(a,g){return new w(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=11,this.c=y.create(a,g)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=w;class R{static create(a,g,M=null){if(typeof g=="boolean")return g?W.create(a,M):l.create(a,M);const C=u.get(a);return typeof C=="boolean"?g===(C?"true":"false")?n.INSTANCE:r.INSTANCE:new R(a,g,M)}constructor(a,g,M){this.c=a,this.d=g,this.f=M,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:Z(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=u.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?n.INSTANCE:r.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Ui=R;class W{static create(a,g=null){const M=u.get(a);return typeof M=="boolean"?M?n.INSTANCE:r.INSTANCE:new W(a,g)}constructor(a,g){this.c=a,this.d=g,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:B(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=u.get(this.c);return typeof a=="boolean"?a?n.INSTANCE:r.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Vi=W;function _(z,a){if(typeof z=="string"){const g=parseFloat(z);isNaN(g)||(z=g)}return typeof z=="string"||typeof z=="number"?a(z):n.INSTANCE}class Y{static create(a,g,M=null){return _(g,C=>new Y(a,C,M))}constructor(a,g,M){this.c=a,this.d=g,this.f=M,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:Z(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Wi=Y;class ue{static create(a,g,M=null){return _(g,C=>new ue(a,C,M))}constructor(a,g,M){this.c=a,this.d=g,this.f=M,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:Z(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Xi=ue;class te{static create(a,g,M=null){return _(g,C=>new te(a,C,M))}constructor(a,g,M){this.c=a,this.d=g,this.f=M,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:Z(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Yi=te;class ae{static create(a,g,M=null){return _(g,C=>new ae(a,C,M))}constructor(a,g,M){this.c=a,this.d=g,this.f=M,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:Z(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Zi=ae;class le{static create(a,g){return new le(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const g=this.f?this.f.source:"",M=a.f?a.f.source:"";return g<M?-1:g>M?1:0}equals(a){if(a.type===this.type){const g=this.f?this.f.source:"",M=a.f?a.f.source:"";return this.d===a.d&&g===M}return!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.d);return this.f?this.f.test(g):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$1i=le;class ie{static create(a){return new ie(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new ie(this.c.map(a))}negate(){return this.c}}e.$2i=ie;function q(z){let a=null;for(let g=0,M=z.length;g<M;g++){const C=z[g].substituteConstants();if(z[g]!==C&&a===null){a=[];for(let X=0;X<g;X++)a[X]=z[X]}a!==null&&(a[g]=C)}return a===null?z:a}class G{static create(a,g,M){return G.d(a,g,M)}constructor(a,g){this.expr=a,this.c=g,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,M=this.expr.length;g<M;g++){const C=i(this.expr[g],a.expr[g]);if(C!==0)return C}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,M=this.expr.length;g<M;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:G.create(a,this.c,!1)}evaluate(a){for(let g=0,M=this.expr.length;g<M;g++)if(!this.expr[g].evaluate(a))return!1;return!0}static d(a,g,M){const C=[];let X=!1;for(const H of a)if(H){if(H.type===1){X=!0;continue}if(H.type===0)return n.INSTANCE;if(H.type===6){C.push(...H.expr);continue}C.push(H)}if(C.length===0&&X)return r.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(i);for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];for(;C.length>1;){const H=C[C.length-1];if(H.type!==9)break;C.pop();const ce=C.pop(),oe=C.length===0,me=T.create(H.expr.map(de=>G.create([de,ce],null,M)),null,oe);me&&(C.push(me),C.sort(i))}if(C.length===1)return C[0];if(M){for(let H=0;H<C.length;H++)for(let ce=H+1;ce<C.length;ce++)if(C[H].negate().equals(C[ce]))return n.INSTANCE;if(C.length===1)return C[0]}return new G(C,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new G(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());this.c=T.create(a,this,!0)}return this.c}}e.$3i=G;class T{static create(a,g,M){return T.d(a,g,M)}constructor(a,g){this.expr=a,this.c=g,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,M=this.expr.length;g<M;g++){const C=i(this.expr[g],a.expr[g]);if(C!==0)return C}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,M=this.expr.length;g<M;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:T.create(a,this.c,!1)}evaluate(a){for(let g=0,M=this.expr.length;g<M;g++)if(this.expr[g].evaluate(a))return!0;return!1}static d(a,g,M){let C=[],X=!1;if(a){for(let H=0,ce=a.length;H<ce;H++){const oe=a[H];if(oe){if(oe.type===0){X=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){C=C.concat(oe.expr);continue}C.push(oe)}}if(C.length===0&&X)return n.INSTANCE;C.sort(i)}if(C.length!==0){if(C.length===1)return C[0];for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];if(M){for(let H=0;H<C.length;H++)for(let ce=H+1;ce<C.length;ce++)if(C[H].negate().equals(C[ce]))return r.INSTANCE;if(C.length===1)return C[0]}return new T(C,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new T(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());for(;a.length>1;){const g=a.shift(),M=a.shift(),C=[];for(const X of F(g))for(const H of F(M))C.push(G.create([X,H],null,!1));a.unshift(T.create(C,null,!1))}this.c=T.create(a,this,!0)}return this.c}}e.$4i=T;class U extends l{static{this.d=[]}static all(){return U.d.values()}constructor(a,g,M){super(a,null),this.f=g,typeof M=="object"?U.d.push({...M,key:a}):M!==!0&&U.d.push({key:a,description:M,type:g!=null?typeof g:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return P.create(this.key,a)}notEqualsTo(a){return R.create(this.key,a)}}e.$5i=U,e.$6i=(0,A.$Nh)("contextKeyService");function B(z,a){return z<a?-1:z>a?1:0}function Z(z,a,g,M){return z<g?-1:z>g?1:a<M?-1:a>M?1:0}function x(z,a){if(z.type===0||a.type===1)return!0;if(z.type===9)return a.type===9?Q(z.expr,a.expr):!1;if(a.type===9){for(const g of a.expr)if(x(z,g))return!0;return!1}if(z.type===6){if(a.type===6)return Q(a.expr,z.expr);for(const g of z.expr)if(x(g,a))return!0;return!1}return z.equals(a)}e.$7i=x;function Q(z,a){let g=0,M=0;for(;g<z.length&&M<a.length;){const C=z[g].cmp(a[M]);if(C<0)return!1;C===0&&g++,M++}return g===z.length}function F(z){return z.type===9?z.expr:[z]}}),define(ne[59],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0,e.$Kn=(0,L.$Nh)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,L.$Nh)("environmentService"),e.$Vh=(0,L.$Oh)(e.$Uh)}),define(ne[21],re([0,1,92,10]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$7n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=void 0,e.$Tn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Un=new RegExp(e.$Tn),e.$Vn="__web_extension",e.$Wn="skipWalkthrough",e.$Xn="extensionsSync",e.$Yn="dependecyOrPackExtensionInstall";function N(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Zn=N;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$1n=A;function j(f,I){switch(f){case 3:return I==="x64"?"win32-x64":I==="ia32"?"win32-ia32":I==="arm64"?"win32-arm64":"unknown";case 2:return I==="x64"?"linux-x64":I==="arm64"?"linux-arm64":I==="arm"?"linux-armhf":"unknown";case"alpine":return I==="x64"?"alpine-x64":I==="arm64"?"alpine-arm64":"unknown";case 1:return I==="x64"?"darwin-x64":I==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$2n=j;function b(f,I){return I==="web"&&!f.includes("web")}e.$3n=b;function u(f,I,p){return b(I,p)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===p?!0:c(p).includes(f)}e.$4n=u;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$5n=c;function E(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$6n=E;var O;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(O||(e.SortBy=O={}));var m;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var d;(function(f){f.Install="install",f.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var k;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(k||(e.InstallOperation=k={})),e.$7n=(0,D.$Nh)("extensionGalleryService");var v;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var $;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class h extends Error{constructor(I,p){super(I),this.code=p,this.name=p}}e.$8n=h,e.$9n=(0,D.$Nh)("extensionManagementService"),e.$0n="extensionsIdentifiers/disabled",e.$$n="extensionsIdentifiers/enabled",e.$_n=(0,D.$Nh)("IGlobalExtensionEnablementService"),e.$ao=(0,D.$Nh)("IExtensionTipsService"),e.$bo=(0,L.localize)(0,null),e.$co={value:e.$bo,original:"Extensions"},e.$do={value:(0,L.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=void 0,e.$bp=(0,L.$Nh)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((A,j)=>J(["node-vsce-sign"],async b=>A(b),j))),this.a}async verify(A,j,b){let u;try{u=await this.b()}catch{return!1}return u.verify(A,j,b)}}e.$cp=D}),define(ne[61],re([0,1,14,9,100,12]),function(J,e,L,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;async function j(E,O,m,d,k,v){let $;try{await b(E,O,m,d,k,v)}catch(h){$=h}finally{$&&k.errorTransformer&&($=k.errorTransformer($)),typeof $<"u"&&m.error($),m.end()}}e.$Jp=j;async function b(E,O,m,d,k,v){u(v);const $=await E.open(O,{create:!1});try{u(v);let h=0,f=0,I=k&&typeof k.length=="number"?k.length:void 0,p=L.$ae.alloc(Math.min(k.bufferSize,typeof I=="number"?I:k.bufferSize)),S=k&&typeof k.position=="number"?k.position:0,s=0;do f=await E.read($,S,p.buffer,s,p.byteLength-s),S+=f,s+=f,h+=f,typeof I=="number"&&(I-=f),s===p.byteLength&&(await m.write(d(p)),p=L.$ae.alloc(Math.min(k.bufferSize,typeof I=="number"?I:k.bufferSize)),s=0);while(f>0&&(typeof I!="number"||I>0)&&u(v)&&c(h,k));if(s>0){let o=s;typeof I=="number"&&(o=Math.min(s,I)),m.write(d(p.slice(0,o)))}}catch(h){throw(0,A.$kk)(h)}finally{await E.close($)}}function u(E){if(E.isCancellationRequested)throw(0,D.$5)();return!0}function c(E,O){if(typeof O?.limits?.size=="number"&&E>O.limits.size)throw(0,A.$jk)((0,N.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,13,167]),function(J,e,L,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class b extends N.$Rc{constructor(){super(...arguments),this.a=this.B(new L.$Md),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Md),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const E=this.j(c),O=E.filter(d=>{const k=this.c.get(d.path);return k?!(0,D.$yj)(k.request.excludes,d.excludes)||!(0,D.$yj)(k.request.includes,d.includes):!0}),m=Array.from(this.c.values()).filter(({request:d})=>!E.find(k=>k.path===d.path&&(0,D.$yj)(k.excludes,d.excludes)&&(0,D.$yj)(k.includes,d.includes))).map(({request:d})=>d.path);O.length&&this.m(`Request to start watching: ${O.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const d of m)this.h(d);for(const d of O)this.g(d)}g(c){const E=new j.$6p(c,m=>this.a.fire(m),m=>this.b.fire(m),this.f),O={request:c,instance:E};this.c.set(c.path,O)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const E=this.c.get(c);E&&(this.c.delete(c),E.instance.dispose())}j(c){const E=new Map;for(const O of c){const m=A.$l?O.path:O.path.toLowerCase();let d=E.get(O.correlationId);d||(d=new Map,E.set(O.correlationId,d)),d.set(m,O)}return Array.from(E.values()).map(O=>Array.from(O.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,E]of this.c)E.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,E){return E?`[File Watcher (node.js)] ${c} (path: ${E.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$8p=b}),define(ne[118],re([0,1,62,117]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class N extends L.$Np{constructor(j,b,u){super(j,b,u),this.s()}r(j){return j.add(new D.$8p)}}e.$9p=N}),define(ne[119],re([0,1,15,57,85,62]),function(J,e,L,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class j extends A.$Op{constructor(u,c,E){super(u,c,E),this.s()}r(u){const c=u.add(new N.$Zp(L.$bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:E,signal:O})=>this.t(`terminated by itself with code ${E}, signal: ${O}`))),D.ProxyChannel.toService((0,D.$uh)(c.getChannel("watcher")))}}e.$1p=j}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class L{constructor(...N){this.a=new Map;for(const[A,j]of N)this.set(A,j)}set(N,A){const j=this.a.get(N);return this.a.set(N,A),j}has(N){return this.a.has(N)}get(N){return this.a.get(N)}}e.$Lh=L}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(J,e,L,D,N,A,j,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;const E=!1;class O extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class m{constructor($=new u.$Lh,h=!1,f,I=E){this.f=$,this.g=h,this.h=f,this.i=I,this.o=new Set,this.f.set(b.$Mh,this),this._globalGraph=I?f?._globalGraph??new j.$_p(p=>p):void 0}createChild($){return new m($,this.g,this,this.i)}invokeFunction($,...h){const f=k.traceInvocation(this.i,$);let I=!1;try{return $({get:S=>{if(I)throw(0,D.$7)("service accessor is only valid during the invocation of its target method");const s=this.m(S,f);if(!s)throw new Error(`[invokeFunction] unknown service '${S}'`);return s}},...h)}finally{I=!0,f.stop()}}createInstance($,...h){let f,I;return $ instanceof A.$Kh?(f=k.traceCreation(this.i,$.ctor),I=this.j($.ctor,$.staticArguments.concat(h),f)):(f=k.traceCreation(this.i,$),I=this.j($,h,f)),f.stop(),I}j($,h=[],f){const I=b._util.getServiceDependencies($).sort((s,o)=>s.index-o.index),p=[];for(const s of I){const o=this.m(s.id,f);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${s.id}.`,!1),p.push(o)}const S=I.length>0?I[0].index:h.length;if(h.length!==S){console.trace(`[createInstance] First service dependency of ${$.name} at position ${S+1} conflicts with ${h.length} static arguments`);const s=S-h.length;s>0?h=h.concat(new Array(s)):h=h.slice(0,S)}return Reflect.construct($,h.concat(p))}k($,h){if(this.f.get($)instanceof A.$Kh)this.f.set($,h);else if(this.h)this.h.k($,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const h=this.f.get($);return!h&&this.h?this.h.l($):h}m($,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const f=this.l($);return f instanceof A.$Kh?this.q($,f,h.branch($,!0)):(h.branch($,!1),f)}q($,h,f){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,h,f)}finally{this.o.delete($)}}r($,h,f){const I=new j.$_p(s=>s.id.toString());let p=0;const S=[{id:$,desc:h,_trace:f}];for(;S.length;){const s=S.pop();if(I.lookupOrInsertNode(s),p++>1e3)throw new O(I);for(const o of b._util.getServiceDependencies(s.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),t instanceof A.$Kh){const i={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};I.insertEdge(s,i),S.push(i)}}}for(;;){const s=I.roots();if(s.length===0){if(!I.isEmpty())throw new O(I);break}for(const{data:o}of s){if(this.l(o.id)instanceof A.$Kh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}I.removeNode(o)}}return this.l($)}s($,h,f=[],I,p){if(this.f.get($)instanceof A.$Kh)return this.t($,h,f,I,p);if(this.h)return this.h.s($,h,f,I,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t($,h,f=[],I,p){if(I){const S=new m(void 0,this.g,this,this.i);S.c=String($);const s=new Map,o=new L.$0g(()=>{const t=S.j(h,f,p);for(const[i,n]of s){const r=t[i];if(typeof r=="function")for(const l of n)r.apply(t,l)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=s.get(i);return l||(l=new c.$1c,s.set(i,l)),(y,w,R)=>{const W=l.push([y,w,R]);return(0,N.$Pc)(W)}}if(i in t)return t[i];const n=o.value;let r=n[i];return typeof r!="function"||(r=r.bind(n),t[i]=r),r},set(t,i,n){return o.value[i]=n,!0},getPrototypeOf(t){return h.prototype}})}else return this.j(h,f,p)}u($,h){if(h&&console.warn($),this.g)throw new Error($)}}e.$aq=m;var d;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(d||(d={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,h){return $?new k(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation($,h){return $?new k(1,h.name):k.c}static{this.f=0}constructor($,h){this.type=$,this.name=h,this.g=Date.now(),this.h=[]}branch($,h){const f=new k(3,$.toString());return this.h.push([$,h,f]),f}stop(){const $=Date.now()-this.g;k.f+=$;let h=!1;function f(p,S){const s=[],o=new Array(p+1).join("	");for(const[t,i,n]of S.h)if(i&&n){h=!0,s.push(`${o}CREATES -> ${t}`);const r=f(p+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}const I=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];($>2||h)&&k.all.add(I.join(`
`))}}e.$bq=k});var se=this&&this.__param||function(J,e){return function(L,D){e(L,D,J)}};define(ne[64],re([0,1,20,2,13,102,21,10]),function(J,e,L,D,N,A,j,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=e.$Oq=void 0;function u(E){return E.tags.find(O=>O.startsWith("lp-"))?.split("lp-")[1]}e.$Oq=u,e.$Pq=(0,b.$Nh)("languagePackService");let c=class extends D.$Rc{constructor(O){super(),this.c=O}async getAvailableLanguages(){const O=new L.$Wd;setTimeout(()=>O.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},O.token)}catch{return[]}const k=m.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some($=>$.startsWith("lp-"))).map(v=>{const $=v.properties.localizedLanguages?.[0],h=u(v);return{...this.f(h,$,v),extensionId:v.identifier.id,galleryExtension:v}});return k.push(this.f("en","English")),k}f(O,m,d){const k=m??O;let v;if(k!==O&&(v=`(${O})`),O.toLowerCase()===N.$w.toLowerCase()&&(v??="",v+=(0,A.localize)(0,null)),d?.installCount){v??="";const $=d.installCount;let h;$>1e6?h=`${Math.floor($/1e5)/10}M`:$>1e3?h=`${Math.floor($/1e3)}K`:h=String($),v+=` $(cloud-download) ${h}`}return{id:O,label:k,description:v}}};e.$Qq=c,e.$Qq=c=pe([se(0,j.$7n)],c)}),define(ne[6],re([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(J,e,L,D,N,A,j,b,u,c,E,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,m.$Nh)("logService"),e.$9i=(0,m.$Nh)("loggerService");function d(){return new Date().toISOString()}function k(y){return(0,c.$Bf)(y)}e.$0i=k;var v;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$$i=v.Info;function $(y,w,R){switch(w){case v.Trace:y.trace(R);break;case v.Debug:y.debug(R);break;case v.Info:y.info(R);break;case v.Warning:y.warn(R);break;case v.Error:y.error(R);break;case v.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=$;function h(y,w=!1){let R="";for(let W=0;W<y.length;W++){let _=y[W];if(_ instanceof Error&&(_=(0,L.$yi)(_,w)),typeof _=="object")try{_=JSON.stringify(_)}catch{}R+=(W>0?" ":"")+_}return R}class f extends A.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new D.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==v.Off&&this.b<=w}}e.$aj=f;class I extends f{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...R){this.f(v.Trace)&&this.g(v.Trace,h([w,...R],!0))}debug(w,...R){this.f(v.Debug)&&this.g(v.Debug,h([w,...R]))}info(w,...R){this.f(v.Info)&&this.g(v.Info,h([w,...R]))}warn(w,...R){this.f(v.Warning)&&this.g(v.Warning,h([w,...R]))}error(w,...R){if(this.f(v.Error))if(w instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=w.stack,this.g(v.Error,h(W))}else this.g(v.Error,h([w,...R]))}flush(){}}e.$bj=I;class p extends f{constructor(w=e.$$i){super(),this.setLevel(w),this.g=!b.$j}trace(w,...R){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...R):console.log(`[main ${d()}]`,w,...R))}debug(w,...R){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...R):console.log(`[main ${d()}]`,w,...R))}info(w,...R){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...R):console.log(`[main ${d()}]`,w,...R))}warn(w,...R){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,w,...R):console.warn(`[main ${d()}]`,w,...R))}error(w,...R){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,w,...R):console.error(`[main ${d()}]`,w,...R))}dispose(){}flush(){}}e.$cj=p;class S extends f{constructor(w=e.$$i,R=!0){super(),this.g=R,this.setLevel(w)}trace(w,...R){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...R):console.log(w,...R))}debug(w,...R){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...R):console.log(w,...R))}info(w,...R){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...R):console.log(w,...R))}warn(w,...R){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...R):console.log(w,...R))}error(w,...R){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...R):console.error(w,...R))}dispose(){}flush(){}}e.$dj=S;class s extends f{constructor(w,R=e.$$i){super(),this.g=w,this.setLevel(R)}trace(w,...R){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(w),...R])}debug(w,...R){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(w),...R])}info(w,...R){this.f(v.Info)&&this.g.log(v.Info,[this.h(w),...R])}warn(w,...R){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(w),...R])}error(w,...R){this.f(v.Error)&&this.g.log(v.Error,[this.h(w),...R])}h(w){return typeof w=="string"?w:(0,L.$yi)(w,this.f(v.Trace))}dispose(){}flush(){}}e.$ej=s;class o extends f{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const R of this.g)R.setLevel(w);super.setLevel(w)}trace(w,...R){for(const W of this.g)W.trace(w,...R)}debug(w,...R){for(const W of this.g)W.debug(w,...R)}info(w,...R){for(const W of this.g)W.info(w,...R)}warn(w,...R){for(const W of this.g)W.warn(w,...R)}error(w,...R){for(const W of this.g)W.error(w,...R)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$fj=o;class t extends A.$Rc{constructor(w,R,W){if(super(),this.h=w,this.j=R,this.b=new j.$zc,this.c=this.B(new D.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Md),this.onDidChangeVisibility=this.g.event,W)for(const _ of W)this.b.set(_.resource,{logger:void 0,info:_})}m(w){return(0,c.$xf)(w)?[...this.b.values()].find(R=>R.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,R){const W=this.n(w),_=(0,c.$xf)(w)?w:R?.id??(0,N.$Bi)(W.toString()).toString(16);let Y=this.b.get(W)?.logger;const ue=R?.logLevel==="always"?v.Trace:R?.logLevel;Y||(Y=this.s(W,ue??this.getLogLevel(W)??this.h,{...R,id:_}));const te={logger:Y,info:{resource:W,id:_,logLevel:ue,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(te.info),this.b.set(W,te),Y}n(w){return(0,c.$xf)(w)?(0,u.$ug)(this.j,`${w}.log`):w}setLogLevel(w,R){if(E.URI.isUri(w)){const W=w,_=R,Y=this.b.get(W);Y&&_!==Y.info.logLevel&&(Y.info.logLevel=_===this.h?void 0:_,Y.logger?.setLevel(_),this.b.set(Y.info.resource,Y),this.f.fire([W,_]))}else{this.h=w;for(const[W,_]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,R){const W=this.m(w);W&&R!==!W.info.hidden&&(W.info.hidden=!R,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,R]))}getLogLevel(w){let R;return w&&(R=this.b.get(w)?.info.logLevel),R??this.h}registerLogger(w){const R=this.b.get(w.resource);R?R.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const R=this.b.get(w);R&&(R.logger&&R.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=t;class i{constructor(){this.onDidChangeLogLevel=new D.$Md().event}setLevel(w){}getLevel(){return v.Info}trace(w,...R){}debug(w,...R){}info(w,...R){}warn(w,...R){}error(w,...R){}critical(w,...R){}dispose(){}flush(){}}e.$hj=i;class n extends i{}e.$ij=n;function r(y){if(y.verbose)return v.Trace;if(typeof y.logLevel=="string"){const w=P(y.logLevel.toLowerCase());if(w!==void 0)return w}return e.$$i}e.$jj=r;function l(y){switch(y){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$kj=l;function P(y){switch(y){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$lj=P,e.$mj=new O.$5i("logLevel",l(v.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(J,e,L,D,N,A,j,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class E extends j.$Rc{constructor(m,d){super(),this.a=m,this.b=d,this.c=this.B(new A.$Md),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Md),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$Qg(0)),this.w=[],this.y=this.B(new D.$Qg(0))}watch(m,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(m,d):this.z(m,d)}n(m,d){const k={path:this.H(m),excludes:d.excludes,includes:d.includes,recursive:d.recursive,correlationId:d.correlationId},v=(0,L.$Tb)(this.j,k);return this.r(),(0,j.$Pc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,N.$Z)(m))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,u.$Pp)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const d of this.j)(0,u.$Lp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const d of this.j)(0,u.$Lp)(d)&&m.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,d){const k={path:this.H(m),excludes:d.excludes,includes:d.includes,recursive:!1,correlationId:d.correlationId},v=(0,L.$Tb)(this.w,k);return this.C(),(0,j.$Pc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,N.$Z)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,u.$Pp)(m)),m=>this.G(m),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,b.$gc)(m.fsPath)}}e.$Tp=E}),define(ne[122],re([0,1,19,8,14,20,4,41,65,2,46,15,123,17,45,99,12,61,6,9]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d,k,v,$,h,f,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;let S=class extends c.$Rc{static{p=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new j.$Md),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$Md),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$Md),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$Md),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$Md),this.Y=this.B(new j.$Md),this.onDidFilesChange=this.Y.event,this.Z=this.B(new j.$Md),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$2g)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${o}`);const i=new c.$Qc;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),i.add(t.onDidChangeFile(n=>{const r=new $.$pk(n,!this.S(t));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,c.$Pc)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,c.$Mc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(i){t.push(i)}}),!this.h.has(o)&&await D.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,d.$yg)(o))throw new $.$rk((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const i=new I.$ab;throw i.message=(0,v.localize)(1,null,o.toString()),i}return t}async m(o){const t=await this.j(o);if((0,$.$ck)(t)||(0,$.$_j)(t)||(0,$.$dk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const t=await this.j(o);if((0,$.$ck)(t)||(0,$.$_j)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.s(o,t)}catch(i){throw(0,$.$mk)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$rk((0,v.localize)(2,null,this.sb(o)),1):(0,$.$kk)(i)}}async s(o,t){const i=await this.j(o),n=this.S(i),r=t?.resolveTo,l=t?.resolveSingleChildDescendants,P=t?.resolveMetadata,y=await i.stat(o);let w;return this.t(i,o,y,void 0,!!P,(R,W)=>(w||(w=E.$Th.forUris(()=>!n),w.set(o,!0),r&&w.fill(!0,r)),w.get(R.resource)||w.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&l?W===1:!1))}async t(o,t,i,n,r,l){const{providerExtUri:P}=this.R(o),y={resource:t,name:P.basename(t),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Ck)({mtime:i.mtime,size:i.size}),children:void 0};if(y.isDirectory&&l(y,n)){try{const w=await o.readdir(t),R=await D.Promises.settled(w.map(async([W,_])=>{try{const Y=P.joinPath(t,W),ue=r?await o.stat(Y):{type:_};return await this.t(o,Y,ue,w.length,r,l)}catch(Y){return this.b.trace(Y),null}}));y.children=(0,L.$Gb)(R)}catch(w){this.b.trace(w),y.children=[]}return y}return y}async resolveAll(o){return D.Promises.settled(o.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),i=await t.stat(o);return this.t(t,o,i,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.u(o,t)}catch(i){return i}return!0}async u(o,t){if(!t?.overwrite&&await this.exists(o))throw new $.$rk((0,v.localize)(3,null,this.sb(o)),3,t)}async createFile(o,t=N.$ae.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,t);return this.r.fire(new $.$ok(o,0,n)),n}async writeFile(o,t,i){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let l=i;if((0,$.$fk)(n)&&!l?.atomic){const P=n.enforceAtomicWriteFile?.(o);P&&(l={...i,atomic:P})}try{await this.w(n,o,l)||await this.U(n,r.dirname(o));let y;if((0,$.$_j)(n)&&!(t instanceof N.$ae))if((0,k.$Yd)(t)){const w=await(0,k.$6d)(t,3);w.ended?y=N.$ae.concat(w.buffer):y=w}else y=(0,k.$3d)(t,w=>N.$ae.concat(w),3);else y=t;!(0,$.$ck)(n)||(0,$.$_j)(n)&&y instanceof N.$ae||(0,$.$_j)(n)&&(0,$.$fk)(n)&&l?.atomic?await this.hb(n,o,l,y):await this.db(n,o,l,y instanceof N.$ae?(0,N.$le)(y):y),this.r.fire(new $.$ok(o,4))}catch(P){throw new $.$rk((0,v.localize)(4,null,this.sb(o),(0,$.$kk)(P).toString()),(0,$.$nk)(P),l)}return this.resolve(o,{resolveMetadata:!0})}async w(o,t,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(t)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(t)));if(n)throw new Error((0,v.localize)(8,null,this.sb(t)))}let l;try{l=await o.stat(t)}catch{return}if(l.type&$.FileType.Directory)throw new $.$rk((0,v.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$Bk&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,$.$Ck)({mtime:i.mtime,size:l.size}))throw new $.$rk((0,v.localize)(10,null),3,i);return l}async readFile(o,t,i){const n=await this.m(o);return t?.atomic?this.z(n,o,t,i):this.C(n,o,t,i)}async z(o,t,i,n){return new Promise((r,l)=>{this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{try{const P=await this.C(o,t,i,n);r(P)}catch(P){l(P)}})})}async C(o,t,i,n){const r=await this.D(o,t,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,N.$me)(r.value)}}async readFileStream(o,t,i){const n=await this.m(o);return this.D(n,o,t,i)}async D(o,t,i,n){const r=new A.$Wd(n);let l=i;(0,$.$ek)(o)&&o.enforceAtomicReadFile?.(t)&&(l={...i,atomic:!0});const P=this.J(t,l).then(w=>w,w=>{throw r.dispose(!0),w});let y;try{return typeof l?.etag=="string"&&l.etag!==$.$Bk&&await P,l?.atomic&&(0,$.$ek)(o)||!((0,$.$ck)(o)||(0,$.$dk)(o))||(0,$.$_j)(o)&&l?.preferUnbuffered?y=this.I(o,t,l):(0,$.$dk)(o)?y=this.G(o,t,r.token,l):y=this.H(o,t,r.token,l),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await P,value:y}}catch(w){throw y&&await(0,k.$4d)(y),this.F(w,t,l)}}F(o,t,i){const n=(0,v.localize)(11,null,this.sb(t),(0,$.$kk)(o).toString());return o instanceof $.$tk?new $.$tk(n,o.stat,i):o instanceof $.$sk?new $.$sk(n,o.fileOperationResult,o.size,o.options):new $.$rk(n,(0,$.$nk)(o),i)}G(o,t,i,n=Object.create(null)){const r=o.readFileStream(t,n,i);return(0,k.$0d)(r,{data:l=>l instanceof N.$ae?l:N.$ae.wrap(l),error:l=>this.F(l,t,n)},l=>N.$ae.concat(l))}H(o,t,i,n=Object.create(null)){const r=(0,N.$qe)();return(0,h.$Jp)(o,t,r,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,t,n)},i),r}I(o,t,i){const n=(0,k.$1d)(r=>N.$ae.concat(r));return(async()=>{try{let r;i?.atomic&&(0,$.$ek)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(t,r.byteLength,i),n.end(N.$ae.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,t){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new $.$rk((0,v.localize)(12,null,this.sb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==$.$Bk&&t.etag===i.etag)throw new $.$tk((0,v.localize)(13,null),i,t);return this.L(o,i.size,t),i}L(o,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new $.$sk((0,v.localize)(14,null,this.sb(o)),7,t,i)}async canMove(o,t,i){return this.M(o,t,"move",i)}async canCopy(o,t,i){return this.M(o,t,"copy",i)}async M(o,t,i,n){if(o.toString()!==t.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),l=this.qb(await this.n(t),t);await this.Q(r,o,l,t,i,n)}catch(r){return r}return!0}async move(o,t,i){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"move",!!i),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$ok(o,l==="move"?2:3,P)),P}async copy(o,t,i){const n=await this.m(o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"copy",!!i),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$ok(o,l==="copy"?3:2,P)),P}async N(o,t,i,n,r,l){if(t.toString()===n.toString())return r;const{exists:P,isSameResourceWithDifferentPathCase:y}=await this.Q(o,t,i,n,r,l);if(P&&!y&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),r==="copy"){if(o===i&&(0,$.$ak)(o))await o.copy(t,n,{overwrite:l});else{const w=await this.resolve(t);w.isDirectory?await this.P(o,w,i,n):await this.O(o,t,i,n)}return r}else return o===i?(await o.rename(t,n,{overwrite:l}),r):(await this.N(o,t,i,n,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(o,t,i,n){if((0,$.$ck)(o)&&(0,$.$ck)(i))return this.jb(o,t,i,n);if((0,$.$ck)(o)&&(0,$.$_j)(i))return this.pb(o,t,i,n);if((0,$.$_j)(o)&&(0,$.$ck)(i))return this.nb(o,t,i,n);if((0,$.$_j)(o)&&(0,$.$_j)(i))return this.lb(o,t,i,n)}async P(o,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async r=>{const l=this.R(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,l):this.O(o,r.resource,i,l)}))}async Q(o,t,i,n,r,l){let P=!1;if(o===i){const{providerExtUri:w,isPathCaseSensitive:R}=this.R(o);if(R||(P=w.isEqual(t,n)),P&&r==="copy")throw new Error((0,v.localize)(15,null,this.sb(t),this.sb(n)));if(!P&&w.isEqualOrParent(n,t))throw new Error((0,v.localize)(16,null,this.sb(t),this.sb(n)))}const y=await this.exists(n);if(y&&!P){if(!l)throw new $.$rk((0,v.localize)(17,null,this.sb(t),this.sb(n)),4);if(o===i){const{providerExtUri:w}=this.R(o);if(w.isEqualOrParent(t,n))throw new Error((0,v.localize)(18,null,this.sb(t),this.sb(n)))}}return{exists:y,isSameResourceWithDifferentPathCase:P}}R(o){const t=this.S(o);return{providerExtUri:t?d.$kg:d.$mg,isPathCaseSensitive:t}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.qb(await this.j(o),o);await this.U(t,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$ok(o,0,i)),i}async U(o,t){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await o.stat(t)).type&$.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(t)));break}catch(r){if((0,$.$mk)(r)!==$.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(t)),t=n.dirname(t)}for(let r=i.length-1;r>=0;r--){t=n.joinPath(t,i[r]);try{await o.mkdir(t)}catch(l){if((0,$.$mk)(l)!==$.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(o,t){try{await this.W(o,t)}catch(i){return i}return!0}async W(o,t){const i=this.qb(await this.j(o),o),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const r=t?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,v.localize)(22,null,this.sb(o)));let l;try{l=await i.stat(o)}catch{}if(l)this.rb(o,l);else throw new $.$rk((0,v.localize)(23,null,this.sb(o)),1);if(!!!t?.recursive){const y=await this.resolve(o);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return i}async del(o,t){const i=await this.W(o,t);let n=t;if((0,$.$gk)(i)&&!n?.atomic){const y=i.enforceAtomicDelete?.(o);y&&(n={...t,atomic:y})}const r=!!n?.useTrash,l=!!n?.recursive,P=n?.atomic??!1;await i.delete(o,{recursive:l,useTrash:r,atomic:P}),this.r.fire(new $.$ok(o,1))}async cloneFile(o,t){const i=await this.j(o),n=this.qb(await this.n(t),t);if(i===n&&this.R(i).providerExtUri.isEqual(o,t))return;if(i===n&&(0,$.$bk)(i))return i.cloneFile(o,t);await this.U(n,this.R(n).providerExtUri.dirname(t));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===n&&(0,$.$ak)(i)?r.queue(()=>i.copy(o,t,{overwrite:!0})):r.queue(()=>this.O(i,o,n,t))}static{this.ab=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:p.ab++})}watch(o,t={recursive:!1,excludes:[]}){const i=new c.$Qc;let n=!1,r=()=>{n=!0};i.add((0,c.$Pc)(()=>r())),(async()=>{try{const P=await this.bb(o,t);n?(0,c.$Mc)(P):r=()=>(0,c.$Mc)(P)}catch(P){this.b.error(P)}})();const l=t.correlationId;if(typeof l=="number"){const P=i.add(new j.$Md);return i.add(this.X.event(w=>{w.correlates(l)&&P.fire(w)})),{onDidChange:P.event,dispose:()=>i.dispose()}}return i}async bb(o,t){const i=await this.j(o),n=(0,b.$Bi)([this.R(i).providerExtUri.getComparisonKey(o),t]);let r=this.$.get(n);return r||(r={count:0,disposable:i.watch(o,t)},this.$.set(n,r)),r.count+=1,(0,c.$Pc)(()=>{r&&(r.count--,r.count===0&&((0,c.$Mc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Mc)(o.disposable);this.$.clear()}async db(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,k.$Yd)(n)||(0,k.$Zd)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(l){throw(0,$.$kk)(l)}finally{await o.close(r)}})}async eb(o,t,i){let n=0,r;if((0,k.$Zd)(i)){if(i.buffer.length>0){const l=N.$ae.concat(i.buffer);await this.gb(o,t,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((l,P)=>{(0,k.$5d)(r,{onData:async y=>{r.pause();try{await this.gb(o,t,y,y.byteLength,n,0)}catch(w){return P(w)}n+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>P(y),onEnd:()=>l()})})}async fb(o,t,i){let n=0,r;for(;(r=i.read())!==null;)await this.gb(o,t,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,t,i,n,r,l){let P=0;for(;P<n;){const y=await o.write(t,r+P,i.buffer,l+P,n-P);P+=y}}async hb(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(()=>this.ib(o,t,i,n))}async ib(o,t,i,n){let r;n instanceof N.$ae?r=n:(0,k.$Yd)(n)?r=await(0,N.$me)(n):(0,k.$Zd)(n)?r=await(0,N.$ne)(n):r=(0,N.$ke)(n),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(o,t,i,n))}async kb(o,t,i,n){let r,l;try{r=await o.open(t,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const P=N.$ae.alloc(this.a);let y=0,w=0,R=0;do R=await o.read(r,y,P.buffer,w,P.byteLength-w),await this.gb(i,l,P,R,y,w),y+=R,w+=R,w===P.byteLength&&(w=0);while(R>0)}catch(P){throw(0,$.$kk)(P)}finally{await D.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(o,t,i,n))}async mb(o,t,i,n){return i.writeFile(n,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(o,t,i,n))}async ob(o,t,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const l=await o.readFile(t);await this.gb(i,r,N.$ae.wrap(l),l.byteLength,0,0)}catch(l){throw(0,$.$kk)(l)}finally{await i.close(r)}}async pb(o,t,i,n){const r=await(0,N.$me)(this.H(o,t,A.CancellationToken.None));await this.hb(i,n,void 0,r)}qb(o,t){if(o.capabilities&2048)throw new $.$rk((0,v.localize)(25,null,this.sb(t)),6);return o}rb(o,t){if((t.permissions??0)&$.FilePermission.Readonly)throw new $.$rk((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===O.Schemas.file?o.fsPath:o.toString(!0)}};e.$Kp=S,e.$Kp=S=p=pe([se(0,f.$8i)],S)}),define(ne[124],re([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d,k,v,$,h,f,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,I.$yi)(o)}`)}})();class s extends f.$Tp{static{this.I=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=b.Event.None,this.N=new A.$zc(n=>m.$lg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,O.$l&&(this.J|=1024)),this.J}async stat(t){try{const{stat:i,symbolicLink:n}=await k.SymlinkSupport.stat(this.H(t));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:$.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await k.Promises.readdir(this.H(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,m.$ug)(t,r.name))).type:l=this.M(r),n.push([r.name,l])}catch(l){this.a.trace(l)}})),n}catch(i){throw this.fb(i)}}M(t,i){let n;return i?.dangling?n=$.FileType.Unknown:t.isFile()?n=$.FileType.File:t.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,i&&(n|=$.FileType.SymbolicLink),n}async O(t){const i=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const r=new N.$Rg;return this.N.set(t,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(t)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),n=await this.O(t));const r=this.H(t);return await k.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,i,n){const r=(0,d.$1d)(l=>j.$ae.concat(l.map(P=>j.$ae.wrap(P))).buffer);return(0,h.$Jp)(this,t,r,l=>l.buffer,{...i,bufferSize:256*1024},n),r}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,m.$ug)((0,m.$tg)(t),`${(0,m.$rg)(t)}${n.atomic.postfix}`),i,n):this.S(t,i,n)}async Q(t){try{const i=this.H(t),{symbolicLink:n}=await k.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(t,i,n,r){const l=new c.$Qc;try{l.add(await this.O(t)),l.add(await this.O(i)),await this.S(i,n,r,!0);try{await this.rename(i,t,{overwrite:!0})}catch(P){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{l.dispose()}}async S(t,i,n,r){let l;try{const P=this.H(t);if(!n.create||!n.overwrite){if(await k.Promises.exists(P)){if(!n.overwrite)throw(0,$.$jk)((0,v.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$jk)((0,v.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:n.unlock},r),await this.write(l,0,i,0,i.byteLength)}catch(P){throw await this.gb(t,P)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,i,n){const r=this.H(t);let l;(0,$.$0j)(i)&&!n&&(l=await this.O(t));let P;try{if((0,$.$0j)(i)&&i.unlock)try{const{stat:w}=await k.SymlinkSupport.stat(r);w.mode&128||await k.Promises.chmod(r,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let y;if((0,$.$0j)(i)){if(O.$j)try{await k.Promises.truncate(r,0),y="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}y||(y="w")}else y="r";P=await k.Promises.open(r,y)}catch(y){throw l?.dispose(),(0,$.$0j)(i)?await this.gb(t,y):this.fb(y)}if(this.U.set(P,0),(0,$.$0j)(i)&&this.X.set(P,t),l){const y=this.W.get(P);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${r})`),this.W.set(P,l),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${r})`),y.dispose())}return P}async close(t){const i=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await k.Promises.fdatasync(t)}catch(n){s.configureFlushOnWrite(!1),this.a.error(n)}return await k.Promises.close(t)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(t)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,r,l){const P=this.Z(t,i);let y=null;try{y=(await k.Promises.read(t,n,r,l,P)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(t,P,y)}return y}Z(t,i){return i===this.U.get(t)?null:i}$(t,i,n){const r=this.U.get(t);typeof r=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(t,r+n):this.U.delete(t)))}async write(t,i,n,r,l){return(0,N.$$g)(()=>this.ab(t,i,n,r,l),100,3)}async ab(t,i,n,r,l){const P=this.Z(t,i);let y=null;try{y=(await k.Promises.write(t,n,r,l,P)).bytesWritten}catch(w){throw await this.gb(this.X.get(t),w)}finally{this.$(t,P,y)}return y}async mkdir(t){try{await k.Promises.mkdir(this.H(t))}catch(i){throw this.fb(i)}}async delete(t,i){try{const n=this.H(t);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,E.$ic)((0,E.$lc)(n),`${(0,E.$mc)(n)}${i.atomic.postfix}`)),await k.Promises.rm(n,k.RimRafMode.MOVE,r)}else try{await k.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:P,symbolicLink:y}=await k.SymlinkSupport.stat(n);l=P.isDirectory()&&!y}catch{}if(l)await k.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"move",n.overwrite),await k.Promises.rename(r,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,v.localize)(2,null,(0,E.$mc)(r),(0,E.$mc)((0,E.$lc)(l)),P.toString()))),this.fb(P)}}async copy(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"copy",n.overwrite),await k.Promises.copy(r,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,v.localize)(3,null,(0,E.$mc)(r),(0,E.$mc)((0,E.$lc)(l)),P.toString()))),this.fb(P)}}async bb(t,i,n,r){const l=this.H(t),P=this.H(i);let y=!1;if(!!(this.capabilities&1024)||(y=(0,u.$Vf)(l,P,!0)),y){if(n==="copy")throw(0,$.$jk)((0,v.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const R=await this.L(t);if(!R)throw(0,$.$jk)((0,v.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const W=await this.L(i);if(W){if(!r)throw(0,$.$jk)((0,v.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);R.type&$.FileType.File&&W.type&$.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.cb(t,i,!1)}async cb(t,i,n){const r=this.H(t),l=this.H(i),P=!!(this.capabilities&1024);if((0,u.$Vf)(r,l,!P))return;const y=new c.$Qc;try{y.add(await this.O(t)),y.add(await this.O(i)),n&&await k.Promises.mkdir((0,E.$lc)(l),{recursive:!0}),await k.Promises.copyFile(r,l)}catch(w){if(w.code==="ENOENT"&&!n)return this.cb(t,i,!0);throw this.fb(w)}finally{y.dispose()}}t(t,i,n){return new p.$1p(r=>t(r),r=>i(r),n)}F(t,i,n){return new S.$9p(r=>t(r),r=>i(r),n)}fb(t){if(t instanceof $.$ik)return t;let i=t,n;switch(t.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$jk)(i,n)}async gb(t,i){let n=this.fb(i);if(t&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await k.SymlinkSupport.stat(this.H(t));r.mode&128||(n=(0,$.$jk)(i,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$0p=s}),define(ne[126],re([0,1,2,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=void 0;class N extends L.$Rc{constructor(j,b=[]){super(),this.a=new D.$fj([j,...b]),this.B(j.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...b){this.a.trace(j,...b)}debug(j,...b){this.a.debug(j,...b)}info(j,...b){this.a.info(j,...b)}warn(j,...b){this.a.warn(j,...b)}error(j,...b){this.a.error(j,...b)}flush(){this.a.flush()}}e.$yN=N}),define(ne[127],re([0,1,12,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=void 0;var N;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(N||(N={}));async function A(c,E,O,m,d){try{const k=await new Promise(($,h)=>{J(["@vscode/spdlog"],$,h)});k.setFlushOn(N.Trace);const v=await k.createAsyncRotatingLogger(c,E,O,m);return d?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(k){console.error(k)}return null}function j(c,E,O){switch(E){case D.LogLevel.Trace:c.trace(O);break;case D.LogLevel.Debug:c.debug(O);break;case D.LogLevel.Info:c.info(O);break;case D.LogLevel.Warning:c.warn(O);break;case D.LogLevel.Error:c.error(O);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function b(c,E){switch(E){case D.LogLevel.Trace:c.setLevel(N.Trace);break;case D.LogLevel.Debug:c.setLevel(N.Debug);break;case D.LogLevel.Info:c.setLevel(N.Info);break;case D.LogLevel.Warning:c.setLevel(N.Warning);break;case D.LogLevel.Error:c.setLevel(N.Error);break;case D.LogLevel.Off:c.setLevel(N.Off);break;default:throw new Error(`Invalid log level ${E}`)}}class u extends D.$bj{constructor(E,O,m,d,k){super(),this.m=[],this.setLevel(k),this.n=this.s(E,O,m,d),this.B(this.onDidChangeLogLevel(v=>{this.r&&b(this.r,v)}))}async s(E,O,m,d){const k=m?6:1,v=30/k*L.$Ek.MB,$=await A(E,O,v,k,d);if($){this.r=$,b(this.r,this.getLevel());for(const{level:h,message:f}of this.m)j(this.r,h,f);this.m=[]}}g(E,O){this.r?j(this.r,E,O):this.getLevel()<=E&&this.m.push({level:E,message:O})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$nN=u}),define(ne[128],re([0,1,28,6,127]),function(J,e,L,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=void 0;class A extends D.$gj{s(b,u,c){return new N.$nN((0,L.$dg)(),b.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$oN=A}),define(ne[38],re([0,1,4,65,2,10]),function(J,e,L,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=void 0,e.$en=(0,A.$Nh)("policy");class j extends N.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Md),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const E=Object.keys(this.f).length;return this.f={...c,...this.f},E!==Object.keys(this.f).length&&await this.j(c),D.Iterable.reduce(this.g.entries(),(O,[m,d])=>({...O,[m]:d}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(c,[E,O])=>({...c,[E]:{definition:O,value:this.g.get(E)}}),{})}}e.$fn=j;class b{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$gn=b}),define(ne[129],re([0,1,8,4,65,3,12,6,38]),function(J,e,L,D,N,A,j,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=void 0;function c(O,m){const d=[];for(const k of new Set(N.Iterable.concat(O.keys(),m.keys())))O.get(k)!==m.get(k)&&d.push(k);return d}let E=class extends u.$fn{constructor(m,d,k){super(),this.m=m,this.n=d,this.s=k,this.c=this.B(new L.$Qg(500));const v=D.Event.filter(d.onDidFilesChange,$=>$.affects(m));this.B(d.watch(m)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const m=new Map;try{const d=await this.n.readFile(this.m),k=JSON.parse(d.value.toString());if(!(0,A.$zf)(k))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(k))this.f[v]&&m.set(v,k[v])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return m}async w(){const m=await this.u(),d=c(this.g,m);this.g=m,d.length>0&&this.h.fire(d)}};e.$17b=E,e.$17b=E=pe([se(1,j.$9j),se(2,b.$8i)],E)}),define(ne[130],re([0,1,38,8,171,2,6]),function(J,e,L,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z7b=void 0;let b=class extends L.$fn{constructor(c,E){super(),this.m=c,this.n=E,this.a=new D.$Mg,this.b=this.B(new A.$Sc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((E,O)=>{try{this.b.value=(0,N.createWatcher)(this.n,c,m=>{this.t(m),E()})}catch(m){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),O(m)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const E in c){const O=c[E];O===void 0?this.g.delete(E):this.g.set(E,O)}this.h.fire(Object.keys(c))}};e.$Z7b=b,e.$Z7b=b=pe([se(0,j.$8i)],b)}),define(ne[32],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,L.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0;class N{constructor(){this.a=new Map}add(j,b){L.ok(D.$xf(j)),L.ok(D.$zf(b)),L.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,b)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$cn=new N}),define(ne[131],re([0,1,4,36]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=void 0,e.$dn={JSONContribution:"base.contributions.json"};function N(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class A{constructor(){this.b=new L.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[N(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const j=new A;D.$cn.add(e.$dn.JSONContribution,j)}),define(ne[43],re([0,1,19,4,3,88,25,131,36]),function(J,e,L,D,N,A,j,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.ConfigurationScope=e.$hn=e.EditPresentationTypes=void 0;var c;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$hn={Configuration:"base.contributions.configuration"};var E;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on="vscode://schemas/settings/resourceLanguage",e.$pn="vscode://schemas/settings/configurationDefaults";const O=u.$cn.as(b.$dn.JSONContribution);class m{constructor(){this.h=new Set,this.i=new D.$Md,this.onDidSchemaChange=this.i.event,this.j=new D.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},O.registerSchema(e.$on,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const t=new Set;this.n(s,o,t),O.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const o=new Set;this.o(s,o),O.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const t=new Set;this.o(o,t),this.n(s,!1,t),O.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const t=[];for(const{overrides:i,source:n}of s)for(const r in i)if(o.add(r),e.$rn.test(r)){const l=this.a.get(r),P=l?.valuesSources??new Map;if(n)for(const W of Object.keys(i[r]))P.set(W,n);const y={...l?.value||{},...i[r]};this.a.set(r,{source:n,value:y,valuesSources:P});const w=(0,j.$ri)(r),R={type:"object",default:y,description:A.localize(1,null,w),$ref:e.$on,defaultDefaultValue:y,source:N.$xf(n)?void 0:n,defaultValueSource:n};t.push(...v(r)),this.d[r]=R,this.b.properties[r]=R}else{this.a.set(r,{value:i[r],source:n});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(t)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:t,source:i}of s)for(const n in t){const r=this.a.get(n),l=N.$xf(i)?i:i?.id,P=N.$xf(r?.source)?r?.source:r?.source?.id;if(l===P)if(o.add(n),this.a.delete(n),e.$rn.test(n))delete this.d[n],delete this.b.properties[n];else{const y=this.d[n];y&&(this.w(n,y),this.r(n,y))}}this.u()}deltaConfiguration(s){let o=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,t){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(s,o){const t=i=>{if(i.properties)for(const n in i.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of s){t(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(s,o=!0,t,i,n=3,r){n=N.$Gf(s.scope)?n:s.scope;const l=s.properties;if(l)for(const y in l){const w=l[y];if(o&&I(y,w)){delete l[y];continue}if(w.source=t,w.defaultDefaultValue=l[y].default,this.w(y,w),e.$rn.test(y)?w.scope=void 0:(w.scope=N.$Gf(w.scope)?n:w.scope,w.restricted=N.$Gf(w.restricted)?!!i?.includes(y):w.restricted),l[y].hasOwnProperty("included")&&!l[y].included){this.f[y]=l[y],delete l[y];continue}else this.d[y]=l[y],l[y].policy?.name&&this.e.set(l[y].policy.name,y);!l[y].deprecationMessage&&l[y].markdownDeprecationMessage&&(l[y].deprecationMessage=l[y].markdownDeprecationMessage),r.add(y)}const P=s.allOf;if(P)for(const y of P)this.p(y,o,t,i,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=t=>{const i=t.properties;if(i)for(const r in i)this.r(r,i[r]);t.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$in.properties[s]=o,o.scope){case 1:e.$jn.properties[s]=o;break;case 2:e.$kn.properties[s]=o;break;case 6:e.$ln.properties[s]=o;break;case 3:e.$mn.properties[s]=o;break;case 4:e.$nn.properties[s]=o;break;case 5:e.$nn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$in.properties[s],o.scope){case 1:delete e.$jn.properties[s];break;case 2:delete e.$kn.properties[s];break;case 6:delete e.$ln.properties[s];break;case 3:delete e.$mn.properties[s];break;case 4:case 5:delete e.$nn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$on};this.w(o,t),e.$in.properties[o]=t,e.$jn.properties[o]=t,e.$kn.properties[o]=t,e.$ln.properties[o]=t,e.$mn.properties[o]=t,e.$nn.properties[o]=t}}v(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$on};e.$in.patternProperties[e.$qn]=s,e.$jn.patternProperties[e.$qn]=s,e.$kn.patternProperties[e.$qn]=s,e.$ln.patternProperties[e.$qn]=s,e.$mn.patternProperties[e.$qn]=s,e.$nn.patternProperties[e.$qn]=s,this.i.fire()}w(s,o){const t=this.a.get(s);let i=t?.value,n=t?.source;N.$Ef(i)&&(i=o.defaultDefaultValue,n=void 0),N.$Ef(i)&&(i=h(o.type)),o.default=i,o.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",k=new RegExp(d,"g");e.$qn=`^(${d})+$`,e.$rn=new RegExp(e.$qn);function v(S){const s=[];if(e.$rn.test(S)){let o=k.exec(S);for(;o?.length;){const t=o[1].trim();t&&s.push(t),o=k.exec(S)}}return(0,L.$Lb)(s)}e.$sn=v;function $(S){return S.reduce((s,o)=>`${s}[${o}]`,"")}e.$tn=$;function h(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$un=h;const f=new m;u.$cn.add(e.$hn.Configuration,f);function I(S,s){return S.trim()?e.$rn.test(S)?A.localize(7,null,S):f.getConfigurationProperties()[S]!==void 0?A.localize(8,null,S):s.policy?.name&&f.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,S,s.policy?.name,f.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.$vn=I;function p(){const S=[],s=f.getConfigurationProperties();for(const o of Object.keys(s))S.push([o,s[o].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.$wn=p}),define(ne[66],re([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(J,e,L,D,N,A,j,b,u,c,E,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=void 0;function d(o){return Object.isFrozen(o)?o:b.$4m(o)}class k{constructor(t={},i=[],n=[],r){this.b=t,this.c=i,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof k)return i;const n=new v("");return n.parseRaw(i),n.configurationModel});this.f=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,E.$pi)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),r=i?this.rawConfiguration.getOverrideValue(t,i):void 0,l=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:r,merged:l}}getOverrideValue(t,i){const n=this.i(i);return n?t?(0,E.$pi)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return L.$Lb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.$Lb(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=b.$3m(this.contents),n=b.$3m(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const P of t)if(l.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(i,P.contents);for(const y of P.overrides){const[w]=n.filter(R=>L.$tb(R.identifiers,y.identifiers));w?(this.h(w.contents,y.contents),w.keys.push(...y.keys),w.keys=L.$Lb(w.keys)):n.push(b.$3m(y))}for(const y of P.keys)r.indexOf(y)===-1&&r.push(y)}return new k(i,r,n,l.every(P=>P instanceof k)?void 0:l)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const r of L.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r];const P=i[r];P&&(typeof l=="object"&&typeof P=="object"?(l=b.$3m(l),this.h(l,P)):l=P),n[r]=l}return new k(n,this.keys,this.overrides)}h(t,i){for(const n of Object.keys(i)){if(n in t&&u.$zf(t[n])&&u.$zf(i[n])){this.h(t[n],i[n]);continue}t[n]=b.$3m(i[n])}}i(t){let i=null,n=null;const r=l=>{l&&(n?this.h(n,l):n=b.$3m(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?i=l.contents:l.identifiers.includes(t)&&r(l.contents);return r(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,E.$oi)(this.contents,t),O.$rn.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>L.$tb(n.identifiers,(0,O.$sn)(t))),1))}j(t,i,n){(0,E.$ni)(this.contents,t,i,r=>console.error(r)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),O.$rn.test(t)&&this.overrides.push({identifiers:(0,O.$sn)(t),keys:Object.keys(this.contents[t]),contents:(0,E.$mi)(this.contents[t],r=>console.error(r))})}}e.$xn=k;class v{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!u.$Gf(t)){const n=this.g(t);this.parseRaw(n,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:n,keys:r,overrides:l,restricted:P,hasExcludedProperties:y}=this.h(t,i);this.b=new k(n,r,l,y?[t]:void 0),this.c=P||[]}g(t){let i={},n=null,r=[];const l=[],P=[];function y(R){Array.isArray(r)?r.push(R):n!==null&&(r[n]=R)}const w={onObjectBegin:()=>{const R={};y(R),l.push(r),r=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const R=[];y(R),l.push(r),r=R,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:y,onError:(R,W,_)=>{P.push({error:R,offset:W,length:_})}};if(t)try{N.$Zm(t,w),i=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return i}h(t,i){const n=m.$cn.as(O.$hn.Configuration).getConfigurationProperties(),r=this.i(t,n,!0,i);t=r.raw;const l=(0,E.$mi)(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),P=Object.keys(t),y=this.j(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:l,keys:P,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(t,i,n,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const P={},y=[];for(const w in t)if(O.$rn.test(w)&&n){const R=this.i(t[w],i,!1,r);P[w]=R.raw,l=l||R.hasExcludedProperties,y.push(...R.restricted)}else{const R=i[w],W=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&y.push(w),!r.exclude?.includes(w)&&(r.include?.includes(w)||(W===void 0||r.scopes===void 0||r.scopes.includes(W))&&!(r.skipRestricted&&R?.restricted))?P[w]=t[w]:l=!0}return{raw:P,restricted:y,hasExcludedProperties:l}}j(t,i){const n=[];for(const r of Object.keys(t))if(O.$rn.test(r)){const l={};for(const P in t[r])l[P]=t[r][P];n.push({identifiers:(0,O.$sn)(r),keys:Object.keys(l),contents:(0,E.$mi)(l,i)})}return n}}e.$yn=v;class $ extends A.$Rc{constructor(t,i,n,r){super(),this.c=t,this.f=i,this.g=r,this.b=this.B(new D.$Md),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zn=$;class h{constructor(t,i,n,r,l,P,y,w,R,W,_,Y,ue){this.a=t,this.b=i,this.c=n,this.overrideIdentifiers=r,this.d=l,this.f=P,this.g=y,this.h=w,this.i=R,this.j=W,this.k=_,this.l=Y,this.m=ue}get value(){return d(this.c)}n(t,i,n){const r=t.inspect(i,n);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(t,i,n,r,l=new k,P=new k,y=new j.$zc,w=new k,R=new j.$zc){this.c=t,this.d=i,this.f=n,this.g=r,this.h=l,this.i=P,this.j=y,this.l=w,this.m=R,this.a=null,this.b=new j.$zc,this.n=null}getValue(t,i,n){return this.q(t,i,n).getValue(t)}updateValue(t,i,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new k,this.m.set(n.resource,r))):r=this.l,i===void 0?r.removeValue(t):r.setValue(t,i),n.resource||(this.a=null)}inspect(t,i,n){const r=this.q(t,i,n),l=this.u(i.resource,n),P=i.resource?this.m.get(i.resource)||this.l:this.l,y=new Set;for(const w of r.overrides)for(const R of w.identifiers)r.getOverrideValue(t,R)!==void 0&&y.add(R);return new h(t,i,r.getValue(t),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,l||void 0,P)}keys(t){const i=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:r,updated:l,removed:P}=S(this.c,t);i=[...r,...l,...P]}for(const r of i)for(const l of(0,O.$sn)(r)){const P=this.c.getKeysForOverrideIdentifier(l),y=t.getKeysForOverrideIdentifier(l),w=[...y.filter(R=>P.indexOf(R)===-1),...P.filter(R=>y.indexOf(R)===-1),...P.filter(R=>!b.$7m(this.c.override(l).getValue(R),t.override(l).getValue(R)))];n.push([l,w])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:r}=S(this.d,t),l=[...i,...n,...r];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.applicationConfiguration,t),P=[...i,...n,...r];return P.length&&this.updateApplicationConfiguration(t),{keys:P,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.localUserConfiguration,t),P=[...i,...n,...r];return P.length&&this.updateLocalUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.remoteUserConfiguration,t),P=[...i,...n,...r];return P.length&&this.updateRemoteUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.workspaceConfiguration,t),P=[...i,...n,...r];return P.length&&this.updateWorkspaceConfiguration(t),{keys:P,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const n=this.p.get(t),{added:r,updated:l,removed:P,overrides:y}=S(n,i),w=[...r,...l,...P];return(w.length||!n)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:y}}compareAndDeleteFolderConfiguration(t){const i=this.p.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:l,overrides:P}=S(i,void 0);return{keys:[...n,...r,...l],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,i,n){let r=this.r(i,n);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(r=r.merge(this.d)),r}r({resource:t},i){let n=this.s();if(i&&t){const r=i.getFolder(t);r&&(n=this.t(r.uri)||n);const l=this.m.get(t);l&&(n=n.merge(l))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let i=this.b.get(t);if(!i){const n=this.s(),r=this.j.get(t);r?(i=n.merge(r),this.b.set(t,i)):i=n}return i}u(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:n,overrides:r,keys:l}=this.j.get(i);return t.push([i,{contents:n,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}w(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.x(t.defaults),n=this.x(t.policy),r=this.x(t.application),l=this.x(t.user),P=this.x(t.workspace),y=t.folders.reduce((w,R)=>(w.set(c.URI.revive(R[0]),this.x(R[1])),w),new j.$zc);return new f(i,n,r,l,new k,P,y,new k,new j.$zc)}static x(t){return new k(t.contents,t.keys,t.overrides)}}e.$An=f;function I(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const r of o)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,P])=>{const y=(0,j.$wc)(i,l,new Set);P.forEach(w=>y.add(w))});const n=[];return i.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.$Bn=I;class p{constructor(t,i,n,r){this.change=t,this.f=i,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const P of l)this.affectedKeys.add(P);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(t,i){const n=this.a+t,r=this.d.indexOf(n);if(r<0)return!1;const l=r+n.length;if(l>=this.d.length)return!1;const P=this.d.charCodeAt(l);if(P!==this.b&&P!==this.c)return!1;if(i){const y=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,w=this.g.getValue(t,i,this.h);return!b.$7m(y,w)}return!0}}e.$Cn=p;function S(o,t){const{added:i,removed:n,updated:r}=s(t?.rawConfiguration,o?.rawConfiguration),l=[],P=o?.getAllOverrideIdentifiers()||[],y=t?.getAllOverrideIdentifiers()||[];if(t){const w=y.filter(R=>!P.includes(R));for(const R of w)l.push([R,t.getKeysForOverrideIdentifier(R)])}if(o){const w=P.filter(R=>!y.includes(R));for(const R of w)l.push([R,o.getKeysForOverrideIdentifier(R)])}if(t&&o){for(const w of P)if(y.includes(w)){const R=s({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:t.getOverrideValue(void 0,w)||{},keys:t.getKeysForOverrideIdentifier(w)});l.push([w,[...R.added,...R.removed,...R.updated]])}}return{added:i,removed:n,updated:r,overrides:l}}function s(o,t){const i=o?t?o.keys.filter(l=>t.keys.indexOf(l)===-1):[...o.keys]:[],n=t?o?t.keys.filter(l=>o.keys.indexOf(l)===-1):[...t.keys]:[],r=[];if(o&&t){for(const l of t.keys)if(o.keys.indexOf(l)!==-1){const P=(0,E.$pi)(t.contents,l),y=(0,E.$pi)(o.contents,l);b.$7m(P,y)||r.push(l)}}return{added:i,removed:n,updated:r}}}),define(ne[132],re([0,1,19,4,2,30,3,66,43,6,38,36]),function(J,e,L,D,N,A,j,b,u,c,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=void 0;class m extends N.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new b.$xn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(O.$cn.as(u.$hn.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:h})=>this.c(Array.from($),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,h){this.h($,O.$cn.as(u.$hn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new b.$xn;const $=O.$cn.as(u.$hn.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,h){const f=this.f();for(const I of $){const p=f[I],S=h[I];p!==void 0?this.b.addValue(I,p):S?this.b.addValue(I,S.default):this.b.removeValue(I)}}}e.$Dn=m;class d{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new b.$xn}async initialize(){return this.configurationModel}}e.$En=d;let k=class extends N.$Rc{get configurationModel(){return this.b}constructor($,h,f){super(),this.c=$,this.f=h,this.g=f,this.a=this.B(new D.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new b.$xn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const h={},f=[],I=O.$cn.as(u.$hn.Configuration).getConfigurationProperties();for(const p of $){const S=I[p];if(!S){f.push(p);continue}if(S.policy){if(S.type!=="string"&&S.type!=="number"){this.g.warn(`Policy ${S.policy.name} has unsupported type ${S.type}`);continue}f.push(p),h[S.policy.name]={type:S.type}}}return(0,j.$Kf)(h)||await this.f.updatePolicyDefinitions(h),f}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const h=O.$cn.as(u.$hn.Configuration).getPolicyConfigurations(),f=(0,L.$Gb)($.map(I=>h.get(I)));this.m(f,!0)}m($,h){this.g.trace("PolicyConfiguration#update",$);const f=O.$cn.as(u.$hn.Configuration).getConfigurationProperties(),I=[],p=this.b.isEmpty();for(const S of $){const s=f[S]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(p?o!==void 0:!(0,A.$7m)(this.b.getValue(S),o))&&I.push([S,o])}else this.b.getValue(S)!==void 0&&I.push([S,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const S=this.b;this.b=new b.$xn;for(const s of S.keys)this.b.setValue(s,S.getValue(s));for(const[s,o]of I)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);h&&this.a.fire(this.b)}}};e.$Fn=k,e.$Fn=k=pe([se(1,E.$en),se(2,c.$8i)],k)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(J,e,L,D,N,A,j,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0;class E extends N.$Rc{constructor(m,d,k,v){super(),this.j=m,this.h=this.B(new D.$Md),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$Dn),this.c=k instanceof c.$gn?new u.$En:this.B(new u.$Fn(this.b,k,v)),this.f=this.B(new b.$zn(this.j,{},A.$lg,d)),this.a=new b.$An(this.b.configurationModel,this.c.configurationModel,new b.$xn,new b.$xn),this.g=this.B(new L.$5g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:h})=>this.n($,h))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,d,k]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.$An(m,d,new b.$xn,k)}getConfigurationData(){return this.a.toData()}getValue(m,d){const k=typeof m=="string"?m:void 0,v=(0,j.$ii)(m)?m:(0,j.$ii)(d)?d:{};return this.a.getValue(k,v,void 0)}updateValue(m,d,k,v){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.m(m)}m(m){const d=this.a.toData(),k=this.a.compareAndUpdateLocalUserConfiguration(m);this.s(k,d,2)}n(m,d){const k=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(m,d);this.s(v,k,7)}r(m){const d=this.a.toData(),k=this.a.compareAndUpdatePolicyConfiguration(m);this.s(k,d,7)}s(m,d,k){const v=new b.$Cn(m,{data:d},this.a);v.source=k,v.sourceConfig=this.t(k),this.h.fire(v)}t(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Gn=E}),define(ne[67],re([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=void 0;function D(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$Sk=D;function N(c){if(!c)return;const E=c.indexOf("+");return E<0?c:c.substr(0,E)}e.$Tk=N;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Uk=A;function j(c){const{host:E,port:O}=u(c);if(typeof O>"u")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:O}}e.$Vk=j;function b(c,E){let{host:O,port:m}=u(c);return typeof m>"u"&&(m=E),{host:O,port:m}}e.$Wk=b;function u(c){const E=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const O=c.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const m=c.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:c,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(J,e,L,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.TargetPlatform=e.ExtensionType=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=void 0,e.$Wl="extensions.user.cache",e.$Xl="extensions.builtin.cache",e.$Yl="undefined_publisher",e.$Zl=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$1l=A,e.$2l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var j;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(j||(e.ExtensionType=j={}));var b;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class u{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,h){if(typeof $>"u"||$===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof $=="string"||typeof h=="string"){const f=typeof $=="string"?$:$.value,I=typeof h=="string"?h:h.value;return L.$1e(f,I)}return $._lower===h._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$3l=u;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const h of $)this.add(h)}add($){this.c.add(u.toKey($))}delete($){return this.c.delete(u.toKey($))}has($){return this.c.has(u.toKey($))}}e.$4l=c;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(u.toKey($))}get($){return this.c.get(u.toKey($))}has($){return this.c.has(u.toKey($))}set($,h){this.c.set(u.toKey($),h)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$5l=E;function O(v){return m(v)}e.$6l=O;function m(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$7l=m;function d(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$8l=d;function k(v,$){if($){const h=`onResolveRemoteAuthority:${(0,N.$Tk)($)}`;return!!v.activationEvents?.includes(h)}return!1}e.$9l=k,e.$0l=(0,D.$Nh)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,12]),function(J,e,L,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;class A extends L.$Rc{constructor(b,u,c,E,O){super(),this.a=b,this.b=u,this.c=c,this.f=O,this.B(E.onDidInstallExtensions(m=>this.g(m))),this.B(E.onDidUninstallExtension(m=>this.h(m)))}g(b){for(const u of b)u.local&&this.invalidate(u.profileLocation)}h(b){b.error||this.invalidate(b.profileLocation)}async invalidate(b){if(b)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,b)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(b){try{await this.b.del(this.c.extUri.joinPath(b.cacheHome,D.$Wl))}catch(u){(0,N.$nk)(u)!==1&&this.f.error(u)}}}e.$Dp=A}),define(ne[44],re([0,1,14,9,2,103,43,10,6,36]),function(J,e,L,D,N,A,j,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0,e.$Po=(0,b.$Nh)("requestService");class E{constructor(S){this.b=S}toJSON(){if(!this.a){const S=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?S[s]="*****":S[s]=this.b[s];this.a=S}return this.a}}class O extends N.$Rc{constructor(S){super(),this.b=0,this.a=S.createLogger("network",{name:(0,A.localize)(0,null),when:u.$mj.isEqualTo((0,u.$kj)(u.LogLevel.Trace)).serialize()})}async c(S,s,o){const t=`${S} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new E(s.headers??{}));try{const i=await o();return this.a.trace(`${t} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,s.type,(0,D.$9)(i)),i}}}e.$Qo=O;function m(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Ro=m;function d(p){return p.res.statusCode===204}e.$So=d;async function k(p){return d(p)?null:(await(0,L.$me)(p.stream)).toString()}e.$To=k;async function v(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);return k(p)}e.$Uo=v;async function $(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const s=(await(0,L.$me)(p.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$Vo=$;function h(p){I(p)}e.$Wo=h;let f;function I(p){const S=c.$cn.as(j.$hn.Configuration),s=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},S.updateConfigurations({add:[f],remove:s?[s]:[]})}I(1)}),define(ne[135],re([0,1,20,15,12,44]),function(J,e,L,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;let j=class{constructor(u,c){this.a=u,this.b=c}async download(u,c,E=L.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,c);return}const O={type:"GET",url:u.toString(!0)},m=await this.a.request(O,E);if(m.res.statusCode===200)await this.b.writeFile(c,m.stream);else{const d=await(0,A.$Uo)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${d}`)}}};e.$NN=j,e.$NN=j=pe([se(0,A.$Po),se(1,N.$9j)],j)}),define(ne[136],re([0,1,137,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;function N(j,b){return j.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:j.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function A(j,b,u={}){const c=(0,L.parse)(j),E=u.proxyUrl||N(c,b);if(!E)return null;const O=(0,L.parse)(E);if(!/^https?:$/.test(O.protocol||""))return null;const m={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,D.$Df)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((d,k)=>{J(["http-proxy-agent"],d,k)}))(m):new(await new Promise((d,k)=>{J(["https-proxy-agent"],d,k)}))(m)}e.$Uq=A}),define(ne[138],re([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=void 0;let k;async function v(h,f,I,p){return I["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$j?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.$Kl)(p)&&!I["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.$Kl)(p)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),k||(k=m.Promises.withAsyncBody(async(S,s)=>{const o=new A.$Wd;let t=1e4;const i=h.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,d.$Ll)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),s(new Error((0,N.localize)(0,null)))},t);try{S(await $(f,o.token))}catch(r){!(0,b.$3)(r)&&!o.token.isCancellationRequested?s(new Error((0,N.localize)(1,null,(0,j.$yi)(r)))):S({})}finally{clearTimeout(n),o.dispose()}})),k)}e.$Ql=v;async function $(h,f){const I=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",I);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",p);const S=(0,c.$dg)().replace(/-/g,"").substr(0,12),s=new RegExp(S+"({.*})"+S),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",o);const t=await(0,E.$Al)(u.OS,o);return h.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if(f.isCancellationRequested)return n(new b.$4);const r=(0,D.$mc)(t);let l,P;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${y} -p '''${S}'' + JSON.stringify(process.env) + ''${S}'''`,P=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${y} -p '"${S}" + JSON.stringify(process.env) + "${S}"'`,P=["-i","-l","-c"]):(l=`'${process.execPath}' ${y} -p '"${S}" + JSON.stringify(process.env) + "${S}"'`,r==="tcsh"||r==="csh"?P=["-ic"]:P=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const w=(0,L.spawn)(t,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(w.kill(),n(new b.$4))),w.on("error",_=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,j.$yi)(_)),n(_)});const R=[];w.stdout.on("data",_=>R.push(_));const W=[];w.stderr.on("data",_=>W.push(_)),w.on("close",(_,Y)=>{const ue=Buffer.concat(R).toString("utf8");h.trace("getUnixShellEnvironment#raw",ue);const te=Buffer.concat(W).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),_||Y)return n(new Error((0,N.localize)(2,null,_,Y)));const ae=s.exec(ue),le=ae?ae[1]:"{}";try{const ie=JSON.parse(le);I?ie.ELECTRON_RUN_AS_NODE=I:delete ie.ELECTRON_RUN_AS_NODE,p?ie.ELECTRON_NO_ATTACH_CONSOLE=p:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",ie),i(ie)}catch(ie){h.error("getUnixShellEnvironment#errorCaught",(0,j.$yi)(ie)),n(ie)}})})}}),define(ne[139],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=void 0,e.$pN=(0,L.$Nh)("stateReadService"),e.$qN=(0,L.$Nh)("stateService")}),define(ne[68],re([0,1,8,14,2,3,18,12,6]),function(J,e,L,D,N,A,j,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=e.$sN=e.$rN=e.SaveStrategy=void 0;var c;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class E extends N.$Rc{constructor(k,v,$,h){super(),this.h=k,this.j=$,this.m=h,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=v===0?void 0:this.B(new L.$Qg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(k){k.fileOperationResult!==1&&this.j.error(k)}}getItem(k,v){const $=this.a[k];return(0,A.$Gf)($)?v:$}setItem(k,v){this.setItems([{key:k,data:v}])}setItems(k){let v=!1;for(const{key:$,data:h}of k)this.a[$]!==h&&((0,A.$Gf)(h)?(0,A.$Ef)(this.a[$])||(this.a[$]=void 0,v=!0):(this.a[$]=h,v=!0));v&&this.r()}removeItem(k){(0,A.$Ef)(this.a[k])||(this.a[k]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const k=JSON.stringify(this.a,null,4);if(k!==this.b)try{await this.m.writeFile(this.h,D.$ae.fromString(k),{atomic:{postfix:".vsctmp"}}),this.b=k}catch(v){this.j.error(v)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$rN=E;let O=class extends N.$Rc{constructor(k,v,$,h){super(),this.a=this.B(new E(v.stateResource,k,$,h))}async init(){await this.a.init()}getItem(k,v){return this.a.getItem(k,v)}};e.$sN=O,e.$sN=O=pe([se(1,j.$Uh),se(2,u.$8i),se(3,b.$9j)],O);class m extends O{setItem(k,v){this.a.setItem(k,v)}setItems(k){this.a.setItems(k)}removeItem(k){this.a.removeItem(k)}close(){return this.a.close()}}e.$tN=m}),define(ne[69],re([0,1,13,35,28]),function(J,e,L,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=void 0;function A(u){if(L.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function j(u,c,E,O,m,d,k,v){const $=Object.create(null);$["common.machineId"]=d,$.sessionID=(0,N.$dg)()+Date.now(),$.commitHash=O,$.version=m,$["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,L.$i)(L.$u),$["common.nodePlatform"]=D.$cc,$["common.nodeArch"]=E,$["common.product"]=v||"desktop",k&&($["common.msftInternal"]=k);let h=0;const f=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),L.$m&&($["common.snap"]="true");const I=A(c);return I&&($["common.platformDetail"]=I),$}e.$eo=j;function b(u){const c=D.env.USERDNSDOMAIN;if(!c)return!1;const E=c.toLowerCase();return u.some(O=>E===O)}e.$fo=b}),define(ne[26],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0,e.$al=(0,L.$Nh)("telemetryService"),e.$bl=(0,L.$Nh)("customEndpointTelemetryService"),e.$cl="telemetry.currentSessionDate",e.$dl="telemetry.firstSessionDate",e.$el="telemetry.lastSessionDate",e.$fl="telemetry.machineId",e.$gl="telemetry",e.$hl="telemetry.telemetryLevel",e.$il="telemetry.enableCrashReporter",e.$jl="telemetry.enableTelemetry";var D;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var N;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(N||(e.TelemetryConfiguration=N={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(J,e,L,D,N,A,j,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$go=c;class E{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ho=E,e.$io=new E;class O{async publicLog(n,r,l){}async publicLogError(n,r,l){}}e.$jo=O,e.$ko="telemetry",e.$lo="extensionTelemetryLog",e.$mo={log:()=>null,flush:()=>Promise.resolve(null)};function m(i,n){return N.Event.debounce(n.onDidChangeConfiguration,(l,P)=>{const y=l?new Set([...l.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:y}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.$ki)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$no=m;function d(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$oo=d;function k(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$po=k;function v(i){const n=i.getValue(u.$hl),r=i.getValue(u.$il);if(i.getValue(u.$jl)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$qo=v;function $(i){const n={},r={},l={};I(i,l);for(let P in l){P=P.length>150?P.substr(P.length-149):P;const y=l[P];typeof y=="number"?r[P]=y:typeof y=="boolean"?r[P]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${y.length}`),n[P]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(n[P]=y)}return{properties:n,measurements:r}}e.$ro=$;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(i){if(!i)return"none";const n=(0,j.$Tk)(i);return h.has(n)?n:"other"}e.$so=f;function I(i,n,r=0,l){if(i)for(const P of Object.getOwnPropertyNames(i)){const y=i[P],w=l?l+P:P;Array.isArray(y)?n[w]=(0,L.$8m)(y):y instanceof Date?n[w]=y.toISOString():(0,D.$zf)(y)?r<2?I(y,n,r+1,w+"."):n[w]=(0,L.$8m)(y):n[w]=y}}function p(i,n){const r=i.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,b.$fo)(r)||l}e.$to=p;function S(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$uo=S;function s(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const l=[];for(const R of n)for(;;){const W=R.exec(i);if(!W)break;l.push([W.index,R.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const R=y.exec(i);if(!R)break;const W=l.some(([_,Y])=>R.index<Y&&_<y.lastIndex);!P.test(R[0])&&!W&&(r+=i.substring(w,R.index)+"<REDACTED: user-file-path>",w=y.lastIndex)}return w<i.length&&(r+=i.substr(w)),r}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function t(i,n){return(0,L.$5m)(i,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=s(l,n);for(const P of n)l=l.replace(P,"");return l=o(l),l}})}e.$vo=t}),define(ne[27],re([0,1,29,21,37,13,11,9,35,39]),function(J,e,L,D,N,A,j,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0;function E(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.$Ve)(t.id,i.id)===0}e.$wo=E;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(i){const n=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new m(i.identifier,n,r)}static parse(i){const n=O.exec(i);return n&&n[1]&&n[2]?new m({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof m?E(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$xo=m;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(t){const i=d.exec(t);return i&&i[1]?[$(i[1]),i[2]]:[$(t),void 0]}e.$yo=k;function v(t,i){return`${t}.${i}`}e.$zo=v;function $(t){return t.toLowerCase()}e.$Ao=$;function h(t,i){return $(v(t??N.$Yl,i))}e.$Bo=h;function f(t,i){const n=[],r=l=>{for(const P of n)if(P.some(y=>E(i(y),i(l))))return P;return null};for(const l of t){const P=r(l);P?P.push(l):n.push([l])}return n}e.$Co=f;function I(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$Do=I;function p(t){return{id:new c.$go(t.identifier.id),name:new c.$go(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Eo=p,e.$Fo=new N.$3l("pprice.better-merge");function S(t,i){const n=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&n.every(P=>!E(P.identifier,{id:l}))){const P=t.filter(y=>E(y.identifier,{id:l}));P.length===1&&(n.push(P[0]),r.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Go=S;async function s(t,i){if(!A.$l)return!1;let n;try{n=(await t.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,b.$9)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const n=await s(t,i),r=(0,D.$2n)(n?"alpine":A.$u,u.$dc);return i.debug("ComputeTargetPlatform:",r),r}e.$Ho=o}),define(ne[140],re([0,1,20,9,15,17,42,11,93,21,27,37]),function(J,e,L,D,N,A,j,b,u,c,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;const m=$=>(0,u.localize)(0,null,$),d=(0,u.localize)(1,null,"ms-dotnettools.csharp");function k($,h){return h?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let v=class{constructor(h,f,I){this.a=h,this.b=f,this.d=I}get f(){}async listExtensions(h,f,I){let p=await this.b.getInstalled(1,I);const S=O.$2l.map(o=>o.toLowerCase());if(f&&f!==""){if(S.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),S.forEach(o=>{this.a.info(o)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),p=p.sort((o,t)=>o.identifier.id.localeCompare(t.identifier.id));let s;for(const o of p)s!==o.identifier.id&&(s=o.identifier.id,this.a.info(k(o.manifest,h)))}async installExtensions(h,f,I,p){const S=[];try{const s=[];h.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const o=[];let t=[];const i=(r,l,P)=>{t.push({id:r,version:l!=="prerelease"?l:void 0,installOptions:{...I,isBuiltin:P,installPreReleaseVersion:l==="prerelease"||I.installPreReleaseVersion}})};for(const r of h)if(r instanceof b.URI)o.push({vsix:r,installOptions:I});else{const[l,P]=(0,E.$yo)(r);i(l,P,!1)}for(const r of f)if(r instanceof b.URI)o.push({vsix:r,installOptions:{...I,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,P]=(0,E.$yo)(r);i(l,P,!0)}const n=await this.b.getInstalled(1,I.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:r,installOptions:l})=>{try{const P=await this.g(r,l,p,n);P&&s.push(P)}catch(P){this.a.error(P),S.push(r.toString())}})),t.length&&(t=t.filter(({id:r,version:l})=>{const P=n.find(y=>(0,E.$wo)(y.identifier,{id:r}));if(P){if(!p&&(!l||l==="prerelease"&&P.preRelease))return this.a.info((0,u.localize)(5,null,r,P.manifest.version,r)),!1;if(l&&P.manifest.version===l)return this.a.info((0,u.localize)(6,null,`${r}@${l}`)),!1}return!0}),t.length)){const r=await this.h(t);await Promise.all(t.map(async l=>{const P=r.get(l.id.toLowerCase());if(P)try{const y=await this.j(l,P,n);y&&s.push(y)}catch(y){this.a.error(y.message||y.stack||y),S.push(l.id)}else this.a.error(`${m(l.version?`${l.id}@${l.version}`:l.id)}
${d}`),S.push(l.id)}))}}catch(s){throw this.a.error((0,u.localize)(7,null,(0,D.$9)(s))),s}if(S.length)throw new Error((0,u.localize)(8,null,S.join(", ")))}async g(h,f,I,p){const S=await this.b.getManifest(h);if(!S)throw new Error("Invalid vsix");if(await this.l(S,I,f.profileLocation,p))try{return await this.b.install(h,f),this.a.info((0,u.localize)(9,null,(0,A.$rg)(h))),S}catch(o){if((0,D.$3)(o))return this.a.info((0,u.localize)(10,null,(0,A.$rg)(h))),null;throw o}return null}async h(h){const f=new Map,I=h.some(s=>s.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),S=[];for(const s of h)c.$Un.test(s.id)&&S.push({...s,preRelease:I});if(S.length){const s=await this.d.getExtensions(S,{targetPlatform:p},L.CancellationToken.None);for(const o of s)f.set(o.identifier.id.toLowerCase(),o)}return f}async j({id:h,version:f,installOptions:I},p,S){const s=await this.d.getManifest(p,L.CancellationToken.None);if(s&&!this.k(s))return null;const o=S.find(t=>(0,E.$wo)(t.identifier,p.identifier));if(o){if(p.version===o.manifest.version)return this.a.info((0,u.localize)(11,null,f?`${h}@${f}`:h)),null;this.a.info((0,u.localize)(12,null,h,p.version))}try{I.isBuiltin?this.a.info(f?(0,u.localize)(13,null,h,f):(0,u.localize)(14,null,h)):this.a.info(f?(0,u.localize)(15,null,h,f):(0,u.localize)(16,null,h));const t=await this.b.installFromGallery(p,{...I,installGivenVersion:!!f});return this.a.info((0,u.localize)(17,null,h,t.manifest.version)),s}catch(t){if((0,D.$3)(t))return this.a.info((0,u.localize)(18,null,h)),null;throw t}}k(h){return!0}async l(h,f,I,p){if(!f){const S={id:(0,E.$Bo)(h.publisher,h.name)},s=p.find(o=>(0,E.$wo)(S,o.identifier)&&(0,j.gt)(o.manifest.version,h.version));if(s)return this.a.info((0,u.localize)(19,null,s.identifier.id,s.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,f,I){const p=async s=>{if(s instanceof b.URI){const o=await this.b.getManifest(s);return k(o)}return s},S=[];for(const s of h){const o=await p(s),i=(await this.b.getInstalled(void 0,I)).filter(n=>(0,E.$wo)(n.identifier,{id:o}));if(!i.length)throw new Error(`${this.m(o)}
${d}`);if(i.some(n=>n.type===0)){this.a.info((0,u.localize)(20,null,o));return}if(!f&&i.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(21,null,o));return}this.a.info((0,u.localize)(22,null,o));for(const n of i)await this.b.uninstall(n,{profileLocation:I}),S.push(n);this.f?this.a.info((0,u.localize)(23,null,o,this.f)):this.a.info((0,u.localize)(24,null,o))}}async locateExtension(h){const f=await this.b.getInstalled();h.forEach(I=>{f.forEach(p=>{if(p.identifier.id===I&&p.location.scheme===N.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(h){return this.f?(0,u.localize)(25,null,h,this.f):(0,u.localize)(26,null,h)}};e.$dp=v,e.$dp=v=pe([se(1,c.$9n),se(2,c.$7n)],v)}),define(ne[141],re([0,1,4,2,31,27,37]),function(J,e,L,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;class b extends D.$Rc{constructor(c,E,O,m,d,k,v){super(),this.f=c,this.g=E,this.h=O,this.j=m,this.m=d,this.n=k,this.r=v,this.a=this.B(new L.$Md),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$Zc),this.s().then(null,$=>v.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(E=>(this.c.set(E.id,(0,D.$Oc)(this.n.watch(this.m.extUri.dirname(E.extensionsResource)),this.n.watch(E.extensionsResource))),this.G(E.extensionsResource))))}catch(E){throw this.r.error(E),E}}async w(c){for(const E of c.extensions)this.I(this.L(E.identifier,E.version),c.profileLocation)}async y(c){for(const E of c.extensions){const O=this.L(E.identifier,E.version);c.error?this.J(O,c.profileLocation):this.I(O,c.profileLocation)}}async z(c){for(const E of c.extensions)this.J(this.L(E.identifier,E.version),c.profileLocation)}async C(c){const E=[],O=[];for(const m of c.extensions){const d=this.L(m.identifier,m.version);c.error?this.I(d,c.profileLocation):(this.J(d,c.profileLocation),this.b.has(d)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),O.push(this.f.scanInstalledExtensionAtLocation(m.location).then(k=>{k?E.push(k):this.r.info("Extension not found at the location",m.location.toString())},k=>this.r.error(k)))))}try{await Promise.all(O),E.length&&await this.H(E)}catch(m){this.r.error(m)}}D(c){for(const E of this.h.profiles)c.contains(E.extensionsResource,0,1)&&this.F(E.extensionsResource)}async F(c){const E=[],O=[],m=await this.j.scanProfileExtensions(c),d=new Set,k=new Set;for(const[v,$]of this.b)$.has(c)&&k.add(v);for(const v of m){const $=this.L(v.identifier,v.version);d.add($),k.has($)||(E.push(v.identifier),this.I($,c))}for(const v of k)if(!d.has(v)){const $=this.M(v);$&&(O.push($.identifier),this.J(v,c))}(E.length||O.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:c}:void 0,removed:O.length?{extensions:O,profileLocation:c}:void 0})}async G(c){const E=await this.j.scanProfileExtensions(c);for(const O of E)this.I(this.L(O.identifier,O.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(O=>!this.b.has(this.L(O.identifier,O.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,E){let O=this.b.get(c);O||this.b.set(c,O=new N.$Ac(m=>this.m.extUri.getComparisonKey(m))),O.add(E)}J(c,E){const O=this.b.get(c);O&&O.delete(E),O?.size||this.b.delete(c)}L(c,E){return`${j.$3l.toKey(c.id)}@${E}`}M(c){const[E,O]=(0,A.$yo)(c);return O?{identifier:{id:E},version:O}:void 0}}e.$Ep=b}),define(ne[142],re([0,1,113,39]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=void 0;async function N(A,j,b,u,c,E,O){const m={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${j.nameShort})`};if((0,D.$oo)(j,b)&&(0,D.$qo)(u)===3){const d=await(0,L.$9o)(b,c,E);m["X-Market-User-Id"]=d,m["VSCode-SessionId"]=O.machineId||d}return m}e.$0o=N}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;let v=class extends d.$Qq{constructor(I,p,S,s){super(S),this.h=I,this.j=s,this.g=this.B(new $(p,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(I,p){const s=(await this.g.getLanguagePacks())[p];if(!s){this.j.warn(`No language pack found for ${p}`);return}const o=s.translations[I];return o?k.URI.file(o):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),p=Object.keys(I).map(S=>{const s=I[S];return{...this.f(S,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((S,s)=>S.label.localeCompare(s.label)),p}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const p=await this.g.getLanguagePacks();Object.keys(p).some(S=>p[S]&&p[S].extensions.some(s=>(0,O.$wo)(s.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),S=await this.g.update(p);return!(0,D.$tb)(Object.keys(I),Object.keys(S))}};e.$Rq=v,e.$Rq=v=pe([se(0,E.$9n),se(1,c.$Vh),se(2,E.$7n),se(3,m.$8i)],v);let $=class extends A.$Rc{constructor(I,p){super(),this.j=p,this.c={},this.f=(0,b.$ic)(I.userDataPath,"languagepacks.json"),this.g=new N.$Zg}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(p=>{Object.keys(p).forEach(S=>delete p[S]),this.m(p,...I)}).then(()=>this.c)}m(I,...p){for(const S of p)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.n(I,S);Object.keys(I).forEach(S=>this.r(I[S]))}n(I,p){const S=p.identifier,s=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of s)if(p.location.scheme===j.Schemas.file&&h(o)){let t=I[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},I[o.languageId]=t);const i=t.extensions.filter(n=>(0,O.$wo)(n.extensionIdentifier,S))[0];i?i.version=p.manifest.version:t.extensions.push({extensionIdentifier:S,version:p.manifest.version});for(const n of o.translations)t.translations[n.id]=(0,b.$ic)(p.location.fsPath,n.path)}}r(I){if(I){const p=(0,L.createHash)("md5");for(const S of I.extensions)p.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);I.hash=p.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let p=null;return u.Promises.readFile(this.f,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch{return{}}}).then(S=>(p=I(S),S)).then(S=>{for(const o of Object.keys(S))S[o]||delete S[o];this.c=S,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),u.Promises.writeFile(this.f,s)}).then(()=>p,S=>this.j.error(S))})}};$=pe([se(0,c.$Vh),se(1,m.$8i)],$);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const I of f.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[144],re([0,1,82,9,30,39]),function(J,e,L,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0;const j="https://mobile.events.data.microsoft.com/OneCollector/1.0",b="https://mobile.events.data.microsoft.com/ping";async function u(E,O,m){const d=await(0,L.$hC)("@microsoft/1ds-core-js","dist/ms.core.js"),k=await(0,L.$hC)("@microsoft/1ds-post-js","dist/ms.post.js"),v=new d.AppInsightsCore,$=new k.PostChannel,h={instrumentationKey:E,endpointUrl:j,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(m){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:m};h.extensionConfig[$.identifier]=f}return v.initialize(h,[]),v.addTelemetryInitializer(f=>{O&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),v}class c{constructor(O,m,d,k,v){this.e=O,this.f=m,this.g=d,this.h=v,this.c=j,this.d=b,this.g||(this.g={}),typeof k=="function"?this.a=k():this.a=k,this.b=null}i(O){if(this.a){if(typeof this.a!="string"){O(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(m=>{O(m)},m=>{(0,D.$Z)(m),console.error(m)})}}log(O,m){if(!this.a)return;m=(0,N.$6m)(m,this.g),m=(0,A.$ro)(m);const d=this.f+"/"+O;try{this.i(k=>{k.pluginVersionString=m?.properties.version??"Unknown",k.track({name:d,baseData:{name:d,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(O=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,O(void 0)})})}):Promise.resolve(void 0)}}e.$lN=c}),define(ne[145],re([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;let k=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,I){this.k=f,this.l=I,this.d={},this.i=new L.$Qc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$Ee)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Ee)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(m.$hl)||p.affectsConfiguration(m.$jl)||p.affectsConfiguration(m.$il))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,d.$qo)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const I=f.usage?3:f.error?2:0;h=Math.min(h,I)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,I){this.g<f||(I=(0,D.$6m)(I,this.d),I=(0,d.$vo)(I,this.j),I=(0,D.$6m)(I,this.c),this.b.forEach(p=>p.log(h,I)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$Xq=k,e.$Xq=k=pe([se(1,b.$hi),se(2,E.$nj)],k);function v(){const $=(0,j.localize)(0,null,c.default.nameLong),h=c.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=N.$p?"":(0,j.localize)(3,null),I=(0,j.localize)(4,null),p=(0,j.localize)(5,null),S=(0,j.localize)(6,null),s=(0,j.localize)(7,null),o=`
|       | ${I} | ${p} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,j.localize)(8,null);return`
${$} ${h} ${f}

&nbsp;

${s}
${o}

&nbsp;

${t}
`}O.$cn.as(u.$hn.Configuration).registerConfiguration({id:m.$gl,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[m.$hl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),O.$cn.as(u.$hn.Configuration).registerConfiguration({id:m.$gl,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[m.$jl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,j.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,j.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${m.$hl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,174,144]),function(J,e,L,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=void 0;async function j(E,O){const m=await O.request(E,D.CancellationToken.None),d=(await(0,L.$me)(m.stream)).toString(),k=m.res.statusCode??200;return{headers:m.res.headers,statusCode:k,responseData:d}}async function b(E){const O={method:E.type,headers:E.headers};return new Promise((d,k)=>{const v=N.request(E.url??"",O,$=>{$.on("data",function(h){d({headers:$.headers,statusCode:$.statusCode??200,responseData:h.toString()})}),$.on("error",function(h){k(h)})});v.write(E.data,$=>{$&&k($)}),v.end()})}async function u(E,O,m){const d=typeof O.data=="string"?O.data:new TextDecoder().decode(O.data),k={type:"POST",headers:{...O.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(O.data).toString()},url:O.urlString,data:d};try{const v=E?await j(k,E):await b(k);m(v.statusCode,v.headers,v.responseData)}catch{m(0,{})}}class c extends A.$lN{constructor(O,m,d,k,v){const $={sendPOST:(h,f)=>{u(O,h,f)}};super(m,d,k,v,$)}}e.$mN=c}),define(ne[148],re([0,1,16,24]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l8b=void 0;async function N(A,j){const b=Object.create(null),u=(E,O)=>{const m=JSON.parse(E);b[O]=m};if(j){const E=[],O=await D.Promises.readdir(j);for(const d of O)try{(await D.Promises.stat((0,L.$ic)(j,d))).isDirectory()&&E.push(d)}catch{}const m=[];for(const d of E)(await D.Promises.readdir((0,L.$ic)(j,d))).filter(v=>v==="telemetry.json").length===1&&m.push(d);for(const d of m){const k=(await D.Promises.readFile((0,L.$ic)(j,d,"telemetry.json"))).toString();u(k,d)}}let c=(await D.Promises.readFile((0,L.$ic)(A,"telemetry-core.json"))).toString();return u(c,"vscode-core"),c=(await D.Promises.readFile((0,L.$ic)(A,"telemetry-extensions.json"))).toString(),u(c,"vscode-extensions"),JSON.stringify(b,null,4)}e.$l8b=N}),define(ne[149],re([0,1,13,75,26]),function(J,e,L,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=void 0;async function A(j,b){let u=j.getItem(N.$fl);return(typeof u!="string"||L.$k&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,D.$Pm)(b.error.bind(b))),u}e.$F7b=A}),define(ne[22],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=void 0,e.$Gk=(0,L.$Nh)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,12,17,73,4,2]),function(J,e,L,D,N,A,j,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;class c{static{this._clock=0}constructor(m){this.uri=m,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let E=class{constructor(m){this.g=m,this.c=new u.$Qc,this.f=2**16;const d=new Map,k=v=>{let $=d.get(v.scheme);return $===void 0&&($=m.hasProvider(v)&&!this.g.hasCapability(v,1024),d.set(v.scheme,$)),$};this.c.add(b.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(v=>{d.delete(v.scheme)})),this.extUri=new A.$jg(k),this.d=new j.$vr((v,$)=>this.extUri.compare(v,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,A.$vg)(m));const d=this.d.get(m);return d?d.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new c(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((k,v)=>k[1].time<v[1].time?1:k[1].time>v[1].time?-1:0);c._clock=0,this.d.clear();const d=this.f*.5;for(let k=0;k<d;k++)this.d.set(m[k][0],m[k][1].touch())}};e.$wr=E,e.$wr=E=pe([se(0,N.$9j)],E),(0,D.$tr)(L.$Gk,E,1)}),define(ne[151],re([0,1,4,2,12,46,31]),function(J,e,L,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=void 0;class b extends D.$Rc{constructor(c,E,O,m,d,k){super(),this.f=c,this.g=E,this.h=O,this.j=m,this.m=d,this.n=k,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Md),this.onDidChangeFile=this.a.event,this.b=A.$Th.forUris(()=>!(this.capabilities&1024)),this.c=new j.$Ac(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,E){return this.g.open(this.t(c),E)}close(c){return this.g.close(c)}read(c,E,O,m,d){return this.g.read(c,E,O,m,d)}write(c,E,O,m,d){return this.g.write(c,E,O,m,d)}watch(c,E){this.b.set(c,c);const O=this.g.watch(this.t(c),E);return(0,D.$Pc)(()=>{this.b.delete(c),O.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,E,O){return this.g.rename(this.t(c),this.t(E),O)}readFile(c,E){return this.g.readFile(this.t(c),E)}readFileStream(c,E,O){return this.g.readFileStream(this.t(c),E,O)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,E,O){return this.g.writeFile(this.t(c),E,O)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,E){return this.g.delete(this.t(c),E)}copy(c,E,O){if((0,N.$ak)(this.g))return this.g.copy(this.t(c),this.t(E),O);throw new Error("copy not supported")}cloneFile(c,E){if((0,N.$bk)(this.g))return this.g.cloneFile(this.t(c),this.t(E));throw new Error("clone not supported")}s(c){const E=[];for(const O of c){if(O.resource.scheme!==this.f)continue;const m=this.u(O.resource);this.b.findSubstr(m)&&E.push({resource:m,type:O.type,cId:O.cId})}E.length&&(this.n.debug("User data changed"),this.a.fire(E))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$27b=b}),define(ne[152],re([0,1,107,16,46,17,11,10,15]),function(J,e,L,D,N,A,j,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,b.$Nh)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&j.URI.isUri(n.uri)}e.$Xh=c;function E(i){return typeof i?.id=="string"&&!c(i)&&!m(i)}e.$Yh=E,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function O(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$mc)(i)}:n?e.$Zh:e.$1h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$2h=O;function m(i){const n=i;return typeof n?.id=="string"&&j.URI.isUri(n.configPath)}e.$3h=m;function d(i){const n=i;if(n?.uri)return{id:n.id,uri:j.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:j.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$4h=d;var k;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$5h=v;function $(i){const n=i;return!!(n&&typeof n=="object"&&j.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$6h=$;class h{constructor(n,r,l,P,y){this.h=n,this.j=l,this.k=P,this.l=y,this.c=N.$Th.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=N.$Th.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=h;class f{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.$ug)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=f;function I(i){return new f({uri:i,index:0,name:(0,A.$qg)(i)},{uri:i.toString()})}e.$9h=I,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,L.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function p(i,n){return A.$lg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$bi=p;function S(i){let n;return j.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===u.Schemas.tmp}e.$ci=S,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$di}e.$ei=s;function o(i,n){return!p(i,n)&&!S(i)}e.$fi=o;function t(i){return(typeof i=="string"?(0,D.$nc)(i):(0,A.$sg)(i))===e.$$h}e.$gi=t}),define(ne[23],re([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d,k,v,$,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.ProfileResourceType=void 0;var I;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&j.URI.isUri(n.location)&&j.URI.isUri(n.globalStorageHome)&&j.URI.isUri(n.settingsResource)&&j.URI.isUri(n.keybindingsResource)&&j.URI.isUri(n.tasksResource)&&j.URI.isUri(n.snippetsHome)&&j.URI.isUri(n.extensionsResource))}e.$Hk=p,e.$Ik=(0,E.$Nh)("IUserDataProfilesService");function S(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:j.URI.revive(i.location).with({scheme:n}),globalStorageHome:j.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:j.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:j.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:j.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:j.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:j.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:j.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Jk=S;function s(i,n,r,l,P,y){return{id:i,name:n,location:r,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:y&&P?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$ug)(r,"globalStorage"),settingsResource:y&&P?.useDefaultFlags?.settings?y.settingsResource:(0,A.$ug)(r,"settings.json"),keybindingsResource:y&&P?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$ug)(r,"keybindings.json"),tasksResource:y&&P?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$ug)(r,"tasks.json"),snippetsHome:y&&P?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$ug)(r,"snippets"),extensionsResource:y&&P?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$ug)(r,"extensions.json"),cacheHome:(0,A.$ug)(l,i),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}e.$Kk=s;let o=class extends N.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,l,P){super(),this.t=n,this.u=r,this.w=l,this.y=P,this.f=!0,this.h=this.B(new D.$Md),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Md),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Md),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Md),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,f.$xf)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(s((0,A.$rg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},n))}}catch(y){this.y.error(y)}const l=new d.$zc,P=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[w,R]of Object.entries(y.workspaces)){const W=j.URI.parse(w),_=r.find(Y=>Y.id===R);_&&l.set(W,_)}if(y.emptyWindows)for(const[w,R]of Object.entries(y.emptyWindows)){const W=r.find(_=>_.id===R);W&&P.set(w,W)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:l,emptyWindows:P}}return this.z}D(){const n=s("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",l=new RegExp(`${(0,h.$Ee)(r)}\\s(\\d+)`);let P=0;for(const w of this.profiles){const R=l.exec(w.name),W=R?parseInt(R[1]):0;P=W>P?W:P}const y=`${r} ${P+1}`;return this.createProfile((0,L.$Bi)((0,$.$dg)()).toString(16),y,{transient:!0},n)}async createNamedProfile(n,r,l){return this.createProfile((0,L.$Bi)((0,$.$dg)()).toString(16),n,r,l)}async createProfile(n,r,l,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(n,r,l);return P&&await this.setProfileForWorkspace(P,y),y}async F(n,r,l){if(!(0,f.$xf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(r);return P||(P=(async()=>{try{const y=this.profiles.find(W=>W.name===r||W.id===n);if(y)return y;const w=s(n,r,(0,A.$ug)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(w.location);const R=[];return this.j.fire({profile:w,join(W){R.push(W)}}),await v.Promises.settled(R),this.I([w],[],[]),w}finally{this.r.delete(r)}})(),this.r.set(r,P)),P}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(P=>P.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=s(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(P=>P.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:r,join(P){l.push(P)}});try{await Promise.allSettled(l)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(P){(0,c.$nk)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(P=>P.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return j.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,m.$Xh)(n)?n.uri:(0,m.$3h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,l){const P=[...this.profiles,...n],y=[];this.s.profiles=[];for(let w of P)w.isDefault||r.some(R=>w.id===R.id)||(w=l.find(R=>w.id===R.id)??w,w.isTransient?this.s.profiles.push(w):y.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(y),this.z=void 0,this.J(n,r,l)}J(n,r,l){this.h.fire({added:n,removed:r,updated:l,all:this.profiles})}L(n,r,l){l=r?.isTransient?!0:l,l||this.L(n,void 0,!0);const P=this.G(n),y=l?this.s:this.C;j.URI.isUri(P)?(y.workspaces.delete(P),r&&y.workspaces.set(P,r)):(y.emptyWindows.delete(P),r&&y.emptyWindows.set(P,r)),l||this.M()}M(){const n={};for(const[l,P]of this.C.workspaces.entries())n[l.toString()]=P.id;const r={};for(const[l,P]of this.C.emptyWindows.entries())r[l.toString()]=P.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},l=this.D();if(n.workspaces)for(const[y,w]of Object.entries(n.workspaces)){const R=j.URI.parse(w);r[y]=this.w.extUri.isEqual(R,l.location)?l.id:this.w.extUri.basename(R)}const P={};if(n.emptyWindows)for(const[y,w]of Object.entries(n.emptyWindows)){const R=j.URI.parse(w);P[y]=this.w.extUri.isEqual(R,l.location)?l.id:this.w.extUri.basename(R)}return{workspaces:r,emptyWindows:P}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Lk=o,e.$Lk=o=pe([se(0,u.$Uh),se(1,c.$9j),se(2,k.$Gk),se(3,O.$8i)],o);class t extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Mk=t}),define(ne[153],re([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d,k,v,$,h,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=void 0;let p=class extends b.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,l,P,y,w){super(),this.z=n,this.C=r,this.D=l,this.F=P,this.G=y,this.H=w,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new j.$Md),this.s=this.B(new j.$Md),this.t=this.B(new j.$Md),this.u=this.B(new j.$Md),this.w=this.B(new j.$Md),this.y=[],this.B((0,b.$Pc)(()=>{this.j.forEach(({task:R})=>R.cancel()),this.m.forEach(R=>R.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,m.$4n)(l,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const P=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:y})=>(0,d.$wo)(y,n.identifier));if(P?.local)return P?.local;throw P?.error?P.error:s(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(l){throw s(l)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new m.$8n(O.localize(0,null),m.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(n.map(async({extension:P,options:y})=>{try{const w=await this.O(P,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);l.push({...w,options:y})}catch(w){r.push({identifier:P.identifier,operation:2,source:P,error:w})}})),l.length&&r.push(...await this.I(l));for(const P of r)P.error&&(this.F.error("Failed to install extension.",P.identifier.id),this.F.error(P.error),P.source&&!E.URI.isUri(P.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,d.$Eo)(P.source),error:P.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,k.$6l)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const P of this.H.profiles){const y=(await this.getInstalled(1,P.extensionsResource)).find(w=>(0,d.$wo)(w.identifier,n.identifier));y?this.w.fire(y):this.u.fire({identifier:n.identifier,profileLocation:P.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async l=>{try{const P=await this.J(l);r.push(...P)}catch(P){r.push({identifier:{id:(0,d.$Bo)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:P})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:l}){const P=l.isApplicationScoped||l.isBuiltin||(0,k.$6l)(n),y={...l,installOnlyNewlyAddedFromExtensionPack:E.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:P,profileLocation:P?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},w=te=>`${d.$xo.create(te).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!E.URI.isUri(r)){const te=this.j.get(w(r));if(te)return this.F.info("Extensions is already requested to install",r.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const R=[],W=[],_=[],Y=this.Z(n,r,y);E.URI.isUri(r)||this.j.set(w(r),{task:Y,waitingTasks:[]}),this.n.fire({identifier:Y.identifier,source:r,profileLocation:y.profileLocation}),this.F.info("Installing extension:",Y.identifier.id),R.push({task:Y,manifest:n});let ue=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",Y.identifier.id);else try{const ae=await this.N(Y.identifier,n,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),le=await this.getInstalled(void 0,y.profileLocation),ie={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[m.$Yn]:!0}};for(const{gallery:q,manifest:G}of(0,L.$Lb)(ae,({gallery:T})=>T.identifier.id)){ue=ue||!!G.extensionDependencies?.some(B=>(0,d.$wo)({id:B},Y.identifier));const T=w(q),U=this.j.get(T);if(U){if(this.L(Y,U.task)){const B=U.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,Y.identifier.id),U.waitingTasks.push(Y),W.push(j.Event.toPromise(j.Event.filter(this.onDidInstallExtensions,Z=>Z.some(x=>(0,d.$wo)(x.identifier,B)))).then(Z=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,Y.identifier.id),!Z.find(Q=>(0,d.$wo)(Q.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!le.some(({identifier:B})=>(0,d.$wo)(B,q.identifier))){const B=this.Z(G,q,ie);this.j.set(T,{task:B,waitingTasks:[Y]}),this.n.fire({identifier:B.identifier,source:q,profileLocation:y.profileLocation}),this.F.info("Installing extension:",B.identifier.id,Y.identifier.id),R.push({task:B,manifest:G})}}}catch(ae){if(E.URI.isUri(Y.source))(0,L.$Kb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",Y.identifier.id,ae.message),(0,L.$Kb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",Y.identifier.id,ae.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",Y.identifier.id),ae}const te=R.reduce((ae,{task:le,manifest:ie})=>(ae.set(le.identifier.id.toLowerCase(),{task:le,manifest:ie}),ae),new Map);for(;te.size;){let ae;const le=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(q=>te.has(q.toLowerCase())));le.length?ae=te.size===1?le:le.filter(({task:ie})=>!(ie===Y&&!ue)):(this.F.info("Found extensions with circular dependencies",le.map(({task:ie})=>ie.identifier.id)),ae=[...te.values()]),await this.M(ae.map(async({task:ie})=>{const q=new Date().getTime();try{const G=await ie.run();if(await this.M(this.y.map(T=>T.postInstall(G,ie.source,y,N.CancellationToken.None))),!E.URI.isUri(ie.source)){const T=ie.operation===3,U=T?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(o(this.C,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$Eo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:U}),u.$p&&ie.operation!==3)try{await this.z.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}_.push({local:G,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw E.URI.isUri(ie.source)||o(this.C,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$Eo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,error:G}),this.F.error("Error while installing the extension:",ie.identifier.id),G}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return W.length&&await this.M(W),_.forEach(({identifier:ae})=>this.F.info("Extension installed successfully:",ae.id)),_}catch(te){if(R.forEach(({task:ae})=>ae.cancel()),_.length)try{const ae=await Promise.allSettled(_.map(({local:le})=>this.$(le,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let le=0;le<ae.length;le++){const ie=ae[le],{identifier:q}=_[le];ie.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",q.id):this.F.warn("Rollback: Error while uninstalling extension",q.id,(0,A.$9)(ie.reason))}}catch(ae){this.F.warn("Error while rolling back extensions",(0,A.$9)(ae),_.map(({identifier:le})=>le.id))}return R.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:y.context,profileLocation:y.profileLocation,error:te}))}finally{for(const{task:te}of R)te.source&&!E.URI.isUri(te.source)&&this.j.delete(w(te.source))}}L(n,r){for(const[,{task:l,waitingTasks:P}]of this.j.entries())if(l===n&&(P.includes(r)||P.some(y=>this.L(y,r)))||l===r&&P[0]&&!this.L(n,P[0]))return!1;return!0}async M(n){const r=[],l=[],P=await Promise.allSettled(n);for(const y of P)y.status==="fulfilled"?r.push(y.value):l.push(y.reason);if(l.length)throw S(l);return r}async N(n,r,l,P,y){if(!this.z.isEnabled())return[];const w=await this.getInstalled(void 0,y),R=[],W=[],_=async(Y,ue)=>{R.push(Y);const te=ue.extensionDependencies||[],ae=[...te];if(ue.extensionPack){const le=l?w.find(ie=>(0,d.$wo)(ie.identifier,Y)):void 0;for(const ie of ue.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(q=>(0,d.$wo)({id:q},{id:ie}))||ae.every(q=>!(0,d.$wo)({id:q},{id:ie}))&&ae.push(ie)}if(ae.length){const le=ae.filter(ie=>R.every(q=>!(0,d.$wo)(q,{id:ie})));if(le.length){const ie=await this.z.getExtensions(le.map(q=>({id:q,preRelease:P})),N.CancellationToken.None);for(const q of ie){if(R.find(U=>(0,d.$wo)(U,q.identifier)))continue;const G=te.some(U=>(0,d.$wo)({id:U},q.identifier));let T;try{T=await this.O(q,!1,P)}catch(U){if(G)throw U;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,A.$9)(U));continue}W.push({gallery:T.extension,manifest:T.manifest}),await _(T.extension.identifier,T.manifest)}}}};return await _(n,r),W}async O(n,r,l){let P;const y=await this.getExtensionsControlManifest();if(y.malicious.some(W=>(0,d.$wo)(n.identifier,W)))throw new m.$8n(O.localize(1,null,n.identifier.id),m.ExtensionManagementErrorCode.Malicious);const w=y.deprecated[n.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),P=(await this.z.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},N.CancellationToken.None))[0],!P)throw new m.$8n(O.localize(2,null,n.identifier.id,w.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const W=await this.getTargetPlatform();throw new m.$8n(O.localize(3,null,n.identifier.id,this.G.nameLong,(0,m.$Zn)(W)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(P=await this.P(n,r,l),!P)throw!l&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],N.CancellationToken.None))[0]?new m.$8n(O.localize(4,null,n.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$8n(O.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),m.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",P.identifier.id);const R=await this.z.getManifest(P,N.CancellationToken.None);if(R===null)throw new m.$8n(`Missing manifest for extension ${P.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(R.version!==P.version)throw new m.$8n(`Cannot install '${P.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:P,manifest:R}}async P(n,r,l){const P=await this.getTargetPlatform();let y=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(y=(await this.z.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:P,compatible:!0},N.CancellationToken.None))[0]||null),!y&&await this.z.isExtensionCompatible(n,l,P)&&(y=n),y||(r?y=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:P,compatible:!0},N.CancellationToken.None))[0]||null:y=await this.z.getCompatibleExtension(n,l,P)),y}async Q(n,r){const l={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},P=Y=>`${Y.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,y=this.m.get(P(n.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),y.waitUntilTaskIsFinished();const w=Y=>{const ue=this.$(Y,l);return this.m.set(P(ue.extension.identifier),ue),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Y.identifier.id}@${Y.manifest.version}`),this.t.fire({identifier:Y.identifier,profileLocation:l.profileLocation,applicationScoped:Y.isApplicationScoped}),ue},R=(Y,ue)=>{ue?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,l.profileLocation.toString(),ue.message):this.F.error("Failed to uninstall extension:",`${Y.identifier.id}@${Y.manifest.version}`,ue.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Y.identifier.id}@${Y.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Y.identifier.id}@${Y.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,d.$Do)(Y),error:ue}),this.u.fire({identifier:Y.identifier,error:ue?.code,profileLocation:l.profileLocation,applicationScoped:Y.isApplicationScoped})},W=[],_=[];try{W.push(w(n));const Y=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ue=this.U(n,Y);for(const te of ue)this.m.has(P(te.identifier))?this.F.info("Extensions is already requested to uninstall",te.identifier.id):W.push(w(te))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(W.map(ue=>ue.extension),Y,n),await this.M(W.map(async ue=>{try{if(await ue.run(),await this.M(this.y.map(te=>te.postUninstall(ue.extension,l,N.CancellationToken.None))),ue.extension.identifier.uuid)try{await this.z.reportStatistic(ue.extension.manifest.publisher,ue.extension.manifest.name,ue.extension.manifest.version,"uninstall")}catch{}R(ue.extension)}catch(te){const ae=te instanceof m.$8n?te:new m.$8n((0,A.$9)(te),m.ExtensionManagementErrorCode.Internal);throw R(ue.extension,ae),ae}finally{_.push(ue)}}))}catch(Y){const ue=Y instanceof m.$8n?Y:new m.$8n((0,A.$9)(Y),m.ExtensionManagementErrorCode.Internal);for(const te of W){try{te.cancel()}catch{}_.includes(te)||R(te.extension,ue)}throw ue}finally{for(const Y of W)this.m.delete(P(Y.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Y.extension.identifier.id)}}R(n,r,l){for(const P of n){const y=this.W(P,r);if(y.length){const w=y.filter(R=>!n.some(W=>(0,d.$wo)(W.identifier,R.identifier)));if(w.length)throw new Error(this.S(P,w,l))}}}S(n,r,l){return l===n?r.length===1?O.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?O.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const P=n.manifest.extensionPack?n.manifest.extensionPack:[];if(P.length){const y=r.filter(R=>!R.isBuiltin&&P.some(W=>(0,d.$wo)({id:W},R.identifier))),w=[];for(const R of y)w.push(...this.U(R,r,l));return[...y,...w]}return[]}W(n,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(P=>(0,d.$wo)({id:P},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$mp=p,e.$mp=p=pe([se(0,m.$7n),se(1,h.$al),se(2,f.$Gk),se(3,v.$8i),se(4,$.$nj),se(5,I.$Ik)],p);function S(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$np=S;function s(i){if(i instanceof m.$8n)return i;const n=new m.$8n(i.message,m.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$op=s;function o(i,n,{extensionData:r,verificationStatus:l,duration:P,error:y,durationSinceUpdate:w}){let R,W;(0,c.$Ff)(l)&&(l===!0?l="Verified":(l===!1||(R=m.ExtensionManagementErrorCode.Signature,W=l),l="Unverified")),y&&(y instanceof m.$8n?(R=y.code,y.code===m.ExtensionManagementErrorCode.Signature&&(W=y.message)):R=m.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:l,success:!y,duration:P,errorcode:R,errorcodeDetail:W,durationSinceUpdate:w})}class t{constructor(){this.d=new D.$Rg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$Gg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$Gg)(n=>new Promise((r,l)=>{const P=n.onCancellationRequested(()=>{P.dispose(),l(new A.$4)})})),this.d.open()),this.g.cancel()}}e.$pp=t}),define(ne[40],re([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d,k,v,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class I extends Error{constructor(t,i){super(t),this.code=i}}e.$qp=I,e.$rp=(0,O.$Nh)("IExtensionsProfileScannerService");let p=class extends N.$Rc{constructor(t,i,n,r,l,P){super(),this.j=t,this.m=i,this.n=n,this.r=r,this.s=l,this.t=P,this.b=this.B(new A.$Md),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Md),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Md),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Md),this.onDidRemoveExtensions=this.g.event,this.h=new j.$zc}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],r=[];try{return await this.u(i,l=>{const P=[];for(const y of l)t.some(([w])=>(0,c.$wo)(w.identifier,y.identifier)&&w.manifest.version!==y.version)?n.push(y):P.push(y);for(const[y,w]of t){const R=P.findIndex(_=>(0,c.$wo)(_.identifier,y.identifier)&&_.version===y.manifest.version),W={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:w};R===-1?(r.push(W),P.push(W)):P.splice(R,1,W)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),P}),r.length&&this.c.fire({extensions:r,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:l,profileLocation:i}),l}}async updateMetadata(t,i){const n=[];return await this.u(i,r=>{const l=[];for(const P of r){const y=t.find(([w])=>(0,c.$wo)(w.identifier,P.identifier)&&w.manifest.version===P.version);y&&(P.metadata={...P.metadata,...y[1]},n.push(P)),l.push(P)}return l}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.u(i,r=>{const l=[];for(const P of r)(0,c.$wo)(P.identifier,t.identifier)?n.push(P):l.push(P);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:i}),r}}async u(t,i,n){return this.F(t).queue(async()=>{let r=[],l;try{const P=await this.m.readFile(t);l=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,E.$nk)(P)!==1)throw P;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new I((0,$.$9)(P),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let P=!1;for(const y of l){S(y)||this.w(t);let w;if((0,v.$xf)(y.relativeLocation)&&y.relativeLocation)w=this.z(y.relativeLocation);else if((0,v.$xf)(y.location))w=this.z(y.location),P=!0,y.relativeLocation=y.location,y.location=w.toJSON();else{w=b.URI.revive(y.location);const R=this.y(w);R&&(P=!0,y.relativeLocation=R)}r.push({identifier:y.identifier,location:w,version:y.version,metadata:y.metadata})}P&&await this.m.writeFile(t,D.$ae.fromString(JSON.stringify(l)))}if(i){r=i(r);const P=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(t,D.$ae.fromString(JSON.stringify(P)))}return r})}w(t){const i=new I(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(t)).value.toString()}catch(l){if((0,E.$nk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let r;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(P=>S(P))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$ae.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,E.$nk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,E.$nk)(l)!==1&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,E.$nk)(l)!==1&&this.t.error(l)}return r})()),this.C}F(t){let i=this.h.get(t);return i||(i=new L.$Zg,this.h.set(t,i)),i}};e.$sp=p,e.$sp=p=pe([se(1,E.$9j),se(2,d.$Ik),se(3,k.$Gk),se(4,h.$al),se(5,m.$8i)],p);function S(o){return(0,v.$zf)(o)&&(0,u.$6n)(o.identifier)&&(s(o.location)||(0,v.$xf)(o.location)&&o.location)&&((0,v.$Ef)(o.relativeLocation)||(0,v.$xf)(o.relativeLocation))&&o.version&&(0,v.$xf)(o.version)}function s(o){return o?(0,v.$xf)(o.path)&&(0,v.$xf)(o.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,80,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,47,40,23,22,112]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d,k,v,$,h,f,I,p,S,s,o,t,i,n,r,l,P,y,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.Translations=void 0;var W;(function(ie){function q(G,T){if(G===T)return!0;const U=Object.keys(G),B=new Set;for(const Z of Object.keys(T))B.add(Z);if(U.length!==B.size)return!1;for(const Z of U){if(G[Z]!==T[Z])return!1;B.delete(Z)}return B.size===0}ie.equals=q})(W||(e.Translations=W={})),e.$vp=(0,t.$Nh)("IExtensionsScannerService");let _=class extends c.$Rc{constructor(q,G,T,U,B,Z,x,Q,F,z,a,g){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=G,this.r=T,this.s=U,this.t=B,this.u=Z,this.w=x,this.y=Q,this.z=F,this.C=z,this.D=a,this.F=g,this.g=this.B(new r.$Md),this.onDidChangeCache=this.g.event,this.h=(0,d.$ug)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(ue,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Ho)(this.w,this.y)),this.G}async scanAllExtensions(q,G,T){const[U,B]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(G)]),Z=T?await this.scanExtensionsUnderDevelopment(q,[...U,...B]):[];return this.L(U,B,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const G=[];G.push(this.M(!!q.useCache,q.language)),G.push(this.N(q.language,!!q.checkControlFile));const[T,U]=await Promise.all(G);return this.J([...T,...U],0,q,!1)}async scanUserExtensions(q){const G=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",G);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(G,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),B=q.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let Z;try{Z=await B.scanExtensions(U)}catch(x){if(x instanceof P.$qp&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Z=await B.scanExtensions(U);else throw x}return Z=await this.J(Z,1,q,!0),this.y.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(q,G){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===E.Schemas.file).map(async U=>{const B=await this.P(U,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(B)).map(x=>(x.type=G.find(Q=>(0,p.$wo)(Q.identifier,x.identifier))?.type??x.type,this.n.validate(x,B)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,G,T){const U=await this.P(q,!1,G,!0,T.language,!0,void 0),B=await this.n.scanExtension(U);return!B||!T.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(q,G,T){const U=await this.P(q,!1,G,!0,T.language,!0,void 0),B=await this.n.scanOneOrMultipleExtensions(U);return this.J(B,G,T,!0)}async scanMetadata(q){const G=(0,d.$ug)(q,"package.json"),T=(await this.w.readFile(G)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,G){const T=(0,d.$ug)(q,"package.json"),U=(await this.w.readFile(T)).value.toString(),B=JSON.parse(U);G.isMachineScoped===!1&&delete G.isMachineScoped,G.isBuiltin===!1&&delete G.isBuiltin,B.__metadata={...B.__metadata,...G},await this.w.writeFile((0,d.$ug)(q,"package.json"),A.$ae.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof P.$qp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(G=>[G,G.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$ae.fromString(JSON.stringify([])))}catch(G){(0,o.$nk)(G)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$9)(G))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,G,T,U){return T.includeAllVersions||(q=this.L(G===0?q:void 0,G===1?q:void 0,G==="development"?q:void 0,await this.getTargetPlatform(),U)),T.includeInvalid||(q=q.filter(B=>B.isValid)),q.sort((B,Z)=>{const x=O.$mc(B.location.fsPath),Q=O.$mc(Z.location.fsPath);return x<Q?-1:x>Q?1:0})}L(q,G,T,U,B){const Z=(Q,F,z)=>{if(Q.isValid&&!F.isValid)return!1;if(Q.isValid===F.isValid){if(B&&k.gt(Q.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${Q.location.path} with version ${Q.manifest.version}`),!1;if(k.eq(Q.manifest.version,F.manifest.version)){if(Q.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${Q.location.path} with same version`),!1;if(Q.targetPlatform===U)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${Q.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${Q.location.path} with ${F.location.path}.`),!0},x=new S.$5l;return q?.forEach(Q=>{const F=x.get(Q.identifier.id);(!F||Z(F,Q,!1))&&x.set(Q.identifier.id,Q)}),G?.forEach(Q=>{const F=x.get(Q.identifier.id);if(!F&&q&&Q.type===0){this.y.debug(`Skipping obsolete system extension ${Q.location.path}.`);return}(!F||Z(F,Q,!1))&&x.set(Q.identifier.id,Q)}),T?.forEach(Q=>{const F=x.get(Q.identifier.id);(!F||Z(F,Q,!0))&&x.set(Q.identifier.id,Q),x.set(Q.identifier.id,Q)}),[...x.values()]}async M(q,G){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0),B=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",B.length),B}async N(q,G){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const U=G?await this.O():{},B=[],Z=h.URI.file(O.$gc(O.$ic(E.$bg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Q of T){const F=U[Q.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":B.push((0,d.$ug)(Z,Q.name));break;default:B.push(h.URI.file(F));break}}const x=await Promise.all(B.map(async Q=>this.n.scanExtension(await this.P(Q,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",x.length),(0,L.$Gb)(x)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,G,T,U,B,Z,x){const Q=await this.f(B??m.$w),F=await this.Q(q),z=G&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,a=z?await this.Q(z):void 0;return new Y(q,F,z,a,G,x,T,U,Z,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,B,Q)}async Q(q){try{const G=await this.w.stat(q);if(typeof G.mtime=="number")return G.mtime}catch{}}};e.$wp=_,e.$wp=_=pe([se(4,y.$Ik),se(5,P.$rp),se(6,o.$9j),se(7,i.$8i),se(8,I.$Uh),se(9,n.$nj),se(10,w.$Gk),se(11,t.$Mh)],_);class Y{constructor(q,G,T,U,B,Z,x,Q,F,z,a,g,M,C,X){this.location=q,this.mtime=G,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=U,this.profile=B,this.profileScanOptions=Z,this.type=x,this.excludeObsolete=Q,this.validate=F,this.productVersion=z,this.productDate=a,this.productCommit=g,this.devMode=M,this.language=C,this.translations=X}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,G){return(0,d.$ng)(q.location,G.location)&&q.mtime===G.mtime&&(0,d.$ng)(q.applicationExtensionslocation,G.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&q.profile===G.profile&&N.$7m(q.profileScanOptions,G.profileScanOptions)&&q.type===G.type&&q.excludeObsolete===G.excludeObsolete&&q.validate===G.validate&&q.productVersion===G.productVersion&&q.productDate===G.productDate&&q.productCommit===G.productCommit&&q.devMode===G.devMode&&q.language===G.language&&W.equals(q.translations,G.translations)}}e.$xp=Y;let ue=class extends c.$Rc{constructor(q,G,T,U,B){super(),this.f=q,this.g=G,this.h=T,this.j=U,this.m=B}async scanExtensions(q){const G=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const U=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(U)}catch{}return(0,$.$Kf)(T)?G:G.filter(U=>!T[p.$xo.create(U).toString()])}async n(q){const G=await this.j.resolve(q.location);if(!G.children?.length)return[];const T=await Promise.all(G.children.map(async U=>{if(!U.isDirectory||q.type===1&&(0,d.$rg)(U.resource).indexOf(".")===0)return null;const B=new Y(U.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B)}));return(0,L.$Gb)(T).sort((U,B)=>U.location.path<B.location.path?-1:1)}async r(q){let G=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){G=G.filter(U=>!U.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,q);G.push(...T)}return G}async s(q,G,T){const U=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!U.length)return[];const B=await Promise.all(U.map(async Z=>{if(G(Z)){const x=new Y(Z.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(x,Z.metadata)}return null}));return(0,L.$Gb)(B)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,d.$ug)(q.location,"package.json"))){const G=await this.scanExtension(q);return G?[G]:[]}else return await this.scanExtensions(q)}catch(G){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,j.$9)(G)),[]}}async scanExtension(q,G){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=S.$Yl),G=G??T.__metadata,delete T.__metadata;const U=(0,p.$Bo)(T.publisher,T.name),B=G?.id?{id:U,uuid:G.id}:{id:U},Z=G?.isSystem?0:q.type,x=Z===0||!!G?.isBuiltin;T=await this.t(q.location,T,Y.createNlsConfiguration(q));const Q={type:Z,identifier:B,manifest:T,location:q.location,isBuiltin:x,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return q.validate?this.validate(Q,q):Q}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,G){let T=!0;const U=(0,s.$Mo)(G.productVersion,G.productDate,G.location,q.manifest,q.isBuiltin);for(const[B,Z]of U)B===v.default.Error&&(T=!1,this.m.error(this.z(G.location,Z)));return q.isValid=T,q.validations=U,q}async scanExtensionManifest(q){const G=(0,d.$ug)(q,"package.json");let T;try{T=(await this.j.readFile(G)).value.toString()}catch(B){return(0,o.$nk)(B)!==1&&this.m.error(this.z(q,(0,f.localize)(0,null,G.path,B.message))),null}let U;try{U=JSON.parse(T)}catch{const Z=[];(0,b.$Sm)(T,Z);for(const x of Z)this.m.error(this.z(q,(0,f.localize)(1,null,G.path,x.offset,x.length,(0,u.$tp)(x.error))));return null}return(0,b.$2m)(U)!=="object"?(this.m.error(this.z(q,(0,f.localize)(2,null,G.path))),null):U}async t(q,G,T){const U=await this.u(q,G,T);if(U)try{const B=[],Z=await this.w(U.default,B);if(B.length>0)return B.forEach(Q=>{this.m.error(this.z(q,(0,f.localize)(3,null,U.default?.path,(0,u.$tp)(Q.error))))}),G;if((0,b.$2m)(U)!=="object")return this.m.error(this.z(q,(0,f.localize)(4,null,U.default?.path))),G;const x=U.values||Object.create(null);return(0,R.$up)(this.m,G,x,Z)}catch{}return G}async u(q,G,T){const U=(0,d.$ug)(q,"package.nls.json"),B=(F,z)=>{z.forEach(a=>{this.m.error(this.z(q,(0,f.localize)(5,null,F?.path,(0,u.$tp)(a.error))))})},Z=F=>{this.m.error(this.z(q,(0,f.localize)(6,null,F?.path)))},x=`${G.publisher}.${G.name}`,Q=T.translations[x];if(Q)try{const F=h.URI.file(Q),z=(await this.j.readFile(F)).value.toString(),a=[],g=(0,b.$Sm)(z,a);return a.length>0?(B(F,a),{values:void 0,default:U}):(0,b.$2m)(g)!=="object"?(Z(F),{values:void 0,default:U}):{values:g.contents?g.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let z;try{z=await this.y(q,T)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const a=(await this.j.readFile(z.localized)).value.toString(),g=[],M=(0,b.$Sm)(a,g);return g.length>0?(B(z.localized,g),{values:void 0,default:z.original}):(0,b.$2m)(M)!=="object"?(Z(z.localized),{values:void 0,default:z.original}):{values:M,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(q,G){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,b.$Sm)(T,G)}catch{}}y(q,G){return new Promise((T,U)=>{const B=Z=>{const x=(0,d.$ug)(q,`package.nls.${Z}.json`);this.j.exists(x).then(Q=>{Q&&T({localized:x,original:(0,d.$ug)(q,"package.nls.json")});const F=Z.lastIndexOf("-");F===-1?T({localized:(0,d.$ug)(q,"package.nls.json"),original:null}):(Z=Z.substring(0,F),B(Z))})};if(G.devMode||G.pseudo||!G.language)return T({localized:(0,d.$ug)(q,"package.nls.json"),original:null});B(G.language)})}z(q,G){return`[${q.path}]: ${G}`}};ue=pe([se(1,P.$rp),se(2,w.$Gk),se(3,o.$9j),se(4,i.$8i)],ue);let te=class extends ue{constructor(q,G,T,U,B,Z,x){super(G,U,B,Z,x),this.G=q,this.H=T,this.D=this.B(new D.$Qg(3e3)),this.F=this.B(new r.$Md),this.onDidChangeCache=this.F.event}async scanExtensions(q){const G=this.M(q),T=await this.I(G);if(this.C=q,T&&T.input&&Y.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(B=>(B.location=h.URI.revive(B.location),B));const U=await super.scanExtensions(q);return await this.J(G,{input:q,result:U}),U}async I(q){try{const G=await this.j.readFile(q),T=JSON.parse(G.value.toString());return{result:T.result,input:(0,l.$kh)(T.input)}}catch(G){this.m.debug("Error while reading the extension cache file:",q.path,(0,j.$9)(G))}return null}async J(q,G){try{await this.j.writeFile(q,A.$ae.fromString(JSON.stringify(G)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,j.$9)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),G=await this.I(q);if(!G)return;const T=G.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!N.$7m(U,T))try{this.m.info("Invalidating Cache",T,U),await this.j.del(q),this.F.fire()}catch(B){this.m.error(B)}}M(q){const G=this.N(q);return this.h.extUri.joinPath(G.cacheHome,q.type===0?S.$Xl:S.$Wl)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(G=>this.h.extUri.isEqual(q.location,G.extensionsResource))??this.G:this.H.defaultProfile}};te=pe([se(2,y.$Ik),se(3,P.$rp),se(4,w.$Gk),se(5,o.$9j),se(6,i.$8i)],te);function ae(ie,q){const G=(0,p.$zo)(ie.manifest.publisher,ie.manifest.name);return{id:G,identifier:new S.$3l(G),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:q,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.$yp=ae;class le extends _{constructor(q,G,T,U,B,Z,x,Q,F,z,a,g){super(q,G,(0,d.$ug)(T,".vscode-oss-dev","extensions","control.json"),U,B,Z,x,Q,F,z,a,g),this.R=(async()=>{if(m.$z)try{const M=await this.w.readFile(h.URI.file(m.$z));return JSON.parse(M.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$zp=le}),define(ne[154],re([0,1,58,8,34,4,2,15,16,24,6,23]),function(J,e,L,D,N,A,j,b,u,c,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;let m=class extends j.$Rc{constructor(k,v){super(),this.b=k,this.f=v,this.a=new D.$Yg(5)}async postUninstall(k){const v=this.g(k,"uninstall");v&&(this.f.info(k.identifier.id,k.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,k),this.f.info("Finished running post uninstall script",k.identifier.id,k.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",k.identifier.id,k.manifest.version),this.f.error($)}}));try{await c.Promises.rm(this.m(k))}catch($){this.f.error("Error while removing extension storage path",k.identifier.id),this.f.error($)}}g(k,v){const $=`vscode:${v}`;if(k.location.scheme===b.Schemas.file&&k.manifest&&k.manifest.scripts&&typeof k.manifest.scripts[$]=="string"){const h=k.manifest.scripts[$].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(k.identifier.id,k.manifest.version,`${$} should be a node script`),null):{script:(0,u.$ic)(k.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(k,v,$,h,f){return new Promise((I,p)=>{const S=this.j(k,v,$,f);let s;const o=t=>{s&&(clearTimeout(s),s=null),t?p(t):I(void 0)};S.on("error",t=>{o((0,N.$yi)(t)||"Unknown")}),S.on("exit",(t,i)=>{o(t?`post-${v} process exited with code ${t}`:void 0)}),h&&(s=setTimeout(()=>{s=null,S.kill(),p("timed out")},5e3))})}j(k,v,$,h){const f={silent:!0,execArgv:void 0},I=(0,L.fork)(k,[`--type=extension-post-${v}`,...$],f);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(I.stdout,"data"),S=A.Event.fromNodeEventEmitter(I.stderr,"data");p(t=>this.f.info(h.identifier.id,h.manifest.version,`post-${v}`,t)),S(t=>this.f.error(h.identifier.id,h.manifest.version,`post-${v}`,t));const s=A.Event.any(A.Event.map(p,t=>({data:`%c${t}`,format:[""]})),A.Event.map(S,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(h.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),I}m(k){return(0,u.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,k.identifier.id.toLowerCase())}};e.$Bp=m,e.$Bp=m=pe([se(0,O.$Ik),se(1,E.$8i)],m)}),define(ne[155],re([0,1,6,23,22,26,40,12,18,11]),function(J,e,L,D,N,A,j,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=void 0;let E=class extends j.$sp{constructor(m,d,k,v,$,h){super(c.URI.file(m.extensionsPath),d,k,v,$,h)}};e.$xN=E,e.$xN=E=pe([se(0,u.$Vh),se(1,b.$9j),se(2,D.$Ik),se(3,N.$Gk),se(4,A.$al),se(5,L.$8i)],E)}),define(ne[156],re([0,1,11,18,40,50,12,10,6,32,22,23]),function(J,e,L,D,N,A,j,b,u,c,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=void 0;let m=class extends A.$zp{constructor(k,v,$,h,f,I,p,S){super(L.URI.file(f.builtinExtensionsPath),L.URI.file(f.extensionsPath),f.userHome,k.defaultProfile,k,v,$,h,f,I,p,S)}};e.$C7b=m,e.$C7b=m=pe([se(0,O.$Ik),se(1,N.$rp),se(2,j.$9j),se(3,u.$8i),se(4,D.$Vh),se(5,c.$nj),se(6,E.$Gk),se(7,b.$Mh)],m)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(J,e,L,D,N,A,j,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$3o=e.$2o=e.$1o=void 0,e.$1o="__$__isNewStorageMarker",e.$2o="__$__targetStorageMarker",e.$3o=(0,u.$Nh)("storageService");var E;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var O;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(O||(e.StorageScope=O={}));var m;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function d(f){const I=f.get(e.$2o);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}e.$4o=d;class k extends N.$Rc{static{this.a=60*1e3}constructor(I={flushInterval:k.a}){super(),this.m=I,this.b=this.B(new D.$Pd),this.c=this.B(new D.$Pd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Md),this.onWillSaveState=this.f.event,this.h=this.B(new L.$5g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new N.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,p,S){return D.Event.filter(this.b.event,s=>s.scope===I&&(p===void 0||s.key===p),S)}n(){this.j.value=(0,L.$9g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,N.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,p){const{key:S,external:s}=p;if(S===e.$2o){switch(I){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:S,target:this.J(I)[S],external:s})}w(I){this.f.fire({reason:I})}get(I,p,S){return this.P(p)?.get(I,S)}getBoolean(I,p,S){return this.P(p)?.getBoolean(I,S)}getNumber(I,p,S){return this.P(p)?.getNumber(I,S)}getObject(I,p,S){return this.P(p)?.getObject(I,S)}storeAll(I,p){this.y(()=>{for(const S of I)this.store(S.key,S.value,S.scope,S.target,p)})}store(I,p,S,s,o=!1){if((0,j.$Gf)(p)){this.remove(I,S,o);return}this.y(()=>{this.z(I,S,s),this.P(S)?.set(I,p,o)})}remove(I,p,S=!1){this.y(()=>{this.z(I,p,void 0),this.P(p)?.delete(I,S)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,p){const S=[],s=this.J(I);for(const o of Object.keys(s))s[o]===p&&S.push(o);return S}z(I,p,S,s=!1){const o=this.J(p);typeof S=="number"?o[I]!==S&&(o[I]=S,this.P(p)?.set(e.$2o,JSON.stringify(o),s)):typeof o[I]=="number"&&(delete o[I],this.P(p)?.set(e.$2o,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(I){switch(I){case-1:return this.I;case 0:return this.G;default:return this.D}}L(I){const p=this.P(I);return p?d(p):Object.create(null)}isNew(I){return this.getBoolean(e.$1o,I)===!0}async flush(I=E.NONE){this.f.fire({reason:I});const p=this.P(-1),S=this.P(0),s=this.P(1);switch(I){case E.NONE:await L.Promises.settled([p?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await L.Promises.settled([p?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,S=this.P(1)?.items??new Map;return h(I,p,S,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,p){return this.w(E.NONE),(0,c.$Hk)(I)?this.R(I,p):this.S(I,p)}M(I,p){return!(I.id===p.id||v(p)&&v(I))}N(I,p,S){this.y(()=>{const s=new Set;for(const[o,t]of I)s.add(o),p.get(o)!==t&&this.u(S,{key:o,external:!0});for(const[o]of p.items)s.has(o)||this.u(S,{key:o,external:!0})})}}e.$5o=k;function v(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$6o=v;class $ extends k{constructor(){super(),this.U=this.B(new b.$Yo(new b.$Zo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Yo(new b.$Zo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Yo(new b.$Zo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(1,I))),this.B(this.W.onDidChangeStorage(I=>this.u(0,I))),this.B(this.U.onDidChangeStorage(I=>this.u(-1,I)))}P(I){switch(I){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(I){switch(I){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$7o=$;async function h(f,I,p,S,s,o){const t=W=>{try{return JSON.parse(W)}catch{return W}},i=new Map,n=new Map;f.forEach((W,_)=>{i.set(_,W),n.set(_,t(W))});const r=new Map,l=new Map;I.forEach((W,_)=>{r.set(_,W),l.set(_,t(W))});const P=new Map,y=new Map;p.forEach((W,_)=>{P.set(_,W),y.set(_,t(W))}),console.group(S!==s?`Storage: Application (path: ${S})`:`Storage: Application & Profile (path: ${S}, default profile)`);const w=[];if(i.forEach((W,_)=>{w.push({key:_,value:W})}),console.table(w),console.groupEnd(),console.log(n),S!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const W=[];r.forEach((_,Y)=>{W.push({key:Y,value:_})}),console.table(W),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const R=[];P.forEach((W,_)=>{R.push({key:_,value:W})}),console.table(R),console.groupEnd(),console.log(y)}e.$8o=h}),define(ne[158],re([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d,k,v,$,h,f,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.$$o=void 0;const s=A.$p?"web":(0,O.$2n)(A.$u,j.$dc),o="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...a){return String(a.reduce((g,M)=>g|M,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class w{constructor(g=y){this.d=g}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(g,M=this.d.pageSize){return new w({...this.d,pageNumber:g,pageSize:M})}withFilter(g,...M){const C=[...this.d.criteria,...M.length?M.map(X=>({filterType:g,value:X})):[{filterType:g}]];return new w({...this.d,criteria:C})}withSortBy(g){return new w({...this.d,sortBy:g})}withSortOrder(g){return new w({...this.d,sortOrder:g})}withFlags(...g){return new w({...this.d,flags:g.reduce((M,C)=>M|C,0)})}withAssetTypes(...g){return new w({...this.d,assetTypes:g})}withSource(g){return new w({...this.d,source:g})}get raw(){const{criteria:g,pageNumber:M,pageSize:C,sortBy:X,sortOrder:H,flags:ce,assetTypes:oe}=this.d;return{filters:[{criteria:g,pageNumber:M,pageSize:C,sortBy:X,sortOrder:H}],assetTypes:oe,flags:ce}}get searchText(){const g=this.d.criteria.filter(M=>M.filterType===n.SearchText)[0];return g&&g.value?g.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(g=>String(g.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function R(a,g){const M=(a||[]).filter(C=>C.statisticName===g)[0];return M?M.value:0}function W(a){const g="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(C=>C.assetType.indexOf(g)===0).reduce((C,X)=>{const H=ue(a,X.assetType);return H&&C.push([X.assetType.substring(g.length),H]),C},[])}function _(a){if(a.properties){const g=a.properties.filter(X=>X.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),C=g.filter(X=>M.test(X.value))[0];return C?{uri:C.value,fallbackUri:C.value}:null}return ue(a,r.Repository)}function Y(a){return{uri:`${a.fallbackAssetUri}/${r.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${r.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function ue(a,g){return a.files.filter(C=>C.assetType===g)[0]?{uri:`${a.assetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function te(a,g){const M=a.properties?a.properties.filter(X=>X.key===g):[],C=M.length>0&&M[0].value;return C?C.split(",").map(X=>(0,m.$Ao)(X)):[]}function ae(a){const g=a.properties?a.properties.filter(M=>M.key===l.Engine):[];return g.length>0&&g[0].value||""}function le(a){const g=a.properties?a.properties.filter(M=>M.key===l.PreRelease):[];return g.length>0&&g[0].value==="true"}function ie(a){const g=a.properties?a.properties.filter(C=>C.key===l.LocalizedLanguages):[],M=g.length>0&&g[0].value||"";return M?M.split(","):[]}function q(a){return a.properties?.find(g=>g.key===l.SponsorLink)?.value}function G(a){return a.indexOf("preview")!==-1}function T(a){return a.targetPlatform?(0,O.$1n)(a.targetPlatform):"undefined"}function U(a){const g=(0,L.$Lb)(a.versions.map(T)),M=!!a.tags?.includes(O.$Vn),C=g.indexOf("web");return M?C===-1&&g.push("web"):C!==-1&&g.splice(C,1),g}function B(a,g){const M=(0,O.$5n)(g);for(let C=0;C<a.length;C++){const X=a[C];if(X.version===a[C-1]?.version){let H=C;const ce=T(X);if(ce===g)for(;H>0&&a[H-1].version===X.version;)H--;else if(M.includes(ce))for(;H>0&&a[H-1].version===X.version&&T(a[H-1])!==g;)H--;H!==C&&(a.splice(C,1),a.splice(H,0,X))}}return a}e.$$o=B;function Z(a,g,M){a.telemetryData={index:g,querySource:M,queryActivityId:a.queryContext?.[o]}}function x(a,g,M,C){const X=a.versions[0],H={manifest:ue(g,r.Manifest),readme:ue(g,r.Details),changelog:ue(g,r.Changelog),license:ue(g,r.License),repository:_(g),download:Y(g),icon:ue(g,r.Icon),signature:ue(g,r.Signature),coreTranslations:W(g)};return{identifier:{id:(0,m.$Bo)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:g.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(X),description:a.shortDescription||"",installCount:R(a.statistics,"install"),rating:R(a.statistics,"averagerating"),ratingCount:R(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:M,assets:H,properties:{dependencies:te(g,l.Dependency),extensionPack:te(g,l.ExtensionPack),engine:ae(g),localizedLanguages:ie(g),targetPlatform:T(g),isPreReleaseVersion:le(g)},hasPreReleaseVersion:le(X),hasReleaseVersion:!0,preview:G(a.flags),isSigned:!!H.signature,queryContext:C}}let Q=class{constructor(g,M,C,X,H,ce,oe,me){this.k=M,this.l=C,this.n=X,this.o=H,this.q=ce,this.u=oe,this.w=me;const de=oe.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,f.$0o)(oe.version,oe,this.n,this.w,this.q,g,this.o)}x(g=""){return`${this.d}${g}`}isEnabled(){return!!this.d}async getExtensions(g,M,C){const X=D.CancellationToken.isCancellationToken(M)?{}:M,H=D.CancellationToken.isCancellationToken(M)?M:C,ce=[],oe=[],me=[],de=[];let ge=!0;for(const we of g){we.uuid?oe.push(we.uuid):ce.push(we.id);const be=!!(we.version||we.preRelease);me.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!oe.length&&!ce.length)return[];let fe=new w().withPage(1,g.length);oe.length&&(fe=fe.withFilter(n.ExtensionId,...oe)),ce.length&&(fe=fe.withFilter(n.ExtensionName,...ce)),(X.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,t.IncludeVersions)),X.source&&(fe=fe.withSource(X.source));const{extensions:he}=await this.z(fe,{targetPlatform:X.targetPlatform??s,includePreRelease:me,versions:de,compatible:!!X.compatible},H);return X.source&&he.forEach((we,be)=>Z(we,be,X.source)),he}async getCompatibleExtension(g,M,C){if((0,O.$3n)(g.allTargetPlatforms,C))return null;if(await this.isExtensionCompatible(g,M,C))return g;const X=new w().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,g.identifier.uuid),{extensions:H}=await this.z(X,{targetPlatform:C,compatible:!0,includePreRelease:M},D.CancellationToken.None);return H[0]||null}async isExtensionCompatible(g,M,C){if(!(0,O.$4n)(g.properties.targetPlatform,g.allTargetPlatforms,C)||!M&&g.properties.isPreReleaseVersion)return!1;let X=g.properties.engine;if(!X){const H=await this.getManifest(g,D.CancellationToken.None);if(!H)throw new Error("Manifest was not found");X=H.engines.vscode}return(0,d.$Oo)(X,this.u.version,this.u.date)}async y(g,M,C,X,H){if(!(0,O.$4n)(T(g),X,H)||M!=="any"&&le(g)!==(M==="prerelease"))return!1;if(C)try{const ce=await this.E(g);if(!(0,d.$Oo)(ce,this.u.version,this.u.date))return!1}catch(ce){return this.l.error(`Error while getting the engine for the version ${g.version}.`,(0,N.$9)(ce)),!1}return!0}async query(g,M){let C=g.text||"";const X=g.pageSize??50;let H=new w().withPage(1,X);C?(C=C.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(H=H.withFilter(n.Category,he||fe),"")),C=C.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(H=H.withFilter(n.Tag,he||fe),"")),C=C.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(n.Featured),"")),C=C.trim(),C&&(C=C.length<200?C:C.substring(0,200),H=H.withFilter(n.SearchText,C)),H=H.withSortBy(0)):g.ids?H=H.withFilter(n.ExtensionId,...g.ids):g.names?H=H.withFilter(n.ExtensionName,...g.names):H=H.withSortBy(4),typeof g.sortBy=="number"&&(H=H.withSortBy(g.sortBy)),typeof g.sortOrder=="number"&&(H=H.withSortOrder(g.sortOrder)),g.source&&(H=H.withSource(g.source));const ce=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!g.includePreRelease},fe);return he.forEach((be,Pe)=>Z(be,(ge.pageNumber-1)*ge.pageSize+Pe,g.source)),{extensions:he,total:we}},{extensions:oe,total:me}=await ce(H,M),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new N.$4;const{extensions:he}=await ce(H.withPage(ge+1),fe);return he};return{firstPage:oe,total:me,pageSize:H.pageSize,getPage:de}}async z(g,M,C){const X=g.flags;g.flags&t.IncludeLatestVersionOnly&&g.flags&t.IncludeVersions&&(g=g.withFlags(g.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(g.flags&t.IncludeLatestVersionOnly)&&!(g.flags&t.IncludeVersions)&&(g=g.withFlags(g.flags,t.IncludeLatestVersionOnly)),M.versions?.length&&(g=g.withFlags(g.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),g=g.withFlags(g.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:H,total:ce,context:oe}=await this.B(g,C);if(!(g.flags&t.IncludeLatestVersionOnly)){const fe=[];for(const he of H){const we=await this.A(he,M,oe);we&&fe.push(we)}return{extensions:fe,total:ce}}const de=[],ge=new Map;for(let fe=0;fe<H.length;fe++){const he=H[fe],we={id:(0,m.$Bo)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,b.$Df)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Me=>(0,m.$wo)(Me,we))?.includePreRelease;if(M.compatible&&(0,O.$3n)(U(he),M.targetPlatform))continue;const Pe=await this.A(he,M,oe);!Pe||Pe.properties.isPreReleaseVersion&&(!be||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==M.targetPlatform&&Pe.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,Pe])}if(ge.size){const fe=new S.$Id,he=new w().withFlags(X&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,M,C);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const Pe=ge.get(be.identifier.uuid);de.push([Pe,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:ce}}async A(g,M,C){const X={id:(0,m.$Bo)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},H=M.versions?.find(de=>(0,m.$wo)(de,X))?.version,ce=(0,b.$Df)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(de=>(0,m.$wo)(de,X))?.includePreRelease,oe=U(g),me=B(g.versions,M.targetPlatform);if(M.compatible&&(0,O.$3n)(oe,M.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(H&&ge.version!==H)){if(await this.y(ge,ce?"any":"release",M.compatible,oe,M.targetPlatform))return x(g,ge,oe,C);if(H&&ge.version===H)return null}}return H||M.compatible?null:x(g,g.versions[0],oe)}async B(g,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");g=g.withFlags(g.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const C=await this.j,X=JSON.stringify(g.raw),H={...C,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},ce=new S.$Id;let oe,me,de=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&g.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:X,headers:H},M),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,h.$Vo)(oe);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[o]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.o.publicLog2("galleryService:query",{...g.telemetryData,requestBodySize:String(X.length),duration:ce.elapsed(),success:!!oe&&(0,h.$Ro)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:me?(0,N.$3)(me)?"canceled":(0,N.$9)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(g,M,C,X){if(!this.isEnabled())return;const H=A.$p?this.x(`/itemName/${g}.${M}/version/${C}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${g}/extensions/${M}/${C}/stats?statType=${X}`),ce=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:ce};try{await this.k.request({type:"POST",url:H,headers:me},D.CancellationToken.None)}catch{}}async download(g,M,C){this.l.trace("ExtensionGalleryService#download",g.identifier.id);const X=(0,m.$Eo)(g),H=new Date().getTime(),ce=fe=>this.o.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),oe=C===2?"install":C===3?"update":"",me=oe?{uri:`${g.assets.download.uri}${u.URI.parse(g.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${g.assets.download.fallbackUri}${u.URI.parse(g.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:g.assets.download,de=g.queryContext?.[o]?{[o]:g.queryContext[o]}:void 0,ge=await this.D(me,de?{headers:de}:void 0);await this.q.writeFile(M,ge.stream),ce(new Date().getTime()-H)}async downloadSignatureArchive(g,M){if(!g.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",g.identifier.id);const C=await this.D(g.assets.signature);await this.q.writeFile(M,C.stream)}async getReadme(g,M){if(g.assets.readme){const C=await this.D(g.assets.readme,{},M);return await(0,h.$Uo)(C)||""}return""}async getManifest(g,M){if(g.assets.manifest){const C=await this.D(g.assets.manifest,{},M),X=await(0,h.$Uo)(C);return X?JSON.parse(X):null}return null}async C(g,M){const C=ue(g,r.Manifest);if(!C)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},H=await this.D(C,{headers:X});return await(0,h.$Vo)(H)}async getCoreTranslation(g,M){const C=g.assets.coreTranslations.filter(X=>X[0]===M.toUpperCase())[0];if(C){const X=await this.D(C[1]),H=await(0,h.$Uo)(X);return H?JSON.parse(H):null}return null}async getChangelog(g,M){if(g.assets.changelog){const C=await this.D(g.assets.changelog,{},M);return await(0,h.$Uo)(C)||""}return""}async getAllCompatibleVersions(g,M,C){let X=new w().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);g.identifier.uuid?X=X.withFilter(n.ExtensionId,g.identifier.uuid):X=X.withFilter(n.ExtensionName,g.identifier.id);const{galleryExtensions:H}=await this.B(X,D.CancellationToken.None);if(!H.length)return[];const ce=U(H[0]);if((0,O.$3n)(ce,C))return[];const oe=[];await Promise.all(H[0].versions.map(async ge=>{try{await this.y(ge,M?"any":"release",!0,ce,C)&&oe.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of B(oe,C))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return me}async D(g,M={},C=D.CancellationToken.None){const X=await this.j,H={type:"GET"},ce={...X,...M.headers||{}};M={...M,...H,headers:ce};const oe=g.uri,me=g.fallbackUri,de={...M,url:oe};try{const ge=await this.k.request(de,C);if(ge.res.statusCode===200)return ge;const fe=await(0,h.$Uo)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,N.$3)(ge))throw ge;const fe=(0,N.$9)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:fe});const he={...M,url:me};return this.k.request(he,C)}}async E(g){let M=ae(g);if(!M){const C=await this.C(g,D.CancellationToken.None);if(!C)throw new Error("Manifest was not found");M=C.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const g=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(g.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,h.$Vo)(g),C=[],X={},H=[];if(M){for(const ce of M.malicious)C.push({id:ce});if(M.migrateToPreRelease)for(const[ce,oe]of Object.entries(M.migrateToPreRelease))(!oe.engine||(0,d.$Oo)(oe.engine,this.u.version,this.u.date))&&(X[ce.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[ce,oe]of Object.entries(M.deprecated))oe&&(X[ce.toLowerCase()]=(0,b.$Df)(oe)?{}:oe);if(M.search)for(const ce of M.search)H.push(ce)}return{malicious:C,deprecated:X,search:H}}};Q=pe([se(1,h.$Po),se(2,v.$8i),se(3,E.$Uh),se(4,p.$al),se(5,k.$9j),se(6,$.$nj),se(7,c.$hi)],Q);let F=class extends Q{constructor(g,M,C,X,H,ce,oe,me){super(g,M,C,X,H,ce,oe,me)}};e.$_o=F,e.$_o=F=pe([se(0,I.$3o),se(1,h.$Po),se(2,v.$8i),se(3,E.$Uh),se(4,p.$al),se(5,k.$9j),se(6,$.$nj),se(7,c.$hi)],F);let z=class extends Q{constructor(g,M,C,X,H,ce,oe){super(void 0,g,M,C,X,H,ce,oe)}};e.$ap=z,e.$ap=z=pe([se(0,h.$Po),se(1,v.$8i),se(2,E.$Uh),se(3,p.$al),se(4,k.$9j),se(5,$.$nj),se(6,c.$hi)],z)}),define(ne[159],re([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,L,D,N,A,j,b,u,c,E){"use strict";var O,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=e.$uN=void 0;let d=class extends u.$Lk{static{O=this}static{this.a="profileAssociationsMigration"}constructor(h,f,I,p,S){super(I,p,f,S),this.U=h,this.W=I}O(){return this.U.getItem(O.b,[]).map(f=>({...f,location:(0,c.$xf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):L.URI.revive(f.location)}))}Q(){const h=this.U.getItem(O.c,{});return this.U.getItem(O.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$uN=d,e.$uN=d=O=pe([se(0,j.$pN),se(1,b.$Gk),se(2,D.$Vh),se(3,N.$9j),se(4,A.$8i)],d);let k=m=class extends d{constructor(h,f,I,p,S){super(h,f,I,p,S),this.$=h}P(h){h.length?this.$.setItem(m.b,h.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(m.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(m.c,h):this.$.removeItem(m.c)}Q(){const h="workspaceAndProfileInfo",f=this.$.getItem(h,void 0);if(f){this.$.removeItem(h);const p=f.reduce((S,{workspace:s,profile:o})=>(S[L.URI.revive(s).toString()]=L.URI.revive(o).toString(),S),{});this.$.setItem(m.c,{workspaces:p})}const I=super.Q();return this.$.getItem(m.a,!1)||(this.R(I),this.$.setItem(m.a,!0)),I}};e.$vN=k,e.$vN=k=m=pe([se(0,j.$qN),se(1,b.$Gk),se(2,D.$Vh),se(3,N.$9j),se(4,A.$8i)],k);let v=class extends k{constructor(h,f,I,p){super(new E.$tN(0,f,p,I),h,f,I,p)}async init(){return await this.$.init(),super.init()}};e.$wN=v,e.$wN=v=pe([se(0,b.$Gk),se(1,D.$Vh),se(2,N.$9j),se(3,A.$8i)],v)}),define(ne[51],re([0,1,125,8,16,3,24,87,176,177]),function(J,e,L,D,N,A,j,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.zip=e.$ip=e.$hp=void 0,e.$hp="end of central directory record signature not found";const E=new RegExp(e.$hp);class O extends Error{constructor(o,t){let i=t.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=t}}e.$ip=O;function m(s){const o=s.externalFileAttributes>>16||33188;return[448,56,7].map(t=>o&t).reduce((t,i)=>t+i,o&61440)}function d(s){if(s instanceof O)return s;let o;return E.test(s.message)&&(o="CorruptZip"),new O(o,s)}function k(s,o,t,i,n,r){const l=N.$lc(o),P=N.$ic(i,l);if(!P.startsWith(i))return Promise.reject(new Error(b.localize(0,null,o)));const y=N.$ic(i,o);let w;return r.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(j.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((R,W)=>{if(!r.isCancellationRequested)try{w=(0,L.createWriteStream)(y,{mode:t}),w.once("close",()=>R()),w.once("error",W),s.once("error",W),s.pipe(w)}catch(_){W(_)}}))}function v(s,o,t,i){let n=(0,D.$Gg)(()=>Promise.resolve()),r=0;const l=i.onCancellationRequested(()=>{n.cancel(),s.close()});return new Promise((P,y)=>{const w=new D.$Ng,R=W=>{W.isCancellationRequested||(r++,s.readEntry())};s.once("error",y),s.once("close",()=>n.then(()=>{i.isCancellationRequested||s.entryCount===r?P():y(new O("Incomplete",new Error(b.localize(1,null,r,s.entryCount))))},y)),s.readEntry(),s.on("entry",W=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(W.fileName)){R(i);return}const _=W.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(_)){const te=N.$ic(o,_);n=(0,D.$Gg)(ae=>j.Promises.mkdir(te,{recursive:!0}).then(()=>R(ae)).then(void 0,y));return}const Y=h(s,W),ue=m(W);n=(0,D.$Gg)(te=>w.queue(()=>Y.then(ae=>k(ae,_,ue,o,t,te).then(()=>R(te)))).then(null,y))})}).finally(()=>l.dispose())}function $(s,o=!1){return new Promise((t,i)=>{(0,u.open)(s,o?{lazyEntries:!0}:void 0,(n,r)=>{n?i(d(n)):t((0,A.$If)(r))})})}function h(s,o){return new Promise((t,i)=>{s.openReadStream(o,(n,r)=>{n?i(d(n)):t((0,A.$If)(r))})})}function f(s,o){return new Promise((t,i)=>{const n=new c.ZipFile;o.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const r=(0,L.createWriteStream)(s);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>t(s))})}e.zip=f;function I(s,o,t={},i){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let r=$(s,!0);return t.overwrite&&(r=r.then(l=>j.Promises.rm(o).then(()=>l))),r.then(l=>v(l,o,{sourcePathRegex:n},i))}e.$kp=I;function p(s,o){return $(s).then(t=>new Promise((i,n)=>{t.on("entry",r=>{r.fileName===o&&h(t,r).then(l=>i(l),l=>n(l))}),t.once("close",()=>n(new Error(b.localize(2,null,o))))}))}function S(s,o){return p(s,o).then(t=>new Promise((i,n)=>{const r=[];t.once("error",n),t.on("data",l=>r.push(l)),t.on("end",()=>i(Buffer.concat(r)))}))}e.$lp=S}),define(ne[160],re([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d,k,v,$,h,f){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;let p=class extends N.$Rc{static{I=this}static{this.c=".sigzip"}constructor(s,o,t,i,n,r){super(),this.h=o,this.j=t,this.m=i,this.n=n,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,t){await this.g;const i=(0,j.$ug)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new k.$8n(r.message,k.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.t(s)){const r=await this.u(s);try{n=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(l){const P=l;if(n=P.code,P.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${P.output}`),n===k.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===k.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new k.$8n(O.$hp,k.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return n===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${s.identifier.id}`),{location:i,verificationStatus:n}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,u.$Df)(o)?o:!0}async u(s){await this.g;const o=(0,j.$ug)(this.extensionsDownloadDir,`${this.z(s)}${I.c}`);return await this.w(s,o,t=>this.j.downloadSignatureArchive(s,t)),o}async w(s,o,t){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await t(o);return}const i=(0,j.$ug)(this.extensionsDownloadDir,`.${(0,c.$dg)()}`);await this.h.exists(i)||await t(i);try{await E.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,D.$9)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],t=[],i=[];for(const l of s.children)if(l.name.endsWith(I.c))i.push(l.resource);else{const P=v.$xo.parse(l.name);P&&t.push([P,l])}const n=(0,v.$Co)(t,([l])=>l),r=[];for(const l of n)l.sort((P,y)=>b.rcompare(P[0].version,y[0].version)),o.push(...l.slice(1).map(P=>P[1].resource)),r.push(l[0][1]);r.sort((l,P)=>l.mtime-P.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),o.push(...i),await L.Promises.settled(o.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(s){this.r.error(s)}}z(s){return this.f?v.$xo.create(s).toString().toLowerCase():(0,c.$dg)()}};e.$Ap=p,e.$Ap=p=I=pe([se(0,d.$Vh),se(1,h.$9j),se(2,k.$7n),se(3,m.$hi),se(4,$.$bp),se(5,f.$8i)],p)}),define(ne[161],re([0,1,51,97]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;function N(A){return(0,L.$lp)(A,"extension/package.json").then(j=>{try{return JSON.parse(j.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$Cp=N}),define(ne[162],re([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d,k,v,$,h,f,I,p,S,s,o,t,i,n,r,l,P,y,w,R,W,_,Y,ue,te,ae,le,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=void 0,e.$Fp=(0,Y.$Oh)(t.$9n);const q=".vsctmp";let G=class extends o.$mp{constructor(F,z,a,g,M,C,X,H,ce,oe,me,de){super(F,z,me,a,oe,de),this.fb=M,this.gb=C,this.hb=X,this.ib=ce,this.eb=new Map,this.rb=new E.$Ac;const ge=this.B(H.createInstance(P.$Bp));this.bb=this.B(H.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new w.$Dp(de,ce,me,this,this.F)),this.db=this.B(H.createInstance(l.$Ap));const fe=this.B(new R.$Ep(this,this.fb,de,C,me,ce,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Ho)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const z=await this.pb(F),a=await(0,I.zip)((0,d.$ug)(this.db.extensionsDownloadDir,(0,h.$dg)()).fsPath,z);return $.URI.file(a)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:z,cleanup:a}=await this.lb(F),g=m.$jc(z.fsPath);try{return await(0,y.$Cp)(g)}finally{await a()}}getInstalled(F,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(F??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.bb.scanUserExtensionAtLocation(F)}async install(F,z={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:a,cleanup:g}=await this.lb(F);try{const M=await(0,y.$Cp)(m.$jc(a.fsPath)),C=(0,i.$Bo)(M.publisher,M.name);if(M.engines&&M.engines.vscode&&!(0,W.$Oo)(M.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,C,this.G.version));const H=(await this.I([{manifest:M,extension:a,options:z}])).find(({identifier:ce})=>(0,i.$wo)(ce,{id:C}));if(H?.local)return H.local;throw H?.error?H.error:(0,o.$op)(new Error(`Unknown error while installing extension ${C}`))}finally{await g()}}async installFromLocation(F,z){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const a=await this.bb.scanUserExtensionAtLocation(F);if(!a)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.ub([[a,void 0]],z),this.F.info("Successfully installed extension",a.identifier.id,z.toString()),a}async installExtensionsFromProfile(F,z,a){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,z.toString(),a.toString());const g=(await this.bb.scanExtensions(1,z)).filter(M=>F.some(C=>(0,i.$wo)(C,M.identifier)));if(g.length){const M=await Promise.all(g.map(C=>this.bb.scanMetadata(C,z)));await this.ub(g.map((C,X)=>[C,M[X]]),a),this.F.info("Successfully installed extensions",g.map(C=>C.identifier.id),a.toString())}return g}async updateMetadata(F,z,a=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),F=await this.bb.updateMetadata(F,z,a),this.cb.invalidate(a),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const z=await this.getTargetPlatform(),[a]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:z,compatible:!0},N.CancellationToken.None);if(!a)throw new Error(p.localize(2,null));await this.bb.setUninstalled(F);try{await this.bb.removeUninstalledExtension(F)}catch(g){throw new Error(p.localize(3,null,(0,A.$yi)(g)))}return this.installFromGallery(a)}ab(F,z,a,g){return this.bb.copyExtension(F,z,a,g)}copyExtensions(F,z){return this.bb.copyExtensions(F,z)}markAsUninstalled(...F){return this.bb.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(F){this.F.error(F)}}async download(F,z,a){const{location:g}=await this.db.download(F,z,!a);return g}async lb(F){if(F.scheme===O.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const z=(0,d.$ug)(this.db.extensionsDownloadDir,(0,h.$dg)());return await this.hb.download(F,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(g){this.F.error(g)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(F,z,a){if($.URI.isUri(z))return new Z(F,z,a,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const g=i.$xo.create(z).toString();let M=this.eb.get(g);return M||(this.eb.set(g,M=new B(F,z,a,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),M.waitUntilTaskIsFinished().finally(()=>this.eb.delete(g))),M}$(F,z){return new x(F,z.profileLocation,this.gb)}async pb(F){const z=async g=>{let M=await f.Promises.readdir(g);M=M.map(H=>m.$ic(g,H));const C=await Promise.all(M.map(H=>f.Promises.stat(H)));let X=Promise.resolve([]);return C.forEach((H,ce)=>{const oe=M[ce];H.isFile()&&(X=X.then(me=>[...me,oe])),H.isDirectory()&&(X=X.then(me=>z(oe).then(de=>[...me,...de])))}),X};return(await z(F.location.fsPath)).map(g=>({path:`extension/${m.$kc(F.location.fsPath,g)}`,localPath:g}))}async qb({added:F,removed:z}){if(z){const a=F&&this.D.extUri.isEqual(z.profileLocation,F.profileLocation)?z.extensions.filter(g=>F.extensions.every(M=>!(0,i.$wo)(M,g))):z.extensions;for(const g of a)this.F.info("Extensions removed from another source",g.id,z.profileLocation.toString()),this.u.fire({identifier:g,profileLocation:z.profileLocation})}if(F){const g=(await this.bb.scanExtensions(1,F.profileLocation)).filter(M=>F.extensions.some(C=>(0,i.$wo)(C,M.identifier)));this.s.fire(g.map(M=>(this.F.info("Extensions added from another source",M.identifier.id,F.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:F.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const F=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of F.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(F){if(!F.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const a of F.rawAdded){if(this.rb.has(a)||!this.D.extUri.isEqual(this.D.extUri.dirname(a),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(a,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(a).startsWith(".")||!(await this.ib.stat(a)).isDirectory)continue;const g=await this.bb.scanUserExtensionAtLocation(a);g&&g.installedTimestamp===void 0&&(this.rb.add(a),z.push(g))}z.length&&(await this.ub(z.map(a=>[a,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(a=>a.identifier.id)))}async ub(F,z){const a=F.map(g=>g[0]);await this.vb(a),await this.gb.addExtensionsToProfile(F,z),this.s.fire(a.map(g=>({local:g,identifier:g.identifier,operation:1,profileLocation:z})))}async vb(F){const z=await this.bb.getUninstalledExtensions();for(const a of F){const g=i.$xo.create(a);z[g.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",g.id),await this.bb.setInstalled(g),this.F.info("Removed the extension from uninstalled list:",g.id))}}};e.$Gp=G,e.$Gp=G=pe([se(0,t.$7n),se(1,ae.$al),se(2,ue.$8i),se(3,s.$Vh),se(4,r.$vp),se(5,n.$rp),se(6,S.$Kn),se(7,Y.$Mh),se(8,_.$9j),se(9,te.$nj),se(10,le.$Gk),se(11,ie.$Ik)],G);let T=class extends c.$Rc{constructor(F,z,a,g,M,C){super(),this.j=F,this.m=z,this.n=a,this.s=g,this.t=M,this.u=C,this.h=this.B(new b.$Md),this.onExtract=this.h.event,this.c=(0,d.$ug)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$Zg}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,z){const a={includeInvalid:!0,profileLocation:z};let g=[];return F===null||F===0?g.push(...await this.n.scanAllExtensions({includeInvalid:!0},a,!1)):F===1&&g.push(...await this.n.scanUserExtensions(a)),g=F!==null?g.filter(M=>M.type===F):g,Promise.all(g.map(M=>this.F(M)))}async scanAllUserExtensions(F){const z=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(z.map(a=>this.F(a)))}async scanUserExtensionAtLocation(F){try{const z=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(F,z,a,g,M){const C=F.toString(),X=$.URI.file(m.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,h.$dg)()}`)),H=$.URI.file(m.$ic(this.n.userExtensionsLocation.fsPath,C));let ce=await this.m.exists(H);if(ce&&g){try{await this.y(F.id,H,"removeExisting")}catch{throw new t.$8n(p.localize(4,null,H.fsPath,F.id),t.ExtensionManagementErrorCode.Delete)}ce=!1}if(!ce)try{try{this.u.trace(`Started extracting the extension from ${z} to ${H.fsPath}`),await(0,I.$kp)(z,X.fsPath,{sourcePath:"extension",overwrite:!0},M),this.u.info(`Extracted extension to ${H}:`,F.id)}catch(oe){let me=t.ExtensionManagementErrorCode.Extract;throw oe instanceof I.$ip&&(oe.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$8n(oe.message,me)}await this.n.updateMetadata(X,a);try{this.u.trace(`Started renaming the extension from ${X.fsPath} to ${H.fsPath}`),await this.C(X.fsPath,H.fsPath),this.u.info("Renamed to",H.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,j.$9)(oe)}. Deleted from extracted location`,X),oe}this.h.fire(H)}catch(oe){try{await this.m.del(X,{recursive:!0})}catch{}throw oe}return this.D(H,1)}async scanMetadata(F,z){return z?(await this.w(F,z))?.metadata:this.n.scanMetadata(F.location)}async w(F,z){return(await this.s.scanProfileExtensions(z)).find(g=>(0,i.$wo)(g.identifier,F.identifier))}async updateMetadata(F,z,a){return a?await this.s.updateMetadata([[F,z]],a):await this.n.updateMetadata(F.location,z),this.D(F.location,F.type,a)}getUninstalledExtensions(){return this.z()}async setUninstalled(...F){const z=F.map(a=>i.$xo.create(a));await this.z(a=>z.forEach(g=>{a[g.toString()]=!0,this.u.info("Marked extension as uninstalled",g.toString())}))}async setInstalled(F){await this.z(z=>delete z[F.toString()])}async removeExtension(F,z){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,z)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(z=>delete z[i.$xo.create(F).toString()])}async copyExtension(F,z,a,g){const M=await this.w(F,z),C=await this.w(F,a);return g={...M?.metadata,...g},C?await this.s.updateMetadata([[F,{...C.metadata,...g}]],a):await this.s.addExtensionsToProfile([[F,g]],a),this.D(F.location,F.type,a)}async copyExtensions(F,z){const a=await this.scanExtensions(1,F),g=await Promise.all(a.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,F)]));await this.s.addExtensionsToProfile(g,z)}async y(F,z,a){this.u.trace(`Deleting ${a} extension from disk`,F,z.fsPath);const g=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,u.$Bi)((0,h.$dg)()).toString(16)}${q}`);await this.C(z.fsPath,g.fsPath),await this.m.del(g,{recursive:!0}),this.u.info(`Deleted ${a} extension from disk`,F,z.fsPath)}async z(F){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(g){if((0,_.$nk)(g)!==1)throw g}let a={};if(z)try{a=JSON.parse(z)}catch{}return F&&(F(a),Object.keys(a).length?await this.m.writeFile(this.c,D.$ae.fromString(JSON.stringify(a))):await this.m.del(this.c)),a})}async C(F,z){try{await f.Promises.rename(F,z,2*60*1e3)}catch(a){throw new t.$8n(a.message||p.localize(5,null,F,z),a.code||t.ExtensionManagementErrorCode.Rename)}}async D(F,z,a){if(a){const M=(await this.n.scanUserExtensions({profileLocation:a})).find(C=>this.t.extUri.isEqual(C.location,F));if(M)return this.F(M)}else{const g=await this.n.scanExistingExtension(F,z,{includeInvalid:!0});if(g)return this.F(g)}throw new Error(p.localize(6,null,F.path))}async F(F){const z=await this.m.resolve(F.location);let a,g;return z.children&&(a=z.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,g=z.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:a,changelogUrl:g,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const M of z)F[i.$xo.create(M).toString()]||a.add(M.identifier.id.toLowerCase());try{const M=(0,i.$Co)(z,C=>C.identifier);await L.Promises.settled(M.map(async C=>{const X=C.sort((H,ce)=>k.rcompare(H.manifest.version,ce.manifest.version))[0];a.has(X.identifier.id.toLowerCase())||await this.j(await this.F(X))}))}catch(M){this.u.error(M)}const g=z.filter(M=>M.metadata&&F[i.$xo.create(M).toString()]);await Promise.allSettled(g.map(M=>this.removeUninstalledExtension(M)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,_.$nk)(z)!==1&&this.u.error(z);return}if(F?.children)try{await Promise.allSettled(F.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(a){(0,_.$nk)(a)!==1&&this.u.error(a)}}}))}catch{}}};e.$Hp=T,e.$Hp=T=pe([se(1,_.$9j),se(2,r.$vp),se(3,n.$rp),se(4,le.$Gk),se(5,ue.$8i)],T);class U extends o.$pp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,v.$Ef)(this.options.operation)?this.l:this.options.operation}constructor(F,z,a,g,M,C,X,H,ce){super(),this.identifier=F,this.source=z,this.options=a,this.m=g,this.n=M,this.o=C,this.p=X,this.q=H,this.s=ce,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[z,a]=await this.x(F);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,a]],this.j),z}async u({zipPath:F,key:z,metadata:a},g,M){let C=await this.v(z);return C||(this.s.trace("Extracting extension...",z.id),C=await this.m.extractUserExtension(z,F,a,g,M),this.s.info("Extracting extension completed.",z.id)),C}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(g=>i.$xo.create(g).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class B extends U{constructor(F,z,a,g,M,C,X,H,ce,oe){super(z.identifier,z,a,M,C,X,H,ce,oe),this.y=z,this.z=g}async x(F){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(X=>(0,i.$wo)(X.identifier,this.y.identifier));a&&(this.l=3);const g={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,v.$Df)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,g),g];const{location:M,verificationStatus:C}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=C,this.B(M.fsPath),[await this.u({zipPath:M.fsPath,key:i.$xo.create(this.y),metadata:g},!1,F),g]}catch(X){try{await this.z.delete(M)}catch(H){this.s.warn("Error while deleting the downloaded file",M.toString(),(0,j.$9)(H))}throw X}}async B(F){try{await(0,y.$Cp)(F)}catch(z){throw new t.$8n((0,o.$np)(z).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Ip=B;class Z extends U{constructor(F,z,a,g,M,C,X,H,ce,oe){super({id:(0,i.$Bo)(F.publisher,F.name)},z,a,M,C,X,H,ce,oe),this.y=F,this.z=z,this.A=g}async h(F){const z=await super.h(F);return this.D(z,F),z}async x(F){const z=new i.$xo(this.identifier,this.y.version),g=(await this.m.scanExtensions(1,this.options.profileLocation)).find(X=>(0,i.$wo)(this.identifier,X.identifier)),M={isApplicationScoped:this.options.isApplicationScoped||g?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||g?.isMachineScoped,isBuiltin:this.options.isBuiltin||g?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(g)if(this.l=3,z.equals(new i.$xo(g.identifier,g.manifest.version)))try{await this.m.removeExtension(g,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&k.gt(g.manifest.version,this.y.version)&&await this.m.setUninstalled(g);else{const X=await this.v(z);if(X)try{await this.m.removeExtension(X,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:m.$jc(this.z.fsPath),key:z,metadata:M},!0,F),M]}async D(F,z){try{let[a]=await this.A.getExtensions([{id:F.identifier.id,version:F.manifest.version}],z);if(a||([a]=await this.A.getExtensions([{id:F.identifier.id}],z)),a){const g={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,g,this.options.profileLocation)}}catch{}}}class x extends o.$pp{constructor(F,z,a){super(),this.extension=F,this.j=z,this.k=a}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,44,136,178]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=void 0;let k=class extends O.$Qo{constructor(f,I,p,S){super(S),this.m=f,this.n=I,this.r=p,this.s(),this.B(f.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,I){const{f:p,g:S}=this;let s;try{s=await(0,c.$Ql)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$9)(i)))}const o={...process.env,...s},t=f.agent?f.agent:await(0,m.$Uq)(f.url||"",o,{proxyUrl:p,strictSSL:S});return f.agent=t,f.strictSSL=S,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>$(f,I))}async resolveProxy(f){}};e.$Vq=k,e.$Vq=k=pe([se(0,b.$hi),se(1,u.$Vh),se(2,E.$8i),se(3,E.$9i)],k);async function v(h){return((0,L.parse)(h.url).protocol==="https:"?await new Promise((p,S)=>{J(["https"],p,S)}):await new Promise((p,S)=>{J(["http"],p,S)})).request}async function $(h,f){return D.Promises.withAsyncBody(async(I,p)=>{const S=(0,L.parse)(h.url),s=h.getRawRequest?h.getRawRequest(h):await v(h),o={hostname:S.hostname,port:S.port?parseInt(S.port):S.protocol==="https:"?443:80,protocol:S.protocol,path:S.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,j.$Df)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(o.auth=h.user+":"+h.password);const t=s(o,i=>{const n=(0,j.$Bf)(h.followRedirects)?h.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)$({...h,url:i.headers.location,followRedirects:n-1},f).then(I,p);else{let r=i;!h.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,d.createGunzip)())),I({res:i,stream:(0,N.$pe)(r)})}});t.on("error",p),h.timeout&&t.setTimeout(h.timeout),h.isChromiumNetwork&&t.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&t.write(h.data),t.end(),f.onCancellationRequested(()=>{t.abort(),p(new A.$4)})})}e.$Wq=$}),define(ne[179],re([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,L,D,N,A,j,b,u,c,E,O,m,d,k,v,$,h,f,I,p,S,s,o,t,i,n,r,l,P,y,w,R,W,_,Y,ue,te,ae,le,ie,q,G,T,U,B,Z,x,Q,F,z,a,g,M,C,X,H,ce,oe,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends j.$Rc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const Pe=be.get(Y.$8i),Me=be.get(r.$9j),V=be.get(h.$Vh),K=be.get(g.$Ik);Pe.info("CLI main",this.b),this.g(Pe),await this.h(V,Me,K,he),await Promise.all(we.map(ee=>{(0,D.$Kg)(ee.flush(),1e3)}))})}async f(){const he=new R.$Lh,we={_serviceBrand:void 0,...le.default};he.set(ie.$nj,we);const be=new f.$gm(this.b,we);he.set(h.$Vh,be),await Promise.all([be.appSettingsHome.with({scheme:b.Schemas.file}).fsPath,be.extensionsPath].map(De=>De?m.Promises.mkdir(De,{recursive:!0}):void 0));const Pe=new ce.$oN((0,Y.$jj)(be),be.logsHome);he.set(Y.$9i,Pe);const Me=this.B(Pe.createLogger("cli",{name:(0,oe.localize)(0,null)})),V=[];Pe.getLogLevel()===Y.LogLevel.Trace&&V.push(new Y.$dj(Pe.getLogLevel()));const K=this.B(new H.$yN(Me,V));he.set(Y.$8i,K);const ee=this.B(new l.$Kp(K));he.set(r.$9j,ee);const $e=this.B(new P.$0p(K));ee.registerProvider(b.Schemas.file,$e);const ye=new a.$wr(ee);he.set(z.$Gk,ye);const Ne=new T.$sN(1,be,K,ee),Se=new M.$uN(Ne,ye,be,ee,K);he.set(g.$Ik,Se),ee.registerProvider(b.Schemas.vscodeUserData,new me.$27b(b.Schemas.file,$e,b.Schemas.vscodeUserData,Se,ye,K));const Le=c.$j&&we.win32RegValueName?this.B(new ae.$Z7b(K,we.win32RegValueName)):be.policyFile?this.B(new ue.$17b(be.policyFile,ee,K)):new te.$gn;he.set(te.$en,Le);const Ie=this.B(new k.$Gn(Se.defaultProfile.settingsResource,ee,Le,K));he.set(d.$hi,Ie),await Promise.all([Ne.init(),Ie.initialize()]);let Ae;try{Ae=await(0,C.$F7b)(Ne,K)}catch(De){De.code!=="ENOENT"&&K.error(De)}Se.init(),he.set(z.$Gk,new a.$wr(ee));const Fe=new G.$Vq(Ie,be,K,Pe);he.set(q.$Po,Fe),he.set(v.$Kn,new y.$Kh($.$NN,void 0,!0)),he.set(o.$rp,new y.$Kh(X.$xN,void 0,!0)),he.set(t.$vp,new y.$Kh(n.$C7b,void 0,!0)),he.set(S.$bp,new y.$Kh(S.$cp,void 0,!0)),he.set(i.$Fp,new y.$Kh(i.$Gp,void 0,!0)),he.set(p.$7n,new y.$Kh(I.$ap,void 0,!0)),he.set(W.$Pq,new y.$Kh(_.$Rq,void 0,!1));const Oe=[],je=(0,x.$to)(we,Ie);if((0,x.$oo)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Oe.push(new Q.$mN(Fe,je,"monacoworkbench",null,we.aiConfig.ariaKey));const De={appenders:Oe,sendErrorTelemetry:!1,commonProperties:(0,U.$eo)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ae,je),piiPaths:(0,x.$uo)(be)};he.set(B.$al,new y.$Kh(Z.$Xq,[De],!1))}else he.set(B.$al,x.$io);return[new w.$aq(he),Oe]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,N.$yi)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$Y)(we)||(0,A.$Z)(we)}),process.on("unhandledRejection",we=>(0,A.$Z)(we))}async h(he,we,be,Pe){let Me;if(he.args.profile&&(Me=be.profiles.find(K=>K.name===he.args.profile),!Me))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Me??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Pe.createInstance(s.$dp,new Y.$dj(Y.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const K={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return Pe.createInstance(s.$dp,new Y.$dj(Y.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),K,!!this.b.force)}else{if(this.b["uninstall-extension"])return Pe.createInstance(s.$dp,new Y.$dj(Y.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return Pe.createInstance(s.$dp,new Y.$dj(Y.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$l8b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?O.URI.file((0,u.$hc)(we)?we:(0,u.$ic)((0,E.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b63441dbc9f729977e8e97321f536a06521496f7/core/vs/code/node/cliProcessMain.js.map
