/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/voiceRecognition/node/voiceRecognitionService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/code/node/sharedProcess/contrib/voiceTranscriber","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(te){for(var e=[],D=0,N=te.length;D<N;D++)e[D]=oe[te[D]];return e};define(oe[124],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class D{static get(){const L=new Map,A=new Map,O=new Map,I=new Map;function C(l,g){l.has(g.detail)||l.set(g.detail,-g.timestamp)}function d(l,g){const p=l.get(g.detail);p&&(p>=0||l.set(g.detail,p+g.timestamp))}let P=[];typeof te=="function"&&typeof te.getStats=="function"&&(P=te.getStats().slice(0).sort((l,g)=>l.timestamp-g.timestamp));for(const l of P)switch(l.type){case 10:C(L,l);break;case 11:case 12:d(L,l);break;case 21:C(A,l);break;case 22:d(A,l);break;case 33:C(O,l);break;case 34:d(O,l);break;case 31:C(I,l);break;case 32:d(I,l);break}let E=0;O.forEach(l=>E+=l);function b(l){const g=[];return l.forEach((p,w)=>g.push([w,p])),g}return{amdLoad:b(L),amdInvoke:b(A),nodeRequire:b(O),nodeEval:b(I),nodeRequireTotal:E}}static toMarkdownTable(L,A){let O="";const I=[];return L.forEach((C,d)=>{I[d]=C.length}),A.forEach(C=>{C.forEach((d,P)=>{typeof d>"u"&&(d=C[P]="-");const E=d.toString().length;I[P]=Math.max(E,I[P])})}),L.forEach((C,d)=>{O+=`| ${C+" ".repeat(I[d]-C.toString().length)} `}),O+=`|
`,L.forEach((C,d)=>{O+=`| ${"-".repeat(I[d])} `}),O+=`|
`,A.forEach(C=>{C.forEach((d,P)=>{typeof d<"u"&&(O+=`| ${d+" ".repeat(I[P]-d.toString().length)} `)}),O+=`|
`}),O}}e.$T=D}),define(oe[125],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function D(p,w,f){const c=N(p,w);if(c!==-1)return p[c]}e.$eb=D;function N(p,w,f=p.length-1){for(let c=f;c>=0;c--){const h=p[c];if(w(h))return c}return-1}e.$fb=N;function L(p,w){const f=A(p,w);return f===-1?void 0:p[f]}e.$gb=L;function A(p,w,f=0,c=p.length){let h=f,m=c;for(;h<m;){const S=Math.floor((h+m)/2);w(p[S])?h=S+1:m=S}return h-1}e.$hb=A;function O(p,w){const f=I(p,w);return f===p.length?void 0:p[f]}e.$ib=O;function I(p,w,f=0,c=p.length){let h=f,m=c;for(;h<m;){const S=Math.floor((h+m)/2);w(p[S])?m=S:h=S+1}return h}e.$jb=I;function C(p,w,f=0,c=p.length){const h=I(p,w,f,c);return h===p.length?-1:h}e.$kb=C;class d{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(d.assertInvariants){if(this.d){for(const c of this.e)if(this.d(c)&&!w(c))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const f=A(this.e,w,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$lb=d;function P(p,w){if(p.length===0)return;let f=p[0];for(let c=1;c<p.length;c++){const h=p[c];w(h,f)>0&&(f=h)}return f}e.$mb=P;function E(p,w){if(p.length===0)return;let f=p[0];for(let c=1;c<p.length;c++){const h=p[c];w(h,f)>=0&&(f=h)}return f}e.$nb=E;function b(p,w){return P(p,(f,c)=>-w(f,c))}e.$ob=b;function l(p,w){if(p.length===0)return-1;let f=0;for(let c=1;c<p.length;c++){const h=p[c];w(h,p[f])>0&&(f=c)}return f}e.$pb=l;function g(p,w){for(const f of p){const c=w(f);if(c!==void 0)return c}}e.$qb=g}),define(oe[126],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function D(O,I){const C=Object.create(null);for(const d of O){const P=I(d);let E=C[P];E||(E=C[P]=[]),E.push(d)}return C}e.$J=D;function N(O,I){const C=[],d=[];for(const P of O)I.has(P)||C.push(P);for(const P of I)O.has(P)||d.push(P);return{removed:C,added:d}}e.$K=N;function L(O,I){const C=[],d=[];for(const[P,E]of O)I.has(P)||C.push(E);for(const[P,E]of I)O.has(P)||d.push(E);return{removed:C,added:d}}e.$L=L;function A(O,I){const C=new Set;for(const d of I)O.has(d)&&C.add(d);return C}e.$M=A}),define(oe[84],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function D(O){return(I,C,d)=>{let P=null,E=null;if(typeof d.value=="function"?(P="value",E=d.value):typeof d.get=="function"&&(P="get",E=d.get),!E)throw new Error("not supported");d[P]=O(E,C)}}function N(O,I,C){let d=null,P=null;if(typeof C.value=="function"?(d="value",P=C.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(d="get",P=C.get),!P)throw new Error("not supported");const E=`$memoize$${I}`;C[d]=function(...b){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,b)}),this[E]}}e.$fh=N;function L(O,I,C){return D((d,P)=>{const E=`$debounce$${P}`,b=`$debounce$result$${P}`;return function(...l){this[b]||(this[b]=C?C():void 0),clearTimeout(this[E]),I&&(this[b]=I(this[b],...l),l=[this[b]]),this[E]=setTimeout(()=>{d.apply(this,l),this[b]=C?C():void 0},O)}})}e.$gh=L;function A(O,I,C){return D((d,P)=>{const E=`$throttle$timer$${P}`,b=`$throttle$result$${P}`,l=`$throttle$lastRun$${P}`,g=`$throttle$pending$${P}`;return function(...p){if(this[b]||(this[b]=C?C():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),I&&(this[b]=I(this[b],...p)),this[g])return;const w=this[l]+O;w<=Date.now()?(this[l]=Date.now(),d.apply(this,[this[b]]),this[b]=C?C():void 0):(this[g]=!0,this[E]=setTimeout(()=>{this[g]=!1,this[l]=Date.now(),d.apply(this,[this[b]]),this[b]=C?C():void 0},w-Date.now()))}})}e.$hh=A}),define(oe[8],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class D{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?h.isErrorNoTelemetry(s)?new h(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(a=>{a(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$V=D,e.$W=new D;function N(S){e.$W.setUnexpectedErrorHandler(S)}e.setUnexpectedErrorHandler=N;function L(S){if(!S||typeof S!="object")return!1;const s=S;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.$Y=L;function A(S){d(S)||e.$W.onUnexpectedError(S)}e.$Z=A;function O(S){d(S)||e.$W.onUnexpectedExternalError(S)}e.$1=O;function I(S){if(S instanceof Error){const{name:s,message:a}=S,n=S.stacktrace||S.stack;return{$isError:!0,name:s,message:a,stack:n,noTelemetry:h.isErrorNoTelemetry(S)}}return S}e.$2=I;const C="Canceled";function d(S){return S instanceof P?!0:S instanceof Error&&S.name===C&&S.message===C}e.$3=d;class P extends Error{constructor(){super(C),this.name=this.message}}e.$4=P;function E(){const S=new Error(C);return S.name=S.message,S}e.$5=E;function b(S){return S?new Error(`Illegal argument: ${S}`):new Error("Illegal argument")}e.$6=b;function l(S){return S?new Error(`Illegal state: ${S}`):new Error("Illegal state")}e.$7=l;class g extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=g;function p(S){return S?S.message?S.message:S.stack?S.stack.split(`
`)[0]:String(S):"Error"}e.$9=p;class w extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$0=w;class f extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$$=f;class c extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=c;class h extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof h)return s;const a=new h;return a.message=s.message,a.stack=s.stack,a}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$ab=h;class m extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$bb=m}),define(oe[18],ae([0,1,8,125]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function L(F,G=0){return F[F.length-(1+G)]}e.$rb=L;function A(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.$sb=A;function O(F,G,Z=(re,le)=>re===le){if(F===G)return!0;if(!F||!G||F.length!==G.length)return!1;for(let re=0,le=F.length;re<le;re++)if(!Z(F[re],G[re]))return!1;return!0}e.$tb=O;function I(F,G){const Z=F.length-1;G<Z&&(F[G]=F[Z]),F.pop()}e.$ub=I;function C(F,G,Z){return d(F.length,re=>Z(F[re],G))}e.$vb=C;function d(F,G){let Z=0,re=F-1;for(;Z<=re;){const le=(Z+re)/2|0,ue=G(le);if(ue<0)Z=le+1;else if(ue>0)re=le-1;else return le}return-(Z+1)}e.$wb=d;function P(F,G,Z){if(F=F|0,F>=G.length)throw new TypeError("invalid index");const re=G[Math.floor(G.length*Math.random())],le=[],ue=[],he=[];for(const $e of G){const de=Z($e,re);de<0?le.push($e):de>0?ue.push($e):he.push($e)}return F<le.length?P(F,le,Z):F<le.length+he.length?he[0]:P(F-(le.length+he.length),ue,Z)}e.$xb=P;function E(F,G){const Z=[];let re;for(const le of F.slice(0).sort(G))!re||G(re[0],le)!==0?(re=[le],Z.push(re)):re.push(le);return Z}e.$yb=E;function*b(F,G){let Z,re;for(const le of F)re!==void 0&&G(re,le)?Z.push(le):(Z&&(yield Z),Z=[le]),re=le;Z&&(yield Z)}e.$zb=b;function l(F,G){for(let Z=0;Z<=F.length;Z++)G(Z===0?void 0:F[Z-1],Z===F.length?void 0:F[Z])}e.$Ab=l;function g(F,G){for(let Z=0;Z<F.length;Z++)G(Z===0?void 0:F[Z-1],F[Z],Z+1===F.length?void 0:F[Z+1])}e.$Bb=g;function p(F,G,Z){const re=[];function le($e,de,we){if(de===0&&we.length===0)return;const Ee=re[re.length-1];Ee&&Ee.start+Ee.deleteCount===$e?(Ee.deleteCount+=de,Ee.toInsert.push(...we)):re.push({start:$e,deleteCount:de,toInsert:we})}let ue=0,he=0;for(;;){if(ue===F.length){le(ue,0,G.slice(he));break}if(he===G.length){le(ue,F.length-ue,[]);break}const $e=F[ue],de=G[he],we=Z($e,de);we===0?(ue+=1,he+=1):we<0?(le(ue,1,[]),ue+=1):we>0&&(le(ue,0,[de]),he+=1)}return re}e.$Cb=p;function w(F,G,Z){const re=p(F,G,Z),le=[],ue=[];for(const he of re)le.push(...F.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:le,added:ue}}e.$Db=w;function f(F,G,Z){if(Z===0)return[];const re=F.slice(0,Z).sort(G);return h(F,G,re,Z,F.length),re}e.top=f;function c(F,G,Z,re,le){return Z===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const $e=F.length,de=F.slice(0,Z).sort(G);for(let we=Z,Ee=Math.min(Z+re,$e);we<$e;we=Ee,Ee=Math.min(Ee+re,$e)){if(we>Z&&await new Promise(Ie=>setTimeout(Ie)),le&&le.isCancellationRequested)throw new D.$4;h(F,G,de,we,Ee)}return de})().then(ue,he)})}e.$Fb=c;function h(F,G,Z,re,le){for(const ue=Z.length;re<le;re++){const he=F[re];if(G(he,Z[ue-1])<0){Z.pop();const $e=(0,N.$jb)(Z,de=>G(he,de)<0);Z.splice($e,0,he)}}}function m(F){return F.filter(G=>!!G)}e.$Gb=m;function S(F){let G=0;for(let Z=0;Z<F.length;Z++)F[Z]&&(F[G]=F[Z],G+=1);F.length=G}e.$Hb=S;function s(F,G,Z){F.splice(Z,0,F.splice(G,1)[0])}e.$Ib=s;function a(F){return!Array.isArray(F)||F.length===0}e.$Jb=a;function n(F){return Array.isArray(F)&&F.length>0}e.$Kb=n;function i(F,G=Z=>Z){const Z=new Set;return F.filter(re=>{const le=G(re);return Z.has(le)?!1:(Z.add(le),!0)})}e.$Lb=i;function t(F){const G=new Set;return Z=>{const re=F(Z);return G.has(re)?!1:(G.add(re),!0)}}e.$Mb=t;function r(F,G){return F.length>0?F[0]:G}e.$Nb=r;function o(F,G){return F.length>0?F[F.length-1]:G}e.$Ob=o;function v(F,G,Z=(re,le)=>re===le){let re=0;for(let le=0,ue=Math.min(F.length,G.length);le<ue&&Z(F[le],G[le]);le++)re++;return re}e.$Pb=v;function y(F){return[].concat(...F)}e.$Qb=y;function u(F,G){let Z=typeof G=="number"?F:0;typeof G=="number"?Z=F:(Z=0,G=F);const re=[];if(Z<=G)for(let le=Z;le<G;le++)re.push(le);else for(let le=Z;le>G;le--)re.push(le);return re}e.$Rb=u;function $(F,G,Z){return F.reduce((re,le)=>(re[G(le)]=Z?Z(le):le,re),Object.create(null))}e.$Sb=$;function j(F,G){return F.push(G),()=>M(F,G)}e.$Tb=j;function M(F,G){const Z=F.indexOf(G);if(Z>-1)return F.splice(Z,1),G}e.$Ub=M;function T(F,G,Z){const re=F.slice(0,G),le=F.slice(G);return re.concat(Z,le)}e.$Vb=T;function U(F,G){let Z;if(typeof G=="number"){let re=G;Z=()=>{const le=Math.sin(re++)*179426549;return le-Math.floor(le)}}else Z=Math.random;for(let re=F.length-1;re>0;re-=1){const le=Math.floor(Z()*(re+1)),ue=F[re];F[re]=F[le],F[le]=ue}}e.$Wb=U;function q(F,G){const Z=F.indexOf(G);Z>-1&&(F.splice(Z,1),F.unshift(G))}e.$Xb=q;function Y(F,G){const Z=F.indexOf(G);Z>-1&&(F.splice(Z,1),F.push(G))}e.$Yb=Y;function J(F,G){for(const Z of G)F.push(Z)}e.$Zb=J;function x(F,G){return Array.isArray(F)?F.map(G):G(F)}e.$1b=x;function W(F){return Array.isArray(F)?F:[F]}e.$2b=W;function Q(F){return F[Math.floor(Math.random()*F.length)]}e.$3b=Q;function H(F,G,Z){const re=ee(F,G),le=F.length,ue=Z.length;F.length=le+ue;for(let he=le-1;he>=re;he--)F[he+ue]=F[he];for(let he=0;he<ue;he++)F[he+re]=Z[he]}e.$4b=H;function V(F,G,Z,re){const le=ee(F,G);let ue=F.splice(le,Z);return ue===void 0&&(ue=[]),H(F,le,re),ue}e.$5b=V;function ee(F,G){return G<0?Math.max(G+F.length,0):Math.min(G,F.length)}var ne;(function(F){function G(ue){return ue<0}F.isLessThan=G;function Z(ue){return ue<=0}F.isLessThanOrEqual=Z;function re(ue){return ue>0}F.isGreaterThan=re;function le(ue){return ue===0}F.isNeitherLessOrGreaterThan=le,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function _(F,G){return(Z,re)=>G(F(Z),F(re))}e.$6b=_;function ie(...F){return(G,Z)=>{for(const re of F){const le=re(G,Z);if(!ne.isNeitherLessOrGreaterThan(le))return le}return ne.neitherLessOrGreaterThan}}e.$7b=ie;const K=(F,G)=>F-G;e.$8b=K;const B=(F,G)=>(0,e.$8b)(F?1:0,G?1:0);e.$9b=B;function k(F){return(G,Z)=>-F(G,Z)}e.$0b=k;class R{constructor(G){this.g=G,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(G){let Z=this.c;for(;Z<this.g.length&&G(this.g[Z]);)Z++;const re=Z===this.c?null:this.g.slice(this.c,Z);return this.c=Z,re}takeFromEndWhile(G){let Z=this.d;for(;Z>=0&&G(this.g[Z]);)Z--;const re=Z===this.d?null:this.g.slice(Z+1,this.d+1);return this.d=Z,re}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const G=this.g[this.c];return this.c++,G}removeLast(){const G=this.g[this.d];return this.d--,G}takeCount(G){const Z=this.g.slice(this.c,this.c+G);return this.c+=G,Z}}e.$$b=R;class z{static{this.empty=new z(G=>{})}constructor(G){this.iterate=G}forEach(G){this.iterate(Z=>(G(Z),!0))}toArray(){const G=[];return this.iterate(Z=>(G.push(Z),!0)),G}filter(G){return new z(Z=>this.iterate(re=>G(re)?Z(re):!0))}map(G){return new z(Z=>this.iterate(re=>Z(G(re))))}some(G){let Z=!1;return this.iterate(re=>(Z=G(re),!Z)),Z}findFirst(G){let Z;return this.iterate(re=>G(re)?(Z=re,!1):!0),Z}findLast(G){let Z;return this.iterate(re=>(G(re)&&(Z=re),!0)),Z}findLastMaxBy(G){let Z,re=!0;return this.iterate(le=>((re||ne.isGreaterThan(G(le,Z)))&&(re=!1,Z=le),!0)),Z}}e.$_b=z}),define(oe[127],ae([0,1,8]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function N(C,d){if(!C)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=N;function L(C,d="Unreachable"){throw new Error(d)}e.$3c=L;function A(C){if(!C)throw new D.$bb("Assertion Failed")}e.$4c=A;function O(C){if(!C()){debugger;C(),(0,D.$Z)(new D.$bb("Assertion Failed"))}}e.$5c=O;function I(C,d){let P=0;for(;P<C.length-1;){const E=C[P],b=C[P+1];if(!d(E,b))return!1;P++}return!0}e.$6c=I}),define(oe[85],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function D(N){const L=this;let A=!1,O;return function(){return A||(A=!0,O=N.apply(L,arguments)),O}}e.$cb=D}),define(oe[59],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function L(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}N.is=L;const A=Object.freeze([]);function O(){return A}N.empty=O;function*I(S){yield S}N.single=I;function C(S){return L(S)?S:I(S)}N.wrap=C;function d(S){return S||A}N.from=d;function*P(S){for(let s=S.length-1;s>=0;s--)yield S[s]}N.reverse=P;function E(S){return!S||S[Symbol.iterator]().next().done===!0}N.isEmpty=E;function b(S){return S[Symbol.iterator]().next().value}N.first=b;function l(S,s){for(const a of S)if(s(a))return!0;return!1}N.some=l;function g(S,s){for(const a of S)if(s(a))return a}N.find=g;function*p(S,s){for(const a of S)s(a)&&(yield a)}N.filter=p;function*w(S,s){let a=0;for(const n of S)yield s(n,a++)}N.map=w;function*f(...S){for(const s of S)for(const a of s)yield a}N.concat=f;function c(S,s,a){let n=a;for(const i of S)n=s(n,i);return n}N.reduce=c;function*h(S,s,a=S.length){for(s<0&&(s+=S.length),a<0?a+=S.length:a>S.length&&(a=S.length);s<a;s++)yield S[s]}N.slice=h;function m(S,s=Number.POSITIVE_INFINITY){const a=[];if(s===0)return[a,S];const n=S[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[a,N.empty()];a.push(t.value)}return[a,{[Symbol.iterator](){return n}}]}N.consume=m})(D||(e.Iterable=D={}))}),define(oe[35],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(s,a=!1){let n=0;const i=s.length;let t="",r=0,o=16,v=0;function y(q){let Y=0,J=0;for(;Y<q;){const x=s.charCodeAt(n);if(x>=48&&x<=57)J=J*16+x-48;else if(x>=65&&x<=70)J=J*16+x-65+10;else if(x>=97&&x<=102)J=J*16+x-97+10;else break;n++,Y++}return Y<q&&(J=-1),J}function u(q){n=q,t="",r=0,o=16,v=0}function $(){const q=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&d(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&d(s.charCodeAt(n)))for(n++;n<s.length&&d(s.charCodeAt(n));)n++;else return v=3,s.substring(q,n);let Y=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&d(s.charCodeAt(n))){for(n++;n<s.length&&d(s.charCodeAt(n));)n++;Y=n}else v=3;return s.substring(q,Y)}function j(){let q="",Y=n;for(;;){if(n>=i){q+=s.substring(Y,n),v=2;break}const J=s.charCodeAt(n);if(J===34){q+=s.substring(Y,n),n++;break}if(J===92){if(q+=s.substring(Y,n),n++,n>=i){v=2;break}switch(s.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const W=y(4);W>=0?q+=String.fromCharCode(W):v=4;break}default:v=5}Y=n;continue}if(J>=0&&J<=31)if(C(J)){q+=s.substring(Y,n),v=2;break}else v=6;n++}return q}function M(){if(t="",v=0,r=n,n>=i)return r=i,o=17;let q=s.charCodeAt(n);if(I(q)){do n++,t+=String.fromCharCode(q),q=s.charCodeAt(n);while(I(q));return o=15}if(C(q))return n++,t+=String.fromCharCode(q),q===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),o=14;switch(q){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,t=j(),o=10;case 47:{const Y=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!C(s.charCodeAt(n));)n++;return t=s.substring(Y,n),o=12}if(s.charCodeAt(n+1)===42){n+=2;const J=i-1;let x=!1;for(;n<J;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=s.substring(Y,n),o=13}return t+=String.fromCharCode(q),n++,o=16}case 45:if(t+=String.fromCharCode(q),n++,n===i||!d(s.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=$(),o=11;default:for(;n<i&&T(q);)n++,q=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return t+=String.fromCharCode(q),n++,o=16}}function T(q){if(I(q)||C(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let q;do q=M();while(q>=12&&q<=15);return q}return{setPosition:u,getPosition:()=>n,scan:a?U:M,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$Qm=O;function I(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function C(s){return s===10||s===13||s===8232||s===8233}function d(s){return s>=48&&s<=57}var P;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(P||(P={}));function E(s,a){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function v(y,u,$,j){r.value=y,r.offset=u,r.length=$,r.type=j,r.colonOffset=void 0,t=r}try{h(s,{onObjectBegin:(y,u)=>{if(a<=y)throw i;t=void 0,o=a>y,n.push("")},onObjectProperty:(y,u,$)=>{if(a<u||(v(y,u,$,"property"),n[n.length-1]=y,a<=u+$))throw i},onObjectEnd:(y,u)=>{if(a<=y)throw i;t=void 0,n.pop()},onArrayBegin:(y,u)=>{if(a<=y)throw i;t=void 0,n.push(0)},onArrayEnd:(y,u)=>{if(a<=y)throw i;t=void 0,n.pop()},onLiteralValue:(y,u,$)=>{if(a<u||(v(y,u,$,S(y)),a<=u+$))throw i},onSeparator:(y,u,$)=>{if(a<=u)throw i;if(y===":"&&t&&t.type==="property")t.colonOffset=u,o=!1,t=void 0;else if(y===","){const j=n[n.length-1];typeof j=="number"?n[n.length-1]=j+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch(y){if(y!==i)throw y}return{path:n,previousNode:t,isAtPropertyKey:o,matches:y=>{let u=0;for(let $=0;u<y.length&&$<n.length;$++)if(y[u]===n[$]||y[u]==="*")u++;else if(y[u]!=="**")return!1;return u===y.length}}}e.$Rm=E;function b(s,a=[],n=A.DEFAULT){let i=null,t=[];const r=[];function o(y){Array.isArray(t)?t.push(y):i!==null&&(t[i]=y)}return h(s,{onObjectBegin:()=>{const y={};o(y),r.push(t),t=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const y=[];o(y),r.push(t),t=y,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:o,onError:(y,u,$)=>{a.push({error:y,offset:u,length:$})}},n),t[0]}e.$Sm=b;function l(s,a=[],n=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function r(y){return i.children.push(y),y}h(s,{onObjectBegin:y=>{i=r({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,u,$)=>{i=r({type:"property",offset:u,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:u,length:$,parent:i})},onObjectEnd:(y,u)=>{i.length=y+u-i.offset,i=i.parent,t(y+u)},onArrayBegin:(y,u)=>{i=r({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,u)=>{i.length=y+u-i.offset,i=i.parent,t(y+u)},onLiteralValue:(y,u,$)=>{r({type:S(y),offset:u,length:$,parent:i,value:y}),t(u+$)},onSeparator:(y,u,$)=>{i.type==="property"&&(y===":"?i.colonOffset=u:y===","&&t(u))},onError:(y,u,$)=>{a.push({error:y,offset:u,length:$})}},n);const v=i.children[0];return v&&delete v.parent,v}e.$Tm=l;function g(s,a){if(!s)return;let n=s;for(const i of a)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$Um=g;function p(s){if(!s.parent||!s.parent.children)return[];const a=p(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;a.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&a.push(n)}return a}e.$Vm=p;function w(s){switch(s.type){case"array":return s.children.map(w);case"object":{const a=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(a[n.children[0].value]=w(i))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$Wm=w;function f(s,a,n=!1){return a>=s.offset&&a<s.offset+s.length||n&&a===s.offset+s.length}e.$Xm=f;function c(s,a,n=!1){if(f(s,a,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=a;t++){const r=c(i[t],a,n);if(r)return r}return s}}e.$Ym=c;function h(s,a,n=A.DEFAULT){const i=O(s,!1);function t(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(_){return _?ie=>_(ie,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=t(a.onObjectBegin),v=r(a.onObjectProperty),y=t(a.onObjectEnd),u=t(a.onArrayBegin),$=t(a.onArrayEnd),j=r(a.onLiteralValue),M=r(a.onSeparator),T=t(a.onComment),U=r(a.onError),q=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function J(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:q||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(_){case 12:case 13:q?x(10):T();break;case 16:x(1);break;case 15:case 14:break;default:return _}}}function x(_,ie=[],K=[]){if(U(_),ie.length+K.length>0){let B=i.getToken();for(;B!==17;){if(ie.indexOf(B)!==-1){J();break}else if(K.indexOf(B)!==-1)break;B=J()}}}function W(_){const ie=i.getTokenValue();return _?j(ie):v(ie),J(),!0}function Q(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(x(2),_=0)}catch{x(2)}j(_);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return J(),!0}function H(){return i.getToken()!==10?(x(3,[],[2,5]),!1):(W(!1),i.getToken()===6?(M(":"),J(),ne()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function V(){o(),J();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),M(","),J(),i.getToken()===2&&Y)break}else _&&x(6,[],[]);H()||x(4,[],[2,5]),_=!0}return y(),i.getToken()!==2?x(7,[2],[]):J(),!0}function ee(){u(),J();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),M(","),J(),i.getToken()===4&&Y)break}else _&&x(6,[],[]);ne()||x(4,[],[4,5]),_=!0}return $(),i.getToken()!==4?x(8,[4],[]):J(),!0}function ne(){switch(i.getToken()){case 3:return ee();case 1:return V();case 10:return W(!0);default:return Q()}}return J(),i.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):ne()?(i.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$Zm=h;function m(s,a){const n=O(s),i=[];let t,r=0,o;do switch(o=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==o&&i.push(s.substring(r,o)),a!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,a)),r=n.getPosition();break}while(t!==17);return i.join("")}e.$1m=m;function S(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$2m=S}),define(oe[41],ae([0,1,35]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VS=e.$US=e.$TS=e.$SS=void 0;function N(d,P,E){let b,l,g,p,w;if(P){for(p=P.offset,w=p+P.length,g=p;g>0&&!C(d,g-1);)g--;let o=w;for(;o<d.length&&!C(d,o);)o++;l=d.substring(g,o),b=O(l,E)}else l=d,b=0,g=0,p=0,w=d.length;const f=I(E,d);let c=!1,h=0,m;E.insertSpaces?m=A(" ",E.tabSize||4):m="	";const S=(0,D.$Qm)(l,!1);let s=!1;function a(){return f+A(m,b+h)}function n(){let o=S.scan();for(c=!1;o===15||o===14;)c=c||o===14,o=S.scan();return s=o===16||S.getTokenError()!==0,o}const i=[];function t(o,v,y){!s&&v<w&&y>p&&d.substring(v,y)!==o&&i.push({offset:v,length:y-v,content:o})}let r=n();if(r!==17){const o=S.getTokenOffset()+g,v=A(m,b);t(v,g,o)}for(;r!==17;){let o=S.getTokenOffset()+S.getTokenLength()+g,v=n(),y="";for(;!c&&(v===12||v===13);){const $=S.getTokenOffset()+g;t(" ",o,$),o=S.getTokenOffset()+S.getTokenLength()+g,y=v===12?a():"",v=n()}if(v===2)r!==1&&(h--,y=a());else if(v===4)r!==3&&(h--,y=a());else{switch(r){case 3:case 1:h++,y=a();break;case 5:case 12:y=a();break;case 13:c?y=a():y=" ";break;case 6:y=" ";break;case 10:if(v===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?y=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}c&&(v===12||v===13)&&(y=a())}const u=S.getTokenOffset()+g;t(y,o,u),r=v}return i}e.$SS=N;function L(d,P){const E=JSON.stringify(d,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.$TS=L;function A(d,P){let E="";for(let b=0;b<P;b++)E+=d;return E}function O(d,P){let E=0,b=0;const l=P.tabSize||4;for(;E<d.length;){const g=d.charAt(E);if(g===" ")b++;else if(g==="	")b+=l;else break;E++}return Math.floor(b/l)}function I(d,P){for(let E=0;E<P.length;E++){const b=P.charAt(E);if(b==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return d&&d.eol||`
`}e.$US=I;function C(d,P){return`\r
`.indexOf(d.charAt(P))!==-1}e.$VS=C}),define(oe[86],ae([0,1,35,41]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1S=e.$ZS=e.$YS=e.$XS=e.$WS=void 0;function L(d,P,E){return A(d,P,void 0,E)}e.$WS=L;function A(d,P,E,b,l){const g=P.slice(),p=[],w=(0,D.$Tm)(d,p);let f,c;for(;g.length>0&&(c=g.pop(),f=(0,D.$Um)(w,g),f===void 0&&E!==void 0);)typeof c=="string"?E={[c]:E}:E=[E];if(f)if(f.type==="object"&&typeof c=="string"&&Array.isArray(f.children)){const h=(0,D.$Um)(f,[c]);if(h!==void 0)if(E===void 0){if(!h.parent)throw new Error("Malformed AST");const m=f.children.indexOf(h.parent);let S,s=h.parent.offset+h.parent.length;if(m>0){const a=f.children[m-1];S=a.offset+a.length}else S=f.offset+1,f.children.length>1&&(s=f.children[1].offset);return O(d,{offset:S,length:s-S,content:""},b)}else return O(d,{offset:h.offset,length:h.length,content:JSON.stringify(E)},b);else{if(E===void 0)return[];const m=`${JSON.stringify(c)}: ${JSON.stringify(E)}`,S=l?l(f.children.map(a=>a.children[0].value)):f.children.length;let s;if(S>0){const a=f.children[S-1];s={offset:a.offset+a.length,length:0,content:","+m}}else f.children.length===0?s={offset:f.offset+1,length:0,content:m}:s={offset:f.offset+1,length:0,content:m+","};return O(d,s,b)}}else if(f.type==="array"&&typeof c=="number"&&Array.isArray(f.children))if(E!==void 0){const h=`${JSON.stringify(E)}`;let m;if(f.children.length===0||c===0)m={offset:f.offset+1,length:0,content:f.children.length===0?h:h+","};else{const S=c===-1||c>f.children.length?f.children.length:c,s=f.children[S-1];m={offset:s.offset+s.length,length:0,content:","+h}}return O(d,m,b)}else{const h=c,m=f.children[h];let S;if(f.children.length===1)S={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===h){const s=f.children[h-1],a=s.offset+s.length,n=f.offset+f.length;S={offset:a,length:n-2-a,content:""}}else S={offset:m.offset,length:f.children[h+1].offset-m.offset,content:""};return O(d,S,b)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${f.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return O(d,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(E)},b)}}e.$XS=A;function O(d,P,E){let b=I(d,P),l=P.offset,g=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;l>0&&!(0,N.$VS)(b,l-1);)l--;for(;g<b.length&&!(0,N.$VS)(b,g);)g++}const p=(0,N.$SS)(b,{offset:l,length:g-l},E);for(let f=p.length-1;f>=0;f--){const c=p[f];b=I(b,c),l=Math.min(l,c.offset),g=Math.max(g,c.offset+c.length),g+=c.content.length-c.length}const w=d.length-(b.length-g)-l;return[{offset:l,length:w,content:b.substring(l,g)}]}e.$YS=O;function I(d,P){return d.substring(0,P.offset)+P.content+d.substring(P.offset+P.length)}e.$ZS=I;function C(d,P){const E=P.slice(0).sort((l,g)=>{const p=l.offset-g.offset;return p===0?l.length-g.length:p});let b=d.length;for(let l=E.length-1;l>=0;l--){const g=E[l];if(g.offset+g.length<=b)d=I(d,g);else throw new Error("Overlapping edit");b=g.offset}return d}e.$1S=C}),define(oe[60],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class D{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=D}),define(oe[87],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let A=this.a;for(;A!==D.Undefined;){const O=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=O}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const I=new D(A);if(this.a===D.Undefined)this.a=I,this.b=I;else if(O){const d=this.b;this.b=I,I.prev=d,d.next=I}else{const d=this.a;this.a=I,I.next=d,d.prev=I}this.c+=1;let C=!1;return()=>{C||(C=!0,this.e(I))}}shift(){if(this.a!==D.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==D.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===D.Undefined&&A.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):A.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):A.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.$1c=N}),define(oe[34],ae([0,1]),function(te,e){"use strict";var D,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function A(c,h,m){let S=c.get(h);return S===void 0&&(S=m,c.set(h,S)),S}e.$wc=A;function O(c){const h=[];return c.forEach((m,S)=>{h.push(`${S} => ${m}`)}),`Map(${c.size}) {${h.join(", ")}}`}e.$xc=O;function I(c){const h=[];return c.forEach(m=>{h.push(m)}),`Set(${c.size}) {${h.join(", ")}}`}e.$yc=I;class C{constructor(h,m){this.uri=h,this.value=m}}function d(c){return Array.isArray(c)}class P{static{this.a=h=>h.toString()}constructor(h,m){if(this[D]="ResourceMap",h instanceof P)this.b=new Map(h.b),this.c=m??P.a;else if(d(h)){this.b=new Map,this.c=m??P.a;for(const[S,s]of h)this.set(S,s)}else this.b=new Map,this.c=h??P.a}set(h,m){return this.b.set(this.c(h),new C(h,m)),this}get(h){return this.b.get(this.c(h))?.value}has(h){return this.b.has(this.c(h))}get size(){return this.b.size}clear(){this.b.clear()}delete(h){return this.b.delete(this.c(h))}forEach(h,m){typeof m<"u"&&(h=h.bind(m));for(const[S,s]of this.b)h(s.value,s.uri,this)}*values(){for(const h of this.b.values())yield h.value}*keys(){for(const h of this.b.values())yield h.uri}*entries(){for(const h of this.b.values())yield[h.uri,h.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.b)yield[h.uri,h.value]}}e.$zc=P;class E{constructor(h,m){this[N]="ResourceSet",!h||typeof h=="function"?this.a=new P(h):(this.a=new P(m),h.forEach(this.add,this))}get size(){return this.a.size}add(h){return this.a.set(h,h),this}clear(){this.a.clear()}delete(h){return this.a.delete(h)}forEach(h,m){this.a.forEach((S,s)=>h.call(m,s,s,this))}has(h){return this.a.has(h)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=E;var b;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class l{constructor(){this[L]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(h){return this.a.has(h)}get(h,m=0){const S=this.a.get(h);if(S)return m!==0&&this.j(S,m),S.value}set(h,m,S=0){let s=this.a.get(h);if(s)s.value=m,S!==0&&this.j(s,S);else{switch(s={key:h,value:m,next:void 0,previous:void 0},S){case 0:this.h(s);break;case 1:this.g(s);break;case 2:this.h(s);break;default:this.h(s);break}this.a.set(h,s),this.d++}return this}delete(h){return!!this.remove(h)}remove(h){const m=this.a.get(h);if(m)return this.a.delete(h),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const h=this.b;return this.a.delete(h.key),this.i(h),this.d--,h.value}forEach(h,m){const S=this.e;let s=this.b;for(;s;){if(m?h.bind(m)(s.value,s.key,this):h(s.value,s.key,this),this.e!==S)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const h=this,m=this.e;let S=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==m)throw new Error("LinkedMap got modified during iteration.");if(S){const a={value:S.key,done:!1};return S=S.next,a}else return{value:void 0,done:!0}}};return s}values(){const h=this,m=this.e;let S=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==m)throw new Error("LinkedMap got modified during iteration.");if(S){const a={value:S.value,done:!1};return S=S.next,a}else return{value:void 0,done:!0}}};return s}entries(){const h=this,m=this.e;let S=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==m)throw new Error("LinkedMap got modified during iteration.");if(S){const a={value:[S.key,S.value],done:!1};return S=S.next,a}else return{value:void 0,done:!0}}};return s}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(h){if(h>=this.size)return;if(h===0){this.clear();return}let m=this.b,S=this.size;for(;m&&S>h;)this.a.delete(m.key),m=m.next,S--;this.b=m,this.d=S,m&&(m.previous=void 0),this.e++}g(h){if(!this.b&&!this.c)this.c=h;else if(this.b)h.next=this.b,this.b.previous=h;else throw new Error("Invalid list");this.b=h,this.e++}h(h){if(!this.b&&!this.c)this.b=h;else if(this.c)h.previous=this.c,this.c.next=h;else throw new Error("Invalid list");this.c=h,this.e++}i(h){if(h===this.b&&h===this.c)this.b=void 0,this.c=void 0;else if(h===this.b){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.b=h.next}else if(h===this.c){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.c=h.previous}else{const m=h.next,S=h.previous;if(!m||!S)throw new Error("Invalid list");m.previous=S,S.next=m}h.next=void 0,h.previous=void 0,this.e++}j(h,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(h===this.b)return;const S=h.next,s=h.previous;h===this.c?(s.next=void 0,this.c=s):(S.previous=s,s.next=S),h.previous=void 0,h.next=this.b,this.b.previous=h,this.b=h,this.e++}else if(m===2){if(h===this.c)return;const S=h.next,s=h.previous;h===this.b?(S.previous=void 0,this.b=S):(S.previous=s,s.next=S),h.next=void 0,h.previous=this.c,this.c.next=h,this.c=h,this.e++}}}toJSON(){const h=[];return this.forEach((m,S)=>{h.push([S,m])}),h}fromJSON(h){this.clear();for(const[m,S]of h)this.set(m,S)}}e.$Bc=l;class g extends l{constructor(h,m=1){super(),this.k=h,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(h){this.k=h,this.m()}get ratio(){return this.l}set ratio(h){this.l=Math.min(Math.max(0,h),1),this.m()}get(h,m=2){return super.get(h,m)}peek(h){return super.get(h,0)}set(h,m){return super.set(h,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=g;class p{constructor(){this.a=new Map}add(h){return this.a.set(h,(this.a.get(h)||0)+1),this}delete(h){let m=this.a.get(h)||0;return m===0?!1:(m--,m===0?this.a.delete(h):this.a.set(h,m),!0)}has(h){return this.a.has(h)}}e.$Dc=p;class w{constructor(h){if(this.a=new Map,this.b=new Map,h)for(const[m,S]of h)this.set(m,S)}clear(){this.a.clear(),this.b.clear()}set(h,m){this.a.set(h,m),this.b.set(m,h)}get(h){return this.a.get(h)}getKey(h){return this.b.get(h)}delete(h){const m=this.a.get(h);return m===void 0?!1:(this.a.delete(h),this.b.delete(m),!0)}forEach(h,m){this.a.forEach((S,s)=>{h.call(m,S,s,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=w;class f{constructor(){this.a=new Map}add(h,m){let S=this.a.get(h);S||(S=new Set,this.a.set(h,S)),S.add(m)}delete(h,m){const S=this.a.get(h);S&&(S.delete(m),S.size===0&&this.a.delete(h))}forEach(h,m){const S=this.a.get(h);S&&S.forEach(m)}get(h){const m=this.a.get(h);return m||new Set}}e.$Fc=f}),define(oe[2],ae([0,1,18,126,34,85,59]),function(te,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const I=!1;let C=null;class d{constructor(){this.b=new Map}static{this.a=0}c($){let j=this.b.get($);return j||(j={parent:null,source:null,isSingleton:!1,value:$,idx:d.a++},this.b.set($,j)),j}trackDisposable($){const j=this.c($);j.source||(j.source=new Error().stack)}setParent($,j){const M=this.c($);M.parent=j}markAsDisposed($){this.b.delete($)}markAsSingleton($){this.c($).isSingleton=!0}f($,j){const M=j.get($);if(M)return M;const T=$.parent?this.f(this.c($.parent),j):$;return j.set($,T),T}getTrackedDisposables(){const $=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,$).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables($=10,j){let M;if(j)M=j;else{const J=new Map,x=[...this.b.values()].filter(Q=>Q.source!==null&&!this.f(Q,J).isSingleton);if(x.length===0)return;const W=new Set(x.map(Q=>Q.value));if(M=x.filter(Q=>!(Q.parent&&W.has(Q.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function T(J){function x(Q,H){for(;Q.length>0&&H.some(V=>typeof V=="string"?V===Q[0]:Q[0].match(V));)Q.shift()}const W=J.source.split(`
`).map(Q=>Q.trim().replace("at ","")).filter(Q=>Q!=="");return x(W,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),W.reverse()}const U=new L.$Fc;for(const J of M){const x=T(J);for(let W=0;W<=x.length;W++)U.add(x.slice(0,W).join(`
`),J)}M.sort((0,D.$6b)(J=>J.idx,D.$8b));let q="",Y=0;for(const J of M.slice(0,$)){Y++;const x=T(J),W=[];for(let Q=0;Q<x.length;Q++){let H=x[Q];H=`(shared with ${U.get(x.slice(0,Q+1).join(`
`)).size}/${M.length} leaks) at ${H}`;const ee=U.get(x.slice(0,Q).join(`
`)),ne=(0,N.$J)([...ee].map(_=>T(_)[Q]),_=>_);delete ne[x[Q]];for(const[_,ie]of Object.entries(ne))W.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${_}`);W.unshift(H)}q+=`


==================== Leaking disposable ${Y}/${M.length}: ${J.value.constructor.name} ====================
${W.join(`
`)}
============================================================

`}return M.length>$&&(q+=`


... and ${M.length-$} more leaking disposables

`),{leaks:M,details:q}}}e.$Gc=d;function P(u){C=u}if(e.$Hc=P,I){const u="__is_disposable_tracked__";P(new class{trackDisposable($){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{$[u]||console.log(j)},3e3)}setParent($,j){if($&&$!==s.None)try{$[u]=!0}catch{}}markAsDisposed($){if($&&$!==s.None)try{$[u]=!0}catch{}}markAsSingleton($){}})}function E(u){return C?.trackDisposable(u),u}e.$Ic=E;function b(u){C?.markAsDisposed(u)}e.$Jc=b;function l(u,$){C?.setParent(u,$)}function g(u,$){if(C)for(const j of u)C.setParent(j,$)}function p(u){return C?.markAsSingleton(u),u}e.$Kc=p;function w(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.$Lc=w;function f(u){if(O.Iterable.is(u)){const $=[];for(const j of u)if(j)try{j.dispose()}catch(M){$.push(M)}if($.length===1)throw $[0];if($.length>1)throw new AggregateError($,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.$Mc=f;function c(u){for(const $ of u)w($)&&$.dispose();return[]}e.$Nc=c;function h(...u){const $=m(()=>f(u));return g(u,$),$}e.$Oc=h;function m(u){const $=E({dispose:(0,A.$cb)(()=>{b($),u()})});return $}e.$Pc=m;class S{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add($){if(!$)return $;if($===this)throw new Error("Cannot register a disposable on itself!");return l($,this),this.g?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add($),$}delete($){if($){if($===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete($),$.dispose()}}deleteAndLeak($){$&&this.f.has($)&&(this.f.delete($),l($,null))}}e.$Qc=S;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new S,E(this),l(this.q,this)}dispose(){b(this),this.q.dispose()}B($){if($===this)throw new Error("Cannot register a disposable on itself!");return this.q.add($)}}e.$Rc=s;class a{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value($){this.b||$===this.a||(this.a?.dispose(),$&&l($,this),this.a=$)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const $=this.a;return this.a=void 0,$&&l($,null),$}}e.$Sc=a;class n{constructor($){this.b=$,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=n;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set($){let j=$;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,b(this))},this}}e.$Uc=i;class t{constructor(){this.a=new Map}acquire($,...j){let M=this.a.get($);M||(M={counter:0,object:this.b($,...j)},this.a.set($,M));const{object:T}=M,U=(0,A.$cb)(()=>{--M.counter===0&&(this.c($,M.object),this.a.delete($))});return M.counter++,{object:T,dispose:U}}}e.$Vc=t;class r{constructor($){this.a=$}async acquire($,...j){const M=this.a.acquire($,...j);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.$Wc=r;class o{constructor($){this.object=$}dispose(){}}e.$Xc=o;function v(u){const $=new S;try{u($)}finally{$.dispose()}}e.$Yc=v;class y{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has($){return this.a.has($)}get size(){return this.a.size}get($){return this.a.get($)}set($,j,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get($)?.dispose(),this.a.set($,j)}deleteAndDispose($){this.a.get($)?.dispose(),this.a.delete($)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=y}),define(oe[88],ae([0,1,34]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nl=e.$ml=e.$ll=void 0;const N=new D.$Cc(1e4);function L(d){return C(d,"NFC",N)}e.$ll=L;const A=new D.$Cc(1e4);function O(d){return C(d,"NFD",A)}e.$ml=O;const I=/[^\u0000-\u0080]/;function C(d,P,E){if(!d)return d;const b=E.get(d);if(b)return b;let l;return I.test(d)?l=d.normalize(P):l=d,E.set(d,l),l}e.$nl=function(){const d=/[\u0300-\u036f]/g;return function(P){return O(P).replace(d,"")}}()}),function(){function te(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function O(C){A.push(C,Date.now())}function I(){const C=[];for(let d=0;d<A.length;d+=2)C.push({name:A[d],startTime:A[d+1]});return C}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(L+O.startTime)});return A}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:te)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function D(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return te[N].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=te,D.c=e,D.d=function(N,L,A){D.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:A})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,L){if(1&L&&(N=D(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var O in N)D.d(A,O,function(I){return N[I]}.bind(null,O));return A},D.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(L,"a",L),L},D.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},D.p="",D(D.s=0)}([function(te,e,D){(function(N){var L;e=te.exports=K,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],C=e.src=[],d=0,P=d++;C[P]="0|[1-9]\\d*";var E=d++;C[E]="[0-9]+";var b=d++;C[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=d++;C[l]="("+C[P]+")\\.("+C[P]+")\\.("+C[P]+")";var g=d++;C[g]="("+C[E]+")\\.("+C[E]+")\\.("+C[E]+")";var p=d++;C[p]="(?:"+C[P]+"|"+C[b]+")";var w=d++;C[w]="(?:"+C[E]+"|"+C[b]+")";var f=d++;C[f]="(?:-("+C[p]+"(?:\\."+C[p]+")*))";var c=d++;C[c]="(?:-?("+C[w]+"(?:\\."+C[w]+")*))";var h=d++;C[h]="[0-9A-Za-z-]+";var m=d++;C[m]="(?:\\+("+C[h]+"(?:\\."+C[h]+")*))";var S=d++,s="v?"+C[l]+C[f]+"?"+C[m]+"?";C[S]="^"+s+"$";var a="[v=\\s]*"+C[g]+C[c]+"?"+C[m]+"?",n=d++;C[n]="^"+a+"$";var i=d++;C[i]="((?:<|>)?=?)";var t=d++;C[t]=C[E]+"|x|X|\\*";var r=d++;C[r]=C[P]+"|x|X|\\*";var o=d++;C[o]="[v=\\s]*("+C[r]+")(?:\\.("+C[r]+")(?:\\.("+C[r]+")(?:"+C[f]+")?"+C[m]+"?)?)?";var v=d++;C[v]="[v=\\s]*("+C[t]+")(?:\\.("+C[t]+")(?:\\.("+C[t]+")(?:"+C[c]+")?"+C[m]+"?)?)?";var y=d++;C[y]="^"+C[i]+"\\s*"+C[o]+"$";var u=d++;C[u]="^"+C[i]+"\\s*"+C[v]+"$";var $=d++;C[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=d++;C[j]="(?:~>?)";var M=d++;C[M]="(\\s*)"+C[j]+"\\s+",I[M]=new RegExp(C[M],"g");var T=d++;C[T]="^"+C[j]+C[o]+"$";var U=d++;C[U]="^"+C[j]+C[v]+"$";var q=d++;C[q]="(?:\\^)";var Y=d++;C[Y]="(\\s*)"+C[q]+"\\s+",I[Y]=new RegExp(C[Y],"g");var J=d++;C[J]="^"+C[q]+C[o]+"$";var x=d++;C[x]="^"+C[q]+C[v]+"$";var W=d++;C[W]="^"+C[i]+"\\s*("+a+")$|^$";var Q=d++;C[Q]="^"+C[i]+"\\s*("+s+")$|^$";var H=d++;C[H]="(\\s*)"+C[i]+"\\s*("+a+"|"+C[o]+")",I[H]=new RegExp(C[H],"g");var V=d++;C[V]="^\\s*("+C[o]+")\\s+-\\s+("+C[o]+")\\s*$";var ee=d++;C[ee]="^\\s*("+C[v]+")\\s+-\\s+("+C[v]+")\\s*$";var ne=d++;C[ne]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)L(_,C[_]),I[_]||(I[_]=new RegExp(C[_]));function ie(ce,ge){if(ce instanceof K)return ce;if(typeof ce!="string"||ce.length>A||!(ge?I[n]:I[S]).test(ce))return null;try{return new K(ce,ge)}catch{return null}}function K(ce,ge){if(ce instanceof K){if(ce.loose===ge)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof K))return new K(ce,ge);L("SemVer",ce,ge),this.loose=ge;var be=ce.trim().match(ge?I[n]:I[S]);if(!be)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(ke){if(/^[0-9]+$/.test(ke)){var Pe=+ke;if(Pe>=0&&Pe<O)return Pe}return ke}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=ie,e.valid=function(ce,ge){var be=ie(ce,ge);return be?be.version:null},e.clean=function(ce,ge){var be=ie(ce.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(ce){return L("SemVer.compare",this.version,this.loose,ce),ce instanceof K||(ce=new K(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},K.prototype.compareMain=function(ce){return ce instanceof K||(ce=new K(ce,this.loose)),k(this.major,ce.major)||k(this.minor,ce.minor)||k(this.patch,ce.patch)},K.prototype.comparePre=function(ce){if(ce instanceof K||(ce=new K(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],ke=ce.prerelease[ge];if(L("prerelease compare",ge,be,ke),be===void 0&&ke===void 0)return 0;if(ke===void 0)return 1;if(be===void 0)return-1;if(be!==ke)return k(be,ke)}while(++ge)},K.prototype.inc=function(ce,ge){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,ge,be,ke){typeof be=="string"&&(ke=be,be=void 0);try{return new K(ce,be).inc(ge,ke).version}catch{return null}},e.diff=function(ce,ge){if(G(ce,ge))return null;var be=ie(ce),ke=ie(ge);if(be.prerelease.length||ke.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return Pe},e.compareIdentifiers=k;var B=/^[0-9]+$/;function k(ce,ge){var be=B.test(ce),ke=B.test(ge);return be&&ke&&(ce=+ce,ge=+ge),be&&!ke?-1:ke&&!be?1:ce<ge?-1:ce>ge?1:0}function R(ce,ge,be){return new K(ce,be).compare(new K(ge,be))}function z(ce,ge,be){return R(ce,ge,be)>0}function F(ce,ge,be){return R(ce,ge,be)<0}function G(ce,ge,be){return R(ce,ge,be)===0}function Z(ce,ge,be){return R(ce,ge,be)!==0}function re(ce,ge,be){return R(ce,ge,be)>=0}function le(ce,ge,be){return R(ce,ge,be)<=0}function ue(ce,ge,be,ke){var Pe;switch(ge){case"===":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce===be;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce!==be;break;case"":case"=":case"==":Pe=G(ce,be,ke);break;case"!=":Pe=Z(ce,be,ke);break;case">":Pe=z(ce,be,ke);break;case">=":Pe=re(ce,be,ke);break;case"<":Pe=F(ce,be,ke);break;case"<=":Pe=le(ce,be,ke);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function he(ce,ge){if(ce instanceof he){if(ce.loose===ge)return ce;ce=ce.value}if(!(this instanceof he))return new he(ce,ge);L("comparator",ce,ge),this.loose=ge,this.parse(ce),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(ce,ge){return k(ge,ce)},e.major=function(ce,ge){return new K(ce,ge).major},e.minor=function(ce,ge){return new K(ce,ge).minor},e.patch=function(ce,ge){return new K(ce,ge).patch},e.compare=R,e.compareLoose=function(ce,ge){return R(ce,ge,!0)},e.rcompare=function(ce,ge,be){return R(ge,ce,be)},e.sort=function(ce,ge){return ce.sort(function(be,ke){return e.compare(be,ke,ge)})},e.rsort=function(ce,ge){return ce.sort(function(be,ke){return e.rcompare(be,ke,ge)})},e.gt=z,e.lt=F,e.eq=G,e.neq=Z,e.gte=re,e.lte=le,e.cmp=ue,e.Comparator=he;var $e={};function de(ce,ge){if(ce instanceof de)return ce.loose===ge?ce:new de(ce.raw,ge);if(ce instanceof he)return new de(ce.value,ge);if(!(this instanceof de))return new de(ce,ge);if(this.loose=ge,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function we(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Ee(ce,ge,be,ke,Pe,Ue,je,ze,Fe,se,fe,me,pe){return((ge=we(be)?"":we(ke)?">="+be+".0.0":we(Pe)?">="+be+"."+ke+".0":">="+ge)+" "+(ze=we(Fe)?"":we(se)?"<"+(+Fe+1)+".0.0":we(fe)?"<"+Fe+"."+(+se+1)+".0":me?"<="+Fe+"."+se+"."+fe+"-"+me:"<="+ze)).trim()}function Ie(ce,ge){for(var be=0;be<ce.length;be++)if(!ce[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<ce.length;be++)if(L(ce[be].semver),ce[be].semver!==$e&&ce[be].semver.prerelease.length>0){var ke=ce[be].semver;if(ke.major===ge.major&&ke.minor===ge.minor&&ke.patch===ge.patch)return!0}return!1}return!0}function Ne(ce,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(ce)}function Te(ce,ge,be,ke){var Pe,Ue,je,ze,Fe;switch(ce=new K(ce,ke),ge=new de(ge,ke),be){case">":Pe=z,Ue=le,je=F,ze=">",Fe=">=";break;case"<":Pe=F,Ue=re,je=z,ze="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(ce,ge,ke))return!1;for(var se=0;se<ge.set.length;++se){var fe=ge.set[se],me=null,pe=null;if(fe.forEach(function(Se){Se.semver===$e&&(Se=new he(">=0.0.0")),me=me||Se,pe=pe||Se,Pe(Se.semver,me.semver,ke)?me=Se:je(Se.semver,pe.semver,ke)&&(pe=Se)}),me.operator===ze||me.operator===Fe||(!pe.operator||pe.operator===ze)&&Ue(ce,pe.semver)||pe.operator===Fe&&je(ce,pe.semver))return!1}return!0}he.prototype.parse=function(ce){var ge=this.loose?I[W]:I[Q],be=ce.match(ge);if(!be)throw new TypeError("Invalid comparator: "+ce);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new K(be[2],this.loose):this.semver=$e},he.prototype.toString=function(){return this.value},he.prototype.test=function(ce){return L("Comparator.test",ce,this.loose),this.semver===$e||(typeof ce=="string"&&(ce=new K(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},he.prototype.intersects=function(ce,ge){if(!(ce instanceof he))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(ce.value,ge),Ne(this.value,be,ge);if(ce.operator==="")return be=new de(this.value,ge),Ne(ce.semver,be,ge);var ke=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ue=this.semver.version===ce.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),ze=ue(this.semver,"<",ce.semver,ge)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Fe=ue(this.semver,">",ce.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return ke||Pe||Ue&&je||ze||Fe},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ce){var ge=this.loose;ce=ce.trim(),L("range",ce,ge);var be=ge?I[ee]:I[V];ce=ce.replace(be,Ee),L("hyphen replace",ce),ce=ce.replace(I[H],"$1$2$3"),L("comparator trim",ce,I[H]),ce=(ce=(ce=ce.replace(I[M],"$1~")).replace(I[Y],"$1^")).split(/\s+/).join(" ");var ke=ge?I[W]:I[Q],Pe=ce.split(" ").map(function(Ue){return function(je,ze){return L("comp",je),je=function(Fe,se){return Fe.trim().split(/\s+/).map(function(fe){return function(me,pe){L("caret",me,pe);var Se=pe?I[x]:I[J];return me.replace(Se,function(Re,Ce,De,Oe,Ae){var Me;return L("caret",me,Re,Ce,De,Oe,Ae),we(Ce)?Me="":we(De)?Me=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Oe)?Me=Ce==="0"?">="+Ce+"."+De+".0 <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+".0 <"+(+Ce+1)+".0.0":Ae?(L("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Me=Ce==="0"?De==="0"?">="+Ce+"."+De+"."+Oe+Ae+" <"+Ce+"."+De+"."+(+Oe+1):">="+Ce+"."+De+"."+Oe+Ae+" <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+"."+Oe+Ae+" <"+(+Ce+1)+".0.0"):(L("no pr"),Me=Ce==="0"?De==="0"?">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+De+"."+(+Oe+1):">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+"."+Oe+" <"+(+Ce+1)+".0.0"),L("caret return",Me),Me})}(fe,se)}).join(" ")}(je,ze),L("caret",je),je=function(Fe,se){return Fe.trim().split(/\s+/).map(function(fe){return function(me,pe){var Se=pe?I[U]:I[T];return me.replace(Se,function(Re,Ce,De,Oe,Ae){var Me;return L("tilde",me,Re,Ce,De,Oe,Ae),we(Ce)?Me="":we(De)?Me=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Oe)?Me=">="+Ce+"."+De+".0 <"+Ce+"."+(+De+1)+".0":Ae?(L("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Me=">="+Ce+"."+De+"."+Oe+Ae+" <"+Ce+"."+(+De+1)+".0"):Me=">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+(+De+1)+".0",L("tilde return",Me),Me})}(fe,se)}).join(" ")}(je,ze),L("tildes",je),je=function(Fe,se){return L("replaceXRanges",Fe,se),Fe.split(/\s+/).map(function(fe){return function(me,pe){me=me.trim();var Se=pe?I[u]:I[y];return me.replace(Se,function(Re,Ce,De,Oe,Ae,Me){L("xRange",me,Re,Ce,De,Oe,Ae,Me);var Be=we(De),qe=Be||we(Oe),We=qe||we(Ae);return Ce==="="&&We&&(Ce=""),Be?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&We?(qe&&(Oe=0),We&&(Ae=0),Ce===">"?(Ce=">=",qe?(De=+De+1,Oe=0,Ae=0):We&&(Oe=+Oe+1,Ae=0)):Ce==="<="&&(Ce="<",qe?De=+De+1:Oe=+Oe+1),Re=Ce+De+"."+Oe+"."+Ae):qe?Re=">="+De+".0.0 <"+(+De+1)+".0.0":We&&(Re=">="+De+"."+Oe+".0 <"+De+"."+(+Oe+1)+".0"),L("xRange return",Re),Re})}(fe,se)}).join(" ")}(je,ze),L("xrange",je),je=function(Fe,se){return L("replaceStars",Fe,se),Fe.trim().replace(I[ne],"")}(je,ze),L("stars",je),je}(Ue,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ue){return!!Ue.match(ke)})),Pe=Pe.map(function(Ue){return new he(Ue,ge)})},de.prototype.intersects=function(ce,ge){if(!(ce instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(ke){return ce.set.some(function(Pe){return Pe.every(function(Ue){return ke.intersects(Ue,ge)})})})})},e.toComparators=function(ce,ge){return new de(ce,ge).set.map(function(be){return be.map(function(ke){return ke.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new K(ce,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Ie(this.set[ge],ce))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(ce,ge,be){var ke=null,Pe=null;try{var Ue=new de(ge,be)}catch{return null}return ce.forEach(function(je){Ue.test(je)&&(ke&&Pe.compare(je)!==-1||(Pe=new K(ke=je,be)))}),ke},e.minSatisfying=function(ce,ge,be){var ke=null,Pe=null;try{var Ue=new de(ge,be)}catch{return null}return ce.forEach(function(je){Ue.test(je)&&(ke&&Pe.compare(je)!==1||(Pe=new K(ke=je,be)))}),ke},e.validRange=function(ce,ge){try{return new de(ce,ge).range||"*"}catch{return null}},e.ltr=function(ce,ge,be){return Te(ce,ge,"<",be)},e.gtr=function(ce,ge,be){return Te(ce,ge,">",be)},e.outside=Te,e.prerelease=function(ce,ge){var be=ie(ce,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ce,ge,be){return ce=new de(ce,be),ge=new de(ge,be),ce.intersects(ge)},e.coerce=function(ce){if(ce instanceof K)return ce;if(typeof ce!="string")return null;var ge=ce.match(I[$]);return ge==null?null:ie((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,D(1))},function(te,e){var D,N,L=te.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(w){if(D===setTimeout)return setTimeout(w,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(w,0);try{return D(w,0)}catch{try{return D.call(null,w,0)}catch{return D.call(this,w,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var C,d=[],P=!1,E=-1;function b(){P&&C&&(P=!1,C.length?d=C.concat(d):E=-1,d.length&&l())}function l(){if(!P){var w=I(b);P=!0;for(var f=d.length;f;){for(C=d,d=[];++E<f;)C&&C[E].run();E=-1,f=d.length}C=null,P=!1,function(c){if(N===clearTimeout)return clearTimeout(c);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(c);try{N(c)}catch{try{return N.call(null,c)}catch{return N.call(this,c)}}}(w)}}function g(w,f){this.fun=w,this.array=f}function p(){}L.nextTick=function(w){var f=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)f[c-1]=arguments[c];d.push(new g(w,f)),d.length!==1||P||I(l)},g.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=p,L.addListener=p,L.once=p,L.off=p,L.removeListener=p,L.removeAllListeners=p,L.emit=p,L.prependListener=p,L.prependOnceListener=p,L.listeners=function(w){return[]},L.binding=function(w){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(w){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(oe[128],ae([0,1]),function(te,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;class N{constructor(I,C,d){this.level=I,this.key=C,this.value=d,this.forward=[]}}const L=void 0;class A{constructor(I,C=2**16){this.comparator=I,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(C)|0),this.e=new N(this.c,L,L)}get size(){return this.f}clear(){this.e=new N(this.c,L,L),this.f=0}has(I){return!!A.g(this,I,this.comparator)}get(I){return A.g(this,I,this.comparator)?.value}set(I,C){return A.h(this,I,C,this.comparator)&&(this.f+=1),this}delete(I){const C=A.k(this,I,this.comparator);return C&&(this.f-=1),C}forEach(I,C){let d=this.e.forward[0];for(;d;)I.call(C,d.value,d.key,this),d=d.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",C=this.e.forward[0];for(;C;)I+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return I}static g(I,C,d){let P=I.e;for(let E=I.d-1;E>=0;E--)for(;P.forward[E]&&d(P.forward[E].key,C)<0;)P=P.forward[E];if(P=P.forward[0],P&&d(P.key,C)===0)return P}static h(I,C,d,P){const E=[];let b=I.e;for(let l=I.d-1;l>=0;l--){for(;b.forward[l]&&P(b.forward[l].key,C)<0;)b=b.forward[l];E[l]=b}if(b=b.forward[0],b&&P(b.key,C)===0)return b.value=d,!1;{const l=A.j(I);if(l>I.d){for(let g=I.d;g<l;g++)E[g]=I.e;I.d=l}b=new N(l,C,d);for(let g=0;g<l;g++)b.forward[g]=E[g].forward[g],E[g].forward[g]=b;return!0}}static j(I,C=.5){let d=1;for(;Math.random()<C&&d<I.c;)d+=1;return d}static k(I,C,d){const P=[];let E=I.e;for(let b=I.d-1;b>=0;b--){for(;E.forward[b]&&d(E.forward[b].key,C)<0;)E=E.forward[b];P[b]=E}if(E=E.forward[0],!E||d(E.key,C)!==0)return!1;for(let b=0;b<I.d&&P[b].forward[b]===E;b++)P[b].forward[b]=E.forward[b];for(;I.d>0&&I.e.forward[I.d-1]===L;)I.d-=1;return!0}}e.$vr=A}),define(oe[61],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(A){return new N(A)}constructor(A){this.c=D&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Id=N}),define(oe[3],ae([0,1,8,85,2,87,61]),function(te,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.Event=void 0;const I=!1,C=!1;var d;(function(y){y.None=()=>L.$Rc.None;function u(ue){if(C){const{onDidAddListener:he}=ue,$e=g.create();let de=0;ue.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),he?.()}}}function $(ue,he){return Q(ue,()=>{},0,void 0,!0,void 0,he)}y.defer=$;function j(ue){return(he,$e=null,de)=>{let we=!1,Ee;return Ee=ue(Ie=>{if(!we)return Ee?Ee.dispose():we=!0,he.call($e,Ie)},null,de),we&&Ee.dispose(),Ee}}y.once=j;function M(ue,he,$e){return x((de,we=null,Ee)=>ue(Ie=>de.call(we,he(Ie)),null,Ee),$e)}y.map=M;function T(ue,he,$e){return x((de,we=null,Ee)=>ue(Ie=>{he(Ie),de.call(we,Ie)},null,Ee),$e)}y.forEach=T;function U(ue,he,$e){return x((de,we=null,Ee)=>ue(Ie=>he(Ie)&&de.call(we,Ie),null,Ee),$e)}y.filter=U;function q(ue){return ue}y.signal=q;function Y(...ue){return(he,$e=null,de)=>{const we=(0,L.$Oc)(...ue.map(Ee=>Ee(Ie=>he.call($e,Ie))));return W(we,de)}}y.any=Y;function J(ue,he,$e,de){let we=$e;return M(ue,Ee=>(we=he(we,Ee),we),de)}y.reduce=J;function x(ue,he){let $e;const de={onWillAddFirstListener(){$e=ue(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};he||u(de);const we=new h(de);return he?.add(we),we.event}function W(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function Q(ue,he,$e=100,de=!1,we=!1,Ee,Ie){let Ne,Te,ce,ge=0,be;const ke={leakWarningThreshold:Ee,onWillAddFirstListener(){Ne=ue(Ue=>{ge++,Te=he(Te,Ue),de&&!ce&&(Pe.fire(Te),Te=void 0),be=()=>{const je=Te;Te=void 0,ce=void 0,(!de||ge>1)&&Pe.fire(je),ge=0},typeof $e=="number"?(clearTimeout(ce),ce=setTimeout(be,$e)):ce===void 0&&(ce=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Ne.dispose()}};Ie||u(ke);const Pe=new h(ke);return Ie?.add(Pe),Pe.event}y.debounce=Q;function H(ue,he=0,$e){return y.debounce(ue,(de,we)=>de?(de.push(we),de):[we],he,void 0,!0,void 0,$e)}y.accumulate=H;function V(ue,he=(de,we)=>de===we,$e){let de=!0,we;return U(ue,Ee=>{const Ie=de||!he(Ee,we);return de=!1,we=Ee,Ie},$e)}y.latch=V;function ee(ue,he,$e){return[y.filter(ue,he,$e),y.filter(ue,de=>!he(de),$e)]}y.split=ee;function ne(ue,he=!1,$e=[],de){let we=$e.slice(),Ee=ue(Te=>{we?we.push(Te):Ne.fire(Te)});de&&de.add(Ee);const Ie=()=>{we?.forEach(Te=>Ne.fire(Te)),we=null},Ne=new h({onWillAddFirstListener(){Ee||(Ee=ue(Te=>Ne.fire(Te)),de&&de.add(Ee))},onDidAddFirstListener(){we&&(he?setTimeout(Ie):Ie())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return de&&de.add(Ne),Ne.event}y.buffer=ne;function _(ue,he){return(de,we,Ee)=>{const Ie=he(new K);return ue(function(Ne){const Te=Ie.evaluate(Ne);Te!==ie&&de.call(we,Te)},void 0,Ee)}}y.chain=_;const ie=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push($e=>(he($e),$e)),this}filter(he){return this.f.push($e=>he($e)?$e:ie),this}reduce(he,$e){let de=$e;return this.f.push(we=>(de=he(de,we),de)),this}latch(he=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const Ee=$e||!he(we,de);return $e=!1,de=we,Ee?we:ie}),this}evaluate(he){for(const $e of this.f)if(he=$e(he),he===ie)break;return he}}function B(ue,he,$e=de=>de){const de=(...Ne)=>Ie.fire($e(...Ne)),we=()=>ue.on(he,de),Ee=()=>ue.removeListener(he,de),Ie=new h({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return Ie.event}y.fromNodeEventEmitter=B;function k(ue,he,$e=de=>de){const de=(...Ne)=>Ie.fire($e(...Ne)),we=()=>ue.addEventListener(he,de),Ee=()=>ue.removeEventListener(he,de),Ie=new h({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return Ie.event}y.fromDOMEventEmitter=k;function R(ue){return new Promise(he=>j(ue)(he))}y.toPromise=R;function z(ue){const he=new h;return ue.then($e=>{he.fire($e)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}y.fromPromise=z;function F(ue,he){return he(void 0),ue($e=>he($e))}y.runAndSubscribe=F;function G(ue,he){let $e=null;function de(Ee){$e?.dispose(),$e=new L.$Qc,he(Ee,$e)}de(void 0);const we=ue(Ee=>de(Ee));return(0,L.$Pc)(()=>{we.dispose(),$e?.dispose()})}y.runAndSubscribeWithStore=G;class Z{constructor(he,$e){this._observable=he,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};$e||u(de),this.emitter=new h(de),$e&&$e.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,$e){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function re(ue,he){return new Z(ue,he).emitter.event}y.fromObservable=re;function le(ue){return he=>{let $e=0,de=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(ue.reportChanges(),de&&(de=!1,he()))},handlePossibleChange(){},handleChange(){de=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}y.fromObservableLight=le})(d||(e.Event=d={}));class P{static{this.all=new Set}static{this.f=0}constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${P.f++}`,P.all.add(this)}start(u){this.g=new O.$Id,this.listenerCount=u}stop(){if(this.g){const u=this.g.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this.g=void 0}}}e.$Kd=P;let E=-1;function b(y){const u=E;return E=y,{dispose(){E=u}}}e.$Ld=b;class l{constructor(u,$=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=$,this.g=0}dispose(){this.f?.clear()}check(u,$){const j=this.threshold;if(j<=0||$<j)return;this.f||(this.f=new Map);const M=this.f.get(u.value)||0;if(this.f.set(u.value,M+1),this.g-=1,this.g<=0){this.g=j*.5;let T,U=0;for(const[q,Y]of this.f)(!T||U<Y)&&(T=q,U=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${$} listeners already. MOST frequent listener (${U}):`),console.warn(T)}return()=>{const T=this.f.get(u.value)||0;this.f.set(u.value,T-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class w{constructor(u){this.value=u,this.id=p++}}const f=2,c=(y,u)=>{if(y instanceof w)u(y);else for(let $=0;$<y.length;$++){const j=y[$];j&&u(j)}};class h{constructor(u){this.w=0,this.f=u,this.g=E>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(I){const u=this.t;queueMicrotask(()=>{c(u,$=>$.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(u,$,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Rc.None;if(this.m)return L.$Rc.None;$&&(u=u.bind($));const M=new w(u);let T,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(M.stack=g.create(),T=this.g.check(M.stack,this.w+1)),I&&(M.stack=U??g.create()),this.t?this.t instanceof w?(this.u??=new S,this.t=[this.t,M]):this.t.push(M):(this.f?.onWillAddFirstListener?.(this),this.t=M,this.f?.onDidAddFirstListener?.(this)),this.w++;const q=(0,L.$Pc)(()=>{T?.(),this.x(M)});return j instanceof L.$Qc?j.add(q):Array.isArray(j)&&j.push(q),q},this.q}x(u){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const $=this.t,j=$.indexOf(u);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,$[j]=void 0;const M=this.u.current===this;if(this.w*f<=$.length){let T=0;for(let U=0;U<$.length;U++)$[U]?$[T++]=$[U]:M&&(this.u.end--,T<this.u.i&&this.u.i--);$.length=T}}y(u,$){if(!u)return;const j=this.f?.onListenerError||D.$Z;if(!j){u.value($);return}try{u.value($)}catch(M){j(M)}}z(u){const $=u.current.t;for(;u.i<u.end;)this.y($[u.i++],u.value);u.reset()}fire(u){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,u);else{const $=this.u;$.enqueue(this,u,this.t.length),this.z($)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Md=h;const m=()=>new S;e.$Nd=m;class S{constructor(){this.i=-1,this.end=0}enqueue(u,$,j){this.i=0,this.end=j,this.current=u,this.value=$}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends h{async fireAsync(u,$,j){if(this.t)for(this.h||(this.h=new A.$1c),c(this.t,M=>this.h.push([M.value,u]));this.h.size>0&&!$.isCancellationRequested;){const[M,T]=this.h.shift(),U=[],q={...T,token:$,waitUntil:Y=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");j&&(Y=j(Y,M)),U.push(Y)}};try{M(q)}catch(Y){(0,D.$Z)(Y);continue}Object.freeze(U),await Promise.allSettled(U).then(Y=>{for(const J of Y)J.status==="rejected"&&(0,D.$Z)(J.reason)})}}}e.$Od=s;class a extends h{get isPaused(){return this.h!==0}constructor(u){super(u),this.h=0,this.s=new A.$1c,this.A=u?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const u=Array.from(this.s);this.s.clear(),super.fire(this.A(u))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(u){this.w&&(this.h!==0?this.s.push(u):super.fire(u))}}e.$Pd=a;class n extends a{constructor(u){super(u),this.k=u.delay??100}fire(u){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(u)}}e.$Qd=n;class i extends h{constructor(u){super(u),this.h=[],this.k=u?.merge}fire(u){this.hasListeners()&&(this.h.push(u),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach($=>super.fire($)),this.h=[]}))}}e.$Rd=i;class t{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(u){const $={event:u,listener:null};this.h.push($),this.g&&this.m($);const j=()=>{this.g&&this.o($);const M=this.h.indexOf($);this.h.splice(M,1)};return(0,L.$Pc)((0,N.$cb)(j))}j(){this.g=!0,this.h.forEach(u=>this.m(u))}k(){this.g=!1,this.h.forEach(u=>this.o(u))}m(u){u.listener=u.event($=>this.f.fire($))}o(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.f.dispose()}}e.$Sd=t;class r{constructor(u,$,j,M){this.f=new L.$Qc;const T=this.f.add(new t),U=this.f.add(new L.$Zc);function q(Y){U.set(Y,T.add(M(Y)))}for(const Y of u)q(Y);this.f.add($(Y=>{q(Y)})),this.f.add(j(Y=>{U.deleteAndDispose(Y)})),this.event=T.event}dispose(){this.f.dispose()}}e.$Td=r;class o{constructor(){this.f=[]}wrapEvent(u){return($,j,M)=>u(T=>{const U=this.f[this.f.length-1];U?U.push(()=>$.call(j,T)):$.call(j,T)},void 0,M)}bufferEvents(u){const $=[];this.f.push($);const j=u();return this.f.pop(),$.forEach(M=>M()),j}}e.$Ud=o;class v{constructor(){this.f=!1,this.g=d.None,this.h=L.$Rc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(u){this.g=u,this.f&&(this.h.dispose(),this.h=u(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Vd=v}),define(oe[26],ae([0,1,3]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.CancellationToken=void 0;const N=Object.freeze(function(I,C){const d=setTimeout(I.bind(C),0);return{dispose(){clearTimeout(d)}}});var L;(function(I){function C(d){return d===I.None||d===I.Cancelled||d instanceof A?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}I.isCancellationToken=C,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new D.$Md),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(C){this.f=void 0,this.g=void 0,this.g=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=L.Cancelled}dispose(C=!1){C&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=L.None}}e.$Wd=O}),define(oe[129],ae([0,1,26]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=void 0;class N{constructor(I){this.b=I,this.a=null}get(){if(this.a)return this.a;const I=new D.$Wd,C=this.b(I.token);return this.a={promise:C,dispose:()=>{this.a=null,I.cancel(),I.dispose()}},this.a}}e.$ve=N;class L{constructor(I){this.c=I,this.a=void 0,this.b=void 0}get(I){const C=JSON.stringify(I);return this.b!==C&&(this.b=C,this.a=this.c(I)),this.a}}e.$we=L;class A{get cachedValues(){return this.a}constructor(I){this.b=I,this.a=new Map}get(I){if(this.a.has(I))return this.a.get(I);const C=this.b(I);return this.a.set(I,C),C}}e.$xe=A}),define(oe[46],ae([0,1,8,2]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function L(m){const S=m;return S?typeof S.read=="function":!1}e.$Xd=L;function A(m){const S=m;return S?[S.on,S.pause,S.resume,S.destroy].every(s=>typeof s=="function"):!1}e.$Yd=A;function O(m){const S=m;return S?A(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$Zd=O;function I(m,S){return new C(m,S)}e.$1d=I;class C{constructor(S,s){this.e=S,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(s=>s(S))}h(S){this.c.error.length===0?(0,D.$Z)(S):this.c.error.slice(0).forEach(s=>s(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,s){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(S,s){if(this.a.destroyed)return;let a;switch(S){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(s);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(m,S){const s=[];let a;for(;(a=m.read())!==null;)s.push(a);return S(s)}e.$2d=d;function P(m,S,s){const a=[];let n;for(;(n=m.read())!==null&&a.length<s;)a.push(n);return n===null&&a.length>0?S(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return m.read()}}}e.$3d=P;function E(m,S){return new Promise((s,a)=>{const n=[];b(m,{onData:i=>{S&&n.push(i)},onError:i=>{S?a(i):s(void 0)},onEnd:()=>{s(S?S(n):void 0)}})})}e.$4d=E;function b(m,S,s){m.on("error",a=>{s?.isCancellationRequested||S.onError(a)}),m.on("end",()=>{s?.isCancellationRequested||S.onEnd()}),m.on("data",a=>{s?.isCancellationRequested||S.onData(a)})}e.$5d=b;function l(m,S){return new Promise((s,a)=>{const n=new N.$Qc,i=[],t=v=>{if(i.push(v),i.length>S)return n.dispose(),m.pause(),s({stream:m,buffer:i,ended:!1})},r=v=>(n.dispose(),a(v)),o=()=>(n.dispose(),s({stream:m,buffer:i,ended:!0}));n.add((0,N.$Pc)(()=>m.removeListener("error",r))),m.on("error",r),n.add((0,N.$Pc)(()=>m.removeListener("end",o))),m.on("end",o),n.add((0,N.$Pc)(()=>m.removeListener("data",t))),m.on("data",t)})}e.$6d=l;function g(m,S){const s=I(S);return s.end(m),s}e.$7d=g;function p(){const m=I(()=>{throw new Error("not supported")});return m.end(),m}e.$8d=p;function w(m){let S=!1;return{read:()=>S?null:(S=!0,m)}}e.$9d=w;function f(m,S,s){const a=I(s);return b(m,{onData:n=>a.write(S.data(n)),onError:n=>a.error(S.error?S.error(n):n),onEnd:()=>a.end()}),a}e.$0d=f;function c(m,S,s){let a=!1;return{read:()=>{const n=S.read();return a?n:(a=!0,n!==null?s([m,n]):m)}}}e.$$d=c;function h(m,S,s){let a=!1;const n=I(s);return b(S,{onData:i=>a?n.write(i):(a=!0,n.write(s([m,i]))),onError:i=>n.error(i),onEnd:()=>{a||(a=!0,n.write(m)),n.end()}}),n}e.$_d=h}),define(oe[15],ae([0,1,60,46]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const L=typeof Buffer<"u",A=new D.$U(()=>new Uint8Array(256));let O,I;class C{static alloc($){return L?new C(Buffer.allocUnsafe($)):new C(new Uint8Array($))}static wrap($){return L&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new C($)}static fromString($,j){return!(j?.dontUseNodeBuffer||!1)&&L?new C(Buffer.from($)):(O||(O=new TextEncoder),new C(O.encode($)))}static fromByteArray($){const j=C.alloc($.length);for(let M=0,T=$.length;M<T;M++)j.buffer[M]=$[M];return j}static concat($,j){if(typeof j>"u"){j=0;for(let U=0,q=$.length;U<q;U++)j+=$[U].byteLength}const M=C.alloc(j);let T=0;for(let U=0,q=$.length;U<q;U++){const Y=$[U];M.set(Y,T),T+=Y.byteLength}return M}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=C.alloc(this.byteLength);return $.set(this),$}toString(){return L?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice($,j){return new C(this.buffer.subarray($,j))}set($,j){if($ instanceof C)this.buffer.set($.buffer,j);else if($ instanceof Uint8Array)this.buffer.set($,j);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),j);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return b(this.buffer,$)}writeUInt32BE($,j){l(this.buffer,$,j)}readUInt32LE($){return g(this.buffer,$)}writeUInt32LE($,j){p(this.buffer,$,j)}readUInt8($){return w(this.buffer,$)}writeUInt8($,j){f(this.buffer,$,j)}indexOf($,j=0){return d(this.buffer,$ instanceof C?$.buffer:$,j)}}e.$ae=C;function d(u,$,j=0){const M=$.byteLength,T=u.byteLength;if(M===0)return 0;if(M===1)return u.indexOf($[0]);if(M>T-j)return-1;const U=A.value;U.fill($.length);for(let x=0;x<$.length;x++)U[$[x]]=$.length-x-1;let q=j+$.length-1,Y=q,J=-1;for(;q<T;)if(u[q]===$[Y]){if(Y===0){J=q;break}q--,Y--}else q+=Math.max($.length-Y,U[u[q]]),Y=$.length-1;return J}e.$be=d;function P(u,$){return u[$+0]<<0>>>0|u[$+1]<<8>>>0}e.$ce=P;function E(u,$,j){u[j+0]=$&255,$=$>>>8,u[j+1]=$&255}e.$de=E;function b(u,$){return u[$]*2**24+u[$+1]*2**16+u[$+2]*2**8+u[$+3]}e.$ee=b;function l(u,$,j){u[j+3]=$,$=$>>>8,u[j+2]=$,$=$>>>8,u[j+1]=$,$=$>>>8,u[j]=$}e.$fe=l;function g(u,$){return u[$+0]<<0>>>0|u[$+1]<<8>>>0|u[$+2]<<16>>>0|u[$+3]<<24>>>0}e.$ge=g;function p(u,$,j){u[j+0]=$&255,$=$>>>8,u[j+1]=$&255,$=$>>>8,u[j+2]=$&255,$=$>>>8,u[j+3]=$&255}e.$he=p;function w(u,$){return u[$]}e.$ie=w;function f(u,$,j){u[j]=$}e.$je=f;function c(u){return N.$2d(u,$=>C.concat($))}e.$ke=c;function h(u){return N.$9d(u)}e.$le=h;function m(u){return N.$4d(u,$=>C.concat($))}e.$me=m;async function S(u){return u.ended?C.concat(u.buffer):C.concat([...u.buffer,await m(u.stream)])}e.$ne=S;function s(u){return N.$7d(u,$=>C.concat($))}e.$oe=s;function a(u){return N.$0d(u,{data:$=>typeof $=="string"?C.fromString($):C.wrap($)},$=>C.concat($))}e.$pe=a;function n(u){return N.$1d($=>C.concat($),u)}e.$qe=n;function i(u,$){return N.$$d(u,$,j=>C.concat(j))}e.$re=i;function t(u,$){return N.$_d(u,$,j=>C.concat(j))}e.$se=t;function r(u){let $=0,j=0,M=0;const T=new Uint8Array(Math.floor(u.length/4*3)),U=Y=>{switch(j){case 3:T[M++]=$|Y,j=0;break;case 2:T[M++]=$|Y>>>2,$=Y<<6,j=3;break;case 1:T[M++]=$|Y>>>4,$=Y<<4,j=2;break;default:$=Y<<2,j=1}};for(let Y=0;Y<u.length;Y++){const J=u.charCodeAt(Y);if(J>=65&&J<=90)U(J-65);else if(J>=97&&J<=122)U(J-97+26);else if(J>=48&&J<=57)U(J-48+52);else if(J===43||J===45)U(62);else if(J===47||J===95)U(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${u[Y]}`)}}const q=M;for(;j>0;)U(0);return C.wrap(T).slice(0,q)}e.$te=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:u},$=!0,j=!1){const M=j?v:o;let T="";const U=u.byteLength%3;let q=0;for(;q<u.byteLength-U;q+=3){const Y=u[q+0],J=u[q+1],x=u[q+2];T+=M[Y>>>2],T+=M[(Y<<4|J>>>4)&63],T+=M[(J<<2|x>>>6)&63],T+=M[x&63]}if(U===1){const Y=u[q+0];T+=M[Y>>>2],T+=M[Y<<4&63],$&&(T+="==")}else if(U===2){const Y=u[q+0],J=u[q+1];T+=M[Y>>>2],T+=M[(Y<<4|J>>>4)&63],T+=M[J<<2&63],$&&(T+="=")}return T}e.$ue=y}),define(oe[27],ae([0,1,129,60]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wf=e.$vf=e.$uf=e.$tf=e.GraphemeBreakType=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function L(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.$Ae=L;const A=/{(\d+)}/g;function O(se,...fe){return fe.length===0?se:se.replace(A,function(me,pe){const Se=parseInt(pe,10);return isNaN(Se)||Se<0||Se>=fe.length?me:fe[Se]})}e.$Be=O;const I=/{([^}]+)}/g;function C(se,fe){return se.replace(I,(me,pe)=>fe[pe]??me)}e.$Ce=C;function d(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$De=d;function P(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ee=P;function E(se,fe){let me=0;const pe=fe.charCodeAt(0);for(let Se=se.length-1;Se>=0;Se--)se.charCodeAt(Se)===pe&&me++;return me}e.$Fe=E;function b(se,fe,me="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${me}`}e.$Ge=b;function l(se,fe=" "){const me=g(se,fe);return p(me,fe)}e.$He=l;function g(se,fe){if(!se||!fe)return se;const me=fe.length;if(me===0||se.length===0)return se;let pe=0;for(;se.indexOf(fe,pe)===pe;)pe=pe+me;return se.substring(pe)}e.$Ie=g;function p(se,fe){if(!se||!fe)return se;const me=fe.length,pe=se.length;if(me===0||pe===0)return se;let Se=pe,Re=-1;for(;Re=se.lastIndexOf(fe,Se-1),!(Re===-1||Re+me!==Se);){if(Re===0)return"";Se=Re}return se.substring(0,Se)}e.$Je=p;function w(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ke=w;function f(se){return se.replace(/\*/g,"")}e.$Le=f;function c(se,fe,me={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=P(se)),me.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(se,pe)}e.$Me=c;function h(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.$Ne=h;function m(se){return se.split(/\r\n|\r|\n/)}e.$Oe=m;function S(se){for(let fe=0,me=se.length;fe<me;fe++){const pe=se.charCodeAt(fe);if(pe!==32&&pe!==9)return fe}return-1}e.$Pe=S;function s(se,fe=0,me=se.length){for(let pe=fe;pe<me;pe++){const Se=se.charCodeAt(pe);if(Se!==32&&Se!==9)return se.substring(fe,pe)}return se.substring(fe,me)}e.$Qe=s;function a(se,fe=se.length-1){for(let me=fe;me>=0;me--){const pe=se.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$Re=a;function n(se,fe,me){const pe=[];let Se=0;for(const Re of se.matchAll(fe)){if(pe.push(se.slice(Se,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Se=Re.index+Re[0].length,pe.push(me(Re[0],...Re.slice(1),Re.index,se,Re.groups))}return pe.push(se.slice(Se)),Promise.all(pe).then(Re=>Re.join(""))}e.$Se=n;function i(se,fe){return se<fe?-1:se>fe?1:0}e.$Te=i;function t(se,fe,me=0,pe=se.length,Se=0,Re=fe.length){for(;me<pe&&Se<Re;me++,Se++){const Oe=se.charCodeAt(me),Ae=fe.charCodeAt(Se);if(Oe<Ae)return-1;if(Oe>Ae)return 1}const Ce=pe-me,De=Re-Se;return Ce<De?-1:Ce>De?1:0}e.$Ue=t;function r(se,fe){return o(se,fe,0,se.length,0,fe.length)}e.$Ve=r;function o(se,fe,me=0,pe=se.length,Se=0,Re=fe.length){for(;me<pe&&Se<Re;me++,Se++){let Oe=se.charCodeAt(me),Ae=fe.charCodeAt(Se);if(Oe===Ae)continue;if(Oe>=128||Ae>=128)return t(se.toLowerCase(),fe.toLowerCase(),me,pe,Se,Re);y(Oe)&&(Oe-=32),y(Ae)&&(Ae-=32);const Me=Oe-Ae;if(Me!==0)return Me}const Ce=pe-me,De=Re-Se;return Ce<De?-1:Ce>De?1:0}e.$We=o;function v(se){return se>=48&&se<=57}e.$Xe=v;function y(se){return se>=97&&se<=122}e.$Ye=y;function u(se){return se>=65&&se<=90}e.$Ze=u;function $(se,fe){return se.length===fe.length&&o(se,fe)===0}e.$1e=$;function j(se,fe){const me=fe.length;return fe.length>se.length?!1:o(se,fe,0,me)===0}e.$2e=j;function M(se,fe){const me=Math.min(se.length,fe.length);let pe;for(pe=0;pe<me;pe++)if(se.charCodeAt(pe)!==fe.charCodeAt(pe))return pe;return me}e.$3e=M;function T(se,fe){const me=Math.min(se.length,fe.length);let pe;const Se=se.length-1,Re=fe.length-1;for(pe=0;pe<me;pe++)if(se.charCodeAt(Se-pe)!==fe.charCodeAt(Re-pe))return pe;return me}e.$4e=T;function U(se){return 55296<=se&&se<=56319}e.$5e=U;function q(se){return 56320<=se&&se<=57343}e.$6e=q;function Y(se,fe){return(se-55296<<10)+(fe-56320)+65536}e.$7e=Y;function J(se,fe,me){const pe=se.charCodeAt(me);if(U(pe)&&me+1<fe){const Se=se.charCodeAt(me+1);if(q(Se))return Y(pe,Se)}return pe}e.$8e=J;function x(se,fe){const me=se.charCodeAt(fe-1);if(q(me)&&fe>1){const pe=se.charCodeAt(fe-2);if(U(pe))return Y(pe,me)}return me}class W{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=x(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=J(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$9e=W;class Q{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new W(fe,me)}nextGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let Se=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.nextCodePoint());if(Te(Se,Ce)){me.setOffset(Re);break}Se=Ce}return me.offset-pe}prevGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let Se=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.prevCodePoint());if(Te(Ce,Se)){me.setOffset(Re);break}Se=Ce}return pe-me.offset}eol(){return this.c.eol()}}e.$0e=Q;function H(se,fe){return new Q(se,fe).nextGraphemeLength()}e.$$e=H;function V(se,fe){return new Q(se,fe).prevGraphemeLength()}e.$_e=V;function ee(se,fe){fe>0&&q(se.charCodeAt(fe))&&fe--;const me=fe+H(se,fe);return[me-V(se,me),me]}e.$af=ee;function ne(se){const fe=new Q(se);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$bf=ne;let _;function ie(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function K(se){return _||(_=ie()),_.test(se)}e.$cf=K;const B=/^[\t\n\r\x20-\x7E]*$/;function k(se){return B.test(se)}e.$df=k,e.$ef=/[\u2028\u2029]/;function R(se){return e.$ef.test(se)}e.$ff=R;function z(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.$gf=z;function F(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.$hf=F;function G(se,fe){if(se.length<fe)return se;const me=/\b/g;let pe=0;for(;me.test(se)&&!(se.length-me.lastIndex<fe);)pe=me.lastIndex,me.lastIndex+=1;return se.substring(pe).replace(/^\s/,"")}e.$if=G;const Z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,re=/\x1b\].*?\x07/g;function le(se){return se&&(se=se.replace(Z,"").replace(re,"")),se}e.$jf=le,e.$kf=String.fromCharCode(65279);function ue(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.$lf=ue;function he(se){return ue(se)?se.substr(1):se}e.$mf=he;function $e(se,fe){if(!se||!fe||se.length<fe.length)return!1;const me=fe.length,pe=se.toLowerCase();let Se=0,Re=-1;for(;Se<me;){const Ce=pe.indexOf(fe[Se],Re+1);if(Ce<0)return!1;Re=Ce,Se++}return!0}e.$nf=$e;function de(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.$of=de;function we(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.$pf=we;function Ee(se,fe=1){if(fe===0)return"";let me=-1;do me=se.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?se:(se[me-1]==="\r"&&me--,se.substr(0,me))}e.$qf=Ee;function Ie(se){return se=se%(2*26),se<26?String.fromCharCode(97+se):String.fromCharCode(65+se-26)}e.$rf=Ie;function Ne(se){return ge.getInstance().getGraphemeBreakType(se)}e.$sf=Ne;function Te(se,fe){return se===0?fe!==5&&fe!==7:se===2&&fe===3?!1:se===4||se===2||se===3||fe===4||fe===2||fe===3?!0:!(se===8&&(fe===8||fe===9||fe===11||fe===12)||(se===11||se===9)&&(fe===9||fe===10)||(se===12||se===10)&&fe===10||fe===5||fe===13||fe===7||se===1||se===13&&fe===14||se===6&&fe===6)}var ce;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(ce||(e.GraphemeBreakType=ce={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,pe=me.length/3;let Se=1;for(;Se<=pe;)if(fe<me[3*Se])Se=2*Se;else if(fe>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ke(se,fe){if(se===0)return 0;const me=Pe(se,fe);if(me!==void 0)return me;const pe=new W(fe,se);return pe.prevCodePoint(),pe.offset}e.$tf=ke;function Pe(se,fe){const me=new W(fe,se);let pe=me.prevCodePoint();for(;Ue(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!F(pe))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function Ue(se){return 127995<=se&&se<=127999}var je;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$uf="\xA0";class ze{static{this.c=new N.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$we(fe=>{function me(Me){const Be=new Map;for(let qe=0;qe<Me.length;qe+=2)Be.set(Me[qe],Me[qe+1]);return Be}function pe(Me,Be){const qe=new Map(Me);for(const[We,_e]of Be)qe.set(We,_e);return qe}function Se(Me,Be){if(!Me)return Be;const qe=new Map;for(const[We,_e]of Me)Be.has(We)&&qe.set(We,_e);return qe}const Re=this.c.value;let Ce=fe.filter(Me=>!Me.startsWith("_")&&Me in Re);Ce.length===0&&(Ce=["_default"]);let De;for(const Me of Ce){const Be=me(Re[Me]);De=Se(De,Be)}const Oe=me(Re._common),Ae=pe(Oe,De);return new ze(Ae)})}static getInstance(fe){return ze.d.get(Array.from(fe))}static{this.e=new N.$U(()=>Object.keys(ze.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return ze.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$vf=ze;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(fe){return Fe.e().has(fe)}static get codePoints(){return Fe.e()}}e.$wf=Fe}),define(oe[52],ae([0,1,27]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=void 0;function N(f){return L(f,0)}e.$Bi=N;function L(f,c){switch(typeof f){case"object":return f===null?A(349,c):Array.isArray(f)?C(f,c):d(f,c);case"string":return I(f,c);case"boolean":return O(f,c);case"number":return A(f,c);case"undefined":return A(937,c);default:return A(617,c)}}e.$Ci=L;function A(f,c){return(c<<5)-c+f|0}e.$Di=A;function O(f,c){return A(f?433:863,c)}function I(f,c){c=A(149417,c);for(let h=0,m=f.length;h<m;h++)c=A(f.charCodeAt(h),c);return c}e.$Ei=I;function C(f,c){return c=A(104579,c),f.reduce((h,m)=>L(m,h),c)}function d(f,c){return c=A(181387,c),Object.keys(f).sort().reduce((h,m)=>(h=I(m,h),L(f[m],h)),c)}class P{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=L(c,this.g),this.g}}e.$Fi=P;var E;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function b(f,c,h=32){const m=h-c,S=~((1<<m)-1);return(f<<c|(S&f)>>>m)>>>0}function l(f,c=0,h=f.byteLength,m=0){for(let S=0;S<h;S++)f[c+S]=m}function g(f,c,h="0"){for(;f.length<c;)f=h+f;return f}function p(f,c=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(h=>h.toString(16).padStart(2,"0")).join(""):g((f>>>0).toString(16),c/4)}e.$Gi=p;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const h=c.length;if(h===0)return;const m=this.p;let S=this.r,s=this.u,a,n;for(s!==0?(a=s,n=-1,s=0):(a=c.charCodeAt(0),n=0);;){let i=a;if(D.$5e(a))if(n+1<h){const t=c.charCodeAt(n+1);D.$6e(t)?(n++,i=D.$7e(a,t)):i=65533}else{s=a;break}else D.$6e(a)&&(i=65533);if(S=this.w(m,S,i),n++,n<h)a=c.charCodeAt(n);else break}this.r=S,this.u=s}w(c,h,m){return m<128?c[h++]=m:m<2048?(c[h++]=192|(m&1984)>>>6,c[h++]=128|(m&63)>>>0):m<65536?(c[h++]=224|(m&61440)>>>12,c[h++]=128|(m&4032)>>>6,c[h++]=128|(m&63)>>>0):(c[h++]=240|(m&1835008)>>>18,c[h++]=128|(m&258048)>>>12,c[h++]=128|(m&4032)>>>6,c[h++]=128|(m&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=w.g,h=this.q;for(let o=0;o<64;o+=4)c.setUint32(o,h.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)c.setUint32(o,b(c.getUint32(o-12,!1)^c.getUint32(o-32,!1)^c.getUint32(o-56,!1)^c.getUint32(o-64,!1),1),!1);let m=this.h,S=this.l,s=this.m,a=this.n,n=this.o,i,t,r;for(let o=0;o<80;o++)o<20?(i=S&s|~S&a,t=1518500249):o<40?(i=S^s^a,t=1859775393):o<60?(i=S&s|S&a|s&a,t=2400959708):(i=S^s^a,t=3395469782),r=b(m,5)+i+n+t+c.getUint32(o*4,!1)&4294967295,n=a,a=s,s=b(S,30),S=m,m=r;this.h=this.h+m&4294967295,this.l=this.l+S&4294967295,this.m=this.m+s&4294967295,this.n=this.n+a&4294967295,this.o=this.o+n&4294967295}}e.$Hi=w}),define(oe[89],ae([0,1,27]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const A="error",O="warning",I="warn",C="info",d="ignore";function P(b){return b?D.$1e(A,b)?L.Error:D.$1e(O,b)||D.$1e(I,b)?L.Warning:D.$1e(C,b)?L.Info:L.Ignore:L.Ignore}L.fromValue=P;function E(b){switch(b){case L.Error:return A;case L.Warning:return O;case L.Info:return C;default:return d}}L.toString=E}(N||(N={})),e.default=N}),define(oe[130],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Jd=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,18,27]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class L{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const g=l.charCodeAt(0),p=this.b.charCodeAt(this.c);return g-p}value(){return this.b[this.c]}}e.$Ph=L;class A{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,N.$Ue)(l,this.b,0,l.length,this.c,this.d):(0,N.$We)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Qh=A;class O{constructor(l=!0,g=!0){this.f=l,this.g=g}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let g=l.length-1;g>=0;g--,this.c--){const p=this.b.charCodeAt(g);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,N.$Ue)(l,this.b,0,l.length,this.d,this.e):(0,N.$We)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Rh=O;var I;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(I||(I={}));class C{constructor(l,g){this.f=l,this.g=g,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,N.$Ve)(l,this.c.scheme);if(this.d[this.e]===2)return(0,N.$Ve)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,N.$Te)(l,this.c.query);if(this.d[this.e]===5)return(0,N.$Te)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Sh=C;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(P||(P={}));class E{static forUris(l=()=>!1,g=()=>!1){return new E(new C(l,g))}static forPaths(l=!1){return new E(new O(void 0,!l))}static forStrings(){return new E(new L)}static forConfigKeys(){return new E(new A)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,g){if(g){const p=g.slice(0);(0,D.$Wb)(p);for(const w of p)this.set(w,l)}else{const p=l.slice(0);(0,D.$Wb)(p);for(const w of p)this.set(w[0],w[1])}}set(l,g){const p=this.b.reset(l);let w;this.c||(this.c=new d,this.c.segment=p.value());const f=[];for(w=this.c;;){const h=p.cmp(w.segment);if(h>0)w.left||(w.left=new d,w.left.segment=p.value()),f.push([-1,w]),w=w.left;else if(h<0)w.right||(w.right=new d,w.right.segment=p.value()),f.push([1,w]),w=w.right;else if(p.hasNext())p.next(),w.mid||(w.mid=new d,w.mid.segment=p.value()),f.push([0,w]),w=w.mid;else break}const c=w.value;w.value=g,w.key=l;for(let h=f.length-1;h>=0;h--){const m=f[h][1];m.updateHeight();const S=m.balanceFactor();if(S<-1||S>1){const s=f[h][0],a=f[h+1][0];if(s===1&&a===1)f[h][1]=m.rotateLeft();else if(s===-1&&a===-1)f[h][1]=m.rotateRight();else if(s===1&&a===-1)m.right=f[h+1][1]=f[h+1][1].rotateRight(),f[h][1]=m.rotateLeft();else if(s===-1&&a===1)m.left=f[h+1][1]=f[h+1][1].rotateLeft(),f[h][1]=m.rotateRight();else throw new Error;if(h>0)switch(f[h-1][0]){case-1:f[h-1][1].left=f[h][1];break;case 1:f[h-1][1].right=f[h][1];break;case 0:f[h-1][1].mid=f[h][1];break}else this.c=f[0][1]}}return c}get(l){return this.d(l)?.value}d(l){const g=this.b.reset(l);let p=this.c;for(;p;){const w=g.cmp(p.segment);if(w>0)p=p.left;else if(w<0)p=p.right;else if(g.hasNext())g.next(),p=p.mid;else break}return p}has(l){const g=this.d(l);return!(g?.value===void 0&&g?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,g){const p=this.b.reset(l),w=[];let f=this.c;for(;f;){const c=p.cmp(f.segment);if(c>0)w.push([-1,f]),f=f.left;else if(c<0)w.push([1,f]),f=f.right;else if(p.hasNext())p.next(),w.push([0,f]),f=f.mid;else break}if(f){if(g?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const c=this.f(f.right);if(c.key){const{key:h,value:m,segment:S}=c;this.e(c.key,!1),f.key=h,f.value=m,f.segment=S}}else{const c=f.left??f.right;if(w.length>0){const[h,m]=w[w.length-1];switch(h){case-1:m.left=c;break;case 0:m.mid=c;break;case 1:m.right=c;break}}else this.c=c}for(let c=w.length-1;c>=0;c--){const h=w[c][1];h.updateHeight();const m=h.balanceFactor();if(m>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),w[c][1]=h.rotateLeft()):m<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),w[c][1]=h.rotateRight()),c>0)switch(w[c-1][0]){case-1:w[c-1][1].left=w[c][1];break;case 1:w[c-1][1].right=w[c][1];break;case 0:w[c-1][1].mid=w[c][1];break}else this.c=w[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const g=this.b.reset(l);let p=this.c,w;for(;p;){const f=g.cmp(p.segment);if(f>0)p=p.left;else if(f<0)p=p.right;else if(g.hasNext())g.next(),w=p.value||w,p=p.mid;else break}return p&&p.value||w}findSuperstr(l){return this.g(l,!1)}g(l,g){const p=this.b.reset(l);let w=this.c;for(;w;){const f=p.cmp(w.segment);if(f>0)w=w.left;else if(f<0)w=w.right;else if(p.hasNext())p.next(),w=w.mid;else return w.mid?this.h(w.mid):g?w.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[g,p]of this)l(p,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const g=[];return this.j(l,g),g[Symbol.iterator]()}j(l,g){l&&(l.left&&this.j(l.left,g),l.value&&g.push([l.key,l.value]),l.mid&&this.j(l.mid,g),l.right&&this.j(l.right,g))}_isBalanced(){const l=g=>{if(!g)return!0;const p=g.balanceFactor();return p<-1||p>1?!1:l(g.left)&&l(g.right)};return l(this.c)}}e.$Th=E}),define(oe[12],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=void 0;function D(S){return typeof S=="string"}e.$xf=D;function N(S){return Array.isArray(S)&&S.every(s=>D(s))}e.$yf=N;function L(S){return typeof S=="object"&&S!==null&&!Array.isArray(S)&&!(S instanceof RegExp)&&!(S instanceof Date)}e.$zf=L;function A(S){const s=Object.getPrototypeOf(Uint8Array);return typeof S=="object"&&S instanceof s}e.$Af=A;function O(S){return typeof S=="number"&&!isNaN(S)}e.$Bf=O;function I(S){return!!S&&typeof S[Symbol.iterator]=="function"}e.$Cf=I;function C(S){return S===!0||S===!1}e.$Df=C;function d(S){return typeof S>"u"}e.$Ef=d;function P(S){return!E(S)}e.$Ff=P;function E(S){return d(S)||S===null}e.$Gf=E;function b(S,s){if(!S)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$Hf=b;function l(S){if(E(S))throw new Error("Assertion Failed: argument is undefined or null");return S}e.$If=l;function g(...S){const s=[];for(let a=0;a<S.length;a++){const n=S[a];if(E(n))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);s.push(n)}return s}e.$Jf=g;const p=Object.prototype.hasOwnProperty;function w(S){if(!L(S))return!1;for(const s in S)if(p.call(S,s))return!1;return!0}e.$Kf=w;function f(S){return typeof S=="function"}e.$Lf=f;function c(...S){return S.length>0&&S.every(f)}e.$Mf=c;function h(S,s){const a=Math.min(S.length,s.length);for(let n=0;n<a;n++)m(S[n],s[n])}e.$Nf=h;function m(S,s){if(D(s)){if(typeof S!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(f(s)){try{if(S instanceof s)return}catch{}if(!E(S)&&S.constructor===s||s.length===1&&s.call(void 0,S)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Of=m}),define(oe[30],ae([0,1,12]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=void 0;function N(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const c=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([h,m])=>{c[h]=m&&typeof m=="object"?N(m):m}),c}e.$3m=N;function L(f){if(!f||typeof f!="object")return f;const c=[f];for(;c.length>0;){const h=c.shift();Object.freeze(h);for(const m in h)if(A.call(h,m)){const S=h[m];typeof S=="object"&&!Object.isFrozen(S)&&!(0,D.$Af)(S)&&c.push(S)}}return f}e.$4m=L;const A=Object.prototype.hasOwnProperty;function O(f,c){return I(f,c,new Set)}e.$5m=O;function I(f,c,h){if((0,D.$Gf)(f))return f;const m=c(f);if(typeof m<"u")return m;if(Array.isArray(f)){const S=[];for(const s of f)S.push(I(s,c,h));return S}if((0,D.$zf)(f)){if(h.has(f))throw new Error("Cannot clone recursive data-structure");h.add(f);const S={};for(const s in f)A.call(f,s)&&(S[s]=I(f[s],c,h));return h.delete(f),S}return f}function C(f,c,h=!0){return(0,D.$zf)(f)?((0,D.$zf)(c)&&Object.keys(c).forEach(m=>{m in f?h&&((0,D.$zf)(f[m])&&(0,D.$zf)(c[m])?C(f[m],c[m],h):f[m]=c[m]):f[m]=c[m]}),f):c}e.$6m=C;function d(f,c){if(f===c)return!0;if(f==null||c===null||c===void 0||typeof f!=typeof c||typeof f!="object"||Array.isArray(f)!==Array.isArray(c))return!1;let h,m;if(Array.isArray(f)){if(f.length!==c.length)return!1;for(h=0;h<f.length;h++)if(!d(f[h],c[h]))return!1}else{const S=[];for(m in f)S.push(m);S.sort();const s=[];for(m in c)s.push(m);if(s.sort(),!d(S,s))return!1;for(h=0;h<S.length;h++)if(!d(f[S[h]],c[S[h]]))return!1}return!0}e.$7m=d;function P(f){const c=new Set;return JSON.stringify(f,(h,m)=>{if((0,D.$zf)(m)||Array.isArray(m)){if(c.has(m))return"[Circular]";c.add(m)}return m})}e.$8m=P;function E(f,c){const h=Object.create(null);return!f||!c||Object.keys(c).forEach(S=>{const s=f[S],a=c[S];d(s,a)||(h[S]=a)}),h}e.$9m=E;function b(f,c){const h=c.toLowerCase(),m=Object.keys(f).find(S=>S.toLowerCase()===h);return m?f[m]:f[c]}e.$0m=b;function l(f,c){const h=Object.create(null);for(const[m,S]of Object.entries(f))c(m,S)&&(h[m]=S);return h}e.$$m=l;function g(f){let c=[];for(;Object.prototype!==f;)c=c.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return c}e.$_m=g;function p(f){const c=[];for(const h of g(f))typeof f[h]=="function"&&c.push(h);return c}e.$an=p;function w(f,c){const h=S=>function(){const s=Array.prototype.slice.call(arguments,0);return c(S,s)},m={};for(const S of f)m[S]=h(S);return m}e.$bn=w}),define(oe[32],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return D.test(L)}e.$cg=N,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(I){for(let C=0;C<I.length;C++)I[C]=Math.floor(Math.random()*256);return I};const A=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){L(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let C=0,d="";return d+=O[A[C++]],d+=O[A[C++]],d+=O[A[C++]],d+=O[A[C++]],d+="-",d+=O[A[C++]],d+=O[A[C++]],d+="-",d+=O[A[C++]],d+=O[A[C++]],d+="-",d+=O[A[C++]],d+=O[A[C++]],d+="-",d+=O[A[C++]],d+=O[A[C++]],d+=O[A[C++]],d+=O[A[C++]],d+=O[A[C++]],d+=O[A[C++]],d}}()}),define(oe[131],ae([0,1,36]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(O){const I=O.replace(/\-/g,":").toLowerCase();return!N.has(I)}function A(){const O=(0,D.networkInterfaces)();for(const I in O){const C=O[I];if(C){for(const{mac:d}of C)if(L(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Nm=A}),define(oe[132],ae([0,1,36,47,32,131]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=void 0,e.$Om=new class{c(d){return this.a||(this.a=N.$Th.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,P=0;const E=(0,D.networkInterfaces)();for(const b in E){const l=E[b];if(l)for(const{mac:g,internal:p}of l)p||(P+=1,this.c(g.toUpperCase())&&(d+=1))}this.b=P>0?d/P:0}return this.b}};let O;async function I(d){return O||(O=(async()=>await C(d)||L.$dg())()),O}e.$Pm=I;async function C(d){try{const P=await new Promise((b,l)=>{te(["crypto"],b,l)}),E=(0,A.$Nm)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){d(P);return}}}),define(oe[133],ae([0,1,268,15]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_S=void 0;class L extends D.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const I=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=I.length===1?I[0]:I,this.c=I.length}}_transform(O,I,C){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let d=0;for(;d<this.a.length;){const P=typeof this.b=="number"?this.a.indexOf(this.b,d):(0,N.$be)(this.a,this.b,d);if(P===-1)break;this.push(this.a.slice(d,P+this.c)),d=P+this.c}this.a=d===this.a.length?void 0:this.a.slice(d),C()}_flush(O){this.a&&this.push(this.a),O()}}e.$_S=L}),define(oe[134],ae([0,1,62]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.$gg=e.$fg=void 0;function N(I,C,d,P=1){let E=!1;return new Promise(b=>{const l=setTimeout(()=>{if(!E)return E=!0,b(0)},d);L(I,C,P,g=>{if(!E)return E=!0,clearTimeout(l),b(g)})})}e.$fg=N;function L(I,C,d,P){if(C===0)return P(0);const E=new D.Socket;E.once("connect",()=>(O(E),L(I+d,C-1,d,P))),E.once("data",()=>{}),E.once("error",b=>(O(E),b.code!=="ECONNREFUSED"?L(I+d,C-1,d,P):P(I))),E.connect(I,"127.0.0.1")}e.$gg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(I,C,d,P="127.0.0.1"){let E=!1,b,l=1;const g=D.createServer({pauseOnConnect:!0});function p(w,f){E||(E=!0,g.removeAllListeners(),g.close(),b&&clearTimeout(b),f(w))}return new Promise(w=>{b=setTimeout(()=>{p(0,w)},d),g.on("listening",()=>{p(I,w)}),g.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&l<C?(I++,l++,g.listen(I,P)):p(0,w)}),g.on("close",()=>{p(0,w)}),g.listen(I,P)})}e.$hg=A;function O(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(C){console.error(C)}}}),define(oe[135],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pT=void 0;function D(N){return!!N.parentPort}e.$pT=D}),define(oe[136],ae([13,9]),function(te,e){return te.create("vs/base/common/date",e)}),define(oe[63],ae([0,1,136]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=void 0;const N=60,L=N*60,A=L*24,O=A*7,I=A*30,C=A*365;function d(E,b,l,g){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,D.localize)(0,null,d(new Date().getTime()+p*1e3,!1));if(!g&&p<30)return(0,D.localize)(1,null);let w;return p<N?(w=p,b?w===1?l?(0,D.localize)(2,null,w):(0,D.localize)(3,null,w):l?(0,D.localize)(4,null,w):(0,D.localize)(5,null,w):w===1?l?(0,D.localize)(6,null,w):(0,D.localize)(7,null,w):l?(0,D.localize)(8,null,w):(0,D.localize)(9,null,w)):p<L?(w=Math.floor(p/N),b?w===1?l?(0,D.localize)(10,null,w):(0,D.localize)(11,null,w):l?(0,D.localize)(12,null,w):(0,D.localize)(13,null,w):w===1?l?(0,D.localize)(14,null,w):(0,D.localize)(15,null,w):l?(0,D.localize)(16,null,w):(0,D.localize)(17,null,w)):p<A?(w=Math.floor(p/L),b?w===1?l?(0,D.localize)(18,null,w):(0,D.localize)(19,null,w):l?(0,D.localize)(20,null,w):(0,D.localize)(21,null,w):w===1?l?(0,D.localize)(22,null,w):(0,D.localize)(23,null,w):l?(0,D.localize)(24,null,w):(0,D.localize)(25,null,w)):p<O?(w=Math.floor(p/A),b?w===1?(0,D.localize)(26,null,w):(0,D.localize)(27,null,w):w===1?(0,D.localize)(28,null,w):(0,D.localize)(29,null,w)):p<I?(w=Math.floor(p/O),b?w===1?l?(0,D.localize)(30,null,w):(0,D.localize)(31,null,w):l?(0,D.localize)(32,null,w):(0,D.localize)(33,null,w):w===1?l?(0,D.localize)(34,null,w):(0,D.localize)(35,null,w):l?(0,D.localize)(36,null,w):(0,D.localize)(37,null,w)):p<C?(w=Math.floor(p/I),b?w===1?l?(0,D.localize)(38,null,w):(0,D.localize)(39,null,w):l?(0,D.localize)(40,null,w):(0,D.localize)(41,null,w):w===1?l?(0,D.localize)(42,null,w):(0,D.localize)(43,null,w):l?(0,D.localize)(44,null,w):(0,D.localize)(45,null,w)):(w=Math.floor(p/C),b?w===1?l?(0,D.localize)(46,null,w):(0,D.localize)(47,null,w):l?(0,D.localize)(48,null,w):(0,D.localize)(49,null,w):w===1?l?(0,D.localize)(50,null,w):(0,D.localize)(51,null,w):l?(0,D.localize)(52,null,w):(0,D.localize)(53,null,w))}e.$am=d;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$bm=P}),define(oe[137],ae([13,9]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,18,12,137]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function A(E,b){return b&&(E.stack||E.stacktrace)?L.localize(0,null,I(E),O(E.stack)||O(E.stacktrace)):I(E)}function O(E){return Array.isArray(E)?E.join(`
`):E}function I(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function C(E=null,b=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const l=D.$Gb(E),g=C(l[0],b);return l.length>1?L.localize(4,null,g,l.length):g}if(N.$xf(E))return E;if(E.detail){const l=E.detail;if(l.error)return A(l.error,b);if(l.exception)return A(l.exception,b)}return E.stack?A(E,b):E.message?E.message:L.localize(5,null)}e.$yi=C;function d(E){const b=E;return b instanceof Error&&Array.isArray(b.actions)}e.$zi=d;function P(E,b){let l;return typeof E=="string"?l=new Error(E):l=E,l.actions=b,l}e.$Ai=P}),define(oe[138],ae([13,9]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(oe[139],ae([0,1,138]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;function N(L){switch(L){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.$tp=N}),define(oe[140],ae([13,9]),function(te,e){return te.create("vs/base/common/platform",e)}),define(oe[6],ae([0,1,140]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let N=!1,L=!1,A=!1,O=!1,I=!1,C=!1,d=!1,P=!1,E=!1,b=!1,l,g=e.$g,p=e.$g,w,f;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?c=e.$h.vscode.process:typeof process<"u"&&(c=process);const h=typeof c?.versions?.electron=="string",m=h&&c?.type==="renderer";if(typeof navigator=="object"&&!m)f=navigator.userAgent,N=f.indexOf("Windows")>=0,L=f.indexOf("Macintosh")>=0,P=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=f.indexOf("Linux")>=0,b=f?.indexOf("Mobi")>=0,C=!0,l=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,g=l,p=navigator.language;else if(typeof c=="object"){N=c.platform==="win32",L=c.platform==="darwin",A=c.platform==="linux",O=A&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,d=h,E=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$g,g=e.$g;const v=c.env.VSCODE_NLS_CONFIG;if(v)try{const y=JSON.parse(v),u=y.availableLanguages["*"];l=y.locale,p=y.osLocale,g=u||e.$g,w=y._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var S;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(S||(e.Platform=S={}));function s(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=s;let a=0;L?a=1:N?a=3:A&&(a=2),e.$j=N,e.$k=L,e.$l=A,e.$m=O,e.$n=I,e.$o=d,e.$p=C,e.$q=C&&typeof e.$h.importScripts=="function",e.$r=P,e.$s=b,e.$t=E,e.$u=a,e.$v=f,e.$w=g;var n;(function(v){function y(){return e.$w}v.value=y;function u(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=u;function $(){return e.$w==="en"}v.isDefault=$})(n||(e.Language=n={})),e.$x=l,e.$y=p,e.$z=w,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const v=[];e.$h.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let $=0,j=v.length;$<j;$++){const M=v[$];if(M.id===u.data.vscodeScheduleAsyncWork){v.splice($,1),M.callback();return}}});let y=0;return u=>{const $=++y;v.push({id:$,callback:u}),e.$h.postMessage({vscodeScheduleAsyncWork:$},"*")}}return v=>setTimeout(v)})();var i;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=L||P?2:N?1:3;let t=!0,r=!1;function o(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,t=new Uint16Array(v.buffer)[0]===(2<<8)+1}return t}e.$D=o,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(oe[37],ae([0,1,6]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let N;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.process<"u"){const L=D.$h.vscode.process;N={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.$j?"win32":D.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$cc=N.platform,e.$dc=N.arch}),define(oe[16],ae([0,1,37]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const N=65,L=97,A=90,O=122,I=46,C=47,d=92,P=58,E=63;class b extends Error{constructor(a,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${t} of type ${n}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function l(s,a){if(s===null||typeof s!="object")throw new b(a,"Object",s)}function g(s,a){if(typeof s!="string")throw new b(a,"string",s)}const p=D.$cc==="win32";function w(s){return s===C||s===d}function f(s){return s===C}function c(s){return s>=N&&s<=A||s>=L&&s<=O}function h(s,a,n,i){let t="",r=0,o=-1,v=0,y=0;for(let u=0;u<=s.length;++u){if(u<s.length)y=s.charCodeAt(u);else{if(i(y))break;y=C}if(i(y)){if(!(o===u-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==I||t.charCodeAt(t.length-2)!==I){if(t.length>2){const $=t.lastIndexOf(n);$===-1?(t="",r=0):(t=t.slice(0,$),r=t.length-1-t.lastIndexOf(n)),o=u,v=0;continue}else if(t.length!==0){t="",r=0,o=u,v=0;continue}}a&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(o+1,u)}`:t=s.slice(o+1,u),r=u-o-1;o=u,v=0}else y===I&&v!==-1?++v:v=-1}return t}function m(s,a){l(a,"pathObject");const n=a.dir||a.root,i=a.base||`${a.name||""}${a.ext||""}`;return n?n===a.root?`${n}${i}`:`${n}${s}${i}`:i}e.$ec={resolve(...s){let a="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],g(r,"path"),r.length===0)continue}else a.length===0?r=D.cwd():(r=D.env[`=${a}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===d)&&(r=`${a}\\`));const o=r.length;let v=0,y="",u=!1;const $=r.charCodeAt(0);if(o===1)w($)&&(v=1,u=!0);else if(w($))if(u=!0,w(r.charCodeAt(1))){let j=2,M=j;for(;j<o&&!w(r.charCodeAt(j));)j++;if(j<o&&j!==M){const T=r.slice(M,j);for(M=j;j<o&&w(r.charCodeAt(j));)j++;if(j<o&&j!==M){for(M=j;j<o&&!w(r.charCodeAt(j));)j++;(j===o||j!==M)&&(y=`\\\\${T}\\${r.slice(M,j)}`,v=j)}}}else v=1;else c($)&&r.charCodeAt(1)===P&&(y=r.slice(0,2),v=2,o>2&&w(r.charCodeAt(2))&&(u=!0,v=3));if(y.length>0)if(a.length>0){if(y.toLowerCase()!==a.toLowerCase())continue}else a=y;if(i){if(a.length>0)break}else if(n=`${r.slice(v)}\\${n}`,i=u,u&&a.length>0)break}return n=h(n,!i,"\\",w),i?`${a}\\${n}`:`${a}${n}`||"."},normalize(s){g(s,"path");const a=s.length;if(a===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(a===1)return f(r)?"\\":s;if(w(r))if(t=!0,w(s.charCodeAt(1))){let v=2,y=v;for(;v<a&&!w(s.charCodeAt(v));)v++;if(v<a&&v!==y){const u=s.slice(y,v);for(y=v;v<a&&w(s.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&!w(s.charCodeAt(v));)v++;if(v===a)return`\\\\${u}\\${s.slice(y)}\\`;v!==y&&(i=`\\\\${u}\\${s.slice(y,v)}`,n=v)}}}else n=1;else c(r)&&s.charCodeAt(1)===P&&(i=s.slice(0,2),n=2,a>2&&w(s.charCodeAt(2))&&(t=!0,n=3));let o=n<a?h(s.slice(n),!t,"\\",w):"";return o.length===0&&!t&&(o="."),o.length>0&&w(s.charCodeAt(a-1))&&(o+="\\"),i===void 0?t?`\\${o}`:o:t?`${i}\\${o}`:`${i}${o}`},isAbsolute(s){g(s,"path");const a=s.length;if(a===0)return!1;const n=s.charCodeAt(0);return w(n)||a>2&&c(n)&&s.charCodeAt(1)===P&&w(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,n;for(let r=0;r<s.length;++r){const o=s[r];g(o,"path"),o.length>0&&(a===void 0?a=n=o:a+=`\\${o}`)}if(a===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&w(n.charCodeAt(0))){++t;const r=n.length;r>1&&w(n.charCodeAt(1))&&(++t,r>2&&(w(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<a.length&&w(a.charCodeAt(t));)t++;t>=2&&(a=`\\${a.slice(t)}`)}return e.$ec.normalize(a)},relative(s,a){if(g(s,"from"),g(a,"to"),s===a)return"";const n=e.$ec.resolve(s),i=e.$ec.resolve(a);if(n===i||(s=n.toLowerCase(),a=i.toLowerCase(),s===a))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===d;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===d;)r--;const o=r-t;let v=0;for(;v<a.length&&a.charCodeAt(v)===d;)v++;let y=a.length;for(;y-1>v&&a.charCodeAt(y-1)===d;)y--;const u=y-v,$=o<u?o:u;let j=-1,M=0;for(;M<$;M++){const U=s.charCodeAt(t+M);if(U!==a.charCodeAt(v+M))break;U===d&&(j=M)}if(M!==$){if(j===-1)return i}else{if(u>$){if(a.charCodeAt(v+M)===d)return i.slice(v+M+1);if(M===2)return i.slice(v+M)}o>$&&(s.charCodeAt(t+M)===d?j=M:M===2&&(j=3)),j===-1&&(j=0)}let T="";for(M=t+j+1;M<=r;++M)(M===r||s.charCodeAt(M)===d)&&(T+=T.length===0?"..":"\\..");return v+=j,T.length>0?`${T}${i.slice(v,y)}`:(i.charCodeAt(v)===d&&++v,i.slice(v,y))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const a=e.$ec.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===d){if(a.charCodeAt(1)===d){const n=a.charCodeAt(2);if(n!==E&&n!==I)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(c(a.charCodeAt(0))&&a.charCodeAt(1)===P&&a.charCodeAt(2)===d)return`\\\\?\\${a}`;return s},dirname(s){g(s,"path");const a=s.length;if(a===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(a===1)return w(t)?s:".";if(w(t)){if(n=i=1,w(s.charCodeAt(1))){let v=2,y=v;for(;v<a&&!w(s.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&w(s.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&!w(s.charCodeAt(v));)v++;if(v===a)return s;v!==y&&(n=i=v+1)}}}}else c(t)&&s.charCodeAt(1)===P&&(n=a>2&&w(s.charCodeAt(2))?3:2,i=n);let r=-1,o=!0;for(let v=a-1;v>=i;--v)if(w(s.charCodeAt(v))){if(!o){r=v;break}}else o=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,a){a!==void 0&&g(a,"ext"),g(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&c(s.charCodeAt(0))&&s.charCodeAt(1)===P&&(n=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=n;--r){const y=s.charCodeAt(r);if(w(y)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&(y===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(w(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){g(s,"path");let a=0,n=-1,i=0,t=-1,r=!0,o=0;s.length>=2&&s.charCodeAt(1)===P&&c(s.charCodeAt(0))&&(a=i=2);for(let v=s.length-1;v>=a;--v){const y=s.charCodeAt(v);if(w(y)){if(!r){i=v+1;break}continue}t===-1&&(r=!1,t=v+1),y===I?n===-1?n=v:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||t===-1||o===0||o===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:m.bind(null,"\\"),parse(s){g(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return w(t)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(w(t)){if(i=1,w(s.charCodeAt(1))){let j=2,M=j;for(;j<n&&!w(s.charCodeAt(j));)j++;if(j<n&&j!==M){for(M=j;j<n&&w(s.charCodeAt(j));)j++;if(j<n&&j!==M){for(M=j;j<n&&!w(s.charCodeAt(j));)j++;j===n?i=j:j!==M&&(i=j+1)}}}}else if(c(t)&&s.charCodeAt(1)===P){if(n<=2)return a.root=a.dir=s,a;if(i=2,w(s.charCodeAt(2))){if(n===3)return a.root=a.dir=s,a;i=3}}i>0&&(a.root=s.slice(0,i));let r=-1,o=i,v=-1,y=!0,u=s.length-1,$=0;for(;u>=i;--u){if(t=s.charCodeAt(u),w(t)){if(!y){o=u+1;break}continue}v===-1&&(y=!1,v=u+1),t===I?r===-1?r=u:$!==1&&($=1):r!==-1&&($=-1)}return v!==-1&&(r===-1||$===0||$===1&&r===v-1&&r===o+1?a.base=a.name=s.slice(o,v):(a.name=s.slice(o,r),a.base=s.slice(o,v),a.ext=s.slice(r,v))),o>0&&o!==i?a.dir=s.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(p){const s=/\\/g;return()=>{const a=D.cwd().replace(s,"/");return a.slice(a.indexOf("/"))}}return()=>D.cwd()})();e.$fc={resolve(...s){let a="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:S();g(t,"path"),t.length!==0&&(a=`${t}/${a}`,n=t.charCodeAt(0)===C)}return a=h(a,!n,"/",f),n?`/${a}`:a.length>0?a:"."},normalize(s){if(g(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===C,n=s.charCodeAt(s.length-1)===C;return s=h(s,!a,"/",f),s.length===0?a?"/":n?"./":".":(n&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return g(s,"path"),s.length>0&&s.charCodeAt(0)===C},join(...s){if(s.length===0)return".";let a;for(let n=0;n<s.length;++n){const i=s[n];g(i,"path"),i.length>0&&(a===void 0?a=i:a+=`/${i}`)}return a===void 0?".":e.$fc.normalize(a)},relative(s,a){if(g(s,"from"),g(a,"to"),s===a||(s=e.$fc.resolve(s),a=e.$fc.resolve(a),s===a))return"";const n=1,i=s.length,t=i-n,r=1,o=a.length-r,v=t<o?t:o;let y=-1,u=0;for(;u<v;u++){const j=s.charCodeAt(n+u);if(j!==a.charCodeAt(r+u))break;j===C&&(y=u)}if(u===v)if(o>v){if(a.charCodeAt(r+u)===C)return a.slice(r+u+1);if(u===0)return a.slice(r+u)}else t>v&&(s.charCodeAt(n+u)===C?y=u:u===0&&(y=0));let $="";for(u=n+y+1;u<=i;++u)(u===i||s.charCodeAt(u)===C)&&($+=$.length===0?"..":"/..");return`${$}${a.slice(r+y)}`},toNamespacedPath(s){return s},dirname(s){if(g(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===C;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===C){if(!i){n=t;break}}else i=!1;return n===-1?a?"/":".":a&&n===1?"//":s.slice(0,n)},basename(s,a){a!==void 0&&g(a,"ext"),g(s,"path");let n=0,i=-1,t=!0,r;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=0;--r){const y=s.charCodeAt(r);if(y===C){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&(y===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===C){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){g(s,"path");let a=-1,n=0,i=-1,t=!0,r=0;for(let o=s.length-1;o>=0;--o){const v=s.charCodeAt(o);if(v===C){if(!t){n=o+1;break}continue}i===-1&&(t=!1,i=o+1),v===I?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||i===-1||r===0||r===1&&a===i-1&&a===n+1?"":s.slice(a,i)},format:m.bind(null,"/"),parse(s){g(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.charCodeAt(0)===C;let i;n?(a.root="/",i=1):i=0;let t=-1,r=0,o=-1,v=!0,y=s.length-1,u=0;for(;y>=i;--y){const $=s.charCodeAt(y);if($===C){if(!v){r=y+1;break}continue}o===-1&&(v=!1,o=y+1),$===I?t===-1?t=y:u!==1&&(u=1):t!==-1&&(u=-1)}if(o!==-1){const $=r===0&&n?1:r;t===-1||u===0||u===1&&t===o-1&&t===r+1?a.base=a.name=s.slice($,o):(a.name=s.slice($,t),a.base=s.slice($,o),a.ext=s.slice(t,o))}return r>0?a.dir=s.slice(0,r-1):n&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=p?e.$ec.normalize:e.$fc.normalize,e.$hc=p?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=p?e.$ec.join:e.$fc.join,e.$jc=p?e.$ec.resolve:e.$fc.resolve,e.$kc=p?e.$ec.relative:e.$fc.relative,e.$lc=p?e.$ec.dirname:e.$fc.dirname,e.$mc=p?e.$ec.basename:e.$fc.basename,e.$nc=p?e.$ec.extname:e.$fc.extname,e.$oc=p?e.$ec.format:e.$fc.format,e.$pc=p?e.$ec.parse:e.$fc.parse,e.$qc=p?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=p?e.$ec.sep:e.$fc.sep,e.$sc=p?e.$ec.delimiter:e.$fc.delimiter}),define(oe[48],ae([0,1,16,6,27,12]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=void 0;function O(r){return r===47||r===92}e.$Pf=O;function I(r){return r.replace(/[\\/]/g,D.$fc.sep)}e.$Qf=I;function C(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Rf=C;function d(r,o=D.$fc.sep){if(!r)return"";const v=r.length,y=r.charCodeAt(0);if(O(y)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let $=3;const j=$;for(;$<v&&!O(r.charCodeAt($));$++);if(j!==$&&!O(r.charCodeAt($+1))){for($+=1;$<v;$++)if(O(r.charCodeAt($)))return r.slice(0,$+1).replace(/[\\/]/g,o)}}return o}else if(f(y)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<v;u++)if(O(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.$Sf=d;function P(r){if(!N.$j||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let v=2;const y=v;for(;v<r.length&&(o=r.charCodeAt(v),o!==92);v++);return!(y===v||(o=r.charCodeAt(v+1),isNaN(o)||o===92))}e.$Tf=P;const E=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,o=N.$j){const v=o?E:b;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||o&&l.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.$Uf=g;function p(r,o,v){const y=r===o;return!v||y?y:!r||!o?!1:(0,L.$1e)(r,o)}e.$Vf=p;function w(r,o,v,y=D.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(v){if(!(0,L.$2e)(r,o))return!1;if(o.length===r.length)return!0;let $=o.length;return o.charAt(o.length-1)===y&&$--,r.charAt($)===y}return o.charAt(o.length-1)!==y&&(o+=y),r.indexOf(o)===0}e.$Wf=w;function f(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Xf=f;function c(r,o){return N.$j&&r.endsWith(":")&&(r+=D.sep),(0,D.$hc)(r)||(r=(0,D.$ic)(o,r)),r=(0,D.$gc)(r),N.$j?(r=(0,L.$Je)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,L.$Je)(r,D.sep),r||(r=D.sep)),r}e.$Yf=c;function h(r){const o=(0,D.$gc)(r);return N.$j?r.length>3?!1:m(o)&&(r.length===2||o.charCodeAt(2)===92):o===D.$fc.sep}e.$Zf=h;function m(r,o=N.$j){return o?f(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$1f=m;function S(r,o=N.$j){return m(r,o)?r[0]:void 0}e.$2f=S;function s(r,o,v){return o.length>r.length?-1:r===o?0:(v&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.$3f=s;function a(r){const o=r.split(":");let v,y,u;for(const $ of o){const j=Number($);(0,A.$Bf)(j)?y===void 0?y=j:u===void 0&&(u=j):v=v?[v,$].join(":"):$}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:y!==void 0?y:void 0,column:u!==void 0?u:y!==void 0?1:void 0}}e.$4f=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,o,v=8){let y="";for(let $=0;$<v;$++){let j;$===0&&N.$j&&!o&&(v===3||v===4)?j=i:j=n,y+=j.charAt(Math.floor(Math.random()*j.length))}let u;return o?u=`${o}-${y}`:u=y,r?(0,D.$ic)(r,u):u}e.$5f=t}),define(oe[141],ae([0,1,16]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0,e.$Mr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(P){const E=(0,D.$nc)(P),b=N[E.toLowerCase()];return b!==void 0?b:O(P)}e.$Nr=A;function O(P){const E=(0,D.$nc)(P);return L[E.toLowerCase()]}e.$Or=O;function I(P){for(const E in L)if(L[E]===P)return E}e.$Pr=I;const C=/^(.+)\/(.+?)(;.+)?$/;function d(P,E){const b=C.exec(P);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:E?void 0:P}e.$Qr=d}),define(oe[90],ae([0,1,6]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=e.TerminateResponseCode=e.Source=void 0;var N;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function A(I,...C){const d=C.reduce((b,l)=>(b[l]=!0,b),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(b=>!d[b]).forEach(b=>{for(let l=0;l<P.length;l++)if(b.search(P[l])!==-1){delete I[b];break}})}e.$wl=A;function O(I){I&&(delete I.DEBUG,D.$k&&delete I.DYLD_LIBRARY_PATH,D.$l&&delete I.LD_PRELOAD)}e.$xl=O}),define(oe[10],ae([0,1,16,6]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function I(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(i,t){return!i&&!t?"file":i}function d(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const P="",E="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(t){return t instanceof l?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,o,v,y,u=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=C(t,u),this.authority=r||P,this.path=d(this.scheme,o||P),this.query=v||P,this.fragment=y||P,I(this,u))}get fsPath(){return m(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:o,path:v,query:y,fragment:u}=t;return r===void 0?r=this.scheme:r===null&&(r=P),o===void 0?o=this.authority:o===null&&(o=P),v===void 0?v=this.path:v===null&&(v=P),y===void 0?y=this.query:y===null&&(y=P),u===void 0?u=this.fragment:u===null&&(u=P),r===this.scheme&&o===this.authority&&v===this.path&&y===this.query&&u===this.fragment?this:new w(r,o,v,y,u)}static parse(t,r=!1){const o=b.exec(t);return o?new w(o[2]||P,n(o[4]||P),n(o[5]||P),n(o[7]||P),n(o[9]||P),r):new w(P,P,P,P,P)}static file(t){let r=P;if(N.$j&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const o=t.indexOf(E,2);o===-1?(r=t.substring(2),t=E):(r=t.substring(2,o),t=t.substring(o)||E)}return new w("file",r,t,P,P)}static from(t,r){return new w(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return N.$j&&t.scheme==="file"?o=l.file(D.$ec.join(m(t,!0),...r)).path:o=D.$fc.join(t.path,...r),t.with({path:o})}toString(t=!1){return S(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof l)return t;{const r=new w(t);return r._formatted=t.external??null,r._fsPath=t._sep===p?t.fsPath??null:null,r}}else return t}}e.URI=l;function g(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$uc=g;const p=N.$j?1:void 0;class w extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(t=!1){return t?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function c(i,t,r){let o,v=-1;for(let y=0;y<i.length;y++){const u=i.charCodeAt(y);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||t&&u===47||r&&u===91||r&&u===93||r&&u===58)v!==-1&&(o+=encodeURIComponent(i.substring(v,y)),v=-1),o!==void 0&&(o+=i.charAt(y));else{o===void 0&&(o=i.substr(0,y));const $=f[u];$!==void 0?(v!==-1&&(o+=encodeURIComponent(i.substring(v,y)),v=-1),o+=$):v===-1&&(v=y)}}return v!==-1&&(o+=encodeURIComponent(i.substring(v))),o!==void 0?o:i}function h(i){let t;for(let r=0;r<i.length;r++){const o=i.charCodeAt(r);o===35||o===63?(t===void 0&&(t=i.substr(0,r)),t+=f[o]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function m(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,N.$j&&(r=r.replace(/\//g,"\\")),r}e.$vc=m;function S(i,t){const r=t?h:c;let o="",{scheme:v,authority:y,path:u,query:$,fragment:j}=i;if(v&&(o+=v,o+=":"),(y||v==="file")&&(o+=E,o+=E),y){let M=y.indexOf("@");if(M!==-1){const T=y.substr(0,M);y=y.substr(M+1),M=T.lastIndexOf(":"),M===-1?o+=r(T,!1,!1):(o+=r(T.substr(0,M),!1,!1),o+=":",o+=r(T.substr(M+1),!1,!0)),o+="@"}y=y.toLowerCase(),M=y.lastIndexOf(":"),M===-1?o+=r(y,!1,!0):(o+=r(y.substr(0,M),!1,!0),o+=y.substr(M))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const M=u.charCodeAt(1);M>=65&&M<=90&&(u=`/${String.fromCharCode(M+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const M=u.charCodeAt(0);M>=65&&M<=90&&(u=`${String.fromCharCode(M+32)}:${u.substr(2)}`)}o+=r(u,!0,!1)}return $&&(o+="?",o+=r($,!1,!1)),j&&(o+="#",o+=t?j:c(j,!1,!1)),o}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(a)?i.replace(a,t=>s(t)):i}}),define(oe[142],ae([0,1,10]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Wp=e.$Vp=e.$Up=void 0;function N(d){const P=d;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Up=N;function L(d){const P=[];let E;try{const b=JSON.parse(d.arguments),l=b[b.length-1];l&&l.__$stack&&(b.pop(),E=l.__$stack),P.push(...b)}catch{P.push("Unable to log remote console arguments",d.arguments)}return{args:P,stack:E}}e.$Vp=L;function A(d){if(typeof d!="string")return A(L(d).stack);const P=d;if(P){const E=O(P),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(b&&b.length===4)return{uri:D.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$Wp=A;function O(d){if(!d)return d;const P=d.indexOf(`
`);return P===-1?d:d.substring(0,P)}function I(d,P){const{args:E,stack:b}=L(d),l=typeof E[0]=="string"&&E.length===1;let g=O(b);g&&(g=`(${g.trim()})`);let p=[];if(typeof E[0]=="string"?g&&l?p=[`%c[${P}] %c${E[0]} %c${g}`,C("blue"),C(""),C("grey")]:p=[`%c[${P}] %c${E[0]}`,C("blue"),C(""),...E.slice(1)]:p=[`%c[${P}]%`,C("blue"),...E],g&&!l&&p.push(g),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,p)}e.log=I;function C(d){return`color: ${d}`}}),define(oe[64],ae([0,1,15,10]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function L(C){return JSON.stringify(C,O)}e.$ih=L;function A(C){let d=JSON.parse(C);return d=I(d),d}e.$jh=A;function O(C,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function I(C,d=0){if(!C||d>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return N.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 17:return new Date(C.source)}if(C instanceof D.$ae||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let P=0;P<C.length;++P)C[P]=I(C[P],d+1);else for(const P in C)Object.hasOwnProperty.call(C,P)&&(C[P]=I(C[P],d+1))}return C}e.$kh=I}),define(oe[23],ae([0,1,8,6,10]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.Schemas=void 0;var A;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.$6f="vscode-tkn",e.$7f="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${A.vscodeRemoteResource}`}set(P,E,b){this.a[P]=E,this.b[P]=b}setConnectionToken(P,E){this.c[P]=E}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(w){return D.$Z(w),P}const E=P.authority;let b=this.a[E];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const l=this.b[E],g=this.c[E];let p=`path=${encodeURIComponent(P.path)}`;return typeof g=="string"&&(p+=`&${e.$7f}=${encodeURIComponent(g)}`),L.URI.from({scheme:N.$p?this.d:A.vscodeRemoteResource,authority:`${b}:${l}`,path:this.f,query:p})}}e.$8f=new O,e.$9f="vs/../../extensions",e.$0f="vs/../../node_modules",e.$$f="vs/../../node_modules.asar",e.$_f="vs/../../node_modules.asar.unpacked",e.$ag="vscode-app";class I{static{this.a=e.$ag}asBrowserUri(P){const E=this.b(P,te);return this.uriToBrowserUri(E)}uriToBrowserUri(P){return P.scheme===A.vscodeRemote?e.$8f.rewrite(P):P.scheme===A.file&&(N.$n||N.$q&&N.$h.origin===`${A.vscodeFileResource}://${I.a}`)?P.with({scheme:A.vscodeFileResource,authority:P.authority||I.a,query:null,fragment:null}):P}asFileUri(P){const E=this.b(P,te);return this.uriToFileUri(E)}uriToFileUri(P){return P.scheme===A.vscodeFileResource?P.with({scheme:A.file,authority:P.authority!==I.a?P.authority:null,query:null,fragment:null}):P}b(P,E){return L.URI.isUri(P)?P:L.URI.parse(E.toUrl(P))}}e.$bg=new I;var C;(function(d){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(P.get("3"));const E="vscode-coi";function b(g){let p;typeof g=="string"?p=new URL(g).searchParams:g instanceof URL?p=g.searchParams:L.URI.isUri(g)&&(p=new URL(g.toString(!0)).searchParams);const w=p?.get(E);if(w)return P.get(w)}d.getHeadersFromQuery=b;function l(g,p,w){if(!globalThis.crossOriginIsolated)return;const f=p&&w?"3":w?"2":"1";g instanceof URLSearchParams?g.set(E,f):g[E]=f}d.addSearchParam=l})(C||(e.COI=C={}))}),define(oe[143],ae([0,1,124,23,6,10]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hC=void 0;class O{constructor(b,l,g){this.id=b,this.dependencies=l,this.callback=g}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,l,g)=>{typeof b!="string"&&(g=l,l=b,b=null),(typeof l!="object"||!Array.isArray(l))&&(g=l,l=null),this.c.push(new O(b,l,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const l=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!l)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(b){return new Promise((l,g)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const w=()=>{p.removeEventListener("load",f),p.removeEventListener("error",c)},f=h=>{w(),l(this.c.pop())},c=h=>{w(),g(h)};p.addEventListener("load",f),p.addEventListener("error",c),this.f&&(b=this.f.createScriptURL(b)),p.setAttribute("src",b),document.getElementsByTagName("head")[0].appendChild(p)})}i(b){return new Promise((l,g)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),l(this.c.pop())}catch(p){g(p)}})}async j(b){try{const l=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,w=A.URI.parse(b).fsPath,f=l.readFileSync(w).toString(),c=p.wrap(f.replace(/^#!.*/,""));return new g.Script(c).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const C=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function P(E,b,l){if(D.$S){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[E]&&(E=d[E]);const g=`${E}/${b}`;if(C.has(g))return C.get(g);let p;if(/^\w[\w\d+.-]*:\/\//.test(g))p=g;else{const h=`${l&&!L.$p?N.$$f:N.$0f}/${g}`;p=N.$bg.asBrowserUri(h).toString(!0)}const w=I.INSTANCE.load(p);return C.set(g,w),w}else return await new Promise((g,p)=>{te([E],g,p)})}e.$hC=P}),define(oe[19],ae([0,1,48,23,16,6,27,10]),function(te,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.DataUri=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function C(l){return(0,I.$vc)(l,!0)}e.$ig=C;class d{constructor(g){this.a=g}compare(g,p,w=!1){return g===p?0:(0,O.$Te)(this.getComparisonKey(g,w),this.getComparisonKey(p,w))}isEqual(g,p,w=!1){return g===p?!0:!g||!p?!1:this.getComparisonKey(g,w)===this.getComparisonKey(p,w)}getComparisonKey(g,p=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,p,w=!1){if(g.scheme===p.scheme){if(g.scheme===N.Schemas.file)return D.$Wf(C(g),C(p),this.a(g))&&g.query===p.query&&(w||g.fragment===p.fragment);if((0,e.$zg)(g.authority,p.authority))return D.$Wf(g.path,p.path,this.a(g),"/")&&g.query===p.query&&(w||g.fragment===p.fragment)}return!1}joinPath(g,...p){return I.URI.joinPath(g,...p)}basenameOrAuthority(g){return(0,e.$rg)(g)||g.authority}basename(g){return L.$fc.basename(g.path)}extname(g){return L.$fc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let p;return g.scheme===N.Schemas.file?p=I.URI.file(L.$lc(C(g))).path:(p=L.$fc.dirname(g.path),g.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),p="/")),g.with({path:p})}normalizePath(g){if(!g.path.length)return g;let p;return g.scheme===N.Schemas.file?p=I.URI.file(L.$gc(C(g))).path:p=L.$fc.normalize(g.path),g.with({path:p})}relativePath(g,p){if(g.scheme!==p.scheme||!(0,e.$zg)(g.authority,p.authority))return;if(g.scheme===N.Schemas.file){const c=L.$kc(C(g),C(p));return A.$j?D.$Qf(c):c}let w=g.path||"/";const f=p.path||"/";if(this.a(g)){let c=0;for(const h=Math.min(w.length,f.length);c<h&&!(w.charCodeAt(c)!==f.charCodeAt(c)&&w.charAt(c).toLowerCase()!==f.charAt(c).toLowerCase());c++);w=f.substr(0,c)+w.substr(c)}return L.$fc.relative(w,f)}resolvePath(g,p){if(g.scheme===N.Schemas.file){const w=I.URI.file(L.$jc(C(g),p));return g.with({authority:w.authority,path:w.path})}return p=D.$Rf(p),g.with({path:L.$fc.resolve(g.path,p)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,p){return g===p||g!==void 0&&p!==void 0&&(0,O.$1e)(g,p)}hasTrailingPathSeparator(g,p=L.sep){if(g.scheme===N.Schemas.file){const w=C(g);return w.length>D.$Sf(w).length&&w[w.length-1]===p}else{const w=g.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,p=L.sep){return(0,e.$Ag)(g,p)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,p=L.sep){let w=!1;if(g.scheme===N.Schemas.file){const f=C(g);w=f!==void 0&&f.length===D.$Sf(f).length&&f[f.length-1]===p}else{p="/";const f=g.path;w=f.length===1&&f.charCodeAt(f.length-1)===47}return!w&&!(0,e.$Ag)(g,p)?g.with({path:g.path+"/"}):g}}e.$jg=d,e.$kg=new d(()=>!1),e.$lg=new d(l=>l.scheme===N.Schemas.file?!A.$l:!0),e.$mg=new d(l=>!0),e.$ng=e.$kg.isEqual.bind(e.$kg),e.$og=e.$kg.isEqualOrParent.bind(e.$kg),e.$pg=e.$kg.getComparisonKey.bind(e.$kg),e.$qg=e.$kg.basenameOrAuthority.bind(e.$kg),e.$rg=e.$kg.basename.bind(e.$kg),e.$sg=e.$kg.extname.bind(e.$kg),e.$tg=e.$kg.dirname.bind(e.$kg),e.$ug=e.$kg.joinPath.bind(e.$kg),e.$vg=e.$kg.normalizePath.bind(e.$kg),e.$wg=e.$kg.relativePath.bind(e.$kg),e.$xg=e.$kg.resolvePath.bind(e.$kg),e.$yg=e.$kg.isAbsolutePath.bind(e.$kg),e.$zg=e.$kg.isEqualAuthority.bind(e.$kg),e.$Ag=e.$kg.hasTrailingPathSeparator.bind(e.$kg),e.$Bg=e.$kg.removeTrailingPathSeparator.bind(e.$kg),e.$Cg=e.$kg.addTrailingPathSeparator.bind(e.$kg);function P(l,g){const p=[];for(let w=0;w<l.length;w++){const f=g(l[w]);l.some((c,h)=>h===w?!1:(0,e.$og)(f,g(c)))||p.push(l[w])}return p}e.$Dg=P;var E;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function g(p){const w=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(h=>{const[m,S]=h.split(":");m&&S&&w.set(m,S)});const c=p.path.substring(0,p.path.indexOf(";"));return c&&w.set(l.META_DATA_MIME,c),w}l.parseMetaData=g})(E||(e.DataUri=E={}));function b(l,g,p){if(g){let w=l.path;return w&&w[0]!==L.$fc.sep&&(w=L.$fc.sep+w),l.with({scheme:p,authority:g,path:w})}return l.with({scheme:p})}e.$Eg=b}),define(oe[5],ae([0,1,26,8,3,2,19,6,130]),function(te,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eh=e.$dh=e.$ch=e.Promises=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function d(k){return!!k&&typeof k.then=="function"}e.$Fg=d;function P(k){const R=new D.$Wd,z=k(R.token),F=new Promise((G,Z)=>{const re=R.token.onCancellationRequested(()=>{re.dispose(),R.dispose(),Z(new N.$4)});Promise.resolve(z).then(le=>{re.dispose(),R.dispose(),G(le)},le=>{re.dispose(),R.dispose(),Z(le)})});return new class{cancel(){R.cancel()}then(G,Z){return F.then(G,Z)}catch(G){return this.then(void 0,G)}finally(G){return F.finally(G)}}}e.$Gg=P;function E(k,R,z){return new Promise((F,G)=>{const Z=R.onCancellationRequested(()=>{Z.dispose(),F(z)});k.then(F,G).finally(()=>Z.dispose())})}e.$Hg=E;function b(k,R){return new Promise((z,F)=>{const G=R.onCancellationRequested(()=>{G.dispose(),F(new N.$4)});k.then(z,F).finally(()=>G.dispose())})}e.$Ig=b;async function l(k){let R=-1;const z=k.map((F,G)=>F.then(Z=>(R=G,Z)));try{return await Promise.race(z)}finally{k.forEach((F,G)=>{G!==R&&F.cancel()})}}e.$Jg=l;function g(k,R,z){let F;const G=setTimeout(()=>{F?.(void 0),z?.()},R);return Promise.race([k.finally(()=>clearTimeout(G)),new Promise(Z=>F=Z)])}e.$Kg=g;function p(k){return new Promise((R,z)=>{const F=k();d(F)?F.then(R,z):R(F)})}e.$Lg=p;class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(R){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=R,!this.b){const z=()=>{if(this.b=null,this.f)return;const F=this.queue(this.d);return this.d=null,F};this.b=new Promise(F=>{this.a.then(z,z).then(F)})}return new Promise((z,F)=>{this.b.then(z,F)})}return this.a=R(),new Promise((z,F)=>{this.a.then(G=>{this.a=null,z(G)},G=>{this.a=null,F(G)})})}dispose(){this.f=!0}}e.$Mg=w;class f{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.$Ng=f;class c{constructor(){this.a=new Map}queue(R,z){const G=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.a.get(R)===G&&this.a.delete(R)});return this.a.set(R,G),G}}e.$Og=c;const h=(k,R)=>{let z=!0;const F=setTimeout(()=>{z=!1,R()},k);return{isTriggered:()=>z,dispose:()=>{clearTimeout(F),z=!1}}},m=k=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,k())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class S{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,z=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((G,Z)=>{this.d=G,this.f=Z}).then(()=>{if(this.b=null,this.d=null,this.g){const G=this.g;return this.g=null,G()}}));const F=()=>{this.a=null,this.d?.(null)};return this.a=z===C.$Jd?m(F):h(z,F),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Pg=S;class s{constructor(R){this.a=new S(R),this.b=new w}trigger(R,z){return this.a.trigger(()=>this.b.queue(R),z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Qg=s;class a{constructor(){this.a=!1,this.b=new Promise((R,z)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Rg=a;class n extends a{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.$Sg=n;function i(k,R){return R?new Promise((z,F)=>{const G=setTimeout(()=>{Z.dispose(),z()},k),Z=R.onCancellationRequested(()=>{clearTimeout(G),Z.dispose(),F(new N.$4)})}):P(z=>i(k,z))}e.$Tg=i;function t(k,R=0,z){const F=setTimeout(()=>{k(),z&&G.dispose()},R),G=(0,A.$Pc)(()=>{clearTimeout(F),z?.deleteAndLeak(G)});return z?.add(G),G}e.$Ug=t;function r(k){const R=[];let z=0;const F=k.length;function G(){return z<F?k[z++]():null}function Z(re){re!=null&&R.push(re);const le=G();return le?le.then(Z):Promise.resolve(R)}return Promise.resolve(null).then(Z)}e.$Vg=r;function o(k,R=F=>!!F,z=null){let F=0;const G=k.length,Z=()=>{if(F>=G)return Promise.resolve(z);const re=k[F++];return Promise.resolve(re()).then(ue=>R(ue)?Promise.resolve(ue):Z())};return Z()}e.$Wg=o;function v(k,R=F=>!!F,z=null){if(k.length===0)return Promise.resolve(z);let F=k.length;const G=()=>{F=-1;for(const Z of k)Z.cancel?.()};return new Promise((Z,re)=>{for(const le of k)le.then(ue=>{--F>=0&&R(ue)?(G(),Z(ue)):F===0&&Z(z)}).catch(ue=>{--F>=0&&(G(),re(ue))})})}e.$Xg=v;class y{constructor(R){this.a=0,this.d=R,this.f=[],this.b=0,this.g=new L.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(R){return this.a++,new Promise((z,F)=>{this.f.push({factory:R,c:z,e:F}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const R=this.f.shift();this.b++;const z=R.factory();z.then(R.c,R.e),z.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Yg=y;class u extends y{constructor(){super(1)}}e.$Zg=u;class ${constructor(){this.a=new Q,this.b=0}queue(R){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,R())):this.a.run(this.b++,R())}}e.$1g=$;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const R=new ee;return this.b.add(R),R.p}g(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueFor(R,z=O.$kg){const F=z.getComparisonKey(R);let G=this.a.get(F);if(!G){G=new u;const Z=this.f++,re=L.Event.once(G.onDrained)(()=>{G?.dispose(),this.a.delete(F),this.h(),this.d?.deleteAndDispose(Z),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$Zc),this.d.set(Z,re),this.a.set(F,G)}return G}h(){this.g()&&this.j()}j(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$2g=j;class M{constructor(R,z){this.a=-1,typeof R=="function"&&typeof z=="number"&&this.setIfNotSet(R,z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},z)}setIfNotSet(R,z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},z))}}e.$3g=M;class T{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(R,z){this.cancel(),this.a=setInterval(()=>{R()},z)}}e.$4g=T;class U{constructor(R,z){this.b=-1,this.a=R,this.d=z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$5g=U;class q{constructor(R,z){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.a=R,this.b=z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$6g=q;class Y extends U{constructor(R,z){super(R,z),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.$7g=Y;class J extends A.$Rc{constructor(R,z){super(),this.g=R,this.h=z,this.a=[],this.b=this.B(new A.$Sc),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const z of R)this.a.push(z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$8g=J,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$9g=k=>{(0,I.$B)(()=>{if(R)return;const z=Date.now()+15;k(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,z-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.$9g=(k,R)=>{const z=requestIdleCallback(k,typeof R=="number"?{timeout:R}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(z))}}}}();class x{constructor(R){this.d=!1,this.a=()=>{try{this.f=R()}catch(z){this.g=z}finally{this.d=!0}},this.b=(0,e.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$0g=x;async function W(k,R,z){let F;for(let G=0;G<z;G++)try{return await k()}catch(Z){F=Z,await i(R)}throw F}e.$$g=W;class Q{isRunning(R){return typeof R=="number"?this.a?.taskId===R:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(R,z,F){return this.a={taskId:R,cancel:()=>F?.(),promise:z},z.then(()=>this.d(R),()=>this.d(R)),z}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}queue(R){if(this.b)this.b.run=R;else{let z,F;const G=new Promise((Z,re)=>{z=Z,F=re});this.b={run:R,promise:G,promiseResolve:z,promiseReject:F}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$_g=Q;class H{constructor(R,z=()=>Date.now()){this.d=R,this.f=z,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.$ah=H;var V;(function(k){k[k.Resolved=0]="Resolved",k[k.Rejected=1]="Rejected"})(V||(V={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((R,z)=>{this.a=R,this.b=z})}complete(R){return new Promise(z=>{this.a(R),this.d={outcome:0,value:R},z()})}error(R){return new Promise(z=>{this.b(R),this.d={outcome:1,value:R},z()})}cancel(){return this.error(new N.$4)}}e.$bh=ee;var ne;(function(k){async function R(F){let G;const Z=await Promise.all(F.map(re=>re.then(le=>le,le=>{G||(G=le)})));if(typeof G<"u")throw G;return Z}k.settled=R;function z(F){return new Promise(async(G,Z)=>{try{await F(G,Z)}catch(re){Z(re)}})}k.withAsyncBody=z})(ne||(e.Promises=ne={}));var _;(function(k){k[k.Initial=0]="Initial",k[k.DoneOK=1]="DoneOK",k[k.DoneError=2]="DoneError"})(_||(_={}));class ie{static fromArray(R){return new ie(z=>{z.emitMany(R)})}static fromPromise(R){return new ie(async z=>{z.emitMany(await R)})}static fromPromises(R){return new ie(async z=>{await Promise.all(R.map(async F=>z.emitOne(await F)))})}static merge(R){return new ie(async z=>{await Promise.all(R.map(async F=>{for await(const G of F)z.emitOne(G)}))})}static{this.EMPTY=ie.fromArray([])}constructor(R){this.a=0,this.b=[],this.d=null,this.f=new L.$Md,queueMicrotask(async()=>{const z={emitOne:F=>this.g(F),emitMany:F=>this.h(F),reject:F=>this.k(F)};try{await Promise.resolve(R(z)),this.j()}catch(F){this.k(F)}finally{z.emitOne=void 0,z.emitMany=void 0,z.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(R,z){return new ie(async F=>{for await(const G of R)F.emitOne(z(G))})}map(R){return ie.map(this,R)}static filter(R,z){return new ie(async F=>{for await(const G of R)z(G)&&F.emitOne(G)})}filter(R){return ie.filter(this,R)}static coalesce(R){return ie.filter(R,z=>!!z)}coalesce(){return ie.coalesce(this)}static async toPromise(R){const z=[];for await(const F of R)z.push(F);return z}toPromise(){return ie.toPromise(this)}g(R){this.a===0&&(this.b.push(R),this.f.fire())}h(R){this.a===0&&(this.b=this.b.concat(R),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(R){this.a===0&&(this.a=2,this.d=R,this.f.fire())}}e.$ch=ie;class K extends ie{constructor(R,z){super(z),this.l=R}cancel(){this.l.cancel()}}e.$dh=K;function B(k){const R=new D.$Wd,z=k(R.token);return new K(R,async F=>{const G=R.token.onCancellationRequested(()=>{G.dispose(),R.dispose(),F.reject(new N.$4)});try{for await(const Z of z){if(R.token.isCancellationRequested)return;F.emitOne(Z)}G.dispose(),R.dispose()}catch(Z){G.dispose(),R.dispose(),F.reject(Z)}})}e.$eh=B}),define(oe[91],ae([0,1,18,5,48,34,16,6,27]),function(te,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0;function d(){return Object.create(null)}e.$pj=d,e.$qj="**",e.$rj="/";const P="[/\\\\]",E="[^/\\\\]",b=/\//g;function l(Q,H){switch(Q){case 0:return"";case 1:return`${E}*?`;default:return`(?:${P}|${E}+${P}${H?`|${P}${E}+`:""})*?`}}function g(Q,H){if(!Q)return[];const V=[];let ee=!1,ne=!1,_="";for(const ie of Q){switch(ie){case H:if(!ee&&!ne){V.push(_),_="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}_+=ie}return _&&V.push(_),V}e.$sj=g;function p(Q){if(!Q)return"";let H="";const V=g(Q,e.$rj);if(V.every(ee=>ee===e.$qj))H=".*";else{let ee=!1;V.forEach((ne,_)=>{if(ne===e.$qj){if(ee)return;H+=l(2,_===V.length-1)}else{let ie=!1,K="",B=!1,k="";for(const R of ne){if(R!=="}"&&ie){K+=R;continue}if(B&&(R!=="]"||!k)){let z;R==="-"?z=R:(R==="^"||R==="!")&&!k?z="^":R===e.$rj?z="":z=(0,C.$Ee)(R),k+=z;continue}switch(R){case"{":ie=!0;continue;case"[":B=!0;continue;case"}":{const F=`(?:${g(K,",").map(G=>p(G)).join("|")})`;H+=F,ie=!1,K="";break}case"]":{H+="["+k+"]",B=!1,k="";break}case"?":H+=E;continue;case"*":H+=l(1);continue;default:H+=(0,C.$Ee)(R)}}_<V.length-1&&(V[_+1]!==e.$qj||_+2<V.length)&&(H+=P)}ee=ne===e.$qj})}return H}const w=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new A.$Cc(1e4),a=function(){return!1},n=function(){return null};function i(Q,H){if(!Q)return n;let V;typeof Q!="string"?V=Q.pattern:V=Q,V=V.trim();const ee=`${V}_${!!H.trimForExclusions}`;let ne=s.get(ee);if(ne)return t(ne,Q);let _;return w.test(V)?ne=o(V.substr(4),V):(_=f.exec(r(V,H)))?ne=v(_[1],V):(H.trimForExclusions?h:c).test(V)?ne=y(V,H):(_=m.exec(r(V,H)))?ne=u(_[1].substr(1),V,!0):(_=S.exec(r(V,H)))?ne=u(_[1],V,!1):ne=$(V),s.set(ee,ne),t(ne,Q)}function t(Q,H){if(typeof H=="string")return Q;const V=function(ee,ne){return(0,L.$Wf)(ee,H.base,!I.$l)?Q((0,C.$Ie)(ee.substr(H.base.length),O.sep),ne):null};return V.allBasenames=Q.allBasenames,V.allPaths=Q.allPaths,V.basenames=Q.basenames,V.patterns=Q.patterns,V}function r(Q,H){return H.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function o(Q,H){return function(V,ee){return typeof V=="string"&&V.endsWith(Q)?H:null}}function v(Q,H){const V=`/${Q}`,ee=`\\${Q}`,ne=function(ie,K){return typeof ie!="string"?null:K?K===Q?H:null:ie===Q||ie.endsWith(V)||ie.endsWith(ee)?H:null},_=[Q];return ne.basenames=_,ne.patterns=[H],ne.allBasenames=_,ne}function y(Q,H){const V=x(Q.slice(1,-1).split(",").map(K=>i(K,H)).filter(K=>K!==n),Q),ee=V.length;if(!ee)return n;if(ee===1)return V[0];const ne=function(K,B){for(let k=0,R=V.length;k<R;k++)if(V[k](K,B))return Q;return null},_=V.find(K=>!!K.allBasenames);_&&(ne.allBasenames=_.allBasenames);const ie=V.reduce((K,B)=>B.allPaths?K.concat(B.allPaths):K,[]);return ie.length&&(ne.allPaths=ie),ne}function u(Q,H,V){const ee=O.sep===O.$fc.sep,ne=ee?Q:Q.replace(b,O.sep),_=O.sep+ne,ie=O.$fc.sep+Q;let K;return V?K=function(B,k){return typeof B=="string"&&(B===ne||B.endsWith(_)||!ee&&(B===Q||B.endsWith(ie)))?H:null}:K=function(B,k){return typeof B=="string"&&(B===ne||!ee&&B===Q)?H:null},K.allPaths=[(V?"*/":"./")+Q],K}function $(Q){try{const H=new RegExp(`^${p(Q)}$`);return function(V){return H.lastIndex=0,typeof V=="string"&&H.test(V)?Q:null}}catch{return n}}function j(Q,H,V){return!Q||typeof H!="string"?!1:M(Q)(H,void 0,V)}e.$tj=j;function M(Q,H={}){if(!Q)return a;if(typeof Q=="string"||T(Q)){const V=i(Q,H);if(V===n)return a;const ee=function(ne,_){return!!V(ne,_)};return V.allBasenames&&(ee.allBasenames=V.allBasenames),V.allPaths&&(ee.allPaths=V.allPaths),ee}return Y(Q,H)}e.$uj=M;function T(Q){const H=Q;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$vj=T;function U(Q){return Q.allBasenames||[]}e.$wj=U;function q(Q){return Q.allPaths||[]}e.$xj=q;function Y(Q,H){const V=x(Object.getOwnPropertyNames(Q).map(K=>J(K,Q[K],H)).filter(K=>K!==n)),ee=V.length;if(!ee)return n;if(!V.some(K=>!!K.requiresSiblings)){if(ee===1)return V[0];const K=function(R,z){let F;for(let G=0,Z=V.length;G<Z;G++){const re=V[G](R,z);if(typeof re=="string")return re;(0,N.$Fg)(re)&&(F||(F=[]),F.push(re))}return F?(async()=>{for(const G of F){const Z=await G;if(typeof Z=="string")return Z}return null})():null},B=V.find(R=>!!R.allBasenames);B&&(K.allBasenames=B.allBasenames);const k=V.reduce((R,z)=>z.allPaths?R.concat(z.allPaths):R,[]);return k.length&&(K.allPaths=k),K}const ne=function(K,B,k){let R,z;for(let F=0,G=V.length;F<G;F++){const Z=V[F];Z.requiresSiblings&&k&&(B||(B=(0,O.$mc)(K)),R||(R=B.substr(0,B.length-(0,O.$nc)(K).length)));const re=Z(K,B,R,k);if(typeof re=="string")return re;(0,N.$Fg)(re)&&(z||(z=[]),z.push(re))}return z?(async()=>{for(const F of z){const G=await F;if(typeof G=="string")return G}return null})():null},_=V.find(K=>!!K.allBasenames);_&&(ne.allBasenames=_.allBasenames);const ie=V.reduce((K,B)=>B.allPaths?K.concat(B.allPaths):K,[]);return ie.length&&(ne.allPaths=ie),ne}function J(Q,H,V){if(H===!1)return n;const ee=i(Q,V);if(ee===n)return n;if(typeof H=="boolean")return ee;if(H){const ne=H.when;if(typeof ne=="string"){const _=(ie,K,B,k)=>{if(!k||!ee(ie,K))return null;const R=ne.replace("$(basename)",()=>B),z=k(R);return(0,N.$Fg)(z)?z.then(F=>F?Q:null):z?Q:null};return _.requiresSiblings=!0,_}}return ee}function x(Q,H){const V=Q.filter(K=>!!K.basenames);if(V.length<2)return Q;const ee=V.reduce((K,B)=>{const k=B.basenames;return k?K.concat(k):K},[]);let ne;if(H){ne=[];for(let K=0,B=ee.length;K<B;K++)ne.push(H)}else ne=V.reduce((K,B)=>{const k=B.patterns;return k?K.concat(k):K},[]);const _=function(K,B){if(typeof K!="string")return null;if(!B){let R;for(R=K.length;R>0;R--){const z=K.charCodeAt(R-1);if(z===47||z===92)break}B=K.substr(R)}const k=ee.indexOf(B);return k!==-1?ne[k]:null};_.basenames=ee,_.patterns=ne,_.allBasenames=ee;const ie=Q.filter(K=>!K.basenames);return ie.push(_),ie}function W(Q,H){return(0,D.$tb)(Q,H,(V,ee)=>typeof V=="string"&&typeof ee=="string"?V===ee:typeof V!="string"&&typeof ee!="string"?V.base===ee.base&&V.pattern===ee.pattern:!1)}e.$yj=W}),define(oe[92],ae([0,1,15,10]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=void 0;function L(E){return E.toJSON()}class A{constructor(b){this.a=b}transformIncoming(b){const l=this.a.transformIncoming(b);return l===b?b:L(N.URI.from(l))}transformOutgoing(b){const l=this.a.transformOutgoing(b);return l===b?b:L(N.URI.from(l))}transformOutgoingURI(b){const l=this.a.transformOutgoing(b);return l===b?b:N.URI.from(l)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$Im=A,e.$Jm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function O(E,b,l){if(!E||l>200)return null;if(typeof E=="object"){if(E instanceof N.URI)return b.transformOutgoing(E);for(const g in E)if(Object.hasOwnProperty.call(E,g)){const p=O(E[g],b,l+1);p!==null&&(E[g]=p)}}return null}function I(E,b){const l=O(E,b,0);return l===null?E:l}e.$Km=I;function C(E,b,l,g){if(!E||g>200)return null;if(typeof E=="object"){if(E.$mid===1)return l?N.URI.revive(b.transformIncoming(E)):b.transformIncoming(E);if(E instanceof D.$ae)return null;for(const p in E)if(Object.hasOwnProperty.call(E,p)){const w=C(E[p],b,l,g+1);w!==null&&(E[p]=w)}}return null}function d(E,b){const l=C(E,b,!1,0);return l===null?E:l}e.$Lm=d;function P(E,b){const l=C(E,b,!0,0);return l===null?E:l}e.$Mm=P}),define(oe[31],ae([0,1,53,36,269,5,48,88,16,6,19,10]),function(te,e,D,N,L,A,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function l(J,x=b.UNLINK,W){if((0,O.$Zf)(J))throw new Error("rimraf - will refuse to recursively delete root");return x===b.UNLINK?p(J):g(J,W)}async function g(J,x=(0,O.$5f)((0,N.tmpdir)())){try{try{await D.promises.rename(J,x)}catch(W){return W.code==="ENOENT"?void 0:p(J)}p(x).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function p(J){return(0,L.promisify)(D.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function w(J){if((0,O.$Zf)(J))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function f(J,x){return m(await(x?c(J):(0,L.promisify)(D.readdir)(J)))}async function c(J){try{return await(0,L.promisify)(D.readdir)(J,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const x=[],W=await f(J);for(const Q of W){let H=!1,V=!1,ee=!1;try{const ne=await e.Promises.lstat((0,C.$ic)(J,Q));H=ne.isFile(),V=ne.isDirectory(),ee=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:Q,isFile:()=>H,isDirectory:()=>V,isSymbolicLink:()=>ee})}return x}function h(J){return m(D.readdirSync(J))}e.readdirSync=h;function m(J){return J.map(x=>typeof x=="string"?d.$k?(0,I.$ll)(x):x:(x.name=d.$k?(0,I.$ll)(x.name):x.name,x))}async function S(J){const x=await f(J),W=[];for(const Q of x)await a.existsDirectory((0,C.$ic)(J,Q))&&W.push(Q);return W}function s(J,x=1e3){return new Promise(W=>{let Q=!1;const H=setInterval(()=>{Q||(Q=!0,D.access(J,V=>{Q=!1,V&&(clearInterval(H),W(void 0))}))},x)})}e.whenDeleted=s;var a;(function(J){async function x(H){let V;try{if(V=await e.Promises.lstat(H),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(d.$j&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw ne}throw ee}}J.stat=x;async function W(H){try{const{stat:V,symbolicLink:ee}=await J.stat(H);return V.isFile()&&ee?.dangling!==!0}catch{}return!1}J.existsFile=W;async function Q(H){try{const{stat:V,symbolicLink:ee}=await J.stat(H);return V.isDirectory()&&ee?.dangling!==!0}catch{}return!1}J.existsDirectory=Q})(a||(e.SymlinkSupport=a={}));const n=new A.$2g;function i(J,x,W){return n.queueFor(E.URI.file(J),P.$lg).queue(()=>{const Q=y(W);return new Promise((H,V)=>o(J,x,Q,ee=>ee?V(ee):H()))})}let t=!0;function r(J){t=J}e.configureFlushOnWrite=r;function o(J,x,W,Q){if(!t)return D.writeFile(J,x,{mode:W.mode,flag:W.flag},Q);D.open(J,W.flag,W.mode,(H,V)=>{if(H)return Q(H);D.writeFile(V,x,ee=>{if(ee)return D.close(V,()=>Q(ee));D.fdatasync(V,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),D.close(V,_=>Q(_))))})})}function v(J,x,W){const Q=y(W);if(!t)return D.writeFileSync(J,x,{mode:Q.mode,flag:Q.flag});const H=D.openSync(J,Q.flag,Q.mode);try{D.writeFileSync(H,x);try{D.fdatasyncSync(H)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{D.closeSync(H)}}e.writeFileSync=v;function y(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function u(J,x,W=6e4){if(J!==x)try{d.$j&&typeof W=="number"?await $(J,x,Date.now(),W):await(0,L.promisify)(D.rename)(J,x)}catch(Q){if(J.toLowerCase()!==x.toLowerCase()&&Q.code==="EXDEV"||J.endsWith("."))await j(J,x,{preserveSymlinks:!1}),await l(J,b.MOVE);else throw Q}}async function $(J,x,W,Q,H=0){try{return await(0,L.promisify)(D.rename)(J,x)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-W>=Q)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${V}`),V;if(H===0){let ee=!1;try{const{stat:ne}=await a.stat(x);ne.isFile()||(ee=!0)}catch{}if(ee)throw V}return await(0,A.$Tg)(Math.min(100,H*10)),$(J,x,W,Q,H+1)}}async function j(J,x,W){return T(J,x,{root:{source:J,target:x},options:W,handledSourcePaths:new Set})}const M=511;async function T(J,x,W){if(W.handledSourcePaths.has(J))return;W.handledSourcePaths.add(J);const{stat:Q,symbolicLink:H}=await a.stat(J);if(H){if(W.options.preserveSymlinks)try{return await Y(J,x,W)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(H.dangling)return}return Q.isDirectory()?U(J,x,Q.mode&M,W):q(J,x,Q.mode&M)}async function U(J,x,W,Q){await e.Promises.mkdir(x,{recursive:!0,mode:W});const H=await f(J);for(const V of H)await T((0,C.$ic)(J,V),(0,C.$ic)(x,V),Q)}async function q(J,x,W){await e.Promises.copyFile(J,x),await e.Promises.chmod(x,W)}async function Y(J,x,W){let Q=await e.Promises.readlink(J);(0,O.$Wf)(Q,W.root.source,!d.$l)&&(Q=(0,C.$ic)(W.root.target,Q.substr(W.root.source.length+1))),await e.Promises.symlink(Q,x)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return(J,x,W,Q,H)=>new Promise((V,ee)=>{D.read(J,x,W,Q,H,(ne,_,ie)=>ne?ee(ne):V({bytesRead:_,buffer:ie}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return(J,x,W,Q,H)=>new Promise((V,ee)=>{D.write(J,x,W,Q,H,(ne,_,ie)=>ne?ee(ne):V({bytesWritten:_,buffer:ie}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return S}get writeFile(){return i}get rm(){return l}get rename(){return u}get copy(){return j}}}),define(oe[144],ae([0,1,53,16,6,27,31]),function(te,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=e.$3p=e.$2p=void 0;function I(b){if(L.$l)return b;const l=(0,N.$lc)(b);if(b===l)return b;const g=((0,N.$mc)(b)||b).toLowerCase();try{const w=(0,O.readdirSync)(l).filter(f=>f.toLowerCase()===g);if(w.length===1){const f=I(l);if(f)return(0,N.$ic)(f,w[0])}else if(w.length>1){const f=w.indexOf(g);if(f>=0){const c=I(l);if(c)return(0,N.$ic)(c,w[f])}}}catch{}return null}e.$2p=I;async function C(b){if(L.$l)return b;const l=(0,N.$lc)(b);if(b===l)return b;const g=((0,N.$mc)(b)||b).toLowerCase();try{const w=(await O.Promises.readdir(l)).filter(f=>f.toLowerCase()===g);if(w.length===1){const f=await C(l);if(f)return(0,N.$ic)(f,w[0])}else if(w.length>1){const f=w.indexOf(g);if(f>=0){const c=await C(l);if(c)return(0,N.$ic)(c,w[f])}}}catch{}return null}e.$3p=C;async function d(b){try{return await O.Promises.realpath(b)}catch{const g=E(b);return await O.Promises.access(g,D.constants.R_OK),g}}e.$4p=d;function P(b){try{return D.realpathSync(b)}catch{const g=E(b);return D.accessSync(g,D.constants.R_OK),g}}e.$5p=P;function E(b){return(0,A.$Je)((0,N.$gc)(b),N.sep)}}),define(oe[145],ae([0,1,16,6,37,90,12,31]),function(te,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$zl=e.$yl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function C(E=L.env){return E.comspec||"cmd.exe"}e.$yl=C;function d(E){let b=[],l=!1;const g=function(p){if(l){b.push(p);return}(!E.send(p,f=>{if(f&&console.error(f),l=!1,b.length>0){const c=b.slice(0);b=[],c.forEach(h=>g(h))}})||N.$j)&&(l=!0)};return{send:g}}e.$zl=d;var P;(function(E){async function b(l,g,p){if(D.$hc(l))return l;if(g===void 0&&(g=L.cwd()),D.$lc(l)!=="."||(p===void 0&&O.$xf(L.env.PATH)&&(p=L.env.PATH.split(D.$sc)),p===void 0||p.length===0))return D.$ic(g,l);async function f(c){if(await I.Promises.exists(c)){let h;try{h=await I.Promises.stat(c)}catch(m){m.message.startsWith("EACCES")&&(h=await I.Promises.lstat(c))}return h?!h.isDirectory():!1}return!1}for(const c of p){let h;if(D.$hc(c)?h=D.$ic(c,l):h=D.$ic(g,c,l),await f(h))return h;let m=h+".com";if(await f(m)||(m=h+".exe",await f(m)))return m}return D.$ic(g,l)}E.findExecutable=b})(P||(e.win32=P={}))}),define(oe[146],ae([0,1,65,23]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;function L(O){return new Promise((I,C)=>{let d;const P=new Map;function E(l,g,p,w,f){const c=P.get(g);if(l===O||c){const h={name:b(p),cmd:p,pid:l,ppid:g,load:w,mem:f};P.set(l,h),l===O&&(d=h),c&&(c.children||(c.children=[]),c.children.push(h),c.children.length>1&&(c.children=c.children.sort((m,S)=>m.pid-S.pid)))}}function b(l){const g=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,w=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,c=/conhost\.exe.+--headless/i,h=/--type=([a-zA-Z-]+)/;if(w.exec(l))return"electron-crash-reporter";if(f.exec(l))return"winpty-agent";if(c.exec(l))return"conpty-agent";let m=h.exec(l);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?g.exec(l)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const S=/[a-zA-Z-]+\.js/g;let s="";do m=S.exec(l),m&&(s+=m+" ");while(m);return s&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${s})`:p.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,p)=>{te(["@vscode/windows-process-tree"],g,p)}).then(g=>{g.getProcessList(O,p=>{if(!p){C(new Error(`Root process ${O} not found`));return}g.getProcessCpuUsage(p,w=>{const f=new Map;w.forEach(c=>{const h=l(c.commandLine||"");f.set(c.pid,{name:b(h),cmd:h,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),d=f.get(O),d?(f.forEach(c=>{const h=f.get(c.ppid);h&&(h.children||(h.children=[]),h.children.push(c))}),f.forEach(c=>{c.children&&(c.children=c.children.sort((h,m)=>h.pid-m.pid))}),I(d)):C(new Error(`Root process ${O} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let l=function(){let g=[d];const p=[];for(;g.length;){const f=g.shift();f&&(p.push(f.pid),f.children&&(g=g.concat(f.children)))}let w=JSON.stringify(N.$bg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+p.join(" "),(0,D.exec)(w,{},(f,c,h)=>{if(f||h)C(f||new Error(h.toString()));else{const m=c.toString().split(`
`);for(let S=0;S<p.length;S++){const s=P.get(p[S]);s.load=parseFloat(m[S])}if(!d){C(new Error(`Root process ${O} not found`));return}I(d)}})};(0,D.exec)("which ps",{},(g,p,w)=>{if(g||w)if(process.platform!=="linux")C(g||new Error(w.toString()));else{const f=JSON.stringify(N.$bg.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(f,{},(c,h,m)=>{c||m?C(c||new Error(m.toString())):(A(h,E),l())})}else{const f=p.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${f} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,m,S)=>{h||S&&!S.includes("screen size is bogus")?C(h||new Error(S.toString())):(A(m,E),process.platform==="linux"?l():d?I(d):C(new Error(`Root process ${O} not found`)))})}})}})}e.$zr=L;function A(O,I){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=O.toString().split(`
`);for(const P of d){const E=C.exec(P.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var ye=this&&this.__decorate||function(te,e,D,N){var L=arguments.length,A=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,D,N);else for(var I=te.length-1;I>=0;I--)(O=te[I])&&(A=(L<3?O(A):L>3?O(e,D,A):O(e,D))||A);return L>3&&A&&Object.defineProperty(e,D,A),A};define(oe[42],ae([0,1,18,5,15,26,84,8,3,2,64,27,12]),function(te,e,D,N,L,A,O,I,C,d,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.ProxyChannel=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.RequestInitiator=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0;var l;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(l||(l={}));function g(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(p||(p={}));function w(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(f||(f={}));function c(H){let V=0;for(let ee=0;;ee+=7){const ne=H.read(1);if(V|=(ne.buffer[0]&127)<<ee,!(ne.buffer[0]&128))return V}}const h=n(0);function m(H,V){if(V===0){H.write(h);return}let ee=0;for(let _=V;_!==0;_=_>>>7)ee++;const ne=L.$ae.alloc(ee);for(let _=0;V!==0;_++)ne.buffer[_]=V&127,V=V>>>7,V>0&&(ne.buffer[_]|=128);H.write(ne)}class S{constructor(V){this.b=V,this.a=0}read(V){const ee=this.b.slice(this.a,this.a+V);return this.a+=ee.byteLength,ee}}e.$lh=S;class s{constructor(){this.a=[]}get buffer(){return L.$ae.concat(this.a)}write(V){this.a.push(V)}}e.$mh=s;var a;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(a||(a={}));function n(H){const V=L.$ae.alloc(1);return V.writeUInt8(H,0),V}const i={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},t=typeof Buffer<"u";function r(H,V){if(typeof V>"u")H.write(i.Undefined);else if(typeof V=="string"){const ee=L.$ae.fromString(V);H.write(i.String),m(H,ee.byteLength),H.write(ee)}else if(t&&Buffer.isBuffer(V)){const ee=L.$ae.wrap(V);H.write(i.Buffer),m(H,ee.byteLength),H.write(ee)}else if(V instanceof L.$ae)H.write(i.VSBuffer),m(H,V.byteLength),H.write(V);else if(Array.isArray(V)){H.write(i.Array),m(H,V.length);for(const ee of V)r(H,ee)}else if(typeof V=="number"&&(V|0)===V)H.write(i.Uint),m(H,V);else{const ee=L.$ae.fromString(JSON.stringify(V));H.write(i.Object),m(H,ee.byteLength),H.write(ee)}}e.$nh=r;function o(H){switch(H.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return H.read(c(H)).toString();case a.Buffer:return H.read(c(H)).buffer;case a.VSBuffer:return H.read(c(H));case a.Array:{const ee=c(H),ne=[];for(let _=0;_<ee;_++)ne.push(o(H));return ne}case a.Object:return JSON.parse(H.read(c(H)).toString());case a.Int:return c(H)}}e.$oh=o;class v{constructor(V,ee,ne=null,_=1e3){this.h=V,this.j=ee,this.k=ne,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ie=>this.q(ie)),this.m({type:200})}registerChannel(V,ee){this.b.set(V,ee),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const ee=this.o([V.type]);this.k?.logOutgoing(ee,0,1,w(V.type));return}case 201:case 202:case 204:case 203:{const ee=this.o([V.type,V.id],V.data);this.k?.logOutgoing(ee,V.id,1,w(V.type),V.data);return}}}o(V,ee=void 0){const ne=new s;return r(ne,V),r(ne,ee),this.p(ne.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const ee=new S(V),ne=o(ee),_=o(ee),ie=ne[0];switch(ie){case 100:return this.k?.logIncoming(V.byteLength,ne[1],1,`${g(ie)}: ${ne[2]}.${ne[3]}`,_),this.s({type:ie,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 102:return this.k?.logIncoming(V.byteLength,ne[1],1,`${g(ie)}: ${ne[2]}.${ne[3]}`,_),this.t({type:ie,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 101:return this.k?.logIncoming(V.byteLength,ne[1],1,`${g(ie)}`),this.u({type:ie,id:ne[1]});case 103:return this.k?.logIncoming(V.byteLength,ne[1],1,`${g(ie)}`),this.u({type:ie,id:ne[1]})}}s(V){const ee=this.b.get(V.channelName);if(!ee){this.v(V);return}const ne=new A.$Wd;let _;try{_=ee.call(this.j,V.name,V.arg,ne.token)}catch(B){_=Promise.reject(B)}const ie=V.id;_.then(B=>{this.m({id:ie,data:B,type:201})},B=>{B instanceof Error?this.m({id:ie,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.m({id:ie,data:B,type:203})}).finally(()=>{K.dispose(),this.d.delete(V.id)});const K=(0,d.$Pc)(()=>ne.cancel());this.d.set(V.id,K)}t(V){const ee=this.b.get(V.channelName);if(!ee){this.v(V);return}const ne=V.id,ie=ee.listen(this.j,V.name,V.arg)(K=>this.m({id:ne,data:K,type:204}));this.d.set(V.id,ie)}u(V){const ee=this.d.get(V.id);ee&&(ee.dispose(),this.d.delete(V.id))}v(V){let ee=this.g.get(V.channelName);ee||(ee=[],this.g.set(V.channelName,ee));const ne=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ee.push({request:V,timeoutTimer:ne})}w(V){const ee=this.g.get(V);if(ee){for(const ne of ee)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}e.$ph=v;var y;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class u{constructor(V,ee=null){this.l=V,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new C.$Md,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=ee}getChannel(V){const ee=this;return{call(ne,_,ie){return ee.a?Promise.reject(new I.$4):ee.m(V,ne,_,ie)},listen(ne,_){return ee.a?C.Event.None:ee.o(V,ne,_)}}}m(V,ee,ne,_=A.CancellationToken.None){const ie=this.g++,B={id:ie,type:100,channelName:V,name:ee,arg:ne};if(_.isCancellationRequested)return Promise.reject(new I.$4);let k;return new Promise((z,F)=>{if(_.isCancellationRequested)return F(new I.$4);const G=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(ie),z(he.data);break;case 202:{this.f.delete(ie);const $e=new Error(he.data.message);$e.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,$e.name=he.data.name,F($e);break}case 203:this.f.delete(ie),F(he.data);break}};this.f.set(ie,ue),this.p(B)};let Z=null;this.b===f.Idle?G():(Z=(0,N.$Gg)(ue=>this.u()),Z.then(()=>{Z=null,G()}));const re=()=>{Z?(Z.cancel(),Z=null):this.p({id:ie,type:101}),F(new I.$4)},le=_.onCancellationRequested(re);k=(0,d.$Oc)((0,d.$Pc)(re),le),this.d.add(k)}).finally(()=>{k.dispose(),this.d.delete(k)})}o(V,ee,ne){const _=this.g++,K={id:_,type:102,channelName:V,name:ee,arg:ne};let B=null;const k=new C.$Md({onWillAddFirstListener:()=>{B=(0,N.$Gg)(z=>this.u()),B.then(()=>{B=null,this.d.add(k),this.p(K)})},onDidRemoveLastListener:()=>{B?(B.cancel(),B=null):(this.d.delete(k),this.p({id:_,type:103}))}}),R=z=>k.fire(z.data);return this.f.set(_,R),k.event}p(V){switch(V.type){case 100:case 102:{const ee=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(ee,V.id,0,`${g(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const ee=this.q([V.type,V.id]);this.j?.logOutgoing(ee,V.id,0,g(V.type));return}}}q(V,ee=void 0){const ne=new s;return r(ne,V),r(ne,ee),this.r(ne.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const ee=new S(V),ne=o(ee),_=o(ee),ie=ne[0];switch(ie){case 200:return this.j?.logIncoming(V.byteLength,0,0,w(ie)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ne[1],0,w(ie),_),this.t({type:ne[0],id:ne[1],data:_})}}t(V){if(V.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}e.$qh=u,ye([O.$fh],u.prototype,"onDidInitializePromise",null);class ${get connections(){const V=[];return this.f.forEach(ee=>V.push(ee)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new C.$Md,this.onDidAddConnection=this.g.event,this.h=new C.$Md,this.onDidRemoveConnection=this.h.event,this.j=new d.$Qc,this.j.add(V(({protocol:ee,onDidClientDisconnect:ne})=>{const _=C.Event.once(ee.onMessage);this.j.add(_(ie=>{const K=new S(ie),B=o(K),k=new v(ee,B),R=new u(ee);this.a.forEach((F,G)=>k.registerChannel(G,F));const z={channelServer:k,channelClient:R,ctx:B};this.f.add(z),this.g.fire(z),this.j.add(ne(()=>{k.dispose(),R.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(V,ee){const ne=this;return{call(_,ie,K){let B;if((0,b.$Lf)(ee)){const R=(0,D.$3b)(ne.connections.filter(ee));B=R?Promise.resolve(R):C.Event.toPromise(C.Event.filter(ne.onDidAddConnection,ee))}else B=ee.routeCall(ne,_,ie);const k=B.then(R=>R.channelClient.getChannel(V));return M(k).call(_,ie,K)},listen(_,ie){if((0,b.$Lf)(ee))return ne.k(V,ee,_,ie);const K=ee.routeEvent(ne,_,ie).then(B=>B.channelClient.getChannel(V));return M(K).listen(_,ie)}}}k(V,ee,ne,_){const ie=this;let K;const B=new C.$Md({onWillAddFirstListener:()=>{K=new d.$Qc;const k=new C.$Sd,R=new Map,z=G=>{const re=G.channelClient.getChannel(V).listen(ne,_),le=k.add(re);R.set(G,le)},F=G=>{const Z=R.get(G);Z&&(Z.dispose(),R.delete(G))};ie.connections.filter(ee).forEach(z),C.Event.filter(ie.onDidAddConnection,ee)(z,void 0,K),ie.onDidRemoveConnection(F,void 0,K),k.event(B.fire,B,K),K.add(k)},onDidRemoveLastListener:()=>{K?.dispose(),K=void 0}});return B.event}registerChannel(V,ee){this.a.set(V,ee);for(const ne of this.f)ne.channelServer.registerChannel(V,ee)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$rh=$;class j{constructor(V,ee,ne=null){const _=new s;r(_,ee),V.send(_.buffer),this.a=new u(V,ne),this.d=new v(V,ee,ne)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,ee){this.d.registerChannel(V,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$sh=j;function M(H){return{call(V,ee,ne){return H.then(_=>_.call(V,ee,ne))},listen(V,ee){const ne=new C.$Vd;return H.then(_=>ne.input=_.listen(V,ee)),ne.event}}}e.$th=M;function T(H){let V=!1;return{call(ee,ne,_){return V?H.call(ee,ne,_):(0,N.$Tg)(0).then(()=>V=!0).then(()=>H.call(ee,ne,_))},listen(ee,ne){if(V)return H.listen(ee,ne);const _=new C.$Vd;return(0,N.$Tg)(0).then(()=>V=!0).then(()=>_.input=H.listen(ee,ne)),_.event}}}e.$uh=T;class U{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const ee of V.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await C.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$vh=U;var q;(function(H){function V(ie,K,B){const k=ie,R=B&&B.disableMarshalling,z=new Map;for(const F in k)ne(F)&&z.set(F,C.Event.buffer(k[F],!0,void 0,K));return new class{listen(F,G,Z){const re=z.get(G);if(re)return re;if(_(G)){const le=k[G];if(typeof le=="function")return le.call(k,Z)}throw new I.$ab(`Event not found: ${G}`)}call(F,G,Z){const re=k[G];if(typeof re=="function"){if(!R&&Array.isArray(Z))for(let ue=0;ue<Z.length;ue++)Z[ue]=(0,P.$kh)(Z[ue]);let le=re.apply(k,Z);return le instanceof Promise||(le=Promise.resolve(le)),le}throw new I.$ab(`Method not found: ${G}`)}}}H.fromService=V;function ee(ie,K){const B=K&&K.disableMarshalling;return new Proxy({},{get(k,R){if(typeof R=="string")return K?.properties?.has(R)?K.properties.get(R):_(R)?function(z){return ie.listen(R,z)}:ne(R)?ie.listen(R):async function(...z){let F;K&&!(0,b.$Gf)(K.context)?F=[K.context,...z]:F=z;const G=await ie.call(R,F);return B?G:(0,P.$kh)(G)};throw new I.$ab(`Property not found: ${String(R)}`)}})}H.toService=ee;function ne(ie){return ie[0]==="o"&&ie[1]==="n"&&E.$Ze(ie.charCodeAt(2))}function _(ie){return/^onDynamic/.test(ie)&&E.$Ze(ie.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const V=H.toString();if(V!=="[object Object]")return V}return H}function x(H){return Array.isArray(H)?H.map(J):J(H)}function W(H,V,ee,ne,_,ie,K){K=x(K);const B=Y[_],k=B[ne%B.length];let R=[`%c[${H}]%c[${String(V).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(ie)?(R=R.concat(K),R.push(")")):R.push(K),console.log.apply(console,R)}class Q{constructor(V,ee){this.d=V,this.f=ee,this.a=0,this.b=0}logOutgoing(V,ee,ne,_,ie){this.b+=V,W(this.d,this.b,V,ee,ne,_,ie)}logIncoming(V,ee,ne,_,ie){this.a+=V,W(this.f,this.a,V,ee,ne,_,ie)}}e.$wh=Q}),define(oe[66],ae([0,1,15,3,2,42]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e.$yh=e.ProtocolConstants=e.$xh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function o(y,u){if(!t.has(y)){const $=String(++r);t.set(y,$)}return t.get(y)}function v(y,u,$,j){if(!i.enableDiagnostics)return;const M=o(y,u);if(j instanceof D.$ae||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const T=D.$ae.alloc(j.byteLength);T.set(j),i.records.push({timestamp:Date.now(),id:M,label:u,type:$,buff:T})}else i.records.push({timestamp:Date.now(),id:M,label:u,type:$,data:j})}i.traceSocketEvent=v})(I||(e.SocketDiagnostics=I={}));var C;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C||(e.SocketCloseEventType=C={}));let d=null;function P(){return d||(d=D.$ae.alloc(0)),d}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return P();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const u=this.a[0];return r&&(this.a.shift(),this.b-=t),u}if(this.a[0].byteLength>t){const u=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),u}const o=D.$ae.alloc(t);let v=0,y=0;for(;t>0;){const u=this.a[y];if(u.byteLength>t){const $=u.slice(0,t);o.set($,v),v+=t,r&&(this.a[y]=u.slice(t),this.b-=t),t-=t}else o.set(u,v),v+=u.byteLength,r?(this.a.shift(),this.b-=u.byteLength):y++,t-=u.byteLength}return o}}e.$xh=E;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(b||(b={}));function l(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class p{constructor(t,r,o,v){this.type=t,this.id=r,this.ack=o,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends L.$Rc{constructor(t){super(),this.f=this.B(new N.$Md),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,v=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new p(o,v,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=D.$ae.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const o=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,o}h(){const t=D.$ae.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class c extends L.$Rc{constructor(t){super(),this.f=new N.$Md,this.onMessage=this.f.event,this.g=new N.$Md,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new f(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new p(1,0,0,t))}}e.$yh=c;class h extends A.$sh{static fromSocket(t,r){return new h(new c(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,o=null){super(t,r,o),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$zh=h;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Md({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Ah=m;class S{constructor(t){this.data=t,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,o=this.a;for(;o;)t[r++]=o.data,o=o.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new S(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<a.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=a.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+a.a)*1e3;let o=0;for(let v=0;v<a.a;v++)t-this.c[v]<=r&&o++;return 1-o/a.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??a.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Qc,this.o=t.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new p(5,0,0,P());this.p.write(t),this.p.flush()}sendPause(){const t=new p(7,0,0,P());this.p.write(t)}sendResume(){const t=new p(8,0,0,P());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new L.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new p(3,0,this.h,P());this.p.write(t);const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new p(6,0,0,P())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const o=new p(1,r,this.h,t);this.b.push(o),this.a||(this.p.write(o),this.B())}sendControl(t){const r=new p(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,o=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&o>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const y=Math.max(2e4-r,2e4-o,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},y)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new p(3,0,this.h,P());this.p.write(t)}D(){this.h=this.g;const t=new p(9,0,this.h,P());this.p.write(t)}}e.$Bh=n}),define(oe[93],ae([0,1,65,5,15,26,142,8,3,2,30,145,90,42]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0;class g extends l.$ph{constructor(f){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",c=>L.$ae.wrap(Buffer.from(c,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$Yp=g;class p{constructor(f,c){this.i=f,this.j=c,this.c=new Set,this.g=new Map,this.h=new C.$Md,this.onDidProcessExit=this.h.event;const h=c&&c.timeout?c.timeout:6e4;this.b=new N.$Pg(h),this.d=null,this.f=null}getChannel(f){const c=this;return{call(h,m,S){return c.k(f,h,m,S)},listen(h,m){return c.l(f,h,m)}}}k(f,c,h,m=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(I.$5());this.b.cancel();const S=this.n(f),s=(0,N.$Gg)(i=>S.call(c,h,i)),a=m.onCancellationRequested(()=>s.cancel()),n=(0,d.$Pc)(()=>s.cancel());return this.c.add(n),s.finally(()=>{a.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(f,c,h){if(!this.b)return C.Event.None;this.b.cancel();let m;const S=new C.$Md({onWillAddFirstListener:()=>{m=this.n(f).listen(c,h)(S.fire,S),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return S.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,P.$3m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,b.$xl)(c.env),this.d=(0,D.fork)(this.i,f,c);const h=new C.$Md;C.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,O.$Up)(t)){(0,O.log)(t,`IPC Library: ${this.j.serverName}`);return}h.fire(L.$ae.wrap(Buffer.from(t,"base64")))});const S=this.j.useQueue?(0,E.$zl)(this.d):this.d,s=t=>this.d&&this.d.connected&&S.send(t.buffer.toString("base64")),a=h.event,n={send:s,onMessage:a};this.f=new l.$qh(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",i),this.c.forEach(o=>(0,d.$Mc)(o)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(f){let c=this.g.get(f);return c||(c=this.m.getChannel(f),this.g.set(f,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Zp=p}),define(oe[147],ae([0,1,135,15,42,3,12,18]),function(te,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rT=e.$qT=void 0;class C{constructor(b){this.a=b,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",l=>N.$ae.wrap(l.data)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}class d extends L.$rh{static b(b){(0,O.$Hf)((0,D.$pT)(process),"Electron Utility Process");const l=new A.$Md;return process.parentPort.on("message",g=>{if(b?.handledClientConnection(g))return;const p=(0,I.$Nb)(g.ports);p&&l.fire(p)}),A.Event.map(l.event,g=>({protocol:new C(g),onDidClientDisconnect:A.Event.fromNodeEventEmitter(g,"close")}))}constructor(b){super(d.b(b))}}e.$qT=d;function P(E,b,l){const g=p=>{p.data===b&&(E.removeListener("message",g),l())};E.on("message",g)}e.$rT=P}),define(oe[67],ae([0,1,5,3,2,64,12]),function(te,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.StorageState=e.$Xo=e.StorageHint=void 0;var I;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function C(b){const l=b;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$Xo=C;var d;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(d||(e.StorageState=d={}));class P extends L.$Rc{static{this.a=100}constructor(l,g=Object.create(null)){super(),this.r=l,this.s=g,this.b=this.B(new N.$Pd),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=this.B(new D.$Qg(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach((g,p)=>this.w(p,g)),l.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(l,g){if(this.c===d.Closed)return;let p=!1;(0,O.$Gf)(g)?p=this.f.delete(l):this.f.get(l)!==g&&(this.f.set(l,g),p=!0),p&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,g){const p=this.f.get(l);return(0,O.$Gf)(p)?g:p}getBoolean(l,g){const p=this.get(l);return(0,O.$Gf)(p)?g:p==="true"}getNumber(l,g){const p=this.get(l);return(0,O.$Gf)(p)?g:parseInt(p,10)}getObject(l,g){const p=this.get(l);return(0,O.$Gf)(p)?g:(0,A.$jh)(p)}async set(l,g,p=!1){if(this.c===d.Closed)return;if((0,O.$Gf)(g))return this.delete(l,p);const w=(0,O.$zf)(g)||Array.isArray(g)?(0,A.$ih)(g):String(g);if(this.f.get(l)!==w)return this.f.set(l,w),this.j.set(l,w),this.h.delete(l),this.b.fire({key:l,external:p}),this.D()}async delete(l,g=!1){if(!(this.c===d.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:g}),this.D()}async optimize(){if(this.c!==d.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=d.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(this.z)return this.D(l)}async D(l){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$Yo=P;class E{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((g,p)=>this.a.set(p,g)),l.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$Zo=E}),define(oe[148],ae([13,9]),function(te,e){return te.create("vs/base/node/zip",e)}),define(oe[149],ae([13,9]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[150],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[151],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(oe[152],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[153],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[154],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[155],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[156],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[157],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[158],ae([13,9]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[159],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(oe[160],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(oe[161],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(oe[162],ae([13,9]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[163],ae([13,9]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[164],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[165],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[166],ae([13,9]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(oe[167],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[168],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[169],ae([13,9]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[170],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[171],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[172],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[173],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[174],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[175],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[176],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[177],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[178],ae([13,9]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(oe[179],ae([0,1,8,151]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var L;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(L||(e.TokenType=L={}));function A(...d){switch(d.length){case 1:return(0,N.localize)(0,null,d[0]);case 2:return(0,N.localize)(1,null,d[0],d[1]);case 3:return(0,N.localize)(2,null,d[0],d[1],d[2]);default:return}}const O=(0,N.localize)(3,null),I=(0,N.localize)(4,null);class C{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,D.$7)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const E=this.d,b=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:b};this.g.push({offset:E,lexeme:b,additionalInfo:P}),this.f.push(l)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const E=this.c.substring(this.d,this.e),b=C.b.get(E);b?this.k(b):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,E=!1,b=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(I);return}const g=this.c.charCodeAt(P);if(E)E=!1;else if(g===47&&!b){P++;break}else g===91?b=!0:g===92?E=!0:g===93&&(b=!1);P++}for(;P<this.c.length&&C.a.has(this.c.charCodeAt(P));)P++;this.e=P;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=C}),define(oe[180],ae([0,1,63,84,23,16,37,19,10]),function(te,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=e.$dm=e.$cm=void 0,e.$cm=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,A.$lc)(L.$bg.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return C.URI.file((0,A.$ic)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.b.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,I.$ug)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$ug)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,D.$bm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ic)(this.userDataPath,"logs",l)}return C.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$ug)(C.URI.file((0,A.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$ug)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$ug)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$ug)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=O.env.VSCODE_PORTABLE;return l?C.URI.file((0,A.$ic)(l,"argv.json")):(0,I.$ug)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,A.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,A.$jc)(l):(0,A.$gc)((0,A.$ic)(L.$bg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?C.URI.file((0,A.$jc)(l)):C.URI.file((0,A.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,A.$jc)(l);const g=O.env.VSCODE_EXTENSIONS;if(g)return g;const p=O.env.VSCODE_PORTABLE;return p?(0,A.$ic)(p,"extensions"):(0,I.$ug)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(g=>/^[^:/?#]+?:\/\//.test(g)?C.URI.parse(g):C.URI.file((0,A.$gc)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?C.URI.parse(l):C.URI.file((0,A.$gc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$cm.test(l))}get extensionLogLevel(){const l=[];for(const g of this.args.log||[]){const p=e.$cm.exec(g);p&&p[1]&&p[2]&&l.push([p[1],p[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,I.$ug)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=O.env.VSCODE_PORTABLE;return l?C.URI.file((0,A.$ic)(l,"policy.json")):(0,I.$ug)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,g,p){this.a=l,this.b=g,this.c=p,this.editSessionId=this.args.editSessionId}}e.$dm=d,ye([N.$fh],d.prototype,"appRoot",null),ye([N.$fh],d.prototype,"userHome",null),ye([N.$fh],d.prototype,"userDataPath",null),ye([N.$fh],d.prototype,"appSettingsHome",null),ye([N.$fh],d.prototype,"tmpDir",null),ye([N.$fh],d.prototype,"cacheHome",null),ye([N.$fh],d.prototype,"stateResource",null),ye([N.$fh],d.prototype,"userRoamingDataHome",null),ye([N.$fh],d.prototype,"userDataSyncHome",null),ye([N.$fh],d.prototype,"sync",null),ye([N.$fh],d.prototype,"machineSettingsResource",null),ye([N.$fh],d.prototype,"workspaceStorageHome",null),ye([N.$fh],d.prototype,"localHistoryHome",null),ye([N.$fh],d.prototype,"keyboardLayoutResource",null),ye([N.$fh],d.prototype,"argvResource",null),ye([N.$fh],d.prototype,"isExtensionDevelopment",null),ye([N.$fh],d.prototype,"untitledWorkspacesHome",null),ye([N.$fh],d.prototype,"builtinExtensionsPath",null),ye([N.$fh],d.prototype,"extensionsPath",null),ye([N.$fh],d.prototype,"extensionDevelopmentLocationURI",null),ye([N.$fh],d.prototype,"extensionDevelopmentKind",null),ye([N.$fh],d.prototype,"extensionTestsLocationURI",null),ye([N.$fh],d.prototype,"debugExtensionHost",null),ye([N.$fh],d.prototype,"logLevel",null),ye([N.$fh],d.prototype,"extensionLogLevel",null),ye([N.$fh],d.prototype,"serviceMachineIdResource",null),ye([N.$fh],d.prototype,"disableTelemetry",null),ye([N.$fh],d.prototype,"disableWorkspaceTrust",null),ye([N.$fh],d.prototype,"useInMemorySecretStorage",null),ye([N.$fh],d.prototype,"policyFile",null);function P(b,l){return E(b["inspect-extensions"],b["inspect-brk-extensions"],5870,l,b.debugId,b.extensionEnvironment)}e.$em=P;function E(b,l,g,p,w,f){const h=Number(l||b)||(p?null:g),m=h?!!l:!1;let S;if(f)try{S=JSON.parse(f)}catch{}return{port:h,break:m,debugId:w,env:S}}e.$fm=E}),function(){"use strict";function te(e,D,N){function L(O,I){const C=A(O,I),d=[C];return e.isAbsolute(C)||d.unshift(N),e.resolve(...d)}function A(O,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,I);const P=O["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(E,"AppData","Roaming")}break;case"darwin":d=e.join(D.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,I)}return{getUserDataPath:L}}if(typeof define=="function")define(oe[181],ae([270,36,37]),function(e,D,N){return te(e,D,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=te(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[182],ae([0,1,36,180,181]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=void 0;class A extends N.$dm{constructor(d,P){super(d,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(d,P.nameShort)},P)}}e.$gm=A;function O(C,d){return(0,N.$fm)(C["inspect-ptyhost"],C["inspect-brk-ptyhost"],5877,d,C.extensionEnvironment)}e.$hm=O;function I(C,d){return(0,N.$fm)(C["inspect-sharedprocess"],C["inspect-brk-sharedprocess"],5879,d,C.extensionEnvironment)}e.$im=I}),define(oe[183],ae([0,1,12,154]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;function L(O,I,C,d){try{A(O,I,C,d)}catch(P){O.error(P?.message??P)}return I}e.$up=L;function A(O,I,C,d){const P=(E,b,l)=>{const g=E[b];if((0,D.$xf)(g)){const p=g,w=p.length;if(w>1&&p[0]==="%"&&p[w-1]==="%"){const f=p.substr(1,w-2);let c=C[f];c===void 0&&d&&(c=d[f]);const h=typeof c=="string"?c:c?.message,m=d?.[f],S=typeof m=="string"?m:m?.message;if(!h){S||O.warn(`[${I.name}]: ${(0,N.localize)(0,null,f)}`);return}if(l&&(b==="title"||b==="category")&&S&&S!==h){const s={value:h,original:S};E[b]=s}else E[b]=h}}else if((0,D.$zf)(g))for(const p in g)g.hasOwnProperty(p)&&(p==="commands"?P(g,p,!0):P(g,p,l));else if(Array.isArray(g))for(let p=0;p<g.length;p++)P(g,p,l)};for(const E in I)I.hasOwnProperty(E)&&P(I,E)}}),define(oe[184],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W8b=e.$V8b=void 0;class D{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$V8b=D;class N{constructor(A){this.a=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,I){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(I[0])}throw new Error(`Call not found: ${O}`)}}e.$W8b=N}),define(oe[68],ae([0,1,19,89,158,54]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function C(f){return f=f.trim(),f==="*"||O.test(f)}e.$Io=C;function d(f){if(!C(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=f.match(O);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$Jo=d;function P(f){if(!f)return null;const c=f.majorBase,h=f.majorMustEqual,m=f.minorBase;let S=f.minorMustEqual;const s=f.patchBase;let a=f.patchMustEqual;f.hasCaret&&(c===0||(S=!1),a=!1);let n=0;if(f.preRelease){const i=I.exec(f.preRelease);if(i){const[,t,r,o]=i;n=Date.UTC(Number(t),Number(r)-1,Number(o))}}return{majorBase:c,majorMustEqual:h,minorBase:m,minorMustEqual:S,patchBase:s,patchMustEqual:a,isMinimum:f.hasGreaterEquals,notBefore:n}}e.$Ko=P;function E(f,c,h){let m;typeof f=="string"?m=P(d(f)):m=f;let S;c instanceof Date?S=c.getTime():typeof c=="string"&&(S=new Date(c).getTime());let s;if(typeof h=="string"?s=P(d(h)):s=h,!m||!s)return!1;const a=m.majorBase,n=m.minorBase,i=m.patchBase;let t=s.majorBase,r=s.minorBase,o=s.patchBase;const v=s.notBefore;let y=s.majorMustEqual,u=s.minorMustEqual,$=s.patchMustEqual;return s.isMinimum?a>t?!0:a<t?!1:n>r?!0:n<r||S&&S<v?!1:i>=o:(a===1&&t===0&&(!y||!u||!$)&&(t=1,r=0,o=0,y=!0,u=!1,$=!1),a<t?!1:a>t?!y:n<r?!1:n>r?!u:i<o?!1:i>o?!$:!(S&&S<v))}e.$Lo=E;function b(f,c,h,m,S){const s=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return s.push([N.default.Error,L.localize(0,null)]),s;if(typeof m.name!="string")return s.push([N.default.Error,L.localize(1,null,"name")]),s;if(typeof m.version!="string")return s.push([N.default.Error,L.localize(2,null,"version")]),s;if(!m.engines)return s.push([N.default.Error,L.localize(3,null,"engines")]),s;if(typeof m.engines.vscode!="string")return s.push([N.default.Error,L.localize(4,null,"engines.vscode")]),s;if(typeof m.extensionDependencies<"u"&&!w(m.extensionDependencies))return s.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),s;if(typeof m.activationEvents<"u"){if(!w(m.activationEvents))return s.push([N.default.Error,L.localize(6,null,"activationEvents")]),s;if(typeof m.main>"u"&&typeof m.browser>"u")return s.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),s}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&s.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return s.push([N.default.Error,L.localize(9,null,"main")]),s;{const i=(0,D.$ug)(h,m.main);(0,D.$og)(i,h)||s.push([N.default.Warning,L.localize(10,null,i.path,h.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return s.push([N.default.Error,L.localize(11,null,"browser")]),s;{const i=(0,D.$ug)(h,m.browser);(0,D.$og)(i,h)||s.push([N.default.Warning,L.localize(12,null,i.path,h.path)])}}if(!A.valid(m.version))return s.push([N.default.Error,L.localize(13,null)]),s;const a=[];if(!l(f,c,m,S,a))for(const i of a)s.push([N.default.Error,i]);return s}e.$Mo=b;function l(f,c,h,m,S){return m||typeof h.main>"u"&&typeof h.browser>"u"?!0:p(f,c,h.engines.vscode,S)}e.$No=l;function g(f,c,h){return f==="*"||p(c,h,f)}e.$Oo=g;function p(f,c,h,m=[]){const S=P(d(h));if(!S)return m.push(L.localize(14,null,h)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return m.push(L.localize(15,null,h)),!1}else if(!S.majorMustEqual)return m.push(L.localize(16,null,h)),!1;return E(f,c,S)?!0:(m.push(L.localize(17,null,f,h)),!1)}function w(f){if(!Array.isArray(f))return!1;for(let c=0,h=f.length;c<h;c++)if(typeof f[c]!="string")return!1;return!0}}),define(oe[43],ae([0,1,15,32]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=void 0;async function L(A,O,I){let C=I&&I.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const P=(await O.readFile(A.serviceMachineIdResource)).value.toString();C=(0,N.$cg)(P)?P:null}catch{C=null}if(!C){C=(0,N.$dg)();try{await O.writeFile(A.serviceMachineIdResource,D.$ae.fromString(C))}catch{}}return I?.store("storage.serviceMachineId",C,-1,1),C}e.$9o=L}),define(oe[69],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class D{constructor(L,A=[],O=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$Kh=D}),define(oe[185],ae([0,1,69]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.InstantiationType=void 0;const N=[];var L;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function A(I,C,d){C instanceof D.$Kh||(C=new D.$Kh(C,[],!!d)),N.push([I,C])}e.$tr=A;function O(){return N}e.$ur=O}),define(oe[186],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=void 0;class D{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$$p=D;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const I=this.lookupOrInsertNode(A),C=this.lookupOrInsertNode(O);I.outgoing.set(C.key,C),C.incoming.set(I.key,I)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const I of this.a.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let I=this.a.get(O);return I||(I=new D(O,A),this.a.set(O,I)),I}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,I]of this.a)A.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const I=new Set([A]),C=this.c(O,I);if(C)return C}}c(A,O){for(const[I,C]of A.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const d=this.c(C,O);if(d)return d;O.delete(I)}}}e.$_p=N}),define(oe[4],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e._util=void 0;var D;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function I(C){return C[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=I})(D||(e._util=D={})),e.$Mh=L("instantiationService");function N(O,I,C){I[D.DI_TARGET]===I?I[D.DI_DEPENDENCIES].push({id:O,index:C}):(I[D.DI_DEPENDENCIES]=[{id:O,index:C}],I[D.DI_TARGET]=I)}function L(O){if(D.serviceIds.has(O))return D.serviceIds.get(O);const I=function(C,d,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(I,C,P)};return I.toString=()=>O,D.serviceIds.set(O,I),I}e.$Nh=L;function A(O){return O}e.$Oh=A}),define(oe[187],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=void 0,e.$s8b=(0,D.$Nh)("checksumService")}),define(oe[20],ae([0,1,12,10,4]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,L.$Nh)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof N.URI)}e.$ii=A;function O(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof N.URI)}e.$ji=O;var I;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function C(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=C;function d(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}e.$li=d;function P(f,c){const h=Object.create(null);for(const m in f)E(h,m,f[m],c);return h}e.$mi=P;function E(f,c,h,m){const S=c.split("."),s=S.pop();let a=f;for(let n=0;n<S.length;n++){const i=S[n];let t=a[i];switch(typeof t){case"undefined":t=a[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${c} as ${S.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[s]=h}catch{m(`Ignoring ${c} as ${S.join(".")} is ${JSON.stringify(a)}`)}else m(`Ignoring ${c} as ${S.join(".")} is ${JSON.stringify(a)}`)}e.$ni=E;function b(f,c){const h=c.split(".");l(f,h)}e.$oi=b;function l(f,c){const h=c.shift();if(c.length===0){delete f[h];return}if(Object.keys(f).indexOf(h)!==-1){const m=f[h];typeof m=="object"&&!Array.isArray(m)&&(l(m,c),Object.keys(m).length===0&&delete f[h])}}function g(f,c,h){function m(a,n){let i=a;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const S=c.split("."),s=m(f,S);return typeof s>"u"?h:s}e.$pi=g;function p(f,c,h){Object.keys(c).forEach(m=>{m!=="__proto__"&&(m in f?D.$zf(f[m])&&D.$zf(c[m])?p(f[m],c[m],h):h&&(f[m]=c[m]):f[m]=c[m])})}e.$qi=p;function w(f){return f.replace(/[\[\]]/g,"")}e.$ri=w}),define(oe[94],ae([0,1,6,27,179,4,150,8]),function(te,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",D.$k),C.set("isLinux",D.$l),C.set("isWindows",D.$j),C.set("isWeb",D.$p),C.set("isMacNative",D.$k&&!D.$p),C.set("isEdge",D.$H),C.set("isFirefox",D.$F),C.set("isChrome",D.$E),C.set("isSafari",D.$G);function d(B,k){if(C.get(B)!==void 0)throw(0,I.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");C.set(B,k)}e.$Ji=d;const P=Object.prototype.hasOwnProperty;var E;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const b={regexParsingWithErrorRecovery:!0},l=(0,O.localize)(0,null),g=(0,O.localize)(1,null),p=(0,O.localize)(2,null),w=(0,O.localize)(3,null),f=(0,O.localize)(4,null),c=(0,O.localize)(5,null),h=(0,O.localize)(6,null),m=(0,O.localize)(7,null);class S{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(k=b){this.k=k,this.d=new L.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(k){if(k===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(k).scan(),this.g=0,this.h=[];try{const R=this.l();if(!this.E()){const z=this.D(),F=z.type===17?c:void 0;throw this.h.push({message:f,offset:z.offset,lexeme:L.$Ii.getLexeme(z),additionalInfo:F}),S.c}return R}catch(R){if(R!==S.c)throw R;return}}l(){return this.m()}m(){const k=[this.o()];for(;this.y(16);){const R=this.o();k.push(R)}return k.length===1?k[0]:s.or(...k)}o(){const k=[this.s()];for(;this.y(15);){const R=this.s();k.push(R)}return k.length===1?k[0]:s.and(...k)}s(){if(this.y(2)){const k=this.D();switch(k.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const R=this.l();return this.A(1,w),R?.negate()}case 17:return this.z(),j.create(k.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",k)}}return this.t()}t(){const k=this.D();switch(k.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const R=this.l();return this.A(1,w),R}case 17:{const R=k.lexeme;if(this.z(),this.y(9)){const F=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),F.type!==10)throw this.B("REGEX",F);const G=F.lexeme,Z=G.lastIndexOf("/"),re=Z===G.length-1?void 0:this.w(G.substring(Z+1));let le;try{le=new RegExp(G.substring(1,Z),re)}catch{throw this.B("REGEX",F)}return J.create(R,le)}switch(F.type){case 10:case 19:{const G=[F.lexeme];this.z();let Z=this.D(),re=0;for(let de=0;de<F.lexeme.length;de++)F.lexeme.charCodeAt(de)===40?re++:F.lexeme.charCodeAt(de)===41&&re--;for(;!this.E()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let de=0;de<Z.lexeme.length;de++)Z.lexeme.charCodeAt(de)===40?re++:F.lexeme.charCodeAt(de)===41&&re--}if(re<0)break;G.push(L.$Ii.getLexeme(Z)),this.z(),Z=this.D()}const le=G.join(""),ue=le.lastIndexOf("/"),he=ue===le.length-1?void 0:this.w(le.substring(ue+1));let $e;try{$e=new RegExp(le.substring(1,ue),he)}catch{throw this.B("REGEX",F)}return s.regex(R,$e)}case 18:{const G=F.lexeme;this.z();let Z=null;if(!(0,N.$Ae)(G)){const re=G.indexOf("/"),le=G.lastIndexOf("/");if(re!==le&&re>=0){const ue=G.slice(re+1,le),he=G[le+1]==="i"?"i":"";try{Z=new RegExp(ue,he)}catch{throw this.B("REGEX",F)}}}if(Z===null)throw this.B("REGEX",F);return J.create(R,Z)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const F=this.u();return s.notIn(R,F)}switch(this.D().type){case 3:{this.z();const F=this.u();if(this.x().type===18)return s.equals(R,F);switch(F){case"true":return s.has(R);case"false":return s.not(R);default:return s.equals(R,F)}}case 4:{this.z();const F=this.u();if(this.x().type===18)return s.notEquals(R,F);switch(F){case"true":return s.not(R);case"false":return s.has(R);default:return s.notEquals(R,F)}}case 5:return this.z(),q.create(R,this.u());case 6:return this.z(),Y.create(R,this.u());case 7:return this.z(),T.create(R,this.u());case 8:return this.z(),U.create(R,this.u());case 13:return this.z(),s.in(R,this.u());default:return s.has(R)}}case 20:throw this.h.push({message:h,offset:k.offset,lexeme:"",additionalInfo:m}),S.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const k=this.D();switch(k.type){case 17:case 18:return this.z(),k.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(k){return k.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(k){return this.C(k)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(k,R){if(this.C(k))return this.z();throw this.B(R,this.D())}B(k,R,z){const F=(0,O.localize)(8,null,k,L.$Ii.getLexeme(R)),G=R.offset,Z=L.$Ii.getLexeme(R);return this.h.push({message:F,offset:G,lexeme:Z,additionalInfo:z}),S.c}C(k){return this.D().type===k}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=S;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(k){return o.create(k)}static equals(k,R){return v.create(k,R)}static notEquals(k,R){return $.create(k,R)}static regex(k,R){return J.create(k,R)}static in(k,R){return y.create(k,R)}static notIn(k,R){return u.create(k,R)}static not(k){return j.create(k)}static and(...k){return Q.create(k,null,!0)}static or(...k){return H.create(k,null,!0)}static greater(k,R){return T.create(k,R)}static greaterEquals(k,R){return U.create(k,R)}static smaller(k,R){return q.create(k,R)}static smallerEquals(k,R){return Y.create(k,R)}static{this.c=new S({regexParsingWithErrorRecovery:!1})}static deserialize(k){return k==null?void 0:this.c.parse(k)}}e.$Li=s;function a(B){const k=new S({regexParsingWithErrorRecovery:!1});return B.map(R=>(k.parse(R),k.lexingErrors.length>0?k.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,O.localize)(9,null,z.additionalInfo):(0,O.localize)(10,null),offset:z.offset,length:z.lexeme.length})):k.parsingErrors.length>0?k.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$Mi=a;function n(B,k){const R=B?B.substituteConstants():void 0,z=k?k.substituteConstants():void 0;return!R&&!z?!0:!R||!z?!1:R.equals(z)}e.$Ni=n;function i(B,k){return B.cmp(k)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return r.INSTANCE}}e.$Oi=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return t.INSTANCE}}e.$Pi=r;class o{static create(k,R=null){const z=C.get(k);return typeof z=="boolean"?z?r.INSTANCE:t.INSTANCE:new o(k,R)}constructor(k,R){this.key=k,this.c=R,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=C.get(this.key);return typeof k=="boolean"?k?r.INSTANCE:t.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Qi=o;class v{static create(k,R,z=null){if(typeof R=="boolean")return R?o.create(k,z):j.create(k,z);const F=C.get(k);return typeof F=="boolean"?R===(F?"true":"false")?r.INSTANCE:t.INSTANCE:new v(k,R,z)}constructor(k,R,z){this.c=k,this.d=R,this.f=z,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:ne(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=C.get(this.c);if(typeof k=="boolean"){const R=k?"true":"false";return this.d===R?r.INSTANCE:t.INSTANCE}return this}evaluate(k){return k.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(k){return k.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=$.create(this.c,this.d,this)),this.f}}e.$Ri=v;class y{static create(k,R){return new y(k,R)}constructor(k,R){this.d=k,this.f=R,this.type=10,this.c=null}cmp(k){return k.type!==this.type?this.type-k.type:ne(this.d,this.f,k.d,k.f)}equals(k){return k.type===this.type?this.d===k.d&&this.f===k.f:!1}substituteConstants(){return this}evaluate(k){const R=k.getValue(this.f),z=k.getValue(this.d);return Array.isArray(R)?R.includes(z):typeof z=="string"&&typeof R=="object"&&R!==null?P.call(R,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(k){return k.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$Si=y;class u{static create(k,R){return new u(k,R)}constructor(k,R){this.d=k,this.f=R,this.type=11,this.c=y.create(k,R)}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(k){return k.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=u;class ${static create(k,R,z=null){if(typeof R=="boolean")return R?j.create(k,z):o.create(k,z);const F=C.get(k);return typeof F=="boolean"?R===(F?"true":"false")?t.INSTANCE:r.INSTANCE:new $(k,R,z)}constructor(k,R,z){this.c=k,this.d=R,this.f=z,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:ne(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=C.get(this.c);if(typeof k=="boolean"){const R=k?"true":"false";return this.d===R?t.INSTANCE:r.INSTANCE}return this}evaluate(k){return k.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(k){return k.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ui=$;class j{static create(k,R=null){const z=C.get(k);return typeof z=="boolean"?z?t.INSTANCE:r.INSTANCE:new j(k,R)}constructor(k,R){this.c=k,this.d=R,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,k.c)}equals(k){return k.type===this.type?this.c===k.c:!1}substituteConstants(){const k=C.get(this.c);return typeof k=="boolean"?k?t.INSTANCE:r.INSTANCE:this}evaluate(k){return!k.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(k){return k.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.$Vi=j;function M(B,k){if(typeof B=="string"){const R=parseFloat(B);isNaN(R)||(B=R)}return typeof B=="string"||typeof B=="number"?k(B):t.INSTANCE}class T{static create(k,R,z=null){return M(R,F=>new T(k,F,z))}constructor(k,R,z){this.c=k,this.d=R,this.f=z,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:ne(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Wi=T;class U{static create(k,R,z=null){return M(R,F=>new U(k,F,z))}constructor(k,R,z){this.c=k,this.d=R,this.f=z,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:ne(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Xi=U;class q{static create(k,R,z=null){return M(R,F=>new q(k,F,z))}constructor(k,R,z){this.c=k,this.d=R,this.f=z,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:ne(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Yi=q;class Y{static create(k,R,z=null){return M(R,F=>new Y(k,F,z))}constructor(k,R,z){this.c=k,this.d=R,this.f=z,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:ne(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Zi=Y;class J{static create(k,R){return new J(k,R)}constructor(k,R){this.d=k,this.f=R,this.type=7,this.c=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.d<k.d)return-1;if(this.d>k.d)return 1;const R=this.f?this.f.source:"",z=k.f?k.f.source:"";return R<z?-1:R>z?1:0}equals(k){if(k.type===this.type){const R=this.f?this.f.source:"",z=k.f?k.f.source:"";return this.d===k.d&&R===z}return!1}substituteConstants(){return this}evaluate(k){const R=k.getValue(this.d);return this.f?this.f.test(R):!1}serialize(){const k=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${k}`}keys(){return[this.d]}map(k){return k.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$1i=J;class x{static create(k){return new x(k)}constructor(k){this.c=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(k){return new x(this.c.map(k))}negate(){return this.c}}e.$2i=x;function W(B){let k=null;for(let R=0,z=B.length;R<z;R++){const F=B[R].substituteConstants();if(B[R]!==F&&k===null){k=[];for(let G=0;G<R;G++)k[G]=B[G]}k!==null&&(k[R]=F)}return k===null?B:k}class Q{static create(k,R,z){return Q.d(k,R,z)}constructor(k,R){this.expr=k,this.c=R,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let R=0,z=this.expr.length;R<z;R++){const F=i(this.expr[R],k.expr[R]);if(F!==0)return F}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let R=0,z=this.expr.length;R<z;R++)if(!this.expr[R].equals(k.expr[R]))return!1;return!0}return!1}substituteConstants(){const k=W(this.expr);return k===this.expr?this:Q.create(k,this.c,!1)}evaluate(k){for(let R=0,z=this.expr.length;R<z;R++)if(!this.expr[R].evaluate(k))return!1;return!0}static d(k,R,z){const F=[];let G=!1;for(const Z of k)if(Z){if(Z.type===1){G=!0;continue}if(Z.type===0)return t.INSTANCE;if(Z.type===6){F.push(...Z.expr);continue}F.push(Z)}if(F.length===0&&G)return r.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(i);for(let Z=1;Z<F.length;Z++)F[Z-1].equals(F[Z])&&(F.splice(Z,1),Z--);if(F.length===1)return F[0];for(;F.length>1;){const Z=F[F.length-1];if(Z.type!==9)break;F.pop();const re=F.pop(),le=F.length===0,ue=H.create(Z.expr.map(he=>Q.create([he,re],null,z)),null,le);ue&&(F.push(ue),F.sort(i))}if(F.length===1)return F[0];if(z){for(let Z=0;Z<F.length;Z++)for(let re=Z+1;re<F.length;re++)if(F[Z].negate().equals(F[re]))return t.INSTANCE;if(F.length===1)return F[0]}return new Q(F,R)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const R of this.expr)k.push(...R.keys());return k}map(k){return new Q(this.expr.map(R=>R.map(k)),null)}negate(){if(!this.c){const k=[];for(const R of this.expr)k.push(R.negate());this.c=H.create(k,this,!0)}return this.c}}e.$3i=Q;class H{static create(k,R,z){return H.d(k,R,z)}constructor(k,R){this.expr=k,this.c=R,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let R=0,z=this.expr.length;R<z;R++){const F=i(this.expr[R],k.expr[R]);if(F!==0)return F}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let R=0,z=this.expr.length;R<z;R++)if(!this.expr[R].equals(k.expr[R]))return!1;return!0}return!1}substituteConstants(){const k=W(this.expr);return k===this.expr?this:H.create(k,this.c,!1)}evaluate(k){for(let R=0,z=this.expr.length;R<z;R++)if(this.expr[R].evaluate(k))return!0;return!1}static d(k,R,z){let F=[],G=!1;if(k){for(let Z=0,re=k.length;Z<re;Z++){const le=k[Z];if(le){if(le.type===0){G=!0;continue}if(le.type===1)return r.INSTANCE;if(le.type===9){F=F.concat(le.expr);continue}F.push(le)}}if(F.length===0&&G)return t.INSTANCE;F.sort(i)}if(F.length!==0){if(F.length===1)return F[0];for(let Z=1;Z<F.length;Z++)F[Z-1].equals(F[Z])&&(F.splice(Z,1),Z--);if(F.length===1)return F[0];if(z){for(let Z=0;Z<F.length;Z++)for(let re=Z+1;re<F.length;re++)if(F[Z].negate().equals(F[re]))return r.INSTANCE;if(F.length===1)return F[0]}return new H(F,R)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const R of this.expr)k.push(...R.keys());return k}map(k){return new H(this.expr.map(R=>R.map(k)),null)}negate(){if(!this.c){const k=[];for(const R of this.expr)k.push(R.negate());for(;k.length>1;){const R=k.shift(),z=k.shift(),F=[];for(const G of K(R))for(const Z of K(z))F.push(Q.create([G,Z],null,!1));k.unshift(H.create(F,null,!1))}this.c=H.create(k,this,!0)}return this.c}}e.$4i=H;class V extends o{static{this.d=[]}static all(){return V.d.values()}constructor(k,R,z){super(k,null),this.f=R,typeof z=="object"?V.d.push({...z,key:k}):z!==!0&&V.d.push({key:k,description:z,type:R!=null?typeof R:void 0})}bindTo(k){return k.createKey(this.key,this.f)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return v.create(this.key,k)}notEqualsTo(k){return $.create(this.key,k)}}e.$5i=V,e.$6i=(0,A.$Nh)("contextKeyService");function ee(B,k){return B<k?-1:B>k?1:0}function ne(B,k,R,z){return B<R?-1:B>R?1:k<z?-1:k>z?1:0}function _(B,k){if(B.type===0||k.type===1)return!0;if(B.type===9)return k.type===9?ie(B.expr,k.expr):!1;if(k.type===9){for(const R of k.expr)if(_(B,R))return!0;return!1}if(B.type===6){if(k.type===6)return ie(k.expr,B.expr);for(const R of B.expr)if(_(R,k))return!0;return!1}return B.equals(k)}e.$7i=_;function ie(B,k){let R=0,z=0;for(;R<B.length&&z<k.length;){const F=B[R].cmp(k[z]);if(F<0)return!1;F===0&&R++,z++}return R===B.length}function K(B){return B.type===9?B.expr:[B]}}),define(oe[95],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=e.ID=void 0,e.ID="diagnosticsService",e.$nm=(0,D.$Nh)(e.ID);function N(A){return!!A.hostName&&!!A.errorMessage}e.$om=N;class L{async getPerformanceInfo(O,I){return{}}async getSystemInfo(O,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,I){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$pm=L}),define(oe[96],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0,e.$Kn=(0,D.$Nh)("downloadService")}),define(oe[14],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,D.$Nh)("environmentService"),e.$Vh=(0,D.$Oh)(e.$Uh)}),define(oe[29],ae([0,1,153,4]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$7n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=void 0,e.$Tn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Un=new RegExp(e.$Tn),e.$Vn="__web_extension",e.$Wn="skipWalkthrough",e.$Xn="extensionsSync",e.$Yn="dependecyOrPackExtensionInstall";function L(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Zn=L;function A(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$1n=A;function O(c,h){switch(c){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$2n=O;function I(c,h){return h==="web"&&!c.includes("web")}e.$3n=I;function C(c,h,m){return I(h,m)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===m?!0:d(m).includes(c)}e.$4n=C;function d(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$5n=d;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$6n=P;var E;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var b;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var l;(function(c){c.Install="install",c.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var g;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$7n=(0,N.$Nh)("extensionGalleryService");var p;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var w;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class f extends Error{constructor(h,m){super(h),this.code=m,this.name=m}}e.$8n=f,e.$9n=(0,N.$Nh)("extensionManagementService"),e.$0n="extensionsIdentifiers/disabled",e.$$n="extensionsIdentifiers/enabled",e.$_n=(0,N.$Nh)("IGlobalExtensionEnablementService"),e.$ao=(0,N.$Nh)("IExtensionTipsService"),e.$bo=(0,D.localize)(0,null),e.$co={value:e.$bo,original:"Extensions"},e.$do={value:(0,D.localize)(1,null),original:"Preferences"}}),define(oe[188],ae([0,1,3,2,30,10,92,29]),function(te,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=void 0;function C(w,f){return w?A.URI.revive(f?f.transformIncoming(w):w):void 0}function d(w,f){return f?f.transformOutgoingURI(w):w}function P(w,f){f=f||O.$Jm;const c=w.manifest;return{...(0,O.$Mm)({...w,manifest:void 0},f),manifest:c}}function E(w,f){return w?.profileLocation?(0,O.$Mm)(w,f??O.$Jm):w}function b(w,f){return f?(0,L.$5m)(w,c=>c instanceof A.URI?f.transformOutgoingURI(c):void 0):w}class l{constructor(f,c){this.a=f,this.b=c,this.onInstallExtension=D.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,c){const h=this.b(f);switch(c){case"onInstallExtension":return D.Event.map(this.onInstallExtension,m=>({...m,profileLocation:m.profileLocation?d(m.profileLocation,h):m.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,m=>m.map(S=>({...S,local:S.local?b(S.local,h):S.local,profileLocation:S.profileLocation?d(S.profileLocation,h):S.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,m=>({...m,profileLocation:m.profileLocation?d(m.profileLocation,h):m.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,m=>({...m,profileLocation:m.profileLocation?d(m.profileLocation,h):m.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,m=>b(m,h))}throw new Error("Invalid listen")}async call(f,c,h){const m=this.b(f);switch(c){case"zip":{const S=P(h[0],m),s=await this.a.zip(S);return d(s,m)}case"unzip":return this.a.unzip(C(h[0],m));case"install":return this.a.install(C(h[0],m),E(h[1],m));case"installFromLocation":return this.a.installFromLocation(C(h[0],m),C(h[1],m));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(h[0],C(h[1],m),C(h[2],m));case"getManifest":return this.a.getManifest(C(h[0],m));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(h[0]);case"installFromGallery":return this.a.installFromGallery(h[0],E(h[1],m));case"installGalleryExtensions":{const S=h[0];return this.a.installGalleryExtensions(S.map(({extension:s,options:a})=>({extension:s,options:E(a,m)??{}})))}case"uninstall":return this.a.uninstall(P(h[0],m),E(h[1],m));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(h[0],m));case"getInstalled":return(await this.a.getInstalled(h[0],C(h[1],m))).map(s=>b(s,m));case"toggleAppliationScope":{const S=await this.a.toggleAppliationScope(P(h[0],m),C(h[1],m));return b(S,m)}case"copyExtensions":return this.a.copyExtensions(C(h[0],m),C(h[1],m));case"updateMetadata":{const S=await this.a.updateMetadata(P(h[0],m),h[1],C(h[2],m));return b(S,m)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(h[0],h[1],h[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$ep=l;class g extends N.$Rc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new D.$Md),this.f=this.B(new D.$Md),this.g=this.B(new D.$Md),this.h=this.B(new D.$Md),this.j=this.B(new D.$Md),this.B(this.m.listen("onInstallExtension")(c=>this.n(this.c,{...c,source:this.r(c.source)?A.URI.revive(c.source):c.source,profileLocation:A.URI.revive(c.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(c=>this.n(this.f,c.map(h=>({...h,local:h.local?P(h.local,null):h.local,source:this.r(h.source)?A.URI.revive(h.source):h.source,profileLocation:A.URI.revive(h.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(c=>this.n(this.g,{...c,profileLocation:A.URI.revive(c.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(c=>this.n(this.h,{...c,profileLocation:A.URI.revive(c.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(c=>this.j.fire(P(c,null))))}n(f,c){f.fire(c)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const c=await this.getTargetPlatform();return f.allTargetPlatforms.some(h=>(0,I.$4n)(h,f.allTargetPlatforms,c))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(c=>A.URI.revive(c)))}unzip(f){return Promise.resolve(this.m.call("unzip",[f]))}install(f,c){return Promise.resolve(this.m.call("install",[f,c])).then(h=>P(h,null))}installFromLocation(f,c){return Promise.resolve(this.m.call("installFromLocation",[f,c])).then(h=>P(h,null))}async installExtensionsFromProfile(f,c,h){return(await this.m.call("installExtensionsFromProfile",[f,c,h])).map(S=>P(S,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,c){return Promise.resolve(this.m.call("installFromGallery",[f,c])).then(h=>P(h,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(h=>({...h,local:h.local?P(h.local,null):h.local,source:this.r(h.source)?A.URI.revive(h.source):h.source,profileLocation:A.URI.revive(h.profileLocation)}))}uninstall(f,c){return Promise.resolve(this.m.call("uninstall",[f,c]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(c=>P(c,null))}getInstalled(f=null,c){return Promise.resolve(this.m.call("getInstalled",[f,c])).then(h=>h.map(m=>P(m,null)))}updateMetadata(f,c,h){return Promise.resolve(this.m.call("updateMetadata",[f,c,h])).then(m=>P(m,null))}toggleAppliationScope(f,c){return this.m.call("toggleAppliationScope",[f,c]).then(h=>P(h,null))}copyExtensions(f,c){return this.m.call("copyExtensions",[f,c])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,c,h){const m=await this.m.call("download",[f,c,h]);return A.URI.revive(m)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$fp=g;class p{constructor(f){this.a=f}listen(f,c){throw new Error("Invalid listen")}call(f,c,h){switch(c){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$gp=p}),define(oe[97],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=void 0,e.$bp=(0,D.$Nh)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((A,O)=>te(["node-vsce-sign"],async I=>A(I),O))),this.a}async verify(A,O,I){let C;try{C=await this.b()}catch{return!1}return C.verify(A,O,I)}}e.$cp=N}),define(oe[98],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yVb=e.RecommendationsNotificationResult=e.$xVb=e.RecommendationSource=void 0;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$xVb=L;var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$yVb=(0,D.$Nh)("IExtensionRecommendationNotificationService")}),define(oe[11],ae([0,1,47,16,27,12,10,160,4,6,23,60]),function(te,e,D,N,L,A,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileKind=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileOperationResult=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileChangeType=e.$ok=e.FileOperation=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.FileSystemProviderErrorCode=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.FileSystemProviderCapabilities=e.$$j=e.FilePermission=e.FileType=e.$0j=e.$9j=void 0,e.$9j=(0,C.$Nh)("fileService");function b(_){return _.create===!0}e.$0j=b;var l;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var g;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(g||(e.FilePermission=g={}));function p(_){const ie=_;return!!ie&&typeof ie.onDidChange=="function"}e.$$j=p;var w;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function f(_){return!!(_.capabilities&2)}e.$_j=f;function c(_){return!!(_.capabilities&8)}e.$ak=c;function h(_){return!!(_.capabilities&131072)}e.$bk=h;function m(_){return!!(_.capabilities&4)}e.$ck=m;function S(_){return!!(_.capabilities&16)}e.$dk=S;function s(_){return f(_)?!!(_.capabilities&16384):!1}e.$ek=s;function a(_){return f(_)?!!(_.capabilities&32768):!1}e.$fk=a;function n(_){return!!(_.capabilities&65536)}e.$gk=n;function i(_){return!!(_.capabilities&2048)}e.$hk=i;var t;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ie,K){const B=new r(ie.toString(),K);return y(B,K),B}constructor(ie,K){super(ie),this.code=K}}e.$ik=r;function o(_,ie){return r.create(_,ie)}e.$jk=o;function v(_){return _||o((0,I.localize)(0,null),t.Unknown)}e.$kk=v;function y(_,ie){return _.name=ie?`${ie} (FileSystemError)`:"FileSystemError",_}e.$lk=y;function u(_){if(!_)return t.Unknown;if(_ instanceof r)return _.code;const ie=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!ie)return t.Unknown;switch(ie[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$mk=u;function $(_){if(_ instanceof Y)return _.fileOperationResult;switch(u(_)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$nk=$;var j;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class M{constructor(ie,K,B){this.resource=ie,this.operation=K,this.target=B}isOperation(ie){return this.operation===ie}}e.$ok=M;var T;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class U{static{this.a=null}constructor(ie,K){this.c=K,this.b=void 0,this.d=new E.$U(()=>{const B=D.$Th.forUris(()=>this.c);return B.fill(this.rawAdded.map(k=>[k,!0])),B}),this.f=new E.$U(()=>{const B=D.$Th.forUris(()=>this.c);return B.fill(this.rawUpdated.map(k=>[k,!0])),B}),this.g=new E.$U(()=>{const B=D.$Th.forUris(()=>this.c);return B.fill(this.rawDeleted.map(k=>[k,!0])),B}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const B of ie){switch(B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}this.b!==U.a&&(typeof B.cId=="number"?this.b===void 0?this.b=B.cId:this.b!==B.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(ie,...K){return this.h(ie,{includeChildren:!1},...K)}affects(ie,...K){return this.h(ie,{includeChildren:!0},...K)}h(ie,K,...B){if(!ie)return!1;const k=B.length>0;return!!((!k||B.includes(1))&&(this.d.value.get(ie)||K.includeChildren&&this.d.value.findSuperstr(ie))||(!k||B.includes(0))&&(this.f.value.get(ie)||K.includeChildren&&this.f.value.findSuperstr(ie))||(!k||B.includes(2))&&(this.g.value.findSubstr(ie)||K.includeChildren&&this.g.value.findSuperstr(ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ie){return this.b===ie}hasCorrelation(){return typeof this.b=="number"}}e.$pk=U;function q(_,ie,K){return!_||!ie||_===ie||ie.length>_.length?!1:(ie.charAt(ie.length-1)!==N.sep&&(ie+=N.sep),K?(0,L.$2e)(_,ie):_.indexOf(ie)===0)}e.$qk=q;class Y extends Error{constructor(ie,K,B){super(ie),this.fileOperationResult=K,this.options=B}}e.$rk=Y;class J extends Y{constructor(ie,K,B,k){super(ie,K,k),this.fileOperationResult=K,this.size=B}}e.$sk=J;class x extends Y{constructor(ie,K,B){super(ie,2,B),this.stat=K}}e.$tk=x;var W;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$uk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$vk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$wk="files.associations",e.$xk="files.exclude",e.$yk="files.readonlyInclude",e.$zk="files.readonlyExclude",e.$Ak="files.readonlyFromPermissions";var Q;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$Bk="";function H(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Ck=H;async function V(_,ie){if(!ie.hasProvider(O.URI.from({scheme:_.scheme})))return new Promise(K=>{const B=ie.onDidChangeFileSystemProviderRegistrations(k=>{k.scheme===_.scheme&&k.added&&(B.dispose(),K())})})}e.$Dk=V;class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ie){return(0,A.$Bf)(ie)||(ie=0),ie<ee.KB?(0,I.localize)(1,null,ie.toFixed(0)):ie<ee.MB?(0,I.localize)(2,null,(ie/ee.KB).toFixed(2)):ie<ee.GB?(0,I.localize)(3,null,(ie/ee.MB).toFixed(2)):ie<ee.TB?(0,I.localize)(4,null,(ie/ee.GB).toFixed(2)):(0,I.localize)(5,null,(ie/ee.TB).toFixed(2))}}e.$Ek=ee;function ne(_){const ie=typeof _=="string"||_?.scheme===P.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===P.Schemas.file?1024*ee.MB:ie?10*ee.MB:d.$p?50*ee.MB:1024*ee.MB}e.$Fk=ne});var X=this&&this.__param||function(te,e){return function(D,N){e(D,N,te)}};define(oe[189],ae([0,1,70,46,11]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=void 0;let A=class{constructor(I){this.a=I}async checksum(I){const C=(await this.a.readFileStream(I)).value;return new Promise((d,P)=>{const E=(0,D.createHash)("md5");(0,N.$5d)(C,{onData:b=>E.update(b.buffer),onError:b=>P(b),onEnd:()=>d(E.digest("base64").replace(/=+$/,""))})})}};e.$t8b=A,e.$t8b=A=ye([X(0,L.$9j)],A)}),define(oe[99],ae([0,1,15,8,161,11]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;async function O(P,E,b,l,g,p){let w;try{await I(P,E,b,l,g,p)}catch(f){w=f}finally{w&&g.errorTransformer&&(w=g.errorTransformer(w)),typeof w<"u"&&b.error(w),b.end()}}e.$Jp=O;async function I(P,E,b,l,g,p){C(p);const w=await P.open(E,{create:!1});try{C(p);let f=0,c=0,h=g&&typeof g.length=="number"?g.length:void 0,m=D.$ae.alloc(Math.min(g.bufferSize,typeof h=="number"?h:g.bufferSize)),S=g&&typeof g.position=="number"?g.position:0,s=0;do c=await P.read(w,S,m.buffer,s,m.byteLength-s),S+=c,s+=c,f+=c,typeof h=="number"&&(h-=c),s===m.byteLength&&(await b.write(l(m)),m=D.$ae.alloc(Math.min(g.bufferSize,typeof h=="number"?h:g.bufferSize)),s=0);while(c>0&&(typeof h!="number"||h>0)&&C(p)&&d(f,g));if(s>0){let a=s;typeof h=="number"&&(a=Math.min(s,h)),b.write(l(m.slice(0,a)))}}catch(f){throw(0,A.$kk)(f)}finally{await P.close(w)}}function C(P){if(P.isCancellationRequested)throw(0,N.$5)();return!0}function d(P,E){if(typeof E?.limits?.size=="number"&&P>E.limits.size)throw(0,A.$jk)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[49],ae([0,1,91,2,16,6,10,11]),function(te,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=e.$Qp=e.$Pp=e.$Op=e.$Np=e.$Mp=e.$Lp=void 0;function C(f){return f.recursive===!0}e.$Lp=C;class d extends N.$Rc{static{this.a=5}constructor(c,h,m,S){super(),this.h=c,this.j=h,this.m=m,this.n=S,this.c=this.B(new N.$Sc),this.f=void 0,this.g=0}s(){const c=new N.$Qc;this.c.value=c,this.b=this.r(c),this.b.setVerboseLogging(this.m),c.add(this.b.onDidChangeFile(h=>this.h(h))),c.add(this.b.onDidLogMessage(h=>this.j(h))),c.add(this.b.onDidError(h=>this.t(h)))}t(c){this.n.restartOnError?this.g<d.a&&this.f?(this.w(`restarting watcher after error: ${c}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${c}`):this.w(c)}u(c){this.g++,this.s(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.m=c,await this.b?.setVerboseLogging(c)}w(c){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${c}`})}y(c){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Mp=d;class P extends d{constructor(c,h,m){super(c,h,m,{type:"node.js",restartOnError:!1})}}e.$Np=P;class E extends d{constructor(c,h,m){super(c,h,m,{type:"universal",restartOnError:!0})}}e.$Op=E;function b(f){return f.map(c=>({type:c.type,resource:O.URI.revive(c.resource),cId:c.cId}))}e.$Pp=b;function l(f){const c=new w;for(const h of f)c.processEvent(h);return c.coalesce()}e.$Qp=l;function g(f,c){return typeof c=="string"&&!c.startsWith(D.$qj)&&!(0,L.$hc)(c)?{base:f,pattern:c}:c}e.$Rp=g;function p(f,c){const h=[];for(const m of c)h.push((0,D.$uj)(g(f,m)));return h}e.$Sp=p;class w{constructor(){this.a=new Set,this.b=new Map}c(c){return A.$l?c.resource.fsPath:c.resource.fsPath.toLowerCase()}processEvent(c){const h=this.b.get(this.c(c));let m=!1;if(h){const S=h.type,s=c.type;h.resource.fsPath!==c.resource.fsPath&&(c.type===2||c.type===1)?m=!0:S===1&&s===2?(this.b.delete(this.c(c)),this.a.delete(h)):S===2&&s===1?h.type=0:S===1&&s===0||(h.type=s)}else m=!0;m&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],h=[];return Array.from(this.a).filter(m=>m.type!==2?(c.push(m),!1):!0).sort((m,S)=>m.resource.fsPath.length-S.resource.fsPath.length).filter(m=>h.some(S=>(0,I.$qk)(m.resource.fsPath,S,!A.$l))?!1:(h.push(m.resource.fsPath),!0)).concat(c)}}}),define(oe[190],ae([0,1,15,38,8,3,2,46,32,11,49]),function(te,e,D,N,L,A,O,I,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0,e.$gN="localFilesystem";class E extends O.$Rc{constructor(l,g){super(),this.a=l,this.b=g,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$Md),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$Md),this.onDidWatchError=this.g.event,this.h=(0,C.$dg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,g){const{buffer:p}=await this.a.call("readFile",[l,g]);return p}readFileStream(l,g,p){const w=(0,I.$1d)(c=>D.$ae.concat(c.map(h=>D.$ae.wrap(h))).buffer),f=new O.$Qc;return f.add(this.a.listen("readFileStream",[l,g])(c=>{if(c instanceof D.$ae)w.write(c.buffer);else{if(c==="end")w.end();else{let h;if(c instanceof Error)h=c;else{const m=c;h=(0,d.$jk)(m.message??(0,N.$yi)(m),m.code??d.FileSystemProviderErrorCode.Unknown)}w.error(h),w.end()}f.dispose()}})),f.add(p.onCancellationRequested(()=>{w.error((0,L.$5)()),w.end(),f.dispose()})),w}writeFile(l,g,p){return this.a.call("writeFile",[l,D.$ae.wrap(g),p])}open(l,g){return this.a.call("open",[l,g])}close(l){return this.a.call("close",[l])}async read(l,g,p,w,f){const[c,h]=await this.a.call("read",[l,g,f]);return p.set(c.buffer.slice(0,h),w),h}write(l,g,p,w,f){return this.a.call("write",[l,g,D.$ae.wrap(p),w,f])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,g){return this.a.call("delete",[l,g])}rename(l,g,p){return this.a.call("rename",[l,g,p])}copy(l,g,p){return this.a.call("copy",[l,g,p])}cloneFile(l,g){return this.a.call("cloneFile",[l,g])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const g=l;this.f.fire((0,P.$Pp)(g))}else{const g=l;this.g.fire(g)}}))}watch(l,g){const p=(0,C.$dg)();return this.a.call("watch",[this.h,p,l,g]),(0,O.$Pc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$hN=E}),define(oe[191],ae([0,1,53,5,26,48,2,88,16,6,19,10,144,31,49]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class p extends O.$Rc{static{this.a=100}static{this.b=75}constructor(c,h,m,S){super(),this.m=c,this.n=h,this.r=m,this.s=S,this.c=this.B(new N.$8g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.n(s))),this.f=this.B(new N.$7g(s=>this.z(s),p.b)),this.g=(0,g.$Sp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,g.$Sp)(this.m.path,this.m.includes):void 0,this.j=new L.$Wd,this.ready=this.t()}async t(){try{const c=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await l.Promises.stat(c);this.B(await this.w(c,h.isDirectory()))}catch(c){c.code!=="ENOENT"?this.D(c):this.G(c)}}async u(c){let h=c.path;try{h=await l.Promises.realpath(c.path),c.path===h&&(h=await(0,b.$3p)(c.path)??c.path),c.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${h})`)}catch{}return h}async w(c,h){if(d.$k&&(0,A.$Wf)(c,"/Volumes/",!0))return this.D(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Rc.None;const m=new L.$Wd(this.j.token),S=new O.$Qc;try{const s=E.URI.file(this.m.path),a=(0,C.$mc)(c),n=(0,D.watch)(c);S.add((0,O.$Pc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${c}'`);const i=new Set;if(h)try{for(const r of await l.Promises.readdir(c))i.add(r)}catch(r){this.D(r)}const t=new Map;S.add((0,O.$Pc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,o)=>{this.D(`Failed to watch ${c} for changes using fs.watch() (${r}, ${o})`),this.dispose()}),n.on("change",(r,o)=>{if(m.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${o}`);let v="";if(o&&(v=o.toString(),d.$k&&(v=(0,I.$ll)(v))),!(!v||r!=="change"&&r!=="rename"))if(h)if(r==="rename"){t.get(v)?.dispose();const y=setTimeout(async()=>{if(t.delete(v),v===a&&!await l.Promises.exists(c)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.C((0,C.$ic)(c,v));if(m.token.isCancellationRequested)return;let $;u?i.has(v)?$=0:($=1,i.add(v)):(i.delete(v),$=2),this.y({resource:(0,P.$ug)(s,v),type:$,cId:this.m.correlationId})},p.a);t.set(v,(0,O.$Pc)(()=>clearTimeout(y)))}else{let y;i.has(v)?y=0:(y=1,i.add(v)),this.y({resource:(0,P.$ug)(s,v),type:y,cId:this.m.correlationId})}else if(r==="rename"||v!==a){const y=setTimeout(async()=>{const u=await l.Promises.exists(c);m.token.isCancellationRequested||(u?(this.y({resource:s,type:0,cId:this.m.correlationId},!0),S.add(await this.w(c,!1))):(this.y({resource:s,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);S.clear(),S.add((0,O.$Pc)(()=>clearTimeout(y)))}else this.y({resource:s,type:0,cId:this.m.correlationId},!0)})}catch(s){await l.Promises.exists(c)&&!m.token.isCancellationRequested&&this.D(`Failed to watch ${c} for changes using fs.watch() (${s.toString()})`)}return(0,O.$Pc)(()=>{m.dispose(!0),S.dispose()})}y(c,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`),!h&&this.g.some(m=>m(c.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${c.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(m=>m(c.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${c.resource.fsPath}`):this.f.work(c))}z(c){const h=(0,g.$Qp)(c);if(h.length>0){if(this.s)for(const S of h)this.G(` >> normalized ${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(c){if(d.$l)return l.Promises.exists(c);try{const h=(0,C.$mc)(c);return(await l.Promises.readdir((0,C.$lc)(c))).some(S=>S===h)}catch(h){return this.G(h),!1}}setVerboseLogging(c){this.s=c}D(c){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}F(c){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}G(c){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$6p=p;async function w(f,c,h,m,S=512){const s=await l.Promises.open(f,"r"),a=Buffer.allocUnsafe(S),n=new L.$Wd(m);let i,t=!1;const r={path:f,excludes:[],recursive:!1},o=new p(r,v=>{(async()=>{for(const{type:y}of v)if(y===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:u}=await l.Promises.read(s,a,0,S,null);if(!u||n.token.isCancellationRequested)break;c(a.slice(0,u))}}catch(u){i=new Error(u),n.dispose(!0)}finally{t=!1}}})()});return await o.ready,h(),new Promise((v,y)=>{n.token.onCancellationRequested(async()=>{o.dispose();try{await l.Promises.close(s)}catch(u){i=new Error(u)}i?y(i):v()})})}e.$7p=w}),define(oe[192],ae([0,1,3,91,2,6,191]),function(te,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class I extends L.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Md),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Md),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(d){const P=this.j(d),E=P.filter(l=>{const g=this.c.get(l.path);return g?!(0,N.$yj)(g.request.excludes,l.excludes)||!(0,N.$yj)(g.request.includes,l.includes):!0}),b=Array.from(this.c.values()).filter(({request:l})=>!P.find(g=>g.path===l.path&&(0,N.$yj)(g.excludes,l.excludes)&&(0,N.$yj)(g.includes,l.includes))).map(({request:l})=>l.path);E.length&&this.m(`Request to start watching: ${E.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`).join(",")}`),b.length&&this.m(`Request to stop watching: ${b.join(",")}`);for(const l of b)this.h(l);for(const l of E)this.g(l)}g(d){const P=new O.$6p(d,b=>this.a.fire(b),b=>this.b.fire(b),this.f),E={request:d,instance:P};this.c.set(d.path,E)}async stop(){for(const[d]of this.c)this.h(d);this.c.clear()}h(d){const P=this.c.get(d);P&&(this.c.delete(d),P.instance.dispose())}j(d){const P=new Map;for(const E of d){const b=A.$l?E.path:E.path.toLowerCase();let l=P.get(E.correlationId);l||(l=new Map,P.set(E.correlationId,l)),l.set(b,E)}return Array.from(P.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(d){this.f=d;for(const[,P]of this.c)P.instance.setVerboseLogging(d)}m(d){this.f&&this.b.fire({type:"trace",message:this.n(d)})}n(d,P){return P?`[File Watcher (node.js)] ${d} (path: ${P.request.path})`:`[File Watcher (node.js)] ${d}`}}e.$8p=I}),define(oe[193],ae([0,1,49,192]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class L extends D.$Np{constructor(O,I,C){super(O,I,C),this.s()}r(O){return O.add(new N.$8p)}}e.$9p=L}),define(oe[194],ae([0,1,23,42,93,49]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class O extends A.$Op{constructor(C,d,P){super(C,d,P),this.s()}r(C){const d=C.add(new L.$Zp(D.$bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(d.onDidProcessExit(({code:P,signal:E})=>this.t(`terminated by itself with code ${P}, signal: ${E}`))),N.ProxyChannel.toService((0,N.$uh)(d.getChannel("watcher")))}}e.$1p=O}),define(oe[71],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class D{constructor(...L){this.a=new Map;for(const[A,O]of L)this.set(A,O)}set(L,A){const O=this.a.get(L);return this.a.set(L,A),O}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$Lh=D}),define(oe[195],ae([0,1,5,8,2,69,186,4,71,87]),function(te,e,D,N,L,A,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;const P=!1;class E extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class b{constructor(w=new C.$Lh,f=!1,c,h=P){this.f=w,this.g=f,this.h=c,this.i=h,this.o=new Set,this.f.set(I.$Mh,this),this._globalGraph=h?c?._globalGraph??new O.$_p(m=>m):void 0}createChild(w){return new b(w,this.g,this,this.i)}invokeFunction(w,...f){const c=g.traceInvocation(this.i,w);let h=!1;try{return w({get:S=>{if(h)throw(0,N.$7)("service accessor is only valid during the invocation of its target method");const s=this.m(S,c);if(!s)throw new Error(`[invokeFunction] unknown service '${S}'`);return s}},...f)}finally{h=!0,c.stop()}}createInstance(w,...f){let c,h;return w instanceof A.$Kh?(c=g.traceCreation(this.i,w.ctor),h=this.j(w.ctor,w.staticArguments.concat(f),c)):(c=g.traceCreation(this.i,w),h=this.j(w,f,c)),c.stop(),h}j(w,f=[],c){const h=I._util.getServiceDependencies(w).sort((s,a)=>s.index-a.index),m=[];for(const s of h){const a=this.m(s.id,c);a||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${s.id}.`,!1),m.push(a)}const S=h.length>0?h[0].index:f.length;if(f.length!==S){console.trace(`[createInstance] First service dependency of ${w.name} at position ${S+1} conflicts with ${f.length} static arguments`);const s=S-f.length;s>0?f=f.concat(new Array(s)):f=f.slice(0,S)}return Reflect.construct(w,f.concat(m))}k(w,f){if(this.f.get(w)instanceof A.$Kh)this.f.set(w,f);else if(this.h)this.h.k(w,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const f=this.f.get(w);return!f&&this.h?this.h.l(w):f}m(w,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const c=this.l(w);return c instanceof A.$Kh?this.q(w,c,f.branch(w,!0)):(f.branch(w,!1),c)}q(w,f,c){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,f,c)}finally{this.o.delete(w)}}r(w,f,c){const h=new O.$_p(s=>s.id.toString());let m=0;const S=[{id:w,desc:f,_trace:c}];for(;S.length;){const s=S.pop();if(h.lookupOrInsertNode(s),m++>1e3)throw new E(h);for(const a of I._util.getServiceDependencies(s.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${w} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(a.id)),n instanceof A.$Kh){const i={id:a.id,desc:n,_trace:s._trace.branch(a.id,!0)};h.insertEdge(s,i),S.push(i)}}}for(;;){const s=h.roots();if(s.length===0){if(!h.isEmpty())throw new E(h);break}for(const{data:a}of s){if(this.l(a.id)instanceof A.$Kh){const i=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,i)}h.removeNode(a)}}return this.l(w)}s(w,f,c=[],h,m){if(this.f.get(w)instanceof A.$Kh)return this.t(w,f,c,h,m);if(this.h)return this.h.s(w,f,c,h,m);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(w,f,c=[],h,m){if(h){const S=new b(void 0,this.g,this,this.i);S.c=String(w);const s=new Map,a=new D.$0g(()=>{const n=S.j(f,c,m);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const o of t)r.apply(n,o)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let o=s.get(i);return o||(o=new d.$1c,s.set(i,o)),(y,u,$)=>{const j=o.push([y,u,$]);return(0,L.$Pc)(j)}}if(i in n)return n[i];const t=a.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return a.value[i]=t,!0},getPrototypeOf(n){return f.prototype}})}else return this.j(f,c,m)}u(w,f){if(f&&console.warn(w),this.g)throw new Error(w)}}e.$aq=b;var l;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(l||(l={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,f){return w?new g(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(w,f){return w?new g(1,f.name):g.c}static{this.f=0}constructor(w,f){this.type=w,this.name=f,this.g=Date.now(),this.h=[]}branch(w,f){const c=new g(3,w.toString());return this.h.push([w,f,c]),c}stop(){const w=Date.now()-this.g;g.f+=w;let f=!1;function c(m,S){const s=[],a=new Array(m+1).join("	");for(const[n,i,t]of S.h)if(i&&t){f=!0,s.push(`${a}CREATES -> ${n}`);const r=c(m+1,t);r&&s.push(r)}else s.push(`${a}uses -> ${n}`);return s.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(w>2||f)&&g.all.add(h.join(`
`))}}e.$bq=g}),define(oe[72],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$47b=e.$37b=void 0,e.$37b=(0,D.$Nh)("mainProcessService");class N{constructor(A,O){this.a=A,this.b=O}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,O){this.a.registerChannel(A,O)}}e.$47b=N}),define(oe[73],ae([0,1,26,2,6,163,29,4]),function(te,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=e.$Oq=void 0;function C(P){return P.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$Oq=C,e.$Pq=(0,I.$Nh)("languagePackService");let d=class extends N.$Rc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new D.$Wd;setTimeout(()=>E.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const g=b.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(w=>w.startsWith("lp-"))).map(p=>{const w=p.properties.localizedLanguages?.[0],f=C(p);return{...this.f(f,w,p),extensionId:p.identifier.id,galleryExtension:p}});return g.push(this.f("en","English")),g}f(E,b,l){const g=b??E;let p;if(g!==E&&(p=`(${E})`),E.toLowerCase()===L.$w.toLowerCase()&&(p??="",p+=(0,A.localize)(0,null)),l?.installCount){p??="";const w=l.installCount;let f;w>1e6?f=`${Math.floor(w/1e5)/10}M`:w>1e3?f=`${Math.floor(w/1e3)}K`:f=String(w),p+=` $(cloud-download) ${f}`}return{id:E,label:g,description:p}}};e.$Qq=d,e.$Qq=d=ye([X(0,O.$7n)],d)}),define(oe[196],ae([0,1,2,73]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=void 0;let L=class extends D.$Rc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$p8b=L,e.$p8b=L=ye([X(0,N.$Pq)],L)}),define(oe[7],ae([0,1,38,3,52,2,34,6,19,12,10,94,4]),function(te,e,D,N,L,A,O,I,C,d,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,b.$Nh)("logService"),e.$9i=(0,b.$Nh)("loggerService");function l(){return new Date().toISOString()}function g(y){return(0,d.$Bf)(y)}e.$0i=g;var p;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$$i=p.Info;function w(y,u,$){switch(u){case p.Trace:y.trace($);break;case p.Debug:y.debug($);break;case p.Info:y.info($);break;case p.Warning:y.warn($);break;case p.Error:y.error($);break;case p.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=w;function f(y,u=!1){let $="";for(let j=0;j<y.length;j++){let M=y[j];if(M instanceof Error&&(M=(0,D.$yi)(M,u)),typeof M=="object")try{M=JSON.stringify(M)}catch{}$+=(j>0?" ":"")+M}return $}class c extends A.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new N.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==p.Off&&this.b<=u}}e.$aj=c;class h extends c{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...$){this.f(p.Trace)&&this.g(p.Trace,f([u,...$],!0))}debug(u,...$){this.f(p.Debug)&&this.g(p.Debug,f([u,...$]))}info(u,...$){this.f(p.Info)&&this.g(p.Info,f([u,...$]))}warn(u,...$){this.f(p.Warning)&&this.g(p.Warning,f([u,...$]))}error(u,...$){if(this.f(p.Error))if(u instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=u.stack,this.g(p.Error,f(j))}else this.g(p.Error,f([u,...$]))}flush(){}}e.$bj=h;class m extends c{constructor(u=e.$$i){super(),this.setLevel(u),this.g=!I.$j}trace(u,...$){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...$):console.log(`[main ${l()}]`,u,...$))}debug(u,...$){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...$):console.log(`[main ${l()}]`,u,...$))}info(u,...$){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...$):console.log(`[main ${l()}]`,u,...$))}warn(u,...$){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,u,...$):console.warn(`[main ${l()}]`,u,...$))}error(u,...$){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,u,...$):console.error(`[main ${l()}]`,u,...$))}dispose(){}flush(){}}e.$cj=m;class S extends c{constructor(u=e.$$i,$=!0){super(),this.g=$,this.setLevel(u)}trace(u,...$){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...$):console.log(u,...$))}debug(u,...$){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...$):console.log(u,...$))}info(u,...$){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...$):console.log(u,...$))}warn(u,...$){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...$):console.log(u,...$))}error(u,...$){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...$):console.error(u,...$))}dispose(){}flush(){}}e.$dj=S;class s extends c{constructor(u,$=e.$$i){super(),this.g=u,this.setLevel($)}trace(u,...$){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(u),...$])}debug(u,...$){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(u),...$])}info(u,...$){this.f(p.Info)&&this.g.log(p.Info,[this.h(u),...$])}warn(u,...$){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(u),...$])}error(u,...$){this.f(p.Error)&&this.g.log(p.Error,[this.h(u),...$])}h(u){return typeof u=="string"?u:(0,D.$yi)(u,this.f(p.Trace))}dispose(){}flush(){}}e.$ej=s;class a extends c{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const $ of this.g)$.setLevel(u);super.setLevel(u)}trace(u,...$){for(const j of this.g)j.trace(u,...$)}debug(u,...$){for(const j of this.g)j.debug(u,...$)}info(u,...$){for(const j of this.g)j.info(u,...$)}warn(u,...$){for(const j of this.g)j.warn(u,...$)}error(u,...$){for(const j of this.g)j.error(u,...$)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose()}}e.$fj=a;class n extends A.$Rc{constructor(u,$,j){if(super(),this.h=u,this.j=$,this.b=new O.$zc,this.c=this.B(new N.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Md),this.onDidChangeVisibility=this.g.event,j)for(const M of j)this.b.set(M.resource,{logger:void 0,info:M})}m(u){return(0,d.$xf)(u)?[...this.b.values()].find($=>$.info.id===u):this.b.get(u)}getLogger(u){return this.m(u)?.logger}createLogger(u,$){const j=this.n(u),M=(0,d.$xf)(u)?u:$?.id??(0,L.$Bi)(j.toString()).toString(16);let T=this.b.get(j)?.logger;const U=$?.logLevel==="always"?p.Trace:$?.logLevel;T||(T=this.s(j,U??this.getLogLevel(j)??this.h,{...$,id:M}));const q={logger:T,info:{resource:j,id:M,logLevel:U,name:$?.name,hidden:$?.hidden,extensionId:$?.extensionId,when:$?.when}};return this.registerLogger(q.info),this.b.set(j,q),T}n(u){return(0,d.$xf)(u)?(0,C.$ug)(this.j,`${u}.log`):u}setLogLevel(u,$){if(P.URI.isUri(u)){const j=u,M=$,T=this.b.get(j);T&&M!==T.info.logLevel&&(T.info.logLevel=M===this.h?void 0:M,T.logger?.setLevel(M),this.b.set(T.info.resource,T),this.f.fire([j,M]))}else{this.h=u;for(const[j,M]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,$){const j=this.m(u);j&&$!==!j.info.hidden&&(j.info.hidden=!$,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,$]))}getLogLevel(u){let $;return u&&($=this.b.get(u)?.info.logLevel),$??this.h}registerLogger(u){const $=this.b.get(u.resource);$?$.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const $=this.b.get(u);$&&($.logger&&$.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[$.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=n;class i{constructor(){this.onDidChangeLogLevel=new N.$Md().event}setLevel(u){}getLevel(){return p.Info}trace(u,...$){}debug(u,...$){}info(u,...$){}warn(u,...$){}error(u,...$){}critical(u,...$){}dispose(){}flush(){}}e.$hj=i;class t extends i{}e.$ij=t;function r(y){if(y.verbose)return p.Trace;if(typeof y.logLevel=="string"){const u=v(y.logLevel.toLowerCase());if(u!==void 0)return u}return e.$$i}e.$jj=r;function o(y){switch(y){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$kj=o;function v(y){switch(y){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$lj=v,e.$mj=new E.$5i("logLevel",o(p.Info))}),define(oe[197],ae([0,1,5,8,2,23,16,19,31,14,7]),function(te,e,D,N,L,A,O,I,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q8b=void 0;let E=class extends L.$Rc{constructor(l,g){super(),this.a=l,this.b=g,this.B(new D.$5g(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,I.$rg)(this.a.logsHome),g=(0,I.$tg)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,f=(await C.Promises.readdir(g)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==l),c=f.slice(0,Math.max(0,f.length-9));c.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${c.join(", ")}'`),await Promise.all(c.map(h=>C.Promises.rm((0,O.$ic)(g,h)))))}catch(l){(0,N.$Z)(l)}}};e.$q8b=E,e.$q8b=E=ye([X(0,d.$Uh),X(1,P.$8i)],E)}),define(oe[198],ae([0,1,18,5,8,3,2,16,49,7]),function(te,e,D,N,L,A,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class P extends O.$Rc{constructor(b,l){super(),this.a=b,this.b=l,this.c=this.B(new A.$Md),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Md),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Qg(0)),this.w=[],this.y=this.B(new N.$Qg(0))}watch(b,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(b,l):this.z(b,l)}n(b,l){const g={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:l.recursive,correlationId:l.correlationId},p=(0,D.$Tb)(this.j,g);return this.r(),(0,O.$Pc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,L.$Z)(b))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,C.$Pp)(l)),l=>this.G(l),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const l of this.j)(0,C.$Lp)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const l of this.j)(0,C.$Lp)(l)&&b.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,l){const g={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:!1,correlationId:l.correlationId},p=(0,D.$Tb)(this.w,g);return this.C(),(0,O.$Pc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,L.$Z)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,C.$Pp)(b)),b=>this.G(b),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,I.$gc)(b.fsPath)}}e.$Tp=P}),define(oe[199],ae([0,1,18,5,15,26,3,52,59,2,47,23,100,19,46,159,11,99,7,8]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;let S=class extends d.$Rc{static{m=this}constructor(a){super(),this.b=a,this.a=256*1024,this.c=this.B(new O.$Md),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$Md),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$Md),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$Md),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$Md),this.Y=this.B(new O.$Md),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$Md),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$2g)}registerProvider(a,n){if(this.h.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${a}`);const i=new d.$Qc;return this.h.set(a,n),this.c.fire({added:!0,scheme:a,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new w.$pk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:a}))),(0,d.$Pc)(()=>{this.c.fire({added:!1,scheme:a,provider:n}),this.h.delete(a),(0,d.$Mc)(i)})}getProvider(a){return this.h.get(a)}async activateProvider(a){const n=[];this.f.fire({scheme:a,join(i){n.push(i)}}),!this.h.has(a)&&await N.Promises.settled(n)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.h.has(a.scheme)}hasCapability(a,n){const i=this.h.get(a.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return C.Iterable.map(this.h,([a,n])=>({scheme:a,capabilities:n.capabilities}))}async j(a){if(!(0,l.$yg)(a))throw new w.$rk((0,p.localize)(0,null,this.sb(a)),8);await this.activateProvider(a.scheme);const n=this.h.get(a.scheme);if(!n){const i=new h.$ab;throw i.message=(0,p.localize)(1,null,a.toString()),i}return n}async m(a){const n=await this.j(a);if((0,w.$ck)(n)||(0,w.$_j)(n)||(0,w.$dk)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(a){const n=await this.j(a);if((0,w.$ck)(n)||(0,w.$_j)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,n){try{return await this.s(a,n)}catch(i){throw(0,w.$mk)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.$rk((0,p.localize)(2,null,this.sb(a)),1):(0,w.$kk)(i)}}async s(a,n){const i=await this.j(a),t=this.S(i),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,y=await i.stat(a);let u;return this.t(i,a,y,void 0,!!v,($,j)=>(u||(u=P.$Th.forUris(()=>!t),u.set(a,!0),r&&u.fill(!0,r)),u.get($.resource)||u.findSuperstr($.resource.with({query:null,fragment:null}))?!0:$.isDirectory&&o?j===1:!1))}async t(a,n,i,t,r,o){const{providerExtUri:v}=this.R(a),y={resource:n,name:v.basename(n),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(a.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Ck)({mtime:i.mtime,size:i.size}),children:void 0};if(y.isDirectory&&o(y,t)){try{const u=await a.readdir(n),$=await N.Promises.settled(u.map(async([j,M])=>{try{const T=v.joinPath(n,j),U=r?await a.stat(T):{type:M};return await this.t(a,T,U,u.length,r,o)}catch(T){return this.b.trace(T),null}}));y.children=(0,D.$Gb)($)}catch(u){this.b.trace(u),y.children=[]}return y}return y}async resolveAll(a){return N.Promises.settled(a.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(a){const n=await this.j(a),i=await n.stat(a);return this.t(n,a,i,void 0,!0,()=>!1)}async exists(a){const n=await this.j(a);try{return!!await n.stat(a)}catch{return!1}}async canCreateFile(a,n){try{await this.u(a,n)}catch(i){return i}return!0}async u(a,n){if(!n?.overwrite&&await this.exists(a))throw new w.$rk((0,p.localize)(3,null,this.sb(a)),3,n)}async createFile(a,n=L.$ae.fromString(""),i){await this.u(a,i);const t=await this.writeFile(a,n);return this.r.fire(new w.$ok(a,0,t)),t}async writeFile(a,n,i){const t=this.qb(await this.n(a),a),{providerExtUri:r}=this.R(t);let o=i;if((0,w.$fk)(t)&&!o?.atomic){const v=t.enforceAtomicWriteFile?.(a);v&&(o={...i,atomic:v})}try{await this.w(t,a,o)||await this.U(t,r.dirname(a));let y;if((0,w.$_j)(t)&&!(n instanceof L.$ae))if((0,g.$Yd)(n)){const u=await(0,g.$6d)(n,3);u.ended?y=L.$ae.concat(u.buffer):y=u}else y=(0,g.$3d)(n,u=>L.$ae.concat(u),3);else y=n;!(0,w.$ck)(t)||(0,w.$_j)(t)&&y instanceof L.$ae||(0,w.$_j)(t)&&(0,w.$fk)(t)&&o?.atomic?await this.hb(t,a,o,y):await this.db(t,a,o,y instanceof L.$ae?(0,L.$le)(y):y),this.r.fire(new w.$ok(a,4))}catch(v){throw new w.$rk((0,p.localize)(4,null,this.sb(a),(0,w.$kk)(v).toString()),(0,w.$nk)(v),o)}return this.resolve(a,{resolveMetadata:!0})}async w(a,n,i){const t=!!i?.unlock;if(t&&!(a.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!i?.atomic){if(!(a.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(a.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(t)throw new Error((0,p.localize)(8,null,this.sb(n)))}let o;try{o=await a.stat(n)}catch{return}if(o.type&w.FileType.Directory)throw new w.$rk((0,p.localize)(9,null,this.sb(n)),0,i);if(this.rb(n,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.$Bk&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,w.$Ck)({mtime:i.mtime,size:o.size}))throw new w.$rk((0,p.localize)(10,null),3,i);return o}async readFile(a,n,i){const t=await this.m(a);return n?.atomic?this.z(t,a,n,i):this.C(t,a,n,i)}async z(a,n,i,t){return new Promise((r,o)=>{this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{try{const v=await this.C(a,n,i,t);r(v)}catch(v){o(v)}})})}async C(a,n,i,t){const r=await this.D(a,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,L.$me)(r.value)}}async readFileStream(a,n,i){const t=await this.m(a);return this.D(t,a,n,i)}async D(a,n,i,t){const r=new A.$Wd(t);let o=i;(0,w.$ek)(a)&&a.enforceAtomicReadFile?.(n)&&(o={...i,atomic:!0});const v=this.J(n,o).then(u=>u,u=>{throw r.dispose(!0),u});let y;try{return typeof o?.etag=="string"&&o.etag!==w.$Bk&&await v,o?.atomic&&(0,w.$ek)(a)||!((0,w.$ck)(a)||(0,w.$dk)(a))||(0,w.$_j)(a)&&o?.preferUnbuffered?y=this.I(a,n,o):(0,w.$dk)(a)?y=this.G(a,n,r.token,o):y=this.H(a,n,r.token,o),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await v,value:y}}catch(u){throw y&&await(0,g.$4d)(y),this.F(u,n,o)}}F(a,n,i){const t=(0,p.localize)(11,null,this.sb(n),(0,w.$kk)(a).toString());return a instanceof w.$tk?new w.$tk(t,a.stat,i):a instanceof w.$sk?new w.$sk(t,a.fileOperationResult,a.size,a.options):new w.$rk(t,(0,w.$nk)(a),i)}G(a,n,i,t=Object.create(null)){const r=a.readFileStream(n,t,i);return(0,g.$0d)(r,{data:o=>o instanceof L.$ae?o:L.$ae.wrap(o),error:o=>this.F(o,n,t)},o=>L.$ae.concat(o))}H(a,n,i,t=Object.create(null)){const r=(0,L.$qe)();return(0,f.$Jp)(a,n,r,o=>o,{...t,bufferSize:this.a,errorTransformer:o=>this.F(o,n,t)},i),r}I(a,n,i){const t=(0,g.$1d)(r=>L.$ae.concat(r));return(async()=>{try{let r;i?.atomic&&(0,w.$ek)(a)?r=await a.readFile(n,{atomic:!0}):r=await a.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(n,r.byteLength,i),t.end(L.$ae.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(a,n){const i=await this.resolve(a,{resolveMetadata:!0});if(i.isDirectory)throw new w.$rk((0,p.localize)(12,null,this.sb(a)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.$Bk&&n.etag===i.etag)throw new w.$tk((0,p.localize)(13,null),i,n);return this.L(a,i.size,n),i}L(a,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new w.$sk((0,p.localize)(14,null,this.sb(a)),7,n,i)}async canMove(a,n,i){return this.M(a,n,"move",i)}async canCopy(a,n,i){return this.M(a,n,"copy",i)}async M(a,n,i,t){if(a.toString()!==n.toString())try{const r=i==="move"?this.qb(await this.n(a),a):await this.m(a),o=this.qb(await this.n(n),n);await this.Q(r,a,o,n,i,t)}catch(r){return r}return!0}async move(a,n,i){const t=this.qb(await this.n(a),a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"move",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$ok(a,o==="move"?2:3,v)),v}async copy(a,n,i){const t=await this.m(a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"copy",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$ok(a,o==="copy"?3:2,v)),v}async N(a,n,i,t,r,o){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:y}=await this.Q(a,n,i,t,r,o);if(v&&!y&&o&&await this.del(t,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(t)),r==="copy"){if(a===i&&(0,w.$ak)(a))await a.copy(n,t,{overwrite:o});else{const u=await this.resolve(n);u.isDirectory?await this.P(a,u,i,t):await this.O(a,n,i,t)}return r}else return a===i?(await a.rename(n,t,{overwrite:o}),r):(await this.N(a,n,i,t,"copy",o),await this.del(n,{recursive:!0}),"copy")}async O(a,n,i,t){if((0,w.$ck)(a)&&(0,w.$ck)(i))return this.jb(a,n,i,t);if((0,w.$ck)(a)&&(0,w.$_j)(i))return this.pb(a,n,i,t);if((0,w.$_j)(a)&&(0,w.$ck)(i))return this.nb(a,n,i,t);if((0,w.$_j)(a)&&(0,w.$_j)(i))return this.lb(a,n,i,t)}async P(a,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async r=>{const o=this.R(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(a,await this.resolve(r.resource),i,o):this.O(a,r.resource,i,o)}))}async Q(a,n,i,t,r,o){let v=!1;if(a===i){const{providerExtUri:u,isPathCaseSensitive:$}=this.R(a);if($||(v=u.isEqual(n,t)),v&&r==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&u.isEqualOrParent(t,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(t)))}const y=await this.exists(t);if(y&&!v){if(!o)throw new w.$rk((0,p.localize)(17,null,this.sb(n),this.sb(t)),4);if(a===i){const{providerExtUri:u}=this.R(a);if(u.isEqualOrParent(n,t))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:y,isSameResourceWithDifferentPathCase:v}}R(a){const n=this.S(a);return{providerExtUri:n?l.$kg:l.$mg,isPathCaseSensitive:n}}S(a){return!!(a.capabilities&1024)}async createFolder(a){const n=this.qb(await this.j(a),a);await this.U(n,a);const i=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new w.$ok(a,0,i)),i}async U(a,n){const i=[],{providerExtUri:t}=this.R(a);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await a.stat(n)).type&w.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(r){if((0,w.$mk)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await a.mkdir(n)}catch(o){if((0,w.$mk)(o)!==w.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,n){try{await this.W(a,n)}catch(i){return i}return!0}async W(a,n){const i=this.qb(await this.j(a),a),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(a)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(a)));if(t&&r)throw new Error((0,p.localize)(22,null,this.sb(a)));let o;try{o=await i.stat(a)}catch{}if(o)this.rb(a,o);else throw new w.$rk((0,p.localize)(23,null,this.sb(a)),1);if(!!!n?.recursive){const y=await this.resolve(a);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(a)))}return i}async del(a,n){const i=await this.W(a,n);let t=n;if((0,w.$gk)(i)&&!t?.atomic){const y=i.enforceAtomicDelete?.(a);y&&(t={...n,atomic:y})}const r=!!t?.useTrash,o=!!t?.recursive,v=t?.atomic??!1;await i.delete(a,{recursive:o,useTrash:r,atomic:v}),this.r.fire(new w.$ok(a,1))}async cloneFile(a,n){const i=await this.j(a),t=this.qb(await this.n(n),n);if(i===t&&this.R(i).providerExtUri.isEqual(a,n))return;if(i===t&&(0,w.$bk)(i))return i.cloneFile(a,n);await this.U(t,this.R(t).providerExtUri.dirname(n));const r=this.cb.queueFor(a,this.R(i).providerExtUri);return i===t&&(0,w.$ak)(i)?r.queue(()=>i.copy(a,n,{overwrite:!0})):r.queue(()=>this.O(i,a,t,n))}static{this.ab=0}createWatcher(a,n){return this.watch(a,{...n,correlationId:m.ab++})}watch(a,n={recursive:!1,excludes:[]}){const i=new d.$Qc;let t=!1,r=()=>{t=!0};i.add((0,d.$Pc)(()=>r())),(async()=>{try{const v=await this.bb(a,n);t?(0,d.$Mc)(v):r=()=>(0,d.$Mc)(v)}catch(v){this.b.error(v)}})();const o=n.correlationId;if(typeof o=="number"){const v=i.add(new O.$Md);return i.add(this.X.event(u=>{u.correlates(o)&&v.fire(u)})),{onDidChange:v.event,dispose:()=>i.dispose()}}return i}async bb(a,n){const i=await this.j(a),t=(0,I.$Bi)([this.R(i).providerExtUri.getComparisonKey(a),n]);let r=this.$.get(t);return r||(r={count:0,disposable:i.watch(a,n)},this.$.set(t,r)),r.count+=1,(0,d.$Pc)(()=>{r&&(r.count--,r.count===0&&((0,d.$Mc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,a]of this.$)(0,d.$Mc)(a.disposable);this.$.clear()}async db(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{const r=await a.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,g.$Yd)(t)||(0,g.$Zd)(t)?await this.eb(a,r,t):await this.fb(a,r,t)}catch(o){throw(0,w.$kk)(o)}finally{await a.close(r)}})}async eb(a,n,i){let t=0,r;if((0,g.$Zd)(i)){if(i.buffer.length>0){const o=L.$ae.concat(i.buffer);await this.gb(a,n,o,o.byteLength,t,0),t+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,v)=>{(0,g.$5d)(r,{onData:async y=>{r.pause();try{await this.gb(a,n,y,y.byteLength,t,0)}catch(u){return v(u)}t+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>v(y),onEnd:()=>o()})})}async fb(a,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.gb(a,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(a,n,i,t,r,o){let v=0;for(;v<t;){const y=await a.write(n,r+v,i.buffer,o+v,t-v);v+=y}}async hb(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(()=>this.ib(a,n,i,t))}async ib(a,n,i,t){let r;t instanceof L.$ae?r=t:(0,g.$Yd)(t)?r=await(0,L.$me)(t):(0,g.$Zd)(t)?r=await(0,L.$ne)(t):r=(0,L.$ke)(t),await a.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.kb(a,n,i,t))}async kb(a,n,i,t){let r,o;try{r=await a.open(n,{create:!1}),o=await i.open(t,{create:!0,unlock:!1});const v=L.$ae.alloc(this.a);let y=0,u=0,$=0;do $=await a.read(r,y,v.buffer,u,v.byteLength-u),await this.gb(i,o,v,$,y,u),y+=$,u+=$,u===v.byteLength&&(u=0);while($>0)}catch(v){throw(0,w.$kk)(v)}finally{await N.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async lb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.mb(a,n,i,t))}async mb(a,n,i,t){return i.writeFile(t,await a.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.ob(a,n,i,t))}async ob(a,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const o=await a.readFile(n);await this.gb(i,r,L.$ae.wrap(o),o.byteLength,0,0)}catch(o){throw(0,w.$kk)(o)}finally{await i.close(r)}}async pb(a,n,i,t){const r=await(0,L.$me)(this.H(a,n,A.CancellationToken.None));await this.hb(i,t,void 0,r)}qb(a,n){if(a.capabilities&2048)throw new w.$rk((0,p.localize)(25,null,this.sb(n)),6);return a}rb(a,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.$rk((0,p.localize)(26,null,this.sb(a)),6)}sb(a){return a.scheme===E.Schemas.file?a.fsPath:a.toString(!0)}};e.$Kp=S,e.$Kp=S=m=ye([X(0,c.$8i)],S)}),define(oe[200],ae([0,1,53,271,5,34,15,3,48,2,16,6,19,46,31,162,11,99,198,38,194,193]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(a){console.error(`Error enabling graceful-fs: ${(0,h.$yi)(a)}`)}})();class s extends c.$Tp{static{this.I=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=I.Event.None,this.N=new A.$zc(t=>b.$lg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$l&&(this.J|=1024)),this.J}async stat(n){try{const{stat:i,symbolicLink:t}=await g.SymlinkSupport.stat(this.H(n));return{type:this.M(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await g.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let o;r.isSymbolicLink()?o=(await this.stat((0,b.$ug)(n,r.name))).type:o=this.M(r),t.push([r.name,o])}catch(o){this.a.trace(o)}})),t}catch(i){throw this.fb(i)}}M(n,i){let t;return i?.dangling?t=w.FileType.Unknown:n.isFile()?t=w.FileType.File:n.isDirectory()?t=w.FileType.Directory:t=w.FileType.Unknown,i&&(t|=w.FileType.SymbolicLink),t}async O(n){const i=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new L.$Rg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,d.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await g.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){s.I&&this.a.trace(n)}readFileStream(n,i,t){const r=(0,l.$1d)(o=>O.$ae.concat(o.map(v=>O.$ae.wrap(v))).buffer);return(0,f.$Jp)(this,n,r,o=>o.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,b.$ug)((0,b.$tg)(n),`${(0,b.$rg)(n)}${t.atomic.postfix}`),i,t):this.S(n,i,t)}async Q(n){try{const i=this.H(n),{symbolicLink:t}=await g.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async R(n,i,t,r){const o=new d.$Qc;try{o.add(await this.O(n)),o.add(await this.O(i)),await this.S(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{o.dispose()}}async S(n,i,t,r){let o;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await g.Promises.exists(v)){if(!t.overwrite)throw(0,w.$jk)((0,p.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,w.$jk)((0,p.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(o,0,i,0,i.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof o=="number"&&await this.close(o)}}static{this.Y=!0}static configureFlushOnWrite(n){s.Y=n}async open(n,i,t){const r=this.H(n);let o;(0,w.$0j)(i)&&!t&&(o=await this.O(n));let v;try{if((0,w.$0j)(i)&&i.unlock)try{const{stat:u}=await g.SymlinkSupport.stat(r);u.mode&128||await g.Promises.chmod(r,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let y;if((0,w.$0j)(i)){if(E.$j)try{await g.Promises.truncate(r,0),y="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}y||(y="w")}else y="r";v=await g.Promises.open(r,y)}catch(y){throw o?.dispose(),(0,w.$0j)(i)?await this.gb(n,y):this.fb(y)}if(this.U.set(v,0),(0,w.$0j)(i)&&this.X.set(v,n),o){const y=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,o),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),y.dispose())}return v}async close(n){const i=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&s.Y)try{await g.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.a.error(t)}return await g.Promises.close(n)}catch(t){throw this.fb(t)}finally{i&&(this.W.get(n)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,o){const v=this.Z(n,i);let y=null;try{y=(await g.Promises.read(n,t,r,o,v)).bytesRead}catch(u){throw this.fb(u)}finally{this.$(n,v,y)}return y}Z(n,i){return i===this.U.get(n)?null:i}$(n,i,t){const r=this.U.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,i,t,r,o){return(0,L.$$g)(()=>this.ab(n,i,t,r,o),100,3)}async ab(n,i,t,r,o){const v=this.Z(n,i);let y=null;try{y=(await g.Promises.write(n,t,r,o,v)).bytesWritten}catch(u){throw await this.gb(this.X.get(n),u)}finally{this.$(n,v,y)}return y}async mkdir(n){try{await g.Promises.mkdir(this.H(n))}catch(i){throw this.fb(i)}}async delete(n,i){try{const t=this.H(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,P.$ic)((0,P.$lc)(t),`${(0,P.$mc)(t)}${i.atomic.postfix}`)),await g.Promises.rm(t,g.RimRafMode.MOVE,r)}else try{await g.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let o=!1;try{const{stat:v,symbolicLink:y}=await g.SymlinkSupport.stat(t);o=v.isDirectory()&&!y}catch{}if(o)await g.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"move",t.overwrite),await g.Promises.rename(r,o)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(2,null,(0,P.$mc)(r),(0,P.$mc)((0,P.$lc)(o)),v.toString()))),this.fb(v)}}async copy(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"copy",t.overwrite),await g.Promises.copy(r,o,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(3,null,(0,P.$mc)(r),(0,P.$mc)((0,P.$lc)(o)),v.toString()))),this.fb(v)}}async bb(n,i,t,r){const o=this.H(n),v=this.H(i);let y=!1;if(!!(this.capabilities&1024)||(y=(0,C.$Vf)(o,v,!0)),y){if(t==="copy")throw(0,w.$jk)((0,p.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const $=await this.L(n);if(!$)throw(0,w.$jk)((0,p.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(i);if(j){if(!r)throw(0,w.$jk)((0,p.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);$.type&w.FileType.File&&j.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.cb(n,i,!1)}async cb(n,i,t){const r=this.H(n),o=this.H(i),v=!!(this.capabilities&1024);if((0,C.$Vf)(r,o,!v))return;const y=new d.$Qc;try{y.add(await this.O(n)),y.add(await this.O(i)),t&&await g.Promises.mkdir((0,P.$lc)(o),{recursive:!0}),await g.Promises.copyFile(r,o)}catch(u){if(u.code==="ENOENT"&&!t)return this.cb(n,i,!0);throw this.fb(u)}finally{y.dispose()}}t(n,i,t){return new m.$1p(r=>n(r),r=>i(r),t)}F(n,i,t){return new S.$9p(r=>n(r),r=>i(r),t)}fb(n){if(n instanceof w.$ik)return n;let i=n,t;switch(n.code){case"ENOENT":t=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=w.FileSystemProviderErrorCode.Unknown;break;default:t=w.FileSystemProviderErrorCode.Unknown}return(0,w.$jk)(i,t)}async gb(n,i){let t=this.fb(i);if(n&&t.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await g.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,w.$jk)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$0p=s}),define(oe[101],ae([0,1,3,2,4,7]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T8b=e.$S8b=void 0,e.$S8b=(0,L.$Nh)("sharedProcessLifecycleService");let O=class extends N.$Rc{constructor(C){super(),this.b=C,this.a=this.B(new D.$Md),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$T8b=O,e.$T8b=O=ye([X(0,A.$8i)],O)}),define(oe[201],ae([0,1,10,3,7,2]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=void 0;class O extends L.$gj{constructor(E,b,l,g,p){super(b,l,g),this.r=E,this.t=p,this.B(p.listen("onDidChangeLogLevel",E)(w=>{(0,L.$0i)(w)?super.setLogLevel(w):super.setLogLevel(D.URI.revive(w[0]),w[1])})),this.B(p.listen("onDidChangeVisibility",E)(([w,f])=>super.setVisibility(D.URI.revive(w),f))),this.B(p.listen("onDidChangeLoggers",E)(({added:w,removed:f})=>{for(const c of w)super.registerLogger({...c,resource:D.URI.revive(c.resource)});for(const c of f)super.deregisterLogger(c.resource)}))}createConsoleMainLogger(){return new L.$ej({log:(E,b)=>{this.t.call("consoleLog",[E,b])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,b){super.setLogLevel(E,b),this.t.call("setLogLevel",[E,b])}setVisibility(E,b){super.setVisibility(E,b),this.t.call("setVisibility",[this.n(E),b])}s(E,b,l){return new I(this.t,E,b,l,this.r)}static setLogLevel(E,b,l){return E.call("setLogLevel",[b,l])}}e.$8q=O;class I extends L.$bj{constructor(E,b,l,g,p){super(g?.logLevel==="always"),this.r=E,this.s=b,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[b,g,p]).then(()=>{this.u(this.n),this.m=!0})}g(E,b){const l=[[E,b]];this.m?this.u(l):this.n.push(...l)}u(E){this.r.call("log",[this.s,E])}}class C{constructor(E,b){this.a=E,this.b=b}listen(E,b){const l=this.b(E);switch(b){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(p=>this.c(p,l)),removed:[...g.removed].map(p=>this.c(p,l))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,g=>[l.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,g=>(0,L.$0i)(g)?g:[l.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${b}`)}async call(E,b,l){const g=this.b(E);switch(b){case"setLogLevel":return(0,L.$0i)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(D.URI.revive(g.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,g)))}throw new Error(`Call not found: ${b}`)}c(E,b){return{...E,resource:b.transformOutgoingURI(E.resource)}}}e.$9q=C;class d extends A.$Rc{constructor(E,b){super(),b.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(l=>b.call("setLogLevel",[l]))),b.call("getRegisteredLoggers").then(l=>{for(const g of l)E.registerLogger({...g,resource:D.URI.revive(g.resource)})}),this.B(b.listen("onDidChangeVisibility")(([l,g])=>E.setVisibility(D.URI.revive(l),g))),this.B(b.listen("onDidChangeLoggers")(({added:l,removed:g})=>{for(const p of l)E.registerLogger({...p,resource:D.URI.revive(p.resource)});for(const p of g)E.deregisterLogger(p.resource)}))}}e.$0q=d}),define(oe[202],ae([0,1,2,7]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=void 0;class L extends D.$Rc{constructor(O,I=[]){super(),this.a=new N.$fj([O,...I]),this.B(O.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...I){this.a.trace(O,...I)}debug(O,...I){this.a.debug(O,...I)}info(O,...I){this.a.info(O,...I)}warn(O,...I){this.a.warn(O,...I)}error(O,...I){this.a.error(O,...I)}flush(){this.a.flush()}}e.$yN=L}),define(oe[55],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M6b=void 0,e.$M6b=(0,D.$Nh)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=void 0,e.$en=(0,A.$Nh)("policy");class O extends L.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$Md),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const P=Object.keys(this.f).length;return this.f={...d,...this.f},P!==Object.keys(this.f).length&&await this.j(d),N.Iterable.reduce(this.g.entries(),(E,[b,l])=>({...E,[b]:l}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(d,[P,E])=>({...d,[P]:{definition:E,value:this.g.get(P)}}),{})}}e.$fn=O;class I{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$gn=I}),define(oe[203],ae([0,1,3,2,56]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7b=e.$A7b=void 0;class A{constructor(C){this.b=C,this.a=new N.$Qc}listen(C,d){switch(d){case"onDidChange":return D.Event.map(this.b.onDidChange,P=>P.reduce((E,b)=>({...E,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(C,d,P){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.$A7b=A;class O extends L.$fn{constructor(C,d){super(),this.a=d;for(const P in C){const{definition:E,value:b}=C[P];this.f[P]=E,b!==void 0&&this.g.set(P,b)}this.a.listen("onDidChange")(P=>{for(const E in P){const b=P[E];b===null?this.g.delete(E):this.g.set(E,b)}this.h.fire(Object.keys(P))})}async j(C){const d=await this.a.call("updatePolicyDefinitions",C);for(const P in d)this.g.set(P,d[P])}}e.$B7b=O}),define(oe[102],ae([0,1,6,37]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.context<"u"){const A=D.$h.vscode.context.configuration();if(A)L=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,N.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:A.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(oe[24],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,D.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"}),define(oe[204],ae([0,1,5,8,2,16,31,7,24]),function(te,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n8b=void 0;let d=class extends L.$Rc{constructor(E,b,l){super(),this.b=b,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new D.$5g(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const b=Date.now(),l=(0,A.$lc)(E),g=(0,A.$mc)(E),p=await O.Promises.readdir(l);await Promise.all(p.map(async w=>{if(w===g)return;const f=(0,A.$ic)(l,w),c=await O.Promises.stat(f);if(c.isDirectory()&&b-c.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),O.Promises.rm(f)}))}catch(b){(0,N.$Z)(b)}}};e.$n8b=d,e.$n8b=d=ye([X(1,C.$nj),X(2,I.$8i)],d)}),define(oe[205],ae([0,1,5,8,2,16,31,14,7,24]),function(te,e,D,N,L,A,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o8b=void 0;let P=class extends L.$Rc{constructor(b,l,g){super(),this.b=b,this.c=l,this.f=g,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.$5g(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const b=Object.create(null),l=JSON.parse(await O.Promises.readFile((0,A.$ic)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const c of Object.keys(l)){const h=l[c];b[`${h.hash}.${c}`]=!0}const g=(0,A.$ic)(this.b.userDataPath,"clp");if(!await O.Promises.exists(g))return;const w=await O.Promises.readdir(g);for(const c of w){if(b[c]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${c}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${c}`),await O.Promises.rm((0,A.$ic)(g,c))}const f=Date.now();for(const c of Object.keys(b)){const h=(0,A.$ic)(g,c),m=await O.Promises.readdir(h);for(const S of m){if(S==="tcf.json")continue;const s=(0,A.$ic)(h,S),a=await O.Promises.stat(s);a.isDirectory()&&f-a.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$ic)(c,S)}`),await O.Promises.rm(s))}}}catch(b){(0,N.$Z)(b)}}};e.$o8b=P,e.$o8b=P=ye([X(0,I.$Vh),X(1,C.$8i),X(2,d.$nj)],P)}),define(oe[206],ae([0,1,16,4]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$SE=void 0,e.$SE=(0,N.$Nh)("IV8InspectProfilingService");var L;(function(A){function O(C){return!!(C.samples&&C.timeDeltas)}A.isValidProfile=O;function I(C,d="noAbsolutePaths"){for(const P of C.nodes)P.callFrame&&P.callFrame.url&&((0,D.$hc)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,D.$ic)(d,(0,D.$mc)(P.callFrame.url)));return C}A.rewriteAbsolutePaths=I})(L||(e.Utils=L={}))}),define(oe[207],ae([0,1,32]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I8b=void 0;class N{constructor(){this.a=new Map}async startProfiling(A){const I=await(await new Promise((d,P)=>{te(["v8-inspect-profiler"],d,P)})).startProfiling({port:A.port,checkForPaused:!0}),C=(0,D.$dg)();return this.a.set(C,I),C}async stopProfiling(A){const O=this.a.get(A);if(!O)throw new Error(`UNKNOWN session '${A}'`);const I=await O.stop();return this.a.delete(A),I.profile}}e.$I8b=N}),define(oe[40],ae([0,1,127,12]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0;class L{constructor(){this.a=new Map}add(O,I){D.ok(N.$xf(O)),D.ok(N.$zf(I)),D.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,I)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$cn=new L}),define(oe[103],ae([0,1,3,40]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=void 0,e.$dn={JSONContribution:"base.contributions.json"};function L(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this.b=new D.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(C,d){this.a[L(C)]=d,this.b.fire(C)}notifySchemaChanged(C){this.b.fire(C)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;N.$cn.add(e.$dn.JSONContribution,O)}),define(oe[50],ae([0,1,18,3,12,149,20,103,40]),function(te,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.ConfigurationScope=e.$hn=e.EditPresentationTypes=void 0;var d;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$hn={Configuration:"base.contributions.configuration"};var P;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on="vscode://schemas/settings/resourceLanguage",e.$pn="vscode://schemas/settings/configurationDefaults";const E=C.$cn.as(I.$dn.JSONContribution);class b{constructor(){this.h=new Set,this.i=new N.$Md,this.onDidSchemaChange=this.i.event,this.j=new N.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$on,this.g),this.v()}registerConfiguration(s,a=!0){this.registerConfigurations([s],a)}registerConfigurations(s,a=!0){const n=new Set;this.n(s,a,n),E.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const a=new Set;this.o(s,a),E.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:s,remove:a}){const n=new Set;this.o(a,n),this.n(s,!1,n),E.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const a=new Set;this.k(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(s,a){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(a.add(r),e.$rn.test(r)){const o=this.a.get(r),v=o?.valuesSources??new Map;if(t)for(const j of Object.keys(i[r]))v.set(j,t);const y={...o?.value||{},...i[r]};this.a.set(r,{source:t,value:y,valuesSources:v});const u=(0,O.$ri)(r),$={type:"object",default:y,description:A.localize(1,null,u),$ref:e.$on,defaultDefaultValue:y,source:L.$xf(t)?void 0:t,defaultValueSource:t};n.push(...p(r)),this.d[r]=$,this.b.properties[r]=$}else{this.a.set(r,{value:i[r],source:t});const o=this.d[r];o&&(this.w(r,o),this.r(r,o))}this.m(n)}deregisterDefaultConfigurations(s){const a=new Set;this.l(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(s,a){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.a.get(t),o=L.$xf(i)?i:i?.id,v=L.$xf(r?.source)?r?.source:r?.source?.id;if(o===v)if(a.add(t),this.a.delete(t),e.$rn.test(t))delete this.d[t],delete this.b.properties[t];else{const y=this.d[t];y&&(this.w(t,y),this.r(t,y))}}this.u()}deltaConfiguration(s){let a=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),a=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),a=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const a of s)this.h.add(a);this.u()}n(s,a,n){s.forEach(i=>{this.p(i,a,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(s,a){const n=i=>{if(i.properties)for(const t in i.properties){a.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.c.indexOf(i);t!==-1&&this.c.splice(t,1)}}p(s,a=!0,n,i,t=3,r){t=L.$Gf(s.scope)?t:s.scope;const o=s.properties;if(o)for(const y in o){const u=o[y];if(a&&h(y,u)){delete o[y];continue}if(u.source=n,u.defaultDefaultValue=o[y].default,this.w(y,u),e.$rn.test(y)?u.scope=void 0:(u.scope=L.$Gf(u.scope)?t:u.scope,u.restricted=L.$Gf(u.restricted)?!!i?.includes(y):u.restricted),o[y].hasOwnProperty("included")&&!o[y].included){this.f[y]=o[y],delete o[y];continue}else this.d[y]=o[y],o[y].policy?.name&&this.e.set(o[y].policy.name,y);!o[y].deprecationMessage&&o[y].markdownDeprecationMessage&&(o[y].deprecationMessage=o[y].markdownDeprecationMessage),r.add(y)}const v=s.allOf;if(v)for(const y of v)this.p(y,a,n,i,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const a=n=>{const i=n.properties;if(i)for(const r in i)this.r(r,i[r]);n.allOf?.forEach(a)};a(s)}r(s,a){switch(e.$in.properties[s]=a,a.scope){case 1:e.$jn.properties[s]=a;break;case 2:e.$kn.properties[s]=a;break;case 6:e.$ln.properties[s]=a;break;case 3:e.$mn.properties[s]=a;break;case 4:e.$nn.properties[s]=a;break;case 5:e.$nn.properties[s]=a,this.g.properties[s]=a;break}}s(s,a){switch(delete e.$in.properties[s],a.scope){case 1:delete e.$jn.properties[s];break;case 2:delete e.$kn.properties[s];break;case 6:delete e.$ln.properties[s];break;case 3:delete e.$mn.properties[s];break;case 4:case 5:delete e.$nn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const a=`[${s}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$on};this.w(a,n),e.$in.properties[a]=n,e.$jn.properties[a]=n,e.$kn.properties[a]=n,e.$ln.properties[a]=n,e.$mn.properties[a]=n,e.$nn.properties[a]=n}}v(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$on};e.$in.patternProperties[e.$qn]=s,e.$jn.patternProperties[e.$qn]=s,e.$kn.patternProperties[e.$qn]=s,e.$ln.patternProperties[e.$qn]=s,e.$mn.patternProperties[e.$qn]=s,e.$nn.patternProperties[e.$qn]=s,this.i.fire()}w(s,a){const n=this.a.get(s);let i=n?.value,t=n?.source;L.$Ef(i)&&(i=a.defaultDefaultValue,t=void 0),L.$Ef(i)&&(i=f(a.type)),a.default=i,a.defaultValueSource=t}}const l="\\[([^\\]]+)\\]",g=new RegExp(l,"g");e.$qn=`^(${l})+$`,e.$rn=new RegExp(e.$qn);function p(S){const s=[];if(e.$rn.test(S)){let a=g.exec(S);for(;a?.length;){const n=a[1].trim();n&&s.push(n),a=g.exec(S)}}return(0,D.$Lb)(s)}e.$sn=p;function w(S){return S.reduce((s,a)=>`${s}[${a}]`,"")}e.$tn=w;function f(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$un=f;const c=new b;C.$cn.add(e.$hn.Configuration,c);function h(S,s){return S.trim()?e.$rn.test(S)?A.localize(7,null,S):c.getConfigurationProperties()[S]!==void 0?A.localize(8,null,S):s.policy?.name&&c.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,S,s.policy?.name,c.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.$vn=h;function m(){const S=[],s=c.getConfigurationProperties();for(const a of Object.keys(s))S.push([a,s[a].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.$wn=m}),define(oe[74],ae([0,1,18,3,35,2,34,30,12,10,20,50,40]),function(te,e,D,N,L,A,O,I,C,d,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=void 0;function l(a){return Object.isFrozen(a)?a:I.$4m(a)}class g{constructor(n={},i=[],t=[],r){this.b=n,this.c=i,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof g)return i;const t=new p("");return t.parseRaw(i),t.configurationModel});this.f=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.$pi)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,o=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:o}}getOverrideValue(n,i){const t=this.i(i);return t?n?(0,P.$pi)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return D.$Lb(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return D.$Lb(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=I.$3m(this.contents),t=I.$3m(this.overrides),r=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const v of n)if(o.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(i,v.contents);for(const y of v.overrides){const[u]=t.filter($=>D.$tb($.identifiers,y.identifiers));u?(this.h(u.contents,y.contents),u.keys.push(...y.keys),u.keys=D.$Lb(u.keys)):t.push(I.$3m(y))}for(const y of v.keys)r.indexOf(y)===-1&&r.push(y)}return new g(i,r,t,o.every(v=>v instanceof g)?void 0:o)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of D.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[r];const v=i[r];v&&(typeof o=="object"&&typeof v=="object"?(o=I.$3m(o),this.h(o,v)):o=v),t[r]=o}return new g(t,this.keys,this.overrides)}h(n,i){for(const t of Object.keys(i)){if(t in n&&C.$zf(n[t])&&C.$zf(i[t])){this.h(n[t],i[t]);continue}n[t]=I.$3m(i[t])}}i(n){let i=null,t=null;const r=o=>{o&&(t?this.h(t,o):t=I.$3m(o))};for(const o of this.overrides)o.identifiers.length===1&&o.identifiers[0]===n?i=o.contents:o.identifiers.includes(n)&&r(o.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,P.$oi)(this.contents,n),E.$rn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>D.$tb(t.identifiers,(0,E.$sn)(n))),1))}j(n,i,t){(0,P.$ni)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),E.$rn.test(n)&&this.overrides.push({identifiers:(0,E.$sn)(n),keys:Object.keys(this.contents[n]),contents:(0,P.$mi)(this.contents[n],r=>console.error(r))})}}e.$xn=g;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!C.$Gf(n)){const t=this.g(n);this.parseRaw(t,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:t,keys:r,overrides:o,restricted:v,hasExcludedProperties:y}=this.h(n,i);this.b=new g(t,r,o,y?[n]:void 0),this.c=v||[]}g(n){let i={},t=null,r=[];const o=[],v=[];function y($){Array.isArray(r)?r.push($):t!==null&&(r[t]=$)}const u={onObjectBegin:()=>{const $={};y($),o.push(r),r=$,t=null},onObjectProperty:$=>{t=$},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const $=[];y($),o.push(r),r=$,t=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:y,onError:($,j,M)=>{v.push({error:$,offset:j,length:M})}};if(n)try{L.$Zm(n,u),i=r[0]||{}}catch($){console.error(`Error while parsing settings file ${this.f}: ${$}`),this.d=[$]}return i}h(n,i){const t=b.$cn.as(E.$hn.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,i);n=r.raw;const o=(0,P.$mi)(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),v=Object.keys(n),y=this.j(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:o,keys:v,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,i,t,r){let o=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:o};const v={},y=[];for(const u in n)if(E.$rn.test(u)&&t){const $=this.i(n[u],i,!1,r);v[u]=$.raw,o=o||$.hasExcludedProperties,y.push(...$.restricted)}else{const $=i[u],j=$?typeof $.scope<"u"?$.scope:3:void 0;$?.restricted&&y.push(u),!r.exclude?.includes(u)&&(r.include?.includes(u)||(j===void 0||r.scopes===void 0||r.scopes.includes(j))&&!(r.skipRestricted&&$?.restricted))?v[u]=n[u]:o=!0}return{raw:v,restricted:y,hasExcludedProperties:o}}j(n,i){const t=[];for(const r of Object.keys(n))if(E.$rn.test(r)){const o={};for(const v in n[r])o[v]=n[r][v];t.push({identifiers:(0,E.$sn)(r),keys:Object.keys(o),contents:(0,P.$mi)(o,i)})}return t}}e.$yn=p;class w extends A.$Rc{constructor(n,i,t,r){super(),this.c=n,this.f=i,this.g=r,this.b=this.B(new N.$Md),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,o=>o.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zn=w;class f{constructor(n,i,t,r,o,v,y,u,$,j,M,T,U){this.a=n,this.b=i,this.c=t,this.overrideIdentifiers=r,this.d=o,this.f=v,this.g=y,this.h=u,this.i=$,this.j=j,this.k=M,this.l=T,this.m=U}get value(){return l(this.c)}n(n,i,t){const r=n.inspect(i,t);return{get value(){return l(r.value)},get override(){return l(r.override)},get merged(){return l(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(n,i,t,r,o=new g,v=new g,y=new O.$zc,u=new g,$=new O.$zc){this.c=n,this.d=i,this.f=t,this.g=r,this.h=o,this.i=v,this.j=y,this.l=u,this.m=$,this.a=null,this.b=new O.$zc,this.n=null}getValue(n,i,t){return this.q(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new g,this.m.set(t.resource,r))):r=this.l,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this.a=null)}inspect(n,i,t){const r=this.q(n,i,t),o=this.u(i.resource,t),v=i.resource?this.m.get(i.resource)||this.l:this.l,y=new Set;for(const u of r.overrides)for(const $ of u.identifiers)r.getOverrideValue(n,$)!==void 0&&y.add($);return new f(n,i,r.getValue(n),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,o||void 0,v)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:o,removed:v}=S(this.c,n);i=[...r,...o,...v]}for(const r of i)for(const o of(0,E.$sn)(r)){const v=this.c.getKeysForOverrideIdentifier(o),y=n.getKeysForOverrideIdentifier(o),u=[...y.filter($=>v.indexOf($)===-1),...v.filter($=>y.indexOf($)===-1),...v.filter($=>!I.$7m(this.c.override(o).getValue($),n.override(o).getValue($)))];t.push([o,u])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=S(this.d,n),o=[...i,...t,...r];return o.length&&this.updatePolicyConfiguration(n),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=S(this.applicationConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=S(this.localUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=S(this.remoteUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=S(this.workspaceConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(n,i){const t=this.p.get(n),{added:r,updated:o,removed:v,overrides:y}=S(t,i),u=[...r,...o,...v];return(u.length||!t)&&this.updateFolderConfiguration(n,i),{keys:u,overrides:y}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:o,overrides:v}=S(i,void 0);return{keys:[...t,...r,...o],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,t){let r=this.r(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},i){let t=this.s();if(i&&n){const r=i.getFolder(n);r&&(t=this.t(r.uri)||t);const o=this.m.get(n);o&&(t=t.merge(o))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const t=this.s(),r=this.j.get(n);r?(i=t.merge(r),this.b.set(n,i)):i=t}return i}u(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:o}=this.j.get(i);return n.push([i,{contents:t,overrides:r,keys:o}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.x(n.defaults),t=this.x(n.policy),r=this.x(n.application),o=this.x(n.user),v=this.x(n.workspace),y=n.folders.reduce((u,$)=>(u.set(d.URI.revive($[0]),this.x($[1])),u),new O.$zc);return new c(i,t,r,o,new g,v,y,new g,new O.$zc)}static x(n){return new g(n.contents,n.keys,n.overrides)}}e.$An=c;function h(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,i=new Map;for(const r of a)r.keys.forEach(o=>n.add(o)),r.overrides.forEach(([o,v])=>{const y=(0,O.$wc)(i,o,new Set);v.forEach(u=>y.add(u))});const t=[];return i.forEach((r,o)=>t.push([o,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$Bn=h;class m{constructor(n,i,t,r){this.change=n,this.f=i,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of n.keys)this.affectedKeys.add(o);for(const[,o]of n.overrides)for(const v of o)this.affectedKeys.add(v);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(n,i){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const o=r+t.length;if(o>=this.d.length)return!1;const v=this.d.charCodeAt(o);if(v!==this.b&&v!==this.c)return!1;if(i){const y=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,u=this.g.getValue(n,i,this.h);return!I.$7m(y,u)}return!0}}e.$Cn=m;function S(a,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,a?.rawConfiguration),o=[],v=a?.getAllOverrideIdentifiers()||[],y=n?.getAllOverrideIdentifiers()||[];if(n){const u=y.filter($=>!v.includes($));for(const $ of u)o.push([$,n.getKeysForOverrideIdentifier($)])}if(a){const u=v.filter($=>!y.includes($));for(const $ of u)o.push([$,a.getKeysForOverrideIdentifier($)])}if(n&&a){for(const u of v)if(y.includes(u)){const $=s({contents:a.getOverrideValue(void 0,u)||{},keys:a.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});o.push([u,[...$.added,...$.removed,...$.updated]])}}return{added:i,removed:t,updated:r,overrides:o}}function s(a,n){const i=a?n?a.keys.filter(o=>n.keys.indexOf(o)===-1):[...a.keys]:[],t=n?a?n.keys.filter(o=>a.keys.indexOf(o)===-1):[...n.keys]:[],r=[];if(a&&n){for(const o of n.keys)if(a.keys.indexOf(o)!==-1){const v=(0,P.$pi)(n.contents,o),y=(0,P.$pi)(a.contents,o);I.$7m(v,y)||r.push(o)}}return{added:i,removed:t,updated:r}}}),define(oe[208],ae([0,1,18,3,2,30,12,74,50,7,56,40]),function(te,e,D,N,L,A,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=void 0;class b extends L.$Rc{constructor(){super(...arguments),this.a=this.B(new N.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new I.$xn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$cn.as(C.$hn.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:f})=>this.c(Array.from(w),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,f){this.h(w,E.$cn.as(C.$hn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new I.$xn;const w=E.$cn.as(C.$hn.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,f){const c=this.f();for(const h of w){const m=c[h],S=f[h];m!==void 0?this.b.addValue(h,m):S?this.b.addValue(h,S.default):this.b.removeValue(h)}}}e.$Dn=b;class l{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new I.$xn}async initialize(){return this.configurationModel}}e.$En=l;let g=class extends L.$Rc{get configurationModel(){return this.b}constructor(w,f,c){super(),this.c=w,this.f=f,this.g=c,this.a=this.B(new N.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new I.$xn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const f={},c=[],h=E.$cn.as(C.$hn.Configuration).getConfigurationProperties();for(const m of w){const S=h[m];if(!S){c.push(m);continue}if(S.policy){if(S.type!=="string"&&S.type!=="number"){this.g.warn(`Policy ${S.policy.name} has unsupported type ${S.type}`);continue}c.push(m),f[S.policy.name]={type:S.type}}}return(0,O.$Kf)(f)||await this.f.updatePolicyDefinitions(f),c}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const f=E.$cn.as(C.$hn.Configuration).getPolicyConfigurations(),c=(0,D.$Gb)(w.map(h=>f.get(h)));this.m(c,!0)}m(w,f){this.g.trace("PolicyConfiguration#update",w);const c=E.$cn.as(C.$hn.Configuration).getConfigurationProperties(),h=[],m=this.b.isEmpty();for(const S of w){const s=c[S]?.policy?.name;if(s){const a=this.f.getPolicyValue(s);(m?a!==void 0:!(0,A.$7m)(this.b.getValue(S),a))&&h.push([S,a])}else this.b.getValue(S)!==void 0&&h.push([S,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const S=this.b;this.b=new I.$xn;for(const s of S.keys)this.b.setValue(s,S.getValue(s));for(const[s,a]of h)a===void 0?this.b.removeValue(s):this.b.setValue(s,a);f&&this.a.fire(this.b)}}};e.$Fn=g,e.$Fn=g=ye([X(1,P.$en),X(2,d.$8i)],g)}),define(oe[209],ae([0,1,5,3,2,19,20,74,208,56]),function(te,e,D,N,L,A,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0;class P extends L.$Rc{constructor(b,l,g,p){super(),this.j=b,this.h=this.B(new N.$Md),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new C.$Dn),this.c=g instanceof d.$gn?new C.$En:this.B(new C.$Fn(this.b,g,p)),this.f=this.B(new I.$zn(this.j,{},A.$lg,l)),this.a=new I.$An(this.b.configurationModel,this.c.configurationModel,new I.$xn,new I.$xn),this.g=this.B(new D.$5g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:f})=>this.n(w,f))),this.B(this.c.onDidChangeConfiguration(w=>this.r(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,l,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new I.$An(b,l,new I.$xn,g)}getConfigurationData(){return this.a.toData()}getValue(b,l){const g=typeof b=="string"?b:void 0,p=(0,O.$ii)(b)?b:(0,O.$ii)(l)?l:{};return this.a.getValue(g,p,void 0)}updateValue(b,l,g,p){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.m(b)}m(b){const l=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(b);this.s(g,l,2)}n(b,l){const g=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(b,l);this.s(p,g,7)}r(b){const l=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(b);this.s(g,l,7)}s(b,l,g){const p=new I.$Cn(b,{data:l},this.a);p.source=g,p.sourceConfig=this.t(g),this.h.fire(p)}t(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Gn=P}),define(oe[210],ae([0,1,15,3,2,66]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkb=e.$ukb=e.$tkb=e.$skb=void 0;const O=(d,P,E)=>{const b=new Uint8Array(16);for(let p=0;p<16;p++)b[p]=Math.round(Math.random()*256);const l=(0,D.$ue)(D.$ae.wrap(b));return[`GET ws://localhost${d}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.$skb=O,e.$tkb=D.$ae.fromString(`\r
\r
`);async function I(d,P,E,b,l){d.write(D.$ae.fromString((0,e.$skb)(P,E,b)));const g=new L.$Qc;try{return await new Promise((p,w)=>{let f;g.add(d.onData(c=>{f?f=D.$ae.concat([f,c],f.byteLength+c.byteLength):f=c;const h=f.indexOf(e.$tkb);if(h===-1)return;p(d),d.pauseData();const m=f.slice(h+e.$tkb.byteLength);m.byteLength&&l.onData.fire(m)})),g.add(d.onClose(c=>w(c??new Error("socket closed")))),g.add(d.onEnd(()=>w(new Error("socket ended"))))})}catch(p){throw d.dispose(),p}finally{g.dispose()}}e.$ukb=I;class C extends L.$Rc{constructor(P,E){super(),this.g=P,this.a=this.B(new N.$Pd),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new N.$Md),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(b=>this.a.fire(b))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,E){A.SocketDiagnostics.traceSocketEvent(this,this.g,P,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$vkb=C}),define(oe[211],ae([0,1,8,4]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.RemoteAuthorityResolverErrorCode=e.$Pk=e.$Ok=e.RemoteConnectionType=e.$Nk=void 0,e.$Nk=(0,N.$Nh)("remoteAuthorityResolverService");var L;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class A{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ok=A;class O{constructor(E,b){this.host=E,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Pk=O;var I;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class C extends D.$ab{static isNotAvailable(E){return E instanceof C&&E._code===I.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof C&&E._code===I.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof C&&E._code===I.NoResolverFound}static isInvalidAuthority(E){return E instanceof C&&E._code===I.InvalidAuthority}static isHandled(E){return E instanceof C&&E.isHandled}constructor(E,b=I.Unknown,l){super(E),this._message=E,this._code=b,this._detail=l,this.isHandled=b===I.NotAvailable&&l===!0,Object.setPrototypeOf(this,C.prototype)}}e.$Qk=C;function d(P){const E=P.indexOf("+");return E===-1?P:P.substring(0,E)}e.$Rk=d}),define(oe[75],ae([0,1,23]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=void 0;function N(d){return d.scheme===D.Schemas.vscodeRemote?d.authority:void 0}e.$Sk=N;function L(d){if(!d)return;const P=d.indexOf("+");return P<0?d:d.substr(0,P)}e.$Tk=L;function A(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.$Uk=A;function O(d){const{host:P,port:E}=C(d);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:E}}e.$Vk=O;function I(d,P){let{host:E,port:b}=C(d);return typeof b>"u"&&(b=P),{host:E,port:b}}e.$Wk=I;function C(d){const P=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const E=d.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const b=d.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:d,port:void 0}}}),define(oe[44],ae([0,1,27,4,75]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.TargetPlatform=e.ExtensionType=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=void 0,e.$Wl="extensions.user.cache",e.$Xl="extensions.builtin.cache",e.$Yl="undefined_publisher",e.$Zl=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$1l=A,e.$2l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(O||(e.ExtensionType=O={}));var I;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class C{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,f){if(typeof w>"u"||w===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof w=="string"||typeof f=="string"){const c=typeof w=="string"?w:w.value,h=typeof f=="string"?f:f.value;return D.$1e(c,h)}return w._lower===f._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$3l=C;class d{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const f of w)this.add(f)}add(w){this.c.add(C.toKey(w))}delete(w){return this.c.delete(C.toKey(w))}has(w){return this.c.has(C.toKey(w))}}e.$4l=d;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(C.toKey(w))}get(w){return this.c.get(C.toKey(w))}has(w){return this.c.has(C.toKey(w))}set(w,f){this.c.set(C.toKey(w),f)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$5l=P;function E(p){return b(p)}e.$6l=E;function b(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$7l=b;function l(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$8l=l;function g(p,w){if(w){const f=`onResolveRemoteAuthority:${(0,L.$Tk)(w)}`;return!!p.activationEvents?.includes(f)}return!1}e.$9l=g,e.$0l=(0,N.$Nh)("IBuiltinExtensionsScannerService")}),define(oe[212],ae([0,1,2,44,11]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;class A extends D.$Rc{constructor(I,C,d,P,E){super(),this.a=I,this.b=C,this.c=d,this.f=E,this.B(P.onDidInstallExtensions(b=>this.g(b))),this.B(P.onDidUninstallExtension(b=>this.h(b)))}g(I){for(const C of I)C.local&&this.invalidate(C.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const C of this.a.profiles)this.c.extUri.isEqual(C.extensionsResource,I)&&await this.j(C);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,N.$Wl))}catch(C){(0,L.$nk)(C)!==1&&this.f.error(C)}}}e.$Dp=A}),define(oe[213],ae([0,1,5,15,26,8,3,2,100,61,32,66,211,75]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.PersistentConnectionEventType=e.$4k=e.$3k=e.$2k=e.ConnectionType=void 0;const g=30*1e3;var p;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function w(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(B){const k=new L.$Wd;return setTimeout(()=>k.cancel(),B),k.token}function c(B,k){if(B.isCancellationRequested||k.isCancellationRequested)return L.CancellationToken.Cancelled;const R=new L.$Wd;return B.onCancellationRequested(()=>R.cancel()),k.onCancellationRequested(()=>R.cancel()),R.token}class h{get didTimeout(){return this.c==="timedout"}constructor(k){this.c="pending",this.d=new I.$Qc,this.promise=new Promise((R,z)=>{this.f=R,this.g=z}),k.isCancellationRequested?this.h():this.d.add(k.onCancellationRequested(()=>this.h()))}registerDisposable(k){this.c==="pending"?this.d.add(k):k.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const k=new Error("Time limit reached");return k.code="ETIMEDOUT",k.syscall="connect",k}resolve(k){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(k))}reject(k){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(k))}}function m(B,k){const R=new h(k);return R.registerDisposable(B.onControlMessage(z=>{const F=JSON.parse(z.toString()),G=V(F);G?R.reject(G):R.resolve(F)})),R.promise}function S(B,k,R,z,F,G,Z,re){const le=new h(re),ue=d.$Id.create(!1);return B.info(`Creating a socket (${Z})...`),C.mark(`code/willCreateSocket/${G}`),k.connect(R,z,F,Z).then(he=>{le.didTimeout?(C.mark(`code/didCreateSocketError/${G}`),B.info(`Creating a socket (${Z}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(C.mark(`code/didCreateSocketOK/${G}`),B.info(`Creating a socket (${Z}) was successful after ${ue.elapsed()} ms.`),le.resolve(he))},he=>{C.mark(`code/didCreateSocketError/${G}`),B.info(`Creating a socket (${Z}) returned an error after ${ue.elapsed()} ms.`),B.error(he),le.reject(he)}),le.promise}function s(B,k){const R=new h(k);return B.then(z=>{R.didTimeout||R.resolve(z)},z=>{R.didTimeout||R.reject(z)}),R.promise}async function a(B,k,R,z){const F=ie(B,k);B.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let G;try{G=await S(B.logService,B.remoteSocketFactoryService,B.connectTo,(0,l.$Uk)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,w(k),`renderer-${w(k)}-${B.reconnectionToken}`,z)}catch(he){throw B.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),B.logService.error(he),he}B.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let Z,re;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(G,null),Z=B.reconnectionProtocol,re=!1):(Z=new E.$Bh({socket:G}),re=!0),B.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const le=await s(B.signService.createNewMessage((0,P.$dg)()),z),ue={type:"auth",auth:B.connectionToken||"00000000000000000000",data:le.data};Z.sendControl(N.$ae.fromString(JSON.stringify(ue)));try{const he=await m(Z,c(z,f(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(B.logService.trace(`${F} 4/6. received SignRequest control message.`),!await s(B.signService.validate(le,he.signedData),z)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await s(B.signService.sign(he.data),z),we={type:"connectionType",commit:B.commit,signedData:de,desiredConnectionType:k};return R&&(we.args=R),B.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(N.$ae.fromString(JSON.stringify(we))),{protocol:Z,ownsProtocol:re}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(B.logService.error(`${F} the handshake timed out. Error:`),B.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${F} received error control message when negotiating connection. Error:`),B.logService.error(he)),re&&H(Z),he}}async function n(B,k,R,z){const F=Date.now(),G=ie(B,k),{protocol:Z,ownsProtocol:re}=await a(B,k,R,z),le=new h(z);return le.registerDisposable(Z.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),$e=V(he);$e?(B.logService.error(`${G} received error control message when negotiating connection. Error:`),B.logService.error($e),re&&H(Z),le.reject($e)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${K(F)}!`),le.resolve({protocol:Z,firstMessage:he}))})),le.promise}async function i(B,k){const{protocol:R}=await n(B,1,void 0,k);return{protocol:R}}async function t(B,k,R){const{protocol:z,firstMessage:F}=await n(B,2,k,R),G=F&&F.debugPort;return{protocol:z,debugPort:G}}async function r(B,k,R){const z=Date.now(),F=ie(B,3),{protocol:G}=await a(B,3,k,R);return B.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${K(z)}!`),G}async function o(B,k,R){const{connectTo:z,connectionToken:F}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,connectTo:z,connectionToken:F,reconnectionToken:k,reconnectionProtocol:R,remoteSocketFactoryService:B.remoteSocketFactoryService,signService:B.signService,logService:B.logService}}async function v(B,k,R){return u(B,async z=>{const{protocol:F}=await i(z,L.CancellationToken.None);return new W(B,k,R,z.reconnectionToken,F)})}e.$2k=v;async function y(B,k){return u(B,async R=>{const{protocol:z,debugPort:F}=await t(R,k,L.CancellationToken.None);return new Q(B,k,R.reconnectionToken,z,F)})}e.$3k=y;async function u(B,k){for(let z=1;;z++)try{const F=(0,P.$dg)(),G=await o(B,F,null);return await k(G)}catch(F){if(z<5)B.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(F);else throw B.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(F),x.triggerPermanentFailure(0,0,b.$Qk.isHandled(F)),F}}async function $(B,k,R){const z=await o(B,(0,P.$dg)(),null);return await r(z,{host:k,port:R},L.CancellationToken.None)}e.$4k=$;function j(B){return(0,D.$Gg)(k=>new Promise((R,z)=>{const F=setTimeout(R,B*1e3);k.onCancellationRequested(()=>{clearTimeout(F),R()})}))}var M;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class T{constructor(k,R){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.type=0}}e.$5k=T;class U{constructor(k,R,z,F){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.durationSeconds=z,this.c=F,this.type=1}skipWait(){this.c.cancel()}}e.$6k=U;class q{constructor(k,R,z){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.attempt=z,this.type=2}}e.$7k=q;class Y{constructor(k,R,z){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.attempt=z,this.type=4}}e.$8k=Y;class J{constructor(k,R,z,F){this.reconnectionToken=k,this.millisSinceLastIncomingData=R,this.attempt=z,this.handled=F,this.type=3}}e.$9k=J;class x extends I.$Rc{static triggerPermanentFailure(k,R,z){this._permanentFailure=!0,this.f=k,this.g=R,this.h=z,this.j.forEach(F=>F.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(k=>k.y())}static debugPauseSocketWriting(){this.j.forEach(k=>k.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(k,R,z,F,G){super(),this.t=k,this.u=R,this.reconnectionToken=z,this.protocol=F,this.w=G,this.m=this.B(new O.$Md),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(F.onSocketClose(Z=>{const re=_(this.t,this.reconnectionToken,!0);Z?Z.type===0?(this.u.logService.info(`${re} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.u.logService.error(Z.error)):(this.u.logService.info(`${re} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.u.logService.error(Z.event)):this.u.logService.info(`${re} received socket close event.`),this.y()})),this.B(F.onSocketTimeout(Z=>{const re=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,I.$Pc)(()=>{const Z=x.j.indexOf(this);Z>=0&&x.j.splice(Z,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const k=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${k} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const R=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const F=z<R.length?R[z]:R[R.length-1];try{if(F>0){const Z=j(F);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,Z)),this.u.logService.info(`${k} waiting for ${F} seconds before reconnecting...`);try{await Z}catch{}}if(this.n){this.u.logService.error(`${k} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.u.logService.info(`${k} resolving connection...`);const G=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${k} connecting to ${G.connectTo}...`),await this.G(G,f(g)),this.u.logService.info(`${k} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${k} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(G),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.u.logService.error(`${k} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(G),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(b.$Qk.isTemporarilyNotAvailable(G)){this.u.logService.info(`${k} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this.u.logService.info(`${k} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(G);continue}if((0,A.$3)(G)){this.u.logService.info(`${k} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(G);continue}if(G instanceof b.$Qk){this.u.logService.error(`${k} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(G),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,b.$Qk.isHandled(G));break}this.u.logService.error(`${k} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(G),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.n&&!this.s)}C(k,R,z){this.w?x.triggerPermanentFailure(k,R,z):this.D(k,R,z)}D(k,R,z){this.m.fire(new J(this.reconnectionToken,k,R,z)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$0k=x;class W extends x{constructor(k,R,z,F,G){super(1,k,F,G,!0),this.client=this.B(new E.$zh(G,{remoteAuthority:R,clientId:z},k.ipcLogger))}async G(k,R){await i(k,R)}}e.$$k=W;class Q extends x{constructor(k,R,z,F,G){super(2,k,z,F,!1),this.H=R,this.debugPort=G}async G(k,R){await t(k,this.H,R)}}e.$_k=Q;function H(B){try{B.acceptDisconnect();const k=B.getSocket();B.dispose(),k.dispose()}catch(k){(0,A.$Z)(k)}}function V(B){if(B&&B.type==="error"){const k=new Error(`Connection error: ${B.reason}`);return k.code="VSCODE_CONNECTION_ERROR",k}return null}function ee(B,k){for(;B.length<k;)B+=" ";return B}function ne(B,k){return`[remote-connection][${ee(w(B),13)}][${k.substr(0,5)}\u2026]`}function _(B,k,R){return`${ne(B,k)}[${R?"reconnect":"initial"}]`}function ie(B,k){return`${_(k,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.connectTo}]`}function K(B){return`${Date.now()-B} ms`}}),define(oe[104],ae([0,1,2,4]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=void 0,e.$Xk=(0,N.$Nh)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(O,I){return this.a[O]??=[],this.a[O].push(I),(0,D.$Pc)(()=>{const C=this.a[O]?.indexOf(I);typeof C=="number"&&C>=0&&this.a[O]?.splice(C,1)})}b(O){return(this.a[O.type]||[]).find(C=>C.supports(O))}connect(O,I,C,d){const P=this.b(O);if(!P)throw new Error(`No socket factory found for ${O}`);return P.connect(O,I,C,d)}}e.$Yk=L}),define(oe[214],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=e.$F8b=void 0,e.$F8b=(0,D.$Nh)("sharedProcessTunnelService"),e.$G8b="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,164]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q8b=e.$P8b=e.$O8b=e.$N8b=e.$M8b=e.TunnelStates=e.$L8b=e.$K8b=void 0,e.$K8b=(0,D.$Nh)("IRemoteTunnelService"),e.$L8b={active:!1};var L;(function(A){A.disconnected=O=>({type:"disconnected",onTokenFailed:O}),A.connected=(O,I)=>({type:"connected",info:O,serviceInstallFailed:I}),A.connecting=O=>({type:"connecting",progress:O}),A.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$M8b="remote.tunnels.access",e.$N8b=e.$M8b+".hostNameOverride",e.$O8b=e.$M8b+".preventSleep",e.$P8b="remoteTunnelService",e.$Q8b=(0,N.localize)(0,null)}),define(oe[57],ae([0,1,15,8,2,166,50,4,7,40]),function(te,e,D,N,L,A,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0,e.$Po=(0,I.$Nh)("requestService");class P{constructor(S){this.b=S}toJSON(){if(!this.a){const S=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?S[s]="*****":S[s]=this.b[s];this.a=S}return this.a}}class E extends L.$Rc{constructor(S){super(),this.b=0,this.a=S.createLogger("network",{name:(0,A.localize)(0,null),when:C.$mj.isEqualTo((0,C.$kj)(C.LogLevel.Trace)).serialize()})}async c(S,s,a){const n=`${S} #${++this.b}: ${s.url}`;this.a.trace(`${n} - begin`,s.type,new P(s.headers??{}));try{const i=await a();return this.a.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,s.type,(0,N.$9)(i)),i}}}e.$Qo=E;function b(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.$Ro=b;function l(m){return m.res.statusCode===204}e.$So=l;async function g(m){return l(m)?null:(await(0,D.$me)(m.stream)).toString()}e.$To=g;async function p(m){if(!b(m))throw new Error("Server returned "+m.res.statusCode);return g(m)}e.$Uo=p;async function w(m){if(!b(m))throw new Error("Server returned "+m.res.statusCode);if(l(m))return null;const s=(await(0,D.$me)(m.stream)).toString();try{return JSON.parse(s)}catch(a){throw a.message+=`:
`+s,a}}e.$Vo=w;function f(m){h(m)}e.$Wo=f;let c;function h(m){const S=d.$cn.as(O.$hn.Configuration),s=c;c={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},S.updateConfigurations({add:[c],remove:s?[s]:[]})}h(1)}),define(oe[215],ae([0,1,26,23,11,57]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;let O=class{constructor(C,d){this.a=C,this.b=d}async download(C,d,P=D.CancellationToken.None){if(C.scheme===N.Schemas.file||C.scheme===N.Schemas.vscodeRemote){await this.b.copy(C,d);return}const E={type:"GET",url:C.toString(!0)},b=await this.a.request(E,P);if(b.res.statusCode===200)await this.b.writeFile(d,b.stream);else{const l=await(0,A.$Uo)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${l}`)}}};e.$NN=O,e.$NN=O=ye([X(0,A.$Po),X(1,L.$9j)],O)}),define(oe[216],ae([0,1,15,26]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=void 0;class L{constructor(I){this.a=I}listen(I,C){throw new Error("Invalid listen")}call(I,C,d,P=N.CancellationToken.None){switch(C){case"request":return this.a.request(d[0],P).then(async({res:E,stream:b})=>{const l=await(0,D.$me)(b);return[{statusCode:E.statusCode,headers:E.headers},l]});case"resolveProxy":return this.a.resolveProxy(d[0])}throw new Error("Invalid call")}}e.$Sq=L;class A{constructor(I){this.a=I}async request(I,C){const[d,P]=await this.a.call("request",[I],C);return{res:d,stream:(0,D.$oe)(P)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}}e.$Tq=A}),define(oe[217],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6b=e.$$6b=e.$06b=void 0,e.$06b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$$6b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$_6b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[218],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$2b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const A=await this.c();if(A){const O=String(D.a++);return this.b.set(O,A),{id:O,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const O=this.b.get(L.id);if(!O)return!1;this.b.delete(L.id);try{return O.validate(A)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$$2b=D}),define(oe[106],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=void 0,e.$Zk="signService",e.$1k=(0,D.$Nh)(e.$Zk)}),define(oe[219],ae([0,1,218]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0;class N extends D.$$2b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(O=>new O.signer().sign(A))}h(){return new Promise((A,O)=>te(["vsda"],A,O))}}e.$Y7b=N}),define(oe[76],ae([0,1,3,2]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Cb=e.$3Cb=e.$2Cb=e.$1Cb=void 0;class L extends N.$Rc{constructor(E,b,l){super(),this.a=E,this.b=b,this.c=l}async getItems(){const E={profile:this.b,workspace:this.c},b=await this.a.call("getItems",E);return new Map(b)}updateItems(E){const b={profile:this.b,workspace:this.c};return E.insert&&(b.insert=Array.from(E.insert.entries())),E.delete&&(b.delete=Array.from(E.delete.values())),this.a.call("updateItems",b)}optimize(){const E={profile:this.b,workspace:this.c};return this.a.call("optimize",E)}}class A extends L{constructor(E,b){super(E,b,void 0),this.f=this.B(new D.$Md),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class O extends A{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$1Cb=O;class I extends A{constructor(E,b){super(E,b)}async close(){this.dispose()}}e.$2Cb=I;class C extends L{constructor(E,b){super(E,void 0,b),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.$3Cb=C;class d{constructor(E){this.a=E}isUsed(E){const b={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",b)}}e.$4Cb=d}),define(oe[107],ae([0,1,6,37,32]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=void 0;function A(C){if(D.$u===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}function O(C,d,P,E,b,l,g,p){const w=Object.create(null);w["common.machineId"]=l,w.sessionID=(0,L.$dg)()+Date.now(),w.commitHash=E,w.version=b,w["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,D.$i)(D.$u),w["common.nodePlatform"]=N.$cc,w["common.nodeArch"]=P,w["common.product"]=p||"desktop",g&&(w["common.msftInternal"]=g);let f=0;const c=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),D.$m&&(w["common.snap"]="true");const h=A(d);return h&&(w["common.platformDetail"]=h),w}e.$eo=O;function I(C){const d=N.env.USERDNSDOMAIN;if(!d)return!1;const P=d.toLowerCase();return C.some(E=>P===E)}e.$fo=I}),define(oe[22],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0,e.$al=(0,D.$Nh)("telemetryService"),e.$bl=(0,D.$Nh)("customEndpointTelemetryService"),e.$cl="telemetry.currentSessionDate",e.$dl="telemetry.firstSessionDate",e.$el="telemetry.lastSessionDate",e.$fl="telemetry.machineId",e.$gl="telemetry",e.$hl="telemetry.telemetryLevel",e.$il="telemetry.enableCrashReporter",e.$jl="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(oe[220],ae([0,1,36,5,35,23,16,6,10,132,31,146,95,11,24,22]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.$Br=e.$Ar=void 0;const w=new Map;async function f(s,a){const n=`${s}::${a.join(":")}`,i=w.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,o=new Map,v=2e4;function y($,j,M,T){const U=j.substring($.length+1);return N.Promises.withAsyncBody(async q=>{let Y;try{Y=await P.Promises.readdir(j,{withFileTypes:!0})}catch{q();return}if(T.count>=v){T.count+=Y.length,T.maxReached=!0,q();return}let J=Y.length;if(J===0){q();return}let x=Y;T.count+Y.length>v&&(T.maxReached=!0,J=v-T.count,x=Y.slice(0,J)),T.count+=Y.length;for(const W of x)if(W.isDirectory()){if(M.includes(W.name)||await y($,(0,O.$ic)(j,W.name),M,T),--J===0){q();return}}else{const Q=W.name.lastIndexOf(".");if(Q>=0){const H=W.name.substring(Q+1);H&&r.set(H,(r.get(H)??0)+1)}for(const H of t)H.relativePathPattern?.test(U)!==!1&&H.filePattern.test(W.name)&&o.set(H.tag,(o.get(H.tag)??0)+1);if(--J===0){q();return}}})}const u=N.Promises.withAsyncBody(async $=>{const j={count:0,maxReached:!1};await y(s,s,a,j);const M=await m(s);$({configFiles:c(o),fileTypes:c(r),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:M})});return w.set(n,u),u}e.$Ar=f;function c(s){return Array.from(s.entries(),([a,n])=>({name:a,count:n})).sort((a,n)=>n.count-a.count)}function h(){const s={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/l.$Ek.GB).toFixed(2)}GB (${(D.freemem()/l.$Ek.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$Om.value()*100)}%`},a=D.cpus();return a&&a.length>0&&(s.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),s}e.$Br=h;async function m(s){try{const a=new Map,n=(0,O.$ic)(s,".vscode","launch.json"),i=await P.Promises.readFile(n),t=[],r=(0,L.$Sm)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$2m)(r)==="object"&&r.configurations)for(const o of r.configurations){const v=o.type;v&&(a.has(v)?a.set(v,a.get(v)+1):a.set(v,1))}return c(a)}catch{return[]}}e.$Cr=m;let S=class{constructor(a,n){this.c=a,this.d=n}f(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}g(a){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const i=D.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/l.$Ek.GB).toFixed(2)}GB (${(D.freemem()/l.$Ek.GB).toFixed(2)}GB free)`),I.$j||n.push(`Load (avg):       ${D.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(d.$Om.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,E.$zr)(a.mainPID),this.k(a)]).then(async i=>{let[t,r]=i,o=this.m(a,t);return n.forEach(v=>{if((0,b.$om)(v))o+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(o+=`

Remote: ${v.hostName}`,v.processes&&(o+=`
${this.m(a,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const y of Object.keys(v.workspaceMetadata)){const u=v.workspaceMetadata[y];let $=`${u.fileCount} files`;u.maxFilesReached&&($=`more than ${$}`),r+=`|    Folder (${y}): ${$}`,r+=this.h(u)}}}),{processInfo:o,workspaceInfo:r}})}async getSystemInfo(a,n){const{memory:i,vmHint:t,os:r,cpus:o}=h(),v={os:r,memory:i,cpus:o,vmHint:t,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return I.$j||(v.load=`${D.loadavg().map(y=>Math.round(y)).join(", ")}`),I.$l&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(a,n){const i=[];return(0,E.$zr)(a.mainPID).then(async t=>(i.push(""),i.push(this.g(a)),i.push(""),i.push(this.m(a,t)),a.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(a))),n.forEach(r=>{if((0,b.$om)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(a,r.processes)),r.workspaceMetadata)for(const o of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[o];let y=`${v.fileCount} files`;v.maxFilesReached&&(y=`more than ${y}`),i.push(`Folder (${o}): ${y}`),i.push(this.h(v))}}),i.push(""),i.push(""),i.join(`
`)))}h(a){const n=[];let t=0;const r=(u,$)=>{const j=` ${u}(${$})`;t+j.length>60?(n.push(o),o="|                 ",t=o.length):t+=j.length,o+=j};let o="|      File types:";const v=10,y=a.fileTypes.length>v?v:a.fileTypes.length;for(let u=0;u<y;u++){const $=a.fileTypes[u];r($.name,$.count)}if(n.push(o),a.configFiles.length>=0&&(o="|      Conf files:",t=0,a.configFiles.forEach(u=>{r(u.name,u.count)}),n.push(o)),a.launchConfigFiles.length>0){let u="|      Launch Configs:";a.launchConfigFiles.forEach($=>{const j=$.count>1?` ${$.name}(${$.count})`:` ${$.name}`;u+=j}),n.push(u)}return n.join(`
`)}j(a){const n=Math.max(...Object.keys(a).map(i=>i.length));return Object.keys(a).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${a[i]}`).join(`
                  `)}k(a){const n=[],i=[];return a.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const o=C.URI.revive(r);if(o.scheme===A.Schemas.file){const v=o.fsPath;i.push(f(v,["node_modules",".git"]).then(y=>{let u=`${y.fileCount} files`;y.maxFilesReached&&(u=`more than ${u}`),n.push(`|    Folder (${(0,O.$mc)(v)}): ${u}`),n.push(this.h(y))}).catch(y=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${y.toString()})`)}))}else n.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(a,n){const i=new Map;a.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),a.pidToNames.forEach(({pid:r,name:o})=>i.set(r,o));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(a.mainPID,i,t,n,0),t.join(`
`)}n(a,n,i,t,r){const o=r===0;let v;o?v=t.pid===a?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const y=process.platform==="win32"?t.mem:D.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(y/l.$Ek.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(u=>this.n(a,n,i,u,r+1))}async getWorkspaceFileExtensions(a){const n=new Set;for(const{uri:i}of a.folders){const t=C.URI.revive(i);if(t.scheme!==A.Schemas.file)continue;const r=t.fsPath;try{(await f(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const i=C.URI.revive(n);if(i.scheme!==A.Schemas.file)continue;const t=i.fsPath;try{const r=await f(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),r.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};e.$Dr=S,e.$Dr=S=ye([X(0,p.$al),X(1,g.$nj)],S)}),define(oe[108],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d7b=e.$c7b=void 0;class D{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:I,data:C}){return this.b.forEach(d=>d.log(I,C)),Promise.resolve(null)}}e.$c7b=D;class N{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$d7b=N}),define(oe[45],ae([0,1,30,12,3,20,75,107,22]),function(te,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=void 0;class d{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$go=d;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ho=P,e.$io=new P;class E{async publicLog(t,r,o){}async publicLogError(t,r,o){}}e.$jo=E,e.$ko="telemetry",e.$lo="extensionTelemetryLog",e.$mo={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,t){return L.Event.debounce(t.onDidChangeConfiguration,(o,v)=>{const y=o?new Set([...o.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:y}},1e3,!0)(o=>{o.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.$ki)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.$no=b;function l(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.$oo=l;function g(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$po=g;function p(i){const t=i.getValue(C.$hl),r=i.getValue(C.$il);if(i.getValue(C.$jl)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$qo=p;function w(i){const t={},r={},o={};h(i,o);for(let v in o){v=v.length>150?v.substr(v.length-149):v;const y=o[v];typeof y=="number"?r[v]=y:typeof y=="boolean"?r[v]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${y.length}`),t[v]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(t[v]=y)}return{properties:t,measurements:r}}e.$ro=w;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(i){if(!i)return"none";const t=(0,O.$Tk)(i);return f.has(t)?t:"other"}e.$so=c;function h(i,t,r=0,o){if(i)for(const v of Object.getOwnPropertyNames(i)){const y=i[v],u=o?o+v:v;Array.isArray(y)?t[u]=(0,D.$8m)(y):y instanceof Date?t[u]=y.toISOString():(0,N.$zf)(y)?r<2?h(y,t,r+1,u+"."):t[u]=(0,D.$8m)(y):t[u]=y}}function m(i,t){const r=i.msftInternalDomains||[],o=t.getValue("telemetry.internalTesting");return(0,I.$fo)(r)||o}e.$to=m;function S(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$uo=S;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const o=[];for(const $ of t)for(;;){const j=$.exec(i);if(!j)break;o.push([j.index,$.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(r="";;){const $=y.exec(i);if(!$)break;const j=o.some(([M,T])=>$.index<T&&M<y.lastIndex);!v.test($[0])&&!j&&(r+=i.substring(u,$.index)+"<REDACTED: user-file-path>",u=y.lastIndex)}return u<i.length&&(r+=i.substr(u)),r}function a(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,D.$5m)(i,r=>{if(r instanceof d||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let o=r.replaceAll("%20"," ");o=s(o,t);for(const v of t)o=o.replace(v,"");return o=a(o),o}})}e.$vo=n}),define(oe[33],ae([0,1,27,29,44,6,10,8,37,45]),function(te,e,D,N,L,A,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0;function P(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,D.$Ve)(n.id,i.id)===0}e.$wo=P;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,t,r)}static parse(i){const t=E.exec(i);return t&&t[1]&&t[2]?new b({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$xo=b;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(n){const i=l.exec(n);return i&&i[1]?[w(i[1]),i[2]]:[w(n),void 0]}e.$yo=g;function p(n,i){return`${n}.${i}`}e.$zo=p;function w(n){return n.toLowerCase()}e.$Ao=w;function f(n,i){return w(p(n??L.$Yl,i))}e.$Bo=f;function c(n,i){const t=[],r=o=>{for(const v of t)if(v.some(y=>P(i(y),i(o))))return v;return null};for(const o of n){const v=r(o);v?v.push(o):t.push([o])}return t}e.$Co=c;function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Do=h;function m(n){return{id:new d.$go(n.identifier.id),name:new d.$go(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Eo=m,e.$Fo=new L.$3l("pprice.better-merge");function S(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&t.every(v=>!P(v.identifier,{id:o}))){const v=n.filter(y=>P(y.identifier,{id:o}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$Go=S;async function s(n,i){if(!A.$l)return!1;let t;try{t=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){i.debug("Error while getting the os-release file.",(0,I.$9)(o))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,i){const t=await s(n,i),r=(0,N.$2n)(t?"alpine":A.$u,C.$dc);return i.debug("ComputeTargetPlatform:",r),r}e.$Ho=a}),define(oe[221],ae([0,1,18,2,19,10,11,24,5,3,16,6,37,33]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e5b=e.$d5b=void 0;let g=class extends N.$Rc{constructor(h,m){super(),this.b=h,this.c=m,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,S])=>this.a.set(S.configPath,S))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const m=[];for(const[S,s]of this.a)if(!(s.configScheme&&s.configScheme!==h.scheme))try{const a=(await this.b.readFile((0,L.$ug)(h,S))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(a))&&m.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return m}};e.$d5b=g,e.$d5b=g=ye([X(0,O.$9j),X(1,I.$nj)],g);const p="extensionTips/promptedExecutableTips",w="extensionTips/lastPromptedMediumImpExeTime";class f extends g{constructor(h,m,S,s,a,n,i,t){super(i,t),this.r=h,this.s=m,this.t=S,this.u=s,this.w=a,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,o])=>{const v=[],y=[],u=[];Object.entries(o.recommendations).forEach(([$,j])=>{j.important?o.important?v.push({extensionId:$,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):y.push({extensionId:$,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):u.push({extensionId:$,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:v}),y.length&&this.h.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:y}),u.length&&this.j.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:u})}),(0,C.$Ug)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),m=await this.O(this.h);return[...h,...m]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),m=await this.O(this.h),S=await this.u.getInstalled();this.m=this.D(h,S),this.n=this.D(m,S)}D(h,m){const S=new Map;h.forEach(t=>S.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:a}=this.N([...S.keys()],m);for(const t of s){const r=S.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of a){const r=S.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),i=new Map;for(const t of a){const r=S.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let o=i.get(r.exeName);o||(o=[],i.set(r.exeName,o)),o.push(r)}}return i}F(){if(this.m.size===0)return;const[h,m]=[...this.m.entries()][0];this.H(m).then(S=>{switch(S){case"reacted":this.M(m[0].exeName,m);break;case"ignored":this.m.delete(h);break;case"incompatibleWindow":{const s=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(s(()=>this.F()));break}case"toomany":{const s=this.B(new N.$Sc);s.value=(0,C.$Ug)(()=>{s.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),m=Date.now()-h,S=7*24*60*60*1e3;if(m<S){const n=this.B(new N.$Sc);n.value=(0,C.$Ug)(()=>{n.dispose(),this.G()},S-m);return}const[s,a]=[...this.n.entries()][0];this.H(a).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(s),this.M(a[0].exeName,a);const i=this.B(new N.$Sc);i.value=(0,C.$Ug)(()=>{i.dispose(),this.G()},S);break}case"ignored":this.n.delete(s),this.G();break;case"incompatibleWindow":{const i=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(i(()=>this.G()));break}case"toomany":{const i=this.B(new N.$Sc);i.value=(0,C.$Ug)(()=>{i.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const m=await this.u.getInstalled(1),S=h.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(a=>m.every(n=>!(0,l.$wo)(n.identifier,{id:a})))).map(({extensionId:s})=>s.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:S,source:3,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(w,-1);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(w,h,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(h,m){const S=this.L();S[h]=m.map(({extensionId:s})=>s.toLowerCase()),this.w.store(p,JSON.stringify(S),-1,0)}N(h,m){const S=[],s=[],a=m.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return h.forEach(n=>{a.has(n.toLowerCase())?S.push(n):s.push(n)}),{installed:S,uninstalled:s}}async O(h){const m=[],S=new Map;for(const s of h.keys()){const a=h.get(s);if(!a||!(0,D.$Kb)(a.recommendations))continue;const n=[];E.$j?a.windowsPath&&n.push(a.windowsPath.replace("%USERPROFILE%",()=>b.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>b.env.ProgramFiles).replace("%APPDATA%",()=>b.env.APPDATA).replace("%WINDIR%",()=>b.env.WINDIR)):(n.push((0,P.$ic)("/usr/local/bin",s)),n.push((0,P.$ic)("/usr/bin",s)),n.push((0,P.$ic)(this.r.fsPath,s)));for(const i of n){let t=S.get(i);if(t===void 0&&(t=await this.b.exists(A.URI.file(i)),S.set(i,t)),t)for(const{extensionId:r,extensionName:o,isExtensionPack:v,whenNotInstalled:y}of a.recommendations)m.push({extensionId:r,extensionName:o,isExtensionPack:v,exeName:s,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:y})}}return m}}e.$e5b=f}),define(oe[222],ae([0,1,26,33]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OVb=void 0;async function L(A,O,I,C,d){try{const P=await A.getExtensionsControlManifest();if(!P.deprecated)return;const E=await A.getInstalled(1);for(const[b,l]of Object.entries(P.deprecated)){if(!l?.extension)continue;const{id:g,autoMigrate:p,preRelease:w}=l.extension;if(!p)continue;const f=E.find(h=>(0,N.$wo)(h.identifier,{id:b}));if(!f)continue;const c=(await O.getExtensions([{id:g,preRelease:w}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!c){d.info(`Skipping migrating '${f.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{d.info(`Migrating '${f.identifier.id}' extension to '${g}' extension...`);const h=!C.getDisabledExtensions().some(S=>(0,N.$wo)(S,f.identifier));await A.uninstall(f),d.info(`Uninstalled the unsupported extension '${f.identifier.id}'`);let m=E.find(S=>(0,N.$wo)(S.identifier,{id:g}));(!m||!m.isPreReleaseVersion&&h)&&(m=await A.installFromGallery(c,{installPreReleaseVersion:!0,isMachineScoped:f.isMachineScoped,operation:4}),d.info(`Installed the pre-release extension '${m.identifier.id}'`),h||(await C.disableExtension(m.identifier),d.info(`Disabled the pre-release extension '${m.identifier.id}' because the unsupported extension '${f.identifier.id}' is disabled`)),p.storage&&(I.addToMigrationList((0,N.$zo)(f.manifest.publisher,f.manifest.name),(0,N.$zo)(m.manifest.publisher,m.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${f.identifier.id}' extension to '${g}' extension.`)}catch(h){d.error(h)}}}catch(P){d.error(P)}}e.$OVb=L}),define(oe[223],ae([0,1,3,2,34,33,44]),function(te,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;class I extends N.$Rc{constructor(d,P,E,b,l,g,p){super(),this.f=d,this.g=P,this.h=E,this.j=b,this.m=l,this.n=g,this.r=p,this.a=this.B(new D.$Md),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$Zc),this.s().then(null,w=>p.error(w))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(d=>this.u(d.added))),this.B(this.j.onAddExtensions(d=>this.w(d))),this.B(this.j.onDidAddExtensions(d=>this.y(d))),this.B(this.j.onRemoveExtensions(d=>this.z(d))),this.B(this.j.onDidRemoveExtensions(d=>this.C(d))),this.B(this.n.onDidFilesChange(d=>this.D(d)))}async u(d){try{d.length&&await Promise.all(d.map(P=>(this.c.set(P.id,(0,N.$Oc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(d){for(const P of d.extensions)this.I(this.L(P.identifier,P.version),d.profileLocation)}async y(d){for(const P of d.extensions){const E=this.L(P.identifier,P.version);d.error?this.J(E,d.profileLocation):this.I(E,d.profileLocation)}}async z(d){for(const P of d.extensions)this.J(this.L(P.identifier,P.version),d.profileLocation)}async C(d){const P=[],E=[];for(const b of d.extensions){const l=this.L(b.identifier,b.version);d.error?this.I(l,d.profileLocation):(this.J(l,d.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",b.identifier.id,b.version),E.push(this.f.scanInstalledExtensionAtLocation(b.location).then(g=>{g?P.push(g):this.r.info("Extension not found at the location",b.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(E),P.length&&await this.H(P)}catch(b){this.r.error(b)}}D(d){for(const P of this.h.profiles)d.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(d){const P=[],E=[],b=await this.j.scanProfileExtensions(d),l=new Set,g=new Set;for(const[p,w]of this.b)w.has(d)&&g.add(p);for(const p of b){const w=this.L(p.identifier,p.version);l.add(w),g.has(w)||(P.push(p.identifier),this.I(w,d))}for(const p of g)if(!l.has(p)){const w=this.M(p);w&&(E.push(w.identifier),this.J(p,d))}(P.length||E.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:d}:void 0,removed:E.length?{extensions:E,profileLocation:d}:void 0})}async G(d){const P=await this.j.scanProfileExtensions(d);for(const E of P)this.I(this.L(E.identifier,E.version),d)}async H(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}I(d,P){let E=this.b.get(d);E||this.b.set(d,E=new L.$Ac(b=>this.m.extUri.getComparisonKey(b))),E.add(P)}J(d,P){const E=this.b.get(d);E&&E.delete(P),E?.size||this.b.delete(d)}L(d,P){return`${O.$3l.toKey(d.id)}@${P}`}M(d){const[P,E]=(0,A.$yo)(d);return E?{identifier:{id:P},version:E}:void 0}}e.$Ep=I}),define(oe[224],ae([0,1,43,45]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=void 0;async function L(A,O,I,C,d,P,E){const b={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${O.nameShort})`};if((0,N.$oo)(O,I)&&(0,N.$qo)(C)===3){const l=await(0,D.$9o)(I,d,P);b["X-Market-User-Id"]=l,b["VSCode-SessionId"]=E.machineId||l}return b}e.$0o=L}),define(oe[225],ae([0,1,70,18,5,2,23,16,31,14,29,33,7,73,10]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;let p=class extends l.$Qq{constructor(h,m,S,s){super(S),this.h=h,this.j=s,this.g=this.B(new w(m,s)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(h,m){const s=(await this.g.getLanguagePacks())[m];if(!s){this.j.warn(`No language pack found for ${m}`);return}const a=s.translations[h];return a?g.URI.file(a):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),m=Object.keys(h).map(S=>{const s=h[S];return{...this.f(S,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((S,s)=>S.label.localeCompare(s.label)),m}async m(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",h.identifier.id),await this.update())}async n(h){const m=await this.g.getLanguagePacks();Object.keys(m).some(S=>m[S]&&m[S].extensions.some(s=>(0,E.$wo)(s.extensionIdentifier,h.identifier)))&&(this.j.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),S=await this.g.update(m);return!(0,N.$tb)(Object.keys(h),Object.keys(S))}};e.$Rq=p,e.$Rq=p=ye([X(0,P.$9n),X(1,d.$Vh),X(2,P.$7n),X(3,b.$8i)],p);let w=class extends A.$Rc{constructor(h,m){super(),this.j=m,this.c={},this.f=(0,I.$ic)(h.userDataPath,"languagepacks.json"),this.g=new L.$Zg}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.s(m=>{Object.keys(m).forEach(S=>delete m[S]),this.m(m,...h)}).then(()=>this.c)}m(h,...m){for(const S of m)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.n(h,S);Object.keys(h).forEach(S=>this.r(h[S]))}n(h,m){const S=m.identifier,s=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const a of s)if(m.location.scheme===O.Schemas.file&&f(a)){let n=h[a.languageId];n||(n={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},h[a.languageId]=n);const i=n.extensions.filter(t=>(0,E.$wo)(t.extensionIdentifier,S))[0];i?i.version=m.manifest.version:n.extensions.push({extensionIdentifier:S,version:m.manifest.version});for(const t of a.translations)n.translations[t.id]=(0,I.$ic)(m.location.fsPath,t.path)}}r(h){if(h){const m=(0,D.createHash)("md5");for(const S of h.extensions)m.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);h.hash=m.digest("hex")}}s(h=()=>null){return this.g.queue(()=>{let m=null;return C.Promises.readFile(this.f,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch{return{}}}).then(S=>(m=h(S),S)).then(S=>{for(const a of Object.keys(S))S[a]||delete S[a];this.c=S,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),C.Promises.writeFile(this.f,s)}).then(()=>m,S=>this.j.error(S))})}};w=ye([X(0,d.$Vh),X(1,b.$8i)],w);function f(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const h of c.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(oe[226],ae([0,1,143,8,30,45]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function C(P,E,b){const l=await(0,D.$hC)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,D.$hC)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new l.AppInsightsCore,w=new g.PostChannel,f={instrumentationKey:P,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(b){f.extensionConfig={};const c={alwaysUseXhrOverride:!0,httpXHROverride:b};f.extensionConfig[w.identifier]=c}return p.initialize(f,[]),p.addTelemetryInitializer(c=>{E&&(c.ext=c.ext??{},c.ext.utc=c.ext.utc??{},c.ext.utc.flags=8462029)}),p}class d{constructor(E,b,l,g,p){this.e=E,this.f=b,this.g=l,this.h=p,this.c=O,this.d=I,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=C(this.a,this.e,this.h)),this.b.then(b=>{E(b)},b=>{(0,N.$Z)(b),console.error(b)})}}log(E,b){if(!this.a)return;b=(0,L.$6m)(b,this.g),b=(0,A.$ro)(b);const l=this.f+"/"+E;try{this.i(g=>{g.pluginVersionString=b?.properties.version??"Unknown",g.track({name:l,baseData:{name:l,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$lN=d}),define(oe[109],ae([0,1,2,167,14,7,24,45]),function(te,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E4b=void 0;let C=class extends D.$Rc{constructor(P,E,b,l,g=""){super(),this.b=g;const p=E.getLogger(I.$ko);if(p)this.a=this.B(p);else{const f=(0,I.$po)(l,b)?" (Not Sent)":"",c=()=>(0,I.$oo)(l,b)&&P.getLevel()===A.LogLevel.Trace;this.a=this.B(E.createLogger(I.$ko,{name:(0,N.localize)(0,null,f),hidden:!c()})),this.B(P.onDidChangeLogLevel(()=>E.setVisibility(I.$ko,c()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,E){this.a.trace(`${this.b}telemetry/${P}`,(0,I.$ro)(E))}};e.$E4b=C,e.$E4b=C=ye([X(0,A.$8i),X(1,A.$9i),X(2,L.$Uh),X(3,O.$nj)],C)}),define(oe[110],ae([0,1,2,30,6,27,168,20,50,102,24,40,22,45]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,c,h){this.k=c,this.l=h,this.d={},this.i=new D.$Qc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,A.$Ee)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Ee)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(b.$hl)||m.affectsConfiguration(b.$jl)||m.affectsConfiguration(b.$il))&&this.m()}))}setExperimentProperty(f,c){this.d[f]=c}m(){let f=(0,l.$qo)(this.k);const c=this.l.enabledTelemetryLevels;if(c){this.h=this.sendErrorTelemetry?c.error:!1;const h=c.usage?3:c.error?2:0;f=Math.min(f,h)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,c,h){this.g<c||(h=(0,N.$6m)(h,this.d),h=(0,l.$vo)(h,this.j),h=(0,N.$6m)(h,this.c),this.b.forEach(m=>m.log(f,h)))}publicLog(f,c){this.n(f,3,c)}publicLog2(f,c){this.publicLog(f,c)}publicLogError(f,c){this.h&&this.n(f,2,c)}publicLogError2(f,c){this.publicLogError(f,c)}};e.$Xq=g,e.$Xq=g=ye([X(1,I.$hi),X(2,P.$nj)],g);function p(){const w=(0,O.localize)(0,null,d.default.nameLong),f=d.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=L.$p?"":(0,O.localize)(3,null),h=(0,O.localize)(4,null),m=(0,O.localize)(5,null),S=(0,O.localize)(6,null),s=(0,O.localize)(7,null),a=`
|       | ${h} | ${m} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${w} ${f} ${c}

&nbsp;

${s}
${a}

&nbsp;

${n}
`}E.$cn.as(C.$hn.Configuration).registerConfiguration({id:b.$gl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[b.$hl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$cn.as(C.$hn.Configuration).registerConfiguration({id:b.$gl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[b.$jl]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,O.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,O.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${b.$hl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[227],ae([0,1,15,26,272,226]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=void 0;async function O(P,E){const b=await E.request(P,N.CancellationToken.None),l=(await(0,D.$me)(b.stream)).toString(),g=b.res.statusCode??200;return{headers:b.res.headers,statusCode:g,responseData:l}}async function I(P){const E={method:P.type,headers:P.headers};return new Promise((l,g)=>{const p=L.request(P.url??"",E,w=>{w.on("data",function(f){l({headers:w.headers,statusCode:w.statusCode??200,responseData:f.toString()})}),w.on("error",function(f){g(f)})});p.write(P.data,w=>{w&&g(w)}),p.end()})}async function C(P,E,b){const l=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),g={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:l};try{const p=P?await O(g,P):await I(g);b(p.statusCode,p.headers,p.responseData)}catch{b(0,{})}}class d extends A.$lN{constructor(E,b,l,g,p){const w={sendPOST:(f,c)=>{C(E,f,c)}};super(b,l,g,p,w)}}e.$mN=d}),define(oe[228],ae([0,1,23,93,20,14,7,24,22,108,109,110]),function(te,e,D,N,L,A,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u8b=void 0;let b=class{constructor(g,p,w,f,c,h){this.b=g,this.c=p,this.d=w,this.e=f,this.f=c,this.g=h,this.a=new Map}h(g){if(!this.a.has(g.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const w=[g.id,JSON.stringify(p),g.aiKey],c=new N.$Zp(D.$bg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new d.$d7b(c),new P.$E4b(this.d,this.e,this.f,this.g,`[${g.id}] `)];this.a.set(g.id,new E.$Xq({appenders:h,sendErrorTelemetry:g.sendErrorTelemetry},this.b,this.g))}return this.a.get(g.id)}publicLog(g,p,w){this.h(g).publicLog(p,w)}publicLogError(g,p,w){this.h(g).publicLogError(p,w)}};e.$u8b=b,e.$u8b=b=ye([X(0,L.$hi),X(1,C.$al),X(2,O.$8i),X(3,O.$9i),X(4,A.$Uh),X(5,I.$nj)],b)}),define(oe[77],ae([0,1,3,20,4,7]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.ProvidedOnAutoForward=e.$7u=e.TunnelPrivacyId=e.TunnelProtocol=e.$6u=e.$5u=void 0,e.$5u=(0,L.$Nh)("tunnelService"),e.$6u=(0,L.$Nh)("sharedTunnelsService");var O;(function(w){w.Http="http",w.Https="https"})(O||(e.TunnelProtocol=O={}));var I;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(I||(e.TunnelPrivacyId=I={}));function C(w){return!!w.forwardPort}e.$7u=C;var d;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function P(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(f)return{address:f[1],port:+f[2]}}e.$8u=P,e.$9u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(w){return e.$9u.indexOf(w)>=0}e.$0u=E,e.$$u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(w){return e.$$u.indexOf(w)>=0}e.$_u=b;function l(w,f,c,h){if(c===1)return!1;if(c===2&&b(f)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(m?.length===4&&parseInt(m[1])>=18)return!1}return w<1024}e.$av=l;class g{constructor(f,c,h){this.remoteAddress=f,this.localAddress=c,this.b=h,this.a=new D.$Md,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$bv=g;let p=class{constructor(f,c){this.j=f,this.k=c,this.a=new D.$Md,this.onTunnelOpened=this.a.event,this.b=new D.$Md,this.onTunnelClosed=this.b.event,this.c=new D.$Md,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const f=this.k.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(f){return this.f=f,f?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(f){this.g=f.elevation,this.h=f.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const f=[],c=Array.from(this.e.values());for(const h of c){const m=Array.from(h.values());for(const S of m){const s=await S.value;s&&typeof s!="string"&&f.push(s)}}return f}async dispose(){for(const f of this.e.values()){for(const{value:c}of f.values())await c.then(h=>typeof h!="string"?h?.dispose():void 0);f.clear()}this.e.clear()}setEnvironmentTunnel(f,c,h,m,S){this.p(f,c,Promise.resolve({tunnelRemoteHost:f,tunnelRemotePort:c,localAddress:h,privacy:m,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(f,c){(b(f)||E(f))&&(f=e.$9u[0]);const h=this.r(f,c);if(h)return++h.refcount,h.value}openTunnel(f,c,h,m,S,s=!1,a,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${h} on local port ${S}.`);const i=this.f??f;if(!i)return;if(c||(c="localhost"),m||(m=this.l),this.f&&this.i.has(h)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(i,c,h,m,S,s,a,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,h),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,h);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.n(r);return(r.tunnelRemoteHost!==c||r.tunnelRemotePort!==h)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&r.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(o),o}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const c=this.e.get(f.tunnelRemoteHost);if(c){const h=c.get(f.tunnelRemotePort);h&&(h.refcount--,await this.o(f.tunnelRemoteHost,f.tunnelRemotePort,h))}}}}async o(f,c,h){if(h.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${c}.`);const m=h.value.then(async S=>{S&&typeof S!="string"&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.e.has(f)&&this.e.get(f).delete(c),m}}async closeTunnel(f,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${c} `);const h=this.e.get(f);if(h&&h.has(c)){const m=h.get(c);m.refcount=0,await this.o(f,c,m)}}p(f,c,h){this.e.has(f)||this.e.set(f,new Map),this.e.get(f).set(c,{refcount:1,value:h})}async q(f,c){const h=this.e.get(f);if(h){const m=h.get(c),S=m?await m.value:void 0;(!S||typeof S=="string")&&h.delete(c),h.size===0&&this.e.delete(f)}}r(f,c){const h=[f];E(f)?(h.push(...e.$9u),h.push(...e.$$u)):b(f)&&h.push(...e.$$u);const m=h.map(S=>this.e.get(S));for(const S of m){const s=S?.get(c);if(s)return s}}canTunnel(f){return!!P(f)}t(f,c,h,m,S,s,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${h} on local port ${m}.`);const n=h;this.i.add(n);const i=m===void 0?h:m,t={elevationRequired:S?this.isPortPrivileged(i):!1},r={remoteAddress:{host:c,port:h},localAddressPort:m,privacy:s,public:s?s!==I.Private:void 0,protocol:a},o=f.forwardPort(r,t);return o?(this.p(c,h,o),o.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),o}};e.$cv=p,e.$cv=p=ye([X(0,A.$8i),X(1,N.$hi)],p)}),define(oe[229],ae([0,1,7,77,2,8,5]),function(te,e,D,N,L,A,O){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$H8b=void 0;class C extends L.$Rc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$bh),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let d=class extends L.$Rc{static{I=this}static{this.a=0}constructor(E,b){super(),this.f=E,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++I.a)}}async startTunnel(E,b,l,g,p,w,f){const c=new C,h=await Promise.resolve(this.f.openTunnel(E,c,l,g,p,w,f));if(!h||typeof h=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${g} (remote).`),c.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),c.dispose(),await h.dispose(),(0,A.$5)();return c.setTunnel(h),this.b.set(b,c),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${h.localAddress} (local) to ${l}:${g} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(E,b){const l=this.b.get(E);l&&l.setAddress(b)}async destroyTunnel(E){const b=this.b.get(E);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await b.dispose();return}this.c.add(E)}};e.$H8b=d,e.$H8b=d=I=ye([X(0,N.$6u),X(1,D.$8i)],d)}),define(oe[28],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=void 0,e.$Gk=(0,D.$Nh)("IUriIdentityService")}),define(oe[230],ae([0,1,28,185,11,19,128,3,2]),function(te,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;class d{static{this._clock=0}constructor(b){this.uri=b,this.time=d._clock++}touch(){return this.time=d._clock++,this}}let P=class{constructor(b){this.g=b,this.c=new C.$Qc,this.f=2**16;const l=new Map,g=p=>{let w=l.get(p.scheme);return w===void 0&&(w=b.hasProvider(p)&&!this.g.hasCapability(p,1024),l.set(p.scheme,w)),w};this.c.add(I.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(p=>{l.delete(p.scheme)})),this.extUri=new A.$jg(g),this.d=new O.$vr((p,w)=>this.extUri.compare(p,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,A.$vg)(b));const l=this.d.get(b);return l?l.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new d(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((g,p)=>g[1].time<p[1].time?1:g[1].time>p[1].time?-1:0);d._clock=0,this.d.clear();const l=this.f*.5;for(let g=0;g<l;g++)this.d.set(b[g][0],b[g][1].touch())}};e.$wr=P,e.$wr=P=ye([X(0,L.$9j)],P),(0,N.$tr)(D.$Gk,P,1)}),define(oe[231],ae([0,1,3,2,11,47,34]),function(te,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=void 0;class I extends N.$Rc{constructor(d,P,E,b,l,g){super(),this.f=d,this.g=P,this.h=E,this.j=b,this.m=l,this.n=g,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$Md),this.onDidChangeFile=this.a.event,this.b=A.$Th.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Ac(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(b.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const d of this.j.profiles)this.c.add(d.settingsResource),this.c.add(d.keybindingsResource),this.c.add(d.tasksResource),this.c.add(d.extensionsResource)}open(d,P){return this.g.open(this.t(d),P)}close(d){return this.g.close(d)}read(d,P,E,b,l){return this.g.read(d,P,E,b,l)}write(d,P,E,b,l){return this.g.write(d,P,E,b,l)}watch(d,P){this.b.set(d,d);const E=this.g.watch(this.t(d),P);return(0,N.$Pc)(()=>{this.b.delete(d),E.dispose()})}stat(d){return this.g.stat(this.t(d))}mkdir(d){return this.g.mkdir(this.t(d))}rename(d,P,E){return this.g.rename(this.t(d),this.t(P),E)}readFile(d,P){return this.g.readFile(this.t(d),P)}readFileStream(d,P,E){return this.g.readFileStream(this.t(d),P,E)}readdir(d){return this.g.readdir(this.t(d))}enforceAtomicReadFile(d){return this.c.has(d)}writeFile(d,P,E){return this.g.writeFile(this.t(d),P,E)}enforceAtomicWriteFile(d){return this.c.has(d)?{postfix:".vsctmp"}:!1}delete(d,P){return this.g.delete(this.t(d),P)}copy(d,P,E){if((0,L.$ak)(this.g))return this.g.copy(this.t(d),this.t(P),E);throw new Error("copy not supported")}cloneFile(d,P){if((0,L.$bk)(this.g))return this.g.cloneFile(this.t(d),this.t(P));throw new Error("clone not supported")}s(d){const P=[];for(const E of d){if(E.resource.scheme!==this.f)continue;const b=this.u(E.resource);this.b.findSubstr(b)&&P.push({resource:b,type:E.type,cId:E.cId})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(d){return d.with({scheme:this.f})}u(d){return d.with({scheme:this.h})}}e.$27b=I}),define(oe[78],ae([0,1,86]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HCb=e.$GCb=e.edit=void 0;function N(O,I,C,d){const P=(0,D.$XS)(O,I,C,d)[0];return P&&(O=O.substring(0,P.offset)+P.content+O.substring(P.offset+P.length)),O}e.edit=N;function L(O,I,C){let d=C;for(;d>=0;){if(O.charAt(d)===I.charAt(I.length-1)&&I.length===1)return d+1;if(d--,I.length===2&&d>=0&&O.charAt(d)===I.charAt(0))return d+2}return 0}e.$GCb=L;function A(O,I,C){let d=C;for(;d>=0;)if(O.charAt(d)===I.charAt(I.length-1)&&I.length===1||(d++,I.length===2&&d>=0&&O.charAt(d)===I.charAt(1)))return d;return O.length-1}e.$HCb=A}),define(oe[232],ae([0,1,30,54,12]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m3b=void 0;function A(l,g,p,w,f,c){const h=[],m=[],S=[];if(!g){const q=l.filter(({identifier:Y})=>f.every(J=>J.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:h,removed:m,updated:S},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}l=l.map(E),g=g.map(E),p=p?p.map(E):null;const s=new Map,a=q=>{q.uuid&&s.set(q.id.toLowerCase(),q.uuid)};l.forEach(({identifier:q})=>a(q)),g.forEach(({identifier:q})=>a(q)),p?.forEach(({identifier:q})=>a(q)),w?.forEach(({identifier:q})=>a(q)),c?.forEach(q=>a(q));const n=q=>{const Y=q.identifier.uuid||s.get(q.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${q.identifier.id.toLowerCase()}`},i=(q,Y)=>(q.set(n(Y),Y),q),t=l.reduce(i,new Map),r=g.reduce(i,new Map),o=g.reduce((q,Y)=>i(q,(0,D.$3m)(Y)),new Map),v=p?p.reduce(i,new Map):null,y=w.reduce(i,new Map),u=f.reduce((q,Y)=>{const J=s.get(Y.toLowerCase());return q.add(J?`uuid:${J}`:`id:${Y.toLowerCase()}`)},new Set),$=c?c.reduce((q,{id:Y,uuid:J})=>(J=J??s.get(Y.toLowerCase()),q.add(J?`uuid:${J}`:`id:${Y.toLowerCase()}`)),new Set):null,j=O(t,r,u,!1);if(j.added.size>0||j.removed.size>0||j.updated.size>0){const q=O(v,t,u,!1),Y=O(v,r,u,!0),J=(x,W,Q,H)=>{let V,ee,ne;return W.installed?(V=H.pinned,ne=H.preRelease,V&&(ee=H.version)):(V=Q.pinned,ne=Q.preRelease,V&&(ee=Q.version)),V===void 0&&(V=W.pinned,V&&(ee=W.version)),ne===void 0&&(ne=W.preRelease),{...H,installed:W.installed||Q.installed,pinned:V,preRelease:ne,version:ee??(Q.version&&(!W.installed||N.gt(Q.version,W.version))?Q.version:W.version),state:C(W,Q,v?.get(x))}};for(const x of Y.removed.values()){const W=t.get(x);if(!W)continue;const Q=(0,L.$If)(v?.get(x)),H=$&&!$.has(x)&&Q.installed;W.installed&&H?m.push(W.identifier):o.set(x,W)}for(const x of Y.added.values()){const W=(0,L.$If)(r.get(x)),Q=t.get(x);if(Q){if(j.updated.has(x)){const H=J(x,Q,W,W);I(Q,W,!1,!1)||S.push(b(H,x)),o.set(x,H)}}else W.installed&&h.push(b(W,x))}for(const x of Y.updated.values()){const W=(0,L.$If)(r.get(x)),Q=(0,L.$If)(v?.get(x)),H=t.get(x);if(H)if($&&!$.has(x)&&Q.installed&&H.installed&&!W.installed)m.push(H.identifier);else{const ee=J(x,H,W,W);S.push(b(ee,x)),o.set(x,ee)}else W.installed&&h.push(b(W,x))}for(const x of q.added.values())Y.added.has(x)||o.set(x,(0,L.$If)(t.get(x)));for(const x of q.updated.values()){if(Y.removed.has(x)||Y.updated.has(x))continue;const W=(0,L.$If)(t.get(x)),Q=(0,L.$If)(r.get(x));o.set(x,J(x,W,Q,W))}for(const x of q.removed.values())Y.updated.has(x)||Y.removed.has(x)||y.has(x)||(0,L.$If)(r.get(x)).installed&&$&&($.has(x)||!(0,L.$If)(v?.get(x)).installed||o.delete(x))}const M=[],T=O(r,o,new Set,!0),U=T.added.size>0||T.updated.size>0||T.removed.size>0;return U&&o.forEach((q,Y)=>M.push(b(q,Y))),{local:{added:h,removed:m,updated:S},remote:U?{added:[...T.added].map(q=>o.get(q)),updated:[...T.updated].map(q=>o.get(q)),removed:[...T.removed].map(q=>r.get(q)),all:M}:null}}e.$m3b=A;function O(l,g,p,w){const f=l?[...l.keys()].filter(s=>!p.has(s)):[],c=[...g.keys()].filter(s=>!p.has(s)),h=c.filter(s=>!f.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),m=f.filter(s=>!c.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),S=new Set;for(const s of f){if(m.has(s))continue;const a=l.get(s),n=g.get(s);(!n||!I(a,n,w,!0))&&S.add(s)}return{added:h,removed:m,updated:S}}function I(l,g,p,w){return!(l.disabled!==g.disabled||!!l.isApplicationScoped!=!!g.isApplicationScoped||w&&l.installed!==g.installed||l.installed&&g.installed&&(l.preRelease!==g.preRelease||l.pinned!==g.pinned||g.pinned&&l.version!==g.version)||!P(l.state,g.state)||p&&l.version!==g.version)}function C(l,g,p){const w=l.state,f=g.state,c=p?.state;if(!g.version||w&&N.gt(l.version,g.version))return w;if(f&&N.gt(g.version,l.version)||!w)return f;if(!f)return w;const h=(0,D.$3m)(w),m=c?d(c,f):{added:Object.keys(f).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set},S=c?d(c,w):{added:Object.keys(w).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set};for(const s of[...m.added.values(),...m.updated.values()])h[s]=f[s];for(const s of m.removed.values())S.updated.has(s)||delete h[s];return h}function d(l,g){const p=Object.keys(l),w=Object.keys(g),f=w.filter(m=>!p.includes(m)).reduce((m,S)=>(m.add(S),m),new Set),c=p.filter(m=>!w.includes(m)).reduce((m,S)=>(m.add(S),m),new Set),h=new Set;for(const m of p){if(c.has(m))continue;const S=l[m],s=g[m];(0,D.$7m)(S,s)||h.add(m)}return{added:f,removed:c,updated:h}}function P(l={},g={}){const{added:p,removed:w,updated:f}=d(l,g);return p.size===0&&w.size===0&&f.size===0}function E(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function b(l,g){const p={...l,identifier:{id:l.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete p.disabled,l.installed||delete p.installed,l.state||delete p.state,l.isApplicationScoped||delete p.isApplicationScoped,p}}),define(oe[111],ae([0,1,18,20,4]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EEb=e.$DEb=void 0,e.$DEb=(0,L.$Nh)("IIgnoredExtensionsManagementService");let A=class{constructor(I){this.a=I}hasToNeverSyncExtension(I){return this.b().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.b().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,C){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return d=d.filter(P=>P!==I&&P!==`-${I}`),C&&d.push(I.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}updateSynchronizedExtensions(I,C){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return d=d.filter(P=>P!==I&&P!==`-${I}`),C&&d.push(`-${I.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}getIgnoredExtensions(I){const C=I.filter(b=>b.isMachineScoped).map(b=>b.identifier.id.toLowerCase()),d=this.b().map(b=>b.toLowerCase()),P=[],E=[];if(Array.isArray(d))for(const b of d)b.startsWith("-")?E.push(b.substring(1)):P.push(b);return(0,D.$Lb)([...C,...P].filter(b=>!E.includes(b)))}b(){let I=this.a.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.a.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};e.$EEb=A,e.$EEb=A=ye([X(0,N.$hi)],A)}),define(oe[233],ae([0,1,18,35,30,94,78]),function(te,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s3b=void 0;function I(m){return(0,N.$Sm)(m)||[]}async function C(m,S,s,a,n){const i=I(m),t=I(S),r=s?I(s):null,o=[...i,...t,...r||[]].map(J=>J.key),v=await n.resolveUserBindings(o),y=P(i,t,r,v);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:m,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};const u=b(i),$=b(t),j=r?b(r):null,M=g(u,$,v),T=j?g(j,u,v):{added:[...u.keys()].reduce((J,x)=>(J.add(x),J),new Set),removed:new Set,updated:new Set},U=j?g(j,$,v):{added:[...$.keys()].reduce((J,x)=>(J.add(x),J),new Set),removed:new Set,updated:new Set},q=d(M,T,U);let Y=m;for(const J of q.removed.values())q.conflicts.has(J)||(Y=c(Y,J,a));for(const J of q.added.values()){if(q.conflicts.has(J))continue;const x=$.get(J);if(x.some(W=>W.command!==`-${J}`&&y.conflicts.has(v[W.key]))){q.conflicts.add(J);continue}Y=f(Y,x,a)}for(const J of q.updated.values()){if(q.conflicts.has(J))continue;const x=$.get(J);if(x.some(W=>W.command!==`-${J}`&&y.conflicts.has(v[W.key]))){q.conflicts.add(J);continue}Y=h(Y,J,x,a)}return{mergeContent:Y,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.$s3b=C;function d(m,S,s){const a=new Set,n=new Set,i=new Set,t=new Set;for(const r of S.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(S.updated.has(r)?t.add(r):n.add(r));for(const r of S.added.values())t.has(r)||s.added.has(r)&&m.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(S.added.has(r)?m.updated.has(r)&&t.add(r):a.add(r));for(const r of S.updated.values())t.has(r)||s.updated.has(r)&&m.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(S.updated.has(r)?m.updated.has(r)&&t.add(r):i.add(r));return{added:a,removed:n,updated:i,conflicts:t}}function P(m,S,s,a){const n=new Set,i=E(m,a),t=E(S,a),r=s?E(s,a):null,o=l(i,t);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?l(r,i):{added:[...i.keys()].reduce((T,U)=>(T.add(U),T),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const y=r?l(r,t):{added:[...t.keys()].reduce((T,U)=>(T.add(U),T),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:u,removed:$,updated:j,conflicts:M}=d(o,v,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:$,updated:j,conflicts:M}}function E(m,S){const s=new Map;for(const a of m){const n=S[a.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(a)}return s}function b(m){const S=new Map;for(const s of m){const a=s.command[0]==="-"?s.command.substring(1):s.command;let n=S.get(a);n||(n=[],S.set(a,n)),n.push(s)}return S}function l(m,S){const s=[...m.keys()],a=[...S.keys()],n=a.filter(r=>!s.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),i=s.filter(r=>!a.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const o=m.get(r).map(y=>({...y,key:r})),v=S.get(r).map(y=>({...y,key:r}));(0,D.$tb)(o,v,(y,u)=>w(y,u))||t.add(r)}return{added:n,removed:i,updated:t}}function g(m,S,s){const a=[...m.keys()],n=[...S.keys()],i=n.filter(o=>!a.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),t=a.filter(o=>!n.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),r=new Set;for(const o of a){if(t.has(o))continue;const v=m.get(o).map(u=>({...u,key:s[u.key]})),y=S.get(o).map(u=>({...u,key:s[u.key]}));p(v,y)||r.add(o)}return{added:i,removed:t,updated:r}}function p(m,S){return!(!(0,D.$tb)(m.filter(({command:s})=>s[0]!=="-"),S.filter(({command:s})=>s[0]!=="-"),(s,a)=>w(s,a))||!(0,D.$tb)(m.filter(({command:s})=>s[0]==="-"),S.filter(({command:s})=>s[0]==="-"),(s,a)=>w(s,a)))}function w(m,S){if(m.command!==S.command||m.key!==S.key)return!1;const s=A.$Li.deserialize(m.when),a=A.$Li.deserialize(S.when);return!(s&&!a||!s&&a||s&&a&&!s.equals(a)||!L.$7m(m.args,S.args))}function f(m,S,s){for(const a of S)m=O.edit(m,[-1],a,s);return m}function c(m,S,s){const a=I(m);for(let n=a.length-1;n>=0;n--)(a[n].command===S||a[n].command===`-${S}`)&&(m=O.edit(m,[n],void 0,s));return m}function h(m,S,s,a){const n=I(m),i=n.findIndex(t=>t.command===S||t.command===`-${S}`);for(let t=n.length-1;t>=0;t--)(n[t].command===S||n[t].command===`-${S}`)&&(m=O.edit(m,[t],void 0,a));for(let t=s.length-1;t>=0;t--)m=O.edit(m,[i],s[t],a);return m}}),define(oe[234],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A3b=e.$z3b=void 0;function D(A,O,I){const C={},d={},P=new Set;if(!O)return{local:{added:C,updated:d,removed:[...P.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const E=N(A,O);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:C,updated:d,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const b=N(I,A),l=N(I,O),g={},p={},w=new Set,f=new Set;for(const c of b.removed.values())l.updated.has(c)?C[c]=O[c]:w.add(c);for(const c of l.removed.values())f.has(c)||(b.updated.has(c)?f.add(c):P.add(c));for(const c of b.updated.values())f.has(c)||(l.updated.has(c)?E.updated.has(c)&&f.add(c):p[c]=A[c]);for(const c of l.updated.values())f.has(c)||(b.updated.has(c)?E.updated.has(c)&&f.add(c):A[c]!==void 0&&(d[c]=O[c]));for(const c of b.added.values())f.has(c)||(l.added.has(c)?E.updated.has(c)&&f.add(c):g[c]=A[c]);for(const c of l.added.values())f.has(c)||(b.added.has(c)?E.updated.has(c)&&f.add(c):C[c]=O[c]);return{local:{added:C,removed:[...P.values()],updated:d},remote:{added:g,removed:[...w.values()],updated:p},conflicts:[...f.values()]}}e.$z3b=D;function N(A,O){const I=A?Object.keys(A):[],C=O?Object.keys(O):[],d=C.filter(b=>!I.includes(b)).reduce((b,l)=>(b.add(l),b),new Set),P=I.filter(b=>!C.includes(b)).reduce((b,l)=>(b.add(l),b),new Set),E=new Set;for(const b of I){if(P.has(b))continue;const l=A[b],g=O[b];l!==g&&E.add(b)}return{added:d,removed:P,updated:E}}function L(A,O){const{added:I,removed:C,updated:d}=N(A,O);return I.size===0&&C.size===0&&d.size===0}e.$A3b=L}),define(oe[235],ae([0,1,30]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h5b=void 0;function N(A,O,I,C){const d={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!O){const b=A.filter(({id:l})=>!C.includes(l));return b.length?P.added=b:P=null,{local:d,remote:P}}const E=L(A,O,C);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const b=L(I,A,C),l=L(I,O,C);for(const g of l.removed){const p=A.find(w=>w.id===g);p&&d.removed.push(p)}for(const g of l.added){const p=O.find(w=>w.id===g);b.added.includes(g)?E.updated.includes(g)&&d.updated.push(p):d.added.push(p)}for(const g of l.updated)d.updated.push(O.find(p=>p.id===g));for(const g of b.added)l.added.includes(g)||P.added.push(A.find(p=>p.id===g));for(const g of b.updated)l.removed.includes(g)||l.updated.includes(g)||P.updated.push(A.find(p=>p.id===g));for(const g of b.removed){const p=O.find(w=>w.id===g);p&&P.removed.push(p)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:d,remote:P}}e.$h5b=N;function L(A,O,I){A=A?A.filter(({id:l})=>!I.includes(l)):[],O=O.filter(({id:l})=>!I.includes(l));const C=A.map(({id:l})=>l),d=O.map(({id:l})=>l),P=d.filter(l=>!C.includes(l)),E=C.filter(l=>!d.includes(l)),b=[];for(const{id:l,name:g,shortName:p,icon:w,useDefaultFlags:f}of A){if(E.includes(l))continue;const c=O.find(h=>h.id===l);(!c||c.name!==g||c.shortName!==p||c.icon!==w||!(0,D.$7m)(c.useDefaultFlags,f))&&b.push(l)}return{added:P,removed:E,updated:b}}}),define(oe[25],ae([0,1,18,12,174,50,29,4,103,40]),function(te,e,D,N,L,A,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgb=e.$Qgb=e.$Pgb=e.$Ogb=e.$Ngb=e.$Mgb=e.$Lgb=e.$Kgb=e.$Jgb=e.$Igb=e.$Hgb=e.MergeState=e.Change=e.SyncStatus=e.$Ggb=e.$Fgb=e.$Egb=e.UserDataSyncErrorCode=e.$Dgb=e.$Cgb=e.$Bgb=e.$Agb=e.$zgb=e.$ygb=e.$xgb=e.$wgb=e.$vgb=e.SyncResource=e.$ugb=e.$tgb=e.$sgb=e.$rgb=e.$qgb=e.$pgb=void 0;function P(){const t=d.$cn.as(A.$hn.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$pgb=P;function E(){const t=d.$cn.as(A.$hn.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(y=>!!t[y].ignoreSync),o=Object.keys(t).filter(y=>t[y].scope===2||t[y].scope===6),v=P();return(0,D.$Lb)([...r,...o,...v])}e.$qgb=E,e.$rgb="settingsSync",e.$sgb="settingsSync.keybindingsPerPlatform";function b(){const t="vscode://schemas/ignoredSettings",r=d.$cn.as(A.$hn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$sgb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:O.$Tn,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=d.$cn.as(C.$dn.JSONContribution),v=()=>{const y=P(),u=E(),$=Object.keys(A.$in.properties).filter(T=>!u.includes(T)),j=u.filter(T=>!y.includes(T)),M={items:{type:"string",enum:[...$,...j.map(T=>`-${T}`)]}};o.registerSchema(t,M)};return r.onDidUpdateConfiguration(()=>v())}e.$tgb=b;function l(t){return t&&(0,N.$zf)(t)&&(0,N.$xf)(t.id)&&Array.isArray(t.scopes)}e.$ugb=l;var g;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(g||(e.SyncResource=g={})),e.$vgb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(t,...r){return t?[t,...r]:r}e.$wgb=p;function w(t,r,o,v){return v.joinPath(o.userDataSyncHome,...p(t,r,`lastSync${r}.json`))}e.$xgb=w,e.$ygb=(0,I.$Nh)("IUserDataSyncStoreManagementService"),e.$zgb=(0,I.$Nh)("IUserDataSyncStoreService"),e.$Agb=(0,I.$Nh)("IUserDataSyncLocalStoreService"),e.$Bgb="x-operation-id",e.$Cgb="X-Execution-Id";function f(t){const r={};return r[e.$Cgb]=t,r}e.$Dgb=f;var c;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(c||(e.UserDataSyncErrorCode=c={}));class h extends Error{constructor(r,o,v,y){super(r),this.code=o,this.resource=v,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Egb=h;class m extends h{constructor(r,o,v,y,u){super(r,v,void 0,u),this.url=o,this.serverCode=y}}e.$Fgb=m;class S extends h{constructor(r,o){super(r,o)}}e.$Ggb=S,function(t){function r(o){if(o instanceof t)return o;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(v&&v[1]){const y=v[2]==="unknown"?void 0:v[2],u=v[3]==="unknown"?void 0:v[3];return new t(o.message,v[1],y,u)}return new t(o.message,"Unknown")}t.toUserDataSyncError=r}(h||(e.$Egb=h={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var a;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(a||(e.Change=a={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Hgb="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.$Igb=i,e.$Jgb=(0,I.$Nh)("IUserDataSyncEnablementService"),e.$Kgb=(0,I.$Nh)("IUserDataSyncService"),e.$Lgb=(0,I.$Nh)("IUserDataSyncResourceProviderService"),e.$Mgb=(0,I.$Nh)("IUserDataAutoSyncService"),e.$Ngb=(0,I.$Nh)("IUserDataSyncUtilService"),e.$Ogb=(0,I.$Nh)("IUserDataSyncLogService"),e.$Pgb="userDataSync",e.$Qgb="vscode-userdata-sync",e.$Rgb="preview"}),define(oe[236],ae([0,1,30,25]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZDb=void 0;function L(O,I,C,d,P){if(!I)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const E=A(O,I);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const b=C?A(C,I):{added:Object.keys(I).reduce((c,h)=>(c.add(h),c),new Set),removed:new Set,updated:new Set},l=C?A(C,O):{added:Object.keys(O).reduce((c,h)=>(c.add(h),c),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},p=D.$3m(I),w=!C;for(const c of l.added.values())c!==N.$Hgb&&w&&b.added.has(c)||(p[c]=O[c]);for(const c of l.updated.values())p[c]=O[c];for(const c of l.removed.values())d.unregistered.includes(c)||delete p[c];for(const c of b.added.values()){const h=I[c];if(d.machine.includes(c)){P.info(`GlobalState: Skipped adding ${c} in local storage because it is declared as machine scoped.`);continue}if(C&&l.added.has(c))continue;const m=O[c];m&&m.value===h.value||c===N.$Hgb&&w&&l.added.has(c)||(m?g.updated[c]=h:g.added[c]=h)}for(const c of b.updated.values()){const h=I[c];if(d.machine.includes(c)){P.info(`GlobalState: Skipped updating ${c} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(c)||l.removed.has(c))continue;const m=O[c];m&&m.value===h.value||(g.updated[c]=h)}for(const c of b.removed.values()){if(d.machine.includes(c)){P.trace(`GlobalState: Skipped removing ${c} in local storage because it is declared as machine scoped.`);continue}l.updated.has(c)||l.removed.has(c)||g.removed.push(c)}const f=A(I,p);return{local:g,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:p}}}e.$ZDb=L;function A(O,I){const C=Object.keys(O),d=Object.keys(I),P=d.filter(l=>!C.includes(l)).reduce((l,g)=>(l.add(g),l),new Set),E=C.filter(l=>!d.includes(l)).reduce((l,g)=>(l.add(g),l),new Set),b=new Set;for(const l of C){if(E.has(l))continue;const g=O[l],p=I[l];D.$7m(g,p)||b.add(l)}return{added:P,removed:E,updated:b}}}),define(oe[237],ae([0,1,18,35,86,41,30,78,25]),function(te,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NCb=e.$MCb=e.$LCb=e.$KCb=e.$JCb=e.$ICb=void 0;function d(o,v,y){let u=[];y?u=E(y):u=P(v);const $=[],j=[...(0,C.$pgb)()];if(Array.isArray(u))for(const M of u)M.startsWith("-")?j.push(M.substring(1)):$.push(M);return(0,D.$Lb)([...o,...$].filter(M=>!j.includes(M)))}e.$ICb=d;function P(o){let v=o.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=o.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const v=(0,N.$Sm)(o);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function b(o,v){const y=(0,N.$Sm)(o)||{};let u="{}";for(const $ of Object.keys(y)){const j=(0,L.$XS)(u,[$],y[$],v);u=(0,L.$1S)(u,j)}return u}e.$JCb=b;function l(o,v,y,u){if(y.length){const $=r(v),j=(0,N.$Sm)(v)||{},M=(0,N.$Sm)(o);if(!M)return o;const T=[];for(const U of y){const q=j[U],Y=M[U];q===void 0?o=I.edit(o,[U],void 0,u):Y!==void 0?o=I.edit(o,[U],q,u):T.push(s(U,$))}T.sort((U,q)=>U.startOffset-q.startOffset),T.forEach(U=>o=c(U.setting.key,v,o,u))}return o}e.$KCb=l;function g(o,v,y,u,$,j){const M=l(o,v,u,j),T=y!==M,U=y!==v;if(!T&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(T&&!U)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(U&&!T)return{conflictsSettings:[],localContent:l(v,o,u,j),remoteContent:null,hasConflicts:!1};if(y===null&&w(o)){const R=p(o,v,u)?null:l(v,o,u,j);return{conflictsSettings:[],localContent:R,remoteContent:null,hasConflicts:!1}}let q=o,Y=v;const J=(0,N.$Sm)(o),x=(0,N.$Sm)(v),W=y?(0,N.$Sm)(y):null,Q=u.reduce((R,z)=>(R.add(z),R),new Set),H=f(J,x,Q),V=f(W,J,Q),ee=f(W,x,Q),ne=new Map,_=new Set,ie=R=>{_.add(R);const z=$.filter(({key:F})=>F===R)[0];z?(q=I.edit(q,[R],z.value,j),Y=I.edit(Y,[R],z.value,j)):ne.set(R,{key:R,localValue:J[R],remoteValue:x[R]})};for(const R of V.removed.values())ee.updated.has(R)?ie(R):Y=I.edit(Y,[R],void 0,j);for(const R of ee.removed.values())_.has(R)||(V.updated.has(R)?ie(R):q=I.edit(q,[R],void 0,j));for(const R of V.updated.values())_.has(R)||(ee.updated.has(R)?H.updated.has(R)&&ie(R):Y=I.edit(Y,[R],J[R],j));for(const R of ee.updated.values())_.has(R)||(V.updated.has(R)?H.updated.has(R)&&ie(R):q=I.edit(q,[R],x[R],j));for(const R of V.added.values())_.has(R)||(ee.added.has(R)?H.updated.has(R)&&ie(R):Y=c(R,q,Y,j));for(const R of ee.added.values())_.has(R)||(V.added.has(R)?H.updated.has(R)&&ie(R):q=c(R,Y,q,j));const K=ne.size>0||!p(q,Y,u),B=K||!p(q,o,[]),k=K||!p(Y,v,[]);return{localContent:B?q:null,remoteContent:k?Y:null,conflictsSettings:[...ne.values()],hasConflicts:K}}e.$LCb=g;function p(o,v,y){if(o===v)return!0;const u=(0,N.$Sm)(o),$=(0,N.$Sm)(v),j=y.reduce((U,q)=>(U.add(q),U),new Set),M=r(o).filter(U=>!(U.setting&&j.has(U.setting.key))),T=r(v).filter(U=>!(U.setting&&j.has(U.setting.key)));if(M.length!==T.length)return!1;for(let U=0;U<M.length;U++){const q=M[U],Y=T[U];if(q.setting&&Y.setting){if(q.setting.key!==Y.setting.key||!O.$7m(u[q.setting.key],$[q.setting.key]))return!1}else if(!q.setting&&!Y.setting){if(q.value!==Y.value)return!1}else return!1}return!0}function w(o){return o?r(o).length===0:!0}e.$MCb=w;function f(o,v,y){const u=o?Object.keys(o).filter(U=>!y.has(U)):[],$=Object.keys(v).filter(U=>!y.has(U)),j=$.filter(U=>!u.includes(U)).reduce((U,q)=>(U.add(q),U),new Set),M=u.filter(U=>!$.includes(U)).reduce((U,q)=>(U.add(q),U),new Set),T=new Set;if(o)for(const U of u){if(M.has(U))continue;const q=o[U],Y=v[U];O.$7m(q,Y)||T.add(U)}return{added:j,removed:M,updated:T}}function c(o,v,y,u){const $=(0,N.$Sm)(v),j=r(v),M=r(y),T=h(o,j,M);return m(y,o,$[o],T,M,u)}e.$NCb=c;function h(o,v,y){const u=v.findIndex(j=>j.setting?.key===o),$=v[u-1];if($){if($.setting){const M=s($.setting.key,y);if(M)return{index:y.indexOf(M),insertAfter:!0}}else{const M=a(u,v);if(M){const T=s(M.setting.key,y);if(T){const U=n(y.indexOf(T),y),q=i(v,M,v[u]);if(U){const Y=i(y,T,U),J=t(q,Y);return J?{index:y.indexOf(J),insertAfter:!0}:{index:y.indexOf(U),insertAfter:!1}}else{const Y=i(y,T,y[y.length-1]),J=t(q,Y);return J?{index:y.indexOf(J),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const j=v[u+1];if(j)if(j.setting){const M=s(j.setting.key,y);if(M)return{index:y.indexOf(M),insertAfter:!1}}else{const M=n(u,v);if(M){const T=s(M.setting.key,y);if(T){const U=a(y.indexOf(T),y),q=i(v,v[u],M);if(U){const Y=i(y,U,T),J=t(q.reverse(),Y.reverse());return J?{index:y.indexOf(J),insertAfter:!1}:{index:y.indexOf(U),insertAfter:!0}}else{const Y=i(y,y[0],T),J=t(q.reverse(),Y.reverse());return J?{index:y.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function m(o,v,y,u,$,j){let M;return u.index===-1?M=(0,L.$XS)(o,[v],y,j):M=S(o,v,y,u,$,j).map(T=>(0,L.$YS)(o,T,j)[0]),(0,L.$1S)(o,M)}function S(o,v,y,u,$,j){const M=`${JSON.stringify(v)}: ${JSON.stringify(y)}`,T=(0,A.$US)(j,o),U=$[u.index];if(u.insertAfter){const q=[];if(U.setting)q.push({offset:U.endOffset,length:0,content:","+M});else{const Y=n(u.index,$),J=a(u.index,$),x=J?.setting?.commaOffset;J&&x===void 0&&q.push({offset:J.endOffset,length:0,content:","});const W=x!==void 0&&x>U.endOffset;q.push({offset:W?x+1:U.endOffset,length:0,content:Y?T+M+",":T+M})}return q}else{if(U.setting)return[{offset:U.startOffset,length:0,content:M+","}];const q=($[u.index-1]&&!$[u.index-1].setting?T:"")+M+(n(u.index,$)?",":"")+T;return[{offset:U.startOffset,length:0,content:q}]}}function s(o,v){return v.filter(y=>y.setting?.key===o)[0]}function a(o,v){for(let y=o-1;y>=0;y--)if(v[y].setting)return v[y]}function n(o,v){for(let y=o+1;y<v.length;y++)if(v[y].setting)return v[y]}function i(o,v,y){const u=o.indexOf(v),$=o.indexOf(y);return o.filter((j,M)=>u<M&&M<$)}function t(o,v){if(o.length&&v.length){let y=0;for(;y<v.length&&y<o.length;y++)if(o[y].value!==v[y].value)return v[y-1];return v[y-1]}}function r(o){const v=[];let y=-1,u,$;const j={onObjectBegin:M=>{y++},onObjectProperty:(M,T,U)=>{y===0&&(u=T,$=M)},onObjectEnd:(M,T)=>{y--,y===0&&v.push({startOffset:u,endOffset:M+T,value:o.substring(u,M+T),setting:{key:$,commaOffset:void 0}})},onArrayBegin:(M,T)=>{y++},onArrayEnd:(M,T)=>{y--,y===0&&v.push({startOffset:u,endOffset:M+T,value:o.substring(u,M+T),setting:{key:$,commaOffset:void 0}})},onLiteralValue:(M,T,U)=>{y===0&&v.push({startOffset:u,endOffset:T+U,value:o.substring(u,T+U),setting:{key:$,commaOffset:void 0}})},onSeparator:(M,T,U)=>{if(y===0&&M===","){let q=v.length-1;for(;q>=0&&!v[q].setting;q--);const Y=v[q];Y&&v.splice(q,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:T}})}},onComment:(M,T)=>{y===0&&v.push({startOffset:M,endOffset:M+T,value:o.substring(M,M+T)})}};return(0,N.$Zm)(o,j),v}}),define(oe[79],ae([0,1,3,2,4,25]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tCb=e.$sCb=void 0,e.$sCb=(0,L.$Nh)("IUserDataSyncAccountService");let O=class extends N.$Rc{get account(){return this.a}constructor(C,d){super(),this.g=C,this.h=d,this.b=this.B(new D.$Md),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.$Md),this.onTokenFailed=this.c.event,this.f=!1,this.B(C.onTokenFailed(P=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,P),this.updateAccount(void 0),P==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(C.onTokenSucceed(()=>this.f=!1))}async updateAccount(C){(C&&this.a?C.token!==this.a.token||C.authenticationProviderId!==this.a.authenticationProviderId:C!==this.a)&&(this.a=C,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(C))}};e.$tCb=O,e.$tCb=O=ye([X(0,A.$zgb),X(1,A.$Ogb)],O)}),define(oe[238],ae([0,1,2,10]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B8b=e.$A8b=e.$z8b=e.$y8b=e.$x8b=e.$w8b=e.$v8b=void 0;class L{constructor(b){this.a=b}listen(b,l){switch(l){case"onError":return this.a.onError}throw new Error(`Event not found: ${l}`)}call(b,l,g){switch(l){case"triggerSync":return this.a.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(g[0])}throw new Error("Invalid call")}}e.$v8b=L;class A{constructor(b){this.a=b}listen(b,l){throw new Error(`Event not found: ${l}`)}call(b,l,g){switch(l){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive(g[0]))}throw new Error("Invalid call")}}e.$w8b=A;class O{constructor(b){this.a=b}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(b){return this.a.call("resolveUserKeybindings",[b])}async resolveFormattingOptions(b){return this.a.call("resolveFormattingOptions",[b])}}e.$x8b=O;class I{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${l}`)}async call(b,l,g){switch(l){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(g[0],g[1]);case"setEnablements":return this.a.setEnablements(g)}throw new Error("Invalid call")}}e.$y8b=I;class C{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${l}`)}call(b,l,g){switch(l){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.$z8b=C;class d{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${l}`)}call(b,l,g){switch(l){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$A8b=d;class P extends D.$Rc{constructor(b){super(),this.a=b,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(b){return this.a.call("switch",[b])}async getPreviousUserDataSyncStore(){const b=await this.a.call("getPreviousUserDataSyncStore");return this.b(b)}b(b){return{url:N.URI.revive(b.url),type:b.type,defaultUrl:N.URI.revive(b.defaultUrl),insidersUrl:N.URI.revive(b.insidersUrl),stableUrl:N.URI.revive(b.stableUrl),canSwitch:b.canSwitch,authenticationProviders:b.authenticationProviders}}}e.$B8b=P}),define(oe[239],ae([0,1,19,175,14,7,25]),function(te,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FEb=void 0;let I=class extends A.$aj{constructor(d,P){super(),this.g=this.B(d.createLogger((0,D.$ug)(P.logsHome,`${O.$Pgb}.log`),{id:O.$Pgb,name:(0,N.localize)(0,null)}))}trace(d,...P){this.g.trace(d,...P)}debug(d,...P){this.g.debug(d,...P)}info(d,...P){this.g.info(d,...P)}warn(d,...P){this.g.warn(d,...P)}error(d,...P){this.g.error(d,...P)}flush(){this.g.flush()}};e.$FEb=I,e.$FEb=I=ye([X(0,A.$9i),X(1,L.$Uh)],I)}),define(oe[112],ae([0,1,7,4,24]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$38b=e.$28b=void 0,e.$28b=(0,N.$Nh)("voiceRecognitionService");let A=class{constructor(I,C){this.a=I,this.b=C}async transcribe(I,C){const d=process.env.VSCODE_VOICE_MODULE_PATH;if(!d||this.b.quality==="stable")throw this.a.error(`[voice] transcribe(${I.length}): Voice recognition not yet supported`),new Error("Voice recognition not yet supported!");const P=Date.now();try{const E=te.__$__nodeRequire(d),b=new AbortController;C.onCancellationRequested(()=>b.abort());const l=await E.transcribe({samplingRate:16e3,bitDepth:16,channelCount:1,channelData:I},{language:"en",signal:b.signal});return this.a.info(`[voice] transcribe(${I.length}): Text "${l}", took ${Date.now()-P}ms)`),l}catch(E){throw this.a.error(`[voice] transcribe(${I.length}): Failed width "${E}", took ${Date.now()-P}ms)`),E}}};e.$38b=A,e.$38b=A=ye([X(0,D.$8i),X(1,L.$nj)],A)}),define(oe[240],ae([0,1,2,112,7,26,5]),function(te,e,D,N,L,A,O){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$48b=void 0;let C=class extends D.$Rc{static{I=this}static{this.a=!!process.env.VSCODE_VOICE_USE_SLIDING_WINDOW}constructor(l,g,p){super(),this.b=l,this.c=g,this.f=p,this.g()}g(){this.B(this.b(l=>{this.f.info(`[voice] transcriber: new connection (sliding window: ${I.a})`),I.a?this.B(new P(l,this.c,this.f)):this.B(new E(l,this.c,this.f))}))}};e.$48b=C,e.$48b=C=I=ye([X(1,N.$28b),X(2,L.$8i)],C);class d extends D.$Rc{static{this.a=30*16e3*16*1/8}constructor(l,g,p){super(),this.b=l,this.c=g,this.f=p,this.g()}g(){const l=new A.$Wd;this.B((0,D.$Pc)(()=>l.dispose(!0)));const g=w=>{w.data instanceof Float32Array&&this.h(w.data,l.token)};this.b.on("message",g),this.B((0,D.$Pc)(()=>this.b.off("message",g))),this.b.start();let p=!1;this.b.on("close",()=>{this.f.info("[voice] transcriber: closed connection"),p=!0,this.dispose()}),this.B((0,D.$Pc)(()=>{p||this.b.close()}))}j(l){const g=new Float32Array(l.reduce((w,f)=>w+f.length,0));let p=0;for(const w of l)g.set(w,p),p+=w.length;return g}}class P extends d{constructor(){super(...arguments),this.m=this.B(new O.$Zg),this.n=[],this.r=new Float32Array(0)}async h(l,g){if(l.length>0)this.f.info("[voice] transcriber: voice detected, storing in buffer"),this.r=this.r?this.j([this.r,l]):l;else{this.f.info("[voice] transcriber: silence detected, transcribing window...");const p=this.r.slice(0);this.r=new Float32Array(0),this.m.queue(()=>this.t(p,g))}}async t(l,g){if(!g.isCancellationRequested){if(l.length>d.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}if(l.length!==0){const p=await this.c.transcribe(l,g);p&&this.n.push(p)}g.isCancellationRequested||this.b.postMessage(this.n.join(" "))}}dispose(){super.dispose(),this.r=new Float32Array(0)}}class E extends d{constructor(){super(...arguments),this.m=new O.$1g,this.n=void 0,this.r=0,this.s=""}async h(l,g){const p=this.n?this.j([this.n,l]):l;if(p.length>d.a){this.f.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}this.n=p,this.m.queue(()=>this.u(g))}async u(l){if(l.isCancellationRequested)return;const g=this.n?.slice(0);if(!g)return;let p;g.length===this.r?(this.f.info("[voice] transcriber: silence detected, reusing previous transcription result"),p=this.s):(this.f.info("[voice] transcriber: voice detected, transcribing everything..."),p=await this.c.transcribe(g,l)),this.s=p,this.r=g.length,!l.isCancellationRequested&&this.b.postMessage(p)}dispose(){super.dispose(),this.n=void 0}}}),define(oe[241],ae([0,1,5,3,2]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=void 0;class A extends L.$Rc{constructor({onDidOpenWindow:I,onDidFocusWindow:C,getActiveWindowId:d}){super(),this.a=this.B(new L.$Qc),N.Event.latch(N.Event.any(I,C))(this.f,this,this.a),this.b=(0,D.$Gg)(()=>d()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$y7b=A}),define(oe[113],ae([0,1,178,16,47,19,10,4,23]),function(te,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,I.$Nh)("contextService");function d(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.$Xh=d;function P(i){return typeof i?.id=="string"&&!d(i)&&!b(i)}e.$Yh=P,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function E(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,N.$mc)(i)}:t?e.$Zh:e.$1h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$2h=E;function b(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.$3h=b;function l(i){const t=i;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$4h=l;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function p(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$5h=p;function w(i){const t=i;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$6h=w;class f{constructor(t,r,o,v,y){this.h=t,this.j=o,this.k=v,this.l=y,this.c=L.$Th.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=L.$Th.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=f;class c{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.$ug)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=c;function h(i){return new c({uri:i,index:0,name:(0,A.$qg)(i)},{uri:i.toString()})}e.$9h=h,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,D.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function m(i,t){return A.$lg.isEqualOrParent(i,t.untitledWorkspacesHome)}e.$bi=m;function S(i){let t;return O.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===C.Schemas.tmp}e.$ci=S,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$di}e.$ei=s;function a(i,t){return!m(i,t)&&!S(i)}e.$fi=a;function n(i){return(typeof i=="string"?(0,N.$nc)(i):(0,A.$sg)(i))===e.$$h}e.$gi=n}),define(oe[17],ae([0,1,52,3,2,19,10,169,14,11,4,7,113,34,28,5,32,27,12]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.ProfileResourceType=void 0;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function m(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$Hk=m,e.$Ik=(0,P.$Nh)("IUserDataProfilesService");function S(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:O.URI.revive(i.location).with({scheme:t}),globalStorageHome:O.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Jk=S;function s(i,t,r,o,v,y){return{id:i,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:y&&v?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$ug)(r,"globalStorage"),settingsResource:y&&v?.useDefaultFlags?.settings?y.settingsResource:(0,A.$ug)(r,"settings.json"),keybindingsResource:y&&v?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$ug)(r,"keybindings.json"),tasksResource:y&&v?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$ug)(r,"tasks.json"),snippetsHome:y&&v?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$ug)(r,"snippets"),extensionsResource:y&&v?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$ug)(r,"extensions.json"),cacheHome:(0,A.$ug)(o,i),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Kk=s;let a=class extends L.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,o,v){super(),this.t=t,this.u=r,this.w=o,this.y=v,this.f=!0,this.h=this.B(new N.$Md),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Md),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Md),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Md),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,c.$xf)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(s((0,A.$rg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},t))}}catch(y){this.y.error(y)}const o=new l.$zc,v=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[u,$]of Object.entries(y.workspaces)){const j=O.URI.parse(u),M=r.find(T=>T.id===$);M&&o.set(j,M)}if(y.emptyWindows)for(const[u,$]of Object.entries(y.emptyWindows)){const j=r.find(M=>M.id===$);j&&v.set(u,j)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:o,emptyWindows:v}}return this.z}D(){const t=s("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,f.$Ee)(r)}\\s(\\d+)`);let v=0;for(const u of this.profiles){const $=o.exec(u.name),j=$?parseInt($[1]):0;v=j>v?j:v}const y=`${r} ${v+1}`;return this.createProfile((0,D.$Bi)((0,w.$dg)()).toString(16),y,{transient:!0},t)}async createNamedProfile(t,r,o){return this.createProfile((0,D.$Bi)((0,w.$dg)()).toString(16),t,r,o)}async createProfile(t,r,o,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(t,r,o);return v&&await this.setProfileForWorkspace(v,y),y}async F(t,r,o){if(!(0,c.$xf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const y=this.profiles.find(j=>j.name===r||j.id===t);if(y)return y;const u=s(t,r,(0,A.$ug)(this.profilesHome,t),this.g,o,this.defaultProfile);await this.u.createFolder(u.location);const $=[];return this.j.fire({profile:u,join(j){$.push(j)}}),await p.Promises.settled($),this.I([u],[],[]),u}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(v=>v.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=s(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this.m.fire({profile:r,join(v){o.push(v)}});try{await Promise.allSettled(o)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,d.$nk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(v=>v.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,o)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,b.$Xh)(t)?t.uri:(0,b.$3h)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,o){const v=[...this.profiles,...t],y=[];this.s.profiles=[];for(let u of v)u.isDefault||r.some($=>u.id===$.id)||(u=o.find($=>u.id===$.id)??u,u.isTransient?this.s.profiles.push(u):y.push({location:u.location,name:u.name,shortName:u.shortName,icon:u.icon,useDefaultFlags:u.useDefaultFlags}));this.P(y),this.z=void 0,this.J(t,r,o)}J(t,r,o){this.h.fire({added:t,removed:r,updated:o,all:this.profiles})}L(t,r,o){o=r?.isTransient?!0:o,o||this.L(t,void 0,!0);const v=this.G(t),y=o?this.s:this.C;O.URI.isUri(v)?(y.workspaces.delete(v),r&&y.workspaces.set(v,r)):(y.emptyWindows.delete(v),r&&y.emptyWindows.set(v,r)),o||this.M()}M(){const t={};for(const[o,v]of this.C.workspaces.entries())t[o.toString()]=v.id;const r={};for(const[o,v]of this.C.emptyWindows.entries())r[o.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},o=this.D();if(t.workspaces)for(const[y,u]of Object.entries(t.workspaces)){const $=O.URI.parse(u);r[y]=this.w.extUri.isEqual($,o.location)?o.id:this.w.extUri.basename($)}const v={};if(t.emptyWindows)for(const[y,u]of Object.entries(t.emptyWindows)){const $=O.URI.parse(u);v[y]=this.w.extUri.isEqual($,o.location)?o.id:this.w.extUri.basename($)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Lk=a,e.$Lk=a=ye([X(0,C.$Uh),X(1,d.$9j),X(2,g.$Gk),X(3,E.$8i)],a);class n extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Mk=n}),define(oe[242],ae([0,1,5,2,17]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J8b=void 0;let A=class extends N.$Rc{constructor(I){super(),this.B(new D.$5g(()=>{I.cleanUp()},10*1e3)).schedule()}};e.$J8b=A,e.$J8b=A=ye([X(0,L.$Ik)],A)}),define(oe[243],ae([0,1,18,5,26,8,3,2,6,12,10,152,29,33,44,7,24,22,28,17]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=void 0;let m=class extends I.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,o,v,y,u){super(),this.z=t,this.C=r,this.D=o,this.F=v,this.G=y,this.H=u,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$Md),this.s=this.B(new O.$Md),this.t=this.B(new O.$Md),this.u=this.B(new O.$Md),this.w=this.B(new O.$Md),this.y=[],this.B((0,I.$Pc)(()=>{this.j.forEach(({task:$})=>$.cancel()),this.m.forEach($=>$.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,b.$4n)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:y})=>(0,l.$wo)(y,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(o){throw s(o)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new b.$8n(E.localize(0,null),b.ExtensionManagementErrorCode.Internal);const r=[],o=[];await Promise.allSettled(t.map(async({extension:v,options:y})=>{try{const u=await this.O(v,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);o.push({...u,options:y})}catch(u){r.push({identifier:v.identifier,operation:2,source:v,error:u})}})),o.length&&r.push(...await this.I(o));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!P.URI.isUri(v.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,l.$Eo)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,g.$6l)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let o=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(o=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const y=(await this.getInstalled(1,v.extensionsResource)).find(u=>(0,l.$wo)(u.identifier,t.identifier));y?this.w.fire(y):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async o=>{try{const v=await this.J(o);r.push(...v)}catch(v){r.push({identifier:{id:(0,l.$Bo)(o.manifest.publisher,o.manifest.name)},operation:2,source:o.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:o}){const v=o.isApplicationScoped||o.isBuiltin||(0,g.$6l)(t),y={...o,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:v,profileLocation:v?this.H.defaultProfile.extensionsResource:o.profileLocation??this.Y()},u=q=>`${l.$xo.create(q).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const q=this.j.get(u(r));if(q)return this.F.info("Extensions is already requested to install",r.identifier.id),await q.task.waitUntilTaskIsFinished(),[]}const $=[],j=[],M=[],T=this.Z(t,r,y);P.URI.isUri(r)||this.j.set(u(r),{task:T,waitingTasks:[]}),this.n.fire({identifier:T.identifier,source:r,profileLocation:y.profileLocation}),this.F.info("Installing extension:",T.identifier.id),$.push({task:T,manifest:t});let U=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const Y=await this.N(T.identifier,t,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),J=await this.getInstalled(void 0,y.profileLocation),x={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[b.$Yn]:!0}};for(const{gallery:W,manifest:Q}of(0,D.$Lb)(Y,({gallery:H})=>H.identifier.id)){U=U||!!Q.extensionDependencies?.some(ee=>(0,l.$wo)({id:ee},T.identifier));const H=u(W),V=this.j.get(H);if(V){if(this.L(T,V.task)){const ee=V.task.identifier;this.F.info("Waiting for already requested installing extension",ee.id,T.identifier.id),V.waitingTasks.push(T),j.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,ne=>ne.some(_=>(0,l.$wo)(_.identifier,ee)))).then(ne=>{if(this.F.info("Finished waiting for already requested installing extension",ee.id,T.identifier.id),!ne.find(ie=>(0,l.$wo)(ie.identifier,ee))?.local)throw new Error(`Extension ${ee.id} is not installed`)}))}}else if(!J.some(({identifier:ee})=>(0,l.$wo)(ee,W.identifier))){const ee=this.Z(Q,W,x);this.j.set(H,{task:ee,waitingTasks:[T]}),this.n.fire({identifier:ee.identifier,source:W,profileLocation:y.profileLocation}),this.F.info("Installing extension:",ee.identifier.id,T.identifier.id),$.push({task:ee,manifest:Q})}}}catch(Y){if(P.URI.isUri(T.source))(0,D.$Kb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",T.identifier.id,Y.message),(0,D.$Kb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",T.identifier.id,Y.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),Y}const q=$.reduce((Y,{task:J,manifest:x})=>(Y.set(J.identifier.id.toLowerCase(),{task:J,manifest:x}),Y),new Map);for(;q.size;){let Y;const J=[...q.values()].filter(({manifest:x})=>!x.extensionDependencies?.some(W=>q.has(W.toLowerCase())));J.length?Y=q.size===1?J:J.filter(({task:x})=>!(x===T&&!U)):(this.F.info("Found extensions with circular dependencies",J.map(({task:x})=>x.identifier.id)),Y=[...q.values()]),await this.M(Y.map(async({task:x})=>{const W=new Date().getTime();try{const Q=await x.run();if(await this.M(this.y.map(H=>H.postInstall(Q,x.source,y,L.CancellationToken.None))),!P.URI.isUri(x.source)){const H=x.operation===3,V=H?void 0:(new Date().getTime()-x.source.lastUpdated)/1e3;if(a(this.C,H?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Eo)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-W,durationSinceUpdate:V}),C.$p&&x.operation!==3)try{await this.z.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}M.push({local:Q,identifier:x.identifier,operation:x.operation,source:x.source,context:x.options.context,profileLocation:x.profileLocation,applicationScoped:Q.isApplicationScoped})}catch(Q){throw P.URI.isUri(x.source)||a(this.C,x.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Eo)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-W,error:Q}),this.F.error("Error while installing the extension:",x.identifier.id),Q}finally{q.delete(x.identifier.id.toLowerCase())}}))}return j.length&&await this.M(j),M.forEach(({identifier:Y})=>this.F.info("Extension installed successfully:",Y.id)),M}catch(q){if($.forEach(({task:Y})=>Y.cancel()),M.length)try{const Y=await Promise.allSettled(M.map(({local:J})=>this.$(J,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let J=0;J<Y.length;J++){const x=Y[J],{identifier:W}=M[J];x.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",W.id):this.F.warn("Rollback: Error while uninstalling extension",W.id,(0,A.$9)(x.reason))}}catch(Y){this.F.warn("Error while rolling back extensions",(0,A.$9)(Y),M.map(({identifier:J})=>J.id))}return $.map(({task:Y})=>({identifier:Y.identifier,operation:2,source:Y.source,context:y.context,profileLocation:y.profileLocation,error:q}))}finally{for(const{task:q}of $)q.source&&!P.URI.isUri(q.source)&&this.j.delete(u(q.source))}}L(t,r){for(const[,{task:o,waitingTasks:v}]of this.j.entries())if(o===t&&(v.includes(r)||v.some(y=>this.L(y,r)))||o===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],o=[],v=await Promise.allSettled(t);for(const y of v)y.status==="fulfilled"?r.push(y.value):o.push(y.reason);if(o.length)throw S(o);return r}async N(t,r,o,v,y){if(!this.z.isEnabled())return[];const u=await this.getInstalled(void 0,y),$=[],j=[],M=async(T,U)=>{$.push(T);const q=U.extensionDependencies||[],Y=[...q];if(U.extensionPack){const J=o?u.find(x=>(0,l.$wo)(x.identifier,T)):void 0;for(const x of U.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(W=>(0,l.$wo)({id:W},{id:x}))||Y.every(W=>!(0,l.$wo)({id:W},{id:x}))&&Y.push(x)}if(Y.length){const J=Y.filter(x=>$.every(W=>!(0,l.$wo)(W,{id:x})));if(J.length){const x=await this.z.getExtensions(J.map(W=>({id:W,preRelease:v})),L.CancellationToken.None);for(const W of x){if($.find(V=>(0,l.$wo)(V,W.identifier)))continue;const Q=q.some(V=>(0,l.$wo)({id:V},W.identifier));let H;try{H=await this.O(W,!1,v)}catch(V){if(Q)throw V;this.F.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,A.$9)(V));continue}j.push({gallery:H.extension,manifest:H.manifest}),await M(H.extension.identifier,H.manifest)}}}};return await M(t,r),j}async O(t,r,o){let v;const y=await this.getExtensionsControlManifest();if(y.malicious.some(j=>(0,l.$wo)(t.identifier,j)))throw new b.$8n(E.localize(1,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);const u=y.deprecated[t.identifier.id.toLowerCase()];if(u?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${u.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:u.extension.id,preRelease:u.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0],!v)throw new b.$8n(E.localize(2,null,t.identifier.id,u.extension.id),b.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const j=await this.getTargetPlatform();throw new b.$8n(E.localize(3,null,t.identifier.id,this.G.nameLong,(0,b.$Zn)(j)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,o),!v)throw!o&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],L.CancellationToken.None))[0]?new b.$8n(E.localize(4,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.$8n(E.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),b.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const $=await this.z.getManifest(v,L.CancellationToken.None);if($===null)throw new b.$8n(`Missing manifest for extension ${v.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if($.version!==v.version)throw new b.$8n(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:$}}async P(t,r,o){const v=await this.getTargetPlatform();let y=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(y=(await this.z.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null),!y&&await this.z.isExtensionCompatible(t,o,v)&&(y=t),y||(r?y=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null:y=await this.z.getCompatibleExtension(t,o,v)),y}async Q(t,r){const o={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=T=>`${T.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,y=this.m.get(v(t.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),y.waitUntilTaskIsFinished();const u=T=>{const U=this.$(T,o);return this.m.set(v(U.extension.identifier),U),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped}),U},$=(T,U)=>{U?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,U.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Do)(T),error:U}),this.u.fire({identifier:T.identifier,error:U?.code,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped})},j=[],M=[];try{j.push(u(t));const T=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const U=this.U(t,T);for(const q of U)this.m.has(v(q.identifier))?this.F.info("Extensions is already requested to uninstall",q.identifier.id):j.push(u(q))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(j.map(U=>U.extension),T,t),await this.M(j.map(async U=>{try{if(await U.run(),await this.M(this.y.map(q=>q.postUninstall(U.extension,o,L.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,"uninstall")}catch{}$(U.extension)}catch(q){const Y=q instanceof b.$8n?q:new b.$8n((0,A.$9)(q),b.ExtensionManagementErrorCode.Internal);throw $(U.extension,Y),Y}finally{M.push(U)}}))}catch(T){const U=T instanceof b.$8n?T:new b.$8n((0,A.$9)(T),b.ExtensionManagementErrorCode.Internal);for(const q of j){try{q.cancel()}catch{}M.includes(q)||$(q.extension,U)}throw U}finally{for(const T of j)this.m.delete(v(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}R(t,r,o){for(const v of t){const y=this.W(v,r);if(y.length){const u=y.filter($=>!t.some(j=>(0,l.$wo)(j.identifier,$.identifier)));if(u.length)throw new Error(this.S(v,u,o))}}}S(t,r,o){return o===t?r.length===1?E.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const y=r.filter($=>!$.isBuiltin&&v.some(j=>(0,l.$wo)({id:j},$.identifier))),u=[];for(const $ of y)u.push(...this.U($,r,o));return[...y,...u]}return[]}W(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(v=>(0,l.$wo)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$mp=m,e.$mp=m=ye([X(0,b.$7n),X(1,f.$al),X(2,c.$Gk),X(3,p.$8i),X(4,w.$nj),X(5,h.$Ik)],m);function S(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.$np=S;function s(i){if(i instanceof b.$8n)return i;const t=new b.$8n(i.message,b.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$op=s;function a(i,t,{extensionData:r,verificationStatus:o,duration:v,error:y,durationSinceUpdate:u}){let $,j;(0,d.$Ff)(o)&&(o===!0?o="Verified":(o===!1||($=b.ExtensionManagementErrorCode.Signature,j=o),o="Unverified")),y&&(y instanceof b.$8n?($=y.code,y.code===b.ExtensionManagementErrorCode.Signature&&(j=y.message)):$=b.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:o,success:!y,duration:v,errorcode:$,errorcodeDetail:j,durationSinceUpdate:u})}class n{constructor(){this.d=new N.$Rg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$Gg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$Gg)(t=>new Promise((r,o)=>{const v=t.onCancellationRequested(()=>{v.dispose(),o(new A.$4)})})),this.d.open()),this.g.cancel()}}e.$pp=n}),define(oe[51],ae([0,1,5,15,2,3,34,10,29,33,11,4,7,17,28,12,8,22]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class h extends Error{constructor(n,i){super(n),this.code=i}}e.$qp=h,e.$rp=(0,E.$Nh)("IExtensionsProfileScannerService");let m=class extends L.$Rc{constructor(n,i,t,r,o,v){super(),this.j=n,this.m=i,this.n=t,this.r=r,this.s=o,this.t=v,this.b=this.B(new A.$Md),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Md),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Md),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Md),this.onDidRemoveExtensions=this.g.event,this.h=new O.$zc}scanProfileExtensions(n,i){return this.u(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.u(i,o=>{const v=[];for(const y of o)n.some(([u])=>(0,d.$wo)(u.identifier,y.identifier)&&u.manifest.version!==y.version)?t.push(y):v.push(y);for(const[y,u]of n){const $=v.findIndex(M=>(0,d.$wo)(M.identifier,y.identifier)&&M.version===y.manifest.version),j={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:u};$===-1?(r.push(j),v.push(j)):v.splice($,1,j)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),t.length&&this.f.fire({extensions:t,profileLocation:i}),v}),r.length&&this.c.fire({extensions:r,profileLocation:i}),t.length&&this.g.fire({extensions:t,profileLocation:i}),r}catch(o){throw r.length&&this.c.fire({extensions:r,error:o,profileLocation:i}),t.length&&this.g.fire({extensions:t,error:o,profileLocation:i}),o}}async updateMetadata(n,i){const t=[];return await this.u(i,r=>{const o=[];for(const v of r){const y=n.find(([u])=>(0,d.$wo)(u.identifier,v.identifier)&&u.manifest.version===v.version);y&&(v.metadata={...v.metadata,...y[1]},t.push(v)),o.push(v)}return o}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.u(i,r=>{const o=[];for(const v of r)(0,d.$wo)(v.identifier,n.identifier)?t.push(v):o.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:i}),o}),t.length&&this.g.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:i}),r}}async u(n,i,t){return this.F(n).queue(async()=>{let r=[],o;try{const v=await this.m.readFile(n);o=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,P.$nk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&t?.bailOutWhenFileNotFound)throw new h((0,w.$9)(v),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.w(n);let v=!1;for(const y of o){S(y)||this.w(n);let u;if((0,p.$xf)(y.relativeLocation)&&y.relativeLocation)u=this.z(y.relativeLocation);else if((0,p.$xf)(y.location))u=this.z(y.location),v=!0,y.relativeLocation=y.location,y.location=u.toJSON();else{u=I.URI.revive(y.location);const $=this.y(u);$&&(v=!0,y.relativeLocation=$)}r.push({identifier:y.identifier,location:u,version:y.version,metadata:y.metadata})}v&&await this.m.writeFile(n,N.$ae.fromString(JSON.stringify(o)))}if(i){r=i(r);const v=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(n,N.$ae.fromString(JSON.stringify(v)))}return r})}w(n){const i=new h(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(o){if((0,P.$nk)(o)===1)return;throw o}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(t);Array.isArray(o)&&o.every(v=>S(v))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$ae.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,P.$nk)(o)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(n)}catch(o){(0,P.$nk)(o)!==1&&this.t.error(o)}try{await this.m.del(i)}catch(o){(0,P.$nk)(o)!==1&&this.t.error(o)}return r})()),this.C}F(n){let i=this.h.get(n);return i||(i=new D.$Zg,this.h.set(n,i)),i}};e.$sp=m,e.$sp=m=ye([X(1,P.$9j),X(2,l.$Ik),X(3,g.$Gk),X(4,f.$al),X(5,b.$8i)],m);function S(a){return(0,p.$zf)(a)&&(0,C.$6n)(a.identifier)&&(s(a.location)||(0,p.$xf)(a.location)&&a.location)&&((0,p.$Ef)(a.relativeLocation)||(0,p.$xf)(a.relativeLocation))&&a.version&&(0,p.$xf)(a.version)}function s(a){return a?(0,p.$xf)(a.path)&&(0,p.$xf)(a.scheme):!1}}),define(oe[80],ae([0,1,18,5,30,15,8,35,139,2,23,16,6,19,54,89,12,10,155,14,33,44,68,11,4,7,24,3,64,51,17,28,183]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h,m,S,s,a,n,i,t,r,o,v,y,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.Translations=void 0;var j;(function(x){function W(Q,H){if(Q===H)return!0;const V=Object.keys(Q),ee=new Set;for(const ne of Object.keys(H))ee.add(ne);if(V.length!==ee.size)return!1;for(const ne of V){if(Q[ne]!==H[ne])return!1;ee.delete(ne)}return ee.size===0}x.equals=W})(j||(e.Translations=j={})),e.$vp=(0,n.$Nh)("IExtensionsScannerService");let M=class extends d.$Rc{constructor(W,Q,H,V,ee,ne,_,ie,K,B,k,R){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=Q,this.r=H,this.s=V,this.t=ee,this.u=ne,this.w=_,this.y=ie,this.z=K,this.C=B,this.D=k,this.F=R,this.g=this.B(new r.$Md),this.onDidChangeCache=this.g.event,this.h=(0,l.$ug)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$Ho)(this.w,this.y)),this.G}async scanAllExtensions(W,Q,H){const[V,ee]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(Q)]),ne=H?await this.scanExtensionsUnderDevelopment(W,[...V,...ee]):[];return this.L(V,ee,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const Q=[];Q.push(this.M(!!W.useCache,W.language)),Q.push(this.N(W.language,!!W.checkControlFile));const[H,V]=await Promise.all(Q);return this.J([...H,...V],0,W,!1)}async scanUserExtensions(W){const Q=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const H=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(Q,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,H),ee=W.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let ne;try{ne=await ee.scanExtensions(V)}catch(_){if(_ instanceof v.$qp&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ne=await ee.scanExtensions(V);else throw _}return ne=await this.J(ne,1,W,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(W,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===P.Schemas.file).map(async V=>{const ee=await this.P(V,!1,1,!0,W.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(ee)).map(_=>(_.type=Q.find(ie=>(0,m.$wo)(ie.identifier,_.identifier))?.type??_.type,this.n.validate(_,ee)))}))).flat();return this.J(H,"development",W,!0)}return[]}async scanExistingExtension(W,Q,H){const V=await this.P(W,!1,Q,!0,H.language,!0,void 0),ee=await this.n.scanExtension(V);return!ee||!H.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(W,Q,H){const V=await this.P(W,!1,Q,!0,H.language,!0,void 0),ee=await this.n.scanOneOrMultipleExtensions(V);return this.J(ee,Q,H,!0)}async scanMetadata(W){const Q=(0,l.$ug)(W,"package.json"),H=(await this.w.readFile(Q)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(W,Q){const H=(0,l.$ug)(W,"package.json"),V=(await this.w.readFile(H)).value.toString(),ee=JSON.parse(V);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,ee.__metadata={...ee.__metadata,...Q},await this.w.writeFile((0,l.$ug)(W,"package.json"),A.$ae.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof v.$qp&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$ae.fromString(JSON.stringify([])))}catch(Q){(0,a.$nk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$9)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,Q,H,V){return H.includeAllVersions||(W=this.L(Q===0?W:void 0,Q===1?W:void 0,Q==="development"?W:void 0,await this.getTargetPlatform(),V)),H.includeInvalid||(W=W.filter(ee=>ee.isValid)),W.sort((ee,ne)=>{const _=E.$mc(ee.location.fsPath),ie=E.$mc(ne.location.fsPath);return _<ie?-1:_>ie?1:0})}L(W,Q,H,V,ee){const ne=(ie,K,B)=>{if(ie.isValid&&!K.isValid)return!1;if(ie.isValid===K.isValid){if(ee&&g.gt(ie.manifest.version,K.manifest.version))return this.y.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version} in favour of ${ie.location.path} with version ${ie.manifest.version}`),!1;if(g.eq(ie.manifest.version,K.manifest.version)){if(ie.type===0)return this.y.debug(`Skipping extension ${K.location.path} in favour of system extension ${ie.location.path} with same version`),!1;if(ie.targetPlatform===V)return this.y.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`),!1}}return B?this.y.warn(`Overwriting user extension ${ie.location.path} with ${K.location.path}.`):this.y.debug(`Overwriting user extension ${ie.location.path} with ${K.location.path}.`),!0},_=new S.$5l;return W?.forEach(ie=>{const K=_.get(ie.identifier.id);(!K||ne(K,ie,!1))&&_.set(ie.identifier.id,ie)}),Q?.forEach(ie=>{const K=_.get(ie.identifier.id);if(!K&&W&&ie.type===0){this.y.debug(`Skipping obsolete system extension ${ie.location.path}.`);return}(!K||ne(K,ie,!1))&&_.set(ie.identifier.id,ie)}),H?.forEach(ie=>{const K=_.get(ie.identifier.id);(!K||ne(K,ie,!0))&&_.set(ie.identifier.id,ie),_.set(ie.identifier.id,ie)}),[..._.values()]}async M(W,Q){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),ee=await(W&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(W,Q){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const V=Q?await this.O():{},ee=[],ne=f.URI.file(E.$gc(E.$ic(P.$bg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ie of H){const K=V[ie.name]||"marketplace";switch(K){case"disabled":break;case"marketplace":ee.push((0,l.$ug)(ne,ie.name));break;default:ee.push(f.URI.file(K));break}}const _=await Promise.all(ee.map(async ie=>this.n.scanExtension(await this.P(ie,!1,0,!0,W,!0,void 0))));return this.y.trace("Scanned dev system extensions:",_.length),(0,D.$Gb)(_)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,Q,H,V,ee,ne,_){const ie=await this.f(ee??b.$w),K=await this.Q(W),B=Q&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,k=B?await this.Q(B):void 0;return new T(W,K,B,k,Q,_,H,V,ne,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,ee,ie)}async Q(W){try{const Q=await this.w.stat(W);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$wp=M,e.$wp=M=ye([X(4,y.$Ik),X(5,v.$rp),X(6,a.$9j),X(7,i.$8i),X(8,h.$Uh),X(9,t.$nj),X(10,u.$Gk),X(11,n.$Mh)],M);class T{constructor(W,Q,H,V,ee,ne,_,ie,K,B,k,R,z,F,G){this.location=W,this.mtime=Q,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=V,this.profile=ee,this.profileScanOptions=ne,this.type=_,this.excludeObsolete=ie,this.validate=K,this.productVersion=B,this.productDate=k,this.productCommit=R,this.devMode=z,this.language=F,this.translations=G}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,Q){return(0,l.$ng)(W.location,Q.location)&&W.mtime===Q.mtime&&(0,l.$ng)(W.applicationExtensionslocation,Q.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&W.profile===Q.profile&&L.$7m(W.profileScanOptions,Q.profileScanOptions)&&W.type===Q.type&&W.excludeObsolete===Q.excludeObsolete&&W.validate===Q.validate&&W.productVersion===Q.productVersion&&W.productDate===Q.productDate&&W.productCommit===Q.productCommit&&W.devMode===Q.devMode&&W.language===Q.language&&j.equals(W.translations,Q.translations)}}e.$xp=T;let U=class extends d.$Rc{constructor(W,Q,H,V,ee){super(),this.f=W,this.g=Q,this.h=H,this.j=V,this.m=ee}async scanExtensions(W){const Q=W.profile?await this.r(W):await this.n(W);let H={};if(W.excludeObsolete&&W.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(V)}catch{}return(0,w.$Kf)(H)?Q:Q.filter(V=>!H[m.$xo.create(V).toString()])}async n(W){const Q=await this.j.resolve(W.location);if(!Q.children?.length)return[];const H=await Promise.all(Q.children.map(async V=>{if(!V.isDirectory||W.type===1&&(0,l.$rg)(V.resource).indexOf(".")===0)return null;const ee=new T(V.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(ee)}));return(0,D.$Gb)(H).sort((V,ee)=>V.location.path<ee.location.path?-1:1)}async r(W){let Q=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){Q=Q.filter(V=>!V.metadata?.isApplicationScoped);const H=await this.s(W.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,W);Q.push(...H)}return Q}async s(W,Q,H){const V=await this.g.scanProfileExtensions(W,H.profileScanOptions);if(!V.length)return[];const ee=await Promise.all(V.map(async ne=>{if(Q(ne)){const _=new T(ne.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(_,ne.metadata)}return null}));return(0,D.$Gb)(ee)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,l.$ug)(W.location,"package.json"))){const Q=await this.scanExtension(W);return Q?[Q]:[]}else return await this.scanExtensions(W)}catch(Q){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,O.$9)(Q)),[]}}async scanExtension(W,Q){try{let H=await this.scanExtensionManifest(W.location);if(H){H.publisher||(H.publisher=S.$Yl),Q=Q??H.__metadata,delete H.__metadata;const V=(0,m.$Bo)(H.publisher,H.name),ee=Q?.id?{id:V,uuid:Q.id}:{id:V},ne=Q?.isSystem?0:W.type,_=ne===0||!!Q?.isBuiltin;H=await this.t(W.location,H,T.createNlsConfiguration(W));const ie={type:ne,identifier:ee,manifest:H,location:W.location,isBuiltin:_,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return W.validate?this.validate(ie,W):ie}}catch(H){W.type!==0&&this.m.error(H)}return null}validate(W,Q){let H=!0;const V=(0,s.$Mo)(Q.productVersion,Q.productDate,Q.location,W.manifest,W.isBuiltin);for(const[ee,ne]of V)ee===p.default.Error&&(H=!1,this.m.error(this.z(Q.location,ne)));return W.isValid=H,W.validations=V,W}async scanExtensionManifest(W){const Q=(0,l.$ug)(W,"package.json");let H;try{H=(await this.j.readFile(Q)).value.toString()}catch(ee){return(0,a.$nk)(ee)!==1&&this.m.error(this.z(W,(0,c.localize)(0,null,Q.path,ee.message))),null}let V;try{V=JSON.parse(H)}catch{const ne=[];(0,I.$Sm)(H,ne);for(const _ of ne)this.m.error(this.z(W,(0,c.localize)(1,null,Q.path,_.offset,_.length,(0,C.$tp)(_.error))));return null}return(0,I.$2m)(V)!=="object"?(this.m.error(this.z(W,(0,c.localize)(2,null,Q.path))),null):V}async t(W,Q,H){const V=await this.u(W,Q,H);if(V)try{const ee=[],ne=await this.w(V.default,ee);if(ee.length>0)return ee.forEach(ie=>{this.m.error(this.z(W,(0,c.localize)(3,null,V.default?.path,(0,C.$tp)(ie.error))))}),Q;if((0,I.$2m)(V)!=="object")return this.m.error(this.z(W,(0,c.localize)(4,null,V.default?.path))),Q;const _=V.values||Object.create(null);return(0,$.$up)(this.m,Q,_,ne)}catch{}return Q}async u(W,Q,H){const V=(0,l.$ug)(W,"package.nls.json"),ee=(K,B)=>{B.forEach(k=>{this.m.error(this.z(W,(0,c.localize)(5,null,K?.path,(0,C.$tp)(k.error))))})},ne=K=>{this.m.error(this.z(W,(0,c.localize)(6,null,K?.path)))},_=`${Q.publisher}.${Q.name}`,ie=H.translations[_];if(ie)try{const K=f.URI.file(ie),B=(await this.j.readFile(K)).value.toString(),k=[],R=(0,I.$Sm)(B,k);return k.length>0?(ee(K,k),{values:void 0,default:V}):(0,I.$2m)(R)!=="object"?(ne(K),{values:void 0,default:V}):{values:R.contents?R.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let B;try{B=await this.y(W,H)}catch{return}if(!B.localized)return{values:void 0,default:B.original};try{const k=(await this.j.readFile(B.localized)).value.toString(),R=[],z=(0,I.$Sm)(k,R);return R.length>0?(ee(B.localized,R),{values:void 0,default:B.original}):(0,I.$2m)(z)!=="object"?(ne(B.localized),{values:void 0,default:B.original}):{values:z,default:B.original}}catch{return{values:void 0,default:B.original}}}}async w(W,Q){if(W)try{const H=(await this.j.readFile(W)).value.toString();return(0,I.$Sm)(H,Q)}catch{}}y(W,Q){return new Promise((H,V)=>{const ee=ne=>{const _=(0,l.$ug)(W,`package.nls.${ne}.json`);this.j.exists(_).then(ie=>{ie&&H({localized:_,original:(0,l.$ug)(W,"package.nls.json")});const K=ne.lastIndexOf("-");K===-1?H({localized:(0,l.$ug)(W,"package.nls.json"),original:null}):(ne=ne.substring(0,K),ee(ne))})};if(Q.devMode||Q.pseudo||!Q.language)return H({localized:(0,l.$ug)(W,"package.nls.json"),original:null});ee(Q.language)})}z(W,Q){return`[${W.path}]: ${Q}`}};U=ye([X(1,v.$rp),X(2,u.$Gk),X(3,a.$9j),X(4,i.$8i)],U);let q=class extends U{constructor(W,Q,H,V,ee,ne,_){super(Q,V,ee,ne,_),this.G=W,this.H=H,this.D=this.B(new N.$Qg(3e3)),this.F=this.B(new r.$Md),this.onDidChangeCache=this.F.event}async scanExtensions(W){const Q=this.M(W),H=await this.I(Q);if(this.C=W,H&&H.input&&T.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),H.result.map(ee=>(ee.location=f.URI.revive(ee.location),ee));const V=await super.scanExtensions(W);return await this.J(Q,{input:W,result:V}),V}async I(W){try{const Q=await this.j.readFile(W),H=JSON.parse(Q.value.toString());return{result:H.result,input:(0,o.$kh)(H.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",W.path,(0,O.$9)(Q))}return null}async J(W,Q){try{await this.j.writeFile(W,A.$ae.fromString(JSON.stringify(Q)))}catch(H){this.m.debug("Error while writing the extension cache file:",W.path,(0,O.$9)(H))}}async L(){if(!this.C)return;const W=this.M(this.C),Q=await this.I(W);if(!Q)return;const H=Q.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!L.$7m(V,H))try{this.m.info("Invalidating Cache",H,V),await this.j.del(W),this.F.fire()}catch(ee){this.m.error(ee)}}M(W){const Q=this.N(W);return this.h.extUri.joinPath(Q.cacheHome,W.type===0?S.$Xl:S.$Wl)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(W.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};q=ye([X(2,y.$Ik),X(3,v.$rp),X(4,u.$Gk),X(5,a.$9j),X(6,i.$8i)],q);function Y(x,W){const Q=(0,m.$zo)(x.manifest.publisher,x.manifest.name);return{id:Q,identifier:new S.$3l(Q),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:W,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$yp=Y;class J extends M{constructor(W,Q,H,V,ee,ne,_,ie,K,B,k,R){super(W,Q,(0,l.$ug)(H,".vscode-oss-dev","extensions","control.json"),V,ee,ne,_,ie,K,B,k,R),this.R=(async()=>{if(b.$z)try{const z=await this.w.readFile(f.URI.file(b.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(W){return this.R}}e.$zp=J}),define(oe[244],ae([0,1,65,5,38,3,2,23,16,31,7,17]),function(te,e,D,N,L,A,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;let b=class extends O.$Rc{constructor(g,p){super(),this.b=g,this.f=p,this.a=new N.$Yg(5)}async postUninstall(g){const p=this.g(g,"uninstall");p&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(w){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(w)}}));try{await d.Promises.rm(this.m(g))}catch(w){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(w)}}g(g,p){const w=`vscode:${p}`;if(g.location.scheme===I.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[w]=="string"){const f=g.manifest.scripts[w].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${w} should be a node script`),null):{script:(0,C.$ic)(g.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(g,p,w,f,c){return new Promise((h,m)=>{const S=this.j(g,p,w,c);let s;const a=n=>{s&&(clearTimeout(s),s=null),n?m(n):h(void 0)};S.on("error",n=>{a((0,L.$yi)(n)||"Unknown")}),S.on("exit",(n,i)=>{a(n?`post-${p} process exited with code ${n}`:void 0)}),f&&(s=setTimeout(()=>{s=null,S.kill(),m("timed out")},5e3))})}j(g,p,w,f){const c={silent:!0,execArgv:void 0},h=(0,D.fork)(g,[`--type=extension-post-${p}`,...w],c);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const m=A.Event.fromNodeEventEmitter(h.stdout,"data"),S=A.Event.fromNodeEventEmitter(h.stderr,"data");m(n=>this.f.info(f.identifier.id,f.manifest.version,`post-${p}`,n)),S(n=>this.f.error(f.identifier.id,f.manifest.version,`post-${p}`,n));const s=A.Event.any(A.Event.map(m,n=>({data:`%c${n}`,format:[""]})),A.Event.map(S,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(f.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}m(g){return(0,C.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$Bp=b,e.$Bp=b=ye([X(0,E.$Ik),X(1,P.$8i)],b)}),define(oe[245],ae([0,1,7,17,28,22,51,11,14,10]),function(te,e,D,N,L,A,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=void 0;let P=class extends O.$sp{constructor(b,l,g,p,w,f){super(d.URI.file(b.extensionsPath),l,g,p,w,f)}};e.$xN=P,e.$xN=P=ye([X(0,C.$Vh),X(1,I.$9j),X(2,N.$Ik),X(3,L.$Gk),X(4,A.$al),X(5,D.$8i)],P)}),define(oe[246],ae([0,1,10,14,51,80,11,4,7,24,28,17]),function(te,e,D,N,L,A,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=void 0;let b=class extends A.$zp{constructor(g,p,w,f,c,h,m,S){super(D.URI.file(c.builtinExtensionsPath),D.URI.file(c.extensionsPath),c.userHome,g.defaultProfile,g,p,w,f,c,h,m,S)}};e.$C7b=b,e.$C7b=b=ye([X(0,E.$Ik),X(1,L.$rp),X(2,O.$9j),X(3,C.$8i),X(4,N.$Vh),X(5,d.$nj),X(6,P.$Gk),X(7,I.$Mh)],b)}),define(oe[21],ae([0,1,5,3,2,100,12,67,4,17]),function(te,e,D,N,L,A,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$3o=e.$2o=e.$1o=void 0,e.$1o="__$__isNewStorageMarker",e.$2o="__$__targetStorageMarker",e.$3o=(0,C.$Nh)("storageService");var P;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var E;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var b;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function l(c){const h=c.get(e.$2o);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.$4o=l;class g extends L.$Rc{static{this.a=60*1e3}constructor(h={flushInterval:g.a}){super(),this.m=h,this.b=this.B(new N.$Pd),this.c=this.B(new N.$Pd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Md),this.onWillSaveState=this.f.event,this.h=this.B(new D.$5g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,m,S){return N.Event.filter(this.b.event,s=>s.scope===h&&(m===void 0||s.key===m),S)}n(){this.j.value=(0,D.$9g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,m){const{key:S,external:s}=m;if(S===e.$2o){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:S,target:this.J(h)[S],external:s})}w(h){this.f.fire({reason:h})}get(h,m,S){return this.P(m)?.get(h,S)}getBoolean(h,m,S){return this.P(m)?.getBoolean(h,S)}getNumber(h,m,S){return this.P(m)?.getNumber(h,S)}getObject(h,m,S){return this.P(m)?.getObject(h,S)}storeAll(h,m){this.y(()=>{for(const S of h)this.store(S.key,S.value,S.scope,S.target,m)})}store(h,m,S,s,a=!1){if((0,O.$Gf)(m)){this.remove(h,S,a);return}this.y(()=>{this.z(h,S,s),this.P(S)?.set(h,m,a)})}remove(h,m,S=!1){this.y(()=>{this.z(h,m,void 0),this.P(m)?.delete(h,S)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,m){const S=[],s=this.J(h);for(const a of Object.keys(s))s[a]===m&&S.push(a);return S}z(h,m,S,s=!1){const a=this.J(m);typeof S=="number"?a[h]!==S&&(a[h]=S,this.P(m)?.set(e.$2o,JSON.stringify(a),s)):typeof a[h]=="number"&&(delete a[h],this.P(m)?.set(e.$2o,JSON.stringify(a),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const m=this.P(h);return m?l(m):Object.create(null)}isNew(h){return this.getBoolean(e.$1o,h)===!0}async flush(h=P.NONE){this.f.fire({reason:h});const m=this.P(-1),S=this.P(0),s=this.P(1);switch(h){case P.NONE:await D.Promises.settled([m?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await D.Promises.settled([m?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,S=this.P(1)?.items??new Map;return f(h,m,S,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,m){return this.w(P.NONE),(0,d.$Hk)(h)?this.R(h,m):this.S(h,m)}M(h,m){return!(h.id===m.id||p(m)&&p(h))}N(h,m,S){this.y(()=>{const s=new Set;for(const[a,n]of h)s.add(a),m.get(a)!==n&&this.u(S,{key:a,external:!0});for(const[a]of m.items)s.has(a)||this.u(S,{key:a,external:!0})})}}e.$5o=g;function p(c){return c.isDefault||!!c.useDefaultFlags?.globalState}e.$6o=p;class w extends g{constructor(){super(),this.U=this.B(new I.$Yo(new I.$Zo,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$Yo(new I.$Zo,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$Yo(new I.$Zo,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$7o=w;async function f(c,h,m,S,s,a){const n=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,t=new Map;c.forEach((j,M)=>{i.set(M,j),t.set(M,n(j))});const r=new Map,o=new Map;h.forEach((j,M)=>{r.set(M,j),o.set(M,n(j))});const v=new Map,y=new Map;m.forEach((j,M)=>{v.set(M,j),y.set(M,n(j))}),console.group(S!==s?`Storage: Application (path: ${S})`:`Storage: Application & Profile (path: ${S}, default profile)`);const u=[];if(i.forEach((j,M)=>{u.push({key:M,value:j})}),console.table(u),console.groupEnd(),console.log(t),S!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const j=[];r.forEach((M,T)=>{j.push({key:T,value:M})}),console.table(j),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${a})`);const $=[];v.forEach((j,M)=>{$.push({key:M,value:j})}),console.table($),console.groupEnd(),console.log(y)}e.$8o=f}),define(oe[114],ae([0,1,3,2,12,29,33,21]),function(te,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rCb=e.$qCb=void 0;let C=class extends N.$Rc{constructor(E,b){super(),this.a=new D.$Md,this.onDidChangeEnablement=this.a.event,this.b=this.B(new d(E)),this.B(this.b.onDidChange(l=>this.a.fire({extensions:l,source:"storage"}))),this.B(b.onDidInstallExtensions(l=>l.forEach(({local:g,operation:p})=>{g&&p===4&&this.f(g.identifier)})))}async enableExtension(E,b){return this.f(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}async disableExtension(E,b){return this.c(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}getDisabledExtensions(){return this.h(A.$0n)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const b=this.getDisabledExtensions();return b.every(l=>!(0,O.$wo)(l,E))?(b.push(E),this.g(b),!0):!1}f(E){const b=this.getDisabledExtensions();for(let l=0;l<b.length;l++){const g=b[l];if((0,O.$wo)(g,E))return b.splice(l,1),this.g(b),!0}return!1}g(E){this.j(A.$0n,E)}h(E){return this.b.get(E,0)}j(E,b){this.b.set(E,b,0)}};e.$qCb=C,e.$qCb=C=ye([X(0,I.$3o),X(1,A.$9n)],C);class d extends N.$Rc{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new D.$Md),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(0,void 0,this.B(new N.$Qc))(b=>this.f(b)))}get(E,b){let l;return b===0?((0,L.$Gf)(this.a[E])&&(this.a[E]=this.g(E,b)),l=this.a[E]):l=this.g(E,b),JSON.parse(l)}set(E,b,l){const g=JSON.stringify(b.map(({id:w,uuid:f})=>({id:w,uuid:f})));this.g(E,l)!==g&&(l===0&&(b.length?this.a[E]=g:delete this.a[E]),this.h(E,b.length?g:void 0,l))}f(E){if(!(0,L.$Gf)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const l=this.get(E.key,E.scope);delete this.a[E.key];const g=this.get(E.key,E.scope),p=l.filter(f=>!g.some(c=>(0,O.$wo)(f,c))),w=g.filter(f=>!l.some(c=>(0,O.$wo)(c,f)));(p.length||w.length)&&this.b.fire([...p,...w])}}g(E,b){return this.c.get(E,b,"[]")}h(E,b,l){b?this.c.store(E,b,l,1):this.c.remove(E,l)}}e.$rCb=d}),define(oe[247],ae([0,1,18,26,8,6,37,12,10,20,14,29,33,68,11,7,24,57,224,21,22,61]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.$$o=void 0;const s=A.$p?"web":(0,E.$2n)(A.$u,O.$dc),a="X-Market-Search-Activity-Id";var n;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished",k[k.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...k){return String(k.reduce((R,z)=>R|z,0))}var t;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class u{constructor(R=y){this.d=R}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(R,z=this.d.pageSize){return new u({...this.d,pageNumber:R,pageSize:z})}withFilter(R,...z){const F=[...this.d.criteria,...z.length?z.map(G=>({filterType:R,value:G})):[{filterType:R}]];return new u({...this.d,criteria:F})}withSortBy(R){return new u({...this.d,sortBy:R})}withSortOrder(R){return new u({...this.d,sortOrder:R})}withFlags(...R){return new u({...this.d,flags:R.reduce((z,F)=>z|F,0)})}withAssetTypes(...R){return new u({...this.d,assetTypes:R})}withSource(R){return new u({...this.d,source:R})}get raw(){const{criteria:R,pageNumber:z,pageSize:F,sortBy:G,sortOrder:Z,flags:re,assetTypes:le}=this.d;return{filters:[{criteria:R,pageNumber:z,pageSize:F,sortBy:G,sortOrder:Z}],assetTypes:le,flags:re}}get searchText(){const R=this.d.criteria.filter(z=>z.filterType===t.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(R=>String(R.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function $(k,R){const z=(k||[]).filter(F=>F.statisticName===R)[0];return z?z.value:0}function j(k){const R="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(F=>F.assetType.indexOf(R)===0).reduce((F,G)=>{const Z=U(k,G.assetType);return Z&&F.push([G.assetType.substring(R.length),Z]),F},[])}function M(k){if(k.properties){const R=k.properties.filter(G=>G.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=R.filter(G=>z.test(G.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return U(k,r.Repository)}function T(k){return{uri:`${k.fallbackAssetUri}/${r.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${r.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function U(k,R){return k.files.filter(F=>F.assetType===R)[0]?{uri:`${k.assetUri}/${R}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${R}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}:null}function q(k,R){const z=k.properties?k.properties.filter(G=>G.key===R):[],F=z.length>0&&z[0].value;return F?F.split(",").map(G=>(0,b.$Ao)(G)):[]}function Y(k){const R=k.properties?k.properties.filter(z=>z.key===o.Engine):[];return R.length>0&&R[0].value||""}function J(k){const R=k.properties?k.properties.filter(z=>z.key===o.PreRelease):[];return R.length>0&&R[0].value==="true"}function x(k){const R=k.properties?k.properties.filter(F=>F.key===o.LocalizedLanguages):[],z=R.length>0&&R[0].value||"";return z?z.split(","):[]}function W(k){return k.properties?.find(R=>R.key===o.SponsorLink)?.value}function Q(k){return k.indexOf("preview")!==-1}function H(k){return k.targetPlatform?(0,E.$1n)(k.targetPlatform):"undefined"}function V(k){const R=(0,D.$Lb)(k.versions.map(H)),z=!!k.tags?.includes(E.$Vn),F=R.indexOf("web");return z?F===-1&&R.push("web"):F!==-1&&R.splice(F,1),R}function ee(k,R){const z=(0,E.$5n)(R);for(let F=0;F<k.length;F++){const G=k[F];if(G.version===k[F-1]?.version){let Z=F;const re=H(G);if(re===R)for(;Z>0&&k[Z-1].version===G.version;)Z--;else if(z.includes(re))for(;Z>0&&k[Z-1].version===G.version&&H(k[Z-1])!==R;)Z--;Z!==F&&(k.splice(F,1),k.splice(Z,0,G))}}return k}e.$$o=ee;function ne(k,R,z){k.telemetryData={index:R,querySource:z,queryActivityId:k.queryContext?.[a]}}function _(k,R,z,F){const G=k.versions[0],Z={manifest:U(R,r.Manifest),readme:U(R,r.Details),changelog:U(R,r.Changelog),license:U(R,r.License),repository:M(R),download:T(R),icon:U(R,r.Icon),signature:U(R,r.Signature),coreTranslations:j(R)};return{identifier:{id:(0,b.$Bo)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:R.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,publisherDomain:k.publisher.domain?{link:k.publisher.domain,verified:!!k.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(G),description:k.shortDescription||"",installCount:$(k.statistics,"install"),rating:$(k.statistics,"averagerating"),ratingCount:$(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:z,assets:Z,properties:{dependencies:q(R,o.Dependency),extensionPack:q(R,o.ExtensionPack),engine:Y(R),localizedLanguages:x(R),targetPlatform:H(R),isPreReleaseVersion:J(R)},hasPreReleaseVersion:J(G),hasReleaseVersion:!0,preview:Q(k.flags),isSigned:!!Z.signature,queryContext:F}}let ie=class{constructor(R,z,F,G,Z,re,le,ue){this.k=z,this.l=F,this.n=G,this.o=Z,this.q=re,this.u=le,this.w=ue;const he=le.extensionsGallery,$e=he?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=$e?he.servicePPEUrl:he?.serviceUrl,this.g=$e?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,c.$0o)(le.version,le,this.n,this.w,this.q,R,this.o)}x(R=""){return`${this.d}${R}`}isEnabled(){return!!this.d}async getExtensions(R,z,F){const G=N.CancellationToken.isCancellationToken(z)?{}:z,Z=N.CancellationToken.isCancellationToken(z)?z:F,re=[],le=[],ue=[],he=[];let $e=!0;for(const Ee of R){Ee.uuid?le.push(Ee.uuid):re.push(Ee.id);const Ie=!!(Ee.version||Ee.preRelease);ue.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ie}),Ee.version&&he.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),$e=$e&&!!Ee.hasPreRelease&&!Ie}if(!le.length&&!re.length)return[];let de=new u().withPage(1,R.length);le.length&&(de=de.withFilter(t.ExtensionId,...le)),re.length&&(de=de.withFilter(t.ExtensionName,...re)),(G.queryAllVersions||$e)&&(de=de.withFlags(de.flags,n.IncludeVersions)),G.source&&(de=de.withSource(G.source));const{extensions:we}=await this.z(de,{targetPlatform:G.targetPlatform??s,includePreRelease:ue,versions:he,compatible:!!G.compatible},Z);return G.source&&we.forEach((Ee,Ie)=>ne(Ee,Ie,G.source)),we}async getCompatibleExtension(R,z,F){if((0,E.$3n)(R.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(R,z,F))return R;const G=new u().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,R.identifier.uuid),{extensions:Z}=await this.z(G,{targetPlatform:F,compatible:!0,includePreRelease:z},N.CancellationToken.None);return Z[0]||null}async isExtensionCompatible(R,z,F){if(!(0,E.$4n)(R.properties.targetPlatform,R.allTargetPlatforms,F)||!z&&R.properties.isPreReleaseVersion)return!1;let G=R.properties.engine;if(!G){const Z=await this.getManifest(R,N.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");G=Z.engines.vscode}return(0,l.$Oo)(G,this.u.version,this.u.date)}async y(R,z,F,G,Z){if(!(0,E.$4n)(H(R),G,Z)||z!=="any"&&J(R)!==(z==="prerelease"))return!1;if(F)try{const re=await this.E(R);if(!(0,l.$Oo)(re,this.u.version,this.u.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${R.version}.`,(0,L.$9)(re)),!1}return!0}async query(R,z){let F=R.text||"";const G=R.pageSize??50;let Z=new u().withPage(1,G);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(Z=Z.withFilter(t.Category,we||de),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(Z=Z.withFilter(t.Tag,we||de),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(Z=Z.withFilter(t.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),Z=Z.withFilter(t.SearchText,F)),Z=Z.withSortBy(0)):R.ids?Z=Z.withFilter(t.ExtensionId,...R.ids):R.names?Z=Z.withFilter(t.ExtensionName,...R.names):Z=Z.withSortBy(4),typeof R.sortBy=="number"&&(Z=Z.withSortBy(R.sortBy)),typeof R.sortOrder=="number"&&(Z=Z.withSortOrder(R.sortOrder)),R.source&&(Z=Z.withSource(R.source));const re=async($e,de)=>{const{extensions:we,total:Ee}=await this.z($e,{targetPlatform:s,compatible:!1,includePreRelease:!!R.includePreRelease},de);return we.forEach((Ie,Ne)=>ne(Ie,($e.pageNumber-1)*$e.pageSize+Ne,R.source)),{extensions:we,total:Ee}},{extensions:le,total:ue}=await re(Z,z),he=async($e,de)=>{if(de.isCancellationRequested)throw new L.$4;const{extensions:we}=await re(Z.withPage($e+1),de);return we};return{firstPage:le,total:ue,pageSize:Z.pageSize,getPage:he}}async z(R,z,F){const G=R.flags;R.flags&n.IncludeLatestVersionOnly&&R.flags&n.IncludeVersions&&(R=R.withFlags(R.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(R.flags&n.IncludeLatestVersionOnly)&&!(R.flags&n.IncludeVersions)&&(R=R.withFlags(R.flags,n.IncludeLatestVersionOnly)),z.versions?.length&&(R=R.withFlags(R.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),R=R.withFlags(R.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:Z,total:re,context:le}=await this.B(R,F);if(!(R.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of Z){const Ee=await this.A(we,z,le);Ee&&de.push(Ee)}return{extensions:de,total:re}}const he=[],$e=new Map;for(let de=0;de<Z.length;de++){const we=Z[de],Ee={id:(0,b.$Bo)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ie=(0,I.$Df)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Te=>(0,b.$wo)(Te,Ee))?.includePreRelease;if(z.compatible&&(0,E.$3n)(V(we),z.targetPlatform))continue;const Ne=await this.A(we,z,le);!Ne||Ne.properties.isPreReleaseVersion&&(!Ie||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==z.targetPlatform&&Ne.hasPreReleaseVersion?$e.set(we.extensionId,de):he.push([de,Ne])}if($e.size){const de=new S.$Id,we=new u().withFlags(G&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,$e.size).withFilter(t.ExtensionId,...$e.keys()),{extensions:Ee}=await this.z(we,z,F);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:$e.size});for(const Ie of Ee){const Ne=$e.get(Ie.identifier.uuid);he.push([Ne,Ie])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:re}}async A(R,z,F){const G={id:(0,b.$Bo)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},Z=z.versions?.find(he=>(0,b.$wo)(he,G))?.version,re=(0,I.$Df)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(he=>(0,b.$wo)(he,G))?.includePreRelease,le=V(R),ue=ee(R.versions,z.targetPlatform);if(z.compatible&&(0,E.$3n)(le,z.targetPlatform))return null;for(let he=0;he<ue.length;he++){const $e=ue[he];if(!(Z&&$e.version!==Z)){if(await this.y($e,re?"any":"release",z.compatible,le,z.targetPlatform))return _(R,$e,le,F);if(Z&&$e.version===Z)return null}}return Z||z.compatible?null:_(R,R.versions[0],le)}async B(R,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const F=await this.j,G=JSON.stringify(R.raw),Z={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},re=new S.$Id;let le,ue,he=0;try{if(le=await this.k.request({type:"POST",url:this.g&&R.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:Z},z),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:he};const $e=await(0,f.$Vo)(le);if($e){const de=$e.results[0],we=de.extensions,Ee=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return he=Ee&&Ee.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[a]:le.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch($e){throw ue=$e,$e}finally{this.o.publicLog2("galleryService:query",{...R.telemetryData,requestBodySize:String(G.length),duration:re.elapsed(),success:!!le&&(0,f.$Ro)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:ue?(0,L.$3)(ue)?"canceled":(0,L.$9)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(R,z,F,G){if(!this.isEnabled())return;const Z=A.$p?this.x(`/itemName/${R}.${z}/version/${F}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${R}/extensions/${z}/${F}/stats?statType=${G}`),re=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:re};try{await this.k.request({type:"POST",url:Z,headers:ue},N.CancellationToken.None)}catch{}}async download(R,z,F){this.l.trace("ExtensionGalleryService#download",R.identifier.id);const G=(0,b.$Eo)(R),Z=new Date().getTime(),re=de=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:de}),le=F===2?"install":F===3?"update":"",ue=le?{uri:`${R.assets.download.uri}${C.URI.parse(R.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${R.assets.download.fallbackUri}${C.URI.parse(R.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:R.assets.download,he=R.queryContext?.[a]?{[a]:R.queryContext[a]}:void 0,$e=await this.D(ue,he?{headers:he}:void 0);await this.q.writeFile(z,$e.stream),re(new Date().getTime()-Z)}async downloadSignatureArchive(R,z){if(!R.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",R.identifier.id);const F=await this.D(R.assets.signature);await this.q.writeFile(z,F.stream)}async getReadme(R,z){if(R.assets.readme){const F=await this.D(R.assets.readme,{},z);return await(0,f.$Uo)(F)||""}return""}async getManifest(R,z){if(R.assets.manifest){const F=await this.D(R.assets.manifest,{},z),G=await(0,f.$Uo)(F);return G?JSON.parse(G):null}return null}async C(R,z){const F=U(R,r.Manifest);if(!F)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},Z=await this.D(F,{headers:G});return await(0,f.$Vo)(Z)}async getCoreTranslation(R,z){const F=R.assets.coreTranslations.filter(G=>G[0]===z.toUpperCase())[0];if(F){const G=await this.D(F[1]),Z=await(0,f.$Uo)(G);return Z?JSON.parse(Z):null}return null}async getChangelog(R,z){if(R.assets.changelog){const F=await this.D(R.assets.changelog,{},z);return await(0,f.$Uo)(F)||""}return""}async getAllCompatibleVersions(R,z,F){let G=new u().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);R.identifier.uuid?G=G.withFilter(t.ExtensionId,R.identifier.uuid):G=G.withFilter(t.ExtensionName,R.identifier.id);const{galleryExtensions:Z}=await this.B(G,N.CancellationToken.None);if(!Z.length)return[];const re=V(Z[0]);if((0,E.$3n)(re,F))return[];const le=[];await Promise.all(Z[0].versions.map(async $e=>{try{await this.y($e,z?"any":"release",!0,re,F)&&le.push($e)}catch{}}));const ue=[],he=new Set;for(const $e of ee(le,F))he.has($e.version)||(he.add($e.version),ue.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:J($e)}));return ue}async D(R,z={},F=N.CancellationToken.None){const G=await this.j,Z={type:"GET"},re={...G,...z.headers||{}};z={...z,...Z,headers:re};const le=R.uri,ue=R.fallbackUri,he={...z,url:le};try{const $e=await this.k.request(he,F);if($e.res.statusCode===200)return $e;const de=await(0,f.$Uo)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${de}`)}catch($e){if((0,L.$3)($e))throw $e;const de=(0,L.$9)($e);this.o.publicLog2("galleryService:cdnFallback",{url:le,message:de});const we={...z,url:ue};return this.k.request(we,F)}}async E(R){let z=Y(R);if(!z){const F=await this.C(R,N.CancellationToken.None);if(!F)throw new Error("Manifest was not found");z=F.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const R=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,f.$Vo)(R),F=[],G={},Z=[];if(z){for(const re of z.malicious)F.push({id:re});if(z.migrateToPreRelease)for(const[re,le]of Object.entries(z.migrateToPreRelease))(!le.engine||(0,l.$Oo)(le.engine,this.u.version,this.u.date))&&(G[re.toLowerCase()]={disallowInstall:!0,extension:{id:le.id,displayName:le.displayName,autoMigrate:{storage:!!le.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[re,le]of Object.entries(z.deprecated))le&&(G[re.toLowerCase()]=(0,I.$Df)(le)?{}:le);if(z.search)for(const re of z.search)Z.push(re)}return{malicious:F,deprecated:G,search:Z}}};ie=ye([X(1,f.$Po),X(2,p.$8i),X(3,P.$Uh),X(4,m.$al),X(5,g.$9j),X(6,w.$nj),X(7,d.$hi)],ie);let K=class extends ie{constructor(R,z,F,G,Z,re,le,ue){super(R,z,F,G,Z,re,le,ue)}};e.$_o=K,e.$_o=K=ye([X(0,h.$3o),X(1,f.$Po),X(2,p.$8i),X(3,P.$Uh),X(4,m.$al),X(5,g.$9j),X(6,w.$nj),X(7,d.$hi)],K);let B=class extends ie{constructor(R,z,F,G,Z,re,le){super(void 0,R,z,F,G,Z,re,le)}};e.$ap=B,e.$ap=B=ye([X(0,f.$Po),X(1,p.$8i),X(2,P.$Uh),X(3,m.$al),X(4,g.$9j),X(5,w.$nj),X(6,d.$hi)],B)}),define(oe[81],ae([0,1,4,3,2,21,33,24,18,7,12]),function(te,e,D,N,L,A,O,I,C,d,P){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tu=e.$Su=void 0,e.$Su=(0,D.$Nh)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends L.$Rc{static{E=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,O.$Ao)(p.id)}@${p.version}`}static c(p){const w=b.exec(p);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(p,w){const f=await p.getInstalled(),c=[];for(const[h,m]of E.f(w)){const S=f.find(s=>(0,O.$wo)(s.identifier,{id:h}))?.manifest.version;for(const s of m)S!==s&&c.push(E.b({id:h,version:s}))}for(const h of c)w.remove(h,0)}static f(p){const w=new Map,f=p.keys(0,1);for(const c of f){const h=E.c(c);if(h){let m=w.get(h.id.toLowerCase());m||w.set(h.id.toLowerCase(),m=[]),m.push(h.version)}}return w}constructor(p,w,f){super(),this.j=p,this.m=w,this.n=f,this.g=this.B(new N.$Md),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=E.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new L.$Qc))(c=>this.r(c)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const w=E.c(p.key);if(w){if(this.j.get(p.key,0)===void 0)this.h.delete(w.id.toLowerCase());else{let f=this.h.get(w.id.toLowerCase());f||this.h.set(w.id.toLowerCase(),f=[]),f.push(w.version),this.g.fire()}return}}s(p){if((0,P.$xf)(p))return p;const w=p.manifest?p.manifest.publisher:p.publisher,f=p.manifest?p.manifest.name:p.name;return(0,O.$zo)(w,f)}getExtensionState(p,w){const f=this.s(p),c=this.getExtensionStateRaw(p,w);if(c)try{return JSON.parse(c)}catch(h){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${w}): ${h}`)}}getExtensionStateRaw(p,w){const f=this.s(p),c=this.j.get(f,w?0:1);return c&&c?.length>E.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${w}): ${c.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),c}setExtensionState(p,w,f){const c=this.s(p);w===void 0?this.j.remove(c,f?0:1):this.j.store(c,JSON.stringify(w),f?0:1,1)}setKeysForSync(p,w){this.j.store(E.b(p),JSON.stringify(w),0,1)}getKeysForSync(p){const w=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],f=this.j.get(E.b(p),0),c=f?JSON.parse(f):void 0;return c&&w?(0,C.$Lb)([...c,...w]):c||w}addToMigrationList(p,w){if(p!==w){const f=this.t.filter(c=>!c.includes(p)&&!c.includes(w));f.push([p,w]),this.t=f}}getSourceExtensionToMigrate(p){const w=this.t.find(([,f])=>p===f);return w?w[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(p);if(Array.isArray(w))return w}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Tu=l,e.$Tu=l=E=ye([X(0,A.$3o),X(1,I.$nj),X(2,d.$8i)],l)}),define(oe[248],ae([0,1,29,11,24,14,98,55,21,22,221]),function(te,e,D,N,L,A,O,I,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y8b=void 0;let E=class extends P.$e5b{constructor(l,g,p,w,f,c,h,m){super(l.userHome,f,g,p,w,c,h,m)}};e.$Y8b=E,e.$Y8b=E=ye([X(0,A.$Vh),X(1,d.$al),X(2,D.$9n),X(3,C.$3o),X(4,I.$M6b),X(5,O.$yVb),X(6,N.$9j),X(7,L.$nj)],E)}),define(oe[249],ae([0,1,105,3,22,14,2,7,16,65,24,6,5,101,20,165,36,21,12,133,19]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U8b=void 0;const S=[D.$N8b,D.$O8b],s="remoteTunnelSession",a="remoteTunnelIsService";let n=class extends O.$Rc{constructor(o,v,y,u,$,j,M){super(),this.y=o,this.z=v,this.C=y,this.D=j,this.F=M,this.f=new N.$Md,this.onDidTokenFailed=this.f.event,this.g=new N.$Md,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$Md,this.onDidChangeMode=this.h.event,this.n=D.$L8b,this.w=!1,this.I=(T,U)=>{U?this.j.error(T):this.j.info(T)},this.j=this.B(u.createLogger((0,m.$ug)(y.logsHome,`${D.$P8b}.log`),{id:D.$P8b,name:D.$Q8b})),this.t=new b.$Pg(100),this.B(this.j.onDidChangeLogLevel(T=>this.j.info("Log level changed to "+(0,I.$kj)(T)))),this.B($.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(j.onDidChangeConfiguration(T=>{S.some(U=>T.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=D.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){t(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let o;E.$k?o=this.C.appRoot:o=(0,C.$lc)((0,C.$lc)(this.C.appRoot)),this.u=(0,C.$ic)(o,"bin",`${this.z.tunnelApplicationName}${E.$j?".exe":""}`)}return this.u}async startTunnel(o){if(t(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const o=this.n.asService;this.H(D.$L8b);try{o&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(D.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",v=!1;const y=(U,q)=>{q?this.j.error(U):o+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(D.TunnelStates.connecting((0,p.localize)(0,null)))},u=this.O("status",["status"],y);this.r=u;try{if(await u,this.r!==u)return;const U=JSON.parse(o.trim().split(`
`).find(q=>q.startsWith("{")));if(v=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(D.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(D.TunnelStates.disconnected());return}finally{this.r===u&&(this.r=void 0)}const $=this.n.active?this.n.session:void 0;if($&&$.token){const U=$.token;this.G(D.TunnelStates.connecting((0,p.localize)(1,null,$.accountLabel,$.providerId)));const q=(J,x)=>{J=J.replaceAll(U,"*".repeat(4)),y(J,x)},Y=this.O("login",["user","login","--provider",$.providerId,"--access-token",U,"--log",(0,I.$kj)(this.j.getLevel())],q);this.r=Y;try{if(await Y,this.r!==Y)return}catch(J){this.j.error(J),this.r=void 0,this.f.fire($),this.G(D.TunnelStates.disconnected($));return}}const j=this.Q();j?this.G(D.TunnelStates.connecting((0,p.localize)(2,null,j))):this.G(D.TunnelStates.connecting((0,p.localize)(3,null)));const M=["--accept-server-license-terms","--log",(0,I.$kj)(this.j.getLevel())];j?M.push("--name",j):M.push("--random-name");let T=!1;return this.n.active&&this.n.asService&&!v&&(T=await this.M(M)===!1),this.N($,M,T)}async M(o){let v;try{v=await this.O("serviceInstall",["service","install",...o])}catch(y){this.j.error(y),v=1}if(v!==0){const y=(0,p.localize)(4,null);return this.j.warn(y),this.G(D.TunnelStates.connecting(y)),!1}return!0}async N(o,v,y){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let u=!1;const $=this.O("tunnel",v,(j,M)=>{M?this.j.error(j):this.j.info(j),j.includes("Connected to an existing tunnel process")&&(u=!0);const T=j.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(T){const U={link:T[1],domain:T[2],tunnelName:T[4],isAttached:u};this.G(D.TunnelStates.connected(U,y))}else j.match(/error refreshing token/)&&($.cancel(),this.f.fire(o),this.G(D.TunnelStates.disconnected(o)))});this.r=$,$.finally(()=>{$===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=D.$L8b,this.G(D.TunnelStates.disconnected()))})}O(o,v,y=this.I){return(0,b.$Gg)(u=>new Promise(($,j)=>{u.isCancellationRequested&&$(-1);let M;const T=["ignore","pipe","pipe"];if(u.onCancellationRequested(()=>{M&&(this.j.info(`${o} terminating(${M.pid})`),M.kill())}),!this.C.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${o} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),M=(0,d.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,C.$ic)(this.C.appRoot,"cli"),stdio:T});else{y(`Running tunnel CLI
`,!1);const U=this.J();y(`${o} Spawning: ${U} tunnel ${v.join(" ")}
`,!1),M=(0,d.spawn)(U,["tunnel",...v],{cwd:(0,w.homedir)(),stdio:T})}M.stdout.pipe(new h.$_S(`
`)).on("data",U=>{if(M){const q=U.toString();y(q,!1)}}),M.stderr.pipe(new h.$_S(`
`)).on("data",U=>{if(M){const q=U.toString();y(q,!0)}}),M.on("exit",U=>{M&&(y(`${o} exit(${M.pid}): + ${U} `,!1),M=void 0,$(U||0))}),M.on("error",U=>{M&&(y(`${o} error(${M.pid}): + ${U} `,!0),M=void 0,j())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(D.$O8b)}Q(){let o=this.D.getValue(D.$N8b)||(0,w.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(s,-1),v=this.F.getBoolean(a,-1,!1);if(o){const y=JSON.parse(o);if(y&&(0,c.$xf)(y.accountLabel)&&(0,c.$xf)(y.sessionId)&&(0,c.$xf)(y.providerId))return{active:!0,session:y,asService:v};this.j.error("Problems restoring session from storage, invalid format",y)}}catch(o){this.j.error("Problems restoring session from storage",o)}return D.$L8b}S(o){if(o.active){const v={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(s,JSON.stringify(v),-1,1),this.F.store(a,o.asService,-1,1)}else this.F.remove(s,-1),this.F.remove(a,-1)}};e.$U8b=n,e.$U8b=n=ye([X(0,L.$al),X(1,P.$nj),X(2,A.$Vh),X(3,I.$9i),X(4,l.$S8b),X(5,g.$hi),X(6,f.$3o)],n);function i(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const t=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&i(r.session,o.session):!0}),define(oe[250],ae([0,1,5,2,23,19,67,21,76,17]),function(te,e,D,N,L,A,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z8b=void 0;class P extends I.$5o{constructor(b,l,g,p){super(),this.bb=b,this.cb=l,this.db=g,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Qc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Qc),this.ab=this.hb(this.bb)}fb(){const b=this.B(new C.$1Cb(this.db.getChannel("storage"))),l=this.B(new O.$Yo(b));return this.B(l.onDidChangeStorage(g=>this.u(-1,g))),l}gb(b){this.X.clear(),this.W=b;let l;if((0,I.$6o)(b))l=this.U;else{const g=this.X.add(new C.$2Cb(this.db.getChannel("storage"),b));l=this.X.add(new O.$Yo(g))}return this.X.add(l.onDidChangeStorage(g=>this.u(0,g))),l}hb(b){this.$.clear(),this.Z=b?.id;let l;if(b){const g=this.$.add(new C.$3Cb(this.db.getChannel("storage"),b));l=this.$.add(new O.$Yo(g)),this.$.add(l.onDidChangeStorage(p=>this.u(1,p)))}return l}async O(){await D.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(b){switch(b){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(b){switch(b){case-1:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$ug)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(I.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(b){if(!this.M(this.W,b))return;const l=this.Y,g=l.items;l!==this.U&&await l.close(),this.Y=this.gb(b),await this.Y.init(),this.N(g,this.Y,0)}async S(b,l){const g=this.ab,p=g?.items??new Map;await g?.close(),this.ab=this.hb(b),await this.ab.init(),this.N(p,this.ab,1)}hasScope(b){return(0,d.$Hk)(b)?this.W.id===b.id:this.Z===b.id}}e.$Z8b=P}),define(oe[251],ae([0,1,3,2,17,92]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=void 0;class O{constructor(d,P){this.a=d,this.b=P}listen(d,P){const E=this.b(d);switch(P){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,b=>({all:b.all.map(l=>(0,A.$Km)({...l},E)),added:b.added.map(l=>(0,A.$Km)({...l},E)),removed:b.removed.map(l=>(0,A.$Km)({...l},E)),updated:b.updated.map(l=>(0,A.$Km)({...l},E))}))}throw new Error(`Invalid listen ${P}`)}async call(d,P,E){const b=this.b(d);switch(P){case"createProfile":{const l=await this.a.createProfile(E[0],E[1],E[2]);return(0,A.$Km)({...l},b)}case"updateProfile":{let l=(0,L.$Jk)((0,A.$Lm)(E[0],b),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,E[1]),(0,A.$Km)({...l},b)}case"removeProfile":{const l=(0,L.$Jk)((0,A.$Lm)(E[0],b),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${P}`)}}e.$EN=O;class I extends N.$Rc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(d,P,E){super(),this.profilesHome=P,this.f=E,this.a=[],this.b=this.B(new D.$Md),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=d.map(b=>(0,L.$Jk)(b,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(b=>{const l=b.added.map(w=>(0,L.$Jk)(w,this.profilesHome.scheme)),g=b.removed.map(w=>(0,L.$Jk)(w,this.profilesHome.scheme)),p=b.updated.map(w=>(0,L.$Jk)(w,this.profilesHome.scheme));this.a=b.all.map(w=>(0,L.$Jk)(w,this.profilesHome.scheme)),this.b.fire({added:l,removed:g,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(d){this.c=d}isEnabled(){return this.c}async createNamedProfile(d,P,E){const b=await this.f.call("createNamedProfile",[d,P,E]);return(0,L.$Jk)(b,this.profilesHome.scheme)}async createProfile(d,P,E,b){const l=await this.f.call("createProfile",[d,P,E,b]);return(0,L.$Jk)(l,this.profilesHome.scheme)}async createTransientProfile(d){const P=await this.f.call("createTransientProfile",[d]);return(0,L.$Jk)(P,this.profilesHome.scheme)}async setProfileForWorkspace(d,P){await this.f.call("setProfileForWorkspace",[d,P])}removeProfile(d){return this.f.call("removeProfile",[d])}async updateProfile(d,P){const E=await this.f.call("updateProfile",[d,P]);return(0,L.$Jk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$FN=I}),define(oe[58],ae([0,1,2,67,4,21,3,76,17]),function(te,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Cb=e.$6Cb=e.$5Cb=void 0,e.$5Cb=(0,L.$Nh)("IUserDataProfileStorageService");let d=class extends D.$Rc{constructor(l){super(),this.a=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async g=>this.b(g))}async updateStorageData(l,g,p){return this.withProfileScopedStorageService(l,async w=>this.c(w,g,p))}async withProfileScopedStorageService(l,g){if(this.a.hasScope(l))return g(this.a);const p=await this.g(l),w=new E(p);try{await w.initialize();const f=await g(w);return await w.flush(),f}finally{w.dispose(),await this.f(p)}}b(l){const g=new Map,p=w=>{for(const f of l.keys(0,w))g.set(f,{value:l.get(f,0),target:w})};return p(0),p(1),g}c(l,g,p){l.storeAll(Array.from(g.entries()).map(([w,f])=>({key:w,value:f,scope:0,target:p})),!0)}async f(l){try{await l.close()}finally{(0,D.$Lc)(l)&&l.dispose()}}};e.$6Cb=d,e.$6Cb=d=ye([X(0,A.$3o)],d);class P extends d{constructor(l,g,p,w){super(p),this.j=l;const f=l.getChannel("profileStorageListener"),c=this.B(new D.$Sc);this.h=this.B(new O.$Md({onWillAddFirstListener:()=>{c.value=f.listen("onDidChange")(h=>{w.trace("profile storage changes",h),this.h.fire({targetChanges:h.targetChanges.map(m=>(0,C.$Jk)(m,g.profilesHome.scheme)),valueChanges:h.valueChanges.map(m=>({...m,profile:(0,C.$Jk)(m.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>c.value=void 0})),this.onDidChange=this.h.event}async g(l){const g=this.j.getChannel("storage");return(0,A.$6o)(l)?new I.$1Cb(g):new I.$2Cb(g,l)}}e.$7Cb=P;class E extends A.$5o{constructor(l){super({flushInterval:100}),this.s=this.B(new N.$Yo(l))}O(){return this.s.init()}P(l){return l===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(oe[252],ae([0,1,21,7,17,72,58]),function(te,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E8b=void 0;let I=class extends O.$7Cb{constructor(d,P,E,b){super(d,P,E,b)}};e.$E8b=I,e.$E8b=I=ye([X(0,A.$37b),X(1,L.$Ik),X(2,D.$3o),X(3,N.$8i)],I)}),define(oe[39],ae([0,1,18,5,15,26,3,35,2,27,12,170,20,14,11,7,43,21,22,28,25,17]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YDb=e.$XDb=e.$WDb=e.$VDb=e.$UDb=e.$TDb=e.$SDb=void 0;function s(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||a(v.syncData)))}e.$SDb=s;function a(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$TDb=a;function n(v,y){return`${(0,d.$pf)(v)}${y.isDefault?"":` (${y.name})`}`}e.$UDb=n;let i=class extends C.$Rc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(y,u,$,j,M,T,U,q,Y,J,x,W){super(),this.syncResource=y,this.collection=u,this.G=$,this.H=j,this.I=M,this.J=T,this.L=U,this.M=q,this.N=Y,this.O=J,this.P=x,this.c=null,this.m="idle",this.n=this.B(new O.$Md),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$Md),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$Qg(50)),this.w=this.B(new O.$Md),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(y.syncResource,y.profile),this.h=W.extUri,this.f=this.h.joinPath(j.userDataSyncHome,...(0,m.$wgb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,m.$Rgb),this.y=(0,m.$xgb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,j,this.h),this.j=(0,w.$9o)(j,$,M)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const u=await this.Y(y.remoteUserData,y.lastSyncUserData,!0,this.ob());this.S(u)}else{this.O.trace(`${this.D}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.ub(y):!0)&&this.w.fire()}}S(y){this.m!==y&&(this.m=y,this.n.fire(y))}async sync(y,u={}){await this.U(y,!0,this.ob(),u)}async preview(y,u,$={}){return this.U(y,!1,u,$)}async apply(y,u={}){try{this.F={...u};const $=await this.ab(y);return this.S($),this.c}finally{this.F={}}}async U(y,u,$,j){try{if(this.F={...j},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let M="idle";try{const T=await this.getLastSyncUserData(),U=await this.X(y,T);return M=await this.Y(U,T,u,$),M==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(M)}}finally{this.F={}}}async replace(y){const u=this.kb(y);if(!u)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const $=await this.getLastSyncUserData(),j=await this.X(null,$),M=await this.W(j),T=await this.qb({ref:j.ref,syncData:u},$,M,this.ob(),A.CancellationToken.None),U=[];for(const q of T){const Y=await this.sb(q,q.remoteResource,void 0,A.CancellationToken.None),{remoteChange:J}=await this.sb(q,q.previewResource,q.remoteContent,A.CancellationToken.None);U.push([q,{...Y,remoteChange:J!==0?J:2}])}await this.tb(j,$,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(y){const u=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===u}async X(y,u){if(u){const $=y?y[this.resource]:void 0;if(u.ref===$||$===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async Y(y,u,$,j){if(y.syncData&&y.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new m.$Egb((0,E.localize)(0,null,this.resource,this.pb,y.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(y,u,$,j)}catch(M){if(M instanceof m.$Egb)switch(M.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(y,u,$,j);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.Y(y,u,$,j)}throw M}}async Z(y,u,$,j){try{const M=await this.W(y),T=!M&&u===null&&this.gb()!==void 0,U=$&&!T;this.c||(this.c=(0,N.$Gg)(Y=>this.eb(y,u,M,U,j,Y)));let q=await this.c;if($&&T){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of q.resourcePreviews)q=await this.accept(Y.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":$?await this.ab(!1):"syncing"}catch(M){throw this.c=null,M}}async merge(y){return await this.$(y,async u=>{const $=await this.rb(u,A.CancellationToken.None);await this.G.writeFile(u.previewResource,L.$ae.fromString($?.content||""));const j=$&&!$.hasConflicts?await this.sb(u,u.previewResource,void 0,A.CancellationToken.None):void 0;return u.acceptResult=j,u.mergeState=$.hasConflicts?"conflict":j?"accepted":"preview",u.localChange=j?j.localChange:$.localChange,u.remoteChange=j?j.remoteChange:$.remoteChange,u}),this.c}async accept(y,u){return await this.$(y,async $=>{const j=await this.sb($,y,u,A.CancellationToken.None);return $.acceptResult=j,$.mergeState="accepted",$.localChange=j.localChange,$.remoteChange=j.remoteChange,$}),this.c}async discard(y){return await this.$(y,async u=>{const $=await this.rb(u,A.CancellationToken.None);return await this.G.writeFile(u.previewResource,L.$ae.fromString($.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=$.localChange,u.remoteChange=$.remoteChange,u}),this.c}async $(y,u){if(!this.c)return;let $=await this.c;const j=$.resourcePreviews.findIndex(({localResource:M,remoteResource:T,previewResource:U})=>this.h.isEqual(M,y)||this.h.isEqual(T,y)||this.h.isEqual(U,y));j!==-1&&(this.c=(0,N.$Gg)(async M=>{const T=[...$.resourcePreviews];return T[j]=await u(T[j]),{...$,resourcePreviews:T}}),$=await this.c,this.cb($.resourcePreviews),$.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(y){if(!this.c)return"idle";const u=await this.c;return u.resourcePreviews.some(({mergeState:$})=>$==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:$})=>$!=="accepted")?"syncing":(await this.tb(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map($=>[$,$.acceptResult]),y),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(y){const u=y.filter(({mergeState:$})=>$==="conflict");(0,D.$tb)(this.s,u,($,j)=>this.h.isEqual($.previewResource,j.previewResource))||(this.s=u,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async db(y){const u=this.c?await this.c:null;if(u)for(const $ of u.resourcePreviews){if(this.h.isEqual($.acceptedResource,y))return $.acceptResult?$.acceptResult.content:null;if(this.h.isEqual($.remoteResource,y))return $.remoteContent;if(this.h.isEqual($.localResource,y))return $.localContent;if(this.h.isEqual($.baseResource,y))return $.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(y){(0,g.$nk)(y)!==1&&this.O.error(y)}}async eb(y,u,$,j,M,T){const U=await this.qb(y,u,$,M,T),q=[];for(const Y of U){const J=Y.previewResource.with({scheme:m.$Qgb,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)q.push({...Y,acceptedResource:J,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=j?await this.rb(Y,T):void 0;if(T.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,L.$ae.fromString(x?.content||""));const W=x&&!x.hasConflicts?await this.sb(Y,Y.previewResource,void 0,T):void 0;q.push({...Y,acceptResult:W,mergeState:x?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:x?x.localChange:Y.localChange,remoteChange:W?W.remoteChange:x?x.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:u,resourcePreviews:q,isLastSyncFromCurrentMachine:$}}async getLastSyncUserData(){let y=this.gb();if(y||(y=await this.jb()),!y)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const u=JSON.parse(y),$=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!u.version&&!!$&&u.version!==$,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${$}.`),await this.resetLocal(),null;let j,M=1;for(;j===void 0&&M++<6;)try{const T=await this.hb();T&&(T.ref===u.ref?j=T.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(T){if(T instanceof g.$rk&&T.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(T instanceof m.$Egb)throw T;this.O.error(T,M)}}if(j===void 0)try{const T=await this.J.resolveResourceContent(this.resource,u.ref,this.collection,this.F);j=T===null?null:this.kb(T),await this.ib({ref:u.ref,syncData:j})}catch(T){if(T instanceof m.$Egb&&T.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw T}return j===void 0?null:{...u,syncData:j}}async fb(y,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const $=this.M.getResourceSyncStateVersion(this.resource),j={ref:y.ref,version:$,...u};this.I.store(this.z,JSON.stringify(j),-1,1),await this.ib(y)}gb(){return this.I.get(this.z,-1)}async hb(){const y=(await this.G.readFile(this.y)).value.toString();try{const u=y?JSON.parse(y):void 0;if(s(u))return u}catch(u){this.O.error(u)}}async ib(y){await this.G.writeFile(this.y,L.$ae.fromString(JSON.stringify(y)))}async jb(){try{const y=await this.G.readFile(this.y),u=JSON.parse(y.value.toString());await this.G.del(this.y),u.ref&&u.content!==void 0?(this.I.store(this.z,JSON.stringify({...u,content:void 0}),-1,1),await this.ib({ref:u.ref,syncData:u.content===null?null:JSON.parse(u.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,u)}catch(y){y instanceof g.$rk&&y.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(y)}return this.I.get(this.z,-1)}async getRemoteUserData(y){const{ref:u,content:$}=await this.lb(y);let j=null;return $!==null&&(j=this.kb($)),{ref:u,syncData:j}}kb(y){try{const u=JSON.parse(y);if(a(u))return u}catch(u){this.O.error(u)}throw new m.$Egb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(y){const u=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.J.readResource(this.resource,u,this.collection,this.F)}async mb(y,u){const $=await this.j,j={version:this.pb,machineId:$,content:y};try{return u=await this.J.writeResource(this.resource,JSON.stringify(j),u,this.collection,this.F),{ref:u,syncData:j}}catch(M){throw M instanceof m.$Egb&&M.code==="TooLarge"&&(M=new m.$Egb(M.message,M.code,this.resource)),M}}async nb(y){const u={version:this.pb,content:y};return this.L.writeResource(this.resource,JSON.stringify(u),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(m.$rgb)}};e.$VDb=i,e.$VDb=i=ye([X(2,g.$9j),X(3,l.$Uh),X(4,f.$3o),X(5,m.$zgb),X(6,m.$Agb),X(7,m.$Jgb),X(8,c.$al),X(9,m.$Ogb),X(10,b.$hi),X(11,h.$Gk)],i);let t=class extends i{constructor(y,u,$,j,M,T,U,q,Y,J,x,W,Q){super(u,$,j,M,T,U,q,Y,J,x,W,Q),this.r=y,this.B(this.G.watch(this.h.dirname(y))),this.B(this.G.onDidFilesChange(H=>this.yb(H)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(y,u,$){try{u?await this.G.writeFile(this.r,L.$ae.fromString(y),$?void 0:u):await this.G.createFile(this.r,L.$ae.fromString(y),{overwrite:$})}catch(j){throw j instanceof g.$rk&&j.fileOperationResult===1||j instanceof g.$rk&&j.fileOperationResult===3?new m.$Egb(j.message,"LocalPreconditionFailed"):j}}async xb(){try{await this.G.del(this.r)}catch(y){if(!(y instanceof g.$rk&&y.fileOperationResult===1))throw y}}yb(y){y.contains(this.r)&&this.Q()}};e.$WDb=t,e.$WDb=t=ye([X(3,g.$9j),X(4,l.$Uh),X(5,f.$3o),X(6,m.$zgb),X(7,m.$Agb),X(8,m.$Jgb),X(9,c.$al),X(10,m.$Ogb),X(11,b.$hi),X(12,h.$Gk)],t);let r=class extends t{constructor(y,u,$,j,M,T,U,q,Y,J,x,W,Q,H){super(y,u,$,j,M,T,U,q,Y,J,x,Q,H),this.zb=W,this.Bb=void 0}Ab(y,u){const $=[],j=(0,I.$Sm)(y,$,{allowEmptyContent:!0,allowTrailingComma:!0});return $.length>0||!(0,P.$Ef)(j)&&u!==Array.isArray(j)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$XDb=r,e.$XDb=r=ye([X(3,g.$9j),X(4,l.$Uh),X(5,f.$3o),X(6,m.$zgb),X(7,m.$Agb),X(8,m.$Jgb),X(9,c.$al),X(10,m.$Ogb),X(11,m.$Ngb),X(12,b.$hi),X(13,h.$Gk)],r);let o=class{constructor(y,u,$,j,M,T,U){this.resource=y,this.g=u,this.h=$,this.j=j,this.k=M,this.l=T,this.d=U.extUri,this.f=(0,m.$xgb)(void 0,this.resource,$,this.d)}async initialize({ref:y,content:u}){if(!u){this.j.info("Remote content does not exist.",this.resource);return}const $=this.m(u);if($)try{await this.o({ref:y,syncData:$})}catch(j){this.j.error(j)}}m(y){try{const u=JSON.parse(y);if(a(u))return u}catch(u){this.j.error(u)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const $={ref:y.ref,version:void 0,...u};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify($),-1,1),await this.k.writeFile(this.f,L.$ae.fromString(JSON.stringify(y)))}};e.$YDb=o,e.$YDb=o=ye([X(1,S.$Ik),X(2,l.$Uh),X(3,p.$8i),X(4,g.$9j),X(5,f.$3o),X(6,h.$Gk)],o)}),define(oe[115],ae([0,1,5,26,8,3,41,2,27,20,14,114,29,33,81,44,11,4,71,7,21,22,28,17,39,232,111,25,58]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h,m,S,s,a,n,i,t,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r3b=e.$q3b=e.$p3b=e.$o3b=e.$n3b=void 0;async function v(T,U){const q=JSON.parse(T.content);if(T.version===1||T.version===2){const Y=(await U.getInstalled(0)).filter(J=>J.isBuiltin);for(const J of q)T.version===1&&(J.enabled===!1&&(J.disabled=!0),delete J.enabled),T.version===2&&Y.every(x=>!(0,l.$wo)(x.identifier,J.identifier))&&(J.installed=!0)}return q}function y(T){return JSON.parse(T.content)}e.$n3b=y;function u(T,U){return T.sort((q,Y)=>!q.identifier.uuid&&Y.identifier.uuid?-1:q.identifier.uuid&&!Y.identifier.uuid?1:(0,C.$Te)(q.identifier.id,Y.identifier.id)),U?(0,O.$TS)(T,{}):JSON.stringify(T)}e.$o3b=u;let $=class extends n.$VDb{constructor(U,q,Y,J,x,W,Q,H,V,ee,ne,_,ie,K,B,k,R){super({syncResource:"extensions",profile:U},q,J,Y,x,W,Q,_,ie,ee,ne,B),this.Cb=H,this.Db=V,this.Eb=R,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Qgb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Qgb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Qgb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Qgb,authority:"accepted"}),this.Bb=this.Eb.createInstance(j),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,z=>z.some(({local:F})=>!!F)),A.Event.filter(this.Cb.onDidUninstallExtension,z=>!z.error),A.Event.filter(k.onDidChange,z=>z.valueChanges.some(({profile:F,changes:G})=>this.syncResource.profile.id===F.id&&G.some(Z=>Z.key===b.$0n))),K.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,q){const Y=U.syncData?await v(U.syncData,this.Cb):null,J=q?.skippedExtensions??[],x=q?.builtinExtensions??null,W=q?.syncData?await v(q.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:ee}=(0,i.$m3b)(Q,Y,W,J,H,x),ne={local:V,remote:ee,content:this.Hb(Q,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:ee!==null?2:0},_=this.Ob(Q,!1);return[{skippedExtensions:J,builtinExtensions:x,baseResource:this.xb,baseContent:W?this.Ob(W,!1):_,localResource:this.yb,localContent:_,localExtensions:Q,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(U){const q=U.syncData?await v(U.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$m3b)(Y,q,q,U.skippedExtensions||[],J,U.builtinExtensions||[]);return x!==null}Hb(U,q,Y,J){const x=[...q,...Y],W=new Set,Q=H=>{W.add(H.id.toLowerCase()),H.uuid&&W.add(H.uuid)};x.forEach(({identifier:H})=>Q(H)),J.forEach(Q);for(const H of U)W.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&W.has(H.identifier.uuid)||x.push(H);return this.Ob(x,!1)}async rb(U,q){return{...U.previewResult,hasConflicts:!1}}async sb(U,q,Y,J){if(this.h.isEqual(q,this.yb))return this.Kb(U);if(this.h.isEqual(q,this.zb))return this.Lb(U);if(this.h.isEqual(q,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(U){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),J=(0,i.$m3b)(U.localExtensions,null,null,U.skippedExtensions,Y,U.builtinExtensions),{local:x,remote:W}=J;return{content:U.localContent,local:x,remote:W,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Lb(U){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),J=U.remoteContent?JSON.parse(U.remoteContent):null;if(J!==null){const x=(0,i.$m3b)(U.localExtensions,J,U.localExtensions,[],Y,U.builtinExtensions),{local:W,remote:Q}=x;return{content:U.remoteContent,local:W,remote:Q,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(U,q,Y,J){let{skippedExtensions:x,builtinExtensions:W,localExtensions:Q}=Y[0][0];const{local:H,remote:V,localChange:ee,remoteChange:ne}=Y[0][1];if(ee===0&&ne===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==0&&(await this.nb(JSON.stringify(Q)),x=await this.Bb.updateLocalExtensions(H.added,H.removed,H.updated,x,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const _=JSON.stringify(V.all);U=await this.mb(_,J?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(ie=>ie.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(ie=>ie.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(ie=>ie.identifier.id))}.`:""}`)}q?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),W=this.Nb(Q,W),await this.fb(U,{skippedExtensions:x,builtinExtensions:W}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`))}Nb(U,q){const Y=new Set,J=[];for(const x of U)Y.add(x.identifier.id.toLowerCase()),x.installed||J.push(x.identifier);if(q)for(const x of q)Y.has(x.id.toLowerCase())||J.push(x);return J}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const q=await this.db(U);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(U,q){return u(U,q)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$p3b=$,e.$p3b=$=ye([X(2,P.$Uh),X(3,w.$9j),X(4,m.$3o),X(5,r.$zgb),X(6,r.$Agb),X(7,b.$9n),X(8,t.$DEb),X(9,r.$Ogb),X(10,d.$hi),X(11,r.$Jgb),X(12,S.$al),X(13,g.$Su),X(14,s.$Gk),X(15,o.$5Cb),X(16,f.$Mh)],$);let j=class{constructor(U,q,Y,J,x,W){this.a=U,this.b=q,this.c=Y,this.d=J,this.f=x,this.g=W}async getLocalExtensions(U){const q=await this.a.getInstalled(void 0,U.extensionsResource),Y=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(U,async(x,W)=>{const Q=x.getDisabledExtensions();return q.map(H=>{const{identifier:V,isBuiltin:ee,manifest:ne,preRelease:_,pinned:ie,isApplicationScoped:K}=H,B={identifier:V,preRelease:_,version:ne.version,pinned:!!ie};K&&!(0,p.$6l)(ne)&&(B.isApplicationScoped=K),Q.some(k=>(0,l.$wo)(k,V))&&(B.disabled=!0),ee||(B.installed=!0);try{const k=W.getKeysForSync({id:V.id,version:ne.version});if(k){const R=W.getExtensionState(H,!0)||{};B.state=Object.keys(R).reduce((z,F)=>(k.includes(F)&&(z[F]=R[F]),z),{})}}catch(k){this.g.info(`${(0,n.$UDb)("extensions",U)}: Error while parsing extension state`,(0,L.$9)(k))}return B})}),ignoredExtensions:Y}}async updateLocalExtensions(U,q,Y,J,x){const W=(0,n.$UDb)("extensions",x),Q=[],H=new Map,V=[],ee=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((U.length||Y.length)&&await this.j(x,async(K,B)=>{await D.Promises.settled([...U,...Y].map(async k=>{const R=ne.find(G=>(0,l.$wo)(G.identifier,k.identifier));if(R&&R.isBuiltin){k.state&&R.manifest.version===k.version&&this.h(k.state,R,R.manifest.version,B),K.getDisabledExtensions().some(Z=>(0,l.$wo)(Z,k.identifier))!==!!k.disabled&&(k.disabled?(this.g.trace(`${W}: Disabling extension...`,k.identifier.id),await K.disableExtension(k.identifier),this.g.info(`${W}: Disabled extension`,k.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,k.identifier.id),await K.enableExtension(k.identifier),this.g.info(`${W}: Enabled extension`,k.identifier.id))),V.push(k.identifier);return}const z=k.pinned?k.version:void 0,F=(await this.c.getExtensions([{...k.identifier,version:z,preRelease:z?void 0:k.preRelease}],N.CancellationToken.None))[0];if(k.state&&(R?R.manifest.version===k.version:F)&&this.h(k.state,R||F,R?.manifest.version,B),F)try{K.getDisabledExtensions().some(Z=>(0,l.$wo)(Z,k.identifier))!==!!k.disabled&&(k.disabled?(this.g.trace(`${W}: Disabling extension...`,k.identifier.id,F.version),await K.disableExtension(F.identifier),this.g.info(`${W}: Disabled extension`,k.identifier.id,F.version)):(this.g.trace(`${W}: Enabling extension...`,k.identifier.id,F.version),await K.enableExtension(F.identifier),this.g.info(`${W}: Enabled extension`,k.identifier.id,F.version))),(!R||R.preRelease!==k.preRelease||R.pinned!==k.pinned||z&&R.manifest.version!==z)&&(await this.a.canInstall(F)?(Q.push({extension:F,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:k.pinned&&!!k.version,installPreReleaseVersion:k.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:k.isApplicationScoped,context:{[b.$Wn]:!0,[b.$Xn]:!0}}}),H.set(F.identifier.id.toLowerCase(),k)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,F.displayName||F.identifier.id),ee.push(k)))}catch(G){ee.push(k),this.g.error(G),this.g.info(`${W}: Skipped synchronizing extension`,F.displayName||F.identifier.id)}else ee.push(k),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,k.identifier.id)}))}),q.length){const K=ne.filter(({identifier:B,isBuiltin:k})=>!k&&q.some(R=>(0,l.$wo)(B,R)));await D.Promises.settled(K.map(async B=>{this.g.trace(`${W}: Uninstalling local extension...`,B.identifier.id),await this.a.uninstall(B,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,B.identifier.id),V.push(B.identifier)}))}const _=await this.a.installGalleryExtensions(Q);for(const{identifier:K,local:B,error:k,source:R}of _){const z=R;if(B)this.g.info(`${W}: Installed extension.`,K.id,z.version),V.push(K);else{const F=H.get(K.id.toLowerCase());F&&(ee.push(F),this.g.info(`${W}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),k instanceof b.$8n&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(k.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):k&&this.g.error(k)}}const ie=[];for(const K of J)V.some(B=>(0,l.$wo)(B,K.identifier))||ie.push(K);for(const K of ee)ie.some(B=>(0,l.$wo)(B.identifier,K.identifier))||ie.push(K);return ie}h(U,q,Y,J){const x=J.getExtensionState(q,!0)||{},W=Y?J.getKeysForSync({id:q.identifier.id,version:Y}):void 0;W?W.forEach(Q=>{x[Q]=U[Q]}):Object.keys(U).forEach(Q=>x[Q]=U[Q]),J.setExtensionState(q,x,!0)}async j(U,q){return this.b.withProfileScopedStorageService(U,async Y=>{const J=new I.$Qc,x=this.f.createChild(new c.$Lh([m.$3o,Y])),W=J.add(x.createInstance(E.$qCb)),Q=J.add(x.createInstance(g.$Tu));try{return await q(W,Q)}finally{J.dispose()}})}};e.$q3b=j,e.$q3b=j=ye([X(0,b.$9n),X(1,o.$5Cb),X(2,b.$7n),X(3,t.$DEb),X(4,f.$Mh),X(5,r.$Ogb)],j);let M=class extends n.$YDb{constructor(U,q,Y,J,x,W,Q,H){super("extensions",J,x,W,Y,Q,H),this.p=U,this.q=q}async t(U){return U.syncData?await v(U.syncData,this.p):null}u(U,q){const Y=[],J=[],x=[];for(const W of U){if(this.q.hasToNeverSyncExtension(W.identifier.id))continue;const Q=q.find(H=>(0,l.$wo)(H.identifier,W.identifier));Q?(Y.push(Q),W.disabled&&x.push(W.identifier)):W.installed&&(J.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&x.push(W.identifier))}return{installedExtensions:Y,newExtensions:J,disabledExtensions:x,remoteExtensions:U}}};e.$r3b=M,e.$r3b=M=ye([X(0,b.$9n),X(1,t.$DEb),X(2,w.$9j),X(3,a.$Ik),X(4,P.$Uh),X(5,h.$8i),X(6,m.$3o),X(7,s.$Gk)],M)}),define(oe[116],ae([0,1,15,8,3,35,41,6,32,20,14,11,7,43,21,22,28,39,78,236,25,17,58,4]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h,m,S,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Db=e.$4Db=e.$3Db=e.$2Db=e.$1Db=void 0;const n="globalState.argv.",i=["locale"];function t($,j){const M=$.storage?Object.keys($.storage).sort():[],T={};return M.forEach(U=>T[U]=$.storage[U]),$.storage=T,j?(0,O.$TS)($,{}):JSON.stringify($)}e.$1Db=t;const r=1;let o=class extends f.$VDb{constructor(j,M,T,U,q,Y,J,x,W,Q,H,V,ee,ne){super({syncResource:"globalState",profile:j},M,U,x,V,q,Y,W,Q,J,H,ee),this.Bb=T,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:m.$Qgb,authority:"base"}),this.xb=this.vb.with({scheme:m.$Qgb,authority:"local"}),this.yb=this.vb.with({scheme:m.$Qgb,authority:"remote"}),this.zb=this.vb.with({scheme:m.$Qgb,authority:"accepted"}),this.Ab=ne.createInstance(v),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(U.onDidFilesChange,_=>_.contains(this.H.argvResource)),L.Event.filter(T.onDidChange,_=>!!(_.targetChanges.some(ie=>this.syncResource.profile.id===ie.id)||_.valueChanges.some(({profile:ie,changes:K})=>this.syncResource.profile.id===ie.id&&K.some(B=>B.target===0)))))(()=>this.Q()))}async qb(j,M,T){const U=j.syncData?JSON.parse(j.syncData.content):null;M=M===null&&T?j:M;const q=M&&M.syncData?JSON.parse(M.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const J=await this.Jb(q),{local:x,remote:W}=(0,h.$ZDb)(Y.storage,U?U.storage:null,q?q.storage:null,J,this.O),Q={content:null,local:x,remote:W,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:W.all!==null?2:0},H=t(Y,!1);return[{baseResource:this.wb,baseContent:q?t(q,!1):H,localResource:this.xb,localContent:H,localUserData:Y,remoteResource:this.yb,remoteContent:U?t(U,!1):null,previewResource:this.vb,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.zb,storageKeys:J}]}async ub(j){const M=j.syncData?JSON.parse(j.syncData.content):null;if(M===null)return!0;const T=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(M),{remote:q}=(0,h.$ZDb)(T.storage,M.storage,M.storage,U,this.O);return q.all!==null}async rb(j,M){return{...j.previewResult,hasConflicts:!1}}async sb(j,M,T,U){if(this.h.isEqual(M,this.xb))return this.Gb(j);if(this.h.isEqual(M,this.yb))return this.Hb(j);if(this.h.isEqual(M,this.vb))return j.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Gb(j){return{content:j.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(j.localUserData.storage),removed:[],updated:[],all:j.localUserData.storage},localChange:0,remoteChange:2}}async Hb(j){if(j.remoteContent!==null){const M=JSON.parse(j.remoteContent),{local:T,remote:U}=(0,h.$ZDb)(j.localUserData.storage,M.storage,null,j.storageKeys,this.O);return{content:j.remoteContent,local:T,remote:U,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:j.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(j,M,T,U){const{localUserData:q}=T[0][0],{local:Y,remote:J,localChange:x,remoteChange:W}=T[0][1];if(x===0&&W===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),W!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Q=JSON.stringify({storage:J.all});j=await this.mb(Q,U?null:j.ref),this.O.info(`${this.D}: Updated remote ui state.${J.added.length?` Added: ${J.added}.`:""}${J.updated.length?` Updated: ${J.updated}.`:""}${J.removed.length?` Removed: ${J.removed}.`:""}`)}M?.ref!==j.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(j),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(j){if(this.h.isEqual(this.yb,j)||this.h.isEqual(this.wb,j)||this.h.isEqual(this.xb,j)||this.h.isEqual(this.zb,j)){const M=await this.db(j);return M&&t(JSON.parse(M),!0)}return null}async hasLocalData(){try{const{storage:j}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(j).length>1||j[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(j){const M=await this.Bb.readStorageData(this.syncResource.profile),T=[],U=[];for(const[J,x]of M)x.target===0?T.push(J):x.target===1&&U.push(J);const q=[...T,...U],Y=j?.storage?Object.keys(j.storage).filter(J=>!J.startsWith(n)&&!q.includes(J)&&M.get(J)!==void 0):[];if(!I.$p){const J=[...m.$vgb.map(x=>(0,m.$Igb)(x)),m.$Hgb];Y.push(...J),U.push(...J)}return{user:T,machine:U,unregistered:Y}}};e.$2Db=o,e.$2Db=o=ye([X(2,s.$5Cb),X(3,E.$9j),X(4,m.$zgb),X(5,m.$Agb),X(6,m.$Ogb),X(7,P.$Uh),X(8,m.$Jgb),X(9,p.$al),X(10,d.$hi),X(11,g.$3o),X(12,w.$Gk),X(13,a.$Mh)],o);let v=class{constructor(j,M,T,U){this.a=j,this.b=M,this.c=T,this.d=U}async getLocalGlobalState(j){const M={};if(j.isDefault){const U=await this.f(),q=(0,A.$Sm)(U);for(const Y of i)q[Y]!==void 0&&(M[`${n}${Y}`]={version:1,value:q[Y]})}const T=await this.c.readStorageData(j);for(const[U,q]of T)q.value&&q.target===0&&(M[U]={version:1,value:q.value});return{storage:M}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const j=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),j.value.toString()}catch(j){this.d.debug((0,N.$9)(j))}return"{}"}async writeLocalGlobalState({added:j,removed:M,updated:T},U){const q=(0,f.$UDb)("globalState",U),Y={},J=new Map,x=await this.c.readStorageData(U),W=(Q,H)=>{for(const V of Q){if(V.startsWith(n)){Y[V.substring(n.length)]=H?H[V].value:void 0;continue}if(H){const ee=H[V];ee.value!==x.get(V)?.value&&J.set(V,ee.value)}else x.get(V)!==void 0&&J.set(V,void 0)}};if(W(Object.keys(j),j),W(Object.keys(T),T),W(M),Object.keys(Y).length){this.d.trace(`${q}: Updating locale...`);const Q=await this.f();let H=Q;for(const V of Object.keys(Y))H=(0,c.edit)(H,[V],Y[V],{});Q!==H&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.$ae.fromString(H)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}J.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(U,J,0),this.d.info(`${q}: Updated global state`,[...J.keys()]))}};e.$3Db=v,e.$3Db=v=ye([X(0,E.$9j),X(1,P.$Uh),X(2,s.$5Cb),X(3,m.$Ogb)],v);let y=class extends f.$YDb{constructor(j,M,T,U,q,Y){super("globalState",T,U,q,M,j,Y)}async o(j){const M=j.syncData?JSON.parse(j.syncData.content):null;if(!M){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const T={},U={};for(const q of Object.keys(M.storage))q.startsWith(n)?T[q.substring(n.length)]=M.storage[q].value:this.l.get(q,0)===void 0&&(U[q]=M.storage[q].value);if(Object.keys(T).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(T))q=(0,c.edit)(q,[Y],T[Y],{});await this.k.writeFile(this.h.argvResource,D.$ae.fromString(q))}if(Object.keys(U).length){const q=[];for(const Y of Object.keys(U))q.push({key:Y,value:U[Y],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$4Db=y,e.$4Db=y=ye([X(0,g.$3o),X(1,E.$9j),X(2,S.$Ik),X(3,P.$Uh),X(4,m.$Ogb),X(5,w.$Gk)],y);let u=class{constructor(j,M,T,U,q){this.a=j,this.b=M,this.c=T,this.d=U,this.f=q}getSyncStoreType(j){return this.h(j)?.storage[m.$Hgb]?.value}async sync(j){const M=(0,m.$Dgb)((0,C.$dg)());try{return await this.g(j,M)}catch(T){if(T instanceof m.$Egb)switch(T.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(j,M)}throw T}}async g(j,M){const T=await this.a.readResource("globalState",null,void 0,M),U=this.h(T)||{storage:{}};U.storage[m.$Hgb]={value:j,version:r};const q=await(0,l.$9o)(this.c,this.d,this.b),Y={version:r,machineId:q,content:t(U,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),T.ref,void 0,M)}h({content:j}){if(!j)return null;const M=JSON.parse(j);if((0,f.$TDb)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};e.$5Db=u,e.$5Db=u=ye([X(1,g.$3o),X(2,P.$Uh),X(3,E.$9j),X(4,b.$8i)],u)}),define(oe[117],ae([0,1,18,15,3,35,6,12,171,20,14,11,21,22,28,17,39,233,25]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v3b=e.$u3b=e.$t3b=void 0;function h(s,a,n){try{const i=JSON.parse(s);if(!a)return(0,I.$Ef)(i.all)?null:i.all;switch(O.OS){case 2:return(0,I.$Ef)(i.mac)?null:i.mac;case 3:return(0,I.$Ef)(i.linux)?null:i.linux;case 1:return(0,I.$Ef)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.$t3b=h;let m=class extends w.$XDb{constructor(a,n,i,t,r,o,v,y,u,$,j,M,T){super(a.keybindingsResource,{syncResource:"keybindings",profile:a},n,y,u,$,i,t,v,M,r,j,o,T),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:c.$Qgb,authority:"base"}),this.Gb=this.Eb.with({scheme:c.$Qgb,authority:"local"}),this.Hb=this.Eb.with({scheme:c.$Qgb,authority:"remote"}),this.Ib=this.Eb.with({scheme:c.$Qgb,authority:"accepted"}),this.B(L.Event.filter(o.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(a,n,i,t){const r=a.syncData?h(a.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&i?a:n;const o=n?this.Ob(n):null,v=await this.vb(),y=await this.Cb();let u=null,$=!1,j=!1,M=!1;if(r){let q=v?v.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new c.$Egb((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==q||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,f.$s3b)(q,r,o,y,this.zb);Y.hasChanges&&(u=Y.mergeContent,M=Y.hasConflicts,$=M||Y.mergeContent!==q,j=M||Y.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=v.value.toString(),j=!0);const T={content:M?o:u,localChange:$?v?2:1:0,remoteChange:j?2:0,hasConflicts:M},U=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:U,localChange:T.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:T.remoteChange,previewResource:this.Eb,previewResult:T,acceptedResource:this.Ib}]}async ub(a){const n=this.Ob(a);if(n===null)return!0;const i=await this.vb(),t=i?i.value.toString():"",r=await this.Cb(),o=await(0,f.$s3b)(t||"[]",n,n,r,this.zb);return o.hasConflicts||o.mergeContent!==n}async rb(a,n){return a.previewResult}async sb(a,n,i,t){if(this.h.isEqual(n,this.Gb))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return i===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(a,n,i,t){const{fileContent:r}=i[0][0];let{content:o,localChange:v,remoteChange:y}=i[0][1];if(v===0&&y===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new c.$Egb((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),y!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const u=this.Pb(o||"[]",a.syncData?.content);a=await this.mb(u,t?null:a.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==a.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(a,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.vb();if(a){const n=(0,A.$Sm)(a.value.toString());if((0,D.$Kb)(n))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async resolveContent(a){return this.h.isEqual(this.Hb,a)||this.h.isEqual(this.Fb,a)||this.h.isEqual(this.Gb,a)||this.h.isEqual(this.Ib,a)?this.db(a):null}Ob(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.Qb()?null:h(a.syncData.content,this.Qb(),this.O)}Pb(a,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete i.all:i.all=a,O.OS){case 2:i.mac=a;break;case 3:i.linux=a;break;case 1:i.windows=a;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(c.$sgb)}};e.$u3b=m,e.$u3b=m=ye([X(2,c.$zgb),X(3,c.$Agb),X(4,c.$Ogb),X(5,d.$hi),X(6,c.$Jgb),X(7,E.$9j),X(8,P.$Uh),X(9,b.$3o),X(10,c.$Ngb),X(11,l.$al),X(12,g.$Gk)],m);let S=class extends w.$YDb{constructor(a,n,i,t,r,o){super("keybindings",n,i,t,a,r,o)}async o(a){const n=a.syncData?this.p(a.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$ae.fromString(n)),await this.n(a)}async i(){try{const a=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$Sm)(a.value.toString());return!(0,D.$Kb)(n)}catch(a){return a.fileOperationResult===1}}p(a){try{return h(a,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$v3b=S,e.$v3b=S=ye([X(0,E.$9j),X(1,p.$Ik),X(2,P.$Uh),X(3,c.$Ogb),X(4,b.$3o),X(5,g.$Gk)],S)}),define(oe[118],ae([0,1,15,3,172,20,74,14,29,11,21,22,28,17,39,237,25]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y3b=e.$x3b=e.$w3b=void 0;function f(S){return S&&S.settings&&typeof S.settings=="string"&&Object.keys(S).length===1}function c(S){const s=JSON.parse(S);return f(s)?s:{settings:S}}e.$w3b=c;let h=class extends g.$XDb{constructor(s,a,n,i,t,r,o,v,y,u,$,j,M,T){super(s.settingsResource,{syncResource:"settings",profile:s},a,n,i,t,r,o,$,j,v,y,u,T),this.Eb=M,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$Qgb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$Qgb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$Qgb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$Qgb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(s){const a=await this.getLastSyncUserData(),n=await this.X(s,a),i=this.Lb(n),t=new O.$yn(w.$rgb);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(w.$rgb)||{}}async qb(s,a,n){const i=await this.vb(),t=await this.Cb(),r=this.Lb(s);a=a===null&&n?s:a;const o=a?this.Lb(a):null,v=await this.Pb();let y=null,u=!1,$=!1,j=!1;if(r){let q=i?i.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,p.$LCb)(q,r.settings,o?o.settings:null,v,[],t);y=Y.localContent||Y.remoteContent,u=Y.localContent!==null,$=Y.remoteContent!==null,j=Y.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),y=i.value.toString().trim()||"{}",this.Qb(y),$=!0);const M=i?i.value.toString():null,T=o?.settings??null,U={content:j?T:y,localChange:u?2:0,remoteChange:$?2:0,hasConflicts:j};return[{fileContent:i,baseResource:this.baseResource,baseContent:T,localResource:this.localResource,localContent:M,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async ub(s){const a=this.Lb(s);if(a===null)return!0;const n=await this.vb(),i=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,p.$LCb)(i||"{}",a.settings,a.settings,t,[],r).remoteContent!==null}async rb(s,a){const n=await this.Cb(),i=await this.Pb();return{...s.previewResult,content:s.previewResult.content?(0,p.$KCb)(s.previewResult.content,"{}",i,n):null}}async sb(s,a,n,i){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(a,this.localResource))return{content:s.fileContent?(0,p.$KCb)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(a,this.remoteResource))return{content:s.remoteContent!==null?(0,p.$KCb)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(a,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,p.$KCb)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async tb(s,a,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:o,remoteChange:v}=n[0][1];if(o===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),o!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,i),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const y=await this.Cb(),u=this.Lb(s),$=await this.Pb(r);r=(0,p.$KCb)(r,u?u.settings:"{}",$,y),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Nb(r)),i?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}a?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,p.$MCb)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let a=await super.db(s);if(a){const n=await this.Cb(),i=await this.Pb();a=(0,p.$KCb)(a,"{}",i,n)}return a}Lb(s){return s.syncData?this.Mb(s.syncData.content):null}Mb(s){try{return c(s)}catch(a){this.O.error(a)}return null}Nb(s){return{settings:s}}async Pb(s){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),N.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this.Ob=void 0}))}const a=await this.Ob;return(0,p.$ICb)(a,this.P,s)}Qb(s){if(this.Ab(s,!1))throw new w.$Egb((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$x3b=h,e.$x3b=h=ye([X(2,d.$9j),X(3,I.$Uh),X(4,P.$3o),X(5,w.$zgb),X(6,w.$Agb),X(7,w.$Ogb),X(8,w.$Ngb),X(9,A.$hi),X(10,w.$Jgb),X(11,E.$al),X(12,C.$9n),X(13,b.$Gk)],h);let m=class extends g.$YDb{constructor(s,a,n,i,t,r){super("settings",a,n,i,s,t,r)}async o(s){const a=s.syncData?this.p(s.syncData.content):null;if(!a){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.$ae.fromString(a.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$MCb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}p(s){try{return c(s)}catch(a){this.j.error(a)}return null}};e.$y3b=m,e.$y3b=m=ye([X(0,d.$9j),X(1,l.$Ik),X(2,I.$Uh),X(3,w.$Ogb),X(4,P.$3o),X(5,b.$Gk)],m)}),define(oe[119],ae([0,1,15,3,30,20,14,11,21,22,28,17,39,234,25]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D3b=e.$C3b=e.$B3b=void 0;function p(c){return JSON.parse(c.content)}e.$B3b=p;let w=class extends b.$VDb{constructor(h,m,S,s,a,n,i,t,r,o,v,y){super({syncResource:"snippets",profile:h},m,s,S,a,n,i,o,v,t,r,y),this.pb=1,this.vb=h.snippetsHome,this.B(this.G.watch(S.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,u=>u.affects(this.vb))(()=>this.Q()))}async qb(h,m,S){const s=await this.Hb(),a=this.Gb(s),n=h.syncData?this.Fb(h.syncData):null;m=m===null&&S?h:m;const i=m&&m.syncData?this.Fb(m.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,l.$z3b)(a,n,i);return this.Bb(t,s,n||{},i||{})}async ub(h){const m=h.syncData?this.Fb(h.syncData):null;if(m===null)return!0;const S=await this.Hb(),s=this.Gb(S),a=(0,l.$z3b)(s,m,m);return Object.keys(a.remote.added).length>0||Object.keys(a.remote.updated).length>0||a.remote.removed.length>0||a.conflicts.length>0}async rb(h,m){return h.previewResult}async sb(h,m,S,s){if(this.h.isEqualOrParent(m,this.g.with({scheme:g.$Qgb,authority:"local"})))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:h.fileContent?h.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(m,this.g.with({scheme:g.$Qgb,authority:"remote"})))return{content:h.remoteContent,localChange:h.remoteContent!==null?h.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(m,this.g))return S===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:S,localChange:S===null?h.fileContent!==null?3:0:2,remoteChange:S===null?h.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async tb(h,m,S,s){const a=S.map(([n,i])=>({...n,acceptResult:i}));a.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),a.some(({localChange:n})=>n!==0)&&(await this.Cb(a),await this.Db(a,s)),a.some(({remoteChange:n})=>n!==0)&&(h=await this.Eb(a,h,s)),m?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of a)try{await this.G.del(n)}catch{}}Bb(h,m,S,s){const a=new Map;for(const n of Object.keys(h.local.added)){const i={content:h.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"remote"}),remoteContent:S[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"accepted"})})}for(const n of Object.keys(h.local.updated)){const i={content:h.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"remote"}),remoteContent:S[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"accepted"})})}for(const n of h.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"accepted"})})}for(const n of Object.keys(h.remote.added)){const i={content:h.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"accepted"})})}for(const n of Object.keys(h.remote.updated)){const i={content:h.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"remote"}),remoteContent:S[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"accepted"})})}for(const n of h.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"remote"}),remoteContent:S[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"accepted"})})}for(const n of h.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:m[n]?2:1,remoteChange:S[n]?2:1},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"remote"}),remoteContent:S[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"accepted"})})}for(const n of Object.keys(m))if(!a.has(n)){const i={content:m[n]?m[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"remote"}),remoteContent:S[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Qgb,authority:"accepted"})})}return[...a.values()]}async resolveContent(h){return this.h.isEqualOrParent(h,this.g.with({scheme:g.$Qgb,authority:"remote"}))||this.h.isEqualOrParent(h,this.g.with({scheme:g.$Qgb,authority:"local"}))||this.h.isEqualOrParent(h,this.g.with({scheme:g.$Qgb,authority:"base"}))||this.h.isEqualOrParent(h,this.g.with({scheme:g.$Qgb,authority:"accepted"}))?this.db(h):null}async hasLocalData(){try{const h=await this.Hb();if(Object.keys(h).length)return!0}catch{}return!1}async Cb(h){const m={};for(const S of h)S.fileContent&&(m[this.h.basename(S.localResource)]=S.fileContent);await this.nb(JSON.stringify(this.Gb(m)))}async Db(h,m){for(const{fileContent:S,acceptResult:s,localResource:a,remoteResource:n,localChange:i}of h)if(i!==0){const t=n?this.h.basename(n):this.h.basename(a),r=this.h.joinPath(this.vb,t);i===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,D.$ae.fromString(s.content),{overwrite:m}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,D.$ae.fromString(s.content),m?void 0:S),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(h,m,S){const s=m.syncData?this.Fb(m.syncData):{},a=(0,L.$3m)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of h)if(r!==0){const o=i?this.h.basename(i):this.h.basename(t);r===3?delete a[o]:a[o]=n.content}return(0,l.$A3b)(s,a)||(this.O.trace(`${this.D}: Updating remote snippets...`),m=await this.mb(JSON.stringify(a),S?null:m.ref),this.O.info(`${this.D}: Updated remote snippets`)),m}Fb(h){return p(h)}Gb(h){const m={};for(const S of Object.keys(h))m[S]=h[S].value.toString();return m}async Hb(){const h={};let m;try{m=await this.G.resolve(this.vb)}catch(S){if(S instanceof I.$rk&&S.fileOperationResult===1)return h;throw S}for(const S of m.children||[]){const s=S.resource,a=this.h.extname(s);if(a===".json"||a===".code-snippets"){const n=this.h.relativePath(this.vb,s),i=await this.G.readFile(s);h[n]=i}}return h}};e.$C3b=w,e.$C3b=w=ye([X(2,O.$Uh),X(3,I.$9j),X(4,C.$3o),X(5,g.$zgb),X(6,g.$Agb),X(7,g.$Ogb),X(8,A.$hi),X(9,g.$Jgb),X(10,d.$al),X(11,P.$Gk)],w);let f=class extends b.$YDb{constructor(h,m,S,s,a,n){super("snippets",m,S,s,h,a,n)}async o(h){const m=h.syncData?JSON.parse(h.syncData.content):null;if(!m){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(m)){const a=m[s];if(a){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,s);await this.k.createFile(n,D.$ae.fromString(a)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(h)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(h){return h.fileOperationResult===1}}};e.$D3b=f,e.$D3b=f=ye([X(0,I.$9j),X(1,E.$Ik),X(2,O.$Uh),X(3,g.$Ogb),X(4,C.$3o),X(5,P.$Gk)],f)}),define(oe[120],ae([0,1,15,20,14,11,21,22,28,17,39,25]),function(te,e,D,N,L,A,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G3b=e.$F3b=e.$E3b=void 0;function b(w,f){try{return JSON.parse(w).tasks??null}catch(c){return f.error(c),null}}e.$E3b=b;let l=class extends P.$WDb{constructor(f,c,h,m,S,s,a,n,i,t,r,o){super(f.tasksResource,{syncResource:"tasks",profile:f},c,n,i,t,h,m,a,r,S,s,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:E.$Qgb,authority:"base"}),this.Cb=this.Ab.with({scheme:E.$Qgb,authority:"local"}),this.Db=this.Ab.with({scheme:E.$Qgb,authority:"remote"}),this.Eb=this.Ab.with({scheme:E.$Qgb,authority:"accepted"})}async qb(f,c,h,m){const S=f.syncData?b(f.syncData.content,this.O):null;c=c===null&&h?f:c;const s=c?.syncData?b(c.syncData.content,this.O):null,a=await this.vb();let n=null,i=!1,t=!1,r=!1;if(f.syncData){const y=a?a.value.toString():null;if(!s||s!==y||s!==S){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const u=p(y,S,s);n=u.content,r=u.hasConflicts,i=u.hasLocalChanged,t=u.hasRemoteChanged}}else a&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=a.value.toString(),t=!0);const o={content:r?s:n,localChange:i?a?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=a?a.value.toString():null;return[{fileContent:a,baseResource:this.Bb,baseContent:s,localResource:this.Cb,localContent:v,localChange:o.localChange,remoteResource:this.Db,remoteContent:S,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(f){const c=f?.syncData?b(f.syncData.content,this.O):null;if(c===null)return!0;const h=await this.vb(),m=h?h.value.toString():null,S=p(m,c,c);return S.hasLocalChanged||S.hasRemoteChanged}async rb(f,c){return f.previewResult}async sb(f,c,h,m){if(this.h.isEqual(c,this.Cb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(c,this.Db))return{content:f.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(c,this.Ab))return h===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:h,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(f,c,h,m){const{fileContent:S}=h[0][0],{content:s,localChange:a,remoteChange:n}=h[0][1];if(a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),a!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),S&&await this.nb(JSON.stringify(this.Kb(S.value.toString()))),s?await this.wb(s,S,m):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(s));f=await this.mb(i,m?null:f.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}c?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(f){return this.h.isEqual(this.Db,f)||this.h.isEqual(this.Bb,f)||this.h.isEqual(this.Cb,f)||this.h.isEqual(this.Eb,f)?this.db(f):null}Kb(f){return f?{tasks:f}:{}}};e.$F3b=l,e.$F3b=l=ye([X(2,E.$zgb),X(3,E.$Agb),X(4,E.$Ogb),X(5,N.$hi),X(6,E.$Jgb),X(7,A.$9j),X(8,L.$Uh),X(9,O.$3o),X(10,I.$al),X(11,C.$Gk)],l);let g=class extends P.$YDb{constructor(f,c,h,m,S,s){super("tasks",c,h,m,f,S,s),this.c=this.g.defaultProfile.tasksResource}async o(f){const c=f.syncData?b(f.syncData.content,this.j):null;if(!c){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.$ae.fromString(c)),await this.n(f)}async p(){return this.k.exists(this.c)}};e.$G3b=g,e.$G3b=g=ye([X(0,A.$9j),X(1,d.$Ik),X(2,L.$Uh),X(3,E.$Ogb),X(4,O.$3o),X(5,C.$Gk)],g);function p(w,f,c){if(w===null&&f===null&&c===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const h=c!==w,m=c!==f;return!h&&!m?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:h&&!m?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:m&&!h?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[121],ae([0,1,41,20,14,11,21,22,28,17,39,235,25]),function(te,e,D,N,L,A,O,I,C,d,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k5b=e.$j5b=e.$i5b=void 0;let l=class extends P.$VDb{constructor(f,c,h,m,S,s,a,n,i,t,r,o,v){super({syncResource:"profiles",profile:f},c,m,S,s,a,n,r,o,i,t,v),this.vb=h,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:b.$Qgb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$Qgb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$Qgb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$Qgb,authority:"accepted"}),this.B(h.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?p(f.syncData):null}async getRemoteSyncedProfiles(f){const c=await this.getLastSyncUserData(),h=await this.X(f,c);return h?.syncData?p(h.syncData):null}async qb(f,c,h){if(!this.vb.isEnabled())throw new b.$Egb("Cannot sync profiles because they are disabled","LocalError");const m=f.syncData?p(f.syncData):null,S=c?.syncData?p(c.syncData):null,s=this.Db(),{local:a,remote:n}=(0,E.$h5b)(s,m,S,[]),i={local:a,remote:n,content:S?this.Eb(S):null,localChange:a.added.length>0||a.removed.length>0||a.updated.length>0?2:0,remoteChange:n!==null?2:0},t=g(s,!1);return[{baseResource:this.baseResource,baseContent:S?this.Eb(S):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:m?this.Eb(m):null,remoteProfiles:m,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(f){const c=f?.syncData?p(f.syncData):null,h=this.Db(),{remote:m}=(0,E.$h5b)(h,c,c,[]);return!!m?.added.length||!!m?.removed.length||!!m?.updated.length}async rb(f,c){return{...f.previewResult,hasConflicts:!1}}async sb(f,c,h,m){if(this.h.isEqual(c,this.localResource))return this.Ab(f);if(this.h.isEqual(c,this.remoteResource))return this.Bb(f);if(this.h.isEqual(c,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${c.toString()}`)}async Ab(f){const c=this.Db(),h=(0,E.$h5b)(c,null,null,[]),{local:m,remote:S}=h;return{content:f.localContent,local:m,remote:S,localChange:m.added.length>0||m.removed.length>0||m.updated.length>0?2:0,remoteChange:S!==null?2:0}}async Bb(f){const c=f.remoteContent?JSON.parse(f.remoteContent):null,h=[],m=[];for(const S of this.Db()){const s=c?.find(a=>a.id===S.id);s&&(h.push({id:S.id,name:S.name,collection:s.collection}),m.push(S))}if(c!==null){const S=(0,E.$h5b)(m,c,h,[]),{local:s,remote:a}=S;return{content:f.remoteContent,local:s,remote:a,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(f,c,h,m){const{local:S,remote:s,localChange:a,remoteChange:n}=h[0][1];a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=h[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new b.$Egb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(a!==0){await this.nb(g(this.Db(),!1));const t=[];for(const r of S.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of S.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of S.updated){const o=this.vb.profiles.find(v=>v.id===r.id);o?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(o,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const o of s?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),i.push({id:o.id,name:o.name,collection:v,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of s?.removed||[])i.splice(i.findIndex(({id:v})=>o.id===v),1);for(const o of s?.updated||[]){const v=i.find(({id:y})=>o.id===y);v&&i.splice(i.indexOf(v),1,{...v,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{f=await this.updateRemoteProfiles(i,m?null:f.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(o=>o.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(o=>o.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(o=>o.name))}.`:""}`)}catch(o){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw o}for(const o of s?.removed||[])await this.J.deleteCollection(o.collection,this.F)}c?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,c){return this.mb(this.Eb(f),c)}async hasLocalData(){return this.Db().length>0}async resolveContent(f){if(this.h.isEqual(this.remoteResource,f)||this.h.isEqual(this.baseResource,f)||this.h.isEqual(this.localResource,f)||this.h.isEqual(this.acceptedResource,f)){const c=await this.db(f);return c&&(0,D.$TS)(JSON.parse(c),{})}return null}Db(){return this.vb.profiles.filter(f=>!f.isDefault&&!f.isTransient)}Eb(f){return JSON.stringify([...f].sort((c,h)=>c.name.localeCompare(h.name)))}};e.$i5b=l,e.$i5b=l=ye([X(2,d.$Ik),X(3,A.$9j),X(4,L.$Uh),X(5,O.$3o),X(6,b.$zgb),X(7,b.$Agb),X(8,b.$Ogb),X(9,N.$hi),X(10,b.$Jgb),X(11,I.$al),X(12,C.$Gk)],l);function g(w,f){const c=[...w].sort((h,m)=>h.name.localeCompare(m.name)).map(h=>({id:h.id,name:h.name}));return f?(0,D.$TS)(c,{}):JSON.stringify(c)}e.$j5b=g;function p(w){return JSON.parse(w.content)}e.$k5b=p}),define(oe[253],ae([0,1,3,2,6,14,21,22,25]),function(te,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$84b=void 0;const d="sync.enable";let P=class extends N.$Rc{constructor(b,l,g,p){super(),this.c=b,this.f=l,this.g=g,this.h=p,this.a=new D.$Md,this.onDidChangeEnablement=this.a.event,this.b=new D.$Md,this.onDidChangeResourceEnablement=this.b.event,this.B(b.onDidChangeValue(-1,void 0,this.B(new N.$Qc))(w=>this.m(w)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(d,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(b){b&&!this.canToggleEnablement()||(this.f.publicLog2(d,{enabled:b}),this.c.store(d,b,-1,1))}isResourceEnabled(b){return this.c.getBoolean((0,C.$Igb)(b),-1,!0)}setResourceEnablement(b,l){if(this.isResourceEnabled(b)!==l){const g=(0,C.$Igb)(b);this.j(g,l)}}getResourceSyncStateVersion(b){}j(b,l){this.c.store(b,l,-1,L.$p?0:1)}m(b){if(d===b.key){this.a.fire(this.isEnabled());return}const l=C.$vgb.filter(g=>(0,C.$Igb)(g)===b.key)[0];if(l){this.b.fire([l,this.isResourceEnabled(l)]);return}}};e.$84b=P,e.$84b=P=ye([X(0,O.$3o),X(1,I.$al),X(2,A.$Uh),X(3,C.$ygb)],P)}),define(oe[254],ae([0,1,5,15,63,2,19,20,14,11,17,25]),function(te,e,D,N,L,A,O,I,C,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g5b=void 0;let b=class extends A.$Rc{constructor(g,p,w,f,c){super(),this.a=g,this.b=p,this.c=w,this.f=f,this.g=c,this.h()}async h(){for(const p of this.g.profiles)for(const w of E.$vgb)try{await this.m(this.j(w,p.isDefault?void 0:p.id))}catch(f){this.f.error(f)}let g;try{g=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,d.$nk)(p)!==1&&this.f.error(p);return}if(g.children){for(const p of g.children)if(p.isDirectory&&!this.g.profiles.some(w=>w.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(w){this.f.error(w)}}}async getAllResourceRefs(g,p,w){const f=this.j(g,p,w);try{const c=await this.b.resolve(f);if(c.children)return c.children.filter(m=>m.isFile&&!m.name.startsWith("lastSync")).sort().reverse().map(m=>({ref:m.name,created:this.n(m)}))}catch(c){if((0,d.$nk)(c)!==1)throw c}return[]}async resolveResourceContent(g,p,w,f){const c=this.j(g,w,f),h=(0,O.$ug)(c,p);try{return(await this.b.readFile(h)).value.toString()}catch(m){return this.f.error(m),null}}async writeResource(g,p,w,f,c){const h=this.j(g,f,c),m=(0,O.$ug)(h,`${(0,L.$bm)(w).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,N.$ae.fromString(p))}catch(S){this.f.error(S)}}j(g,p,w=this.a.userDataSyncHome){return(0,O.$ug)(w,...p?[p,g]:[g])}async m(g){try{try{if(!await this.b.exists(g))return}catch{return}const p=await this.b.resolve(g);if(p.children){const w=p.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort(),f=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let c=w.filter(m=>Date.now()-this.n(m)>f);const h=w.length-c.length;h<10&&(c=c.slice(10-h)),await D.Promises.settled(c.map(async m=>{this.f.info("Deleting from backup",m.resource.path),await this.b.del(m.resource)}))}}catch(p){this.f.error(p)}}n(g){return new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};e.$g5b=b,e.$g5b=b=ye([X(0,C.$Uh),X(1,d.$9j),X(2,I.$hi),X(3,E.$Ogb),X(4,P.$Ik)],b)}),define(oe[82],ae([0,1,3,2,6,27,176,14,11,4,24,43,21,25]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$ogb=e.$ngb=e.$mgb=void 0,e.$mgb=(0,d.$Nh)("IUserDataSyncMachinesService");const p="sync.currentMachineName",w="Safari",f="Chrome",c="Edge",h="Firefox",m="Android";function S(n){switch(n){case w:case f:case c:case h:case m:case(0,L.$i)(0):return!0}return!1}e.$ngb=S;function s(){return L.$G?w:L.$E?f:L.$H?c:L.$F?h:L.$I?m:(0,L.$i)(L.$p?0:L.$u)}let a=class extends N.$Rc{static{g=this}static{this.a=1}static{this.b="machines"}constructor(i,t,r,o,v,y){super(),this.h=r,this.j=o,this.m=v,this.n=y,this.c=this.B(new D.$Md),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$9o)(i,t,r)}async getMachines(i){const t=await this.f;return(await this.s(i)).machines.map(o=>({...o,isCurrent:o.id===t}))}async addCurrentMachine(i){const t=await this.f,r=await this.s(i);r.machines.some(({id:o})=>o===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:s()}),await this.t(r))}async removeCurrentMachine(i){const t=await this.f,r=await this.s(i),o=r.machines.filter(({id:v})=>v!==t);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(i,t,r){const o=await this.s(r),v=o.machines.find(({id:y})=>y===i);if(v){v.name=t,await this.t(o);const y=await this.f;i===y&&this.h.store(p,t,-1,1)}}async setEnablements(i){const t=await this.s();for(const[r,o]of i){const v=t.machines.find(y=>y.id===r);v&&(v.disabled=o?void 0:!0)}await this.t(t)}r(i){const t=this.h.get(p,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${s()} (${this.n.nameShort})`,o=new RegExp(`${(0,A.$Ee)(r)}\\s#(\\d+)`);let v=0;for(const y of i){const u=o.exec(y.name),$=u?parseInt(u[1]):0;v=$>v?$:v}return`${r} #${v+1}`}async s(i){this.g=await this.u(i);const t=this.w(this.g);if(t.version!==g.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return t}async t(i){const t=JSON.stringify(i),r=await this.j.writeResource(g.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(i){if(this.g){const t=i&&i.latest?i.latest[g.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(g.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.m.error(t)}return{version:g.a,machines:[]}}};e.$ogb=a,e.$ogb=a=g=ye([X(0,I.$Uh),X(1,C.$9j),X(2,b.$3o),X(3,l.$zgb),X(4,l.$Ogb),X(5,P.$nj)],a)}),define(oe[255],ae([0,1,5,63,38,8,3,2,6,19,10,173,24,21,22,25,79,82]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m5b=void 0;const c="sync.disableMachineEventually",h="sync.sessionId",m="sync.storeUrl",S="sync.productQuality";let s=class extends I.$Rc{get n(){const i=this.H.get(m,-1);return i?P.URI.parse(i):void 0}set n(i){i?this.H.store(m,i.toString(),-1,1):this.H.remove(m,-1)}get s(){return this.H.get(S,-1)}set s(i){i?this.H.store(S,i,-1,1):this.H.remove(S,-1)}constructor(i,t,r,o,v,y,u,$,j,M){super(),this.u=t,this.w=r,this.y=o,this.z=v,this.C=y,this.D=u,this.F=$,this.G=j,this.H=M,this.a=this.B(new I.$Sc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$Md),this.onError=this.h.event,this.S=[],this.f=this.B(new D.$Qg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,d.$ng)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(u.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(T=>this.triggerSync([T],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,T])=>T)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:t}=this.L();i?this.a.value===void 0&&(this.a.value=new a(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$bm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(h,-1),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),t)this.M(!1);else throw o}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const t=p.$Egb.toUserDataSyncError(i);t instanceof p.$Ggb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?C.$p&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(c,!0,-1,1),await(0,D.$Tg)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(c,-1,!1)}R(){this.H.remove(c,-1)}async triggerSync(i,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$m5b=s,e.$m5b=s=ye([X(0,b.$nj),X(1,p.$ygb),X(2,p.$zgb),X(3,p.$Jgb),X(4,p.$Kgb),X(5,p.$Ogb),X(6,w.$sCb),X(7,g.$al),X(8,f.$mgb),X(9,l.$3o)],s);class a extends I.$Rc{static{this.a="Interval"}constructor(i,t,r,o,v,y,u,$,j){super(),this.m=i,this.n=t,this.r=r,this.s=o,this.u=v,this.w=y,this.y=u,this.z=$,this.C=j,this.b=this.B(new I.$Sc),this.c=this.B(new O.$Md),this.onDidStartSync=this.c.event,this.f=this.B(new O.$Md),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,I.$Pc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(a.a,!1)}D(){this.b.value=(0,D.$Ug)(()=>{this.sync(a.a,!1),this.b.value=void 0},this.n)}sync(i,t){const r=(0,D.$Gg)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,A.$3)(v))return}return this.H(i,t,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,d.$ng)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!i&&(!(0,d.$ng)(t.defaultUrl,i.defaultUrl)||!(0,d.$ng)(t.insidersUrl,i.insidersUrl)||!(0,d.$ng)(t.stableUrl,i.stableUrl))}async H(i,t,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let o;try{await this.I(t,r)}catch(v){if(this.y.error(v),o=v,p.$Egb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),o=void 0}catch(y){this.y.error(y),o=y}}this.f.fire(o)}async I(i,t){if(this.h=await this.u.createSyncTask(this.g,i),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$Ggb((0,E.localize)(0,null),"DefaultServiceChanged"):new p.$Ggb((0,E.localize)(1,null),"ServiceChanged"):new p.$Ggb((0,E.localize)(2,null),"TurnedOff");const r=this.C.get(h,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$Ggb((0,E.localize)(3,null),"DefaultServiceChanged"):new p.$Ggb((0,E.localize)(4,null),"ServiceChanged"):new p.$Ggb((0,E.localize)(5,null),"SessionExpired");const o=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=o.find(u=>u.isCurrent);if(v?.disabled)throw new p.$Ggb((0,E.localize)(6,null),"TurnedOff");const y=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.s.manifest(null)}catch(u){throw new p.$Ggb((0,L.$yi)(u),u instanceof p.$Egb?u.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(h,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(oe[256],ae([0,1,10,177,14,11,43,21,28,25,17,39,119,118,117,20,120,115,116,4,121,41,27]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h,m,S,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$X5b=void 0;let n=class{static{a=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,o,v,y,u,$,j,M,T){this.e=t,this.f=r,this.g=o,this.h=y,this.i=u,this.j=$,this.k=j,this.l=M,this.n=T,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,m.$k5b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(o){const v=this.L(o,"profiles");return(0,m.$k5b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(o)return JSON.parse(o).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:y})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(t,r,o){return(await this.f.getAllResourceRefs(t,r?.collection,o)).map(({created:y,ref:u})=>({created:y,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:u,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),o=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const o=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,o);case"keybindings":return this.u(t,o);case"tasks":return this.w(t,o);case"snippets":return this.y(t,o);case"globalState":return this.D(t,o);case"extensions":return this.A(t,o);case"profiles":return this.G(t,o);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,O.$9o)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===a.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,o,v,y){if(t){const{content:u}=await this.M(r,v,o);return u}return this.f.resolveResourceContent(r,v,o,y)}q(t,r,o){const v=this.L(r,t);switch(t){case"settings":return this.t(v,o);case"keybindings":return this.v(v,o);case"tasks":return this.x(v,o);case"snippets":return this.z(v,o);case"globalState":return this.E(v,o);case"extensions":return this.B(v,o);case"profiles":return this.H(v,o);case"workspaceState":return null}}async r(t,r){const o=this.k.profiles.find(v=>v.id===r);if(!o)return null;switch(t){case"globalState":return this.F(o);case"extensions":return this.C(o);case"profiles":return this.I(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const o=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,l.$w3b)(t.content).settings}return null}u(t,r){const o=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,g.$t3b)(t.content,!!this.l.getValue(d.$sgb),this.g)}return null}w(t,r){const o=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,w.$E3b)(t.content,this.g)}return null}async y(t,r){const o=await this.resolveContent(t);if(o){const v=this.L(o,"snippets");if(v){const y=(0,b.$B3b)(v),u=[];for(const $ of Object.keys(y)){const j=this.d.joinPath(t,$),M=r?this.d.joinPath(r.snippetsHome,$):this.d.joinPath(t,a.a);u.push({resource:j,comparableResource:M})}return u}}return[]}z(t,r){return(0,b.$B3b)(t)[r]||null}A(t,r){const o=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,f.$o3b)((0,f.$n3b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(f.$q3b).getLocalExtensions(t);return(0,f.$o3b)(r,!0)}D(t,r){const o=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,c.$1Db)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(c.$3Db).getLocalGlobalState(t);return(0,c.$1Db)(r,!0)}G(t,r){const o=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,S.$TS)(JSON.parse(t.content),{})}return null}async I(t){return(0,m.$j5b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?a.b:a.c,o=[];return t.location&&(o.push(`scheme:${t.location.scheme}`),o.push(`authority:${t.location.authority}`),o.push((0,s.$He)(t.location.path,"/"))),o.push(`syncResource:${t.syncResource}`),o.push(`profile:${t.profile}`),t.collection&&o.push(`collection:${t.collection}`),t.ref&&o.push(`ref:${t.ref}`),t.node&&o.push(t.node),this.d.joinPath(D.URI.from({scheme:d.$Qgb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...o)}K(t){if(t.scheme!==d.$Qgb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const o=t.authority===a.b;let v,y;const u=[];let $,j,M,T,U;for(;r.length;){const q=r.shift();q.startsWith("scheme:")?v=q.substring(7):q.startsWith("authority:")?y=q.substring(10):q.startsWith("syncResource:")?$=q.substring(13):q.startsWith("profile:")?j=q.substring(8):q.startsWith("collection:")?M=q.substring(11):q.startsWith("ref:")?T=q.substring(4):$?U=q:u.push(q)}return{remote:o,syncResource:$,profile:j,collection:M,ref:T,node:U,location:v&&y!==void 0?this.d.joinPath(D.URI.from({scheme:v,authority:y,query:t.query,fragment:t.fragment,path:"/"}),...u):void 0}}L(t,r){try{const o=JSON.parse(t);if((0,E.$TDb)(o))return o}catch(o){this.g.error(o)}throw new d.$Egb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,o){const v=await this.e.resolveResourceContent(t,r,o);return{ref:r,content:v}}};e.$X5b=n,e.$X5b=n=a=ye([X(0,d.$zgb),X(1,d.$Agb),X(2,d.$Ogb),X(3,C.$Gk),X(4,L.$Uh),X(5,I.$3o),X(6,A.$9j),X(7,P.$Ik),X(8,p.$hi),X(9,h.$Mh)],n)}),define(oe[257],ae([0,1,18,5,26,38,3,2,19,12,32,20,29,11,4,21,22,17,115,116,117,118,119,120,121,25]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h,m,S,s,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l5b=void 0;const t="sync.lastSyncTime";let r=class extends I.$Rc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor($,j,M,T,U,q,Y,J,x,W,Q){super(),this.C=$,this.D=j,this.F=M,this.G=T,this.H=U,this.I=q,this.J=Y,this.L=J,this.M=x,this.N=W,this.O=Q,this.f="uninitialized",this.g=this.B(new O.$Md),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$Md),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$Md),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$Md),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$Md),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$Md),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$Md),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=M.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,I.$Pc)(()=>this.bb()))}async createSyncTask($,j){this.cb(),this.H.info("Sync started.");const M=new Date().getTime(),T=(0,P.$dg)();try{const J=(0,i.$Dgb)(T);j&&(J["Cache-Control"]="no-cache"),$=await this.D.manifest($,J)}catch(J){const x=i.$Egb.toUserDataSyncError(J);throw y(x,T,this.F,this.I),x}const U=!1,q=this;let Y;return{manifest:$,async run(){if(U)throw new Error("Can run a task only once");Y=(0,N.$Gg)(J=>q.P($,!1,T,J)),await Y.finally(()=>Y=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-M}ms`),q.$()},stop(){return Y?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new i.$Egb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const $=new Date().getTime(),j=(0,P.$dg)(),M=(0,i.$Dgb)(j);let T;try{T=await this.D.manifest(null,M)}catch(Y){const J=i.$Egb.toUserDataSyncError(Y);throw y(J,j,this.F,this.I),J}await this.resetLocal();const U=this,q=new L.$Wd;return{id:j,async merge(){return U.P(T,!0,j,q.token)},async apply(){try{try{await U.R(T,j,q.token)}catch(Y){if(i.$Egb.toUserDataSyncError(Y).code==="MethodNotFound")U.H.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.H.info("Applying manual sync again..."),await U.R(T,j,q.token);else throw Y}}catch(Y){throw U.H.error(Y),Y}U.H.info(`Sync done. Took ${new Date().getTime()-$}ms`),U.$()},async stop(){q.cancel(),await U.U(),await U.resetLocal()}}}async P($,j,M,T){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(U,$,j,M,T));const q=U.enabled.find(Y=>Y.resource==="profiles");if(q){const Y=await q.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.Q(Y,$,j,M,T)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q($,j,M,T,U){for(const q of $){if(U.isCancellationRequested)return;const Y=this.M.profiles.find(x=>x.id===q.id);if(!Y){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const J=this.getOrCreateActiveProfileSynchronizer(Y,q);this.n.push(...await this.S(J,j,M,T,U))}for(const[q,Y]of this.z.entries())this.M.profiles.some(J=>J.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(q))}async R($,j,M){const T=this.ab();for(const x of T){if(M.isCancellationRequested)return;await x.apply(j,M)}const U=T.find(x=>x.profile.isDefault);if(!U)return;const q=U.enabled.find(x=>x.resource==="profiles");if(!q)return;const J=(await q.getRemoteSyncedProfiles($?.latest??null)||[]).filter(x=>T.every(W=>W.profile.id!==x.id));J.length&&await this.Q(J,$,!1,j,M)}async S($,j,M,T,U){return(await $.sync(j,M,T,U)).map(([Y,J])=>({profile:$.profile,syncResource:Y,error:J}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map($=>$.stop()))}async resolveContent($){const j=await this.N.resolveContent($);if(j)return j;for(const M of this.ab())for(const T of M.enabled){const U=await T.resolveContent($);if(U)return U}return null}async replace($){this.cb();const j=this.N.resolveUserDataSyncResource($);if(!j)return;const M=await this.resolveContent($.uri);M&&await this.W(j.profile,async T=>{if(j.syncResource===T.resource)return await T.replace(M),!0})}async accept($,j,M,T){this.cb(),await this.W($.profile,async U=>{if($.syncResource===U.resource)return await U.accept(j,M),T&&await U.apply((0,d.$Df)(T)?!1:T.force,(0,i.$Dgb)((0,P.$dg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async j=>{if(j.resource!=="globalState"&&await j.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async j=>{if(await j.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch($){this.H.error($)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[$]of this.z.values())try{await $.resetLocal()}catch(j){this.H.error(j)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const $=await this.N.getRemoteSyncedProfiles(),j=$.map(q=>q.collection),M=await this.D.getAllCollections(),T=M.filter(q=>!j.includes(q));T.length&&(this.H.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const U=$.filter(q=>M.includes(q.collection));if(U.length!==$.length){const q=this.G.createInstance(n.$i5b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(U,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData($){this.cb();const j=await this.D.getActivityData();await this.C.writeFile($,j)}async extractActivityData($,j){const M=(await this.C.readFile($)).value.toString(),T=JSON.parse(M);if(T.resources)for(const U in T.resources)for(const q of T.resources[U])await this.O.writeResource(U,q.content,new Date(q.created*1e3),void 0,j);if(T.collections)for(const U in T.collections)for(const q in T.collections[U].resources)for(const Y of T.collections[U].resources?.[q]??[])await this.O.writeResource(q,Y.content,new Date(Y.created*1e3),U,j)}async W($,j){const M=new I.$Qc;try{const T=this.z.get($.id);if(T){const x=await this.X(T[0],j,M);return(0,d.$Ef)(x)?null:x}if($.isDefault){const x=M.add(this.G.createInstance(o,$,void 0)),W=await this.X(x,j,M);return(0,d.$Ef)(W)?null:W}if(this.M.isEnabled())return null;const U=M.add(this.G.createInstance(n.$i5b,$,void 0)),q=await this.D.manifest(null),J=(await U.getRemoteSyncedProfiles(q?.latest??null)||[]).find(x=>x.id===$.id);if(J){const x=M.add(this.G.createInstance(o,$,J.collection)),W=await this.X(x,j,M);return(0,d.$Ef)(W)?null:W}return null}finally{M.dispose()}}async X($,j,M){const T=[...$.enabled,...$.disabled.reduce((U,q)=>(q!=="workspaceState"&&U.push(M.add($.createSynchronizer(q))),U),[])];for(const U of T){const q=await j(U);if(!(0,d.$Ef)(q))return q}}Y($){const j=this.f;this.f!==$&&(this.f=$,this.g.fire($),j==="hasConflicts"&&this.$())}Z(){const $=this.ab().map(j=>j.conflicts).flat();(0,D.$tb)(this.j,$,(j,M)=>j.profile.id===M.profile.id&&j.syncResource===M.syncResource&&(0,D.$tb)(j.conflicts,M.conflicts,(T,U)=>(0,C.$ng)(T.previewResource,U.previewResource)))||(this.j=$,this.m.fire($))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer($,j){let M=this.z.get($.id);if(M&&M[0].collection!==j?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),M[1].dispose(),M=void 0,this.z.delete($.id)),!M){const T=new I.$Qc,U=T.add(this.G.createInstance(o,$,j?.collection));T.add(U.onDidChangeStatus(q=>this.Y(q))),T.add(U.onDidChangeConflicts(q=>this.Z())),T.add(U.onDidChangeLocal(q=>this.h.fire(q))),this.z.set($.id,M=[U,T])}return M[0]}ab(){const $=[];for(const[j]of this.z.values())$.push(j);return $}bb(){this.z.forEach(([,$])=>$.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$l5b=r,e.$l5b=r=ye([X(0,l.$9j),X(1,i.$zgb),X(2,i.$ygb),X(3,g.$Mh),X(4,i.$Ogb),X(5,w.$al),X(6,p.$3o),X(7,i.$Jgb),X(8,f.$Ik),X(9,i.$Lgb),X(10,i.$Agb)],r);let o=class extends I.$Rc{get enabled(){return this.f.sort(($,j)=>$[1]-j[1]).map(([$])=>$)}get disabled(){return i.$vgb.filter($=>!this.r.isResourceEnabled($))}get status(){return this.g}get conflicts(){return this.m}constructor($,j,M,T,U,q,Y,J,x,W){super(),this.profile=$,this.collection=j,this.r=M,this.t=T,this.u=U,this.w=q,this.y=Y,this.z=J,this.C=x,this.D=W,this.f=[],this.g="idle",this.h=this.B(new O.$Md),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$Md),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$Md),this.onDidChangeConflicts=this.n.event,this.B(M.onDidChangeResourceEnablement(([Q,H])=>this.F(Q,H))),this.B((0,I.$Pc)(()=>this.f.splice(0,this.f.length).forEach(([,,Q])=>Q.dispose())));for(const Q of i.$vgb)M.isResourceEnabled(Q)&&this.G(Q)}F($,j){j?this.G($):this.H($)}G($){if(this.f.some(([U])=>U.resource===$))return;if($==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if($==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||$==="workspaceState")return;if($!=="profiles"&&this.profile.useDefaultFlags?.[$]){this.z.debug(`Skipping syncing ${$} in ${this.profile.name} because it is already synced by default profile`);return}const j=new I.$Qc,M=j.add(this.createSynchronizer($));j.add(M.onDidChangeStatus(()=>this.L())),j.add(M.onDidChangeConflicts(()=>this.M())),j.add(M.onDidChangeLocal(()=>this.j.fire($)));const T=this.N($);this.f.push([M,T,j])}H($){const j=this.f.findIndex(([M])=>M.resource===$);if(j!==-1){const[[M,,T]]=this.f.splice(j,1);T.dispose(),this.L(),Promise.allSettled([M.stop(),M.resetLocal()]).then(null,U=>this.z.error(U))}}createSynchronizer($){switch($){case"settings":return this.t.createInstance(S.$x3b,this.profile,this.collection);case"keybindings":return this.t.createInstance(m.$u3b,this.profile,this.collection);case"snippets":return this.t.createInstance(s.$C3b,this.profile,this.collection);case"tasks":return this.t.createInstance(a.$F3b,this.profile,this.collection);case"globalState":return this.t.createInstance(h.$2Db,this.profile,this.collection);case"extensions":return this.t.createInstance(c.$p3b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$i5b,this.profile,this.collection)}}async sync($,j,M,T){if(T.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const q=[],Y=(0,i.$Dgb)(M),J=(this.collection?$?.collections?.[this.collection]?.latest:$?.latest)??null,x=j?await this.I(J):{};for(const W of U){if(T.isCancellationRequested)return[];if(!this.r.isResourceEnabled(W.resource))return[];try{if(j){const Q=await W.preview(J,x,Y);if(Q)for(const H of Q.resourcePreviews)(H.localChange!==0||H.remoteChange!==0)&&H.mergeState==="preview"&&await W.merge(H.previewResource)}else await W.sync(J,Y)}catch(Q){const H=i.$Egb.toUserDataSyncError(Q);if(y(H,M,this.w,this.y),v(Q))throw H;this.z.error(Q),this.z.error(`${W.resource}: ${(0,A.$yi)(Q)}`),q.push([W.resource,H])}}return q}finally{this.L()}}async apply($,j){const M=(0,i.$Dgb)($);for(const T of this.enabled){if(j.isCancellationRequested)return;try{await T.apply(!1,M)}catch(U){const q=i.$Egb.toUserDataSyncError(U);if(y(q,$,this.w,this.y),v(U))throw q;this.z.error(U),this.z.error(`${T.resource}: ${(0,A.$yi)(U)}`)}}}async stop(){for(const $ of this.enabled)try{$.status!=="idle"&&await $.stop()}catch(j){this.z.error(j)}}async resetLocal(){for(const $ of this.enabled)try{await $.resetLocal()}catch(j){this.z.error(`${$.resource}: ${(0,A.$yi)(j)}`),this.z.error(j)}}async I($){if(!this.profile.isDefault)return{};const j=this.D.getValue(i.$rgb),M=this.enabled.find(T=>T instanceof S.$x3b);if(M){const T=await M.getRemoteUserDataSyncConfiguration($);return{...j,...T}}return j}J($){this.g!==$&&(this.g=$,this.h.fire($))}L(){return this.M(),this.enabled.some($=>$.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some($=>$.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const $=this.enabled.filter(j=>j.status==="hasConflicts").filter(j=>j.conflicts.conflicts.length>0).map(j=>j.conflicts);(0,D.$tb)(this.m,$,(j,M)=>j.syncResource===M.syncResource&&(0,D.$tb)(j.conflicts,M.conflicts,(T,U)=>(0,C.$ng)(T.previewResource,U.previewResource)))||(this.m=$,this.n.fire($))}N($){switch($){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=ye([X(2,i.$Jgb),X(3,g.$Mh),X(4,b.$7n),X(5,i.$ygb),X(6,w.$al),X(7,i.$Ogb),X(8,f.$Ik),X(9,E.$hi)],o);function v(u){if(u instanceof i.$Egb)switch(u.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function y(u,$,j,M){M.publicLog2("sync/error",{code:u.code,serverCode:u instanceof i.$Fgb?String(u.serverCode):void 0,url:u instanceof i.$Fgb?u.url:void 0,resource:u.resource,executionId:$,service:j.userDataSyncStore.url.toString()})}}),define(oe[258],ae([0,1,3,2,10,17,25]),function(te,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D8b=e.$C8b=void 0;function I(b,l){return{...b,profile:(0,A.$Jk)(b.profile,l.profilesHome.scheme)}}function C(b){return{created:b.created,uri:L.URI.revive(b.uri)}}class d{constructor(l,g,p){this.c=l,this.d=g,this.f=p,this.a=new Map,this.b=new D.$Md}listen(l,g){switch(g){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${g}`)}async call(l,g,p){try{return await this.g(l,g,p)}catch(w){throw this.f.error(w),w}}async g(l,g,p){switch(g){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(p[0]));case"accept":return this.c.accept(I(p[0],this.d),L.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(C(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(p[0]),L.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if(g.startsWith("manualSync/")){const w=g.substring(11),f=p[0],c=this.h(f);switch(p=p.slice(1),w){case"merge":return c.merge();case"apply":return c.apply().then(()=>this.a.delete(this.j(c.id)));case"stop":return c.stop().finally(()=>this.a.delete(this.j(c.id)))}}throw new Error("Invalid call")}h(l){const g=this.a.get(this.j(l));if(!g)throw new Error(`Manual sync taks not found: ${l}`);return g}async i(){const l=await this.c.createManualSyncTask();return this.a.set(this.j(l.id),l),l.id}j(l){return`manualSyncTask-${l}`}}e.$C8b=d;let P=class extends N.$Rc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(l,g){super(),this.n=g,this.b="uninitialized",this.c=this.B(new D.$Md),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.$Md),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new D.$Md),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new D.$Md),this.onSyncErrors=this.m.event,this.a={call(p,w,f){return l.call(p,w,f).then(null,c=>{throw O.$Egb.toUserDataSyncError(c)})},listen(p,w){return l.listen(p,w)}},this.a.call("_getInitialData").then(([p,w,f])=>{this.s(p),this.t(w),f&&this.u(f),this.B(this.a.listen("onDidChangeStatus")(c=>this.s(c))),this.B(this.a.listen("onDidChangeLastSyncTime")(c=>this.u(c)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(w=>({...w,error:O.$Egb.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.a.call("createManualSyncTask"),g=this;return new E(l,{async call(w,f,c){return g.a.call(`manualSync/${w}`,[l,...Array.isArray(f)?f:[f]],c)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(l,g,p,w){return this.a.call("accept",[l,g,p,w])}resolveContent(l){return this.a.call("resolveContent",[l])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(l){return this.a.call("replace",[l])}saveRemoteActivityData(l){return this.a.call("getRemoteActivityData",[l])}extractActivityData(l,g){return this.a.call("extractActivityData",[l,g])}async s(l){this.b=l,this.c.fire(l)}async t(l){this.f=l.map(g=>({syncResource:g.syncResource,profile:(0,A.$Jk)(g.profile,this.n.profilesHome.scheme),conflicts:g.conflicts.map(p=>({...p,baseResource:L.URI.revive(p.baseResource),localResource:L.URI.revive(p.localResource),remoteResource:L.URI.revive(p.remoteResource),previewResource:L.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(l){this.h!==l&&(this.h=l,this.j.fire(l))}};e.$D8b=P,e.$D8b=P=ye([X(1,A.$Ik)],P);class E extends N.$Rc{constructor(l,g){super(),this.id=l,this.a=g}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[259],ae([0,1,5,26,8,3,2,141,6,19,12,10,32,20,14,11,24,57,43,21,25]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RDb=e.$QDb=e.$PDb=e.$ODb=e.$NDb=void 0;const S="configurationSync.store",s="sync.previous.store",a="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let o=class extends O.$Rc{get userDataSyncStore(){return this.b}get c(){return this.h.get(m.$Hgb,-1)}set c(M){this.h.store(m.$Hgb,M,-1,C.$p?0:1)}constructor(M,T,U){super(),this.f=M,this.g=T,this.h=U,this.a=this.B(new A.$Md),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new O.$Qc);this.B(A.Event.filter(U.onDidChangeValue(-1,m.$Hgb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[S]),this.a.fire()}m(M){if(M&&(M=C.$p&&M.web?{...M,...M.web}:M,(0,P.$xf)(M.url)&&(0,P.$zf)(M.authenticationProviders)&&Object.keys(M.authenticationProviders).every(T=>Array.isArray(M.authenticationProviders[T].scopes)))){const T=M,U=!!T.canSwitch,q=T.url===T.insidersUrl?"insiders":"stable",Y=(U?this.c:void 0)||q,J=Y==="insiders"?T.insidersUrl:Y==="stable"?T.stableUrl:T.url;return{url:E.URI.parse(J),type:Y,defaultType:q,defaultUrl:E.URI.parse(T.url),stableUrl:E.URI.parse(T.stableUrl),insidersUrl:E.URI.parse(T.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(T.authenticationProviders).reduce((x,W)=>(x.push({id:W,scopes:T.authenticationProviders[W].scopes}),x),[])}}}};e.$NDb=o,e.$NDb=o=ye([X(0,w.$nj),X(1,l.$hi),X(2,h.$3o)],o);let v=class extends o{constructor(M,T,U){super(M,T,U);const q=this.h.get(s,-1);q&&(this.n=JSON.parse(q));const Y=this.f[S];Y?this.h.store(s,JSON.stringify(Y),-1,1):this.h.remove(s,-1)}async switch(M){M!==this.c&&(this.c=M,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$ODb=v,e.$ODb=v=ye([X(0,w.$nj),X(1,l.$hi),X(2,h.$3o)],v);let y=class extends O.$Rc{get donotMakeRequestsUntil(){return this.j}constructor(M,T,U,q,Y,J,x){super(),this.n=U,this.r=q,this.s=x,this.g=this.B(new A.$Md),this.onTokenFailed=this.g.event,this.h=this.B(new A.$Md),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$Md),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(M),this.c=(0,c.$9o)(Y,J,x).then(W=>{const Q={"X-Client-Name":`${T.applicationName}${C.$p?"-web":""}`,"X-Client-Version":T.version};return T.commit&&(Q["X-Client-Commit"]=T.commit),Q}),this.f=new $(t,r,this.n,this.r),this.u(),this.B((0,O.$Pc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(M,T){this.b={token:M,type:T}}t(M){this.a=M?(0,d.$ug)(M,"v1"):void 0}u(){const M=this.s.getNumber(a,-1);M&&Date.now()<M&&this.y(new Date(M))}y(M){this.j?.getTime()!==M?.getTime()&&(this.j=M,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(a,this.j.getTime(),-1,1),this.w=(0,D.$Gg)(T=>(0,D.$Tg)(this.j.getTime()-Date.now(),T).then(()=>this.y(void 0))),this.w.then(null,T=>null)):this.s.remove(a,-1),this.m.fire())}async getAllCollections(M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$ug)(this.a,"collection").toString();M={...M},M["Content-Type"]="application/json";const U=await this.D(T,{type:"GET",headers:M},[],N.CancellationToken.None);return(await(0,f.$Vo)(U))?.map(({id:q})=>q)||[]}async createCollection(M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$ug)(this.a,"collection").toString();M={...M},M["Content-Type"]=I.$Mr.text;const U=await this.D(T,{type:"POST",headers:M},[],N.CancellationToken.None),q=await(0,f.$Uo)(U);if(!q)throw new m.$Fgb("Server did not return the collection id",T,"NoCollection",U.res.statusCode,U.res.headers[m.$Bgb]);return q}async deleteCollection(M,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=M?(0,d.$ug)(this.a,"collection",M).toString():(0,d.$ug)(this.a,"collection").toString();T={...T},await this.D(U,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async getAllResourceRefs(M,T){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,T,M),q={},Y=await this.D(U.toString(),{type:"GET",headers:q},[],N.CancellationToken.None);return(await(0,f.$Vo)(Y)||[]).map(({url:x,created:W})=>({ref:(0,d.$wg)(U,U.with({path:x})),created:W*1e3}))}async resolveResourceContent(M,T,U,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,d.$ug)(this.z(this.a,U,M),T).toString();q={...q},q["Cache-Control"]="no-cache";const J=await this.D(Y,{type:"GET",headers:q},[],N.CancellationToken.None);return await(0,f.$Uo)(J)}async deleteResource(M,T,U){if(!this.a)throw new Error("No settings sync store url configured.");const q=T!==null?(0,d.$ug)(this.z(this.a,U,M),T).toString():this.z(this.a,U,M).toString(),Y={};await this.D(q,{type:"DELETE",headers:Y},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$ug)(this.a,"resource").toString(),T={"Content-Type":I.$Mr.text};await this.D(M,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async readResource(M,T,U,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,d.$ug)(this.z(this.a,U,M),"latest").toString();q={...q},q["Cache-Control"]="no-cache",T&&(q["If-None-Match"]=T.ref);const J=await this.D(Y,{type:"GET",headers:q},[304],N.CancellationToken.None);let x=null;if(J.res.statusCode===304&&(x=T),x===null){const W=J.res.headers.etag;if(!W)throw new m.$Fgb("Server did not return the ref",Y,"NoRef",J.res.statusCode,J.res.headers[m.$Bgb]);const Q=await(0,f.$Uo)(J);if(!Q&&J.res.statusCode===304)throw new m.$Fgb("Empty response",Y,"EmptyResponse",J.res.statusCode,J.res.headers[m.$Bgb]);x={ref:W,content:Q}}return x}async writeResource(M,T,U,q,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=this.z(this.a,q,M).toString();Y={...Y},Y["Content-Type"]=I.$Mr.text,U&&(Y["If-Match"]=U);const x=await this.D(J,{type:"POST",data:T,headers:Y},[],N.CancellationToken.None),W=x.res.headers.etag;if(!W)throw new m.$Fgb("Server did not return the ref",J,"NoRef",x.res.statusCode,x.res.headers[m.$Bgb]);return W}async manifest(M,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,d.$ug)(this.a,"manifest").toString();T={...T},T["Content-Type"]="application/json",M&&(T["If-None-Match"]=M.ref);const q=await this.D(U,{type:"GET",headers:T},[304],N.CancellationToken.None);let Y=null;if(q.res.statusCode===304&&(Y=M),!Y){const x=q.res.headers.etag;if(!x)throw new m.$Fgb("Server did not return the ref",U,"NoRef",q.res.statusCode,q.res.headers[m.$Bgb]);const W=await(0,f.$Uo)(q);if(!W&&q.res.statusCode===304)throw new m.$Fgb("Empty response",U,"EmptyResponse",q.res.statusCode,q.res.headers[m.$Bgb]);W&&(Y={...JSON.parse(W),ref:x})}const J=this.s.get(n,-1);return J&&Y&&J!==Y.session&&this.C(),Y===null&&J&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$ug)(this.a,"download").toString(),T={},U=await this.D(M,{type:"GET",headers:T},[],N.CancellationToken.None);if(!(0,f.$Ro)(U))throw new m.$Fgb("Server returned "+U.res.statusCode,M,"EmptyResponse",U.res.statusCode,U.res.headers[m.$Bgb]);if((0,f.$So)(U))throw new m.$Fgb("Empty response",M,"EmptyResponse",U.res.statusCode,U.res.headers[m.$Bgb]);return U.stream}z(M,T,U){return T?(0,d.$ug)(M,"collection",T,"resource",U):(0,d.$ug)(M,"resource",U)}C(){this.s.remove(n,-1),this.s.remove(i,-1)}async D(M,T,U,q){if(!this.b)throw new m.$Fgb("No Auth Token Available",M,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new m.$Fgb(`${T.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;T.headers={...T.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(T.headers),this.r.trace("Sending request to server",{url:M,type:T.type,headers:{...T.headers,authorization:void 0}});let J;try{J=await this.f.request(M,T,q)}catch(V){if(!(V instanceof m.$Fgb)){let ee="RequestFailed";const ne=(0,L.$9)(V).toLowerCase();ne.includes("xhr timeout")?ee="RequestTimeout":ne.includes("protocol")&&ne.includes("not supported")?ee="RequestProtocolNotSupported":ne.includes("request path contains unescaped characters")?ee="RequestPathNotEscaped":ne.includes("headers must be an object")?ee="RequestHeadersNotObject":(0,L.$3)(V)&&(ee="RequestCanceled"),V=new m.$Fgb(`Connection refused for the request '${M}'.`,M,ee,void 0,void 0)}throw this.r.info("Request failed",M),V}const x=J.res.headers[m.$Bgb],W={url:M,status:J.res.statusCode,"execution-id":T.headers[m.$Cgb],"operation-id":x},Q=(0,f.$Ro)(J)||J.res.statusCode&&U.includes(J.res.statusCode);let H="";if(Q?this.r.trace("Request succeeded",W):(H=await(0,f.$To)(J)||"",this.r.info("Request failed",W,H)),J.res.statusCode===401||J.res.statusCode===403){if(this.b=void 0,J.res.statusCode===401)throw this.g.fire("Unauthorized"),new m.$Fgb(`${T.type} request '${M}' failed because of Unauthorized (401).`,M,"Unauthorized",J.res.statusCode,x);if(J.res.statusCode===403)throw this.g.fire("Forbidden"),new m.$Fgb(`${T.type} request '${M}' failed because the access is forbidden (403).`,M,"Forbidden",J.res.statusCode,x)}if(this.h.fire(),J.res.statusCode===404)throw new m.$Fgb(`${T.type} request '${M}' failed because the requested resource is not found (404).`,M,"NotFound",J.res.statusCode,x);if(J.res.statusCode===405)throw new m.$Fgb(`${T.type} request '${M}' failed because the requested endpoint is not found (405). ${H}`,M,"MethodNotFound",J.res.statusCode,x);if(J.res.statusCode===409)throw new m.$Fgb(`${T.type} request '${M}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,M,"Conflict",J.res.statusCode,x);if(J.res.statusCode===410)throw new m.$Fgb(`${T.type} request '${M}' failed because the requested resource is not longer available (410).`,M,"Gone",J.res.statusCode,x);if(J.res.statusCode===412)throw new m.$Fgb(`${T.type} request '${M}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,M,"PreconditionFailed",J.res.statusCode,x);if(J.res.statusCode===413)throw new m.$Fgb(`${T.type} request '${M}' failed because of too large payload (413).`,M,"TooLarge",J.res.statusCode,x);if(J.res.statusCode===426)throw new m.$Fgb(`${T.type} request '${M}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,M,"UpgradeRequired",J.res.statusCode,x);if(J.res.statusCode===429){const V=J.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new m.$Fgb(`${T.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",J.res.statusCode,x)):new m.$Fgb(`${T.type} request '${M}' failed because of too many requests (429).`,M,"RemoteTooManyRequests",J.res.statusCode,x)}if(!Q)throw new m.$Fgb("Server returned "+J.res.statusCode,M,"Unknown",J.res.statusCode,x);return J}F(M){let T=this.s.get(i,-1);T===void 0&&(T=(0,b.$dg)(),this.s.store(i,T,-1,1)),M["X-Machine-Session-Id"]=T;const U=this.s.get(n,-1);U!==void 0&&(M["X-User-Session-Id"]=U)}};e.$PDb=y,e.$PDb=y=ye([X(1,w.$nj),X(2,f.$Po),X(3,m.$Ogb),X(4,g.$Uh),X(5,p.$9j),X(6,h.$3o)],y);let u=class extends y{constructor(M,T,U,q,Y,J,x){super(M.userDataSyncStore?.url,T,U,q,Y,J,x),this.B(M.onDidChangeUserDataSyncStore(()=>this.t(M.userDataSyncStore?.url)))}};e.$QDb=u,e.$QDb=u=ye([X(0,m.$ygb),X(1,w.$nj),X(2,f.$Po),X(3,m.$Ogb),X(4,g.$Uh),X(5,p.$9j),X(6,h.$3o)],u);class ${constructor(M,T,U,q){this.c=M,this.d=T,this.f=U,this.g=q,this.a=[],this.b=void 0}request(M,T,U){if(this.h()&&this.i(),T.url=M,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new m.$Fgb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,M,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(M),this.f.request(T,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$RDb=$}),define(oe[260],ae([0,1,3,55,24,21,22,255,25,79,82]),function(te,e,D,N,L,A,O,I,C,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X8b=void 0;let E=class extends I.$m5b{constructor(l,g,p,w,f,c,h,m,S,s,a){super(l,g,p,w,f,h,m,S,s,a),this.B(D.Event.debounce(D.Event.any(D.Event.map(c.onDidFocusWindow,()=>"windowFocus"),D.Event.map(c.onDidOpenWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$X8b=E,e.$X8b=E=ye([X(0,L.$nj),X(1,C.$ygb),X(2,C.$zgb),X(3,C.$Jgb),X(4,C.$Kgb),X(5,N.$M6b),X(6,C.$Ogb),X(7,d.$sCb),X(8,O.$al),X(9,P.$mgb),X(10,A.$3o)],E)}),define(oe[261],ae([0,1,70,23,6,19]),function(te,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o6b=e.$n6b=e.$m6b=e.$l6b=void 0,e.$l6b=128/4;function O(d){function P(){let E=d.scheme===N.Schemas.file?(0,A.$ig)(d):d.toString();return L.$l||(E=E.toLowerCase()),(0,D.createHash)("md5").update(E).digest("hex")}return{id:P(),configPath:d}}e.$m6b=O;function I(d,P){function E(){if(d.scheme!==N.Schemas.file)return(0,D.createHash)("md5").update(d.toString()).digest("hex");if(!P)return;let l;return L.$l?l=P.ino:L.$k?l=P.birthtime.getTime():L.$j&&(typeof P.birthtimeMs=="number"?l=Math.floor(P.birthtimeMs):l=P.birthtime.getTime()),(0,D.createHash)("md5").update(d.fsPath).update(l?String(l):"").digest("hex")}const b=E();if(typeof b=="string")return{id:b,uri:d}}e.$n6b=I;function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$o6b=C}),define(oe[262],ae([0,1,5,8,2,16,31,14,7,76,113,261,55,72,23]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r8b=void 0;let p=class extends L.$Rc{constructor(f,c,h,m){super(),this.a=f,this.b=c,this.c=h,this.f=m,this.B(new D.$5g(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=this.a.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,c=await O.Promises.readdir(f),h=new d.$4Cb(this.f.getChannel("storage"));await Promise.all(c.map(async m=>{const S=(0,A.$ic)(f,m);m.length===E.$l6b||m===P.$Zh.id||(await this.c.getWindows()).some(n=>n.workspace?.id===m)||await h.isUsed(S)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await O.Promises.rm(S))}))}catch(f){(0,N.$Z)(f)}}};e.$r8b=p,e.$r8b=p=ye([X(0,I.$Vh),X(1,C.$8i),X(2,b.$M6b),X(3,l.$37b)],p)}),define(oe[83],ae([0,1,53,5,16,12,31,148,273,274]),function(te,e,D,N,L,A,O,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.zip=e.$ip=e.$hp=void 0,e.$hp="end of central directory record signature not found";const P=new RegExp(e.$hp);class E extends Error{constructor(a,n){let i=n.message;switch(a){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=a,this.cause=n}}e.$ip=E;function b(s){const a=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>a&n).reduce((n,i)=>n+i,a&61440)}function l(s){if(s instanceof E)return s;let a;return P.test(s.message)&&(a="CorruptZip"),new E(a,s)}function g(s,a,n,i,t,r){const o=L.$lc(a),v=L.$ic(i,o);if(!v.startsWith(i))return Promise.reject(new Error(I.localize(0,null,a)));const y=L.$ic(i,a);let u;return r.onCancellationRequested(()=>{u?.destroy()}),Promise.resolve(O.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise(($,j)=>{if(!r.isCancellationRequested)try{u=(0,D.createWriteStream)(y,{mode:n}),u.once("close",()=>$()),u.once("error",j),s.once("error",j),s.pipe(u)}catch(M){j(M)}}))}function p(s,a,n,i){let t=(0,N.$Gg)(()=>Promise.resolve()),r=0;const o=i.onCancellationRequested(()=>{t.cancel(),s.close()});return new Promise((v,y)=>{const u=new N.$Ng,$=j=>{j.isCancellationRequested||(r++,s.readEntry())};s.once("error",y),s.once("close",()=>t.then(()=>{i.isCancellationRequested||s.entryCount===r?v():y(new E("Incomplete",new Error(I.localize(1,null,r,s.entryCount))))},y)),s.readEntry(),s.on("entry",j=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(j.fileName)){$(i);return}const M=j.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(M)){const q=L.$ic(a,M);t=(0,N.$Gg)(Y=>O.Promises.mkdir(q,{recursive:!0}).then(()=>$(Y)).then(void 0,y));return}const T=f(s,j),U=b(j);t=(0,N.$Gg)(q=>u.queue(()=>T.then(Y=>g(Y,M,U,a,n,q).then(()=>$(q)))).then(null,y))})}).finally(()=>o.dispose())}function w(s,a=!1){return new Promise((n,i)=>{(0,C.open)(s,a?{lazyEntries:!0}:void 0,(t,r)=>{t?i(l(t)):n((0,A.$If)(r))})})}function f(s,a){return new Promise((n,i)=>{s.openReadStream(a,(t,r)=>{t?i(l(t)):n((0,A.$If)(r))})})}function c(s,a){return new Promise((n,i)=>{const t=new d.ZipFile;a.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const r=(0,D.createWriteStream)(s);t.outputStream.pipe(r),t.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>n(s))})}e.zip=c;function h(s,a,n={},i){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=w(s,!0);return n.overwrite&&(r=r.then(o=>O.Promises.rm(a).then(()=>o))),r.then(o=>p(o,a,{sourcePathRegex:t},i))}e.$kp=h;function m(s,a){return w(s).then(n=>new Promise((i,t)=>{n.on("entry",r=>{r.fileName===a&&f(n,r).then(o=>i(o),o=>t(o))}),n.once("close",()=>t(new Error(I.localize(2,null,a))))}))}function S(s,a){return m(s,a).then(n=>new Promise((i,t)=>{const r=[];n.once("error",t),n.on("data",o=>r.push(o)),n.on("end",()=>i(Buffer.concat(r)))}))}e.$lp=S}),define(oe[263],ae([0,1,5,8,2,23,19,54,12,32,31,83,20,14,29,33,97,11,7]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;let m=class extends L.$Rc{static{h=this}static{this.c=".sigzip"}constructor(s,a,n,i,t,r){super(),this.h=a,this.j=n,this.m=i,this.n=t,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,a,n){await this.g;const i=(0,O.$ug)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,a))}catch(r){throw new g.$8n(r.message,g.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(s)){const r=await this.u(s);try{t=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===c.LogLevel.Trace)}catch(o){const v=o;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${v.output}`),t===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new g.$8n(E.$hp,g.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(o){this.r.error(o)}}}return t===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}t(s){if(!s.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,C.$Df)(a)?a:!0}async u(s){await this.g;const a=(0,O.$ug)(this.extensionsDownloadDir,`${this.z(s)}${h.c}`);return await this.w(s,a,n=>this.j.downloadSignatureArchive(s,n)),a}async w(s,a,n){if(await this.h.exists(a))return;if(a.scheme!==A.Schemas.file){await n(a);return}const i=(0,O.$ug)(this.extensionsDownloadDir,`.${(0,d.$dg)()}`);await this.h.exists(i)||await n(i);try{await P.Promises.rename(i.fsPath,a.fsPath,2*60*1e3)}catch(t){try{await this.h.del(i)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,N.$9)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const a=[],n=[],i=[];for(const o of s.children)if(o.name.endsWith(h.c))i.push(o.resource);else{const v=p.$xo.parse(o.name);v&&n.push([v,o])}const t=(0,p.$Co)(n,([o])=>o),r=[];for(const o of t)o.sort((v,y)=>I.rcompare(v[0].version,y[0].version)),a.push(...o.slice(1).map(v=>v[1].resource)),r.push(o[0][1]);r.sort((o,v)=>o.mtime-v.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),a.push(...i),await D.Promises.settled(a.map(o=>(this.r.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(s){this.r.error(s)}}z(s){return this.f?p.$xo.create(s).toString().toLowerCase():(0,d.$dg)()}};e.$Ap=m,e.$Ap=m=h=ye([X(0,l.$Vh),X(1,f.$9j),X(2,g.$7n),X(3,b.$hi),X(4,w.$bp),X(5,c.$8i)],m)}),define(oe[264],ae([0,1,83,157]),function(te,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;function L(A){return(0,D.$lp)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$Cp=L}),define(oe[122],ae([0,1,5,15,26,38,8,3,52,2,34,23,16,19,54,12,10,32,31,83,156,96,14,243,29,33,51,80,263,244,264,212,223,68,11,4,7,24,22,28,17]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h,m,S,s,a,n,i,t,r,o,v,y,u,$,j,M,T,U,q,Y,J,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=void 0,e.$Fp=(0,T.$Oh)(n.$9n);const W=".vsctmp";let Q=class extends a.$mp{constructor(K,B,k,R,z,F,G,Z,re,le,ue,he){super(K,B,ue,k,le,he),this.fb=z,this.gb=F,this.hb=G,this.ib=re,this.eb=new Map,this.rb=new P.$Ac;const $e=this.B(Z.createInstance(v.$Bp));this.bb=this.B(Z.createInstance(H,we=>$e.postUninstall(we))),this.cb=this.B(new u.$Dp(he,re,ue,this,this.F)),this.db=this.B(Z.createInstance(o.$Ap));const de=this.B(new $.$Ep(this,this.fb,he,F,ue,re,k));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Ho)(this.ib,this.F)),this.jb}async zip(K){this.F.trace("ExtensionManagementService#zip",K.identifier.id);const B=await this.pb(K),k=await(0,h.zip)((0,l.$ug)(this.db.extensionsDownloadDir,(0,f.$dg)()).fsPath,B);return w.URI.file(k)}async unzip(K){return this.F.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:B,cleanup:k}=await this.lb(K),R=b.$jc(B.fsPath);try{return await(0,y.$Cp)(R)}finally{await k()}}getInstalled(K,B=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(K??null,B)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.bb.scanUserExtensionAtLocation(K)}async install(K,B={}){this.F.trace("ExtensionManagementService#install",K.toString());const{location:k,cleanup:R}=await this.lb(K);try{const z=await(0,y.$Cp)(b.$jc(k.fsPath)),F=(0,i.$Bo)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,j.$Oo)(z.engines.vscode,this.G.version,this.G.date))throw new Error(m.localize(0,null,F,this.G.version));const Z=(await this.I([{manifest:z,extension:k,options:B}])).find(({identifier:re})=>(0,i.$wo)(re,{id:F}));if(Z?.local)return Z.local;throw Z?.error?Z.error:(0,a.$op)(new Error(`Unknown error while installing extension ${F}`))}finally{await R()}}async installFromLocation(K,B){this.F.trace("ExtensionManagementService#installFromLocation",K.toString());const k=await this.bb.scanUserExtensionAtLocation(K);if(!k)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.ub([[k,void 0]],B),this.F.info("Successfully installed extension",k.identifier.id,B.toString()),k}async installExtensionsFromProfile(K,B,k){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",K,B.toString(),k.toString());const R=(await this.bb.scanExtensions(1,B)).filter(z=>K.some(F=>(0,i.$wo)(F,z.identifier)));if(R.length){const z=await Promise.all(R.map(F=>this.bb.scanMetadata(F,B)));await this.ub(R.map((F,G)=>[F,z[G]]),k),this.F.info("Successfully installed extensions",R.map(F=>F.identifier.id),k.toString())}return R}async updateMetadata(K,B,k=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",K.identifier.id),B.isPreReleaseVersion&&(B.preRelease=!0),B.isMachineScoped===!1&&(B.isMachineScoped=void 0),B.isBuiltin===!1&&(B.isBuiltin=void 0),B.pinned===!1&&(B.pinned=void 0),K=await this.bb.updateMetadata(K,B,k),this.cb.invalidate(k),this.w.fire(K),K}async reinstallFromGallery(K){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.z.isEnabled())throw new Error(m.localize(1,null));const B=await this.getTargetPlatform(),[k]=await this.z.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:B,compatible:!0},L.CancellationToken.None);if(!k)throw new Error(m.localize(2,null));await this.bb.setUninstalled(K);try{await this.bb.removeUninstalledExtension(K)}catch(R){throw new Error(m.localize(3,null,(0,A.$yi)(R)))}return this.installFromGallery(k)}ab(K,B,k,R){return this.bb.copyExtension(K,B,k,R)}copyExtensions(K,B){return this.bb.copyExtensions(K,B)}markAsUninstalled(...K){return this.bb.setUninstalled(...K)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(K){this.F.error(K)}}async download(K,B,k){const{location:R}=await this.db.download(K,B,!k);return R}async lb(K){if(K.scheme===E.Schemas.file)return{location:K,async cleanup(){}};this.F.trace("Downloading extension from",K.toString());const B=(0,l.$ug)(this.db.extensionsDownloadDir,(0,f.$dg)());return await this.hb.download(K,B),this.F.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.ib.del(B)}catch(R){this.F.error(R)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(K,B,k){if(w.URI.isUri(B))return new ne(K,B,k,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const R=i.$xo.create(B).toString();let z=this.eb.get(R);return z||(this.eb.set(R,z=new ee(K,B,k,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(R))),z}$(K,B){return new _(K,B.profileLocation,this.gb)}async pb(K){const B=async R=>{let z=await c.Promises.readdir(R);z=z.map(Z=>b.$ic(R,Z));const F=await Promise.all(z.map(Z=>c.Promises.stat(Z)));let G=Promise.resolve([]);return F.forEach((Z,re)=>{const le=z[re];Z.isFile()&&(G=G.then(ue=>[...ue,le])),Z.isDirectory()&&(G=G.then(ue=>B(le).then(he=>[...ue,...he])))}),G};return(await B(K.location.fsPath)).map(R=>({path:`extension/${b.$kc(K.location.fsPath,R)}`,localPath:R}))}async qb({added:K,removed:B}){if(B){const k=K&&this.D.extUri.isEqual(B.profileLocation,K.profileLocation)?B.extensions.filter(R=>K.extensions.every(z=>!(0,i.$wo)(z,R))):B.extensions;for(const R of k)this.F.info("Extensions removed from another source",R.id,B.profileLocation.toString()),this.u.fire({identifier:R,profileLocation:B.profileLocation})}if(K){const R=(await this.bb.scanExtensions(1,K.profileLocation)).filter(z=>K.extensions.some(F=>(0,i.$wo)(F,z.identifier)));this.s.fire(R.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,K.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:K.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(B=>this.rb.add(B)));const K=await this.ib.resolve(this.fb.userExtensionsLocation);for(const B of K.children??[])B.isDirectory&&this.rb.add(B.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(B=>this.tb(B)))}async tb(K){if(!K.affects(this.fb.userExtensionsLocation,1))return;const B=[];for(const k of K.rawAdded){if(this.rb.has(k)||!this.D.extUri.isEqual(this.D.extUri.dirname(k),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(k,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(k).startsWith(".")||!(await this.ib.stat(k)).isDirectory)continue;const R=await this.bb.scanUserExtensionAtLocation(k);R&&R.installedTimestamp===void 0&&(this.rb.add(k),B.push(R))}B.length&&(await this.ub(B.map(k=>[k,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",B.map(k=>k.identifier.id)))}async ub(K,B){const k=K.map(R=>R[0]);await this.vb(k),await this.gb.addExtensionsToProfile(K,B),this.s.fire(k.map(R=>({local:R,identifier:R.identifier,operation:1,profileLocation:B})))}async vb(K){const B=await this.bb.getUninstalledExtensions();for(const k of K){const R=i.$xo.create(k);B[R.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",R.id),await this.bb.setInstalled(R),this.F.info("Removed the extension from uninstalled list:",R.id))}}};e.$Gp=Q,e.$Gp=Q=ye([X(0,n.$7n),X(1,Y.$al),X(2,U.$8i),X(3,s.$Vh),X(4,r.$vp),X(5,t.$rp),X(6,S.$Kn),X(7,T.$Mh),X(8,M.$9j),X(9,q.$nj),X(10,J.$Gk),X(11,x.$Ik)],Q);let H=class extends d.$Rc{constructor(K,B,k,R,z,F){super(),this.j=K,this.m=B,this.n=k,this.s=R,this.t=z,this.u=F,this.h=this.B(new I.$Md),this.onExtract=this.h.event,this.c=(0,l.$ug)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$Zg}async cleanUp(){await this.H(),await this.G()}async scanExtensions(K,B){const k={includeInvalid:!0,profileLocation:B};let R=[];return K===null||K===0?R.push(...await this.n.scanAllExtensions({includeInvalid:!0},k,!1)):K===1&&R.push(...await this.n.scanUserExtensions(k)),R=K!==null?R.filter(z=>z.type===K):R,Promise.all(R.map(z=>this.F(z)))}async scanAllUserExtensions(K){const B=await this.n.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(B.map(k=>this.F(k)))}async scanUserExtensionAtLocation(K){try{const B=await this.n.scanExistingExtension(K,1,{includeInvalid:!0});if(B)return await this.F(B)}catch(B){this.u.error(B)}return null}async extractUserExtension(K,B,k,R,z){const F=K.toString(),G=w.URI.file(b.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,f.$dg)()}`)),Z=w.URI.file(b.$ic(this.n.userExtensionsLocation.fsPath,F));let re=await this.m.exists(Z);if(re&&R){try{await this.y(K.id,Z,"removeExisting")}catch{throw new n.$8n(m.localize(4,null,Z.fsPath,K.id),n.ExtensionManagementErrorCode.Delete)}re=!1}if(!re)try{try{this.u.trace(`Started extracting the extension from ${B} to ${Z.fsPath}`),await(0,h.$kp)(B,G.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${Z}:`,K.id)}catch(le){let ue=n.ExtensionManagementErrorCode.Extract;throw le instanceof h.$ip&&(le.type==="CorruptZip"?ue=n.ExtensionManagementErrorCode.CorruptZip:le.type==="Incomplete"&&(ue=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$8n(le.message,ue)}await this.n.updateMetadata(G,k);try{this.u.trace(`Started renaming the extension from ${G.fsPath} to ${Z.fsPath}`),await this.C(G.fsPath,Z.fsPath),this.u.info("Renamed to",Z.fsPath)}catch(le){if(le.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.u.info(`Rename failed because of ${(0,O.$9)(le)}. Deleted from extracted location`,G),le}this.h.fire(Z)}catch(le){try{await this.m.del(G,{recursive:!0})}catch{}throw le}return this.D(Z,1)}async scanMetadata(K,B){return B?(await this.w(K,B))?.metadata:this.n.scanMetadata(K.location)}async w(K,B){return(await this.s.scanProfileExtensions(B)).find(R=>(0,i.$wo)(R.identifier,K.identifier))}async updateMetadata(K,B,k){return k?await this.s.updateMetadata([[K,B]],k):await this.n.updateMetadata(K.location,B),this.D(K.location,K.type,k)}getUninstalledExtensions(){return this.z()}async setUninstalled(...K){const B=K.map(k=>i.$xo.create(k));await this.z(k=>B.forEach(R=>{k[R.toString()]=!0,this.u.info("Marked extension as uninstalled",R.toString())}))}async setInstalled(K){await this.z(B=>delete B[K.toString()])}async removeExtension(K,B){if(this.t.extUri.isEqualOrParent(K.location,this.n.userExtensionsLocation))return this.y(K.identifier.id,K.location,B)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.z(B=>delete B[i.$xo.create(K).toString()])}async copyExtension(K,B,k,R){const z=await this.w(K,B),F=await this.w(K,k);return R={...z?.metadata,...R},F?await this.s.updateMetadata([[K,{...F.metadata,...R}]],k):await this.s.addExtensionsToProfile([[K,R]],k),this.D(K.location,K.type,k)}async copyExtensions(K,B){const k=await this.scanExtensions(1,K),R=await Promise.all(k.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,K)]));await this.s.addExtensionsToProfile(R,B)}async y(K,B,k){this.u.trace(`Deleting ${k} extension from disk`,K,B.fsPath);const R=this.t.extUri.joinPath(this.t.extUri.dirname(B),`${this.t.extUri.basename(B)}.${(0,C.$Bi)((0,f.$dg)()).toString(16)}${W}`);await this.C(B.fsPath,R.fsPath),await this.m.del(R,{recursive:!0}),this.u.info(`Deleted ${k} extension from disk`,K,B.fsPath)}async z(K){return this.g.queue(async()=>{let B;try{B=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(R){if((0,M.$nk)(R)!==1)throw R}let k={};if(B)try{k=JSON.parse(B)}catch{}return K&&(K(k),Object.keys(k).length?await this.m.writeFile(this.c,N.$ae.fromString(JSON.stringify(k))):await this.m.del(this.c)),k})}async C(K,B){try{await c.Promises.rename(K,B,2*60*1e3)}catch(k){throw new n.$8n(k.message||m.localize(5,null,K,B),k.code||n.ExtensionManagementErrorCode.Rename)}}async D(K,B,k){if(k){const z=(await this.n.scanUserExtensions({profileLocation:k})).find(F=>this.t.extUri.isEqual(F.location,K));if(z)return this.F(z)}else{const R=await this.n.scanExistingExtension(K,B,{includeInvalid:!0});if(R)return this.F(R)}throw new Error(m.localize(6,null,K.path))}async F(K){const B=await this.m.resolve(K.location);let k,R;return B.children&&(k=B.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,R=B.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:k,changelogUrl:R,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned}}async G(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(K));const B=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),k=new Set;for(const z of B)K[i.$xo.create(z).toString()]||k.add(z.identifier.id.toLowerCase());try{const z=(0,i.$Co)(B,F=>F.identifier);await D.Promises.settled(z.map(async F=>{const G=F.sort((Z,re)=>g.rcompare(Z.manifest.version,re.manifest.version))[0];k.has(G.identifier.id.toLowerCase())||await this.j(await this.F(G))}))}catch(z){this.u.error(z)}const R=B.filter(z=>z.metadata&&K[i.$xo.create(z).toString()]);await Promise.allSettled(R.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let K;try{K=await this.m.resolve(this.n.userExtensionsLocation)}catch(B){(0,M.$nk)(B)!==1&&this.u.error(B);return}if(K?.children)try{await Promise.allSettled(K.children.map(async B=>{if(!(!B.isDirectory||!B.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",B.resource.toString());try{await this.m.del(B.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",B.resource.toString())}catch(k){(0,M.$nk)(k)!==1&&this.u.error(k)}}}))}catch{}}};e.$Hp=H,e.$Hp=H=ye([X(1,M.$9j),X(2,r.$vp),X(3,t.$rp),X(4,J.$Gk),X(5,U.$8i)],H);class V extends a.$pp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$Ef)(this.options.operation)?this.l:this.options.operation}constructor(K,B,k,R,z,F,G,Z,re){super(),this.identifier=K,this.source=B,this.options=k,this.m=R,this.n=z,this.o=F,this.p=G,this.q=Z,this.s=re,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(K){const[B,k]=await this.x(K);return this.j=B.isBuiltin||B.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[B,k]],this.j),B}async u({zipPath:K,key:B,metadata:k},R,z){let F=await this.v(B);return F||(this.s.trace("Extracting extension...",B.id),F=await this.m.extractUserExtension(B,K,k,R,z),this.s.info("Extracting extension completed.",B.id)),F}async v(K){return await this.w(K)?(this.s.trace("Removing the extension from uninstalled list:",K.id),await this.m.setInstalled(K),this.s.info("Removed the extension from uninstalled list:",K.id),(await this.m.scanAllUserExtensions(!0)).find(R=>i.$xo.create(R).equals(K))):void 0}async w(K){return!!(await this.m.getUninstalledExtensions())[K.toString()]}}class ee extends V{constructor(K,B,k,R,z,F,G,Z,re,le){super(B.identifier,B,k,z,F,G,Z,re,le),this.y=B,this.z=R}async x(K){const k=(await this.m.scanExtensions(null,this.options.profileLocation)).find(G=>(0,i.$wo)(G.identifier,this.y.identifier));k&&(this.l=3);const R={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||k?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||k?.isMachineScoped,isBuiltin:this.options.isBuiltin||k?.isBuiltin,isSystem:k?.type===0?!0:void 0,updated:!!k,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,p.$Df)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:k?.preRelease)};if(k?.manifest.version===this.y.version)return[await this.m.updateMetadata(k,R),R];const{location:z,verificationStatus:F}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=F,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:i.$xo.create(this.y),metadata:R},!1,K),R]}catch(G){try{await this.z.delete(z)}catch(Z){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,O.$9)(Z))}throw G}}async B(K){try{await(0,y.$Cp)(K)}catch(B){throw new n.$8n((0,a.$np)(B).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Ip=ee;class ne extends V{constructor(K,B,k,R,z,F,G,Z,re,le){super({id:(0,i.$Bo)(K.publisher,K.name)},B,k,z,F,G,Z,re,le),this.y=K,this.z=B,this.A=R}async h(K){const B=await super.h(K);return this.D(B,K),B}async x(K){const B=new i.$xo(this.identifier,this.y.version),R=(await this.m.scanExtensions(1,this.options.profileLocation)).find(G=>(0,i.$wo)(this.identifier,G.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(R)if(this.l=3,B.equals(new i.$xo(R.identifier,R.manifest.version)))try{await this.m.removeExtension(R,"existing")}catch{throw new Error(m.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&g.gt(R.manifest.version,this.y.version)&&await this.m.setUninstalled(R);else{const G=await this.v(B);if(G)try{await this.m.removeExtension(G,"existing")}catch{throw new Error(m.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:b.$jc(this.z.fsPath),key:B,metadata:z},!0,K),z]}async D(K,B){try{let[k]=await this.A.getExtensions([{id:K.identifier.id,version:K.manifest.version}],B);if(k||([k]=await this.A.getExtensions([{id:K.identifier.id}],B)),k){const R={id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(K,R,this.options.profileLocation)}}catch{}}}class _ extends a.$pp{constructor(K,B,k){super(),this.extension=K,this.j=B,this.k=k}async h(K){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[265],ae([0,1,2,29,81,222,122,7,21]),function(te,e,D,N,L,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R8b=void 0;let d=class extends D.$Rc{constructor(E,b,l,g,p,w){super(),E.cleanUp(),(0,A.$OVb)(E,b,l,g,w),L.$Tu.removeOutdatedExtensionVersions(E,p)}};e.$R8b=d,e.$R8b=d=ye([X(0,O.$Fp),X(1,N.$7n),X(2,L.$Su),X(3,N.$_n),X(4,C.$3o),X(5,I.$8i)],d)}),define(oe[123],ae([0,1,70,62,36,275,15,8,3,2,16,6,32,42,66]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class p{traceSocketEvent(u,$){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,$)}constructor(u,$=""){this.f=!0,this.debugLabel=$,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,I.$Z)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(u){const $=j=>{this.traceSocketEvent("read",j),u(O.$ae.wrap(j))};return this.socket.on("data",$),{dispose:()=>this.socket.off("data",$)}}onClose(u){const $=j=>{u({type:0,hadError:j,error:void 0})};return this.socket.on("close",$),{dispose:()=>this.socket.off("close",$)}}onEnd(u){const $=()=>{u()};return this.socket.on("end",$),{dispose:()=>this.socket.off("end",$)}}write(u){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,$=>{if($){if($.code==="EPIPE")return;(0,I.$Z)($)}})}catch($){if($.code==="EPIPE")return;(0,I.$Z)($)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,$)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Ch=p;var w;(function(y){y[y.MinHeaderByteSize=2]="MinHeaderByteSize",y[y.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var f;(function(y){y[y.PeekHeader=1]="PeekHeader",y[y.ReadHeader=2]="ReadHeader",y[y.ReadBody=3]="ReadBody",y[y.Fin=4]="Fin"})(f||(f={}));class c extends d.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(u,$){this.socket.traceSocketEvent(u,$)}constructor(u,$,j,M){super(),this.f=this.B(new C.$Md),this.g=this.B(new C.$Md),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:$,inflateBytesLength:j?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new h(this,$,j,M,this.f,(T,U)=>this.m(T,U))),this.B(this.a.onError(T=>{console.error(T),(0,I.$Z)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new g.$xh,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this.f.event(u)}onClose(u){return this.g.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){let $=0;for(;$<u.byteLength;)this.a.writeMessage(u.slice($,Math.min($+262144,u.byteLength)),{compressed:!0,opcode:2}),$+=262144}m(u,{compressed:$,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let M=2;u.byteLength<126?M+=0:u.byteLength<2**16?M+=2:M+=8;const T=O.$ae.alloc(M),U=$?64:0,q=j&15;if(T.writeUInt8(128|U|q,0),u.byteLength<126)T.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){T.writeUInt8(126,1);let Y=1;T.writeUInt8(u.byteLength>>>8&255,++Y),T.writeUInt8(u.byteLength>>>0&255,++Y)}else{T.writeUInt8(127,1);let Y=1;T.writeUInt8(0,++Y),T.writeUInt8(0,++Y),T.writeUInt8(0,++Y),T.writeUInt8(0,++Y),T.writeUInt8(u.byteLength>>>24&255,++Y),T.writeUInt8(u.byteLength>>>16&255,++Y),T.writeUInt8(u.byteLength>>>8&255,++Y),T.writeUInt8(u.byteLength>>>0&255,++Y)}this.socket.write(O.$ae.concat([T,u]))}end(){this.h=!0,this.socket.end()}n(u){if(u.byteLength!==0){for(this.b.acceptChunk(u);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const $=this.b.peek(this.j.readLen),j=$.readUInt8(0),M=(j&128)>>>7,T=(j&64)>>>6,U=j&15,q=$.readUInt8(1),Y=(q&128)>>>7,J=q&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(J===126?2:0)+(J===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!M,this.j.mask=0,this.j.opcode=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const $=this.b.read(this.j.readLen),j=$.readUInt8(1),M=(j&128)>>>7;let T=j&127,U=1;T===126?T=$.readUInt8(++U)*2**8+$.readUInt8(++U):T===127&&(T=$.readUInt8(++U)*0+$.readUInt8(++U)*0+$.readUInt8(++U)*0+$.readUInt8(++U)*0+$.readUInt8(++U)*2**24+$.readUInt8(++U)*2**16+$.readUInt8(++U)*2**8+$.readUInt8(++U));let q=0;M&&(q=$.readUInt8(++U)*2**24+$.readUInt8(++U)*2**16+$.readUInt8(++U)*2**8+$.readUInt8(++U)),this.j.state=3,this.j.readLen=T,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const $=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",$),s($,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",$),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame($,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage($,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Dh=c;class h extends d.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$ae.alloc(0)}constructor(u,$,j,M,T,U){super(),this.n=u,this.r=T,this.s=U,this.a=this.B(new C.$Md),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.$Md),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new C.$Md),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,$?(this.b=this.B(new m(this.n,M,j,{windowBits:15})),this.f=this.B(new S(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(u,$){this.g.push({data:u,options:$}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:u,options:$}=this.g.shift();if(this.f&&$.compressed){const j=await this.w(this.f,u);this.s(j,$)}else this.s(u,{...$,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(u,$){return new Promise((j,M)=>{u.write($),u.flush(T=>j(T))})}acceptFrame(u,$,j){this.h.push({data:u,isCompressed:$,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const u=this.h.shift();if(this.b&&u.isCompressed){const $=await this.C(this.b,u.data,u.isLastFrameOfMessage);this.r.fire($)}else this.r.fire(u.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(u,$,j){return new Promise((M,T)=>{u.write($),j&&u.write(O.$ae.fromByteArray([0,0,255,255])),u.flush(U=>M(U))})}}class m extends d.$Rc{get recordedInflateBytes(){return this.j?O.$ae.concat(this.f):O.$ae.alloc(0)}constructor(u,$,j,M){super(),this.h=u,this.j=$,this.a=this.B(new C.$Md),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(M),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(O.$ae.wrap(T))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(u){this.j&&this.f.push(u.clone()),this.h.traceSocketEvent("zlibInflateWrite",u),this.b.write(u.buffer)}flush(u){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const $=O.$ae.concat(this.g);this.g.length=0,u($)})}}class S extends d.$Rc{constructor(u,$){super(),this.g=u,this.a=this.B(new C.$Md),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(O.$ae.wrap(j))})}write(u){this.g.traceSocketEvent("zlibDeflateWrite",u.buffer),this.b.write(u.buffer)}flush(u){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let $=O.$ae.concat(this.f);this.f.length=0,$=$.slice(0,$.byteLength-4),u($)})}}function s(y,u){if(u===0)return;const $=y.byteLength>>>2;for(let Y=0;Y<$;Y++){const J=y.readUInt32BE(Y*4);y.writeUInt32BE(J^u,Y*4)}const j=$*4,M=y.byteLength-j,T=u>>>24&255,U=u>>>16&255,q=u>>>8&255;M>=1&&y.writeUInt8(y.readUInt8(j)^T,j),M>=2&&y.writeUInt8(y.readUInt8(j+1)^U,j+1),M>=3&&y.writeUInt8(y.readUInt8(j+2)^q,j+2)}e.$Eh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const y=(0,b.$dg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${y}-sock`;const u=process.platform!=="darwin"&&e.$Eh?e.$Eh:(0,L.tmpdir)(),$=(0,P.$ic)(u,`vscode-ipc-${y}.sock`);return t($),$}e.$Fh=n;function i(y,u,$){const j=(0,D.createHash)("md5").update(y).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${$}-${u}-sock`;const M=$.substr(0,4),T=u.substr(0,6),U=j.substr(0,8);let q;return process.platform!=="darwin"&&e.$Eh&&!process.env.VSCODE_PORTABLE?q=(0,P.$ic)(e.$Eh,`vscode-${U}-${M}-${T}.sock`):q=(0,P.$ic)(y,`${M}-${T}.sock`),t(q),q}e.$Gh=i;function t(y){const u=a[E.$u];typeof u=="number"&&y.length>=u&&console.warn(`WARNING: IPC handle "${y}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends l.$rh{static b(u){const $=C.Event.fromNodeEventEmitter(u,"connection");return C.Event.map($,j=>({protocol:new g.$yh(new p(j,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(j,"close"))}))}constructor(u){super(r.b(u)),this.d=u}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Hh=r;function o(y){return new Promise((u,$)=>{const j=(0,N.createServer)();j.on("error",$),j.listen(y,()=>{j.removeListener("error",$),u(new r(j))})})}e.$Ih=o;function v(y,u){return new Promise(($,j)=>{const M=(0,N.createConnection)(y,()=>{M.removeListener("error",j),$(g.$zh.fromSocket(new p(M,`ipc-client${u}`),u))});M.once("error",j)})}e.$Jh=v}),define(oe[266],ae([0,1,62,123,210]),function(te,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$18b=void 0,e.$18b=new class{supports(A){return!0}connect({host:A,port:O},I,C,d){return new Promise((P,E)=>{const b=D.createConnection({host:A,port:O},()=>{b.removeListener("error",E),b.write((0,L.$skb)(I,C,d));const l=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",l),P(new N.$Ch(b,d)))};b.on("data",l)});b.setNoDelay(!0),b.once("error",E)})}}}),define(oe[267],ae([0,1,62,36,134,123,5,2,6,20,7,24,213,104,106,77,15]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W7b=e.$V7b=e.$U7b=e.$T7b=void 0;async function f(s,a,n,i,t){let r;for(let o=3;o&&(r?.dispose(),r=await new c(s,a,n,i,t).waitForReady(),!(t&&L.$gg[t]||!L.$gg[r.tunnelLocalPort]));o--);return r}class c extends I.$Rc{constructor(a,n,i,t,r){super(),this.m=n,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=a,this.b=D.createServer(),this.c=new O.$Rg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const a=this.n??this.tunnelRemotePort,n=(0,p.$_u)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,L.$hg)(a,2,1e3,n),t=null;return this.b.listen(i,this.m),await this.c.wait(),t=this.b.address(),t||(i=0,this.b.listen(i,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(a){a.pause();const n=(0,p.$0u)(this.tunnelRemoteHost)||(0,p.$_u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,b.$4k)(this.a,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&a.write(r.buffer),a.on("end",()=>{a.localAddress&&this.j.delete(a.localAddress),t.end()}),a.on("close",()=>t.end()),a.on("error",()=>{a.localAddress&&this.j.delete(a.localAddress),t instanceof A.$Ch?t.socket.destroy():t.end()}),t instanceof A.$Ch?this.t(a,t):this.s(a,t),a.localAddress&&this.j.set(a.localAddress,()=>{a.end(),t.end()})}s(a,n){n.onClose(()=>a.destroy()),n.onEnd(()=>a.end()),n.onData(i=>a.write(i.buffer)),a.on("data",i=>n.write(w.$ae.wrap(i))),a.resume()}t(a,n){const i=n.socket;i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),i.pipe(a),a.pipe(i)}}e.$T7b=c;let h=class extends p.$cv{constructor(a,n,i,t,r){super(n,r),this.u=a,this.v=i,this.w=t}isPortPrivileged(a){return(0,p.$av)(a,this.l,C.OS,N.release())}s(a,n,i,t,r,o,v,y){const u=this.r(n,i);if(u)return++u.refcount,u.value;if((0,p.$7u)(a))return this.t(a,n,i,r,o,v,y);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const $={commit:this.w.commit,quality:this.w.quality,addressProvider:a,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=f($,t,n,i,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,i,j),j}}};e.$U7b=h,e.$U7b=h=ye([X(0,l.$Xk),X(1,P.$8i),X(2,g.$1k),X(3,E.$nj),X(4,d.$hi)],h);let m=class extends h{constructor(a,n,i,t,r){super(a,n,i,t,r)}};e.$V7b=m,e.$V7b=m=ye([X(0,l.$Xk),X(1,P.$8i),X(2,g.$1k),X(3,E.$nj),X(4,d.$hi)],m);let S=class extends I.$Rc{constructor(a,n,i,t,r){super(),this.b=a,this.c=n,this.f=i,this.g=t,this.h=r,this.a=new Map}async openTunnel(a,n,i,t,r,o,v,y,u){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${o}.`),!this.a.has(a)){const $=new m(this.b,this.c,this.g,this.f,this.h);this.B($),this.a.set(a,$),$.onTunnelClosed(async()=>{(await $.tunnels).length===0&&($.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(n,i,t,r,o,v,y,u)}};e.$W7b=S,e.$W7b=S=ye([X(0,l.$Xk),X(1,P.$8i),X(2,E.$nj),X(3,g.$1k),X(4,d.$hi)],S)}),define(oe[276],ae([0,1,36,38,8,2,23,10,18,3,42,147,204,205,196,197,262,187,189,20,209,95,220,96,215,14,114,247,29,97,188,122,98,11,199,200,69,4,195,71,73,225,7,201,102,24,57,21,107,22,108,109,110,45,228,81,111,25,79,254,238,239,82,253,257,258,259,58,252,241,106,219,77,267,214,229,28,230,6,231,190,207,206,80,246,17,51,203,56,251,227,242,105,256,265,9,202,101,249,245,216,184,55,260,248,72,250,104,266,182,112,240,217]),function(te,e,D,N,L,A,O,I,C,d,P,E,b,l,g,p,w,f,c,h,m,S,s,a,n,i,t,r,o,v,y,u,$,j,M,T,U,q,Y,J,x,W,Q,H,V,ee,ne,_,ie,K,B,k,R,z,F,G,Z,re,le,ue,he,$e,de,we,Ee,Ie,Ne,Te,ce,ge,be,ke,Pe,Ue,je,ze,Fe,se,fe,me,pe,Se,Re,Ce,De,Oe,Ae,Me,Be,qe,We,_e,ut,vt,Et,St,kt,ft,Ct,Pt,Rt,It,Dt,Ot,jt,dt,Lt,gt,At,Nt,$t,Mt,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends A.$Rc{constructor(ve){super(),this.f=ve,this.a=this.B(new E.$qT(this)),this.b=void 0,this.c=this.B(new d.$Md),this.g()}g(){let ve=!1;const Le=()=>{ve||(ve=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Le),(0,E.$rT)(process.parentPort,it.$06b.exit,Le)}async init(){const ve=await this.h();(0,re.$tgb)(),ve.invokeFunction(Le=>{const Ke=Le.get(Q.$8i),Ve=Le.get(K.$al),Qe=Le.get(Oe.$Ik);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Le),this.m(Ke),this.n(Ve,Qe),this.B(Qe.onDidChangeProfiles(()=>this.n(Ve,Qe)))}),this.B((0,A.$Oc)(ve.createInstance(b.$n8b,this.f.codeCachePath),ve.createInstance(l.$o8b),ve.createInstance(w.$r8b),ve.createInstance(p.$q8b),ve.createInstance(g.$p8b),ve.createInstance(Et.$R8b),ve.createInstance(_e.$J8b),ve.createInstance(Mt.$48b,this.c.event)))}async h(){const ve=new J.$Lh,Le={_serviceBrand:void 0,...V.default};ve.set(ee.$nj,Le);const Ke=new P.$vh(He=>He==="main"),Ve=new dt.$47b(this.a,Ke);ve.set(dt.$37b,Ve);const Qe=this.f.policiesData?new Me.$B7b(this.f.policiesData,Ve.getChannel("policy")):new Be.$gn;ve.set(Be.$en,Qe);const Ge=new Nt.$gm(this.f.args,Le);ve.set(i.$Vh,Ge);const xe=new H.$8q(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:I.URI.revive(He.resource)})),Ve.getChannel("logger"));ve.set(Q.$9i,xe);const st=this.B(xe.createLogger("sharedprocess",{name:(0,St.localize)(0,null)})),ct=this.B(new Q.$dj(st.getLevel())),Je=this.B(new kt.$yN(st,[ct]));ve.set(Q.$8i,Je),this.b=this.B(new ft.$T8b(Je)),ve.set(ft.$S8b,this.b);const Ze=this.B(new M.$Kp(Je));ve.set(j.$9j,Ze);const lt=this.B(new T.$0p(Je));Ze.registerProvider(O.Schemas.file,lt);const rt=new se.$wr(Ze);ve.set(Fe.$Gk,rt);const Xe=this.B(new qe.$FN(this.f.profiles.all,I.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));ve.set(Oe.$Ik,Xe);const ht=this.B(new me.$27b(O.Schemas.file,this.B(new pe.$hN(Ve.getChannel(pe.$gN),{pathCaseSensitive:fe.$l})),O.Schemas.vscodeUserData,Xe,rt,Je));Ze.registerProvider(O.Schemas.vscodeUserData,ht);const Ye=this.B(new m.$Gn(Xe.defaultProfile.settingsResource,Ze,Qe,Je));ve.set(h.$hi,Ye);const et=new Lt.$Z8b(void 0,{defaultProfile:Xe.defaultProfile,currentProfile:Xe.defaultProfile},Ve,Ge);ve.set(_.$3o,et),this.B((0,A.$Pc)(()=>et.flush())),await Promise.all([Ye.initialize(),et.initialize()]);const bt=new Rt.$Tq(Ve.getChannel("request"));ve.set(ne.$Po,bt),ve.set(f.$s8b,new U.$Kh(c.$t8b,void 0,!1)),ve.set(Re.$SE,new U.$Kh(Se.$I8b,void 0,!1));const wt=P.ProxyChannel.toService(Ve.getChannel("nativeHost"));ve.set(Dt.$M6b,wt),ve.set(a.$Kn,new U.$Kh(n.$NN,void 0,!0));const Tt=this.B(new ge.$y7b(wt)),Ut=new P.$vh(He=>Tt.getActiveClientId().then(at=>He===at));ve.set($.$yVb,new It.$V8b(this.a.getChannel("extensionRecommendationNotification",Ut)));let ot;const tt=[],yt=(0,z.$to)(Le,Ye);if((0,z.$oo)(Le,Ge)){const He=new k.$E4b(Je,xe,Ge,Le);if(tt.push(He),!(0,z.$po)(Le,Ge)&&Le.aiConfig?.ariaKey){const at=new We.$mN(bt,yt,"monacoworkbench",null,Le.aiConfig.ariaKey);this.B((0,A.$Pc)(()=>at.flush())),tt.push(at)}ot=new R.$Xq({appenders:tt,commonProperties:(0,ie.$eo)((0,D.release)(),(0,D.hostname)(),process.arch,Le.commit,Le.version,this.f.machineId,yt),sendErrorTelemetry:!0,piiPaths:(0,z.$uo)(Ge)},Ye,Le)}else{ot=z.$io;const He=z.$mo;tt.push(He)}this.a.registerChannel("telemetryAppender",new B.$c7b(tt)),ve.set(K.$al,ot);const zt=new F.$u8b(Ye,ot,Je,xe,Ge,Le);ve.set(K.$bl,zt),ve.set(Ae.$rp,new U.$Kh(Pt.$xN,void 0,!0)),ve.set(Ce.$vp,new U.$Kh(De.$C7b,void 0,!0)),ve.set(v.$bp,new U.$Kh(v.$cp,void 0,!0)),ve.set(u.$Fp,new U.$Kh(u.$Gp,void 0,!0)),ve.set(o.$7n,new U.$Kh(r.$_o,void 0,!0)),ve.set(o.$ao,new U.$Kh(jt.$Y8b,void 0,!1)),ve.set(x.$Pq,new U.$Kh(W.$Rq,void 0,!1)),ve.set(S.$nm,new U.$Kh(s.$Dr,void 0,!1)),ve.set(le.$sCb,new U.$Kh(le.$tCb,void 0,!0)),ve.set(re.$Ogb,new U.$Kh($e.$FEb,void 0,!0)),ve.set(re.$Ngb,new he.$x8b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ve.set(o.$_n,new U.$Kh(t.$qCb,void 0,!1)),ve.set(Z.$DEb,new U.$Kh(Z.$EEb,void 0,!0)),ve.set(G.$Su,new U.$Kh(G.$Tu)),ve.set(re.$ygb,new U.$Kh(Ne.$ODb,void 0,!0)),ve.set(re.$zgb,new U.$Kh(Ne.$QDb,void 0,!0)),ve.set(de.$mgb,new U.$Kh(de.$ogb,void 0,!0)),ve.set(re.$Agb,new U.$Kh(ue.$g5b,void 0,!1)),ve.set(re.$Jgb,new U.$Kh(we.$84b,void 0,!0)),ve.set(re.$Kgb,new U.$Kh(Ee.$l5b,void 0,!1)),ve.set(Te.$5Cb,new U.$Kh(ce.$E8b,void 0,!0)),ve.set(re.$Lgb,new U.$Kh(vt.$X5b,void 0,!0)),ve.set(be.$1k,new U.$Kh(ke.$Y7b,void 0,!1));const pt=new gt.$Yk;return ve.set(gt.$Xk,pt),pt.register(0,At.$18b),ve.set(Pe.$6u,new U.$Kh(Ue.$W7b)),ve.set(je.$F8b,new U.$Kh(ze.$H8b)),ve.set(ut.$K8b,new U.$Kh(Ct.$U8b)),ve.set($t.$28b,new U.$Kh($t.$38b)),new Y.$aq(ve)}j(ve){const Le=this.B(new A.$Qc),Ke=new y.$ep(ve.get(o.$9n),()=>null);this.a.registerChannel("extensions",Ke);const Ve=P.ProxyChannel.fromService(ve.get(x.$Pq),Le);this.a.registerChannel("languagePacks",Ve);const Qe=P.ProxyChannel.fromService(ve.get(S.$nm),Le);this.a.registerChannel("diagnostics",Qe);const Ge=new y.$gp(ve.get(o.$ao));this.a.registerChannel("extensionTipsService",Ge);const xe=P.ProxyChannel.fromService(ve.get(f.$s8b),Le);this.a.registerChannel("checksum",xe);const st=P.ProxyChannel.fromService(ve.get(Re.$SE),Le);this.a.registerChannel("v8InspectProfiling",st);const ct=new he.$y8b(ve.get(de.$mgb));this.a.registerChannel("userDataSyncMachines",ct);const Je=P.ProxyChannel.fromService(ve.get(K.$bl),Le);this.a.registerChannel("customEndpointTelemetry",Je);const Ze=new he.$z8b(ve.get(le.$sCb));this.a.registerChannel("userDataSyncAccount",Ze);const lt=new he.$A8b(ve.get(re.$ygb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Ie.$C8b(ve.get(re.$Kgb),ve.get(Oe.$Ik),ve.get(Q.$8i));this.a.registerChannel("userDataSync",rt);const Xe=this.B(ve.get(q.$Mh).createInstance(Ot.$X8b)),ht=new he.$v8b(Xe);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(ve.get(re.$Lgb),Le));const Ye=P.ProxyChannel.fromService(ve.get(je.$F8b),Le);this.a.registerChannel(je.$G8b,Ye);const et=P.ProxyChannel.fromService(ve.get(ut.$K8b),Le);this.a.registerChannel("remoteTunnel",et)}m(ve){process.on("uncaughtException",Le=>(0,L.$Z)(Le)),process.on("unhandledRejection",Le=>(0,L.$Z)(Le)),(0,L.setUnexpectedErrorHandler)(Le=>{const Ke=(0,N.$yi)(Le,!0);Ke&&ve.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(ve,Le){ve.publicLog2("profilesInfo",{count:Le.profiles.length})}handledClientConnection(ve){if(ve.data!==it.$_6b.response)return!1;const Le=(0,C.$Nb)(ve.ports);return Le?(this.c.fire(Le),!0):!1}}async function mt(nt){const ve=new Ft(nt);process.parentPort.postMessage(it.$06b.ipcReady),await ve.init(),process.parentPort.postMessage(it.$06b.initDone)}e.main=mt,process.parentPort.once("message",nt=>{mt(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b63441dbc9f729977e8e97321f536a06521496f7/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
