/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function($e){for(var e=[],C=0,F=$e.length;C<F;C++)e[C]=De[$e[C]];return e};define(De[156],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class C{static get(){const d=new Map,M=new Map,A=new Map,b=new Map;function E(y,D){y.has(D.detail)||y.set(D.detail,-D.timestamp)}function w(y,D){const p=y.get(D.detail);p&&(p>=0||y.set(D.detail,p+D.timestamp))}let R=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(R=$e.getStats().slice(0).sort((y,D)=>y.timestamp-D.timestamp));for(const y of R)switch(y.type){case 10:E(d,y);break;case 11:case 12:w(d,y);break;case 21:E(M,y);break;case 22:w(M,y);break;case 33:E(A,y);break;case 34:w(A,y);break;case 31:E(b,y);break;case 32:w(b,y);break}let I=0;A.forEach(y=>I+=y);function v(y){const D=[];return y.forEach((p,l)=>D.push([l,p])),D}return{amdLoad:v(d),amdInvoke:v(M),nodeRequire:v(A),nodeEval:v(b),nodeRequireTotal:I}}static toMarkdownTable(d,M){let A="";const b=[];return d.forEach((E,w)=>{b[w]=E.length}),M.forEach(E=>{E.forEach((w,R)=>{typeof w>"u"&&(w=E[R]="-");const I=w.toString().length;b[R]=Math.max(I,b[R])})}),d.forEach((E,w)=>{A+=`| ${E+" ".repeat(b[w]-E.toString().length)} `}),A+=`|
`,d.forEach((E,w)=>{A+=`| ${"-".repeat(b[w])} `}),A+=`|
`,M.forEach(E=>{E.forEach((w,R)=>{typeof w<"u"&&(A+=`| ${w+" ".repeat(b[R]-w.toString().length)} `)}),A+=`|
`}),A}}e.$T=C}),define(De[118],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function C(p,l,c){const r=F(p,l);if(r!==-1)return p[r]}e.$eb=C;function F(p,l,c=p.length-1){for(let r=c;r>=0;r--){const o=p[r];if(l(o))return r}return-1}e.$fb=F;function d(p,l){const c=M(p,l);return c===-1?void 0:p[c]}e.$gb=d;function M(p,l,c=0,r=p.length){let o=c,m=r;for(;o<m;){const h=Math.floor((o+m)/2);l(p[h])?o=h+1:m=h}return o-1}e.$hb=M;function A(p,l){const c=b(p,l);return c===p.length?void 0:p[c]}e.$ib=A;function b(p,l,c=0,r=p.length){let o=c,m=r;for(;o<m;){const h=Math.floor((o+m)/2);l(p[h])?m=h:o=h+1}return o}e.$jb=b;function E(p,l,c=0,r=p.length){const o=b(p,l,c,r);return o===p.length?-1:o}e.$kb=E;class w{static{this.assertInvariants=!1}constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if(w.assertInvariants){if(this.d){for(const r of this.e)if(this.d(r)&&!l(r))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const c=M(this.e,l,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$lb=w;function R(p,l){if(p.length===0)return;let c=p[0];for(let r=1;r<p.length;r++){const o=p[r];l(o,c)>0&&(c=o)}return c}e.$mb=R;function I(p,l){if(p.length===0)return;let c=p[0];for(let r=1;r<p.length;r++){const o=p[r];l(o,c)>=0&&(c=o)}return c}e.$nb=I;function v(p,l){return R(p,(c,r)=>-l(c,r))}e.$ob=v;function y(p,l){if(p.length===0)return-1;let c=0;for(let r=1;r<p.length;r++){const o=p[r];l(o,p[c])>0&&(c=r)}return c}e.$pb=y;function D(p,l){for(const c of p){const r=l(c);if(r!==void 0)return r}}e.$qb=D}),define(De[73],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function C(A,b){const E=Object.create(null);for(const w of A){const R=b(w);let I=E[R];I||(I=E[R]=[]),I.push(w)}return E}e.$J=C;function F(A,b){const E=[],w=[];for(const R of A)b.has(R)||E.push(R);for(const R of b)A.has(R)||w.push(R);return{removed:E,added:w}}e.$K=F;function d(A,b){const E=[],w=[];for(const[R,I]of A)b.has(R)||E.push(I);for(const[R,I]of b)A.has(R)||w.push(I);return{removed:E,added:w}}e.$L=d;function M(A,b){const E=new Set;for(const w of b)A.has(w)&&E.add(w);return E}e.$M=M}),define(De[57],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function C(A){return(b,E,w)=>{let R=null,I=null;if(typeof w.value=="function"?(R="value",I=w.value):typeof w.get=="function"&&(R="get",I=w.get),!I)throw new Error("not supported");w[R]=A(I,E)}}function F(A,b,E){let w=null,R=null;if(typeof E.value=="function"?(w="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(w="get",R=E.get),!R)throw new Error("not supported");const I=`$memoize$${b}`;E[w]=function(...v){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,v)}),this[I]}}e.$fh=F;function d(A,b,E){return C((w,R)=>{const I=`$debounce$${R}`,v=`$debounce$result$${R}`;return function(...y){this[v]||(this[v]=E?E():void 0),clearTimeout(this[I]),b&&(this[v]=b(this[v],...y),y=[this[v]]),this[I]=setTimeout(()=>{w.apply(this,y),this[v]=E?E():void 0},A)}})}e.$gh=d;function M(A,b,E){return C((w,R)=>{const I=`$throttle$timer$${R}`,v=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,D=`$throttle$pending$${R}`;return function(...p){if(this[v]||(this[v]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),b&&(this[v]=b(this[v],...p)),this[D])return;const l=this[y]+A;l<=Date.now()?(this[y]=Date.now(),w.apply(this,[this[v]]),this[v]=E?E():void 0):(this[D]=!0,this[I]=setTimeout(()=>{this[D]=!1,this[y]=Date.now(),w.apply(this,[this[v]]),this[v]=E?E():void 0},l-Date.now()))}})}e.$hh=M}),define(De[8],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?o.isErrorNoTelemetry(t)?new o(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(n=>{n(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=C,e.$W=new C;function F(h){e.$W.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=F;function d(h){if(!h||typeof h!="object")return!1;const t=h;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=d;function M(h){w(h)||e.$W.onUnexpectedError(h)}e.$Z=M;function A(h){w(h)||e.$W.onUnexpectedExternalError(h)}e.$1=A;function b(h){if(h instanceof Error){const{name:t,message:n}=h,a=h.stacktrace||h.stack;return{$isError:!0,name:t,message:n,stack:a,noTelemetry:o.isErrorNoTelemetry(h)}}return h}e.$2=b;const E="Canceled";function w(h){return h instanceof R?!0:h instanceof Error&&h.name===E&&h.message===E}e.$3=w;class R extends Error{constructor(){super(E),this.name=this.message}}e.$4=R;function I(){const h=new Error(E);return h.name=h.message,h}e.$5=I;function v(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.$6=v;function y(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.$7=y;class D extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=D;function p(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.$9=p;class l extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=l;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=c;class r extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=r;class o extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof o)return t;const n=new o;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=o;class m extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$bb=m}),define(De[19],Ce([1,0,8,118]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function d(_,ie=0){return _[_.length-(1+ie)]}e.$rb=d;function M(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.$sb=M;function A(_,ie,re=(Ee,ce)=>Ee===ce){if(_===ie)return!0;if(!_||!ie||_.length!==ie.length)return!1;for(let Ee=0,ce=_.length;Ee<ce;Ee++)if(!re(_[Ee],ie[Ee]))return!1;return!0}e.$tb=A;function b(_,ie){const re=_.length-1;ie<re&&(_[ie]=_[re]),_.pop()}e.$ub=b;function E(_,ie,re){return w(_.length,Ee=>re(_[Ee],ie))}e.$vb=E;function w(_,ie){let re=0,Ee=_-1;for(;re<=Ee;){const ce=(re+Ee)/2|0,de=ie(ce);if(de<0)re=ce+1;else if(de>0)Ee=ce-1;else return ce}return-(re+1)}e.$wb=w;function R(_,ie,re){if(_=_|0,_>=ie.length)throw new TypeError("invalid index");const Ee=ie[Math.floor(ie.length*Math.random())],ce=[],de=[],ee=[];for(const he of ie){const be=re(he,Ee);be<0?ce.push(he):be>0?de.push(he):ee.push(he)}return _<ce.length?R(_,ce,re):_<ce.length+ee.length?ee[0]:R(_-(ce.length+ee.length),de,re)}e.$xb=R;function I(_,ie){const re=[];let Ee;for(const ce of _.slice(0).sort(ie))!Ee||ie(Ee[0],ce)!==0?(Ee=[ce],re.push(Ee)):Ee.push(ce);return re}e.$yb=I;function*v(_,ie){let re,Ee;for(const ce of _)Ee!==void 0&&ie(Ee,ce)?re.push(ce):(re&&(yield re),re=[ce]),Ee=ce;re&&(yield re)}e.$zb=v;function y(_,ie){for(let re=0;re<=_.length;re++)ie(re===0?void 0:_[re-1],re===_.length?void 0:_[re])}e.$Ab=y;function D(_,ie){for(let re=0;re<_.length;re++)ie(re===0?void 0:_[re-1],_[re],re+1===_.length?void 0:_[re+1])}e.$Bb=D;function p(_,ie,re){const Ee=[];function ce(he,be,Pe){if(be===0&&Pe.length===0)return;const B=Ee[Ee.length-1];B&&B.start+B.deleteCount===he?(B.deleteCount+=be,B.toInsert.push(...Pe)):Ee.push({start:he,deleteCount:be,toInsert:Pe})}let de=0,ee=0;for(;;){if(de===_.length){ce(de,0,ie.slice(ee));break}if(ee===ie.length){ce(de,_.length-de,[]);break}const he=_[de],be=ie[ee],Pe=re(he,be);Pe===0?(de+=1,ee+=1):Pe<0?(ce(de,1,[]),de+=1):Pe>0&&(ce(de,0,[be]),ee+=1)}return Ee}e.$Cb=p;function l(_,ie,re){const Ee=p(_,ie,re),ce=[],de=[];for(const ee of Ee)ce.push(..._.slice(ee.start,ee.start+ee.deleteCount)),de.push(...ee.toInsert);return{removed:ce,added:de}}e.$Db=l;function c(_,ie,re){if(re===0)return[];const Ee=_.slice(0,re).sort(ie);return o(_,ie,Ee,re,_.length),Ee}e.top=c;function r(_,ie,re,Ee,ce){return re===0?Promise.resolve([]):new Promise((de,ee)=>{(async()=>{const he=_.length,be=_.slice(0,re).sort(ie);for(let Pe=re,B=Math.min(re+Ee,he);Pe<he;Pe=B,B=Math.min(B+Ee,he)){if(Pe>re&&await new Promise(J=>setTimeout(J)),ce&&ce.isCancellationRequested)throw new C.$4;o(_,ie,be,Pe,B)}return be})().then(de,ee)})}e.$Fb=r;function o(_,ie,re,Ee,ce){for(const de=re.length;Ee<ce;Ee++){const ee=_[Ee];if(ie(ee,re[de-1])<0){re.pop();const he=(0,F.$jb)(re,be=>ie(ee,be)<0);re.splice(he,0,ee)}}}function m(_){return _.filter(ie=>!!ie)}e.$Gb=m;function h(_){let ie=0;for(let re=0;re<_.length;re++)_[re]&&(_[ie]=_[re],ie+=1);_.length=ie}e.$Hb=h;function t(_,ie,re){_.splice(re,0,_.splice(ie,1)[0])}e.$Ib=t;function n(_){return!Array.isArray(_)||_.length===0}e.$Jb=n;function a(_){return Array.isArray(_)&&_.length>0}e.$Kb=a;function i(_,ie=re=>re){const re=new Set;return _.filter(Ee=>{const ce=ie(Ee);return re.has(ce)?!1:(re.add(ce),!0)})}e.$Lb=i;function s(_){const ie=new Set;return re=>{const Ee=_(re);return ie.has(Ee)?!1:(ie.add(Ee),!0)}}e.$Mb=s;function u(_,ie){return _.length>0?_[0]:ie}e.$Nb=u;function S(_,ie){return _.length>0?_[_.length-1]:ie}e.$Ob=S;function k(_,ie,re=(Ee,ce)=>Ee===ce){let Ee=0;for(let ce=0,de=Math.min(_.length,ie.length);ce<de&&re(_[ce],ie[ce]);ce++)Ee++;return Ee}e.$Pb=k;function $(_){return[].concat(..._)}e.$Qb=$;function f(_,ie){let re=typeof ie=="number"?_:0;typeof ie=="number"?re=_:(re=0,ie=_);const Ee=[];if(re<=ie)for(let ce=re;ce<ie;ce++)Ee.push(ce);else for(let ce=re;ce>ie;ce--)Ee.push(ce);return Ee}e.$Rb=f;function g(_,ie,re){return _.reduce((Ee,ce)=>(Ee[ie(ce)]=re?re(ce):ce,Ee),Object.create(null))}e.$Sb=g;function P(_,ie){return _.push(ie),()=>O(_,ie)}e.$Tb=P;function O(_,ie){const re=_.indexOf(ie);if(re>-1)return _.splice(re,1),ie}e.$Ub=O;function N(_,ie,re){const Ee=_.slice(0,ie),ce=_.slice(ie);return Ee.concat(re,ce)}e.$Vb=N;function L(_,ie){let re;if(typeof ie=="number"){let Ee=ie;re=()=>{const ce=Math.sin(Ee++)*179426549;return ce-Math.floor(ce)}}else re=Math.random;for(let Ee=_.length-1;Ee>0;Ee-=1){const ce=Math.floor(re()*(Ee+1)),de=_[Ee];_[Ee]=_[ce],_[ce]=de}}e.$Wb=L;function j(_,ie){const re=_.indexOf(ie);re>-1&&(_.splice(re,1),_.unshift(ie))}e.$Xb=j;function z(_,ie){const re=_.indexOf(ie);re>-1&&(_.splice(re,1),_.push(ie))}e.$Yb=z;function T(_,ie){for(const re of ie)_.push(re)}e.$Zb=T;function K(_,ie){return Array.isArray(_)?_.map(ie):ie(_)}e.$1b=K;function V(_){return Array.isArray(_)?_:[_]}e.$2b=V;function fe(_){return _[Math.floor(Math.random()*_.length)]}e.$3b=fe;function X(_,ie,re){const Ee=Z(_,ie),ce=_.length,de=re.length;_.length=ce+de;for(let ee=ce-1;ee>=Ee;ee--)_[ee+de]=_[ee];for(let ee=0;ee<de;ee++)_[ee+Ee]=re[ee]}e.$4b=X;function Q(_,ie,re,Ee){const ce=Z(_,ie);let de=_.splice(ce,re);return de===void 0&&(de=[]),X(_,ce,Ee),de}e.$5b=Q;function Z(_,ie){return ie<0?Math.max(ie+_.length,0):Math.min(ie,_.length)}var oe;(function(_){function ie(de){return de<0}_.isLessThan=ie;function re(de){return de<=0}_.isLessThanOrEqual=re;function Ee(de){return de>0}_.isGreaterThan=Ee;function ce(de){return de===0}_.isNeitherLessOrGreaterThan=ce,_.greaterThan=1,_.lessThan=-1,_.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function x(_,ie){return(re,Ee)=>ie(_(re),_(Ee))}e.$6b=x;function ae(..._){return(ie,re)=>{for(const Ee of _){const ce=Ee(ie,re);if(!oe.isNeitherLessOrGreaterThan(ce))return ce}return oe.neitherLessOrGreaterThan}}e.$7b=ae;const ve=(_,ie)=>_-ie;e.$8b=ve;const G=(_,ie)=>(0,e.$8b)(_?1:0,ie?1:0);e.$9b=G;function U(_){return(ie,re)=>-_(ie,re)}e.$0b=U;class q{constructor(ie){this.g=ie,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let re=this.c;for(;re<this.g.length&&ie(this.g[re]);)re++;const Ee=re===this.c?null:this.g.slice(this.c,re);return this.c=re,Ee}takeFromEndWhile(ie){let re=this.d;for(;re>=0&&ie(this.g[re]);)re--;const Ee=re===this.d?null:this.g.slice(re+1,this.d+1);return this.d=re,Ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ie=this.g[this.c];return this.c++,ie}removeLast(){const ie=this.g[this.d];return this.d--,ie}takeCount(ie){const re=this.g.slice(this.c,this.c+ie);return this.c+=ie,re}}e.$$b=q;class me{static{this.empty=new me(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(re=>(ie(re),!0))}toArray(){const ie=[];return this.iterate(re=>(ie.push(re),!0)),ie}filter(ie){return new me(re=>this.iterate(Ee=>ie(Ee)?re(Ee):!0))}map(ie){return new me(re=>this.iterate(Ee=>re(ie(Ee))))}some(ie){let re=!1;return this.iterate(Ee=>(re=ie(Ee),!re)),re}findFirst(ie){let re;return this.iterate(Ee=>ie(Ee)?(re=Ee,!1):!0),re}findLast(ie){let re;return this.iterate(Ee=>(ie(Ee)&&(re=Ee),!0)),re}findLastMaxBy(ie){let re,Ee=!0;return this.iterate(ce=>((Ee||oe.isGreaterThan(ie(ce,re)))&&(Ee=!1,re=ce),!0)),re}}e.$_b=me}),define(De[58],Ce([1,0,8]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function F(E,w){if(!E)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=F;function d(E,w="Unreachable"){throw new Error(w)}e.$3c=d;function M(E){if(!E)throw new C.$bb("Assertion Failed")}e.$4c=M;function A(E){if(!E()){debugger;E(),(0,C.$Z)(new C.$bb("Assertion Failed"))}}e.$5c=A;function b(E,w){let R=0;for(;R<E.length-1;){const I=E[R],v=E[R+1];if(!w(I,v))return!1;R++}return!0}e.$6c=b}),define(De[74],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function C(F){const d=this;let M=!1,A;return function(){return M||(M=!0,A=F.apply(d,arguments)),A}}e.$cb=C}),define(De[119],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$gM=void 0;class C{constructor(d){this.a=d,this.b=0}nextId(){return this.a+ ++this.b}}e.$gM=C,e.$hM=new C("id#")}),define(De[51],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(F){function d(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}F.is=d;const M=Object.freeze([]);function A(){return M}F.empty=A;function*b(h){yield h}F.single=b;function E(h){return d(h)?h:b(h)}F.wrap=E;function w(h){return h||M}F.from=w;function*R(h){for(let t=h.length-1;t>=0;t--)yield h[t]}F.reverse=R;function I(h){return!h||h[Symbol.iterator]().next().done===!0}F.isEmpty=I;function v(h){return h[Symbol.iterator]().next().value}F.first=v;function y(h,t){for(const n of h)if(t(n))return!0;return!1}F.some=y;function D(h,t){for(const n of h)if(t(n))return n}F.find=D;function*p(h,t){for(const n of h)t(n)&&(yield n)}F.filter=p;function*l(h,t){let n=0;for(const a of h)yield t(a,n++)}F.map=l;function*c(...h){for(const t of h)for(const n of t)yield n}F.concat=c;function r(h,t,n){let a=n;for(const i of h)a=t(a,i);return a}F.reduce=r;function*o(h,t,n=h.length){for(t<0&&(t+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);t<n;t++)yield h[t]}F.slice=o;function m(h,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,h];const a=h[Symbol.iterator]();for(let i=0;i<t;i++){const s=a.next();if(s.done)return[n,F.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return a}}]}F.consume=m})(C||(e.Iterable=C={}))}),define(De[157],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var d;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(d||(e.ParseErrorCode=d={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(t,n=!1){let a=0;const i=t.length;let s="",u=0,S=16,k=0;function $(j){let z=0,T=0;for(;z<j;){const K=t.charCodeAt(a);if(K>=48&&K<=57)T=T*16+K-48;else if(K>=65&&K<=70)T=T*16+K-65+10;else if(K>=97&&K<=102)T=T*16+K-97+10;else break;a++,z++}return z<j&&(T=-1),T}function f(j){a=j,s="",u=0,S=16,k=0}function g(){const j=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&w(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&w(t.charCodeAt(a)))for(a++;a<t.length&&w(t.charCodeAt(a));)a++;else return k=3,t.substring(j,a);let z=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&w(t.charCodeAt(a))){for(a++;a<t.length&&w(t.charCodeAt(a));)a++;z=a}else k=3;return t.substring(j,z)}function P(){let j="",z=a;for(;;){if(a>=i){j+=t.substring(z,a),k=2;break}const T=t.charCodeAt(a);if(T===34){j+=t.substring(z,a),a++;break}if(T===92){if(j+=t.substring(z,a),a++,a>=i){k=2;break}switch(t.charCodeAt(a++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const V=$(4);V>=0?j+=String.fromCharCode(V):k=4;break}default:k=5}z=a;continue}if(T>=0&&T<=31)if(E(T)){j+=t.substring(z,a),k=2;break}else k=6;a++}return j}function O(){if(s="",k=0,u=a,a>=i)return u=i,S=17;let j=t.charCodeAt(a);if(b(j)){do a++,s+=String.fromCharCode(j),j=t.charCodeAt(a);while(b(j));return S=15}if(E(j))return a++,s+=String.fromCharCode(j),j===13&&t.charCodeAt(a)===10&&(a++,s+=`
`),S=14;switch(j){case 123:return a++,S=1;case 125:return a++,S=2;case 91:return a++,S=3;case 93:return a++,S=4;case 58:return a++,S=6;case 44:return a++,S=5;case 34:return a++,s=P(),S=10;case 47:{const z=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<i&&!E(t.charCodeAt(a));)a++;return s=t.substring(z,a),S=12}if(t.charCodeAt(a+1)===42){a+=2;const T=i-1;let K=!1;for(;a<T;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,k=1),s=t.substring(z,a),S=13}return s+=String.fromCharCode(j),a++,S=16}case 45:if(s+=String.fromCharCode(j),a++,a===i||!w(t.charCodeAt(a)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=g(),S=11;default:for(;a<i&&N(j);)a++,j=t.charCodeAt(a);if(u!==a){switch(s=t.substring(u,a),s){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return s+=String.fromCharCode(j),a++,S=16}}function N(j){if(b(j)||E(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let j;do j=O();while(j>=12&&j<=15);return j}return{setPosition:f,getPosition:()=>a,scan:n?L:O,getToken:()=>S,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>a-u,getTokenError:()=>k}}e.$Qm=A;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function I(t,n){const a=[],i=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function k($,f,g,P){u.value=$,u.offset=f,u.length=g,u.type=P,u.colonOffset=void 0,s=u}try{o(t,{onObjectBegin:($,f)=>{if(n<=$)throw i;s=void 0,S=n>$,a.push("")},onObjectProperty:($,f,g)=>{if(n<f||(k($,f,g,"property"),a[a.length-1]=$,n<=f+g))throw i},onObjectEnd:($,f)=>{if(n<=$)throw i;s=void 0,a.pop()},onArrayBegin:($,f)=>{if(n<=$)throw i;s=void 0,a.push(0)},onArrayEnd:($,f)=>{if(n<=$)throw i;s=void 0,a.pop()},onLiteralValue:($,f,g)=>{if(n<f||(k($,f,g,h($)),n<=f+g))throw i},onSeparator:($,f,g)=>{if(n<=f)throw i;if($===":"&&s&&s.type==="property")s.colonOffset=f,S=!1,s=void 0;else if($===","){const P=a[a.length-1];typeof P=="number"?a[a.length-1]=P+1:(S=!0,a[a.length-1]=""),s=void 0}}})}catch($){if($!==i)throw $}return{path:a,previousNode:s,isAtPropertyKey:S,matches:$=>{let f=0;for(let g=0;f<$.length&&g<a.length;g++)if($[f]===a[g]||$[f]==="*")f++;else if($[f]!=="**")return!1;return f===$.length}}}e.$Rm=I;function v(t,n=[],a=M.DEFAULT){let i=null,s=[];const u=[];function S($){Array.isArray(s)?s.push($):i!==null&&(s[i]=$)}return o(t,{onObjectBegin:()=>{const $={};S($),u.push(s),s=$,i=null},onObjectProperty:$=>{i=$},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const $=[];S($),u.push(s),s=$,i=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:S,onError:($,f,g)=>{n.push({error:$,offset:f,length:g})}},a),s[0]}e.$Sm=v;function y(t,n=[],a=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s($){i.type==="property"&&(i.length=$-i.offset,i=i.parent)}function u($){return i.children.push($),$}o(t,{onObjectBegin:$=>{i=u({type:"object",offset:$,length:-1,parent:i,children:[]})},onObjectProperty:($,f,g)=>{i=u({type:"property",offset:f,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:$,offset:f,length:g,parent:i})},onObjectEnd:($,f)=>{i.length=$+f-i.offset,i=i.parent,s($+f)},onArrayBegin:($,f)=>{i=u({type:"array",offset:$,length:-1,parent:i,children:[]})},onArrayEnd:($,f)=>{i.length=$+f-i.offset,i=i.parent,s($+f)},onLiteralValue:($,f,g)=>{u({type:h($),offset:f,length:g,parent:i,value:$}),s(f+g)},onSeparator:($,f,g)=>{i.type==="property"&&($===":"?i.colonOffset=f:$===","&&s(f))},onError:($,f,g)=>{n.push({error:$,offset:f,length:g})}},a);const k=i.children[0];return k&&delete k.parent,k}e.$Tm=y;function D(t,n){if(!t)return;let a=t;for(const i of n)if(typeof i=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let s=!1;for(const u of a.children)if(Array.isArray(u.children)&&u.children[0].value===i){a=u.children[1],s=!0;break}if(!s)return}else{const s=i;if(a.type!=="array"||s<0||!Array.isArray(a.children)||s>=a.children.length)return;a=a.children[s]}return a}e.$Um=D;function p(t){if(!t.parent||!t.parent.children)return[];const n=p(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;n.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&n.push(a)}return n}e.$Vm=p;function l(t){switch(t.type){case"array":return t.children.map(l);case"object":{const n=Object.create(null);for(const a of t.children){const i=a.children[1];i&&(n[a.children[0].value]=l(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Wm=l;function c(t,n,a=!1){return n>=t.offset&&n<t.offset+t.length||a&&n===t.offset+t.length}e.$Xm=c;function r(t,n,a=!1){if(c(t,n,a)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=n;s++){const u=r(i[s],n,a);if(u)return u}return t}}e.$Ym=r;function o(t,n,a=M.DEFAULT){const i=A(t,!1);function s(x){return x?()=>x(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(x){return x?ae=>x(ae,i.getTokenOffset(),i.getTokenLength()):()=>!0}const S=s(n.onObjectBegin),k=u(n.onObjectProperty),$=s(n.onObjectEnd),f=s(n.onArrayBegin),g=s(n.onArrayEnd),P=u(n.onLiteralValue),O=u(n.onSeparator),N=s(n.onComment),L=u(n.onError),j=a&&a.disallowComments,z=a&&a.allowTrailingComma;function T(){for(;;){const x=i.scan();switch(i.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:j||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(x){case 12:case 13:j?K(10):N();break;case 16:K(1);break;case 15:case 14:break;default:return x}}}function K(x,ae=[],ve=[]){if(L(x),ae.length+ve.length>0){let G=i.getToken();for(;G!==17;){if(ae.indexOf(G)!==-1){T();break}else if(ve.indexOf(G)!==-1)break;G=T()}}}function V(x){const ae=i.getTokenValue();return x?P(ae):k(ae),T(),!0}function fe(){switch(i.getToken()){case 11:{let x=0;try{x=JSON.parse(i.getTokenValue()),typeof x!="number"&&(K(2),x=0)}catch{K(2)}P(x);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return T(),!0}function X(){return i.getToken()!==10?(K(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(O(":"),T(),oe()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Q(){S(),T();let x=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(x||K(4,[],[]),O(","),T(),i.getToken()===2&&z)break}else x&&K(6,[],[]);X()||K(4,[],[2,5]),x=!0}return $(),i.getToken()!==2?K(7,[2],[]):T(),!0}function Z(){f(),T();let x=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(x||K(4,[],[]),O(","),T(),i.getToken()===4&&z)break}else x&&K(6,[],[]);oe()||K(4,[],[4,5]),x=!0}return g(),i.getToken()!==4?K(8,[4],[]):T(),!0}function oe(){switch(i.getToken()){case 3:return Z();case 1:return Q();case 10:return V(!0);default:return fe()}}return T(),i.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):oe()?(i.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.$Zm=o;function m(t,n){const a=A(t),i=[];let s,u=0,S;do switch(S=a.getPosition(),s=a.scan(),s){case 12:case 13:case 17:u!==S&&i.push(t.substring(u,S)),n!==void 0&&i.push(a.getTokenValue().replace(/[^\r\n]/g,n)),u=a.getPosition();break}while(s!==17);return i.join("")}e.$1m=m;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$2m=h}),define(De[46],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class C{constructor(d){this.d=d,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(d){this.c=d}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=C}),define(De[75],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class C{static{this.Undefined=new C(void 0)}constructor(M){this.element=M,this.next=C.Undefined,this.prev=C.Undefined}}class F{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let M=this.a;for(;M!==C.Undefined;){const A=M.next;M.prev=C.Undefined,M.next=C.Undefined,M=A}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,A){const b=new C(M);if(this.a===C.Undefined)this.a=b,this.b=b;else if(A){const w=this.b;this.b=b,b.prev=w,w.next=b}else{const w=this.a;this.a=b,b.next=w,w.prev=b}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(b))}}shift(){if(this.a!==C.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==C.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==C.Undefined&&M.next!==C.Undefined){const A=M.prev;A.next=M.next,M.next.prev=A}else M.prev===C.Undefined&&M.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):M.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):M.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==C.Undefined;)yield M.element,M=M.next}}e.$1c=F}),define(De[28],Ce([1,0]),function($e,e){"use strict";var C,F,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function M(r,o,m){let h=r.get(o);return h===void 0&&(h=m,r.set(o,h)),h}e.$wc=M;function A(r){const o=[];return r.forEach((m,h)=>{o.push(`${h} => ${m}`)}),`Map(${r.size}) {${o.join(", ")}}`}e.$xc=A;function b(r){const o=[];return r.forEach(m=>{o.push(m)}),`Set(${r.size}) {${o.join(", ")}}`}e.$yc=b;class E{constructor(o,m){this.uri=o,this.value=m}}function w(r){return Array.isArray(r)}class R{static{this.a=o=>o.toString()}constructor(o,m){if(this[C]="ResourceMap",o instanceof R)this.b=new Map(o.b),this.c=m??R.a;else if(w(o)){this.b=new Map,this.c=m??R.a;for(const[h,t]of o)this.set(h,t)}else this.b=new Map,this.c=o??R.a}set(o,m){return this.b.set(this.c(o),new E(o,m)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,m){typeof m<"u"&&(o=o.bind(m));for(const[h,t]of this.b)o(t.value,t.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$zc=R;class I{constructor(o,m){this[F]="ResourceSet",!o||typeof o=="function"?this.a=new R(o):(this.a=new R(m),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,m){this.a.forEach((h,t)=>o.call(m,t,t,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=I;var v;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class y{constructor(){this[d]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,m=0){const h=this.a.get(o);if(h)return m!==0&&this.j(h,m),h.value}set(o,m,h=0){let t=this.a.get(o);if(t)t.value=m,h!==0&&this.j(t,h);else{switch(t={key:o,value:m,next:void 0,previous:void 0},h){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(o,t),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const m=this.a.get(o);if(m)return this.a.delete(o),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,m){const h=this.e;let t=this.b;for(;t;){if(m?o.bind(m)(t.value,t.key,this):o(t.value,t.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const o=this,m=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const n={value:h.key,done:!1};return h=h.next,n}else return{value:void 0,done:!0}}};return t}values(){const o=this,m=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const n={value:h.value,done:!1};return h=h.next,n}else return{value:void 0,done:!0}}};return t}entries(){const o=this,m=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const n={value:[h.key,h.value],done:!1};return h=h.next,n}else return{value:void 0,done:!0}}};return t}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let m=this.b,h=this.size;for(;m&&h>o;)this.a.delete(m.key),m=m.next,h--;this.b=m,this.d=h,m&&(m.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const m=o.next,h=o.previous;if(!m||!h)throw new Error("Invalid list");m.previous=h,h.next=m}o.next=void 0,o.previous=void 0,this.e++}j(o,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(o===this.b)return;const h=o.next,t=o.previous;o===this.c?(t.next=void 0,this.c=t):(h.previous=t,t.next=h),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(m===2){if(o===this.c)return;const h=o.next,t=o.previous;o===this.b?(h.previous=void 0,this.b=h):(h.previous=t,t.next=h),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((m,h)=>{o.push([h,m])}),o}fromJSON(o){this.clear();for(const[m,h]of o)this.set(m,h)}}e.$Bc=y;class D extends y{constructor(o,m=1){super(),this.k=o,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,m=2){return super.get(o,m)}peek(o){return super.get(o,0)}set(o,m){return super.set(o,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=D;class p{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let m=this.a.get(o)||0;return m===0?!1:(m--,m===0?this.a.delete(o):this.a.set(o,m),!0)}has(o){return this.a.has(o)}}e.$Dc=p;class l{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[m,h]of o)this.set(m,h)}clear(){this.a.clear(),this.b.clear()}set(o,m){this.a.set(o,m),this.b.set(m,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const m=this.a.get(o);return m===void 0?!1:(this.a.delete(o),this.b.delete(m),!0)}forEach(o,m){this.a.forEach((h,t)=>{o.call(m,h,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=l;class c{constructor(){this.a=new Map}add(o,m){let h=this.a.get(o);h||(h=new Set,this.a.set(o,h)),h.add(m)}delete(o,m){const h=this.a.get(o);h&&(h.delete(m),h.size===0&&this.a.delete(o))}forEach(o,m){const h=this.a.get(o);h&&h.forEach(m)}get(o){const m=this.a.get(o);return m||new Set}}e.$Fc=c}),define(De[3],Ce([1,0,19,73,28,74,51]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const b=!1;let E=null;class w{constructor(){this.b=new Map}static{this.a=0}c(g){let P=this.b.get(g);return P||(P={parent:null,source:null,isSingleton:!1,value:g,idx:w.a++},this.b.set(g,P)),P}trackDisposable(g){const P=this.c(g);P.source||(P.source=new Error().stack)}setParent(g,P){const O=this.c(g);O.parent=P}markAsDisposed(g){this.b.delete(g)}markAsSingleton(g){this.c(g).isSingleton=!0}f(g,P){const O=P.get(g);if(O)return O;const N=g.parent?this.f(this.c(g.parent),P):g;return P.set(g,N),N}getTrackedDisposables(){const g=new Map;return[...this.b.entries()].filter(([,O])=>O.source!==null&&!this.f(O,g).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(g=10,P){let O;if(P)O=P;else{const T=new Map,K=[...this.b.values()].filter(fe=>fe.source!==null&&!this.f(fe,T).isSingleton);if(K.length===0)return;const V=new Set(K.map(fe=>fe.value));if(O=K.filter(fe=>!(fe.parent&&V.has(fe.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function N(T){function K(fe,X){for(;fe.length>0&&X.some(Q=>typeof Q=="string"?Q===fe[0]:fe[0].match(Q));)fe.shift()}const V=T.source.split(`
`).map(fe=>fe.trim().replace("at ","")).filter(fe=>fe!=="");return K(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const L=new d.$Fc;for(const T of O){const K=N(T);for(let V=0;V<=K.length;V++)L.add(K.slice(0,V).join(`
`),T)}O.sort((0,C.$6b)(T=>T.idx,C.$8b));let j="",z=0;for(const T of O.slice(0,g)){z++;const K=N(T),V=[];for(let fe=0;fe<K.length;fe++){let X=K[fe];X=`(shared with ${L.get(K.slice(0,fe+1).join(`
`)).size}/${O.length} leaks) at ${X}`;const Z=L.get(K.slice(0,fe).join(`
`)),oe=(0,F.$J)([...Z].map(x=>N(x)[fe]),x=>x);delete oe[K[fe]];for(const[x,ae]of Object.entries(oe))V.unshift(`    - stacktraces of ${ae.length} other leaks continue with ${x}`);V.unshift(X)}j+=`


==================== Leaking disposable ${z}/${O.length}: ${T.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return O.length>g&&(j+=`


... and ${O.length-g} more leaking disposables

`),{leaks:O,details:j}}}e.$Gc=w;function R(f){E=f}if(e.$Hc=R,b){const f="__is_disposable_tracked__";R(new class{trackDisposable(g){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[f]||console.log(P)},3e3)}setParent(g,P){if(g&&g!==t.None)try{g[f]=!0}catch{}}markAsDisposed(g){if(g&&g!==t.None)try{g[f]=!0}catch{}}markAsSingleton(g){}})}function I(f){return E?.trackDisposable(f),f}e.$Ic=I;function v(f){E?.markAsDisposed(f)}e.$Jc=v;function y(f,g){E?.setParent(f,g)}function D(f,g){if(E)for(const P of f)E.setParent(P,g)}function p(f){return E?.markAsSingleton(f),f}e.$Kc=p;function l(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.$Lc=l;function c(f){if(A.Iterable.is(f)){const g=[];for(const P of f)if(P)try{P.dispose()}catch(O){g.push(O)}if(g.length===1)throw g[0];if(g.length>1)throw new AggregateError(g,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}e.$Mc=c;function r(f){for(const g of f)l(g)&&g.dispose();return[]}e.$Nc=r;function o(...f){const g=m(()=>c(f));return D(f,g),g}e.$Oc=o;function m(f){const g=I({dispose:(0,M.$cb)(()=>{v(g),f()})});return g}e.$Pc=m;class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return y(g,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(g),g}delete(g){if(g){if(g===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(g),g.dispose()}}deleteAndLeak(g){g&&this.f.has(g)&&(this.f.delete(g),y(g,null))}}e.$Qc=h;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,I(this),y(this.q,this)}dispose(){v(this),this.q.dispose()}B(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(g)}}e.$Rc=t;class n{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(g){this.b||g===this.a||(this.a?.dispose(),g&&y(g,this),this.a=g)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const g=this.a;return this.a=void 0,g&&y(g,null),g}}e.$Sc=n;class a{constructor(g){this.b=g,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=a;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(g){let P=g;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,v(this))},this}}e.$Uc=i;class s{constructor(){this.a=new Map}acquire(g,...P){let O=this.a.get(g);O||(O={counter:0,object:this.b(g,...P)},this.a.set(g,O));const{object:N}=O,L=(0,M.$cb)(()=>{--O.counter===0&&(this.c(g,O.object),this.a.delete(g))});return O.counter++,{object:N,dispose:L}}}e.$Vc=s;class u{constructor(g){this.a=g}async acquire(g,...P){const O=this.a.acquire(g,...P);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(N){throw O.dispose(),N}}}e.$Wc=u;class S{constructor(g){this.object=g}dispose(){}}e.$Xc=S;function k(f){const g=new h;try{f(g)}finally{g.dispose()}}e.$Yc=k;class ${constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(g){return this.a.has(g)}get size(){return this.a.size}get(g){return this.a.get(g)}set(g,P,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(g)?.dispose(),this.a.set(g,P)}deleteAndDispose(g){this.a.get(g)?.dispose(),this.a.delete(g)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=$}),function($e,e){typeof define=="function"&&define.amd?define(De[158],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(ie,re){for(var Ee=0;Ee<re.length;Ee++){var ce=re[Ee];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(ie,ce.key,ce)}}function C(ie,re,Ee){return re&&e(ie.prototype,re),Ee&&e(ie,Ee),Object.defineProperty(ie,"prototype",{writable:!1}),ie}function F(ie,re){if(ie){if(typeof ie=="string")return d(ie,re);var Ee=Object.prototype.toString.call(ie).slice(8,-1);if(Ee==="Object"&&ie.constructor&&(Ee=ie.constructor.name),Ee==="Map"||Ee==="Set")return Array.from(ie);if(Ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ee))return d(ie,re)}}function d(ie,re){(re==null||re>ie.length)&&(re=ie.length);for(var Ee=0,ce=new Array(re);Ee<re;Ee++)ce[Ee]=ie[Ee];return ce}function M(ie,re){var Ee=typeof Symbol<"u"&&ie[Symbol.iterator]||ie["@@iterator"];if(Ee)return(Ee=Ee.call(ie)).next.bind(Ee);if(Array.isArray(ie)||(Ee=F(ie))||re&&ie&&typeof ie.length=="number"){Ee&&(ie=Ee);var ce=0;return function(){return ce>=ie.length?{done:!0}:{done:!1,value:ie[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=A();function b(ie){$e.defaults=ie}var E=/[&<>"']/,w=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(re){return v[re]};function D(ie,re){if(re){if(E.test(ie))return ie.replace(w,y)}else if(R.test(ie))return ie.replace(I,y);return ie}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(ie){return ie.replace(p,function(re,Ee){return Ee=Ee.toLowerCase(),Ee==="colon"?":":Ee.charAt(0)==="#"?Ee.charAt(1)==="x"?String.fromCharCode(parseInt(Ee.substring(2),16)):String.fromCharCode(+Ee.substring(1)):""})}var c=/(^|[^\[])\^/g;function r(ie,re){ie=typeof ie=="string"?ie:ie.source,re=re||"";var Ee={replace:function(de,ee){return ee=ee.source||ee,ee=ee.replace(c,"$1"),ie=ie.replace(de,ee),Ee},getRegex:function(){return new RegExp(ie,re)}};return Ee}var o=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(ie,re,Ee){if(ie){var ce;try{ce=decodeURIComponent(l(Ee)).replace(o,"").toLowerCase()}catch{return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}re&&!m.test(Ee)&&(Ee=s(re,Ee));try{Ee=encodeURI(Ee).replace(/%25/g,"%")}catch{return null}return Ee}var t={},n=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(ie,re){t[" "+ie]||(n.test(ie)?t[" "+ie]=ie+"/":t[" "+ie]=$(ie,"/",!0)),ie=t[" "+ie];var Ee=ie.indexOf(":")===-1;return re.substring(0,2)==="//"?Ee?re:ie.replace(a,"$1")+re:re.charAt(0)==="/"?Ee?re:ie.replace(i,"$1")+re:ie+re}var u={exec:function(){}};function S(ie){for(var re=1,Ee,ce;re<arguments.length;re++){Ee=arguments[re];for(ce in Ee)Object.prototype.hasOwnProperty.call(Ee,ce)&&(ie[ce]=Ee[ce])}return ie}function k(ie,re){var Ee=ie.replace(/\|/g,function(ee,he,be){for(var Pe=!1,B=he;--B>=0&&be[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ce=Ee.split(/ \|/),de=0;if(ce[0].trim()||ce.shift(),ce.length>0&&!ce[ce.length-1].trim()&&ce.pop(),ce.length>re)ce.splice(re);else for(;ce.length<re;)ce.push("");for(;de<ce.length;de++)ce[de]=ce[de].trim().replace(/\\\|/g,"|");return ce}function $(ie,re,Ee){var ce=ie.length;if(ce===0)return"";for(var de=0;de<ce;){var ee=ie.charAt(ce-de-1);if(ee===re&&!Ee)de++;else if(ee!==re&&Ee)de++;else break}return ie.slice(0,ce-de)}function f(ie,re){if(ie.indexOf(re[1])===-1)return-1;for(var Ee=ie.length,ce=0,de=0;de<Ee;de++)if(ie[de]==="\\")de++;else if(ie[de]===re[0])ce++;else if(ie[de]===re[1]&&(ce--,ce<0))return de;return-1}function g(ie){ie&&ie.sanitize&&!ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ie,re){if(re<1)return"";for(var Ee="";re>1;)re&1&&(Ee+=ie),re>>=1,ie+=ie;return Ee+ie}function O(ie,re,Ee,ce){var de=re.href,ee=re.title?D(re.title):null,he=ie[1].replace(/\\([\[\]])/g,"$1");if(ie[0].charAt(0)!=="!"){ce.state.inLink=!0;var be={type:"link",raw:Ee,href:de,title:ee,text:he,tokens:ce.inlineTokens(he)};return ce.state.inLink=!1,be}return{type:"image",raw:Ee,href:de,title:ee,text:D(he)}}function N(ie,re){var Ee=ie.match(/^(\s+)(?:```)/);if(Ee===null)return re;var ce=Ee[1];return re.split(`
`).map(function(de){var ee=de.match(/^\s+/);if(ee===null)return de;var he=ee[0];return he.length>=ce.length?de.slice(ce.length):de}).join(`
`)}var L=function(){function ie(Ee){this.options=Ee||$e.defaults}var re=ie.prototype;return re.space=function(ce){var de=this.rules.block.newline.exec(ce);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},re.code=function(ce){var de=this.rules.block.code.exec(ce);if(de){var ee=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:$(ee,`
`)}}},re.fences=function(ce){var de=this.rules.block.fences.exec(ce);if(de){var ee=de[0],he=N(ee,de[3]||"");return{type:"code",raw:ee,lang:de[2]?de[2].trim():de[2],text:he}}},re.heading=function(ce){var de=this.rules.block.heading.exec(ce);if(de){var ee=de[2].trim();if(/#$/.test(ee)){var he=$(ee,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ee=he.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:ee,tokens:this.lexer.inline(ee)}}},re.hr=function(ce){var de=this.rules.block.hr.exec(ce);if(de)return{type:"hr",raw:de[0]}},re.blockquote=function(ce){var de=this.rules.block.blockquote.exec(ce);if(de){var ee=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},re.list=function(ce){var de=this.rules.block.list.exec(ce);if(de){var ee,he,be,Pe,B,J,te,se,Y,ge,ye,je,We=de[1].trim(),_e=We.length>1,Ye={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ce&&(je=!1,!(!(de=it.exec(ce))||this.rules.block.hr.test(ce)));){if(ee=de[0],ce=ce.substring(ee.length),se=de[2].split(`
`,1)[0],Y=ce.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=se.trimLeft()):(Pe=de[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=se.slice(Pe),Pe+=de[1].length),J=!1,!se&&/^ *$/.test(Y)&&(ee+=Y+`
`,ce=ce.substring(Y.length+1),je=!0),!je)for(var et=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ce&&(ge=ce.split(`
`,1)[0],se=ge,this.options.pedantic&&(se=se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(se)||qe.test(se)||et.test(se)||Ae.test(ce)));){if(se.search(/[^ ]/)>=Pe||!se.trim())ye+=`
`+se.slice(Pe);else if(!J)ye+=`
`+se;else break;!J&&!se.trim()&&(J=!0),ee+=ge+`
`,ce=ce.substring(ge.length+1)}Ye.loose||(te?Ye.loose=!0:/\n *\n *$/.test(ee)&&(te=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(ye),he&&(be=he[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ee,task:!!he,checked:be,loose:!1,text:ye}),Ye.raw+=ee}Ye.items[Ye.items.length-1].raw=ee.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Me=Ye.items.length;for(B=0;B<Me;B++){this.lexer.state.top=!1,Ye.items[B].tokens=this.lexer.blockTokens(Ye.items[B].text,[]);var Ze=Ye.items[B].tokens.filter(function(ue){return ue.type==="space"}),le=Ze.every(function(ue){for(var Ie=ue.raw.split(""),Ve=0,ze=M(Ie),Xe;!(Xe=ze()).done;){var rt=Xe.value;if(rt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Ye.loose&&Ze.length&&le&&(Ye.loose=!0,Ye.items[B].loose=!0)}return Ye}},re.html=function(ce){var de=this.rules.block.html.exec(ce);if(de){var ee={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var he=this.options.sanitizer?this.options.sanitizer(de[0]):D(de[0]);ee.type="paragraph",ee.text=he,ee.tokens=this.lexer.inline(he)}return ee}},re.def=function(ce){var de=this.rules.block.def.exec(ce);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var ee=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:de[0],href:de[2],title:de[3]}}},re.table=function(ce){var de=this.rules.block.table.exec(ce);if(de){var ee={type:"table",header:k(de[1]).map(function(te){return{text:te}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=de[0];var he=ee.align.length,be,Pe,B,J;for(be=0;be<he;be++)/^ *-+: *$/.test(ee.align[be])?ee.align[be]="right":/^ *:-+: *$/.test(ee.align[be])?ee.align[be]="center":/^ *:-+ *$/.test(ee.align[be])?ee.align[be]="left":ee.align[be]=null;for(he=ee.rows.length,be=0;be<he;be++)ee.rows[be]=k(ee.rows[be],ee.header.length).map(function(te){return{text:te}});for(he=ee.header.length,Pe=0;Pe<he;Pe++)ee.header[Pe].tokens=this.lexer.inline(ee.header[Pe].text);for(he=ee.rows.length,Pe=0;Pe<he;Pe++)for(J=ee.rows[Pe],B=0;B<J.length;B++)J[B].tokens=this.lexer.inline(J[B].text);return ee}}},re.lheading=function(ce){var de=this.rules.block.lheading.exec(ce);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},re.paragraph=function(ce){var de=this.rules.block.paragraph.exec(ce);if(de){var ee=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:ee,tokens:this.lexer.inline(ee)}}},re.text=function(ce){var de=this.rules.block.text.exec(ce);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},re.escape=function(ce){var de=this.rules.inline.escape.exec(ce);if(de)return{type:"escape",raw:de[0],text:D(de[1])}},re.tag=function(ce){var de=this.rules.inline.tag.exec(ce);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):D(de[0]):de[0]}},re.link=function(ce){var de=this.rules.inline.link.exec(ce);if(de){var ee=de[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var he=$(ee.slice(0,-1),"\\");if((ee.length-he.length)%2===0)return}else{var be=f(de[2],"()");if(be>-1){var Pe=de[0].indexOf("!")===0?5:4,B=Pe+de[1].length+be;de[2]=de[2].substring(0,be),de[0]=de[0].substring(0,B).trim(),de[3]=""}}var J=de[2],te="";if(this.options.pedantic){var se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);se&&(J=se[1],te=se[3])}else te=de[3]?de[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(ee)?J=J.slice(1):J=J.slice(1,-1)),O(de,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:te&&te.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},re.reflink=function(ce,de){var ee;if((ee=this.rules.inline.reflink.exec(ce))||(ee=this.rules.inline.nolink.exec(ce))){var he=(ee[2]||ee[1]).replace(/\s+/g," ");if(he=de[he.toLowerCase()],!he||!he.href){var be=ee[0].charAt(0);return{type:"text",raw:be,text:be}}return O(ee,he,ee[0],this.lexer)}},re.emStrong=function(ce,de,ee){ee===void 0&&(ee="");var he=this.rules.inline.emStrong.lDelim.exec(ce);if(he&&!(he[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=he[1]||he[2]||"";if(!be||be&&(ee===""||this.rules.inline.punctuation.exec(ee))){var Pe=he[0].length-1,B,J,te=Pe,se=0,Y=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,de=de.slice(-1*ce.length+Pe);(he=Y.exec(de))!=null;)if(B=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!B){if(J=B.length,he[3]||he[4]){te+=J;continue}else if((he[5]||he[6])&&Pe%3&&!((Pe+J)%3)){se+=J;continue}if(te-=J,!(te>0)){if(J=Math.min(J,J+te+se),Math.min(Pe,J)%2){var ge=ce.slice(1,Pe+he.index+J);return{type:"em",raw:ce.slice(0,Pe+he.index+J+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}var ye=ce.slice(2,Pe+he.index+J-1);return{type:"strong",raw:ce.slice(0,Pe+he.index+J+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},re.codespan=function(ce){var de=this.rules.inline.code.exec(ce);if(de){var ee=de[2].replace(/\n/g," "),he=/[^ ]/.test(ee),be=/^ /.test(ee)&&/ $/.test(ee);return he&&be&&(ee=ee.substring(1,ee.length-1)),ee=D(ee,!0),{type:"codespan",raw:de[0],text:ee}}},re.br=function(ce){var de=this.rules.inline.br.exec(ce);if(de)return{type:"br",raw:de[0]}},re.del=function(ce){var de=this.rules.inline.del.exec(ce);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},re.autolink=function(ce,de){var ee=this.rules.inline.autolink.exec(ce);if(ee){var he,be;return ee[2]==="@"?(he=D(this.options.mangle?de(ee[1]):ee[1]),be="mailto:"+he):(he=D(ee[1]),be=he),{type:"link",raw:ee[0],text:he,href:be,tokens:[{type:"text",raw:he,text:he}]}}},re.url=function(ce,de){var ee;if(ee=this.rules.inline.url.exec(ce)){var he,be;if(ee[2]==="@")he=D(this.options.mangle?de(ee[0]):ee[0]),be="mailto:"+he;else{var Pe;do Pe=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(Pe!==ee[0]);he=D(ee[0]),ee[1]==="www."?be="http://"+he:be=he}return{type:"link",raw:ee[0],text:he,href:be,tokens:[{type:"text",raw:he,text:he}]}}},re.inlineText=function(ce,de){var ee=this.rules.inline.text.exec(ce);if(ee){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):D(ee[0]):ee[0]:he=D(this.options.smartypants?de(ee[0]):ee[0]),{type:"text",raw:ee[0],text:he}}},ie}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=r(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=r(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=r(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=r(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=r(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=r(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=S({},j),j.gfm=S({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=r(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=r(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=S({},j.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:r(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=r(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=r(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=r(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=r(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=r(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=r(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=r(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=r(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=r(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=r(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=r(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=S({},z),z.pedantic=S({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=S({},z.normal,{escape:r(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=r(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=S({},z.gfm,{br:r(z.br).replace("{2,}","*").getRegex(),text:r(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(ie){return ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(ie){var re="",Ee,ce,de=ie.length;for(Ee=0;Ee<de;Ee++)ce=ie.charCodeAt(Ee),Math.random()>.5&&(ce="x"+ce.toString(16)),re+="&#"+ce+";";return re}var V=function(){function ie(Ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ee||$e.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ce={block:j.normal,inline:z.normal};this.options.pedantic?(ce.block=j.pedantic,ce.inline=z.pedantic):this.options.gfm&&(ce.block=j.gfm,this.options.breaks?ce.inline=z.breaks:ce.inline=z.gfm),this.tokenizer.rules=ce}ie.lex=function(ce,de){var ee=new ie(de);return ee.lex(ce)},ie.lexInline=function(ce,de){var ee=new ie(de);return ee.inlineTokens(ce)};var re=ie.prototype;return re.lex=function(ce){ce=ce.replace(/\r\n|\r/g,`
`),this.blockTokens(ce,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},re.blockTokens=function(ce,de){var ee=this;de===void 0&&(de=[]),this.options.pedantic?ce=ce.replace(/\t/g,"    ").replace(/^ +$/gm,""):ce=ce.replace(/^( *)(\t+)/gm,function(te,se,Y){return se+"    ".repeat(Y.length)});for(var he,be,Pe,B;ce;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(te){return(he=te.call({lexer:ee},ce,de))?(ce=ce.substring(he.raw.length),de.push(he),!0):!1}))){if(he=this.tokenizer.space(ce)){ce=ce.substring(he.raw.length),he.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(he);continue}if(he=this.tokenizer.code(ce)){ce=ce.substring(he.raw.length),be=de[de.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+he.raw,be.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):de.push(he);continue}if(he=this.tokenizer.fences(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.heading(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.hr(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.blockquote(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.list(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.html(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.def(ce)){ce=ce.substring(he.raw.length),be=de[de.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+he.raw,be.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.lheading(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(Pe=ce,this.options.extensions&&this.options.extensions.startBlock&&function(){var te=1/0,se=ce.slice(1),Y=void 0;ee.options.extensions.startBlock.forEach(function(ge){Y=ge.call({lexer:this},se),typeof Y=="number"&&Y>=0&&(te=Math.min(te,Y))}),te<1/0&&te>=0&&(Pe=ce.substring(0,te+1))}(),this.state.top&&(he=this.tokenizer.paragraph(Pe))){be=de[de.length-1],B&&be.type==="paragraph"?(be.raw+=`
`+he.raw,be.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):de.push(he),B=Pe.length!==ce.length,ce=ce.substring(he.raw.length);continue}if(he=this.tokenizer.text(ce)){ce=ce.substring(he.raw.length),be=de[de.length-1],be&&be.type==="text"?(be.raw+=`
`+he.raw,be.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):de.push(he);continue}if(ce){var J="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,de},re.inline=function(ce,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:ce,tokens:de}),de},re.inlineTokens=function(ce,de){var ee=this;de===void 0&&(de=[]);var he,be,Pe,B=ce,J,te,se;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)Y.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,J.index)+"["+P("a",J[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,J.index)+"["+P("a",J[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,J.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;)if(te||(se=""),te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(he=ye.call({lexer:ee},ce,de))?(ce=ce.substring(he.raw.length),de.push(he),!0):!1}))){if(he=this.tokenizer.escape(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.tag(ce)){ce=ce.substring(he.raw.length),be=de[de.length-1],be&&he.type==="text"&&be.type==="text"?(be.raw+=he.raw,be.text+=he.text):de.push(he);continue}if(he=this.tokenizer.link(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(he.raw.length),be=de[de.length-1],be&&he.type==="text"&&be.type==="text"?(be.raw+=he.raw,be.text+=he.text):de.push(he);continue}if(he=this.tokenizer.emStrong(ce,B,se)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.codespan(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.br(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.del(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.autolink(ce,K)){ce=ce.substring(he.raw.length),de.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(ce,K))){ce=ce.substring(he.raw.length),de.push(he);continue}if(Pe=ce,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,je=ce.slice(1),We=void 0;ee.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},je),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Pe=ce.substring(0,ye+1))}(),he=this.tokenizer.inlineText(Pe,T)){ce=ce.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(se=he.raw.slice(-1)),te=!0,be=de[de.length-1],be&&be.type==="text"?(be.raw+=he.raw,be.text+=he.text):de.push(he);continue}if(ce){var ge="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return de},C(ie,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),ie}(),fe=function(){function ie(Ee){this.options=Ee||$e.defaults}var re=ie.prototype;return re.code=function(ce,de,ee){var he=(de||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(ce,he);be!=null&&be!==ce&&(ee=!0,ce=be)}return ce=ce.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+D(he,!0)+'">'+(ee?ce:D(ce,!0))+`</code></pre>
`:"<pre><code>"+(ee?ce:D(ce,!0))+`</code></pre>
`},re.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},re.html=function(ce){return ce},re.heading=function(ce,de,ee,he){if(this.options.headerIds){var be=this.options.headerPrefix+he.slug(ee);return"<h"+de+' id="'+be+'">'+ce+"</h"+de+`>
`}return"<h"+de+">"+ce+"</h"+de+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(ce,de,ee){var he=de?"ol":"ul",be=de&&ee!==1?' start="'+ee+'"':"";return"<"+he+be+`>
`+ce+"</"+he+`>
`},re.listitem=function(ce){return"<li>"+ce+`</li>
`},re.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(ce){return"<p>"+ce+`</p>
`},re.table=function(ce,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+de+`</table>
`},re.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},re.tablecell=function(ce,de){var ee=de.header?"th":"td",he=de.align?"<"+ee+' align="'+de.align+'">':"<"+ee+">";return he+ce+("</"+ee+`>
`)},re.strong=function(ce){return"<strong>"+ce+"</strong>"},re.em=function(ce){return"<em>"+ce+"</em>"},re.codespan=function(ce){return"<code>"+ce+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(ce){return"<del>"+ce+"</del>"},re.link=function(ce,de,ee){if(ce=h(this.options.sanitize,this.options.baseUrl,ce),ce===null)return ee;var he='<a href="'+D(ce)+'"';return de&&(he+=' title="'+de+'"'),he+=">"+ee+"</a>",he},re.image=function(ce,de,ee){if(ce=h(this.options.sanitize,this.options.baseUrl,ce),ce===null)return ee;var he='<img src="'+ce+'" alt="'+ee+'"';return de&&(he+=' title="'+de+'"'),he+=this.options.xhtml?"/>":">",he},re.text=function(ce){return ce},ie}(),X=function(){function ie(){}var re=ie.prototype;return re.strong=function(ce){return ce},re.em=function(ce){return ce},re.codespan=function(ce){return ce},re.del=function(ce){return ce},re.html=function(ce){return ce},re.text=function(ce){return ce},re.link=function(ce,de,ee){return""+ee},re.image=function(ce,de,ee){return""+ee},re.br=function(){return""},ie}(),Q=function(){function ie(){this.seen={}}var re=ie.prototype;return re.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(ce,de){var ee=ce,he=0;if(this.seen.hasOwnProperty(ee)){he=this.seen[ce];do he++,ee=ce+"-"+he;while(this.seen.hasOwnProperty(ee))}return de||(this.seen[ce]=he,this.seen[ee]=0),ee},re.slug=function(ce,de){de===void 0&&(de={});var ee=this.serialize(ce);return this.getNextSafeSlug(ee,de.dryrun)},ie}(),Z=function(){function ie(Ee){this.options=Ee||$e.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new Q}ie.parse=function(ce,de){var ee=new ie(de);return ee.parse(ce)},ie.parseInline=function(ce,de){var ee=new ie(de);return ee.parseInline(ce)};var re=ie.prototype;return re.parse=function(ce,de){de===void 0&&(de=!0);var ee="",he,be,Pe,B,J,te,se,Y,ge,ye,je,We,_e,Ye,it,et,Ae,Oe,qe,Me=ce.length;for(he=0;he<Me;he++){if(ye=ce[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(qe=this.options.extensions.renderers[ye.type].call({parser:this},ye),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ee+=qe||"";continue}switch(ye.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,l(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(Y="",se="",B=ye.header.length,be=0;be<B;be++)se+=this.renderer.tablecell(this.parseInline(ye.header[be].tokens),{header:!0,align:ye.align[be]});for(Y+=this.renderer.tablerow(se),ge="",B=ye.rows.length,be=0;be<B;be++){for(te=ye.rows[be],se="",J=te.length,Pe=0;Pe<J;Pe++)se+=this.renderer.tablecell(this.parseInline(te[Pe].tokens),{header:!1,align:ye.align[Pe]});ge+=this.renderer.tablerow(se)}ee+=this.renderer.table(Y,ge);continue}case"blockquote":{ge=this.parse(ye.tokens),ee+=this.renderer.blockquote(ge);continue}case"list":{for(je=ye.ordered,We=ye.start,_e=ye.loose,B=ye.items.length,ge="",be=0;be<B;be++)it=ye.items[be],et=it.checked,Ae=it.task,Ye="",it.task&&(Oe=this.renderer.checkbox(et),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Oe+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Oe+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Oe}):Ye+=Oe),Ye+=this.parse(it.tokens,_e),ge+=this.renderer.listitem(Ye,Ae,et);ee+=this.renderer.list(ge,je,We);continue}case"html":{ee+=this.renderer.html(ye.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(ge=ye.tokens?this.parseInline(ye.tokens):ye.text;he+1<Me&&ce[he+1].type==="text";)ye=ce[++he],ge+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ee+=de?this.renderer.paragraph(ge):ge;continue}default:{var Ze='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return ee},re.parseInline=function(ce,de){de=de||this.renderer;var ee="",he,be,Pe,B=ce.length;for(he=0;he<B;he++){if(be=ce[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Pe=this.options.extensions.renderers[be.type].call({parser:this},be),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){ee+=Pe||"";continue}switch(be.type){case"escape":{ee+=de.text(be.text);break}case"html":{ee+=de.html(be.text);break}case"link":{ee+=de.link(be.href,be.title,this.parseInline(be.tokens,de));break}case"image":{ee+=de.image(be.href,be.title,be.text);break}case"strong":{ee+=de.strong(this.parseInline(be.tokens,de));break}case"em":{ee+=de.em(this.parseInline(be.tokens,de));break}case"codespan":{ee+=de.codespan(be.text);break}case"br":{ee+=de.br();break}case"del":{ee+=de.del(this.parseInline(be.tokens,de));break}case"text":{ee+=de.text(be.text);break}default:{var J='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return ee},ie}();function oe(ie,re,Ee){if(typeof ie>"u"||ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");if(typeof re=="function"&&(Ee=re,re=null),re=S({},oe.defaults,re||{}),g(re),Ee){var ce=re.highlight,de;try{de=V.lex(ie,re)}catch(B){return Ee(B)}var ee=function(J){var te;if(!J)try{re.walkTokens&&oe.walkTokens(de,re.walkTokens),te=Z.parse(de,re)}catch(se){J=se}return re.highlight=ce,J?Ee(J):Ee(null,te)};if(!ce||ce.length<3||(delete re.highlight,!de.length))return ee();var he=0;oe.walkTokens(de,function(B){B.type==="code"&&(he++,setTimeout(function(){ce(B.text,B.lang,function(J,te){if(J)return ee(J);te!=null&&te!==B.text&&(B.text=te,B.escaped=!0),he--,he===0&&ee()})},0))}),he===0&&ee();return}function be(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+D(B.message+"",!0)+"</pre>";throw B}try{var Pe=V.lex(ie,re);if(re.walkTokens){if(re.async)return Promise.all(oe.walkTokens(Pe,re.walkTokens)).then(function(){return Z.parse(Pe,re)}).catch(be);oe.walkTokens(Pe,re.walkTokens)}return Z.parse(Pe,re)}catch(B){be(B)}}oe.options=oe.setOptions=function(ie){return S(oe.defaults,ie),b(oe.defaults),oe},oe.getDefaults=A,oe.defaults=$e.defaults,oe.use=function(){for(var ie=arguments.length,re=new Array(ie),Ee=0;Ee<ie;Ee++)re[Ee]=arguments[Ee];var ce=S.apply(void 0,[{}].concat(re)),de=oe.defaults.extensions||{renderers:{},childTokens:{}},ee;re.forEach(function(he){if(he.extensions&&(ee=!0,he.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=de.renderers?de.renderers[Pe.name]:null;B?de.renderers[Pe.name]=function(){for(var J=arguments.length,te=new Array(J),se=0;se<J;se++)te[se]=arguments[se];var Y=Pe.renderer.apply(this,te);return Y===!1&&(Y=B.apply(this,te)),Y}:de.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Pe.level]?de[Pe.level].unshift(Pe.tokenizer):de[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?de.startBlock?de.startBlock.push(Pe.start):de.startBlock=[Pe.start]:Pe.level==="inline"&&(de.startInline?de.startInline.push(Pe.start):de.startInline=[Pe.start]))}Pe.childTokens&&(de.childTokens[Pe.name]=Pe.childTokens)})),he.renderer&&function(){var Pe=oe.defaults.renderer||new fe,B=function(se){var Y=Pe[se];Pe[se]=function(){for(var ge=arguments.length,ye=new Array(ge),je=0;je<ge;je++)ye[je]=arguments[je];var We=he.renderer[se].apply(Pe,ye);return We===!1&&(We=Y.apply(Pe,ye)),We}};for(var J in he.renderer)B(J);ce.renderer=Pe}(),he.tokenizer&&function(){var Pe=oe.defaults.tokenizer||new L,B=function(se){var Y=Pe[se];Pe[se]=function(){for(var ge=arguments.length,ye=new Array(ge),je=0;je<ge;je++)ye[je]=arguments[je];var We=he.tokenizer[se].apply(Pe,ye);return We===!1&&(We=Y.apply(Pe,ye)),We}};for(var J in he.tokenizer)B(J);ce.tokenizer=Pe}(),he.walkTokens){var be=oe.defaults.walkTokens;ce.walkTokens=function(Pe){var B=[];return B.push(he.walkTokens.call(this,Pe)),be&&(B=B.concat(be.call(this,Pe))),B}}ee&&(ce.extensions=de),oe.setOptions(ce)})},oe.walkTokens=function(ie,re){for(var Ee=[],ce=function(){var be=ee.value;switch(Ee=Ee.concat(re.call(oe,be)),be.type){case"table":{for(var Pe=M(be.header),B;!(B=Pe()).done;){var J=B.value;Ee=Ee.concat(oe.walkTokens(J.tokens,re))}for(var te=M(be.rows),se;!(se=te()).done;)for(var Y=se.value,ge=M(Y),ye;!(ye=ge()).done;){var je=ye.value;Ee=Ee.concat(oe.walkTokens(je.tokens,re))}break}case"list":{Ee=Ee.concat(oe.walkTokens(be.items,re));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[be.type]?oe.defaults.extensions.childTokens[be.type].forEach(function(We){Ee=Ee.concat(oe.walkTokens(be[We],re))}):be.tokens&&(Ee=Ee.concat(oe.walkTokens(be.tokens,re)))}},de=M(ie),ee;!(ee=de()).done;)ce();return Ee},oe.parseInline=function(ie,re){if(typeof ie>"u"||ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");re=S({},oe.defaults,re||{}),g(re);try{var Ee=V.lexInline(ie,re);return re.walkTokens&&oe.walkTokens(Ee,re.walkTokens),Z.parseInline(Ee,re)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+D(ce.message+"",!0)+"</pre>";throw ce}},oe.Parser=Z,oe.parser=Z.parse,oe.Renderer=fe,oe.TextRenderer=X,oe.Lexer=V,oe.lexer=V.lex,oe.Tokenizer=L,oe.Slugger=Q,oe.parse=oe;var x=oe.options,ae=oe.setOptions,ve=oe.use,G=oe.walkTokens,U=oe.parseInline,q=oe,me=Z.parse,_=V.lex;$e.Lexer=V,$e.Parser=Z,$e.Renderer=fe,$e.Slugger=Q,$e.TextRenderer=X,$e.Tokenizer=L,$e.getDefaults=A,$e.lexer=_,$e.marked=oe,$e.options=x,$e.parse=q,$e.parseInline=U,$e.parser=me,$e.setOptions=ae,$e.use=ve,$e.walkTokens=G,Object.defineProperty($e,"__esModule",{value:!0})}),define(De[76],Ce([1,0,28]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nl=e.$ml=e.$ll=void 0;const F=new C.$Cc(1e4);function d(w){return E(w,"NFC",F)}e.$ll=d;const M=new C.$Cc(1e4);function A(w){return E(w,"NFD",M)}e.$ml=A;const b=/[^\u0000-\u0080]/;function E(w,R,I){if(!w)return w;const v=I.get(w);if(v)return v;let y;return b.test(w)?y=w.normalize(R):y=w,I.set(w,y),y}e.$nl=function(){const w=/[\u0300-\u036f]/g;return function(R){return A(R).replace(w,"")}}()}),define(De[120],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Nl=e.rot=e.$Ll=void 0;function C(b,E,w){return Math.min(Math.max(b,E),w)}e.$Ll=C;function F(b,E){return(E+b%E)%E}e.rot=F;class d{constructor(){this.a=0}getNext(){return this.a++}}e.$Nl=d;class M{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ol=M;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const w=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pl=A}),function(){function $e(d){const M=[];typeof d=="number"&&M.push("code/timeOrigin",d);function A(E){M.push(E,Date.now())}function b(){const E=[];for(let w=0;w<M.length;w+=2)E.push({name:M[w],startTime:M[w+1]});return E}return{mark:A,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(d){performance.mark(d)},getMarks(){let d=performance.timeOrigin;typeof d!="number"&&(d=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(d)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(d+A.startTime)});return M}};if(typeof process=="object"){const d=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(d)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function C(d){return d.MonacoPerformanceMarks||(d.MonacoPerformanceMarks=e()),d.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=C(F))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var F in C)(typeof exports=="object"?exports:$e)[F]=C[F]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function C(F){if(e[F])return e[F].exports;var d=e[F]={i:F,l:!1,exports:{}};return $e[F].call(d.exports,d,d.exports,C),d.l=!0,d.exports}return C.m=$e,C.c=e,C.d=function(F,d,M){C.o(F,d)||Object.defineProperty(F,d,{enumerable:!0,get:M})},C.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},C.t=function(F,d){if(1&d&&(F=C(F)),8&d||4&d&&typeof F=="object"&&F&&F.__esModule)return F;var M=Object.create(null);if(C.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:F}),2&d&&typeof F!="string")for(var A in F)C.d(M,A,function(b){return F[b]}.bind(null,A));return M},C.n=function(F){var d=F&&F.__esModule?function(){return F.default}:function(){return F};return C.d(d,"a",d),d},C.o=function(F,d){return Object.prototype.hasOwnProperty.call(F,d)},C.p="",C(C.s=0)}([function($e,e,C){(function(F){var d;e=$e.exports=ve,d=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],E=e.src=[],w=0,R=w++;E[R]="0|[1-9]\\d*";var I=w++;E[I]="[0-9]+";var v=w++;E[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=w++;E[y]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var D=w++;E[D]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var p=w++;E[p]="(?:"+E[R]+"|"+E[v]+")";var l=w++;E[l]="(?:"+E[I]+"|"+E[v]+")";var c=w++;E[c]="(?:-("+E[p]+"(?:\\."+E[p]+")*))";var r=w++;E[r]="(?:-?("+E[l]+"(?:\\."+E[l]+")*))";var o=w++;E[o]="[0-9A-Za-z-]+";var m=w++;E[m]="(?:\\+("+E[o]+"(?:\\."+E[o]+")*))";var h=w++,t="v?"+E[y]+E[c]+"?"+E[m]+"?";E[h]="^"+t+"$";var n="[v=\\s]*"+E[D]+E[r]+"?"+E[m]+"?",a=w++;E[a]="^"+n+"$";var i=w++;E[i]="((?:<|>)?=?)";var s=w++;E[s]=E[I]+"|x|X|\\*";var u=w++;E[u]=E[R]+"|x|X|\\*";var S=w++;E[S]="[v=\\s]*("+E[u]+")(?:\\.("+E[u]+")(?:\\.("+E[u]+")(?:"+E[c]+")?"+E[m]+"?)?)?";var k=w++;E[k]="[v=\\s]*("+E[s]+")(?:\\.("+E[s]+")(?:\\.("+E[s]+")(?:"+E[r]+")?"+E[m]+"?)?)?";var $=w++;E[$]="^"+E[i]+"\\s*"+E[S]+"$";var f=w++;E[f]="^"+E[i]+"\\s*"+E[k]+"$";var g=w++;E[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=w++;E[P]="(?:~>?)";var O=w++;E[O]="(\\s*)"+E[P]+"\\s+",b[O]=new RegExp(E[O],"g");var N=w++;E[N]="^"+E[P]+E[S]+"$";var L=w++;E[L]="^"+E[P]+E[k]+"$";var j=w++;E[j]="(?:\\^)";var z=w++;E[z]="(\\s*)"+E[j]+"\\s+",b[z]=new RegExp(E[z],"g");var T=w++;E[T]="^"+E[j]+E[S]+"$";var K=w++;E[K]="^"+E[j]+E[k]+"$";var V=w++;E[V]="^"+E[i]+"\\s*("+n+")$|^$";var fe=w++;E[fe]="^"+E[i]+"\\s*("+t+")$|^$";var X=w++;E[X]="(\\s*)"+E[i]+"\\s*("+n+"|"+E[S]+")",b[X]=new RegExp(E[X],"g");var Q=w++;E[Q]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var Z=w++;E[Z]="^\\s*("+E[k]+")\\s+-\\s+("+E[k]+")\\s*$";var oe=w++;E[oe]="(<|>)?=?\\s*\\*";for(var x=0;x<35;x++)d(x,E[x]),b[x]||(b[x]=new RegExp(E[x]));function ae(Y,ge){if(Y instanceof ve)return Y;if(typeof Y!="string"||Y.length>M||!(ge?b[a]:b[h]).test(Y))return null;try{return new ve(Y,ge)}catch{return null}}function ve(Y,ge){if(Y instanceof ve){if(Y.loose===ge)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ve))return new ve(Y,ge);d("SemVer",Y,ge),this.loose=ge;var ye=Y.trim().match(ge?b[a]:b[h]);if(!ye)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<A)return We}return je}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ae,e.valid=function(Y,ge){var ye=ae(Y,ge);return ye?ye.version:null},e.clean=function(Y,ge){var ye=ae(Y.trim().replace(/^[=v]+/,""),ge);return ye?ye.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(Y){return d("SemVer.compare",this.version,this.loose,Y),Y instanceof ve||(Y=new ve(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},ve.prototype.compareMain=function(Y){return Y instanceof ve||(Y=new ve(Y,this.loose)),U(this.major,Y.major)||U(this.minor,Y.minor)||U(this.patch,Y.patch)},ve.prototype.comparePre=function(Y){if(Y instanceof ve||(Y=new ve(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var ge=0;do{var ye=this.prerelease[ge],je=Y.prerelease[ge];if(d("prerelease compare",ge,ye,je),ye===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ye===void 0)return-1;if(ye!==je)return U(ye,je)}while(++ge)},ve.prototype.inc=function(Y,ge){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,ge,ye,je){typeof ye=="string"&&(je=ye,ye=void 0);try{return new ve(Y,ye).inc(ge,je).version}catch{return null}},e.diff=function(Y,ge){if(ie(Y,ge))return null;var ye=ae(Y),je=ae(ge);if(ye.prerelease.length||je.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return We},e.compareIdentifiers=U;var G=/^[0-9]+$/;function U(Y,ge){var ye=G.test(Y),je=G.test(ge);return ye&&je&&(Y=+Y,ge=+ge),ye&&!je?-1:je&&!ye?1:Y<ge?-1:Y>ge?1:0}function q(Y,ge,ye){return new ve(Y,ye).compare(new ve(ge,ye))}function me(Y,ge,ye){return q(Y,ge,ye)>0}function _(Y,ge,ye){return q(Y,ge,ye)<0}function ie(Y,ge,ye){return q(Y,ge,ye)===0}function re(Y,ge,ye){return q(Y,ge,ye)!==0}function Ee(Y,ge,ye){return q(Y,ge,ye)>=0}function ce(Y,ge,ye){return q(Y,ge,ye)<=0}function de(Y,ge,ye,je){var We;switch(ge){case"===":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),We=Y===ye;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),We=Y!==ye;break;case"":case"=":case"==":We=ie(Y,ye,je);break;case"!=":We=re(Y,ye,je);break;case">":We=me(Y,ye,je);break;case">=":We=Ee(Y,ye,je);break;case"<":We=_(Y,ye,je);break;case"<=":We=ce(Y,ye,je);break;default:throw new TypeError("Invalid operator: "+ge)}return We}function ee(Y,ge){if(Y instanceof ee){if(Y.loose===ge)return Y;Y=Y.value}if(!(this instanceof ee))return new ee(Y,ge);d("comparator",Y,ge),this.loose=ge,this.parse(Y),this.semver===he?this.value="":this.value=this.operator+this.semver.version,d("comp",this)}e.rcompareIdentifiers=function(Y,ge){return U(ge,Y)},e.major=function(Y,ge){return new ve(Y,ge).major},e.minor=function(Y,ge){return new ve(Y,ge).minor},e.patch=function(Y,ge){return new ve(Y,ge).patch},e.compare=q,e.compareLoose=function(Y,ge){return q(Y,ge,!0)},e.rcompare=function(Y,ge,ye){return q(ge,Y,ye)},e.sort=function(Y,ge){return Y.sort(function(ye,je){return e.compare(ye,je,ge)})},e.rsort=function(Y,ge){return Y.sort(function(ye,je){return e.rcompare(ye,je,ge)})},e.gt=me,e.lt=_,e.eq=ie,e.neq=re,e.gte=Ee,e.lte=ce,e.cmp=de,e.Comparator=ee;var he={};function be(Y,ge){if(Y instanceof be)return Y.loose===ge?Y:new be(Y.raw,ge);if(Y instanceof ee)return new be(Y.value,ge);if(!(this instanceof be))return new be(Y,ge);if(this.loose=ge,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Pe(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function B(Y,ge,ye,je,We,_e,Ye,it,et,Ae,Oe,qe,Me){return((ge=Pe(ye)?"":Pe(je)?">="+ye+".0.0":Pe(We)?">="+ye+"."+je+".0":">="+ge)+" "+(it=Pe(et)?"":Pe(Ae)?"<"+(+et+1)+".0.0":Pe(Oe)?"<"+et+"."+(+Ae+1)+".0":qe?"<="+et+"."+Ae+"."+Oe+"-"+qe:"<="+it)).trim()}function J(Y,ge){for(var ye=0;ye<Y.length;ye++)if(!Y[ye].test(ge))return!1;if(ge.prerelease.length){for(ye=0;ye<Y.length;ye++)if(d(Y[ye].semver),Y[ye].semver!==he&&Y[ye].semver.prerelease.length>0){var je=Y[ye].semver;if(je.major===ge.major&&je.minor===ge.minor&&je.patch===ge.patch)return!0}return!1}return!0}function te(Y,ge,ye){try{ge=new be(ge,ye)}catch{return!1}return ge.test(Y)}function se(Y,ge,ye,je){var We,_e,Ye,it,et;switch(Y=new ve(Y,je),ge=new be(ge,je),ye){case">":We=me,_e=ce,Ye=_,it=">",et=">=";break;case"<":We=_,_e=Ee,Ye=me,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(te(Y,ge,je))return!1;for(var Ae=0;Ae<ge.set.length;++Ae){var Oe=ge.set[Ae],qe=null,Me=null;if(Oe.forEach(function(Ze){Ze.semver===he&&(Ze=new ee(">=0.0.0")),qe=qe||Ze,Me=Me||Ze,We(Ze.semver,qe.semver,je)?qe=Ze:Ye(Ze.semver,Me.semver,je)&&(Me=Ze)}),qe.operator===it||qe.operator===et||(!Me.operator||Me.operator===it)&&_e(Y,Me.semver)||Me.operator===et&&Ye(Y,Me.semver))return!1}return!0}ee.prototype.parse=function(Y){var ge=this.loose?b[V]:b[fe],ye=Y.match(ge);if(!ye)throw new TypeError("Invalid comparator: "+Y);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new ve(ye[2],this.loose):this.semver=he},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Y){return d("Comparator.test",Y,this.loose),this.semver===he||(typeof Y=="string"&&(Y=new ve(Y,this.loose)),de(Y,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Y,ge){if(!(Y instanceof ee))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new be(Y.value,ge),te(this.value,ye,ge);if(Y.operator==="")return ye=new be(this.value,ge),te(Y.semver,ye,ge);var je=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),_e=this.semver.version===Y.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),it=de(this.semver,"<",Y.semver,ge)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),et=de(this.semver,">",Y.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return je||We||_e&&Ye||it||et},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Y){var ge=this.loose;Y=Y.trim(),d("range",Y,ge);var ye=ge?b[Z]:b[Q];Y=Y.replace(ye,B),d("hyphen replace",Y),Y=Y.replace(b[X],"$1$2$3"),d("comparator trim",Y,b[X]),Y=(Y=(Y=Y.replace(b[O],"$1~")).replace(b[z],"$1^")).split(/\s+/).join(" ");var je=ge?b[V]:b[fe],We=Y.split(" ").map(function(_e){return function(Ye,it){return d("comp",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Oe){return function(qe,Me){d("caret",qe,Me);var Ze=Me?b[K]:b[T];return qe.replace(Ze,function(le,ue,Ie,Ve,ze){var Xe;return d("caret",qe,le,ue,Ie,Ve,ze),Pe(ue)?Xe="":Pe(Ie)?Xe=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ve)?Xe=ue==="0"?">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+".0 <"+(+ue+1)+".0.0":ze?(d("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Xe=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ve+ze+" <"+ue+"."+Ie+"."+(+Ve+1):">="+ue+"."+Ie+"."+Ve+ze+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ve+ze+" <"+(+ue+1)+".0.0"):(d("no pr"),Xe=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ve+" <"+ue+"."+Ie+"."+(+Ve+1):">="+ue+"."+Ie+"."+Ve+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ve+" <"+(+ue+1)+".0.0"),d("caret return",Xe),Xe})}(Oe,Ae)}).join(" ")}(Ye,it),d("caret",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Oe){return function(qe,Me){var Ze=Me?b[L]:b[N];return qe.replace(Ze,function(le,ue,Ie,Ve,ze){var Xe;return d("tilde",qe,le,ue,Ie,Ve,ze),Pe(ue)?Xe="":Pe(Ie)?Xe=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ve)?Xe=">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":ze?(d("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Xe=">="+ue+"."+Ie+"."+Ve+ze+" <"+ue+"."+(+Ie+1)+".0"):Xe=">="+ue+"."+Ie+"."+Ve+" <"+ue+"."+(+Ie+1)+".0",d("tilde return",Xe),Xe})}(Oe,Ae)}).join(" ")}(Ye,it),d("tildes",Ye),Ye=function(et,Ae){return d("replaceXRanges",et,Ae),et.split(/\s+/).map(function(Oe){return function(qe,Me){qe=qe.trim();var Ze=Me?b[f]:b[$];return qe.replace(Ze,function(le,ue,Ie,Ve,ze,Xe){d("xRange",qe,le,ue,Ie,Ve,ze,Xe);var rt=Pe(Ie),ot=rt||Pe(Ve),wt=ot||Pe(ze);return ue==="="&&wt&&(ue=""),rt?le=ue===">"||ue==="<"?"<0.0.0":"*":ue&&wt?(ot&&(Ve=0),wt&&(ze=0),ue===">"?(ue=">=",ot?(Ie=+Ie+1,Ve=0,ze=0):wt&&(Ve=+Ve+1,ze=0)):ue==="<="&&(ue="<",ot?Ie=+Ie+1:Ve=+Ve+1),le=ue+Ie+"."+Ve+"."+ze):ot?le=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":wt&&(le=">="+Ie+"."+Ve+".0 <"+Ie+"."+(+Ve+1)+".0"),d("xRange return",le),le})}(Oe,Ae)}).join(" ")}(Ye,it),d("xrange",Ye),Ye=function(et,Ae){return d("replaceStars",et,Ae),et.trim().replace(b[oe],"")}(Ye,it),d("stars",Ye),Ye}(_e,ge)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(je)})),We=We.map(function(_e){return new ee(_e,ge)})},be.prototype.intersects=function(Y,ge){if(!(Y instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(je){return Y.set.some(function(We){return We.every(function(_e){return je.intersects(_e,ge)})})})})},e.toComparators=function(Y,ge){return new be(Y,ge).set.map(function(ye){return ye.map(function(je){return je.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new ve(Y,this.loose));for(var ge=0;ge<this.set.length;ge++)if(J(this.set[ge],Y))return!0;return!1},e.satisfies=te,e.maxSatisfying=function(Y,ge,ye){var je=null,We=null;try{var _e=new be(ge,ye)}catch{return null}return Y.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==-1||(We=new ve(je=Ye,ye)))}),je},e.minSatisfying=function(Y,ge,ye){var je=null,We=null;try{var _e=new be(ge,ye)}catch{return null}return Y.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==1||(We=new ve(je=Ye,ye)))}),je},e.validRange=function(Y,ge){try{return new be(Y,ge).range||"*"}catch{return null}},e.ltr=function(Y,ge,ye){return se(Y,ge,"<",ye)},e.gtr=function(Y,ge,ye){return se(Y,ge,">",ye)},e.outside=se,e.prerelease=function(Y,ge){var ye=ae(Y,ge);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(Y,ge,ye){return Y=new be(Y,ye),ge=new be(ge,ye),Y.intersects(ge)},e.coerce=function(Y){if(Y instanceof ve)return Y;if(typeof Y!="string")return null;var ge=Y.match(b[g]);return ge==null?null:ae((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,C(1))},function($e,e){var C,F,d=$e.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function b(l){if(C===setTimeout)return setTimeout(l,0);if((C===M||!C)&&setTimeout)return C=setTimeout,setTimeout(l,0);try{return C(l,0)}catch{try{return C.call(null,l,0)}catch{return C.call(this,l,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:M}catch{C=M}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var E,w=[],R=!1,I=-1;function v(){R&&E&&(R=!1,E.length?w=E.concat(w):I=-1,w.length&&y())}function y(){if(!R){var l=b(v);R=!0;for(var c=w.length;c;){for(E=w,w=[];++I<c;)E&&E[I].run();I=-1,c=w.length}E=null,R=!1,function(r){if(F===clearTimeout)return clearTimeout(r);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(r);try{F(r)}catch{try{return F.call(null,r)}catch{return F.call(this,r)}}}(l)}}function D(l,c){this.fun=l,this.array=c}function p(){}d.nextTick=function(l){var c=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)c[r-1]=arguments[r];w.push(new D(l,c)),w.length!==1||R||b(y)},D.prototype.run=function(){this.fun.apply(null,this.array)},d.title="browser",d.browser=!0,d.env={},d.argv=[],d.version="",d.versions={},d.on=p,d.addListener=p,d.once=p,d.off=p,d.removeListener=p,d.removeAllListeners=p,d.emit=p,d.prependListener=p,d.prependOnceListener=p,d.listeners=function(l){return[]},d.binding=function(l){throw new Error("process.binding is not supported")},d.cwd=function(){return"/"},d.chdir=function(l){throw new Error("process.chdir is not supported")},d.umask=function(){return 0}}])}),define(De[37],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(M){return new F(M)}constructor(M){this.c=C&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Id=F}),define(De[4],Ce([1,0,8,74,3,75,37]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.Event=void 0;const b=!1,E=!1;var w;(function($){$.None=()=>d.$Rc.None;function f(de){if(E){const{onDidAddListener:ee}=de,he=D.create();let be=0;de.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),ee?.()}}}function g(de,ee){return fe(de,()=>{},0,void 0,!0,void 0,ee)}$.defer=g;function P(de){return(ee,he=null,be)=>{let Pe=!1,B;return B=de(J=>{if(!Pe)return B?B.dispose():Pe=!0,ee.call(he,J)},null,be),Pe&&B.dispose(),B}}$.once=P;function O(de,ee,he){return K((be,Pe=null,B)=>de(J=>be.call(Pe,ee(J)),null,B),he)}$.map=O;function N(de,ee,he){return K((be,Pe=null,B)=>de(J=>{ee(J),be.call(Pe,J)},null,B),he)}$.forEach=N;function L(de,ee,he){return K((be,Pe=null,B)=>de(J=>ee(J)&&be.call(Pe,J),null,B),he)}$.filter=L;function j(de){return de}$.signal=j;function z(...de){return(ee,he=null,be)=>{const Pe=(0,d.$Oc)(...de.map(B=>B(J=>ee.call(he,J))));return V(Pe,be)}}$.any=z;function T(de,ee,he,be){let Pe=he;return O(de,B=>(Pe=ee(Pe,B),Pe),be)}$.reduce=T;function K(de,ee){let he;const be={onWillAddFirstListener(){he=de(Pe.fire,Pe)},onDidRemoveLastListener(){he?.dispose()}};ee||f(be);const Pe=new o(be);return ee?.add(Pe),Pe.event}function V(de,ee){return ee instanceof Array?ee.push(de):ee&&ee.add(de),de}function fe(de,ee,he=100,be=!1,Pe=!1,B,J){let te,se,Y,ge=0,ye;const je={leakWarningThreshold:B,onWillAddFirstListener(){te=de(_e=>{ge++,se=ee(se,_e),be&&!Y&&(We.fire(se),se=void 0),ye=()=>{const Ye=se;se=void 0,Y=void 0,(!be||ge>1)&&We.fire(Ye),ge=0},typeof he=="number"?(clearTimeout(Y),Y=setTimeout(ye,he)):Y===void 0&&(Y=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&ge>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,te.dispose()}};J||f(je);const We=new o(je);return J?.add(We),We.event}$.debounce=fe;function X(de,ee=0,he){return $.debounce(de,(be,Pe)=>be?(be.push(Pe),be):[Pe],ee,void 0,!0,void 0,he)}$.accumulate=X;function Q(de,ee=(be,Pe)=>be===Pe,he){let be=!0,Pe;return L(de,B=>{const J=be||!ee(B,Pe);return be=!1,Pe=B,J},he)}$.latch=Q;function Z(de,ee,he){return[$.filter(de,ee,he),$.filter(de,be=>!ee(be),he)]}$.split=Z;function oe(de,ee=!1,he=[],be){let Pe=he.slice(),B=de(se=>{Pe?Pe.push(se):te.fire(se)});be&&be.add(B);const J=()=>{Pe?.forEach(se=>te.fire(se)),Pe=null},te=new o({onWillAddFirstListener(){B||(B=de(se=>te.fire(se)),be&&be.add(B))},onDidAddFirstListener(){Pe&&(ee?setTimeout(J):J())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return be&&be.add(te),te.event}$.buffer=oe;function x(de,ee){return(be,Pe,B)=>{const J=ee(new ve);return de(function(te){const se=J.evaluate(te);se!==ae&&be.call(Pe,se)},void 0,B)}}$.chain=x;const ae=Symbol("HaltChainable");class ve{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(he=>(ee(he),he)),this}filter(ee){return this.f.push(he=>ee(he)?he:ae),this}reduce(ee,he){let be=he;return this.f.push(Pe=>(be=ee(be,Pe),be)),this}latch(ee=(he,be)=>he===be){let he=!0,be;return this.f.push(Pe=>{const B=he||!ee(Pe,be);return he=!1,be=Pe,B?Pe:ae}),this}evaluate(ee){for(const he of this.f)if(ee=he(ee),ee===ae)break;return ee}}function G(de,ee,he=be=>be){const be=(...te)=>J.fire(he(...te)),Pe=()=>de.on(ee,be),B=()=>de.removeListener(ee,be),J=new o({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return J.event}$.fromNodeEventEmitter=G;function U(de,ee,he=be=>be){const be=(...te)=>J.fire(he(...te)),Pe=()=>de.addEventListener(ee,be),B=()=>de.removeEventListener(ee,be),J=new o({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return J.event}$.fromDOMEventEmitter=U;function q(de){return new Promise(ee=>P(de)(ee))}$.toPromise=q;function me(de){const ee=new o;return de.then(he=>{ee.fire(he)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}$.fromPromise=me;function _(de,ee){return ee(void 0),de(he=>ee(he))}$.runAndSubscribe=_;function ie(de,ee){let he=null;function be(B){he?.dispose(),he=new d.$Qc,ee(B,he)}be(void 0);const Pe=de(B=>be(B));return(0,d.$Pc)(()=>{Pe.dispose(),he?.dispose()})}$.runAndSubscribeWithStore=ie;class re{constructor(ee,he){this._observable=ee,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};he||f(be),this.emitter=new o(be),he&&he.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,he){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(de,ee){return new re(de,ee).emitter.event}$.fromObservable=Ee;function ce(de){return ee=>{let he=0,be=!1;const Pe={beginUpdate(){he++},endUpdate(){he--,he===0&&(de.reportChanges(),be&&(be=!1,ee()))},handlePossibleChange(){},handleChange(){be=!0}};return de.addObserver(Pe),de.reportChanges(),{dispose(){de.removeObserver(Pe)}}}}$.fromObservableLight=ce})(w||(e.Event=w={}));class R{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${R.f++}`,R.all.add(this)}start(f){this.g=new A.$Id,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Kd=R;let I=-1;function v($){const f=I;return I=$,{dispose(){I=f}}}e.$Ld=v;class y{constructor(f,g=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=g,this.g=0}dispose(){this.f?.clear()}check(f,g){const P=this.threshold;if(P<=0||g<P)return;this.f||(this.f=new Map);const O=this.f.get(f.value)||0;if(this.f.set(f.value,O+1),this.g-=1,this.g<=0){this.g=P*.5;let N,L=0;for(const[j,z]of this.f)(!N||L<z)&&(N=j,L=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${L}):`),console.warn(N)}return()=>{const N=this.f.get(f.value)||0;this.f.set(f.value,N-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class l{constructor(f){this.value=f,this.id=p++}}const c=2,r=($,f)=>{if($ instanceof l)f($);else for(let g=0;g<$.length;g++){const P=$[g];P&&f(P)}};class o{constructor(f){this.w=0,this.f=f,this.g=I>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const f=this.t;queueMicrotask(()=>{r(f,g=>g.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,g,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),d.$Rc.None;if(this.m)return d.$Rc.None;g&&(f=f.bind(g));const O=new l(f);let N,L;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(O.stack=D.create(),N=this.g.check(O.stack,this.w+1)),b&&(O.stack=L??D.create()),this.t?this.t instanceof l?(this.u??=new h,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,d.$Pc)(()=>{N?.(),this.x(O)});return P instanceof d.$Qc?P.add(j):Array.isArray(P)&&P.push(j),j},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const g=this.t,P=g.indexOf(f);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,g[P]=void 0;const O=this.u.current===this;if(this.w*c<=g.length){let N=0;for(let L=0;L<g.length;L++)g[L]?g[N++]=g[L]:O&&(this.u.end--,N<this.u.i&&this.u.i--);g.length=N}}y(f,g){if(!f)return;const P=this.f?.onListenerError||C.$Z;if(!P){f.value(g);return}try{f.value(g)}catch(O){P(O)}}z(f){const g=f.current.t;for(;f.i<f.end;)this.y(g[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,f);else{const g=this.u;g.enqueue(this,f,this.t.length),this.z(g)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Md=o;const m=()=>new h;e.$Nd=m;class h{constructor(){this.i=-1,this.end=0}enqueue(f,g,P){this.i=0,this.end=P,this.current=f,this.value=g}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends o{async fireAsync(f,g,P){if(this.t)for(this.h||(this.h=new M.$1c),r(this.t,O=>this.h.push([O.value,f]));this.h.size>0&&!g.isCancellationRequested;){const[O,N]=this.h.shift(),L=[],j={...N,token:g,waitUntil:z=>{if(Object.isFrozen(L))throw new Error("waitUntil can NOT be called asynchronous");P&&(z=P(z,O)),L.push(z)}};try{O(j)}catch(z){(0,C.$Z)(z);continue}Object.freeze(L),await Promise.allSettled(L).then(z=>{for(const T of z)T.status==="rejected"&&(0,C.$Z)(T.reason)})}}}e.$Od=t;class n extends o{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new M.$1c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Pd=n;class a extends n{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$Qd=a;class i extends o{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(g=>super.fire(g)),this.h=[]}))}}e.$Rd=i;class s{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const g={event:f,listener:null};this.h.push(g),this.g&&this.m(g);const P=()=>{this.g&&this.o(g);const O=this.h.indexOf(g);this.h.splice(O,1)};return(0,d.$Pc)((0,F.$cb)(P))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(g=>this.f.fire(g))}o(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.f.dispose()}}e.$Sd=s;class u{constructor(f,g,P,O){this.f=new d.$Qc;const N=this.f.add(new s),L=this.f.add(new d.$Zc);function j(z){L.set(z,N.add(O(z)))}for(const z of f)j(z);this.f.add(g(z=>{j(z)})),this.f.add(P(z=>{L.deleteAndDispose(z)})),this.event=N.event}dispose(){this.f.dispose()}}e.$Td=u;class S{constructor(){this.f=[]}wrapEvent(f){return(g,P,O)=>f(N=>{const L=this.f[this.f.length-1];L?L.push(()=>g.call(P,N)):g.call(P,N)},void 0,O)}bufferEvents(f){const g=[];this.f.push(g);const P=f();return this.f.pop(),g.forEach(O=>O()),P}}e.$Ud=S;class k{constructor(){this.f=!1,this.g=w.None,this.h=d.$Rc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Vd=k}),define(De[21],Ce([1,0,4]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.CancellationToken=void 0;const F=Object.freeze(function(b,E){const w=setTimeout(b.bind(E),0);return{dispose(){clearTimeout(w)}}});var d;(function(b){function E(w){return w===b.None||w===b.Cancelled||w instanceof M?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}b.isCancellationToken=E,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(d||(e.CancellationToken=d={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new C.$Md),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=d.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=d.None}}e.$Wd=A}),define(De[159],Ce([1,0,21]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=void 0;class F{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new C.$Wd,E=this.b(b.token);return this.a={promise:E,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$ve=F;class d{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const E=JSON.stringify(b);return this.b!==E&&(this.b=E,this.a=this.c(b)),this.a}}e.$we=d;class M{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const E=this.b(b);return this.a.set(b,E),E}}e.$xe=M}),define(De[96],Ce([1,0,8,3]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function d(m){const h=m;return h?typeof h.read=="function":!1}e.$Xd=d;function M(m){const h=m;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}e.$Yd=M;function A(m){const h=m;return h?M(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$Zd=A;function b(m,h){return new E(m,h)}e.$1d=b;class E{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,C.$Z)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let n;switch(h){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const a=n.indexOf(t);a>=0&&n.splice(a,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(m,h){const t=[];let n;for(;(n=m.read())!==null;)t.push(n);return h(t)}e.$2d=w;function R(m,h,t){const n=[];let a;for(;(a=m.read())!==null&&n.length<t;)n.push(a);return a===null&&n.length>0?h(n):{read:()=>{if(n.length>0)return n.shift();if(typeof a<"u"){const i=a;return a=void 0,i}return m.read()}}}e.$3d=R;function I(m,h){return new Promise((t,n)=>{const a=[];v(m,{onData:i=>{h&&a.push(i)},onError:i=>{h?n(i):t(void 0)},onEnd:()=>{t(h?h(a):void 0)}})})}e.$4d=I;function v(m,h,t){m.on("error",n=>{t?.isCancellationRequested||h.onError(n)}),m.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),m.on("data",n=>{t?.isCancellationRequested||h.onData(n)})}e.$5d=v;function y(m,h){return new Promise((t,n)=>{const a=new F.$Qc,i=[],s=k=>{if(i.push(k),i.length>h)return a.dispose(),m.pause(),t({stream:m,buffer:i,ended:!1})},u=k=>(a.dispose(),n(k)),S=()=>(a.dispose(),t({stream:m,buffer:i,ended:!0}));a.add((0,F.$Pc)(()=>m.removeListener("error",u))),m.on("error",u),a.add((0,F.$Pc)(()=>m.removeListener("end",S))),m.on("end",S),a.add((0,F.$Pc)(()=>m.removeListener("data",s))),m.on("data",s)})}e.$6d=y;function D(m,h){const t=b(h);return t.end(m),t}e.$7d=D;function p(){const m=b(()=>{throw new Error("not supported")});return m.end(),m}e.$8d=p;function l(m){let h=!1;return{read:()=>h?null:(h=!0,m)}}e.$9d=l;function c(m,h,t){const n=b(t);return v(m,{onData:a=>n.write(h.data(a)),onError:a=>n.error(h.error?h.error(a):a),onEnd:()=>n.end()}),n}e.$0d=c;function r(m,h,t){let n=!1;return{read:()=>{const a=h.read();return n?a:(n=!0,a!==null?t([m,a]):m)}}}e.$$d=r;function o(m,h,t){let n=!1;const a=b(t);return v(h,{onData:i=>n?a.write(i):(n=!0,a.write(t([m,i]))),onError:i=>a.error(i),onEnd:()=>{n||(n=!0,a.write(m)),a.end()}}),a}e.$_d=o}),define(De[22],Ce([1,0,46,96]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const d=typeof Buffer<"u",M=new C.$U(()=>new Uint8Array(256));let A,b;class E{static alloc(g){return d?new E(Buffer.allocUnsafe(g)):new E(new Uint8Array(g))}static wrap(g){return d&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new E(g)}static fromString(g,P){return!(P?.dontUseNodeBuffer||!1)&&d?new E(Buffer.from(g)):(A||(A=new TextEncoder),new E(A.encode(g)))}static fromByteArray(g){const P=E.alloc(g.length);for(let O=0,N=g.length;O<N;O++)P.buffer[O]=g[O];return P}static concat(g,P){if(typeof P>"u"){P=0;for(let L=0,j=g.length;L<j;L++)P+=g[L].byteLength}const O=E.alloc(P);let N=0;for(let L=0,j=g.length;L<j;L++){const z=g[L];O.set(z,N),N+=z.byteLength}return O}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=E.alloc(this.byteLength);return g.set(this),g}toString(){return d?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(g,P){return new E(this.buffer.subarray(g,P))}set(g,P){if(g instanceof E)this.buffer.set(g.buffer,P);else if(g instanceof Uint8Array)this.buffer.set(g,P);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),P);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return v(this.buffer,g)}writeUInt32BE(g,P){y(this.buffer,g,P)}readUInt32LE(g){return D(this.buffer,g)}writeUInt32LE(g,P){p(this.buffer,g,P)}readUInt8(g){return l(this.buffer,g)}writeUInt8(g,P){c(this.buffer,g,P)}indexOf(g,P=0){return w(this.buffer,g instanceof E?g.buffer:g,P)}}e.$ae=E;function w(f,g,P=0){const O=g.byteLength,N=f.byteLength;if(O===0)return 0;if(O===1)return f.indexOf(g[0]);if(O>N-P)return-1;const L=M.value;L.fill(g.length);for(let K=0;K<g.length;K++)L[g[K]]=g.length-K-1;let j=P+g.length-1,z=j,T=-1;for(;j<N;)if(f[j]===g[z]){if(z===0){T=j;break}j--,z--}else j+=Math.max(g.length-z,L[f[j]]),z=g.length-1;return T}e.$be=w;function R(f,g){return f[g+0]<<0>>>0|f[g+1]<<8>>>0}e.$ce=R;function I(f,g,P){f[P+0]=g&255,g=g>>>8,f[P+1]=g&255}e.$de=I;function v(f,g){return f[g]*2**24+f[g+1]*2**16+f[g+2]*2**8+f[g+3]}e.$ee=v;function y(f,g,P){f[P+3]=g,g=g>>>8,f[P+2]=g,g=g>>>8,f[P+1]=g,g=g>>>8,f[P]=g}e.$fe=y;function D(f,g){return f[g+0]<<0>>>0|f[g+1]<<8>>>0|f[g+2]<<16>>>0|f[g+3]<<24>>>0}e.$ge=D;function p(f,g,P){f[P+0]=g&255,g=g>>>8,f[P+1]=g&255,g=g>>>8,f[P+2]=g&255,g=g>>>8,f[P+3]=g&255}e.$he=p;function l(f,g){return f[g]}e.$ie=l;function c(f,g,P){f[P]=g}e.$je=c;function r(f){return F.$2d(f,g=>E.concat(g))}e.$ke=r;function o(f){return F.$9d(f)}e.$le=o;function m(f){return F.$4d(f,g=>E.concat(g))}e.$me=m;async function h(f){return f.ended?E.concat(f.buffer):E.concat([...f.buffer,await m(f.stream)])}e.$ne=h;function t(f){return F.$7d(f,g=>E.concat(g))}e.$oe=t;function n(f){return F.$0d(f,{data:g=>typeof g=="string"?E.fromString(g):E.wrap(g)},g=>E.concat(g))}e.$pe=n;function a(f){return F.$1d(g=>E.concat(g),f)}e.$qe=a;function i(f,g){return F.$$d(f,g,P=>E.concat(P))}e.$re=i;function s(f,g){return F.$_d(f,g,P=>E.concat(P))}e.$se=s;function u(f){let g=0,P=0,O=0;const N=new Uint8Array(Math.floor(f.length/4*3)),L=z=>{switch(P){case 3:N[O++]=g|z,P=0;break;case 2:N[O++]=g|z>>>2,g=z<<6,P=3;break;case 1:N[O++]=g|z>>>4,g=z<<4,P=2;break;default:g=z<<2,P=1}};for(let z=0;z<f.length;z++){const T=f.charCodeAt(z);if(T>=65&&T<=90)L(T-65);else if(T>=97&&T<=122)L(T-97+26);else if(T>=48&&T<=57)L(T-48+52);else if(T===43||T===45)L(62);else if(T===47||T===95)L(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${f[z]}`)}}const j=O;for(;P>0;)L(0);return E.wrap(N).slice(0,j)}e.$te=u;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:f},g=!0,P=!1){const O=P?k:S;let N="";const L=f.byteLength%3;let j=0;for(;j<f.byteLength-L;j+=3){const z=f[j+0],T=f[j+1],K=f[j+2];N+=O[z>>>2],N+=O[(z<<4|T>>>4)&63],N+=O[(T<<2|K>>>6)&63],N+=O[K&63]}if(L===1){const z=f[j+0];N+=O[z>>>2],N+=O[z<<4&63],g&&(N+="==")}else if(L===2){const z=f[j+0],T=f[j+1];N+=O[z>>>2],N+=O[(z<<4|T>>>4)&63],N+=O[T<<2&63],g&&(N+="=")}return N}e.$ue=$}),define(De[15],Ce([1,0,159,46]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wf=e.$vf=e.$uf=e.$tf=e.GraphemeBreakType=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function d(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Ae=d;const M=/{(\d+)}/g;function A(Ae,...Oe){return Oe.length===0?Ae:Ae.replace(M,function(qe,Me){const Ze=parseInt(Me,10);return isNaN(Ze)||Ze<0||Ze>=Oe.length?qe:Oe[Ze]})}e.$Be=A;const b=/{([^}]+)}/g;function E(Ae,Oe){return Ae.replace(b,(qe,Me)=>Oe[Me]??qe)}e.$Ce=E;function w(Ae){return Ae.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.$De=w;function R(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ee=R;function I(Ae,Oe){let qe=0;const Me=Oe.charCodeAt(0);for(let Ze=Ae.length-1;Ze>=0;Ze--)Ae.charCodeAt(Ze)===Me&&qe++;return qe}e.$Fe=I;function v(Ae,Oe,qe="\u2026"){return Ae.length<=Oe?Ae:`${Ae.substr(0,Oe)}${qe}`}e.$Ge=v;function y(Ae,Oe=" "){const qe=D(Ae,Oe);return p(qe,Oe)}e.$He=y;function D(Ae,Oe){if(!Ae||!Oe)return Ae;const qe=Oe.length;if(qe===0||Ae.length===0)return Ae;let Me=0;for(;Ae.indexOf(Oe,Me)===Me;)Me=Me+qe;return Ae.substring(Me)}e.$Ie=D;function p(Ae,Oe){if(!Ae||!Oe)return Ae;const qe=Oe.length,Me=Ae.length;if(qe===0||Me===0)return Ae;let Ze=Me,le=-1;for(;le=Ae.lastIndexOf(Oe,Ze-1),!(le===-1||le+qe!==Ze);){if(le===0)return"";Ze=le}return Ae.substring(0,Ze)}e.$Je=p;function l(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ke=l;function c(Ae){return Ae.replace(/\*/g,"")}e.$Le=c;function r(Ae,Oe,qe={}){if(!Ae)throw new Error("Cannot create regex from empty string");Oe||(Ae=R(Ae)),qe.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Me="";return qe.global&&(Me+="g"),qe.matchCase||(Me+="i"),qe.multiline&&(Me+="m"),qe.unicode&&(Me+="u"),new RegExp(Ae,Me)}e.$Me=r;function o(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Ne=o;function m(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Oe=m;function h(Ae){for(let Oe=0,qe=Ae.length;Oe<qe;Oe++){const Me=Ae.charCodeAt(Oe);if(Me!==32&&Me!==9)return Oe}return-1}e.$Pe=h;function t(Ae,Oe=0,qe=Ae.length){for(let Me=Oe;Me<qe;Me++){const Ze=Ae.charCodeAt(Me);if(Ze!==32&&Ze!==9)return Ae.substring(Oe,Me)}return Ae.substring(Oe,qe)}e.$Qe=t;function n(Ae,Oe=Ae.length-1){for(let qe=Oe;qe>=0;qe--){const Me=Ae.charCodeAt(qe);if(Me!==32&&Me!==9)return qe}return-1}e.$Re=n;function a(Ae,Oe,qe){const Me=[];let Ze=0;for(const le of Ae.matchAll(Oe)){if(Me.push(Ae.slice(Ze,le.index)),le.index===void 0)throw new Error("match.index should be defined");Ze=le.index+le[0].length,Me.push(qe(le[0],...le.slice(1),le.index,Ae,le.groups))}return Me.push(Ae.slice(Ze)),Promise.all(Me).then(le=>le.join(""))}e.$Se=a;function i(Ae,Oe){return Ae<Oe?-1:Ae>Oe?1:0}e.$Te=i;function s(Ae,Oe,qe=0,Me=Ae.length,Ze=0,le=Oe.length){for(;qe<Me&&Ze<le;qe++,Ze++){const Ve=Ae.charCodeAt(qe),ze=Oe.charCodeAt(Ze);if(Ve<ze)return-1;if(Ve>ze)return 1}const ue=Me-qe,Ie=le-Ze;return ue<Ie?-1:ue>Ie?1:0}e.$Ue=s;function u(Ae,Oe){return S(Ae,Oe,0,Ae.length,0,Oe.length)}e.$Ve=u;function S(Ae,Oe,qe=0,Me=Ae.length,Ze=0,le=Oe.length){for(;qe<Me&&Ze<le;qe++,Ze++){let Ve=Ae.charCodeAt(qe),ze=Oe.charCodeAt(Ze);if(Ve===ze)continue;if(Ve>=128||ze>=128)return s(Ae.toLowerCase(),Oe.toLowerCase(),qe,Me,Ze,le);$(Ve)&&(Ve-=32),$(ze)&&(ze-=32);const Xe=Ve-ze;if(Xe!==0)return Xe}const ue=Me-qe,Ie=le-Ze;return ue<Ie?-1:ue>Ie?1:0}e.$We=S;function k(Ae){return Ae>=48&&Ae<=57}e.$Xe=k;function $(Ae){return Ae>=97&&Ae<=122}e.$Ye=$;function f(Ae){return Ae>=65&&Ae<=90}e.$Ze=f;function g(Ae,Oe){return Ae.length===Oe.length&&S(Ae,Oe)===0}e.$1e=g;function P(Ae,Oe){const qe=Oe.length;return Oe.length>Ae.length?!1:S(Ae,Oe,0,qe)===0}e.$2e=P;function O(Ae,Oe){const qe=Math.min(Ae.length,Oe.length);let Me;for(Me=0;Me<qe;Me++)if(Ae.charCodeAt(Me)!==Oe.charCodeAt(Me))return Me;return qe}e.$3e=O;function N(Ae,Oe){const qe=Math.min(Ae.length,Oe.length);let Me;const Ze=Ae.length-1,le=Oe.length-1;for(Me=0;Me<qe;Me++)if(Ae.charCodeAt(Ze-Me)!==Oe.charCodeAt(le-Me))return Me;return qe}e.$4e=N;function L(Ae){return 55296<=Ae&&Ae<=56319}e.$5e=L;function j(Ae){return 56320<=Ae&&Ae<=57343}e.$6e=j;function z(Ae,Oe){return(Ae-55296<<10)+(Oe-56320)+65536}e.$7e=z;function T(Ae,Oe,qe){const Me=Ae.charCodeAt(qe);if(L(Me)&&qe+1<Oe){const Ze=Ae.charCodeAt(qe+1);if(j(Ze))return z(Me,Ze)}return Me}e.$8e=T;function K(Ae,Oe){const qe=Ae.charCodeAt(Oe-1);if(j(qe)&&Oe>1){const Me=Ae.charCodeAt(Oe-2);if(L(Me))return z(Me,qe)}return qe}class V{get offset(){return this.e}constructor(Oe,qe=0){this.c=Oe,this.d=Oe.length,this.e=qe}setOffset(Oe){this.e=Oe}prevCodePoint(){const Oe=K(this.c,this.e);return this.e-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=T(this.c,this.d,this.e);return this.e+=Oe>=65536?2:1,Oe}eol(){return this.e>=this.d}}e.$9e=V;class fe{get offset(){return this.c.offset}constructor(Oe,qe=0){this.c=new V(Oe,qe)}nextGraphemeLength(){const Oe=ge.getInstance(),qe=this.c,Me=qe.offset;let Ze=Oe.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const le=qe.offset,ue=Oe.getGraphemeBreakType(qe.nextCodePoint());if(se(Ze,ue)){qe.setOffset(le);break}Ze=ue}return qe.offset-Me}prevGraphemeLength(){const Oe=ge.getInstance(),qe=this.c,Me=qe.offset;let Ze=Oe.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const le=qe.offset,ue=Oe.getGraphemeBreakType(qe.prevCodePoint());if(se(ue,Ze)){qe.setOffset(le);break}Ze=ue}return Me-qe.offset}eol(){return this.c.eol()}}e.$0e=fe;function X(Ae,Oe){return new fe(Ae,Oe).nextGraphemeLength()}e.$$e=X;function Q(Ae,Oe){return new fe(Ae,Oe).prevGraphemeLength()}e.$_e=Q;function Z(Ae,Oe){Oe>0&&j(Ae.charCodeAt(Oe))&&Oe--;const qe=Oe+X(Ae,Oe);return[qe-Q(Ae,qe),qe]}e.$af=Z;function oe(Ae){const Oe=new fe(Ae);let qe=0;for(;!Oe.eol();)qe++,Oe.nextGraphemeLength();return qe}e.$bf=oe;let x;function ae(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve(Ae){return x||(x=ae()),x.test(Ae)}e.$cf=ve;const G=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return G.test(Ae)}e.$df=U,e.$ef=/[\u2028\u2029]/;function q(Ae){return e.$ef.test(Ae)}e.$ff=q;function me(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$gf=me;function _(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$hf=_;function ie(Ae,Oe){if(Ae.length<Oe)return Ae;const qe=/\b/g;let Me=0;for(;qe.test(Ae)&&!(Ae.length-qe.lastIndex<Oe);)Me=qe.lastIndex,qe.lastIndex+=1;return Ae.substring(Me).replace(/^\s/,"")}e.$if=ie;const re=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Ee=/\x1b\].*?\x07/g;function ce(Ae){return Ae&&(Ae=Ae.replace(re,"").replace(Ee,"")),Ae}e.$jf=ce,e.$kf=String.fromCharCode(65279);function de(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$lf=de;function ee(Ae){return de(Ae)?Ae.substr(1):Ae}e.$mf=ee;function he(Ae,Oe){if(!Ae||!Oe||Ae.length<Oe.length)return!1;const qe=Oe.length,Me=Ae.toLowerCase();let Ze=0,le=-1;for(;Ze<qe;){const ue=Me.indexOf(Oe[Ze],le+1);if(ue<0)return!1;le=ue,Ze++}return!0}e.$nf=he;function be(Ae,Oe=!1){return Ae?(Oe&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$of=be;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$pf=Pe;function B(Ae,Oe=1){if(Oe===0)return"";let qe=-1;do qe=Ae.indexOf(`
`,qe+1),Oe--;while(Oe>0&&qe>=0);return qe===-1?Ae:(Ae[qe-1]==="\r"&&qe--,Ae.substr(0,qe))}e.$qf=B;function J(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$rf=J;function te(Ae){return ge.getInstance().getGraphemeBreakType(Ae)}e.$sf=te;function se(Ae,Oe){return Ae===0?Oe!==5&&Oe!==7:Ae===2&&Oe===3?!1:Ae===4||Ae===2||Ae===3||Oe===4||Oe===2||Oe===3?!0:!(Ae===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(Ae===11||Ae===9)&&(Oe===9||Oe===10)||(Ae===12||Ae===10)&&Oe===10||Oe===5||Oe===13||Oe===7||Ae===1||Ae===13&&Oe===14||Ae===6&&Oe===6)}var Y;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Y||(e.GraphemeBreakType=Y={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=ye()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const qe=this.d,Me=qe.length/3;let Ze=1;for(;Ze<=Me;)if(Oe<qe[3*Ze])Ze=2*Ze;else if(Oe>qe[3*Ze+1])Ze=2*Ze+1;else return qe[3*Ze+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Oe){if(Ae===0)return 0;const qe=We(Ae,Oe);if(qe!==void 0)return qe;const Me=new V(Oe,Ae);return Me.prevCodePoint(),Me.offset}e.$tf=je;function We(Ae,Oe){const qe=new V(Oe,Ae);let Me=qe.prevCodePoint();for(;_e(Me)||Me===65039||Me===8419;){if(qe.offset===0)return;Me=qe.prevCodePoint()}if(!_(Me))return;let Ze=qe.offset;return Ze>0&&qe.prevCodePoint()===8205&&(Ze=qe.offset),Ze}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$uf="\xA0";class it{static{this.c=new F.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$we(Oe=>{function qe(Xe){const rt=new Map;for(let ot=0;ot<Xe.length;ot+=2)rt.set(Xe[ot],Xe[ot+1]);return rt}function Me(Xe,rt){const ot=new Map(Xe);for(const[wt,Et]of rt)ot.set(wt,Et);return ot}function Ze(Xe,rt){if(!Xe)return rt;const ot=new Map;for(const[wt,Et]of Xe)rt.has(wt)&&ot.set(wt,Et);return ot}const le=this.c.value;let ue=Oe.filter(Xe=>!Xe.startsWith("_")&&Xe in le);ue.length===0&&(ue=["_default"]);let Ie;for(const Xe of ue){const rt=qe(le[Xe]);Ie=Ze(Ie,rt)}const Ve=qe(le._common),ze=Me(Ve,Ie);return new it(ze)})}static getInstance(Oe){return it.d.get(Array.from(Oe))}static{this.e=new F.$U(()=>Object.keys(it.c.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return it.e.value}constructor(Oe){this.f=Oe}isAmbiguous(Oe){return this.f.has(Oe)}getPrimaryConfusable(Oe){return this.f.get(Oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$vf=it;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Oe){return et.e().has(Oe)}static get codePoints(){return et.e()}}e.$wf=et}),define(De[121],Ce([1,0,28,15]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.FuzzyScore=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.or=void 0;function d(...ee){return function(he,be){for(let Pe=0,B=ee.length;Pe<B;Pe++){const J=ee[Pe](he,be);if(J)return J}return null}}e.or=d,e.$Aj=M.bind(void 0,!1),e.$Bj=M.bind(void 0,!0);function M(ee,he,be){if(!be||be.length<he.length)return null;let Pe;return ee?Pe=F.$2e(be,he):Pe=be.indexOf(he)===0,Pe?he.length>0?[{start:0,end:he.length}]:[]:null}function A(ee,he){const be=he.toLowerCase().indexOf(ee.toLowerCase());return be===-1?null:[{start:be,end:be+ee.length}]}e.$Cj=A;function b(ee,he){return E(ee.toLowerCase(),he.toLowerCase(),0,0)}e.$Dj=b;function E(ee,he,be,Pe){if(be===ee.length)return[];if(Pe===he.length)return null;if(ee[be]===he[Pe]){let B=null;return(B=E(ee,he,be+1,Pe+1))?c({start:Pe,end:Pe+1},B):null}return E(ee,he,be,Pe+1)}function w(ee){return 97<=ee&&ee<=122}function R(ee){return 65<=ee&&ee<=90}e.$Ej=R;function I(ee){return 48<=ee&&ee<=57}function v(ee){return ee===32||ee===9||ee===10||ee===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>y.add(ee.charCodeAt(0)));function D(ee){return v(ee)||y.has(ee)}function p(ee,he){return ee===he||D(ee)&&D(he)}function l(ee){return w(ee)||R(ee)||I(ee)}function c(ee,he){return he.length===0?he=[ee]:ee.end===he[0].start?he[0].start=ee.start:he.unshift(ee),he}function r(ee,he){for(let be=he;be<ee.length;be++){const Pe=ee.charCodeAt(be);if(R(Pe)||I(Pe)||be>0&&!l(ee.charCodeAt(be-1)))return be}return ee.length}function o(ee,he,be,Pe){if(be===ee.length)return[];if(Pe===he.length)return null;if(ee[be]!==he[Pe].toLowerCase())return null;{let B=null,J=Pe+1;for(B=o(ee,he,be+1,Pe+1);!B&&(J=r(he,J))<he.length;)B=o(ee,he,be+1,J),J++;return B===null?null:c({start:Pe,end:Pe+1},B)}}function m(ee){let he=0,be=0,Pe=0,B=0,J=0;for(let ye=0;ye<ee.length;ye++)J=ee.charCodeAt(ye),R(J)&&he++,w(J)&&be++,l(J)&&Pe++,I(J)&&B++;const te=he/ee.length,se=be/ee.length,Y=Pe/ee.length,ge=B/ee.length;return{upperPercent:te,lowerPercent:se,alphaPercent:Y,numericPercent:ge}}function h(ee){const{upperPercent:he,lowerPercent:be}=ee;return be===0&&he>.6}function t(ee){const{upperPercent:he,lowerPercent:be,alphaPercent:Pe,numericPercent:B}=ee;return be>.2&&he<.8&&Pe>.6&&B<.2}function n(ee){let he=0,be=0,Pe=0,B=0;for(let J=0;J<ee.length;J++)Pe=ee.charCodeAt(J),R(Pe)&&he++,w(Pe)&&be++,v(Pe)&&B++;return(he===0||be===0)&&B===0?ee.length<=30:he<=5}function a(ee,he){if(!he||(he=he.trim(),he.length===0)||!n(ee)||he.length>60)return null;const be=m(he);if(!t(be)){if(!h(be))return null;he=he.toLowerCase()}let Pe=null,B=0;for(ee=ee.toLowerCase();B<he.length&&(Pe=o(ee,he,0,B))===null;)B=r(he,B+1);return Pe}e.$Fj=a;function i(ee,he,be=!1){if(!he||he.length===0)return null;let Pe=null,B=0;for(ee=ee.toLowerCase(),he=he.toLowerCase();B<he.length&&(Pe=s(ee,he,0,B,be))===null;)B=u(he,B+1);return Pe}e.$Gj=i;function s(ee,he,be,Pe,B){if(be===ee.length)return[];if(Pe===he.length)return null;if(p(ee.charCodeAt(be),he.charCodeAt(Pe))){let J=null,te=Pe+1;if(J=s(ee,he,be+1,Pe+1,B),!B)for(;!J&&(te=u(he,te))<he.length;)J=s(ee,he,be+1,te,B),te++;return J?ee.charCodeAt(be)!==he.charCodeAt(Pe)?J:c({start:Pe,end:Pe+1},J):null}else return null}function u(ee,he){for(let be=he;be<ee.length;be++)if(D(ee.charCodeAt(be))||be>0&&D(ee.charCodeAt(be-1)))return be;return ee.length}const S=d(e.$Bj,a,A),k=d(e.$Bj,a,b),$=new C.$Cc(1e4);function f(ee,he,be=!1){if(typeof ee!="string"||typeof he!="string")return null;let Pe=$.get(ee);Pe||(Pe=new RegExp(F.$Ke(ee),"i"),$.set(ee,Pe));const B=Pe.exec(he);return B?[{start:B.index,end:B.index+B[0].length}]:be?k(ee,he):S(ee,he)}e.$Hj=f;function g(ee,he){const be=me(ee,ee.toLowerCase(),0,he,he.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?O(be):null}e.$Ij=g;function P(ee,he,be,Pe,B,J){const te=Math.min(13,ee.length);for(;be<te;be++){const se=me(ee,he,be,Pe,B,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,J]}e.$Jj=P;function O(ee){if(typeof ee>"u")return[];const he=[],be=ee[1];for(let Pe=ee.length-1;Pe>1;Pe--){const B=ee[Pe]+be,J=he[he.length-1];J&&J.end===B?J.end=B+1:he.push({start:B,end:B+1})}return he}e.$Kj=O;const N=128;function L(){const ee=[],he=[];for(let be=0;be<=N;be++)he[be]=0;for(let be=0;be<=N;be++)ee.push(he.slice(0));return ee}function j(ee){const he=[];for(let be=0;be<=ee;be++)he[be]=0;return he}const z=j(2*N),T=j(2*N),K=L(),V=L(),fe=L(),X=!1;function Q(ee,he,be,Pe,B){function J(se,Y,ge=" "){for(;se.length<Y;)se=ge+se;return se}let te=` |   |${Pe.split("").map(se=>J(se,3)).join("|")}
`;for(let se=0;se<=be;se++)se===0?te+=" |":te+=`${he[se-1]}|`,te+=ee[se].slice(0,B+1).map(Y=>J(Y.toString(),3)).join("|")+`
`;return te}function Z(ee,he,be,Pe){ee=ee.substr(he),be=be.substr(Pe),console.log(Q(V,ee,ee.length,be,be.length)),console.log(Q(fe,ee,ee.length,be,be.length)),console.log(Q(K,ee,ee.length,be,be.length))}function oe(ee,he){if(he<0||he>=ee.length)return!1;const be=ee.codePointAt(he);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$hf(be)}}function x(ee,he){if(he<0||he>=ee.length)return!1;switch(ee.charCodeAt(he)){case 32:case 9:return!0;default:return!1}}function ae(ee,he,be){return he[ee]!==be[ee]}function ve(ee,he,be,Pe,B,J,te=!1){for(;he<be&&B<J;)ee[he]===Pe[B]&&(te&&(z[he]=B),he+=1),B+=1;return he===be}e.$Lj=ve;var G;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(G||(G={}));var U;(function(ee){ee.Default=[-100,0];function he(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}ee.isDefault=he})(U||(e.FuzzyScore=U={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(he,be){this.firstMatchCanBeWeak=he,this.boostFullMatch=be}}e.$Mj=q;function me(ee,he,be,Pe,B,J,te=q.default){const se=ee.length>N?N:ee.length,Y=Pe.length>N?N:Pe.length;if(be>=se||J>=Y||se-be>Y-J||!ve(he,be,se,B,J,Y,!0))return;_(se,Y,be,J,he,B);let ge=1,ye=1,je=be,We=J;const _e=[!1];for(ge=1,je=be;je<se;ge++,je++){const Oe=z[je],qe=T[je],Me=je+1<se?T[je+1]:Y;for(ye=Oe-J+1,We=Oe;We<Me;ye++,We++){let Ze=Number.MIN_SAFE_INTEGER,le=!1;We<=qe&&(Ze=ie(ee,he,je,be,Pe,B,We,Y,J,K[ge-1][ye-1]===0,_e));let ue=0;Ze!==Number.MAX_SAFE_INTEGER&&(le=!0,ue=Ze+V[ge-1][ye-1]);const Ie=We>Oe,Ve=Ie?V[ge][ye-1]+(K[ge][ye-1]>0?-5:0):0,ze=We>Oe+1&&K[ge][ye-1]>0,Xe=ze?V[ge][ye-2]+(K[ge][ye-2]>0?-5:0):0;if(ze&&(!Ie||Xe>=Ve)&&(!le||Xe>=ue))V[ge][ye]=Xe,fe[ge][ye]=3,K[ge][ye]=0;else if(Ie&&(!le||Ve>=ue))V[ge][ye]=Ve,fe[ge][ye]=2,K[ge][ye]=0;else if(le)V[ge][ye]=ue,fe[ge][ye]=1,K[ge][ye]=K[ge-1][ye-1]+1;else throw new Error("not possible")}}if(X&&Z(ee,be,Pe,J),!_e[0]&&!te.firstMatchCanBeWeak)return;ge--,ye--;const Ye=[V[ge][ye],J];let it=0,et=0;for(;ge>=1;){let Oe=ye;do{const qe=fe[ge][Oe];if(qe===3)Oe=Oe-2;else if(qe===2)Oe=Oe-1;else break}while(Oe>=1);it>1&&he[be+ge-1]===B[J+ye-1]&&!ae(Oe+J-1,Pe,B)&&it+1>K[ge][Oe]&&(Oe=ye),Oe===ye?it++:it=1,et||(et=Oe),ge--,ye=Oe-1,Ye.push(ye)}Y===se&&te.boostFullMatch&&(Ye[0]+=2);const Ae=et-se;return Ye[0]-=Ae,Ye}e.$Nj=me;function _(ee,he,be,Pe,B,J){let te=ee-1,se=he-1;for(;te>=be&&se>=Pe;)B[te]===J[se]&&(T[te]=se,te--),se--}function ie(ee,he,be,Pe,B,J,te,se,Y,ge,ye){if(he[be]!==J[te])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return te===be-Pe?je=ee[be]===B[te]?7:5:ae(te,B,J)&&(te===0||!ae(te-1,B,J))?(je=ee[be]===B[te]?7:5,We=!0):oe(J,te)&&(te===0||!oe(J,te-1))?je=5:(oe(J,te-1)||x(J,te-1))&&(je=5,We=!0),je>1&&be===Pe&&(ye[0]=!0),We||(We=ae(te,B,J)||oe(J,te-1)||x(J,te-1)),be===Pe?te>Y&&(je-=We?3:5):ge?je+=We?2:0:je+=We?0:1,te+1===se&&(je-=We?3:5),je}function re(ee,he,be,Pe,B,J,te){return ce(ee,he,be,Pe,B,J,!0,te)}e.$Oj=re;function Ee(ee,he,be,Pe,B,J,te){return ce(ee,he,be,Pe,B,J,!1,te)}e.$Pj=Ee;function ce(ee,he,be,Pe,B,J,te,se){let Y=me(ee,he,be,Pe,B,J,se);if(Y&&!te)return Y;if(ee.length>=3){const ge=Math.min(7,ee.length-1);for(let ye=be+1;ye<ge;ye++){const je=de(ee,ye);if(je){const We=me(je,je.toLowerCase(),be,Pe,B,J,se);We&&(We[0]-=3,(!Y||We[0]>Y[0])&&(Y=We))}}}return Y}function de(ee,he){if(he+1>=ee.length)return;const be=ee[he],Pe=ee[he+1];if(be!==Pe)return ee.slice(0,he)+Pe+be+ee.slice(he+2)}}),define(De[52],Ce([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=void 0;function F(c){return d(c,0)}e.$Bi=F;function d(c,r){switch(typeof c){case"object":return c===null?M(349,r):Array.isArray(c)?E(c,r):w(c,r);case"string":return b(c,r);case"boolean":return A(c,r);case"number":return M(c,r);case"undefined":return M(937,r);default:return M(617,r)}}e.$Ci=d;function M(c,r){return(r<<5)-r+c|0}e.$Di=M;function A(c,r){return M(c?433:863,r)}function b(c,r){r=M(149417,r);for(let o=0,m=c.length;o<m;o++)r=M(c.charCodeAt(o),r);return r}e.$Ei=b;function E(c,r){return r=M(104579,r),c.reduce((o,m)=>d(m,o),r)}function w(c,r){return r=M(181387,r),Object.keys(c).sort().reduce((o,m)=>(o=b(m,o),d(c[m],o)),r)}class R{constructor(){this.g=0}get value(){return this.g}hash(r){return this.g=d(r,this.g),this.g}}e.$Fi=R;var I;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function v(c,r,o=32){const m=o-r,h=~((1<<m)-1);return(c<<r|(h&c)>>>m)>>>0}function y(c,r=0,o=c.byteLength,m=0){for(let h=0;h<o;h++)c[r+h]=m}function D(c,r,o="0"){for(;c.length<r;)c=o+c;return c}function p(c,r=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(o=>o.toString(16).padStart(2,"0")).join(""):D((c>>>0).toString(16),r/4)}e.$Gi=p;class l{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(r){const o=r.length;if(o===0)return;const m=this.p;let h=this.r,t=this.u,n,a;for(t!==0?(n=t,a=-1,t=0):(n=r.charCodeAt(0),a=0);;){let i=n;if(C.$5e(n))if(a+1<o){const s=r.charCodeAt(a+1);C.$6e(s)?(a++,i=C.$7e(n,s)):i=65533}else{t=n;break}else C.$6e(n)&&(i=65533);if(h=this.w(m,h,i),a++,a<o)n=r.charCodeAt(a);else break}this.r=h,this.u=t}w(r,o,m){return m<128?r[o++]=m:m<2048?(r[o++]=192|(m&1984)>>>6,r[o++]=128|(m&63)>>>0):m<65536?(r[o++]=224|(m&61440)>>>12,r[o++]=128|(m&4032)>>>6,r[o++]=128|(m&63)>>>0):(r[o++]=240|(m&1835008)>>>18,r[o++]=128|(m&258048)>>>12,r[o++]=128|(m&4032)>>>6,r[o++]=128|(m&63)>>>0),o>=64&&(this.y(),o-=64,this.t+=64,r[0]=r[64+0],r[1]=r[64+1],r[2]=r[64+2]),o}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const r=8*this.t;this.q.setUint32(56,Math.floor(r/4294967296),!1),this.q.setUint32(60,r%4294967296,!1),this.y()}y(){const r=l.g,o=this.q;for(let S=0;S<64;S+=4)r.setUint32(S,o.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)r.setUint32(S,v(r.getUint32(S-12,!1)^r.getUint32(S-32,!1)^r.getUint32(S-56,!1)^r.getUint32(S-64,!1),1),!1);let m=this.h,h=this.l,t=this.m,n=this.n,a=this.o,i,s,u;for(let S=0;S<80;S++)S<20?(i=h&t|~h&n,s=1518500249):S<40?(i=h^t^n,s=1859775393):S<60?(i=h&t|h&n|t&n,s=2400959708):(i=h^t^n,s=3395469782),u=v(m,5)+i+a+s+r.getUint32(S*4,!1)&4294967295,a=n,n=t,t=v(h,30),h=m,m=u;this.h=this.h+m&4294967295,this.l=this.l+h&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+a&4294967295}}e.$Hi=l}),define(De[38],Ce([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(d){d[d.Ignore=0]="Ignore",d[d.Info=1]="Info",d[d.Warning=2]="Warning",d[d.Error=3]="Error"})(F||(F={})),function(d){const M="error",A="warning",b="warn",E="info",w="ignore";function R(v){return v?C.$1e(M,v)?d.Error:C.$1e(A,v)||C.$1e(b,v)?d.Warning:C.$1e(E,v)?d.Info:d.Ignore:d.Ignore}d.fromValue=R;function I(v){switch(v){case d.Error:return M;case d.Warning:return A;case d.Info:return E;default:return w}}d.toString=I}(F||(F={})),e.default=F}),define(De[160],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Jd=Symbol("MicrotaskDelay")}),define(De[77],Ce([1,0,19,15]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class d{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const D=y.charCodeAt(0),p=this.b.charCodeAt(this.c);return D-p}value(){return this.b[this.c]}}e.$Ph=d;class M{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,F.$Ue)(y,this.b,0,y.length,this.c,this.d):(0,F.$We)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Qh=M;class A{constructor(y=!0,D=!0){this.f=y,this.g=D}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let D=y.length-1;D>=0;D--,this.c--){const p=this.b.charCodeAt(D);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const D=this.b.charCodeAt(this.e);if(D===47||this.f&&D===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,F.$Ue)(y,this.b,0,y.length,this.d,this.e):(0,F.$We)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Rh=A;var b;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(b||(b={}));class E{constructor(y,D){this.f=y,this.g=D,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,F.$Ve)(y,this.c.scheme);if(this.d[this.e]===2)return(0,F.$Ve)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,F.$Te)(y,this.c.query);if(this.d[this.e]===5)return(0,F.$Te)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Sh=E;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(R||(R={}));class I{static forUris(y=()=>!1,D=()=>!1){return new I(new E(y,D))}static forPaths(y=!1){return new I(new A(void 0,!y))}static forStrings(){return new I(new d)}static forConfigKeys(){return new I(new M)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,D){if(D){const p=D.slice(0);(0,C.$Wb)(p);for(const l of p)this.set(l,y)}else{const p=y.slice(0);(0,C.$Wb)(p);for(const l of p)this.set(l[0],l[1])}}set(y,D){const p=this.b.reset(y);let l;this.c||(this.c=new w,this.c.segment=p.value());const c=[];for(l=this.c;;){const o=p.cmp(l.segment);if(o>0)l.left||(l.left=new w,l.left.segment=p.value()),c.push([-1,l]),l=l.left;else if(o<0)l.right||(l.right=new w,l.right.segment=p.value()),c.push([1,l]),l=l.right;else if(p.hasNext())p.next(),l.mid||(l.mid=new w,l.mid.segment=p.value()),c.push([0,l]),l=l.mid;else break}const r=l.value;l.value=D,l.key=y;for(let o=c.length-1;o>=0;o--){const m=c[o][1];m.updateHeight();const h=m.balanceFactor();if(h<-1||h>1){const t=c[o][0],n=c[o+1][0];if(t===1&&n===1)c[o][1]=m.rotateLeft();else if(t===-1&&n===-1)c[o][1]=m.rotateRight();else if(t===1&&n===-1)m.right=c[o+1][1]=c[o+1][1].rotateRight(),c[o][1]=m.rotateLeft();else if(t===-1&&n===1)m.left=c[o+1][1]=c[o+1][1].rotateLeft(),c[o][1]=m.rotateRight();else throw new Error;if(o>0)switch(c[o-1][0]){case-1:c[o-1][1].left=c[o][1];break;case 1:c[o-1][1].right=c[o][1];break;case 0:c[o-1][1].mid=c[o][1];break}else this.c=c[0][1]}}return r}get(y){return this.d(y)?.value}d(y){const D=this.b.reset(y);let p=this.c;for(;p;){const l=D.cmp(p.segment);if(l>0)p=p.left;else if(l<0)p=p.right;else if(D.hasNext())D.next(),p=p.mid;else break}return p}has(y){const D=this.d(y);return!(D?.value===void 0&&D?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,D){const p=this.b.reset(y),l=[];let c=this.c;for(;c;){const r=p.cmp(c.segment);if(r>0)l.push([-1,c]),c=c.left;else if(r<0)l.push([1,c]),c=c.right;else if(p.hasNext())p.next(),l.push([0,c]),c=c.mid;else break}if(c){if(D?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const r=this.f(c.right);if(r.key){const{key:o,value:m,segment:h}=r;this.e(r.key,!1),c.key=o,c.value=m,c.segment=h}}else{const r=c.left??c.right;if(l.length>0){const[o,m]=l[l.length-1];switch(o){case-1:m.left=r;break;case 0:m.mid=r;break;case 1:m.right=r;break}}else this.c=r}for(let r=l.length-1;r>=0;r--){const o=l[r][1];o.updateHeight();const m=o.balanceFactor();if(m>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),l[r][1]=o.rotateLeft()):m<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),l[r][1]=o.rotateRight()),r>0)switch(l[r-1][0]){case-1:l[r-1][1].left=l[r][1];break;case 1:l[r-1][1].right=l[r][1];break;case 0:l[r-1][1].mid=l[r][1];break}else this.c=l[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const D=this.b.reset(y);let p=this.c,l;for(;p;){const c=D.cmp(p.segment);if(c>0)p=p.left;else if(c<0)p=p.right;else if(D.hasNext())D.next(),l=p.value||l,p=p.mid;else break}return p&&p.value||l}findSuperstr(y){return this.g(y,!1)}g(y,D){const p=this.b.reset(y);let l=this.c;for(;l;){const c=p.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(p.hasNext())p.next(),l=l.mid;else return l.mid?this.h(l.mid):D?l.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[D,p]of this)y(p,D)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const D=[];return this.j(y,D),D[Symbol.iterator]()}j(y,D){y&&(y.left&&this.j(y.left,D),y.value&&D.push([y.key,y.value]),y.mid&&this.j(y.mid,D),y.right&&this.j(y.right,D))}_isBalanced(){const y=D=>{if(!D)return!0;const p=D.balanceFactor();return p<-1||p>1?!1:y(D.left)&&y(D.right)};return y(this.c)}}e.$Th=I}),define(De[18],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=void 0;function C(h){return typeof h=="string"}e.$xf=C;function F(h){return Array.isArray(h)&&h.every(t=>C(t))}e.$yf=F;function d(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.$zf=d;function M(h){const t=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof t}e.$Af=M;function A(h){return typeof h=="number"&&!isNaN(h)}e.$Bf=A;function b(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.$Cf=b;function E(h){return h===!0||h===!1}e.$Df=E;function w(h){return typeof h>"u"}e.$Ef=w;function R(h){return!I(h)}e.$Ff=R;function I(h){return w(h)||h===null}e.$Gf=I;function v(h,t){if(!h)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Hf=v;function y(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.$If=y;function D(...h){const t=[];for(let n=0;n<h.length;n++){const a=h[n];if(I(a))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(a)}return t}e.$Jf=D;const p=Object.prototype.hasOwnProperty;function l(h){if(!d(h))return!1;for(const t in h)if(p.call(h,t))return!1;return!0}e.$Kf=l;function c(h){return typeof h=="function"}e.$Lf=c;function r(...h){return h.length>0&&h.every(c)}e.$Mf=r;function o(h,t){const n=Math.min(h.length,t.length);for(let a=0;a<n;a++)m(h[a],t[a])}e.$Nf=o;function m(h,t){if(C(t)){if(typeof h!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(h instanceof t)return}catch{}if(!I(h)&&h.constructor===t||t.length===1&&t.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Of=m}),define(De[78],Ce([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=void 0;const F=Object.create(null);function d(b,E){if((0,C.$xf)(E)){const w=F[E];if(w===void 0)throw new Error(`${b} references an unknown codicon: ${E}`);E=w}return F[b]=E,{id:b}}function M(){return F}e.$Qj=M;function A(){return Object.values(e.$Sj)}e.$Rj=A,e.$Sj={add:d("add",6e4),plus:d("plus",6e4),gistNew:d("gist-new",6e4),repoCreate:d("repo-create",6e4),lightbulb:d("lightbulb",60001),lightBulb:d("light-bulb",60001),repo:d("repo",60002),repoDelete:d("repo-delete",60002),gistFork:d("gist-fork",60003),repoForked:d("repo-forked",60003),gitPullRequest:d("git-pull-request",60004),gitPullRequestAbandoned:d("git-pull-request-abandoned",60004),recordKeys:d("record-keys",60005),keyboard:d("keyboard",60005),tag:d("tag",60006),tagAdd:d("tag-add",60006),tagRemove:d("tag-remove",60006),gitPullRequestLabel:d("git-pull-request-label",60006),person:d("person",60007),personFollow:d("person-follow",60007),personOutline:d("person-outline",60007),personFilled:d("person-filled",60007),gitBranch:d("git-branch",60008),gitBranchCreate:d("git-branch-create",60008),gitBranchDelete:d("git-branch-delete",60008),sourceControl:d("source-control",60008),mirror:d("mirror",60009),mirrorPublic:d("mirror-public",60009),star:d("star",60010),starAdd:d("star-add",60010),starDelete:d("star-delete",60010),starEmpty:d("star-empty",60010),comment:d("comment",60011),commentAdd:d("comment-add",60011),alert:d("alert",60012),warning:d("warning",60012),search:d("search",60013),searchSave:d("search-save",60013),logOut:d("log-out",60014),signOut:d("sign-out",60014),logIn:d("log-in",60015),signIn:d("sign-in",60015),eye:d("eye",60016),eyeUnwatch:d("eye-unwatch",60016),eyeWatch:d("eye-watch",60016),circleFilled:d("circle-filled",60017),primitiveDot:d("primitive-dot",60017),closeDirty:d("close-dirty",60017),debugBreakpoint:d("debug-breakpoint",60017),debugBreakpointDisabled:d("debug-breakpoint-disabled",60017),debugHint:d("debug-hint",60017),primitiveSquare:d("primitive-square",60018),edit:d("edit",60019),pencil:d("pencil",60019),info:d("info",60020),issueOpened:d("issue-opened",60020),gistPrivate:d("gist-private",60021),gitForkPrivate:d("git-fork-private",60021),lock:d("lock",60021),mirrorPrivate:d("mirror-private",60021),close:d("close",60022),removeClose:d("remove-close",60022),x:d("x",60022),repoSync:d("repo-sync",60023),sync:d("sync",60023),clone:d("clone",60024),desktopDownload:d("desktop-download",60024),beaker:d("beaker",60025),microscope:d("microscope",60025),vm:d("vm",60026),deviceDesktop:d("device-desktop",60026),file:d("file",60027),fileText:d("file-text",60027),more:d("more",60028),ellipsis:d("ellipsis",60028),kebabHorizontal:d("kebab-horizontal",60028),mailReply:d("mail-reply",60029),reply:d("reply",60029),organization:d("organization",60030),organizationFilled:d("organization-filled",60030),organizationOutline:d("organization-outline",60030),newFile:d("new-file",60031),fileAdd:d("file-add",60031),newFolder:d("new-folder",60032),fileDirectoryCreate:d("file-directory-create",60032),trash:d("trash",60033),trashcan:d("trashcan",60033),history:d("history",60034),clock:d("clock",60034),folder:d("folder",60035),fileDirectory:d("file-directory",60035),symbolFolder:d("symbol-folder",60035),logoGithub:d("logo-github",60036),markGithub:d("mark-github",60036),github:d("github",60036),terminal:d("terminal",60037),console:d("console",60037),repl:d("repl",60037),zap:d("zap",60038),symbolEvent:d("symbol-event",60038),error:d("error",60039),stop:d("stop",60039),variable:d("variable",60040),symbolVariable:d("symbol-variable",60040),array:d("array",60042),symbolArray:d("symbol-array",60042),symbolModule:d("symbol-module",60043),symbolPackage:d("symbol-package",60043),symbolNamespace:d("symbol-namespace",60043),symbolObject:d("symbol-object",60043),symbolMethod:d("symbol-method",60044),symbolFunction:d("symbol-function",60044),symbolConstructor:d("symbol-constructor",60044),symbolBoolean:d("symbol-boolean",60047),symbolNull:d("symbol-null",60047),symbolNumeric:d("symbol-numeric",60048),symbolNumber:d("symbol-number",60048),symbolStructure:d("symbol-structure",60049),symbolStruct:d("symbol-struct",60049),symbolParameter:d("symbol-parameter",60050),symbolTypeParameter:d("symbol-type-parameter",60050),symbolKey:d("symbol-key",60051),symbolText:d("symbol-text",60051),symbolReference:d("symbol-reference",60052),goToFile:d("go-to-file",60052),symbolEnum:d("symbol-enum",60053),symbolValue:d("symbol-value",60053),symbolRuler:d("symbol-ruler",60054),symbolUnit:d("symbol-unit",60054),activateBreakpoints:d("activate-breakpoints",60055),archive:d("archive",60056),arrowBoth:d("arrow-both",60057),arrowDown:d("arrow-down",60058),arrowLeft:d("arrow-left",60059),arrowRight:d("arrow-right",60060),arrowSmallDown:d("arrow-small-down",60061),arrowSmallLeft:d("arrow-small-left",60062),arrowSmallRight:d("arrow-small-right",60063),arrowSmallUp:d("arrow-small-up",60064),arrowUp:d("arrow-up",60065),bell:d("bell",60066),bold:d("bold",60067),book:d("book",60068),bookmark:d("bookmark",60069),debugBreakpointConditionalUnverified:d("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:d("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:d("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:d("debug-breakpoint-data-unverified",60072),debugBreakpointData:d("debug-breakpoint-data",60073),debugBreakpointDataDisabled:d("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:d("debug-breakpoint-log-unverified",60074),debugBreakpointLog:d("debug-breakpoint-log",60075),debugBreakpointLogDisabled:d("debug-breakpoint-log-disabled",60075),briefcase:d("briefcase",60076),broadcast:d("broadcast",60077),browser:d("browser",60078),bug:d("bug",60079),calendar:d("calendar",60080),caseSensitive:d("case-sensitive",60081),check:d("check",60082),checklist:d("checklist",60083),chevronDown:d("chevron-down",60084),dropDownButton:d("drop-down-button",60084),chevronLeft:d("chevron-left",60085),chevronRight:d("chevron-right",60086),chevronUp:d("chevron-up",60087),chromeClose:d("chrome-close",60088),chromeMaximize:d("chrome-maximize",60089),chromeMinimize:d("chrome-minimize",60090),chromeRestore:d("chrome-restore",60091),circle:d("circle",60092),circleOutline:d("circle-outline",60092),debugBreakpointUnverified:d("debug-breakpoint-unverified",60092),circleSlash:d("circle-slash",60093),circuitBoard:d("circuit-board",60094),clearAll:d("clear-all",60095),clippy:d("clippy",60096),closeAll:d("close-all",60097),cloudDownload:d("cloud-download",60098),cloudUpload:d("cloud-upload",60099),code:d("code",60100),collapseAll:d("collapse-all",60101),colorMode:d("color-mode",60102),commentDiscussion:d("comment-discussion",60103),compareChanges:d("compare-changes",60157),creditCard:d("credit-card",60105),dash:d("dash",60108),dashboard:d("dashboard",60109),database:d("database",60110),debugContinue:d("debug-continue",60111),debugDisconnect:d("debug-disconnect",60112),debugPause:d("debug-pause",60113),debugRestart:d("debug-restart",60114),debugStart:d("debug-start",60115),debugStepInto:d("debug-step-into",60116),debugStepOut:d("debug-step-out",60117),debugStepOver:d("debug-step-over",60118),debugStop:d("debug-stop",60119),debug:d("debug",60120),deviceCameraVideo:d("device-camera-video",60121),deviceCamera:d("device-camera",60122),deviceMobile:d("device-mobile",60123),diffAdded:d("diff-added",60124),diffIgnored:d("diff-ignored",60125),diffModified:d("diff-modified",60126),diffRemoved:d("diff-removed",60127),diffRenamed:d("diff-renamed",60128),diff:d("diff",60129),discard:d("discard",60130),editorLayout:d("editor-layout",60131),emptyWindow:d("empty-window",60132),exclude:d("exclude",60133),extensions:d("extensions",60134),eyeClosed:d("eye-closed",60135),fileBinary:d("file-binary",60136),fileCode:d("file-code",60137),fileMedia:d("file-media",60138),filePdf:d("file-pdf",60139),fileSubmodule:d("file-submodule",60140),fileSymlinkDirectory:d("file-symlink-directory",60141),fileSymlinkFile:d("file-symlink-file",60142),fileZip:d("file-zip",60143),files:d("files",60144),filter:d("filter",60145),flame:d("flame",60146),foldDown:d("fold-down",60147),foldUp:d("fold-up",60148),fold:d("fold",60149),folderActive:d("folder-active",60150),folderOpened:d("folder-opened",60151),gear:d("gear",60152),gift:d("gift",60153),gistSecret:d("gist-secret",60154),gist:d("gist",60155),gitCommit:d("git-commit",60156),gitCompare:d("git-compare",60157),gitMerge:d("git-merge",60158),githubAction:d("github-action",60159),githubAlt:d("github-alt",60160),globe:d("globe",60161),grabber:d("grabber",60162),graph:d("graph",60163),gripper:d("gripper",60164),heart:d("heart",60165),home:d("home",60166),horizontalRule:d("horizontal-rule",60167),hubot:d("hubot",60168),inbox:d("inbox",60169),issueClosed:d("issue-closed",60324),issueReopened:d("issue-reopened",60171),issues:d("issues",60172),italic:d("italic",60173),jersey:d("jersey",60174),json:d("json",60175),bracket:d("bracket",60175),kebabVertical:d("kebab-vertical",60176),key:d("key",60177),law:d("law",60178),lightbulbAutofix:d("lightbulb-autofix",60179),linkExternal:d("link-external",60180),link:d("link",60181),listOrdered:d("list-ordered",60182),listUnordered:d("list-unordered",60183),liveShare:d("live-share",60184),loading:d("loading",60185),location:d("location",60186),mailRead:d("mail-read",60187),mail:d("mail",60188),markdown:d("markdown",60189),megaphone:d("megaphone",60190),mention:d("mention",60191),milestone:d("milestone",60192),gitPullRequestMilestone:d("git-pull-request-milestone",60192),mortarBoard:d("mortar-board",60193),move:d("move",60194),multipleWindows:d("multiple-windows",60195),mute:d("mute",60196),noNewline:d("no-newline",60197),note:d("note",60198),octoface:d("octoface",60199),openPreview:d("open-preview",60200),package:d("package",60201),paintcan:d("paintcan",60202),pin:d("pin",60203),play:d("play",60204),run:d("run",60204),plug:d("plug",60205),preserveCase:d("preserve-case",60206),preview:d("preview",60207),project:d("project",60208),pulse:d("pulse",60209),question:d("question",60210),quote:d("quote",60211),radioTower:d("radio-tower",60212),reactions:d("reactions",60213),references:d("references",60214),refresh:d("refresh",60215),regex:d("regex",60216),remoteExplorer:d("remote-explorer",60217),remote:d("remote",60218),remove:d("remove",60219),replaceAll:d("replace-all",60220),replace:d("replace",60221),repoClone:d("repo-clone",60222),repoForcePush:d("repo-force-push",60223),repoPull:d("repo-pull",60224),repoPush:d("repo-push",60225),report:d("report",60226),requestChanges:d("request-changes",60227),rocket:d("rocket",60228),rootFolderOpened:d("root-folder-opened",60229),rootFolder:d("root-folder",60230),rss:d("rss",60231),ruby:d("ruby",60232),saveAll:d("save-all",60233),saveAs:d("save-as",60234),save:d("save",60235),screenFull:d("screen-full",60236),screenNormal:d("screen-normal",60237),searchStop:d("search-stop",60238),server:d("server",60240),settingsGear:d("settings-gear",60241),settings:d("settings",60242),shield:d("shield",60243),smiley:d("smiley",60244),sortPrecedence:d("sort-precedence",60245),splitHorizontal:d("split-horizontal",60246),splitVertical:d("split-vertical",60247),squirrel:d("squirrel",60248),starFull:d("star-full",60249),starHalf:d("star-half",60250),symbolClass:d("symbol-class",60251),symbolColor:d("symbol-color",60252),symbolCustomColor:d("symbol-customcolor",60252),symbolConstant:d("symbol-constant",60253),symbolEnumMember:d("symbol-enum-member",60254),symbolField:d("symbol-field",60255),symbolFile:d("symbol-file",60256),symbolInterface:d("symbol-interface",60257),symbolKeyword:d("symbol-keyword",60258),symbolMisc:d("symbol-misc",60259),symbolOperator:d("symbol-operator",60260),symbolProperty:d("symbol-property",60261),wrench:d("wrench",60261),wrenchSubaction:d("wrench-subaction",60261),symbolSnippet:d("symbol-snippet",60262),tasklist:d("tasklist",60263),telescope:d("telescope",60264),textSize:d("text-size",60265),threeBars:d("three-bars",60266),thumbsdown:d("thumbsdown",60267),thumbsup:d("thumbsup",60268),tools:d("tools",60269),triangleDown:d("triangle-down",60270),triangleLeft:d("triangle-left",60271),triangleRight:d("triangle-right",60272),triangleUp:d("triangle-up",60273),twitter:d("twitter",60274),unfold:d("unfold",60275),unlock:d("unlock",60276),unmute:d("unmute",60277),unverified:d("unverified",60278),verified:d("verified",60279),versions:d("versions",60280),vmActive:d("vm-active",60281),vmOutline:d("vm-outline",60282),vmRunning:d("vm-running",60283),watch:d("watch",60284),whitespace:d("whitespace",60285),wholeWord:d("whole-word",60286),window:d("window",60287),wordWrap:d("word-wrap",60288),zoomIn:d("zoom-in",60289),zoomOut:d("zoom-out",60290),listFilter:d("list-filter",60291),listFlat:d("list-flat",60292),listSelection:d("list-selection",60293),selection:d("selection",60293),listTree:d("list-tree",60294),debugBreakpointFunctionUnverified:d("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:d("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:d("debug-breakpoint-function-disabled",60296),debugStackframeActive:d("debug-stackframe-active",60297),circleSmallFilled:d("circle-small-filled",60298),debugStackframeDot:d("debug-stackframe-dot",60298),debugStackframe:d("debug-stackframe",60299),debugStackframeFocused:d("debug-stackframe-focused",60299),debugBreakpointUnsupported:d("debug-breakpoint-unsupported",60300),symbolString:d("symbol-string",60301),debugReverseContinue:d("debug-reverse-continue",60302),debugStepBack:d("debug-step-back",60303),debugRestartFrame:d("debug-restart-frame",60304),callIncoming:d("call-incoming",60306),callOutgoing:d("call-outgoing",60307),menu:d("menu",60308),expandAll:d("expand-all",60309),feedback:d("feedback",60310),gitPullRequestReviewer:d("git-pull-request-reviewer",60310),groupByRefType:d("group-by-ref-type",60311),ungroupByRefType:d("ungroup-by-ref-type",60312),account:d("account",60313),gitPullRequestAssignee:d("git-pull-request-assignee",60313),bellDot:d("bell-dot",60314),debugConsole:d("debug-console",60315),library:d("library",60316),output:d("output",60317),runAll:d("run-all",60318),syncIgnored:d("sync-ignored",60319),pinned:d("pinned",60320),githubInverted:d("github-inverted",60321),debugAlt:d("debug-alt",60305),serverProcess:d("server-process",60322),serverEnvironment:d("server-environment",60323),pass:d("pass",60324),stopCircle:d("stop-circle",60325),playCircle:d("play-circle",60326),record:d("record",60327),debugAltSmall:d("debug-alt-small",60328),vmConnect:d("vm-connect",60329),cloud:d("cloud",60330),merge:d("merge",60331),exportIcon:d("export",60332),graphLeft:d("graph-left",60333),magnet:d("magnet",60334),notebook:d("notebook",60335),redo:d("redo",60336),checkAll:d("check-all",60337),pinnedDirty:d("pinned-dirty",60338),passFilled:d("pass-filled",60339),circleLargeFilled:d("circle-large-filled",60340),circleLarge:d("circle-large",60341),circleLargeOutline:d("circle-large-outline",60341),combine:d("combine",60342),gather:d("gather",60342),table:d("table",60343),variableGroup:d("variable-group",60344),typeHierarchy:d("type-hierarchy",60345),typeHierarchySub:d("type-hierarchy-sub",60346),typeHierarchySuper:d("type-hierarchy-super",60347),gitPullRequestCreate:d("git-pull-request-create",60348),runAbove:d("run-above",60349),runBelow:d("run-below",60350),notebookTemplate:d("notebook-template",60351),debugRerun:d("debug-rerun",60352),workspaceTrusted:d("workspace-trusted",60353),workspaceUntrusted:d("workspace-untrusted",60354),workspaceUnspecified:d("workspace-unspecified",60355),terminalCmd:d("terminal-cmd",60356),terminalDebian:d("terminal-debian",60357),terminalLinux:d("terminal-linux",60358),terminalPowershell:d("terminal-powershell",60359),terminalTmux:d("terminal-tmux",60360),terminalUbuntu:d("terminal-ubuntu",60361),terminalBash:d("terminal-bash",60362),arrowSwap:d("arrow-swap",60363),copy:d("copy",60364),personAdd:d("person-add",60365),filterFilled:d("filter-filled",60366),wand:d("wand",60367),debugLineByLine:d("debug-line-by-line",60368),inspect:d("inspect",60369),layers:d("layers",60370),layersDot:d("layers-dot",60371),layersActive:d("layers-active",60372),compass:d("compass",60373),compassDot:d("compass-dot",60374),compassActive:d("compass-active",60375),azure:d("azure",60376),issueDraft:d("issue-draft",60377),gitPullRequestClosed:d("git-pull-request-closed",60378),gitPullRequestDraft:d("git-pull-request-draft",60379),debugAll:d("debug-all",60380),debugCoverage:d("debug-coverage",60381),runErrors:d("run-errors",60382),folderLibrary:d("folder-library",60383),debugContinueSmall:d("debug-continue-small",60384),beakerStop:d("beaker-stop",60385),graphLine:d("graph-line",60386),graphScatter:d("graph-scatter",60387),pieChart:d("pie-chart",60388),bracketDot:d("bracket-dot",60389),bracketError:d("bracket-error",60390),lockSmall:d("lock-small",60391),azureDevops:d("azure-devops",60392),verifiedFilled:d("verified-filled",60393),newLine:d("newline",60394),layout:d("layout",60395),layoutActivitybarLeft:d("layout-activitybar-left",60396),layoutActivitybarRight:d("layout-activitybar-right",60397),layoutPanelLeft:d("layout-panel-left",60398),layoutPanelCenter:d("layout-panel-center",60399),layoutPanelJustify:d("layout-panel-justify",60400),layoutPanelRight:d("layout-panel-right",60401),layoutPanel:d("layout-panel",60402),layoutSidebarLeft:d("layout-sidebar-left",60403),layoutSidebarRight:d("layout-sidebar-right",60404),layoutStatusbar:d("layout-statusbar",60405),layoutMenubar:d("layout-menubar",60406),layoutCentered:d("layout-centered",60407),layoutSidebarRightOff:d("layout-sidebar-right-off",60416),layoutPanelOff:d("layout-panel-off",60417),layoutSidebarLeftOff:d("layout-sidebar-left-off",60418),target:d("target",60408),indent:d("indent",60409),recordSmall:d("record-small",60410),errorSmall:d("error-small",60411),arrowCircleDown:d("arrow-circle-down",60412),arrowCircleLeft:d("arrow-circle-left",60413),arrowCircleRight:d("arrow-circle-right",60414),arrowCircleUp:d("arrow-circle-up",60415),heartFilled:d("heart-filled",60420),map:d("map",60421),mapFilled:d("map-filled",60422),circleSmall:d("circle-small",60423),bellSlash:d("bell-slash",60424),bellSlashDot:d("bell-slash-dot",60425),commentUnresolved:d("comment-unresolved",60426),gitPullRequestGoToChanges:d("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:d("git-pull-request-new-changes",60428),searchFuzzy:d("search-fuzzy",60429),commentDraft:d("comment-draft",60430),send:d("send",60431),sparkle:d("sparkle",60432),insert:d("insert",60433),mic:d("mic",60434),dialogError:d("dialog-error","error"),dialogWarning:d("dialog-warning","warning"),dialogInfo:d("dialog-info","info"),dialogClose:d("dialog-close","close"),treeItemExpanded:d("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:d("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:d("tree-filter-on-type-off","list-selection"),treeFilterClear:d("tree-filter-clear","close"),treeItemLoading:d("tree-item-loading","loading"),menuSelection:d("menu-selection","check"),menuSubmenu:d("menu-submenu","chevron-right"),menuBarMore:d("menubar-more","more"),scrollbarButtonLeft:d("scrollbar-button-left","triangle-left"),scrollbarButtonRight:d("scrollbar-button-right","triangle-right"),scrollbarButtonUp:d("scrollbar-button-up","triangle-up"),scrollbarButtonDown:d("scrollbar-button-down","triangle-down"),toolBarMore:d("toolbar-more","more"),quickInputBack:d("quick-input-back","arrow-left")}}),define(De[24],Ce([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=void 0;function F(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const r=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([o,m])=>{r[o]=m&&typeof m=="object"?F(m):m}),r}e.$3m=F;function d(c){if(!c||typeof c!="object")return c;const r=[c];for(;r.length>0;){const o=r.shift();Object.freeze(o);for(const m in o)if(M.call(o,m)){const h=o[m];typeof h=="object"&&!Object.isFrozen(h)&&!(0,C.$Af)(h)&&r.push(h)}}return c}e.$4m=d;const M=Object.prototype.hasOwnProperty;function A(c,r){return b(c,r,new Set)}e.$5m=A;function b(c,r,o){if((0,C.$Gf)(c))return c;const m=r(c);if(typeof m<"u")return m;if(Array.isArray(c)){const h=[];for(const t of c)h.push(b(t,r,o));return h}if((0,C.$zf)(c)){if(o.has(c))throw new Error("Cannot clone recursive data-structure");o.add(c);const h={};for(const t in c)M.call(c,t)&&(h[t]=b(c[t],r,o));return o.delete(c),h}return c}function E(c,r,o=!0){return(0,C.$zf)(c)?((0,C.$zf)(r)&&Object.keys(r).forEach(m=>{m in c?o&&((0,C.$zf)(c[m])&&(0,C.$zf)(r[m])?E(c[m],r[m],o):c[m]=r[m]):c[m]=r[m]}),c):r}e.$6m=E;function w(c,r){if(c===r)return!0;if(c==null||r===null||r===void 0||typeof c!=typeof r||typeof c!="object"||Array.isArray(c)!==Array.isArray(r))return!1;let o,m;if(Array.isArray(c)){if(c.length!==r.length)return!1;for(o=0;o<c.length;o++)if(!w(c[o],r[o]))return!1}else{const h=[];for(m in c)h.push(m);h.sort();const t=[];for(m in r)t.push(m);if(t.sort(),!w(h,t))return!1;for(o=0;o<h.length;o++)if(!w(c[h[o]],r[h[o]]))return!1}return!0}e.$7m=w;function R(c){const r=new Set;return JSON.stringify(c,(o,m)=>{if((0,C.$zf)(m)||Array.isArray(m)){if(r.has(m))return"[Circular]";r.add(m)}return m})}e.$8m=R;function I(c,r){const o=Object.create(null);return!c||!r||Object.keys(r).forEach(h=>{const t=c[h],n=r[h];w(t,n)||(o[h]=n)}),o}e.$9m=I;function v(c,r){const o=r.toLowerCase(),m=Object.keys(c).find(h=>h.toLowerCase()===o);return m?c[m]:c[r]}e.$0m=v;function y(c,r){const o=Object.create(null);for(const[m,h]of Object.entries(c))r(m,h)&&(o[m]=h);return o}e.$$m=y;function D(c){let r=[];for(;Object.prototype!==c;)r=r.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return r}e.$_m=D;function p(c){const r=[];for(const o of D(c))typeof c[o]=="function"&&r.push(o);return r}e.$an=p;function l(c,r){const o=h=>function(){const t=Array.prototype.slice.call(arguments,0);return r(h,t)},m={};for(const h of c)m[h]=o(h);return m}e.$bn=l}),define(De[59],Ce([1,0,78]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Tj=e.ThemeColor=void 0;var F;(function(A){function b(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=b})(F||(e.ThemeColor=F={}));function d(A){return{id:A}}e.$Tj=d;var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(r){const o=b.exec(r.id);if(!o)return E(C.$Sj.error);const[,m,h]=o,t=["codicon","codicon-"+m];return h&&t.push("codicon-modifier-"+h.substring(1)),t}A.asClassNameArray=E;function w(r){return E(r).join(" ")}A.asClassName=w;function R(r){return"."+E(r).join(".")}A.asCSSSelector=R;function I(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||F.isThemeColor(r.color))}A.isThemeIcon=I;const v=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function y(r){const o=v.exec(r);if(!o)return;const[,m]=o;return{id:m}}A.fromString=y;function D(r){return{id:r}}A.fromId=D;function p(r,o){let m=r.id;const h=m.lastIndexOf("~");return h!==-1&&(m=m.substring(0,h)),o&&(m=`${m}~${o}`),{id:m}}A.modify=p;function l(r){const o=r.id.lastIndexOf("~");if(o!==-1)return r.id.substring(o+1)}A.getModifier=l;function c(r,o){return r.id===o.id&&r.color?.id===o.color?.id}A.isEqual=c})(M||(e.ThemeIcon=M={}))}),define(De[161],Ce([1,0,121,15,59]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=void 0;const M="$(",A=new RegExp(`\\$\\(${d.ThemeIcon.iconNameExpression}(?:${d.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${A.source}`,"g");function E(c){return c.replace(b,(r,o)=>o?r:`\\${r}`)}e.$Uj=E;const w=new RegExp(`\\\\${A.source}`,"g");function R(c){return c.replace(w,r=>`\\${r}`)}e.$Vj=R;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function v(c){return c.indexOf(M)===-1?c:c.replace(I,(r,o,m,h)=>m?r:o||h||"")}e.$Wj=v;function y(c){return c?c.replace(/\$\((.*?)\)/g,(r,o)=>` ${o} `).trim():""}e.$Xj=y;const D=new RegExp(`\\$\\(${d.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(c){D.lastIndex=0;let r="";const o=[];let m=0;for(;;){const h=D.lastIndex,t=D.exec(c),n=c.substring(h,t?.index);if(n.length>0){r+=n;for(let a=0;a<n.length;a++)o.push(m)}if(!t)break;m+=t[0].length}return{text:r,iconOffsets:o}}e.$Yj=p;function l(c,r,o=!1){const{text:m,iconOffsets:h}=r;if(!h||h.length===0)return(0,C.$Hj)(c,m,o);const t=(0,F.$Ie)(m," "),n=m.length-t.length,a=(0,C.$Hj)(c,t,o);if(a)for(const i of a){const s=h[i.start+n]+n;i.start+=s,i.end+=s}return a}e.$Zj=l}),define(De[122],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.Constants=void 0;var C;(function(M){M[M.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",M[M.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",M[M.MAX_UINT_8=255]="MAX_UINT_8",M[M.MAX_UINT_16=65535]="MAX_UINT_16",M[M.MAX_UINT_32=4294967295]="MAX_UINT_32",M[M.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function F(M){return M<0?0:M>255?255:M|0}e.$ye=F;function d(M){return M<0?0:M>4294967295?4294967295:M|0}e.$ze=d}),define(De[31],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(d){return C.test(d)}e.$cg=F,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let d;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?d=crypto.getRandomValues.bind(crypto):d=function(b){for(let E=0;E<b.length;E++)b[E]=Math.floor(Math.random()*256);return b};const M=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));return function(){d(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let E=0,w="";return w+=A[M[E++]],w+=A[M[E++]],w+=A[M[E++]],w+=A[M[E++]],w+="-",w+=A[M[E++]],w+=A[M[E++]],w+="-",w+=A[M[E++]],w+=A[M[E++]],w+="-",w+=A[M[E++]],w+=A[M[E++]],w+="-",w+=A[M[E++]],w+=A[M[E++]],w+=A[M[E++]],w+=A[M[E++]],w+=A[M[E++]],w+=A[M[E++]],w}}()}),define(De[162],Ce([1,0,19,51,31]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=e.$Xs=e.$Ws=e.$Vs=e.$Us=void 0;function M(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$Us=M;function A(I,v,y){const D={id:(0,d.$dg)(),name:I,uri:v,data:y};return{asString:async()=>"",asFile:()=>D,value:void 0}}e.$Vs=A;class b{constructor(){this.a=new Map}get size(){let v=0;for(const y of this.a)v++;return v}has(v){return this.a.has(this.b(v))}matches(v){const y=[...this.a.keys()];return F.Iterable.some(this,([D,p])=>p.asFile())&&y.push("files"),R(E(v),y)}get(v){return this.a.get(this.b(v))?.[0]}append(v,y){const D=this.a.get(v);D?D.push(y):this.a.set(this.b(v),[y])}replace(v,y){this.a.set(this.b(v),[y])}delete(v){this.a.delete(this.b(v))}*[Symbol.iterator](){for(const[v,y]of this.a)for(const D of y)yield[v,D]}b(v){return E(v)}}e.$Ws=b;function E(I){return I.toLowerCase()}function w(I,v){return R(E(I),v.map(E))}e.$Xs=w;function R(I,v){if(I==="*/*")return v.length>0;if(v.includes(I))return!0;const y=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[D,p,l]=y;return l==="*"?v.some(c=>c.startsWith(p+"/")):!1}e.$Ys=Object.freeze({create:I=>(0,C.$Lb)(I.map(v=>v.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Ys.split(I).filter(v=>!v.startsWith("#"))})}),define(De[163],Ce([1,0,60]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.$gg=e.$fg=void 0;function F(b,E,w,R=1){let I=!1;return new Promise(v=>{const y=setTimeout(()=>{if(!I)return I=!0,v(0)},w);d(b,E,R,D=>{if(!I)return I=!0,clearTimeout(y),v(D)})})}e.$fg=F;function d(b,E,w,R){if(E===0)return R(0);const I=new C.Socket;I.once("connect",()=>(A(I),d(b+w,E-1,w,R))),I.once("data",()=>{}),I.once("error",v=>(A(I),v.code!=="ECONNREFUSED"?d(b+w,E-1,w,R):R(b))),I.connect(b,"127.0.0.1")}e.$gg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(b,E,w,R="127.0.0.1"){let I=!1,v,y=1;const D=C.createServer({pauseOnConnect:!0});function p(l,c){I||(I=!0,D.removeAllListeners(),D.close(),v&&clearTimeout(v),c(l))}return new Promise(l=>{v=setTimeout(()=>{p(0,l)},w),D.on("listening",()=>{p(b,l)}),D.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&y<E?(b++,y++,D.listen(b,R)):p(0,l)}),D.on("close",()=>{p(0,l)}),D.listen(b,R)})}e.$hg=M;function A(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(E){console.error(E)}}}),define(De[123],Ce([1,0,122]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=e.$Ms=void 0;class F{constructor(b){const E=(0,C.$ye)(b);this.c=E,this.a=F.d(E),this.b=new Map}static d(b){const E=new Uint8Array(256);return E.fill(b),E}set(b,E){const w=(0,C.$ye)(E);b>=0&&b<256?this.a[b]=w:this.b.set(b,w)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Ms=F;var d;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(d||(d={}));class M{constructor(){this.a=new F(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$Ns=M}),define(De[61],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=void 0;class C{constructor(d,M){this.lineNumber=d,this.column=M}with(d=this.lineNumber,M=this.column){return d===this.lineNumber&&M===this.column?this:new C(d,M)}delta(d=0,M=0){return this.with(this.lineNumber+d,this.column+M)}equals(d){return C.equals(this,d)}static equals(d,M){return!d&&!M?!0:!!d&&!!M&&d.lineNumber===M.lineNumber&&d.column===M.column}isBefore(d){return C.isBefore(this,d)}static isBefore(d,M){return d.lineNumber<M.lineNumber?!0:M.lineNumber<d.lineNumber?!1:d.column<M.column}isBeforeOrEqual(d){return C.isBeforeOrEqual(this,d)}static isBeforeOrEqual(d,M){return d.lineNumber<M.lineNumber?!0:M.lineNumber<d.lineNumber?!1:d.column<=M.column}static compare(d,M){const A=d.lineNumber|0,b=M.lineNumber|0;if(A===b){const E=d.column|0,w=M.column|0;return E-w}return A-b}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(d){return new C(d.lineNumber,d.column)}static isIPosition(d){return d&&typeof d.lineNumber=="number"&&typeof d.column=="number"}}e.$os=C}),define(De[34],Ce([1,0,61]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0;class F{constructor(M,A,b,E){M>b||M===b&&A>E?(this.startLineNumber=b,this.startColumn=E,this.endLineNumber=M,this.endColumn=A):(this.startLineNumber=M,this.startColumn=A,this.endLineNumber=b,this.endColumn=E)}isEmpty(){return F.isEmpty(this)}static isEmpty(M){return M.startLineNumber===M.endLineNumber&&M.startColumn===M.endColumn}containsPosition(M){return F.containsPosition(this,M)}static containsPosition(M,A){return!(A.lineNumber<M.startLineNumber||A.lineNumber>M.endLineNumber||A.lineNumber===M.startLineNumber&&A.column<M.startColumn||A.lineNumber===M.endLineNumber&&A.column>M.endColumn)}static strictContainsPosition(M,A){return!(A.lineNumber<M.startLineNumber||A.lineNumber>M.endLineNumber||A.lineNumber===M.startLineNumber&&A.column<=M.startColumn||A.lineNumber===M.endLineNumber&&A.column>=M.endColumn)}containsRange(M){return F.containsRange(this,M)}static containsRange(M,A){return!(A.startLineNumber<M.startLineNumber||A.endLineNumber<M.startLineNumber||A.startLineNumber>M.endLineNumber||A.endLineNumber>M.endLineNumber||A.startLineNumber===M.startLineNumber&&A.startColumn<M.startColumn||A.endLineNumber===M.endLineNumber&&A.endColumn>M.endColumn)}strictContainsRange(M){return F.strictContainsRange(this,M)}static strictContainsRange(M,A){return!(A.startLineNumber<M.startLineNumber||A.endLineNumber<M.startLineNumber||A.startLineNumber>M.endLineNumber||A.endLineNumber>M.endLineNumber||A.startLineNumber===M.startLineNumber&&A.startColumn<=M.startColumn||A.endLineNumber===M.endLineNumber&&A.endColumn>=M.endColumn)}plusRange(M){return F.plusRange(this,M)}static plusRange(M,A){let b,E,w,R;return A.startLineNumber<M.startLineNumber?(b=A.startLineNumber,E=A.startColumn):A.startLineNumber===M.startLineNumber?(b=A.startLineNumber,E=Math.min(A.startColumn,M.startColumn)):(b=M.startLineNumber,E=M.startColumn),A.endLineNumber>M.endLineNumber?(w=A.endLineNumber,R=A.endColumn):A.endLineNumber===M.endLineNumber?(w=A.endLineNumber,R=Math.max(A.endColumn,M.endColumn)):(w=M.endLineNumber,R=M.endColumn),new F(b,E,w,R)}intersectRanges(M){return F.intersectRanges(this,M)}static intersectRanges(M,A){let b=M.startLineNumber,E=M.startColumn,w=M.endLineNumber,R=M.endColumn;const I=A.startLineNumber,v=A.startColumn,y=A.endLineNumber,D=A.endColumn;return b<I?(b=I,E=v):b===I&&(E=Math.max(E,v)),w>y?(w=y,R=D):w===y&&(R=Math.min(R,D)),b>w||b===w&&E>R?null:new F(b,E,w,R)}equalsRange(M){return F.equalsRange(this,M)}static equalsRange(M,A){return!M&&!A?!0:!!M&&!!A&&M.startLineNumber===A.startLineNumber&&M.startColumn===A.startColumn&&M.endLineNumber===A.endLineNumber&&M.endColumn===A.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(M){return new C.$os(M.endLineNumber,M.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(M){return new C.$os(M.startLineNumber,M.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(M,A){return new F(this.startLineNumber,this.startColumn,M,A)}setStartPosition(M,A){return new F(M,A,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(M){return new F(M.startLineNumber,M.startColumn,M.startLineNumber,M.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(M){return new F(M.endLineNumber,M.endColumn,M.endLineNumber,M.endColumn)}delta(M){return new F(this.startLineNumber+M,this.startColumn,this.endLineNumber+M,this.endColumn)}static fromPositions(M,A=M){return new F(M.lineNumber,M.column,A.lineNumber,A.column)}static lift(M){return M?new F(M.startLineNumber,M.startColumn,M.endLineNumber,M.endColumn):null}static isIRange(M){return M&&typeof M.startLineNumber=="number"&&typeof M.startColumn=="number"&&typeof M.endLineNumber=="number"&&typeof M.endColumn=="number"}static areIntersectingOrTouching(M,A){return!(M.endLineNumber<A.startLineNumber||M.endLineNumber===A.startLineNumber&&M.endColumn<A.startColumn||A.endLineNumber<M.startLineNumber||A.endLineNumber===M.startLineNumber&&A.endColumn<M.startColumn)}static areIntersecting(M,A){return!(M.endLineNumber<A.startLineNumber||M.endLineNumber===A.startLineNumber&&M.endColumn<=A.startColumn||A.endLineNumber<M.startLineNumber||A.endLineNumber===M.startLineNumber&&A.endColumn<=M.startColumn)}static compareRangesUsingStarts(M,A){if(M&&A){const w=M.startLineNumber|0,R=A.startLineNumber|0;if(w===R){const I=M.startColumn|0,v=A.startColumn|0;if(I===v){const y=M.endLineNumber|0,D=A.endLineNumber|0;if(y===D){const p=M.endColumn|0,l=A.endColumn|0;return p-l}return y-D}return I-v}return w-R}return(M?1:0)-(A?1:0)}static compareRangesUsingEnds(M,A){return M.endLineNumber===A.endLineNumber?M.endColumn===A.endColumn?M.startLineNumber===A.startLineNumber?M.startColumn-A.startColumn:M.startLineNumber-A.startLineNumber:M.endColumn-A.endColumn:M.endLineNumber-A.endLineNumber}static spansMultipleLines(M){return M.endLineNumber>M.startLineNumber}toJSON(){return this}}e.$ps=F}),define(De[164],Ce([1,0,34]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=void 0;class F{static insert(M,A){return{range:new C.$ps(M.lineNumber,M.column,M.lineNumber,M.column),text:A,forceMoveMarkers:!0}}static delete(M){return{range:M,text:null}}static replace(M,A){return{range:M,text:A}}static replaceMove(M,A){return{range:M,text:A,forceMoveMarkers:!0}}}e.$qs=F}),define(De[165],Ce([1,0,61,34]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.SelectionDirection=void 0;var d;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(d||(e.SelectionDirection=d={}));class M extends F.$ps{constructor(b,E,w,R){super(b,E,w,R),this.selectionStartLineNumber=b,this.selectionStartColumn=E,this.positionLineNumber=w,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return M.selectionsEqual(this,b)}static selectionsEqual(b,E){return b.selectionStartLineNumber===E.selectionStartLineNumber&&b.selectionStartColumn===E.selectionStartColumn&&b.positionLineNumber===E.positionLineNumber&&b.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,E){return this.getDirection()===0?new M(this.startLineNumber,this.startColumn,b,E):new M(b,E,this.startLineNumber,this.startColumn)}getPosition(){return new C.$os(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.$os(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,E){return this.getDirection()===0?new M(b,E,this.endLineNumber,this.endColumn):new M(this.endLineNumber,this.endColumn,b,E)}static fromPositions(b,E=b){return new M(b.lineNumber,b.column,E.lineNumber,E.column)}static fromRange(b,E){return E===0?new M(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new M(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new M(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,E){if(b&&!E||!b&&E)return!1;if(!b&&!E)return!0;if(b.length!==E.length)return!1;for(let w=0,R=b.length;w<R;w++)if(!this.selectionsEqual(b[w],E[w]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,E,w,R,I){return I===0?new M(b,E,w,R):new M(w,R,b,E)}}e.$rs=M}),define(De[166],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0,e.$Zr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[167],Ce([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=e.$Os=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class d extends C.$Ms{constructor(b){super(0);for(let E=0,w=b.length;E<w;E++)this.set(b.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Os=d;function M(A){const b={};return E=>(b.hasOwnProperty(E)||(b[E]=A(E)),b[E])}e.$Ps=M(A=>new d(A))}),define(De[124],Ce([1,0,51,3,75]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=e.$4r=e.$3r=e.$2r=e.$1r=void 0,e.$1r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function M(I=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$1r)I.indexOf(y)>=0||(v+="\\"+y);return v+="\\s]+)",new RegExp(v,"g")}e.$2r=M();function A(I){let v=e.$2r;if(I&&I instanceof RegExp)if(I.global)v=I;else{let y="g";I.ignoreCase&&(y+="i"),I.multiline&&(y+="m"),I.unicode&&(y+="u"),v=new RegExp(I.source,y)}return v.lastIndex=0,v}e.$3r=A;const b=new d.$1c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(I){const v=b.unshift(I);return(0,F.$Pc)(v)}e.$4r=E;function w(I,v,y,D,p){if(p||(p=C.Iterable.first(b)),y.length>p.maxLen){let m=I-p.maxLen/2;return m<0?m=0:D+=m,y=y.substring(m,I+p.maxLen/2),w(I,v,y,D,p)}const l=Date.now(),c=I-1-D;let r=-1,o=null;for(let m=1;!(Date.now()-l>=p.timeBudget);m++){const h=c-p.windowSize*m;v.lastIndex=Math.max(0,h);const t=R(v,y,c,r);if(!t&&o||(o=t,h<=0))break;r=h}if(o){const m={word:o[0],startColumn:D+1+o.index,endColumn:D+1+o.index+o[0].length};return v.lastIndex=0,m}return null}e.$5r=w;function R(I,v,y,D){let p;for(;p=I.exec(v);){const l=p.index||0;if(l<=y&&I.lastIndex>=y)return p;if(D>0&&l>D)return null}return null}}),define(De[168],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.$lt=e.IndentAction=void 0;var C;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class F{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let E=0,w=b.notIn.length;E<w;E++)switch(b.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,E){if(b.getTokenCount()===0)return!0;const w=b.findTokenIndexAtOffset(E-2),R=b.getStandardTokenType(w);return this.isOK(R)}g(b,E){for(let w=b;w<=E;w++){const R=String.fromCharCode(w);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$lt=F;class d{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of b)M(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),M(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),M(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),M(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&M(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$mt=d;function M(A,b,E){A.has(b)?A.get(b).push(E):A.set(b,[E])}}),define(De[169],Ce([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VY=e.$UY=e.$TY=e.State=void 0;var F;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class d{constructor(D,p,l){const c=new Uint8Array(D*p);for(let r=0,o=D*p;r<o;r++)c[r]=l;this.a=c,this.rows=D,this.cols=p}get(D,p){return this.a[D*this.cols+p]}set(D,p,l){this.a[D*this.cols+p]=l}}class M{constructor(D){let p=0,l=0;for(let r=0,o=D.length;r<o;r++){const[m,h,t]=D[r];h>p&&(p=h),m>l&&(l=m),t>l&&(l=t)}p++,l++;const c=new d(l,p,0);for(let r=0,o=D.length;r<o;r++){const[m,h,t]=D[r];c.set(m,h,t)}this.a=c,this.b=p}nextState(D,p){return p<0||p>=this.b?0:this.a.get(D,p)}}e.$TY=M;let A=null;function b(){return A===null&&(A=new M([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let w=null;function R(){if(w===null){w=new C.$Ms(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<y.length;p++)w.set(y.charCodeAt(p),1);const D=".,;:";for(let p=0;p<D.length;p++)w.set(D.charCodeAt(p),2)}return w}class I{static a(D,p,l,c,r){let o=r-1;do{const m=p.charCodeAt(o);if(D.get(m)!==2)break;o--}while(o>c);if(c>0){const m=p.charCodeAt(c-1),h=p.charCodeAt(o);(m===40&&h===41||m===91&&h===93||m===123&&h===125)&&o--}return{range:{startLineNumber:l,startColumn:c+1,endLineNumber:l,endColumn:o+2},url:p.substring(c,o+1)}}static computeLinks(D,p=b()){const l=R(),c=[];for(let r=1,o=D.getLineCount();r<=o;r++){const m=D.getLineContent(r),h=m.length;let t=0,n=0,a=0,i=1,s=!1,u=!1,S=!1,k=!1;for(;t<h;){let $=!1;const f=m.charCodeAt(t);if(i===13){let g;switch(f){case 40:s=!0,g=0;break;case 41:g=s?0:1;break;case 91:S=!0,u=!0,g=0;break;case 93:S=!1,g=u?0:1;break;case 123:k=!0,g=0;break;case 125:g=k?0:1;break;case 39:case 34:case 96:a===f?g=1:a===39||a===34||a===96?g=0:g=1;break;case 42:g=a===42?1:0;break;case 124:g=a===124?1:0;break;case 32:g=S?0:1;break;default:g=l.get(f)}g===1&&(c.push(I.a(l,m,r,n,t)),$=!0)}else if(i===12){let g;f===91?(u=!0,g=0):g=l.get(f),g===1?$=!0:i=13}else i=p.nextState(i,f),i===0&&($=!0);$&&(i=1,s=!1,u=!1,k=!1,n=t+1,a=f),t++}i===13&&c.push(I.a(l,m,r,n,h))}return c}}e.$UY=I;function v(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:I.computeLinks(y)}e.$VY=v}),define(De[125],Ce([1,0,24]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lu=e.$Ku=e.$Ju=e.$Iu=e.ModelConstants=e.PositionAffinity=e.$Hu=e.TrackedRangeStickiness=e.$Gu=e.$Fu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var d;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(d||(e.GlyphMarginLane=d={}));var M;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(M||(e.MinimapPosition=M={}));var A;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var b;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var E;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var w;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(w||(e.EndOfLineSequence=w={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(h){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,h.tabSize|0),h.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,h.indentSize|0),this.a=!1),this.insertSpaces=!!h.insertSpaces,this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=!!h.trimAutoWhitespace,this.bracketPairColorizationOptions=h.bracketPairColorizationOptions}equals(h){return this.tabSize===h.tabSize&&this.a===h.a&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace&&(0,C.$7m)(this.bracketPairColorizationOptions,h.bracketPairColorizationOptions)}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.$Fu=R;class I{constructor(h,t){this._findMatchBrand=void 0,this.range=h,this.matches=t}}e.$Gu=I;var v;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(v||(e.TrackedRangeStickiness=v={}));function y(m){return m&&typeof m.read=="function"}e.$Hu=y;var D;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(D||(e.PositionAffinity=D={}));var p;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(p||(e.ModelConstants=p={}));class l{constructor(h,t,n,a,i,s){this.identifier=h,this.range=t,this.text=n,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=i,this._isTracked=s}}e.$Iu=l;class c{constructor(h,t,n){this.regex=h,this.wordSeparators=t,this.simpleSearch=n}}e.$Ju=c;class r{constructor(h,t,n){this.reverseEdits=h,this.changes=t,this.trimAutoWhitespaceLineNumbers=n}}e.$Ku=r;function o(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.$Lu=o}),define(De[170],Ce([1,0,19,122]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qu=e.$Pu=e.$Ou=void 0;class d{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,w){E=(0,F.$ze)(E);const R=this.a,I=this.b,v=w.length;return v===0?!1:(this.a=new Uint32Array(R.length+v),this.a.set(R.subarray(0,E),0),this.a.set(R.subarray(E),E+v),this.a.set(w,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(E,w){return E=(0,F.$ze)(E),w=(0,F.$ze)(w),this.a[E]===w?!1:(this.a[E]=w,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,w){E=(0,F.$ze)(E),w=(0,F.$ze)(w);const R=this.a,I=this.b;if(E>=R.length)return!1;const v=R.length-E;return w>=v&&(w=v),w===0?!1:(this.a=new Uint32Array(R.length-w),this.a.set(R.subarray(0,E),0),this.a.set(R.subarray(E+w),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,F.$ze)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let w=this.c[0]+1;w===0&&(this.b[0]=this.a[0],w++),E>=this.a.length&&(E=this.a.length-1);for(let R=w;R<=E;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let w=0,R=this.a.length-1,I=0,v=0,y=0;for(;w<=R;)if(I=w+(R-w)/2|0,v=this.b[I],y=v-this.a[I],E<y)R=I-1;else if(E>=v)w=I+1;else break;return new A(I,E-y)}}e.$Ou=d;class M{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const w=this.e[E],R=w>0?this.d[w-1]:0;return new A(w,E-R)}removeValues(E,w){this.a.splice(E,w),this.f(E)}insertValues(E,w){this.a=(0,C.$Vb)(this.a,E,w),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,w=this.a.length;E<w;E++){const R=this.a[E],I=E>0?this.d[E-1]:0;this.d[E]=I+R;for(let v=0;v<R;v++)this.e[I+v]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,w){this.a[E]!==w&&(this.a[E]=w,this.f(E))}}e.$Pu=M;class A{constructor(E,w){this.index=E,this.remainder=w,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=w}}e.$Qu=A}),define(De[171],Ce([1,0,15,61,170]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ru=void 0;class M{constructor(b,E,w,R){this.d=b,this.f=E,this.g=w,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const E=b.changes;for(const w of E)this.o(w.range),this.p(new F.$os(w.range.startLineNumber,w.range.startColumn),w.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,E=this.f.length,w=new Uint32Array(E);for(let R=0;R<E;R++)w[R]=this.f[R].length+b;this.j=new d.$Ou(w)}}n(b,E){this.f[b]=E,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,E){if(E.length===0)return;const w=(0,C.$Oe)(E);if(w.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+w[0]+this.f[b.lineNumber-1].substring(b.column-1));return}w[w.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+w[0]);const R=new Uint32Array(w.length-1);for(let I=1;I<w.length;I++)this.f.splice(b.lineNumber+I-1,0,w[I]),R[I-1]=w[I].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,R)}}e.$Ru=M}),define(De[172],Ce([1,0,15,167,61,34,125]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tB=e.$sB=e.$rB=e.$qB=e.$pB=e.$oB=void 0;const b=999;class E{constructor(r,o,m,h){this.searchString=r,this.isRegex=o,this.matchCase=m,this.wordSeparators=h}parseSearchRequest(){if(this.searchString==="")return null;let r;this.isRegex?r=w(this.searchString):r=this.searchString.indexOf(`
`)>=0;let o=null;try{o=C.$Me(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:r,global:!0,unicode:!0})}catch{return null}if(!o)return null;let m=!this.isRegex&&!r;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new A.$Ju(o,this.wordSeparators?(0,F.$Ps)(this.wordSeparators):null,m?this.searchString:null)}}e.$oB=E;function w(c){if(!c||c.length===0)return!1;for(let r=0,o=c.length;r<o;r++){const m=c.charCodeAt(r);if(m===10)return!0;if(m===92){if(r++,r>=o)break;const h=c.charCodeAt(r);if(h===110||h===114||h===87)return!0}}return!1}e.$pB=w;function R(c,r,o){if(!o)return new A.$Gu(c,null);const m=[];for(let h=0,t=r.length;h<t;h++)m[h]=r[h];return new A.$Gu(c,m)}e.$qB=R;class I{constructor(r){const o=[];let m=0;for(let h=0,t=r.length;h<t;h++)r.charCodeAt(h)===10&&(o[m++]=h);this.a=o}findLineFeedCountBeforeOffset(r){const o=this.a;let m=0,h=o.length-1;if(h===-1||r<=o[0])return 0;for(;m<h;){const t=m+((h-m)/2>>0);o[t]>=r?h=t-1:o[t+1]>=r?(m=t,h=t):m=t+1}return m+1}}class v{static findMatches(r,o,m,h,t){const n=o.parseSearchRequest();return n?n.regex.multiline?this.b(r,m,new l(n.wordSeparators,n.regex),h,t):this.c(r,m,n,h,t):[]}static a(r,o,m,h,t,n){let a,i=0;h?(i=h.findLineFeedCountBeforeOffset(t),a=o+t+i):a=o+t;let s;if(h){const $=h.findLineFeedCountBeforeOffset(t+n.length)-i;s=a+n.length+$}else s=a+n.length;const u=r.getPositionAt(a),S=r.getPositionAt(s);return new M.$ps(u.lineNumber,u.column,S.lineNumber,S.column)}static b(r,o,m,h,t){const n=r.getOffsetAt(o.getStartPosition()),a=r.getValueInRange(o,1),i=r.getEOL()===`\r
`?new I(a):null,s=[];let u=0,S;for(m.reset(0);S=m.next(a);)if(s[u++]=R(this.a(r,n,a,i,S.index,S[0]),S,h),u>=t)return s;return s}static c(r,o,m,h,t){const n=[];let a=0;if(o.startLineNumber===o.endLineNumber){const s=r.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return a=this.d(m,s,o.startLineNumber,o.startColumn-1,a,n,h,t),n}const i=r.getLineContent(o.startLineNumber).substring(o.startColumn-1);a=this.d(m,i,o.startLineNumber,o.startColumn-1,a,n,h,t);for(let s=o.startLineNumber+1;s<o.endLineNumber&&a<t;s++)a=this.d(m,r.getLineContent(s),s,0,a,n,h,t);if(a<t){const s=r.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);a=this.d(m,s,o.endLineNumber,0,a,n,h,t)}return n}static d(r,o,m,h,t,n,a,i){const s=r.wordSeparators;if(!a&&r.simpleSearch){const k=r.simpleSearch,$=k.length,f=o.length;let g=-$;for(;(g=o.indexOf(k,g+$))!==-1;)if((!s||p(s,o,f,g,$))&&(n[t++]=new A.$Gu(new M.$ps(m,g+1+h,m,g+1+$+h),null),t>=i))return t;return t}const u=new l(r.wordSeparators,r.regex);let S;u.reset(0);do if(S=u.next(o),S&&(n[t++]=R(new M.$ps(m,S.index+1+h,m,S.index+1+S[0].length+h),S,a),t>=i))return t;while(S);return t}static findNextMatch(r,o,m,h){const t=o.parseSearchRequest();if(!t)return null;const n=new l(t.wordSeparators,t.regex);return t.regex.multiline?this.e(r,m,n,h):this.f(r,m,n,h)}static e(r,o,m,h){const t=new d.$os(o.lineNumber,1),n=r.getOffsetAt(t),a=r.getLineCount(),i=r.getValueInRange(new M.$ps(t.lineNumber,t.column,a,r.getLineMaxColumn(a)),1),s=r.getEOL()===`\r
`?new I(i):null;m.reset(o.column-1);const u=m.next(i);return u?R(this.a(r,n,i,s,u.index,u[0]),u,h):o.lineNumber!==1||o.column!==1?this.e(r,new d.$os(1,1),m,h):null}static f(r,o,m,h){const t=r.getLineCount(),n=o.lineNumber,a=r.getLineContent(n),i=this.g(m,a,n,o.column,h);if(i)return i;for(let s=1;s<=t;s++){const u=(n+s-1)%t,S=r.getLineContent(u+1),k=this.g(m,S,u+1,1,h);if(k)return k}return null}static g(r,o,m,h,t){r.reset(h-1);const n=r.next(o);return n?R(new M.$ps(m,n.index+1,m,n.index+1+n[0].length),n,t):null}static findPreviousMatch(r,o,m,h){const t=o.parseSearchRequest();if(!t)return null;const n=new l(t.wordSeparators,t.regex);return t.regex.multiline?this.h(r,m,n,h):this.j(r,m,n,h)}static h(r,o,m,h){const t=this.b(r,new M.$ps(1,1,o.lineNumber,o.column),m,h,10*b);if(t.length>0)return t[t.length-1];const n=r.getLineCount();return o.lineNumber!==n||o.column!==r.getLineMaxColumn(n)?this.h(r,new d.$os(n,r.getLineMaxColumn(n)),m,h):null}static j(r,o,m,h){const t=r.getLineCount(),n=o.lineNumber,a=r.getLineContent(n).substring(0,o.column-1),i=this.k(m,a,n,h);if(i)return i;for(let s=1;s<=t;s++){const u=(t+n-s-1)%t,S=r.getLineContent(u+1),k=this.k(m,S,u+1,h);if(k)return k}return null}static k(r,o,m,h){let t=null,n;for(r.reset(0);n=r.next(o);)t=R(new M.$ps(m,n.index+1,m,n.index+1+n[0].length),n,h);return t}}e.$rB=v;function y(c,r,o,m,h){if(m===0)return!0;const t=r.charCodeAt(m-1);if(c.get(t)!==0||t===13||t===10)return!0;if(h>0){const n=r.charCodeAt(m);if(c.get(n)!==0)return!0}return!1}function D(c,r,o,m,h){if(m+h===o)return!0;const t=r.charCodeAt(m+h);if(c.get(t)!==0||t===13||t===10)return!0;if(h>0){const n=r.charCodeAt(m+h-1);if(c.get(n)!==0)return!0}return!1}function p(c,r,o,m,h){return y(c,r,o,m,h)&&D(c,r,o,m,h)}e.$sB=p;class l{constructor(r,o){this._wordSeparators=r,this.a=o,this.b=-1,this.c=0}reset(r){this.a.lastIndex=r,this.b=-1,this.c=0}next(r){const o=r.length;let m;do{if(this.b+this.c===o||(m=this.a.exec(r),!m))return null;const h=m.index,t=m[0].length;if(h===this.b&&t===this.c){if(t===0){C.$8e(r,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=h,this.c=t,!this._wordSeparators||p(this._wordSeparators,r,o,h,t))return m}while(m);return null}}e.$tB=l}),define(De[173],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H7=e.$G7=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const A=this.a.get(M);return this.a.delete(M),A}}addDragOperationTransfer(M,A){this.a.set(M,A)}}e.$G7=C;class F{constructor(M){this.identifier=M}}e.$H7=F}),define(De[174],Ce([1,0,4,3]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=void 0;class d{constructor(){this.a=new Map,this.b=new Map,this.c=new C.$Md,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,E){return this.a.set(b,E),this.handleChange([b]),(0,F.$Pc)(()=>{this.a.get(b)===E&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,E){this.b.get(b)?.dispose();const w=new M(this,b,E);return this.b.set(b,w),(0,F.$Pc)(()=>{const R=this.b.get(b);!R||R!==w||(this.b.delete(b),R.dispose())})}async getOrCreate(b){const E=this.get(b);if(E)return E;const w=this.b.get(b);return!w||w.isResolved?null:(await w.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const w=this.b.get(b);return!!(!w||w.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$1s=d;class M extends F.$Rc{get isResolved(){return this.c}constructor(b,E,w){super(),this.f=b,this.g=E,this.h=w,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(De[175],Ce([10,11]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(De[176],Ce([1,0,4,3,175]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class M extends F.$Rc{constructor(v,y="",D="",p=!0,l){super(),this.h=this.B(new C.$Md),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=y,this.u=D,this.w=p,this.C=l}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,y){this.C&&await this.C(v)}}e.$si=M;class A extends F.$Rc{constructor(){super(...arguments),this.f=this.B(new C.$Md),this.onWillRun=this.f.event,this.m=this.B(new C.$Md),this.onDidRun=this.m.event}async run(v,y){if(!v.enabled)return;this.f.fire({action:v});let D;try{await this.u(v,y)}catch(p){D=p}this.m.fire({action:v,error:D})}async u(v,y){await v.run(y)}}e.$ti=A;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let y=[];for(const D of v)D.length&&(y.length?y=[...y,new b,...D]:y=D);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$ui=b;class E{get actions(){return this.a}constructor(v,y,D,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=y,this.class=p,this.a=D}async run(){}}e.$vi=E;class w extends M{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,d.localize(0,null),void 0,!1)}}e.$wi=w;function R(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...v)=>I.run(...v),tooltip:I.label}}e.$xi=R}),define(De[177],Ce([10,11]),function($e,e){return $e.create("vs/base/common/date",e)}),define(De[178],Ce([1,0,177]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=void 0;const F=60,d=F*60,M=d*24,A=M*7,b=M*30,E=M*365;function w(I,v,y,D){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,C.localize)(0,null,w(new Date().getTime()+p*1e3,!1));if(!D&&p<30)return(0,C.localize)(1,null);let l;return p<F?(l=p,v?l===1?y?(0,C.localize)(2,null,l):(0,C.localize)(3,null,l):y?(0,C.localize)(4,null,l):(0,C.localize)(5,null,l):l===1?y?(0,C.localize)(6,null,l):(0,C.localize)(7,null,l):y?(0,C.localize)(8,null,l):(0,C.localize)(9,null,l)):p<d?(l=Math.floor(p/F),v?l===1?y?(0,C.localize)(10,null,l):(0,C.localize)(11,null,l):y?(0,C.localize)(12,null,l):(0,C.localize)(13,null,l):l===1?y?(0,C.localize)(14,null,l):(0,C.localize)(15,null,l):y?(0,C.localize)(16,null,l):(0,C.localize)(17,null,l)):p<M?(l=Math.floor(p/d),v?l===1?y?(0,C.localize)(18,null,l):(0,C.localize)(19,null,l):y?(0,C.localize)(20,null,l):(0,C.localize)(21,null,l):l===1?y?(0,C.localize)(22,null,l):(0,C.localize)(23,null,l):y?(0,C.localize)(24,null,l):(0,C.localize)(25,null,l)):p<A?(l=Math.floor(p/M),v?l===1?(0,C.localize)(26,null,l):(0,C.localize)(27,null,l):l===1?(0,C.localize)(28,null,l):(0,C.localize)(29,null,l)):p<b?(l=Math.floor(p/A),v?l===1?y?(0,C.localize)(30,null,l):(0,C.localize)(31,null,l):y?(0,C.localize)(32,null,l):(0,C.localize)(33,null,l):l===1?y?(0,C.localize)(34,null,l):(0,C.localize)(35,null,l):y?(0,C.localize)(36,null,l):(0,C.localize)(37,null,l)):p<E?(l=Math.floor(p/b),v?l===1?y?(0,C.localize)(38,null,l):(0,C.localize)(39,null,l):y?(0,C.localize)(40,null,l):(0,C.localize)(41,null,l):l===1?y?(0,C.localize)(42,null,l):(0,C.localize)(43,null,l):y?(0,C.localize)(44,null,l):(0,C.localize)(45,null,l)):(l=Math.floor(p/E),v?l===1?y?(0,C.localize)(46,null,l):(0,C.localize)(47,null,l):y?(0,C.localize)(48,null,l):(0,C.localize)(49,null,l):l===1?y?(0,C.localize)(50,null,l):(0,C.localize)(51,null,l):y?(0,C.localize)(52,null,l):(0,C.localize)(53,null,l))}e.$am=w;function R(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$bm=R}),define(De[179],Ce([10,11]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(De[47],Ce([1,0,19,18,179]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function M(I,v){return v&&(I.stack||I.stacktrace)?d.localize(0,null,b(I),A(I.stack)||A(I.stacktrace)):b(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?d.localize(1,null,I.message):I.message||d.localize(2,null)}function E(I=null,v=!1){if(!I)return d.localize(3,null);if(Array.isArray(I)){const y=C.$Gb(I),D=E(y[0],v);return y.length>1?d.localize(4,null,D,y.length):D}if(F.$xf(I))return I;if(I.detail){const y=I.detail;if(y.error)return M(y.error,v);if(y.exception)return M(y.exception,v)}return I.stack?M(I,v):I.message?I.message:d.localize(5,null)}e.$yi=E;function w(I){const v=I;return v instanceof Error&&Array.isArray(v.actions)}e.$zi=w;function R(I,v){let y;return typeof I=="string"?y=new Error(I):y=I,y.actions=v,y}e.$Ai=R}),define(De[180],Ce([10,11]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(De[12],Ce([1,0,180]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let F=!1,d=!1,M=!1,A=!1,b=!1,E=!1,w=!1,R=!1,I=!1,v=!1,y,D=e.$g,p=e.$g,l,c;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let r;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?r=e.$h.vscode.process:typeof process<"u"&&(r=process);const o=typeof r?.versions?.electron=="string",m=o&&r?.type==="renderer";if(typeof navigator=="object"&&!m)c=navigator.userAgent,F=c.indexOf("Windows")>=0,d=c.indexOf("Macintosh")>=0,R=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=c.indexOf("Linux")>=0,v=c?.indexOf("Mobi")>=0,E=!0,y=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$g,D=y,p=navigator.language;else if(typeof r=="object"){F=r.platform==="win32",d=r.platform==="darwin",M=r.platform==="linux",A=M&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,w=o,I=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,D=e.$g;const k=r.env.VSCODE_NLS_CONFIG;if(k)try{const $=JSON.parse(k),f=$.availableLanguages["*"];y=$.locale,p=$.osLocale,D=f||e.$g,l=$._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var h;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(h||(e.Platform=h={}));function t(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=t;let n=0;d?n=1:F?n=3:M&&(n=2),e.$j=F,e.$k=d,e.$l=M,e.$m=A,e.$n=b,e.$o=w,e.$p=E,e.$q=E&&typeof e.$h.importScripts=="function",e.$r=R,e.$s=v,e.$t=I,e.$u=n,e.$v=c,e.$w=D;var a;(function(k){function $(){return e.$w}k.value=$;function f(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=f;function g(){return e.$w==="en"}k.isDefault=g})(a||(e.Language=a={})),e.$x=y,e.$y=p,e.$z=l,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const k=[];e.$h.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let g=0,P=k.length;g<P;g++){const O=k[g];if(O.id===f.data.vscodeScheduleAsyncWork){k.splice(g,1),O.callback();return}}});let $=0;return f=>{const g=++$;k.push({id:g,callback:f}),e.$h.postMessage({vscodeScheduleAsyncWork:g},"*")}}return k=>setTimeout(k)})();var i;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=d||R?2:F?1:3;let s=!0,u=!1;function S(){if(!u){u=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,s=new Uint16Array(k.buffer)[0]===(2<<8)+1}return s}e.$D=S,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(De[48],Ce([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let F;if(typeof C.$h.vscode<"u"&&typeof C.$h.vscode.process<"u"){const d=C.$h.vscode.process;F={get platform(){return d.platform},get arch(){return d.arch},get env(){return d.env},cwd(){return d.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return C.$j?"win32":C.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$cc=F.platform,e.$dc=F.arch}),define(De[16],Ce([1,0,48]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const F=65,d=97,M=90,A=122,b=46,E=47,w=92,R=58,I=63;class v extends Error{constructor(n,a,i){let s;typeof a=="string"&&a.indexOf("not ")===0?(s="must not be",a=a.replace(/^not /,"")):s="must be";const u=n.indexOf(".")!==-1?"property":"argument";let S=`The "${n}" ${u} ${s} of type ${a}`;S+=`. Received type ${typeof i}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,n){if(t===null||typeof t!="object")throw new v(n,"Object",t)}function D(t,n){if(typeof t!="string")throw new v(n,"string",t)}const p=C.$cc==="win32";function l(t){return t===E||t===w}function c(t){return t===E}function r(t){return t>=F&&t<=M||t>=d&&t<=A}function o(t,n,a,i){let s="",u=0,S=-1,k=0,$=0;for(let f=0;f<=t.length;++f){if(f<t.length)$=t.charCodeAt(f);else{if(i($))break;$=E}if(i($)){if(!(S===f-1||k===1))if(k===2){if(s.length<2||u!==2||s.charCodeAt(s.length-1)!==b||s.charCodeAt(s.length-2)!==b){if(s.length>2){const g=s.lastIndexOf(a);g===-1?(s="",u=0):(s=s.slice(0,g),u=s.length-1-s.lastIndexOf(a)),S=f,k=0;continue}else if(s.length!==0){s="",u=0,S=f,k=0;continue}}n&&(s+=s.length>0?`${a}..`:"..",u=2)}else s.length>0?s+=`${a}${t.slice(S+1,f)}`:s=t.slice(S+1,f),u=f-S-1;S=f,k=0}else $===b&&k!==-1?++k:k=-1}return s}function m(t,n){y(n,"pathObject");const a=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return a?a===n.root?`${a}${i}`:`${a}${t}${i}`:i}e.$ec={resolve(...t){let n="",a="",i=!1;for(let s=t.length-1;s>=-1;s--){let u;if(s>=0){if(u=t[s],D(u,"path"),u.length===0)continue}else n.length===0?u=C.cwd():(u=C.env[`=${n}`]||C.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==n.toLowerCase()&&u.charCodeAt(2)===w)&&(u=`${n}\\`));const S=u.length;let k=0,$="",f=!1;const g=u.charCodeAt(0);if(S===1)l(g)&&(k=1,f=!0);else if(l(g))if(f=!0,l(u.charCodeAt(1))){let P=2,O=P;for(;P<S&&!l(u.charCodeAt(P));)P++;if(P<S&&P!==O){const N=u.slice(O,P);for(O=P;P<S&&l(u.charCodeAt(P));)P++;if(P<S&&P!==O){for(O=P;P<S&&!l(u.charCodeAt(P));)P++;(P===S||P!==O)&&($=`\\\\${N}\\${u.slice(O,P)}`,k=P)}}}else k=1;else r(g)&&u.charCodeAt(1)===R&&($=u.slice(0,2),k=2,S>2&&l(u.charCodeAt(2))&&(f=!0,k=3));if($.length>0)if(n.length>0){if($.toLowerCase()!==n.toLowerCase())continue}else n=$;if(i){if(n.length>0)break}else if(a=`${u.slice(k)}\\${a}`,i=f,f&&n.length>0)break}return a=o(a,!i,"\\",l),i?`${n}\\${a}`:`${n}${a}`||"."},normalize(t){D(t,"path");const n=t.length;if(n===0)return".";let a=0,i,s=!1;const u=t.charCodeAt(0);if(n===1)return c(u)?"\\":t;if(l(u))if(s=!0,l(t.charCodeAt(1))){let k=2,$=k;for(;k<n&&!l(t.charCodeAt(k));)k++;if(k<n&&k!==$){const f=t.slice($,k);for($=k;k<n&&l(t.charCodeAt(k));)k++;if(k<n&&k!==$){for($=k;k<n&&!l(t.charCodeAt(k));)k++;if(k===n)return`\\\\${f}\\${t.slice($)}\\`;k!==$&&(i=`\\\\${f}\\${t.slice($,k)}`,a=k)}}}else a=1;else r(u)&&t.charCodeAt(1)===R&&(i=t.slice(0,2),a=2,n>2&&l(t.charCodeAt(2))&&(s=!0,a=3));let S=a<n?o(t.slice(a),!s,"\\",l):"";return S.length===0&&!s&&(S="."),S.length>0&&l(t.charCodeAt(n-1))&&(S+="\\"),i===void 0?s?`\\${S}`:S:s?`${i}\\${S}`:`${i}${S}`},isAbsolute(t){D(t,"path");const n=t.length;if(n===0)return!1;const a=t.charCodeAt(0);return l(a)||n>2&&r(a)&&t.charCodeAt(1)===R&&l(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,a;for(let u=0;u<t.length;++u){const S=t[u];D(S,"path"),S.length>0&&(n===void 0?n=a=S:n+=`\\${S}`)}if(n===void 0)return".";let i=!0,s=0;if(typeof a=="string"&&l(a.charCodeAt(0))){++s;const u=a.length;u>1&&l(a.charCodeAt(1))&&(++s,u>2&&(l(a.charCodeAt(2))?++s:i=!1))}if(i){for(;s<n.length&&l(n.charCodeAt(s));)s++;s>=2&&(n=`\\${n.slice(s)}`)}return e.$ec.normalize(n)},relative(t,n){if(D(t,"from"),D(n,"to"),t===n)return"";const a=e.$ec.resolve(t),i=e.$ec.resolve(n);if(a===i||(t=a.toLowerCase(),n=i.toLowerCase(),t===n))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===w;)s++;let u=t.length;for(;u-1>s&&t.charCodeAt(u-1)===w;)u--;const S=u-s;let k=0;for(;k<n.length&&n.charCodeAt(k)===w;)k++;let $=n.length;for(;$-1>k&&n.charCodeAt($-1)===w;)$--;const f=$-k,g=S<f?S:f;let P=-1,O=0;for(;O<g;O++){const L=t.charCodeAt(s+O);if(L!==n.charCodeAt(k+O))break;L===w&&(P=O)}if(O!==g){if(P===-1)return i}else{if(f>g){if(n.charCodeAt(k+O)===w)return i.slice(k+O+1);if(O===2)return i.slice(k+O)}S>g&&(t.charCodeAt(s+O)===w?P=O:O===2&&(P=3)),P===-1&&(P=0)}let N="";for(O=s+P+1;O<=u;++O)(O===u||t.charCodeAt(O)===w)&&(N+=N.length===0?"..":"\\..");return k+=P,N.length>0?`${N}${i.slice(k,$)}`:(i.charCodeAt(k)===w&&++k,i.slice(k,$))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.$ec.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===w){if(n.charCodeAt(1)===w){const a=n.charCodeAt(2);if(a!==I&&a!==b)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(r(n.charCodeAt(0))&&n.charCodeAt(1)===R&&n.charCodeAt(2)===w)return`\\\\?\\${n}`;return t},dirname(t){D(t,"path");const n=t.length;if(n===0)return".";let a=-1,i=0;const s=t.charCodeAt(0);if(n===1)return l(s)?t:".";if(l(s)){if(a=i=1,l(t.charCodeAt(1))){let k=2,$=k;for(;k<n&&!l(t.charCodeAt(k));)k++;if(k<n&&k!==$){for($=k;k<n&&l(t.charCodeAt(k));)k++;if(k<n&&k!==$){for($=k;k<n&&!l(t.charCodeAt(k));)k++;if(k===n)return t;k!==$&&(a=i=k+1)}}}}else r(s)&&t.charCodeAt(1)===R&&(a=n>2&&l(t.charCodeAt(2))?3:2,i=a);let u=-1,S=!0;for(let k=n-1;k>=i;--k)if(l(t.charCodeAt(k))){if(!S){u=k;break}}else S=!1;if(u===-1){if(a===-1)return".";u=a}return t.slice(0,u)},basename(t,n){n!==void 0&&D(n,"ext"),D(t,"path");let a=0,i=-1,s=!0,u;if(t.length>=2&&r(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(a=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let S=n.length-1,k=-1;for(u=t.length-1;u>=a;--u){const $=t.charCodeAt(u);if(l($)){if(!s){a=u+1;break}}else k===-1&&(s=!1,k=u+1),S>=0&&($===n.charCodeAt(S)?--S===-1&&(i=u):(S=-1,i=k))}return a===i?i=k:i===-1&&(i=t.length),t.slice(a,i)}for(u=t.length-1;u>=a;--u)if(l(t.charCodeAt(u))){if(!s){a=u+1;break}}else i===-1&&(s=!1,i=u+1);return i===-1?"":t.slice(a,i)},extname(t){D(t,"path");let n=0,a=-1,i=0,s=-1,u=!0,S=0;t.length>=2&&t.charCodeAt(1)===R&&r(t.charCodeAt(0))&&(n=i=2);for(let k=t.length-1;k>=n;--k){const $=t.charCodeAt(k);if(l($)){if(!u){i=k+1;break}continue}s===-1&&(u=!1,s=k+1),$===b?a===-1?a=k:S!==1&&(S=1):a!==-1&&(S=-1)}return a===-1||s===-1||S===0||S===1&&a===s-1&&a===i+1?"":t.slice(a,s)},format:m.bind(null,"\\"),parse(t){D(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const a=t.length;let i=0,s=t.charCodeAt(0);if(a===1)return l(s)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(l(s)){if(i=1,l(t.charCodeAt(1))){let P=2,O=P;for(;P<a&&!l(t.charCodeAt(P));)P++;if(P<a&&P!==O){for(O=P;P<a&&l(t.charCodeAt(P));)P++;if(P<a&&P!==O){for(O=P;P<a&&!l(t.charCodeAt(P));)P++;P===a?i=P:P!==O&&(i=P+1)}}}}else if(r(s)&&t.charCodeAt(1)===R){if(a<=2)return n.root=n.dir=t,n;if(i=2,l(t.charCodeAt(2))){if(a===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let u=-1,S=i,k=-1,$=!0,f=t.length-1,g=0;for(;f>=i;--f){if(s=t.charCodeAt(f),l(s)){if(!$){S=f+1;break}continue}k===-1&&($=!1,k=f+1),s===b?u===-1?u=f:g!==1&&(g=1):u!==-1&&(g=-1)}return k!==-1&&(u===-1||g===0||g===1&&u===k-1&&u===S+1?n.base=n.name=t.slice(S,k):(n.name=t.slice(S,u),n.base=t.slice(S,k),n.ext=t.slice(u,k))),S>0&&S!==i?n.dir=t.slice(0,S-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(p){const t=/\\/g;return()=>{const n=C.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>C.cwd()})();e.$fc={resolve(...t){let n="",a=!1;for(let i=t.length-1;i>=-1&&!a;i--){const s=i>=0?t[i]:h();D(s,"path"),s.length!==0&&(n=`${s}/${n}`,a=s.charCodeAt(0)===E)}return n=o(n,!a,"/",c),a?`/${n}`:n.length>0?n:"."},normalize(t){if(D(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E,a=t.charCodeAt(t.length-1)===E;return t=o(t,!n,"/",c),t.length===0?n?"/":a?"./":".":(a&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return D(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let n;for(let a=0;a<t.length;++a){const i=t[a];D(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.$fc.normalize(n)},relative(t,n){if(D(t,"from"),D(n,"to"),t===n||(t=e.$fc.resolve(t),n=e.$fc.resolve(n),t===n))return"";const a=1,i=t.length,s=i-a,u=1,S=n.length-u,k=s<S?s:S;let $=-1,f=0;for(;f<k;f++){const P=t.charCodeAt(a+f);if(P!==n.charCodeAt(u+f))break;P===E&&($=f)}if(f===k)if(S>k){if(n.charCodeAt(u+f)===E)return n.slice(u+f+1);if(f===0)return n.slice(u+f)}else s>k&&(t.charCodeAt(a+f)===E?$=f:f===0&&($=0));let g="";for(f=a+$+1;f<=i;++f)(f===i||t.charCodeAt(f)===E)&&(g+=g.length===0?"..":"/..");return`${g}${n.slice(u+$)}`},toNamespacedPath(t){return t},dirname(t){if(D(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E;let a=-1,i=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===E){if(!i){a=s;break}}else i=!1;return a===-1?n?"/":".":n&&a===1?"//":t.slice(0,a)},basename(t,n){n!==void 0&&D(n,"ext"),D(t,"path");let a=0,i=-1,s=!0,u;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let S=n.length-1,k=-1;for(u=t.length-1;u>=0;--u){const $=t.charCodeAt(u);if($===E){if(!s){a=u+1;break}}else k===-1&&(s=!1,k=u+1),S>=0&&($===n.charCodeAt(S)?--S===-1&&(i=u):(S=-1,i=k))}return a===i?i=k:i===-1&&(i=t.length),t.slice(a,i)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===E){if(!s){a=u+1;break}}else i===-1&&(s=!1,i=u+1);return i===-1?"":t.slice(a,i)},extname(t){D(t,"path");let n=-1,a=0,i=-1,s=!0,u=0;for(let S=t.length-1;S>=0;--S){const k=t.charCodeAt(S);if(k===E){if(!s){a=S+1;break}continue}i===-1&&(s=!1,i=S+1),k===b?n===-1?n=S:u!==1&&(u=1):n!==-1&&(u=-1)}return n===-1||i===-1||u===0||u===1&&n===i-1&&n===a+1?"":t.slice(n,i)},format:m.bind(null,"/"),parse(t){D(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const a=t.charCodeAt(0)===E;let i;a?(n.root="/",i=1):i=0;let s=-1,u=0,S=-1,k=!0,$=t.length-1,f=0;for(;$>=i;--$){const g=t.charCodeAt($);if(g===E){if(!k){u=$+1;break}continue}S===-1&&(k=!1,S=$+1),g===b?s===-1?s=$:f!==1&&(f=1):s!==-1&&(f=-1)}if(S!==-1){const g=u===0&&a?1:u;s===-1||f===0||f===1&&s===S-1&&s===u+1?n.base=n.name=t.slice(g,S):(n.name=t.slice(g,s),n.base=t.slice(g,S),n.ext=t.slice(s,S))}return u>0?n.dir=t.slice(0,u-1):a&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=p?e.$ec.normalize:e.$fc.normalize,e.$hc=p?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=p?e.$ec.join:e.$fc.join,e.$jc=p?e.$ec.resolve:e.$fc.resolve,e.$kc=p?e.$ec.relative:e.$fc.relative,e.$lc=p?e.$ec.dirname:e.$fc.dirname,e.$mc=p?e.$ec.basename:e.$fc.basename,e.$nc=p?e.$ec.extname:e.$fc.extname,e.$oc=p?e.$ec.format:e.$fc.format,e.$pc=p?e.$ec.parse:e.$fc.parse,e.$qc=p?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=p?e.$ec.sep:e.$fc.sep,e.$sc=p?e.$ec.delimiter:e.$fc.delimiter}),define(De[126],Ce([1,0,46,16]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=void 0;const d=new C.$U(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),M=new C.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new C.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(k,$,f=!1){const g=k||"",P=$||"",O=d.value.collator.compare(g,P);return d.value.collatorIsNumeric&&O===0&&g!==P?g<P?-1:1:O}e.$eq=b;function E(k,$){const f=M.value.collator;return k=k||"",$=$||"",m(f,k,$)}e.$fq=E;function w(k,$){const f=M.value.collator;return k=k||"",$=$||"",a(k,$)||m(f,k,$)}e.$gq=w;function R(k,$){const f=M.value.collator;return k=k||"",$=$||"",n(k,$)||m(f,k,$)}e.$hq=R;function I(k,$){return k=k||"",$=$||"",k===$?0:k<$?-1:1}e.$iq=I;function v(k,$){const[f,g]=r(k),[P,O]=r($);let N=d.value.collator.compare(g,O);if(N===0){if(d.value.collatorIsNumeric&&g!==O)return g<O?-1:1;if(N=d.value.collator.compare(f,P),d.value.collatorIsNumeric&&N===0&&f!==P)return f<P?-1:1}return N}e.$jq=v;function y(k,$){k=k||"",$=$||"";const f=o(k),g=o($),P=M.value.collator,O=A.value.collator;return m(O,f,g)||m(P,k,$)}e.$kq=y;function D(k,$){k=k||"",$=$||"";const f=o(k),g=o($),P=M.value.collator,O=A.value.collator;return m(O,f,g)||a(k,$)||m(P,k,$)}e.$lq=D;function p(k,$){k=k||"",$=$||"";const f=o(k),g=o($),P=M.value.collator,O=A.value.collator;return m(O,f,g)||n(k,$)||m(P,k,$)}e.$mq=p;function l(k,$){k=k||"",$=$||"";const f=o(k).toLowerCase(),g=o($).toLowerCase();return f!==g?f<g?-1:1:k!==$?k<$?-1:1:0}e.$nq=l;const c=/^(.*?)(\.([^.]*))?$/;function r(k,$=!1){const f=k?c.exec(k):[];let g=[f&&f[1]||"",f&&f[3]||""];return $&&(!g[0]&&g[1]||g[0]&&g[0].charAt(0)===".")&&(g=[g[0]+"."+g[1],""]),g}function o(k){const $=k?c.exec(k):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function m(k,$,f){const g=k.compare($,f);return g!==0?g:$.length!==f.length?$.length<f.length?-1:1:0}function h(k){const $=k.charAt(0);return $.toLocaleUpperCase()!==$}function t(k){const $=k.charAt(0);return $.toLocaleLowerCase()!==$}function n(k,$){return h(k)&&t($)?-1:t(k)&&h($)?1:0}function a(k,$){return t(k)&&h($)?-1:h(k)&&t($)?1:0}function i(k,$,f=!1){return f||(k=k&&k.toLowerCase(),$=$&&$.toLowerCase()),k===$?0:k<$?-1:1}function s(k,$,f=!1){const g=k.split(F.sep),P=$.split(F.sep),O=g.length-1,N=P.length-1;let L,j;for(let z=0;;z++){if(L=O===z,j=N===z,L&&j)return b(g[z],P[z],f);if(L)return-1;if(j)return 1;const T=i(g[z],P[z],f);if(T!==0)return T}}e.$oq=s;function u(k,$,f){const g=k.toLowerCase(),P=$.toLowerCase(),O=S(k,$,f);if(O)return O;const N=g.endsWith(f),L=P.endsWith(f);if(N!==L)return N?-1:1;const j=b(g,P);return j!==0?j:g.localeCompare(P)}e.$pq=u;function S(k,$,f){const g=k.toLowerCase(),P=$.toLowerCase(),O=g.startsWith(f),N=P.startsWith(f);if(O!==N)return O?-1:1;if(O&&N){if(g.length<P.length)return-1;if(g.length>P.length)return 1}return 0}e.$qq=S}),define(De[32],Ce([1,0,16,12,15,18]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=void 0;function A(u){return u===47||u===92}e.$Pf=A;function b(u){return u.replace(/[\\/]/g,C.$fc.sep)}e.$Qf=b;function E(u){return u.indexOf("/")===-1&&(u=b(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.$Rf=E;function w(u,S=C.$fc.sep){if(!u)return"";const k=u.length,$=u.charCodeAt(0);if(A($)){if(A(u.charCodeAt(1))&&!A(u.charCodeAt(2))){let g=3;const P=g;for(;g<k&&!A(u.charCodeAt(g));g++);if(P!==g&&!A(u.charCodeAt(g+1))){for(g+=1;g<k;g++)if(A(u.charCodeAt(g)))return u.slice(0,g+1).replace(/[\\/]/g,S)}}return S}else if(c($)&&u.charCodeAt(1)===58)return A(u.charCodeAt(2))?u.slice(0,2)+S:u.slice(0,2);let f=u.indexOf("://");if(f!==-1){for(f+=3;f<k;f++)if(A(u.charCodeAt(f)))return u.slice(0,f+1)}return""}e.$Sf=w;function R(u){if(!F.$j||!u||u.length<5)return!1;let S=u.charCodeAt(0);if(S!==92||(S=u.charCodeAt(1),S!==92))return!1;let k=2;const $=k;for(;k<u.length&&(S=u.charCodeAt(k),S!==92);k++);return!($===k||(S=u.charCodeAt(k+1),isNaN(S)||S===92))}e.$Tf=R;const I=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(u,S=F.$j){const k=S?I:v;return!(!u||u.length===0||/^\s+$/.test(u)||(k.lastIndex=0,k.test(u))||S&&y.test(u)||u==="."||u===".."||S&&u[u.length-1]==="."||S&&u.length!==u.trim().length||u.length>255)}e.$Uf=D;function p(u,S,k){const $=u===S;return!k||$?$:!u||!S?!1:(0,d.$1e)(u,S)}e.$Vf=p;function l(u,S,k,$=C.sep){if(u===S)return!0;if(!u||!S||S.length>u.length)return!1;if(k){if(!(0,d.$2e)(u,S))return!1;if(S.length===u.length)return!0;let g=S.length;return S.charAt(S.length-1)===$&&g--,u.charAt(g)===$}return S.charAt(S.length-1)!==$&&(S+=$),u.indexOf(S)===0}e.$Wf=l;function c(u){return u>=65&&u<=90||u>=97&&u<=122}e.$Xf=c;function r(u,S){return F.$j&&u.endsWith(":")&&(u+=C.sep),(0,C.$hc)(u)||(u=(0,C.$ic)(S,u)),u=(0,C.$gc)(u),F.$j?(u=(0,d.$Je)(u,C.sep),u.endsWith(":")&&(u+=C.sep)):(u=(0,d.$Je)(u,C.sep),u||(u=C.sep)),u}e.$Yf=r;function o(u){const S=(0,C.$gc)(u);return F.$j?u.length>3?!1:m(S)&&(u.length===2||S.charCodeAt(2)===92):S===C.$fc.sep}e.$Zf=o;function m(u,S=F.$j){return S?c(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.$1f=m;function h(u,S=F.$j){return m(u,S)?u[0]:void 0}e.$2f=h;function t(u,S,k){return S.length>u.length?-1:u===S?0:(k&&(u=u.toLowerCase(),S=S.toLowerCase()),u.indexOf(S))}e.$3f=t;function n(u){const S=u.split(":");let k,$,f;for(const g of S){const P=Number(g);(0,M.$Bf)(P)?$===void 0?$=P:f===void 0&&(f=P):k=k?[k,g].join(":"):g}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:$!==void 0?$:void 0,column:f!==void 0?f:$!==void 0?1:void 0}}e.$4f=n;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(u,S,k=8){let $="";for(let g=0;g<k;g++){let P;g===0&&F.$j&&!S&&(k===3||k===4)?P=i:P=a,$+=P.charAt(Math.floor(Math.random()*P.length))}let f;return S?f=`${S}-${$}`:f=$,u?(0,C.$ic)(u,f):f}e.$5f=s}),define(De[127],Ce([1,0,126,121,52,16,12,15]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=void 0;const E=0,w=[E,[]];function R(K,V,fe,X){if(!K||!V)return w;const Q=K.length,Z=V.length;if(Q<Z)return w;const oe=K.toLowerCase();return I(V,fe,Z,K,oe,Q,X)}e.$rq=R;function I(K,V,fe,X,Q,Z,oe){const x=[],ae=[];for(let q=0;q<fe;q++){const me=q*Z,_=me-Z,ie=q>0,re=K[q],Ee=V[q];for(let ce=0;ce<Z;ce++){const de=ce>0,ee=me+ce,he=ee-1,be=_+ce-1,Pe=de?x[he]:0,B=ie&&de?x[be]:0,J=ie&&de?ae[be]:0;let te;!B&&ie?te=0:te=v(re,Ee,X,Q,ce,J),te&&B+te>=Pe&&(oe||ie||Q.startsWith(V,ce))?(ae[ee]=J+1,x[ee]=B+te):(ae[ee]=E,x[ee]=Pe)}}const ve=[];let G=fe-1,U=Z-1;for(;G>=0&&U>=0;){const q=G*Z+U;ae[q]===E||(ve.push(U),G--),U--}return[x[fe*Z-1],ve.reverse()]}function v(K,V,fe,X,Q,Z){let oe=0;if(!y(V,X[Q]))return oe;if(oe+=1,Z>0&&(oe+=Z*5),K===fe[Q]&&(oe+=1),Q===0)oe+=8;else{const x=D(fe.charCodeAt(Q-1));x?oe+=x:(0,F.$Ej)(fe.charCodeAt(Q))&&Z===0&&(oe+=2)}return oe}function y(K,V){return K===V?!0:K==="/"||K==="\\"?V==="/"||V==="\\":!1}function D(K){switch(K){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function l(K,V,fe=0,X=0){const Q=V;return Q.values&&Q.values.length>1?c(K,Q.values,fe,X):r(K,V,fe,X)}e.$sq=l;function c(K,V,fe,X){let Q=0;const Z=[];for(const oe of V){const[x,ae]=r(K,oe,fe,X);if(typeof x!="number")return p;Q+=x,Z.push(...ae)}return[Q,k(Z)]}function r(K,V,fe,X){const Q=(0,F.$Nj)(V.original,V.originalLowercase,fe,K,K.toLowerCase(),X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,F.$Kj)(Q)]:p}const o=Object.freeze({score:0}),m=1<<18,h=1<<17,t=1<<16;function n(K,V,fe,X){const Q=X.values?X.values:[X];return(0,d.$Bi)({[X.normalized]:{values:Q.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:K,description:V,allowNonContiguousMatches:fe}})}function a(K,V,fe,X,Q){if(!K||!V.normalized)return o;const Z=X.getItemLabel(K);if(!Z)return o;const oe=X.getItemDescription(K),x=n(Z,oe,fe,V),ae=Q[x];if(ae)return ae;const ve=i(Z,oe,X.getItemPath(K),V,fe);return Q[x]=ve,ve}e.$tq=a;function i(K,V,fe,X,Q){const Z=!fe||!X.containsPathSeparator;return fe&&(A.$l?X.pathNormalized===fe:(0,b.$1e)(X.pathNormalized,fe))?{score:m,labelMatch:[{start:0,end:K.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:X.values&&X.values.length>1?s(K,V,fe,X.values,Z,Q):u(K,V,fe,X,Z,Q)}function s(K,V,fe,X,Q,Z){let oe=0;const x=[],ae=[];for(const ve of X){const{score:G,labelMatch:U,descriptionMatch:q}=u(K,V,fe,ve,Q,Z);if(G===E)return o;oe+=G,U&&x.push(...U),q&&ae.push(...q)}return{score:oe,labelMatch:k(x),descriptionMatch:k(ae)}}function u(K,V,fe,X,Q,Z){if(Q||!V){const[oe,x]=R(K,X.normalized,X.normalizedLowercase,Z&&!X.expectContiguousMatch);if(oe){const ae=(0,F.$Bj)(X.normalized,K);let ve;if(ae){ve=h;const G=Math.round(X.normalized.length/K.length*100);ve+=G}else ve=t;return{score:ve+oe,labelMatch:ae||S(x)}}}if(V){let oe=V;fe&&(oe=`${V}${M.sep}`);const x=oe.length,ae=`${oe}${K}`,[ve,G]=R(ae,X.normalized,X.normalizedLowercase,Z&&!X.expectContiguousMatch);if(ve){const U=S(G),q=[],me=[];return U.forEach(_=>{_.start<x&&_.end>x?(q.push({start:0,end:_.end-x}),me.push({start:_.start,end:x})):_.start>=x?q.push({start:_.start-x,end:_.end-x}):me.push(_)}),{score:ve,labelMatch:q,descriptionMatch:me}}}return o}function S(K){const V=[];if(!K)return V;let fe;for(const X of K)fe&&fe.end===X?fe.end+=1:(fe={start:X,end:X+1},V.push(fe));return V}function k(K){const V=K.sort((Q,Z)=>Q.start-Z.start),fe=[];let X;for(const Q of V)!X||!$(X,Q)?(X=Q,fe.push(Q)):(X.start=Math.min(X.start,Q.start),X.end=Math.max(X.end,Q.end));return fe}function $(K,V){return!(K.end<V.start||V.end<K.start)}function f(K,V,fe,X,Q,Z){const oe=a(K,fe,X,Q,Z),x=a(V,fe,X,Q,Z),ae=oe.score,ve=x.score;if((ae===m||ve===m)&&ae!==ve)return ae===m?-1:1;if(ae>t||ve>t){if(ae!==ve)return ae>ve?-1:1;if(ae<h&&ve<h){const re=P(oe.labelMatch,x.labelMatch);if(re!==0)return re}const _=Q.getItemLabel(K)||"",ie=Q.getItemLabel(V)||"";if(_.length!==ie.length)return _.length-ie.length}if(ae!==ve)return ae>ve?-1:1;const G=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,U=Array.isArray(x.labelMatch)&&x.labelMatch.length>0;if(G&&!U)return-1;if(U&&!G)return 1;const q=g(K,oe,Q),me=g(V,x,Q);return q&&me&&q!==me?me>q?-1:1:O(K,V,fe,Q)}e.$uq=f;function g(K,V,fe){let X=-1,Q=-1;if(V.descriptionMatch&&V.descriptionMatch.length?X=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(X=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if(Q=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const Z=fe.getItemDescription(K);Z&&(Q+=Z.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&(Q=V.descriptionMatch[V.descriptionMatch.length-1].end);return Q-X}function P(K,V){if(!K&&!V||(!K||!K.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!K||!K.length)return 1;const fe=K[0].start,Q=K[K.length-1].end-fe,Z=V[0].start,x=V[V.length-1].end-Z;return Q===x?0:x<Q?1:-1}function O(K,V,fe,X){const Q=X.getItemLabel(K)||"",Z=X.getItemLabel(V)||"",oe=X.getItemDescription(K),x=X.getItemDescription(V),ae=Q.length+(oe?oe.length:0),ve=Z.length+(x?x.length:0);if(ae!==ve)return ae-ve;const G=X.getItemPath(K),U=X.getItemPath(V);return G&&U&&G.length!==U.length?G.length-U.length:Q!==Z?(0,C.$pq)(Q,Z,fe.normalized):oe&&x&&oe!==x?(0,C.$pq)(oe,x,fe.normalized):G&&U&&G!==U?(0,C.$pq)(G,U,fe.normalized):0}function N(K){return K.startsWith('"')&&K.endsWith('"')}const L=" ";function j(K){typeof K!="string"&&(K="");const V=K.toLowerCase(),{pathNormalized:fe,normalized:X,normalizedLowercase:Q}=z(K),Z=fe.indexOf(M.sep)>=0,oe=N(K);let x;const ae=K.split(L);if(ae.length>1)for(const ve of ae){const G=N(ve),{pathNormalized:U,normalized:q,normalizedLowercase:me}=z(ve);q&&(x||(x=[]),x.push({original:ve,originalLowercase:ve.toLowerCase(),pathNormalized:U,normalized:q,normalizedLowercase:me,expectContiguousMatch:G}))}return{original:K,originalLowercase:V,pathNormalized:fe,normalized:X,normalizedLowercase:Q,values:x,containsPathSeparator:Z,expectContiguousMatch:oe}}e.$vq=j;function z(K){let V;A.$j?V=K.replace(/\//g,M.sep):V=K.replace(/\\/g,M.sep);const fe=(0,b.$Le)(V).replace(/\s|"/g,"");return{pathNormalized:V,normalized:fe,normalizedLowercase:fe.toLowerCase()}}function T(K){return Array.isArray(K)?j(K.map(V=>V.original).join(L)):j(K.original)}e.$wq=T}),define(De[97],Ce([1,0,16]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0,e.$Mr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(R){const I=(0,C.$nc)(R),v=F[I.toLowerCase()];return v!==void 0?v:A(R)}e.$Nr=M;function A(R){const I=(0,C.$nc)(R);return d[I.toLowerCase()]}e.$Or=A;function b(R){for(const I in d)if(d[I]===R)return I}e.$Pr=b;const E=/^(.+)\/(.+?)(;.+)?$/;function w(R,I){const v=E.exec(R);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:I?void 0:R}e.$Qr=w}),define(De[98],Ce([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$wl=e.TerminateResponseCode=e.Source=void 0;var F;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(F||(e.Source=F={}));var d;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(d||(e.TerminateResponseCode=d={}));function M(b,...E){const w=E.reduce((v,y)=>(v[y]=!0,v),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(v=>!w[v]).forEach(v=>{for(let y=0;y<R.length;y++)if(v.search(R[y])!==-1){delete b[v];break}})}e.$wl=M;function A(b){b&&(delete b.DEBUG,C.$k&&delete b.DYLD_LIBRARY_PATH,C.$l&&delete b.LD_PRELOAD)}e.$xl=A}),define(De[2],Ce([1,0,16,12]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const d=/^\w[\w\d+.-]*$/,M=/^\//,A=/^\/\//;function b(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!d.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(i,s){return!i&&!s?"file":i}function w(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const R="",I="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(s){return s instanceof y?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,u,S,k,$,f=!1){typeof s=="object"?(this.scheme=s.scheme||R,this.authority=s.authority||R,this.path=s.path||R,this.query=s.query||R,this.fragment=s.fragment||R):(this.scheme=E(s,f),this.authority=u||R,this.path=w(this.scheme,S||R),this.query=k||R,this.fragment=$||R,b(this,f))}get fsPath(){return m(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:S,path:k,query:$,fragment:f}=s;return u===void 0?u=this.scheme:u===null&&(u=R),S===void 0?S=this.authority:S===null&&(S=R),k===void 0?k=this.path:k===null&&(k=R),$===void 0?$=this.query:$===null&&($=R),f===void 0?f=this.fragment:f===null&&(f=R),u===this.scheme&&S===this.authority&&k===this.path&&$===this.query&&f===this.fragment?this:new l(u,S,k,$,f)}static parse(s,u=!1){const S=v.exec(s);return S?new l(S[2]||R,a(S[4]||R),a(S[5]||R),a(S[7]||R),a(S[9]||R),u):new l(R,R,R,R,R)}static file(s){let u=R;if(F.$j&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const S=s.indexOf(I,2);S===-1?(u=s.substring(2),s=I):(u=s.substring(2,S),s=s.substring(S)||I)}return new l("file",u,s,R,R)}static from(s,u){return new l(s.scheme,s.authority,s.path,s.query,s.fragment,u)}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return F.$j&&s.scheme==="file"?S=y.file(C.$ec.join(m(s,!0),...u)).path:S=C.$fc.join(s.path,...u),s.with({path:S})}toString(s=!1){return h(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof y)return s;{const u=new l(s);return u._formatted=s.external??null,u._fsPath=s._sep===p?s.fsPath??null:null,u}}else return s}}e.URI=y;function D(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$uc=D;const p=F.$j?1:void 0;class l extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(s=!1){return s?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=p),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function r(i,s,u){let S,k=-1;for(let $=0;$<i.length;$++){const f=i.charCodeAt($);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||s&&f===47||u&&f===91||u&&f===93||u&&f===58)k!==-1&&(S+=encodeURIComponent(i.substring(k,$)),k=-1),S!==void 0&&(S+=i.charAt($));else{S===void 0&&(S=i.substr(0,$));const g=c[f];g!==void 0?(k!==-1&&(S+=encodeURIComponent(i.substring(k,$)),k=-1),S+=g):k===-1&&(k=$)}}return k!==-1&&(S+=encodeURIComponent(i.substring(k))),S!==void 0?S:i}function o(i){let s;for(let u=0;u<i.length;u++){const S=i.charCodeAt(u);S===35||S===63?(s===void 0&&(s=i.substr(0,u)),s+=c[S]):s!==void 0&&(s+=i[u])}return s!==void 0?s:i}function m(i,s){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,F.$j&&(u=u.replace(/\//g,"\\")),u}e.$vc=m;function h(i,s){const u=s?o:r;let S="",{scheme:k,authority:$,path:f,query:g,fragment:P}=i;if(k&&(S+=k,S+=":"),($||k==="file")&&(S+=I,S+=I),$){let O=$.indexOf("@");if(O!==-1){const N=$.substr(0,O);$=$.substr(O+1),O=N.lastIndexOf(":"),O===-1?S+=u(N,!1,!1):(S+=u(N.substr(0,O),!1,!1),S+=":",S+=u(N.substr(O+1),!1,!0)),S+="@"}$=$.toLowerCase(),O=$.lastIndexOf(":"),O===-1?S+=u($,!1,!0):(S+=u($.substr(0,O),!1,!0),S+=$.substr(O))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const O=f.charCodeAt(1);O>=65&&O<=90&&(f=`/${String.fromCharCode(O+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const O=f.charCodeAt(0);O>=65&&O<=90&&(f=`${String.fromCharCode(O+32)}:${f.substr(2)}`)}S+=u(f,!0,!1)}return g&&(S+="?",S+=u(g,!1,!1)),P&&(S+="#",S+=s?P:r(P,!1,!1)),S}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(n)?i.replace(n,s=>t(s)):i}}),define(De[181],Ce([1,0,2]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Wp=e.$Vp=e.$Up=void 0;function F(w){const R=w;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$Up=F;function d(w){const R=[];let I;try{const v=JSON.parse(w.arguments),y=v[v.length-1];y&&y.__$stack&&(v.pop(),I=y.__$stack),R.push(...v)}catch{R.push("Unable to log remote console arguments",w.arguments)}return{args:R,stack:I}}e.$Vp=d;function M(w){if(typeof w!="string")return M(d(w).stack);const R=w;if(R){const I=A(R),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(v&&v.length===4)return{uri:C.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$Wp=M;function A(w){if(!w)return w;const R=w.indexOf(`
`);return R===-1?w:w.substring(0,R)}function b(w,R){const{args:I,stack:v}=d(w),y=typeof I[0]=="string"&&I.length===1;let D=A(v);D&&(D=`(${D.trim()})`);let p=[];if(typeof I[0]=="string"?D&&y?p=[`%c[${R}] %c${I[0]} %c${D}`,E("blue"),E(""),E("grey")]:p=[`%c[${R}] %c${I[0]}`,E("blue"),E(""),...I.slice(1)]:p=[`%c[${R}]%`,E("blue"),...I],D&&!y&&p.push(D),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,p)}e.log=b;function E(w){return`color: ${w}`}}),define(De[62],Ce([1,0,22,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function d(E){return JSON.stringify(E,A)}e.$ih=d;function M(E){let w=JSON.parse(E);return w=b(w),w}e.$jh=M;function A(E,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function b(E,w=0){if(!E||w>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return F.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof C.$ae||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let R=0;R<E.length;++R)E[R]=b(E[R],w+1);else for(const R in E)Object.hasOwnProperty.call(E,R)&&(E[R]=b(E[R],w+1))}return E}e.$kh=b}),define(De[17],Ce([1,0,8,12,2]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.Schemas=void 0;var M;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$6f="vscode-tkn",e.$7f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${M.vscodeRemoteResource}`}set(R,I,v){this.a[R]=I,this.b[R]=v}setConnectionToken(R,I){this.c[R]=I}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(l){return C.$Z(l),R}const I=R.authority;let v=this.a[I];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const y=this.b[I],D=this.c[I];let p=`path=${encodeURIComponent(R.path)}`;return typeof D=="string"&&(p+=`&${e.$7f}=${encodeURIComponent(D)}`),d.URI.from({scheme:F.$p?this.d:M.vscodeRemoteResource,authority:`${v}:${y}`,path:this.f,query:p})}}e.$8f=new A,e.$9f="vs/../../extensions",e.$0f="vs/../../node_modules",e.$$f="vs/../../node_modules.asar",e.$_f="vs/../../node_modules.asar.unpacked",e.$ag="vscode-app";class b{static{this.a=e.$ag}asBrowserUri(R){const I=this.b(R,$e);return this.uriToBrowserUri(I)}uriToBrowserUri(R){return R.scheme===M.vscodeRemote?e.$8f.rewrite(R):R.scheme===M.file&&(F.$n||F.$q&&F.$h.origin===`${M.vscodeFileResource}://${b.a}`)?R.with({scheme:M.vscodeFileResource,authority:R.authority||b.a,query:null,fragment:null}):R}asFileUri(R){const I=this.b(R,$e);return this.uriToFileUri(I)}uriToFileUri(R){return R.scheme===M.vscodeFileResource?R.with({scheme:M.file,authority:R.authority!==b.a?R.authority:null,query:null,fragment:null}):R}b(R,I){return d.URI.isUri(R)?R:d.URI.parse(I.toUrl(R))}}e.$bg=new b;var E;(function(w){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(R.get("3"));const I="vscode-coi";function v(D){let p;typeof D=="string"?p=new URL(D).searchParams:D instanceof URL?p=D.searchParams:d.URI.isUri(D)&&(p=new URL(D.toString(!0)).searchParams);const l=p?.get(I);if(l)return R.get(l)}w.getHeadersFromQuery=v;function y(D,p,l){if(!globalThis.crossOriginIsolated)return;const c=p&&l?"3":l?"2":"1";D instanceof URLSearchParams?D.set(I,c):D[I]=c}w.addSearchParam=y})(E||(e.COI=E={}))}),define(De[182],Ce([1,0,156,17,12,2]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hC=void 0;class A{constructor(v,y,D){this.id=v,this.dependencies=y,this.callback=D}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(v,y,D)=>{typeof v!="string"&&(D=y,y=v,v=null),(typeof y!="object"||!Array.isArray(y))&&(D=y,y=null),this.c.push(new A(v,y,D))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this.g();const y=await(this.a?this.i(v):this.b?this.h(v):this.j(v));if(!y)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(v){return new Promise((y,D)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const l=()=>{p.removeEventListener("load",c),p.removeEventListener("error",r)},c=o=>{l(),y(this.c.pop())},r=o=>{l(),D(o)};p.addEventListener("load",c),p.addEventListener("error",r),this.f&&(v=this.f.createScriptURL(v)),p.setAttribute("src",v),document.getElementsByTagName("head")[0].appendChild(p)})}i(v){return new Promise((y,D)=>{try{this.f&&(v=this.f.createScriptURL(v)),importScripts(v),y(this.c.pop())}catch(p){D(p)}})}async j(v){try{const y=globalThis._VSCODE_NODE_MODULES.fs,D=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,l=M.URI.parse(v).fsPath,c=y.readFileSync(l).toString(),r=p.wrap(c.replace(/^#!.*/,""));return new D.Script(r).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const E=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function R(I,v,y){if(C.$S){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[I]&&(I=w[I]);const D=`${I}/${v}`;if(E.has(D))return E.get(D);let p;if(/^\w[\w\d+.-]*:\/\//.test(D))p=D;else{const o=`${y&&!d.$p?F.$$f:F.$0f}/${D}`;p=F.$bg.asBrowserUri(o).toString(!0)}const l=b.INSTANCE.load(p);return E.set(D,l),l}else return await new Promise((D,p)=>{$e([I],D,p)})}e.$hC=R}),define(De[23],Ce([1,0,32,17,16,12,15,2]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.DataUri=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function E(y){return(0,b.$vc)(y,!0)}e.$ig=E;class w{constructor(D){this.a=D}compare(D,p,l=!1){return D===p?0:(0,A.$Te)(this.getComparisonKey(D,l),this.getComparisonKey(p,l))}isEqual(D,p,l=!1){return D===p?!0:!D||!p?!1:this.getComparisonKey(D,l)===this.getComparisonKey(p,l)}getComparisonKey(D,p=!1){return D.with({path:this.a(D)?D.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(D){return this.a(D)}isEqualOrParent(D,p,l=!1){if(D.scheme===p.scheme){if(D.scheme===F.Schemas.file)return C.$Wf(E(D),E(p),this.a(D))&&D.query===p.query&&(l||D.fragment===p.fragment);if((0,e.$zg)(D.authority,p.authority))return C.$Wf(D.path,p.path,this.a(D),"/")&&D.query===p.query&&(l||D.fragment===p.fragment)}return!1}joinPath(D,...p){return b.URI.joinPath(D,...p)}basenameOrAuthority(D){return(0,e.$rg)(D)||D.authority}basename(D){return d.$fc.basename(D.path)}extname(D){return d.$fc.extname(D.path)}dirname(D){if(D.path.length===0)return D;let p;return D.scheme===F.Schemas.file?p=b.URI.file(d.$lc(E(D))).path:(p=d.$fc.dirname(D.path),D.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),p="/")),D.with({path:p})}normalizePath(D){if(!D.path.length)return D;let p;return D.scheme===F.Schemas.file?p=b.URI.file(d.$gc(E(D))).path:p=d.$fc.normalize(D.path),D.with({path:p})}relativePath(D,p){if(D.scheme!==p.scheme||!(0,e.$zg)(D.authority,p.authority))return;if(D.scheme===F.Schemas.file){const r=d.$kc(E(D),E(p));return M.$j?C.$Qf(r):r}let l=D.path||"/";const c=p.path||"/";if(this.a(D)){let r=0;for(const o=Math.min(l.length,c.length);r<o&&!(l.charCodeAt(r)!==c.charCodeAt(r)&&l.charAt(r).toLowerCase()!==c.charAt(r).toLowerCase());r++);l=c.substr(0,r)+l.substr(r)}return d.$fc.relative(l,c)}resolvePath(D,p){if(D.scheme===F.Schemas.file){const l=b.URI.file(d.$jc(E(D),p));return D.with({authority:l.authority,path:l.path})}return p=C.$Rf(p),D.with({path:d.$fc.resolve(D.path,p)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,p){return D===p||D!==void 0&&p!==void 0&&(0,A.$1e)(D,p)}hasTrailingPathSeparator(D,p=d.sep){if(D.scheme===F.Schemas.file){const l=E(D);return l.length>C.$Sf(l).length&&l[l.length-1]===p}else{const l=D.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,p=d.sep){return(0,e.$Ag)(D,p)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,p=d.sep){let l=!1;if(D.scheme===F.Schemas.file){const c=E(D);l=c!==void 0&&c.length===C.$Sf(c).length&&c[c.length-1]===p}else{p="/";const c=D.path;l=c.length===1&&c.charCodeAt(c.length-1)===47}return!l&&!(0,e.$Ag)(D,p)?D.with({path:D.path+"/"}):D}}e.$jg=w,e.$kg=new w(()=>!1),e.$lg=new w(y=>y.scheme===F.Schemas.file?!M.$l:!0),e.$mg=new w(y=>!0),e.$ng=e.$kg.isEqual.bind(e.$kg),e.$og=e.$kg.isEqualOrParent.bind(e.$kg),e.$pg=e.$kg.getComparisonKey.bind(e.$kg),e.$qg=e.$kg.basenameOrAuthority.bind(e.$kg),e.$rg=e.$kg.basename.bind(e.$kg),e.$sg=e.$kg.extname.bind(e.$kg),e.$tg=e.$kg.dirname.bind(e.$kg),e.$ug=e.$kg.joinPath.bind(e.$kg),e.$vg=e.$kg.normalizePath.bind(e.$kg),e.$wg=e.$kg.relativePath.bind(e.$kg),e.$xg=e.$kg.resolvePath.bind(e.$kg),e.$yg=e.$kg.isAbsolutePath.bind(e.$kg),e.$zg=e.$kg.isEqualAuthority.bind(e.$kg),e.$Ag=e.$kg.hasTrailingPathSeparator.bind(e.$kg),e.$Bg=e.$kg.removeTrailingPathSeparator.bind(e.$kg),e.$Cg=e.$kg.addTrailingPathSeparator.bind(e.$kg);function R(y,D){const p=[];for(let l=0;l<y.length;l++){const c=D(y[l]);y.some((r,o)=>o===l?!1:(0,e.$og)(c,D(r)))||p.push(y[l])}return p}e.$Dg=R;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function D(p){const l=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(o=>{const[m,h]=o.split(":");m&&h&&l.set(m,h)});const r=p.path.substring(0,p.path.indexOf(";"));return r&&l.set(y.META_DATA_MIME,r),l}y.parseMetaData=D})(I||(e.DataUri=I={}));function v(y,D,p){if(D){let l=y.path;return l&&l[0]!==d.$fc.sep&&(l=d.$fc.sep+l),y.with({scheme:p,authority:D,path:l})}return y.with({scheme:p})}e.$Eg=v}),define(De[9],Ce([1,0,21,8,4,3,23,12,160]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eh=e.$dh=e.$ch=e.Promises=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function w(U){return!!U&&typeof U.then=="function"}e.$Fg=w;function R(U){const q=new C.$Wd,me=U(q.token),_=new Promise((ie,re)=>{const Ee=q.token.onCancellationRequested(()=>{Ee.dispose(),q.dispose(),re(new F.$4)});Promise.resolve(me).then(ce=>{Ee.dispose(),q.dispose(),ie(ce)},ce=>{Ee.dispose(),q.dispose(),re(ce)})});return new class{cancel(){q.cancel()}then(ie,re){return _.then(ie,re)}catch(ie){return this.then(void 0,ie)}finally(ie){return _.finally(ie)}}}e.$Gg=R;function I(U,q,me){return new Promise((_,ie)=>{const re=q.onCancellationRequested(()=>{re.dispose(),_(me)});U.then(_,ie).finally(()=>re.dispose())})}e.$Hg=I;function v(U,q){return new Promise((me,_)=>{const ie=q.onCancellationRequested(()=>{ie.dispose(),_(new F.$4)});U.then(me,_).finally(()=>ie.dispose())})}e.$Ig=v;async function y(U){let q=-1;const me=U.map((_,ie)=>_.then(re=>(q=ie,re)));try{return await Promise.race(me)}finally{U.forEach((_,ie)=>{ie!==q&&_.cancel()})}}e.$Jg=y;function D(U,q,me){let _;const ie=setTimeout(()=>{_?.(void 0),me?.()},q);return Promise.race([U.finally(()=>clearTimeout(ie)),new Promise(re=>_=re)])}e.$Kg=D;function p(U){return new Promise((q,me)=>{const _=U();w(_)?_.then(q,me):q(_)})}e.$Lg=p;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const me=()=>{if(this.b=null,this.f)return;const _=this.queue(this.d);return this.d=null,_};this.b=new Promise(_=>{this.a.then(me,me).then(_)})}return new Promise((me,_)=>{this.b.then(me,_)})}return this.a=q(),new Promise((me,_)=>{this.a.then(ie=>{this.a=null,me(ie)},ie=>{this.a=null,_(ie)})})}dispose(){this.f=!0}}e.$Mg=l;class c{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$Ng=c;class r{constructor(){this.a=new Map}queue(q,me){const ie=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.a.get(q)===ie&&this.a.delete(q)});return this.a.set(q,ie),ie}}e.$Og=r;const o=(U,q)=>{let me=!0;const _=setTimeout(()=>{me=!1,q()},U);return{isTriggered:()=>me,dispose:()=>{clearTimeout(_),me=!1}}},m=U=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,U())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class h{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,me=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((ie,re)=>{this.d=ie,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const ie=this.g;return this.g=null,ie()}}));const _=()=>{this.a=null,this.d?.(null)};return this.a=me===E.$Jd?m(_):o(me,_),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Pg=h;class t{constructor(q){this.a=new h(q),this.b=new l}trigger(q,me){return this.a.trigger(()=>this.b.queue(q),me)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Qg=t;class n{constructor(){this.a=!1,this.b=new Promise((q,me)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Rg=n;class a extends n{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Sg=a;function i(U,q){return q?new Promise((me,_)=>{const ie=setTimeout(()=>{re.dispose(),me()},U),re=q.onCancellationRequested(()=>{clearTimeout(ie),re.dispose(),_(new F.$4)})}):R(me=>i(U,me))}e.$Tg=i;function s(U,q=0,me){const _=setTimeout(()=>{U(),me&&ie.dispose()},q),ie=(0,M.$Pc)(()=>{clearTimeout(_),me?.deleteAndLeak(ie)});return me?.add(ie),ie}e.$Ug=s;function u(U){const q=[];let me=0;const _=U.length;function ie(){return me<_?U[me++]():null}function re(Ee){Ee!=null&&q.push(Ee);const ce=ie();return ce?ce.then(re):Promise.resolve(q)}return Promise.resolve(null).then(re)}e.$Vg=u;function S(U,q=_=>!!_,me=null){let _=0;const ie=U.length,re=()=>{if(_>=ie)return Promise.resolve(me);const Ee=U[_++];return Promise.resolve(Ee()).then(de=>q(de)?Promise.resolve(de):re())};return re()}e.$Wg=S;function k(U,q=_=>!!_,me=null){if(U.length===0)return Promise.resolve(me);let _=U.length;const ie=()=>{_=-1;for(const re of U)re.cancel?.()};return new Promise((re,Ee)=>{for(const ce of U)ce.then(de=>{--_>=0&&q(de)?(ie(),re(de)):_===0&&re(me)}).catch(de=>{--_>=0&&(ie(),Ee(de))})})}e.$Xg=k;class ${constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new d.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((me,_)=>{this.f.push({factory:q,c:me,e:_}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const me=q.factory();me.then(q.c,q.e),me.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Yg=$;class f extends ${constructor(){super(1)}}e.$Zg=f;class g{constructor(){this.a=new fe,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$1g=g;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new Z;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,me=A.$kg){const _=me.getComparisonKey(q);let ie=this.a.get(_);if(!ie){ie=new f;const re=this.f++,Ee=d.Event.once(ie.onDrained)(()=>{ie?.dispose(),this.a.delete(_),this.h(),this.d?.deleteAndDispose(re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$Zc),this.d.set(re,Ee),this.a.set(_,ie)}return ie}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$2g=P;class O{constructor(q,me){this.a=-1,typeof q=="function"&&typeof me=="number"&&this.setIfNotSet(q,me)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,me){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},me)}setIfNotSet(q,me){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},me))}}e.$3g=O;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,me){this.cancel(),this.a=setInterval(()=>{q()},me)}}e.$4g=N;class L{constructor(q,me){this.b=-1,this.a=q,this.d=me,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$5g=L;class j{constructor(q,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.a=q,this.b=me,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$6g=j;class z extends L{constructor(q,me){super(q,me),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$7g=z;class T extends M.$Rc{constructor(q,me){super(),this.g=q,this.h=me,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const me of q)this.a.push(me);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new L(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$8g=T,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$9g=U=>{(0,b.$B)(()=>{if(q)return;const me=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$9g=(U,q)=>{const me=requestIdleCallback(U,typeof q=="number"?{timeout:q}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(me))}}}}();class K{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(me){this.g=me}finally{this.d=!0}},this.b=(0,e.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$0g=K;async function V(U,q,me){let _;for(let ie=0;ie<me;ie++)try{return await U()}catch(re){_=re,await i(q)}throw _}e.$$g=V;class fe{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,me,_){return this.a={taskId:q,cancel:()=>_?.(),promise:me},me.then(()=>this.d(q),()=>this.d(q)),me}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let me,_;const ie=new Promise((re,Ee)=>{me=re,_=Ee});this.b={run:q,promise:ie,promiseResolve:me,promiseReject:_}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$_g=fe;class X{constructor(q,me=()=>Date.now()){this.d=q,this.f=me,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$ah=X;var Q;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(Q||(Q={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,me)=>{this.a=q,this.b=me})}complete(q){return new Promise(me=>{this.a(q),this.d={outcome:0,value:q},me()})}error(q){return new Promise(me=>{this.b(q),this.d={outcome:1,value:q},me()})}cancel(){return this.error(new F.$4)}}e.$bh=Z;var oe;(function(U){async function q(_){let ie;const re=await Promise.all(_.map(Ee=>Ee.then(ce=>ce,ce=>{ie||(ie=ce)})));if(typeof ie<"u")throw ie;return re}U.settled=q;function me(_){return new Promise(async(ie,re)=>{try{await _(ie,re)}catch(Ee){re(Ee)}})}U.withAsyncBody=me})(oe||(e.Promises=oe={}));var x;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(x||(x={}));class ae{static fromArray(q){return new ae(me=>{me.emitMany(q)})}static fromPromise(q){return new ae(async me=>{me.emitMany(await q)})}static fromPromises(q){return new ae(async me=>{await Promise.all(q.map(async _=>me.emitOne(await _)))})}static merge(q){return new ae(async me=>{await Promise.all(q.map(async _=>{for await(const ie of _)me.emitOne(ie)}))})}static{this.EMPTY=ae.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new d.$Md,queueMicrotask(async()=>{const me={emitOne:_=>this.g(_),emitMany:_=>this.h(_),reject:_=>this.k(_)};try{await Promise.resolve(q(me)),this.j()}catch(_){this.k(_)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await d.Event.toPromise(this.f.event)}while(!0)}}}static map(q,me){return new ae(async _=>{for await(const ie of q)_.emitOne(me(ie))})}map(q){return ae.map(this,q)}static filter(q,me){return new ae(async _=>{for await(const ie of q)me(ie)&&_.emitOne(ie)})}filter(q){return ae.filter(this,q)}static coalesce(q){return ae.filter(q,me=>!!me)}coalesce(){return ae.coalesce(this)}static async toPromise(q){const me=[];for await(const _ of q)me.push(_);return me}toPromise(){return ae.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$ch=ae;class ve extends ae{constructor(q,me){super(me),this.l=q}cancel(){this.l.cancel()}}e.$dh=ve;function G(U){const q=new C.$Wd,me=U(q.token);return new ve(q,async _=>{const ie=q.token.onCancellationRequested(()=>{ie.dispose(),q.dispose(),_.reject(new F.$4)});try{for await(const re of me){if(q.token.isCancellationRequested)return;_.emitOne(re)}ie.dispose(),q.dispose()}catch(re){ie.dispose(),q.dispose(),_.reject(re)}})}e.$eh=G}),define(De[35],Ce([1,0,19,9,32,28,16,12,15]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0;function w(){return Object.create(null)}e.$pj=w,e.$qj="**",e.$rj="/";const R="[/\\\\]",I="[^/\\\\]",v=/\//g;function y(fe,X){switch(fe){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${X?`|${R}${I}+`:""})*?`}}function D(fe,X){if(!fe)return[];const Q=[];let Z=!1,oe=!1,x="";for(const ae of fe){switch(ae){case X:if(!Z&&!oe){Q.push(x),x="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}x+=ae}return x&&Q.push(x),Q}e.$sj=D;function p(fe){if(!fe)return"";let X="";const Q=D(fe,e.$rj);if(Q.every(Z=>Z===e.$qj))X=".*";else{let Z=!1;Q.forEach((oe,x)=>{if(oe===e.$qj){if(Z)return;X+=y(2,x===Q.length-1)}else{let ae=!1,ve="",G=!1,U="";for(const q of oe){if(q!=="}"&&ae){ve+=q;continue}if(G&&(q!=="]"||!U)){let me;q==="-"?me=q:(q==="^"||q==="!")&&!U?me="^":q===e.$rj?me="":me=(0,E.$Ee)(q),U+=me;continue}switch(q){case"{":ae=!0;continue;case"[":G=!0;continue;case"}":{const _=`(?:${D(ve,",").map(ie=>p(ie)).join("|")})`;X+=_,ae=!1,ve="";break}case"]":{X+="["+U+"]",G=!1,U="";break}case"?":X+=I;continue;case"*":X+=y(1);continue;default:X+=(0,E.$Ee)(q)}}x<Q.length-1&&(Q[x+1]!==e.$qj||x+2<Q.length)&&(X+=R)}Z=oe===e.$qj})}return X}const l=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Cc(1e4),n=function(){return!1},a=function(){return null};function i(fe,X){if(!fe)return a;let Q;typeof fe!="string"?Q=fe.pattern:Q=fe,Q=Q.trim();const Z=`${Q}_${!!X.trimForExclusions}`;let oe=t.get(Z);if(oe)return s(oe,fe);let x;return l.test(Q)?oe=S(Q.substr(4),Q):(x=c.exec(u(Q,X)))?oe=k(x[1],Q):(X.trimForExclusions?o:r).test(Q)?oe=$(Q,X):(x=m.exec(u(Q,X)))?oe=f(x[1].substr(1),Q,!0):(x=h.exec(u(Q,X)))?oe=f(x[1],Q,!1):oe=g(Q),t.set(Z,oe),s(oe,fe)}function s(fe,X){if(typeof X=="string")return fe;const Q=function(Z,oe){return(0,d.$Wf)(Z,X.base,!b.$l)?fe((0,E.$Ie)(Z.substr(X.base.length),A.sep),oe):null};return Q.allBasenames=fe.allBasenames,Q.allPaths=fe.allPaths,Q.basenames=fe.basenames,Q.patterns=fe.patterns,Q}function u(fe,X){return X.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function S(fe,X){return function(Q,Z){return typeof Q=="string"&&Q.endsWith(fe)?X:null}}function k(fe,X){const Q=`/${fe}`,Z=`\\${fe}`,oe=function(ae,ve){return typeof ae!="string"?null:ve?ve===fe?X:null:ae===fe||ae.endsWith(Q)||ae.endsWith(Z)?X:null},x=[fe];return oe.basenames=x,oe.patterns=[X],oe.allBasenames=x,oe}function $(fe,X){const Q=K(fe.slice(1,-1).split(",").map(ve=>i(ve,X)).filter(ve=>ve!==a),fe),Z=Q.length;if(!Z)return a;if(Z===1)return Q[0];const oe=function(ve,G){for(let U=0,q=Q.length;U<q;U++)if(Q[U](ve,G))return fe;return null},x=Q.find(ve=>!!ve.allBasenames);x&&(oe.allBasenames=x.allBasenames);const ae=Q.reduce((ve,G)=>G.allPaths?ve.concat(G.allPaths):ve,[]);return ae.length&&(oe.allPaths=ae),oe}function f(fe,X,Q){const Z=A.sep===A.$fc.sep,oe=Z?fe:fe.replace(v,A.sep),x=A.sep+oe,ae=A.$fc.sep+fe;let ve;return Q?ve=function(G,U){return typeof G=="string"&&(G===oe||G.endsWith(x)||!Z&&(G===fe||G.endsWith(ae)))?X:null}:ve=function(G,U){return typeof G=="string"&&(G===oe||!Z&&G===fe)?X:null},ve.allPaths=[(Q?"*/":"./")+fe],ve}function g(fe){try{const X=new RegExp(`^${p(fe)}$`);return function(Q){return X.lastIndex=0,typeof Q=="string"&&X.test(Q)?fe:null}}catch{return a}}function P(fe,X,Q){return!fe||typeof X!="string"?!1:O(fe)(X,void 0,Q)}e.$tj=P;function O(fe,X={}){if(!fe)return n;if(typeof fe=="string"||N(fe)){const Q=i(fe,X);if(Q===a)return n;const Z=function(oe,x){return!!Q(oe,x)};return Q.allBasenames&&(Z.allBasenames=Q.allBasenames),Q.allPaths&&(Z.allPaths=Q.allPaths),Z}return z(fe,X)}e.$uj=O;function N(fe){const X=fe;return X?typeof X.base=="string"&&typeof X.pattern=="string":!1}e.$vj=N;function L(fe){return fe.allBasenames||[]}e.$wj=L;function j(fe){return fe.allPaths||[]}e.$xj=j;function z(fe,X){const Q=K(Object.getOwnPropertyNames(fe).map(ve=>T(ve,fe[ve],X)).filter(ve=>ve!==a)),Z=Q.length;if(!Z)return a;if(!Q.some(ve=>!!ve.requiresSiblings)){if(Z===1)return Q[0];const ve=function(q,me){let _;for(let ie=0,re=Q.length;ie<re;ie++){const Ee=Q[ie](q,me);if(typeof Ee=="string")return Ee;(0,F.$Fg)(Ee)&&(_||(_=[]),_.push(Ee))}return _?(async()=>{for(const ie of _){const re=await ie;if(typeof re=="string")return re}return null})():null},G=Q.find(q=>!!q.allBasenames);G&&(ve.allBasenames=G.allBasenames);const U=Q.reduce((q,me)=>me.allPaths?q.concat(me.allPaths):q,[]);return U.length&&(ve.allPaths=U),ve}const oe=function(ve,G,U){let q,me;for(let _=0,ie=Q.length;_<ie;_++){const re=Q[_];re.requiresSiblings&&U&&(G||(G=(0,A.$mc)(ve)),q||(q=G.substr(0,G.length-(0,A.$nc)(ve).length)));const Ee=re(ve,G,q,U);if(typeof Ee=="string")return Ee;(0,F.$Fg)(Ee)&&(me||(me=[]),me.push(Ee))}return me?(async()=>{for(const _ of me){const ie=await _;if(typeof ie=="string")return ie}return null})():null},x=Q.find(ve=>!!ve.allBasenames);x&&(oe.allBasenames=x.allBasenames);const ae=Q.reduce((ve,G)=>G.allPaths?ve.concat(G.allPaths):ve,[]);return ae.length&&(oe.allPaths=ae),oe}function T(fe,X,Q){if(X===!1)return a;const Z=i(fe,Q);if(Z===a)return a;if(typeof X=="boolean")return Z;if(X){const oe=X.when;if(typeof oe=="string"){const x=(ae,ve,G,U)=>{if(!U||!Z(ae,ve))return null;const q=oe.replace("$(basename)",()=>G),me=U(q);return(0,F.$Fg)(me)?me.then(_=>_?fe:null):me?fe:null};return x.requiresSiblings=!0,x}}return Z}function K(fe,X){const Q=fe.filter(ve=>!!ve.basenames);if(Q.length<2)return fe;const Z=Q.reduce((ve,G)=>{const U=G.basenames;return U?ve.concat(U):ve},[]);let oe;if(X){oe=[];for(let ve=0,G=Z.length;ve<G;ve++)oe.push(X)}else oe=Q.reduce((ve,G)=>{const U=G.patterns;return U?ve.concat(U):ve},[]);const x=function(ve,G){if(typeof ve!="string")return null;if(!G){let q;for(q=ve.length;q>0;q--){const me=ve.charCodeAt(q-1);if(me===47||me===92)break}G=ve.substr(q)}const U=Z.indexOf(G);return U!==-1?oe[U]:null};x.basenames=Z,x.patterns=oe,x.allBasenames=Z;const ae=fe.filter(ve=>!ve.basenames);return ae.push(x),ae}function V(fe,X){return(0,C.$tb)(fe,X,(Q,Z)=>typeof Q=="string"&&typeof Z=="string"?Q===Z:typeof Q!="string"&&typeof Z!="string"?Q.base===Z.base&&Q.pattern===Z.pattern:!1)}e.$yj=V}),define(De[79],Ce([1,0,8,161,23,15,2]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class E{constructor(c="",r=!1){if(this.value=c,typeof this.value!="string")throw(0,C.$6)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(c,r=0){return this.value+=v(this.supportThemeIcons?(0,F.$Uj)(c):c).replace(/([ \t]+)/g,(o,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,r){return this.value+="\n```",this.value+=c,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}appendLink(c,r,o){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(c),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(c,r){const o=new RegExp((0,M.$Ee)(r),"g");return c.replace(o,(m,h)=>c.charAt(h-1)!=="\\"?`\\${m}`:m)}}e.$1j=E;function w(l){return R(l)?!l.value:Array.isArray(l)?l.every(w):!0}e.$2j=w;function R(l){return l instanceof E?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.$3j=R;function I(l,c){return l===c?!0:!l||!c?!1:l.value===c.value&&l.isTrusted===c.isTrusted&&l.supportThemeIcons===c.supportThemeIcons&&l.supportHtml===c.supportHtml&&(l.baseUri===c.baseUri||!!l.baseUri&&!!c.baseUri&&(0,d.$ng)(A.URI.from(l.baseUri),A.URI.from(c.baseUri)))}e.$4j=I;function v(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$5j=v;function y(l){return l.replace(/"/g,"&quot;")}e.$6j=y;function D(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$7j=D;function p(l){const c=[],r=l.split("|").map(m=>m.trim());l=r[0];const o=r[1];if(o){const m=/height=(\d+)/.exec(o),h=/width=(\d+)/.exec(o),t=m?m[1]:"",n=h?h[1]:"",a=isFinite(parseInt(n)),i=isFinite(parseInt(t));a&&c.push(`width="${n}"`),i&&c.push(`height="${t}"`)}return{href:l,dimensions:c}}e.$8j=p}),define(De[99],Ce([1,0,19,32,16,12,23,15]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=void 0;function E(i,s){const{os:u,tildify:S,relative:k}=s;if(k){const g=w(i,k,u);if(typeof g=="string")return g}let $=i.fsPath;if(u===1&&!M.$j?$=$.replace(/\//g,"\\"):u!==1&&M.$j&&($=$.replace(/\\/g,"/")),u!==1&&S?.userHome){const g=S.userHome.fsPath;let P;i.scheme!==S.userHome.scheme&&i.path.startsWith(d.$fc.sep)?P=S.userHome.with({path:i.path}).fsPath:P=i.fsPath,$=v(P,g,u)}return(u===1?d.$ec:d.$fc).normalize(R($,u===1))}e.$mv=E;function w(i,s,u){const S=u===1?d.$ec:d.$fc,k=u===3?A.$kg:A.$mg,$=s.getWorkspace(),f=(0,C.$Nb)($.folders);if(!f)return;i.scheme!==f.uri.scheme&&i.path.startsWith(d.$fc.sep)&&(i=f.uri.with({path:i.path}));const g=s.getWorkspaceFolder(i);if(!g)return;let P;if(k.isEqual(g.uri,i)?P="":P=k.relativePath(g.uri,i)??"",P&&(P=S.normalize(P)),$.folders.length>1&&!s.noPrefix){const O=g.name?g.name:k.basenameOrAuthority(g.uri);P=P?`${O} \u2022 ${P}`:O}return P}function R(i,s=M.$j){return(0,F.$1f)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$nv=R;let I=Object.create(null);function v(i,s,u=M.OS){if(u===1||!i||!s)return i;let S=I.original===s?I.normalized:void 0;S||(S=s,M.$j&&(S=(0,F.$Qf)(S)),S=`${(0,b.$Je)(S,d.$fc.sep)}${d.$fc.sep}`,I={original:s,normalized:S});let k=i;return M.$j&&(k=(0,F.$Qf)(k)),(u===3?k.startsWith(S):(0,b.$2e)(k,S))?`~/${k.substr(S.length)}`:i}e.$ov=v;function y(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.$pv=y;const D="\u2026",p="\\\\",l="~";function c(i,s=d.sep){const u=new Array(i.length);let S=!1;for(let k=0;k<i.length;k++){const $=i[k];if($===""){u[k]=`.${s}`;continue}if(!$){u[k]=$;continue}S=!0;let f="",g=$;g.indexOf(p)===0?(f=g.substr(0,g.indexOf(p)+p.length),g=g.substr(g.indexOf(p)+p.length)):g.indexOf(s)===0?(f=g.substr(0,g.indexOf(s)+s.length),g=g.substr(g.indexOf(s)+s.length)):g.indexOf(l)===0&&(f=g.substr(0,g.indexOf(l)+l.length),g=g.substr(g.indexOf(l)+l.length));const P=g.split(s);for(let O=1;S&&O<=P.length;O++)for(let N=P.length-O;S&&N>=0;N--){S=!1;let L=P.slice(N,N+O).join(s);for(let j=0;!S&&j<i.length;j++)if(j!==k&&i[j]&&i[j].indexOf(L)>-1){const z=N+O===P.length,T=N>0&&i[j].indexOf(s)>-1?s+L:L,K=i[j].endsWith(T);S=!z||K}if(!S){let j="";(P[0].endsWith(":")||f!=="")&&(N===1&&(N=0,O++,L=P[0]+s+L),N>0&&(j=P[0]+s),j=f+j),N>0&&(j=j+D+s),j=j+L,N+O<P.length&&(j=j+s+D),u[k]=j}}S&&(u[k]=$)}return u}e.$qv=c;var r;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function o(i,s=Object.create(null)){const u=[];let S=!1,k="";for(const $ of i)if($==="$"||S&&$==="{")k&&u.push({value:k,type:r.TEXT}),k="",S=!0;else if($==="}"&&S){const f=s[k];if(typeof f=="string")f.length&&u.push({value:f,type:r.VARIABLE});else if(f){const g=u[u.length-1];(!g||g.type!==r.SEPARATOR)&&u.push({value:f.label,type:r.SEPARATOR})}k="",S=!1}else k+=$;return k&&!S&&u.push({value:k,type:r.TEXT}),u.filter(($,f)=>{if($.type===r.SEPARATOR){const g=u[f-1],P=u[f+1];return[g,P].every(O=>O&&(O.type===r.VARIABLE||O.type===r.TEXT)&&O.value.length>0)}return!0}).map($=>$.value).join("")}e.$rv=o;function m(i,s){return M.$k||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$k?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.$sv=m;function h(i,s){return M.$k||s?i.replace(/\(&&\w\)|&&/g,""):M.$j?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$tv=h;function t(i){return i.replace(/&/g,"&&")}e.$uv=t;function n(i){if(i.endsWith("]")){const s=i.lastIndexOf(" [",i.length-2);if(s!==-1){const u=a(i.substring(0,s));return{name:u.name,parentPath:u.parentPath+i.substring(s)}}}return a(i)}e.$vv=n;function a(i){const s=i.indexOf("/")!==-1?d.$fc:d.$ec,u=s.basename(i),S=s.dirname(i);return u.length?{name:u,parentPath:S}:{name:S,parentPath:""}}}),define(De[128],Ce([1,0,22,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=void 0;function d(I){return I.toJSON()}class M{constructor(v){this.a=v}transformIncoming(v){const y=this.a.transformIncoming(v);return y===v?v:d(F.URI.from(y))}transformOutgoing(v){const y=this.a.transformOutgoing(v);return y===v?v:d(F.URI.from(y))}transformOutgoingURI(v){const y=this.a.transformOutgoing(v);return y===v?v:F.URI.from(y)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$Im=M,e.$Jm=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,v,y){if(!I||y>200)return null;if(typeof I=="object"){if(I instanceof F.URI)return v.transformOutgoing(I);for(const D in I)if(Object.hasOwnProperty.call(I,D)){const p=A(I[D],v,y+1);p!==null&&(I[D]=p)}}return null}function b(I,v){const y=A(I,v,0);return y===null?I:y}e.$Km=b;function E(I,v,y,D){if(!I||D>200)return null;if(typeof I=="object"){if(I.$mid===1)return y?F.URI.revive(v.transformIncoming(I)):v.transformIncoming(I);if(I instanceof C.$ae)return null;for(const p in I)if(Object.hasOwnProperty.call(I,p)){const l=E(I[p],v,y,D+1);l!==null&&(I[p]=l)}}return null}function w(I,v){const y=E(I,v,!1,0);return y===null?I:y}e.$Lm=w;function R(I,v){const y=E(I,v,!0,0);return y===null?I:y}e.$Mm=R}),define(De[29],Ce([1,0,53,63,370,9,32,76,16,12,23,2]),function($e,e,C,F,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function y(T,K=v.UNLINK,V){if((0,A.$Zf)(T))throw new Error("rimraf - will refuse to recursively delete root");return K===v.UNLINK?p(T):D(T,V)}async function D(T,K=(0,A.$5f)((0,F.tmpdir)())){try{try{await C.promises.rename(T,K)}catch(V){return V.code==="ENOENT"?void 0:p(T)}p(K).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function p(T){return(0,d.promisify)(C.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function l(T){if((0,A.$Zf)(T))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=l;async function c(T,K){return m(await(K?r(T):(0,d.promisify)(C.readdir)(T)))}async function r(T){try{return await(0,d.promisify)(C.readdir)(T,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const K=[],V=await c(T);for(const fe of V){let X=!1,Q=!1,Z=!1;try{const oe=await e.Promises.lstat((0,E.$ic)(T,fe));X=oe.isFile(),Q=oe.isDirectory(),Z=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}K.push({name:fe,isFile:()=>X,isDirectory:()=>Q,isSymbolicLink:()=>Z})}return K}function o(T){return m(C.readdirSync(T))}e.readdirSync=o;function m(T){return T.map(K=>typeof K=="string"?w.$k?(0,b.$ll)(K):K:(K.name=w.$k?(0,b.$ll)(K.name):K.name,K))}async function h(T){const K=await c(T),V=[];for(const fe of K)await n.existsDirectory((0,E.$ic)(T,fe))&&V.push(fe);return V}function t(T,K=1e3){return new Promise(V=>{let fe=!1;const X=setInterval(()=>{fe||(fe=!0,C.access(T,Q=>{fe=!1,Q&&(clearInterval(X),V(void 0))}))},K)})}e.whenDeleted=t;var n;(function(T){async function K(X){let Q;try{if(Q=await e.Promises.lstat(X),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(w.$j&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw oe}throw Z}}T.stat=K;async function V(X){try{const{stat:Q,symbolicLink:Z}=await T.stat(X);return Q.isFile()&&Z?.dangling!==!0}catch{}return!1}T.existsFile=V;async function fe(X){try{const{stat:Q,symbolicLink:Z}=await T.stat(X);return Q.isDirectory()&&Z?.dangling!==!0}catch{}return!1}T.existsDirectory=fe})(n||(e.SymlinkSupport=n={}));const a=new M.$2g;function i(T,K,V){return a.queueFor(I.URI.file(T),R.$lg).queue(()=>{const fe=$(V);return new Promise((X,Q)=>S(T,K,fe,Z=>Z?Q(Z):X()))})}let s=!0;function u(T){s=T}e.configureFlushOnWrite=u;function S(T,K,V,fe){if(!s)return C.writeFile(T,K,{mode:V.mode,flag:V.flag},fe);C.open(T,V.flag,V.mode,(X,Q)=>{if(X)return fe(X);C.writeFile(Q,K,Z=>{if(Z)return C.close(Q,()=>fe(Z));C.fdatasync(Q,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),u(!1)),C.close(Q,x=>fe(x))))})})}function k(T,K,V){const fe=$(V);if(!s)return C.writeFileSync(T,K,{mode:fe.mode,flag:fe.flag});const X=C.openSync(T,fe.flag,fe.mode);try{C.writeFileSync(X,K);try{C.fdatasyncSync(X)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),u(!1)}}finally{C.closeSync(X)}}e.writeFileSync=k;function $(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function f(T,K,V=6e4){if(T!==K)try{w.$j&&typeof V=="number"?await g(T,K,Date.now(),V):await(0,d.promisify)(C.rename)(T,K)}catch(fe){if(T.toLowerCase()!==K.toLowerCase()&&fe.code==="EXDEV"||T.endsWith("."))await P(T,K,{preserveSymlinks:!1}),await y(T,v.MOVE);else throw fe}}async function g(T,K,V,fe,X=0){try{return await(0,d.promisify)(C.rename)(T,K)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-V>=fe)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${Q}`),Q;if(X===0){let Z=!1;try{const{stat:oe}=await n.stat(K);oe.isFile()||(Z=!0)}catch{}if(Z)throw Q}return await(0,M.$Tg)(Math.min(100,X*10)),g(T,K,V,fe,X+1)}}async function P(T,K,V){return N(T,K,{root:{source:T,target:K},options:V,handledSourcePaths:new Set})}const O=511;async function N(T,K,V){if(V.handledSourcePaths.has(T))return;V.handledSourcePaths.add(T);const{stat:fe,symbolicLink:X}=await n.stat(T);if(X){if(V.options.preserveSymlinks)try{return await z(T,K,V)}catch(Q){console.warn("[node.js fs] copy of symlink failed: ",Q)}if(X.dangling)return}return fe.isDirectory()?L(T,K,fe.mode&O,V):j(T,K,fe.mode&O)}async function L(T,K,V,fe){await e.Promises.mkdir(K,{recursive:!0,mode:V});const X=await c(T);for(const Q of X)await N((0,E.$ic)(T,Q),(0,E.$ic)(K,Q),fe)}async function j(T,K,V){await e.Promises.copyFile(T,K),await e.Promises.chmod(K,V)}async function z(T,K,V){let fe=await e.Promises.readlink(T);(0,A.$Wf)(fe,V.root.source,!w.$l)&&(fe=(0,E.$ic)(V.root.target,fe.substr(V.root.source.length+1))),await e.Promises.symlink(fe,K)}e.Promises=new class{get access(){return(0,d.promisify)(C.access)}get stat(){return(0,d.promisify)(C.stat)}get lstat(){return(0,d.promisify)(C.lstat)}get utimes(){return(0,d.promisify)(C.utimes)}get read(){return(T,K,V,fe,X)=>new Promise((Q,Z)=>{C.read(T,K,V,fe,X,(oe,x,ae)=>oe?Z(oe):Q({bytesRead:x,buffer:ae}))})}get readFile(){return(0,d.promisify)(C.readFile)}get write(){return(T,K,V,fe,X)=>new Promise((Q,Z)=>{C.write(T,K,V,fe,X,(oe,x,ae)=>oe?Z(oe):Q({bytesWritten:x,buffer:ae}))})}get appendFile(){return(0,d.promisify)(C.appendFile)}get fdatasync(){return(0,d.promisify)(C.fdatasync)}get truncate(){return(0,d.promisify)(C.truncate)}get copyFile(){return(0,d.promisify)(C.copyFile)}get open(){return(0,d.promisify)(C.open)}get close(){return(0,d.promisify)(C.close)}get symlink(){return(0,d.promisify)(C.symlink)}get readlink(){return(0,d.promisify)(C.readlink)}get chmod(){return(0,d.promisify)(C.chmod)}get mkdir(){return(0,d.promisify)(C.mkdir)}get unlink(){return(0,d.promisify)(C.unlink)}get rmdir(){return(0,d.promisify)(C.rmdir)}get realpath(){return(0,d.promisify)(C.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return h}get writeFile(){return i}get rm(){return y}get rename(){return f}get copy(){return P}}}),define(De[100],Ce([1,0,53,16,12,15,29]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=e.$3p=e.$2p=void 0;function b(v){if(d.$l)return v;const y=(0,F.$lc)(v);if(v===y)return v;const D=((0,F.$mc)(v)||v).toLowerCase();try{const l=(0,A.readdirSync)(y).filter(c=>c.toLowerCase()===D);if(l.length===1){const c=b(y);if(c)return(0,F.$ic)(c,l[0])}else if(l.length>1){const c=l.indexOf(D);if(c>=0){const r=b(y);if(r)return(0,F.$ic)(r,l[c])}}}catch{}return null}e.$2p=b;async function E(v){if(d.$l)return v;const y=(0,F.$lc)(v);if(v===y)return v;const D=((0,F.$mc)(v)||v).toLowerCase();try{const l=(await A.Promises.readdir(y)).filter(c=>c.toLowerCase()===D);if(l.length===1){const c=await E(y);if(c)return(0,F.$ic)(c,l[0])}else if(l.length>1){const c=l.indexOf(D);if(c>=0){const r=await E(y);if(r)return(0,F.$ic)(r,l[c])}}}catch{}return null}e.$3p=E;async function w(v){try{return await A.Promises.realpath(v)}catch{const D=I(v);return await A.Promises.access(D,C.constants.R_OK),D}}e.$4p=w;function R(v){try{return C.realpathSync(v)}catch{const D=I(v);return C.accessSync(D,C.constants.R_OK),D}}e.$5p=R;function I(v){return(0,M.$Je)((0,F.$gc)(v),F.sep)}}),define(De[101],Ce([1,0,16,12,48,98,18,29]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$zl=e.$yl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function E(I=d.env){return I.comspec||"cmd.exe"}e.$yl=E;function w(I){let v=[],y=!1;const D=function(p){if(y){v.push(p);return}(!I.send(p,c=>{if(c&&console.error(c),y=!1,v.length>0){const r=v.slice(0);v=[],r.forEach(o=>D(o))}})||F.$j)&&(y=!0)};return{send:D}}e.$zl=w;var R;(function(I){async function v(y,D,p){if(C.$hc(y))return y;if(D===void 0&&(D=d.cwd()),C.$lc(y)!=="."||(p===void 0&&A.$xf(d.env.PATH)&&(p=d.env.PATH.split(C.$sc)),p===void 0||p.length===0))return C.$ic(D,y);async function c(r){if(await b.Promises.exists(r)){let o;try{o=await b.Promises.stat(r)}catch(m){m.message.startsWith("EACCES")&&(o=await b.Promises.lstat(r))}return o?!o.isDirectory():!1}return!1}for(const r of p){let o;if(C.$hc(r)?o=C.$ic(r,y):o=C.$ic(D,r,y),await c(o))return o;let m=o+".com";if(await c(m)||(m=o+".exe",await c(m)))return m}return C.$ic(D,y)}I.findExecutable=v})(R||(e.win32=R={}))});var He=this&&this.__decorate||function($e,e,C,F){var d=arguments.length,M=d<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,C):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate($e,e,C,F);else for(var b=$e.length-1;b>=0;b--)(A=$e[b])&&(M=(d<3?A(M):d>3?A(e,C,M):A(e,C))||M);return d>3&&M&&Object.defineProperty(e,C,M),M};define(De[80],Ce([1,0,19,9,22,21,57,8,4,3,62,15,18]),function($e,e,C,F,d,M,A,b,E,w,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.ProxyChannel=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.RequestInitiator=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0;var y;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(y||(y={}));function D(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(p||(p={}));function l(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(c||(c={}));function r(X){let Q=0;for(let Z=0;;Z+=7){const oe=X.read(1);if(Q|=(oe.buffer[0]&127)<<Z,!(oe.buffer[0]&128))return Q}}const o=a(0);function m(X,Q){if(Q===0){X.write(o);return}let Z=0;for(let x=Q;x!==0;x=x>>>7)Z++;const oe=d.$ae.alloc(Z);for(let x=0;Q!==0;x++)oe.buffer[x]=Q&127,Q=Q>>>7,Q>0&&(oe.buffer[x]|=128);X.write(oe)}class h{constructor(Q){this.b=Q,this.a=0}read(Q){const Z=this.b.slice(this.a,this.a+Q);return this.a+=Z.byteLength,Z}}e.$lh=h;class t{constructor(){this.a=[]}get buffer(){return d.$ae.concat(this.a)}write(Q){this.a.push(Q)}}e.$mh=t;var n;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(n||(n={}));function a(X){const Q=d.$ae.alloc(1);return Q.writeUInt8(X,0),Q}const i={Undefined:a(n.Undefined),String:a(n.String),Buffer:a(n.Buffer),VSBuffer:a(n.VSBuffer),Array:a(n.Array),Object:a(n.Object),Uint:a(n.Int)},s=typeof Buffer<"u";function u(X,Q){if(typeof Q>"u")X.write(i.Undefined);else if(typeof Q=="string"){const Z=d.$ae.fromString(Q);X.write(i.String),m(X,Z.byteLength),X.write(Z)}else if(s&&Buffer.isBuffer(Q)){const Z=d.$ae.wrap(Q);X.write(i.Buffer),m(X,Z.byteLength),X.write(Z)}else if(Q instanceof d.$ae)X.write(i.VSBuffer),m(X,Q.byteLength),X.write(Q);else if(Array.isArray(Q)){X.write(i.Array),m(X,Q.length);for(const Z of Q)u(X,Z)}else if(typeof Q=="number"&&(Q|0)===Q)X.write(i.Uint),m(X,Q);else{const Z=d.$ae.fromString(JSON.stringify(Q));X.write(i.Object),m(X,Z.byteLength),X.write(Z)}}e.$nh=u;function S(X){switch(X.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return X.read(r(X)).toString();case n.Buffer:return X.read(r(X)).buffer;case n.VSBuffer:return X.read(r(X));case n.Array:{const Z=r(X),oe=[];for(let x=0;x<Z;x++)oe.push(S(X));return oe}case n.Object:return JSON.parse(X.read(r(X)).toString());case n.Int:return r(X)}}e.$oh=S;class k{constructor(Q,Z,oe=null,x=1e3){this.h=Q,this.j=Z,this.k=oe,this.l=x,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(Q,Z){this.b.set(Q,Z),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const Z=this.o([Q.type]);this.k?.logOutgoing(Z,0,1,l(Q.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(Z,Q.id,1,l(Q.type),Q.data);return}}}o(Q,Z=void 0){const oe=new t;return u(oe,Q),u(oe,Z),this.p(oe.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const Z=new h(Q),oe=S(Z),x=S(Z),ae=oe[0];switch(ae){case 100:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${D(ae)}: ${oe[2]}.${oe[3]}`,x),this.s({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:x});case 102:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${D(ae)}: ${oe[2]}.${oe[3]}`,x),this.t({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:x});case 101:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${D(ae)}`),this.u({type:ae,id:oe[1]});case 103:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${D(ae)}`),this.u({type:ae,id:oe[1]})}}s(Q){const Z=this.b.get(Q.channelName);if(!Z){this.v(Q);return}const oe=new M.$Wd;let x;try{x=Z.call(this.j,Q.name,Q.arg,oe.token)}catch(G){x=Promise.reject(G)}const ae=Q.id;x.then(G=>{this.m({id:ae,data:G,type:201})},G=>{G instanceof Error?this.m({id:ae,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.m({id:ae,data:G,type:203})}).finally(()=>{ve.dispose(),this.d.delete(Q.id)});const ve=(0,w.$Pc)(()=>oe.cancel());this.d.set(Q.id,ve)}t(Q){const Z=this.b.get(Q.channelName);if(!Z){this.v(Q);return}const oe=Q.id,ae=Z.listen(this.j,Q.name,Q.arg)(ve=>this.m({id:oe,data:ve,type:204}));this.d.set(Q.id,ae)}u(Q){const Z=this.d.get(Q.id);Z&&(Z.dispose(),this.d.delete(Q.id))}v(Q){let Z=this.g.get(Q.channelName);Z||(Z=[],this.g.set(Q.channelName,Z));const oe=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:Q,timeoutTimer:oe})}w(Q){const Z=this.g.get(Q);if(Z){for(const oe of Z)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Mc)(this.d.values()),this.d.clear()}}e.$ph=k;var $;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));class f{constructor(Q,Z=null){this.l=Q,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$Md,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=Z}getChannel(Q){const Z=this;return{call(oe,x,ae){return Z.a?Promise.reject(new b.$4):Z.m(Q,oe,x,ae)},listen(oe,x){return Z.a?E.Event.None:Z.o(Q,oe,x)}}}m(Q,Z,oe,x=M.CancellationToken.None){const ae=this.g++,G={id:ae,type:100,channelName:Q,name:Z,arg:oe};if(x.isCancellationRequested)return Promise.reject(new b.$4);let U;return new Promise((me,_)=>{if(x.isCancellationRequested)return _(new b.$4);const ie=()=>{const de=ee=>{switch(ee.type){case 201:this.f.delete(ae),me(ee.data);break;case 202:{this.f.delete(ae);const he=new Error(ee.data.message);he.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,he.name=ee.data.name,_(he);break}case 203:this.f.delete(ae),_(ee.data);break}};this.f.set(ae,de),this.p(G)};let re=null;this.b===c.Idle?ie():(re=(0,F.$Gg)(de=>this.u()),re.then(()=>{re=null,ie()}));const Ee=()=>{re?(re.cancel(),re=null):this.p({id:ae,type:101}),_(new b.$4)},ce=x.onCancellationRequested(Ee);U=(0,w.$Oc)((0,w.$Pc)(Ee),ce),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Q,Z,oe){const x=this.g++,ve={id:x,type:102,channelName:Q,name:Z,arg:oe};let G=null;const U=new E.$Md({onWillAddFirstListener:()=>{G=(0,F.$Gg)(me=>this.u()),G.then(()=>{G=null,this.d.add(U),this.p(ve)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(U),this.p({id:x,type:103}))}}),q=me=>U.fire(me.data);return this.f.set(x,q),U.event}p(Q){switch(Q.type){case 100:case 102:{const Z=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(Z,Q.id,0,`${D(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const Z=this.q([Q.type,Q.id]);this.j?.logOutgoing(Z,Q.id,0,D(Q.type));return}}}q(Q,Z=void 0){const oe=new t;return u(oe,Q),u(oe,Z),this.r(oe.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const Z=new h(Q),oe=S(Z),x=S(Z),ae=oe[0];switch(ae){case 200:return this.j?.logIncoming(Q.byteLength,0,0,l(ae)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,oe[1],0,l(ae),x),this.t({type:oe[0],id:oe[1],data:x})}}t(Q){if(Q.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Mc)(this.d.values()),this.d.clear()}}e.$qh=f,He([A.$fh],f.prototype,"onDidInitializePromise",null);class g{get connections(){const Q=[];return this.f.forEach(Z=>Q.push(Z)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new E.$Md,this.onDidAddConnection=this.g.event,this.h=new E.$Md,this.onDidRemoveConnection=this.h.event,this.j=new w.$Qc,this.j.add(Q(({protocol:Z,onDidClientDisconnect:oe})=>{const x=E.Event.once(Z.onMessage);this.j.add(x(ae=>{const ve=new h(ae),G=S(ve),U=new k(Z,G),q=new f(Z);this.a.forEach((_,ie)=>U.registerChannel(ie,_));const me={channelServer:U,channelClient:q,ctx:G};this.f.add(me),this.g.fire(me),this.j.add(oe(()=>{U.dispose(),q.dispose(),this.f.delete(me),this.h.fire(me)}))}))}))}getChannel(Q,Z){const oe=this;return{call(x,ae,ve){let G;if((0,v.$Lf)(Z)){const q=(0,C.$3b)(oe.connections.filter(Z));G=q?Promise.resolve(q):E.Event.toPromise(E.Event.filter(oe.onDidAddConnection,Z))}else G=Z.routeCall(oe,x,ae);const U=G.then(q=>q.channelClient.getChannel(Q));return O(U).call(x,ae,ve)},listen(x,ae){if((0,v.$Lf)(Z))return oe.k(Q,Z,x,ae);const ve=Z.routeEvent(oe,x,ae).then(G=>G.channelClient.getChannel(Q));return O(ve).listen(x,ae)}}}k(Q,Z,oe,x){const ae=this;let ve;const G=new E.$Md({onWillAddFirstListener:()=>{ve=new w.$Qc;const U=new E.$Sd,q=new Map,me=ie=>{const Ee=ie.channelClient.getChannel(Q).listen(oe,x),ce=U.add(Ee);q.set(ie,ce)},_=ie=>{const re=q.get(ie);re&&(re.dispose(),q.delete(ie))};ae.connections.filter(Z).forEach(me),E.Event.filter(ae.onDidAddConnection,Z)(me,void 0,ve),ae.onDidRemoveConnection(_,void 0,ve),U.event(G.fire,G,ve),ve.add(U)},onDidRemoveLastListener:()=>{ve?.dispose(),ve=void 0}});return G.event}registerChannel(Q,Z){this.a.set(Q,Z);for(const oe of this.f)oe.channelServer.registerChannel(Q,Z)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$rh=g;class P{constructor(Q,Z,oe=null){const x=new t;u(x,Z),Q.send(x.buffer),this.a=new f(Q,oe),this.d=new k(Q,Z,oe)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,Z){this.d.registerChannel(Q,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$sh=P;function O(X){return{call(Q,Z,oe){return X.then(x=>x.call(Q,Z,oe))},listen(Q,Z){const oe=new E.$Vd;return X.then(x=>oe.input=x.listen(Q,Z)),oe.event}}}e.$th=O;function N(X){let Q=!1;return{call(Z,oe,x){return Q?X.call(Z,oe,x):(0,F.$Tg)(0).then(()=>Q=!0).then(()=>X.call(Z,oe,x))},listen(Z,oe){if(Q)return X.listen(Z,oe);const x=new E.$Vd;return(0,F.$Tg)(0).then(()=>Q=!0).then(()=>x.input=X.listen(Z,oe)),x.event}}}e.$uh=N;class L{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const Z of Q.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await E.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$vh=L;var j;(function(X){function Q(ae,ve,G){const U=ae,q=G&&G.disableMarshalling,me=new Map;for(const _ in U)oe(_)&&me.set(_,E.Event.buffer(U[_],!0,void 0,ve));return new class{listen(_,ie,re){const Ee=me.get(ie);if(Ee)return Ee;if(x(ie)){const ce=U[ie];if(typeof ce=="function")return ce.call(U,re)}throw new b.$ab(`Event not found: ${ie}`)}call(_,ie,re){const Ee=U[ie];if(typeof Ee=="function"){if(!q&&Array.isArray(re))for(let de=0;de<re.length;de++)re[de]=(0,R.$kh)(re[de]);let ce=Ee.apply(U,re);return ce instanceof Promise||(ce=Promise.resolve(ce)),ce}throw new b.$ab(`Method not found: ${ie}`)}}}X.fromService=Q;function Z(ae,ve){const G=ve&&ve.disableMarshalling;return new Proxy({},{get(U,q){if(typeof q=="string")return ve?.properties?.has(q)?ve.properties.get(q):x(q)?function(me){return ae.listen(q,me)}:oe(q)?ae.listen(q):async function(...me){let _;ve&&!(0,v.$Gf)(ve.context)?_=[ve.context,...me]:_=me;const ie=await ae.call(q,_);return G?ie:(0,R.$kh)(ie)};throw new b.$ab(`Property not found: ${String(q)}`)}})}X.toService=Z;function oe(ae){return ae[0]==="o"&&ae[1]==="n"&&I.$Ze(ae.charCodeAt(2))}function x(ae){return/^onDynamic/.test(ae)&&I.$Ze(ae.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const Q=X.toString();if(Q!=="[object Object]")return Q}return X}function K(X){return Array.isArray(X)?X.map(T):T(X)}function V(X,Q,Z,oe,x,ae,ve){ve=K(ve);const G=z[x],U=G[oe%G.length];let q=[`%c[${X}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ae)?(q=q.concat(ve),q.push(")")):q.push(ve),console.log.apply(console,q)}class fe{constructor(Q,Z){this.d=Q,this.f=Z,this.a=0,this.b=0}logOutgoing(Q,Z,oe,x,ae){this.b+=Q,V(this.d,this.b,Q,Z,oe,x,ae)}logIncoming(Q,Z,oe,x,ae){this.a+=Q,V(this.f,this.a,Q,Z,oe,x,ae)}}e.$wh=fe}),define(De[81],Ce([1,0,22,4,3,80]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e.$yh=e.ProtocolConstants=e.$xh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var b;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let u=0;function S($,f){if(!s.has($)){const g=String(++u);s.set($,g)}return s.get($)}function k($,f,g,P){if(!i.enableDiagnostics)return;const O=S($,f);if(P instanceof C.$ae||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const N=C.$ae.alloc(P.byteLength);N.set(P),i.records.push({timestamp:Date.now(),id:O,label:f,type:g,buff:N})}else i.records.push({timestamp:Date.now(),id:O,label:f,type:g,data:P})}i.traceSocketEvent=k})(b||(e.SocketDiagnostics=b={}));var E;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let w=null;function R(){return w||(w=C.$ae.alloc(0)),w}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,u){if(s===0)return R();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const f=this.a[0];return u&&(this.a.shift(),this.b-=s),f}if(this.a[0].byteLength>s){const f=this.a[0].slice(0,s);return u&&(this.a[0]=this.a[0].slice(s),this.b-=s),f}const S=C.$ae.alloc(s);let k=0,$=0;for(;s>0;){const f=this.a[$];if(f.byteLength>s){const g=f.slice(0,s);S.set(g,k),k+=s,u&&(this.a[$]=f.slice(s),this.b-=s),s-=s}else S.set(f,k),k+=f.byteLength,u?(this.a.shift(),this.b-=f.byteLength):$++,s-=f.byteLength}return S}}e.$xh=I;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var D;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(D||(e.ProtocolConstants=D={}));class p{constructor(s,u,S,k){this.type=s,this.id=u,this.ack=S,this.data=k,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends d.$Rc{constructor(s){super(),this.f=this.B(new F.$Md),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new I,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,k=this.g.id,$=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",u),this.f.fire(new p(S,k,$,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=C.$ae.alloc(13);u.writeUInt8(s.type,0),u.writeUInt32BE(s.id,1),u.writeUInt32BE(s.ack,5),u.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(u,s.data)}g(s,u){const S=this.f===0;return this.d.push(s,u),this.f+=s.byteLength+u.byteLength,S}h(){const s=C.$ae.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,u){this.g(s,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class r extends d.$Rc{constructor(s){super(),this.f=new F.$Md,this.onMessage=this.f.event,this.g=new F.$Md,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new c(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(u=>{u.type===1&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new p(1,0,0,s))}}e.$yh=r;class o extends M.$sh{static fromSocket(s,u){return new o(new r(s),u)}get onDidDispose(){return this.b.onDidDispose}constructor(s,u,S=null){super(s,u,S),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$zh=o;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$Md({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$Ah=m;class h{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,u=this.a;for(;u;)u=u.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let u=0,S=this.a;for(;S;)s[u++]=S.data,S=S.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const u=new h(s);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const s=Date.now();for(let u=0;u<n.a;u++)this.c[u]=s-1e3*u;setInterval(()=>{for(let u=n.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),u=(1+n.a)*1e3;let S=0;for(let k=0;k<n.a;k++)s-this.c[k]<=u&&S++;return 1-S/n.a}hasHighLoad(){return this.d()>=.5}}class a{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??n.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new d.$Qc,this.o=s.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new l(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new p(5,0,0,R());this.p.write(s),this.p.flush()}sendPause(){const s=new p(7,0,0,R());this.p.write(s)}sendResume(){const s=new p(8,0,0,R());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,u){this.a=!0,this.r.dispose(),this.r=new d.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new l(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new p(3,0,this.h,R());this.p.write(s);const u=this.b.toArray();for(let S=0,k=u.length;S<k;S++)this.p.write(u[S]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const u=this.b.peek();if(u&&u.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new p(6,0,0,R())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const u=this.b.toArray();for(let S=0,k=u.length;S<k;S++)this.p.write(u[S]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const u=++this.c;this.h=this.g;const S=new p(1,u,this.h,s);this.b.push(S),this.a||(this.p.write(S),this.B())}sendControl(s){const u=new p(2,0,0,s);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),u=Date.now()-s.writtenTime,S=Date.now()-this.q.lastReadTime,k=Date.now()-this.n;if(u>=2e4&&S>=2e4&&k>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:S});return}const $=Math.max(2e4-u,2e4-S,2e4-k,500);this.f=setTimeout(()=>{this.f=null,this.B()},$)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new p(3,0,this.h,R());this.p.write(s)}D(){this.h=this.g;const s=new p(9,0,this.h,R());this.p.write(s)}}e.$Bh=a}),define(De[183],Ce([1,0,49,9,22,21,181,8,4,3,24,101,98,80]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0;class D extends y.$ph{constructor(c){super({send:r=>{try{process.send?.(r.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",r=>d.$ae.wrap(Buffer.from(r,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Yp=D;class p{constructor(c,r){this.i=c,this.j=r,this.c=new Set,this.g=new Map,this.h=new E.$Md,this.onDidProcessExit=this.h.event;const o=r&&r.timeout?r.timeout:6e4;this.b=new F.$Pg(o),this.d=null,this.f=null}getChannel(c){const r=this;return{call(o,m,h){return r.k(c,o,m,h)},listen(o,m){return r.l(c,o,m)}}}k(c,r,o,m=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(b.$5());this.b.cancel();const h=this.n(c),t=(0,F.$Gg)(i=>h.call(r,o,i)),n=m.onCancellationRequested(()=>t.cancel()),a=(0,w.$Pc)(()=>t.cancel());return this.c.add(a),t.finally(()=>{n.dispose(),this.c.delete(a),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,r,o){if(!this.b)return E.Event.None;this.b.cancel();let m;const h=new E.$Md({onWillAddFirstListener:()=>{m=this.n(c).listen(r,o)(h.fire,h),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],r=Object.create(null);r.env={...(0,R.$3m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(r.env={...r.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(r.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(r.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(r.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),r.execArgv===void 0&&(r.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,v.$xl)(r.env),this.d=(0,C.fork)(this.i,c,r);const o=new E.$Md;E.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,A.$Up)(s)){(0,A.log)(s,`IPC Library: ${this.j.serverName}`);return}o.fire(d.$ae.wrap(Buffer.from(s,"base64")))});const h=this.j.useQueue?(0,I.$zl)(this.d):this.d,t=s=>this.d&&this.d.connected&&h.send(s.buffer.toString("base64")),n=o.event,a={send:t,onMessage:n};this.f=new y.$qh(a);const i=()=>this.o();process.once("exit",i),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,u)=>{process.removeListener("exit",i),this.c.forEach(S=>(0,w.$Mc)(S)),this.c.clear(),s!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:u})})}return this.f}n(c){let r=this.g.get(c);return r||(r=this.m.getChannel(c),this.g.set(c,r)),r}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Zp=p}),define(De[184],Ce([1,0,9,4,3,62,18]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.StorageState=e.$Xo=e.StorageHint=void 0;var b;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function E(v){const y=v;return y?.changed instanceof Map||y?.deleted instanceof Set}e.$Xo=E;var w;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(w||(e.StorageState=w={}));class R extends d.$Rc{static{this.a=100}constructor(y,D=Object.create(null)){super(),this.r=y,this.s=D,this.b=this.B(new F.$Pd),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new C.$Qg(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((D,p)=>this.w(p,D)),y.deleted?.forEach(D=>this.w(D,void 0))}finally{this.b.resume()}}w(y,D){if(this.c===w.Closed)return;let p=!1;(0,A.$Gf)(D)?p=this.f.delete(y):this.f.get(y)!==D&&(this.f.set(y,D),p=!0),p&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,D){const p=this.f.get(y);return(0,A.$Gf)(p)?D:p}getBoolean(y,D){const p=this.get(y);return(0,A.$Gf)(p)?D:p==="true"}getNumber(y,D){const p=this.get(y);return(0,A.$Gf)(p)?D:parseInt(p,10)}getObject(y,D){const p=this.get(y);return(0,A.$Gf)(p)?D:(0,M.$jh)(p)}async set(y,D,p=!1){if(this.c===w.Closed)return;if((0,A.$Gf)(D))return this.delete(y,p);const l=(0,A.$zf)(D)||Array.isArray(D)?(0,M.$ih)(D):String(D);if(this.f.get(y)!==l)return this.f.set(y,l),this.j.set(y,l),this.h.delete(y),this.b.fire({key:y,external:p}),this.D()}async delete(y,D=!1){if(!(this.c===w.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:D}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Yo=R;class I{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((D,p)=>this.a.set(p,D)),y.delete?.forEach(D=>this.a.delete(D))}async optimize(){}async close(){}}e.$Zo=I}),define(De[185],Ce([1,0,35,16]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nE=void 0;function d(M,A,b,E,w,R){if(Array.isArray(M)){let I=0;for(const v of M){const y=d(v,A,b,E,w,R);if(y===10)return y;y>I&&(I=y)}return I}else{if(typeof M=="string")return E?M==="*"?5:M===b?10:0:0;if(M){const{language:I,pattern:v,scheme:y,hasAccessToAllModels:D,notebookType:p}=M;if(!E&&!D)return 0;p&&w&&(A=w);let l=0;if(y)if(y===A.scheme)l=10;else if(y==="*")l=5;else return 0;if(I)if(I===b)l=10;else if(I==="*")l=Math.max(l,5);else return 0;if(p)if(p===R)l=10;else if(p==="*"&&R!==void 0)l=Math.max(l,5);else return 0;if(v){let c;if(typeof v=="string"?c=v:c={...v,base:(0,F.$gc)(v.base)},c===A.fsPath||(0,C.$tj)(c,A.fsPath))l=10;else return 0}return l}else return 0}}e.$nE=d}),define(De[129],Ce([1,0,22,12]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R0=e.$Q0=void 0;var d;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(d||(d={}));function M(I){for(let v=0,y=I.length;v<y;v+=4){const D=I[v+0],p=I[v+1],l=I[v+2],c=I[v+3];I[v+0]=c,I[v+1]=l,I[v+2]=p,I[v+3]=D}}function A(I){const v=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.$D()||M(v),C.$ae.wrap(v)}function b(I){const v=I.buffer;if(F.$D()||M(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const y=new Uint8Array(v.byteLength);return y.set(v),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function E(I){const v=new Uint32Array(w(I));let y=0;if(v[y++]=I.id,I.type==="full")v[y++]=1,v[y++]=I.data.length,v.set(I.data,y),y+=I.data.length;else{v[y++]=2,v[y++]=I.deltas.length;for(const D of I.deltas)v[y++]=D.start,v[y++]=D.deleteCount,D.data?(v[y++]=D.data.length,v.set(D.data,y),y+=D.data.length):v[y++]=0}return A(v)}e.$Q0=E;function w(I){let v=0;if(v+=1+1,I.type==="full")v+=1+I.data.length;else{v+=1,v+=(1+1+1)*I.deltas.length;for(const y of I.deltas)y.data&&(v+=y.data.length)}return v}function R(I){const v=b(I);let y=0;const D=v[y++];if(v[y++]===1){const r=v[y++],o=v.subarray(y,y+r);return y+=r,{id:D,type:"full",data:o}}const l=v[y++],c=[];for(let r=0;r<l;r++){const o=v[y++],m=v[y++],h=v[y++];let t;h>0&&(t=v.subarray(y,y+h),y+=h),c[r]={start:o,deleteCount:m,data:t}}return{id:D,type:"delta",deltas:c}}e.$R0=R}),define(De[186],Ce([10,11]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(De[130],Ce([1,0,19,24,12,166,124,186]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(le){le[le.None=0]="None",le[le.Keep=1]="Keep",le[le.Brackets=2]="Brackets",le[le.Advanced=3]="Advanced",le[le.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=w;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class I{constructor(ue,Ie,Ve,ze){this.id=ue,this.name=Ie,this.defaultValue=Ve,this.schema=ze}applyUpdate(ue,Ie){return y(ue,Ie)}compute(ue,Ie,Ve){return Ve}}class v{constructor(ue,Ie){this.newValue=ue,this.didChange=Ie}}e.ApplyUpdateResult=v;function y(le,ue){if(typeof le!="object"||typeof ue!="object"||!le||!ue)return new v(ue,le!==ue);if(Array.isArray(le)||Array.isArray(ue)){const Ve=Array.isArray(le)&&Array.isArray(ue)&&C.$tb(le,ue);return new v(ue,!Ve)}let Ie=!1;for(const Ve in ue)if(ue.hasOwnProperty(Ve)){const ze=y(le[Ve],ue[Ve]);ze.didChange&&(le[Ve]=ze.newValue,Ie=!0)}return new v(le,Ie)}class D{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return this.defaultValue}}class p{constructor(ue,Ie,Ve,ze){this.id=ue,this.name=Ie,this.defaultValue=Ve,this.schema=ze}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ie,Ve){return Ve}}function l(le,ue){return typeof le>"u"?ue:le==="false"?!1:!!le}e.boolean=l;class c extends p{constructor(ue,Ie,Ve,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=Ve),super(ue,Ie,Ve,ze)}validate(ue){return l(ue,this.defaultValue)}}function r(le,ue,Ie,Ve){if(typeof le>"u")return ue;let ze=parseInt(le,10);return isNaN(ze)?ue:(ze=Math.max(Ie,ze),ze=Math.min(Ve,ze),ze|0)}e.clampedInt=r;class o extends p{static clampedInt(ue,Ie,Ve,ze){return r(ue,Ie,Ve,ze)}constructor(ue,Ie,Ve,ze,Xe,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Ve,rt.minimum=ze,rt.maximum=Xe),super(ue,Ie,Ve,rt),this.minimum=ze,this.maximum=Xe}validate(ue){return o.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function m(le,ue,Ie,Ve){if(typeof le>"u")return ue;const ze=h.float(le,ue);return h.clamp(ze,Ie,Ve)}e.clampedFloat=m;class h extends p{static clamp(ue,Ie,Ve){return ue<Ie?Ie:ue>Ve?Ve:ue}static float(ue,Ie){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ie;const Ve=parseFloat(ue);return isNaN(Ve)?Ie:Ve}constructor(ue,Ie,Ve,ze,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Ve),super(ue,Ie,Ve,Xe),this.validationFn=ze}validate(ue){return this.validationFn(h.float(ue,this.defaultValue))}}class t extends p{static string(ue,Ie){return typeof ue!="string"?Ie:ue}constructor(ue,Ie,Ve,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=Ve),super(ue,Ie,Ve,ze)}validate(ue){return t.string(ue,this.defaultValue)}}function n(le,ue,Ie,Ve){return typeof le!="string"?ue:Ve&&le in Ve?Ve[le]:Ie.indexOf(le)===-1?ue:le}e.stringSet=n;class a extends p{constructor(ue,Ie,Ve,ze,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=ze,Xe.default=Ve),super(ue,Ie,Ve,Xe),this.c=ze}validate(ue){return n(ue,this.defaultValue,this.c)}}class i extends I{constructor(ue,Ie,Ve,ze,Xe,rt,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=Xe,ot.default=ze),super(ue,Ie,Ve,ot),this.c=Xe,this.d=rt}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function s(le){switch(le){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ie,Ve){return Ve===0?ue.accessibilitySupport:Ve}}class S extends I{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertSpace:l(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(le){le[le.Hidden=0]="Hidden",le[le.Blink=1]="Blink",le[le.Smooth=2]="Smooth",le[le.Phase=3]="Phase",le[le.Expand=4]="Expand",le[le.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function $(le){switch(le){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(le){le[le.Line=1]="Line",le[le.Block=2]="Block",le[le.Underline=3]="Underline",le[le.LineThin=4]="LineThin",le[le.BlockOutline=5]="BlockOutline",le[le.UnderlineThin=6]="UnderlineThin"})(f||(e.TextEditorCursorStyle=f={}));function g(le){switch(le){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=g;function P(le){switch(le){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class O extends D{constructor(){super(140)}compute(ue,Ie,Ve){const ze=["monaco-editor"];return Ie.get(39)&&ze.push(Ie.get(39)),ue.extraEditorClassName&&ze.push(ue.extraEditorClassName),Ie.get(73)==="default"?ze.push("mouse-default"):Ie.get(73)==="copy"&&ze.push("mouse-copy"),Ie.get(110)&&ze.push("showUnused"),Ie.get(138)&&ze.push("showDeprecated"),ze.join(" ")}}class N extends c{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ue,Ie,Ve){return Ve&&ue.emptySelectionClipboard}}class L extends I{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:b.localize(16,null),included:d.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:b.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{cursorMoveOnType:l(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":n(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":n(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(Ie.loop,this.defaultValue.loop)}}}class j extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?j.OFF:ue==="true"?j.ON:ue:ue?j.ON:j.OFF}}e.EditorFontLigatures=j;class z extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",z.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?z.OFF:ue==="true"?z.TRANSLATE:ue:ue?z.TRANSLATE:z.OFF}compute(ue,Ie,Ve){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=z;class T extends D{constructor(){super(50)}compute(ue,Ie,Ve){return ue.fontInfo}}class K extends p{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ue){const Ie=h.float(ue,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Ie,6,100)}compute(ue,Ie,Ve){return ue.fontInfo.fontSize}}class V extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(o.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}class fe extends I{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ve,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ve,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ve,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ve,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ve,description:b.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{multiple:n(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??n(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??n(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??n(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??n(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??n(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class X extends I{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:b.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),delay:o.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:l(Ie.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:l(Ie.above,this.defaultValue.above)}}}var Q;(function(le){le[le.None=0]="None",le[le.Text=1]="Text",le[le.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class Z extends D{constructor(){super(143)}compute(ue,Ie,Ve){return Z.computeLayout(Ie,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ie=ue.height/ue.lineHeight,Ve=Math.floor(ue.paddingTop/ue.lineHeight);let ze=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(ze=Math.max(ze,Ie-1));const Xe=(Ve+ue.viewLineCount+ze)/(ue.pixelRatio*ue.height),rt=Math.floor(ue.viewLineCount/Xe);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:ze,desiredRatio:Xe,minimapLineCount:rt}}static c(ue,Ie){const Ve=ue.outerWidth,ze=ue.outerHeight,Xe=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const rt=Ie.stableMinimapLayoutInput,ot=rt&&ue.outerHeight===rt.outerHeight&&ue.lineHeight===rt.lineHeight&&ue.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&ue.pixelRatio===rt.pixelRatio&&ue.scrollBeyondLastLine===rt.scrollBeyondLastLine&&ue.paddingTop===rt.paddingTop&&ue.paddingBottom===rt.paddingBottom&&ue.minimap.enabled===rt.minimap.enabled&&ue.minimap.side===rt.minimap.side&&ue.minimap.size===rt.minimap.size&&ue.minimap.showSlider===rt.minimap.showSlider&&ue.minimap.renderCharacters===rt.minimap.renderCharacters&&ue.minimap.maxColumn===rt.minimap.maxColumn&&ue.minimap.scale===rt.minimap.scale&&ue.verticalScrollbarWidth===rt.verticalScrollbarWidth&&ue.isViewportWrapping===rt.isViewportWrapping,wt=ue.lineHeight,Et=ue.typicalHalfwidthCharacterWidth,Yt=ue.scrollBeyondLastLine,Kt=ue.minimap.renderCharacters;let pt=Xe>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const Ut=ue.minimap.maxColumn,Tt=ue.minimap.size,Bt=ue.minimap.side,Pt=ue.verticalScrollbarWidth,At=ue.viewLineCount,Ot=ue.remainingWidth,Wt=ue.isViewportWrapping,Ht=Kt?2:3;let qt=Math.floor(Xe*ze);const ct=qt/Xe;let lt=!1,Jt=!1,It=Ht*pt,kt=pt/Xe,ft=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:Le,extraLinesBeforeFirstLine:Fe,extraLinesBeyondLastLine:Se,desiredRatio:ne,minimapLineCount:Te}=Z.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Yt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:ze,lineHeight:wt,pixelRatio:Xe});if(At/Te>1)lt=!0,Jt=!0,pt=1,It=1,kt=pt/Xe;else{let xe=!1,Je=pt+1;if(Tt==="fit"){const nt=Math.ceil((Fe+At+Se)*It);Wt&&ot&&Ot<=Ie.stableFitRemainingWidth?(xe=!0,Je=Ie.stableFitMaxMinimapScale):xe=nt>qt}if(Tt==="fill"||xe){lt=!0;const nt=pt;It=Math.min(wt*Xe,Math.max(1,Math.floor(1/ne))),Wt&&ot&&Ot<=Ie.stableFitRemainingWidth&&(Je=Ie.stableFitMaxMinimapScale),pt=Math.min(Je,Math.max(1,Math.floor(It/Ht))),pt>nt&&(ft=Math.min(2,pt/nt)),kt=pt/Xe/ft,qt=Math.ceil(Math.max(Le,Fe+At+Se)*It),Wt?(Ie.stableMinimapLayoutInput=ue,Ie.stableFitRemainingWidth=Ot,Ie.stableFitMaxMinimapScale=pt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Dt=Math.floor(Ut*kt),Ft=Math.min(Dt,Math.max(0,Math.floor((Ot-Pt-2)*kt/(Et+kt)))+e.MINIMAP_GUTTER_WIDTH);let yt=Math.floor(Xe*Ft);const Ge=yt/Xe;yt=Math.floor(yt*ft);const Nt=Kt?1:2,jt=Bt==="left"?0:Ve-Ft-Pt;return{renderMinimap:Nt,minimapLeft:jt,minimapWidth:Ft,minimapHeightIsEditorHeight:lt,minimapIsSampling:Jt,minimapScale:pt,minimapLineHeight:It,minimapCanvasInnerWidth:yt,minimapCanvasInnerHeight:qt,minimapCanvasOuterWidth:Ge,minimapCanvasOuterHeight:ct}}static computeLayout(ue,Ie){const Ve=Ie.outerWidth|0,ze=Ie.outerHeight|0,Xe=Ie.lineHeight|0,rt=Ie.lineNumbersDigitCount|0,ot=Ie.typicalHalfwidthCharacterWidth,wt=Ie.maxDigitWidth,Et=Ie.pixelRatio,Yt=Ie.viewLineCount,Kt=ue.get(135),pt=Kt==="inherit"?ue.get(134):Kt,Ut=pt==="inherit"?ue.get(130):pt,Tt=ue.get(133),Bt=Ie.isDominatedByLongLines,Pt=ue.get(57),At=ue.get(67).renderType!==0,Ot=ue.get(68),Wt=ue.get(104),Ht=ue.get(83),qt=ue.get(72),ct=ue.get(102),lt=ct.verticalScrollbarSize,Jt=ct.verticalHasArrows,It=ct.arrowSize,kt=ct.horizontalScrollbarSize,ft=ue.get(43),Dt=ue.get(109)!=="never";let Ft=ue.get(65);ft&&Dt&&(Ft+=16);let yt=0;if(At){const gt=Math.max(rt,Ot);yt=Math.round(gt*wt)}let Ge=0;Pt&&(Ge=Xe*Ie.glyphMarginDecorationLaneCount);let Nt=0,jt=Nt+Ge,Le=jt+yt,Fe=Le+Ft;const Se=Ve-Ge-yt-Ft;let ne=!1,Te=!1,Ke=-1;pt==="inherit"&&Bt?(ne=!0,Te=!0):Ut==="on"||Ut==="bounded"?Te=!0:Ut==="wordWrapColumn"&&(Ke=Tt);const xe=Z.c({outerWidth:Ve,outerHeight:ze,lineHeight:Xe,typicalHalfwidthCharacterWidth:ot,pixelRatio:Et,scrollBeyondLastLine:Wt,paddingTop:Ht.top,paddingBottom:Ht.bottom,minimap:qt,verticalScrollbarWidth:lt,viewLineCount:Yt,remainingWidth:Se,isViewportWrapping:Te},Ie.memory||new R);xe.renderMinimap!==0&&xe.minimapLeft===0&&(Nt+=xe.minimapWidth,jt+=xe.minimapWidth,Le+=xe.minimapWidth,Fe+=xe.minimapWidth);const Je=Se-xe.minimapWidth,nt=Math.max(1,Math.floor((Je-lt-2)/ot)),mt=Jt?It:0;return Te&&(Ke=Math.max(1,nt),Ut==="bounded"&&(Ke=Math.min(Ke,Tt))),{width:Ve,height:ze,glyphMarginLeft:Nt,glyphMarginWidth:Ge,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:jt,lineNumbersWidth:yt,decorationsLeft:Le,decorationsWidth:Ft,contentLeft:Fe,contentWidth:Je,minimap:xe,viewportColumn:nt,isWordWrapMinified:ne,isViewportWrapping:Te,wrappingColumn:Ke,verticalScrollbarWidth:lt,horizontalScrollbarHeight:kt,overviewRuler:{top:mt,width:lt,height:ze-2*mt,right:0}}}}e.EditorLayoutInfoComputer=Z;class oe extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ue){return n(ue,"simple",["simple","advanced"])}compute(ue,Ie,Ve){return Ie.get(2)===2?"advanced":Ve}}class x extends I{constructor(){const ue={enabled:!0};super(64,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"boolean",default:ue.enabled,description:b.localize(50,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:l(ue.enabled,this.defaultValue.enabled)}}}class ae extends I{constructor(){const ue={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:b.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:10,description:b.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:b.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:b.localize(54,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:n(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:l(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ve extends I{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:b.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(56,null),b.localize(57,null,d.$k?"Ctrl+Option":"Ctrl+Alt"),b.localize(58,null,d.$k?"Ctrl+Option":"Ctrl+Alt"),b.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:b.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:b.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:b.localize(62,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:n(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:l(Ie.padding,this.defaultValue.padding)}}}class G extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):o.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ie,Ve){return Ve<0?o.clampedInt(-Ve*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class U extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>h.clamp(ue,0,150),{markdownDescription:b.localize(63,null)})}compute(ue,Ie,Ve){return ue.fontInfo.lineHeight}}class q extends I{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:b.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:b.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(66,null),b.localize(67,null),b.localize(68,null)],default:ue.size,description:b.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:b.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:b.localize(71,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:b.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:b.localize(74,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),autohide:l(Ie.autohide,this.defaultValue.autohide),size:n(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(Ie.side,this.defaultValue.side,["right","left"]),showSlider:n(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(Ie.scale,1,1,3),maxColumn:o.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function me(le){return le==="ctrlCmd"?d.$k?"metaKey":"ctrlKey":"altKey"}class _ extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(76,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{top:o.clampedInt(Ie.top,0,0,1e3),bottom:o.clampedInt(Ie.bottom,0,0,1e3)}}}class ie extends I{constructor(){const ue={enabled:!0,cycle:!0};super(85,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:b.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:b.localize(78,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),cycle:l(Ie.cycle,this.defaultValue.cycle)}}}class re extends D{constructor(){super(141)}compute(ue,Ie,Ve){return ue.pixelRatio}}class Ee extends I{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(79,null),b.localize(80,null),b.localize(81,null)]}];super(88,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ue.strings,description:b.localize(82,null)},comments:{anyOf:Ie,default:ue.comments,description:b.localize(83,null)},other:{anyOf:Ie,default:ue.other,description:b.localize(84,null)}},default:ue,markdownDescription:b.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const Et=ue?"on":"off";return{comments:Et,strings:Et,other:Et}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ie,comments:Ve,strings:ze}=ue,Xe=["on","inline","off"];let rt,ot,wt;return typeof Ie=="boolean"?rt=Ie?"on":"off":rt=n(Ie,this.defaultValue.other,Xe),typeof Ve=="boolean"?ot=Ve?"on":"off":ot=n(Ve,this.defaultValue.comments,Xe),typeof ze=="boolean"?wt=ze?"on":"off":wt=n(ze,this.defaultValue.strings,Xe),{other:rt,comments:ot,strings:wt}}}var ce;(function(le){le[le.Off=0]="Off",le[le.On=1]="On",le[le.Relative=2]="Relative",le[le.Interval=3]="Interval",le[le.Custom=4]="Custom"})(ce||(e.RenderLineNumbersType=ce={}));class de extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(86,null),b.localize(87,null),b.localize(88,null),b.localize(89,null)],default:"on",description:b.localize(90,null)})}validate(ue){let Ie=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ie=4,Ve=ue):ue==="interval"?Ie=3:ue==="relative"?Ie=2:ue==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ve}}}function ee(le){const ue=le.get(97);return ue==="editable"?le.get(90):ue!=="on"}e.filterValidationDecorations=ee;class he extends I{constructor(){const ue=[],Ie={type:"number",description:b.localize(91,null)};super(101,"rulers",ue,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(92,null),format:"color-hex"}}}]},default:ue,description:b.localize(93,null)})}validate(ue){if(Array.isArray(ue)){const Ie=[];for(const Ve of ue)if(typeof Ve=="number")Ie.push({column:o.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const ze=Ve;Ie.push({column:o.clampedInt(ze.column,0,0,1e4),color:ze.color})}return Ie.sort((Ve,ze)=>Ve.column-ze.column),Ie}return this.defaultValue}}class be extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Pe(le,ue){if(typeof le!="string")return ue;switch(le){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(94,null),b.localize(95,null),b.localize(96,null)],default:"auto",description:b.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(98,null),b.localize(99,null),b.localize(100,null)],default:"auto",description:b.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:b.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:b.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:b.localize(104,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue,Ve=o.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=o.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:l(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:o.clampedInt(Ie.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:o.clampedInt(Ie.verticalSliderSize,ze,0,1e3),scrollByPage:l(Ie.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends I{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:b.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:b.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:b.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:b.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:b.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:b.localize(111,null)}})}applyUpdate(ue,Ie){let Ve=!1;Ie.allowedCharacters&&ue&&(F.$7m(ue.allowedCharacters,Ie.allowedCharacters)||(ue={...ue,allowedCharacters:Ie.allowedCharacters},Ve=!0)),Ie.allowedLocales&&ue&&(F.$7m(ue.allowedLocales,Ie.allowedLocales)||(ue={...ue,allowedLocales:Ie.allowedLocales},Ve=!0));const ze=super.applyUpdate(ue,Ie);return Ve?new v(ze.newValue,!0):ze}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{nonBasicASCII:ge(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:l(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:l(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ie){if(typeof ue!="object"||!ue)return Ie;const Ve={};for(const[ze,Xe]of Object.entries(ue))Xe===!0&&(Ve[ze]=!0);return Ve}}class te extends I{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:b.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover"],enumDescriptions:[b.localize(113,null),b.localize(114,null)],description:b.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:b.localize(116,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),mode:n(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:l(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:l(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class se extends I{constructor(){const ue={enabled:M.$Zr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$Zr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:b.localize(118,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:l(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Y extends I{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(119,null),b.localize(120,null),b.localize(121,null)],default:ue.bracketPairs,description:b.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(123,null),b.localize(124,null),b.localize(125,null)],default:ue.bracketPairsHorizontal,description:b.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:b.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:b.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(129,null),b.localize(130,null),b.localize(131,null)],default:ue.highlightActiveIndentation,description:b.localize(132,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{bracketPairs:ge(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:l(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:l(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(le,ue,Ie){const Ve=Ie.indexOf(le);return Ve===-1?ue:Ie[Ve]}class ye extends I{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(133,null),b.localize(134,null)],default:ue.insertMode,description:b.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:b.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:b.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:b.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null),b.localize(142,null)],default:ue.selectionMode,markdownDescription:b.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:b.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:b.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:b.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:b.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:b.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertMode:n(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:l(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:l(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:l(Ie.preview,this.defaultValue.preview),previewMode:n(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(Ie.showMethods,this.defaultValue.showMethods),showFunctions:l(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:l(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:l(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:l(Ie.showFields,this.defaultValue.showFields),showVariables:l(Ie.showVariables,this.defaultValue.showVariables),showClasses:l(Ie.showClasses,this.defaultValue.showClasses),showStructs:l(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:l(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:l(Ie.showModules,this.defaultValue.showModules),showProperties:l(Ie.showProperties,this.defaultValue.showProperties),showEvents:l(Ie.showEvents,this.defaultValue.showEvents),showOperators:l(Ie.showOperators,this.defaultValue.showOperators),showUnits:l(Ie.showUnits,this.defaultValue.showUnits),showValues:l(Ie.showValues,this.defaultValue.showValues),showConstants:l(Ie.showConstants,this.defaultValue.showConstants),showEnums:l(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:l(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(Ie.showKeywords,this.defaultValue.showKeywords),showWords:l(Ie.showWords,this.defaultValue.showWords),showColors:l(Ie.showColors,this.defaultValue.showColors),showFiles:l(Ie.showFiles,this.defaultValue.showFiles),showReferences:l(Ie.showReferences,this.defaultValue.showReferences),showFolders:l(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:l(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:l(Ie.showUsers,this.defaultValue.showUsers),showIssues:l(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(182,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:l(ue.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(le){le[le.None=0]="None",le[le.Same=1]="Same",le[le.Indent=2]="Indent",le[le.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(183,null),b.localize(184,null),b.localize(185,null),b.localize(186,null)],description:b.localize(187,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ie,Ve){return Ie.get(2)===2?0:Ve}}class Ye extends D{constructor(){super(144)}compute(ue,Ie,Ve){const ze=Ie.get(143);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class it extends I{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(190,null),b.localize(191,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),showDropSelector:n(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends I{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(194,null),b.localize(195,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),showPasteSelector:n(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Oe="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:d.$k?Oe:d.$l?qe:Ae,fontWeight:"normal",fontSize:d.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(le){return e.editorOptionsRegistry[le.id]=le,le}var Ze;(function(le){le[le.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",le[le.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",le[le.accessibilitySupport=2]="accessibilitySupport",le[le.accessibilityPageSize=3]="accessibilityPageSize",le[le.ariaLabel=4]="ariaLabel",le[le.ariaRequired=5]="ariaRequired",le[le.autoClosingBrackets=6]="autoClosingBrackets",le[le.autoClosingComments=7]="autoClosingComments",le[le.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",le[le.autoClosingDelete=9]="autoClosingDelete",le[le.autoClosingOvertype=10]="autoClosingOvertype",le[le.autoClosingQuotes=11]="autoClosingQuotes",le[le.autoIndent=12]="autoIndent",le[le.automaticLayout=13]="automaticLayout",le[le.autoSurround=14]="autoSurround",le[le.bracketPairColorization=15]="bracketPairColorization",le[le.guides=16]="guides",le[le.codeLens=17]="codeLens",le[le.codeLensFontFamily=18]="codeLensFontFamily",le[le.codeLensFontSize=19]="codeLensFontSize",le[le.colorDecorators=20]="colorDecorators",le[le.colorDecoratorsLimit=21]="colorDecoratorsLimit",le[le.columnSelection=22]="columnSelection",le[le.comments=23]="comments",le[le.contextmenu=24]="contextmenu",le[le.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",le[le.cursorBlinking=26]="cursorBlinking",le[le.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",le[le.cursorStyle=28]="cursorStyle",le[le.cursorSurroundingLines=29]="cursorSurroundingLines",le[le.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",le[le.cursorWidth=31]="cursorWidth",le[le.disableLayerHinting=32]="disableLayerHinting",le[le.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",le[le.domReadOnly=34]="domReadOnly",le[le.dragAndDrop=35]="dragAndDrop",le[le.dropIntoEditor=36]="dropIntoEditor",le[le.emptySelectionClipboard=37]="emptySelectionClipboard",le[le.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",le[le.extraEditorClassName=39]="extraEditorClassName",le[le.fastScrollSensitivity=40]="fastScrollSensitivity",le[le.find=41]="find",le[le.fixedOverflowWidgets=42]="fixedOverflowWidgets",le[le.folding=43]="folding",le[le.foldingStrategy=44]="foldingStrategy",le[le.foldingHighlight=45]="foldingHighlight",le[le.foldingImportsByDefault=46]="foldingImportsByDefault",le[le.foldingMaximumRegions=47]="foldingMaximumRegions",le[le.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",le[le.fontFamily=49]="fontFamily",le[le.fontInfo=50]="fontInfo",le[le.fontLigatures=51]="fontLigatures",le[le.fontSize=52]="fontSize",le[le.fontWeight=53]="fontWeight",le[le.fontVariations=54]="fontVariations",le[le.formatOnPaste=55]="formatOnPaste",le[le.formatOnType=56]="formatOnType",le[le.glyphMargin=57]="glyphMargin",le[le.gotoLocation=58]="gotoLocation",le[le.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",le[le.hover=60]="hover",le[le.inDiffEditor=61]="inDiffEditor",le[le.inlineSuggest=62]="inlineSuggest",le[le.letterSpacing=63]="letterSpacing",le[le.lightbulb=64]="lightbulb",le[le.lineDecorationsWidth=65]="lineDecorationsWidth",le[le.lineHeight=66]="lineHeight",le[le.lineNumbers=67]="lineNumbers",le[le.lineNumbersMinChars=68]="lineNumbersMinChars",le[le.linkedEditing=69]="linkedEditing",le[le.links=70]="links",le[le.matchBrackets=71]="matchBrackets",le[le.minimap=72]="minimap",le[le.mouseStyle=73]="mouseStyle",le[le.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",le[le.mouseWheelZoom=75]="mouseWheelZoom",le[le.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",le[le.multiCursorModifier=77]="multiCursorModifier",le[le.multiCursorPaste=78]="multiCursorPaste",le[le.multiCursorLimit=79]="multiCursorLimit",le[le.occurrencesHighlight=80]="occurrencesHighlight",le[le.overviewRulerBorder=81]="overviewRulerBorder",le[le.overviewRulerLanes=82]="overviewRulerLanes",le[le.padding=83]="padding",le[le.pasteAs=84]="pasteAs",le[le.parameterHints=85]="parameterHints",le[le.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",le[le.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",le[le.quickSuggestions=88]="quickSuggestions",le[le.quickSuggestionsDelay=89]="quickSuggestionsDelay",le[le.readOnly=90]="readOnly",le[le.readOnlyMessage=91]="readOnlyMessage",le[le.renameOnType=92]="renameOnType",le[le.renderControlCharacters=93]="renderControlCharacters",le[le.renderFinalNewline=94]="renderFinalNewline",le[le.renderLineHighlight=95]="renderLineHighlight",le[le.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",le[le.renderValidationDecorations=97]="renderValidationDecorations",le[le.renderWhitespace=98]="renderWhitespace",le[le.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",le[le.roundedSelection=100]="roundedSelection",le[le.rulers=101]="rulers",le[le.scrollbar=102]="scrollbar",le[le.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",le[le.scrollBeyondLastLine=104]="scrollBeyondLastLine",le[le.scrollPredominantAxis=105]="scrollPredominantAxis",le[le.selectionClipboard=106]="selectionClipboard",le[le.selectionHighlight=107]="selectionHighlight",le[le.selectOnLineNumbers=108]="selectOnLineNumbers",le[le.showFoldingControls=109]="showFoldingControls",le[le.showUnused=110]="showUnused",le[le.snippetSuggestions=111]="snippetSuggestions",le[le.smartSelect=112]="smartSelect",le[le.smoothScrolling=113]="smoothScrolling",le[le.stickyScroll=114]="stickyScroll",le[le.stickyTabStops=115]="stickyTabStops",le[le.stopRenderingLineAfter=116]="stopRenderingLineAfter",le[le.suggest=117]="suggest",le[le.suggestFontSize=118]="suggestFontSize",le[le.suggestLineHeight=119]="suggestLineHeight",le[le.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",le[le.suggestSelection=121]="suggestSelection",le[le.tabCompletion=122]="tabCompletion",le[le.tabIndex=123]="tabIndex",le[le.unicodeHighlighting=124]="unicodeHighlighting",le[le.unusualLineTerminators=125]="unusualLineTerminators",le[le.useShadowDOM=126]="useShadowDOM",le[le.useTabStops=127]="useTabStops",le[le.wordBreak=128]="wordBreak",le[le.wordSeparators=129]="wordSeparators",le[le.wordWrap=130]="wordWrap",le[le.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",le[le.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",le[le.wordWrapColumn=133]="wordWrapColumn",le[le.wordWrapOverride1=134]="wordWrapOverride1",le[le.wordWrapOverride2=135]="wordWrapOverride2",le[le.wrappingIndent=136]="wrappingIndent",le[le.wrappingStrategy=137]="wrappingStrategy",le[le.showDeprecated=138]="showDeprecated",le[le.inlayHints=139]="inlayHints",le[le.editorClassName=140]="editorClassName",le[le.pixelRatio=141]="pixelRatio",le[le.tabFocusMode=142]="tabFocusMode",le[le.layoutInfo=143]="layoutInfo",le[le.wrappingInfo=144]="wrappingInfo",le[le.defaultColorDecorators=145]="defaultColorDecorators",le[le.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",le[le.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ze||(e.EditorOption=Ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(196,null)})),acceptSuggestionOnEnter:Me(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(197,null),""],markdownDescription:b.localize(198,null)})),accessibilitySupport:Me(new u),accessibilityPageSize:Me(new o(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(199,null),tags:["accessibility"]})),ariaLabel:Me(new t(4,"ariaLabel",b.localize(200,null))),ariaRequired:Me(new c(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Me(new c(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Me(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(202,null),b.localize(203,null),""],description:b.localize(204,null)})),autoClosingComments:Me(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(205,null),b.localize(206,null),""],description:b.localize(207,null)})),autoClosingDelete:Me(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(208,null),""],description:b.localize(209,null)})),autoClosingOvertype:Me(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(210,null),""],description:b.localize(211,null)})),autoClosingQuotes:Me(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(212,null),b.localize(213,null),""],description:b.localize(214,null)})),autoIndent:Me(new i(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[b.localize(215,null),b.localize(216,null),b.localize(217,null),b.localize(218,null),b.localize(219,null)],description:b.localize(220,null)})),automaticLayout:Me(new c(13,"automaticLayout",!1)),autoSurround:Me(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null),""],description:b.localize(224,null)})),bracketPairColorization:Me(new se),bracketPairGuides:Me(new Y),stickyTabStops:Me(new c(115,"stickyTabStops",!1,{description:b.localize(225,null)})),codeLens:Me(new c(17,"codeLens",!0,{description:b.localize(226,null)})),codeLensFontFamily:Me(new t(18,"codeLensFontFamily","",{description:b.localize(227,null)})),codeLensFontSize:Me(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(228,null)})),colorDecorators:Me(new c(20,"colorDecorators",!0,{description:b.localize(229,null)})),colorDecoratorActivatedOn:Me(new a(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(230,null),b.localize(231,null),b.localize(232,null)],description:b.localize(233,null)})),colorDecoratorsLimit:Me(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(234,null)})),columnSelection:Me(new c(22,"columnSelection",!1,{description:b.localize(235,null)})),comments:Me(new S),contextmenu:Me(new c(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new c(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(236,null)})),cursorBlinking:Me(new i(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:b.localize(237,null)})),cursorSmoothCaretAnimation:Me(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(238,null),b.localize(239,null),b.localize(240,null)],description:b.localize(241,null)})),cursorStyle:Me(new i(28,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(242,null)})),cursorSurroundingLines:Me(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(243,null)})),cursorSurroundingLinesStyle:Me(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(244,null),b.localize(245,null)],markdownDescription:b.localize(246,null)})),cursorWidth:Me(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(247,null)})),disableLayerHinting:Me(new c(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new c(33,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new c(34,"domReadOnly",!1)),dragAndDrop:Me(new c(35,"dragAndDrop",!0,{description:b.localize(248,null)})),emptySelectionClipboard:Me(new N),dropIntoEditor:Me(new it),stickyScroll:Me(new ae),experimentalWhitespaceRendering:Me(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(249,null),b.localize(250,null),b.localize(251,null)],description:b.localize(252,null)})),extraEditorClassName:Me(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Me(new h(40,"fastScrollSensitivity",5,le=>le<=0?5:le,{markdownDescription:b.localize(253,null)})),find:Me(new L),fixedOverflowWidgets:Me(new c(42,"fixedOverflowWidgets",!1)),folding:Me(new c(43,"folding",!0,{description:b.localize(254,null)})),foldingStrategy:Me(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(255,null),b.localize(256,null)],description:b.localize(257,null)})),foldingHighlight:Me(new c(45,"foldingHighlight",!0,{description:b.localize(258,null)})),foldingImportsByDefault:Me(new c(46,"foldingImportsByDefault",!1,{description:b.localize(259,null)})),foldingMaximumRegions:Me(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(260,null)})),unfoldOnClickAfterEndOfLine:Me(new c(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(261,null)})),fontFamily:Me(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(262,null)})),fontInfo:Me(new T),fontLigatures2:Me(new j),fontSize:Me(new K),fontWeight:Me(new V),fontVariations:Me(new z),formatOnPaste:Me(new c(55,"formatOnPaste",!1,{description:b.localize(263,null)})),formatOnType:Me(new c(56,"formatOnType",!1,{description:b.localize(264,null)})),glyphMargin:Me(new c(57,"glyphMargin",!0,{description:b.localize(265,null)})),gotoLocation:Me(new fe),hideCursorInOverviewRuler:Me(new c(59,"hideCursorInOverviewRuler",!1,{description:b.localize(266,null)})),hover:Me(new X),inDiffEditor:Me(new c(61,"inDiffEditor",!1)),letterSpacing:Me(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,le=>h.clamp(le,-5,20),{description:b.localize(267,null)})),lightbulb:Me(new x),lineDecorationsWidth:Me(new G),lineHeight:Me(new U),lineNumbers:Me(new de),lineNumbersMinChars:Me(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new c(69,"linkedEditing",!1,{description:b.localize(268,null)})),links:Me(new c(70,"links",!0,{description:b.localize(269,null)})),matchBrackets:Me(new a(71,"matchBrackets","always",["always","near","never"],{description:b.localize(270,null)})),minimap:Me(new q),mouseStyle:Me(new a(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new h(74,"mouseWheelScrollSensitivity",1,le=>le===0?1:le,{markdownDescription:b.localize(271,null)})),mouseWheelZoom:Me(new c(75,"mouseWheelZoom",!1,{markdownDescription:b.localize(272,null)})),multiCursorMergeOverlapping:Me(new c(76,"multiCursorMergeOverlapping",!0,{description:b.localize(273,null)})),multiCursorModifier:Me(new i(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],me,{markdownEnumDescriptions:[b.localize(274,null),b.localize(275,null)],markdownDescription:b.localize(276,null)})),multiCursorPaste:Me(new a(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(277,null),b.localize(278,null)],markdownDescription:b.localize(279,null)})),multiCursorLimit:Me(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(280,null)})),occurrencesHighlight:Me(new c(80,"occurrencesHighlight",!0,{description:b.localize(281,null)})),overviewRulerBorder:Me(new c(81,"overviewRulerBorder",!0,{description:b.localize(282,null)})),overviewRulerLanes:Me(new o(82,"overviewRulerLanes",3,0,3)),padding:Me(new _),pasteAs:Me(new et),parameterHints:Me(new ie),peekWidgetDefaultFocus:Me(new a(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(283,null),b.localize(284,null)],description:b.localize(285,null)})),definitionLinkOpensInPeek:Me(new c(87,"definitionLinkOpensInPeek",!1,{description:b.localize(286,null)})),quickSuggestions:Me(new Ee),quickSuggestionsDelay:Me(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(287,null)})),readOnly:Me(new c(90,"readOnly",!1)),readOnlyMessage:Me(new be),renameOnType:Me(new c(92,"renameOnType",!1,{description:b.localize(288,null),markdownDeprecationMessage:b.localize(289,null)})),renderControlCharacters:Me(new c(93,"renderControlCharacters",!0,{description:b.localize(290,null),restricted:!0})),renderFinalNewline:Me(new a(94,"renderFinalNewline",d.$l?"dimmed":"on",["off","on","dimmed"],{description:b.localize(291,null)})),renderLineHighlight:Me(new a(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(292,null)],description:b.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Me(new c(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(294,null)})),renderValidationDecorations:Me(new a(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new a(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(295,null),b.localize(296,null),b.localize(297,null),""],description:b.localize(298,null)})),revealHorizontalRightPadding:Me(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new c(100,"roundedSelection",!0,{description:b.localize(299,null)})),rulers:Me(new he),scrollbar:Me(new B),scrollBeyondLastColumn:Me(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(300,null)})),scrollBeyondLastLine:Me(new c(104,"scrollBeyondLastLine",!0,{description:b.localize(301,null)})),scrollPredominantAxis:Me(new c(105,"scrollPredominantAxis",!0,{description:b.localize(302,null)})),selectionClipboard:Me(new c(106,"selectionClipboard",!0,{description:b.localize(303,null),included:d.$l})),selectionHighlight:Me(new c(107,"selectionHighlight",!0,{description:b.localize(304,null)})),selectOnLineNumbers:Me(new c(108,"selectOnLineNumbers",!0)),showFoldingControls:Me(new a(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(305,null),b.localize(306,null),b.localize(307,null)],description:b.localize(308,null)})),showUnused:Me(new c(110,"showUnused",!0,{description:b.localize(309,null)})),showDeprecated:Me(new c(138,"showDeprecated",!0,{description:b.localize(310,null)})),inlayHints:Me(new ve),snippetSuggestions:Me(new a(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(311,null),b.localize(312,null),b.localize(313,null),b.localize(314,null)],description:b.localize(315,null)})),smartSelect:Me(new je),smoothScrolling:Me(new c(113,"smoothScrolling",!1,{description:b.localize(316,null)})),stopRenderingLineAfter:Me(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new ye),inlineSuggest:Me(new te),inlineCompletionsAccessibilityVerbose:Me(new c(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(317,null)})),suggestFontSize:Me(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new c(120,"suggestOnTriggerCharacters",!0,{description:b.localize(320,null)})),suggestSelection:Me(new a(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(321,null),b.localize(322,null),b.localize(323,null)],description:b.localize(324,null)})),tabCompletion:Me(new a(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(325,null),b.localize(326,null),b.localize(327,null)],description:b.localize(328,null)})),tabIndex:Me(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new J),unusualLineTerminators:Me(new a(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(329,null),b.localize(330,null),b.localize(331,null)],description:b.localize(332,null)})),useShadowDOM:Me(new c(126,"useShadowDOM",!0)),useTabStops:Me(new c(127,"useTabStops",!0,{description:b.localize(333,null)})),wordBreak:Me(new a(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(334,null),b.localize(335,null)],description:b.localize(336,null)})),wordSeparators:Me(new t(129,"wordSeparators",A.$1r,{description:b.localize(337,null)})),wordWrap:Me(new a(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(338,null),b.localize(339,null),b.localize(340,null),b.localize(341,null)],description:b.localize(342,null)})),wordWrapBreakAfterCharacters:Me(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(343,null)})),wordWrapOverride1:Me(new a(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new a(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new O),defaultColorDecorators:Me(new c(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(344,null)})),pixelRatio:Me(new re),tabFocusMode:Me(new c(142,"tabFocusMode",!1,{markdownDescription:b.localize(345,null)})),layoutInfo:Me(new Z),wrappingInfo:Me(new Ye),wrappingIndent:Me(new _e),wrappingStrategy:Me(new oe)}}),define(De[187],Ce([10,11]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(De[82],Ce([1,0,78,2,164,34,174,187]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$gt=e.$ft=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$et=e.$dt=e.SymbolKinds=e.SymbolTag=e.$ct=e.$bt=e.SymbolKind=e.$at=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$_s=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$$s=e.$0s=e.$9s=void 0;class E{constructor(j,z,T){this.offset=j,this.type=z,this.language=T,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$9s=E;class w{constructor(j,z){this.tokens=j,this.endState=z,this._tokenizationResultBrand=void 0}}e.$0s=w;class R{constructor(j,z){this.tokens=j,this.endState=z,this._encodedTokenizationResultBrand=void 0}}e.$$s=R;var I;(function(L){L[L.Method=0]="Method",L[L.Function=1]="Function",L[L.Constructor=2]="Constructor",L[L.Field=3]="Field",L[L.Variable=4]="Variable",L[L.Class=5]="Class",L[L.Struct=6]="Struct",L[L.Interface=7]="Interface",L[L.Module=8]="Module",L[L.Property=9]="Property",L[L.Event=10]="Event",L[L.Operator=11]="Operator",L[L.Unit=12]="Unit",L[L.Value=13]="Value",L[L.Constant=14]="Constant",L[L.Enum=15]="Enum",L[L.EnumMember=16]="EnumMember",L[L.Keyword=17]="Keyword",L[L.Text=18]="Text",L[L.Color=19]="Color",L[L.File=20]="File",L[L.Reference=21]="Reference",L[L.Customcolor=22]="Customcolor",L[L.Folder=23]="Folder",L[L.TypeParameter=24]="TypeParameter",L[L.User=25]="User",L[L.Issue=26]="Issue",L[L.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var v;(function(L){const j=new Map;j.set(0,C.$Sj.symbolMethod),j.set(1,C.$Sj.symbolFunction),j.set(2,C.$Sj.symbolConstructor),j.set(3,C.$Sj.symbolField),j.set(4,C.$Sj.symbolVariable),j.set(5,C.$Sj.symbolClass),j.set(6,C.$Sj.symbolStruct),j.set(7,C.$Sj.symbolInterface),j.set(8,C.$Sj.symbolModule),j.set(9,C.$Sj.symbolProperty),j.set(10,C.$Sj.symbolEvent),j.set(11,C.$Sj.symbolOperator),j.set(12,C.$Sj.symbolUnit),j.set(13,C.$Sj.symbolValue),j.set(15,C.$Sj.symbolEnum),j.set(14,C.$Sj.symbolConstant),j.set(15,C.$Sj.symbolEnum),j.set(16,C.$Sj.symbolEnumMember),j.set(17,C.$Sj.symbolKeyword),j.set(27,C.$Sj.symbolSnippet),j.set(18,C.$Sj.symbolText),j.set(19,C.$Sj.symbolColor),j.set(20,C.$Sj.symbolFile),j.set(21,C.$Sj.symbolReference),j.set(22,C.$Sj.symbolCustomColor),j.set(23,C.$Sj.symbolFolder),j.set(24,C.$Sj.symbolTypeParameter),j.set(25,C.$Sj.account),j.set(26,C.$Sj.issues);function z(V){let fe=j.get(V);return fe||(console.info("No codicon found for CompletionItemKind "+V),fe=C.$Sj.symbolProperty),fe}L.toIcon=z;const T=new Map;T.set("method",0),T.set("function",1),T.set("constructor",2),T.set("field",3),T.set("variable",4),T.set("class",5),T.set("struct",6),T.set("interface",7),T.set("module",8),T.set("property",9),T.set("event",10),T.set("operator",11),T.set("unit",12),T.set("value",13),T.set("constant",14),T.set("enum",15),T.set("enum-member",16),T.set("enumMember",16),T.set("keyword",17),T.set("snippet",27),T.set("text",18),T.set("color",19),T.set("file",20),T.set("reference",21),T.set("customcolor",22),T.set("folder",23),T.set("type-parameter",24),T.set("typeParameter",24),T.set("account",25),T.set("issue",26);function K(V,fe){let X=T.get(V);return typeof X>"u"&&!fe&&(X=9),X}L.fromString=K})(v||(e.CompletionItemKinds=v={}));var y;(function(L){L[L.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var D;(function(L){L[L.None=0]="None",L[L.KeepWhitespace=1]="KeepWhitespace",L[L.InsertAsSnippet=4]="InsertAsSnippet"})(D||(e.CompletionItemInsertTextRule=D={}));var p;(function(L){L[L.Invoke=0]="Invoke",L[L.TriggerCharacter=1]="TriggerCharacter",L[L.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var l;(function(L){L[L.Automatic=0]="Automatic",L[L.Explicit=1]="Explicit"})(l||(e.InlineCompletionTriggerKind=l={}));class c{constructor(j,z,T,K){this.range=j,this.text=z,this.completionKind=T,this.isSnippetText=K}equals(j){return M.$ps.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$_s=c;var r;(function(L){L[L.Invoke=1]="Invoke",L[L.Auto=2]="Auto"})(r||(e.CodeActionTriggerType=r={}));var o;(function(L){L[L.Invoke=1]="Invoke",L[L.TriggerCharacter=2]="TriggerCharacter",L[L.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var m;(function(L){L[L.Text=0]="Text",L[L.Read=1]="Read",L[L.Write=2]="Write"})(m||(e.DocumentHighlightKind=m={}));function h(L){return L&&F.URI.isUri(L.uri)&&M.$ps.isIRange(L.range)&&(M.$ps.isIRange(L.originSelectionRange)||M.$ps.isIRange(L.targetSelectionRange))}e.$at=h;var t;(function(L){L[L.File=0]="File",L[L.Module=1]="Module",L[L.Namespace=2]="Namespace",L[L.Package=3]="Package",L[L.Class=4]="Class",L[L.Method=5]="Method",L[L.Property=6]="Property",L[L.Field=7]="Field",L[L.Constructor=8]="Constructor",L[L.Enum=9]="Enum",L[L.Interface=10]="Interface",L[L.Function=11]="Function",L[L.Variable=12]="Variable",L[L.Constant=13]="Constant",L[L.String=14]="String",L[L.Number=15]="Number",L[L.Boolean=16]="Boolean",L[L.Array=17]="Array",L[L.Object=18]="Object",L[L.Key=19]="Key",L[L.Null=20]="Null",L[L.EnumMember=21]="EnumMember",L[L.Struct=22]="Struct",L[L.Event=23]="Event",L[L.Operator=24]="Operator",L[L.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$bt={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function n(L,j){return(0,b.localize)(26,null,L,e.$bt[j])}e.$ct=n;var a;(function(L){L[L.Deprecated=1]="Deprecated"})(a||(e.SymbolTag=a={}));var i;(function(L){const j=new Map;j.set(0,C.$Sj.symbolFile),j.set(1,C.$Sj.symbolModule),j.set(2,C.$Sj.symbolNamespace),j.set(3,C.$Sj.symbolPackage),j.set(4,C.$Sj.symbolClass),j.set(5,C.$Sj.symbolMethod),j.set(6,C.$Sj.symbolProperty),j.set(7,C.$Sj.symbolField),j.set(8,C.$Sj.symbolConstructor),j.set(9,C.$Sj.symbolEnum),j.set(10,C.$Sj.symbolInterface),j.set(11,C.$Sj.symbolFunction),j.set(12,C.$Sj.symbolVariable),j.set(13,C.$Sj.symbolConstant),j.set(14,C.$Sj.symbolString),j.set(15,C.$Sj.symbolNumber),j.set(16,C.$Sj.symbolBoolean),j.set(17,C.$Sj.symbolArray),j.set(18,C.$Sj.symbolObject),j.set(19,C.$Sj.symbolKey),j.set(20,C.$Sj.symbolNull),j.set(21,C.$Sj.symbolEnumMember),j.set(22,C.$Sj.symbolStruct),j.set(23,C.$Sj.symbolEvent),j.set(24,C.$Sj.symbolOperator),j.set(25,C.$Sj.symbolTypeParameter);function z(T){let K=j.get(T);return K||(console.info("No codicon found for SymbolKind "+T),K=C.$Sj.symbolProperty),K}L.toIcon=z})(i||(e.SymbolKinds=i={}));class s{static asEditOperation(j){return d.$qs.replace(M.$ps.lift(j.range),j.text)}}e.$dt=s;class u{static{this.Comment=new u("comment")}static{this.Imports=new u("imports")}static{this.Region=new u("region")}static fromValue(j){switch(j){case"comment":return u.Comment;case"imports":return u.Imports;case"region":return u.Region}return new u(j)}constructor(j){this.value=j}}e.$et=u;var S;(function(L){function j(z){return!z||typeof z!="object"?!1:typeof z.id=="string"&&typeof z.title=="string"}L.is=j})(S||(e.Command=S={}));var k;(function(L){L[L.Collapsed=0]="Collapsed",L[L.Expanded=1]="Expanded"})(k||(e.CommentThreadCollapsibleState=k={}));var $;(function(L){L[L.Unresolved=0]="Unresolved",L[L.Resolved=1]="Resolved"})($||(e.CommentThreadState=$={}));var f;(function(L){L[L.Editing=0]="Editing",L[L.Preview=1]="Preview"})(f||(e.CommentMode=f={}));var g;(function(L){L[L.Published=0]="Published",L[L.Draft=1]="Draft"})(g||(e.CommentState=g={}));var P;(function(L){L[L.Type=1]="Type",L[L.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class O{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$ft=O,e.$gt=new A.$1s;var N;(function(L){L[L.None=0]="None",L[L.Option=1]="Option",L[L.Default=2]="Default",L[L.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}))}),define(De[188],Ce([10,11]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[189],Ce([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(De[190],Ce([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(De[191],Ce([10,11]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(De[192],Ce([10,11]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[193],Ce([10,11]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[194],Ce([10,11]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[195],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(De[196],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(De[197],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[198],Ce([10,11]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(De[199],Ce([10,11]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(De[200],Ce([10,11]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[201],Ce([10,11]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(De[202],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(De[203],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[204],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[205],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[206],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(De[207],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[208],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(De[209],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[210],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[211],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[212],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[213],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[214],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[215],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[216],Ce([10,11]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(De[217],Ce([10,11]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(De[218],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[219],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[220],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[221],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[222],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[223],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[224],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[225],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(De[226],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[227],Ce([1,0,8,190]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var d;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(d||(e.TokenType=d={}));function M(...w){switch(w.length){case 1:return(0,F.localize)(0,null,w[0]);case 2:return(0,F.localize)(1,null,w[0],w[1]);case 3:return(0,F.localize)(2,null,w[0],w[1],w[2]);default:return}}const A=(0,F.localize)(3,null),b=(0,F.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,C.$7)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const I=this.d,v=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:v};this.g.push({offset:I,lexeme:v,additionalInfo:R}),this.f.push(y)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const I=this.c.substring(this.d,this.e),v=E.b.get(I);v?this.k(v):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,I=!1,v=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(b);return}const D=this.c.charCodeAt(R);if(I)I=!1;else if(D===47&&!v){R++;break}else D===91?v=!0:D===92?I=!0:D===93&&(v=!1);R++}for(;R<this.c.length&&E.a.has(this.c.charCodeAt(R));)R++;this.e=R;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=E}),define(De[228],Ce([1,0,23,38,193,371]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function E(c){return c=c.trim(),c==="*"||A.test(c)}e.$Io=E;function w(c){if(!E(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=c.match(A);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$Jo=w;function R(c){if(!c)return null;const r=c.majorBase,o=c.majorMustEqual,m=c.minorBase;let h=c.minorMustEqual;const t=c.patchBase;let n=c.patchMustEqual;c.hasCaret&&(r===0||(h=!1),n=!1);let a=0;if(c.preRelease){const i=b.exec(c.preRelease);if(i){const[,s,u,S]=i;a=Date.UTC(Number(s),Number(u)-1,Number(S))}}return{majorBase:r,majorMustEqual:o,minorBase:m,minorMustEqual:h,patchBase:t,patchMustEqual:n,isMinimum:c.hasGreaterEquals,notBefore:a}}e.$Ko=R;function I(c,r,o){let m;typeof c=="string"?m=R(w(c)):m=c;let h;r instanceof Date?h=r.getTime():typeof r=="string"&&(h=new Date(r).getTime());let t;if(typeof o=="string"?t=R(w(o)):t=o,!m||!t)return!1;const n=m.majorBase,a=m.minorBase,i=m.patchBase;let s=t.majorBase,u=t.minorBase,S=t.patchBase;const k=t.notBefore;let $=t.majorMustEqual,f=t.minorMustEqual,g=t.patchMustEqual;return t.isMinimum?n>s?!0:n<s?!1:a>u?!0:a<u||h&&h<k?!1:i>=S:(n===1&&s===0&&(!$||!f||!g)&&(s=1,u=0,S=0,$=!0,f=!1,g=!1),n<s?!1:n>s?!$:a<u?!1:a>u?!f:i<S?!1:i>S?!g:!(h&&h<k))}e.$Lo=I;function v(c,r,o,m,h){const t=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return t.push([F.default.Error,d.localize(0,null)]),t;if(typeof m.name!="string")return t.push([F.default.Error,d.localize(1,null,"name")]),t;if(typeof m.version!="string")return t.push([F.default.Error,d.localize(2,null,"version")]),t;if(!m.engines)return t.push([F.default.Error,d.localize(3,null,"engines")]),t;if(typeof m.engines.vscode!="string")return t.push([F.default.Error,d.localize(4,null,"engines.vscode")]),t;if(typeof m.extensionDependencies<"u"&&!l(m.extensionDependencies))return t.push([F.default.Error,d.localize(5,null,"extensionDependencies")]),t;if(typeof m.activationEvents<"u"){if(!l(m.activationEvents))return t.push([F.default.Error,d.localize(6,null,"activationEvents")]),t;if(typeof m.main>"u"&&typeof m.browser>"u")return t.push([F.default.Error,d.localize(7,null,"activationEvents","main","browser")]),t}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&t.push([F.default.Warning,d.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return t.push([F.default.Error,d.localize(9,null,"main")]),t;{const i=(0,C.$ug)(o,m.main);(0,C.$og)(i,o)||t.push([F.default.Warning,d.localize(10,null,i.path,o.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return t.push([F.default.Error,d.localize(11,null,"browser")]),t;{const i=(0,C.$ug)(o,m.browser);(0,C.$og)(i,o)||t.push([F.default.Warning,d.localize(12,null,i.path,o.path)])}}if(!M.valid(m.version))return t.push([F.default.Error,d.localize(13,null)]),t;const n=[];if(!y(c,r,m,h,n))for(const i of n)t.push([F.default.Error,i]);return t}e.$Mo=v;function y(c,r,o,m,h){return m||typeof o.main>"u"&&typeof o.browser>"u"?!0:p(c,r,o.engines.vscode,h)}e.$No=y;function D(c,r,o){return c==="*"||p(r,o,c)}e.$Oo=D;function p(c,r,o,m=[]){const h=R(w(o));if(!h)return m.push(d.localize(14,null,o)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return m.push(d.localize(15,null,o)),!1}else if(!h.majorMustEqual)return m.push(d.localize(16,null,o)),!1;return I(c,r,h)?!0:(m.push(d.localize(17,null,c,o)),!1)}function l(c){if(!Array.isArray(c))return!1;for(let r=0,o=c.length;r<o;r++)if(typeof c[r]!="string")return!1;return!0}}),define(De[102],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class C{constructor(d,M=[],A=!1){this.ctor=d,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$Kh=C}),define(De[103],Ce([1,0,102]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.InstantiationType=void 0;const F=[];var d;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(d||(e.InstantiationType=d={}));function M(b,E,w){E instanceof C.$Kh||(E=new C.$Kh(E,[],!!w)),F.push([b,E])}e.$tr=M;function A(){return F}e.$ur=A}),define(De[229],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=void 0;class C{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$$p=C;class F{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const b=this.lookupOrInsertNode(M),E=this.lookupOrInsertNode(A);b.outgoing.set(E.key,E),E.incoming.set(b.key,b)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const b of this.a.values())b.outgoing.delete(A),b.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let b=this.a.get(A);return b||(b=new C(A,M),this.a.set(A,b)),b}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,b]of this.a)M.push(`${A}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const b=new Set([M]),E=this.c(A,b);if(E)return E}}c(M,A){for(const[b,E]of M.outgoing){if(A.has(b))return[...A,b].join(" -> ");A.add(b);const w=this.c(E,A);if(w)return w;A.delete(b)}}}e.$_p=F}),define(De[5],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e._util=void 0;var C;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function b(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=b})(C||(e._util=C={})),e.$Mh=d("instantiationService");function F(A,b,E){b[C.DI_TARGET]===b?b[C.DI_DEPENDENCIES].push({id:A,index:E}):(b[C.DI_DEPENDENCIES]=[{id:A,index:E}],b[C.DI_TARGET]=b)}function d(A){if(C.serviceIds.has(A))return C.serviceIds.get(A);const b=function(E,w,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(b,E,R)};return b.toString=()=>A,C.serviceIds.set(A,b),b}e.$Nh=d;function M(A){return A}e.$Oh=M}),define(De[50],Ce([1,0,18,2,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,d.$Nh)("configurationService");function M(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof F.URI)}e.$ii=M;function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof F.URI)}e.$ji=A;var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function E(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=E;function w(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$li=w;function R(c,r){const o=Object.create(null);for(const m in c)I(o,m,c[m],r);return o}e.$mi=R;function I(c,r,o,m){const h=r.split("."),t=h.pop();let n=c;for(let a=0;a<h.length;a++){const i=h[a];let s=n[i];switch(typeof s){case"undefined":s=n[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${r} as ${h.slice(0,a+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[t]=o}catch{m(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(n)}`)}else m(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(n)}`)}e.$ni=I;function v(c,r){const o=r.split(".");y(c,o)}e.$oi=v;function y(c,r){const o=r.shift();if(r.length===0){delete c[o];return}if(Object.keys(c).indexOf(o)!==-1){const m=c[o];typeof m=="object"&&!Array.isArray(m)&&(y(m,r),Object.keys(m).length===0&&delete c[o])}}function D(c,r,o){function m(n,a){let i=n;for(const s of a){if(typeof i!="object"||i===null)return;i=i[s]}return i}const h=r.split("."),t=m(c,h);return typeof t>"u"?o:t}e.$pi=D;function p(c,r,o){Object.keys(r).forEach(m=>{m!=="__proto__"&&(m in c?C.$zf(c[m])&&C.$zf(r[m])?p(c[m],r[m],o):o&&(c[m]=r[m]):c[m]=r[m])})}e.$qi=p;function l(c){return c.replace(/[\[\]]/g,"")}e.$ri=l}),define(De[41],Ce([1,0,12,15,227,5,189,8]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",C.$k),E.set("isLinux",C.$l),E.set("isWindows",C.$j),E.set("isWeb",C.$p),E.set("isMacNative",C.$k&&!C.$p),E.set("isEdge",C.$H),E.set("isFirefox",C.$F),E.set("isChrome",C.$E),E.set("isSafari",C.$G);function w(G,U){if(E.get(G)!==void 0)throw(0,b.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(G,U)}e.$Ji=w;const R=Object.prototype.hasOwnProperty;var I;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const v={regexParsingWithErrorRecovery:!0},y=(0,A.localize)(0,null),D=(0,A.localize)(1,null),p=(0,A.localize)(2,null),l=(0,A.localize)(3,null),c=(0,A.localize)(4,null),r=(0,A.localize)(5,null),o=(0,A.localize)(6,null),m=(0,A.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=v){this.k=U,this.d=new d.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:D});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const me=this.D(),_=me.type===17?r:void 0;throw this.h.push({message:c,offset:me.offset,lexeme:d.$Ii.getLexeme(me),additionalInfo:_}),h.c}return q}catch(q){if(q!==h.c)throw q;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const q=this.o();U.push(q)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const q=this.s();U.push(q)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,l),q?.negate()}case 17:return this.z(),P.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const q=this.l();return this.A(1,l),q}case 17:{const q=U.lexeme;if(this.z(),this.y(9)){const _=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),_.type!==10)throw this.B("REGEX",_);const ie=_.lexeme,re=ie.lastIndexOf("/"),Ee=re===ie.length-1?void 0:this.w(ie.substring(re+1));let ce;try{ce=new RegExp(ie.substring(1,re),Ee)}catch{throw this.B("REGEX",_)}return T.create(q,ce)}switch(_.type){case 10:case 19:{const ie=[_.lexeme];this.z();let re=this.D(),Ee=0;for(let be=0;be<_.lexeme.length;be++)_.lexeme.charCodeAt(be)===40?Ee++:_.lexeme.charCodeAt(be)===41&&Ee--;for(;!this.E()&&re.type!==15&&re.type!==16;){switch(re.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let be=0;be<re.lexeme.length;be++)re.lexeme.charCodeAt(be)===40?Ee++:_.lexeme.charCodeAt(be)===41&&Ee--}if(Ee<0)break;ie.push(d.$Ii.getLexeme(re)),this.z(),re=this.D()}const ce=ie.join(""),de=ce.lastIndexOf("/"),ee=de===ce.length-1?void 0:this.w(ce.substring(de+1));let he;try{he=new RegExp(ce.substring(1,de),ee)}catch{throw this.B("REGEX",_)}return t.regex(q,he)}case 18:{const ie=_.lexeme;this.z();let re=null;if(!(0,F.$Ae)(ie)){const Ee=ie.indexOf("/"),ce=ie.lastIndexOf("/");if(Ee!==ce&&Ee>=0){const de=ie.slice(Ee+1,ce),ee=ie[ce+1]==="i"?"i":"";try{re=new RegExp(de,ee)}catch{throw this.B("REGEX",_)}}}if(re===null)throw this.B("REGEX",_);return T.create(q,re)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const _=this.u();return t.notIn(q,_)}switch(this.D().type){case 3:{this.z();const _=this.u();if(this.x().type===18)return t.equals(q,_);switch(_){case"true":return t.has(q);case"false":return t.not(q);default:return t.equals(q,_)}}case 4:{this.z();const _=this.u();if(this.x().type===18)return t.notEquals(q,_);switch(_){case"true":return t.not(q);case"false":return t.has(q);default:return t.notEquals(q,_)}}case 5:return this.z(),j.create(q,this.u());case 6:return this.z(),z.create(q,this.u());case 7:return this.z(),N.create(q,this.u());case 8:return this.z(),L.create(q,this.u());case 13:return this.z(),t.in(q,this.u());default:return t.has(q)}}case 20:throw this.h.push({message:o,offset:U.offset,lexeme:"",additionalInfo:m}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,q){if(this.C(U))return this.z();throw this.B(q,this.D())}B(U,q,me){const _=(0,A.localize)(8,null,U,d.$Ii.getLexeme(q)),ie=q.offset,re=d.$Ii.getLexeme(q);return this.h.push({message:_,offset:ie,lexeme:re,additionalInfo:me}),h.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=h;class t{static false(){return s.INSTANCE}static true(){return u.INSTANCE}static has(U){return S.create(U)}static equals(U,q){return k.create(U,q)}static notEquals(U,q){return g.create(U,q)}static regex(U,q){return T.create(U,q)}static in(U,q){return $.create(U,q)}static notIn(U,q){return f.create(U,q)}static not(U){return P.create(U)}static and(...U){return fe.create(U,null,!0)}static or(...U){return X.create(U,null,!0)}static greater(U,q){return N.create(U,q)}static greaterEquals(U,q){return L.create(U,q)}static smaller(U,q){return j.create(U,q)}static smallerEquals(U,q){return z.create(U,q)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Li=t;function n(G){const U=new h({regexParsingWithErrorRecovery:!1});return G.map(q=>(U.parse(q),U.lexingErrors.length>0?U.lexingErrors.map(me=>({errorMessage:me.additionalInfo?(0,A.localize)(9,null,me.additionalInfo):(0,A.localize)(10,null),offset:me.offset,length:me.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(me=>({errorMessage:me.additionalInfo?`${me.message}. ${me.additionalInfo}`:me.message,offset:me.offset,length:me.lexeme.length})):[]))}e.$Mi=n;function a(G,U){const q=G?G.substituteConstants():void 0,me=U?U.substituteConstants():void 0;return!q&&!me?!0:!q||!me?!1:q.equals(me)}e.$Ni=a;function i(G,U){return G.cmp(U)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return u.INSTANCE}}e.$Oi=s;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return s.INSTANCE}}e.$Pi=u;class S{static create(U,q=null){const me=E.get(U);return typeof me=="boolean"?me?u.INSTANCE:s.INSTANCE:new S(U,q)}constructor(U,q){this.key=U,this.c=q,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=E.get(this.key);return typeof U=="boolean"?U?u.INSTANCE:s.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Qi=S;class k{static create(U,q,me=null){if(typeof q=="boolean")return q?S.create(U,me):P.create(U,me);const _=E.get(U);return typeof _=="boolean"?q===(_?"true":"false")?u.INSTANCE:s.INSTANCE:new k(U,q,me)}constructor(U,q,me){this.c=U,this.d=q,this.f=me,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const q=U?"true":"false";return this.d===q?u.INSTANCE:s.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.$Ri=k;class ${static create(U,q){return new $(U,q)}constructor(U,q){this.d=U,this.f=q,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const q=U.getValue(this.f),me=U.getValue(this.d);return Array.isArray(q)?q.includes(me):typeof me=="string"&&typeof q=="object"&&q!==null?R.call(q,me):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Si=$;class f{static create(U,q){return new f(U,q)}constructor(U,q){this.d=U,this.f=q,this.type=11,this.c=$.create(U,q)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=f;class g{static create(U,q,me=null){if(typeof q=="boolean")return q?P.create(U,me):S.create(U,me);const _=E.get(U);return typeof _=="boolean"?q===(_?"true":"false")?s.INSTANCE:u.INSTANCE:new g(U,q,me)}constructor(U,q,me){this.c=U,this.d=q,this.f=me,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const q=U?"true":"false";return this.d===q?s.INSTANCE:u.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Ui=g;class P{static create(U,q=null){const me=E.get(U);return typeof me=="boolean"?me?s.INSTANCE:u.INSTANCE:new P(U,q)}constructor(U,q){this.c=U,this.d=q,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=E.get(this.c);return typeof U=="boolean"?U?s.INSTANCE:u.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$Vi=P;function O(G,U){if(typeof G=="string"){const q=parseFloat(G);isNaN(q)||(G=q)}return typeof G=="string"||typeof G=="number"?U(G):s.INSTANCE}class N{static create(U,q,me=null){return O(q,_=>new N(U,_,me))}constructor(U,q,me){this.c=U,this.d=q,this.f=me,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Wi=N;class L{static create(U,q,me=null){return O(q,_=>new L(U,_,me))}constructor(U,q,me){this.c=U,this.d=q,this.f=me,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Xi=L;class j{static create(U,q,me=null){return O(q,_=>new j(U,_,me))}constructor(U,q,me){this.c=U,this.d=q,this.f=me,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Yi=j;class z{static create(U,q,me=null){return O(q,_=>new z(U,_,me))}constructor(U,q,me){this.c=U,this.d=q,this.f=me,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Zi=z;class T{static create(U,q){return new T(U,q)}constructor(U,q){this.d=U,this.f=q,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const q=this.f?this.f.source:"",me=U.f?U.f.source:"";return q<me?-1:q>me?1:0}equals(U){if(U.type===this.type){const q=this.f?this.f.source:"",me=U.f?U.f.source:"";return this.d===U.d&&q===me}return!1}substituteConstants(){return this}evaluate(U){const q=U.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$1i=T;class K{static create(U){return new K(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new K(this.c.map(U))}negate(){return this.c}}e.$2i=K;function V(G){let U=null;for(let q=0,me=G.length;q<me;q++){const _=G[q].substituteConstants();if(G[q]!==_&&U===null){U=[];for(let ie=0;ie<q;ie++)U[ie]=G[ie]}U!==null&&(U[q]=_)}return U===null?G:U}class fe{static create(U,q,me){return fe.d(U,q,me)}constructor(U,q){this.expr=U,this.c=q,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let q=0,me=this.expr.length;q<me;q++){const _=i(this.expr[q],U.expr[q]);if(_!==0)return _}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let q=0,me=this.expr.length;q<me;q++)if(!this.expr[q].equals(U.expr[q]))return!1;return!0}return!1}substituteConstants(){const U=V(this.expr);return U===this.expr?this:fe.create(U,this.c,!1)}evaluate(U){for(let q=0,me=this.expr.length;q<me;q++)if(!this.expr[q].evaluate(U))return!1;return!0}static d(U,q,me){const _=[];let ie=!1;for(const re of U)if(re){if(re.type===1){ie=!0;continue}if(re.type===0)return s.INSTANCE;if(re.type===6){_.push(...re.expr);continue}_.push(re)}if(_.length===0&&ie)return u.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(i);for(let re=1;re<_.length;re++)_[re-1].equals(_[re])&&(_.splice(re,1),re--);if(_.length===1)return _[0];for(;_.length>1;){const re=_[_.length-1];if(re.type!==9)break;_.pop();const Ee=_.pop(),ce=_.length===0,de=X.create(re.expr.map(ee=>fe.create([ee,Ee],null,me)),null,ce);de&&(_.push(de),_.sort(i))}if(_.length===1)return _[0];if(me){for(let re=0;re<_.length;re++)for(let Ee=re+1;Ee<_.length;Ee++)if(_[re].negate().equals(_[Ee]))return s.INSTANCE;if(_.length===1)return _[0]}return new fe(_,q)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const q of this.expr)U.push(...q.keys());return U}map(U){return new fe(this.expr.map(q=>q.map(U)),null)}negate(){if(!this.c){const U=[];for(const q of this.expr)U.push(q.negate());this.c=X.create(U,this,!0)}return this.c}}e.$3i=fe;class X{static create(U,q,me){return X.d(U,q,me)}constructor(U,q){this.expr=U,this.c=q,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let q=0,me=this.expr.length;q<me;q++){const _=i(this.expr[q],U.expr[q]);if(_!==0)return _}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let q=0,me=this.expr.length;q<me;q++)if(!this.expr[q].equals(U.expr[q]))return!1;return!0}return!1}substituteConstants(){const U=V(this.expr);return U===this.expr?this:X.create(U,this.c,!1)}evaluate(U){for(let q=0,me=this.expr.length;q<me;q++)if(this.expr[q].evaluate(U))return!0;return!1}static d(U,q,me){let _=[],ie=!1;if(U){for(let re=0,Ee=U.length;re<Ee;re++){const ce=U[re];if(ce){if(ce.type===0){ie=!0;continue}if(ce.type===1)return u.INSTANCE;if(ce.type===9){_=_.concat(ce.expr);continue}_.push(ce)}}if(_.length===0&&ie)return s.INSTANCE;_.sort(i)}if(_.length!==0){if(_.length===1)return _[0];for(let re=1;re<_.length;re++)_[re-1].equals(_[re])&&(_.splice(re,1),re--);if(_.length===1)return _[0];if(me){for(let re=0;re<_.length;re++)for(let Ee=re+1;Ee<_.length;Ee++)if(_[re].negate().equals(_[Ee]))return u.INSTANCE;if(_.length===1)return _[0]}return new X(_,q)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const q of this.expr)U.push(...q.keys());return U}map(U){return new X(this.expr.map(q=>q.map(U)),null)}negate(){if(!this.c){const U=[];for(const q of this.expr)U.push(q.negate());for(;U.length>1;){const q=U.shift(),me=U.shift(),_=[];for(const ie of ve(q))for(const re of ve(me))_.push(fe.create([ie,re],null,!1));U.unshift(X.create(_,null,!1))}this.c=X.create(U,this,!0)}return this.c}}e.$4i=X;class Q extends S{static{this.d=[]}static all(){return Q.d.values()}constructor(U,q,me){super(U,null),this.f=q,typeof me=="object"?Q.d.push({...me,key:U}):me!==!0&&Q.d.push({key:U,description:me,type:q!=null?typeof q:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return k.create(this.key,U)}notEqualsTo(U){return g.create(this.key,U)}}e.$5i=Q,e.$6i=(0,M.$Nh)("contextKeyService");function Z(G,U){return G<U?-1:G>U?1:0}function oe(G,U,q,me){return G<q?-1:G>q?1:U<me?-1:U>me?1:0}function x(G,U){if(G.type===0||U.type===1)return!0;if(G.type===9)return U.type===9?ae(G.expr,U.expr):!1;if(U.type===9){for(const q of U.expr)if(x(G,q))return!0;return!1}if(G.type===6){if(U.type===6)return ae(U.expr,G.expr);for(const q of G.expr)if(x(q,U))return!0;return!1}return G.equals(U)}e.$7i=x;function ae(G,U){let q=0,me=0;for(;q<G.length&&me<U.length;){const _=G[q].cmp(U[me]);if(_<0)return!1;_===0&&q++,me++}return q===G.length}function ve(G){return G.type===9?G.expr:[G]}}),define(De[230],Ce([1,0,23,38,191,5,99,12,24]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.ConfirmResult=e.$yv=e.$xv=e.$wv=void 0,e.$wv=(0,M.$Nh)("dialogService");var w;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(w||(w={}));class R{a(l){return this.d(l,w.Confirmation)}b(l){return this.d(l,w.Prompt)}c(l){return this.d(l,w.Input)}d(l,c){const r=[];switch(c){case w.Confirmation:{const o=l;o.primaryButton?r.push(o.primaryButton):r.push((0,d.localize)(0,null)),o.cancelButton?r.push(o.cancelButton):r.push((0,d.localize)(1,null));break}case w.Prompt:{const o=l;Array.isArray(o.buttons)&&o.buttons.length>0&&r.push(...o.buttons.map(m=>m.label)),o.cancelButton&&(o.cancelButton===!0?r.push((0,d.localize)(2,null)):typeof o.cancelButton=="string"?r.push(o.cancelButton):o.cancelButton.label?r.push(o.cancelButton.label):r.push((0,d.localize)(3,null))),r.length===0&&r.push((0,d.localize)(4,null));break}case w.Input:{const o=l;o.primaryButton?r.push(o.primaryButton):r.push((0,d.localize)(5,null)),o.cancelButton?r.push(o.cancelButton):r.push((0,d.localize)(6,null));break}}return r}e(l){if(typeof l=="string")return l;if(typeof l=="number")return l===F.default.Info?"info":l===F.default.Error?"error":l===F.default.Warning?"warning":"none"}f(l,c,r){const o=[...l.buttons??[]];l.cancelButton&&typeof l.cancelButton!="string"&&typeof l.cancelButton!="boolean"&&o.push(l.cancelButton);let m=o[c]?.run({checkboxChecked:r});return m instanceof Promise||(m=Promise.resolve(m)),{result:m,checkboxChecked:r}}}e.$xv=R,e.$yv=(0,M.$Nh)("fileDialogService");var I;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const v=10;function y(p){const l=[];return l.push(...p.slice(0,v).map(c=>typeof c=="string"?c:(0,C.$rg)(c))),p.length>v&&(p.length-v===1?l.push((0,d.localize)(7,null)):l.push((0,d.localize)(8,null,p.length-v))),l.push(""),l.join(`
`)}e.$zv=y;function D(p,l){const c=(0,E.$3m)(p);let r=(c.buttons??[]).map(t=>(0,A.$tv)(t)),o=(p.buttons||[]).map((t,n)=>n),m=0,h=c.cancelId??r.length-1;if(r.length>1){const t=typeof h=="number"?r[h]:void 0;if(b.$l||b.$k){if(typeof t=="string"&&r.length>1&&h!==1){r.splice(h,1),r.splice(1,0,t);const n=o[h];o.splice(h,1),o.splice(1,0,n),h=1}b.$l&&r.length>1&&(r=r.reverse(),o=o.reverse(),m=r.length-1,typeof t=="string"&&(h=m-1))}else if(b.$j&&typeof t=="string"&&r.length>1&&h!==r.length-1){r.splice(h,1),r.push(t);const n=o[h];o.splice(h,1),o.push(n),h=r.length-1}}return c.buttons=r,c.defaultId=m,c.cancelId=h,c.noLink=!0,c.title=c.title||l.nameLong,{options:c,buttonIndeces:o}}e.$Av=D}),define(De[131],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,C.$Nh)("environmentService"),e.$Vh=(0,C.$Oh)(e.$Uh)}),define(De[132],Ce([1,0,192,5]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$7n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=void 0,e.$Tn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Un=new RegExp(e.$Tn),e.$Vn="__web_extension",e.$Wn="skipWalkthrough",e.$Xn="extensionsSync",e.$Yn="dependecyOrPackExtensionInstall";function d(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Zn=d;function M(r){switch(r){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$1n=M;function A(r,o){switch(r){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$2n=A;function b(r,o){return o==="web"&&!r.includes("web")}e.$3n=b;function E(r,o,m){return b(o,m)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===m?!0:w(m).includes(r)}e.$4n=E;function w(r){switch(r){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$5n=w;function R(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$6n=R;var I;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var v;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var y;(function(r){r.Install="install",r.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var D;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(D||(e.InstallOperation=D={})),e.$7n=(0,F.$Nh)("extensionGalleryService");var p;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.Extract="Extract",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var l;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l||(e.ExtensionSignaturetErrorCode=l={}));class c extends Error{constructor(o,m){super(o),this.code=m,this.name=m}}e.$8n=c,e.$9n=(0,F.$Nh)("extensionManagementService"),e.$0n="extensionsIdentifiers/disabled",e.$$n="extensionsIdentifiers/enabled",e.$_n=(0,F.$Nh)("IGlobalExtensionEnablementService"),e.$ao=(0,F.$Nh)("IExtensionTipsService"),e.$bo=(0,C.localize)(0,null),e.$co={value:e.$bo,original:"Extensions"},e.$do={value:(0,C.localize)(1,null),original:"Preferences"}}),define(De[231],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YXb=e.$XXb=void 0,e.$XXb=(0,C.$Nh)("externalTerminal"),e.$YXb="Terminal.app"}),define(De[232],Ce([1,0,49,17,16,12,98,29,101,194,231]),function($e,e,C,F,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=e.$J6b=e.$I6b=void 0;const I=w.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends v{static{this.b="cmd.exe"}openTerminal(m,h){return this.spawnTerminal(C,m,E.$yl(),h)}spawnTerminal(m,h,t,n){const a=h.windowsExec||y.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const i=d.$mc(a,".exe").toLowerCase();if(i==="cmder")return m.spawn(a,n?[n]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return a.indexOf(" ")>=0&&s.push('""'),s.push(a),i==="wt"&&s.push("-d ."),new Promise((u,S)=>{const k=l(process),$=m.spawn(t,s,{cwd:n,env:k});$.on("error",S),$.on("exit",()=>u())})}runInTerminal(m,h,t,n,a){const i="windowsExec"in a&&a.windowsExec?a.windowsExec:y.getDefaultTerminalWindows();return new Promise((s,u)=>{const S=`"${h} - ${I}"`,k=`""${t.join('" "')}" & pause"`,$=Object.assign({},l(process),n);Object.keys($).filter(N=>$[N]===null).forEach(N=>delete $[N]);const f={cwd:h,env:$,windowsVerbatimArguments:!0};let g,P;d.$mc(i,".exe")==="wt"?(g=i,P=["-d",".",y.b,"/c",k]):(g=y.b,P=["/c","start",S,"/wait",i,"/c",k]),C.spawn(g,P,f).on("error",N=>{u(c(N))}),s(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const m=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${m?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.$I6b=y;class D extends v{static{this.b="/usr/bin/osascript"}openTerminal(m,h){return this.spawnTerminal(C,m,h)}runInTerminal(m,h,t,n,a){const i=a.osxExec||R.$YXb;return new Promise((s,u)=>{if(i===R.$YXb||i==="iTerm.app"){const S=i===R.$YXb?"TerminalHelper":"iTermHelper",$=[F.$bg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",m||I,"-w",h];for(const P of t)$.push("-a"),$.push(P);if(n){const P=Object.assign({},l(process),n);for(const O in P){const N=P[O];N===null?($.push("-u"),$.push(O)):($.push("-e"),$.push(`${O}=${N}`))}}let f="";const g=C.spawn(D.b,$);g.on("error",P=>{u(c(P))}),g.stderr.on("data",P=>{f+=P.toString()}),g.on("exit",P=>{if(P===0)s(void 0);else if(f){const O=f.split(`
`,1);u(new Error(O[0]))}else u(new Error(w.localize(1,null,S,P)))})}else u(new Error(w.localize(2,null,i)))})}spawnTerminal(m,h,t){const n=h.osxExec||R.$YXb;return new Promise((a,i)=>{const s=["-a",n];t&&s.push(t);const u=l(process),S=m.spawn("/usr/bin/open",s,{cwd:t,env:u});S.on("error",i),S.on("exit",()=>a())})}}e.$J6b=D;class p extends v{static{this.b=w.localize(3,null)}openTerminal(m,h){return this.spawnTerminal(C,m,h)}runInTerminal(m,h,t,n,a){const i=a.linuxExec?Promise.resolve(a.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,u)=>{const S=[];i.then(k=>{k.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const $=`${r(t)}; echo; read -p "${p.b}" -n1;`;S.push(`''${$}''`);const f=Object.assign({},l(process),n);Object.keys(f).filter(N=>f[N]===null).forEach(N=>delete f[N]);const g={cwd:h,env:f};let P="";const O=C.spawn(k,S,g);O.on("error",N=>{u(c(N))}),O.stderr.on("data",N=>{P+=N.toString()}),O.on("exit",N=>{if(N===0)s(void 0);else if(P){const L=P.split(`
`,1);u(new Error(L[0]))}else u(new Error(w.localize(4,null,k,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!M.$l)p.d=Promise.resolve("xterm");else{const m=await b.Promises.exists("/etc/debian_version");p.d=new Promise(h=>{m?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return p.d}spawnTerminal(m,h,t){const n=h.linuxExec?Promise.resolve(h.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((a,i)=>{n.then(s=>{const u=l(process),S=m.spawn(s,[],{cwd:t,env:u});S.on("error",i),S.on("exit",()=>a())})})}}e.$K6b=p;function l(o){const m={...o.env};return(0,A.$wl)(m),m}function c(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(w.localize(5,null,o.path)):o}function r(o){let m="";for(const h of o)h.indexOf(" ")>=0?m+='"'+h+'"':m+=h,m+=" ";return m}}),define(De[30],Ce([1,0,77,16,15,18,2,195,5,12,17,46]),function($e,e,C,F,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileKind=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileOperationResult=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileChangeType=e.$ok=e.FileOperation=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.FileSystemProviderErrorCode=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.FileSystemProviderCapabilities=e.$$j=e.FilePermission=e.FileType=e.$0j=e.$9j=void 0,e.$9j=(0,E.$Nh)("fileService");function v(x){return x.create===!0}e.$0j=v;var y;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var D;(function(x){x[x.Readonly=1]="Readonly",x[x.Locked=2]="Locked"})(D||(e.FilePermission=D={}));function p(x){const ae=x;return!!ae&&typeof ae.onDidChange=="function"}e.$$j=p;var l;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileAtomicWrite=32768]="FileAtomicWrite",x[x.FileAtomicDelete=65536]="FileAtomicDelete",x[x.FileClone=131072]="FileClone"})(l||(e.FileSystemProviderCapabilities=l={}));function c(x){return!!(x.capabilities&2)}e.$_j=c;function r(x){return!!(x.capabilities&8)}e.$ak=r;function o(x){return!!(x.capabilities&131072)}e.$bk=o;function m(x){return!!(x.capabilities&4)}e.$ck=m;function h(x){return!!(x.capabilities&16)}e.$dk=h;function t(x){return c(x)?!!(x.capabilities&16384):!1}e.$ek=t;function n(x){return c(x)?!!(x.capabilities&32768):!1}e.$fk=n;function a(x){return!!(x.capabilities&65536)}e.$gk=a;function i(x){return!!(x.capabilities&2048)}e.$hk=i;var s;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class u extends Error{static create(ae,ve){const G=new u(ae.toString(),ve);return $(G,ve),G}constructor(ae,ve){super(ae),this.code=ve}}e.$ik=u;function S(x,ae){return u.create(x,ae)}e.$jk=S;function k(x){return x||S((0,b.localize)(0,null),s.Unknown)}e.$kk=k;function $(x,ae){return x.name=ae?`${ae} (FileSystemError)`:"FileSystemError",x}e.$lk=$;function f(x){if(!x)return s.Unknown;if(x instanceof u)return x.code;const ae=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!ae)return s.Unknown;switch(ae[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$mk=f;function g(x){if(x instanceof z)return x.fileOperationResult;switch(f(x)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$nk=g;var P;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class O{constructor(ae,ve,G){this.resource=ae,this.operation=ve,this.target=G}isOperation(ae){return this.operation===ae}}e.$ok=O;var N;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(N||(e.FileChangeType=N={}));class L{static{this.a=null}constructor(ae,ve){this.c=ve,this.b=void 0,this.d=new I.$U(()=>{const G=C.$Th.forUris(()=>this.c);return G.fill(this.rawAdded.map(U=>[U,!0])),G}),this.f=new I.$U(()=>{const G=C.$Th.forUris(()=>this.c);return G.fill(this.rawUpdated.map(U=>[U,!0])),G}),this.g=new I.$U(()=>{const G=C.$Th.forUris(()=>this.c);return G.fill(this.rawDeleted.map(U=>[U,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of ae){switch(G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}this.b!==L.a&&(typeof G.cId=="number"?this.b===void 0?this.b=G.cId:this.b!==G.cId&&(this.b=L.a):this.b!==void 0&&(this.b=L.a))}}contains(ae,...ve){return this.h(ae,{includeChildren:!1},...ve)}affects(ae,...ve){return this.h(ae,{includeChildren:!0},...ve)}h(ae,ve,...G){if(!ae)return!1;const U=G.length>0;return!!((!U||G.includes(1))&&(this.d.value.get(ae)||ve.includeChildren&&this.d.value.findSuperstr(ae))||(!U||G.includes(0))&&(this.f.value.get(ae)||ve.includeChildren&&this.f.value.findSuperstr(ae))||(!U||G.includes(2))&&(this.g.value.findSubstr(ae)||ve.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$pk=L;function j(x,ae,ve){return!x||!ae||x===ae||ae.length>x.length?!1:(ae.charAt(ae.length-1)!==F.sep&&(ae+=F.sep),ve?(0,d.$2e)(x,ae):x.indexOf(ae)===0)}e.$qk=j;class z extends Error{constructor(ae,ve,G){super(ae),this.fileOperationResult=ve,this.options=G}}e.$rk=z;class T extends z{constructor(ae,ve,G,U){super(ae,ve,U),this.fileOperationResult=ve,this.size=G}}e.$sk=T;class K extends z{constructor(ae,ve,G){super(ae,2,G),this.stat=ve}}e.$tk=K;var V;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$uk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$vk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$wk="files.associations",e.$xk="files.exclude",e.$yk="files.readonlyInclude",e.$zk="files.readonlyExclude",e.$Ak="files.readonlyFromPermissions";var fe;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$Bk="";function X(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.$Ck=X;async function Q(x,ae){if(!ae.hasProvider(A.URI.from({scheme:x.scheme})))return new Promise(ve=>{const G=ae.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===x.scheme&&U.added&&(G.dispose(),ve())})})}e.$Dk=Q;class Z{static{this.KB=1024}static{this.MB=Z.KB*Z.KB}static{this.GB=Z.MB*Z.KB}static{this.TB=Z.GB*Z.KB}static formatSize(ae){return(0,M.$Bf)(ae)||(ae=0),ae<Z.KB?(0,b.localize)(1,null,ae.toFixed(0)):ae<Z.MB?(0,b.localize)(2,null,(ae/Z.KB).toFixed(2)):ae<Z.GB?(0,b.localize)(3,null,(ae/Z.MB).toFixed(2)):ae<Z.TB?(0,b.localize)(4,null,(ae/Z.GB).toFixed(2)):(0,b.localize)(5,null,(ae/Z.TB).toFixed(2))}}e.$Ek=Z;function oe(x){const ae=typeof x=="string"||x?.scheme===R.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===R.Schemas.file?1024*Z.MB:ae?10*Z.MB:w.$p?50*Z.MB:1024*Z.MB}e.$Fk=oe}),define(De[233],Ce([1,0,22,8,196,30]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;async function A(R,I,v,y,D,p){let l;try{await b(R,I,v,y,D,p)}catch(c){l=c}finally{l&&D.errorTransformer&&(l=D.errorTransformer(l)),typeof l<"u"&&v.error(l),v.end()}}e.$Jp=A;async function b(R,I,v,y,D,p){E(p);const l=await R.open(I,{create:!1});try{E(p);let c=0,r=0,o=D&&typeof D.length=="number"?D.length:void 0,m=C.$ae.alloc(Math.min(D.bufferSize,typeof o=="number"?o:D.bufferSize)),h=D&&typeof D.position=="number"?D.position:0,t=0;do r=await R.read(l,h,m.buffer,t,m.byteLength-t),h+=r,t+=r,c+=r,typeof o=="number"&&(o-=r),t===m.byteLength&&(await v.write(y(m)),m=C.$ae.alloc(Math.min(D.bufferSize,typeof o=="number"?o:D.bufferSize)),t=0);while(r>0&&(typeof o!="number"||o>0)&&E(p)&&w(c,D));if(t>0){let n=t;typeof o=="number"&&(n=Math.min(t,o)),v.write(y(m.slice(0,n)))}}catch(c){throw(0,M.$kk)(c)}finally{await R.close(l)}}function E(R){if(R.isCancellationRequested)throw(0,F.$5)();return!0}function w(R,I){if(typeof I?.limits?.size=="number"&&R>I.limits.size)throw(0,M.$jk)((0,d.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[83],Ce([1,0,35,3,16,12,2,30]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=e.$Qp=e.$Pp=e.$Op=e.$Np=e.$Mp=e.$Lp=void 0;function E(c){return c.recursive===!0}e.$Lp=E;class w extends F.$Rc{static{this.a=5}constructor(r,o,m,h){super(),this.h=r,this.j=o,this.m=m,this.n=h,this.c=this.B(new F.$Sc),this.f=void 0,this.g=0}s(){const r=new F.$Qc;this.c.value=r,this.b=this.r(r),this.b.setVerboseLogging(this.m),r.add(this.b.onDidChangeFile(o=>this.h(o))),r.add(this.b.onDidLogMessage(o=>this.j(o))),r.add(this.b.onDidError(o=>this.t(o)))}t(r){this.n.restartOnError?this.g<w.a&&this.f?(this.w(`restarting watcher after error: ${r}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${r}`):this.w(r)}u(r){this.g++,this.s(),this.watch(r)}async watch(r){this.f=r,await this.b?.watch(r)}async setVerboseLogging(r){this.m=r,await this.b?.setVerboseLogging(r)}w(r){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${r}`})}y(r){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${r}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Mp=w;class R extends w{constructor(r,o,m){super(r,o,m,{type:"node.js",restartOnError:!1})}}e.$Np=R;class I extends w{constructor(r,o,m){super(r,o,m,{type:"universal",restartOnError:!0})}}e.$Op=I;function v(c){return c.map(r=>({type:r.type,resource:A.URI.revive(r.resource),cId:r.cId}))}e.$Pp=v;function y(c){const r=new l;for(const o of c)r.processEvent(o);return r.coalesce()}e.$Qp=y;function D(c,r){return typeof r=="string"&&!r.startsWith(C.$qj)&&!(0,d.$hc)(r)?{base:c,pattern:r}:r}e.$Rp=D;function p(c,r){const o=[];for(const m of r)o.push((0,C.$uj)(D(c,m)));return o}e.$Sp=p;class l{constructor(){this.a=new Set,this.b=new Map}c(r){return M.$l?r.resource.fsPath:r.resource.fsPath.toLowerCase()}processEvent(r){const o=this.b.get(this.c(r));let m=!1;if(o){const h=o.type,t=r.type;o.resource.fsPath!==r.resource.fsPath&&(r.type===2||r.type===1)?m=!0:h===1&&t===2?(this.b.delete(this.c(r)),this.a.delete(o)):h===2&&t===1?o.type=0:h===1&&t===0||(o.type=t)}else m=!0;m&&(this.a.add(r),this.b.set(this.c(r),r))}coalesce(){const r=[],o=[];return Array.from(this.a).filter(m=>m.type!==2?(r.push(m),!1):!0).sort((m,h)=>m.resource.fsPath.length-h.resource.fsPath.length).filter(m=>o.some(h=>(0,b.$qk)(m.resource.fsPath,h,!M.$l))?!1:(o.push(m.resource.fsPath),!0)).concat(r)}}}),define(De[234],Ce([1,0,53,9,21,32,3,76,16,12,23,2,100,29,83]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class p extends A.$Rc{static{this.a=100}static{this.b=75}constructor(r,o,m,h){super(),this.m=r,this.n=o,this.r=m,this.s=h,this.c=this.B(new F.$8g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new F.$7g(t=>this.z(t),p.b)),this.g=(0,D.$Sp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,D.$Sp)(this.m.path,this.m.includes):void 0,this.j=new d.$Wd,this.ready=this.t()}async t(){try{const r=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const o=await y.Promises.stat(r);this.B(await this.w(r,o.isDirectory()))}catch(r){r.code!=="ENOENT"?this.D(r):this.G(r)}}async u(r){let o=r.path;try{o=await y.Promises.realpath(r.path),r.path===o&&(o=await(0,v.$3p)(r.path)??r.path),r.path!==o&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${o})`)}catch{}return o}async w(r,o){if(w.$k&&(0,M.$Wf)(r,"/Volumes/",!0))return this.D(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Rc.None;const m=new d.$Wd(this.j.token),h=new A.$Qc;try{const t=I.URI.file(this.m.path),n=(0,E.$mc)(r),a=(0,C.watch)(r);h.add((0,A.$Pc)(()=>{a.removeAllListeners(),a.close()})),this.G(`Started watching: '${r}'`);const i=new Set;if(o)try{for(const u of await y.Promises.readdir(r))i.add(u)}catch(u){this.D(u)}const s=new Map;h.add((0,A.$Pc)(()=>{for(const[,u]of s)u.dispose();s.clear()})),a.on("error",(u,S)=>{this.D(`Failed to watch ${r} for changes using fs.watch() (${u}, ${S})`),this.dispose()}),a.on("change",(u,S)=>{if(m.token.isCancellationRequested)return;this.G(`[raw] ["${u}"] ${S}`);let k="";if(S&&(k=S.toString(),w.$k&&(k=(0,b.$ll)(k))),!(!k||u!=="change"&&u!=="rename"))if(o)if(u==="rename"){s.get(k)?.dispose();const $=setTimeout(async()=>{if(s.delete(k),k===n&&!await y.Promises.exists(r)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.C((0,E.$ic)(r,k));if(m.token.isCancellationRequested)return;let g;f?i.has(k)?g=0:(g=1,i.add(k)):(i.delete(k),g=2),this.y({resource:(0,R.$ug)(t,k),type:g,cId:this.m.correlationId})},p.a);s.set(k,(0,A.$Pc)(()=>clearTimeout($)))}else{let $;i.has(k)?$=0:($=1,i.add(k)),this.y({resource:(0,R.$ug)(t,k),type:$,cId:this.m.correlationId})}else if(u==="rename"||k!==n){const $=setTimeout(async()=>{const f=await y.Promises.exists(r);m.token.isCancellationRequested||(f?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),h.add(await this.w(r,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);h.clear(),h.add((0,A.$Pc)(()=>clearTimeout($)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await y.Promises.exists(r)&&!m.token.isCancellationRequested&&this.D(`Failed to watch ${r} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Pc)(()=>{m.dispose(!0),h.dispose()})}y(r,o=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.resource.fsPath}`),!o&&this.g.some(m=>m(r.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${r.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(m=>m(r.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${r.resource.fsPath}`):this.f.work(r))}z(r){const o=(0,D.$Qp)(r);if(o.length>0){if(this.s)for(const h of o)this.G(` >> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`);this.c.work(o)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(r){if(w.$l)return y.Promises.exists(r);try{const o=(0,E.$mc)(r);return(await y.Promises.readdir((0,E.$lc)(r))).some(h=>h===o)}catch(o){return this.G(o),!1}}setVerboseLogging(r){this.s=r}D(r){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}F(r){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}G(r){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$6p=p;async function l(c,r,o,m,h=512){const t=await y.Promises.open(c,"r"),n=Buffer.allocUnsafe(h),a=new d.$Wd(m);let i,s=!1;const u={path:c,excludes:[],recursive:!1},S=new p(u,k=>{(async()=>{for(const{type:$}of k)if($===0){if(s)return;s=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:f}=await y.Promises.read(t,n,0,h,null);if(!f||a.token.isCancellationRequested)break;r(n.slice(0,f))}}catch(f){i=new Error(f),a.dispose(!0)}finally{s=!1}}})()});return await S.ready,o(),new Promise((k,$)=>{a.token.onCancellationRequested(async()=>{S.dispose();try{await y.Promises.close(t)}catch(f){i=new Error(f)}i?$(i):k()})})}e.$7p=l}),define(De[235],Ce([1,0,4,35,3,12,234]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class b extends d.$Rc{constructor(){super(...arguments),this.a=this.B(new C.$Md),this.onDidChangeFile=this.a.event,this.b=this.B(new C.$Md),this.onDidLogMessage=this.b.event,this.onDidError=C.Event.None,this.c=new Map,this.f=!1}async watch(w){const R=this.j(w),I=R.filter(y=>{const D=this.c.get(y.path);return D?!(0,F.$yj)(D.request.excludes,y.excludes)||!(0,F.$yj)(D.request.includes,y.includes):!0}),v=Array.from(this.c.values()).filter(({request:y})=>!R.find(D=>D.path===y.path&&(0,F.$yj)(D.excludes,y.excludes)&&(0,F.$yj)(D.includes,y.includes))).map(({request:y})=>y.path);I.length&&this.m(`Request to start watching: ${I.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const y of v)this.h(y);for(const y of I)this.g(y)}g(w){const R=new A.$6p(w,v=>this.a.fire(v),v=>this.b.fire(v),this.f),I={request:w,instance:R};this.c.set(w.path,I)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const R=this.c.get(w);R&&(this.c.delete(w),R.instance.dispose())}j(w){const R=new Map;for(const I of w){const v=M.$l?I.path:I.path.toLowerCase();let y=R.get(I.correlationId);y||(y=new Map,R.set(I.correlationId,y)),y.set(v,I)}return Array.from(R.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(w){this.f=w;for(const[,R]of this.c)R.instance.setVerboseLogging(w)}m(w){this.f&&this.b.fire({type:"trace",message:this.n(w)})}n(w,R){return R?`[File Watcher (node.js)] ${w} (path: ${R.request.path})`:`[File Watcher (node.js)] ${w}`}}e.$8p=b}),define(De[236],Ce([1,0,83,235]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class d extends C.$Np{constructor(A,b,E){super(A,b,E),this.s()}r(A){return A.add(new F.$8p)}}e.$9p=d}),define(De[237],Ce([1,0,17,80,183,83]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class A extends M.$Op{constructor(E,w,R){super(E,w,R),this.s()}r(E){const w=E.add(new d.$Zp(C.$bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(w.onDidProcessExit(({code:R,signal:I})=>this.t(`terminated by itself with code ${R}, signal: ${I}`))),F.ProxyChannel.toService((0,F.$uh)(w.getChannel("watcher")))}}e.$1p=A}),define(De[104],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class C{constructor(...d){this.a=new Map;for(const[M,A]of d)this.set(M,A)}set(d,M){const A=this.a.get(d);return this.a.set(d,M),A}has(d){return this.a.has(d)}get(d){return this.a.get(d)}}e.$Lh=C}),define(De[238],Ce([1,0,9,8,3,102,229,5,104,75]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;const R=!1;class I extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class v{constructor(l=new E.$Lh,c=!1,r,o=R){this.f=l,this.g=c,this.h=r,this.i=o,this.o=new Set,this.f.set(b.$Mh,this),this._globalGraph=o?r?._globalGraph??new A.$_p(m=>m):void 0}createChild(l){return new v(l,this.g,this,this.i)}invokeFunction(l,...c){const r=D.traceInvocation(this.i,l);let o=!1;try{return l({get:h=>{if(o)throw(0,F.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(h,r);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...c)}finally{o=!0,r.stop()}}createInstance(l,...c){let r,o;return l instanceof M.$Kh?(r=D.traceCreation(this.i,l.ctor),o=this.j(l.ctor,l.staticArguments.concat(c),r)):(r=D.traceCreation(this.i,l),o=this.j(l,c,r)),r.stop(),o}j(l,c=[],r){const o=b._util.getServiceDependencies(l).sort((t,n)=>t.index-n.index),m=[];for(const t of o){const n=this.m(t.id,r);n||this.u(`[createInstance] ${l.name} depends on UNKNOWN service ${t.id}.`,!1),m.push(n)}const h=o.length>0?o[0].index:c.length;if(c.length!==h){console.trace(`[createInstance] First service dependency of ${l.name} at position ${h+1} conflicts with ${c.length} static arguments`);const t=h-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,h)}return Reflect.construct(l,c.concat(m))}k(l,c){if(this.f.get(l)instanceof M.$Kh)this.f.set(l,c);else if(this.h)this.h.k(l,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(l){const c=this.f.get(l);return!c&&this.h?this.h.l(l):c}m(l,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(l));const r=this.l(l);return r instanceof M.$Kh?this.q(l,r,c.branch(l,!0)):(c.branch(l,!1),r)}q(l,c,r){if(this.o.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this.o.add(l);try{return this.r(l,c,r)}finally{this.o.delete(l)}}r(l,c,r){const o=new A.$_p(t=>t.id.toString());let m=0;const h=[{id:l,desc:c,_trace:r}];for(;h.length;){const t=h.pop();if(o.lookupOrInsertNode(t),m++>1e3)throw new I(o);for(const n of b._util.getServiceDependencies(t.desc.ctor)){const a=this.l(n.id);if(a||this.u(`[createInstance] ${l} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),a instanceof M.$Kh){const i={id:n.id,desc:a,_trace:t._trace.branch(n.id,!0)};o.insertEdge(t,i),h.push(i)}}}for(;;){const t=o.roots();if(t.length===0){if(!o.isEmpty())throw new I(o);break}for(const{data:n}of t){if(this.l(n.id)instanceof M.$Kh){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}o.removeNode(n)}}return this.l(l)}s(l,c,r=[],o,m){if(this.f.get(l)instanceof M.$Kh)return this.t(l,c,r,o,m);if(this.h)return this.h.s(l,c,r,o,m);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(l,c,r=[],o,m){if(o){const h=new v(void 0,this.g,this,this.i);h.c=String(l);const t=new Map,n=new C.$0g(()=>{const a=h.j(c,r,m);for(const[i,s]of t){const u=a[i];if(typeof u=="function")for(const S of s)u.apply(a,S)}return t.clear(),a});return new Proxy(Object.create(null),{get(a,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let S=t.get(i);return S||(S=new w.$1c,t.set(i,S)),($,f,g)=>{const P=S.push([$,f,g]);return(0,d.$Pc)(P)}}if(i in a)return a[i];const s=n.value;let u=s[i];return typeof u!="function"||(u=u.bind(s),a[i]=u),u},set(a,i,s){return n.value[i]=s,!0},getPrototypeOf(a){return c.prototype}})}else return this.j(c,r,m)}u(l,c){if(c&&console.warn(l),this.g)throw new Error(l)}}e.$aq=v;var y;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(y||(y={}));class D{static{this.all=new Set}static{this.c=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(l,c){return l?new D(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D.c}static traceCreation(l,c){return l?new D(1,c.name):D.c}static{this.f=0}constructor(l,c){this.type=l,this.name=c,this.g=Date.now(),this.h=[]}branch(l,c){const r=new D(3,l.toString());return this.h.push([l,c,r]),r}stop(){const l=Date.now()-this.g;D.f+=l;let c=!1;function r(m,h){const t=[],n=new Array(m+1).join("	");for(const[a,i,s]of h.h)if(i&&s){c=!0,t.push(`${n}CREATES -> ${a}`);const u=r(m+1,s);u&&t.push(u)}else t.push(`${n}uses -> ${a}`);return t.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${D.f.toFixed(2)}ms)`];(l>2||c)&&D.all.add(o.join(`
`))}}e.$bq=D}),define(De[13],Ce([1,0,47,4,52,3,28,12,23,18,2,41,5]),function($e,e,C,F,d,M,A,b,E,w,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,v.$Nh)("logService"),e.$9i=(0,v.$Nh)("loggerService");function y(){return new Date().toISOString()}function D($){return(0,w.$Bf)($)}e.$0i=D;var p;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$$i=p.Info;function l($,f,g){switch(f){case p.Trace:$.trace(g);break;case p.Debug:$.debug(g);break;case p.Info:$.info(g);break;case p.Warning:$.warn(g);break;case p.Error:$.error(g);break;case p.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=l;function c($,f=!1){let g="";for(let P=0;P<$.length;P++){let O=$[P];if(O instanceof Error&&(O=(0,C.$yi)(O,f)),typeof O=="object")try{O=JSON.stringify(O)}catch{}g+=(P>0?" ":"")+O}return g}class r extends M.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new F.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==p.Off&&this.b<=f}}e.$aj=r;class o extends r{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...g){this.f(p.Trace)&&this.g(p.Trace,c([f,...g],!0))}debug(f,...g){this.f(p.Debug)&&this.g(p.Debug,c([f,...g]))}info(f,...g){this.f(p.Info)&&this.g(p.Info,c([f,...g]))}warn(f,...g){this.f(p.Warning)&&this.g(p.Warning,c([f,...g]))}error(f,...g){if(this.f(p.Error))if(f instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=f.stack,this.g(p.Error,c(P))}else this.g(p.Error,c([f,...g]))}flush(){}}e.$bj=o;class m extends r{constructor(f=e.$$i){super(),this.setLevel(f),this.g=!b.$j}trace(f,...g){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,f,...g):console.log(`[main ${y()}]`,f,...g))}debug(f,...g){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,f,...g):console.log(`[main ${y()}]`,f,...g))}info(f,...g){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,f,...g):console.log(`[main ${y()}]`,f,...g))}warn(f,...g){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,f,...g):console.warn(`[main ${y()}]`,f,...g))}error(f,...g){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,f,...g):console.error(`[main ${y()}]`,f,...g))}dispose(){}flush(){}}e.$cj=m;class h extends r{constructor(f=e.$$i,g=!0){super(),this.g=g,this.setLevel(f)}trace(f,...g){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...g):console.log(f,...g))}debug(f,...g){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...g):console.log(f,...g))}info(f,...g){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...g):console.log(f,...g))}warn(f,...g){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...g):console.log(f,...g))}error(f,...g){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...g):console.error(f,...g))}dispose(){}flush(){}}e.$dj=h;class t extends r{constructor(f,g=e.$$i){super(),this.g=f,this.setLevel(g)}trace(f,...g){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(f),...g])}debug(f,...g){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(f),...g])}info(f,...g){this.f(p.Info)&&this.g.log(p.Info,[this.h(f),...g])}warn(f,...g){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(f),...g])}error(f,...g){this.f(p.Error)&&this.g.log(p.Error,[this.h(f),...g])}h(f){return typeof f=="string"?f:(0,C.$yi)(f,this.f(p.Trace))}dispose(){}flush(){}}e.$ej=t;class n extends r{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const g of this.g)g.setLevel(f);super.setLevel(f)}trace(f,...g){for(const P of this.g)P.trace(f,...g)}debug(f,...g){for(const P of this.g)P.debug(f,...g)}info(f,...g){for(const P of this.g)P.info(f,...g)}warn(f,...g){for(const P of this.g)P.warn(f,...g)}error(f,...g){for(const P of this.g)P.error(f,...g)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$fj=n;class a extends M.$Rc{constructor(f,g,P){if(super(),this.h=f,this.j=g,this.b=new A.$zc,this.c=this.B(new F.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Md),this.onDidChangeVisibility=this.g.event,P)for(const O of P)this.b.set(O.resource,{logger:void 0,info:O})}m(f){return(0,w.$xf)(f)?[...this.b.values()].find(g=>g.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,g){const P=this.n(f),O=(0,w.$xf)(f)?f:g?.id??(0,d.$Bi)(P.toString()).toString(16);let N=this.b.get(P)?.logger;const L=g?.logLevel==="always"?p.Trace:g?.logLevel;N||(N=this.s(P,L??this.getLogLevel(P)??this.h,{...g,id:O}));const j={logger:N,info:{resource:P,id:O,logLevel:L,name:g?.name,hidden:g?.hidden,extensionId:g?.extensionId,when:g?.when}};return this.registerLogger(j.info),this.b.set(P,j),N}n(f){return(0,w.$xf)(f)?(0,E.$ug)(this.j,`${f}.log`):f}setLogLevel(f,g){if(R.URI.isUri(f)){const P=f,O=g,N=this.b.get(P);N&&O!==N.info.logLevel&&(N.info.logLevel=O===this.h?void 0:O,N.logger?.setLevel(O),this.b.set(N.info.resource,N),this.f.fire([P,O]))}else{this.h=f;for(const[P,O]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,g){const P=this.m(f);P&&g!==!P.info.hidden&&(P.info.hidden=!g,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,g]))}getLogLevel(f){let g;return f&&(g=this.b.get(f)?.info.logLevel),g??this.h}registerLogger(f){const g=this.b.get(f.resource);g?g.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const g=this.b.get(f);g&&(g.logger&&g.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[g.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=a;class i{constructor(){this.onDidChangeLogLevel=new F.$Md().event}setLevel(f){}getLevel(){return p.Info}trace(f,...g){}debug(f,...g){}info(f,...g){}warn(f,...g){}error(f,...g){}critical(f,...g){}dispose(){}flush(){}}e.$hj=i;class s extends i{}e.$ij=s;function u($){if($.verbose)return p.Trace;if(typeof $.logLevel=="string"){const f=k($.logLevel.toLowerCase());if(f!==void 0)return f}return e.$$i}e.$jj=u;function S($){switch($){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$kj=S;function k($){switch($){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$lj=k,e.$mj=new I.$5i("logLevel",S(p.Info))}),define(De[239],Ce([1,0,19,9,8,4,3,16,83,13]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class R extends A.$Rc{constructor(v,y){super(),this.a=v,this.b=y,this.c=this.B(new M.$Md),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Md),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$Qg(0)),this.w=[],this.y=this.B(new F.$Qg(0))}watch(v,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(v,y):this.z(v,y)}n(v,y){const D={path:this.H(v),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},p=(0,C.$Tb)(this.j,D);return this.r(),(0,A.$Pc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,d.$Z)(v))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,E.$Pp)(y)),y=>this.G(y),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const y of this.j)(0,E.$Lp)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const y of this.j)(0,E.$Lp)(y)&&v.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,y){const D={path:this.H(v),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},p=(0,C.$Tb)(this.w,D);return this.C(),(0,A.$Pc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,d.$Z)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,E.$Pp)(v)),v=>this.G(v),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,b.$gc)(v.fsPath)}}e.$Tp=R}),define(De[240],Ce([1,0,53,372,9,28,22,4,32,3,16,12,23,96,29,197,30,233,239,47,237,236]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0,(()=>{try{(0,F.gracefulify)(C)}catch(n){console.error(`Error enabling graceful-fs: ${(0,o.$yi)(n)}`)}})();class t extends r.$Tp{static{this.I=!1}constructor(a,i){super(a,i),this.onDidChangeCapabilities=b.Event.None,this.N=new M.$zc(s=>v.$lg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$l&&(this.J|=1024)),this.J}async stat(a){try{const{stat:i,symbolicLink:s}=await D.SymlinkSupport.stat(this.H(a));return{type:this.M(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:l.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const i=await D.Promises.readdir(this.H(a),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async u=>{try{let S;u.isSymbolicLink()?S=(await this.stat((0,v.$ug)(a,u.name))).type:S=this.M(u),s.push([u.name,S])}catch(S){this.a.trace(S)}})),s}catch(i){throw this.fb(i)}}M(a,i){let s;return i?.dangling?s=l.FileType.Unknown:a.isFile()?s=l.FileType.File:a.isDirectory()?s=l.FileType.Directory:s=l.FileType.Unknown,i&&(s|=l.FileType.SymbolicLink),s}async O(a){const i=this.H(a);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.N.get(a);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const u=new d.$Rg;return this.N.set(a,u),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,w.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(a)===u&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(a)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(a,i){let s;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(a)})`),s=await this.O(a));const u=this.H(a);return await D.Promises.readFile(u)}catch(u){throw this.fb(u)}finally{s?.dispose()}}P(a){t.I&&this.a.trace(a)}readFileStream(a,i,s){const u=(0,y.$1d)(S=>A.$ae.concat(S.map(k=>A.$ae.wrap(k))).buffer);return(0,c.$Jp)(this,a,u,S=>S.buffer,{...i,bufferSize:256*1024},s),u}async writeFile(a,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(a)?this.R(a,(0,v.$ug)((0,v.$tg)(a),`${(0,v.$rg)(a)}${s.atomic.postfix}`),i,s):this.S(a,i,s)}async Q(a){try{const i=this.H(a),{symbolicLink:s}=await D.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async R(a,i,s,u){const S=new w.$Qc;try{S.add(await this.O(a)),S.add(await this.O(i)),await this.S(i,s,u,!0);try{await this.rename(i,a,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{S.dispose()}}async S(a,i,s,u){let S;try{const k=this.H(a);if(!s.create||!s.overwrite){if(await D.Promises.exists(k)){if(!s.overwrite)throw(0,l.$jk)((0,p.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,l.$jk)((0,p.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(a,{create:!0,unlock:s.unlock},u),await this.write(S,0,i,0,i.byteLength)}catch(k){throw await this.gb(a,k)}finally{typeof S=="number"&&await this.close(S)}}static{this.Y=!0}static configureFlushOnWrite(a){t.Y=a}async open(a,i,s){const u=this.H(a);let S;(0,l.$0j)(i)&&!s&&(S=await this.O(a));let k;try{if((0,l.$0j)(i)&&i.unlock)try{const{stat:f}=await D.SymlinkSupport.stat(u);f.mode&128||await D.Promises.chmod(u,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let $;if((0,l.$0j)(i)){if(I.$j)try{await D.Promises.truncate(u,0),$="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}$||($="w")}else $="r";k=await D.Promises.open(u,$)}catch($){throw S?.dispose(),(0,l.$0j)(i)?await this.gb(a,$):this.fb($)}if(this.U.set(k,0),(0,l.$0j)(i)&&this.X.set(k,a),S){const $=this.W.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${u})`),this.W.set(k,S),$&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${u})`),$.dispose())}return k}async close(a){const i=this.W.get(a);try{if(this.U.delete(a),this.X.delete(a)&&t.Y)try{await D.Promises.fdatasync(a)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await D.Promises.close(a)}catch(s){throw this.fb(s)}finally{i&&(this.W.get(a)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.W.delete(a)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),i.dispose())}}async read(a,i,s,u,S){const k=this.Z(a,i);let $=null;try{$=(await D.Promises.read(a,s,u,S,k)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(a,k,$)}return $}Z(a,i){return i===this.U.get(a)?null:i}$(a,i,s){const u=this.U.get(a);typeof u=="number"&&(typeof i=="number"||(typeof s=="number"?this.U.set(a,u+s):this.U.delete(a)))}async write(a,i,s,u,S){return(0,d.$$g)(()=>this.ab(a,i,s,u,S),100,3)}async ab(a,i,s,u,S){const k=this.Z(a,i);let $=null;try{$=(await D.Promises.write(a,s,u,S,k)).bytesWritten}catch(f){throw await this.gb(this.X.get(a),f)}finally{this.$(a,k,$)}return $}async mkdir(a){try{await D.Promises.mkdir(this.H(a))}catch(i){throw this.fb(i)}}async delete(a,i){try{const s=this.H(a);if(i.recursive){let u;i?.atomic!==!1&&i.atomic.postfix&&(u=(0,R.$ic)((0,R.$lc)(s),`${(0,R.$mc)(s)}${i.atomic.postfix}`)),await D.Promises.rm(s,D.RimRafMode.MOVE,u)}else try{await D.Promises.unlink(s)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let S=!1;try{const{stat:k,symbolicLink:$}=await D.SymlinkSupport.stat(s);S=k.isDirectory()&&!$}catch{}if(S)await D.Promises.rmdir(s);else throw u}else throw u}}catch(s){throw this.fb(s)}}async rename(a,i,s){const u=this.H(a),S=this.H(i);if(u!==S)try{await this.bb(a,i,"move",s.overwrite),await D.Promises.rename(u,S)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,p.localize)(2,null,(0,R.$mc)(u),(0,R.$mc)((0,R.$lc)(S)),k.toString()))),this.fb(k)}}async copy(a,i,s){const u=this.H(a),S=this.H(i);if(u!==S)try{await this.bb(a,i,"copy",s.overwrite),await D.Promises.copy(u,S,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,p.localize)(3,null,(0,R.$mc)(u),(0,R.$mc)((0,R.$lc)(S)),k.toString()))),this.fb(k)}}async bb(a,i,s,u){const S=this.H(a),k=this.H(i);let $=!1;if(!!(this.capabilities&1024)||($=(0,E.$Vf)(S,k,!0)),$){if(s==="copy")throw(0,l.$jk)((0,p.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const g=await this.L(a);if(!g)throw(0,l.$jk)((0,p.localize)(5,null),l.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(i);if(P){if(!u)throw(0,l.$jk)((0,p.localize)(6,null),l.FileSystemProviderErrorCode.FileExists);g.type&l.FileType.File&&P.type&l.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,i){return this.cb(a,i,!1)}async cb(a,i,s){const u=this.H(a),S=this.H(i),k=!!(this.capabilities&1024);if((0,E.$Vf)(u,S,!k))return;const $=new w.$Qc;try{$.add(await this.O(a)),$.add(await this.O(i)),s&&await D.Promises.mkdir((0,R.$lc)(S),{recursive:!0}),await D.Promises.copyFile(u,S)}catch(f){if(f.code==="ENOENT"&&!s)return this.cb(a,i,!0);throw this.fb(f)}finally{$.dispose()}}t(a,i,s){return new m.$1p(u=>a(u),u=>i(u),s)}F(a,i,s){return new h.$9p(u=>a(u),u=>i(u),s)}fb(a){if(a instanceof l.$ik)return a;let i=a,s;switch(a.code){case"ENOENT":s=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=l.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=l.FileSystemProviderErrorCode.Unknown;break;default:s=l.FileSystemProviderErrorCode.Unknown}return(0,l.$jk)(i,s)}async gb(a,i){let s=this.fb(i);if(a&&s.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await D.SymlinkSupport.stat(this.H(a));u.mode&128||(s=(0,l.$jk)(i,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return s}}e.$0p=t}),define(De[241],Ce([1,0,3,13]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=void 0;class d extends C.$Rc{constructor(A,b=[]){super(),this.a=new F.$fj([A,...b]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...b){this.a.trace(A,...b)}debug(A,...b){this.a.debug(A,...b)}info(A,...b){this.a.info(A,...b)}warn(A,...b){this.a.warn(A,...b)}error(A,...b){this.a.error(A,...b)}flush(){this.a.flush()}}e.$yN=d}),define(De[242],Ce([1,0,30,13]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=void 0;var d;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(d||(d={}));async function M(w,R,I,v,y){try{const D=await new Promise((l,c)=>{$e(["@vscode/spdlog"],l,c)});D.setFlushOn(d.Trace);const p=await D.createAsyncRotatingLogger(w,R,I,v);return y?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(D){console.error(D)}return null}function A(w,R,I){switch(R){case F.LogLevel.Trace:w.trace(I);break;case F.LogLevel.Debug:w.debug(I);break;case F.LogLevel.Info:w.info(I);break;case F.LogLevel.Warning:w.warn(I);break;case F.LogLevel.Error:w.error(I);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function b(w,R){switch(R){case F.LogLevel.Trace:w.setLevel(d.Trace);break;case F.LogLevel.Debug:w.setLevel(d.Debug);break;case F.LogLevel.Info:w.setLevel(d.Info);break;case F.LogLevel.Warning:w.setLevel(d.Warning);break;case F.LogLevel.Error:w.setLevel(d.Error);break;case F.LogLevel.Off:w.setLevel(d.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class E extends F.$bj{constructor(R,I,v,y,D){super(),this.m=[],this.setLevel(D),this.n=this.s(R,I,v,y),this.B(this.onDidChangeLogLevel(p=>{this.r&&b(this.r,p)}))}async s(R,I,v,y){const D=v?6:1,p=30/D*C.$Ek.MB,l=await M(R,I,p,D,y);if(l){this.r=l,b(this.r,this.getLevel());for(const{level:c,message:r}of this.m)A(this.r,c,r);this.m=[]}}g(R,I){this.r?A(this.r,R,I):this.getLevel()<=R&&this.m.push({level:R,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$nN=E}),define(De[133],Ce([1,0,38,198,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function w(D,p){return p-D}E.compare=w;const R=Object.create(null);R[E.Error]=(0,F.localize)(0,null),R[E.Warning]=(0,F.localize)(1,null),R[E.Info]=(0,F.localize)(2,null);function I(D){return R[D]||""}E.toString=I;function v(D){switch(D){case C.default.Error:return E.Error;case C.default.Warning:return E.Warning;case C.default.Info:return E.Info;case C.default.Ignore:return E.Hint}}E.fromSeverity=v;function y(D){switch(D){case E.Error:return C.default.Error;case E.Warning:return C.default.Warning;case E.Info:return C.default.Info;case E.Hint:return C.default.Ignore}}E.toSeverity=y}(A||(e.MarkerSeverity=A={}));var b;(function(E){const w="";function R(v){return I(v,!0)}E.makeKey=R;function I(v,y){const D=[w];return v.source?D.push(v.source.replace("\xA6","\\\xA6")):D.push(w),v.code?typeof v.code=="string"?D.push(v.code.replace("\xA6","\\\xA6")):D.push(v.code.value.replace("\xA6","\\\xA6")):D.push(w),v.severity!==void 0&&v.severity!==null?D.push(A.toString(v.severity)):D.push(w),v.message&&y?D.push(v.message.replace("\xA6","\\\xA6")):D.push(w),v.startLineNumber!==void 0&&v.startLineNumber!==null?D.push(v.startLineNumber.toString()):D.push(w),v.startColumn!==void 0&&v.startColumn!==null?D.push(v.startColumn.toString()):D.push(w),v.endLineNumber!==void 0&&v.endLineNumber!==null?D.push(v.endLineNumber.toString()):D.push(w),v.endColumn!==void 0&&v.endColumn!==null?D.push(v.endColumn.toString()):D.push(w),D.push(w),D.join("\xA6")}E.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.$8s=(0,d.$Nh)("markerService")}),define(De[243],Ce([1,0,4,38,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Vu=e.Severity=void 0,e.Severity=F.default,e.$Vu=(0,d.$Nh)("notificationService");var M;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var b;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(b||(e.NotificationsFilter=b={}));class E{constructor(){this.progress=new w,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$Wu=E;class w{infinite(){}done(){}total(I){}worked(I){}}e.$Xu=w}),define(De[134],Ce([1,0,15,2,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aU=e.$_T=e.$$T=e.$0T=e.$9T=void 0,e.$9T=(0,d.$Nh)("openerService");function M(w,R){return F.URI.isUri(w)?(0,C.$1e)(w.scheme,R):(0,C.$2e)(w,R+":")}e.$0T=M;function A(w,...R){return R.some(I=>M(w,I))}e.$$T=A;function b(w,R){return w.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$_T=b;function E(w){let R;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(w.fragment);return I&&(R={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},w=w.with({fragment:""})),{selection:R,uri:w}}e.$aU=E}),define(De[244],Ce([1,0,12,48]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let d;if(typeof C.$h.vscode<"u"&&typeof C.$h.vscode.context<"u"){const M=C.$h.vscode.context.configuration();if(M)d=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(d=globalThis._VSCODE_PRODUCT_JSON,F.env.VSCODE_DEV&&Object.assign(d,{nameShort:`${d.nameShort} Dev`,nameLong:`${d.nameLong} Dev`,dataFolderName:`${d.dataFolderName}-dev`,serverDataFolderName:d.serverDataFolderName?`${d.serverDataFolderName}-dev`:void 0}),!d.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(d,{version:M.version})}}else d={},Object.keys(d).length===0&&Object.assign(d,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=d}),define(De[135],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,C.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function($e,e){return function(C,F){e(C,F,$e)}};define(De[84],Ce([1,0,9,21,3,5]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4u=e.$3u=e.$2u=e.$1u=e.$Zu=e.ProgressLocation=e.$Yu=void 0,e.$Yu=(0,M.$Nh)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Zu=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,v){this.e=I,this.report=v?.async?this.g.bind(this):this.f.bind(this)}f(I){this.a=I,this.e(this.a)}g(I){this.b?this.b.push(I):this.b=[I],this.h()}async h(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const I=this.b.shift();this.a=I,await this.e(this.a)}}finally{this.c=!1;const I=this.d;this.d=void 0,I?.()}}drain(){return this.c?new Promise(I=>{const v=this.d;this.d=()=>{v?.(),I()}}):Promise.resolve()}}e.$1u=b;let E=class extends d.$Rc{constructor(I,v){super(),this.a=new C.$bh,v.withProgress(I,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,d.$Pc)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$2u=E,e.$2u=E=He([Be(1,e.$Yu)],E);class w extends d.$Rc{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new d.$Qc)}start(I){this.stop();const v=++this.a,y=new F.$Wd;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,d.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,d.$Pc)(()=>y.cancel())),this.b.add((0,d.$Pc)(()=>this.c?this.c.done():void 0)),{id:v,token:y.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$3u=w,e.$4u=(0,M.$Nh)("editorProgressService")}),define(De[42],Ce([1,0,58,18]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0;class d{constructor(){this.a=new Map}add(A,b){C.ok(F.$xf(A)),C.ok(F.$zf(b)),C.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,b)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$cn=new d}),define(De[105],Ce([1,0,4,42]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=void 0,e.$dn={JSONContribution:"base.contributions.json"};function d(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class M{constructor(){this.b=new C.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,w){this.a[d(E)]=w,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;F.$cn.add(e.$dn.JSONContribution,A)}),define(De[136],Ce([1,0,19,4,18,188,50,105,42]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.ConfigurationScope=e.$hn=e.EditPresentationTypes=void 0;var w;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$hn={Configuration:"base.contributions.configuration"};var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on="vscode://schemas/settings/resourceLanguage",e.$pn="vscode://schemas/settings/configurationDefaults";const I=E.$cn.as(b.$dn.JSONContribution);class v{constructor(){this.h=new Set,this.i=new F.$Md,this.onDidSchemaChange=this.i.event,this.j=new F.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$on,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const a=new Set;this.n(t,n,a),I.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const n=new Set;this.o(t,n),I.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const a=new Set;this.o(n,a),this.n(t,!1,a),I.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const a=[];for(const{overrides:i,source:s}of t)for(const u in i)if(n.add(u),e.$rn.test(u)){const S=this.a.get(u),k=S?.valuesSources??new Map;if(s)for(const P of Object.keys(i[u]))k.set(P,s);const $={...S?.value||{},...i[u]};this.a.set(u,{source:s,value:$,valuesSources:k});const f=(0,A.$ri)(u),g={type:"object",default:$,description:M.localize(1,null,f),$ref:e.$on,defaultDefaultValue:$,source:d.$xf(s)?void 0:s,defaultValueSource:s};a.push(...p(u)),this.d[u]=g,this.b.properties[u]=g}else{this.a.set(u,{value:i[u],source:s});const S=this.d[u];S&&(this.w(u,S),this.r(u,S))}this.m(a)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:a,source:i}of t)for(const s in a){const u=this.a.get(s),S=d.$xf(i)?i:i?.id,k=d.$xf(u?.source)?u?.source:u?.source?.id;if(S===k)if(n.add(s),this.a.delete(s),e.$rn.test(s))delete this.d[s],delete this.b.properties[s];else{const $=this.d[s];$&&(this.w(s,$),this.r(s,$))}}this.u()}deltaConfiguration(t){let n=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,a){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,a),this.c.push(i),this.q(i)})}o(t,n){const a=i=>{if(i.properties)for(const s in i.properties){n.add(s);const u=this.d[s];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>a(s))};for(const i of t){a(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(t,n=!0,a,i,s=3,u){s=d.$Gf(t.scope)?s:t.scope;const S=t.properties;if(S)for(const $ in S){const f=S[$];if(n&&o($,f)){delete S[$];continue}if(f.source=a,f.defaultDefaultValue=S[$].default,this.w($,f),e.$rn.test($)?f.scope=void 0:(f.scope=d.$Gf(f.scope)?s:f.scope,f.restricted=d.$Gf(f.restricted)?!!i?.includes($):f.restricted),S[$].hasOwnProperty("included")&&!S[$].included){this.f[$]=S[$],delete S[$];continue}else this.d[$]=S[$],S[$].policy?.name&&this.e.set(S[$].policy.name,$);!S[$].deprecationMessage&&S[$].markdownDeprecationMessage&&(S[$].deprecationMessage=S[$].markdownDeprecationMessage),u.add($)}const k=t.allOf;if(k)for(const $ of k)this.p($,n,a,i,s,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=a=>{const i=a.properties;if(i)for(const u in i)this.r(u,i[u]);a.allOf?.forEach(n)};n(t)}r(t,n){switch(e.$in.properties[t]=n,n.scope){case 1:e.$jn.properties[t]=n;break;case 2:e.$kn.properties[t]=n;break;case 6:e.$ln.properties[t]=n;break;case 3:e.$mn.properties[t]=n;break;case 4:e.$nn.properties[t]=n;break;case 5:e.$nn.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.$in.properties[t],n.scope){case 1:delete e.$jn.properties[t];break;case 2:delete e.$kn.properties[t];break;case 6:delete e.$ln.properties[t];break;case 3:delete e.$mn.properties[t];break;case 4:case 5:delete e.$nn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,a={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$on};this.w(n,a),e.$in.properties[n]=a,e.$jn.properties[n]=a,e.$kn.properties[n]=a,e.$ln.properties[n]=a,e.$mn.properties[n]=a,e.$nn.properties[n]=a}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$on};e.$in.patternProperties[e.$qn]=t,e.$jn.patternProperties[e.$qn]=t,e.$kn.patternProperties[e.$qn]=t,e.$ln.patternProperties[e.$qn]=t,e.$mn.patternProperties[e.$qn]=t,e.$nn.patternProperties[e.$qn]=t,this.i.fire()}w(t,n){const a=this.a.get(t);let i=a?.value,s=a?.source;d.$Ef(i)&&(i=n.defaultDefaultValue,s=void 0),d.$Ef(i)&&(i=c(n.type)),n.default=i,n.defaultValueSource=s}}const y="\\[([^\\]]+)\\]",D=new RegExp(y,"g");e.$qn=`^(${y})+$`,e.$rn=new RegExp(e.$qn);function p(h){const t=[];if(e.$rn.test(h)){let n=D.exec(h);for(;n?.length;){const a=n[1].trim();a&&t.push(a),n=D.exec(h)}}return(0,C.$Lb)(t)}e.$sn=p;function l(h){return h.reduce((t,n)=>`${t}[${n}]`,"")}e.$tn=l;function c(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$un=c;const r=new v;E.$cn.add(e.$hn.Configuration,r);function o(h,t){return h.trim()?e.$rn.test(h)?M.localize(7,null,h):r.getConfigurationProperties()[h]!==void 0?M.localize(8,null,h):t.policy?.name&&r.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,h,t.policy?.name,r.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$vn=o;function m(){const h=[],t=r.getConfigurationProperties();for(const n of Object.keys(t))h.push([n,t[n].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$wn=m}),define(De[245],Ce([1,0,19,4,157,3,28,24,18,2,50,136,42]),function($e,e,C,F,d,M,A,b,E,w,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=void 0;function y(n){return Object.isFrozen(n)?n:b.$4m(n)}class D{constructor(a={},i=[],s=[],u){this.b=a,this.c=i,this.d=s,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(i=>{if(i instanceof D)return i;const s=new p("");return s.parseRaw(i),s.configurationModel});this.f=a.reduce((i,s)=>s===i?s:i.merge(s),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,R.$pi)(this.contents,a):this.contents}inspect(a,i){const s=this.rawConfiguration.getValue(a),u=i?this.rawConfiguration.getOverrideValue(a,i):void 0,S=i?this.rawConfiguration.override(i).getValue(a):s;return{value:s,override:u,merged:S}}getOverrideValue(a,i){const s=this.i(i);return s?a?(0,R.$pi)(s,a):s:void 0}getKeysForOverrideIdentifier(a){const i=[];for(const s of this.overrides)s.identifiers.includes(a)&&i.push(...s.keys);return C.$Lb(i)}getAllOverrideIdentifiers(){const a=[];for(const i of this.overrides)a.push(...i.identifiers);return C.$Lb(a)}override(a){let i=this.a.get(a);return i||(i=this.g(a),this.a.set(a,i)),i}merge(...a){const i=b.$3m(this.contents),s=b.$3m(this.overrides),u=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const k of a)if(S.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(i,k.contents);for(const $ of k.overrides){const[f]=s.filter(g=>C.$tb(g.identifiers,$.identifiers));f?(this.h(f.contents,$.contents),f.keys.push(...$.keys),f.keys=C.$Lb(f.keys)):s.push(b.$3m($))}for(const $ of k.keys)u.indexOf($)===-1&&u.push($)}return new D(i,u,s,S.every(k=>k instanceof D)?void 0:S)}g(a){const i=this.i(a);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const u of C.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let S=this.contents[u];const k=i[u];k&&(typeof S=="object"&&typeof k=="object"?(S=b.$3m(S),this.h(S,k)):S=k),s[u]=S}return new D(s,this.keys,this.overrides)}h(a,i){for(const s of Object.keys(i)){if(s in a&&E.$zf(a[s])&&E.$zf(i[s])){this.h(a[s],i[s]);continue}a[s]=b.$3m(i[s])}}i(a){let i=null,s=null;const u=S=>{S&&(s?this.h(s,S):s=b.$3m(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===a?i=S.contents:S.identifiers.includes(a)&&u(S.contents);return u(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,i){this.j(a,i,!0)}setValue(a,i){this.j(a,i,!1)}removeValue(a){const i=this.keys.indexOf(a);i!==-1&&(this.keys.splice(i,1),(0,R.$oi)(this.contents,a),I.$rn.test(a)&&this.overrides.splice(this.overrides.findIndex(s=>C.$tb(s.identifiers,(0,I.$sn)(a))),1))}j(a,i,s){(0,R.$ni)(this.contents,a,i,u=>console.error(u)),s=s||this.keys.indexOf(a)===-1,s&&this.keys.push(a),I.$rn.test(a)&&this.overrides.push({identifiers:(0,I.$sn)(a),keys:Object.keys(this.contents[a]),contents:(0,R.$mi)(this.contents[a],u=>console.error(u))})}}e.$xn=D;class p{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,i){if(!E.$Gf(a)){const s=this.g(a);this.parseRaw(s,i)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,i){this.a=a;const{contents:s,keys:u,overrides:S,restricted:k,hasExcludedProperties:$}=this.h(a,i);this.b=new D(s,u,S,$?[a]:void 0),this.c=k||[]}g(a){let i={},s=null,u=[];const S=[],k=[];function $(g){Array.isArray(u)?u.push(g):s!==null&&(u[s]=g)}const f={onObjectBegin:()=>{const g={};$(g),S.push(u),u=g,s=null},onObjectProperty:g=>{s=g},onObjectEnd:()=>{u=S.pop()},onArrayBegin:()=>{const g=[];$(g),S.push(u),u=g,s=null},onArrayEnd:()=>{u=S.pop()},onLiteralValue:$,onError:(g,P,O)=>{k.push({error:g,offset:P,length:O})}};if(a)try{d.$Zm(a,f),i=u[0]||{}}catch(g){console.error(`Error while parsing settings file ${this.f}: ${g}`),this.d=[g]}return i}h(a,i){const s=v.$cn.as(I.$hn.Configuration).getConfigurationProperties(),u=this.i(a,s,!0,i);a=u.raw;const S=(0,R.$mi)(a,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),k=Object.keys(a),$=this.j(a,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:S,keys:k,overrides:$,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(a,i,s,u){let S=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:S};const k={},$=[];for(const f in a)if(I.$rn.test(f)&&s){const g=this.i(a[f],i,!1,u);k[f]=g.raw,S=S||g.hasExcludedProperties,$.push(...g.restricted)}else{const g=i[f],P=g?typeof g.scope<"u"?g.scope:3:void 0;g?.restricted&&$.push(f),!u.exclude?.includes(f)&&(u.include?.includes(f)||(P===void 0||u.scopes===void 0||u.scopes.includes(P))&&!(u.skipRestricted&&g?.restricted))?k[f]=a[f]:S=!0}return{raw:k,restricted:$,hasExcludedProperties:S}}j(a,i){const s=[];for(const u of Object.keys(a))if(I.$rn.test(u)){const S={};for(const k in a[u])S[k]=a[u][k];s.push({identifiers:(0,I.$sn)(u),keys:Object.keys(S),contents:(0,R.$mi)(S,i)})}return s}}e.$yn=p;class l extends M.$Rc{constructor(a,i,s,u){super(),this.c=a,this.f=i,this.g=u,this.b=this.B(new F.$Md),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&s.isEqual(S.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new D}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zn=l;class c{constructor(a,i,s,u,S,k,$,f,g,P,O,N,L){this.a=a,this.b=i,this.c=s,this.overrideIdentifiers=u,this.d=S,this.f=k,this.g=$,this.h=f,this.i=g,this.j=P,this.k=O,this.l=N,this.m=L}get value(){return y(this.c)}n(a,i,s){const u=a.inspect(i,s);return{get value(){return y(u.value)},get override(){return y(u.override)},get merged(){return y(u.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class r{constructor(a,i,s,u,S=new D,k=new D,$=new A.$zc,f=new D,g=new A.$zc){this.c=a,this.d=i,this.f=s,this.g=u,this.h=S,this.i=k,this.j=$,this.l=f,this.m=g,this.a=null,this.b=new A.$zc,this.n=null}getValue(a,i,s){return this.q(a,i,s).getValue(a)}updateValue(a,i,s={}){let u;s.resource?(u=this.m.get(s.resource),u||(u=new D,this.m.set(s.resource,u))):u=this.l,i===void 0?u.removeValue(a):u.setValue(a,i),s.resource||(this.a=null)}inspect(a,i,s){const u=this.q(a,i,s),S=this.u(i.resource,s),k=i.resource?this.m.get(i.resource)||this.l:this.l,$=new Set;for(const f of u.overrides)for(const g of f.identifiers)u.getOverrideValue(a,g)!==void 0&&$.add(g);return new c(a,i,u.getValue(a),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,S||void 0,k)}keys(a){const i=this.u(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,i){this.j.set(a,i),this.b.delete(a)}deleteFolderConfiguration(a){this.p.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,i){const s=[];if(!i){const{added:u,updated:S,removed:k}=h(this.c,a);i=[...u,...S,...k]}for(const u of i)for(const S of(0,I.$sn)(u)){const k=this.c.getKeysForOverrideIdentifier(S),$=a.getKeysForOverrideIdentifier(S),f=[...$.filter(g=>k.indexOf(g)===-1),...k.filter(g=>$.indexOf(g)===-1),...k.filter(g=>!b.$7m(this.c.override(S).getValue(g),a.override(S).getValue(g)))];s.push([S,f])}return this.updateDefaultConfiguration(a),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(a){const{added:i,updated:s,removed:u}=h(this.d,a),S=[...i,...s,...u];return S.length&&this.updatePolicyConfiguration(a),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:i,updated:s,removed:u,overrides:S}=h(this.applicationConfiguration,a),k=[...i,...s,...u];return k.length&&this.updateApplicationConfiguration(a),{keys:k,overrides:S}}compareAndUpdateLocalUserConfiguration(a){const{added:i,updated:s,removed:u,overrides:S}=h(this.localUserConfiguration,a),k=[...i,...s,...u];return k.length&&this.updateLocalUserConfiguration(a),{keys:k,overrides:S}}compareAndUpdateRemoteUserConfiguration(a){const{added:i,updated:s,removed:u,overrides:S}=h(this.remoteUserConfiguration,a),k=[...i,...s,...u];return k.length&&this.updateRemoteUserConfiguration(a),{keys:k,overrides:S}}compareAndUpdateWorkspaceConfiguration(a){const{added:i,updated:s,removed:u,overrides:S}=h(this.workspaceConfiguration,a),k=[...i,...s,...u];return k.length&&this.updateWorkspaceConfiguration(a),{keys:k,overrides:S}}compareAndUpdateFolderConfiguration(a,i){const s=this.p.get(a),{added:u,updated:S,removed:k,overrides:$}=h(s,i),f=[...u,...S,...k];return(f.length||!s)&&this.updateFolderConfiguration(a,i),{keys:f,overrides:$}}compareAndDeleteFolderConfiguration(a){const i=this.p.get(a);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:s,updated:u,removed:S,overrides:k}=h(i,void 0);return{keys:[...s,...u,...S],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(a,i,s){let u=this.r(i,s);return i.overrideIdentifier&&(u=u.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(u=u.merge(this.d)),u}r({resource:a},i){let s=this.s();if(i&&a){const u=i.getFolder(a);u&&(s=this.t(u.uri)||s);const S=this.m.get(a);S&&(s=s.merge(S))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(a){let i=this.b.get(a);if(!i){const s=this.s(),u=this.j.get(a);u?(i=s.merge(u),this.b.set(a,i)):i=s}return i}u(a,i){if(i&&a){const s=i.getFolder(a);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,i)=>{const{contents:s,overrides:u,keys:S}=this.j.get(i);return a.push([i,{contents:s,overrides:u,keys:S}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(i=>a.add(i)),this.userConfiguration.keys.forEach(i=>a.add(i)),this.i.keys.forEach(i=>a.add(i)),this.j.forEach(i=>i.keys.forEach(s=>a.add(s))),[...a.values()]}v(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>a.add(s))),[...a.values()]}w(a){const i=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(s=>i.add(s)),this.i.getKeysForOverrideIdentifier(a).forEach(s=>i.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(a).forEach(u=>i.add(u))),[...i.values()]}static parse(a){const i=this.x(a.defaults),s=this.x(a.policy),u=this.x(a.application),S=this.x(a.user),k=this.x(a.workspace),$=a.folders.reduce((f,g)=>(f.set(w.URI.revive(g[0]),this.x(g[1])),f),new A.$zc);return new r(i,s,u,S,new D,k,$,new D,new A.$zc)}static x(a){return new D(a.contents,a.keys,a.overrides)}}e.$An=r;function o(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const a=new Set,i=new Map;for(const u of n)u.keys.forEach(S=>a.add(S)),u.overrides.forEach(([S,k])=>{const $=(0,A.$wc)(i,S,new Set);k.forEach(f=>$.add(f))});const s=[];return i.forEach((u,S)=>s.push([S,[...u.values()]])),{keys:[...a.values()],overrides:s}}e.$Bn=o;class m{constructor(a,i,s,u){this.change=a,this.f=i,this.g=s,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of a.keys)this.affectedKeys.add(S);for(const[,S]of a.overrides)for(const k of S)this.affectedKeys.add(k);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(a,i){const s=this.a+a,u=this.d.indexOf(s);if(u<0)return!1;const S=u+s.length;if(S>=this.d.length)return!1;const k=this.d.charCodeAt(S);if(k!==this.b&&k!==this.c)return!1;if(i){const $=this.previousConfiguration?this.previousConfiguration.getValue(a,i,this.f?.workspace):void 0,f=this.g.getValue(a,i,this.h);return!b.$7m($,f)}return!0}}e.$Cn=m;function h(n,a){const{added:i,removed:s,updated:u}=t(a?.rawConfiguration,n?.rawConfiguration),S=[],k=n?.getAllOverrideIdentifiers()||[],$=a?.getAllOverrideIdentifiers()||[];if(a){const f=$.filter(g=>!k.includes(g));for(const g of f)S.push([g,a.getKeysForOverrideIdentifier(g)])}if(n){const f=k.filter(g=>!$.includes(g));for(const g of f)S.push([g,n.getKeysForOverrideIdentifier(g)])}if(a&&n){for(const f of k)if($.includes(f)){const g=t({contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)},{contents:a.getOverrideValue(void 0,f)||{},keys:a.getKeysForOverrideIdentifier(f)});S.push([f,[...g.added,...g.removed,...g.updated]])}}return{added:i,removed:s,updated:u,overrides:S}}function t(n,a){const i=n?a?n.keys.filter(S=>a.keys.indexOf(S)===-1):[...n.keys]:[],s=a?n?a.keys.filter(S=>n.keys.indexOf(S)===-1):[...a.keys]:[],u=[];if(n&&a){for(const S of a.keys)if(n.keys.indexOf(S)!==-1){const k=(0,R.$pi)(a.contents,S),$=(0,R.$pi)(n.contents,S);b.$7m(k,$)||u.push(S)}}return{added:i,removed:s,updated:u}}}),define(De[246],Ce([1,0,22,4,3,81]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkb=e.$ukb=e.$tkb=e.$skb=void 0;const A=(w,R,I)=>{const v=new Uint8Array(16);for(let p=0;p<16;p++)v[p]=Math.round(Math.random()*256);const y=(0,C.$ue)(C.$ae.wrap(v));return[`GET ws://localhost${w}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$skb=A,e.$tkb=C.$ae.fromString(`\r
\r
`);async function b(w,R,I,v,y){w.write(C.$ae.fromString((0,e.$skb)(R,I,v)));const D=new d.$Qc;try{return await new Promise((p,l)=>{let c;D.add(w.onData(r=>{c?c=C.$ae.concat([c,r],c.byteLength+r.byteLength):c=r;const o=c.indexOf(e.$tkb);if(o===-1)return;p(w),w.pauseData();const m=c.slice(o+e.$tkb.byteLength);m.byteLength&&y.onData.fire(m)})),D.add(w.onClose(r=>l(r??new Error("socket closed")))),D.add(w.onEnd(()=>l(new Error("socket ended"))))})}catch(p){throw w.dispose(),p}finally{D.dispose()}}e.$ukb=b;class E extends d.$Rc{constructor(R,I){super(),this.g=R,this.a=this.B(new F.$Pd),this.onData=(...v)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...v)),this.b=this.B(new F.$Md),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(v=>this.a.fire(v))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,I){M.SocketDiagnostics.traceSocketEvent(this,this.g,R,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$vkb=E}),define(De[64],Ce([1,0,8,5]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.RemoteAuthorityResolverErrorCode=e.$Pk=e.$Ok=e.RemoteConnectionType=e.$Nk=void 0,e.$Nk=(0,F.$Nh)("remoteAuthorityResolverService");var d;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(d||(e.RemoteConnectionType=d={}));class M{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ok=M;class A{constructor(I,v){this.host=I,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Pk=A;var b;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class E extends C.$ab{static isNotAvailable(I){return I instanceof E&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof E&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof E&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof E&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof E&&I.isHandled}constructor(I,v=b.Unknown,y){super(I),this._message=I,this._code=v,this._detail=y,this.isHandled=v===b.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Qk=E;function w(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}e.$Rk=w}),define(De[65],Ce([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=void 0;function F(w){return w.scheme===C.Schemas.vscodeRemote?w.authority:void 0}e.$Sk=F;function d(w){if(!w)return;const R=w.indexOf("+");return R<0?w:w.substr(0,R)}e.$Tk=d;function M(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$Uk=M;function A(w){const{host:R,port:I}=E(w);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:I}}e.$Vk=A;function b(w,R){let{host:I,port:v}=E(w);return typeof v>"u"&&(v=R),{host:I,port:v}}e.$Wk=b;function E(w){const R=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const I=w.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const v=w.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:w,port:void 0}}}),define(De[25],Ce([1,0,15,5,65]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.TargetPlatform=e.ExtensionType=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=void 0,e.$Wl="extensions.user.cache",e.$Xl="extensions.builtin.cache",e.$Yl="undefined_publisher",e.$Zl=["ui","workspace","web"];function M(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$1l=M,e.$2l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(A||(e.ExtensionType=A={}));var b;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class E{constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,c){if(typeof l>"u"||l===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof l=="string"||typeof c=="string"){const r=typeof l=="string"?l:l.value,o=typeof c=="string"?c:c.value;return C.$1e(r,o)}return l._lower===c._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.$3l=E;class w{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const c of l)this.add(c)}add(l){this.c.add(E.toKey(l))}delete(l){return this.c.delete(E.toKey(l))}has(l){return this.c.has(E.toKey(l))}}e.$4l=w;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete(E.toKey(l))}get(l){return this.c.get(E.toKey(l))}has(l){return this.c.has(E.toKey(l))}set(l,c){this.c.set(E.toKey(l),c)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$5l=R;function I(p){return v(p)}e.$6l=I;function v(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$7l=v;function y(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$8l=y;function D(p,l){if(l){const c=`onResolveRemoteAuthority:${(0,d.$Tk)(l)}`;return!!p.activationEvents?.includes(c)}return!1}e.$9l=D,e.$0l=(0,F.$Nh)("IBuiltinExtensionsScannerService")}),define(De[137],Ce([1,0,8,25]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RE=e.$QE=void 0;class d{constructor(){this.a=new Map,this.b=new WeakMap}register(A,b){this.a.set(A,b)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const b=Object.create(null);for(const E of A){const w=this.readActivationEvents(E);w.length>0&&(b[F.$3l.toKey(E.identifier)]=w)}return b}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const b=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return b;for(const E in A.contributes){const w=this.a.get(E);if(!w)continue;const R=A.contributes[E],I=Array.isArray(R)?R:[R];try{w(I,b)}catch(v){(0,C.$Z)(v)}}return b}}e.$QE=d,e.$RE=new d}),define(De[247],Ce([1,0,9,22,21,8,4,3,54,37,31,81,64,65]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.PersistentConnectionEventType=e.$4k=e.$3k=e.$2k=e.ConnectionType=void 0;const D=30*1e3;var p;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function l(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(G){const U=new d.$Wd;return setTimeout(()=>U.cancel(),G),U.token}function r(G,U){if(G.isCancellationRequested||U.isCancellationRequested)return d.CancellationToken.Cancelled;const q=new d.$Wd;return G.onCancellationRequested(()=>q.cancel()),U.onCancellationRequested(()=>q.cancel()),q.token}class o{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Qc,this.promise=new Promise((q,me)=>{this.f=q,this.g=me}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function m(G,U){const q=new o(U);return q.registerDisposable(G.onControlMessage(me=>{const _=JSON.parse(me.toString()),ie=Q(_);ie?q.reject(ie):q.resolve(_)})),q.promise}function h(G,U,q,me,_,ie,re,Ee){const ce=new o(Ee),de=w.$Id.create(!1);return G.info(`Creating a socket (${re})...`),E.mark(`code/willCreateSocket/${ie}`),U.connect(q,me,_,re).then(ee=>{ce.didTimeout?(E.mark(`code/didCreateSocketError/${ie}`),G.info(`Creating a socket (${re}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(E.mark(`code/didCreateSocketOK/${ie}`),G.info(`Creating a socket (${re}) was successful after ${de.elapsed()} ms.`),ce.resolve(ee))},ee=>{E.mark(`code/didCreateSocketError/${ie}`),G.info(`Creating a socket (${re}) returned an error after ${de.elapsed()} ms.`),G.error(ee),ce.reject(ee)}),ce.promise}function t(G,U){const q=new o(U);return G.then(me=>{q.didTimeout||q.resolve(me)},me=>{q.didTimeout||q.reject(me)}),q.promise}async function n(G,U,q,me){const _=ae(G,U);G.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let ie;try{ie=await h(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,y.$Uk)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,l(U),`renderer-${l(U)}-${G.reconnectionToken}`,me)}catch(ee){throw G.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),G.logService.error(ee),ee}G.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let re,Ee;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(ie,null),re=G.reconnectionProtocol,Ee=!1):(re=new I.$Bh({socket:ie}),Ee=!0),G.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const ce=await t(G.signService.createNewMessage((0,R.$dg)()),me),de={type:"auth",auth:G.connectionToken||"00000000000000000000",data:ce.data};re.sendControl(F.$ae.fromString(JSON.stringify(de)));try{const ee=await m(re,r(me,c(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(G.logService.trace(`${_} 4/6. received SignRequest control message.`),!await t(G.signService.validate(ce,ee.signedData),me)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const be=await t(G.signService.sign(ee.data),me),Pe={type:"connectionType",commit:G.commit,signedData:be,desiredConnectionType:U};return q&&(Pe.args=q),G.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),re.sendControl(F.$ae.fromString(JSON.stringify(Pe))),{protocol:re,ownsProtocol:Ee}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(G.logService.error(`${_} the handshake timed out. Error:`),G.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${_} received error control message when negotiating connection. Error:`),G.logService.error(ee)),Ee&&X(re),ee}}async function a(G,U,q,me){const _=Date.now(),ie=ae(G,U),{protocol:re,ownsProtocol:Ee}=await n(G,U,q,me),ce=new o(me);return ce.registerDisposable(re.onControlMessage(de=>{const ee=JSON.parse(de.toString()),he=Q(ee);he?(G.logService.error(`${ie} received error control message when negotiating connection. Error:`),G.logService.error(he),Ee&&X(re),ce.reject(he)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${ie} 6/6. handshake finished, connection is up and running after ${ve(_)}!`),ce.resolve({protocol:re,firstMessage:ee}))})),ce.promise}async function i(G,U){const{protocol:q}=await a(G,1,void 0,U);return{protocol:q}}async function s(G,U,q){const{protocol:me,firstMessage:_}=await a(G,2,U,q),ie=_&&_.debugPort;return{protocol:me,debugPort:ie}}async function u(G,U,q){const me=Date.now(),_=ae(G,3),{protocol:ie}=await n(G,3,U,q);return G.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${ve(me)}!`),ie}async function S(G,U,q){const{connectTo:me,connectionToken:_}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:me,connectionToken:_,reconnectionToken:U,reconnectionProtocol:q,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function k(G,U,q){return f(G,async me=>{const{protocol:_}=await i(me,d.CancellationToken.None);return new V(G,U,q,me.reconnectionToken,_)})}e.$2k=k;async function $(G,U){return f(G,async q=>{const{protocol:me,debugPort:_}=await s(q,U,d.CancellationToken.None);return new fe(G,U,q.reconnectionToken,me,_)})}e.$3k=$;async function f(G,U){for(let me=1;;me++)try{const _=(0,R.$dg)(),ie=await S(G,_,null);return await U(ie)}catch(_){if(me<5)G.logService.error(`[remote-connection][attempt ${me}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(_);else throw G.logService.error(`[remote-connection][attempt ${me}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(_),K.triggerPermanentFailure(0,0,v.$Qk.isHandled(_)),_}}async function g(G,U,q){const me=await S(G,(0,R.$dg)(),null);return await u(me,{host:U,port:q},d.CancellationToken.None)}e.$4k=g;function P(G){return(0,C.$Gg)(U=>new Promise((q,me)=>{const _=setTimeout(q,G*1e3);U.onCancellationRequested(()=>{clearTimeout(_),q()})}))}var O;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class N{constructor(U,q){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.type=0}}e.$5k=N;class L{constructor(U,q,me,_){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.durationSeconds=me,this.c=_,this.type=1}skipWait(){this.c.cancel()}}e.$6k=L;class j{constructor(U,q,me){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=me,this.type=2}}e.$7k=j;class z{constructor(U,q,me){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=me,this.type=4}}e.$8k=z;class T{constructor(U,q,me,_){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=me,this.handled=_,this.type=3}}e.$9k=T;class K extends b.$Rc{static triggerPermanentFailure(U,q,me){this._permanentFailure=!0,this.f=U,this.g=q,this.h=me,this.j.forEach(_=>_.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||K._permanentFailure}constructor(U,q,me,_,ie){super(),this.t=U,this.u=q,this.reconnectionToken=me,this.protocol=_,this.w=ie,this.m=this.B(new A.$Md),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(_.onSocketClose(re=>{const Ee=x(this.t,this.reconnectionToken,!0);re?re.type===0?(this.u.logService.info(`${Ee} received socket close event (hadError: ${re.hadError}).`),re.error&&this.u.logService.error(re.error)):(this.u.logService.info(`${Ee} received socket close event (wasClean: ${re.wasClean}, code: ${re.code}, reason: ${re.reason}).`),re.event&&this.u.logService.error(re.event)):this.u.logService.info(`${Ee} received socket close event.`),this.y()})),this.B(_.onSocketTimeout(re=>{const Ee=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Ee} received socket timeout event (unacknowledgedMsgCount: ${re.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${re.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${re.timeSinceLastReceivedSomeData}).`),this.y()})),K.j.push(this),this.B((0,b.$Pc)(()=>{const re=K.j.indexOf(this);re>=0&&K.j.splice(re,1)})),this.n&&this.D(K.f,K.g,K.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const q=[0,5,5,10,10,10,10,10,30];let me=-1;do{me++;const _=me<q.length?q[me]:q[q.length-1];try{if(_>0){const re=P(_);this.m.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,re)),this.u.logService.info(`${U} waiting for ${_} seconds before reconnecting...`);try{await re}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),me+1)),this.u.logService.info(`${U} resolving connection...`);const ie=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${ie.connectTo}...`),await this.G(ie,c(D)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),me+1));break}catch(ie){if(ie.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}if(me>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}if(v.$Qk.isTemporarilyNotAvailable(ie)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((ie.code==="ETIMEDOUT"||ie.code==="ENETUNREACH"||ie.code==="ECONNREFUSED"||ie.code==="ECONNRESET")&&ie.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((0,M.$3)(ie)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if(ie instanceof v.$Qk){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),me+1,v.$Qk.isHandled(ie));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}}while(!this.n&&!this.s)}C(U,q,me){this.w?K.triggerPermanentFailure(U,q,me):this.D(U,q,me)}D(U,q,me){this.m.fire(new T(this.reconnectionToken,U,q,me)),X(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$0k=K;class V extends K{constructor(U,q,me,_,ie){super(1,U,_,ie,!0),this.client=this.B(new I.$zh(ie,{remoteAuthority:q,clientId:me},U.ipcLogger))}async G(U,q){await i(U,q)}}e.$$k=V;class fe extends K{constructor(U,q,me,_,ie){super(2,U,me,_,!1),this.H=q,this.debugPort=ie}async G(U,q){await s(U,this.H,q)}}e.$_k=fe;function X(G){try{G.acceptDisconnect();const U=G.getSocket();G.dispose(),U.dispose()}catch(U){(0,M.$Z)(U)}}function Q(G){if(G&&G.type==="error"){const U=new Error(`Connection error: ${G.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Z(G,U){for(;G.length<U;)G+=" ";return G}function oe(G,U){return`[remote-connection][${Z(l(G),13)}][${U.substr(0,5)}\u2026]`}function x(G,U,q){return`${oe(G,U)}[${q?"reconnect":"initial"}]`}function ae(G,U){return`${x(U,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function ve(G){return`${Date.now()-G} ms`}}),define(De[248],Ce([1,0,3,5]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=void 0,e.$Xk=(0,F.$Nh)("remoteSocketFactoryService");class d{constructor(){this.a={}}register(A,b){return this.a[A]??=[],this.a[A].push(b),(0,C.$Pc)(()=>{const E=this.a[A]?.indexOf(b);typeof E=="number"&&E>=0&&this.a[A]?.splice(E,1)})}b(A){return(this.a[A.type]||[]).find(E=>E.supports(A))}connect(A,b,E,w){const R=this.b(A);if(!R)throw new Error(`No socket factory found for ${A}`);return R.connect(A,b,E,w)}}e.$Yk=d}),define(De[249],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$2b=void 0;class C{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(d){try{const M=await this.c();if(M){const A=String(C.a++);return this.b.set(A,M),{id:A,data:M.createNewMessage(d)}}}catch{}return{id:"",data:d}}async validate(d,M){if(!d.id)return!0;const A=this.b.get(d.id);if(!A)return!1;this.b.delete(d.id);try{return A.validate(M)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(d){try{return await this.d(d)}catch{}return d}}e.$$2b=C}),define(De[106],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=void 0,e.$Zk="signService",e.$1k=(0,C.$Nh)(e.$Zk)}),define(De[138],Ce([1,0,249]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0;class F extends C.$$2b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(A=>new A.signer().sign(M))}h(){return new Promise((M,A)=>$e(["vsda"],M,A))}}e.$Y7b=F}),define(De[250],Ce([1,0,12,48,31]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=void 0;function M(E){if(C.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,w,R,I,v,y,D,p){const l=Object.create(null);l["common.machineId"]=y,l.sessionID=(0,d.$dg)()+Date.now(),l.commitHash=I,l.version=v,l["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,C.$i)(C.$u),l["common.nodePlatform"]=F.$cc,l["common.nodeArch"]=R,l["common.product"]=p||"desktop",D&&(l["common.msftInternal"]=D);let c=0;const r=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),C.$m&&(l["common.snap"]="true");const o=M(w);return o&&(l["common.platformDetail"]=o),l}e.$eo=A;function b(E){const w=F.env.USERDNSDOMAIN;if(!w)return!1;const R=w.toLowerCase();return E.some(I=>R===I)}e.$fo=b}),define(De[251],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0,e.$al=(0,C.$Nh)("telemetryService"),e.$bl=(0,C.$Nh)("customEndpointTelemetryService"),e.$cl="telemetry.currentSessionDate",e.$dl="telemetry.firstSessionDate",e.$el="telemetry.lastSessionDate",e.$fl="telemetry.machineId",e.$gl="telemetry",e.$hl="telemetry.telemetryLevel",e.$il="telemetry.enableCrashReporter",e.$jl="telemetry.enableTelemetry";var F;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var d;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(d||(e.TelemetryConfiguration=d={}))}),define(De[85],Ce([1,0,24,18,4,50,65,250,251]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=void 0;class w{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$go=w;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ho=R,e.$io=new R;class I{async publicLog(s,u,S){}async publicLogError(s,u,S){}}e.$jo=I,e.$ko="telemetry",e.$lo="extensionTelemetryLog",e.$mo={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,s){return d.Event.debounce(s.onDidChangeConfiguration,(S,k)=>{const $=S?new Set([...S.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:$}},1e3,!0)(S=>{S.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,M.$ki)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$no=v;function y(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry)}e.$oo=y;function D(i,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$po=D;function p(i){const s=i.getValue(E.$hl),u=i.getValue(E.$il);if(i.getValue(E.$jl)===!1||u===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$qo=p;function l(i){const s={},u={},S={};o(i,S);for(let k in S){k=k.length>150?k.substr(k.length-149):k;const $=S[k];typeof $=="number"?u[k]=$:typeof $=="boolean"?u[k]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${$.length}`),s[k]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(s[k]=$)}return{properties:s,measurements:u}}e.$ro=l;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(i){if(!i)return"none";const s=(0,A.$Tk)(i);return c.has(s)?s:"other"}e.$so=r;function o(i,s,u=0,S){if(i)for(const k of Object.getOwnPropertyNames(i)){const $=i[k],f=S?S+k:k;Array.isArray($)?s[f]=(0,C.$8m)($):$ instanceof Date?s[f]=$.toISOString():(0,F.$zf)($)?u<2?o($,s,u+1,f+"."):s[f]=(0,C.$8m)($):s[f]=$}}function m(i,s){const u=i.msftInternalDomains||[],S=s.getValue("telemetry.internalTesting");return(0,b.$fo)(u)||S}e.$to=m;function h(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$uo=h;function t(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let u=i;const S=[];for(const g of s)for(;;){const P=g.exec(i);if(!P)break;S.push([P.index,g.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(u="";;){const g=$.exec(i);if(!g)break;const P=S.some(([O,N])=>g.index<N&&O<$.lastIndex);!k.test(g[0])&&!P&&(u+=i.substring(f,g.index)+"<REDACTED: user-file-path>",f=$.lastIndex)}return f<i.length&&(u+=i.substr(f)),u}function n(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of s)if(u.regex.test(i))return`<REDACTED: ${u.label}>`;return i}function a(i,s){return(0,C.$5m)(i,u=>{if(u instanceof w||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let S=u.replaceAll("%20"," ");S=t(S,s);for(const k of s)S=S.replace(k,"");return S=n(S),S}})}e.$vo=a}),define(De[252],Ce([1,0,15,132,25,12,2,8,48,85]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0;function R(a,i){return a.uuid&&i.uuid?a.uuid===i.uuid:a.id===i.id?!0:(0,C.$Ve)(a.id,i.id)===0}e.$wo=R;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const s=i.manifest?i.manifest.version:i.version,u=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,s,u)}static parse(i){const s=I.exec(i);return s&&s[1]&&s[2]?new v({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,u="undefined"){this.version=s,this.targetPlatform=u,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?R(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$xo=v;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(a){const i=y.exec(a);return i&&i[1]?[l(i[1]),i[2]]:[l(a),void 0]}e.$yo=D;function p(a,i){return`${a}.${i}`}e.$zo=p;function l(a){return a.toLowerCase()}e.$Ao=l;function c(a,i){return l(p(a??d.$Yl,i))}e.$Bo=c;function r(a,i){const s=[],u=S=>{for(const k of s)if(k.some($=>R(i($),i(S))))return k;return null};for(const S of a){const k=u(S);k?k.push(S):s.push([S])}return s}e.$Co=r;function o(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$Do=o;function m(a){return{id:new w.$go(a.identifier.id),name:new w.$go(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Eo=m,e.$Fo=new d.$3l("pprice.better-merge");function h(a,i){const s=[],u=i.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const S=u.shift();if(S&&s.every(k=>!R(k.identifier,{id:S}))){const k=a.filter($=>R($.identifier,{id:S}));k.length===1&&(s.push(k[0]),u.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$Go=h;async function t(a,i){if(!M.$l)return!1;let s;try{s=(await a.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await a.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){i.debug("Error while getting the os-release file.",(0,b.$9)(S))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(a,i){const s=await t(a,i),u=(0,F.$2n)(s?"alpine":M.$u,E.$dc);return i.debug("ComputeTargetPlatform:",u),u}e.$Ho=n}),define(De[253],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=e.$kr=e.$jr=e.$ir=e.$hr=void 0;function C(E){return[...E.entries()]}e.$hr=C;function F(E){return E?[...E.entries()]:[]}e.$ir=F;function d(E){return new Map(E)}e.$jr=d;function M(E){return new Map(E??[])}e.$kr=M;function A(E){return Array.from(E.entries()).map(w=>[w[0],C(w[1].map),F(w[1].descriptionMap)])}e.$lr=A;function b(E){return new Map(E.map(w=>[w[0],{map:d(w[1]),descriptionMap:M(w[2])}]))}e.$mr=b}),define(De[254],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkb=void 0;class C{constructor(d){this.b=d,this.a=new Map}dispose(){for(const d of this.a.values())d.dispose()}startBuffering(d,M,A=5){const b=M(E=>{const w=typeof E=="string"?E:E.data;let R=this.a.get(d);if(R){R.data.push(w);return}const I=setTimeout(()=>this.flushBuffer(d),A);R={data:[w],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(d),b.dispose()}},this.a.set(d,R)});return b}stopBuffering(d){this.a.get(d)?.dispose()}flushBuffer(d){const M=this.a.get(d);M&&(this.a.delete(d),this.b(d,M.data.join("")))}}e.$Lkb=C}),define(De[255],Ce([1,0,9,78,59,4,18,2,199,105,42]),function($e,e,C,F,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8v=e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.IconFontDefinition=e.IconContribution=e.$Zv=void 0,e.$Zv={IconContribution:"base.contributions.icons"};var I;(function(m){function h(t,n){let a=t.defaults;for(;d.ThemeIcon.isThemeIcon(a);){const i=D.getIcon(a.id);if(!i)return;a=i.defaults}return a}m.getDefinition=h})(I||(e.IconContribution=I={}));var v;(function(m){function h(n){return{weight:n.weight,style:n.style,src:n.src.map(a=>({format:a.format,location:a.location.toString()}))}}m.toJSONObject=h;function t(n){const a=i=>(0,A.$xf)(i)?i:void 0;if(n&&Array.isArray(n.src)&&n.src.every(i=>(0,A.$xf)(i.format)&&(0,A.$xf)(i.location)))return{weight:a(n.weight),style:a(n.style),src:n.src.map(i=>({format:i.format,location:b.URI.parse(i.location)}))}}m.fromJSONObject=t})(v||(e.IconFontDefinition=v={}));class y{constructor(){this.a=new M.$Md,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${d.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,t,n,a){const i=this.b[h];if(i){if(n&&!i.description){i.description=n,this.d.properties[h].markdownDescription=`${n} $(${h})`;const S=this.e.enum.indexOf(h);S!==-1&&(this.e.enumDescriptions[S]=n),this.a.fire()}return i}const s={id:h,description:n,defaults:t,deprecationMessage:a};this.b[h]=s;const u={$ref:"#/definitions/icons"};return a&&(u.deprecationMessage=a),n&&(u.markdownDescription=`${n}: $(${h})`),this.d.properties[h]=u,this.e.enum.push(h),this.e.enumDescriptions.push(n||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const t=this.e.enum.indexOf(h);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,t){const n=this.f[h];return n||(this.f[h]=t,this.a.fire(),t)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(i,s)=>i.id.localeCompare(s.id),t=i=>{for(;d.ThemeIcon.isThemeIcon(i.defaults);)i=this.b[i.defaults.id];return`codicon codicon-${i?i.id:""}`},n=[];n.push("| preview     | identifier                        | default codicon ID                | description"),n.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(i=>this.b[i]);for(const i of a.filter(s=>!!s.description).sort(h))n.push(`|<i class="${t(i)}"></i>|${i.id}|${d.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);n.push("| preview     | identifier                        "),n.push("| ----------- | --------------------------------- |");for(const i of a.filter(s=>!d.ThemeIcon.isThemeIcon(s.defaults)).sort(h))n.push(`|<i class="${t(i)}"></i>|${i.id}|`);return n.join(`
`)}}const D=new y;R.$cn.add(e.$Zv.IconContribution,D);function p(m,h,t,n){return D.registerIcon(m,h,t,n)}e.$1v=p;function l(){return D}e.$2v=l;function c(){const m=(0,F.$Qj)();for(const h in m){const t="\\"+m[h].toString(16);D.registerIcon(h,{fontCharacter:t})}}c(),e.$3v="vscode://schemas/icons";const r=R.$cn.as(w.$dn.JSONContribution);r.registerSchema(e.$3v,D.getIconSchema());const o=new C.$5g(()=>r.notifySchemaChanged(e.$3v),200);D.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$4v=p("widget-close",F.$Sj.close,(0,E.localize)(2,null)),e.$5v=p("goto-previous-location",F.$Sj.arrowUp,(0,E.localize)(3,null)),e.$6v=p("goto-next-location",F.$Sj.arrowDown,(0,E.localize)(4,null)),e.$7v=d.ThemeIcon.modify(F.$Sj.sync,"spin"),e.$8v=d.ThemeIcon.modify(F.$Sj.loading,"spin")}),define(De[86],Ce([1,0,4,50,5,13]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.ProvidedOnAutoForward=e.$7u=e.TunnelPrivacyId=e.TunnelProtocol=e.$6u=e.$5u=void 0,e.$5u=(0,d.$Nh)("tunnelService"),e.$6u=(0,d.$Nh)("sharedTunnelsService");var A;(function(l){l.Http="http",l.Https="https"})(A||(e.TunnelProtocol=A={}));var b;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(b||(e.TunnelPrivacyId=b={}));function E(l){return!!l.forwardPort}e.$7u=E;var w;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function R(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(c)return{address:c[1],port:+c[2]}}e.$8u=R,e.$9u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(l){return e.$9u.indexOf(l)>=0}e.$0u=I,e.$$u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(l){return e.$$u.indexOf(l)>=0}e.$_u=v;function y(l,c,r,o){if(r===1)return!1;if(r===2&&v(c)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(m?.length===4&&parseInt(m[1])>=18)return!1}return l<1024}e.$av=y;class D{constructor(c,r,o){this.remoteAddress=c,this.localAddress=r,this.b=o,this.a=new C.$Md,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$bv=D;let p=class{constructor(c,r){this.j=c,this.k=r,this.a=new C.$Md,this.onTunnelOpened=this.a.event,this.b=new C.$Md,this.onTunnelClosed=this.b.event,this.c=new C.$Md,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const c=this.k.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.f=c,c?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.g=c.elevation,this.h=c.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const c=[],r=Array.from(this.e.values());for(const o of r){const m=Array.from(o.values());for(const h of m){const t=await h.value;t&&typeof t!="string"&&c.push(t)}}return c}async dispose(){for(const c of this.e.values()){for(const{value:r}of c.values())await r.then(o=>typeof o!="string"?o?.dispose():void 0);c.clear()}this.e.clear()}setEnvironmentTunnel(c,r,o,m,h){this.p(c,r,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:r,localAddress:o,privacy:m,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,r){(v(c)||I(c))&&(c=e.$9u[0]);const o=this.r(c,r);if(o)return++o.refcount,o.value}openTunnel(c,r,o,m,h,t=!1,n,a){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${o} on local port ${h}.`);const i=this.f??c;if(!i)return;if(r||(r="localhost"),m||(m=this.l),this.f&&this.i.has(o)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.s(i,r,o,m,h,t,n,a);return s?s.then(u=>{if(u){if(typeof u=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(r,o),u}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(r,o);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n(u);return(u.tunnelRemoteHost!==r||u.tunnelRemotePort!==o)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&u.privacy!==n&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}n(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const r=this.e.get(c.tunnelRemoteHost);if(r){const o=r.get(c.tunnelRemotePort);o&&(o.refcount--,await this.o(c.tunnelRemoteHost,c.tunnelRemotePort,o))}}}}async o(c,r,o){if(o.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${r}.`);const m=o.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(c)&&this.e.get(c).delete(r),m}}async closeTunnel(c,r){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${r} `);const o=this.e.get(c);if(o&&o.has(r)){const m=o.get(r);m.refcount=0,await this.o(c,r,m)}}p(c,r,o){this.e.has(c)||this.e.set(c,new Map),this.e.get(c).set(r,{refcount:1,value:o})}async q(c,r){const o=this.e.get(c);if(o){const m=o.get(r),h=m?await m.value:void 0;(!h||typeof h=="string")&&o.delete(r),o.size===0&&this.e.delete(c)}}r(c,r){const o=[c];I(c)?(o.push(...e.$9u),o.push(...e.$$u)):v(c)&&o.push(...e.$$u);const m=o.map(h=>this.e.get(h));for(const h of m){const t=h?.get(r);if(t)return t}}canTunnel(c){return!!R(c)}t(c,r,o,m,h,t,n){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${o} on local port ${m}.`);const a=o;this.i.add(a);const i=m===void 0?o:m,s={elevationRequired:h?this.isPortPrivileged(i):!1},u={remoteAddress:{host:r,port:o},localAddressPort:m,privacy:t,public:t?t!==b.Private:void 0,protocol:n},S=c.forwardPort(u,s);return S?(this.p(r,o,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(a)})):this.i.delete(a),S}};e.$cv=p,e.$cv=p=He([Be(0,M.$8i),Be(1,F.$hi)],p)}),define(De[256],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=void 0,e.$Gk=(0,C.$Nh)("IUriIdentityService")}),define(De[257],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$dv=void 0,e.$dv=(0,C.$Nh)("editSessionIdentityService");var F;(function(d){d[d.Complete=100]="Complete",d[d.Partial=50]="Partial",d[d.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(De[258],Ce([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=void 0;function F(E){return E.scheme!==C.Schemas.file&&E.scheme!==C.Schemas.vscodeRemote}e.$JJ=F;function d(E){if(E.folders.length)return E.folders.every(w=>F(w.uri))?E.folders[0].uri:void 0;if(E.configuration&&F(E.configuration))return E.configuration}e.$KJ=d;function M(E){return d(E)?.scheme}e.$LJ=M;function A(E){return d(E)?.authority}e.$MJ=A;function b(E){return d(E)!==void 0}e.$NJ=b}),define(De[43],Ce([1,0,201,16,77,23,2,5,17]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,b.$Nh)("contextService");function w(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}e.$Xh=w;function R(i){return typeof i?.id=="string"&&!w(i)&&!v(i)}e.$Yh=R,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function I(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,F.$mc)(i)}:s?e.$Zh:e.$1h;const u=i;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}e.$2h=I;function v(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}e.$3h=v;function y(i){const s=i;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:A.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}e.$4h=y;var D;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(D||(e.WorkbenchState=D={}));function p(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$5h=p;function l(i){const s=i;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$6h=l;class c{constructor(s,u,S,k,$){this.h=s,this.j=S,this.k=k,this.l=$,this.c=d.$Th.forUris(this.l,()=>!0),this.folders=u}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=d.$Th.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=c;class r{constructor(s,u){this.raw=u,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,M.$ug)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=r;function o(i){return new r({uri:i,index:0,name:(0,M.$qg)(i)},{uri:i.toString()})}e.$9h=o,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,C.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function m(i,s){return M.$lg.isEqualOrParent(i,s.untitledWorkspacesHome)}e.$bi=m;function h(i){let s;return A.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===E.Schemas.tmp}e.$ci=h,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$di}e.$ei=t;function n(i,s){return!m(i,s)&&!h(i)}e.$fi=n;function a(i){return(typeof i=="string"?(0,F.$nc)(i):(0,M.$sg)(i))===e.$$h}e.$gi=a}),define(De[259],Ce([1,0,52,4,3,23,2,200,131,30,5,13,43,28,256,9,31,15,18]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.ProfileResourceType=void 0;var o;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(o||(e.ProfileResourceType=o={}));function m(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$Hk=m,e.$Ik=(0,R.$Nh)("IUserDataProfilesService");function h(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:s}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Jk=h;function t(i,s,u,S,k,$){return{id:i,name:s,location:u,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:$&&k?.useDefaultFlags?.globalState?$.globalStorageHome:(0,M.$ug)(u,"globalStorage"),settingsResource:$&&k?.useDefaultFlags?.settings?$.settingsResource:(0,M.$ug)(u,"settings.json"),keybindingsResource:$&&k?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,M.$ug)(u,"keybindings.json"),tasksResource:$&&k?.useDefaultFlags?.tasks?$.tasksResource:(0,M.$ug)(u,"tasks.json"),snippetsHome:$&&k?.useDefaultFlags?.snippets?$.snippetsHome:(0,M.$ug)(u,"snippets"),extensionsResource:$&&k?.useDefaultFlags?.extensions?$.extensionsResource:(0,M.$ug)(u,"extensions.json"),cacheHome:(0,M.$ug)(S,i),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$Kk=t;let n=class extends d.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,u,S,k){super(),this.t=s,this.u=u,this.w=S,this.y=k,this.f=!0,this.h=this.B(new F.$Md),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$Md),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$Md),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$Md),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$zc,emptyWindows:new Map},this.profilesHome=(0,M.$ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),u=[s];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,r.$xf)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}u.push(t((0,M.$rg)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},s))}}catch($){this.y.error($)}const S=new y.$zc,k=new Map;if(u.length)try{const $=this.Q();if($.workspaces)for(const[f,g]of Object.entries($.workspaces)){const P=A.URI.parse(f),O=u.find(N=>N.id===g);O&&S.set(P,O)}if($.emptyWindows)for(const[f,g]of Object.entries($.emptyWindows)){const P=u.find(O=>O.id===g);P&&k.set(f,P)}}catch($){this.y.error($)}this.z={profiles:u,workspaces:S,emptyWindows:k}}return this.z}D(){const s=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const u="Temp",S=new RegExp(`${(0,c.$Ee)(u)}\\s(\\d+)`);let k=0;for(const f of this.profiles){const g=S.exec(f.name),P=g?parseInt(g[1]):0;k=P>k?P:k}const $=`${u} ${k+1}`;return this.createProfile((0,C.$Bi)((0,l.$dg)()).toString(16),$,{transient:!0},s)}async createNamedProfile(s,u,S){return this.createProfile((0,C.$Bi)((0,l.$dg)()).toString(16),s,u,S)}async createProfile(s,u,S,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(s,u,S);return k&&await this.setProfileForWorkspace(k,$),$}async F(s,u,S){if(!(0,r.$xf)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(u);return k||(k=(async()=>{try{const $=this.profiles.find(P=>P.name===u||P.id===s);if($)return $;const f=t(s,u,(0,M.$ug)(this.profilesHome,s),this.g,S,this.defaultProfile);await this.u.createFolder(f.location);const g=[];return this.j.fire({profile:f,join(P){g.push(P)}}),await p.Promises.settled(g),this.I([f],[],[]),f}finally{this.r.delete(u)}})(),this.r.set(u,k)),k}async updateProfile(s,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(k=>k.id===s.id);if(!S)throw new Error(`Profile '${s.name}' does not exist`);return S=t(S.id,u.name??S.name,S.location,this.g,{shortName:u.shortName??S.shortName,icon:u.icon===null?void 0:u.icon??S.icon,transient:u.transient??S.isTransient,useDefaultFlags:u.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(k=>k.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);const S=[];this.m.fire({profile:u,join(k){S.push(k)}});try{await Promise.allSettled(S)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(k){(0,w.$nk)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(s,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(k=>k.id===u.id);if(!S)throw new Error(`Profile '${u.name}' does not exist`);this.L(s,S)}unsetWorkspace(s,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(u=>u.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(s.map(u=>this.removeProfile(u)))}getProfileForWorkspace(s){const u=this.G(s);return A.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(s){return(0,v.$Xh)(s)?s.uri:(0,v.$3h)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,s.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,s.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,s.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,s.location)))}I(s,u,S){const k=[...this.profiles,...s],$=[];this.s.profiles=[];for(let f of k)f.isDefault||u.some(g=>f.id===g.id)||(f=S.find(g=>f.id===g.id)??f,f.isTransient?this.s.profiles.push(f):$.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P($),this.z=void 0,this.J(s,u,S)}J(s,u,S){this.h.fire({added:s,removed:u,updated:S,all:this.profiles})}L(s,u,S){S=u?.isTransient?!0:S,S||this.L(s,void 0,!0);const k=this.G(s),$=S?this.s:this.C;A.URI.isUri(k)?($.workspaces.delete(k),u&&$.workspaces.set(k,u)):($.emptyWindows.delete(k),u&&$.emptyWindows.set(k,u)),S||this.M()}M(){const s={};for(const[S,k]of this.C.workspaces.entries())s[S.toString()]=k.id;const u={};for(const[S,k]of this.C.emptyWindows.entries())u[S.toString()]=k.id;this.R({workspaces:s,emptyWindows:u}),this.z=void 0}N(s){const u={},S=this.D();if(s.workspaces)for(const[$,f]of Object.entries(s.workspaces)){const g=A.URI.parse(f);u[$]=this.w.extUri.isEqual(g,S.location)?S.id:this.w.extUri.basename(g)}const k={};if(s.emptyWindows)for(const[$,f]of Object.entries(s.emptyWindows)){const g=A.URI.parse(f);k[$]=this.w.extUri.isEqual(g,S.location)?S.id:this.w.extUri.basename(g)}return{workspaces:u,emptyWindows:k}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Lk=n,e.$Lk=n=He([Be(0,E.$Uh),Be(1,w.$9j),Be(2,D.$Gk),Be(3,I.$8i)],n);class a extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Mk=a}),define(De[260],Ce([1,0,9,4,3,54,18,184,5,259]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$3o=e.$2o=e.$1o=void 0,e.$1o="__$__isNewStorageMarker",e.$2o="__$__targetStorageMarker",e.$3o=(0,E.$Nh)("storageService");var R;(function(r){r[r.NONE=0]="NONE",r[r.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var I;(function(r){r[r.APPLICATION=-1]="APPLICATION",r[r.PROFILE=0]="PROFILE",r[r.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var v;(function(r){r[r.USER=0]="USER",r[r.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function y(r){const o=r.get(e.$2o);if(o)try{return JSON.parse(o)}catch{}return Object.create(null)}e.$4o=y;class D extends d.$Rc{static{this.a=60*1e3}constructor(o={flushInterval:D.a}){super(),this.m=o,this.b=this.B(new F.$Pd),this.c=this.B(new F.$Pd),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$Md),this.onWillSaveState=this.f.event,this.h=this.B(new C.$5g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new d.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(o,m,h){return F.Event.filter(this.b.event,t=>t.scope===o&&(m===void 0||t.key===m),h)}n(){this.j.value=(0,C.$9g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,d.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(o,m){const{key:h,external:t}=m;if(h===e.$2o){switch(o){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:o})}else this.b.fire({scope:o,key:h,target:this.J(o)[h],external:t})}w(o){this.f.fire({reason:o})}get(o,m,h){return this.P(m)?.get(o,h)}getBoolean(o,m,h){return this.P(m)?.getBoolean(o,h)}getNumber(o,m,h){return this.P(m)?.getNumber(o,h)}getObject(o,m,h){return this.P(m)?.getObject(o,h)}storeAll(o,m){this.y(()=>{for(const h of o)this.store(h.key,h.value,h.scope,h.target,m)})}store(o,m,h,t,n=!1){if((0,A.$Gf)(m)){this.remove(o,h,n);return}this.y(()=>{this.z(o,h,t),this.P(h)?.set(o,m,n)})}remove(o,m,h=!1){this.y(()=>{this.z(o,m,void 0),this.P(m)?.delete(o,h)})}y(o){this.b.pause(),this.c.pause();try{o()}finally{this.b.resume(),this.c.resume()}}keys(o,m){const h=[],t=this.J(o);for(const n of Object.keys(t))t[n]===m&&h.push(n);return h}z(o,m,h,t=!1){const n=this.J(m);typeof h=="number"?n[o]!==h&&(n[o]=h,this.P(m)?.set(e.$2o,JSON.stringify(n),t)):typeof n[o]=="number"&&(delete n[o],this.P(m)?.set(e.$2o,JSON.stringify(n),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(o){switch(o){case-1:return this.I;case 0:return this.G;default:return this.D}}L(o){const m=this.P(o);return m?y(m):Object.create(null)}isNew(o){return this.getBoolean(e.$1o,o)===!0}async flush(o=R.NONE){this.f.fire({reason:o});const m=this.P(-1),h=this.P(0),t=this.P(1);switch(o){case R.NONE:await C.Promises.settled([m?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await C.Promises.settled([m?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const o=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return c(o,m,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(o){return await this.flush(),this.P(o)?.optimize()}async switch(o,m){return this.w(R.NONE),(0,w.$Hk)(o)?this.R(o,m):this.S(o,m)}M(o,m){return!(o.id===m.id||p(m)&&p(o))}N(o,m,h){this.y(()=>{const t=new Set;for(const[n,a]of o)t.add(n),m.get(n)!==a&&this.u(h,{key:n,external:!0});for(const[n]of m.items)t.has(n)||this.u(h,{key:n,external:!0})})}}e.$5o=D;function p(r){return r.isDefault||!!r.useDefaultFlags?.globalState}e.$6o=p;class l extends D{constructor(){super(),this.U=this.B(new b.$Yo(new b.$Zo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Yo(new b.$Zo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Yo(new b.$Zo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(o=>this.u(1,o))),this.B(this.W.onDidChangeStorage(o=>this.u(0,o))),this.B(this.U.onDidChangeStorage(o=>this.u(-1,o)))}P(o){switch(o){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(o){switch(o){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(o){return!1}}e.$7o=l;async function c(r,o,m,h,t,n){const a=P=>{try{return JSON.parse(P)}catch{return P}},i=new Map,s=new Map;r.forEach((P,O)=>{i.set(O,P),s.set(O,a(P))});const u=new Map,S=new Map;o.forEach((P,O)=>{u.set(O,P),S.set(O,a(P))});const k=new Map,$=new Map;m.forEach((P,O)=>{k.set(O,P),$.set(O,a(P))}),console.group(h!==t?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const f=[];if(i.forEach((P,O)=>{f.push({key:O,value:P})}),console.table(f),console.groupEnd(),console.log(s),h!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];u.forEach((O,N)=>{P.push({key:N,value:O})}),console.table(P),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${n})`);const g=[];k.forEach((P,O)=>{g.push({key:O,value:P})}),console.table(g),console.groupEnd(),console.log($)}e.$8o=c}),define(De[107],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class C{static{this.a=!1}constructor(d){this.d=d,this.b=new Map,this.c=1}add(d){const M=this.c++;return this.b.set(M,d),this.e(),M}get(d,M){return this.b.has(d)?this.b.get(d)[M]:void 0}delete(d){this.b.delete(d),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Jbc=C}),define(De[55],Ce([1,0,17,23,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=e.$Lbc=void 0;class M{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new F.$jg(b=>{const E=this.b.get(b.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(b,E){E===null?this.b.delete(b.scheme):this.b.set(b.scheme,E)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Lbc=M,e.$Mbc=(0,d.$Nh)("IExtHostFileSystemInfo")}),define(De[27],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=void 0,e.$rM=(0,C.$Nh)("IExtHostInitDataService")}),define(De[261],Ce([1,0,206,13,241,27]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;let A=class extends d.$yN{constructor(E,w,R){const I=R.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",v=R.remote.isRemote?(0,C.localize)(0,null):E?(0,C.localize)(1,null):(0,C.localize)(2,null);super(w.createLogger(I,{name:v}))}};e.$Sdc=A,e.$Sdc=A=He([Be(1,F.$9i),Be(2,M.$rM)],A)}),define(De[262],Ce([1,0,9]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=e.$ccc=void 0;class F{constructor(A,b,E){this.h=new Map,this.a=A,this.b=b,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new C.$5g(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of w.values())R.complete()}catch(R){for(const I of w.values())I.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,b){let E=this.f[A];return typeof E>"u"&&(E=b),E}update(A,b){this.f[A]=b;const E=this.h.get(A);if(E!==void 0)return E.p;const w=new C.$bh;return this.h.set(A,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$ccc=F;class d extends F{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,b){super(A.identifier.value,!0,b),this.j=A}}e.$dcc=d}),define(De[263],Ce([1,0,4,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class d{constructor(A){this.c=A,this.a=new C.$Md,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$Md,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,b,E,w){const I=this.c.getNotebookDocument(F.URI.revive(A)).acceptModelChanged(b.value,E,w);this.b.fire(I)}$acceptDirtyStateChanged(A,b){this.c.getNotebookDocument(F.URI.revive(A)).acceptDirty(b)}$acceptModelSaved(A){const b=this.c.getNotebookDocument(F.URI.revive(A));this.a.fire(b.apiNotebook)}}e.$Bdc=d}),define(De[20],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=void 0,e.$bM=(0,C.$Nh)("IExtHostRpcService");class F{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$cM=F}),define(De[264],Ce([1,0,25,4]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class d{#e;constructor(A,b){this.b=new F.$Md,this.onDidChange=this.b.event,this.a=C.$3l.toKey(A.identifier),this.#e=b,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,b){return this.#e.store(this.a,A,b)}delete(A){return this.#e.delete(this.a,A)}}e.$occ=d}),define(De[66],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=e.$Wbc=void 0,e.$Wbc=(0,C.$Nh)("IURITransformerService");class F{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Xbc=F}),define(De[265],Ce([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcb=e.$scb=void 0;class F{constructor(){this.buffers=[]}add(E){let w=this.buffers.indexOf(E);return w<0&&(w=this.buffers.length,this.buffers.push(E)),w}}function d(b,E){if(E.serializeBuffersForPostMessage){const w=new F,I=JSON.stringify(b,(y,D)=>{if(D instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(D)};if(ArrayBuffer.isView(D)){const p=M(D);if(p)return{$$vscode_array_buffer_reference$$:!0,index:w.add(D.buffer),view:{type:p,byteLength:D.byteLength,byteOffset:D.byteOffset}}}return D}),v=w.buffers.map(y=>{const D=new Uint8Array(y);return C.$ae.wrap(D)});return{message:I,buffers:v}}else return{message:JSON.stringify(b),buffers:[]}}e.$scb=d;function M(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(b,E){const w=E.map(v=>{const y=new ArrayBuffer(v.byteLength);return new Uint8Array(y).set(v.buffer),y}),R=E.length?(v,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const D=y,{index:p}=D,l=w[p];if(D.view)switch(D.view.type){case 1:return new Int8Array(l,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(l,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(l,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(l,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(l,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(l,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(l,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(l,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(l,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(l,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(l,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return l}return y}:void 0;return{message:JSON.parse(b,R),arrayBuffers:w}}e.$tcb=A}),define(De[266],Ce([1,0,267,373,374,60,2,13,375]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;const w=!1;function R(o,m,h,t,n,a){const i=a.environment.useHostProxy,s=typeof i=="boolean"?i:!a.remote.isRemote,u={resolveProxy:$=>o.resolveProxy($),lookupProxyAuthorization:l.bind(void 0,t,n,m,{},a.remote.isRemote),getProxyURL:()=>m.getConfiguration("http").get("proxy"),getProxySupport:()=>m.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>v(m),getSystemCertificatesV2:()=>y(m),log:($,f,...g)=>{switch($){case E.LogLevel.Trace:t.trace(f,...g);break;case E.LogLevel.Debug:t.debug(f,...g);break;case E.LogLevel.Info:t.info(f,...g);break;case E.LogLevel.Warning:t.warn(f,...g);break;case E.LogLevel.Error:t.error(f,...g);break;case E.LogLevel.Critical:t.error(f,...g);break;case E.LogLevel.Off:break;default:P($,f,g);break}function P(O,N,...L){t.error("Unknown log level",O),t.error(N,...L)}},getLogLevel:()=>{const $=t.getLevel();switch($){case b.LogLevel.Trace:return E.LogLevel.Trace;case b.LogLevel.Debug:return E.LogLevel.Debug;case b.LogLevel.Info:return E.LogLevel.Info;case b.LogLevel.Warning:return E.LogLevel.Warning;case b.LogLevel.Error:return E.LogLevel.Error;case b.LogLevel.Off:return E.LogLevel.Off;default:return f($)}function f(g){return t.error("Unknown log level",g),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:s,addCertificates:[],env:process.env},S=(0,E.createProxyResolver)(u),k=I(u,S);return p(h,k)}e.$oec=R;function I(o,m){return{http:Object.assign(C,(0,E.createHttpPatch)(o,C,m)),https:Object.assign(F,(0,E.createHttpPatch)(o,F,m)),net:Object.assign(M,(0,E.createNetPatch)(o,M)),tls:Object.assign(d,(0,E.createTlsPatch)(o,d))}}function v(o){const m=o.getConfiguration("http");return!m.get("experimental.systemCertificatesV2",w)&&!!m.get("systemCertificates")}function y(o){const m=o.getConfiguration("http");return!!m.get("experimental.systemCertificatesV2",w)&&!!m.get("systemCertificates")}const D=new Map;function p(o,m){return o.getExtensionPathIndex().then(h=>{const t=globalThis._VSCODE_NODE_MODULES.module,n=t._load;t._load=function(i,s,u){if(i==="net")return m.net;if(i==="tls")return m.tls;if(i!=="http"&&i!=="https")return n.apply(this,arguments);const S=h.findSubstr(A.URI.file(s.filename));let k=D.get(S);if(k||D.set(S,k={}),!k[i]){const $=m[i];k[i]={...$}}return k[i]}})}async function l(o,m,h,t,n,a,i,s){const u=t[a];i&&(t[a]=i),o.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${a}`,`proxyAuthenticate:${i}`,`proxyAuthenticateCache:${u}`);const S=i||u,k=Array.isArray(S)?S:typeof S=="string"?[S]:[];if(r(m,k,n),k.some($=>/^(Negotiate|Kerberos)( |$)/i.test($))&&!s.kerberosRequested)try{s.kerberosRequested=!0;const $=await new Promise((N,L)=>{$e(["kerberos"],N,L)}),f=new URL(a),g=h.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${f.hostname}`:`HTTP@${f.hostname}`);return o.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${a}`,`spn:${g}`),"Negotiate "+await(await $.initializeClient(g)).step("")}catch($){o.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",$)}}let c=!1;function r(o,m,h){c||!m.length||(c=!0,o.$publicLog2("proxyAuthenticationRequest",{authenticationType:m.map(t=>t.split(" ")[0]).join(","),extensionHostType:h?"remote":"local"}))}}),define(De[268],Ce([1,0,128]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0;function F(M){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:M,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function d(M){return new C.$Im(F(M))}e.$xr=d}),define(De[139],Ce([1,0,216,18,2,3,5,42,30,17,47,176,38]),function($e,e,C,F,d,M,A,b,E,w,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bE=e.$aE=e.$_D=e.EditorsOrder=e.$$D=e.CloseDirection=e.$0D=e.$9D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.EditorInputCapabilities=e.$ZD=e.SaveReason=e.Verbosity=e.$YD=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$RD=e.$QD=e.$PD=e.$OD=e.$ND=void 0,e.$ND={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$OD={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$PD="workbench.editor.sidebysideEditor",e.$QD="workbench.editors.textDiffEditor",e.$RD="workbench.editors.binaryResourceDiffEditor";var y;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var D;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})(D||(e.EditorPaneSelectionCompareResult=D={}));function p(ae){const ve=ae;return!!ve&&typeof ve.getSelection=="function"&&!!ve.onDidChangeSelection}e.$SD=p;function l(ae,ve,G){for(const U of G.visibleEditorPanes)if(U.group.id===ve&&ae.matches(U.input))return U.getViewState()}e.$TD=l;function c(ae){if(u(ae))return!1;const ve=ae;return d.URI.isUri(ve?.resource)}e.$UD=c;function r(ae){if(u(ae))return!1;const ve=ae;return ve?.original!==void 0&&ve.modified!==void 0}e.$VD=r;function o(ae){if(u(ae)||r(ae))return!1;const ve=ae;return ve?.primary!==void 0&&ve.secondary!==void 0}e.$WD=o;function m(ae){if(u(ae))return!1;const ve=ae;return ve?ve.resource===void 0||ve.resource.scheme===w.Schemas.untitled||ve.forceUntitled===!0:!1}e.$XD=m;function h(ae){if(u(ae))return!1;const ve=ae;return d.URI.isUri(ve?.base?.resource)&&d.URI.isUri(ve?.input1?.resource)&&d.URI.isUri(ve?.input2?.resource)&&d.URI.isUri(ve?.result?.resource)}e.$YD=h;var t;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var n;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class a{constructor(){this.a=new Map}registerSource(ve,G){let U=this.a.get(ve);return U||(U={source:ve,label:G},this.a.set(ve,U)),U.source}getSourceLabel(ve){return this.a.get(ve)?.label??ve}}e.$ZD=new a;var i;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class s extends M.$Rc{}e.$1D=s;function u(ae){return ae instanceof s}e.$2D=u;function S(ae){const ve=ae;return d.URI.isUri(ve?.preferredResource)}function k(ae){const ve=ae;return u(ve?.primary)&&u(ve?.secondary)}e.$3D=k;function $(ae){const ve=ae;return u(ve?.modified)&&u(ve?.original)}e.$4D=$;function f(ae,ve,G,U,q){return x(U,[(0,I.$xi)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const me={...G,limits:{size:Number.MAX_VALUE}};ae.openEditor(ve,me)}}),(0,I.$xi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.$5D=f;function g(ae){return u(ae?.editor)}e.$6D=g;function P(ae){const ve=ae;return g(ae)&&ve?.group!==void 0}e.$7D=P;function O(ae){const ve=ae;return typeof ve?.groupId=="number"&&u(ve.editor)}e.$8D=O;var N;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var L;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LOCKED=2]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=3]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=4]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=5]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=7]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=9]="EDITOR_PIN",ae[ae.EDITOR_STICKY=10]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=11]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(L||(e.GroupModelChangeKind=L={}));var j;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class z{getOriginalUri(ve,G){if(!ve)return;if(h(ve))return e.$0D.getOriginalUri(ve.result,G);if(G?.supportSideBySide){const{primary:q,secondary:me}=this.a(ve);if(q&&me){if(G?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:G.filterByScheme}),secondary:this.getOriginalUri(me,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getOriginalUri(q,{filterByScheme:G.filterByScheme})??this.getOriginalUri(me,{filterByScheme:G.filterByScheme});ve=G.supportSideBySide===j.PRIMARY?q:me}}if(r(ve)||o(ve)||h(ve))return;const U=S(ve)?ve.preferredResource:ve.resource;return!U||!G||!G.filterByScheme?U:this.b(U,G.filterByScheme)}a(ve){return k(ve)||o(ve)?{primary:ve.primary,secondary:ve.secondary}:$(ve)||r(ve)?{primary:ve.modified,secondary:ve.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ve,G){if(!ve)return;if(h(ve))return e.$0D.getCanonicalUri(ve.result,G);if(G?.supportSideBySide){const{primary:q,secondary:me}=this.a(ve);if(q&&me){if(G?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:G.filterByScheme}),secondary:this.getCanonicalUri(me,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getCanonicalUri(q,{filterByScheme:G.filterByScheme})??this.getCanonicalUri(me,{filterByScheme:G.filterByScheme});ve=G.supportSideBySide===j.PRIMARY?q:me}}if(r(ve)||o(ve)||h(ve))return;const U=ve.resource;return!U||!G||!G.filterByScheme?U:this.b(U,G.filterByScheme)}b(ve,G){if(Array.isArray(G)){if(G.some(U=>ve.scheme===U))return ve}else if(G===ve.scheme)return ve}}var T;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(T||(e.EditorCloseMethod=T={}));function K(ae,ve,G,U){if(!ae.isSticky(ve))return!1;switch(U.preventPinnedEditorClose){case"keyboardAndMouse":return G===T.MOUSE||G===T.KEYBOARD;case"mouse":return G===T.MOUSE;case"keyboard":return G===T.KEYBOARD}return!1}e.$9D=K,e.$0D=new z;var V;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class fe{constructor(){this.c=new Map,this.d=new Map}start(ve){const G=this.a=ve.get(A.$Mh);for(const[U,q]of this.c)this.e(U,q,G);this.c.clear()}e(ve,G,U){const q=U.createInstance(G);this.d.set(ve,q)}registerFileEditorFactory(ve){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ve}getFileEditorFactory(){return(0,F.$If)(this.b)}registerEditorSerializer(ve,G){if(this.c.has(ve)||this.d.has(ve))throw new Error(`A editor serializer with type ID '${ve}' was already registered.`);return this.a?this.e(ve,G,this.a):this.c.set(ve,G),(0,M.$Pc)(()=>{this.c.delete(ve),this.d.delete(ve)})}getEditorSerializer(ve){return this.d.get(typeof ve=="string"?ve:ve.typeId)}}b.$cn.add(e.$ND.EditorFactory,new fe);async function X(ae,ve,G){return!ae||!ae.length?[]:await Promise.all(ae.map(async U=>{const q=d.URI.revive(U.fileUri);if(!q){G.info("Cannot resolve the path because it is not valid.",U);return}if(!await ve.canHandleResource(q)){G.info("Cannot resolve the path because it cannot be handled",U);return}let _=U.exists,ie=U.type;if(typeof _!="boolean"||typeof ie!="number")try{ie=(await ve.stat(q)).isDirectory?E.FileType.Directory:E.FileType.Unknown,_=!0}catch(Ee){G.error(Ee),_=!1}if(!_&&U.openOnlyIfExists){G.info("Cannot resolve the path because it does not exist",U);return}if(ie===E.FileType.Directory){G.info("Cannot resolve the path because it is a directory",U);return}const re={...U.options,pinned:!0};return _?{resource:q,options:re}:{resource:q,options:re,forceUntitled:!0}}))}e.$$D=X;var Q;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(Q||(e.EditorsOrder=Q={}));function Z(ae){const ve=ae;if(!ve)return!1;const G=ve;if(G.modified)return Z(G.modified);const U=ve;return!!(U.contributionsState&&U.viewState&&Array.isArray(U.cursorState))}e.$_D=Z;function oe(ae){return(0,R.$zi)(ae)}e.$aE=oe;function x(ae,ve,G){const U=(0,R.$Ai)(ae,ve);return U.forceMessage=G?.forceMessage,U.forceSeverity=G?.forceSeverity,U.allowDialog=G?.allowDialog,U}e.$bE=x}),define(De[269],Ce([1,0,4,217,5,3,28,42,19,24,78,255]),function($e,e,C,F,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=e.$lE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$kE=e.$jE=e.ViewContentGroups=e.$iE=e.$hE=e.ViewContainerLocation=e.Extensions=e.$gE=e.$fE=e.$eE=void 0,e.$eE="views",e.$fE=(0,F.localize)(0,null),e.$gE=(0,I.$1v)("default-view-icon",R.$Sj.window,(0,F.localize)(1,null));var v;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var y;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$hE=[0,1,2];function D(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$iE=D;class p extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new C.$Md),this.onDidRegister=this.c.event,this.f=this.B(new C.$Md),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Qb)([...this.g.values()])}registerViewContainer(a,i,s){const u=this.get(a.id);if(u)return u;const S=a;return S.openCommandActionDescriptor=s?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,A.$wc)(this.g,i,[]).push(S),s?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:i}),S}deregisterViewContainer(a){for(const i of this.g.keys()){const s=this.g.get(i),u=s?.indexOf(a);if(u!==-1){s?.splice(u,1),s.length===0&&this.g.delete(i),this.f.fire({viewContainer:a,viewContainerLocation:i});return}}}get(a){return this.all.filter(i=>i.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(i=>this.getViewContainers(i).filter(s=>s?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(i=>this.getViewContainerLocation(i)===a)}}b.$cn.add(v.ViewContainersRegistry,new p);var l;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(l||(e.ViewContentGroups=l={}));function c(n,a){const i=n.group??l.More,s=a.group??l.More;return i!==s?i.localeCompare(s):(n.order??5)-(a.order??5)}class r extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new C.$Md),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$Md),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$Md),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$Md),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Fc}registerViews(a,i){this.registerViews2([{views:a,viewContainer:i}])}registerViews2(a){a.forEach(({views:i,viewContainer:s})=>this.r(i,s)),this.c.fire(a)}deregisterViews(a,i){const s=this.s(a,i);s.length&&this.f.fire({views:s,viewContainer:i})}moveViews(a,i){for(const s of this.m.keys())if(s!==i){const u=this.s(a,s);u.length&&(this.r(u,i),this.g.fire({views:u,from:s,to:i}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const i of this.j){const s=(this.m.get(i)||[]).filter(u=>u.id===a)[0];if(s)return s}return null}getViewContainer(a){for(const i of this.j)if((this.m.get(i)||[]).filter(u=>u.id===a)[0])return i;return null}registerViewWelcomeContent(a,i){return this.n.add(a,i),this.h.fire(a),(0,M.$Pc)(()=>{this.n.delete(a,i),this.h.fire(a)})}registerViewWelcomeContent2(a,i){const s=new Map;for(const[u,S]of i)this.n.add(a,S),s.set(u,(0,M.$Pc)(()=>{this.n.delete(a,S),this.h.fire(a)}));return this.h.fire(a),s}getViewWelcomeContent(a){const i=[];return this.n.forEach(a,s=>i.push(s)),i.sort(c)}r(a,i){let s=this.m.get(i);s||(s=[],this.m.set(i,s),this.j.push(i));for(const u of a){if(this.getView(u.id)!==null)throw new Error((0,F.localize)(2,null,u.id));s.push(u)}}s(a,i){const s=this.m.get(i);if(!s)return[];const u=[],S=[];for(const k of s)a.includes(k)?u.push(k):S.push(k);return u.length&&(S.length?this.m.set(i,S):(this.m.delete(i),this.j.splice(this.j.indexOf(i),1))),u}}b.$cn.add(v.ViewsRegistry,new r),e.$jE=(0,d.$Nh)("viewsService"),e.$kE=(0,d.$Nh)("viewDescriptorService");var o;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var m;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(m||(e.TreeItemCollapsibleState=m={}));class h{constructor(a,i){this.c=!1,this.d=!1,(0,w.$6m)(this,a),this.d=!!i,this.resolve=async s=>{if(i&&!this.c){const u=await i(s);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}s.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$lE=h;class t extends Error{constructor(a){super((0,F.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$mE=t}),define(De[140],Ce([1,0,4,9,218]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new C.$Md,this.n=new C.$Md,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,E,w,R){const I={command:b};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.s("request",I),typeof R=="number"){const v=setTimeout(()=>{clearTimeout(v);const y=this.f.get(I.seq);if(y){this.f.delete(I.seq);const D={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,d.localize)(0,null,R,b)};y(D)}},R)}return w&&this.f.set(I.seq,w),I.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,E){return b.type!=="event"||E.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,F.$Tg)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const E=b,w=this.f.get(E.request_seq);w&&(this.f.delete(E.request_seq),w(E));break}}}}s(b,E){E.type=b,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((E,w)=>b.set(w,E)),await(0,F.$Tg)(500),b.forEach((E,w)=>{E({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Ycb=M}),define(De[270],Ce([1,0,219,41,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$3G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$2G=e.MemoryRangeType=e.$1G=e.State=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=void 0,e.$YF="workbench.view.debug",e.$ZF="workbench.debug.variablesView",e.$1F="workbench.debug.watchExpressionsView",e.$2F="workbench.debug.callStackView",e.$3F="workbench.debug.loadedScriptsView",e.$4F="workbench.debug.breakPointsView",e.$5F="workbench.debug.disassemblyView",e.$6F="workbench.panel.repl",e.$7F="workbench.panel.repl.view",e.$8F=new F.$5i("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$9F=new F.$5i("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$0F=new F.$5i("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$$F="debugUx",e.$_F=new F.$5i(e.$$F,"default",{type:"string",description:C.localize(3,null)}),e.$aG=new F.$5i("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$bG=new F.$5i("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$cG=new F.$5i("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$dG=new F.$5i("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$eG=new F.$5i("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$fG=new F.$5i("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$gG=new F.$5i("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$hG=new F.$5i("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$iG=new F.$5i("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$jG=new F.$5i("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$kG=new F.$5i("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$lG=new F.$5i("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$mG=new F.$5i("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$nG=new F.$5i("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$oG=new F.$5i("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$pG=new F.$5i("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$qG=new F.$5i("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$rG=new F.$5i("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$sG=new F.$5i("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(22,null)}),e.$tG=new F.$5i("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(23,null)}),e.$uG=new F.$5i("loadedScriptsItemType",void 0,{type:"string",description:C.localize(24,null)}),e.$vG=new F.$5i("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(25,null)}),e.$wG=new F.$5i("stepBackSupported",!1,{type:"boolean",description:C.localize(26,null)}),e.$xG=new F.$5i("restartFrameSupported",!1,{type:"boolean",description:C.localize(27,null)}),e.$yG=new F.$5i("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(28,null)}),e.$zG=new F.$5i("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(29,null)}),e.$AG=new F.$5i("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$BG=new F.$5i("breakpointsExist",!1,{type:"boolean",description:C.localize(31,null)}),e.$CG=new F.$5i("debuggersAvailable",!1,{type:"boolean",description:C.localize(32,null)}),e.$DG=new F.$5i("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(33,null)}),e.$EG=new F.$5i("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(34,null)}),e.$FG=new F.$5i("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(35,null)}),e.$GG=new F.$5i("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(36,null)}),e.$HG=new F.$5i("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(37,null)}),e.$IG=new F.$5i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$JG=new F.$5i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$KG=new F.$5i("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$LG=new F.$5i("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$MG=new F.$5i("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(42,null)}),e.$NG=new F.$5i("variableIsReadonly",!1,{type:"boolean",description:C.localize(43,null)}),e.$OG=new F.$5i("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(44,null)}),e.$PG=new F.$5i("multiSessionRepl",!1,{type:"boolean",description:C.localize(45,null)}),e.$QG=new F.$5i("multiSessionDebug",!1,{type:"boolean",description:C.localize(46,null)}),e.$RG=new F.$5i("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(47,null)}),e.$SG=new F.$5i("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(48,null)}),e.$TG=new F.$5i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(49,null)}),e.$UG=new F.$5i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(50,null)});const M=v=>C.localize(51,null,v);e.$VG=M,e.$WG="editor.contrib.debug",e.$XG="editor.contrib.breakpoint",e.$YG="debug",e.$ZG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(52,null)};var A;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(A||(e.State=A={}));function b(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$1G=b;var E;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$2G="vscode-debug-memory";var w;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var R;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$3G=(0,d.$Nh)("debugService");var I;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(De[271],Ce([1,0,15,2,16,24,17,34,21,19]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=void 0;const R=/{([^}]+)}/g;function I(k,$,f){return k.replace(R,function(g,P){return $&&P.length>0&&P[0]!=="_"?g:f&&f.hasOwnProperty(P)?f[P]:g})}e.$nF=I;function v(k){const $={};for(const f of Object.keys(k))f.startsWith("!")||($[f]=k[f]);return $}e.$oF=v;function y(k){return k.configuration.request==="attach"&&!D(k)&&(!k.parentSession||y(k.parentSession))}e.$pF=y;function D(k){let $=k.configuration.type;if($)return $==="vslsShare"&&($=k.configuration.adapterProxy.configuration.type),(0,C.$1e)($,"extensionhost")||(0,C.$1e)($,"pwa-extensionhost")?k:k.parentSession?D(k.parentSession):void 0}e.$qF=D;function p(k){return k.type&&(k.label||k.program||k.runtime)}e.$rF=p;function l(k,$,f){let g,P=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=O.exec(k);){const L=N.index+1,j=L+N[0].length;if(L<=$&&j>=f){g=N[0],P=L;break}}if(g){const L=/\w+/g;let j=null;for(;(j=L.exec(g))&&!(j.index+1+P+j[0].length>=f););j&&(g=g.substring(0,L.lastIndex))}return g?{start:P,end:P+g.length-1}:{start:0,end:0}}e.$sF=l;async function c(k,$,f,g){if(k.evaluatableExpressionProvider.has($)){const P=k.evaluatableExpressionProvider.ordered($),O=(0,w.$Gb)(await Promise.all(P.map(async N=>{try{return await N.provideEvaluatableExpression($,f,g??E.CancellationToken.None)}catch{return}})));if(O.length>0){let N=O[0].expression;const L=O[0].range;return N||(N=$.getLineContent(f.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:N}}}else{const P=$.getLineContent(f.lineNumber),{start:O,end:N}=l(P,f.column,f.column),L=P.substring(O-1,N);return{matchingExpression:L,range:new b.$ps(f.lineNumber,O,f.lineNumber,O+L.length)}}return null}e.$tF=c;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(k){return!!(k&&k.match(r))}e.$uF=o;function m(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(o(k.path))return F.URI.parse(k.path);if((0,d.$hc)(k.path))return F.URI.file(k.path)}return k.path}function h(k){if(typeof k.path=="object"){const $=F.URI.revive(k.path);if($)return $.scheme===A.Schemas.file?$.fsPath:$.toString()}return k.path}function t(k,$){const f=$?m:h,g=(0,M.$3m)(k);return a(g,(P,O)=>{P&&O&&(O.path=f(O))}),g}e.$vF=t;function n(k,$){const f=$?m:h,g=(0,M.$3m)(k);return a(g,(P,O)=>{!P&&O&&(O.path=f(O))}),g}e.$wF=n;function a(k,$){switch(k.type){case"event":{const f=k;switch(f.event){case"output":$(!1,f.body.source);break;case"loadedSource":$(!1,f.body.source);break;case"breakpoint":$(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=k;switch(f.command){case"setBreakpoints":$(!0,f.arguments.source);break;case"breakpointLocations":$(!0,f.arguments.source);break;case"source":$(!0,f.arguments.source);break;case"gotoTargets":$(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(g=>$(!1,g));break;default:break}break}case"response":{const f=k;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(g=>$(!1,g.source));break;case"loadedSources":f.body.sources.forEach(g=>$(!1,g));break;case"scopes":f.body.scopes.forEach(g=>$(!1,g.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(g=>$(!1,g.source));break;case"setBreakpoints":f.body.breakpoints.forEach(g=>$(!1,g.source));break;case"disassemble":f.body?.instructions.forEach(P=>$(!1,P.location));break;default:break}break}}}function i(k){return k.filter($=>!$.presentation?.hidden).sort(($,f)=>$.presentation?f.presentation?$.presentation.group?f.presentation.group?$.presentation.group!==f.presentation.group?$.presentation.group.localeCompare(f.presentation.group):s($.presentation.order,f.presentation.order):-1:f.presentation.group?1:s($.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.$xF=i;function s(k,$){return typeof k!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:k-$}async function u(k,$){const f=k.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(f!=="none"&&(await $.saveAll(),f==="allEditorsInActiveGroup")){const g=$.activeEditorPane;g&&g.input.resource?.scheme===A.Schemas.untitled&&await $.save({editor:g.input,groupId:g.group.id})}await k.reloadConfiguration()}e.$yF=u;const S=(k,$)=>!k||!$?k===$:k.name===$.name&&k.path===$.path&&k.sourceReference===$.sourceReference;e.$zF=S}),define(De[272],Ce([1,0,49,60,24,16,12,15,29,220,140]),function($e,e,C,F,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=e.$1dc=e.$Zdc=e.$Ydc=void 0;class I extends R.$Ycb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(c,r){this.p=r,this.r=Buffer.allocUnsafe(0),this.t=-1,c.on("data",o=>this.w(o))}sendMessage(c){if(this.p){const r=JSON.stringify(c);this.p.write(`Content-Length: ${Buffer.byteLength(r,"utf8")}${I.a}${r}`,"utf8")}}w(c){for(this.r=Buffer.concat([this.r,c]);;){if(this.t>=0){if(this.r.length>=this.t){const r=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,r.length>0)try{this.acceptMessage(JSON.parse(r))}catch(o){this.m.fire(new Error((o.message||o)+`
`+r))}continue}}else{const r=this.r.indexOf(I.a);if(r!==-1){const m=this.r.toString("utf8",0,r).split(I.b);for(const h of m){const t=h.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(r+I.a.length);continue}}break}}}e.$Ydc=I;class v extends I{startSession(){return new Promise((c,r)=>{let o=!1;this.x=this.y(()=>{this.v(this.x,this.x),c(),o=!0}),this.x.on("close",()=>{o?this.m.fire(new Error("connection closed")):r(new Error("connection closed"))}),this.x.on("error",m=>{o?this.m.fire(m):r(m)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Zdc=v;class y extends v{constructor(c){super(),this.z=c}y(c){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",c)}}e.$1dc=y;class D extends v{constructor(c){super(),this.z=c}y(c){return F.createConnection(this.z.path,c)}}e.$2dc=D;class p extends I{constructor(c,r){super(),this.y=c,this.z=r}async startSession(){const c=this.y.command,r=this.y.args,o=this.y.options||{};try{if(c)if(M.$hc(c)){if(!await E.Promises.exists(c))throw new Error(w.localize(0,null,c))}else c.indexOf("/")<0&&c.indexOf("\\")<0;else throw new Error(w.localize(1,null,this.z));let m=process.env;if(o.env&&Object.keys(o.env).length>0&&(m=d.$6m(d.$3m(process.env),o.env)),c==="node")if(Array.isArray(r)&&r.length>0){const h=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:m,execArgv:h?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(t.cwd=o.cwd);const n=C.fork(r[0],r.slice(1),t);if(!n.pid)throw new Error(w.localize(2,null,r[0]));this.x=n}else throw new Error(w.localize(3,null));else{const h={env:m};o.cwd&&(h.cwd=o.cwd),this.x=C.spawn(c,r,h)}this.x.on("error",h=>{this.m.fire(h)}),this.x.on("exit",(h,t)=>{this.n.fire(h)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",h=>{this.m.fire(h)}),this.x.stdin.on("error",h=>{this.m.fire(h)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(m){this.m.fire(m)}}async stopSession(){return this.x?(await this.u(),A.$j?new Promise((c,r)=>{const o=C.exec(`taskkill /F /T /PID ${this.x.pid}`,function(m,h,t){if(m)return r(m)});o.on("exit",c),o.on("error",r)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(c,r){if(!c)return;const o=Object.create(null);c.runtime&&(c.runtime.indexOf("./")===0?o.runtime=M.$ic(r,c.runtime):o.runtime=c.runtime),c.runtimeArgs&&(o.runtimeArgs=c.runtimeArgs),c.program&&(M.$hc(c.program)?o.program=c.program:o.program=M.$ic(r,c.program)),c.args&&(o.args=c.args);const m=c;return m.win&&(o.win=p.A(m.win,r)),m.winx86&&(o.winx86=p.A(m.winx86,r)),m.windows&&(o.windows=p.A(m.windows,r)),m.osx&&(o.osx=p.A(m.osx,r)),m.linux&&(o.linux=p.A(m.linux,r)),o}static platformAdapterExecutable(c,r){let o=Object.create(null);r=r.toLowerCase();for(const i of c)if(i.contributes){const s=i.contributes.debuggers;s&&s.length>0&&s.filter(u=>typeof u.type=="string"&&b.$1e(u.type,r)).forEach(u=>{const S=p.A(u,i.extensionLocation.fsPath);o=d.$6m(o,S,i.isBuiltin)})}let m;A.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=o.winx86||o.win||o.windows:A.$j?m=o.win||o.windows:A.$k?m=o.osx:A.$l&&(m=o.linux),m=m||o;const h=m.program||o.program,t=m.args||o.args,n=m.runtime||o.runtime,a=m.runtimeArgs||o.runtimeArgs;if(n)return{type:"executable",command:n,args:(a||[]).concat(typeof h=="string"?[h]:[]).concat(t||[])};if(h)return{type:"executable",command:h,args:t||[]}}}e.$3dc=p}),define(De[273],Ce([1,0,49,32,12]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=e.$4dc=void 0;function M(w,R){return new Promise((I,v)=>{let y="";const D=C.spawn(w,R);D.pid&&D.stdout.on("data",p=>{y+=p.toString()}),D.on("error",p=>{v(p)}),D.on("close",p=>{I(y)})})}async function A(w){if(w)if(d.$j){const R=await new Promise((I,v)=>{$e(["@vscode/windows-process-tree"],I,v)});return new Promise(I=>{R.getProcessTree(w,v=>{I(!!v&&v.children.length>0)})})}else return M("/usr/bin/pgrep",["-lP",String(w)]).then(R=>{const I=R.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$4dc=A;var b;(function(w){w[w.cmd=0]="cmd",w[w.powershell=1]="powershell",w[w.bash=2]="bash"})(b||(b={}));function E(w,R,I,v,y){w=w.trim().toLowerCase();let D;w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0?D=1:w.indexOf("cmd.exe")>=0?D=0:w.indexOf("bash")>=0?D=2:d.$j?D=0:D=2;let p,l=" ";switch(D){case 1:if(p=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),v){const c=(0,F.$2f)(v);c&&(l+=`${c}:; `),l+=`cd ${p(v)}; `}if(y)for(const c in y){const r=y[c];r===null?l+=`Remove-Item env:${c}; `:l+=`\${env:${c}}='${r}'; `}if(R.length>0){const c=R.shift(),r=I?c:p(c);l+=r[0]==="'"?`& ${r} `:`${r} `;for(const o of R)l+=o==="<"||o===">"||I?o:p(o),l+=" "}break;case 0:if(p=c=>(c=c.replace(/\"/g,'""'),c=c.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(r=>c.includes(r))||c.length===0?`"${c}"`:c),v){const c=(0,F.$2f)(v);c&&(l+=`${c}: && `),l+=`cd ${p(v)} && `}if(y){l+='cmd /C "';for(const c in y){let r=y[c];r===null?l+=`set "${c}=" && `:(r=r.replace(/[&^|<>]/g,o=>`^${o}`),l+=`set "${c}=${r}" && `)}}for(const c of R)l+=c==="<"||c===">"||I?c:p(c),l+=" ";y&&(l+='"');break;case 2:{p=r=>(r=r.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),r.length===0?'""':r);const c=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(v&&(l+=`cd ${p(v)} ; `),y){l+="/usr/bin/env";for(const r in y){const o=y[r];o===null?l+=` -u ${c(r)}`:l+=` ${c(`${r}=${o}`)}`}l+=" "}for(const r of R)l+=r==="<"||r===">"||I?r:p(r),l+=" ";break}}return l}e.$5dc=E}),define(De[108],Ce([1,0,22,35,51,97,17,16,12,41]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oI=e.$nI=e.$mI=e.$lI=e.CellStatusbarAlignment=e.$kI=e.$jI=e.$iI=e.NotebookEditorPriority=e.$hI=e.$gI=e.$fI=e.$eI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$dI=e.$cI=e.$bI=e.$aI=e.CellKind=e.$_H=e.$$H=e.$0H=void 0,e.$0H="workbench.editor.notebook",e.$$H="workbench.editor.notebookTextDiffEditor",e.$_H="workbench.editor.interactive";var R;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(R||(e.CellKind=R={})),e.$aI=["application/json","application/javascript","text/html","image/svg+xml",M.$Mr.latex,M.$Mr.markdown,"image/png","image/jpeg",M.$Mr.text],e.$bI=[M.$Mr.latex,M.$Mr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Mr.text],e.$cI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$dI="_notAvailable";var I;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var v;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var y;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var D;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(D||(e.NotebookRendererMatch=D={}));var p;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(p||(e.RendererMessagingSpec=p={}));var l;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(l||(e.NotebookCellsChangeType=l={}));var c;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(c||(e.SelectionStateType=c={}));var r;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var o;(function(T){T.scheme=A.Schemas.vscodeNotebookCell;const K=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${K.join("")}]+`),fe=7;function X(ve,G){const U=G.toString(fe),me=`${U.length<K.length?K[U.length-1]:"z"}${U}s${(0,C.$ue)(C.$ae.fromString(ve.scheme),!0,!0)}`;return ve.with({scheme:T.scheme,fragment:me})}T.generate=X;function Q(ve){if(ve.scheme!==T.scheme)return;const G=ve.fragment.indexOf("s");if(G<0)return;const U=parseInt(ve.fragment.substring(0,G).replace(V,""),fe),q=(0,C.$te)(ve.fragment.substring(G+1)).toString();if(!isNaN(U))return{handle:U,notebook:ve.with({scheme:q,fragment:null})}}T.parse=Q;function Z(ve,G){return ve.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${ve.scheme!==A.Schemas.file?ve.scheme:""}`})}T.generateCellOutputUri=Z;function oe(ve){if(ve.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ve.fragment);if(!G)return;const U=G[1]&&G[1]!==""?G[1]:void 0,q=G[2];return{outputId:U,notebook:ve.with({scheme:q||A.Schemas.file,fragment:null})}}T.parseCellOutputUri=oe;function x(ve,G,U){return T.generate(ve,G).with({scheme:U})}T.generateCellPropertyUri=x;function ae(ve,G){if(ve.scheme===G)return T.parse(ve.with({scheme:T.scheme}))}T.parseCellPropertyUri=ae})(o||(e.CellUri=o={}));const m=T=>E.$j?T.replace(/\//g,"\\"):T;class h{constructor(K=[],V=e.$aI){this.e=V,this.d=[...new Set(K)].map(fe=>({pattern:fe,matches:F.$uj(m(fe))}))}sort(K){const V=new Map(d.Iterable.map(K,X=>[X,m(X)]));let fe=[];for(const{matches:X}of this.d)for(const[Q,Z]of V)if(X(Z)){fe.push(Q),V.delete(Q);break}return V.size&&(fe=fe.concat([...V.keys()].sort((X,Q)=>this.e.indexOf(X)-this.e.indexOf(Q)))),fe}prioritize(K,V){const fe=this.f(K);if(fe===-1){this.d.unshift({pattern:K,matches:F.$uj(m(K))});return}const X=new Set(V.map(Z=>this.f(Z,fe)));X.delete(-1);const Q=Array.from(X).sort();this.d.splice(fe+1,0,...Q.map(Z=>this.d[Z]));for(let Z=Q.length-1;Z>=0;Z--)this.d.splice(Q[Z],1)}toArray(){return this.d.map(K=>K.pattern)}f(K,V=this.d.length){const fe=m(K);for(let X=0;X<V;X++)if(this.d[X].matches(fe))return X;return-1}}e.$eI=h;function t(T,K,V,fe=(X,Q)=>X===Q){const X=[];function Q(x,ae,ve){if(ae===0&&ve.length===0)return;const G=X[X.length-1];G&&G.start+G.deleteCount===x?(G.deleteCount+=ae,G.toInsert.push(...ve)):X.push({start:x,deleteCount:ae,toInsert:ve})}let Z=0,oe=0;for(;;){if(Z===T.length){Q(Z,0,K.slice(oe));break}if(oe===K.length){Q(Z,T.length-Z,[]);break}const x=T[Z],ae=K[oe];if(fe(x,ae)){Z+=1,oe+=1;continue}V(ae)?(Q(Z,1,[]),Z+=1):(Q(Z,0,[ae]),oe+=1)}return X}e.$fI=t,e.$gI=new w.$5i("notebookEditorCursorAtBoundary","none"),e.$hI=new w.$5i("notebookEditorCursorAtLineBoundary","none");var n;(function(T){T.default="default",T.option="option"})(n||(e.NotebookEditorPriority=n={}));function a(T){const K=T;return!!((typeof K.include=="string"||F.$vj(K.include))&&(typeof K.exclude=="string"||F.$vj(K.exclude)))}e.$iI=a;function i(T,K,V){if(Array.isArray(T.viewType)&&T.viewType.indexOf(K)>=0||T.viewType===K)return!0;if(T.filenamePattern){const fe=a(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,X=a(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(F.$tj(fe,(0,b.$mc)(V.fsPath).toLowerCase()))return!(X&&F.$tj(X,(0,b.$mc)(V.fsPath).toLowerCase()))}return!1}e.$jI=i,e.$kI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var s;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(s||(e.CellStatusbarAlignment=s={}));class u{static{this.d="notebook/"}static create(K){return`${u.d}${K}`}static parse(K){if(K.startsWith(u.d))return K.substring(u.d.length)}}e.$lI=u;function S(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.$mI=S;const k=new TextDecoder;function $(T){const K=[];let V=!1;for(const Z of T)(K.length===0||V)&&(K.push(Z),V=!0);let fe=P(K);const X=C.$ae.concat(K.map(Z=>C.$ae.wrap(Z))),Q=z(X);return fe=fe||Q.byteLength!==X.byteLength,{data:Q,didCompression:fe}}e.$nI=$,e.$oI=`${String.fromCharCode(27)}[A`;const f=e.$oI.split("").map(T=>T.charCodeAt(0)),g=10;function P(T){let K=!1;return T.forEach((V,fe)=>{if(fe===0||V.length<e.$oI.length)return;const X=T[fe-1],Q=V.subarray(0,e.$oI.length);if(Q[0]===f[0]&&Q[1]===f[1]&&Q[2]===f[2]){const Z=X.lastIndexOf(g);if(Z===-1)return;K=!0,T[fe-1]=X.subarray(0,Z),T[fe]=V.subarray(e.$oI.length)}}),K}function O(T){let K=T;do T=K,K=T.replace(/[^\n]\x08/gm,"");while(K.length<T.length);return T}function N(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const K=T.match(/^(.*)\r+/m)[1];let V=T.match(/\r+(.*)$/m)[1];V=V+K.slice(V.length,K.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return T}const L="\b".charCodeAt(0),j="\r".charCodeAt(0);function z(T){return!T.buffer.includes(L)&&!T.buffer.includes(j)?T:C.$ae.fromString(N(O(k.decode(T.buffer))))}}),define(De[7],Ce([1,0,19,8,79,28,97,15,18,2,31,25,30,64,108]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D){"use strict";var p,l,c,r,o,m,h,t,n,a,i,s,u,S,k,$,f,g;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$3L=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.TestRunProfileKind=e.TestResultState=e.$JL=e.$IL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$HL=e.$GL=e.$FL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$EL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.ColorThemeKind=e.$yL=e.$xL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$wL=e.DebugConsoleMode=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$qL=e.$pL=e.FileChangeType=e.$oL=e.$nL=e.$mL=e.$lL=e.InlineCompletionTriggerKind=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.ConfigurationTarget=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$1K=e.ViewBadge=e.ProgressLocation=e.$ZK=e.$YK=e.TaskScope=e.ShellQuoting=e.$XK=e.$WK=e.$VK=e.TaskPanelKind=e.TaskRevealKind=e.$UK=e.TerminalLocation=e.$TK=e.$SK=e.$RK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$QK=e.$PK=e.$OK=e.$NK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$MK=e.StatusBarAlignment=e.ViewColumn=e.$LK=e.$KK=e.$JK=e.$IK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$HK=e.$GK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.LanguageStatusSeverity=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.CodeActionTriggerKind=e.$uK=e.$tK=e.SymbolTag=e.SymbolKind=e.$sK=e.DocumentHighlightKind=e.$rK=e.$qK=e.$pK=e.$oK=e.DiagnosticSeverity=e.DiagnosticTag=e.$nK=e.$mK=e.FileEditType=e.$lK=e.$kK=e.$jK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(H){return Object.assign(H,{apply:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const Re=pe.length===1?[]:pe[1];return Reflect.construct(H,Re,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const[Re,...Qe]=pe;return Reflect.construct(H,Qe,Re.constructor)}}})}var O;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(O||(e.TerminalOutputAnchor=O={}));var N;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let L=p=class{static from(...W){let pe=W;return new p(function(){if(pe){for(const Re of pe)Re&&typeof Re.dispose=="function"&&Re.dispose();pe=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$cK=L,e.$cK=L=p=He([P],L);let j=l=class{static Min(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isBefore(pe)&&(pe=Qe)}return pe}static Max(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isAfter(pe)&&(pe=Qe)}return pe}static isPosition(W){if(!W)return!1;if(W instanceof l)return!0;const{line:pe,character:Re}=W;return typeof pe=="number"&&typeof Re=="number"}static of(W){if(W instanceof l)return W;if(this.isPosition(W))return new l(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,pe){if(W<0)throw(0,F.$6)("line must be non-negative");if(pe<0)throw(0,F.$6)("character must be non-negative");this.c=W,this.e=pe}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,pe=0){if(W===null||pe===null)throw(0,F.$6)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,pe=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&pe===0?this:new l(this.line+Re,this.character+pe)}with(W,pe=this.character){if(W===null||pe===null)throw(0,F.$6)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,pe=typeof W.character=="number"?W.character:this.character),Re===this.line&&pe===this.character?this:new l(Re,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$dK=j,e.$dK=j=l=He([P],j);let z=c=class{static isRange(W){return W instanceof c?!0:W?j.isPosition(W.start)&&j.isPosition(W.end):!1}static of(W){if(W instanceof c)return W;if(this.isRange(W))return new c(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,pe,Re,Qe){let tt,at;if(typeof W=="number"&&typeof pe=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new j(W,pe),at=new j(Re,Qe)):j.isPosition(W)&&j.isPosition(pe)&&(tt=j.of(W),at=j.of(pe)),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this.c=tt,this.e=at):(this.c=at,this.e=tt)}contains(W){return c.isRange(W)?this.contains(W.start)&&this.contains(W.end):j.isPosition(W)?!(j.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const pe=j.Max(W.start,this.c),Re=j.Min(W.end,this.e);if(!pe.isAfter(Re))return new c(pe,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const pe=j.Min(W.start,this.c),Re=j.Max(W.end,this.end);return new c(pe,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,pe=this.end){if(W===null||pe===null)throw(0,F.$6)();let Re;return W?j.isPosition(W)?Re=W:(Re=W.start||this.start,pe=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&pe.isEqual(this.end)?this:new c(Re,pe)}toJSON(){return[this.start,this.end]}};e.$eK=z,e.$eK=z=c=He([P],z);let T=r=class extends z{static isSelection(W){return W instanceof r?!0:W?z.isRange(W)&&j.isPosition(W.anchor)&&j.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,pe,Re,Qe){let tt,at;if(typeof W=="number"&&typeof pe=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new j(W,pe),at=new j(Re,Qe)):j.isPosition(W)&&j.isPosition(pe)&&(tt=j.of(W),at=j.of(pe)),!tt||!at)throw new Error("Invalid arguments");super(tt,at),this.f=tt,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$fK=T,e.$fK=T=r=He([P],T);const K=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,F.$6)("connectionToken")};class V{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe,Re){if(typeof W!="string"||W.length===0)throw(0,F.$6)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,F.$6)("port");typeof Re<"u"&&K(Re),this.host=W,this.port=Math.round(pe),this.connectionToken=Re}}e.$gK=V;class fe{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe){this.makeConnection=W,this.connectionToken=pe,typeof pe<"u"&&K(pe)}}e.$hK=fe;class X extends Error{static NotAvailable(W,pe){return new X(W,y.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(W){return new X(W,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,pe=y.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=pe,this._detail=Re,Object.setPrototypeOf(this,X.prototype)}}e.$iK=X;var Q;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var Z;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(Z||(e.EnvironmentVariableMutatorType=Z={}));let oe=o=class{static isTextEdit(W){return W instanceof o?!0:W?z.isRange(W)&&typeof W.newText=="string":!1}static replace(W,pe){return new o(W,pe)}static insert(W,pe){return o.replace(new z(W,W),pe)}static delete(W){return o.replace(W,"")}static setEndOfLine(W){const pe=new o(new z(new j(0,0),new j(0,0)),"");return pe.newEol=W,pe}get range(){return this.c}set range(W){if(W&&!z.isRange(W))throw(0,F.$6)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,F.$6)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,F.$6)("newEol");this.f=W}constructor(W,pe){this.c=W,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$jK=oe,e.$jK=oe=o=He([P],oe);let x=m=class{static isNotebookCellEdit(W){return W instanceof m?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,pe){return new m(W,pe)}static insertCells(W,pe){return new m(new xt(W,W),pe)}static deleteCells(W){return new m(W,[])}static updateCellMetadata(W,pe){const Re=new m(new xt(W,W),[]);return Re.newCellMetadata=pe,Re}static updateNotebookMetadata(W){const pe=new m(new xt(0,0),[]);return pe.newNotebookMetadata=W,pe}constructor(W,pe){this.range=W,this.newCells=pe}};e.$kK=x,e.$kK=x=m=He([P],x);class ae{static isSnippetTextEdit(W){return W instanceof ae?!0:W?z.isRange(W.range)&&U.isSnippetString(W.snippet):!1}static replace(W,pe){return new ae(W,pe)}static insert(W,pe){return ae.replace(new z(W,W),pe)}constructor(W,pe){this.range=W,this.snippet=pe}}e.$lK=ae;var ve;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(ve||(e.FileEditType=ve={}));let G=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,pe,Re,Qe){this.c.push({_type:1,from:W,to:pe,options:Re,metadata:Qe})}createFile(W,pe,Re){this.c.push({_type:1,from:void 0,to:W,options:pe,metadata:Re})}deleteFile(W,pe,Re){this.c.push({_type:1,from:W,to:void 0,options:pe,metadata:Re})}e(W,pe,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(W,pe,Re,Qe){const tt=pe.start,at=pe.end;(tt!==at||Re.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:at-tt,cells:Re,metadata:Qe})}g(W,pe,Re,Qe){this.c.push({_type:3,metadata:Qe,uri:W,edit:{editType:3,index:pe,metadata:Re}})}replace(W,pe,Re,Qe){this.c.push({_type:2,uri:W,edit:new oe(pe,Re),metadata:Qe})}insert(W,pe,Re,Qe){this.replace(W,new z(pe,pe),Re,Qe)}delete(W,pe,Re){this.replace(W,pe,"",Re)}has(W){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===W.toString())}set(W,pe){if(pe)for(const Re of pe){if(!Re)continue;let Qe,tt;Array.isArray(Re)?(Qe=Re[0],tt=Re[1]):Qe=Re,x.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(W,Qe.range.start,Qe.newCellMetadata,tt):Qe.newNotebookMetadata?this.e(W,Qe.newNotebookMetadata,tt):this.f(W,Qe.range,Qe.newCells,tt):ae.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:W,range:Qe.range,edit:Qe.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Qe,metadata:tt})}else{for(let Re=0;Re<this.c.length;Re++){const Qe=this.c[Re];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,C.$Hb)(this.c)}}get(W){const pe=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&pe.push(Re.edit);return pe}entries(){const W=new M.$zc;for(const pe of this.c)if(pe._type===2){let Re=W.get(pe.uri);Re||(Re=[pe.uri,[]],W.set(pe.uri,Re)),Re[1].push(pe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$mK=G,e.$mK=G=He([P],G);let U=h=class{static isSnippetString(W){return W instanceof h?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=h.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,pe=this.e++){if(typeof W=="function"){const Re=new h;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=h.c(W);return this.value+="${",this.value+=pe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,pe=this.e++){const Re=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,pe){if(typeof pe=="function"){const Re=new h;Re.e=this.e,pe(Re),this.e=Re.e,pe=Re.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$nK=U,e.$nK=U=h=He([P],U);var q;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var me;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(me||(e.DiagnosticSeverity=me={}));let _=t=class{static isLocation(W){return W instanceof t?!0:W?z.isRange(W.range)&&w.URI.isUri(W.uri):!1}constructor(W,pe){if(this.uri=W,pe)if(z.isRange(pe))this.range=z.of(pe);else if(j.isPosition(pe))this.range=new z(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$oK=_,e.$oK=_=t=He([P],_);let ie=class{static is(W){return W?typeof W.message=="string"&&W.location&&z.isRange(W.location.range)&&w.URI.isUri(W.location.uri):!1}constructor(W,pe){this.location=W,this.message=pe}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.location.range.isEqual(pe.location.range)&&W.location.uri.toString()===pe.location.uri.toString()}};e.$pK=ie,e.$pK=ie=He([P],ie);let re=class{constructor(W,pe,Re=me.Error){if(!z.isRange(W))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=W,this.message=pe,this.severity=Re}toJSON(){return{severity:me[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.severity===pe.severity&&W.code===pe.code&&W.severity===pe.severity&&W.source===pe.source&&W.range.isEqual(pe.range)&&(0,C.$tb)(W.tags,pe.tags)&&(0,C.$tb)(W.relatedInformation,pe.relatedInformation,ie.isEqual)}};e.$qK=re,e.$qK=re=He([P],re);let Ee=class{constructor(W,pe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=pe}};e.$rK=Ee,e.$rK=Ee=He([P],Ee);var ce;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(ce||(e.DocumentHighlightKind=ce={}));let de=class{constructor(W,pe=ce.Text){this.range=W,this.kind=pe}toJSON(){return{range:this.range,kind:ce[this.kind]}}};e.$sK=de,e.$sK=de=He([P],de);var ee;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var he;(function(H){H[H.Deprecated=1]="Deprecated"})(he||(e.SymbolTag=he={}));let be=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,pe,Re,Qe,tt){this.name=W,this.kind=pe,this.containerName=tt,typeof Re=="string"&&(this.containerName=Re),Qe instanceof _?this.location=Qe:Re instanceof z&&(this.location=new _(Qe,Re)),n.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.$tK=be,e.$tK=be=n=He([P],be);let Pe=a=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(a.validate)}constructor(W,pe,Re,Qe,tt){this.name=W,this.detail=pe,this.kind=Re,this.range=Qe,this.selectionRange=tt,this.children=[],a.validate(this)}};e.$uK=Pe,e.$uK=Pe=a=He([P],Pe);var B;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let J=class{constructor(W,pe){this.title=W,this.kind=pe}};e.$vK=J,e.$vK=J=He([P],J);let te=class{static{i=this}static{this.c="."}constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.c)}};e.$wK=te,e.$wK=te=i=He([P],te),te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorMove=te.Refactor.append("move"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll"),te.Notebook=te.Empty.append("notebook");let se=class{constructor(W,pe){if(this.range=W,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$xK=se,e.$xK=se=He([P],se);class Y{constructor(W,pe,Re,Qe,tt,at){this.kind=W,this.name=pe,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=at}}e.$yK=Y;class ge{constructor(W,pe){this.fromRanges=pe,this.from=W}}e.$zK=ge;class ye{constructor(W,pe){this.fromRanges=pe,this.to=W}}e.$AK=ye;var je;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(W,pe){this.range=W,this.command=pe}get isResolved(){return!!this.command}};e.$BK=We,e.$BK=We=He([P],We);let _e=s=class{#e;static isMarkdownString(W){return W instanceof s?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,pe=!1){this.#e=new d.$1j(W,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,pe){return this.#e.appendCodeblock(pe??"",W),this}};e.$CK=_e,e.$CK=_e=s=He([P],_e);let Ye=class{constructor(W,pe){this.label=W,this.documentation=pe}};e.$DK=Ye,e.$DK=Ye=He([P],Ye);let it=class{constructor(W,pe){this.label=W,this.documentation=pe,this.parameters=[]}};e.$EK=it,e.$EK=it=He([P],it);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$FK=et,e.$FK=et=He([P],et);var Ae;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Oe;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(Oe||(e.InlayHintKind=Oe={}));let qe=class{constructor(W){this.value=W}};e.$GK=qe,e.$GK=qe=He([P],qe);let Me=class{constructor(W,pe,Re){this.position=W,this.label=pe,this.kind=Re}};e.$HK=Me,e.$HK=Me=He([P],Me);var Ze;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ze||(e.CompletionTriggerKind=Ze={}));var le;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(le||(e.CompletionItemKind=le={}));var ue;(function(H){H[H.Deprecated=1]="Deprecated"})(ue||(e.CompletionItemTag=ue={}));let Ie=class{constructor(W,pe){this.label=W,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$IK=Ie,e.$IK=Ie=He([P],Ie);let Ve=class{constructor(W=[],pe=!1){this.items=W,this.isIncomplete=pe}};e.$JK=Ve,e.$JK=Ve=He([P],Ve);let ze=class{constructor(W,pe,Re){this.insertText=W,this.range=pe,this.command=Re}};e.$KK=ze,e.$KK=ze=He([P],ze);let Xe=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$LK=Xe,e.$LK=Xe=He([P],Xe);var rt;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var ot;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function wt(H,W){return`${I.$3l.toKey(H)}.${W}`}e.$MK=wt;var Et;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(Et||(e.TextEditorLineNumbersStyle=Et={}));var Yt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Yt||(e.TextDocumentSaveReason=Yt={}));var Kt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var pt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(pt||(e.TextEditorSelectionChangeKind=pt={}));var Ut;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Tt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Tt||(e.DecorationRangeBehavior=Tt={})),function(H){function W(pe){switch(pe){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=W}(pt||(e.TextEditorSelectionChangeKind=pt={}));var Bt;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(H){function W(pe){switch(pe){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=W}(Bt||(e.SyntaxTokenType=Bt={}));let Pt=class{constructor(W,pe){if(pe&&!w.URI.isUri(pe))throw(0,F.$6)("target");if(!z.isRange(W)||W.isEmpty)throw(0,F.$6)("range");this.range=W,this.target=pe}};e.$NK=Pt,e.$NK=Pt=He([P],Pt);let At=class{constructor(W,pe,Re,Qe){this.red=W,this.green=pe,this.blue=Re,this.alpha=Qe}};e.$OK=At,e.$OK=At=He([P],At);let Ot=class{constructor(W,pe){if(pe&&!(pe instanceof At))throw(0,F.$6)("color");if(!z.isRange(W)||W.isEmpty)throw(0,F.$6)("range");this.range=W,this.color=pe}};e.$PK=Ot,e.$PK=Ot=He([P],Ot);let Wt=class{constructor(W){if(!W||typeof W!="string")throw(0,F.$6)("label");this.label=W}};e.$QK=Wt,e.$QK=Wt=He([P],Wt);var Ht;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var qt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(qt||(e.SourceControlInputBoxValidationType=qt={}));var ct;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ct||(e.TerminalExitReason=ct={}));class lt{constructor(W,pe,Re){if(this.startIndex=W,this.length=pe,this.tooltip=Re,typeof W!="number"||W<0)throw(0,F.$6)("startIndex");if(typeof pe!="number"||pe<1)throw(0,F.$6)("length");if(Re!==void 0&&typeof Re!="string")throw(0,F.$6)("tooltip")}}e.$RK=lt;class Jt{constructor(W){this.uri=W}}e.$SK=Jt;class It{constructor(W){this.terminalCommand=W}}e.$TK=It;var kt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class ft{constructor(W){if(this.options=W,typeof W!="object")throw(0,F.$6)("options")}}e.$UK=ft;var Dt;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Dt||(e.TaskRevealKind=Dt={}));var Ft;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(Ft||(e.TaskPanelKind=Ft={}));let yt=class{static{u=this}static{this.Clean=new u("clean","Clean")}static{this.Build=new u("build","Build")}static{this.Rebuild=new u("rebuild","Rebuild")}static{this.Test=new u("test","Test")}static from(W){switch(W){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}constructor(W,pe){if(this.label=pe,typeof W!="string"||typeof pe!="string")throw(0,F.$6)("name");this.c=W}get id(){return this.c}};e.$VK=yt,e.$VK=yt=u=He([P],yt);function Ge(H){let W="";for(let pe=0;pe<H.length;pe++)W+=H[pe].replace(/,/g,",,")+",";return W}let Nt=class{constructor(W,pe,Re){if(typeof W!="string")throw(0,F.$6)("process");this.e=[],this.c=W,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Re):this.f=pe)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,F.$6)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)W.push(pe);return Ge(W)}};e.$WK=Nt,e.$WK=Nt=He([P],Nt);let jt=class{constructor(W,pe,Re){if(this.f=[],Array.isArray(pe)){if(!W)throw(0,F.$6)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$6)("command");this.e=W,this.f=pe,this.g=Re}else{if(typeof W!="string")throw(0,F.$6)("commandLine");this.c=W,this.g=pe}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,F.$6)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$6)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)W.push(typeof pe=="string"?pe:pe.value);return Ge(W)}};e.$XK=jt,e.$XK=jt=He([P],jt);var Le;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Le||(e.ShellQuoting=Le={}));var Fe;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Fe||(e.TaskScope=Fe={}));class Se{constructor(W){this.c=W}computeId(){return"customExecution"+(0,R.$dg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$YK=Se;let ne=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,pe,Re,Qe,tt,at){this.j=!1,this.k=this.definition=W;let ht;typeof pe=="string"?(this.m=this.name=pe,this.t=this.source=Re,this.execution=Qe,ht=tt,this.j=!0):pe===Fe.Global||pe===Fe.Workspace?(this.target=pe,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,ht=at):(this.target=pe,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,ht=at),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Nt?this.k={type:S.e,id:this.n.computeId()}:this.n instanceof jt?this.k={type:S.f,id:this.n.computeId()}:this.n instanceof Se?this.k={type:S.c,id:this.n.computeId()}:this.k={type:S.g,id:(0,R.$dg)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,F.$6)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,F.$6)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const pe=this.k.type;(S.g===pe||S.e===pe||S.f===pe||S.c===pe)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,F.$6)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$ZK=ne,e.$ZK=ne=S=He([P],ne);var Te;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Te||(e.ProgressLocation=Te={}));var Ke;(function(H){function W(pe){const Re=pe;return(0,E.$Bf)(Re.value)?Re.tooltip&&!(0,E.$xf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}H.isViewBadge=W})(Ke||(e.ViewBadge=Ke={}));let xe=k=class{static isTreeItem(W,pe){const Re=W;if(Re.checkboxState!==void 0){const Qe=(0,E.$Bf)(Re.checkboxState)?Re.checkboxState:(0,E.$zf)(Re.checkboxState)&&(0,E.$Bf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,tt=!(0,E.$Bf)(Re.checkboxState)&&(0,E.$zf)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==nt.Checked&&Qe!==nt.Unchecked||tt!==void 0&&!(0,E.$xf)(tt))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof k)return!0;if(Re.label!==void 0&&!(0,E.$xf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,E.$xf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,E.$xf)(Re.iconPath)&&!w.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,E.$xf)(Re.iconPath.id))){const Qe=Re.iconPath;if(!Qe||!(0,E.$xf)(Qe.light)&&!w.URI.isUri(Qe.light)&&!(0,E.$xf)(Qe.dark)&&!w.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,E.$xf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!w.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,E.$xf)(Re.tooltip)&&!(Re.tooltip instanceof _e)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<Je.None&&Re.collapsibleState>Je.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,E.$xf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,pe=Je.None){this.collapsibleState=pe,w.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$1K=xe,e.$1K=xe=k=He([P],xe);var Je;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Je||(e.TreeItemCollapsibleState=Je={}));var nt;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(nt||(e.TreeItemCheckboxState=nt={}));let mt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$2K=mt,e.$2K=mt=He([P],mt);class gt extends mt{}e.$3K=gt;class bt extends gt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$4K=bt;class dt{constructor(W,pe,Re,Qe){this.name=W,this.uri=pe,this._itemId=Re,this.c=Qe}data(){return this.c()}}e.$5K=dt;let Rt=class{#e=new Map;constructor(W){for(const[pe,Re]of W??[]){const Qe=this.#e.get(this.#t(pe));Qe?Qe.push(Re):this.#e.set(this.#t(pe),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,pe){this.#e.set(this.#t(W),[pe])}forEach(W,pe){for(const[Re,Qe]of this.#e)for(const tt of Qe)W.call(pe,tt,Re,this)}*[Symbol.iterator](){for(const[W,pe]of this.#e)for(const Re of pe)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$6K=Rt,e.$6K=Rt=He([P],Rt);let Gt=class{constructor(W){this.insertText=W}};e.$7K=Gt,e.$7K=Gt=He([P],Gt);let Ei=class{constructor(W,pe){this.label=pe,this.insertText=W}};e.$8K=Ei,e.$8K=Ei=He([P],Ei);let Vt=class{constructor(W,pe){this.id=W,this.color=pe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$9K=Vt,e.$9K=Vt=He([P],Vt),Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let mi=class{constructor(W){this.id=W}};e.$0K=mi,e.$0K=mi=He([P],mi);var Ct;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Ct||(e.ConfigurationTarget=Ct={}));let ki=class{get base(){return this.c}set base(W){this.c=W,this.e=w.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,pe){if(typeof W!="string"&&(!W||!w.URI.isUri(W)&&!w.URI.isUri(W.uri)))throw(0,F.$6)("base");if(typeof pe!="string")throw(0,F.$6)("pattern");typeof W=="string"?this.baseUri=w.URI.file(W):w.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$$K=ki,e.$$K=ki=He([P],ki);const qi=new WeakMap;function St(H,W){qi.set(H,W)}e.$_K=St;let ii=class{constructor(W,pe,Re,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof pe=="string"&&(this.condition=pe),typeof Re=="string"&&(this.hitCondition=Re),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=qi.get(this)??(0,R.$dg)()),this.c}};e.$aL=ii,e.$aL=ii=He([P],ii);let $i=class extends ii{constructor(W,pe,Re,Qe,tt){if(super(pe,Re,Qe,tt),W===null)throw(0,F.$6)("location");this.location=W}};e.$bL=$i,e.$bL=$i=He([P],$i);let oi=class extends ii{constructor(W,pe,Re,Qe,tt){super(pe,Re,Qe,tt),this.functionName=W}};e.$cL=oi,e.$cL=oi=He([P],oi);let Si=class extends ii{constructor(W,pe,Re,Qe,tt,at,ht){if(super(Qe,tt,at,ht),!pe)throw(0,F.$6)("dataId");this.label=W,this.dataId=pe,this.canPersist=Re}};e.$dL=Si,e.$dL=Si=He([P],Si);let Di=class{constructor(W,pe,Re){this.command=W,this.args=pe||[],this.options=Re}};e.$eL=Di,e.$eL=Di=He([P],Di);let Mt=class{constructor(W,pe){this.port=W,this.host=pe}};e.$fL=Mt,e.$fL=Mt=He([P],Mt);let bi=class{constructor(W){this.path=W}};e.$gL=bi,e.$gL=bi=He([P],bi);let Ci=class{constructor(W){this.implementation=W}};e.$hL=Ci,e.$hL=Ci=He([P],Ci);let ai=class{constructor(W,pe,Re){this.session=W,this.threadId=pe,this.frameId=Re}};e.$iL=ai,e.$iL=ai=He([P],ai);let ci=class{constructor(W,pe){this.session=W,this.threadId=pe}};e.$jL=ci,e.$jL=ci=He([P],ci);let ut=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$kL=ut,e.$kL=ut=He([P],ut);var Vi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Vi||(e.InlineCompletionTriggerKind=Vi={}));let Xt=class{constructor(W,pe){this.range=W,this.text=pe}};e.$lL=Xt,e.$lL=Xt=He([P],Xt);let ni=class{constructor(W,pe,Re=!0){this.range=W,this.variableName=pe,this.caseSensitiveLookup=Re}};e.$mL=ni,e.$mL=ni=He([P],ni);let wi=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$nL=wi,e.$nL=wi=He([P],wi);let Ii=class{constructor(W,pe){this.frameId=W,this.stoppedLocation=pe}};e.$oL=Ii,e.$oL=Ii=He([P],Ii);var Ki;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Pi=$=class extends Error{static FileExists(W){return new $(W,v.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(W){return new $(W,v.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(W){return new $(W,v.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(W){return new $(W,v.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(W){return new $(W,v.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(W){return new $(W,v.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(W,pe=v.FileSystemProviderErrorCode.Unknown,Re){super(w.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,v.$lk)(this,pe),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$pL=Pi,e.$pL=Pi=$=He([P],Pi);let vi=class{constructor(W,pe,Re){this.start=W,this.end=pe,this.kind=Re}};e.$qL=vi,e.$qL=vi=He([P],vi);var Hi;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Ai;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ui;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(ui||(e.CommentMode=ui={}));var Gi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var pi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(pi||(e.CommentThreadState=pi={}));class Ri{constructor(W,pe=[]){this.tokenTypes=W,this.tokenModifiers=pe}}e.$rL=Ri;function cn(H){return typeof H>"u"||(0,E.$yf)(H)}class Mi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let pe=0,Re=W.tokenTypes.length;pe<Re;pe++)this.j.set(W.tokenTypes[pe],pe);for(let pe=0,Re=W.tokenModifiers.length;pe<Re;pe++)this.k.set(W.tokenModifiers[pe],pe)}}push(W,pe,Re,Qe,tt){if(typeof W=="number"&&typeof pe=="number"&&typeof Re=="number"&&typeof Qe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(W,pe,Re,Qe,tt);if(z.isRange(W)&&typeof pe=="string"&&cn(Re))return this.m(W,pe,Re);throw(0,F.$6)()}m(W,pe,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(pe))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,tt=W.start.character,at=W.end.character-W.start.character,ht=this.j.get(pe);let zt=0;if(Re)for(const Zt of Re){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);zt|=1<<ei>>>0}this.n(Qe,tt,at,ht,zt)}n(W,pe,Re,Qe,tt){if(this.f&&(W<this.c||W===this.c&&pe<this.e)){this.f=!1;const zt=this.g.length/5|0;let Zt=0,ei=0;for(let ti=0;ti<zt;ti++){let si=this.g[5*ti],Bi=this.g[5*ti+1];si===0?(si=Zt,Bi+=ei):si+=Zt,this.g[5*ti]=si,this.g[5*ti+1]=Bi,Zt=si,ei=Bi}}let at=W,ht=pe;this.f&&this.h>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ht,this.g[this.h++]=Re,this.g[this.h++]=Qe,this.g[this.h++]=tt,this.c=W,this.e=pe}static o(W){const pe=[],Re=W.length/5|0;for(let ht=0;ht<Re;ht++)pe[ht]=ht;pe.sort((ht,zt)=>{const Zt=W[5*ht],ei=W[5*zt];if(Zt===ei){const ti=W[5*ht+1],si=W[5*zt+1];return ti-si}return Zt-ei});const Qe=new Uint32Array(W.length);let tt=0,at=0;for(let ht=0;ht<Re;ht++){const zt=5*pe[ht],Zt=W[zt+0],ei=W[zt+1],ti=W[zt+2],si=W[zt+3],Bi=W[zt+4],pn=Zt-tt,Mn=pn===0?ei-at:ei,Wi=5*ht;Qe[Wi+0]=pn,Qe[Wi+1]=Mn,Qe[Wi+2]=ti,Qe[Wi+3]=si,Qe[Wi+4]=Bi,tt=Zt,at=ei}return Qe}build(W){return this.f?new ri(new Uint32Array(this.g),W):new ri(Mi.o(this.g),W)}}e.$sL=Mi;class ri{constructor(W,pe){this.resultId=pe,this.data=W}}e.$tL=ri;class un{constructor(W,pe,Re){this.start=W,this.deleteCount=pe,this.data=Re}}e.$uL=un;class ln{constructor(W,pe){this.resultId=pe,this.edits=W}}e.$vL=ln;var Ji;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Ji||(e.DebugConsoleMode=Ji={}));let fi=class{static{this.Back={iconPath:new Vt("arrow-left")}}constructor(){}};e.$wL=fi,e.$wL=fi=He([P],fi);var Qi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var gi;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class Yi{static validate(W){if(typeof W.badge=="string"){let pe=(0,b.$$e)(W.badge,0);if(pe<W.badge.length&&(pe+=(0,b.$$e)(W.badge,pe)),W.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Vt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,pe,Re){this.badge=W,this.tooltip=pe,this.color=Re}}e.$xL=Yi;let Li=class{constructor(W){this.kind=W}};e.$yL=Li,e.$yL=Li=He([P],Li);var Xi;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Xi||(e.ColorThemeKind=Xi={}));class xt{static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,pe){if(W<0)throw(0,F.$6)("start must be positive");if(pe<0)throw(0,F.$6)("end must be positive");W<=pe?(this.c=W,this.e=pe):(this.c=pe,this.e=W)}with(W){let pe=this.c,Re=this.e;return W.start!==void 0&&(pe=W.start),W.end!==void 0&&(Re=W.end),pe===this.c&&Re===this.e?this:new xt(pe,Re)}}e.$zL=xt;class yi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(pe=>yi.isNotebookCellData(pe))}static isNotebookCellData(W){return!0}constructor(W,pe,Re,Qe,tt,at,ht){this.kind=W,this.value=pe,this.languageId=Re,this.mime=Qe,this.outputs=tt??[],this.metadata=at,this.executionSummary=ht,yi.validate(this)}}e.$AL=yi;class hn{constructor(W){this.cells=W}}e.$BL=hn;class Qt{static isNotebookCellOutputItem(W){return W instanceof Qt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const pe={name:W.name,message:W.message,stack:W.stack};return Qt.json(pe,"application/vnd.code.notebook.error")}static stdout(W){return Qt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Qt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,pe="application/octet-stream"){return new Qt(W,pe)}static#e=new TextEncoder;static text(W,pe=A.$Mr.text){const Re=Qt.#e.encode(String(W));return new Qt(Re,pe)}static json(W,pe="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Qt.text(Re,pe)}constructor(W,pe){this.data=W,this.mime=pe;const Re=(0,A.$Qr)(pe,!0);if(!Re)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$CL=Qt;class li{static isNotebookCellOutput(W){return W instanceof li?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,pe=!1){const Re=new Set,Qe=new Set;for(let tt=0;tt<W.length;tt++){const at=W[tt],ht=(0,A.$Qr)(at.mime);if(!Re.has(ht)||(0,D.$mI)(ht)){Re.add(ht);continue}Qe.add(tt),pe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Qe.size===0?W:W.filter((tt,at)=>!Qe.has(at))}constructor(W,pe,Re){this.items=li.ensureUniqueMimeTypes(W,!0),typeof pe=="string"?(this.id=pe,this.metadata=Re):(this.id=(0,R.$dg)(),this.metadata=pe??Re)}}e.$DL=li;var Fi;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(Fi||(e.NotebookCellKind=Fi={}));var Ue;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Ue||(e.NotebookCellExecutionState=Ue={}));var _t;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(_t||(e.NotebookCellStatusBarAlignment=_t={}));var Ti;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ti||(e.NotebookEditorRevealType=Ti={}));class $t{constructor(W,pe){this.text=W,this.alignment=pe}}e.$EL=$t;var xi;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(xi||(e.NotebookControllerAffinity=xi={}));var _i;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class en{constructor(W,pe=[]){this.uri=W,this.provides=(0,C.$2b)(pe)}}e.$FL=en;class dn{constructor(W){this.label=W}}e.$GL=dn;let hi=class{constructor(W,pe){this.label=W,this.timestamp=pe}};e.$HL=hi,e.$HL=hi=He([P],hi);var tn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(W,pe){this.ranges=W,this.wordPattern=pe}}e.$IL=sn;class fn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$JL=fn;var on;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Oi=class{constructor(W=void 0,pe=void 0,Re=void 0,Qe=!1){this.include=W,this.exclude=pe,this.profile=Re,this.continuous=Qe}};e.$KL=Oi,e.$KL=Oi=He([P],Oi);let Ni=f=class{static diff(W,pe,Re){const Qe=new f(W);return Qe.expectedOutput=pe,Qe.actualOutput=Re,Qe}constructor(W){this.message=W}};e.$LL=Ni,e.$LL=Ni=f=He([P],Ni);let ji=class{constructor(W){this.id=W}};e.$ML=ji,e.$ML=ji=He([P],ji);let di=class{constructor(W,pe){this.covered=W,this.total=pe}};e.$NL=di,e.$NL=di=He([P],di);let zi=g=class{static fromDetails(W,pe){const Re=new di(0,0),Qe=new di(0,0),tt=new di(0,0);for(const ht of pe)if("branches"in ht){Re.total+=1,Re.covered+=ht.executionCount>0?1:0;for(const zt of ht.branches)Qe.total+=1,Qe.covered+=zt.executionCount>0?1:0}else tt.total+=1,tt.covered+=ht.executionCount>0?1:0;const at=new g(W,Re,Qe.total>0?Qe:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=pe,at}constructor(W,pe,Re,Qe){this.uri=W,this.statementCoverage=pe,this.branchCoverage=Re,this.functionCoverage=Qe}};e.$OL=zi,e.$OL=zi=g=He([P],zi);let Ui=class{constructor(W,pe,Re=[]){this.executionCount=W,this.location=pe,this.branches=Re}};e.$PL=Ui,e.$PL=Ui=He([P],Ui);let we=class{constructor(W,pe){this.executionCount=W,this.location=pe}};e.$QL=we,e.$QL=we=He([P],we);let ke=class{constructor(W,pe){this.executionCount=W,this.location=pe}};e.$RL=ke,e.$RL=ke=He([P],ke);var Ne;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Ne||(e.ExternalUriOpenerPriority=Ne={}));var st;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(st||(e.WorkspaceTrustState=st={}));var vt;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(vt||(e.PortAutoForwardAction=vt={}));class Lt{constructor(W,pe,Re,Qe,tt,at){this.kind=W,this.name=pe,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=at}}e.$SL=Lt;class yn{constructor(W){this.uri=W}}e.$TL=yn;class En{constructor(W,pe){this.original=W,this.modified=pe}}e.$UL=En;class kn{constructor(W,pe,Re,Qe){this.base=W,this.input1=pe,this.input2=Re,this.result=Qe}}e.$VL=kn;class Sn{constructor(W,pe){this.uri=W,this.viewType=pe}}e.$WL=Sn;class Dn{constructor(W){this.viewType=W}}e.$XL=Dn;class Cn{constructor(W,pe){this.uri=W,this.notebookType=pe}}e.$YL=Cn;class In{constructor(W,pe,Re){this.original=W,this.modified=pe,this.notebookType=Re}}e.$ZL=In;class Pn{constructor(){}}e.$1L=Pn;class An{constructor(W,pe){this.uri=W,this.inputBoxUri=pe}}e.$2L=An;var gn;(function(H){H[H.Up=1]="Up",H[H.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var bn;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(bn||(e.ChatMessageRole=bn={}));var wn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Rn{constructor(W,pe){this.role=W,this.content=pe}}e.$3L=Rn;var vn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(vn||(e.RelatedInformationType=vn={}))}),define(De[141],Ce([1,0,58,17,15,171,124,7,19]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=e.$eM=e.$dM=void 0;const w=new Map;function R(D,p){p?w.set(D,p):w.delete(D)}e.$dM=R;function I(D){return w.get(D)}class v extends M.$Ru{constructor(p,l,c,r,o,m,h,t){super(l,c,r,o),this.c=p,this.m=m,this.q=h,this.notebook=t,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(p){return(0,E.$tb)(this.f,p)}get document(){if(!this.a){const p=this;this.a={get uri(){return p.d},get fileName(){return p.d.fsPath},get isUntitled(){return p.d.scheme===F.Schemas.untitled},get languageId(){return p.m},get version(){return p.h},get isClosed(){return p.b},get isDirty(){return p.q},save(){return p.r()},getText(l){return l?p.s(l):p.getText()},get eol(){return p.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return p.f.length},lineAt(l){return p.t(l)},offsetAt(l){return p.u(l)},positionAt(l){return p.v(l)},validateRange(l){return p.w(l)},validatePosition(l){return p.x(l)},getWordRangeAtPosition(l,c){return p.y(l,c)}}}return Object.freeze(this.a)}_acceptLanguageId(p){(0,C.ok)(!this.b),this.m=p}_acceptIsDirty(p){(0,C.ok)(!this.b),this.q=p}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(p){const l=this.w(p);if(l.isEmpty)return"";if(l.isSingleLine)return this.f[l.start.line].substring(l.start.character,l.end.character);const c=this.g,r=l.start.line,o=l.end.line,m=[];m.push(this.f[r].substring(l.start.character));for(let h=r+1;h<o;h++)m.push(this.f[h]);return m.push(this.f[o].substring(0,l.end.character)),m.join(c)}t(p){let l;if(p instanceof b.$dK?l=p.line:typeof p=="number"&&(l=p),typeof l!="number"||l<0||l>=this.f.length||Math.floor(l)!==l)throw new Error("Illegal value for `line`");return new y(l,this.f[l],l===this.f.length-1)}u(p){return p=this.x(p),this.l(),this.j.getPrefixSum(p.line-1)+p.character}v(p){p=Math.floor(p),p=Math.max(0,p),this.l();const l=this.j.getIndexOf(p),c=this.f[l.index].length;return new b.$dK(l.index,Math.min(l.remainder,c))}w(p){if(!(p instanceof b.$eK))throw new Error("Invalid argument");const l=this.x(p.start),c=this.x(p.end);return l===p.start&&c===p.end?p:new b.$eK(l.line,l.character,c.line,c.character)}x(p){if(!(p instanceof b.$dK))throw new Error("Invalid argument");if(this.f.length===0)return p.with(0,0);let{line:l,character:c}=p,r=!1;if(l<0)l=0,c=0,r=!0;else if(l>=this.f.length)l=this.f.length-1,c=this.f[l].length,r=!0;else{const o=this.f[l].length;c<0?(c=0,r=!0):c>o&&(c=o,r=!0)}return r?new b.$dK(l,c):p}y(p,l){const c=this.x(p);if(!l)l=I(this.m);else if((0,d.$Ne)(l))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${l.source}' because it matches the empty string.`);const r=(0,A.$5r)(c.character+1,(0,A.$3r)(l),this.f[c.line],0);if(r)return new b.$eK(c.line,r.startColumn-1,c.line,r.endColumn-1)}}e.$eM=v;class y{constructor(p,l,c){this.a=p,this.b=l,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$eK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$eK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$fM=y}),define(De[274],Ce([1,0,7,20,4]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;let M=class{constructor(b){this.a=new C.$yL(C.ColorThemeKind.Dark),this.b=new d.$Md}get activeColorTheme(){return this.a}$onColorThemeChange(b){let E;switch(b){case"light":E=C.ColorThemeKind.Light;break;case"hcDark":E=C.ColorThemeKind.HighContrast;break;case"hcLight":E=C.ColorThemeKind.HighContrastLight;break;default:E=C.ColorThemeKind.Dark}this.a=new C.$yL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$kdc=M,e.$kdc=M=He([Be(0,F.$bM)],M)}),define(De[275],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qI=e.CellExecutionUpdateType=void 0;var F;(function(d){d[d.Output=1]="Output",d[d.OutputItems=2]="OutputItems",d[d.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$qI=(0,C.$Nh)("INotebookExecutionService")}),define(De[67],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6I=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(M){M.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var F;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class d{static fromExtHostTestItem(A,b,E=A.parent){if(A._isRoot)return new d([b]);const w=[A.id];for(let R=E;R&&R.id!==b;R=R.parent)w.push(R.id);return w.push(b),new d(w.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const b=A.indexOf("\0");return b===-1?A:A.slice(0,b)}static fromString(A){return new d(A.split("\0"))}static join(A,b){return new d([...A.path,b])}static joinToString(A,b){return A.toString()+"\0"+b}static parentId(A){const b=A.lastIndexOf("\0");return b===-1?void 0:A.slice(0,b)}static localId(A){const b=A.lastIndexOf("\0");return b===-1?A:A.slice(b+1)}static isChild(A,b){return b.startsWith(A)&&b[A.length]==="\0"}static compare(A,b){return A===b?0:d.isChild(A,b)?2:d.isChild(b,A)?3:1}constructor(A,b=A.length){if(this.path=A,this.d=b,A.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new d(this.path,1)}get parentId(){return this.d>1?new d(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new d(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new d(this.path,A)}compare(A){if(typeof A=="string")return d.compare(this.toString(),A);for(let b=0;b<A.d&&b<this.d;b++)if(A.path[b]!==this.path[b])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$6I=d}),define(De[87],Ce([1,0,2,34,67]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$_I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$$I=e.$0I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$9I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$8I=e.$7I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var A;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var b;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$7I=[2,4,8,16,32,64];const E=k=>"runId"in k;e.$8I=E;var w;(function(k){k.serialize=$=>({range:$.range.toJSON(),uri:$.uri.toJSON()}),k.deserialize=$=>({range:F.$ps.lift($.range),uri:C.URI.revive($.uri)})})(w||(e.IRichLocation=w={}));var R;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(R||(e.TestMessageType=R={}));var I;(function(k){k.serialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&w.serialize($.location)}),k.deserialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&w.deserialize($.location)})})(I||(e.ITestErrorMessage=I={}));const v=(k,$)=>`${$?"s":"e"}${k}`;e.$9I=v;var y;(function(k){k.serialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&w.serialize($.location)}),k.deserialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&w.deserialize($.location)})})(y||(e.ITestOutputMessage=y={}));var D;(function(k){k.serialize=$=>$.type===0?I.serialize($):y.serialize($),k.deserialize=$=>$.type===0?I.deserialize($):y.deserialize($)})(D||(e.ITestMessage=D={}));var p;(function(k){k.serializeWithoutMessages=$=>({state:$.state,duration:$.duration,messages:[]}),k.serialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(D.serialize)}),k.deserialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(D.deserialize)})})(p||(e.ITestTaskState=p={}));const l="\0",c=(k,$)=>k+l+$;e.$0I=c;const r=k=>{const $=k.indexOf(l);return{ctrlId:k.slice(0,$),tagId:k.slice($+1)}};e.$$I=r;var o;(function(k){k.serialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?.toJSON(),range:$.range?.toJSON()||null,description:$.description,error:$.error,sortText:$.sortText}),k.deserialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?C.URI.revive($.uri):void 0,range:$.range?F.$ps.lift($.range):null,description:$.description,error:$.error,sortText:$.sortText})})(o||(e.ITestItem=o={}));var m;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(m||(e.TestItemExpandState=m={}));var h;(function(k){k.serialize=$=>({expand:$.expand,item:o.serialize($.item)}),k.deserialize=$=>({controllerId:d.$6I.root($.item.extId),expand:$.expand,item:o.deserialize($.item)})})(h||(e.InternalTestItem=h={}));var t;(function(k){k.serialize=$=>{let f;return $.item&&(f={},$.item.label!==void 0&&(f.label=$.item.label),$.item.tags!==void 0&&(f.tags=$.item.tags),$.item.busy!==void 0&&(f.busy=$.item.busy),$.item.uri!==void 0&&(f.uri=$.item.uri?.toJSON()),$.item.range!==void 0&&(f.range=$.item.range?.toJSON()),$.item.description!==void 0&&(f.description=$.item.description),$.item.error!==void 0&&(f.error=$.item.error),$.item.sortText!==void 0&&(f.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:f}},k.deserialize=$=>{let f;return $.item&&(f={},$.item.label!==void 0&&(f.label=$.item.label),$.item.tags!==void 0&&(f.tags=$.item.tags),$.item.busy!==void 0&&(f.busy=$.item.busy),$.item.range!==void 0&&(f.range=$.item.range?F.$ps.lift($.item.range):null),$.item.description!==void 0&&(f.description=$.item.description),$.item.error!==void 0&&(f.error=$.item.error),$.item.sortText!==void 0&&(f.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:f}}})(t||(e.ITestItemUpdate=t={}));const n=(k,$)=>{$.expand!==void 0&&(k.expand=$.expand),$.item!==void 0&&(k.item=k.item?Object.assign(k.item,$.item):$.item)};e.$_I=n;var a;(function(k){k.serializeWithoutMessages=$=>({...h.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(p.serializeWithoutMessages)}),k.serialize=$=>({...h.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(p.serialize)}),k.deserialize=$=>({...h.deserialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(p.deserialize),retired:!0})})(a||(e.TestResultItem=a={}));var i;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(i||(e.DetailType=i={}));var s;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(s||(e.TestDiffOpType=s={}));var u;(function(k){k.deserialize=$=>$.op===0?{op:$.op,item:h.deserialize($.item)}:$.op===1?{op:$.op,item:t.deserialize($.item)}:$.op===2?{op:$.op,uri:C.URI.revive($.uri),docv:$.docv}:$,k.serialize=$=>$.op===0?{op:$.op,item:h.serialize($.item)}:$.op===1?{op:$.op,item:t.serialize($.item)}:$})(u||(e.TestsDiffOp=u={}));class S{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply($){const f=this.p();for(const g of $)switch(g.op){case 0:this.k(h.deserialize(g.item),f);break;case 1:this.l(t.deserialize(g.item),f);break;case 3:this.m(g.itemId,f);break;case 5:this.o(g.itemId);break;case 4:this.updatePendingRoots(g.amount);break;case 6:this.d.set(g.tag.id,g.tag);break;case 7:this.d.delete(g.id);break}f.complete?.()}k($,f){const g=d.$6I.parentId($.item.extId)?.toString();let P;if(!g)P=this.q($),this.g.add(P),this.f.set($.item.extId,P);else if(this.f.has(g)){const O=this.f.get(g);O.children.add($.item.extId),P=this.q($,O),this.f.set($.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify($)}`);return}return f.add?.(P),$.expand===2&&this.h++,P}l($,f){const g=this.f.get($.extId);if(g)return $.expand!==void 0&&(g.expand===2&&this.h--,$.expand===2&&this.h++),(0,e.$_I)(g,$),f.update?.(g),g}m($,f){const g=this.f.get($);if(!g)return;const P=d.$6I.parentId(g.item.extId)?.toString();P?this.f.get(P).children.delete(g.item.extId):this.g.delete(g);const O=[[$]];for(;O.length;)for(const N of O.pop()){const L=this.f.get(N);L&&(O.push(L.children),this.f.delete(N),f.remove?.(L,L!==g),L.expand===2&&this.h--)}}o($){}updatePendingRoots($){this.j+=$}p(){return{}}}e.$aJ=S}),define(De[109],Ce([1,0,9,4,3,58,87,67]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.TestItemEventOp=void 0;var E;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const w=(r,o)=>r===o,I=Object.entries({range:(r,o)=>r===o?!0:!r||!o?!1:r.equalsRange(o),busy:w,label:w,description:w,error:w,sortText:w,tags:(r,o)=>!(r.length!==o.length||r.some(m=>!o.includes(m)))}),v=(r,o)=>{let m;for(const[h,t]of I)t(r[h],o[h])||(m?m[h]=o[h]:m={[h]:o[h]});return m};class y extends d.$Rc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new C.$5g(()=>this.flushDiff(),200)),this.g=this.B(new F.$Md),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(o){this.h=o;for(const m of this.tree.values())this.I(m)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const m of this.m)if(m.op===2&&m.uri===o.uri){m.docv=o.docv;return}break}case 1:{const m=this.m[this.m.length-1];if(m){if(m.op===1&&m.item.extId===o.item.extId){(0,A.$_I)(m.item,o.item);return}if(m.op===0&&m.item.item.extId===o.item.extId){(0,A.$_I)(m.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,m){const h=this.tree.get(o);if(h){if((h.expandLevels===void 0||m>h.expandLevels)&&(h.expandLevels=m),h.expand===1){const t=this.L(h);return t.isOpen()?this.J(h,m-1):t.wait().then(()=>this.J(h,m-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,m-1)):this.J(h,m-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(o,m){switch(m.op){case 3:this.N(b.$6I.joinToString(o.fullId,m.id));break;case 0:this.y(m.item,o);break;case 5:for(const h of m.ops)this.u(o,h);break;case 1:this.z(m.new,m.old,o.fullId.toString());break;case 2:this.I(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:m.update}});break;case 6:this.w(o.actual.uri);break;default:(0,M.$3c)(m)}}w(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}y(o,m){const h=b.$6I.fromExtHostTestItem(o,this.root.id,m?.actual),t=this.s.getApiFor(o);t.parent&&t.parent!==m?.actual&&this.s.getChildren(t.parent).delete(o.id);let n=this.tree.get(h.toString());if(!n){n={fullId:h,actual:o,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},o.tags.forEach(this.C,this),this.tree.set(n.fullId.toString(),n),this.F(o,m),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(o)}}),this.H(o,n,m);return}if(n.actual===o){this.G(o,n,m);return}if(n.actual.uri?.toString()!==o.uri?.toString())return this.N(h.toString()),this.y(o,m);const a=this.s.getChildren(n.actual),i=n.actual,s=v(this.s.toITestItem(i),this.s.toITestItem(o));this.s.getApiFor(i).listener=void 0,n.actual=o,n.expand=0,s&&(s.hasOwnProperty("tags")&&(this.z(o.tags,i.tags,h.toString()),delete s.tags),this.u(n,{op:4,update:s})),this.H(o,n,m);for(const[u,S]of a)this.s.getChildren(o).get(S.id)||this.N(b.$6I.joinToString(h,S.id));this.w(n.actual.uri)}z(o,m,h){const t=new Set(m.map(n=>n.id));for(const n of o)t.delete(n.id)||this.C(n);this.pushDiff({op:1,item:{extId:h,item:{tags:o.map(n=>(0,A.$0I)(this.s.controllerId,n.id))}}}),t.forEach(this.D,this)}C(o){const m=this.j.get(o.id);m?m.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$0I)(this.s.controllerId,o.id)}}))}D(o){const m=this.j.get(o);m&&!--m.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,A.$0I)(this.s.controllerId,o)}))}F(o,m){this.s.getApiFor(o).parent=m&&m.actual!==this.root?m.actual:void 0}G(o,m,h){this.F(o,h);const t=this.s.getApiFor(o);t.parent=h?.actual,t.listener=n=>this.u(m,n),this.I(m)}H(o,m,h){this.G(o,m,h);for(const[t,n]of this.s.getChildren(o))this.y(n,m)}I(o){let m;this.h?o.resolveBarrier?m=o.resolveBarrier.isOpen()?3:2:m=o.actual.canResolveChildren?1:0:m=0,m!==o.expand&&(o.expand=m,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:m}}),m===1&&o.expandLevels!==void 0&&this.L(o))}J(o,m){if(m<0)return;const h=[];for(const[t,n]of this.s.getChildren(o.actual)){const a=this.expand(b.$6I.joinToString(o.fullId,n.id),m);(0,C.$Fg)(a)&&h.push(a)}if(h.length)return Promise.all(h).then(()=>{})}L(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const n=new C.$Rg;return n.open(),n}o.expand=2,this.M(o);const m=o.resolveBarrier=new C.$Rg,h=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let t;try{t=this.h(o.actual===this.root?void 0:o.actual)}catch(n){h(n)}return(0,C.$Fg)(t)?t.catch(h).then(()=>{m.open(),this.I(o)}):(m.open(),this.I(o)),o.resolveBarrier}M(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}N(o){const m=this.tree.get(o);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const h=[m];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.D(n.id);this.tree.delete(t.fullId.toString());for(const[n,a]of this.s.getChildren(t.actual))h.push(this.tree.get(b.$6I.joinToString(t.fullId,a.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$4L=y;class D extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$5L=D;class p extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$6L=p;class l extends Error{constructor(o,m,h){super(`TestItem with ID "${o}" is from controller "${m}" and cannot be added as a child of an item from controller "${h}".`)}}e.$7L=l;const c=(r,o,m)=>{let h=new Map;return{get size(){return h.size},forEach(t,n){for(const a of h.values())t.call(n,a,this)},[Symbol.iterator](){return h.entries()},replace(t){const n=new Map,a=new Set(h.keys()),i={op:5,ops:[]};for(const s of t){if(!(s instanceof m))throw new p(s.id);const u=o(s).controllerId;if(u!==r.controllerId)throw new l(s.id,u,r.controllerId);if(n.has(s.id))throw new D(s.id);n.set(s.id,s),a.delete(s.id),i.ops.push({op:0,item:s})}for(const s of a.keys())i.ops.push({op:3,id:s});r.listener?.(i),h=n},add(t){if(!(t instanceof m))throw new p(t.id);h.set(t.id,t),r.listener?.({op:0,item:t})},delete(t){h.delete(t)&&r.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$8L=c}),define(De[142],Ce([1,0,109]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=e.$9L=void 0;const F=new WeakMap,d=(A,b)=>{const E={controllerId:b};return F.set(A,E),E};e.$9L=d;const M=A=>{const b=F.get(A);if(!b)throw new C.$6L(A?.id||"<unknown>");return b};e.$0L=M}),define(De[110],Ce([1,0,17,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ob=e.$1ob=e.$Zob=e.$Yob=e.$Xob=void 0,e.$Xob="vscode-cdn.net",e.$Yob=`vscode-resource.${e.$Xob}`,e.$Zob=`'self' https://*.${e.$Xob}`;function d(b,E){return b.scheme===C.Schemas.http||b.scheme===C.Schemas.https?b:(E&&E.authority&&E.isRemote&&b.scheme===C.Schemas.file&&(b=F.URI.from({scheme:C.Schemas.vscodeRemote,authority:E.authority,path:b.path})),F.URI.from({scheme:C.Schemas.https,authority:`${b.scheme}+${M(b.authority)}.${e.$Yob}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$1ob=d;function M(b){return b.replace(/./g,E=>{const w=E.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?E:"-"+w.toString(16).padStart(4,"0")})}function A(b){return b.replace(/-([0-9a-f]{4})/g,(E,w)=>String.fromCharCode(parseInt(w,16)))}e.$2ob=A}),define(De[276],Ce([1,0,4,3,110]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;class M{constructor(b,E,w){this.d=b,this.e=E,this.f=w,this.a=0,this.b=new F.$Qc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const R=E.getVisibleTextEditors();for(const I of this.c.values())R.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,E,w,R,I){let v;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===b){v=o;break}if(!v)throw new Error("not a visible editor");const y=this,D=this.a++,p=new C.$Md,l=new C.$Md,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,d.$1ob)(o,y.f)}get cspSource(){return d.$Zob}set options(o){this.b=o,y.d.$setOptions(D,o)}get options(){return this.b}set html(o){this.a=o,y.d.$setHtml(D,o)}get html(){return this.a}get onDidReceiveMessage(){return p.event}postMessage(o){return y.d.$postMessage(D,o)}},r=new class{constructor(){this.editor=b,this.line=E,this.height=w,this.webview=c,this.onDidDispose=l.event}dispose(){y.c.has(D)&&(y.c.delete(D),y.d.$disposeEditorInset(D),l.fire(),l.dispose(),p.dispose())}};return this.d.$createEditorInset(D,v.id,v.value.document.uri,E+1,w,R||{},I.identifier,I.extensionLocation),this.c.set(D,{editor:b,inset:r,onDidReceiveMessage:p}),r}$onDidDispose(b){const E=this.c.get(b);E&&E.inset.dispose()}$onDidReceiveMessage(b,E){this.c.get(b)?.onDidReceiveMessage.fire(E)}}e.$Ucc=M}),define(De[277],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.VariableKind=e.$ZM=void 0,e.$ZM=(0,C.$Nh)("configurationResolverService");var F;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class d extends Error{constructor(A,b){super(b),this.variable=A}}e.$1M=d}),define(De[278],Ce([1,0,16,48,18,24,12,99,223,277,15]),function($e,e,C,F,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,D,p,l){this.h=new Map,this.a=y,this.b=D,this.g=p,l&&(this.c=l.then(c=>this.i(c)))}i(y){if(A.$j){const D=Object.create(null);return Object.keys(y).forEach(p=>{D[p.toLowerCase()]=y[p]}),D}return y}resolveWithEnvironment(y,D,p){return this.l({env:this.i(y),userHome:void 0},D?D.uri:void 0,p)}async resolveAsync(y,D){const p={env:await this.c,userHome:await this.g};return this.l(p,y?y.uri:void 0,D)}async j(y,D,p,l){const c=M.$3m(D);A.$j&&c.windows?Object.keys(c.windows).forEach(o=>c[o]=c.windows[o]):A.$k&&c.osx?Object.keys(c.osx).forEach(o=>c[o]=c.osx[o]):A.$l&&c.linux&&Object.keys(c.linux).forEach(o=>c[o]=c.linux[o]),delete c.windows,delete c.osx,delete c.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,y?y.uri:void 0,c,p,l)}async resolveAnyAsync(y,D,p){return this.j(y,D,p)}async resolveAnyMap(y,D,p){const l=new Map;return{newConfig:await this.j(y,D,p,l),resolvedVariables:l}}resolveWithInteractionReplace(y,D,p,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,D,p,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,D){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,D)}async l(y,D,p,l,c){if(d.$xf(p))return this.m(y,D,p,l,c);if(Array.isArray(p))return Promise.all(p.map(r=>this.l(y,D,r,l,c)));if(d.$zf(p)){const r=Object.create(null),o=await Promise.all(Object.keys(p).map(async m=>[await this.m(y,D,m,l,c),await this.l(y,D,p[m],l,c)]));for(const[m,h]of o)r[m]=h;return r}return p}m(y,D,p,l,c){return(0,R.$Se)(p,I.VARIABLE_REGEXP,async(r,o)=>{if(o.includes(I.VARIABLE_LHS))return r;let m=await this.o(y,r,o,D,l);return c?.set(o,m),m!==r&&d.$xf(m)&&m.match(I.VARIABLE_REGEXP)&&(m=await this.m(y,D,m,l,c)),m})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,D,p,l,c){let r;const o=p.split(":");o.length>1&&(p=o[0],r=o[1]);const m=n=>{const a=this.a.getFilePath();if(a)return(0,b.$nv)(a);throw new w.$1M(n,(0,E.localize)(0,null,D))},h=n=>{const a=m(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,b.$nv)(i)}throw new w.$1M(n,(0,E.localize)(1,null,D,C.$mc(a)))},t=n=>{if(r){const a=this.a.getFolderUri(r);if(a)return a;throw new w.$1M(n,(0,E.localize)(2,null,D,r))}if(l)return l;throw this.a.getWorkspaceFolderCount()>1?new w.$1M(n,(0,E.localize)(3,null,D)):new w.$1M(n,(0,E.localize)(4,null,D))};switch(p){case"env":if(r){if(y.env){const n=y.env[A.$j?r.toLowerCase():r];if(d.$xf(n))return n}return""}throw new w.$1M(w.VariableKind.Env,(0,E.localize)(5,null,D));case"config":if(r){const n=this.a.getConfigurationValue(l,r);if(d.$Gf(n))throw new w.$1M(w.VariableKind.Config,(0,E.localize)(6,null,D,r));if(d.$zf(n))throw new w.$1M(w.VariableKind.Config,(0,E.localize)(7,null,D,r));return n}throw new w.$1M(w.VariableKind.Config,(0,E.localize)(8,null,D));case"command":return this.p(w.VariableKind.Command,D,r,c,"command");case"input":return this.p(w.VariableKind.Input,D,r,c,"input");case"extensionInstallFolder":if(r){const n=await this.a.getExtension(r);if(!n)throw new w.$1M(w.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,D,r));return this.n(n.extensionLocation)}throw new w.$1M(w.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,D));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,b.$nv)(this.n(t(w.VariableKind.WorkspaceFolder)));case"cwd":return l||r?(0,b.$nv)(this.n(t(w.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$nv)(C.$mc(this.n(t(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new w.$1M(w.VariableKind.UserHome,(0,E.localize)(11,null,D))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new w.$1M(w.VariableKind.LineNumber,(0,E.localize)(12,null,D))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new w.$1M(w.VariableKind.SelectedText,(0,E.localize)(13,null,D))}case"file":return m(w.VariableKind.File);case"fileWorkspaceFolder":return h(w.VariableKind.FileWorkspaceFolder);case"relativeFile":return l||r?C.$kc(this.n(t(w.VariableKind.RelativeFile)),m(w.VariableKind.RelativeFile)):m(w.VariableKind.RelativeFile);case"relativeFileDirname":{const n=C.$lc(m(w.VariableKind.RelativeFileDirname));if(l||r){const a=C.$kc(this.n(t(w.VariableKind.RelativeFileDirname)),n);return a.length===0?".":a}return n}case"fileDirname":return C.$lc(m(w.VariableKind.FileDirname));case"fileExtname":return C.$nc(m(w.VariableKind.FileExtname));case"fileBasename":return C.$mc(m(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=C.$mc(m(w.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-C.$nc(n).length)}case"fileDirnameBasename":return C.$mc(C.$lc(m(w.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||D}case"execInstallFolder":{const n=this.a.getAppRoot();return n||D}case"pathSeparator":return C.sep;default:try{const n=r?`${p}:${r}`:p;return this.p(w.VariableKind.Unknown,D,n,c,void 0)}catch{return D}}}}p(y,D,p,l,c){if(p&&l){const r=c===void 0?l[p]:l[c+":"+p];if(typeof r=="string")return r;throw new w.$1M(y,(0,E.localize)(14,null,D))}return D}}e.$cN=I}),define(De[143],Ce([1,0,5,139]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.OpenEditorContext=e.GroupsOrder=e.$aC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$_B=void 0,e.$_B=(0,C.$Nh)("editorGroupsService");var d;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(d||(e.GroupDirection=d={}));var M;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var A;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var b;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EVEN=1]="EVEN",D[D.TOGGLE=2]="TOGGLE"})(b||(e.GroupsArrangement=b={}));var E;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function w(D){const p=D;return(0,F.$2D)(p?.editor)&&(0,F.$2D)(p?.replacement)}e.$aC=w;var R;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var I;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function v(D){const p=D;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.$bC=v;function y(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$cC=y}),define(De[279],Ce([1,0,5,143]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gC=e.$fC=e.$eC=e.$dC=void 0,e.$dC=(0,C.$Nh)("editorService"),e.$eC=-1,e.$fC=-2;function d(M){const A=M;return typeof M=="number"||(0,F.$bC)(A)}e.$gC=d}),define(De[14],Ce([1,0,19,22,162,74,79,28,158,62,97,24,18,2,34,82,133,142,139,108,67,87,279,7]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m,h,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$aM=e.$_L=e.MarkdownString=e.$$L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Le){function Fe(ne){const{selectionStartLineNumber:Te,selectionStartColumn:Ke,positionLineNumber:xe,positionColumn:Je}=ne,nt=new n.$dK(Te-1,Ke-1),mt=new n.$dK(xe-1,Je-1);return new n.$fK(nt,mt)}Le.to=Fe;function Se(ne){const{anchor:Te,active:Ke}=ne;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}Le.from=Se})(a||(e.Selection=a={}));var i;(function(Le){function Fe(ne){if(!ne)return;const{start:Te,end:Ke}=ne;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}Le.from=Fe;function Se(ne){if(!ne)return;const{startLineNumber:Te,startColumn:Ke,endLineNumber:xe,endColumn:Je}=ne;return new n.$eK(Te-1,Ke-1,xe-1,Je-1)}Le.to=Se})(i||(e.Range=i={}));var s;(function(Le){function Fe(Se){switch(Se){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Le.to=Fe})(s||(e.TokenType=s={}));var u;(function(Le){function Fe(ne){return new n.$dK(ne.lineNumber-1,ne.column-1)}Le.to=Fe;function Se(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Le.from=Se})(u||(e.Position=u={}));var S;(function(Le){function Fe(Te,Ke,xe){return(0,C.$Gb)((0,C.$2b)(Te).map(Je=>Se(Je,Ke,xe)))}Le.from=Fe;function Se(Te,Ke,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:ne(Te.scheme,Ke),pattern:Ze.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function ne(Te,Ke){return Ke&&typeof Te=="string"?Ke.transformOutgoingScheme(Te):Te}})(S||(e.DocumentSelector=S={}));var k;(function(Le){function Fe(ne){switch(ne){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Le.from=Fe;function Se(ne){switch(ne){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Le.to=Se})(k||(e.DiagnosticTag=k={}));var $;(function(Le){function Fe(ne){let Te;return ne.code&&((0,v.$xf)(ne.code)||(0,v.$Bf)(ne.code)?Te=String(ne.code):Te={value:String(ne.code.value),target:ne.code.target}),{...i.from(ne.range),message:ne.message,source:ne.source,code:Te,severity:g.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(f.from),tags:Array.isArray(ne.tags)?(0,C.$Gb)(ne.tags.map(k.from)):void 0}}Le.from=Fe;function Se(ne){const Te=new n.$qK(i.to(ne),ne.message,g.to(ne.severity));return Te.source=ne.source,Te.code=(0,v.$xf)(ne.code)?ne.code:ne.code?.value,Te.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(f.to),Te.tags=ne.tags&&(0,C.$Gb)(ne.tags.map(k.to)),Te}Le.to=Se})($||(e.Diagnostic=$={}));var f;(function(Le){function Fe(ne){return{...i.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Le.from=Fe;function Se(ne){return new n.$pK(new n.$oK(ne.resource,i.to(ne)),ne.message)}Le.to=Se})(f||(e.DiagnosticRelatedInformation=f={}));var g;(function(Le){function Fe(ne){switch(ne){case n.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}Le.from=Fe;function Se(ne){switch(ne){case l.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Le.to=Se})(g||(e.DiagnosticSeverity=g={}));var P;(function(Le){function Fe(ne){return typeof ne=="number"&&ne>=n.ViewColumn.One?ne-1:ne===n.ViewColumn.Beside?t.$fC:t.$eC}Le.from=Fe;function Se(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=Se})(P||(e.ViewColumn=P={}));function O(Le){return typeof Le.range<"u"}function N(Le){return Le.length===0?!0:!!O(Le[0])}e.$$L=N;var L;(function(Le){function Fe(Je){return Je.map(Le.from)}Le.fromMany=Fe;function Se(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ne(Je){let nt;if(Se(Je)){const{language:dt,value:Rt}=Je;nt={value:"```"+dt+`
`+Rt+"\n```\n"}}else n.$CK.isMarkdownString(Je)?nt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?nt={value:Je}:nt={value:""};const mt=Object.create(null);nt.uris=mt;const gt=dt=>{try{let Rt=y.URI.parse(dt,!0);Rt=Rt.with({query:Te(Rt.query,mt)}),mt[dt]=Rt}catch{}return""},bt=new E.marked.Renderer;return bt.link=gt,bt.image=dt=>typeof dt=="string"?gt(A.$8j(dt).href):"",(0,E.marked)(nt.value,{renderer:bt}),nt}Le.from=ne;function Te(Je,nt){if(!Je)return Je;let mt;try{mt=(0,w.$jh)(Je)}catch{}if(!mt)return Je;let gt=!1;return mt=(0,I.$5m)(mt,bt=>{if(y.URI.isUri(bt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[dt]=bt,gt=!0,dt}else return}),gt?JSON.stringify(mt):Je}function Ke(Je){const nt=new n.$CK(Je.value,Je.supportThemeIcons);return nt.isTrusted=Je.isTrusted,nt.supportHtml=Je.supportHtml,nt.baseUri=Je.baseUri?y.URI.from(Je.baseUri):void 0,nt}Le.to=Ke;function xe(Je){if(Je)return typeof Je=="string"?Je:Le.from(Je)}Le.fromStrict=xe})(L||(e.MarkdownString=L={}));function j(Le){return N(Le)?Le.map(Fe=>({range:i.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?L.fromMany(Fe.hoverMessage):Fe.hoverMessage?L.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Le.map(Fe=>({range:i.from(Fe)}))}e.$_L=j;function z(Le){return typeof Le>"u"?Le:typeof Le=="string"?y.URI.file(Le):Le}e.$aM=z;var T;(function(Le){function Fe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?z(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Le.from=Fe})(T||(e.ThemableDecorationAttachmentRenderOptions=T={}));var K;(function(Le){function Fe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?z(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?T.from(Se.before):void 0,after:Se.after?T.from(Se.after):void 0}}Le.from=Fe})(K||(e.ThemableDecorationRenderOptions=K={}));var V;(function(Le){function Fe(Se){if(typeof Se>"u")return Se;switch(Se){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Fe})(V||(e.DecorationRangeBehavior=V={}));var fe;(function(Le){function Fe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?V.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?K.from(Se.light):void 0,dark:Se.dark?K.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?z(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?T.from(Se.before):void 0,after:Se.after?T.from(Se.after):void 0}}Le.from=Fe})(fe||(e.DecorationRenderOptions=fe={}));var X;(function(Le){function Fe(ne){return{text:ne.newText,eol:ne.newEol&&et.from(ne.newEol),range:i.from(ne.range)}}Le.from=Fe;function Se(ne){const Te=new n.$jK(i.to(ne.range),ne.text);return Te.newEol=typeof ne.eol>"u"?void 0:et.to(ne.eol),Te}Le.to=Se})(X||(e.TextEdit=X={}));var Q;(function(Le){function Fe(ne,Te){const Ke={edits:[]};if(ne instanceof n.$mK){const xe=new b.$Ac;for(const Je of ne._allEntries())Je._type===1&&y.URI.isUri(Je.to)&&Je.from===void 0&&xe.add(Je.to);for(const Je of ne._allEntries())if(Je._type===1){let nt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?nt={type:"base64",value:(0,F.$ue)(F.$ae.wrap(Je.options.contents))}:nt={type:"dataTransferItem",id:Je.options.contents._itemId}),Ke.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:nt},metadata:Je.metadata})}else Je._type===2?Ke.edits.push({resource:Je.uri,textEdit:X.from(Je.edit),versionId:xe.has(Je.uri)?void 0:Te?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Ke.edits.push({resource:Je.uri,textEdit:{range:i.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:xe.has(Je.uri)?void 0:Te?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Ke.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Ke.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(ot.from)}})}return Ke}Le.from=Fe;function Se(ne){const Te=new n.$mK,Ke=new b.$zc;for(const xe of ne.edits)if(xe.textEdit){const Je=xe,nt=y.URI.revive(Je.resource),mt=i.to(Je.textEdit.range),gt=Je.textEdit.text,bt=Je.textEdit.insertAsSnippet;let dt;bt?dt=n.$lK.replace(mt,new n.$nK(gt)):dt=n.$jK.replace(mt,gt);const Rt=Ke.get(nt);Rt?Rt.push(dt):Ke.set(nt,[dt])}else Te.renameFile(y.URI.revive(xe.oldResource),y.URI.revive(xe.newResource),xe.options);for(const[xe,Je]of Ke)Te.set(xe,Je);return Te}Le.to=Se})(Q||(e.WorkspaceEdit=Q={}));var Z;(function(Le){const Fe=Object.create(null);Fe[n.SymbolKind.File]=0,Fe[n.SymbolKind.Module]=1,Fe[n.SymbolKind.Namespace]=2,Fe[n.SymbolKind.Package]=3,Fe[n.SymbolKind.Class]=4,Fe[n.SymbolKind.Method]=5,Fe[n.SymbolKind.Property]=6,Fe[n.SymbolKind.Field]=7,Fe[n.SymbolKind.Constructor]=8,Fe[n.SymbolKind.Enum]=9,Fe[n.SymbolKind.Interface]=10,Fe[n.SymbolKind.Function]=11,Fe[n.SymbolKind.Variable]=12,Fe[n.SymbolKind.Constant]=13,Fe[n.SymbolKind.String]=14,Fe[n.SymbolKind.Number]=15,Fe[n.SymbolKind.Boolean]=16,Fe[n.SymbolKind.Array]=17,Fe[n.SymbolKind.Object]=18,Fe[n.SymbolKind.Key]=19,Fe[n.SymbolKind.Null]=20,Fe[n.SymbolKind.EnumMember]=21,Fe[n.SymbolKind.Struct]=22,Fe[n.SymbolKind.Event]=23,Fe[n.SymbolKind.Operator]=24,Fe[n.SymbolKind.TypeParameter]=25;function Se(Te){return typeof Fe[Te]=="number"?Fe[Te]:6}Le.from=Se;function ne(Te){for(const Ke in Fe)if(Fe[Ke]===Te)return Number(Ke);return n.SymbolKind.Property}Le.to=ne})(Z||(e.SymbolKind=Z={}));var oe;(function(Le){function Fe(ne){switch(ne){case n.SymbolTag.Deprecated:return 1}}Le.from=Fe;function Se(ne){switch(ne){case 1:return n.SymbolTag.Deprecated}}Le.to=Se})(oe||(e.SymbolTag=oe={}));var x;(function(Le){function Fe(ne){return{name:ne.name,kind:Z.from(ne.kind),tags:ne.tags&&ne.tags.map(oe.from),containerName:ne.containerName,location:q.from(ne.location)}}Le.from=Fe;function Se(ne){const Te=new n.$tK(ne.name,Z.to(ne.kind),ne.containerName,q.to(ne.location));return Te.tags=ne.tags&&ne.tags.map(oe.to),Te}Le.to=Se})(x||(e.WorkspaceSymbol=x={}));var ae;(function(Le){function Fe(ne){const Te={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),kind:Z.from(ne.kind),tags:ne.tags?.map(oe.from)??[]};return ne.children&&(Te.children=ne.children.map(Fe)),Te}Le.from=Fe;function Se(ne){const Te=new n.$uK(ne.name,ne.detail,Z.to(ne.kind),i.to(ne.range),i.to(ne.selectionRange));return(0,C.$Kb)(ne.tags)&&(Te.tags=ne.tags.map(oe.to)),ne.children&&(Te.children=ne.children.map(Se)),Te}Le.to=Se})(ae||(e.DocumentSymbol=ae={}));var ve;(function(Le){function Fe(ne){const Te=new n.$yK(Z.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),i.to(ne.range),i.to(ne.selectionRange));return Te._sessionId=ne._sessionId,Te._itemId=ne._itemId,Te}Le.to=Fe;function Se(ne,Te,Ke){if(Te=Te??ne._sessionId,Ke=Ke??ne._itemId,Te===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Ke,name:ne.name,detail:ne.detail,kind:Z.from(ne.kind),uri:ne.uri,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),tags:ne.tags?.map(oe.from)}}Le.from=Se})(ve||(e.CallHierarchyItem=ve={}));var G;(function(Le){function Fe(Se){return new n.$zK(ve.to(Se.from),Se.fromRanges.map(ne=>i.to(ne)))}Le.to=Fe})(G||(e.CallHierarchyIncomingCall=G={}));var U;(function(Le){function Fe(Se){return new n.$AK(ve.to(Se.to),Se.fromRanges.map(ne=>i.to(ne)))}Le.to=Fe})(U||(e.CallHierarchyOutgoingCall=U={}));var q;(function(Le){function Fe(ne){return{range:ne.range&&i.from(ne.range),uri:ne.uri}}Le.from=Fe;function Se(ne){return new n.$oK(y.URI.revive(ne.uri),i.to(ne.range))}Le.to=Se})(q||(e.location=q={}));var me;(function(Le){function Fe(ne){const Te=ne,Ke=ne;return{originSelectionRange:Te.originSelectionRange?i.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Ke.uri,range:i.from(Te.targetRange?Te.targetRange:Ke.range),targetSelectionRange:Te.targetSelectionRange?i.from(Te.targetSelectionRange):void 0}}Le.from=Fe;function Se(ne){return{targetUri:y.URI.revive(ne.uri),targetRange:i.to(ne.range),targetSelectionRange:ne.targetSelectionRange?i.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?i.to(ne.originSelectionRange):void 0}}Le.to=Se})(me||(e.DefinitionLink=me={}));var _;(function(Le){function Fe(ne){return{range:i.from(ne.range),contents:L.fromMany(ne.contents)}}Le.from=Fe;function Se(ne){return new n.$rK(ne.contents.map(L.to),i.to(ne.range))}Le.to=Se})(_||(e.Hover=_={}));var ie;(function(Le){function Fe(ne){return{range:i.from(ne.range),expression:ne.expression}}Le.from=Fe;function Se(ne){return new n.$kL(i.to(ne.range),ne.expression)}Le.to=Se})(ie||(e.EvaluatableExpression=ie={}));var re;(function(Le){function Fe(ne){if(ne instanceof n.$lL)return{type:"text",range:i.from(ne.range),text:ne.text};if(ne instanceof n.$mL)return{type:"variable",range:i.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof n.$nL)return{type:"expression",range:i.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Fe;function Se(ne){switch(ne.type){case"text":return{range:i.to(ne.range),text:ne.text};case"variable":return{range:i.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:i.to(ne.range),expression:ne.expression}}}Le.to=Se})(re||(e.InlineValue=re={}));var Ee;(function(Le){function Fe(ne){return{frameId:ne.frameId,stoppedLocation:i.from(ne.stoppedLocation)}}Le.from=Fe;function Se(ne){return new n.$oL(ne.frameId,i.to(ne.stoppedLocation))}Le.to=Se})(Ee||(e.InlineValueContext=Ee={}));var ce;(function(Le){function Fe(ne){return{range:i.from(ne.range),kind:ne.kind}}Le.from=Fe;function Se(ne){return new n.$sK(i.to(ne.range),ne.kind)}Le.to=Se})(ce||(e.DocumentHighlight=ce={}));var de;(function(Le){function Fe(Se){switch(Se){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Le.to=Fe})(de||(e.CompletionTriggerKind=de={}));var ee;(function(Le){function Fe(Se){return{triggerKind:de.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Le.to=Fe})(ee||(e.CompletionContext=ee={}));var he;(function(Le){function Fe(ne){switch(ne){case n.CompletionItemTag.Deprecated:return 1}}Le.from=Fe;function Se(ne){switch(ne){case 1:return n.CompletionItemTag.Deprecated}}Le.to=Se})(he||(e.CompletionItemTag=he={}));var be;(function(Le){const Fe=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function Se(Ke){return Fe.get(Ke)??9}Le.from=Se;const ne=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Te(Ke){return ne.get(Ke)??n.CompletionItemKind.Property}Le.to=Te})(be||(e.CompletionItemKind=be={}));var Pe;(function(Le){function Fe(Se,ne){const Te=new n.$IK(Se.label);return Te.insertText=Se.insertText,Te.kind=be.to(Se.kind),Te.tags=Se.tags?.map(he.to),Te.detail=Se.detail,Te.documentation=A.$3j(Se.documentation)?L.to(Se.documentation):Se.documentation,Te.sortText=Se.sortText,Te.filterText=Se.filterText,Te.preselect=Se.preselect,Te.commitCharacters=Se.commitCharacters,D.$ps.isIRange(Se.range)?Te.range=i.to(Se.range):typeof Se.range=="object"&&(Te.range={inserting:i.to(Se.range.insert),replacing:i.to(Se.range.replace)}),Te.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Te.insertText=new n.$nK(Se.insertText):(Te.insertText=Se.insertText,Te.textEdit=Te.range instanceof n.$eK?new n.$jK(Te.range,Te.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Te.additionalTextEdits=Se.additionalTextEdits.map(Ke=>X.to(Ke))),Te.command=ne&&Se.command?ne.fromInternal(Se.command):void 0,Te}Le.to=Fe})(Pe||(e.CompletionItem=Pe={}));var B;(function(Le){function Fe(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:L.fromStrict(ne.documentation)}}Le.from=Fe;function Se(ne){return{label:ne.label,documentation:A.$3j(ne.documentation)?L.to(ne.documentation):ne.documentation}}Le.to=Se})(B||(e.ParameterInformation=B={}));var J;(function(Le){function Fe(ne){return{label:ne.label,documentation:L.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(B.from):[],activeParameter:ne.activeParameter}}Le.from=Fe;function Se(ne){return{label:ne.label,documentation:A.$3j(ne.documentation)?L.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(B.to):[],activeParameter:ne.activeParameter}}Le.to=Se})(J||(e.SignatureInformation=J={}));var te;(function(Le){function Fe(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(J.from):[]}}Le.from=Fe;function Se(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(J.to):[]}}Le.to=Se})(te||(e.SignatureHelp=te={}));var se;(function(Le){function Fe(Se,ne){const Te=new n.$HK(u.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(Y.to.bind(void 0,Se)),ne.kind&&ge.to(ne.kind));return Te.textEdits=ne.textEdits&&ne.textEdits.map(X.to),Te.tooltip=A.$3j(ne.tooltip)?L.to(ne.tooltip):ne.tooltip,Te.paddingLeft=ne.paddingLeft,Te.paddingRight=ne.paddingRight,Te}Le.to=Fe})(se||(e.InlayHint=se={}));var Y;(function(Le){function Fe(Se,ne){const Te=new n.$GK(ne.label);return Te.tooltip=A.$3j(ne.tooltip)?L.to(ne.tooltip):ne.tooltip,p.Command.is(ne.command)&&(Te.command=Se.fromInternal(ne.command)),ne.location&&(Te.location=q.to(ne.location)),Te}Le.to=Fe})(Y||(e.InlayHintLabelPart=Y={}));var ge;(function(Le){function Fe(ne){return ne}Le.from=Fe;function Se(ne){return ne}Le.to=Se})(ge||(e.InlayHintKind=ge={}));var ye;(function(Le){function Fe(ne){return{range:i.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Le.from=Fe;function Se(ne){let Te;if(ne.url)try{Te=typeof ne.url=="string"?y.URI.parse(ne.url,!0):y.URI.revive(ne.url)}catch{}return new n.$NK(i.to(ne.range),Te)}Le.to=Se})(ye||(e.DocumentLink=ye={}));var je;(function(Le){function Fe(ne){const Te=new n.$QK(ne.label);return ne.textEdit&&(Te.textEdit=X.to(ne.textEdit)),ne.additionalTextEdits&&(Te.additionalTextEdits=ne.additionalTextEdits.map(Ke=>X.to(Ke))),Te}Le.to=Fe;function Se(ne){return{label:ne.label,textEdit:ne.textEdit?X.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Te=>X.from(Te)):void 0}}Le.from=Se})(je||(e.ColorPresentation=je={}));var We;(function(Le){function Fe(ne){return new n.$OK(ne[0],ne[1],ne[2],ne[3])}Le.to=Fe;function Se(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Le.from=Se})(We||(e.Color=We={}));var _e;(function(Le){function Fe(ne){return{range:i.from(ne.range)}}Le.from=Fe;function Se(ne){return new n.$xK(i.to(ne.range))}Le.to=Se})(_e||(e.SelectionRange=_e={}));var Ye;(function(Le){function Fe(Se){switch(Se){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Le.to=Fe})(Ye||(e.TextDocumentSaveReason=Ye={}));var it;(function(Le){function Fe(ne){switch(ne){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Fe;function Se(ne){switch(ne){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Le.to=Se})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Le){function Fe(ne){if(ne===n.EndOfLine.CRLF)return 1;if(ne===n.EndOfLine.LF)return 0}Le.from=Fe;function Se(ne){if(ne===1)return n.EndOfLine.CRLF;if(ne===0)return n.EndOfLine.LF}Le.to=Se})(et||(e.EndOfLine=et={}));var Ae;(function(Le){function Fe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Fe})(Ae||(e.ProgressLocation=Ae={}));var Oe;(function(Le){function Fe(ne){const Te={start:ne.start+1,end:ne.end+1};return ne.kind&&(Te.kind=qe.from(ne.kind)),Te}Le.from=Fe;function Se(ne){const Te={start:ne.start-1,end:ne.end-1};return ne.kind&&(Te.kind=qe.to(ne.kind)),Te}Le.to=Se})(Oe||(e.FoldingRange=Oe={}));var qe;(function(Le){function Fe(ne){if(ne)switch(ne){case n.FoldingRangeKind.Comment:return p.$et.Comment;case n.FoldingRangeKind.Imports:return p.$et.Imports;case n.FoldingRangeKind.Region:return p.$et.Region}}Le.from=Fe;function Se(ne){if(ne)switch(ne.value){case p.$et.Comment.value:return n.FoldingRangeKind.Comment;case p.$et.Imports.value:return n.FoldingRangeKind.Imports;case p.$et.Region.value:return n.FoldingRangeKind.Region}}Le.to=Se})(qe||(e.FoldingRangeKind=qe={}));var Me;(function(Le){function Fe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?i.from(Se.selection):void 0,override:typeof Se.override=="boolean"?r.$OD.id:void 0}}Le.from=Fe})(Me||(e.TextEditorOpenOptions=Me={}));var Ze;(function(Le){function Fe(Ke){return Ke instanceof n.$$K?Ke.toJSON():typeof Ke=="string"?Ke:Se(Ke)||ne(Ke)?new n.$$K(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}Le.from=Fe;function Se(Ke){const xe=Ke;return xe?y.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ne(Ke){const xe=Ke;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(Ke){return typeof Ke=="string"?Ke:new n.$$K(y.URI.revive(Ke.baseUri),Ke.pattern)}Le.to=Te})(Ze||(e.GlobPattern=Ze={}));var le;(function(Le){function Fe(Se){if(Se){if(Array.isArray(Se))return Se.map(Fe);if(typeof Se=="string")return Se;{const ne=Se;return{language:ne.language,scheme:ne.scheme,pattern:Ze.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Le.from=Fe})(le||(e.LanguageSelector=le={}));var ue;(function(Le){function Fe(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Te=>Array.isArray(Te)&&Te.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&y.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(xe=>xe instanceof n.$eK)))}Le.is=Fe;function Se(ne){return{documents:ne.documents.map(Te=>Te.map(Ke=>({uri:y.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(xe=>i.from(xe))})))}}Le.from=Se})(ue||(e.MappedEditsContext=ue={}));var Ie;(function(Le){function Fe(ne){return{start:ne.start,end:ne.end}}Le.from=Fe;function Se(ne){return new n.$zL(ne.start,ne.end)}Le.to=Se})(Ie||(e.NotebookRange=Ie={}));var Ve;(function(Le){function Fe(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Le.to=Fe;function Se(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Le.from=Se})(Ve||(e.NotebookCellExecutionSummary=Ve={}));var ze;(function(Le){function Fe(Se){if(Se===o.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(Se===o.NotebookCellExecutionState.Pending)return;if(Se===o.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Le.to=Fe})(ze||(e.NotebookCellExecutionState=ze={}));var Xe;(function(Le){function Fe(ne){switch(ne){case n.NotebookCellKind.Markup:return o.CellKind.Markup;case n.NotebookCellKind.Code:default:return o.CellKind.Code}}Le.from=Fe;function Se(ne){switch(ne){case o.CellKind.Markup:return n.NotebookCellKind.Markup;case o.CellKind.Code:default:return n.NotebookCellKind.Code}}Le.to=Se})(Xe||(e.NotebookCellKind=Xe={}));var rt;(function(Le){function Fe(ne){const Te={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ke of ne.cells)n.$AL.validate(Ke),Te.cells.push(ot.from(Ke));return Te}Le.from=Fe;function Se(ne){const Te=new n.$BL(ne.cells.map(ot.to));return(0,v.$Kf)(ne.metadata)||(Te.metadata=ne.metadata),Te}Le.to=Se})(rt||(e.NotebookData=rt={}));var ot;(function(Le){function Fe(ne){return{cellKind:Xe.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:Ve.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(Et.from):[]}}Le.from=Fe;function Se(ne){return new n.$AL(Xe.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(Et.to):void 0,ne.metadata,ne.internalMetadata?Ve.to(ne.internalMetadata):void 0)}Le.to=Se})(ot||(e.NotebookCellData=ot={}));var wt;(function(Le){function Fe(ne){return{mime:ne.mime,valueBytes:F.$ae.wrap(ne.data)}}Le.from=Fe;function Se(ne){return new n.$CL(ne.valueBytes.buffer,ne.mime)}Le.to=Se})(wt||(e.NotebookCellOutputItem=wt={}));var Et;(function(Le){function Fe(ne){return{outputId:ne.id,items:ne.items.map(wt.from),metadata:ne.metadata}}Le.from=Fe;function Se(ne){const Te=ne.items.map(wt.to);return new n.$DL(Te,ne.outputId,ne.metadata)}Le.to=Se})(Et||(e.NotebookCellOutput=Et={}));var Yt;(function(Le){function Fe(Te){return ne(Te)?{include:Ze.from(Te.include)??void 0,exclude:Ze.from(Te.exclude)??void 0}:Ze.from(Te)??void 0}Le.from=Fe;function Se(Te){return ne(Te)?{include:Ze.to(Te.include),exclude:Ze.to(Te.exclude)}:Ze.to(Te)}Le.to=Se;function ne(Te){const Ke=Te;return Ke?!(0,v.$Gf)(Ke.include)&&!(0,v.$Gf)(Ke.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var Kt;(function(Le){function Fe(Se,ne,Te){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ke,Te),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Le.from=Fe})(Kt||(e.NotebookStatusBarItem=Kt={}));var pt;(function(Le){function Fe(Se,ne,Te){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ne.toInternal(Ke,Te),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Le.from=Fe})(pt||(e.NotebookKernelSourceAction=pt={}));var Ut;(function(Le){function Fe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Le.from=Fe})(Ut||(e.NotebookDocumentContentOptions=Ut={}));var Tt;(function(Le){function Fe(ne){return{uri:ne.uri,provides:ne.provides}}Le.from=Fe;function Se(ne){return new n.$FL(y.URI.revive(ne.uri),ne.provides)}Le.to=Se})(Tt||(e.NotebookRendererScript=Tt={}));var Bt;(function(Le){function Fe(ne){return{message:L.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:i.from(ne.location.range),uri:ne.location.uri}}}Le.from=Fe;function Se(ne){const Te=new n.$LL(typeof ne.message=="string"?ne.message:L.to(ne.message));return Te.actualOutput=ne.actual,Te.expectedOutput=ne.expected,Te.contextValue=ne.contextValue,Te.location=ne.location?q.to(ne.location):void 0,Te}Le.to=Se})(Bt||(e.TestMessage=Bt={}));var Pt;(function(Le){Le.namespace=h.$0I,Le.denamespace=h.$$I})(Pt||(e.TestTag=Pt={}));var At;(function(Le){function Fe(ne){const Te=(0,c.$0L)(ne).controllerId;return{extId:m.$6I.fromExtHostTestItem(ne,Te).toString(),label:ne.label,uri:y.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ke=>Pt.namespace(Te,Ke.id)),range:D.$ps.lift(i.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&L.fromStrict(ne.error)||null}}Le.from=Fe;function Se(ne){return{parent:void 0,error:void 0,id:m.$6I.fromString(ne.extId).localId,label:ne.label,uri:y.URI.revive(ne.uri),tags:(ne.tags||[]).map(Te=>{const{tagId:Ke}=Pt.denamespace(Te);return new n.$ML(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Le.toPlain=Se})(At||(e.TestItem=At={})),function(Le){function Fe(ne){return{id:ne.id}}Le.from=Fe;function Se(ne){return new n.$ML(ne.id)}Le.to=Se}(Pt||(e.TestTag=Pt={}));var Ot;(function(Le){const Fe=(ne,Te)=>{const Ke=[];for(const[Je,nt]of Te)m.$6I.compare(nt.item.extId,Je)===2&&(Te.delete(Je),Ke.push(nt));const xe={...At.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(nt=>nt.type===0).map(Bt.to)})),children:Ke.map(Je=>Fe(Je,Te))};for(const Je of xe.children)Je.parent=xe;return xe};function Se(ne){const Te=[],Ke=new Map;for(const xe of ne.items){Ke.set(xe.item.extId,xe);const Je=m.$6I.root(xe.item.extId);ne.request.targets.some(nt=>nt.controllerId===Je&&nt.testIds.includes(xe.item.extId))&&Te.push(xe)}return{completedAt:ne.completedAt,results:Te.map(xe=>Fe(xe,Ke))}}Le.to=Se})(Ot||(e.TestResults=Ot={}));var Wt;(function(Le){function Fe(Ke){return{covered:Ke.covered,total:Ke.covered}}function Se(Ke){return"line"in Ke?u.from(Ke):i.from(Ke)}function ne(Ke){return"branches"in Ke?{count:Ke.executionCount,location:Se(Ke.location),type:1,branches:Ke.branches.length?Ke.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Se(xe.location)})):void 0}:{type:0,count:Ke.executionCount,location:Se(Ke.location)}}Le.fromDetailed=ne;function Te(Ke){return{uri:Ke.uri,statement:Fe(Ke.statementCoverage),branch:Ke.branchCoverage&&Fe(Ke.branchCoverage),function:Ke.functionCoverage&&Fe(Ke.functionCoverage),details:Ke.detailedCoverage?.map(ne)}}Le.fromFile=Te})(Wt||(e.TestCoverage=Wt={}));var Ht;(function(Le){function Fe(Se){switch(Se){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Le.to=Fe})(Ht||(e.CodeActionTriggerKind=Ht={}));var qt;(function(Le){function Fe(ne){const Te=new n.$SL(Z.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),i.to(ne.range),i.to(ne.selectionRange));return Te._sessionId=ne._sessionId,Te._itemId=ne._itemId,Te}Le.to=Fe;function Se(ne,Te,Ke){if(Te=Te??ne._sessionId,Ke=Ke??ne._itemId,Te===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Ke,kind:Z.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:i.from(ne.range),selectionRange:i.from(ne.selectionRange),tags:ne.tags?.map(oe.from)}}Le.from=Se})(qt||(e.TypeHierarchyItem=qt={}));var ct;(function(Le){function Fe(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Le.from=Fe})(ct||(e.ViewBadge=ct={}));var lt;(function(Le){function Fe(Ke,xe,Je){const nt=xe.fileData;return nt?new n.$4K(new n.$5K(nt.name,y.URI.revive(nt.uri),nt.id,(0,M.$cb)(()=>Je(nt.id)))):Ke===R.$Mr.uriList&&xe.uriListData?new n.$3K(Te(xe.uriListData)):new n.$3K(xe.asString)}Le.to=Fe;async function Se(Ke,xe){const Je=await xe.asString();if(Ke===R.$Mr.uriList)return{asString:Je,fileData:void 0,uriListData:ne(Je)};const nt=xe.asFile();return{asString:Je,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Le.from=Se;function ne(Ke){return d.$Ys.split(Ke).map(xe=>{if(xe.startsWith("#"))return xe;try{return y.URI.parse(xe)}catch{}return xe})}function Te(Ke){return d.$Ys.create(Ke.map(xe=>typeof xe=="string"?xe:y.URI.revive(xe)))}})(lt||(e.DataTransferItem=lt={}));var Jt;(function(Le){function Fe(ne,Te){const Ke=ne.items.map(([xe,Je])=>[xe,lt.to(xe,Je,Te)]);return new n.$6K(Ke)}Le.toDataTransfer=Fe;async function Se(ne){const Te={items:[]},Ke=[];for(const[xe,Je]of ne)Ke.push((async()=>{Te.items.push([xe,await lt.from(xe,Je)])})());return await Promise.all(Ke),Te}Le.from=Se})(Jt||(e.DataTransfer=Jt={}));var It;(function(Le){function Fe(ne){return{message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Le.to=Fe;function Se(ne){return{kind:"reply",message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Le.from=Se})(It||(e.ChatReplyFollowup=It={}));var kt;(function(Le){function Fe(Se){return typeof Se=="string"?{title:Se,message:Se,kind:"reply"}:"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:It.from(Se)}Le.from=Fe})(kt||(e.ChatFollowup=kt={}));var ft;(function(Le){function Fe(ne){const Te=new n.$3L(Dt.to(ne.role),ne.content);return Te.name=ne.name,Te}Le.to=Fe;function Se(ne){return{role:Dt.from(ne.role),content:ne.content,name:ne.name}}Le.from=Se})(ft||(e.ChatMessage=ft={}));var Dt;(function(Le){function Fe(ne){switch(ne){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}Le.to=Fe;function Se(ne){switch(ne){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}Le.from=Se})(Dt||(e.ChatMessageRole=Dt={}));var Ft;(function(Le){function Fe(ne){return{level:yt.to(ne.level),value:ne.value,description:ne.description}}Le.to=Fe;function Se(ne){return{level:yt.from(ne.level),value:ne.value,description:ne.description}}Le.from=Se})(Ft||(e.ChatVariable=Ft={}));var yt;(function(Le){function Fe(ne){switch(ne){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}Le.to=Fe;function Se(ne){switch(ne){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}Le.from=Se})(yt||(e.ChatVariableLevel=yt={}));var Ge;(function(Le){function Fe(Se){switch(Se){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted}}Le.to=Fe})(Ge||(e.InteractiveEditorResponseFeedbackKind=Ge={}));var Nt;(function(Le){function Fe(Se){return"placeholder"in Se&&"resolvedContent"in Se?{placeholder:Se.placeholder}:"responseId"in Se?{requestId:Se.responseId}:"content"in Se?{content:typeof Se.content=="string"?Se.content:L.from(Se.content)}:"documents"in Se?{documents:Se.documents.map(ne=>({uri:ne.uri,version:ne.version,ranges:ne.ranges.map(Te=>i.from(Te))}))}:"reference"in Se?{reference:"uri"in Se.reference?{uri:Se.reference.uri,range:i.from(Se.reference.range)}:Se.reference}:Se}Le.from=Fe})(Nt||(e.ChatResponseProgress=Nt={}));var jt;(function(Le){function Fe(Se,ne,Te){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand}:"uri"in Se?{uri:Se.uri}:ne.toInternal(Se,Te)}Le.from=Fe})(jt||(e.TerminalQuickFix=jt={}))}),define(De[280],Ce([1,0,2,8,7,14,75]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0;class b{constructor(w,R,I,v={timeout:1500,errors:3}){this.c=w,this.d=R,this.f=I,this.g=v,this.a=new A.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(R,I,v)=>{const D={dispose:this.a.push([R,I,w])};return Array.isArray(v)&&v.push(D),D}}async $participateInSave(w,R){const I=C.URI.revive(w);let v=!1;const y=setTimeout(()=>v=!0,this.g.timeout),D=[];try{for(const p of[...this.a]){if(v)break;const l=this.d.getDocument(I),c=await this.h(p,{document:l,reason:M.TextDocumentSaveReason.to(R)});D.push(c)}}finally{clearTimeout(y)}return D}h([w,R,I],v){const y=this.b.get(w);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(I,w,R,v).then(()=>!0,D=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const p=this.b.get(w);this.b.set(w,p?p+1:1),typeof p=="number"&&p>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,R,I,v){const y=[],D=Date.now(),{document:p,reason:l}=v,{version:c}=p,r=Object.freeze({document:p,reason:l,waitUntil(o){if(Object.isFrozen(y))throw(0,F.$7)("waitUntil can not be called async");y.push(Promise.resolve(o))}});try{R.apply(I,[r])}catch(o){return Promise.reject(o)}return Object.freeze(y),new Promise((o,m)=>{const h=setTimeout(()=>m(new Error("timeout")),this.g.timeout);return Promise.all(y).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(h),o(t)}).catch(t=>{clearTimeout(h),m(t)})}).then(o=>{const m={edits:[]};for(const h of o)if(Array.isArray(h)&&h.every(t=>t instanceof d.$jK))for(const{newText:t,newEol:n,range:a}of h)m.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:a&&M.Range.from(a),text:t,eol:n&&M.EndOfLine.from(n)}});if(m.edits.length!==0)return c===p.version?this.f.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.$6bc=b}),define(De[281],Ce([1,0,17,2,14,7,108]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=e.$gdc=void 0;class b{constructor(I,v,y,D){this.start=I,this.deletedCount=v,this.deletedItems=y,this.items=D}asApiEvent(){return{range:new M.$zL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(I,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,v,y){this.notebook=I,this.h=v,this.j=y,this.handle=y.handle,this.uri=F.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(d.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(d.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:d.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return I.g},set mime(D){I.g=D},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(y)}return this.f}setOutputs(I){this.a=I.map(d.NotebookCellOutput.to)}setOutputItems(I,v,y){const D=y.map(d.NotebookCellOutputItem.to),p=this.a.find(l=>l.id===I);if(p&&(v||(p.items.length=0),p.items.push(...D),p.items.length>1&&p.items.every(l=>A.$mI(l.mime)))){const l=new Map,c=[];p.items.forEach(r=>{let o;l.has(r.mime)?o=l.get(r.mime):(o=[],l.set(r.mime,o),c.push(r.mime)),o.push(r.data)}),p.items.length=0,c.forEach(r=>{const o=A.$nI(l.get(r));p.items.push({mime:r,data:o.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(d.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$gdc=E;class w{static{this.a=0}constructor(I,v,y,D,p){this.k=I,this.l=v,this.m=y,this.uri=D,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=p.viewType,this.f=Object.freeze(p.metadata??Object.create(null)),this.r([[0,0,p.cells]],!0,void 0),this.g=p.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,v={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===C.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(y){return y=I.n(y),I.b[y].apiCell},getCells(y){return(y?I.p(y):I.b).map(p=>p.apiCell)},save(){return I.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,v,y){this.g=I.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:y});const D={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},p=[];for(const c of I.rawEvents)c.kind===A.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,D.contentChanges):c.kind===A.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,D.contentChanges):c.kind===A.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),p.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),p.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),p.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===A.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),p.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),p.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const l=new Map;for(let c=0;c<p.length;c++){const r=p[c],o=l.get(r.cell);if(o===void 0){const m=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});l.set(r.cell,m-1)}else D.cellChanges[o]={...D.cellChanges[o],...r}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let v=I.start|0,y=I.end|0;return v<0&&(v=0),y>this.b.length&&(y=this.b.length),I.with({start:v,end:y})}p(I){I=this.o(I);const v=[];for(let y=I.start;y<I.end;y++)v.push(this.b[y]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,v,y){if(this.j)return;const D=[],p=[],l=[];if(I.reverse().forEach(c=>{const o=c[2].map(t=>{const n=new E(this,this.l,t);return v||p.push(E.asModelAddData(this.apiNotebook,t)),n}),m=new b(c[0],c[1],[],o),h=this.b.splice(c[0],c[1],...o);for(const t of h)l.push(t.uri),m.deletedItems.push(t.apiCell);D.push(m)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:l}),y)for(const c of D)y.push(c.asApiEvent())}s(I,v,y,D){const p=this.b.splice(I,v);this.b.splice(y,0,...p);const l=[new b(I,v,p.map(c=>c.apiCell),[]),new b(y,0,[],p)];for(const c of l)D.push(c.asApiEvent())}t(I,v){this.b[I].setOutputs(v)}u(I,v,y,D){this.b[I].setOutputItems(v,y,D)}v(I,v){const y=this.b[I];y.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(y.uri,v)}w(I,v){const y=this.b[I];y.apiCell.mime=v}x(I,v){this.b[I].setMetadata(v)}y(I,v){this.b[I].setInternalMetadata(v)}getCellFromApiCell(I){return this.b.find(v=>v.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(v=>v.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$hdc=w}),define(De[282],Ce([1,0,4,2,14,7]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class A{constructor(E,w,R,I={timeout:1500,errors:3}){this.b=E,this.c=w,this.d=R,this.f=I,this.a=new C.$Od}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(w,R,I)=>{const v=function(D){w.call(R,D)};return v.extension=E,this.a.event(v,void 0,I)}}async $participateInSave(E,w,R){const I=F.URI.revive(E),v=this.c.getNotebookDocument(I);if(!v)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:d.TextDocumentSaveReason.to(w)},R,async(p,l)=>{const c=Date.now(),r=await await Promise.resolve(p);Date.now()-c>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",l.extension.identifier),!R.isCancellationRequested&&r&&(r instanceof M.$mK?y.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",l.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(y.length===0)return!0;const D={edits:[]};for(const p of y){const{edits:l}=d.WorkspaceEdit.from(p);D.edits=D.edits.concat(l)}return this.d.$tryApplyWorkspaceEdit(D)}}e.$Hdc=A}),define(De[144],Ce([1,0,8,14,7]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,E,w,R,I,v){this.id=b,this.f=E,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=R,this.c=v}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(E){this.selections=[E]},get selections(){return b.a},set selections(E){if(!Array.isArray(E)||!E.every(d.$zL.isNotebookRange))throw(0,C.$6)("selections");b.a=E,b.g(E)},get visibleRanges(){return b.b},revealRange(E,w){b.f.$tryRevealRange(b.id,F.NotebookRange.from(E),w??d.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(F.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$idc=M}),define(De[283],Ce([1,0,8,4,13,14]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;let A=class{constructor(E,w){this.c=E,this.d=w,this.a=new F.$Md({onListenerError:C.$1}),this.b=new F.$Md({onListenerError:C.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,w){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,w);const R=this.d.getEditorById(E);w.visibleRanges&&R._acceptVisibleRanges(w.visibleRanges.ranges.map(M.NotebookRange.to)),w.selections&&R._acceptSelections(w.selections.selections.map(M.NotebookRange.to)),w.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),w.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const w in E)this.d.getEditorById(w)._acceptViewColumn(M.ViewColumn.to(E[w]))}};e.$Adc=A,e.$Adc=A=He([Be(0,d.$8i)],A)}),define(De[284],Ce([1,0,14,84,208,21,57,8]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class E{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,y,D){const p=this.b++,{title:l,location:c,cancellable:r}=y,o={label:(0,d.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(p,{location:C.ProgressLocation.from(c),title:l,source:o,cancellable:r},v.isUnderDevelopment?void 0:v.identifier.value).catch(b.$1),this.d(p,D,!!r)}d(v,y,D){let p;D&&(p=new M.$Wd,this.c.set(v,p));const l=r=>{this.a.$progressEnd(r),this.c.delete(r),p?.dispose()};let c;try{c=y(new R(this.a,v),D&&p?p.token:M.CancellationToken.None)}catch(r){throw l(v),r}return c.then(r=>l(v),r=>l(v)),c}$acceptProgressCanceled(v){const y=this.c.get(v);y&&(y.cancel(),this.c.delete(v))}}e.$Ecc=E;function w(I,v){return I.message=v.message,typeof v.increment=="number"&&(typeof I.increment=="number"?I.increment+=v.increment:I.increment=v.increment),I}class R extends F.$1u{constructor(v,y){super(D=>this.throttledReport(D)),this.i=v,this.j=y}throttledReport(v){this.i.$progressReport(this.j,v)}}He([(0,A.$hh)(100,(I,v)=>w(I,v),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[145],Ce([1,0,34,142,67,109,87,14,2]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=e.$oM=e.$nM=void 0;const w=(o,m,h,t)=>{let n=m;return{enumerable:!0,configurable:!1,get(){return n},set(a){if(!h(n,a)){const i=n;n=a,o.listener?.(t(a,i))}}}},R=(o,m)=>o===m,I={range:(o,m)=>o===m?!0:!o||!m?!1:o.isEqual(m),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(o,m)=>!(o.length!==m.length||o.some(h=>!m.find(t=>h.id===t.id)))},v=o=>m=>({op:4,update:o(m)}),y=(o,m)=>({range:(()=>{let h;const t=v(n=>({range:C.$ps.lift(b.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return h},set(n){o.listener?.({op:6}),I.range(h,n)||(h=n,o.listener?.(t(n)))}}})(),label:w(o,m,I.label,v(h=>({label:h}))),description:w(o,void 0,I.description,v(h=>({description:h}))),sortText:w(o,void 0,I.sortText,v(h=>({sortText:h}))),canResolveChildren:w(o,!1,I.canResolveChildren,h=>({op:2,state:h})),busy:w(o,!1,I.busy,v(h=>({busy:h}))),error:w(o,void 0,I.error,v(h=>({error:b.MarkdownString.fromStrict(h)||null}))),tags:w(o,[],I.tags,(h,t)=>({op:1,new:h.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),D=o=>{const m=d.$6I.fromString(o.extId),h=new l(m.controllerId,m.localId,o.label,E.URI.revive(o.uri)||void 0);return h.range=b.Range.to(o.range||void 0),h.description=o.description||void 0,h.sortText=o.sortText||void 0,h.tags=o.tags.map(t=>b.TestTag.to({id:(0,A.$$I)(t).tagId})),h},p=o=>{let m;for(const h of o.tests){const t=D(h.item);(0,F.$0L)(t).parent=m,m=t}return m};e.$nM=p;class l{constructor(m,h,t,n){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const a=(0,F.$9L)(this,m);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof c?void 0:a.parent}},children:{value:(0,M.$8L)(a,F.$0L,l),enumerable:!0,writable:!1},...y(a,t)})}}e.$oM=l;class c extends l{constructor(m,h){super(m,m,h,void 0),this._isRoot=!0}}e.$pM=c;class r extends M.$4L{constructor(m,h,t){super({controllerId:m,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:F.$0L,getChildren:n=>n.children,root:new c(m,h),toITestItem:b.TestItem.from})}}e.$qM=r}),define(De[146],Ce([1,0,58,8,119,14,7]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.$iM=void 0;class b{static{this.c=new d.$gM("TextEditorDecorationType")}constructor(v,y,D){const p=b.c.nextId();v.$registerTextEditorDecorationType(y.identifier,p,M.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:p,dispose(){v.$removeTextEditorDecorationType(p)}})}}e.$iM=b;class E{constructor(v,y){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,y){this.k();let D=null;if(v instanceof A.$dK)D=new A.$eK(v,v);else if(v instanceof A.$eK)D=v;else throw new Error("Unrecognized location");this.l(D,y,!1)}insert(v,y){this.k(),this.l(new A.$eK(v,v),y,!0)}delete(v){this.k();let y=null;if(v instanceof A.$eK)y=v;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(v,y,D){const p=this.c.validateRange(v);this.g.push({range:p,text:y,forceMoveMarkers:D})}setEndOfLine(v){if(this.k(),v!==A.EndOfLine.LF&&v!==A.EndOfLine.CRLF)throw(0,F.$6)("endOfLine");this.h=v}}class w{constructor(v,y,D,p){this.c=v,this.d=y,this._accept(D),this.e=p;const l=this;this.value={get tabSize(){return l.f},set tabSize(c){l.m(c)},get indentSize(){return l.g},set indentSize(c){l.o(c)},get insertSpaces(){return l.h},set insertSpaces(c){l.q(c)},get cursorStyle(){return l.j},set cursorStyle(c){l.s(c)},get lineNumbers(){return l.k},set lineNumbers(c){l.t(c)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const y=Math.floor(v);return y>0?y:null}if(typeof v=="string"){const y=parseInt(v,10);return isNaN(y)?null:y>0?y:null}return null}m(v){const y=this.l(v);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const y=Math.floor(v);return y>0?y:null}if(typeof v=="string"){const y=parseInt(v,10);return isNaN(y)?null:y>0?y:null}return null}o(v){const y=this.n(v);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(v){return v==="auto"?"auto":v==="false"?!1:!!v}q(v){const y=this.p(v);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(v)})))}assign(v){const y={};let D=!1;if(typeof v.tabSize<"u"){const p=this.l(v.tabSize);p==="auto"?(D=!0,y.tabSize=p):typeof p=="number"&&this.f!==p&&(this.f=p,D=!0,y.tabSize=p)}if(typeof v.indentSize<"u"){const p=this.n(v.indentSize);p==="tabSize"?(D=!0,y.indentSize=p):typeof p=="number"&&this.g!==p&&(this.g=p,D=!0,y.indentSize=p)}if(typeof v.insertSpaces<"u"){const p=this.p(v.insertSpaces);p==="auto"?(D=!0,y.insertSpaces=p):this.h!==p&&(this.h=p,D=!0,y.insertSpaces=p)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,D=!0,y.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,D=!0,y.lineNumbers=M.TextEditorLineNumbersStyle.from(v.lineNumbers)),D&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(v,y){y.catch(D=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(D)})}}e.$jM=w;class R{constructor(v,y,D,p,l,c,r,o){this.id=v,this.j=y,this.k=D,this.g=!1,this.h=new Set,this.c=l,this.d=new w(this.j,this.id,c,D),this.e=r,this.f=o;const m=this;this.value=Object.freeze({get document(){return p.value},set document(h){throw new F.$8("document")},get selection(){return m.c&&m.c[0]},set selection(h){if(!(h instanceof A.$fK))throw(0,F.$6)("selection");m.c=[h],m.l()},get selections(){return m.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof A.$fK)))throw(0,F.$6)("selections");m.c=h,m.l()},get visibleRanges(){return m.e},set visibleRanges(h){throw new F.$8("visibleRanges")},get options(){return m.d.value},set options(h){m.g||m.d.assign(h)},get viewColumn(){return m.f},set viewColumn(h){throw new F.$8("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new E(p.value,t);return h(n),m.m(n)},insertSnippet(h,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=m.c.map(i=>M.Range.from(i));else if(t instanceof A.$dK){const{lineNumber:i,column:s}=M.Position.from(t);a=[{startLineNumber:i,startColumn:s,endLineNumber:i,endColumn:s}]}else if(t instanceof A.$eK)a=[M.Range.from(t)];else{a=[];for(const i of t)if(i instanceof A.$eK)a.push(M.Range.from(i));else{const{lineNumber:s,column:u}=M.Position.from(i);a.push({startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u})}}return y.$tryInsertSnippet(v,p.value.version,h.value,a,n)},setDecorations(h,t){const n=t.length===0;n&&!m.h.has(h.key)||(n?m.h.delete(h.key):m.h.add(h.key),m.n(()=>{if(M.$$L(t))return y.$trySetDecorations(v,h.key,M.$_L(t));{const a=new Array(4*t.length);for(let i=0,s=t.length;i<s;i++){const u=t[i];a[4*i]=u.start.line+1,a[4*i+1]=u.start.character+1,a[4*i+2]=u.end.line+1,a[4*i+3]=u.end.character+1}return y.$trySetDecorationsFast(v,h.key,a)}}))},revealRange(h,t){m.n(()=>y.$tryRevealRange(v,M.Range.from(h),t||A.TextEditorRevealType.Default))},show(h){y.$tryShowEditor(v,M.ViewColumn.from(h))},hide(){y.$tryHideEditor(v)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,C.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,C.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,C.ok)(!this.g),this.f=v}_acceptSelections(v){(0,C.ok)(!this.g),this.c=v}async l(){const v=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const y=v.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const D=y.edits.map(l=>l.range);D.sort((l,c)=>l.end.line===c.end.line?l.end.character===c.end.character?l.start.line===c.start.line?l.start.character-c.start.character:l.start.line-c.start.line:l.end.character-c.end.character:l.end.line-c.end.line);for(let l=0,c=D.length-1;l<c;l++){const r=D[l].end;if(D[l+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=y.edits.map(l=>({range:M.Range.from(l.range),text:l.text,forceMoveMarkers:l.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,p,{setEndOfLine:typeof y.setEndOfLine=="number"?M.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$kM=R}),define(De[147],Ce([1,0,5,131]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xJ=void 0,e.$xJ=(0,C.$Oh)(F.$Uh)}),define(De[148],Ce([1,0,25,4,16,3]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d4b=e.$c4b=e.$b4b=e.$a4b=e.$_3b=e.$$3b=void 0;class A{constructor(c,r){this.versionId=c,this.removedDueToLooping=r}}e.$$3b=A;class b{static isHostExtension(c,r,o){if(r.getExtensionDescription(c))return!1;const m=o.getExtensionDescription(c);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(c,r){this.j=c,this.c=new F.$Md,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(D),this.f=new C.$5l,this.g=[],this.h=new Map;for(const c of this.e){if(this.f.has(c.identifier)){console.error("Extension `"+c.identifier.value+"` is already registered");continue}this.f.set(c.identifier,c),this.g.push(c);const r=this.j.readActivationEvents(c);if(Array.isArray(r))for(let o of r)o==="onUri"&&(o=`onUri:${C.$3l.toKey(c.identifier)}`),this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(c)}}set(c){return this.e=c,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(c,r){this.e=p(this.e,r),this.e=this.e.concat(c);const o=b.l(this.e);return this.e=p(this.e,o.map(m=>m.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,o)}static l(c){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,a){this.addNode(n),this.addNode(a),this.c.has(n)?this.c.get(n).push(a):this.c.set(n,[a])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,a){const i=r.getArcs(n);for(let s=0;s<i.length;s++)if(!a.has(i[s]))return!1;return!0}getNodes(){return this.e}},o=new C.$5l;for(const n of c)if(o.set(n.identifier,n),n.extensionDependencies)for(const a of n.extensionDependencies)r.addArc(C.$3l.toKey(n.identifier),C.$3l.toKey(a));const m=new Set;r.getNodes().filter(n=>r.getArcs(n).length===0).forEach(n=>m.add(n));const h=r.getNodes().filter(n=>!m.has(n));let t;do{t=!1;for(let n=0;n<h.length;n++){const a=h[n];r.hasOnlyGoodArcs(a,m)&&(h.splice(n,1),n--,m.add(a),t=!0)}}while(t);return h.map(n=>o.get(n))}containsActivationEvent(c){return this.h.has(c)}containsExtension(c){return this.f.has(c)}getExtensionDescriptionsForActivationEvent(c){const r=this.h.get(c);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(c){const r=this.f.get(c);return r||void 0}getExtensionDescriptionByUUID(c){for(const r of this.g)if(r.uuid===c)return r}getExtensionDescriptionByIdOrUUID(c,r){return this.getExtensionDescription(c)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$_3b=b;class E{constructor(c,r){this.versionId=c,this.extensions=r}}e.$a4b=E,e.$b4b={readActivationEvents:l=>l.activationEvents};class w{constructor(c){this.d=new v,this.c=new b(c,[])}async acquireLock(c){const r=await this.d.acquire(c);return new R(this,r)}deltaExtensions(c,r,o){if(!c.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,o)}containsActivationEvent(c){return this.c.containsActivationEvent(c)}containsExtension(c){return this.c.containsExtension(c)}getExtensionDescriptionsForActivationEvent(c){return this.c.getExtensionDescriptionsForActivationEvent(c)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(c){return this.c.getExtensionDescription(c)}getExtensionDescriptionByUUID(c){return this.c.getExtensionDescriptionByUUID(c)}getExtensionDescriptionByIdOrUUID(c,r){return this.c.getExtensionDescriptionByIdOrUUID(c,r)}}e.$c4b=w;class R extends M.$Rc{constructor(c,r){super(),this.f=c,this.c=!1,this.B(r)}isAcquiredFor(c){return!this.c&&this.f===c}}e.$d4b=R;class I{constructor(c){this.name=c,this.promise=new Promise((r,o)=>{this.c=r})}resolve(c){this.c(c)}}class v{constructor(){this.c=[],this.d=!1}async acquire(c){const r=new I(c);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const c=this.c.shift();this.d=!0;let r=!0;const o=setTimeout(()=>{r&&console.warn(`The customer named ${c.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{r&&(clearTimeout(o),r=!1,this.d=!1,this.e())};c.resolve((0,M.$Pc)(m))}}var y;(function(l){l[l.Builtin=0]="Builtin",l[l.User=1]="User",l[l.Dev=2]="Dev"})(y||(y={}));function D(l,c){const r=l.isBuiltin?0:l.isUnderDevelopment?2:1,o=c.isBuiltin?0:c.isUnderDevelopment?2:1;if(r!==o)return r-o;const m=d.$fc.basename(l.extensionLocation.path),h=d.$fc.basename(c.extensionLocation.path);return m<h?-1:m>h?1:0}function p(l,c){const r=new C.$4l(c);return l.filter(o=>!r.has(o.identifier))}}),define(De[285],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.ExtHostConnectionType=void 0;var C;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[F.ENV_KEY]=this.pipeName}}e.$um=F;class d{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[d.ENV_KEY]="1"}}e.$vm=d;class M{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[M.ENV_KEY]="1"}}e.$wm=M;function A(R){delete R[F.ENV_KEY],delete R[d.ENV_KEY],delete R[M.ENV_KEY]}function b(R,I){A(I),R.serialize(I)}e.$xm=b;function E(R){if(R[F.ENV_KEY])return w(R,new F(R[F.ENV_KEY]));if(R[d.ENV_KEY])return w(R,new d);if(R[M.ENV_KEY])return w(R,new M);throw new Error("No connection information defined in environment!")}e.$ym=E;function w(R,I){return A(R),I}}),define(De[111],Ce([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$_l=e.$$l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(F||(e.UIKind=F={}));var d;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(d||(e.ExtensionHostExitCode=d={}));var M;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function A(w){const R=C.$ae.alloc(1);switch(w){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$$l=A;function b(w,R){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$_l=b;var E;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(De[88],Ce([1,0,5,4,13,27,111,65,85,24,2,3,210]),function($e,e,C,F,d,M,A,b,E,w,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=e.$sM=void 0;let y=class extends I.$Rc{constructor(c,r){super(),this.s=c,this.t=r,this.a=this.B(new F.$Md),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$Md),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:E.$lo,name:(0,v.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(r.onDidChangeLogLevel(o=>{(0,d.$0i)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===d.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(c,r,o){const m=this.getTelemetryDetails(),h=new D(r,o,c,this.n,this.j,this.getBuiltInCommonProperties(c),{isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}),t=this.r.get(c.identifier.value)??[];return this.r.set(c.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(c,r,o){this.f=c,this.g=r,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(c){const r=Object.create(null);switch(r["common.extname"]=`${c.publisher}.${c.name}`,r["common.extversion"]=c.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=p(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:r["common.uikind"]="web";break;case A.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,b.$Tk)((0,E.$so)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const r=this.getTelemetryDetails();this.r.forEach((o,m)=>{const h=o.filter(t=>!t.isDisposed);h.length===0?this.r.delete(m):this.r.set(m,h)}),this.r.forEach(o=>{for(const m of o)m.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(c,r){const m=this.r.get(c.value)?.filter(t=>!t.isDisposed);if(!m)return this.r.delete(c.value),!1;let h=!1;for(const t of m)t.ignoreUnhandledExtHostErrors||(t.logError(r),h=!0);return h}};e.$sM=y,e.$sM=y=He([Be(0,M.$rM),Be(1,d.$9i)],y);class D{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,r,o,m,h,t,n){this.g=o,this.h=m,this.i=h,this.j=t,this.a=new F.$Md,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(c,r){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let r="properties"in c?c.properties??{}:c;return r=(0,E.$vo)(r,[]),this.c&&(r=(0,w.$6m)(r,this.c)),this.b||(r=(0,w.$6m)(r,this.j)),"properties"in c?c.properties=r:c=r,c}k(c,r){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(c,r),this.h.trace(c,r))}logUsage(c,r){this.d.isUsageEnabled&&this.k(c,r)}logError(c,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof c=="string")this.k(c,r);else{const o={name:c.name,message:c.message,stack:c.stack,cause:c.cause},m=(0,E.$vo)(o,[]),h=new Error(m.message,{cause:m.cause});h.stack=m.stack,h.name=m.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(h,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const c=this,r={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$tM=D;function p(l){const c=Date.now()-new Date(l).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$uM=p,e.$vM=(0,C.$Nh)("IExtHostTelemetry")}),define(De[26],Ce([1,0,4,2,252,137,25,5]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fF=e.$eF=e.$dF=e.ActivationKind=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.ExtensionHostStartup=e.$0E=e.$9E=e.$8E=e.$7E=void 0,e.$7E=Object.freeze({identifier:new A.$3l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$8E="extensions.webWorker",e.$9E=(0,b.$Nh)("extensionService");class E{constructor(h){this.dependency=h}}e.$0E=E;var w;(function(m){m[m.EagerAutoStart=1]="EagerAutoStart",m[m.EagerManualStart=2]="EagerManualStart",m[m.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,n){this.c=h,this.d=t.slice(0),this.e=n.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$RE.createActivationEventsMap(this.d)}}set(h,t,n){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const a=[],i=[],s=[],u=[],S=I(this.d),k=I(t),$=(N,L)=>N.extensionLocation.toString()===L.extensionLocation.toString()||N.isBuiltin===L.isBuiltin||N.isUserBuiltin===L.isUserBuiltin||N.isUnderDevelopment===L.isUnderDevelopment;for(const N of this.d){const L=k.get(N.identifier);if(!L){a.push(N.identifier),S.delete(N.identifier);continue}if(!$(N,L)){a.push(N.identifier),S.delete(N.identifier);continue}}for(const N of t){const L=S.get(N.identifier);if(!L){i.push(N);continue}if(!$(L,N)){a.push(L.identifier),S.delete(L.identifier);continue}}const f=new A.$4l(this.e),g=new A.$4l(n);for(const N of this.e)g.has(N)||s.push(N);for(const N of n)f.has(N)||u.push(N);const P=M.$RE.createActivationEventsMap(i),O={versionId:h,toRemove:a,toAdd:i,addActivationEvents:P,myToRemove:s,myToAdd:u};return this.delta(O),O}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:n,myToRemove:a,myToAdd:i}=h,s=new A.$4l(t),u=new A.$4l(a);for(let S=0;S<this.d.length;S++)s.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)u.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of n)this.d.push(S);for(const S of i)this.e.push(S);return h}containsExtension(h){for(const t of this.e)if(A.$3l.equals(t,h))return!0;return!1}}e.$$E=R;function I(m){const h=new A.$5l;for(const t of m)h.set(t.identifier,t);return h}function v(m,h){return m.enabledApiProposals?m.enabledApiProposals.includes(h):!1}e.$_E=v;function y(m,h){if(!v(m,h))throw new Error(`Extension '${m.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${m.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.$aF=y;class D{constructor(h,t,n,a){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=a}}e.$bF=D;class p{constructor(h,t){this.description=h,this.value=t}}e.$cF=p;var l;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(l||(e.ActivationKind=l={}));function c(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,d.$Bo)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation,targetPlatform:m.targetPlatform,validations:[],isValid:!0}}e.$dF=c;function r(m,h){return{identifier:new A.$3l((0,d.$zo)(m.manifest.publisher,m.manifest.name)),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!!h,extensionLocation:m.location,...m.manifest,uuid:m.identifier.uuid,targetPlatform:m.targetPlatform}}e.$eF=r;class o{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$fF=o}),define(De[286],Ce([1,0,8,148,25,26,13,9]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=e.$$bc=e.$0bc=e.$9bc=e.$8bc=e.$7bc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(c,r,o,m){this.startup=c,this.codeLoadingTime=r,this.activateCallTime=o,this.activateResolvedTime=m}}e.$7bc=E;class w{constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,r){return c===-1||r===-1?-1:r-c}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$8bc=w;class R{constructor(c,r,o,m,h,t){this.activationFailed=c,this.activationFailedError=r,this.activationTimes=o,this.module=m,this.exports=h,this.subscriptions=t}}e.$9bc=R;class I extends R{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.$0bc=I;class v extends R{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$$bc=v;class y extends R{constructor(c){super(!0,c,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(c,r,o,m){this.g=m,this.a=c,this.b=r,this.c=o,this.d=new d.$5l,this.f=Object.create(null)}dispose(){for(const[c,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const c=[];for(const[r,o]of this.d)c.push(o.wait());await Promise.all(c)}isActivated(c){const r=this.d.get(c);return!!(r&&r.value)}getActivatedExtension(c){const r=this.d.get(c);if(!r||!r.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return r.value}async activateByEvent(c,r){if(this.f[c])return;const o=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(o.map(m=>({id:m.identifier,reason:{startup:r,extensionId:m.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,r){const o=this.a.getExtensionDescription(c);if(!o)throw new Error(`Extension '${c}' is not known`);return this.h([{id:o.identifier,reason:r}])}async h(c){const r=c.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(r.map(o=>o.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const r=this.a.getExtensionDescription(c.id);if(!r){const h=new Error(`Cannot activate unknown extension '${c.id.value}'`),t=this.k(c,null,[],new y(h));return this.c.onExtensionActivationError(c.id,h,new M.$0E(c.id.value)),t}const o=[],m=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const h of m){if(this.m(h))continue;const t=this.d.get(h);if(t){o.push(t);continue}if(this.l(h)){o.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:c.reason}));continue}const n=this.a.getExtensionDescription(h);if(n){if(!n.main&&!n.browser)continue;o.push(this.j({id:n.identifier,reason:c.reason}));continue}const a=r.displayName||r.identifier.value,i=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${h}'`),s=this.k(c,r.displayName,[],new y(i));return this.c.onExtensionActivationError(r.identifier,i,new M.$0E(h)),s}return this.k(c,r.displayName,o,null)}k(c,r,o,m){const h=new p(c.id,r,c.reason,o,m,this.c,this.g);return this.d.set(c.id,h),h}l(c){return F.$_3b.isHostExtension(c,this.a,this.b)}m(c){const r=this.b.getExtensionDescription(c);return r?!r.main&&!r.browser:!1}};e.$_bc=D,e.$_bc=D=He([Be(3,A.$8i)],D);let p=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,r,o,m,h,t,n){this.c=c,this.d=r,this.f=o,this.g=m,this.h=h,this.j=t,this.k=n,this.a=new b.$Rg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const r=this.g[c];if(r.value&&!r.value.activationFailed){this.g.splice(c,1),c--;continue}if(r.value&&r.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);o.detail=r.value.activationFailedError,this.h=new y(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const r=new Error;if(c&&c.name&&(r.name=c.name),c&&c.message?r.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(r.stack=c.stack),this.h=new y(r),this.b&&C.$3(c))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};p=He([Be(6,A.$8i)],p)}),define(De[287],Ce([1,0,212,23,2,4,3,269,9,7,18,19,14,79,21,173,26]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;function c(m,h){if((0,R.$xf)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let t;return Array.isArray(m.highlights)&&(t=m.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),t=t.length?t:void 0),{label:m.label,highlights:t}}}class r extends A.$Rc{constructor(h,t,n){super(),this.f=h,this.g=t,this.h=n,this.a=new Map,this.b=new p.$G7;function a(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:i=>a(i)?this.r(i):Array.isArray(i)&&i.length>0?i.map(s=>a(s)?this.r(s):s):i})}registerTreeDataProvider(h,t,n){const a=this.createTreeView(h,{treeDataProvider:t},n);return{dispose:()=>a.dispose()}}createTreeView(h,t,n){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],i=t.dragAndDropController?.dragMimeTypes??[],s=!!t.dragAndDropController?.handleDrag,u=!!t.dragAndDropController?.handleDrop,S=this.m(h,t,n),k={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:i,hasHandleDrag:s,hasHandleDrop:u,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(h,k),f={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,l.$aF)(n,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,l.$aF)(n,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(g){(0,y.$3j)(g)&&(0,l.$aF)(n,"treeViewMarkdownMessage"),S.message=g},get title(){return S.title},set title(g){S.title=g},get description(){return S.description},set description(g){S.description=g},get badge(){return S.badge},set badge(g){g!==void 0&&w.ViewBadge.isViewBadge(g)?S.badge={value:Math.floor(Math.abs(g.value)),tooltip:g.tooltip}:g===void 0&&(S.badge=void 0)},reveal:(g,P)=>S.reveal(g,P),dispose:async()=>{await $,this.a.delete(h),S.dispose()}};return this.B(f),f}$getChildren(h,t){const n=this.a.get(h);return n?n.getChildren(t):Promise.reject(new b.$mE(h))}async $handleDrop(h,t,n,a,i,s,u,S){const k=this.a.get(h);if(!k)return Promise.reject(new b.$mE(h));const $=v.DataTransfer.toDataTransfer(n,async f=>(await this.f.$resolveDropFileData(h,t,f)).buffer);return u===h&&S&&await this.j($,k,S,i,s),k.onDrop($,a,i)}async j(h,t,n,a,i){const s=this.b.removeDragOperationTransfer(i);if(s)(await s)?.forEach((u,S)=>{u&&h.set(S,u)});else if(i&&t.handleDrag){const u=t.handleDrag(n,h,a);this.b.addDragOperationTransfer(i,u),await u}return h}async $handleDrag(h,t,n,a){const i=this.a.get(h);if(!i)return Promise.reject(new b.$mE(h));const s=await this.j(new w.$6K,i,t,a,n);if(!(!s||a.isCancellationRequested))return v.DataTransfer.from(s)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new b.$mE(h);return t.hasResolve}$resolve(h,t,n){const a=this.a.get(h);if(!a)throw new b.$mE(h);return a.resolveTreeItem(t,n)}$setExpanded(h,t,n){const a=this.a.get(h);if(!a)throw new b.$mE(h);a.setExpanded(t,n)}$setSelectionAndFocus(h,t,n){const a=this.a.get(h);if(!a)throw new b.$mE(h);a.setSelectionAndFocus(t,n)}$setVisible(h,t){const n=this.a.get(h);if(!n){if(!t)return;throw new b.$mE(h)}n.setVisible(t)}$changeCheckboxState(h,t){const n=this.a.get(h);if(!n)throw new b.$mE(h);n.setCheckboxState(t)}m(h,t,n){const a=this.B(new o(h,t,this.f,this.g.converter,this.h,n));return this.a.set(h,a),a}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$Lcc=r;class o extends A.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,R.$Gf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,n,a,i,s){if(super(),this.I=h,this.J=n,this.L=a,this.M=i,this.N=s,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Md),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Md),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Md),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Md),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Md),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Md),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Md),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new D.$Wd,s.contributes&&s.contributes.views)for(const $ in s.contributes.views)for(const f of s.contributes.views[$])f.id===h&&(this.P=f.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let u,S;const k=M.Event.debounce(this.F.event,($,f)=>($||($={message:!1,elements:[]}),f.element!==!1&&(u||(u=new Promise(g=>S=g),this.G=this.G.then(()=>u)),Array.isArray(f.element)?$.elements.push(...f.element):$.elements.push(f.element)),f.message&&($.message=!0),$),200,!0);this.B(k(({message:$,elements:f})=>{f.length&&(this.H=this.H.then(()=>{const g=S;return u=null,this.$(f).then(()=>g())})),$&&this.J.$setMessage(this.I,v.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let n=this.X(h);return n||(n=await this.Y(t)),n?n.map(a=>a.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const n=(0,R.$Gf)(t.select)?!0:t.select,a=(0,R.$Gf)(t.focus)?!1:t.focus,i=(0,R.$Gf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(s=>this.W(h,s[s.length-1]).then(u=>this.J.$reveal(this.I,{item:u.item,parentChain:s.map(S=>S.item)},{select:n,focus:a,expand:i})),s=>this.M.error(s)):this.J.$reveal(this.I,void 0,{select:n,focus:a,expand:i})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=v.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const n=this.getExtensionElement(h);n&&(t?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(h,t){const n=!(0,I.$tb)(this.s,h);this.s=h;const a=this.t!==t;this.t=t,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async n=>{const a=this.getExtensionElement(n.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:n.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);t.forEach(n=>{n.treeItem.checkboxState=n.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(n=>[n.extensionItem,n.newState])})}async handleDrag(h,t,n){const a=[];for(const i of h){const s=this.getExtensionElement(i);s&&a.push(s)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,n),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,n){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,E.$Lg)(()=>this.g?.handleDrop?this.g.handleDrop(a,h,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const n=this.j.get(h);if(n){const a=this.m.get(n);if(a){const i=await this.f.resolveTreeItem(a.extensionItem,n,t)??a.extensionItem;return this.hb(i),a.item.tooltip=this.eb(i.tooltip),a.item.command=this.fb(a.disposableStore,i.command),a.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(n=>this.W(t,n[n.length-1]).then(a=>(n.push(a),n))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,E.$Lg)(()=>this.f.getParent(h))}W(h,t){const n=this.m.get(h);return n?Promise.resolve(n):(0,E.$Lg)(()=>this.f.getTreeItem(h)).then(a=>this.kb(h,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const i=this.getExtensionElement(a);if(i){const s=this.m.get(i);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const n=this.getExtensionElement(h);t=n?this.m.get(n):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new D.$Wd(this.Z.token);try{const n=h?this.m.get(h):void 0,a=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const i=await Promise.all((0,I.$Gb)(a||[]).map(async s=>{const u=await this.f.getTreeItem(s);return u&&!t.token.isCancellationRequested?this.db(s,u,n):null}));return t.token.isCancellationRequested?void 0:(0,I.$Gb)(i)}finally{t.dispose()}}$(h){if(h.some(n=>!n))return this.Z.dispose(!0),this.Z=new D.$Wd,this.tb(),this.J.$refresh(this.I);{const n=this.ab(h);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(h){const t=new Set,n=h.map(i=>this.m.get(i));for(const i of n)if(i&&!t.has(i.item.handle)){let s=i;for(;s&&s.parent&&n.findIndex(u=>s&&s.parent&&u&&u.item.handle===s.parent.item.handle)===-1;){const u=this.j.get(s.parent.item.handle);s=u?this.m.get(u):void 0}s&&!s.parent&&t.add(i.item.handle)}const a=[];return t.forEach(i=>{const s=this.j.get(i);if(s){const u=this.m.get(s);u&&(!u.parent||!t.has(u.parent.item.handle))&&a.push(i)}}),a}bb(h){const t={};return Promise.all(h.map(n=>this.cb(n).then(a=>{a&&(t[n]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const n=this.m.get(t);if(n)return this.rb(t),(0,E.$Lg)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const i=this.ib(t,a,n.parent);return this.pb(t,i,n,n.parent),n.dispose(),i}return null})}return Promise.resolve(null)}db(h,t,n){const a=this.ib(h,t,n);if(t.id&&this.j.has(a.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(h,a),this.qb(a,n),a}eb(h){return w.$CK.isMarkdownString(h)?v.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,n,a;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,n=h.checkboxState.tooltip,a=h.checkboxState.accessibilityInformation),{isChecked:t===w.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:a}}hb(h){if(!w.$1K.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,n){this.hb(t);const a=this.B(new A.$Qc),i=this.kb(h,t,n),s=this.lb(t);return{item:{handle:i,parentHandle:n?n.item.handle:void 0,label:c(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:s,iconDark:this.mb(t)||s,themeIcon:this.jb(t),collapsibleState:(0,R.$Gf)(t.collapsibleState)?w.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:n,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(h){return h.iconPath instanceof w.$9K?h.iconPath:void 0}kb(h,{id:t,label:n,resourceUri:a},i,s){if(t)return`${o.b}/${t}`;const u=c(n,this.N),S=i?i.item.handle:o.a;let k=u?u.label:a?(0,F.$rg)(a):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const $=this.m.has(h)?this.m.get(h).item.handle:void 0,f=this.X(i)||[];let g,P=0;do{if(g=`${S}/${P}:${k}`,s||!this.j.has(g)||$===g)break;P++}while(P<=f.length);return g}lb(h){if(h.iconPath&&!(h.iconPath instanceof w.$9K))return typeof h.iconPath=="string"||d.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof w.$9K)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return d.URI.isUri(h)?h:d.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,n,a){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(h,t);const i=this.X(a)||[],s=i.filter(u=>u.item.handle===n.item.handle)[0];s&&i.splice(i.indexOf(s),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const n of t.children){const a=this.j.get(n.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const n of t.children){const a=this.j.get(n.item.handle);a&&this.sb(a)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(De[288],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[289],Ce([1,0,224,8,38,132,105,42,25,288,135,137]),function($e,e,C,F,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=void 0;const v=b.$cn.as(A.$dn.JSONContribution);class y{constructor(h,t,n){this.a=h,this.b=t,this.c=n}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(d.default.Error,h)}warn(h){this.d(d.default.Warning,h)}info(h){this.d(d.default.Info,h)}}e.$1E=y;class D{static a(h){const t=new E.$4l;for(let n=0,a=h.length;n<a;n++)t.add(h[n].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new D(t,[]);if(!t||!t.length)return new D([],h);const n=this.a(h),a=this.a(t),i=t.filter(u=>!n.has(u.description.identifier)),s=h.filter(u=>!a.has(u.description.identifier));return new D(i,s)}constructor(h,t){this.added=h,this.removed=t}}e.$2E=D;class p{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=D.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,F.$Z)(h)}}}e.$3E=p;const l={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.$4E={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$2l},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"*",description:C.localize(42,null),body:"*"}]}},badges:{type:"array",description:C.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(44,null)},href:{type:"string",description:C.localize(45,null)},description:{type:"string",description:C.localize(46,null)}}}},markdown:{type:"string",description:C.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Tn}},extensionPack:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Tn}},extensionKind:{description:C.localize(51,null),type:"array",items:l,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(52,null)},{body:["workspace"],description:C.localize(53,null)},{body:["ui","workspace"],description:C.localize(54,null)},{body:["workspace","ui"],description:C.localize(55,null)},{body:[],description:C.localize(56,null)}]},capabilities:{description:C.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(60,null),C.localize(61,null),C.localize(62,null)]},description:{type:"string",markdownDescription:C.localize(63,null)}}},untrustedWorkspaces:{description:C.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(66,null),C.localize(67,null),C.localize(68,null)]},restrictedConfigurations:{description:C.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(70,null)}}}}},sponsor:{description:C.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(73,null),type:"string"},"vscode:uninstall":{description:C.localize(74,null),type:"string"}}},icon:{type:"string",description:C.localize(75,null)},l10n:{type:"string",description:C.localize(76,null)},pricing:{type:"string",markdownDescription:C.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new p(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&I.$RE.register(h.extensionPoint,h.activationEventsGenerator),e.$4E.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,v.registerSchema(c,e.$4E),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$5E=r;const o={ExtensionsRegistry:"ExtensionsRegistry"};b.$cn.add(o.ExtensionsRegistry,new r),e.$6E=b.$cn.as(o.ExtensionsRegistry),v.registerSchema(c,e.$4E),v.registerSchema(R.$oj,{properties:{extensionEnabledApiProposals:{description:C.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(De[290],Ce([1,0,221,18,24,289,41,4]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var w;(function(v){function y(D,p,l){if(!D)return;const c=F.$xf(D.type)?D.type:void 0;if(!c||c.length===0){l.error(C.localize(3,null));return}const r=[];if(Array.isArray(D.required))for(const o of D.required)F.$xf(o)&&r.push(o);return{extensionId:p.value,taskType:c,required:r,properties:D.properties?d.$3m(D.properties):{},when:D.when?A.$Li.deserialize(D.when):void 0}}v.from=y})(w||(w={}));const R=M.$6E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,y)=>{for(const D of v)D.type&&y.push(`onTaskType:${D.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:E}});class I{constructor(){this.d=new b.$Md,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,D)=>{R.setHandler((p,l)=>{this.c=void 0;try{for(const c of l.removed){const r=c.value;for(const o of r)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const c of l.added){const r=c.value;for(const o of r){const m=w.from(o,c.description.identifier,c.collector);m&&(this.a[m.taskType]=m)}}(l.removed.length>0||l.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const D of this.all()){const p={type:"object",additionalProperties:!1};D.required.length>0&&(p.required=D.required.slice(0)),D.properties!==void 0?p.properties=d.$3m(D.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[D.taskType]},y.push(p)}this.c={oneOf:y}}return this.c}}e.$NF=new I}),define(De[291],Ce([1,0,222,18,23,24,41,290]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$XF=e.JsonSchemaVersion=e.ExecutionEngine=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$RF=e.ShellQuoting=e.$QF=e.$PF=e.$OF=void 0,e.$OF="settings",e.$PF=new A.$5i("taskRunning",!1,C.localize(0,null)),e.$QF={value:C.localize(1,null),original:"Tasks"};var E;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$RF="$customized",function(z){function T(K){if(!K)return z.Strong;switch(K.toLowerCase()){case"escape":return z.Escape;case"strong":return z.Strong;case"weak":return z.Weak;default:return z.Strong}}z.from=T}(E||(e.ShellQuoting=E={}));var w;(function(z){z.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var R;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(R||(e.RevealKind=R={})),function(z){function T(K){switch(K.toLowerCase()){case"always":return z.Always;case"silent":return z.Silent;case"never":return z.Never;default:return z.Always}}z.fromString=T}(R||(e.RevealKind=R={}));var I;(function(z){z[z.Never=1]="Never",z[z.OnProblem=2]="OnProblem",z[z.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(z){function T(K){switch(K.toLowerCase()){case"always":return z.Always;case"never":return z.Never;case"onproblem":return z.OnProblem;default:return z.OnProblem}}z.fromString=T}(I||(e.RevealProblemKind=I={}));var v;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(v||(e.PanelKind=v={})),function(z){function T(K){switch(K.toLowerCase()){case"shared":return z.Shared;case"dedicated":return z.Dedicated;case"new":return z.New;default:return z.Shared}}z.fromString=T}(v||(e.PanelKind=v={}));var y;(function(z){z.defaults={echo:!0,reveal:R.Always,revealProblems:I.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var D;(function(z){z[z.Shell=1]="Shell",z[z.Process=2]="Process",z[z.CustomExecution=3]="CustomExecution"})(D||(e.RuntimeType=D={})),function(z){function T(V){switch(V.toLowerCase()){case"shell":return z.Shell;case"process":return z.Process;case"customExecution":return z.CustomExecution;default:return z.Process}}z.fromString=T;function K(V){switch(V){case z.Shell:return"shell";case z.Process:return"process";case z.CustomExecution:return"customExecution";default:return"process"}}z.toString=K}(D||(e.RuntimeType=D={}));var p;(function(z){function T(K){return F.$xf(K)?K:K.value}z.value=T})(p||(e.CommandString=p={}));var l;(function(z){z.Clean={_id:"clean",isDefault:!1},z.Build={_id:"build",isDefault:!1},z.Rebuild={_id:"rebuild",isDefault:!1},z.Test={_id:"test",isDefault:!1};function T(V){return V===z.Clean._id||V===z.Build._id||V===z.Rebuild._id||V===z.Test._id}z.is=T;function K(V){if(V!==void 0)return F.$xf(V)?T(V)?{_id:V,isDefault:!1}:void 0:V}z.from=K})(l||(e.TaskGroup=l={}));var c;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var r;(function(z){z.Workspace="workspace",z.Extension="extension",z.InMemory="inMemory",z.WorkspaceFile="workspaceFile",z.User="user";function T(K){switch(K){case z.User:return 2;case z.WorkspaceFile:return 5;default:return 6}}z.toConfigurationTarget=T})(r||(e.TaskSourceKind=r={}));var o;(function(z){z.parallel="parallel",z.sequence="sequence"})(o||(e.DependsOrder=o={}));var m;(function(z){z[z.default=1]="default",z[z.folderOpen=2]="folderOpen"})(m||(e.RunOnOptions=m={}));var h;(function(z){z.defaults={reevaluateOnRerun:!0,runOn:m.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(T,K,V,fe,X,Q){this._label="",this._id=T,K&&(this._label=K),V&&(this.type=V),this.runOptions=fe,this.configurationProperties=X,this._source=Q}getDefinition(T){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,K=!1){if(T===void 0)return!1;if(F.$xf(T))return T===this._label||T===this.configurationProperties.identifier||K&&T===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$SF=t;class n extends t{constructor(T,K,V,fe,X,Q,Z,oe){super(T,V,void 0,Z,oe,K),this.command={},this._source=K,this.hasDefinedMatchers=Q,X&&(this.command=X)}clone(){return new n(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case D.Shell:K="shell";break;case D.Process:K="process";break;case D.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(T){return T instanceof n}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$OF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const T=this.d();if(!T)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const V={type:e.$RF,folder:T,id:K};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.$rg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new n(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$TF=n;class a extends t{constructor(T,K,V,fe,X,Q,Z){super(T,V,fe,Q,Z,K),this._source=K,this.configures=X}static is(T){return T instanceof a}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.$rg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$OF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const T=this.d();if(!T)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const V={type:e.$RF,folder:T,id:K};return JSON.stringify(V)}}e.$UF=a;class i extends t{constructor(T,K,V,fe,X,Q,Z,oe,x){super(T,V,fe,oe,x,K),this.defines=X,this.hasDefinedMatchers=Z,this.command=Q,this.icon=x.icon,this.hide=x.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof i}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new i(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$VF=i;class s extends t{constructor(T,K,V,fe,X,Q){super(T,V,fe,X,Q,K),this._source=K}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new s(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$WF=s;var u;(function(z){z[z.Process=1]="Process",z[z.Terminal=2]="Terminal"})(u||(e.ExecutionEngine=u={})),function(z){z._default=z.Terminal}(u||(e.ExecutionEngine=u={}));var S;(function(z){z[z.V0_1_0=1]="V0_1_0",z[z.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class k{constructor(T){this.c=new Map;for(let K=0;K<T.length;K++)this.c.set(T[K].uri.toString(),K)}compare(T,K){const V=T.getWorkspaceFolder(),fe=K.getWorkspaceFolder();if(V&&fe){let X=this.c.get(V.uri.toString());X=X===void 0?0:X+1;let Q=this.c.get(fe.uri.toString());return Q=Q===void 0?0:Q+1,X===Q?T._label.localeCompare(K._label):X-Q}else return!V&&fe?-1:V&&!fe?1:0}}e.$XF=k;var $;(function(z){z.DependsOnStarted="dependsOnStarted",z.AcquiredInput="acquiredInput",z.Start="start",z.ProcessStarted="processStarted",z.Active="active",z.Inactive="inactive",z.Changed="changed",z.Terminated="terminated",z.ProcessEnded="processEnded",z.End="end"})($||(e.TaskEventKind=$={}));var f;(function(z){z.SingleRun="singleRun",z.Background="background"})(f||(e.TaskRunType=f={}));var g;(function(z){z[z.System=0]="System",z[z.User=1]="User",z[z.FolderOpen=2]="FolderOpen",z[z.ConfigurationChange=3]="ConfigurationChange",z[z.Reconnect=4]="Reconnect"})(g||(e.TaskRunSource=g={}));var P;(function(z){function T(oe){return{taskId:oe._id,taskName:oe.configurationProperties.name,runType:oe.configurationProperties.isBackground?"background":"singleRun",group:oe.configurationProperties.group,__task:oe}}function K(oe,x,ae){return{...T(oe),kind:"start",terminalId:x,resolvedVariables:ae}}z.start=K;function V(oe,x,ae){return{...T(oe),kind:"processStarted",terminalId:x,processId:ae}}z.processStarted=V;function fe(oe,x,ae){return{...T(oe),kind:"processEnded",terminalId:x,exitCode:ae}}z.processEnded=fe;function X(oe,x,ae){return{...T(oe),kind:"terminated",exitReason:ae,terminalId:x}}z.terminated=X;function Q(oe,x,ae){return{...T(x),kind:oe,terminalId:ae}}z.general=Q;function Z(){return{kind:"changed"}}z.changed=Z})(P||(e.TaskEvent=P={}));var O;(function(z){function T(V){const fe=Object.keys(V).sort();let X="";for(const Q of fe){let Z=V[Q];Z instanceof Object?Z=T(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),X+=Q+","+Z+","}return X}function K(V){const X={_key:T(V),type:V.taskType};return Object.assign(X,V),X}z.create=K})(O||(e.KeyedTaskIdentifier=O={}));var N;(function(z){z.AutoDetect="task.autoDetect",z.SaveBeforeRun="task.saveBeforeRun",z.ShowDecorations="task.showDecorations",z.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",z.SlowProviderWarning="task.slowProviderWarning",z.QuickOpenHistory="task.quickOpen.history",z.QuickOpenDetail="task.quickOpen.detail",z.QuickOpenSkip="task.quickOpen.skip",z.QuickOpenShowAll="task.quickOpen.showAll",z.AllowAutomaticTasks="task.allowAutomaticTasks",z.Reconnection="task.reconnection"})(N||(e.TaskSettingId=N={}));var L;(function(z){z.Tasks="tasks",z.SuppressTaskName="tasks.suppressTaskName",z.Windows="tasks.windows",z.Osx="tasks.osx",z.Linux="tasks.linux",z.ShowOutput="tasks.showOutput",z.IsShellCommand="tasks.isShellCommand",z.ServiceTestSetting="tasks.service.testSetting"})(L||(e.TasksSchemaProperties=L={}));var j;(function(z){function T(K,V){const fe=b.$NF.get(K.type);if(fe===void 0){const oe=M.$3m(K);return delete oe._key,O.create(oe)}const X=Object.create(null);X.type=fe.taskType;const Q=new Set;fe.required.forEach(oe=>Q.add(oe));const Z=fe.properties;for(const oe of Object.keys(Z)){const x=K[oe];if(x!=null)X[oe]=x;else if(Q.has(oe)){const ae=Z[oe];if(ae.default!==void 0)X[oe]=M.$3m(ae.default);else switch(ae.type){case"boolean":X[oe]=!1;break;case"number":case"integer":X[oe]=0;break;case"string":X[oe]="";break;default:V.error(C.localize(2,null,JSON.stringify(K,void 0,0),oe));return}}}return O.create(X)}z.createTaskIdentifier=T})(j||(e.TaskDefinition=j={}))}),define(De[292],Ce([1,0,8]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f4b=e.$e4b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,b)=>{this.b=A,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,C.$Z)(A))}then(A,b){return this.j().then(A,b)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$e4b=F;class d extends F{constructor(){super(),this.h=!0,this.i=new C.$4}}e.$f4b=d}),define(De[68],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=void 0;class C{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++C.count}}e.$iv=C;const F=[];function d(b){const E=new C(b);return F[E.nid]=E,E}e.$jv=d;function M(b){return F[b].sid}e.$kv=M;class A{constructor(E){this.value=E}}e.$lv=A}),define(De[6],Ce([1,0,68]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$aK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$_J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var d;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(d||(e.TabInputKind=d={}));var M;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var A;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var b;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var E;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var w;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var R;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class I{static{this.a=0}static mixin(l){return l._id=I.a++,l}}e.$_J=I;var v;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var y;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var D;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(D||(e.ExtHostTestingResource=D={})),e.$aK={MainThreadAuthentication:(0,C.$jv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$jv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.$jv)("MainThreadChatProvider"),MainThreadChatAgents:(0,C.$jv)("MainThreadChatAgents"),MainThreadChatVariables:(0,C.$jv)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$jv)("MainThreadClipboard"),MainThreadCommands:(0,C.$jv)("MainThreadCommands"),MainThreadComments:(0,C.$jv)("MainThreadComments"),MainThreadConfiguration:(0,C.$jv)("MainThreadConfiguration"),MainThreadConsole:(0,C.$jv)("MainThreadConsole"),MainThreadDebugService:(0,C.$jv)("MainThreadDebugService"),MainThreadDecorations:(0,C.$jv)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$jv)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$jv)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$jv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$jv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$jv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$jv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$jv)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$jv)("MainThreadErrors"),MainThreadTreeViews:(0,C.$jv)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$jv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$jv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$jv)("MainThreadLanguages"),MainThreadLogger:(0,C.$jv)("MainThreadLogger"),MainThreadMessageService:(0,C.$jv)("MainThreadMessageService"),MainThreadOutputService:(0,C.$jv)("MainThreadOutputService"),MainThreadProgress:(0,C.$jv)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$jv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$jv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$jv)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$jv)("MainThreadSecretState"),MainThreadStorage:(0,C.$jv)("MainThreadStorage"),MainThreadTelemetry:(0,C.$jv)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$jv)("MainThreadTerminalService"),MainThreadWebviews:(0,C.$jv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$jv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$jv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$jv)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$jv)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$jv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$jv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$jv)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$jv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$jv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$jv)("MainThreadExtensionService"),MainThreadSCM:(0,C.$jv)("MainThreadSCM"),MainThreadSearch:(0,C.$jv)("MainThreadSearch"),MainThreadShare:(0,C.$jv)("MainThreadShare"),MainThreadTask:(0,C.$jv)("MainThreadTask"),MainThreadWindow:(0,C.$jv)("MainThreadWindow"),MainThreadLabelService:(0,C.$jv)("MainThreadLabelService"),MainThreadNotebook:(0,C.$jv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$jv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$jv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$jv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$jv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$jv)("MainThreadInteractive"),MainThreadChat:(0,C.$jv)("MainThreadChat"),MainThreadInlineChat:(0,C.$jv)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$jv)("MainThreadTheming"),MainThreadTunnelService:(0,C.$jv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$jv)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$jv)("MainThreadTimeline"),MainThreadTesting:(0,C.$jv)("MainThreadTesting"),MainThreadLocalization:(0,C.$jv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$jv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$jv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.$jv)("MainThreadIssueReporter")},e.$bK={ExtHostCommands:(0,C.$jv)("ExtHostCommands"),ExtHostConfiguration:(0,C.$jv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$jv)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$jv)("ExtHostDebugService"),ExtHostDecorations:(0,C.$jv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$jv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$jv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$jv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$jv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$jv)("ExtHostEditors"),ExtHostTreeViews:(0,C.$jv)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$jv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$jv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$jv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$jv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$jv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$jv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$jv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$jv)("ExtHostStatusBar"),ExtHostShare:(0,C.$jv)("ExtHostShare"),ExtHostExtensionService:(0,C.$jv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$jv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$jv)("ExtHostTerminalService"),ExtHostSCM:(0,C.$jv)("ExtHostSCM"),ExtHostSearch:(0,C.$jv)("ExtHostSearch"),ExtHostTask:(0,C.$jv)("ExtHostTask"),ExtHostWorkspace:(0,C.$jv)("ExtHostWorkspace"),ExtHostWindow:(0,C.$jv)("ExtHostWindow"),ExtHostWebviews:(0,C.$jv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$jv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$jv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$jv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$jv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$jv)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$jv)("ExtHostProgress"),ExtHostComments:(0,C.$jv)("ExtHostComments"),ExtHostSecretState:(0,C.$jv)("ExtHostSecretState"),ExtHostStorage:(0,C.$jv)("ExtHostStorage"),ExtHostUrls:(0,C.$jv)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$jv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$jv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$jv)("ExtHostOutputService"),ExtHosLabelService:(0,C.$jv)("ExtHostLabelService"),ExtHostNotebook:(0,C.$jv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$jv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$jv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$jv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$jv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$jv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$jv)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$jv)("ExtHostInlineChatShape"),ExtHostChat:(0,C.$jv)("ExtHostChat"),ExtHostChatAgents:(0,C.$jv)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$jv)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$jv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,C.$jv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$jv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$jv)("ExtHostTheming"),ExtHostTunnelService:(0,C.$jv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$jv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$jv)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$jv)("ExtHostTimeline"),ExtHostTesting:(0,C.$jv)("ExtHostTesting"),ExtHostTelemetry:(0,C.$jv)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$jv)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.$jv)("ExtHostIssueReporter")}}),define(De[293],Ce([1,0,6,7]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;class d{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$aK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,b,E){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(A);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(b,E)??[]}getRelatedInformation(A,b,E){return this.c.$getAiRelatedInformation(b,E)}registerRelatedInformationProvider(A,b,E){const w=this.b;return this.b++,this.a.set(w,E),this.c.$registerAiRelatedInformationProvider(w,b),new F.$cK(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$Mdc=d}),define(De[89],Ce([1,0,5,13,6,20]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=e.$Qbc=e.$Pbc=void 0,e.$Pbc=(0,C.$Nh)("IExtHostApiDeprecationService");let A=class{constructor(E,w){this.c=w,this.a=new Set,this.b=E.getProxy(d.$aK.MainThreadTelemetry)}report(E,w,R){const I=this.d(E,w);this.a.has(I)||(this.a.add(I),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:E}))}d(E,w){return`${E}-${w.identifier.value}`}};e.$Qbc=A,e.$Qbc=A=He([Be(0,M.$bM),Be(1,F.$8i)],A),e.$Rbc=Object.freeze(new class{report(b,E,w){}})}),define(De[294],Ce([1,0,4,6,7,25]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class A{constructor(w){this.b=new Map,this.c=[],this.d=new C.$Md,this.onDidChangeSessions=this.d.event,this.f=new b,this.g=new b,this.a=w.getProxy(F.$aK.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,R,I,v={}){const y=M.$3l.toKey(w.identifier),D=[...I].sort().join(" ");return await this.f.getOrCreate(`${y} ${R} ${D}`,async()=>{await this.a.$ensureProvider(R);const p=w.displayName||w.name;return this.a.$getSession(R,I,y,p,v)})}async getSessions(w,R,I){const v=M.$3l.toKey(w.identifier),y=[...I].sort().join(" ");return await this.g.getOrCreate(`${v} ${y}`,async()=>{await this.a.$ensureProvider(R);const D=w.displayName||w.name;return this.a.$getSessions(R,I,v,D)})}async removeSession(w,R){const I=this.b.get(w);return I?I.provider.removeSession(R):this.a.$removeSession(w,R)}registerAuthenticationProvider(w,R,I,v){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:R,provider:I,options:v??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===w)||this.c.push({id:w,label:R});const y=I.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions(w,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider(w,R,v?.supportsMultipleAccounts??!1),new d.$cK(()=>{y.dispose(),this.b.delete(w);const D=this.c.findIndex(p=>p.id===w);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,R,I){const v=this.b.get(w);if(v)return Promise.resolve(v.provider.createSession(R,I));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,R){const I=this.b.get(w);if(I)return Promise.resolve(I.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,R){const I=this.b.get(w);if(I)return Promise.resolve(I.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,R){return this.d.fire({provider:{id:w,label:R}}),Promise.resolve()}}e.$ldc=A;class b{constructor(){this.a=new Map}getOrCreate(w,R){const I=this.a.get(w);if(I)return I;const v=R().finally(()=>this.a.delete(w));return this.a.set(w,v),v}}}),define(De[295],Ce([1,0,6,20,14]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;let M=class{constructor(b,E){this.a=b.getProxy(C.$aK.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>E.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,E,w){const R=d.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,w?.isRefactoring??!1)}};e.$rdc=M,e.$rdc=M=He([Be(0,F.$bM)],M)}),define(De[296],Ce([1,0,9,4,51,3,37,202,6,14]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class R{static{this.a=0}constructor(y,D){this.extension=y,this.provider=D,this.handle=R.a++}}class I{static{this.a=0}constructor(y,D){this.h=D,this.b=new Map,this.d=new Map,this.e=new F.$Md,this.onDidPerformUserAction=this.e.event,this.g=y.getProxy(E.$aK.MainThreadChat)}registerChatProvider(y,D,p){const l=new R(y,p);return this.b.set(l.handle,l),this.g.$registerChatProvider(l.handle,D),(0,M.$Pc)(()=>{this.g.$unregisterChatProvider(l.handle),this.b.delete(l.handle)})}transferChatSession(y,D){const p=d.Iterable.find(this.d.keys(),l=>this.d.get(l)===y)??0;typeof p=="number"&&this.g.$transferChatSession(p,D)}sendInteractiveRequestToProvider(y,D){this.g.$sendRequestToProvider(y,D)}async $prepareChat(y,D,p){const l=this.b.get(y);if(!l)return;const c=await l.provider.prepareSession(D,p);if(!c)return;const r=I.a++;return this.d.set(r,c),{id:r,requesterUsername:c.requester?.name,requesterAvatarIconUri:c.requester?.icon,responderUsername:c.responder?.name,responderAvatarIconUri:c.responder?.icon,inputPlaceholder:c.inputPlaceholder}}async $provideWelcomeMessage(y,D){const p=this.b.get(y);if(!p||!p.provider.provideWelcomeMessage)return;const l=await p.provider.provideWelcomeMessage(D);if(l)return l.map(c=>typeof c=="string"?c:c.map(r=>w.ChatReplyFollowup.from(r)))}async $provideFollowups(y,D,p){const l=this.b.get(y);if(!l)return;const c=this.d.get(D);return!c||!l.provider.provideFollowups?void 0:(await l.provider.provideFollowups(c,p))?.map(o=>w.ChatFollowup.from(o))}$removeRequest(y,D,p){const l=this.b.get(y);if(!l)return;const c=this.d.get(D);c&&l.provider.removeRequest&&l.provider.removeRequest(c,p)}async $provideReply(y,D,p,l){const c=this.b.get(y);if(!c)return;const r=this.d.get(D);if(!r)return;const o={session:r,message:typeof p.message=="string"?p.message:w.ChatReplyFollowup.to(p.message),variables:{}};if(p.variables)for(const i of Object.keys(p.variables))o.variables[i]=p.variables[i].map(w.ChatVariable.to);const m=A.$Id.create(!1);let h;const t={report:i=>{if(l.isCancellationRequested)return;typeof h>"u"&&(h=m.elapsed());const s=w.ChatResponseProgress.from(i);if("placeholder"in i&&"resolvedContent"in i){const u=Promise.all([this.g.$acceptResponseProgress(y,D,s),i.resolvedContent]);(0,C.$Hg)(u,l).then(S=>{if(!S)return;const[k,$]=S;this.g.$acceptResponseProgress(y,D,$,k??void 0)})}else this.g.$acceptResponseProgress(y,D,s)}};let n;try{n=await c.provider.provideResponseWithProgress(o,t,l),n||(n={errorDetails:{message:(0,b.localize)(0,null)}})}catch(i){n={errorDetails:{message:(0,b.localize)(1,null,i.message),responseIsIncomplete:!0}},this.h.error(i)}try{if(r.saveState&&this.d.has(D)){const i=r.saveState();this.g.$acceptChatState(D,i)}}catch(i){this.h.warn(i)}const a={firstProgress:h??0,totalElapsed:m.elapsed()};return{errorDetails:n.errorDetails,timings:a}}async $provideSlashCommands(y,D,p){const l=this.b.get(y);if(!l)return;const c=this.d.get(D);return!c||!l.provider.provideSlashCommands?void 0:(await l.provider.provideSlashCommands(c,p))?.map(o=>({...o,kind:w.CompletionItemKind.from(o.kind)}))}$releaseSession(y){this.d.delete(y)}async $onDidPerformUserAction(y){this.e.fire(y)}}e.$Fdc=I}),define(De[297],Ce([1,0,9,3,84,6,14,7]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class E{static{this.a=0}constructor(I,v,y){this.d=v,this.e=y,this.b=new Map,this.c=I.getProxy(M.$aK.MainThreadChatAgents)}registerAgent(I,v,y,D){const p=E.a++;return this.b.set(p,{extension:I,agent:y}),this.c.$registerAgent(p,v,D),(0,F.$Pc)(()=>{this.c.$unregisterAgent(p),this.b.delete(p)})}async $invokeAgent(I,v,y,D,p){const l=this.b.get(I);if(!l){this.e.warn(`[CHAT](${I}) CANNOT invoke agent because the agent is not registered`);return}let c=!1;function r(){if(c)throw new Error("Only valid while executing the command")}const o=new C.$bh;p.onCancellationRequested(()=>o.complete()),setTimeout(()=>o.complete(),10*1e3),this.d.allowListExtensionWhile(l.extension,o.p);const m=l.agent({role:b.ChatMessageRole.User,content:y},{history:D.history.map(A.ChatMessage.to)},new d.$1u(h=>{r(),this.c.$handleProgressChunk(v,{content:w(h.message)?h.message:h.message.value})}),p);try{return await(0,C.$Hg)(Promise.resolve(m).then(h=>{if(h&&"followUp"in h)return{followUp:h?.followUp?.map(n=>A.ChatFollowup.from(n))}}),p)}finally{c=!0,o.complete()}}}e.$Odc=E;function w(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(De[298],Ce([1,0,3,6,14,84,25]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class b{static{this.a=1}constructor(w,R){this.d=R,this.c=new Map,this.e=new Map,this.f=new A.$5l,this.b=w.getProxy(F.$aK.MainThreadChatProvider)}registerProvider(w,R,I,v){const y=b.a++;return this.c.set(y,{extension:w,provider:I}),this.b.$registerProvider(y,R,{extension:w,displayName:v.name??w.value}),(0,C.$Pc)(()=>{this.b.$unregisterProvider(y),this.c.delete(y)})}async $provideChatResponse(w,R,I,v,y){const D=this.c.get(w);if(!D)return;const p=new M.$1u(async l=>{if(y.isCancellationRequested){this.d.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(R,{index:l.index,part:l.part})},{async:!0});return D.provider.provideChatResponse(I.map(d.ChatMessage.to),v,p,y)}allowListExtensionWhile(w,R){this.f.set(w,R),R.finally(()=>this.f.delete(w))}async requestChatResponseProvider(w,R){if(!this.f.has(w))throw new Error("Extension is NOT allowed to make chat requests");const I=this;return{get isRevoked(){return!I.f.has(w)},async makeRequest(v,y,D,p){if(!I.f.has(w))throw new Error("Access to chat has been revoked");const l=Math.random()*1e6|0;I.e.set(l,D);try{await I.b.$fetchResponse(w,R,l,v.map(d.ChatMessage.from),y,p)}finally{I.e.delete(l)}}}}async $handleResponseFragment(w,R){this.e.get(w)?.report(R)}}e.$Kdc=b}),define(De[299],Ce([1,0,3,6,8,14]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;class A{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(F.$aK.MainThreadChatVariables)}async $resolveVariable(E,w,R){const I=this.b.get(E);if(I)try{const v=await I.resolver.resolve(I.data.name,{message:w},R);if(v)return v.map(M.ChatVariable.from)}catch(v){(0,d.$1)(v)}}registerVariableResolver(E,w,R,I){const v=A.a++;return this.b.set(v,{extension:E.identifier,data:{name:w,description:R},resolver:I}),this.c.$registerVariable(v,{name:w,description:R}),(0,C.$Pc)(()=>{this.b.delete(v),this.c.$unregisterVariable(v)})}}e.$Ldc=A}),define(De[300],Ce([1,0,6]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class F{constructor(M){const A=M.getProxy(C.$aK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(b){return A.$writeText(b)}})}}e.$Ubc=F}),define(De[33],Ce([1,0,18,7,14,24,6,19,13,62,34,61,2,3,5,20,145,22,68,47,37,85,88]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=void 0;let n=class{#e;#t;#i;constructor(k,$,f){this.b=new Map,this.c=new Map,this.#e=k.getProxy(A.$aK.MainThreadCommands),this.d=$,this.#i=f,this.#t=k.getProxy(A.$aK.MainThreadTelemetry),this.converter=new a(this,g=>{const P=this.c.get(g);return P?.result===s.Void?P:void 0},$),this.f=[{processArgument(g){return(0,w.$kh)(g)}},{processArgument(g){return(0,M.$5m)(g,function(P){if(R.$ps.isIRange(P))return d.Range.to(P);if(I.$os.isIPosition(P))return d.Position.to(P);if(R.$ps.isIRange(P.range)&&v.URI.isUri(P.uri))return d.location.to(P);if(P instanceof c.$ae)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const $=this.registerCommand(!1,k.id,async(...f)=>{const g=k.args.map((O,N)=>{if(!O.validate(f[N]))throw new Error(`Invalid argument '${O.name}' when running '${k.id}', received: ${typeof f[N]=="object"?JSON.stringify(f[N],null,"	"):f[N]} `);return O.convert(f[N])}),P=await this.executeCommand(k.internalId,...g);return k.result.convert(P,f,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new F.$cK(()=>{$.dispose(),this.c.delete(k.id)})}registerCommand(k,$,f,g,P,O){if(this.d.trace("ExtHostCommands#registerCommand",$),!$.trim().length)throw new Error("invalid id");if(this.b.has($))throw new Error(`command '${$}' already exists`);return this.b.set($,{callback:f,thisArg:g,metadata:P,extension:O}),k&&this.#e.$registerCommand($),new F.$cK(()=>{this.b.delete($)&&k&&this.#e.$unregisterCommand($)})}executeCommand(k,...$){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,$,!0)}async g(k,$,f){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,$,!1);{let g=!1;const P=(0,M.$5m)($,function(O){if(O instanceof F.$dK)return d.Position.from(O);if(O instanceof F.$eK)return d.Range.from(O);if(O instanceof F.$oK)return d.location.from(O);if(F.$zL.isNotebookRange(O))return d.NotebookRange.from(O);if(O instanceof ArrayBuffer)return g=!0,c.$ae.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return g=!0,c.$ae.wrap(O);if(O instanceof c.$ae)return g=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(k,g?new r.$lv(P):P,f);return(0,w.$kh)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(k,$,!1);throw O}}}async h(k,$,f){const g=this.b.get(k);if(!g)throw new Error("Unknown command");const{callback:P,thisArg:O,metadata:N}=g;if(N?.args)for(let j=0;j<N.args.length;j++)try{(0,C.$Of)($[j],N.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${N.args[j].name}' - ${N.args[j].description}`)}const L=m.$Id.create();try{return await P.apply(O,$)}catch(j){if(k===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...$);z&&(k=z.command)}if(this.d.error(j,k,g.extension?.identifier),!f)throw j;if(g.extension?.identifier){const z=this.#i.onExtensionError(g.extension.identifier,j);this.d.trace("forwarded error to extension?",z,g.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$yi)(j)),this.id=k,this.source=g.extension?.displayName??g.extension?.name}}}finally{this.j(g,k,L.elapsed())}}j(k,$,f){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new h.$go($),duration:f})}$executeContributedCommand(k,...$){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const f=this.b.get(k);return f?($=$.map(g=>this.f.reduce((P,O)=>O.processArgument(P,f.extension?.identifier),g)),this.h(k,$,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then($=>(k&&($=$.filter(f=>f[0]!=="_")),$))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[$,f]of this.b){const{metadata:g}=f;g&&(k[$]=g)}return Promise.resolve(k)}};e.$wM=n,e.$wM=n=He([Be(0,p.$bM),Be(1,E.$8i),Be(2,t.$vM)],n),e.$xM=(0,D.$Nh)("IExtHostCommands");class a{constructor(k,$,f){this.d=k,this.f=$,this.g=f,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,$){if(!k)return;const f={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return f;const g=this.f(k.command);if(g)f.id=g.internalId,f.arguments=g.args.map((P,O)=>P.convert(k.arguments&&k.arguments[O]));else if((0,b.$Kb)(k.arguments)){const P=`${k.command} /${++this.c}`;this.b.set(P,k),$.add((0,y.$Pc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),f.$ident=P,f.id=this.delegatingCommandId,f.arguments=[P],this.g.trace("CommandsConverter#CREATE",k.command,P)}return f}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const $=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],$?$.command:"MISSING"),$?this.d.executeCommand($.command,...$.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$yM=a;class i{static{this.Uri=new i("uri","Uri of a text document",k=>v.URI.isUri(k),k=>k)}static{this.Position=new i("position","A position in a text document",k=>F.$dK.isPosition(k),d.Position.from)}static{this.Range=new i("range","A range in a text document",k=>F.$eK.isRange(k),d.Range.from)}static{this.Selection=new i("selection","A selection in a text document",k=>F.$fK.isSelection(k),d.Selection.from)}static{this.Number=new i("number","",k=>typeof k=="number",k=>k)}static{this.String=new i("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=i.Arr(i.String)}static Arr(k){return new i(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,$=>Array.isArray($)&&$.every(f=>k.validate(f)),$=>$.map(f=>k.convert(f)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",k=>k instanceof F.$yK,d.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",k=>k instanceof F.$SL,d.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VS Code TestItem",k=>k instanceof l.$oM,d.TestItem.from)}constructor(k,$,f,g){this.name=k,this.description=$,this.validate=f,this.convert=g}optional(){return new i(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,$){return new i(k??this.name,$??this.description,this.validate,this.convert)}}e.$zM=i;class s{static{this.Void=new s("no result",k=>k)}constructor(k,$){this.description=k,this.convert=$}}e.$AM=s;class u{constructor(k,$,f,g,P){this.id=k,this.internalId=$,this.description=f,this.args=g,this.result=P}}e.$BM=u}),define(De[301],Ce([1,0,19,17,2,82,129,41,134,33,14,7]),function($e,e,C,F,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=void 0;const v=[new w.$BM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[w.$zM.Uri,w.$zM.Position],new w.$AM("A promise that resolves to an array of DocumentHighlight-instances.",D(R.DocumentHighlight.to))),new w.$BM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[w.$zM.Uri],new w.$AM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,c)=>{if((0,C.$Jb)(l))return;class r extends I.$tK{static to(m){const h=new r(m.name,R.SymbolKind.to(m.kind),m.containerName||"",new I.$oK(c[0],R.Range.to(m.range)));return h.detail=m.detail,h.range=h.location.range,h.selectionRange=R.Range.to(m.selectionRange),h.children=m.children?m.children.map(r.to):[],h}}return l.map(r.to)})),new w.$BM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[w.$zM.Uri,new w.$zM("options","Formatting options",l=>!0,l=>l)],new w.$AM("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new w.$BM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[w.$zM.Uri,w.$zM.Range,new w.$zM("options","Formatting options",l=>!0,l=>l)],new w.$AM("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new w.$BM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[w.$zM.Uri,w.$zM.Position,new w.$zM("ch","Trigger character",l=>typeof l=="string",l=>l),new w.$zM("options","Formatting options",l=>!0,l=>l)],new w.$AM("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new w.$BM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[w.$zM.Uri,w.$zM.Position],new w.$AM("A promise that resolves to an array of Location or LocationLink instances.",p)),new w.$BM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[w.$zM.Uri,w.$zM.Position],new w.$AM("A promise that resolves to an array of Location or LocationLink instances.",p)),new w.$BM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[w.$zM.Uri,w.$zM.Position],new w.$AM("A promise that resolves to an array of Location or LocationLink instances.",p)),new w.$BM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[w.$zM.Uri,w.$zM.Position],new w.$AM("A promise that resolves to an array of Location or LocationLink instances.",p)),new w.$BM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[w.$zM.Uri,w.$zM.Position],new w.$AM("A promise that resolves to an array of Location-instances.",D(R.location.to))),new w.$BM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[w.$zM.Uri,w.$zM.Position],new w.$AM("A promise that resolves to an array of Hover-instances.",D(R.Hover.to))),new w.$BM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[w.$zM.Uri,new w.$zM("position","A position in a text document",l=>Array.isArray(l)&&l.every(c=>I.$dK.isPosition(c)),l=>l.map(R.Position.from))],new w.$AM("A promise that resolves to an array of ranges.",l=>l.map(c=>{let r;for(const o of c.reverse())r=new I.$xK(R.Range.to(o),r);return r}))),new w.$BM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[w.$zM.String.with("query","Search string")],new w.$AM("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(R.WorkspaceSymbol.to))),new w.$BM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[w.$zM.Uri,w.$zM.Position],new w.$AM("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(R.CallHierarchyItem.to))),new w.$BM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[w.$zM.CallHierarchyItem],new w.$AM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(R.CallHierarchyIncomingCall.to))),new w.$BM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[w.$zM.CallHierarchyItem],new w.$AM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(R.CallHierarchyOutgoingCall.to))),new w.$BM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[w.$zM.Uri,w.$zM.Position],new w.$AM("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:R.Range.to(l.range),placeholder:l.text}})),new w.$BM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[w.$zM.Uri,w.$zM.Position,w.$zM.String.with("newName","The new symbol name")],new w.$AM("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return R.WorkspaceEdit.to(l)}})),new w.$BM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[w.$zM.Uri,w.$zM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new w.$AM("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(R.DocumentLink.to))),new w.$BM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[w.$zM.Uri],new w.$AM("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new I.$rL(l.tokenTypes,l.tokenModifiers)})),new w.$BM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[w.$zM.Uri],new w.$AM("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const c=(0,A.$R0)(l);if(c.type==="full")return new I.$tL(c.data,void 0)})),new w.$BM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[w.$zM.Uri,w.$zM.Range.optional()],new w.$AM("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new I.$rL(l.tokenTypes,l.tokenModifiers)})),new w.$BM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[w.$zM.Uri,w.$zM.Range],new w.$AM("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const c=(0,A.$R0)(l);if(c.type==="full")return new I.$tL(c.data,void 0)})),new w.$BM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[w.$zM.Uri,w.$zM.Position,w.$zM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),w.$zM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new w.$AM("A promise that resolves to a CompletionList-instance.",(l,c,r)=>{if(!l)return new I.$JK([]);const o=l.suggestions.map(m=>R.CompletionItem.to(m,r));return new I.$JK(o,l.incomplete)})),new w.$BM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[w.$zM.Uri,w.$zM.Position,w.$zM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new w.$AM("A promise that resolves to SignatureHelp.",l=>{if(l)return R.SignatureHelp.to(l)})),new w.$BM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[w.$zM.Uri,w.$zM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new w.$AM("A promise that resolves to an array of CodeLens-instances.",(l,c,r)=>D(o=>new I.$BK(R.Range.to(o.range),o.command&&r.fromInternal(o.command)))(l))),new w.$BM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[w.$zM.Uri,new w.$zM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>I.$eK.isRange(l),l=>I.$fK.isSelection(l)?R.Selection.from(l):R.Range.from(l)),w.$zM.String.with("kind","Code action kind to return code actions for").optional(),w.$zM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new w.$AM("A promise that resolves to an array of Command-instances.",(l,c,r)=>D(o=>{if(o._isSynthetic){if(!o.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(o.command)}else{const m=new I.$vK(o.title,o.kind?new I.$wK(o.kind):void 0);return o.edit&&(m.edit=R.WorkspaceEdit.to(o.edit)),o.command&&(m.command=r.fromInternal(o.command)),m.isPreferred=o.isPreferred,m}})(l))),new w.$BM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[w.$zM.Uri],new w.$AM("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(c=>new I.$PK(R.Range.to(c.range),R.Color.to(c.color))):[])),new w.$BM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new w.$zM("color","The color to show and insert",l=>l instanceof I.$OK,R.Color.from),new w.$zM("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:R.Range.from(l.range)}))],new w.$AM("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(R.ColorPresentation.to):[])),new w.$BM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[w.$zM.Uri,w.$zM.Range],new w.$AM("A promise that resolves to an array of Inlay objects",(l,c,r)=>l.map(R.InlayHint.to.bind(void 0,r)))),new w.$BM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[w.$zM.Uri],new w.$AM("A promise that resolves to an array of FoldingRange objects",(l,c)=>{if(l)return l.map(R.FoldingRange.to)})),new w.$BM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new w.$AM("A promise that resolves to an array of NotebookContentProvider static info objects.",D(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(c=>R.NotebookExclusiveDocumentPattern.to(c))})))),new w.$BM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[w.$zM.Uri,w.$zM.Range,new w.$zM("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof I.$eK,l=>R.InlineValueContext.from(l))],new w.$AM("A promise that resolves to an array of InlineValue objects",l=>l.map(R.InlineValue.to))),new w.$BM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new w.$zM("uriOrString","Uri-instance or string (only http/https)",l=>d.URI.isUri(l)||typeof l=="string"&&(0,E.$$T)(l,F.Schemas.http,F.Schemas.https),l=>l),new w.$zM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[R.ViewColumn.from(l),void 0]:[R.ViewColumn.from(l.viewColumn),R.TextEditorOpenOptions.from(l)])).optional(),w.$zM.String.with("label","").optional()],w.$AM.Void),new w.$BM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[w.$zM.Uri.with("resource","Resource to open"),w.$zM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new w.$zM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[R.ViewColumn.from(l),void 0]:[R.ViewColumn.from(l.viewColumn),R.TextEditorOpenOptions.from(l)])).optional()],w.$AM.Void),new w.$BM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[w.$zM.Uri.with("left","Left-hand side resource of the diff editor"),w.$zM.Uri.with("right","Right-hand side resource of the diff editor"),w.$zM.String.with("title","Human readable title for the diff editor").optional(),new w.$zM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[R.ViewColumn.from(l.viewColumn),R.TextEditorOpenOptions.from(l)]).optional()],w.$AM.Void),new w.$BM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[w.$zM.Uri,w.$zM.Position],new w.$AM("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(R.TypeHierarchyItem.to))),new w.$BM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[w.$zM.TypeHierarchyItem],new w.$AM("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(R.TypeHierarchyItem.to))),new w.$BM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[w.$zM.TypeHierarchyItem],new w.$AM("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(R.TypeHierarchyItem.to))),new w.$BM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[w.$zM.TestItem],w.$AM.Void),new w.$BM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[w.$zM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],w.$AM.Void),new w.$BM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[w.$zM.String.with("name","The context key name"),new w.$zM("value","The context key value",()=>!0,l=>l)],w.$AM.Void),new w.$BM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[w.$zM.Uri,w.$zM.StringArray,new w.$zM("MappedEditsContext","Mapped Edits Context",l=>R.MappedEditsContext.is(l),l=>R.MappedEditsContext.from(l))],new w.$AM("A promise that resolves to a workspace edit or null",l=>l?R.WorkspaceEdit.to(l):null))];class y{static register(c){v.forEach(c.registerApiCommand,c),this.a(c)}static a(c){c.registerCommand(!1,"_validateWhenClauses",b.$Mi)}}e.$Tbc=y;function D(l){return c=>{if(Array.isArray(c))return c.map(l)}}function p(l){if(!Array.isArray(l))return;const c=[];for(const r of l)M.$at(r)?c.push(R.DefinitionLink.to(r)):c.push(R.location.to(r));return c}}),define(De[302],Ce([1,0,9,57,4,3,2,82,25,14,7,6,26]),function($e,e,C,F,d,M,A,b,E,w,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;function y(D,p,l){const c=D.getProxy(I.$aK.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$5l,p.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const S=this.b.get(u.handle);return S?S.value:u}else if(u&&u.$mid===7){const S=this.b.get(u.commentControlHandle);if(!S)return u;const k=S.getCommentThread(u.commentThreadHandle);return k?k.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const S=this.b.get(u.thread.commentControlHandle);if(!S)return u;const k=S.getCommentThread(u.thread.commentThreadHandle);return k?u.$mid===8?k.value:{thread:k.value,text:u.text}:u}else if(u&&u.$mid===10){const S=this.b.get(u.thread.commentControlHandle);if(!S)return u;const k=S.getCommentThread(u.thread.commentThreadHandle);if(!k)return u;const $=u.commentUniqueId,f=k.getCommentByUniqueId($);return f||u}else if(u&&u.$mid===11){const S=this.b.get(u.thread.commentControlHandle);if(!S)return u;const k=S.getCommentThread(u.thread.commentThreadHandle);if(!k)return u;const $=u.text,f=u.commentUniqueId,g=k.getCommentByUniqueId(f);return g?(typeof g.body=="string"?g.body=$:g.body=new R.$CK($),g):u}return u}})}createCommentController(u,S,k){const $=r.a++,f=new m(u,$,S,k);this.b.set(f.handle,f);const g=this.c.get(u.identifier)||[];return g.push(f),this.c.set(u.identifier,g),f.value}async $createCommentThreadTemplate(u,S,k){const $=this.b.get(u);$&&$.$createCommentThreadTemplate(S,k)}async $updateCommentThreadTemplate(u,S,k){const $=this.b.get(u);$&&$.$updateCommentThreadTemplate(S,k)}$deleteCommentThread(u,S){this.b.get(u)?.$deleteCommentThread(S)}$provideCommentingRanges(u,S,k){const $=this.b.get(u);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const f=l.getDocument(A.URI.revive(S));return(0,C.$Lg)(async()=>{const g=await $.commentingRangeProvider.provideCommentingRanges(f,k);let P;return Array.isArray(g)?P={ranges:g,fileComments:!1}:g?P={ranges:g.ranges||[],fileComments:g.fileComments||!1}:P=g??void 0,P}).then(g=>{let P;return g&&(P={ranges:g.ranges.map(O=>w.Range.from(O)),fileComments:g.fileComments}),P})}$toggleReaction(u,S,k,$,f){const g=this.b.get(u);return!g||!g.reactionHandler?Promise.resolve(void 0):(0,C.$Lg)(()=>{const P=g.getCommentThread(S);if(P){const O=P.getCommentByUniqueId($.uniqueIdInThread);if(g!==void 0&&O&&g.reactionHandler)return g.reactionHandler(O,n(f))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){(u===void 0!=(this.p===void 0)||!u||!this.p||!u.isEqual(this.p))&&(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return this.h}set state(u){this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,S,k,$,f,g,P,O){this.m=S,this.n=k,this.o=$,this.p=f,this.q=g,this.extensionDescription=P,this.r=O,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new d.$Md,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${u}.${this.handle}`),c.$createCommentThread(S,this.handle,this.n,this.o,w.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=g,this.i.push({dispose:()=>{c.$deleteCommentThread(S,this.handle)}});const N=this;this.value={get uri(){return N.uri},get range(){return N.range},set range(L){N.range=L},get comments(){return N.comments},set comments(L){N.comments=L},get collapsibleState(){return N.collapsibleState},set collapsibleState(L){N.collapsibleState=L},get canReply(){return N.canReply},set canReply(L){N.canReply=L},get contextValue(){return N.contextValue},set contextValue(L){N.contextValue=L},get label(){return N.label},set label(L){N.label=L},get state(){return N.state},set state(L){N.state=L},dispose:()=>{N.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const u=k=>Object.prototype.hasOwnProperty.call(this.b,k),S={};u("range")&&(S.range=w.Range.from(this.p)),u("label")&&(S.label=this.label),u("contextValue")&&(S.contextValue=this.contextValue??null),u("comments")&&(S.comments=this.q.map(k=>h(this,k,this.k,this.extensionDescription))),u("collapsibleState")&&(S.collapseState=a(this.g)),u("canReply")&&(S.canReply=this.canReply),u("state")&&(S.state=i(this.h)),u("isTemplate")&&(S.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(u){for(const S of this.k){const k=S[0],$=S[1];if(u===$)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}He([(0,F.$gh)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class m{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,S,k,$){this.f=u,this.g=S,this.h=k,this.i=$,this.a=new Map,c.$registerCommentController(this.handle,k,$,this.f.identifier.value);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(g){f.options=g},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(g){f.commentingRangeProvider=g},get reactionHandler(){return f.reactionHandler},set reactionHandler(g){f.reactionHandler=g},createCommentThread(g,P,O){return f.createCommentThread(g,P,O).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(u,S,k){S===void 0&&(0,v.$aF)(this.f,"fileComments");const $=new o(this.id,this.handle,void 0,u,S,k,this.f,!1);return this.a.set($.handle,$),$}$createCommentThreadTemplate(u,S){const k=new o(this.id,this.handle,void 0,A.URI.revive(u),w.Range.to(S),[],this.f,!0);return k.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(u,S){const k=this.a.get(u);k&&(k.range=w.Range.to(S))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function h(s,u,S,k){let $=S.get(u);return $||($=++s.commentHandle,S.set(u,$)),u.state!==void 0&&(0,v.$aF)(k,"commentsDraftState"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:$,body:typeof u.body=="string"?u.body:w.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(f=>t(f)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function t(s){return{label:s.label,iconPath:s.iconPath?w.$aM(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function n(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?A.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function a(s){if(s!==void 0)switch(s){case R.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function i(s){if(s!==void 0)switch(s){case R.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new r}e.$Vbc=y}),define(De[303],Ce([1,0,24,6,27,20]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;let A=class{constructor(R,I){this.a=R.getProxy(F.$aK.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,I){const v=this,y=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){v.e(R,I,y,arguments)}})}e(R,I,v,y){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:E(y,this.b)}),this.c&&this.f(R,v,y)}};e.$Rdc=A,e.$Rdc=A=He([Be(0,M.$bM),Be(1,d.$rM)],A);const b=1e5;function E(w,R){const I=[];if(w.length)for(let v=0;v<w.length;v++){let y=w[v];if(typeof y>"u")y="undefined";else if(y instanceof Error){const D=y;D.stack?y=D.stack:y=D.toString()}I.push(y)}if(R){const v=new Error().stack;v&&I.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,C.$8m)(I);return v.length>b?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(De[149],Ce([1,0,2,6,7,5,20,13,19,15,16,26]),function($e,e,C,F,d,M,A,b,E,w,R,I){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=void 0;let y=class{static{v=this}static{this.c=0}static{this.d=250}constructor(p,l){this.h=l,this.f=new Map,this.g=p.getProxy(F.$aK.MainThreadDecorations)}registerFileDecorationProvider(p,l){const c=v.c++;this.f.set(c,{provider:p,extensionDescription:l}),this.g.$registerDecorationProvider(c,l.identifier.value);const r=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(c,null);return}const m=(0,E.$2b)(o);if(m.length<=v.d){this.g.$onDidChange(c,m);return}this.h.warn("[Decorations] CAPPING events from decorations provider",l.identifier.value,m.length);const h=m.map(a=>({uri:a,rank:(0,w.$Fe)(a.path,"/")})),t=(0,E.$yb)(h,(a,i)=>a.rank-i.rank||(0,w.$Te)(a.uri.path,i.uri.path)),n=[];e:for(const a of t){let i;for(const s of a){const u=(0,R.$lc)(s.uri.path);if(i!==u&&(i=u,n.push(s.uri)>=v.d))break e}}this.g.$onDidChange(c,n)});return new d.$cK(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(p,l,c){if(!this.f.has(p))return Object.create(null);const r=Object.create(null),{provider:o,extensionDescription:m}=this.f.get(p);return await Promise.all(l.map(async h=>{try{const{uri:t,id:n}=h,a=await Promise.resolve(o.provideFileDecoration(C.URI.revive(t),c));if(!a)return;try{d.$xL.validate(a),a.badge&&typeof a.badge!="string"&&(0,I.$aF)(m,"codiconDecoration"),r[n]=[a.propagate,a.tooltip,a.badge,a.color]}catch(i){this.h.warn(`INVALID decoration from extension '${m.identifier.value}': ${i}`)}}catch(t){this.h.error(t)}})),r}};e.$Wcc=y,e.$Wcc=y=v=He([Be(0,A.$bM),Be(1,b.$8i)],y),e.$Xcc=(0,M.$Nh)("IExtHostDecorations")}),define(De[304],Ce([1,0,203,133,2,6,7,14,4,13,28,55]),function($e,e,C,F,d,M,A,b,E,w,R,I){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=void 0;class y{#e;#t;#i;constructor(l,c,r,o,m,h,t,n){this.d=l,this.e=c,this.f=r,this.g=o,this.h=m,this.c=!1,this.f=Math.max(o,r),this.#i=new R.$zc(a=>h.getComparisonKey(a)),this.#e=t,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(l,c){if(!l){this.clear();return}this.j();let r=[];if(d.URI.isUri(l)){if(!c){this.delete(l);return}this.#i.set(l,c.slice()),r=[l]}else if(Array.isArray(l)){r=[];let h;l=[...l].sort(y.k);for(const t of l){const[n,a]=t;if((!h||n.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=n,r.push(n),this.#i.set(n,[])),a)this.#i.get(n)?.push(...a);else{const i=this.#i.get(n);i&&(i.length=0)}}}if(this.#t.fire(r),!this.#e)return;const o=[];let m=0;for(const h of r){let t=[];const n=this.#i.get(h);if(n)if(n.length>this.g){t=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const s of n)if(s.severity===a[i]&&t.push({...b.Diagnostic.from(s),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,C.localize)(0,null,n.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=n.map(a=>({...b.Diagnostic.from(a),modelVersionId:this.h(h)}));if(o.push([h,t]),m+=t.length,m>this.f)break}this.#e.$changeMany(this.e,o)}delete(l){this.j(),this.#t.fire([l]),this.#i.delete(l),this.#e?.$changeMany(this.e,[[l,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(l,c){this.j();for(const[r,o]of this)l.call(c,r,o,this)}*[Symbol.iterator](){this.j();for(const l of this.#i.keys())yield[l,this.get(l)]}get(l){this.j();const c=this.#i.get(l);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(l){return this.j(),Array.isArray(this.#i.get(l))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(l,c){return l[0].toString()<c[0].toString()?-1:l[0].toString()>c[0].toString()?1:0}}e.$Nbc=y;let D=class{static{v=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*v.d}static _mapper(l){const c=new R.$zc;for(const r of l)c.set(r,r);return{uris:Object.freeze(Array.from(c.values()))}}constructor(l,c,r,o){this.j=c,this.k=r,this.l=o,this.g=new Map,this.h=new E.$Qd({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,v._mapper),this.f=l.getProxy(M.$aK.MainThreadDiagnostics)}createDiagnosticCollection(l,c){const{g:r,f:o,h:m,j:h,k:t,l:n}=this,a=new class{$changeMany(u,S){o.$changeMany(u,S),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,u,S.length===0?"CLEARING":S)}$clear(u){o.$clear(u),h.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,u)}dispose(){o.dispose()}};let i;if(!c)c="_generated_diagnostic_collection_name_#"+v.c++,i=c;else if(!r.has(c))i=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do i=c+v.c++;while(r.has(i))}return new class extends y{constructor(){super(c,i,v.e,v.d,u=>n.getDocument(u)?.version,t.extUri,a,m),r.set(i,this)}dispose(){super.dispose(),r.delete(i)}}}getDiagnostics(l){if(l)return this.m(l);{const c=new Map,r=[];for(const o of this.g.values())o.forEach((m,h)=>{let t=c.get(m.toString());typeof t>"u"&&(t=r.length,c.set(m.toString(),t),r.push([m,[]])),r[t][1]=r[t][1].concat(...h)});return r}}m(l){let c=[];for(const r of this.g.values())r.has(l)&&(c=c.concat(r.get(l)));return c}$acceptMarkersChange(l){if(!this.n){const c="_generated_mirror",r=new y(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(c,r),this.n=r}for(const[c,r]of l)this.n.set(d.URI.revive(c),r.map(b.Diagnostic.to))}};e.$Obc=D,e.$Obc=D=v=He([Be(1,w.$8i),Be(2,I.$Mbc)],D)}),define(De[305],Ce([1,0,2,6,26]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=void 0;class M{constructor(b){this.a=b.getProxy(F.$aK.MainThreadDialogs)}showOpenDialog(b,E){return E?.allowUIResources&&(0,d.$aF)(b,"showLocal"),this.a.$showOpenDialog(E).then(w=>w?w.map(R=>C.URI.revive(R)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(E=>E?C.URI.revive(E):void 0)}}e.$4bc=M}),define(De[306],Ce([1,0,8,2,7,6,17,21,15]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;class w{static{this.a=0}constructor(I,v,y){this.d=v,this.e=y,this.b=new Map,this.c=I.getProxy(M.$aK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,v){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const y=w.a++;this.b.set(y,v),this.c.$registerTextContentProvider(y,I);let D;return typeof v.onDidChange=="function"&&(D=v.onDidChange(p=>{if(p.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this.d.getDocument(p)&&this.$provideTextDocumentContent(y,p).then(l=>{if(!l&&typeof l!="string")return;const c=this.d.getDocument(p);if(!c)return;const r=(0,E.$Oe)(l);if(!c.equalLines(r))return this.c.$onVirtualDocumentChange(p,l)},C.$Z)})),new d.$cK(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(I,v){const y=this.b.get(I);return y?Promise.resolve(y.provideTextDocumentContent(F.URI.revive(v),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.$5bc=w}),define(De[307],Ce([1,0,4,3,2,6,141,14,18,24,7,8]),function($e,e,C,F,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;class v{constructor(D,p){this.a=new C.$Md({onListenerError:I.$1}),this.b=new C.$Md({onListenerError:I.$1}),this.c=new C.$Md({onListenerError:I.$1}),this.d=new C.$Md({onListenerError:I.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Qc,this.h=new Map,this.f=D.getProxy(M.$aK.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(l=>{for(const c of l)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(l=>{for(const c of l)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const p=this.g.getDocument(D);if(p)return p}getDocument(D){const p=this.getDocumentData(D);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return p.document}ensureDocumentData(D){const p=this.g.getDocument(D);if(p)return Promise.resolve(p);let l=this.h.get(D.toString());return l||(l=this.f.$tryOpenDocument(D).then(c=>{this.h.delete(D.toString());const r=d.URI.revive(c);return(0,E.$If)(this.g.getDocument(r))},c=>(this.h.delete(D.toString()),Promise.reject(c))),this.h.set(D.toString(),l)),l}createDocumentData(D){return this.f.$tryCreateDocument(D).then(p=>d.URI.revive(p))}$acceptModelLanguageChanged(D,p){const l=d.URI.revive(D),c=this.g.getDocument(l);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId(p),this.a.fire(c.document)}$acceptModelSaved(D){const p=d.URI.revive(D),l=this.g.getDocument(p);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(l.document)}$acceptDirtyStateChanged(D,p){const l=d.URI.revive(D),c=this.g.getDocument(l);if(!c)throw new Error("unknown document");c._acceptIsDirty(p),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,p,l){const c=d.URI.revive(D),r=this.g.getDocument(c);if(!r)throw new Error("unknown document");r._acceptIsDirty(l),r.onEvents(p);let o;p.isUndoing?o=R.TextDocumentChangeReason.Undo:p.isRedoing&&(o=R.TextDocumentChangeReason.Redo),this.c.fire((0,w.$4m)({document:r.document,contentChanges:p.changes.map(m=>({range:b.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:o}))}setWordDefinitionFor(D,p){(0,A.$dM)(D,p)}}e.$Kbc=v}),define(De[69],Ce([1,0,58,4,3,2,5,6,141,20,146,14,13,28,17,51,46]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=void 0;class c{constructor(m){this.value=m,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(m,h){this.h=m,this.i=h,this.a=null,this.b=new Map,this.c=new y.$zc,this.d=new F.$Md,this.e=new F.$Md,this.f=new F.$Md,this.g=new F.$Md,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const h=[],t=[],n=[];if(m.removedDocuments)for(const a of m.removedDocuments){const i=M.URI.revive(a),s=this.c.get(i);s?.unref()&&(this.c.delete(i),h.push(s.value))}if(m.addedDocuments)for(const a of m.addedDocuments){const i=M.URI.revive(a.uri);let s=this.c.get(i);if(s&&i.scheme!==D.Schemas.vscodeNotebookCell&&i.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);s||(s=new c(new E.$eM(this.h.getProxy(b.$aK.MainThreadDocuments),i,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(i,s),t.push(s.value)),s.ref()}if(m.removedEditors)for(const a of m.removedEditors){const i=this.b.get(a);this.b.delete(a),i&&n.push(i)}if(m.addedEditors)for(const a of m.addedEditors){const i=M.URI.revive(a.documentUri);C.ok(this.c.has(i),`document '${i}' does not exist`),C.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const s=this.c.get(i).value,u=new R.$kM(a.id,this.h.getProxy(b.$aK.MainThreadTextEditors),this.i,new l.$U(()=>s.document),a.selections.map(I.Selection.to),a.options,a.visibleRanges.map(S=>I.Range.to(S)),typeof a.editorPosition=="number"?I.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,u)}m.newActiveEditor!==void 0&&(C.ok(m.newActiveEditor===null||this.b.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this.a=m.newActiveEditor),(0,d.$Mc)(h),(0,d.$Mc)(n),m.removedDocuments&&this.e.fire(h),m.addedDocuments&&this.d.fire(t),(m.removedEditors||m.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),m.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(m){return this.c.get(m)?.value}allDocuments(){return p.Iterable.map(this.c.values(),m=>m.value)}getEditor(m){return this.b.get(m)}activeEditor(m){if(!this.a)return;const h=this.b.get(this.a);return m?h:h?.value}allEditors(){return[...this.b.values()]}};e.$lM=r,e.$lM=r=He([Be(0,w.$bM),Be(1,v.$8i)],r),e.$mM=(0,A.$Nh)("IExtHostDocumentsAndEditors")}),define(De[70],Ce([1,0,14,6,2,4,5,7,20,18,73]),function($e,e,C,F,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=void 0,e.$2cc=(0,A.$Nh)("IExtHostEditorTabs");class I{constructor(l,c,r){this.e=r,this.d=c,this.acceptDtoUpdate(l)}get apiObject(){if(!this.a){const l=this,c={get isActive(){return l.b.id===l.e()},get label(){return l.b.label},get input(){return l.c},get isDirty(){return l.b.isDirty},get isPinned(){return l.b.isPinned},get isPreview(){return l.b.isPreview},get group(){return l.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(l){this.b=l,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new b.$TL(d.URI.revive(this.b.input.uri));case 2:return new b.$UL(d.URI.revive(this.b.input.original),d.URI.revive(this.b.input.modified));case 3:return new b.$VL(d.URI.revive(this.b.input.base),d.URI.revive(this.b.input.input1),d.URI.revive(this.b.input.input2),d.URI.revive(this.b.input.result));case 6:return new b.$WL(d.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new b.$XL(this.b.input.viewType);case 4:return new b.$YL(d.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new b.$ZL(d.URI.revive(this.b.input.original),d.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new b.$1L;case 9:return new b.$2L(d.URI.revive(this.b.input.uri),d.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(l,c){this.c=[],this.d="",this.b=l,this.e=c;for(const r of l.tabs)r.isActive&&(this.d=r.id),this.c.push(new I(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const l=this,c={get isActive(){return l.b.groupId===l.e()},get viewColumn(){return C.ViewColumn.to(l.b.viewColumn)},get activeTab(){return l.c.find(r=>r.tabId===l.d)?.apiObject},get tabs(){return Object.freeze(l.c.map(r=>r.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(l){this.b=l}acceptTabOperation(l){if(l.kind===0){const r=new I(l.tabDto,this,()=>this.activeTabId());return this.c.splice(l.index,0,r),l.tabDto.isActive&&(this.d=r.tabId),r}else if(l.kind===1){const r=this.c.splice(l.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${l.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(l.kind===3){if(l.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(l.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${l.oldIndex} which does not exist`);return this.c.splice(l.index,0,r),r}const c=this.c.find(r=>r.tabId===l.tabDto.id);if(!c)throw new Error("INVALID tab");return l.tabDto.isActive?this.d=l.tabDto.id:this.d===l.tabDto.id&&!l.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(l.tabDto),c}activeTabId(){return this.d}}let y=class{constructor(l){this.b=new M.$Md,this.c=new M.$Md,this.e=[],this.a=l.getProxy(F.$aK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const l=this,c={onDidChangeTabGroups:l.c.event,onDidChangeTabs:l.b.event,get all(){return Object.freeze(l.e.map(r=>r.apiObject))},get activeTabGroup(){const r=l.d;return(0,w.$If)(l.e.find(m=>m.groupId===r)?.apiObject)},close:async(r,o)=>{const m=Array.isArray(r)?r:[r];return m.length?D(m[0])?this.j(m,o):this.i(m,o):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(l){const c=new Set(this.e.map(a=>a.groupId)),r=new Set(l.map(a=>a.groupId)),o=(0,R.$K)(c,r),m=this.e.filter(a=>o.removed.includes(a.groupId)).map(a=>a.apiObject),h=[],t=[];this.e=l.map(a=>{const i=new v(a,()=>this.d);return o.added.includes(i.groupId)?h.push(i.apiObject):t.push(i.apiObject),i});const n=(0,w.$If)(l.find(a=>a.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:h,closed:m,changed:t}))}$acceptTabGroupUpdate(l){const c=this.e.find(r=>r.groupId===l.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(l),l.isActive&&(this.d=l.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(l){const c=this.e.find(o=>o.groupId===l.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const r=c.acceptTabOperation(l);switch(l.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(l){for(const c of this.e)for(const r of c.tabs)if(r.apiObject===l)return r}h(l){return this.e.find(c=>c.apiObject===l)}async i(l,c){const r=[];for(const o of l){const m=this.g(o);if(!m)throw new Error("Tab close: Invalid tab not found!");r.push(m.tabId)}return this.a.$closeTab(r,c)}async j(l,c){const r=[];for(const o of l){const m=this.h(o);if(!m)throw new Error("Group close: Invalid group not found!");r.push(m.groupId)}return this.a.$closeGroup(r,c)}};e.$3cc=y,e.$3cc=y=He([Be(0,E.$bM)],y);function D(p){return p.tabs!==void 0}}),define(De[308],Ce([1,0,6,7]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class d{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$aK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,b,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(A);if(!w)throw new Error("Embedding vector provider not found");const R=await w.provideEmbeddingVector(b,E);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,b,E){const w=this.b;return this.b++,this.a.set(w,E),this.c.$registerAiEmbeddingVectorProvider(b,w),new F.$cK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$Ndc=d}),define(De[309],Ce([1,0,2,6,3,7,14,169,15,22,26,79]),function($e,e,C,F,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class v{constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const l=this.a.indexOf(p);l>=0&&(this.a.splice(l,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),l=[];let c,r,o=14,m=14;for(const h of p){let t=c?(0,E.$3e)(c,h):0;for(t===0?r=1:r=m;t<h.length;t++)t+1===h.length?(o=m,m=9):m+=1,l.push([r,h.toUpperCase().charCodeAt(t),m]),l.push([r,h.toLowerCase().charCodeAt(t),m]),r=m;c=h,m=o}l.push([9,58,10]),l.push([10,47,12]),this.b=new b.$TY(l)}}provideDocumentLinks(p){this.c();const l=[],c=b.$UY.computeLinks({getLineContent(r){return p.lineAt(r-1).text},getLineCount(){return p.lineCount}},this.b);for(const r of c){const o=A.DocumentLink.to(r);o.target&&l.push(o)}return l}}class y{constructor(p,l){this.i=l,this.b=new v,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(F.$aK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,l,c,r={}){if(y.j(c),this.d.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const o=this.h++;this.b.add(l),this.d.add(l),this.c.set(o,c);let m=2;r.isCaseSensitive&&(m+=1024),r.isReadonly&&(m+=2048),typeof c.copy=="function"&&(m+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,R.$aF)(p,"fsChunks"),m+=4);let h;r.isReadonly&&(0,I.$3j)(r.isReadonly)&&((0,R.$aF)(p,"readonlyMessage"),h={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(o,l,m,h).catch(n=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${l}`),console.error(n)});const t=c.onDidChangeFile(n=>{const a=[];for(const i of n){const{uri:s,type:u}=i;if(s.scheme!==l)continue;let S;switch(u){case M.FileChangeType.Changed:S=0;break;case M.FileChangeType.Created:S=1;break;case M.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:s,type:S})}this.a.$onFileSystemChange(o,a)});return(0,d.$Pc)(()=>{t.dispose(),this.b.delete(l),this.d.delete(l),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:l,ctime:c,mtime:r,size:o,permissions:m}=p;return{type:l,ctime:c,mtime:r,size:o,permissions:m}}$stat(p,l){return Promise.resolve(this.l(p).stat(C.URI.revive(l))).then(c=>y.k(c))}$readdir(p,l){return Promise.resolve(this.l(p).readDirectory(C.URI.revive(l)))}$readFile(p,l){return Promise.resolve(this.l(p).readFile(C.URI.revive(l))).then(c=>w.$ae.wrap(c))}$writeFile(p,l,c,r){return Promise.resolve(this.l(p).writeFile(C.URI.revive(l),c.buffer,r))}$delete(p,l,c){return Promise.resolve(this.l(p).delete(C.URI.revive(l),c))}$rename(p,l,c,r){return Promise.resolve(this.l(p).rename(C.URI.revive(l),C.URI.revive(c),r))}$copy(p,l,c,r){const o=this.l(p);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(C.URI.revive(l),C.URI.revive(c),r))}$mkdir(p,l){return Promise.resolve(this.l(p).createDirectory(C.URI.revive(l)))}$watch(p,l,c,r){const o=this.l(p).watch(C.URI.revive(c),r);this.f.set(l,o)}$unwatch(p,l){const c=this.f.get(l);c&&(c.dispose(),this.f.delete(l))}$open(p,l,c){const r=this.l(p);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(C.URI.revive(l),c))}$close(p,l){const c=this.l(p);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(l))}$read(p,l,c,r){const o=this.l(p);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const m=w.$ae.alloc(r);return Promise.resolve(o.read(l,c,m.buffer,0,r)).then(h=>m.slice(0,h))}$write(p,l,c,r){const o=this.l(p);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(l,c,r.buffer,0,r.byteLength))}l(p){const l=this.c.get(p);if(!l){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return l}}e.$ycc=y}),define(De[71],Ce([1,0,6,30,7,22,5,20,55,3,9,23,17]),function($e,e,C,F,d,M,A,b,E,w,R,I,v){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=e.$ecc=void 0;let D=y=class{constructor(l,c){this.b=new Map,this.c=new R.$2g,this.a=l.getProxy(C.$aK.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(o){try{let m;const h=r.b.get(o.scheme);return h?(await r.a.$ensureActivation(o.scheme),m=await h.impl.stat(o)):m=await r.a.$stat(o),{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===F.FilePermission.Readonly?1:void 0}}catch(m){y.e(m)}},async readDirectory(o){try{const m=r.b.get(o.scheme);return m?(await r.a.$ensureActivation(o.scheme),(await m.impl.readDirectory(o)).slice()):await r.a.$readdir(o)}catch(m){return y.e(m)}},async createDirectory(o){try{const m=r.b.get(o.scheme);return m&&!m.isReadonly?(await r.a.$ensureActivation(o.scheme),await r.d(m.impl,m.extUri,o)):await r.a.$mkdir(o)}catch(m){return y.e(m)}},async readFile(o){try{const m=r.b.get(o.scheme);return m?(await r.a.$ensureActivation(o.scheme),(await m.impl.readFile(o)).slice()):(await r.a.$readFile(o)).buffer}catch(m){return y.e(m)}},async writeFile(o,m){try{const h=r.b.get(o.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(o.scheme),await r.d(h.impl,h.extUri,h.extUri.dirname(o)),await r.c.queueFor(o).queue(()=>Promise.resolve(h.impl.writeFile(o,m,{create:!0,overwrite:!0})))):await r.a.$writeFile(o,M.$ae.wrap(m))}catch(h){return y.e(h)}},async delete(o,m){try{const h=r.b.get(o.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(o.scheme),await h.impl.delete(o,{recursive:!1,...m})):await r.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...m})}catch(h){return y.e(h)}},async rename(o,m,h){try{return await r.a.$rename(o,m,{overwrite:!1,...h})}catch(t){return y.e(t)}},async copy(o,m,h){try{return await r.a.$copy(o,m,{overwrite:!1,...h})}catch(t){return y.e(t)}},isWritableFileSystem(o){const m=c.getCapabilities(o);if(typeof m=="number")return!(m&2048)}})}async d(l,c,r){const o=[];for(;!c.isEqual(r,c.dirname(r));)try{if(!((await l.stat(r)).type&F.FileType.Directory))throw d.$pL.FileExists(`Unable to create folder '${r.scheme===v.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(m){if(F.$mk(m)!==F.FileSystemProviderErrorCode.FileNotFound)throw m;o.push(c.basename(r)),r=c.dirname(r)}for(let m=o.length-1;m>=0;m--){r=c.joinPath(r,o[m]);try{await l.createDirectory(r)}catch(h){if(F.$mk(h)!==F.FileSystemProviderErrorCode.FileExists)throw h}}}static e(l){if(l instanceof d.$pL)throw l;if(l instanceof F.$ik)switch(l.code){case F.FileSystemProviderErrorCode.FileExists:throw d.$pL.FileExists(l.message);case F.FileSystemProviderErrorCode.FileNotFound:throw d.$pL.FileNotFound(l.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw d.$pL.FileNotADirectory(l.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw d.$pL.FileIsADirectory(l.message);case F.FileSystemProviderErrorCode.NoPermissions:throw d.$pL.NoPermissions(l.message);case F.FileSystemProviderErrorCode.Unavailable:throw d.$pL.Unavailable(l.message);default:throw new d.$pL(l.message,l.name)}if(!(l instanceof Error))throw new d.$pL(String(l));if(l.name==="ENOPRO"||l.message.includes("ENOPRO"))throw d.$pL.Unavailable(l.message);switch(l.name){case F.FileSystemProviderErrorCode.FileExists:throw d.$pL.FileExists(l.message);case F.FileSystemProviderErrorCode.FileNotFound:throw d.$pL.FileNotFound(l.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw d.$pL.FileNotADirectory(l.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw d.$pL.FileIsADirectory(l.message);case F.FileSystemProviderErrorCode.NoPermissions:throw d.$pL.NoPermissions(l.message);case F.FileSystemProviderErrorCode.Unavailable:throw d.$pL.Unavailable(l.message);default:throw new d.$pL(l.message,l.name)}}addFileSystemProvider(l,c,r){return this.b.set(l,{impl:c,extUri:r?.isCaseSensitive?I.$kg:I.$mg,isReadonly:!!r?.isReadonly}),(0,w.$Pc)(()=>this.b.delete(l))}getFileSystemProviderExtUri(l){return this.b.get(l)?.extUri??I.$kg}};e.$ecc=D,e.$ecc=D=y=He([Be(0,b.$bM),Be(1,E.$Mbc)],D),e.$fcc=(0,A.$Nh)("IExtHostConsumerFileSystem")}),define(De[310],Ce([1,0,4,35,2,6,14,7,46]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,D,p,l,c,r){this.a=Math.random(),this.b=new C.$Md,this.c=new C.$Md,this.d=new C.$Md,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const o=(0,F.$uj)(c),m=typeof c=="string",h=l(t=>{if(!(typeof t.session=="number"&&t.session!==this.a)){if(!r?.ignoreCreateEvents)for(const n of t.created){const a=d.URI.revive(n);o(a.fsPath)&&(!m||D.getWorkspaceFolder(a))&&this.b.fire(a)}if(!r?.ignoreChangeEvents)for(const n of t.changed){const a=d.URI.revive(n);o(a.fsPath)&&(!m||D.getWorkspaceFolder(a))&&this.c.fire(a)}if(!r?.ignoreDeleteEvents)for(const n of t.deleted){const a=d.URI.revive(n);o(a.fsPath)&&(!m||D.getWorkspaceFolder(a))&&this.d.fire(a)}}});this.g=b.$cK.from(this.i(y,p,c,r),this.b,this.c,this.d,h)}i(y,D,p,l){const c=b.$cK.from();if(typeof p=="string")return c;const r=y.getProxy(M.$aK.MainThreadFileSystemEventService);let o=!1;return(p.pattern.includes(F.$qj)||p.pattern.includes(F.$rj))&&(o=!0),r.$watch(D.identifier.value,this.a,p.baseUri,{recursive:o,excludes:l?.excludes??[]}),b.$cK.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(y){this.a=y,this.session=this.a.session,this.b=new E.$U(()=>this.a.created.map(d.URI.revive)),this.c=new E.$U(()=>this.a.changed.map(d.URI.revive)),this.d=new E.$U(()=>this.a.deleted.map(d.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(y,D,p){this.j=y,this.k=D,this.l=p,this.a=new C.$Md,this.b=new C.$Md,this.c=new C.$Md,this.d=new C.$Md,this.g=new C.$Od,this.h=new C.$Od,this.i=new C.$Od,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,D,p,l){return new w(this.j,y,D,this.a.event,A.GlobPattern.from(p),l)}$onFileEvent(y){this.a.fire(new R(y))}$onDidRunFileOperation(y,D){switch(y){case 2:this.b.fire(Object.freeze({files:D.map(p=>({oldUri:d.URI.revive(p.source),newUri:d.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:D.map(p=>d.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:D.map(p=>d.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,D){return(p,l,c)=>{const r=function(m){p.call(l,m)};return r.extension=y,D.event(r,void 0,c)}}async $onWillRunFileOperation(y,D,p,l){switch(y){case 2:return await this.n(this.g,{files:D.map(c=>({oldUri:d.URI.revive(c.source),newUri:d.URI.revive(c.target)}))},p,l);case 1:return await this.n(this.i,{files:D.map(c=>d.URI.revive(c.target))},p,l);case 0:case 3:return await this.n(this.h,{files:D.map(c=>d.URI.revive(c.target))},p,l)}}async n(y,D,p,l){const c=new Set,r=[];if(await y.fireAsync(D,l,async(m,h)=>{const t=Date.now(),n=await Promise.resolve(m);n instanceof b.$mK&&(r.push([h.extension,n]),c.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>p&&this.k.warn("SLOW file-participant",h.extension.identifier)}),l.isCancellationRequested||r.length===0)return;const o={edits:[]};for(const[,m]of r){const{edits:h}=A.WorkspaceEdit.from(m,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(h)}return{edit:o,extensionNames:Array.from(c)}}}e.$zcc=I}),define(De[311],Ce([1,0,3,2,6,14,7,33,9]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;class w{static{this.a=0}constructor(y,D){this.extension=y,this.provider=D,this.handle=w.a++}}class R{constructor(y){this.session=y,this.responses=[]}}class I{static{this.a=0}constructor(y,D,p,l){this.f=p,this.g=l,this.b=new Map,this.d=new Map,this.e=y.getProxy(d.$aK.MainThreadInlineChat),D.registerApiCommand(new b.$BM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$zM("Run arguments","",c=>!0,c=>{if(c)return{initialRange:c.initialRange?M.Range.from(c.initialRange):void 0,initialSelection:c.initialSelection?M.Selection.from(c.initialSelection):void 0,message:c.message,autoSend:c.autoSend,position:c.position?M.Position.from(c.position):void 0}})],b.$AM.Void))}registerProvider(y,D,p){const l=new w(y,D);return this.b.set(l.handle,l),this.e.$registerInteractiveEditorProvider(l.handle,p.label,y.identifier.value,typeof D.handleInteractiveEditorResponseFeedback=="function"),(0,C.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(l.handle),this.b.delete(l.handle)})}async $prepareSession(y,D,p,l){const c=this.b.get(y);if(!c){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(F.URI.revive(D)),o=M.Selection.to(p),m=await c.provider.prepareInteractiveEditorSession({document:r,selection:o},l);if(!m)return;if(m.wholeRange&&!m.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=I.a++;return this.d.set(h,new R(m)),{id:h,placeholder:m.placeholder,slashCommands:m.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:M.Range.from(m.wholeRange),message:m.message}}async $provideResponse(y,D,p,l){const c=this.b.get(y);if(!c)return;const r=this.d.get(D.id);if(!r)return;const o={prompt:p.prompt,selection:M.Selection.to(p.selection),wholeRange:M.Range.to(p.wholeRange),attempt:p.attempt,live:p.live};let m=!1;const h={report:async u=>{if(!p.live)throw new Error("Progress reporting is only supported for live sessions");m||l.isCancellationRequested||await this.e.$handleProgressChunk(p.requestId,{message:u.message,edits:u.edits?.map(M.TextEdit.from),slashCommand:u.slashCommand?.command})}},t=Promise.resolve(c.provider.provideInteractiveEditorResponse(r.session,o,h,l));let n;try{n=await(0,E.$Hg)(t,l)}finally{m=!0}if(!n)return;const a=r.responses.push(n)-1,i={wholeRange:M.Range.from(n.wholeRange),placeholder:n.placeholder};if(I.h(n))return{...i,id:a,type:"message",message:M.MarkdownString.from(n.contents)};const{edits:s}=n;return s instanceof A.$mK?{...i,id:a,type:"bulkEdit",edits:M.WorkspaceEdit.from(s)}:{...i,id:a,type:"editorEdit",edits:s.map(M.TextEdit.from)}}$handleFeedback(y,D,p,l){const c=this.b.get(y),r=this.d.get(D),o=r?.responses[p];if(c&&o){const m=M.InteractiveEditorResponseFeedbackKind.to(l);c.provider.handleInteractiveEditorResponseFeedback?.(r.session,o,m)}}$releaseSession(y,D){}static h(y){return typeof y=="object"&&typeof y.contents=="object"}}e.$Gdc=I}),define(De[312],Ce([1,0,2,33]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class d{constructor(A,b,E,w,R){this.a=b,this.b=E,this.c=w;const I=new F.$BM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$zM("showOptions","Show Options",v=>!0,v=>v),new F.$zM("resource","Interactive resource Uri",v=>!0,v=>v),new F.$zM("controllerId","Notebook controller Id",v=>!0,v=>v),new F.$zM("title","Interactive editor title",v=>!0,v=>v)],new F.$AM("Notebook and input URI",v=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const y=this.a.getEditorById(v.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:C.URI.revive(v.notebookUri),inputUri:C.URI.revive(v.inputUri),notebookEditor:y.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:C.URI.revive(v.notebookUri),inputUri:C.URI.revive(v.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(A,b,E,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(C.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Cdc=d}),define(De[313],Ce([1,0,6,7]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class d{constructor(A){this.a=new Map,this.b=A.getProxy(C.$aK.MainThreadIssueReporter)}async $getIssueReporterUri(A,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const w=await E.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}registerIssueUriRequestHandler(A,b){const E=A.identifier.value;return this.a.set(E,b),this.b.$registerIssueUriRequestHandler(E),new F.$cK(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$Idc=d}),define(De[314],Ce([1,0,3,6]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0;class d{constructor(A){this.b=0,this.a=A.getProxy(F.$aK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,A),(0,C.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$Vcc=d}),define(De[315],Ce([1,0,2,24,14,7,82,6,15,34,19,18,165,21,25,3,129,119,107,37,8,9,26,205]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m,h,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;class a{constructor(B,J){this.d=B,this.e=J}async provideDocumentSymbols(B,J){const te=this.d.getDocument(B),se=await this.e.provideDocumentSymbols(te,J);if(!(0,R.$Jb)(se))return se[0]instanceof M.$uK?se.map(d.DocumentSymbol.from):a.f(se)}static f(B){B=B.slice(0).sort((se,Y)=>{let ge=se.location.range.start.compareTo(Y.location.range.start);return ge===0&&(ge=Y.location.range.end.compareTo(se.location.range.end)),ge});const J=[],te=[];for(const se of B){const Y={name:se.name||"!!MISSING: name!!",kind:d.SymbolKind.from(se.kind),tags:se.tags?.map(d.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:d.Range.from(se.location.range),selectionRange:d.Range.from(se.location.range),children:[]};for(;;){if(te.length===0){te.push(Y),J.push(Y);break}const ge=te[te.length-1];if(w.$ps.containsRange(ge.range,Y.range)&&!w.$ps.equalsRange(ge.range,Y.range)){ge.children?.push(Y),te.push(Y);break}te.pop()}}return J}}class i{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,J,te){this.g=B,this.h=J,this.j=te,this.e=new r.$Jbc("CodeLens"),this.f=new Map}async provideCodeLenses(B,J){const te=this.g.getDocument(B),se=await this.j.provideCodeLenses(te,J);if(!se||J.isCancellationRequested)return;const Y=this.e.add(se),ge=new p.$Qc;this.f.set(Y,ge);const ye={cacheId:Y,lenses:[]};for(let je=0;je<se.length;je++)ye.lenses.push({cacheId:[Y,je],range:d.Range.from(se[je].range),command:this.h.toInternal(se[je].command,ge)});return ye}async resolveCodeLens(B,J){const te=B.cacheId&&this.e.get(...B.cacheId);if(!te)return;let se;if(typeof this.j.resolveCodeLens!="function"||te.isResolved?se=te:se=await this.j.resolveCodeLens(te,J),se||(se=te),J.isCancellationRequested)return;const Y=B.cacheId&&this.f.get(B.cacheId[0]);if(Y)return B.command=this.h.toInternal(se.command??i.d,Y),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function s(Pe){return Array.isArray(Pe)?Pe.map(d.DefinitionLink.from):Pe?[d.DefinitionLink.from(Pe)]:[]}class u{constructor(B,J){this.d=B,this.e=J}async provideDefinition(B,J,te){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideDefinition(se,Y,te);return s(ge)}}class S{constructor(B,J){this.d=B,this.e=J}async provideDeclaration(B,J,te){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideDeclaration(se,Y,te);return s(ge)}}class k{constructor(B,J){this.d=B,this.e=J}async provideImplementation(B,J,te){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideImplementation(se,Y,te);return s(ge)}}class ${constructor(B,J){this.d=B,this.e=J}async provideTypeDefinition(B,J,te){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideTypeDefinition(se,Y,te);return s(ge)}}class f{constructor(B,J){this.d=B,this.e=J}async provideHover(B,J,te){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideHover(se,Y,te);if(!(!ge||(0,R.$Jb)(ge.contents)))return ge.range||(ge.range=se.getWordRangeAtPosition(Y)),ge.range||(ge.range=new M.$eK(Y,Y)),d.Hover.from(ge)}}class g{constructor(B,J){this.d=B,this.e=J}async provideEvaluatableExpression(B,J,te){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideEvaluatableExpression(se,Y,te);if(ge)return d.EvaluatableExpression.from(ge)}}class P{constructor(B,J){this.d=B,this.e=J}async provideInlineValues(B,J,te,se){const Y=this.d.getDocument(B),ge=await this.e.provideInlineValues(Y,d.Range.to(J),d.InlineValueContext.to(te),se);if(Array.isArray(ge))return ge.map(ye=>d.InlineValue.from(ye))}}class O{constructor(B,J){this.d=B,this.e=J}async provideDocumentHighlights(B,J,te){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideDocumentHighlights(se,Y,te);if(Array.isArray(ge))return ge.map(d.DocumentHighlight.from)}}class N{constructor(B,J){this.d=B,this.e=J}async provideLinkedEditingRanges(B,J,te){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideLinkedEditingRanges(se,Y,te);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,R.$Gb)(ge.ranges.map(d.Range.from)),wordPattern:ge.wordPattern}}}class L{constructor(B,J){this.d=B,this.e=J}async provideReferences(B,J,te,se){const Y=this.d.getDocument(B),ge=d.Position.to(J),ye=await this.e.provideReferences(Y,ge,te,se);if(Array.isArray(ye))return ye.map(d.location.from)}}class j{static{this.d=1e3}constructor(B,J,te,se,Y,ge,ye){this.g=B,this.h=J,this.j=te,this.k=se,this.l=Y,this.m=ge,this.n=ye,this.e=new r.$Jbc("CodeAction"),this.f=new Map}async provideCodeActions(B,J,te,se){const Y=this.g.getDocument(B),ge=v.$rs.isISelection(J)?d.Selection.to(J):d.Range.to(J),ye=[];for(const et of this.j.getDiagnostics(B))if(ge.intersection(et.range)&&ye.push(et)>j.d)break;const je={diagnostics:ye,only:te.only?new M.$wK(te.only):void 0,triggerKind:d.CodeActionTriggerKind.to(te.trigger)},We=await this.k.provideCodeActions(Y,ge,je,se);if(!(0,R.$Kb)(We)||se.isCancellationRequested)return;const _e=this.e.add(We),Ye=new p.$Qc;this.f.set(_e,Ye);const it=[];for(let et=0;et<We.length;et++){const Ae=We[et];Ae&&(j.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ye)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,et],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(d.Diagnostic.from),edit:Ae.edit&&d.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$_E)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:_e,actions:it}}async resolveCodeAction(B,J){const[te,se]=B,Y=this.e.get(te,se);if(!Y||j.o(Y))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(Y,J)??Y;let ye;ge.edit&&(ye=d.WorkspaceEdit.from(ge.edit,void 0));let je;if(ge.command){const We=this.f.get(te);We&&(je=this.h.toInternal(ge.command,We))}return{edit:ye,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class z{static toInternalProviderId(B,J){return B+"."+J}constructor(B,J,te,se,Y){this.d=B,this.e=J,this.f=te,this.g=se,this.h=Y}async prepareDocumentPaste(B,J,te,se){if(!this.f.prepareDocumentPaste)return;const Y=this.e.getDocument(B),ge=J.map(We=>d.Range.to(We)),ye=d.DataTransfer.toDataTransfer(te,()=>{throw new m.$0});if(await this.f.prepareDocumentPaste(Y,ge,ye,se),se.isCancellationRequested)return;const je=Array.from(ye).filter(([,We])=>!(We instanceof M.$3K));return d.DataTransfer.from(je)}async providePasteEdits(B,J,te,se,Y){if(!this.f.provideDocumentPasteEdits)return;const ge=this.e.getDocument(J),ye=te.map(_e=>d.Range.to(_e)),je=d.DataTransfer.toDataTransfer(se,async _e=>(await this.d.$resolvePasteFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentPasteEdits(ge,ye,je,Y);if(We)return{label:We.label??(0,n.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:z.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class T{constructor(B,J){this.d=B,this.e=J}async provideDocumentFormattingEdits(B,J,te){const se=this.d.getDocument(B),Y=await this.e.provideDocumentFormattingEdits(se,J,te);if(Array.isArray(Y))return Y.map(d.TextEdit.from)}}class K{constructor(B,J){this.d=B,this.e=J}async provideDocumentRangeFormattingEdits(B,J,te,se){const Y=this.d.getDocument(B),ge=d.Range.to(J),ye=await this.e.provideDocumentRangeFormattingEdits(Y,ge,te,se);if(Array.isArray(ye))return ye.map(d.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,J,te,se){(0,I.$Hf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Y=this.d.getDocument(B),ge=J.map(d.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(Y,ge,te,se);if(Array.isArray(ye))return ye.map(d.TextEdit.from)}}class V{constructor(B,J){this.d=B,this.e=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,J,te,se,Y){const ge=this.d.getDocument(B),ye=d.Position.to(J),je=await this.e.provideOnTypeFormattingEdits(ge,ye,te,se,Y);if(Array.isArray(je))return je.map(d.TextEdit.from)}}class fe{constructor(B,J){this.e=B,this.f=J,this.d=new r.$Jbc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,J){const te=await this.e.provideWorkspaceSymbols(B,J);if(!(0,R.$Kb)(te))return{symbols:[]};const se=this.d.add(te),Y={cacheId:se,symbols:[]};for(let ge=0;ge<te.length;ge++){const ye=te[ge];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Y.symbols.push({...d.WorkspaceSymbol.from(ye),cacheId:[se,ge]})}return Y}async resolveWorkspaceSymbol(B,J){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const te=this.d.get(...B.cacheId);if(te){const se=await this.e.resolveWorkspaceSymbol(te,J);return se&&(0,F.$6m)(B,d.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class X{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,J,te){this.d=B,this.e=J,this.f=te}async provideRenameEdits(B,J,te,se){const Y=this.d.getDocument(B),ge=d.Position.to(J);try{const ye=await this.e.provideRenameEdits(Y,ge,te,se);return ye?d.WorkspaceEdit.from(ye):void 0}catch(ye){const je=X.g(ye);return je?{rejectReason:je,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,J,te){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const se=this.d.getDocument(B),Y=d.Position.to(J);try{const ge=await this.e.prepareRename(se,Y,te);let ye,je;if(M.$eK.isRange(ge)?(ye=ge,je=se.getText(ge)):(0,I.$zf)(ge)&&(ye=ge.range,je=ge.placeholder),!ye||!je)return;if(ye.start.line>Y.line||ye.end.line<Y.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:d.Range.from(ye),text:je}}catch(ge){const ye=X.g(ge);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(ge)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Q{constructor(B,J){this.resultId=B,this.tokens=J}}class Z{constructor(B,J){this.f=B,this.g=J,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,J,te){const se=this.f.getDocument(B),Y=J!==0?this.d.get(J):null;let ge=typeof Y?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(se,Y.resultId,te):await this.g.provideDocumentSemanticTokens(se,te);return Y&&this.d.delete(J),ge?(ge=Z.h(ge),this.o(Z.n(Y,ge),ge)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return Z.j(B)?Z.k(B)?B:new M.$tL(new Uint32Array(B.data),B.resultId):Z.l(B)?Z.m(B)?B:new M.$vL(B.edits.map(J=>new M.$uL(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const J of B.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static n(B,J){if(!Z.j(J)||!B||!B.tokens)return J;const te=B.tokens,se=te.length,Y=J.data,ge=Y.length;let ye=0;const je=Math.min(se,ge);for(;ye<je&&te[ye]===Y[ye];)ye++;if(ye===se&&ye===ge)return new M.$vL([],J.resultId);let We=0;const _e=je-ye;for(;We<_e&&te[se-We-1]===Y[ge-We-1];)We++;return new M.$vL([{start:ye,deleteCount:se-ye-We,data:Y.subarray(ye,ge-We)}],J.resultId)}o(B,J){if(Z.j(B)){const te=this.e++;return this.d.set(te,new Q(B.resultId,B.data)),(0,l.$Q0)({id:te,type:"full",data:B.data})}if(Z.l(B)){const te=this.e++;return Z.j(J)?this.d.set(te,new Q(J.resultId,J.data)):this.d.set(te,new Q(B.resultId)),(0,l.$Q0)({id:te,type:"delta",deltas:(B.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}class oe{constructor(B,J){this.d=B,this.e=J}async provideDocumentRangeSemanticTokens(B,J,te){const se=this.d.getDocument(B),Y=await this.e.provideDocumentRangeSemanticTokens(se,d.Range.to(J),te);return Y?this.f(Y):null}f(B){return(0,l.$Q0)({id:0,type:"full",data:B.data})}}class x{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,J,te,se,Y){this.f=B,this.g=J,this.h=te,this.j=se,this.k=Y,this.d=new r.$Jbc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,J,te,se){const Y=this.f.getDocument(B),ge=d.Position.to(J),ye=Y.getWordRangeAtPosition(ge)||new M.$eK(ge,ge),je=ye.with({end:ge}),We=new o.$Id,_e=await this.h.provideCompletionItems(Y,ge,se,d.CompletionContext.to(te));if(!_e||se.isCancellationRequested)return;const Ye=Array.isArray(_e)?new M.$JK(_e):_e,it=x.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),et=new p.$Qc;this.e.set(it,et);const Ae=[],Oe={x:it,b:Ae,a:{replace:d.Range.from(ye),insert:d.Range.from(je)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let qe=0;qe<Ye.items.length;qe++){const Me=Ye.items[qe],Ze=this.l(Me,[it,qe],je,ye);Ae.push(Ze)}return Oe}async resolveCompletionItem(B,J){if(typeof this.h.resolveCompletionItem!="function")return;const te=this.d.get(...B);if(!te)return;const se=this.l(te,B),Y=await this.h.resolveCompletionItem(te,J);if(!Y)return;const ge=this.l(Y,B);return(se.h!==ge.h||se.i!==ge.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(se.n!==ge.n||se.o!==ge.o||!(0,F.$7m)(se.p,ge.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...se,d:ge.d,c:ge.c,l:ge.l,h:ge.h,i:ge.i,n:ge.n,o:ge.o,p:ge.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,J,te,se){const Y=this.e.get(J[0]);if(!Y)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(B.command,Y),ye={x:J,a:B.label,b:B.kind!==void 0?d.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(d.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:d.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(d.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof M.$nK&&(ye.h=B.insertText.value,ye.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),M.$eK.isRange(je)?ye.j=d.Range.from(je):je&&(!te?.isEqual(je.inserting)||!se?.isEqual(je.replacing))&&(ye.j={insert:d.Range.from(je.inserting),replace:d.Range.from(je.replacing)}),ye}}class ae{async provideInlineCompletions(B,J,te,se){}disposeCompletions(B){}handleDidShowCompletionItem(B,J,te){}handlePartialAccept(B,J,te){}}class ve extends ae{constructor(B,J,te,se){super(),this.f=B,this.g=J,this.h=te,this.j=se,this.d=new G,this.e=(0,t.$_E)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$_E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,J,te,se){const Y=this.g.getDocument(B),ge=d.Position.to(J),ye=await this.h.provideInlineCompletionItems(Y,ge,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:d.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[te.triggerKind]},se);if(!ye||se.isCancellationRequested)return;const je=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],_e=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:je}),items:je.map((et,Ae)=>{let Oe;et.command&&(Ye||(Ye=new p.$Qc),Oe=this.j.toInternal(et.command,Ye));const qe=et.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:et.filterText,range:et.range?d.Range.from(et.range):void 0,command:Oe,idx:Ae,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:We.map(et=>(Ye||(Ye=new p.$Qc),this.j.toInternal(et,Ye))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,J,te){const se=this.d.get(B)?.items[J];se&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(se,te)}handlePartialAccept(B,J,te){const se=this.d.get(B)?.items[J];se&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(se,te)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const J=this.e++;return this.d.set(J,B),J}disposeReferenceId(B){const J=this.d.get(B);return this.d.delete(B),J}get(B){return this.d.get(B)}}class U{constructor(B,J){this.e=B,this.f=J,this.d=new r.$Jbc("SignatureHelp")}async provideSignatureHelp(B,J,te,se){const Y=this.e.getDocument(B),ge=d.Position.to(J),ye=this.g(te),je=await this.f.provideSignatureHelp(Y,ge,se,ye);if(je){const We=this.d.add([je]);return{...d.SignatureHelp.from(je),id:We}}}g(B){let J;if(B.activeSignatureHelp){const te=d.SignatureHelp.to(B.activeSignatureHelp),se=this.d.get(B.activeSignatureHelp.id,0);se?(J=se,J.activeSignature=te.activeSignature,J.activeParameter=te.activeParameter):J=te}return{...B,activeSignatureHelp:J}}releaseSignatureHelp(B){this.d.delete(B)}}class q{constructor(B,J,te,se,Y){this.f=B,this.g=J,this.h=te,this.j=se,this.k=Y,this.d=new r.$Jbc("InlayHints"),this.e=new Map}async provideInlayHints(B,J,te){const se=this.f.getDocument(B),Y=d.Range.to(J),ge=await this.h.provideInlayHints(se,Y,te);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${J}`);return}if(te.isCancellationRequested)return;const ye=this.d.add(ge);this.e.set(ye,new p.$Qc);const je={hints:[],cacheId:ye};for(let We=0;We<ge.length;We++)this.l(ge[We],Y)&&je.hints.push(this.m(ge[We],[ye,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${J}`),je}async resolveInlayHint(B,J){if(typeof this.h.resolveInlayHint!="function")return;const te=this.d.get(...B);if(!te)return;const se=await this.h.resolveInlayHint(te,J);if(se&&this.l(se))return this.m(se,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,J){return B.label.length===0||Array.isArray(B.label)&&B.label.every(te=>te.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(J&&!J.contains(B.position))}m(B,J){const te=this.e.get(J[0]);if(!te)throw Error("DisposableStore is missing...");const se={label:"",cacheId:J,tooltip:d.MarkdownString.fromStrict(B.tooltip),position:d.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(d.TextEdit.from),kind:B.kind&&d.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?se.label=B.label:se.label=B.label.map(Y=>{const ge={label:Y.value};return ge.tooltip=d.MarkdownString.fromStrict(Y.tooltip),M.$oK.isLocation(Y.location)&&(ge.location=d.location.from(Y.location)),Y.command&&(ge.command=this.g.toInternal(Y.command,te)),ge}),se}}class me{constructor(B,J){this.e=B,this.f=J,this.d=new r.$Jbc("DocumentLink")}async provideLinks(B,J){const te=this.e.getDocument(B),se=await this.f.provideDocumentLinks(te,J);if(!(!Array.isArray(se)||se.length===0)&&!J.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:se.filter(me.g).map(d.DocumentLink.from)};{const Y=this.d.add(se),ge={links:[],cacheId:Y};for(let ye=0;ye<se.length;ye++){if(!me.g(se[ye]))continue;const je=d.DocumentLink.from(se[ye]);je.cacheId=[Y,ye],ge.links.push(je)}return ge}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,J){if(typeof this.f.resolveDocumentLink!="function")return;const te=this.d.get(...B);if(!te)return;const se=await this.f.resolveDocumentLink(te,J);if(!(!se||!me.g(se)))return d.DocumentLink.from(se)}releaseLinks(B){this.d.delete(B)}}class _{constructor(B,J){this.d=B,this.e=J}async provideColors(B,J){const te=this.d.getDocument(B),se=await this.e.provideDocumentColors(te,J);return Array.isArray(se)?se.map(ge=>({color:d.Color.from(ge.color),range:d.Range.from(ge.range)})):[]}async provideColorPresentations(B,J,te){const se=this.d.getDocument(B),Y=d.Range.to(J.range),ge=d.Color.to(J.color),ye=await this.e.provideColorPresentations(ge,{document:se,range:Y},te);if(Array.isArray(ye))return ye.map(d.ColorPresentation.from)}}class ie{constructor(B,J){this.d=B,this.e=J}async provideFoldingRanges(B,J,te){const se=this.d.getDocument(B),Y=await this.e.provideFoldingRanges(se,J,te);if(Array.isArray(Y))return Y.map(d.FoldingRange.from)}}class re{constructor(B,J,te){this.d=B,this.e=J,this.f=te}async provideSelectionRanges(B,J,te){const se=this.d.getDocument(B),Y=J.map(d.Position.to),ge=await this.e.provideSelectionRanges(se,Y,te);if(!(0,R.$Kb)(ge))return[];if(ge.length!==Y.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let je=0;je<Y.length;je++){const We=[];ye.push(We);let _e=Y[je],Ye=ge[je];for(;;){if(!Ye.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(d.SelectionRange.from(Ye)),!Ye.parent)break;_e=Ye.range,Ye=Ye.parent}}return ye}}class Ee{constructor(B,J){this.f=B,this.g=J,this.d=new c.$gM(""),this.e=new Map}async prepareSession(B,J,te){const se=this.f.getDocument(B),Y=d.Position.to(J),ge=await this.g.prepareCallHierarchy(se,Y,te);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(je=>this.h(ye,je)):[this.h(ye,ge)]}async provideCallsTo(B,J,te){const se=this.j(B,J);if(!se)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyIncomingCalls(se,te);if(Y)return Y.map(ge=>({from:this.h(B,ge.from),fromRanges:ge.fromRanges.map(ye=>d.Range.from(ye))}))}async provideCallsFrom(B,J,te){const se=this.j(B,J);if(!se)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyOutgoingCalls(se,te);if(Y)return Y.map(ge=>({to:this.h(B,ge.to),fromRanges:ge.fromRanges.map(ye=>d.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,J){const te=this.e.get(B),se=d.CallHierarchyItem.from(J,B,te.size.toString(36));return te.set(se._itemId,J),se}j(B,J){return this.e.get(B)?.get(J)}}class ce{constructor(B,J){this.f=B,this.g=J,this.d=new c.$gM(""),this.e=new Map}async prepareSession(B,J,te){const se=this.f.getDocument(B),Y=d.Position.to(J),ge=await this.g.prepareTypeHierarchy(se,Y,te);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(je=>this.h(ye,je)):[this.h(ye,ge)]}async provideSupertypes(B,J,te){const se=this.j(B,J);if(!se)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySupertypes(se,te);if(Y)return Y.map(ge=>this.h(B,ge))}async provideSubtypes(B,J,te){const se=this.j(B,J);if(!se)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySubtypes(se,te);if(Y)return Y.map(ge=>this.h(B,ge))}releaseSession(B){this.e.delete(B)}h(B,J){const te=this.e.get(B),se=d.TypeHierarchyItem.from(J,B,te.size.toString(36));return te.set(se._itemId,J),se}j(B,J){return this.e.get(B)?.get(J)}}class de{static toInternalProviderId(B,J){return B+"."+J}constructor(B,J,te,se,Y){this.d=B,this.e=J,this.f=te,this.g=se,this.h=Y}async provideDocumentOnDropEdits(B,J,te,se,Y){const ge=this.e.getDocument(J),ye=d.Position.to(te),je=d.DataTransfer.toDataTransfer(se,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentDropEdits(ge,ye,je,Y);if(We)return{label:We.label??(0,n.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:de.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ee{constructor(B,J){this.d=B,this.e=J}async provideMappedEdits(B,J,te,se){const Y=C.URI.revive(B),ge=this.d.getDocument(Y),ye=te.documents.map(_e=>_e.map(Ye=>({uri:C.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(it=>d.Range.to(it))}))),je={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(ge,J,je,se);return We?d.WorkspaceEdit.from(We):null}}class he{constructor(B,J){this.adapter=B,this.extension=J}}class be{static{this.d=0}constructor(B,J,te,se,Y,ge,ye,je){this.g=J,this.h=te,this.j=se,this.k=Y,this.l=ge,this.m=ye,this.n=je,this.f=new Map,this.e=B.getProxy(b.$aK.MainThreadLanguageFeatures)}o(B,J){return d.DocumentSelector.from(B,this.g,J)}p(B){return new M.$cK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return be.d++}async s(B,J,te,se,Y,ge=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof J))return se;const je=Date.now();ge||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${te.toString().replace(/[\r\n]/g,"")}'`);const We=te(ye.adapter,ye.extension);return Promise.resolve(We).catch(_e=>{(0,m.$3)(_e)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(ye.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),y.CancellationToken.isCancellationToken(Y)?(0,h.$Ig)(We,Y):We}t(B,J){const te=this.q();return this.f.set(te,new he(B,J)),te}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,J,te,se){const Y=this.t(new a(this.h,te),B),ge=se&&se.label||be.u(B);return this.e.$registerDocumentSymbolProvider(Y,this.o(J,B),ge),this.p(Y)}$provideDocumentSymbols(B,J,te){return this.s(B,a,se=>se.provideDocumentSymbols(C.URI.revive(J),te),void 0,te)}registerCodeLensProvider(B,J,te){const se=this.q(),Y=typeof te.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(se,new he(new i(this.h,this.j.converter,te),B)),this.e.$registerCodeLensSupport(se,this.o(J,B),Y);let ge=this.p(se);if(Y!==void 0){const ye=te.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(Y));ge=M.$cK.from(ge,ye)}return ge}$provideCodeLenses(B,J,te){return this.s(B,i,se=>se.provideCodeLenses(C.URI.revive(J),te),void 0,te)}$resolveCodeLens(B,J,te){return this.s(B,i,se=>se.resolveCodeLens(J,te),void 0,void 0)}$releaseCodeLenses(B,J){this.s(B,i,te=>Promise.resolve(te.releaseCodeLenses(J)),void 0,void 0)}registerDefinitionProvider(B,J,te){const se=this.t(new u(this.h,te),B);return this.e.$registerDefinitionSupport(se,this.o(J,B)),this.p(se)}$provideDefinition(B,J,te,se){return this.s(B,u,Y=>Y.provideDefinition(C.URI.revive(J),te,se),[],se)}registerDeclarationProvider(B,J,te){const se=this.t(new S(this.h,te),B);return this.e.$registerDeclarationSupport(se,this.o(J,B)),this.p(se)}$provideDeclaration(B,J,te,se){return this.s(B,S,Y=>Y.provideDeclaration(C.URI.revive(J),te,se),[],se)}registerImplementationProvider(B,J,te){const se=this.t(new k(this.h,te),B);return this.e.$registerImplementationSupport(se,this.o(J,B)),this.p(se)}$provideImplementation(B,J,te,se){return this.s(B,k,Y=>Y.provideImplementation(C.URI.revive(J),te,se),[],se)}registerTypeDefinitionProvider(B,J,te){const se=this.t(new $(this.h,te),B);return this.e.$registerTypeDefinitionSupport(se,this.o(J,B)),this.p(se)}$provideTypeDefinition(B,J,te,se){return this.s(B,$,Y=>Y.provideTypeDefinition(C.URI.revive(J),te,se),[],se)}registerHoverProvider(B,J,te,se){const Y=this.t(new f(this.h,te),B);return this.e.$registerHoverProvider(Y,this.o(J,B)),this.p(Y)}$provideHover(B,J,te,se){return this.s(B,f,Y=>Y.provideHover(C.URI.revive(J),te,se),void 0,se)}registerEvaluatableExpressionProvider(B,J,te,se){const Y=this.t(new g(this.h,te),B);return this.e.$registerEvaluatableExpressionProvider(Y,this.o(J,B)),this.p(Y)}$provideEvaluatableExpression(B,J,te,se){return this.s(B,g,Y=>Y.provideEvaluatableExpression(C.URI.revive(J),te,se),void 0,se)}registerInlineValuesProvider(B,J,te,se){const Y=typeof te.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new P(this.h,te),B);this.e.$registerInlineValuesProvider(ge,this.o(J,B),Y);let ye=this.p(ge);if(Y!==void 0){const je=te.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Y));ye=M.$cK.from(ye,je)}return ye}$provideInlineValues(B,J,te,se,Y){return this.s(B,P,ge=>ge.provideInlineValues(C.URI.revive(J),te,se,Y),void 0,Y)}registerDocumentHighlightProvider(B,J,te){const se=this.t(new O(this.h,te),B);return this.e.$registerDocumentHighlightProvider(se,this.o(J,B)),this.p(se)}$provideDocumentHighlights(B,J,te,se){return this.s(B,O,Y=>Y.provideDocumentHighlights(C.URI.revive(J),te,se),void 0,se)}registerLinkedEditingRangeProvider(B,J,te){const se=this.t(new N(this.h,te),B);return this.e.$registerLinkedEditingRangeProvider(se,this.o(J,B)),this.p(se)}$provideLinkedEditingRanges(B,J,te,se){return this.s(B,N,async Y=>{const ge=await Y.provideLinkedEditingRanges(C.URI.revive(J),te,se);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?be.w(ge.wordPattern):void 0}},void 0,se)}registerReferenceProvider(B,J,te){const se=this.t(new L(this.h,te),B);return this.e.$registerReferenceSupport(se,this.o(J,B)),this.p(se)}$provideReferences(B,J,te,se,Y){return this.s(B,L,ge=>ge.provideReferences(C.URI.revive(J),te,se,Y),void 0,Y)}registerCodeActionProvider(B,J,te,se){const Y=new p.$Qc,ge=this.t(new j(this.h,this.j.converter,this.k,te,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(ge,this.o(J,B),{providedKinds:se?.providedCodeActionKinds?.map(ye=>ye.value),documentation:se?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Y)}))},be.u(B),!!te.resolveCodeAction),Y.add(this.p(ge)),Y}$provideCodeActions(B,J,te,se,Y){return this.s(B,j,ge=>ge.provideCodeActions(C.URI.revive(J),te,se,Y),void 0,Y)}$resolveCodeAction(B,J,te){return this.s(B,j,se=>se.resolveCodeAction(J,te),{},void 0)}$releaseCodeActions(B,J){this.s(B,j,te=>Promise.resolve(te.releaseCodeActions(J)),void 0,void 0)}registerDocumentFormattingEditProvider(B,J,te){const se=this.t(new T(this.h,te),B);return this.e.$registerDocumentFormattingSupport(se,this.o(J,B),B.identifier,B.displayName||B.name),this.p(se)}$provideDocumentFormattingEdits(B,J,te,se){return this.s(B,T,Y=>Y.provideDocumentFormattingEdits(C.URI.revive(J),te,se),void 0,se)}registerDocumentRangeFormattingEditProvider(B,J,te){const se=typeof te.provideDocumentRangesFormattingEdits=="function",Y=this.t(new K(this.h,te),B);return this.e.$registerRangeFormattingSupport(Y,this.o(J,B),B.identifier,B.displayName||B.name,se),this.p(Y)}$provideDocumentRangeFormattingEdits(B,J,te,se,Y){return this.s(B,K,ge=>ge.provideDocumentRangeFormattingEdits(C.URI.revive(J),te,se,Y),void 0,Y)}$provideDocumentRangesFormattingEdits(B,J,te,se,Y){return this.s(B,K,ge=>ge.provideDocumentRangesFormattingEdits(C.URI.revive(J),te,se,Y),void 0,Y)}registerOnTypeFormattingEditProvider(B,J,te,se){const Y=this.t(new V(this.h,te),B);return this.e.$registerOnTypeFormattingSupport(Y,this.o(J,B),se,B.identifier),this.p(Y)}$provideOnTypeFormattingEdits(B,J,te,se,Y,ge){return this.s(B,V,ye=>ye.provideOnTypeFormattingEdits(C.URI.revive(J),te,se,Y,ge),void 0,ge)}registerWorkspaceSymbolProvider(B,J){const te=this.t(new fe(J,this.l),B);return this.e.$registerNavigateTypeSupport(te,typeof J.resolveWorkspaceSymbol=="function"),this.p(te)}$provideWorkspaceSymbols(B,J,te){return this.s(B,fe,se=>se.provideWorkspaceSymbols(J,te),{symbols:[]},te)}$resolveWorkspaceSymbol(B,J,te){return this.s(B,fe,se=>se.resolveWorkspaceSymbol(J,te),void 0,void 0)}$releaseWorkspaceSymbols(B,J){this.s(B,fe,te=>te.releaseWorkspaceSymbols(J),void 0,void 0)}registerRenameProvider(B,J,te){const se=this.t(new X(this.h,te,this.l),B);return this.e.$registerRenameSupport(se,this.o(J,B),X.supportsResolving(te)),this.p(se)}$provideRenameEdits(B,J,te,se,Y){return this.s(B,X,ge=>ge.provideRenameEdits(C.URI.revive(J),te,se,Y),void 0,Y)}$resolveRenameLocation(B,J,te,se){return this.s(B,X,Y=>Y.resolveRenameLocation(C.URI.revive(J),te,se),void 0,se)}registerDocumentSemanticTokensProvider(B,J,te,se){const Y=this.t(new Z(this.h,te),B),ge=typeof te.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Y,this.o(J,B),se,ge);let ye=this.p(Y);if(ge){const je=te.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(ge));ye=M.$cK.from(ye,je)}return ye}$provideDocumentSemanticTokens(B,J,te,se){return this.s(B,Z,Y=>Y.provideDocumentSemanticTokens(C.URI.revive(J),te,se),null,se)}$releaseDocumentSemanticTokens(B,J){this.s(B,Z,te=>te.releaseDocumentSemanticColoring(J),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,J,te,se){const Y=this.t(new oe(this.h,te),B);return this.e.$registerDocumentRangeSemanticTokensProvider(Y,this.o(J,B),se),this.p(Y)}$provideDocumentRangeSemanticTokens(B,J,te,se){return this.s(B,oe,Y=>Y.provideDocumentRangeSemanticTokens(C.URI.revive(J),te,se),null,se)}registerCompletionItemProvider(B,J,te,se){const Y=this.t(new x(this.h,this.j.converter,te,this.m,B),B);return this.e.$registerCompletionsProvider(Y,this.o(J,B),se,x.supportsResolving(te),B.identifier),this.p(Y)}$provideCompletionItems(B,J,te,se,Y){return this.s(B,x,ge=>ge.provideCompletionItems(C.URI.revive(J),te,se,Y),void 0,Y)}$resolveCompletionItem(B,J,te){return this.s(B,x,se=>se.resolveCompletionItem(J,te),void 0,te)}$releaseCompletionItems(B,J){this.s(B,x,te=>te.releaseCompletionItems(J),void 0,void 0)}registerInlineCompletionsProvider(B,J,te,se){const Y=new ve(B,this.h,te,this.j.converter),ge=this.t(Y,B);return this.e.$registerInlineCompletionsSupport(ge,this.o(J,B),Y.supportsHandleEvents,D.$3l.toKey(B.identifier.value),se?.yieldTo?.map(ye=>D.$3l.toKey(ye))||[]),this.p(ge)}$provideInlineCompletions(B,J,te,se,Y){return this.s(B,ae,ge=>ge.provideInlineCompletions(C.URI.revive(J),te,se,Y),void 0,Y)}$handleInlineCompletionDidShow(B,J,te,se){this.s(B,ae,async Y=>{Y.handleDidShowCompletionItem(J,te,se)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,J,te,se){this.s(B,ae,async Y=>{Y.handlePartialAccept(J,te,se)},void 0,void 0)}$freeInlineCompletionsList(B,J){this.s(B,ae,async te=>{te.disposeCompletions(J)},void 0,void 0)}registerSignatureHelpProvider(B,J,te,se){const Y=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,ge=this.t(new U(this.h,te),B);return this.e.$registerSignatureHelpProvider(ge,this.o(J,B),Y),this.p(ge)}$provideSignatureHelp(B,J,te,se,Y){return this.s(B,U,ge=>ge.provideSignatureHelp(C.URI.revive(J),te,se,Y),void 0,Y)}$releaseSignatureHelp(B,J){this.s(B,U,te=>te.releaseSignatureHelp(J),void 0,void 0)}registerInlayHintsProvider(B,J,te){const se=typeof te.onDidChangeInlayHints=="function"?this.q():void 0,Y=this.t(new q(this.h,this.j.converter,te,this.l,B),B);this.e.$registerInlayHintsProvider(Y,this.o(J,B),typeof te.resolveInlayHint=="function",se,be.u(B));let ge=this.p(Y);if(se!==void 0){const ye=te.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(se));ge=M.$cK.from(ge,ye)}return ge}$provideInlayHints(B,J,te,se){return this.s(B,q,Y=>Y.provideInlayHints(C.URI.revive(J),te,se),void 0,se)}$resolveInlayHint(B,J,te){return this.s(B,q,se=>se.resolveInlayHint(J,te),void 0,te)}$releaseInlayHints(B,J){this.s(B,q,te=>te.releaseHints(J),void 0,void 0)}registerDocumentLinkProvider(B,J,te){const se=this.t(new me(this.h,te),B);return this.e.$registerDocumentLinkProvider(se,this.o(J,B),typeof te.resolveDocumentLink=="function"),this.p(se)}$provideDocumentLinks(B,J,te){return this.s(B,me,se=>se.provideLinks(C.URI.revive(J),te),void 0,te,J.scheme==="output")}$resolveDocumentLink(B,J,te){return this.s(B,me,se=>se.resolveLink(J,te),void 0,void 0,!0)}$releaseDocumentLinks(B,J){this.s(B,me,te=>te.releaseLinks(J),void 0,void 0,!0)}registerColorProvider(B,J,te){const se=this.t(new _(this.h,te),B);return this.e.$registerDocumentColorProvider(se,this.o(J,B)),this.p(se)}$provideDocumentColors(B,J,te){return this.s(B,_,se=>se.provideColors(C.URI.revive(J),te),[],te)}$provideColorPresentations(B,J,te,se){return this.s(B,_,Y=>Y.provideColorPresentations(C.URI.revive(J),te,se),void 0,se)}registerFoldingRangeProvider(B,J,te){const se=this.q(),Y=typeof te.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(se,new he(new ie(this.h,te),B)),this.e.$registerFoldingRangeProvider(se,this.o(J,B),B.identifier,Y);let ge=this.p(se);if(Y!==void 0){const ye=te.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Y));ge=M.$cK.from(ge,ye)}return ge}$provideFoldingRanges(B,J,te,se){return this.s(B,ie,Y=>Y.provideFoldingRanges(C.URI.revive(J),te,se),void 0,se)}registerSelectionRangeProvider(B,J,te){const se=this.t(new re(this.h,te,this.l),B);return this.e.$registerSelectionRangeProvider(se,this.o(J,B)),this.p(se)}$provideSelectionRanges(B,J,te,se){return this.s(B,re,Y=>Y.provideSelectionRanges(C.URI.revive(J),te,se),[],se)}registerCallHierarchyProvider(B,J,te){const se=this.t(new Ee(this.h,te),B);return this.e.$registerCallHierarchyProvider(se,this.o(J,B)),this.p(se)}$prepareCallHierarchy(B,J,te,se){return this.s(B,Ee,Y=>Promise.resolve(Y.prepareSession(C.URI.revive(J),te,se)),void 0,se)}$provideCallHierarchyIncomingCalls(B,J,te,se){return this.s(B,Ee,Y=>Y.provideCallsTo(J,te,se),void 0,se)}$provideCallHierarchyOutgoingCalls(B,J,te,se){return this.s(B,Ee,Y=>Y.provideCallsFrom(J,te,se),void 0,se)}$releaseCallHierarchy(B,J){this.s(B,Ee,te=>Promise.resolve(te.releaseSession(J)),void 0,void 0)}registerTypeHierarchyProvider(B,J,te){const se=this.t(new ce(this.h,te),B);return this.e.$registerTypeHierarchyProvider(se,this.o(J,B)),this.p(se)}$prepareTypeHierarchy(B,J,te,se){return this.s(B,ce,Y=>Promise.resolve(Y.prepareSession(C.URI.revive(J),te,se)),void 0,se)}$provideTypeHierarchySupertypes(B,J,te,se){return this.s(B,ce,Y=>Y.provideSupertypes(J,te,se),void 0,se)}$provideTypeHierarchySubtypes(B,J,te,se){return this.s(B,ce,Y=>Y.provideSubtypes(J,te,se),void 0,se)}$releaseTypeHierarchy(B,J){this.s(B,ce,te=>Promise.resolve(te.releaseSession(J)),void 0,void 0)}registerDocumentOnDropEditProvider(B,J,te,se){const Y=this.q();this.f.set(Y,new he(new de(this.e,this.h,te,Y,B),B));const ge=(0,t.$_E)(B,"dropMetadata")&&se?de.toInternalProviderId(B.identifier.value,se.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Y,this.o(J,B),ge,(0,t.$_E)(B,"dropMetadata")?se:void 0),this.p(Y)}$provideDocumentOnDropEdits(B,J,te,se,Y,ge){return this.s(B,de,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(J,C.URI.revive(te),se,Y,ge)),void 0,void 0)}registerMappedEditsProvider(B,J,te){const se=this.t(new ee(this.h,te),B);return this.e.$registerMappedEditsProvider(se,this.o(J,B)),this.p(se)}$provideMappedEdits(B,J,te,se,Y){return this.s(B,ee,ge=>Promise.resolve(ge.provideMappedEdits(J,te,se,Y)),null,Y)}registerDocumentPasteEditProvider(B,J,te,se){const Y=this.q();this.f.set(Y,new he(new z(this.e,this.h,te,Y,B),B));const ge=z.toInternalProviderId(B.identifier.value,se.id);return this.e.$registerPasteEditProvider(Y,this.o(J,B),ge,{supportsCopy:!!te.prepareDocumentPaste,supportsPaste:!!te.provideDocumentPasteEdits,copyMimeTypes:se.copyMimeTypes,pasteMimeTypes:se.pasteMimeTypes}),this.p(Y)}$prepareDocumentPaste(B,J,te,se,Y){return this.s(B,z,ge=>ge.prepareDocumentPaste(C.URI.revive(J),te,se,Y),void 0,Y)}$providePasteEdits(B,J,te,se,Y,ge){return this.s(B,z,ye=>ye.providePasteEdits(J,C.URI.revive(te),se,Y,ge),void 0,ge)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:be.w(B.decreaseIndentPattern),increaseIndentPattern:be.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?be.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?be.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:be.w(B.beforeText),afterText:B.afterText?be.w(B.afterText):void 0,previousLineText:B.previousLineText?be.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(be.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(J=>M.SyntaxTokenType.toString(J)):void 0}}static D(B){return B.map(be.C)}setLanguageConfiguration(B,J,te){const{wordPattern:se}=te;if(se&&(0,E.$Ne)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this.h.setWordDefinitionFor(J,se):this.h.setWordDefinitionFor(J,void 0),te.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),te.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const Y=this.q(),ge={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?be.w(te.wordPattern):void 0,indentationRules:te.indentationRules?be.y(te.indentationRules):void 0,onEnterRules:te.onEnterRules?be.B(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport,autoClosingPairs:te.autoClosingPairs?be.D(te.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Y,J,ge),this.p(Y)}$setWordDefinitions(B){for(const J of B)this.h.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.$Sbc=be}),define(De[316],Ce([1,0,6,14,7,38,9,3,26]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;class w{constructor(I,v,y,D){this.c=v,this.d=y,this.e=D,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(C.$aK.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,v){await this.a.$changeLanguage(I,v);const y=this.c.getDocumentData(I);if(!y)throw new Error(`document '${I.toString()}' NOT found`);return y.document}async tokenAtPosition(I,v){const y=I.version,D=F.Position.from(v),p=await this.a.$tokensAtPosition(I.uri,D),l={type:d.StandardTokenType.Other,range:I.getWordRangeAtPosition(v)??new d.$eK(v.line,v.character,v.line,v.character)};if(!p)return l;const c={range:F.Range.to(p.range),type:F.TokenType.to(p.type)};return!c.range.contains(v)||y!==I.version?l:c}createLanguageStatusItem(I,v,y){const D=this.f++,p=this.a,l=this.g,c=`${I.identifier.value}/${v}`;if(l.has(c))throw new Error(`LanguageStatusItem with id '${v}' ALREADY exists`);l.add(c);const r={selector:y,id:v,name:I.displayName??I.name,severity:d.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const m=new b.$Qc,h=()=>{if(o?.dispose(),!l.has(c)){console.warn(`LanguageStatusItem (${v}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,A.$Ug)(()=>{m.clear(),this.a.$setLanguageStatus(D,{id:c,name:r.name??I.displayName??I.name,source:I.displayName??I.name,selector:F.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===d.LanguageStatusSeverity.Error?M.default.Error:r.severity===d.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:r.command&&this.d.toInternal(r.command,m),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},t={dispose(){m.dispose(),o?.dispose(),p.$removeLanguageStatus(D),l.delete(c)},get id(){return r.id},get name(){return r.name},set name(n){r.name=n,h()},get selector(){return r.selector},set selector(n){r.selector=n,h()},get text(){return r.text},set text(n){r.text=n,h()},set text2(n){(0,E.$aF)(I,"languageStatusText"),r.text=n,h()},get text2(){return(0,E.$aF)(I,"languageStatusText"),r.text},get detail(){return r.detail},set detail(n){r.detail=n,h()},get severity(){return r.severity},set severity(n){r.severity=n,h()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(n){r.accessibilityInformation=n,h()},get command(){return r.command},set command(n){r.command=n,h()},get busy(){return r.busy},set busy(n){r.busy=n,h()}};return h(),t}}e.$Acc=w}),define(De[112],Ce([1,0,12,15,2,5,13,6,27,20]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=e.$pcc=void 0;let R=class{constructor(v,y,D){this.f=D,this.d=new Map,this.a=y.getProxy(b.$aK.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===C.$g}getMessage(v,y){const{message:D,args:p,comment:l}=y;if(this.c)return(0,F.$Ce)(D,p??{});let c=D;l&&l.length>0&&(c+=`/${Array.isArray(l)?l.join(""):l}`);const r=this.d.get(v)?.contents[c];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,F.$Ce)(r??D,p??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let y;const D=await this.g(v);if(!D){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const p=await this.a.$fetchBundleContents(D),l=JSON.parse(p);y=v.isBuiltin?l.contents?.bundle:l}catch(p){this.f.error(`Failed to load translations for ${v.identifier.value} from ${D}: ${p.message}`);return}y&&this.d.set(v.identifier.value,{contents:y,uri:D})}async g(v){if(v.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(v.identifier.value,this.b);return d.URI.revive(y)}return v.l10n?d.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$pcc=R,e.$pcc=R=He([Be(0,E.$rM),Be(1,w.$bM),Be(2,A.$8i)],R),e.$qcc=(0,M.$Nh)("IExtHostLocalizationService")}),define(De[150],Ce([1,0,13,6,27,20,2,62]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;let E=class extends C.$gj{constructor(I,v){super(v.logLevel,v.logsLocation,v.loggers.map(y=>(0,b.$kh)(y))),this.r=I.getProxy(F.$aK.MainThreadLogger)}$setLogLevel(I,v){v?this.setLogLevel(A.URI.revive(v),I):this.setLogLevel(I)}setVisibility(I,v){super.setVisibility(I,v),this.r.$setVisibility(I,v)}s(I,v,y){return new w(this.r,I,v,y)}};e.$Qdc=E,e.$Qdc=E=He([Be(0,M.$bM),Be(1,d.$rM)],E);class w extends C.$bj{constructor(I,v,y,D){super(D?.logLevel==="always"),this.r=I,this.s=v,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(v,D).then(()=>{this.u(this.n),this.m=!0})}g(I,v){const y=[[I,v]];this.m?this.u(y):this.n.push(...y)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(De[113],Ce([1,0,6,5,3,20,22]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=e.$rcc=void 0,e.$rcc=(0,F.$Nh)("IExtHostManagedSockets");let b=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(C.$aK.MainThreadManagedSockets)}setFactory(I,v){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(I,v),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const v=++this.b,y=await this.c.makeConnection(),D=new d.$Qc;return this.d.set(v,new w(v,y,D)),D.add((0,d.$Pc)(()=>this.d.delete(v))),D.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(v),D.dispose()})),D.add(y.onDidClose(p=>{this.a.$onDidManagedSocketClose(v,p?.stack??p?.message),D.dispose()})),D.add(y.onDidReceiveMessage(p=>this.a.$onDidManagedSocketHaveData(v,A.$ae.wrap(p)))),v}$remoteSocketWrite(I,v){this.d.get(I)?.actual.send(v.buffer)}$remoteSocketEnd(I){const v=this.d.get(I);v&&(v.actual.end(),v.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$scc=b,e.$scc=b=He([Be(0,M.$bM)],b);class E{constructor(I,v){this.socketFactoryId=I,this.makeConnection=v}}class w extends d.$Rc{constructor(I,v,y){super(),this.socketId=I,this.actual=v,this.B(y)}}}),define(De[317],Ce([1,0,6,13,26]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;function M(b){return b&&b.title}let A=class{constructor(E,w){this.b=w,this.a=E.getProxy(C.$aK.MainThreadMessageService)}showMessage(E,w,R,I,v){const y={source:{identifier:E.identifier,label:E.displayName||E.name}};let D;typeof I=="string"||M(I)?D=[I,...v]:(y.modal=I?.modal,y.useCustom=I?.useCustom,y.detail=I?.detail,D=v),y.useCustom&&(0,d.$aF)(E,"resolvers");const p=[];for(let l=0;l<D.length;l++){const c=D[l];if(typeof c=="string")p.push({title:c,handle:l,isCloseAffordance:!1});else if(typeof c=="object"){const{title:r,isCloseAffordance:o}=c;p.push({title:r,isCloseAffordance:!!o,handle:l})}else this.b.warn("Invalid message item:",c)}return this.a.$showMessage(w,R,y,p).then(l=>{if(typeof l=="number")return D[l]})}};e.$Bcc=A,e.$Bcc=A=He([Be(1,F.$8i)],A)}),define(De[318],Ce([1,0,207,22,4,3,28,15,18,2,30,107,6,33,14,7,68,281,144,8,24,17]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,i,s,u,S){this.q=s,this.r=u,this.s=S,this.f=new Map,this.g=new A.$zc,this.h=new Map,this.j=new d.$Md({onListenerError:o.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new d.$Md({onListenerError:o.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new d.$Md({onListenerError:o.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new d.$Md({onListenerError:o.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Jbc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=a.getProxy(v.$aK.MainThreadNotebook),this.c=a.getProxy(v.$aK.MainThreadNotebookDocuments),this.d=a.getProxy(v.$aK.MainThreadNotebookEditors),this.i=i.converter,i.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const $=k.notebookEditor?.notebookUri,f=k.cell.handle,P=this.g.get($)?.getCell(f);if(P)return P.apiCell}if(k&&k.$mid===14){const $=k.uri,f=this.g.get($);if(f)return f.apiNotebook}return k}}),t.A(i)}getEditorById(a){const i=this.h.get(a);if(!i)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return i}getIdByEditor(a){for(const[i,s]of this.h)if(s.apiEditor===a)return i}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,i){const s=this.g.get(a);if(!s&&!i)throw new Error(`NO notebook document for '${a}'`);return s}static t(a,i){if(!i)return;const s=i.filenamePattern.map(u=>D.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(i.filenamePattern&&!s){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:i.displayName,filenamePattern:s,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,i,s){const u=t.a++,S=typeof s.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(u,s),this.b.$registerNotebookCellStatusBarItemProvider(u,S,i);let k;return S!==void 0&&(k=s.onDidChangeCellStatusBarItems($=>this.b.$emitCellStatusBarEvent(S))),new p.$cK(()=>{this.f.delete(u),this.b.$unregisterNotebookCellStatusBarItemProvider(u,S),k?.dispose()})}async createNotebookDocument(a){const i=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&D.NotebookData.from(a.content)});return w.URI.revive(i)}async openNotebookDocument(a){const i=this.g.get(a);if(i)return i.apiNotebook;const s=await this.c.$tryOpenNotebook(a),u=this.g.get(w.URI.revive(s));return(0,E.$If)(u?.apiNotebook)}async showNotebookDocument(a,i){w.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let s;typeof i=="object"?s={position:D.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(D.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:s={preserveFocus:!1};const u=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,s),S=u&&this.h.get(u)?.apiEditor;if(S)return S;throw u?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,i,s,u){const S=this.f.get(a),k=w.URI.revive(i),$=this.g.get(k);if(!$||!S)return;const f=$.getCellFromIndex(s);if(!f)return;const g=await S.provideCellStatusBarItems(f.apiCell,u);if(!g)return;const P=new M.$Qc,O=this.p.add([P]),L=(Array.isArray(g)?g:[g]).map(j=>D.NotebookStatusBarItem.from(j,this.i,P));return{cacheId:O,items:L}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,i,s,u,S){if((0,b.$Ae)(i))throw new Error("viewType cannot be empty or just whitespace");const k=this.u++;return this.w.set(k,{viewType:i,serializer:s,options:u}),this.b.$registerNotebookSerializer(k,{id:a.identifier,location:a.extensionLocation},i,D.NotebookDocumentContentOptions.from(u),t.t(a,S)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(a,i,s){const u=this.w.get(a);if(!u)throw new Error("NO serializer found");const S=await u.serializer.deserializeNotebook(i.buffer,s);return new l.$lv(D.NotebookData.from(S))}async $notebookToData(a,i,s){const u=this.w.get(a);if(!u)throw new Error("NO serializer found");const S=await u.serializer.serializeNotebook(D.NotebookData.to(i.value),s);return F.$ae.wrap(S)}async $saveNotebook(a,i,s,u,S){const k=w.URI.revive(i),$=this.w.get(a);if(!$)throw new Error("NO serializer found");const f=this.g.get(k);if(!f)throw new Error("Document NOT found");if(f.versionId!==s)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new R.$rk((0,C.localize)(0,null,this.y(k)),6);await this.x(k,u);const g={metadata:(0,m.$$m)(f.apiNotebook.metadata,j=>!($.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of f.apiNotebook.getCells()){const z=new p.$AL(j.kind,j.document.getText(),j.document.languageId,j.mime,$.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);z.metadata=(0,m.$$m)(j.metadata,T=>!($.options?.transientCellMetadata??{})[T]),g.cells.push(z)}const P=await $.serializer.serializeNotebook(g,S);await this.s.value.writeFile(k,P);const O=this.s.getFileSystemProviderExtUri(k.scheme),N=await this.s.value.stat(k);return{name:O.basename(k),isFile:(N.type&R.FileType.File)!==0,isDirectory:(N.type&R.FileType.Directory)!==0,isSymbolicLink:(N.type&R.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((N.permissions??0)&R.FilePermission.Locked),etag:R.$Ck({mtime:N.mtime,size:N.size}),children:void 0}}async x(a,i){const s=await this.s.value.stat(a);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==R.$Bk&&typeof s.mtime=="number"&&typeof s.size=="number"&&i.mtime<s.mtime&&i.etag!==R.$Ck({mtime:i.mtime,size:s.size}))throw new R.$rk((0,C.localize)(1,null),3,i)}y(a){return a.scheme===h.Schemas.file?a.fsPath:a.toString()}z(a,i,s){if(this.h.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const u=new r.$idc(i,this.d,a,s.visibleRanges.map(D.NotebookRange.to),s.selections.map(D.NotebookRange.to),typeof s.viewColumn=="number"?D.ViewColumn.to(s.viewColumn):void 0);this.h.set(i,u)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const s of a.value.removedDocuments){const u=w.URI.revive(s),S=this.g.get(u);S&&(S.dispose(),this.g.delete(u),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(S.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===u.toString()&&this.h.delete(k.id)}if(a.value.addedDocuments){const s=[];for(const u of a.value.addedDocuments){const S=w.URI.revive(u.uri);if(this.g.has(S))throw new Error(`adding EXISTING notebook ${S} `);const k=new c.$hdc(this.c,this.q,this.r,S,u);s.push(...u.cells.map($=>c.$gdc.asModelAddData(k.apiNotebook,$))),this.g.get(S)?.dispose(),this.g.set(S,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:s}),this.m.fire(k.apiNotebook)}}if(a.value.addedEditors)for(const s of a.value.addedEditors){if(this.h.has(s.id))return;const u=w.URI.revive(s.documentUri),S=this.g.get(u);S&&this.z(S,s.id,s)}const i=[];if(a.value.removedEditors)for(const s of a.value.removedEditors){const u=this.h.get(s);u&&(this.h.delete(s),this.k?.id===u.id&&(this.k=void 0),i.push(u))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(u=>this.h.get(u)).filter(u=>!!u);const s=new Set;this.l.forEach(u=>s.add(u.id));for(const u of this.h.values()){const S=s.has(u.id);u._acceptVisibility(S)}this.l=[...this.h.values()].map(u=>u).filter(u=>u.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(a){const i=y.$zM.String.with("notebookType","A notebook type"),s=new y.$BM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new y.$zM("data","Bytes to convert to data",S=>S instanceof Uint8Array,S=>F.$ae.wrap(S))],new y.$AM("Notebook Data",S=>D.NotebookData.to(S.value))),u=new y.$BM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new y.$zM("NotebookData","Notebook data to convert to bytes",S=>!0,S=>new l.$lv(D.NotebookData.from(S)))],new y.$AM("Bytes",S=>S.buffer));a.registerApiCommand(s),a.registerApiCommand(u)}}e.$jdc=t}),define(De[319],Ce([1,0,19,9,21,4,3,28,2,25,13,6,33,14,7,110,275,26,68]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=e.$xdc=void 0;let o=class{constructor(u,S,k,$,f){this.l=S,this.m=k,this.n=$,this.o=f,this.b=new b.$zc,this.c=new b.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new M.$Md,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=u.getProxy(I.$aK.MainThreadNotebookKernels);const g=new v.$BM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.$zM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const O=this.m.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:O}}else if(P&&"notebookEditor"in P){const O=this.m.getIdByEditor(P.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return P})],v.$AM.Void);this.n.registerApiCommand(g)}createNotebookController(u,S,k,$,f,g){for(const oe of this.i.values())if(oe.controller.id===S&&w.$3l.equals(u.identifier,oe.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const P=this.j++,O=this;this.o.trace(`NotebookController[${P}], CREATED by ${u.identifier.value}, ${S}`);const N=()=>console.warn(`NO execute handler from notebook controller '${T.id}' of extension: '${u.identifier}'`);let L=!1;const j=new M.$Md,z=new M.$Md,T={id:i(u.identifier,S),notebookType:k,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:$||u.identifier.value,preloads:g?g.map(y.NotebookRendererScript.from):[]};let K=f??N,V;this.a.$addKernel(P,T).catch(oe=>{console.log(oe),L=!0});let fe=0;const X=()=>{if(L)return;const oe=++fe;Promise.resolve().then(()=>{oe===fe&&this.a.$updateKernel(P,T)})},Q=new b.$zc,Z={get id(){return S},get notebookType(){return T.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return T.label},set label(oe){T.label=oe??u.displayName??u.name,X()},get detail(){return T.detail??""},set detail(oe){T.detail=oe,X()},get description(){return T.description??""},set description(oe){T.description=oe,X()},get supportedLanguages(){return T.supportedLanguages},set supportedLanguages(oe){T.supportedLanguages=oe,X()},get supportsExecutionOrder(){return T.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){T.supportsExecutionOrder=oe,X()},get rendererScripts(){return T.preloads?T.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(oe){K=oe??N},get interruptHandler(){return V},set interruptHandler(oe){V=oe,T.supportsInterrupt=!!oe,X()},createNotebookCellExecution(oe){if(L)throw new Error("notebook controller is DISPOSED");if(!Q.has(oe.notebook.uri))throw O.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(x=>x.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return O._createNotebookCellExecution(oe,i(u.identifier,this.id))},createNotebookExecution(oe){if((0,c.$aF)(u,"notebookExecution"),L)throw new Error("notebook controller is DISPOSED");if(!Q.has(oe.uri))throw O.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(x=>x.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return O._createNotebookExecution(oe,i(u.identifier,this.id))},dispose:()=>{L||(this.o.trace(`NotebookController[${P}], DISPOSED`),L=!0,this.i.delete(P),j.dispose(),z.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(oe,x){x===D.NotebookControllerAffinity2.Hidden&&(0,c.$aF)(u,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(P,oe.uri,x)},onDidReceiveMessage:z.event,postMessage(oe,x){return(0,c.$aF)(u,"notebookMessaging"),O.a.$postMessage(P,x&&O.m.getIdByEditor(x),oe)},asWebviewUri(oe){return(0,c.$aF)(u,"notebookMessaging"),(0,p.$1ob)(oe,O.l.remote)}};return this.i.set(P,{extensionId:u.identifier,controller:Z,onDidReceiveMessage:z,onDidChangeSelection:j,associatedNotebooks:Q}),Z}getIdByController(u){for(const[S,k]of this.i)if(k.controller===u)return i(k.extensionId,u.id);return null}createNotebookControllerDetectionTask(u,S){const k=this.f++,$=this;this.o.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${u.identifier.value}`),this.a.$addKernelDetectionTask(k,S);const f={dispose:()=>{this.e.delete(k),$.a.$removeKernelDetectionTask(k)}};return this.e.set(k,f),f}registerKernelSourceActionProvider(u,S,k){const $=this.h++,f=typeof k.onDidChangeNotebookKernelSourceActions=="function"?$:void 0,g=this;this.g.set($,k),this.o.trace(`NotebookKernelSourceActionProvider[${$}], CREATED by ${u.identifier.value}`),this.a.$addKernelSourceActionProvider($,$,S);let P;return f!==void 0&&(P=k.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.g.delete($),g.a.$removeKernelSourceActionProvider($,$),P?.dispose()}}}async $provideKernelSourceActions(u,S){const k=this.g.get(u);if(k){const $=new A.$Qc;return(await k.provideNotebookKernelSourceActions(S)??[]).map(g=>y.NotebookKernelSourceAction.from(g,this.n.converter,$))}return[]}$acceptNotebookAssociation(u,S,k){const $=this.i.get(u);if($){const f=this.m.getNotebookDocument(E.URI.revive(S));k?$.associatedNotebooks.set(f.uri,!0):$.associatedNotebooks.delete(f.uri),this.o.trace(`NotebookController[${u}] ASSOCIATE notebook`,f.uri.toString(),k),$.onDidChangeSelection.fire({selected:k,notebook:f.apiNotebook})}}async $executeCells(u,S,k){const $=this.i.get(u);if(!$)return;const f=this.m.getNotebookDocument(E.URI.revive(S)),g=[];for(const P of k){const O=f.getCell(P);O&&g.push(O.apiCell)}try{this.o.trace(`NotebookController[${u}] EXECUTE cells`,f.uri.toString(),g.length),await $.controller.executeHandler.call($.controller,g,f.apiNotebook,$.controller)}catch(P){this.o.error(`NotebookController[${u}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(u,S,k){const $=this.i.get(u);if(!$)return;const f=this.m.getNotebookDocument(E.URI.revive(S));if($.controller.interruptHandler)await $.controller.interruptHandler.call($.controller,f.apiNotebook);else for(const g of k){const P=f.getCell(g);P&&this.b.get(P.uri)?.cancel()}if($.controller.interruptHandler){const g=this.c.get(f.uri);k.length&&Array.isArray(g)&&g.length&&g.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(u,S,k){const $=this.i.get(u);if(!$)return;const f=this.m.getEditorById(S);$.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:k}))}$cellExecutionChanged(u,S,k){const f=this.m.getNotebookDocument(E.URI.revive(u)).getCell(S);if(f){const g=k?y.NotebookCellExecutionState.to(k):D.NotebookCellExecutionState.Idle;g!==void 0&&this.k.fire({cell:f.apiCell,state:g})}}_createNotebookCellExecution(u,S){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const $=this.m.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!$)throw new Error("invalid cell");if(this.b.has($.uri))throw new Error(`duplicate execution for ${$.uri}`);const f=new h(S,$,this.a);this.b.set($.uri,f);const g=f.onDidChangeState(()=>{f.state===m.Resolved&&(f.dispose(),g.dispose(),this.b.delete($.uri))});return f.asApiObject()}_createNotebookExecution(u,S){const k=this.m.getNotebookDocument(u.uri),$=u.getCells().find(P=>{const O=k.getCellFromApiCell(P);return O&&this.b.has(O.uri)});if($)throw new Error(`duplicate cell execution for ${$.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const f=new n(S,k,this.a),g=f.onDidChangeState(()=>{f.state===t.Resolved&&(f.dispose(),g.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[f,g]),f.asApiObject()}};e.$xdc=o,e.$xdc=o=He([Be(4,R.$8i)],o);var m;(function(s){s[s.Init=0]="Init",s[s.Started=1]="Started",s[s.Resolved=2]="Resolved"})(m||(m={}));class h extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(u,S,k){super(),this.m=S,this.n=k,this.b=h.a++,this.c=new M.$Md,this.onDidChangeState=this.c.event,this.f=m.Init,this.g=this.B(new d.$Wd),this.h=new a(10,$=>this.s($)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,u,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(u){await this.h.addItem(u)}async s(u){const S=Array.isArray(u)?u:[u];return this.n.$updateExecution(this.b,new r.$lv(S))}t(){if(this.f===m.Init)throw new Error("Must call start before modifying cell output");if(this.f===m.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(u){let S=this.m;if(u&&(S=this.m.notebook.getCellFromApiCell(u)),!S)throw new Error("INVALID cell");return S.handle}y(u){return u.map(S=>{const k=D.$DL.ensureUniqueMimeTypes(S.items,!0);return k===S.items?y.NotebookCellOutput.from(S):y.NotebookCellOutput.from({items:k,id:S.id,metadata:S.metadata})})}async z(u,S,k){const $=this.w(S),f=this.y((0,C.$2b)(u));return this.r({editType:l.CellExecutionUpdateType.Output,cellHandle:$,append:k,outputs:f})}async C(u,S,k){return u=D.$DL.ensureUniqueMimeTypes((0,C.$2b)(u),!0),this.r({editType:l.CellExecutionUpdateType.OutputItems,items:u.map(y.NotebookCellOutputItem.from),outputId:S.id,append:k})}asApiObject(){const u=this;return Object.freeze({get token(){return u.g.token},get cell(){return u.m.apiCell},get executionOrder(){return u.j},set executionOrder(k){u.j=k,u.s([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:u.j}])},start(k){if(u.f===m.Resolved||u.f===m.Started)throw new Error("Cannot call start again");u.f=m.Started,u.c.fire(),u.s({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,$){if(u.f===m.Resolved)throw new Error("Cannot call resolve twice");u.f=m.Resolved,u.c.fire(),u.h.flush(),u.n.$completeExecution(u.b,new r.$lv({runEndTime:$,lastRunSuccess:k}))},clearOutput(k){return u.t(),u.z([],k,!1)},appendOutput(k,$){return u.t(),u.z(k,$,!0)},replaceOutput(k,$){return u.t(),u.z(k,$,!1)},appendOutputItems(k,$){return u.t(),u.C(k,$,!0)},replaceOutputItems(k,$){return u.t(),u.C(k,$,!1)}})}}var t;(function(s){s[s.Init=0]="Init",s[s.Started=1]="Started",s[s.Resolved=2]="Resolved"})(t||(t={}));class n extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(u,S,k){super(),this.h=S,this.j=k,this.b=n.a++,this.c=new M.$Md,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new d.$Wd),this.j.$createNotebookExecution(this.b,u,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class a{constructor(u,S){this.e=u,this.f=S,this.a=[],this.b=Date.now()}addItem(u){return this.a.push(u),this.c||(this.c=new F.$bh,this.b=Date.now(),(0,F.$Tg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const u=this.c;this.c=void 0;const S=this.a;return this.a=[],this.f(S).finally(()=>u.complete())}}function i(s,u){return`${s.value}/${u}`}e.$ydc=i}),define(De[320],Ce([1,0,4,6,144]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;class M{constructor(b,E){this.c=E,this.a=new Map,this.b=b.getProxy(F.$aK.MainThreadNotebookRenderers)}$postRendererMessage(b,E,w){const R=this.c.getEditorById(b);this.a.get(E)?.fire({editor:R.apiEditor,message:w})}createRendererMessaging(b,E){if(!b.contributes?.notebookRenderer?.some(R=>R.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(R,I,v)=>this.d(E).event(R,I,v),postMessage:(R,I)=>{d.$idc.apiEditorsToExtHost.has(R)&&([R,I]=[I,R]);const v=I&&d.$idc.apiEditorsToExtHost.get(I);return this.b.$postMessage(v?.id,E,R)}}}d(b){let E=this.a.get(b);return E||(E=new C.$Md({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(b)}}),this.a.set(b,E),E)}}e.$zdc=M}),define(De[321],Ce([1,0,3,18,2,26,6]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;class b{constructor(w){this.b=new Map,this.a=w.getProxy(A.$aK.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,R,I){if((0,M.$aF)(w,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,I),this.a.$registerProfileContentHandler(R,I.name,I.description,w.identifier.value),(0,C.$Pc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(w,R,I,v){const y=this.b.get(w);if(!y)throw new Error(`Unknown handler with id: ${w}`);return y.saveProfile(R,I,v)}async $readProfile(w,R,I){const v=this.b.get(w);if(!v)throw new Error(`Unknown handler with id: ${w}`);return v.readProfile((0,F.$xf)(R)?R:d.URI.revive(R),I)}}e.$Ddc=b}),define(De[322],Ce([1,0,2,6,9,14]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class A{static{this.a=0}constructor(E,w){this.d=w,this.c=new Map,this.b=E.getProxy(F.$aK.MainThreadQuickDiff)}$provideOriginalResource(E,w,R){const I=C.URI.revive(w),v=this.c.get(E);return v?(0,d.$Lg)(()=>v.provideOriginalResource(I,R)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(E,w,R,I){const v=A.a++;return this.c.set(v,w),this.b.$registerQuickDiffProvider(v,M.DocumentSelector.from(E,this.d),R,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(v),this.c.delete(v)}}}}e.$Edc=A}),define(De[323],Ce([1,0,21,4,3,6,2,7,8,19,38,59,26,14]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;function D(p,l,c){const r=p.getProxy(M.$aK.MainThreadQuickOpen);class o{constructor(S,k){this.e=new Map,this.f=0,this.a=S,this.b=k}showQuickPick(S,k,$,f=C.CancellationToken.None){this.c=void 0;const g=Promise.resolve(k),P=++this.f,O=r.$show(P,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},f),N={},L=O.then(()=>N);return Promise.race([L,g]).then(j=>{if(j===N)return;const z=(0,v.$_E)(S,"quickPickItemTooltip");return g.then(T=>{const K=[];for(let V=0;V<T.length;V++){const fe=T[V];if(typeof fe=="string")K.push({label:fe,handle:V});else if(fe.kind===b.QuickPickItemKind.Separator)K.push({type:"separator",label:fe.label});else{fe.tooltip&&!z&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const X=fe.iconPath?a(fe.iconPath):void 0;K.push({label:fe.label,iconPath:X?.iconPath,iconClass:X?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:z?y.MarkdownString.fromStrict(fe.tooltip):void 0,handle:V})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=V=>{$.onDidSelectItem(T[V])}),r.$setItems(P,K),O.then(V=>{if(typeof V=="number")return T[V];if(Array.isArray(V))return V.map(fe=>T[fe])})})}).then(void 0,j=>{if(!(0,E.$3)(j))return r.$setError(P,j),Promise.reject(j)})}$onItemSelected(S){this.c?.(S)}showInput(S,k=C.CancellationToken.None){return this.d=S?.validateInput,r.$input(S,typeof this.d=="function",k).then(void 0,$=>{if(!(0,E.$3)($))return Promise.reject($)})}async $validateInput(S){if(!this.d)return;const k=await this.d(S);if(!k||typeof k=="string")return k;let $;switch(k.severity){case b.InputBoxValidationSeverity.Info:$=R.default.Info;break;case b.InputBoxValidationSeverity.Warning:$=R.default.Warning;break;case b.InputBoxValidationSeverity.Error:$=R.default.Error;break;default:$=k.message?R.default.Error:R.default.Ignore;break}return{content:k.message,severity:$}}async showWorkspaceFolderPick(S,k=C.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!$)return;const f=await this.a.getWorkspaceFolders2();if(f)return f.find(g=>g.uri.toString()===$.uri.toString())}createQuickPick(S){const k=new i(S,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(S){const k=new s(S,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(S,k){this.e.get(S)?._fireDidChangeValue(k)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,k){const $=this.e.get(S);$ instanceof i&&$._fireDidChangeActive(k)}$onDidChangeSelection(S,k){const $=this.e.get(S);$ instanceof i&&$._fireDidChangeSelection(k)}$onDidTriggerButton(S,k){this.e.get(S)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(S,k,$){const f=this.e.get(S);f instanceof i&&f._fireDidTriggerItemButton(k,$)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class m{static{this.a=1}constructor(S,k){this.x=S,this.y=k,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$Md,this.q=new F.$Md,this.r=new F.$Md,this.s=new F.$Md,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((k,$)=>{const f=k===b.$wL.Back?-1:$;this.o.set(f,k)}),this.z({buttons:S.map((k,$)=>({...a(k.iconPath),tooltip:k.tooltip,handle:k===b.$wL.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const k=this.o.get(S);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,d.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(S){if(!this.v){for(const k of Object.keys(S)){const $=S[k];this.u[k]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function h(u){if(u instanceof b.$9K)return{id:u.id};const S=n(u),k=t(u);return{dark:typeof S=="string"?A.URI.file(S):S,light:typeof k=="string"?A.URI.file(k):k}}function t(u){return typeof u=="object"&&"light"in u?u.light:u}function n(u){return typeof u=="object"&&"dark"in u?u.dark:u}function a(u){const S=h(u);let k,$;return"id"in S?$=I.ThemeIcon.asClassName(S):k=S,{iconPath:k,iconClass:$}}class i extends m{constructor(S,k){super(S.identifier,k),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$Md,this.L=[],this.M=new F.$Md,this.N=new F.$Md,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((f,g)=>{this.C.set(g,f),this.D.set(f,g)});const k=(0,v.$_E)(this.O,"quickPickItemTooltip"),$=[];for(let f=0;f<S.length;f++){const g=S[f];if(g.kind===b.QuickPickItemKind.Separator)$.push({type:"separator",label:g.label});else{g.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=g.iconPath?a(g.iconPath):void 0;$.push({handle:f,label:g.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,tooltip:k?y.MarkdownString.fromStrict(g.tooltip):void 0,buttons:g.buttons?.map((O,N)=>({...a(O.iconPath),tooltip:O.tooltip,handle:N}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(S){const k=(0,w.$Gb)(S.map($=>this.C.get($)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(S){const k=(0,w.$Gb)(S.map($=>this.C.get($)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(S,k){const $=this.C.get(S);if(!$||!$.buttons||!$.buttons.length)return;const f=$.buttons[k];f&&this.N.fire({button:f,item:$})}}class s extends m{constructor(S,k){super(S.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:R.default.Error}):this.z({validationMessage:S.message,severity:S.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new o(l,c)}e.$Fcc=D}),define(De[324],Ce([1,0,2,4,57,3,9,6,19,126,13,25,59,14,26,17]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=e.$Gcc=void 0;function c(f){if(f)return typeof f.iconPath=="string"?C.URI.file(f.iconPath):C.URI.isUri(f.iconPath)||v.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function r(f){if(f.icon){if(C.URI.isUri(f.icon))return f.icon;if(v.ThemeIcon.isThemeIcon(f.icon))return f.icon;{const g=f.icon;return{light:g.light,dark:g.dark}}}else return}function o(f,g){if(!f.iconPath&&!g.iconPath)return 0;if(f.iconPath){if(!g.iconPath)return 1}else return-1;const P=typeof f.iconPath=="string"?f.iconPath:C.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,O=typeof g.iconPath=="string"?g.iconPath:C.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,w.$oq)(P,O)}function m(f,g){let P=0;if(f.strikeThrough!==g.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==g.faded)return f.faded?1:-1;if(f.tooltip!==g.tooltip)return(f.tooltip||"").localeCompare(g.tooltip||"");if(P=o(f,g),P!==0)return P;if(f.light&&g.light)P=o(f.light,g.light);else{if(f.light)return 1;if(g.light)return-1}if(P!==0)return P;if(f.dark&&g.dark)P=o(f.dark,g.dark);else{if(f.dark)return 1;if(g.dark)return-1}return P}function h(f,g){if(f.command!==g.command)return f.command<g.command?-1:1;if(f.title!==g.title)return f.title<g.title?-1:1;if(f.tooltip!==g.tooltip){if(f.tooltip!==void 0&&g.tooltip!==void 0)return f.tooltip<g.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(f.arguments===g.arguments)return 0;if(f.arguments)if(g.arguments){if(f.arguments.length!==g.arguments.length)return f.arguments.length-g.arguments.length}else return 1;else return-1;for(let P=0;P<f.arguments.length;P++){const O=f.arguments[P],N=g.arguments[P];if(O!==N)return O<N?-1:1}return 0}function t(f,g){let P=(0,w.$oq)(f.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(P!==0)return P;if(f.command&&g.command)P=h(f.command,g.command);else{if(f.command)return 1;if(g.command)return-1}if(P!==0)return P;if(f.decorations&&g.decorations)P=m(f.decorations,g.decorations);else{if(f.decorations)return 1;if(g.decorations)return-1}return P}function n(f,g){for(let P=0;P<f.length;P++)if(f[P]!==g[P])return!1;return!0}function a(f,g){return f.command===g.command&&f.title===g.title&&f.tooltip===g.tooltip&&(f.arguments&&g.arguments?n(f.arguments,g.arguments):f.arguments===g.arguments)}function i(f,g){return(0,E.$tb)(f,g,a)}function s(f,g){return f===g?!0:!f||!g?!1:f.id===g.id&&f.label===g.label&&f.upstream?.id===g.upstream?.id&&f.upstream?.label===g.upstream?.label}class u{#e;#t;get value(){return this.d}set value(g){g=g??"",this.#e.$setInputBoxValue(this.l,g),this.n(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){this.#e.$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,D.$aF)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,D.$aF)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,this.#e.$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,this.#e.$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,this.#e.$setInputBoxVisibility(this.l,g))}get document(){return(0,D.$aF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(g,P,O,N,L){this.k=g,this.l=N,this.m=L,this.d="",this.e=new F.$Md,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=O}showValidationMessage(g,P){(0,D.$aF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,g,P)}$onInputBoxValueChange(g){this.n(g)}n(g){this.d=g,this.e.fire(g)}}e.$Gcc=u;class S{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,P,O,N,L){this.q=g,this.s=P,this.t=O,this.u=N,this.v=L,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$Md,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$Md,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=S.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,P){const O=this.h.get(g);return O?(0,A.$Lg)(()=>this.s.executeCommand(O.command,...O.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(t),O=(0,E.$Cb)(this.o,g,t).map(j=>{const z=j.toInsert.map(T=>{const K=this.e++;this.g.set(K,T);const V=T.resourceUri;let fe;if(T.command)if(T.command.command==="vscode.open"||T.command.command==="vscode.diff"){const q=new M.$Qc;fe=this.s.converter.toInternal(T.command,q),this.j.set(K,q)}else this.h.set(K,T.command);const X=c(T.decorations),Q=T.decorations&&c(T.decorations.light)||X,Z=T.decorations&&c(T.decorations.dark)||X,oe=[Q,Z],x=T.decorations&&T.decorations.tooltip||"",ae=T.decorations&&!!T.decorations.strikeThrough,ve=T.decorations&&!!T.decorations.faded,G=T.contextValue||"";return{rawResource:[K,V,oe,x,ae,ve,G,fe],handle:K}});return{start:j.start,deleteCount:j.deleteCount,toInsert:z}}),N=O.map(({start:j,deleteCount:z,toInsert:T})=>[j,z,T.map(K=>K.rawResource)]),L=O.reverse();for(const{start:j,deleteCount:z,toInsert:T}of L){const K=T.map(fe=>fe.handle),V=this.n.splice(j,z,...K);for(const fe of V)this.g.delete(fe),this.h.delete(fe),this.j.get(fe)?.dispose(),this.j.delete(fe)}return this.o=g,N}dispose(){this.l=!0,this.m.fire()}}class k{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,this.#e.$updateSourceControl(this.x,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g;let P;(0,D.$_E)(this.y,"quickDiffProvider")&&(P=g?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!g,quickDiffLabel:P})}get historyProvider(){return(0,D.$aF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(g){(0,D.$aF)(this.y,"scmHistoryProvider"),this.j=g,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!g}),g&&(this.k.value.add(g.onDidChangeCurrentHistoryItemGroup(()=>{s(this.l,g?.currentHistoryItemGroup)||(this.l=g?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(g.onDidChangeActionButton(()=>{(0,D.$aF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const P=g.actionButton!==void 0?{command:this.z.converter.toInternal(g.actionButton.command,this.m.value),description:g.actionButton.description,enabled:g.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(g){g!==this.n&&(this.n=g,this.#e.$updateSourceControl(this.x,{commitTemplate:g}))}get acceptInputCommand(){return this.p}set acceptInputCommand(g){this.o.value=new M.$Qc,this.p=g;const P=this.z.converter.toInternal(g,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,D.$aF)(this.y,"scmActionButton"),this.s}set actionButton(g){(0,D.$aF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=g;const P=g!==void 0?{command:this.z.converter.toInternal(g.command,this.q.value),secondaryCommands:g.secondaryCommands?.map(O=>O.map(N=>this.z.converter.toInternal(N,this.q.value))),description:g.description,enabled:g.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(g){if(this.u&&g&&i(this.u,g))return;this.t.value=new M.$Qc,this.u=g;const P=(g||[]).map(O=>this.z.converter.toInternal(O,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(g,P,O,N,L,j,z){this.y=g,this.z=N,this.A=L,this.B=j,this.C=z,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new F.$Md,this.onDidChangeSelection=this.w.event,this.x=k.d++,this.D=new Map,this.E=new Set,this.#e=O;const T=C.URI.from({scheme:p.Schemas.vscodeSourceControl,path:`${L}/scm${this.x}/input`,query:z?`rootUri=${encodeURIComponent(z.toString())}`:void 0});this.f=new u(g,P,this.#e,this.x,T),this.#e.$registerSourceControl(this.x,L,j,z,T)}createResourceGroup(g,P){const O=new S(this.#e,this.z,this.x,g,P),N=F.Event.once(O.onDidDispose)(()=>this.D.delete(O));return this.D.set(O,N),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const g=[],P=[];for(const[O,N]of this.D){N.dispose();const L=O.onDidUpdateResourceStates(()=>{this.E.add(O),this.eventuallyUpdateResourceStates()});F.Event.once(O.onDidDispose)(()=>{this.E.delete(O),L.dispose(),this.e.delete(O.handle),this.#e.$unregisterGroup(this.x,O.handle)}),g.push([O.handle,O.id,O.label,O.features]);const j=O._takeResourceStateSnapshot();j.length>0&&P.push([O.handle,j]),this.e.set(O.handle,O)}this.#e.$registerGroups(this.x,g,P),this.D.clear()}eventuallyUpdateResourceStates(){const g=[];this.E.forEach(P=>{const O=P._takeResourceStateSnapshot();O.length!==0&&g.push([P.handle,O])}),g.length>0&&this.#e.$spliceResourceStates(this.x,g),this.E.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.v=g,this.w.fire(g)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(g=>g.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,d.$gh)(100)],k.prototype,"eventuallyAddResourceGroups",null),He([(0,d.$gh)(100)],k.prototype,"eventuallyUpdateResourceStates",null);let $=class{static{l=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(g,P,O,N){this.l=P,this.m=O,this.n=N,this.g=new Map,this.h=new I.$5l,this.j=new F.$Md,this.e=g.getProxy(b.$aK.MainThreadSCM),this.f=g.getProxy(b.$aK.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const j=this.g.get(L.sourceControlHandle);if(!j)return L;const z=j.getResourceGroup(L.groupHandle);return z?z.getResourceState(L.handle):L}else if(L&&L.$mid===4){const j=this.g.get(L.sourceControlHandle);return j?j.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const j=this.g.get(L.handle);return j||L}return L}})}createSourceControl(g,P,O,N){this.n.trace("ExtHostSCM#createSourceControl",g.identifier.value,P,O,N),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const L=l.d++,j=new k(g,this.m,this.e,this.l,P,O,N);this.g.set(L,j);const z=this.h.get(g.identifier)||[];return z.push(j),this.h.set(g.identifier,z),j}getLastInputBox(g){this.n.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const P=this.h.get(g.identifier),O=P&&P[P.length-1];return O&&O.inputBox}$provideOriginalResource(g,P,O){const N=C.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",g,N.toString());const L=this.g.get(g);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Lg)(()=>L.quickDiffProvider.provideOriginalResource(N,O)).then(j=>j||null)}$onInputBoxValueChange(g,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",g);const O=this.g.get(g);return O&&O.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(g,P,O,N){this.n.trace("ExtHostSCM#$executeResourceCommand",g,P,O);const L=this.g.get(g);if(!L)return Promise.resolve(void 0);const j=L.getResourceGroup(P);return j?j.$executeResourceCommand(O,N):Promise.resolve(void 0)}$validateInput(g,P,O){this.n.trace("ExtHostSCM#$validateInput",g);const N=this.g.get(g);return!N||!N.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Lg)(()=>N.inputBox.validateInput(P,O)).then(L=>{if(!L)return Promise.resolve(void 0);const j=y.MarkdownString.fromStrict(L.message);return j?Promise.resolve([j,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(g,P,O){return await this.g.get(g)?.historyProvider?.resolveHistoryItemGroupBase(P,O)??void 0}async $resolveHistoryItemGroupCommonAncestor(g,P,O,N){return await this.g.get(g)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,O,N)??void 0}async $provideHistoryItems(g,P,O,N){return(await this.g.get(g)?.historyProvider?.provideHistoryItems(P,O,N))?.map(z=>({id:z.id,parentIds:z.parentIds,label:z.label,description:z.description,icon:r(z),timestamp:z.timestamp}))??void 0}async $provideHistoryItemChanges(g,P,O){return await this.g.get(g)?.historyProvider?.provideHistoryItemChanges(P,O)??void 0}};e.$Hcc=$,e.$Hcc=$=l=He([Be(3,R.$8i)],$)}),define(De[114],Ce([1,0,6,4,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=void 0;class M{constructor(b){this.b=new F.$Md,this.onDidChangePassword=this.b.event,this.a=b.getProxy(C.$aK.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,E){return this.a.$getPassword(b,E)}store(b,E,w){return this.a.$setPassword(b,E,w)}delete(b,E){return this.a.$deletePassword(b,E)}}e.$mcc=M,e.$ncc=(0,d.$Nh)("IExtHostSecretState")}),define(De[325],Ce([1,0,6,14,2]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class M{static{this.a=0}constructor(b,E){this.d=E,this.c=new Map,this.b=b.getProxy(C.$aK.MainThreadShare)}async $provideShare(b,E,w){return await this.c.get(b)?.provideShare({selection:F.Range.to(E.selection),resourceUri:d.URI.revive(E.resourceUri)},w)??void 0}registerShareProvider(b,E){const w=M.a++;return this.c.set(w,E),this.b.$registerShareProvider(w,F.DocumentSelector.from(b,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$Jdc=M}),define(De[326],Ce([1,0,7,6,209,3,14,18]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=e.$Icc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$0K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$0K("statusBarItem.warningForeground")]])}#e;#t;constructor(v,y,D,p,l,c=C.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=v,this.#t=y,l&&p){this.c=(0,C.$MK)(p.identifier,l);const o=D.get(this.c);o&&(c=o.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,r=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(E.a++);this.e=p,this.f=l,this.g=c,this.h=this.u(r)}u(v){if((0,b.$Bf)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(v){this.k=v,this.v()}set name(v){this.m=v,this.v()}set tooltip(v){this.l=v,this.v()}set color(v){this.n=v,this.v()}set backgroundColor(v){v&&!E.b.has(v.id)&&(v=void 0),this.o=v,this.v()}set command(v){this.r?.fromApi!==v&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof v=="string"?this.r={fromApi:v,internal:this.#t.toInternal({title:"",command:v},this.p)}:v?this.r={fromApi:v,internal:this.#t.toInternal(v,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(v){this.t=v,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let y;this.m?y=this.m:y=(0,d.localize)(0,null,this.e.displayName||this.e.name);let D=this.n;this.o&&(D=E.b.get(this.o.id));const p=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,v,this.e?.identifier.value,y,this.k,p,this.r?.internal,D,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Icc=E;class w{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,d.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const y={message:v};return this.b.unshift(y),this.c(),new C.$cK(()=>{const D=this.b.indexOf(y);D>=0&&(this.b.splice(D,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(v,y){this.e=new Map,this.a=v.getProxy(F.$aK.MainThreadStatusBar),this.b=y,this.c=new w(this)}$acceptStaticEntries(v){for(const y of v)this.e.set(y.entryId,y)}createStatusBarEntry(v,y,D,p){return new E(this.a,this.b,this.e,v,y,D,p)}setStatusBarMessage(v,y){const D=this.c.setMessage(v);let p;return typeof y=="number"?p=setTimeout(()=>D.dispose(),y):typeof y<"u"&&y.then(()=>D.dispose(),()=>D.dispose()),new C.$cK(()=>{D.dispose(),clearTimeout(p)})}}e.$Jcc=R}),define(De[115],Ce([1,0,6,4,5]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=void 0;class M{constructor(b,E){this.c=E,this.b=new F.$Md,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(C.$aK.MainThreadStorage)}registerExtensionStorageKeysToSync(b,E){this.a.$registerExtensionStorageKeysToSync(b,E)}async initializeExtensionStorage(b,E,w){const R=await this.a.$initializeExtensionStorage(b,E);let I;return R&&(I=this.d(b,E,R)),I||w}setValue(b,E,w){return this.a.$setValue(b,E,w)}$acceptValue(b,E,w){const R=this.d(b,E,w);R&&this.b.fire({shared:b,key:E,value:R})}d(b,E,w){try{return JSON.parse(w)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${b}): ${R}`)}}}e.$acc=M,e.$bcc=(0,d.$Nh)("IExtHostStorage")}),define(De[90],Ce([1,0,5,27,13,71,2]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=e.$gcc=void 0,e.$gcc=(0,C.$Nh)("IExtensionStoragePaths");let b=class{constructor(w,R,I){this.d=R,this.f=I,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(w){return A.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,R=await this.g(w);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(w){if(this.c)return A.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return A.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$hcc=b,e.$hcc=b=He([Be(0,F.$rM),Be(1,d.$8i),Be(2,M.$fcc)],b)}),define(De[44],Ce([1,0,4,6,5,2,20,3,7,211,8,253,21,31,254,59,9,14,33]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=e.$kcc=e.$jcc=e.$icc=void 0,e.$icc=(0,d.$Nh)("IExtHostTerminalService");class o{constructor($,f,g,P){this.l=$,this._id=f,this.m=g,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(N=>this.f=N);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(N,L=!0){O.q(),O.l.$sendText(O._id,N,L)},show(N){O.q(),O.l.$show(O._id,N)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create($,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??void 0,env:$.env??void 0,icon:s($.iconPath)??void 0,color:p.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,isFeatureTerminal:f?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:f?.useShellEnvironment??void 0,location:f?.location||this.o($.location,f?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,f,g,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:g,color:p.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o($,f),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o($,f){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in $?{viewColumn:c.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.n=$}setExitStatus($,f){this.h=Object.freeze({code:$,reason:f})}setDimensions($,f){return $===this.d&&f===this.g||$===0||f===0?!1:(this.d=$,this.g=f,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection($){this.k=$}_setProcessId($){this.f?(this.f($),this.f=void 0):this.b.then(f=>{f!==$&&(this.b=Promise.resolve($))})}}e.$jcc=o;class m{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new C.$Md,this.onProcessData=this.a.event,this.b=new C.$Md,this.d=new C.$Md,this.onDidChangeProperty=this.d.event,this.f=new C.$Md,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,f){this.g.setDimensions?.({columns:$,rows:f})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:"title",value:f})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends b.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,f,g){super(),this.Q=f,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$Md,this.onDidCloseTerminal=this.H.event,this.I=new C.$Md,this.onDidOpenTerminal=this.I.event,this.J=new C.$Md,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$Md,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$Md,this.onDidChangeTerminalState=this.M.event,this.N=new C.$Md,this.onDidChangeShell=this.N.event,this.O=new C.$Md({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$Md({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=g.getProxy(F.$aK.MainThreadTerminalService),this.y=new D.$Lkb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:P=>{const O=N=>{const L=N;return this.W(L.instanceId)?.value};switch(P?.$mid){case 15:return O(P);default:{if(Array.isArray(P))for(let N=0;N<P.length&&P[N].$mid===15;N++)P[N]=O(P[N]);return P}}}}),this.B({dispose:()=>{for(const[P,O]of this.g)O.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,f){const g=new o(this.a,(0,y.$dg)(),$,$.name),P=new m($.pty);return g.createExtensionTerminal($.location,this.R($,f).resolvedExtHostIdentifier,s($.iconPath),u($.color)).then(O=>{const N=this.S(O,P);this.h[O]=N}),this.f.push(g),g.value}R($,f){if(f=f||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const g=$.location.parentTerminal;if(g){const P=this.f.find(O=>O.value===g);P&&(f.resolvedExtHostIdentifier=P._id)}}else $.location&&typeof $.location!="object"?f.location=$.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal($,f){if(!this.W($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const P=new m(f),O=this.S($,P);this.h[$]=O}async $acceptActiveTerminalChanged($){const f=this.b;if($===null){this.b=void 0,f!==this.b&&this.J.fire(this.b);return}const g=this.W($);g&&(this.b=g,f!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,f){const g=this.W($);g&&this.O.fire({terminal:g.value,data:f})}async $acceptTerminalDimensions($,f,g){const P=this.W($);P&&P.setDimensions(f,g)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand($,f){const g=this.W($);g&&this.P.fire({terminal:g.value,...f})}async $acceptTerminalMaximumDimensions($,f,g){this.g.get($)?.resize(f,g)}async $acceptTerminalTitleChange($,f){const g=this.W($);g&&(g.name=f)}async $acceptTerminalClosed($,f,g){const P=this.Y(this.f,$);if(P!==null){const O=this.f.splice(P,1)[0];O.setExitStatus(f,g),this.H.fire(O.value)}}$acceptTerminalOpened($,f,g,P){if(f){const L=this.Y(this.f,f);if(L!==null){this.f[L]._id=$,this.I.fire(this.terminals[L]),this.f[L].isOpen=!0;return}}const O={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:M.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},N=new o(this.a,$,O,g);this.f.push(N),this.I.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId($,f){this.W($)?._setProcessId(f)}async $startExtensionTerminal($,f){const g=this.W($);if(!g)return{message:(0,w.localize)(0,null,$)};g.isOpen||await new Promise(O=>{const N=this.onDidOpenTerminal(async L=>{L===g.value&&(N.dispose(),O())})});const P=this.g.get($);P?P.startSendingEvents(f):this.j[$]={initialDimensions:f}}S($,f){const g=new b.$Qc;g.add(f.onProcessReady(O=>this.a.$sendProcessReady($,O.pid,O.cwd,O.windowsPty))),g.add(f.onDidChangeProperty(O=>this.a.$sendProcessProperty($,O))),this.y.startBuffering($,f.onProcessData),g.add(f.onProcessExit(O=>this.U($,O))),this.g.set($,f);const P=this.j[$];return P&&f instanceof m&&(f.startSendingEvents(P.initialDimensions),delete this.j[$]),g}$acceptProcessAckDataEvent($,f){this.g.get($)?.acknowledgeDataEvent(f)}$acceptProcessInput($,f){this.g.get($)?.input(f)}$acceptTerminalInteraction($){const f=this.W($);f?.setInteractedWith()&&this.M.fire(f.value)}$acceptTerminalSelection($,f){this.W($)?.setSelection(f)}$acceptProcessResize($,f,g){try{this.g.get($)?.resize(f,g)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown($,f){this.g.get($)?.shutdown(f)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(f=>this.a.$sendProcessProperty($,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(f=>this.a.$sendProcessProperty($,{type:"cwd",value:f}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new E.$cK(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,f,g){if(this.C.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.C.set(f,g),this.a.$registerProfileProvider(f,$.identifier.value),new E.$cK(()=>{this.C.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider($,f,g){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,g),this.a.$registerQuickFixProvider($,f),new E.$cK(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,f){const g=new v.$Wd().token;if(g.isCancellationRequested)return;const P=this.D.get($);if(!P)return;const O=await P.provideTerminalQuickFixes(f,g);if(O===null||Array.isArray(O)&&O.length===0)return;const N=new b.$Qc;if(this.w.value=N,!Array.isArray(O))return O?c.TerminalQuickFix.from(O,this.Q.converter,N):void 0;const L=[];for(const j of O){const z=c.TerminalQuickFix.from(j,this.Q.converter,N);z&&L.push(z)}return L}async $createContributedProfileTerminal($,f){const g=new v.$Wd().token;let P=await this.C.get($)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,f);return}this.createTerminalFromOptions(P.options,f)}}async $provideLinks($,f){const g=this.W($);if(!g)return[];this.F.delete($),this.G.get($)?.dispose(!0);const O=new v.$Wd;this.G.set($,O);const N=[],L={terminal:g.value,line:f},j=[];for(const K of this.z)j.push(l.Promises.withAsyncBody(async V=>{O.token.onCancellationRequested(()=>V({provider:K,links:[]}));const fe=await K.provideTerminalLinks(L,O.token)||[];O.token.isCancellationRequested||V({provider:K,links:fe})}));const z=await Promise.all(j);if(O.token.isCancellationRequested)return[];const T=new Map;for(const K of z)K&&K.links.length>0&&N.push(...K.links.map(V=>{const fe={id:h++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return T.set(fe.id,{provider:K.provider,link:V}),fe}));return this.F.set($,T),N}$activateLink($,f){const g=this.F.get($)?.get(f);g&&g.provider.handleTerminalLink(g.link)}U($,f){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const g=this.h[$];g&&(g.dispose(),delete this.h[$]),this.a.$sendProcessExit($,f)}W($){return this.X(this.f,$)}X($,f){const g=this.Y($,f);return g!==null?$[g]:null}Y($,f){const g=$.findIndex(P=>P._id===f);return g===-1?null:g}getEnvironmentVariableCollection($){let f=this.n.get($.identifier.value);return f||(f=new n,this.$($.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}Z($,f){const g=(0,I.$hr)(f.map),P=(0,I.$ir)(f.descriptionMap);this.a.$setEnvironmentVariableCollection($,f.persistent,g.length===0?void 0:g,P)}$initEnvironmentVariableCollections($){$.forEach(f=>{const g=f[0],P=new n(f[1]);this.$(g,P)})}$acceptDefaultProfile($,f){const g=this.s;this.s=$,this.u=f,g?.path!==$.path&&this.N.fire($.path)}$($,f){this.n.set($,f),f.onDidChangeCollection(()=>{this.Z($,f)})}};e.$kcc=t,e.$kcc=t=He([Be(1,r.$xM),Be(2,A.$bM)],t);class n{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$Md,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const f=this.h($);let g=this.a.get(f);return g||(g=new a(this,$),this.a.set(f,g),g.onDidChangeCollection(()=>this.d.fire())),g}replace($,f,g,P){this.f($,{value:f,type:E.EnvironmentVariableMutatorType.Replace,options:g??{applyAtProcessCreation:!0},scope:P})}append($,f,g,P){this.f($,{value:f,type:E.EnvironmentVariableMutatorType.Append,options:g??{applyAtProcessCreation:!0},scope:P})}prepend($,f,g,P){this.f($,{value:f,type:E.EnvironmentVariableMutatorType.Prepend,options:g??{applyAtProcessCreation:!0},scope:P})}f($,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const g=this.g($,f.scope),P=this.map.get(g),O=f.options?{applyAtProcessCreation:f.options.applyAtProcessCreation??!1,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==f.value||P.type!==f.type||P.options?.applyAtProcessCreation!==O.applyAtProcessCreation||P.options?.applyAtShellIntegration!==O.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const N=this.g($,f.scope),L={variable:$,...f,options:O};this.map.set(N,L),this.d.fire()}}get($,f){const g=this.g($,f),P=this.map.get(g);return P?S(P):void 0}g($,f){const g=this.h(f);return g.length?`${$}:::${g}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const f=new Map;for(const[g,P]of this.map)this.h(P.scope)===this.h($)&&f.set(P.variable,S(P));return f}delete($,f){const g=this.g($,f);this.map.delete(g),this.d.fire()}clear($){if($?.workspaceFolder){for(const[f,g]of this.map)g.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(f);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,f){const g=this.h(f),P=this.descriptionMap.get(g);if(!P||P.description!==$){let O;typeof $=="string"?O=$:O=$?.value.split(`

`)[0];const N={description:O,scope:f};this.descriptionMap.set(g,N),this.d.fire()}}getDescription($){const f=this.h($);return this.descriptionMap.get(f)?.description}k($){const f=this.h($);this.descriptionMap.delete(f)}}class a{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,f){this.b=$,this.d=f,this.a=new C.$Md}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,f,g){this.b.replace($,f,g,this.d)}append($,f,g){this.b.append($,f,g,this.d)}prepend($,f,g){this.b.prepend($,f,g,this.d)}get($){return this.b.get($,this.d)}forEach($,f){this.b.getVariableMap(this.d).forEach((g,P)=>$.call(f,P,g,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let i=class extends t{constructor($,f){super(!1,$,f)}createTerminal($,f,g){throw new R.$$}createTerminalFromOptions($,f){throw new R.$$}};e.$lcc=i,e.$lcc=i=He([Be(0,r.$xM),Be(1,A.$bM)],i);function s(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function u(k){return p.ThemeColor.isThemeColor(k)?k:void 0}function S(k){const $={...k};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(De[327],Ce([1,0,118,9,22,21,4,74,52,3,24,18,31,6,20,145,14,7,67,109,87,26]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=e.$tdc=e.$sdc=void 0;let t=class{constructor(L,j,z){this.k=z,this.d=new A.$Md,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=L.getProxy(y.$aK.MainThreadTesting),this.j=new g(this.g),this.h=new s(this.g),j.registerArgumentProcessor({processArgument:T=>{switch(T?.$mid){case 16:{const K=T,V=K.tests[K.tests.length-1].item.extId;return this.f.get(r.$6I.root(V))?.collection.tree.get(V)?.actual??(0,p.$nM)(T)}case 18:{const{extId:K,message:V}=T;return{test:this.f.get(r.$6I.root(K))?.collection.tree.get(K)?.actual,message:l.TestMessage.to(V)}}default:return T}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const T=await j.executeCommand("_testing.getExplorerSelection"),K=V=>{const fe=this.f.get(r.$6I.root(V));if(fe)return r.$6I.isRoot(V)?fe.controller:fe.collection.tree.get(V)?.actual};return{include:T?.include.map(K).filter(I.$Ff)||[],exclude:T?.exclude.map(K).filter(I.$Ff)||[]}})}createTestController(L,j,z,T){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const K=new w.$Qc,V=K.add(new p.$qM(j,z,this.k));V.root.label=z;const fe=new Map,X=this.g,Q={items:V.root.children,get label(){return z},set label(oe){z=oe,V.root.label=oe,X.$updateController(j,{label:z})},get refreshHandler(){return T},set refreshHandler(oe){T=oe,X.$updateController(j,{canRefresh:!!oe})},get id(){return j},createRunProfile:(oe,x,ae,ve,G,U)=>{let q=(0,E.$Bi)(oe);for(;fe.has(q);)q++;return new P(this.g,fe,j,q,oe,x,ae,ve,G,U)},createTestItem(oe,x,ae){return new p.$oM(j,oe,x,ae)},createTestRun:(oe,x,ae=!0)=>this.h.createTestRun(L,j,V,oe,x,ae),invalidateTestResults:oe=>{if(oe===void 0)this.g.$markTestRetired(void 0);else{const x=oe instanceof Array?oe:[oe];this.g.$markTestRetired(x.map(ae=>r.$6I.fromExtHostTestItem(ae,j).toString()))}},set resolveHandler(oe){V.resolveHandler=oe},get resolveHandler(){return V.resolveHandler},dispose:()=>{K.dispose()}};X.$registerTestController(j,z,!!T),K.add((0,w.$Pc)(()=>X.$unregisterTestController(j)));const Z={controller:Q,collection:V,profiles:fe,extension:L};return this.f.set(j,Z),K.add((0,w.$Pc)(()=>this.f.delete(j))),K.add(V.onDidGenerateDiff(oe=>X.$publishDiff(j,oe.map(m.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.j.checkout()}async runTests(L,j=M.CancellationToken.None){const z=u(L);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const T=this.f.get(z.controllerId);if(!T)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(K=>r.$6I.fromExtHostTestItem(K,T.collection.root.id).toString())??[T.collection.root.id],profileGroup:O[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:L.exclude?.map(K=>K.id)},j)}$syncTests(){for(const{collection:L}of this.f.values())L.flushDiff();return Promise.resolve()}$provideFileCoverage(L,j,z){return(0,C.$qb)(this.h.trackers,K=>K.id===L?K.getCoverage(j):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(L,j,z,T){return(0,C.$qb)(this.h.trackers,V=>V.id===L?V.getCoverage(j):void 0)?.resolveFileCoverage(z,T)??Promise.resolve([])}$configureRunProfile(L,j){this.f.get(L)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(L,j){await this.f.get(L)?.controller.refreshHandler?.(j)}$publishTestResults(L){this.results=Object.freeze(L.map(j=>(0,R.$4m)(l.TestResults.to(j))).concat(this.results).sort((j,z)=>z.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(L,j){const z=this.f.get(r.$6I.fromString(L).controllerId)?.collection;z&&(await z.expand(L,j<0?1/0:j),z.flushDiff())}$acceptDiff(L){this.j.applyDiff(L.map(m.TestsDiffOp.deserialize))}async $runControllerTests(L,j){return Promise.all(L.map(z=>this.l(z,!1,j)))}async $startContinuousRun(L,j){const z=new M.$Wd(j),T=await Promise.all(L.map(K=>this.l(K,!0,z.token)));return!j.isCancellationRequested&&!T.some(K=>K.error)&&await new Promise(K=>j.onCancellationRequested(K)),z.dispose(!0),T}async l(L,j,z){const T=this.f.get(L.controllerId);if(!T)return{};const{collection:K,profiles:V,extension:fe}=T,X=V.get(L.profileId);if(!X)return{};const Q=L.testIds.map(ae=>K.tree.get(ae)).filter(I.$Ff),Z=L.excludeExtIds.map(ae=>T.collection.tree.get(ae)).filter(I.$Ff).filter(ae=>Q.some(ve=>ve.fullId.compare(ae.fullId)===2));if(!Q.length)return{};const oe=new c.$KL(Q.some(ae=>ae.actual instanceof p.$pM)?void 0:Q.map(ae=>ae.actual),Z.map(ae=>ae.actual),X,j),x=(0,m.$8I)(L)&&this.h.prepareForMainThreadTestRun(oe,S.fromInternal(L,T.collection),fe,z);try{return await X.runHandler(oe,z),{}}catch(ae){return{error:String(ae)}}finally{x&&(x.hasRunningTasks&&!z.isCancellationRequested&&await A.Event.toPromise(x.onEnd),x.dispose())}}$cancelExtensionTestRun(L){L===void 0?this.h.cancelAllRuns():this.h.cancelRunById(L)}};e.$sdc=t,e.$sdc=t=He([Be(0,D.$bM)],t);const n=1e4;var a;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(a||(a={}));class i extends w.$Rc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(L,j,z,T){super(),this.s=L,this.u=j,this.w=z,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$Md),this.onEnd=this.m.event,this.j=this.B(new M.$Wd(T));const K=this.B(new F.$5g(()=>this.y(),n));this.B(this.j.token.onCancellationRequested(()=>K.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(L){return this.g.get(L)?.coverage}createRun(L){const j=this.s.id,z=this.s.controllerId,T=(0,v.$dg)(),K=new k(this.u,j,T),V=Z=>(oe,...x)=>{if(X){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.s.isIncluded(oe)&&(this.C(oe),Z(oe,...x))},fe=(Z,oe)=>{const x=oe instanceof Array?oe.map(l.TestMessage.from):[l.TestMessage.from(oe)];if(x.some(ae=>ae.contextValue!==void 0)&&(0,h.$aF)(this.w,"testMessageContextValue"),Z.uri&&Z.range){const ae={range:l.Range.from(Z.range),uri:Z.uri};for(const ve of x)ve.location=ve.location||ae}this.u.$appendTestMessagesInRun(j,T,r.$6I.fromExtHostTestItem(Z,z).toString(),x)};let X=!1;const Q={isPersisted:this.s.isPersisted,token:this.j.token,name:L,get coverageProvider(){return K.coverageProvider},set coverageProvider(Z){K.coverageProvider=Z},enqueued:V(Z=>{this.u.$updateTestStateInRun(j,T,r.$6I.fromExtHostTestItem(Z,z).toString(),1)}),skipped:V(Z=>{this.u.$updateTestStateInRun(j,T,r.$6I.fromExtHostTestItem(Z,z).toString(),5)}),started:V(Z=>{this.u.$updateTestStateInRun(j,T,r.$6I.fromExtHostTestItem(Z,z).toString(),2)}),errored:V((Z,oe,x)=>{fe(Z,oe),this.u.$updateTestStateInRun(j,T,r.$6I.fromExtHostTestItem(Z,z).toString(),6,x)}),failed:V((Z,oe,x)=>{fe(Z,oe),this.u.$updateTestStateInRun(j,T,r.$6I.fromExtHostTestItem(Z,z).toString(),4,x)}),passed:V((Z,oe)=>{this.u.$updateTestStateInRun(j,T,r.$6I.fromExtHostTestItem(Z,this.s.controllerId).toString(),3,oe)}),appendOutput:(Z,oe,x)=>{X||(x&&(this.s.isIncluded(x)?this.C(x):x=void 0),this.u.$appendOutputToRun(j,T,d.$ae.fromString(Z),oe&&l.location.from(oe),x&&r.$6I.fromExtHostTestItem(x,z).toString()))},end:()=>{X||(X=!0,this.u.$finishedTestRunTask(j,T),this.g.delete(T),this.g.size||this.z())}};return this.g.set(T,{run:Q,coverage:K}),this.u.$startedTestRunTask(j,{id:T,name:L,running:!0}),Q}y(){for(const{run:L}of this.g.values())L.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(L){if(!(L instanceof p.$oM))throw new o.$6L(L.id);if(this.h.has(r.$6I.fromExtHostTestItem(L,this.s.controllerId).toString()))return;const j=[],z=this.s.colllection.root;for(;;){const T=l.TestItem.from(L);if(j.unshift(T),this.h.has(T.extId)||(this.h.add(T.extId),L===z))break;L=L.parent||z}this.u.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.z(),super.dispose()}}class s{get trackers(){return this.d.values()}constructor(L){this.f=L,this.d=new Map}prepareForMainThreadTestRun(L,j,z,T){return this.g(L,j,z,T)}cancelRunById(L){for(const j of this.d.values())if(j.id===L){j.cancel();return}}cancelAllRuns(){for(const L of this.d.values())L.cancel()}createTestRun(L,j,z,T,K,V){const fe=this.d.get(T);if(fe)return fe.createRun(K);const X=S.fromPublic(j,z,T,V),Q=u(T);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!T.continuous,profile:Q&&{group:O[Q.kind],id:Q.profileId},exclude:T.exclude?.map(oe=>r.$6I.fromExtHostTestItem(oe,z.root.id).toString())??[],id:X.id,include:T.include?.map(oe=>r.$6I.fromExtHostTestItem(oe,z.root.id).toString())??[z.root.id],persist:V});const Z=this.g(T,X,L);return A.Event.once(Z.onEnd)(()=>{this.f.$finishedExtensionTestRun(X.id),Z.dispose()}),Z.createRun(K)}g(L,j,z,T){const K=new i(j,this.f,z,T);return this.d.set(L,K),A.Event.once(K.onEnd)(()=>this.d.delete(L)),K}}e.$tdc=s;const u=N=>{if(N.profile){if(!(N.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class S{static fromPublic(L,j,z,T){return new S(L,(0,v.$dg)(),z.include?.map(K=>r.$6I.fromExtHostTestItem(K,L).toString())??[L],z.exclude?.map(K=>r.$6I.fromExtHostTestItem(K,L).toString())??[],T,j)}static fromInternal(L,j){return new S(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,j)}constructor(L,j,z,T,K,V){this.controllerId=L,this.id=j,this.isPersisted=K,this.colllection=V,this.d=z.map(fe=>fe+"\0"),this.f=T.map(fe=>fe+"\0")}isIncluded(L){const j=r.$6I.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const z of this.f)if(j===z||j.startsWith(z))return!1;for(const z of this.d)if(j===z||j.startsWith(z))return!0;return!1}}e.$udc=S;class k{set coverageProvider(L){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");L&&(this.d=L,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(L,j,z){this.g=L,this.h=j,this.j=z}async provideFileCoverage(L){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(L))());try{return(await this.f)?.map(l.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(L,j){const z=await this.f;let T=z?.[L];return!this.d||!z||!T?[]:(T.detailedCoverage||(T=z[L]=await this.d.resolveFileCoverage?.(T,j)??T),T.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class ${get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(L){this.j=L,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(L){this.d.add(L)}update(L){Object.assign(L.revived,l.TestItem.toPlain(L.item)),this.d.has(L)||this.f.add(L)}remove(L){if(this.d.has(L)){this.d.delete(L);return}this.f.delete(L);const j=r.$6I.parentId(L.item.extId);if(j&&this.h.has(j.toString())){this.h.add(L.item.extId);return}this.g.add(L)}getChangeEvent(){const{d:L,f:j,g:z}=this;return{get added(){return[...L].map(T=>T.revived)},get updated(){return[...j].map(T=>T.revived)},get removed(){return[...z].map(T=>T.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class f extends m.$aJ{constructor(){super(...arguments),this.s=new A.$Md,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(L){return this.f.get(L)}getMirroredTestDataByReference(L){return this.f.get(L.id)}q(L,j){return{...L,revived:l.TestItem.toPlain(L.item),depth:j?j.depth+1:0,children:new Set}}p(){return new $(this.s)}}class g{constructor(L){this.f=L}checkout(){this.d||(this.d=this.g());const L=this.d;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(j=>j.revived)},dispose:(0,b.$cb)(()=>{--L.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(L){return this.d?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.d?.tests.apply(L)}g(){const L=new f;return this.f.$subscribeToDiffs(),{observers:0,tests:L}}}class P{#e;#t;get label(){return this.f}set label(L){L!==this.f&&(this.f=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(L){L!==this.h&&(this.h=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:L}))}get isDefault(){return this.g}set isDefault(L){L!==this.g&&(this.g=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?l.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this.d}set configureHandler(L){L!==this.d&&(this.d=L,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}constructor(L,j,z,T,K,V,fe,X=!1,Q=void 0,Z=!1){this.controllerId=z,this.profileId=T,this.f=K,this.kind=V,this.runHandler=fe,this.g=X,this._tag=Q,this.h=Z,this.#e=L,this.#t=j,j.set(T,this);const oe=O[V];if(typeof oe!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);this.#e.$publishTestRunProfile({profileId:T,controllerId:z,tag:Q?l.TestTag.namespace(this.controllerId,Q.id):null,label:K,group:oe,isDefault:X,hasConfigurationHandler:!1,supportsContinuousRun:Z})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$vdc=P;const O={[c.TestRunProfileKind.Coverage]:8,[c.TestRunProfileKind.Debug]:4,[c.TestRunProfileKind.Run]:2}}),define(De[328],Ce([1,0,19,8,4,6,146,14,7]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0;class w{constructor(I,v){this.i=v,this.a=new d.$Md({onListenerError:F.$1}),this.b=new d.$Md({onListenerError:F.$1}),this.c=new d.$Md({onListenerError:F.$1}),this.d=new d.$Md({onListenerError:F.$1}),this.f=new d.$Md({onListenerError:F.$1}),this.g=new d.$Md({onListenerError:F.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(M.$aK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const v=this.i.allEditors();return I?v:v.map(y=>y.value)}async showTextDocument(I,v,y){let D;typeof v=="number"?D={position:b.ViewColumn.from(v),preserveFocus:y}:typeof v=="object"?D={position:b.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selection:typeof v.selection=="object"?b.Range.from(v.selection):void 0,pinned:typeof v.preview=="boolean"?!v.preview:void 0}:D={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(I.uri,D),l=p&&this.i.getEditor(p);if(l)return l.value;throw p?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,v){return new A.$iM(this.h,I,v).value}$acceptEditorPropertiesChanged(I,v){const y=this.i.getEditor(I);if(!y)throw new Error("unknown text editor");if(v.options&&y._acceptOptions(v.options),v.selections){const D=v.selections.selections.map(b.Selection.to);y._acceptSelections(D)}if(v.visibleRanges){const D=C.$Gb(v.visibleRanges.map(b.Range.to));y._acceptVisibleRanges(D)}if(v.options&&this.b.fire({textEditor:y.value,options:{...v.options,lineNumbers:b.TextEditorLineNumbersStyle.to(v.options.lineNumbers)}}),v.selections){const D=E.TextEditorSelectionChangeKind.fromValue(v.selections.source),p=v.selections.selections.map(b.Selection.to);this.a.fire({textEditor:y.value,selections:p,kind:D})}if(v.visibleRanges){const D=C.$Gb(v.visibleRanges.map(b.Range.to));this.c.fire({textEditor:y.value,visibleRanges:D})}}$acceptEditorPositionData(I){for(const v in I){const y=this.i.getEditor(v);if(!y)throw new Error("Unknown text editor");const D=b.ViewColumn.to(I[v]);y.value.viewColumn!==D&&(y._acceptViewColumn(D),this.d.fire({textEditor:y.value,viewColumn:D}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$Kcc=w}),define(De[329],Ce([1,0,2,5,6,3,7,14,25,18]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=void 0,e.$mdc=(0,F.$Nh)("IExtHostTimeline");class R{constructor(y,D){this.b=new Map,this.c=new Map,this.a=y.getProxy(d.$aK.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(p,l)=>{if(p&&p.$mid===12)if(this.b.get(p.source)&&E.$3l.equals(l,this.b.get(p.source)?.extension)){const c=p.uri===void 0?void 0:C.URI.revive(p.uri);return this.c.get(p.source)?.get(I(c))?.get(p.handle)}else return;return p}})}async $getTimeline(y,D,p,l){return this.b.get(y)?.provider.provideTimeline(C.URI.revive(D),p,l)}registerTimelineProvider(y,D,p,l){const c=new M.$Qc,r=this.d(D.id,l,c).bind(this);let o;D.onDidChange&&(o=D.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:D.id}),this));const m=this.c;return this.f({...D,scheme:y,onDidChange:void 0,async provideTimeline(h,t,n){t?.resetCache&&(c.clear(),m.get(D.id)?.clear());const a=await D.provideTimeline(h,t,n);if(a==null)return;const i=r(h,t);return{...a,source:D.id,items:a.items.map(i)}},dispose(){for(const h of m.values())h.get(D.id)?.clear();o?.dispose(),c.dispose()}},p)}d(y,D,p){return(l,c)=>{let r;if(c?.cacheResults){let o=this.c.get(y);o===void 0&&(o=new Map,this.c.set(y,o));const m=I(l);r=o.get(m),r===void 0&&(r=new Map,o.set(m,r))}return o=>{const{iconPath:m,...h}=o,t=`${y}|${o.id??o.timestamp}`;r?.set(t,o);let n,a,i;o.iconPath&&(m instanceof A.$9K?i={id:m.id,color:m.color}:C.URI.isUri(m)?(n=m,a=m):{light:n,dark:a}=m);let s;return A.$CK.isMarkdownString(h.tooltip)?s=b.MarkdownString.from(h.tooltip):(0,w.$xf)(h.tooltip)?s=h.tooltip:A.$CK.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=b.MarkdownString.from(h.detail)):(0,w.$xf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=h.detail),{...h,id:h.id??void 0,handle:t,source:y,command:o.command?D.toInternal(o.command,p):void 0,icon:n,iconDark:a,themeIcon:i,tooltip:s,accessibilityInformation:o.accessibilityInformation}}}}f(y,D){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:D}),(0,M.$Pc)(()=>{for(const l of this.c.values())l.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$ndc=R;function I(v){return v?.toString()}}),define(De[72],Ce([1,0,21,4,3,213,5,13,86,6,27,20,7]),function($e,e,C,F,d,M,A,b,E,w,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xvb=e.$Wvb=e.TunnelDtoConverter=void 0;class y extends E.$bv{}var D;(function(l){function c(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:o.protocol}}l.fromApiTunnel=c;function r(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==E.TunnelPrivacyId.ConstantPrivate&&o.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}l.fromServiceTunnel=r})(D||(e.TunnelDtoConverter=D={})),e.$Wvb=(0,A.$Nh)("IExtHostTunnelService");let p=class extends d.$Rc{constructor(c,r,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$Md,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(w.$aK.MainThreadTunnelService)}async openTunnel(c,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const o=await this.a.$openTunnel(r,c.displayName);if(o){const m=new y(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(m),m}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,r){const o=this.u();return this.r.set(o,{selector:c,provider:r}),this.a.$registerPortsAttributesProvider(c,o),new v.$cK(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(c,r,o,m,h){const t=[];for(const a of c){const i=this.r.get(a);if(!i)return[];t.push(...await Promise.all(r.map(async s=>{let u;try{u=await i.provider.providePortAttributes({port:s,pid:o,commandLine:m},h)}catch{u=await i.provider.providePortAttributes(s,o,m,h)}return{providedAttributes:u,port:s}})))}const n=t.filter(a=>!!a.providedAttributes);return n.length>0?n.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(m,h)=>await c.provideTunnel(m,h,new C.$Wd().token)??void 0;const o=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,d.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,r){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const o=c.tunnelFactory??(r?this.w(r):void 0);if(o){this.b=o;let m=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const h=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:m}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,d.$Pc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,r){if(this.g.has(c.host)){const o=this.g.get(c.host);o.has(c.port)&&(r&&o.get(c.port).disposeListener.dispose(),await o.get(c.port).tunnel.dispose(),o.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(c,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const m=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),m===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const h=this.B(m.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(m.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:m,disposeListener:h}),D.fromApiTunnel(m)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(c){const r=await Promise.all(c.map(m=>this.f(m.host,m.port,m.detail??""))),o=c.filter((m,h)=>r[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(m=>m.port).join(", ")} to ${o.map(m=>m.port).join(", ")}`),o}};e.$Xvb=p,e.$Xvb=p=He([Be(0,I.$bM),Be(1,R.$rM),Be(2,b.$8i)],p)}),define(De[330],Ce([1,0,3,17,2,6]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class A{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(M.$aK.MainThreadUriOpeners)}registerExternalUriOpener(E,w,R,I){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const v=I.schemes.find(y=>!A.a.has(y));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(w,R),this.b.$registerUriOpener(w,I.schemes,E,I.label),(0,C.$Pc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(E,w,R){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const v=d.URI.revive(w);return I.canOpenExternalUri(v,R)}async $openUri(E,w,R){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(d.URI.revive(w.resolvedUri),{sourceUri:d.URI.revive(w.sourceUri)},R)}}e.$wdc=A}),define(De[331],Ce([1,0,6,2,3,8,25]),function($e,e,C,F,d,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class b{static{this.a=0}constructor(w){this.c=new A.$4l,this.d=new Map,this.b=w.getProxy(C.$aK.MainThreadUrls)}registerUriHandler(w,R){const I=w.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const v=b.a++;return this.c.add(I),this.d.set(v,R),this.b.$registerUriHandler(v,I,w.displayName||w.name),(0,d.$Pc)(()=>{this.c.delete(I),this.d.delete(v),this.b.$unregisterUriHandler(v)})}$handleExternalUri(w,R){const I=this.d.get(w);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(R))}catch(v){(0,M.$Z)(v)}return Promise.resolve(void 0)}async createAppUri(w){return F.URI.revive(await this.b.$createAppUri(w))}}e.$Mcc=b}),define(De[91],Ce([1,0,4,3,17,24,2,228,265,110,6]),function($e,e,C,F,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=e.$Pcc=e.$Occ=e.$Ncc=void 0;class I{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(m,h,t,n,a,i,s){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new C.$Md,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$Md,this._onDidDispose=this.#h.event,this.#e=m,this.#t=h,this.#r=t,this.#l=n,this.#u=a,this.#n=i,this.#c=v(i),this.#d=y(i),this.#i=s}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return this.#a=!0,(0,w.$1ob)(m,this.#l)}get cspSource(){const m=this.#n.extensionLocation;if(m.scheme===d.Schemas.https||m.scheme===d.Schemas.http){let h=m.toString();return h.endsWith("/")||(h+="/"),h+" "+w.$Zob}return w.$Zob}get html(){return this.a(),this.#s}set html(m){this.a(),this.#s!==m&&(this.#s=m,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(m)))}get options(){return this.a(),this.#r}set options(m){this.a(),M.$7m(this.#r,m)||this.#t.$setOptions(this.#e,l(this.#n,this.#u,m)),this.#r=m}async postMessage(m){if(this.#o)return!1;const h=(0,E.$scb)(m,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(m){if(!this.#d)return m;const h=this.#n.extensionLocation?.scheme===d.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===d.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return m.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,a,i,s,u,S)=>{const k=A.URI.from({scheme:s||"file",path:decodeURIComponent(u)}),$=(0,w.$1ob)(k,{isRemote:h,authority:t}).toString();return`${a}${$}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,a,i,s,u,S)=>{const k=A.URI.from({scheme:s||"file",path:decodeURIComponent(u)}),$=(0,w.$1ob)(k,{isRemote:h,authority:t}).toString();return`${a}${$}${S}`})}}e.$Ncc=I;function v(o){try{const m=(0,b.$Ko)((0,b.$Jo)(o.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.$Occ=v;function y(o){try{const m=(0,b.$Ko)((0,b.$Jo)(o.engines.vscode));return m?m.majorBase<1||m.majorBase===1&&m.minorBase<60:!1}catch{return!1}}class D extends F.$Rc{constructor(m,h,t,n,a){super(),this.c=h,this.f=t,this.g=n,this.h=a,this.b=new Map,this.a=m.getProxy(R.$aK.MainThreadWebviews)}dispose(){super.dispose();for(const m of this.b.values())m.dispose();this.b.clear()}$onMessage(m,h,t){const n=this.j(m);if(n){const{message:a}=(0,E.$tcb)(h,t.value);n._onMessageEmitter.fire(a)}}$onMissingCsp(m,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,h,t){const n=new I(m,this.a,c(h),this.c,this.f,t,this.h);this.b.set(m,n);const a=n._onDidDispose(()=>{a.dispose(),this.deleteWebview(m)});return n}deleteWebview(m){this.b.delete(m)}j(m){return this.b.get(m)}}e.$Pcc=D;function p(o){return{id:o.identifier,location:o.extensionLocation}}e.$Qcc=p;function l(o,m,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||r(o,m)}}e.$Rcc=l;function c(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(m=>A.URI.from(m))}}function r(o,m){return[...(m?.getWorkspaceFolders()||[]).map(h=>h.uri),o.extensionLocation]}}),define(De[332],Ce([1,0,21,52,3,17,23,2,14,91,107,6,7]),function($e,e,C,F,d,M,A,b,E,w,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class y{constructor(n,a){this.document=n,this.b=a,this.a=1,this.c=new R.$Jbc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,a){await this.f(n).undo(),a||this.disposeBackup()}async redo(n,a){await this.f(n).redo(),a||this.disposeBackup()}disposeEdits(n){for(const a of n)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=h(this.document.uri)+this.a++;return(0,A.$ug)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const a=this.c.get(n,0);if(!a)throw new Error("No edit found");return a}}class D{constructor(){this.a=new Map}get(n,a){return this.a.get(this.b(n,a))}add(n,a,i){const s=this.b(n,a.uri);if(this.a.has(s))throw new Error(`Document already exists for viewType:${n} resource:${a.uri}`);const u=new y(a,i);return this.a.set(s,u),u}delete(n,a){const i=this.b(n,a.uri);this.a.delete(i)}b(n,a){return`${n}@@@${a}`}}var p;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(p||(p={}));class l{constructor(){this.a=new Map}addTextProvider(n,a,i){return this.b(0,n,a,i)}addCustomProvider(n,a,i){return this.b(1,n,a,i)}get(n){return this.a.get(n)}b(n,a,i,s){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:n,extension:i,provider:s}),new v.$cK(()=>this.a.delete(a))}}class c{constructor(n,a,i,s,u){this.d=a,this.f=i,this.g=s,this.h=u,this.b=new l,this.c=new D,this.a=n.getProxy(I.$aK.MainThreadCustomEditors)}registerCustomEditorProvider(n,a,i,s){const u=new d.$Qc;return o(i)?(u.add(this.b.addTextProvider(a,n,i)),this.a.$registerTextEditorProvider((0,w.$Qcc)(n),a,s.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,w.$Occ)(n))):(u.add(this.b.addCustomProvider(a,n,i)),r(i)&&u.add(i.onDidChangeCustomDocument(S=>{const k=this.i(a,S.document.uri);if(m(S)){const $=k.addEdit(S);this.a.$onDidEdit(S.document.uri,a,$,S.label)}else this.a.$onContentChange(S.document.uri,a)})),this.a.$registerCustomEditorProvider((0,w.$Qcc)(n),a,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,w.$Occ)(n))),v.$cK.from(u,new v.$cK(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(n,a,i,s,u){const S=this.b.get(a);if(!S)throw new Error(`No provider found for '${a}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${a}'`);const k=b.URI.revive(n),$=await S.provider.openCustomDocument(k,{backupId:i,untitledDocumentData:s?.buffer},u);let f;return r(S.provider)&&this.f&&(f=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(a,$,f),{editable:r(S.provider)}}async $disposeCustomDocument(n,a){const i=this.b.get(a);if(!i)throw new Error(`No provider found for '${a}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${a}'`);const s=b.URI.revive(n),{document:u}=this.i(a,s);this.c.delete(a,u),u.dispose()}async $resolveCustomEditor(n,a,i,s,u,S){const k=this.b.get(i);if(!k)throw new Error(`No provider found for '${i}'`);const $=E.ViewColumn.to(u),f=this.g.createNewWebview(a,s.contentOptions,k.extension),g=this.h.createNewWebviewPanel(a,i,s.title,$,s.options,f,s.active),P=b.URI.revive(n);switch(k.type){case 1:{const{document:O}=this.i(i,P);return k.provider.resolveCustomEditor(O,g,S)}case 0:{const O=this.d.getDocument(P);return k.provider.resolveCustomTextEditor(O,g,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,a,i){this.i(a,n).disposeEdits(i)}async $onMoveCustomEditor(n,a,i){const s=this.b.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const u=this.h.getWebviewPanel(n);if(!u)throw new Error("No webview found");const S=b.URI.revive(a),k=this.d.getDocument(S);await s.provider.moveCustomTextEditor(k,u,C.CancellationToken.None)}async $undo(n,a,i,s){return this.i(a,n).undo(i,s)}async $redo(n,a,i,s){return this.i(a,n).redo(i,s)}async $revert(n,a,i){const s=this.i(a,n);await this.j(a).revertCustomDocument(s.document,i),s.disposeBackup()}async $onSave(n,a,i){const s=this.i(a,n);await this.j(a).saveCustomDocument(s.document,i),s.disposeBackup()}async $onSaveAs(n,a,i,s){const u=this.i(a,n);return this.j(a).saveCustomDocumentAs(u.document,b.URI.revive(i),s)}async $backup(n,a,i){const s=this.i(a,n),S=await this.j(a).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},i);return s.updateBackup(S),S.id}i(n,a){const i=this.c.get(n,b.URI.revive(a));if(!i)throw new Error("No custom document found");return i}j(n){const i=this.b.get(n)?.provider;if(!i||!r(i))throw new Error("Custom document is not editable");return i}}e.$qdc=c;function r(t){return!!t.onDidChangeCustomDocument}function o(t){return typeof t.resolveCustomTextEditor=="function"}function m(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const n=t.scheme===M.Schemas.file||t.scheme===M.Schemas.untitled?t.fsPath:t.toString();return(0,F.$Bi)(n)+""}}),define(De[333],Ce([1,0,4,3,2,31,14,91,6,7]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0;class R extends F.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(D,p,l,c){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new C.$Md),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$Md),this.onDidChangeViewState=this.#h.event,this.#e=D,this.#t=p,this.#l=l,this.#i=c.viewType,this.#u=c.panelOptions,this.#r=c.viewColumn,this.#n=c.title,this.#a=c.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(D){this.c(),this.#n!==D&&(this.#n=D,this.#t.$setTitle(this.#e,D))}get iconPath(){return this.c(),this.#s}set iconPath(D){this.c(),this.#s!==D&&(this.#s=D,this.#t.$setIconPath(this.#e,d.URI.isUri(D)?{light:D,dark:D}:D))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(D){this.#c||(this.active!==D.active||this.visible!==D.visible||this.viewColumn!==D.viewColumn)&&(this.#a=D.active,this.#o=D.visible,this.#r=D.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(D,p){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof D>"u"?void 0:A.ViewColumn.from(D),preserveFocus:!!p})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I extends F.$Rc{static c(){return(0,M.$dg)()}constructor(D,p,l){super(),this.j=p,this.m=l,this.g=new Map,this.h=new Map,this.f=D.getProxy(E.$aK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(D=>D.dispose()),this.g.clear()}createWebviewPanel(D,p,l,c,r={}){const o=typeof c=="object"?c.viewColumn:c,m={viewColumn:A.ViewColumn.from(o),preserveFocus:typeof c=="object"&&!!c.preserveFocus},h=(0,b.$Occ)(D),t=I.c();this.f.$createWebviewPanel((0,b.$Qcc)(D),t,p,{title:l,panelOptions:v(r),webviewOptions:(0,b.$Rcc)(D,this.m,r),serializeBuffersForPostMessage:h},m);const n=this.j.createNewWebview(t,r,D);return this.createNewWebviewPanel(t,p,l,o,r,n,!0)}$onDidChangeWebviewPanelViewStates(D){const p=Object.keys(D);p.sort((l,c)=>{const r=D[l],o=D[c];return r.active?1:o.active?-1:+r.visible-+o.visible});for(const l of p){const c=this.getWebviewPanel(l);if(!c)continue;const r=D[l];c._updateViewState({active:r.active,visible:r.visible,viewColumn:A.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(D){this.getWebviewPanel(D)?.dispose(),this.g.delete(D),this.j.deleteWebview(D)}registerWebviewPanelSerializer(D,p,l){if(this.h.has(p))throw new Error(`Serializer for '${p}' already registered`);return this.h.set(p,{serializer:l,extension:D}),this.f.$registerSerializer(p,{serializeBuffersForPostMessage:(0,b.$Occ)(D)}),new w.$cK(()=>{this.h.delete(p),this.f.$unregisterSerializer(p)})}async $deserializeWebviewPanel(D,p,l,c){const r=this.h.get(p);if(!r)throw new Error(`No serializer found for '${p}'`);const{serializer:o,extension:m}=r,h=this.j.createNewWebview(D,l.webviewOptions,m),t=this.createNewWebviewPanel(D,p,l.title,c,l.panelOptions,h,l.active);await o.deserializeWebviewPanel(t,l.state)}createNewWebviewPanel(D,p,l,c,r,o,m){const h=new R(D,this.f,o,{viewType:p,title:l,viewColumn:c,panelOptions:r,active:m});return this.g.set(D,h),h}getWebviewPanel(D){return this.g.get(D)}}e.$pdc=I;function v(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(De[334],Ce([1,0,4,3,91,14,6,7]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;class E extends F.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,v,y,D,p,l){super(),this.#u=!1,this.#a=this.B(new C.$Md),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new C.$Md),this.onDidDispose=this.#c.event,this.#i=y,this.#s=D,this.#e=I,this.#t=v,this.#l=p,this.#n=l}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=M.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class w{constructor(I,v){this.d=v,this.b=new Map,this.c=new Map,this.a=I.getProxy(A.$aK.MainThreadWebviewViews)}registerWebviewViewProvider(I,v,y,D){if(this.b.has(v))throw new Error(`View provider for '${v}' already registered`);return this.b.set(v,{provider:y,extension:I}),this.a.$registerWebviewViewProvider((0,d.$Qcc)(I),v,{retainContextWhenHidden:D?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,d.$Occ)(I)}),new b.$cK(()=>{this.b.delete(v),this.a.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(I,v,y,D,p){const l=this.b.get(v);if(!l)throw new Error(`No view provider found for '${v}'`);const{provider:c,extension:r}=l,o=this.d.createNewWebview(I,{},r),m=new E(I,this.a,v,y,o,!0);this.c.set(I,m),await c.resolveWebviewView(m,{state:D},p)}async $onDidChangeWebviewViewVisibility(I,v){this.e(I)._setVisible(v)}async $disposeWebviewView(I){const v=this.e(I);this.c.delete(I),v.dispose(),this.d.deleteWebview(I)}e(I){const v=this.c.get(I);if(!v)throw new Error("No webview found");return v}}e.$odc=w}),define(De[151],Ce([1,0,4,6,2,17,15,5,20,26]),function($e,e,C,F,d,M,A,b,E,w){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=void 0;let I=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(y){const D=this.d;return{get focused(){return D.focused},get active(){return(0,w.$aF)(y,"windowActivity"),D.active}}}constructor(y){this.c=new C.$Md,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=y.getProxy(F.$aK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:p})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,D){D!==this.d[y]&&(this.d={...this.d,[y]:D},this.c.fire(this.d))}openUri(y,D){let p;if(typeof y=="string"){p=y;try{y=d.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,A.$Ae)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,p,D)}async asExternalUri(y,D){if((0,A.$Ae)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(y,D);return d.URI.from(p)}};e.$Scc=I,e.$Scc=I=R=He([Be(0,E.$bM)],I),e.$Tcc=(0,b.$Nh)("IExtHostWindow")}),define(De[335],Ce([1,0,303,27,20]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0;const M=1024*1024;let A=class extends C.$Rdc{constructor(E,w){super(E,w),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,w,R){const I=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),w.apply(console,R),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,w){const R=process[E],I=R.write;let v="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(y,D,p)=>{if(!this.g){v+=y.toString(D);const l=v.length>M?v.length:v.lastIndexOf(`
`);l!==-1&&(console[w](v.slice(0,l)),v=v.slice(l+1))}I.call(R,y,D,p)}})}};e.$qec=A,e.$qec=A=He([Be(0,d.$bM),Be(1,F.$rM)],A)}),define(De[336],Ce([1,0,71,17,13,240,30,12]),function($e,e,C,F,d,M,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;let E=class{constructor(I,v){I.addFileSystemProvider(F.Schemas.file,new w(v),{isCaseSensitive:b.$l})}};e.$rec=E,e.$rec=E=He([Be(0,C.$fcc),Be(1,d.$8i)],E);class w{constructor(I){this.b=I,this.a=new M.$0p(this.b)}async stat(I){const v=await this.a.stat(I);return{type:v.type,ctime:v.ctime,mtime:v.mtime,size:v.size,permissions:v.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,v,y){return this.a.writeFile(I,v,{...y,unlock:!1,atomic:!1})}delete(I,v){return this.a.delete(I,{...v,useTrash:!1,atomic:!1})}rename(I,v,y){return this.a.rename(I,v,y)}copy(I,v,y){return this.a.copy(I,v,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,v){throw new Error("Method not implemented.")}}}),define(De[337],Ce([1,0,16,63,31,33,3,6,2,20]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;let R=class extends A.$Rc{constructor(v,y){super();const D=v.getProxy(b.$aK.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async p=>{const l=E.URI.file((0,C.$ic)((0,F.tmpdir)(),(0,d.$dg)()));return await D.$download(p,l),l})}};e.$pec=R,e.$pec=R=He([Be(0,w.$bM),Be(1,M.$xM)],R)}),define(De[338],Ce([1,0,150,17,242,31]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;class A extends C.$Qdc{s(E,w,R){return E.scheme===F.Schemas.file?new d.$nN(R?.name||(0,M.$dg)(),E.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,w):super.s(E,w,R)}registerLogger(E){super.registerLogger(E),this.r.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.r.$deregisterLogger(E)}}e.$Cec=A}),define(De[339],Ce([1,0,53,16,2,90,3,17,9,29]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;class R extends M.$hcc{constructor(){super(...arguments),this.i=null}async g(t){const n=await super.g(t);if(n.scheme!==b.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const a=n.fsPath;let i=0;do{let s;i===0?s=a:s=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${i}`:`${a}-${i}`,await I(s);const u=F.$ic(s,"vscode.lock"),S=await p(this.d,u,!1);if(S)return this.i=S,process.on("exit",()=>{S.dispose()}),d.URI.file(s);i++}while(i<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Bec=R;async function I(h){try{await w.Promises.stat(h);return}catch{}try{await w.Promises.mkdir(h,{recursive:!0})}catch{}}const v=1e3,y=10*60*1e3;class D extends A.$Rc{constructor(t,n){super(),this.b=t,this.c=n,this.a=this.B(new E.$4g),this.a.cancelAndSet(async()=>{const a=await l(t,n);(!a||a.pid!==process.pid)&&(t.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await w.Promises.utimes(n,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${n}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{C.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+t};await w.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function p(h,t,n){try{const i={pid:process.pid,willReleaseAt:0};await w.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){h.error(i)}const a=await l(h,t);return!a||a.pid!==process.pid?n?(h.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(h.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),o(h,t)):(h.info(`Lock '${t}': Lock acquired.`),new D(h,t))}async function l(h,t){let n;try{n=await w.Promises.readFile(t)}catch(a){return h.error(a),null}try{return JSON.parse(String(n))}catch(a){return h.error(a),null}}async function c(h,t){let n;try{n=await w.Promises.stat(t)}catch(a){return h.error(a),0}return n.mtime.getTime()}function r(h){try{return process.kill(h,0),!0}catch{return!1}}async function o(h,t){const n=await l(h,t);if(!n)return h.info(`Lock '${t}': Could not read pid of lock holder.`),m(h,t);if(n.willReleaseAt){let S=n.willReleaseAt-Date.now();if(S<5e3){for(S>0?h.info(`Lock '${t}': The lockfile is scheduled to be released in ${S} ms.`):h.info(`Lock '${t}': The lockfile is scheduled to have been released.`);S>0;){if(await(0,E.$Tg)(Math.min(100,S)),await c(h,t)===0)return m(h,t);S=n.willReleaseAt-Date.now()}return m(h,t)}}if(!r(n.pid))return h.info(`Lock '${t}': The pid ${n.pid} appears to be gone.`),m(h,t);const a=await c(h,t),i=Date.now()-a;if(i<=y)return h.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;h.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Tg)(2e3);const s=await c(h,t),u=Date.now()-s;return u<=y?(h.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(h.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),m(h,t))}async function m(h,t){h.info(`Lock '${t}': Deleting a stale lock.`);try{await w.Promises.unlink(t)}catch{}return p(h,t,!0)}}),define(De[340],Ce([1,0,31,20,44,33]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;let A=class extends d.$kcc{constructor(E,w){super(!0,E,w)}createTerminal(E,w,R){return this.createTerminalFromOptions({name:E,shellPath:w,shellArgs:R})}createTerminalFromOptions(E,w){const R=new d.$jcc(this.a,(0,C.$dg)(),E,E.name);return this.f.push(R),R.create(E,this.R(E,w)),R.value}};e.$Wdc=A,e.$Wdc=A=He([Be(0,M.$xM),Be(1,F.$bM)],A)}),define(De[341],Ce([1,0,9,22,21,8,4,3,128,292,68]),function($e,e,C,F,d,M,A,b,E,w,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$i4b=e.ResponsiveState=e.RequestInitiator=e.$h4b=e.$g4b=void 0;function v(g,P){try{return JSON.stringify(g,P)}catch{return"null"}}const y="$$ref$$",D={[y]:-1};class p{constructor(P,O){this.jsonString=P,this.referencedBuffers=O}}function l(g,P=null,O=!1){const N=[];return{jsonString:(O?v:JSON.stringify)(g,(j,z)=>{if(typeof z>"u")return D;if(typeof z=="object"){if(z instanceof F.$ae){const T=N.push(z)-1;return{[y]:T}}if(P)return P(j,z)}return z}),referencedBuffers:N}}e.$g4b=l;function c(g,P,O){return JSON.parse(g,(N,L)=>{if(L){const j=L[y];if(typeof j=="number")return P[j];if(O&&L.$mid===1)return O.transformIncoming(L)}return L})}e.$h4b=c;function r(g,P){return JSON.stringify(g,P)}function o(g){return g?(P,O)=>O&&O.$mid===1?g.transformOutgoing(O):O:null}var m;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));var h;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},n=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class i extends b.$Rc{static{I=n}static{this.a=3*1e3}constructor(P,O=null,N=null){super(),this[I]=!0,this.b=this.B(new A.$Md),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=O,this.g=N,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let L=0,j=R.$iv.count;L<j;L++)this.m[L]=null,this.s[L]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$5g(()=>this.H(),1e3)),this.c.onMessage(L=>this.L(L))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const O=this.w[P];delete this.w[P],O.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+i.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+i.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,E.$Lm)(P,this.g):P}getProxy(P){const{nid:O,sid:N}=P;return this.s[O]||(this.s[O]=this.J(O,N)),this.s[O]}J(P,O){const N={get:(L,j)=>(typeof j=="string"&&!L[j]&&j.charCodeAt(0)===36&&(L[j]=(...z)=>this.U(P,j,z)),j===a?O:L[j])};return new Proxy(Object.create(null),N)}set(P,O){return this.m[P.nid]=O,O}assertRegistered(P){for(let O=0,N=P.length;O<N;O++){const L=P[O];if(!this.m[L.nid])throw new Error(`Missing proxy instance ${L.sid}`)}}L(P){if(this.j)return;const O=P.byteLength,N=u.read(P,0),L=N.readUInt8(),j=N.readUInt32();switch(L){case 1:case 2:{let{rpcId:z,method:T,args:K}=k.deserializeRequestJSONArgs(N);this.g&&(K=(0,E.$Lm)(K,this.g)),this.M(O,j,z,T,K,L===2);break}case 3:case 4:{let{rpcId:z,method:T,args:K}=k.deserializeRequestMixedArgs(N);this.g&&(K=(0,E.$Lm)(K,this.g)),this.M(O,j,z,T,K,L===4);break}case 5:{this.f?.logIncoming(O,j,0,"ack"),this.G(j);break}case 6:{this.N(O,j);break}case 7:{this.O(O,j,void 0);break}case 9:{let z=k.deserializeReplyOKJSON(N);this.g&&(z=(0,E.$Lm)(z,this.g)),this.O(O,j,z);break}case 10:{const z=k.deserializeReplyOKJSONWithBuffers(N,this.g);this.O(O,j,z);break}case 8:{const z=k.deserializeReplyOKVSBuffer(N);this.O(O,j,z);break}case 11:{let z=k.deserializeReplyErrError(N);this.g&&(z=(0,E.$Lm)(z,this.g)),this.P(O,j,z);break}case 12:{this.P(O,j,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,O,N,L,j,z){this.f?.logIncoming(P,O,1,`receiveRequest ${(0,R.$kv)(N)}.${L}(`,j);const T=String(O);let K,V;if(z){const X=new d.$Wd;j.push(X.token),K=this.Q(N,L,j),V=()=>X.cancel()}else K=this.Q(N,L,j),V=t;this.u[T]=V;const fe=k.serializeAcknowledged(O);this.f?.logOutgoing(fe.byteLength,O,1,"ack"),this.c.send(fe),K.then(X=>{delete this.u[T];const Q=k.serializeReplyOK(O,X,this.h);this.f?.logOutgoing(Q.byteLength,O,1,"reply:",X),this.c.send(Q)},X=>{delete this.u[T];const Q=k.serializeReplyErr(O,X);this.f?.logOutgoing(Q.byteLength,O,1,"replyErr:",X),this.c.send(Q)})}N(P,O){this.f?.logIncoming(P,O,1,"receiveCancel");const N=String(O);this.u[N]?.()}O(P,O,N){this.f?.logIncoming(P,O,0,"receiveReply:",N);const L=String(O);if(!this.w.hasOwnProperty(L))return;const j=this.w[L];delete this.w[L],j.resolveOk(N)}P(P,O,N){this.f?.logIncoming(P,O,0,"receiveReplyErr:",N);const L=String(O);if(!this.w.hasOwnProperty(L))return;const j=this.w[L];delete this.w[L];let z;N&&(N.$isError?(z=new Error,z.name=N.name,z.message=N.message,z.stack=N.stack):z=N),j.resolveErr(z)}Q(P,O,N){try{return Promise.resolve(this.S(P,O,N))}catch(L){return Promise.reject(L)}}S(P,O,N){const L=this.m[P];if(!L)throw new Error("Unknown actor "+(0,R.$kv)(P));const j=L[O];if(typeof j!="function")throw new Error("Unknown method "+O+" on actor "+(0,R.$kv)(P));return j.apply(L,N)}U(P,O,N){if(this.j)return new w.$f4b;let L=null;if(N.length>0&&d.CancellationToken.isCancellationToken(N[N.length-1])&&(L=N.pop()),L&&L.isCancellationRequested)return Promise.reject(M.$5());const j=k.serializeRequestArguments(N,this.h),z=++this.t,T=String(z),K=new w.$e4b,V=new b.$Qc;L&&V.add(L.onCancellationRequested(()=>{const X=k.serializeCancel(z);this.f?.logOutgoing(X.byteLength,z,0,"cancel"),this.c.send(k.serializeCancel(z))})),this.w[T]=new s(K,V),this.F(z);const fe=k.serializeRequest(z,P,O,j,!!L);return this.f?.logOutgoing(fe.byteLength,z,0,`request: ${(0,R.$kv)(P)}.${O}(`,N),this.c.send(fe),K}}e.$i4b=i;class s{constructor(P,O){this.a=P,this.b=O}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class u{static alloc(P,O,N){const L=new u(F.$ae.alloc(N+1+4),0);return L.writeUInt8(P),L.writeUInt32(O),L}static read(P,O){return new u(P,O)}get buffer(){return this.a}constructor(P,O){this.a=P,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const N=this.a.slice(this.b,this.b+P).toString();return this.b+=P,N}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+P).toString();return this.b+=P,N}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+P);return this.b+=P,O}static sizeMixedArray(P){let O=0;O+=1;for(let N=0,L=P.length;N<L;N++){const j=P[N];switch(O+=1,j.type){case 1:O+=this.sizeLongString(j.value);break;case 2:O+=this.sizeVSBuffer(j.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(j.value);for(let z=0;z<j.buffers.length;++z)O+=this.sizeVSBuffer(j.buffers[z]);break;case 4:break}}return O}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let O=0,N=P.length;O<N;O++){const L=P[O];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let j=0;j<L.buffers.length;++j)this.writeBuffer(L.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const O=new Array(P);for(let N=0;N<P;N++)switch(this.readUInt8()){case 1:O[N]=this.readLongString();break;case 2:O[N]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),z=this.readLongString(),T=[];for(let K=0;K<j;++K)T.push(this.readVSBuffer());O[N]=new R.$lv(c(z,T,null));break}case 4:O[N]=void 0;break}return O}}var S;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(S||(S={}));class k{static a(P){for(let O=0,N=P.length;O<N;O++)if(P[O]instanceof F.$ae||P[O]instanceof R.$lv||typeof P[O]>"u")return!0;return!1}static serializeRequestArguments(P,O){if(this.a(P)){const N=[];for(let L=0,j=P.length;L<j;L++){const z=P[L];if(z instanceof F.$ae)N[L]={type:2,value:z};else if(typeof z>"u")N[L]={type:4};else if(z instanceof R.$lv){const{jsonString:T,referencedBuffers:K}=l(z.value,O);N[L]={type:3,value:F.$ae.fromString(T),buffers:K}}else N[L]={type:1,value:F.$ae.fromString(r(z,O))}}return{type:1,args:N}}return{type:0,args:r(P,O)}}static serializeRequest(P,O,N,L,j){switch(L.type){case 0:return this.b(P,O,N,L.args,j);case 1:return this.c(P,O,N,L.args,j)}}static b(P,O,N,L,j){const z=F.$ae.fromString(N),T=F.$ae.fromString(L);let K=0;K+=u.sizeUInt8(),K+=u.sizeShortString(z),K+=u.sizeLongString(T);const V=u.alloc(j?2:1,P,K);return V.writeUInt8(O),V.writeShortString(z),V.writeLongString(T),V.buffer}static deserializeRequestJSONArgs(P){const O=P.readUInt8(),N=P.readShortString(),L=P.readLongString();return{rpcId:O,method:N,args:JSON.parse(L)}}static c(P,O,N,L,j){const z=F.$ae.fromString(N);let T=0;T+=u.sizeUInt8(),T+=u.sizeShortString(z),T+=u.sizeMixedArray(L);const K=u.alloc(j?4:3,P,T);return K.writeUInt8(O),K.writeShortString(z),K.writeMixedArray(L),K.buffer}static deserializeRequestMixedArgs(P){const O=P.readUInt8(),N=P.readShortString(),L=P.readMixedArray(),j=new Array(L.length);for(let z=0,T=L.length;z<T;z++){const K=L[z];typeof K=="string"?j[z]=JSON.parse(K):j[z]=K}return{rpcId:O,method:N,args:j}}static serializeAcknowledged(P){return u.alloc(5,P,0).buffer}static serializeCancel(P){return u.alloc(6,P,0).buffer}static serializeReplyOK(P,O,N){if(typeof O>"u")return this.d(P);if(O instanceof F.$ae)return this.e(P,O);if(O instanceof R.$lv){const{jsonString:L,referencedBuffers:j}=l(O.value,N,!0);return this.g(P,L,j)}else return this.f(P,v(O,N))}static d(P){return u.alloc(7,P,0).buffer}static e(P,O){let N=0;N+=u.sizeVSBuffer(O);const L=u.alloc(8,P,N);return L.writeVSBuffer(O),L.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,O){const N=F.$ae.fromString(O);let L=0;L+=u.sizeLongString(N);const j=u.alloc(9,P,L);return j.writeLongString(N),j.buffer}static g(P,O,N){const L=F.$ae.fromString(O);let j=0;j+=u.sizeUInt32,j+=u.sizeLongString(L);for(const T of N)j+=u.sizeVSBuffer(T);const z=u.alloc(10,P,j);z.writeUInt32(N.length),z.writeLongString(L);for(const T of N)z.writeBuffer(T);return z.buffer}static deserializeReplyOKJSON(P){const O=P.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(P,O){const N=P.readUInt32(),L=P.readLongString(),j=[];for(let z=0;z<N;++z)j.push(P.readVSBuffer());return new R.$lv(c(L,j,O))}static serializeReplyErr(P,O){const N=O?v(M.$2(O),null):void 0;if(typeof N!="string")return this.h(P);const L=F.$ae.fromString(N);let j=0;j+=u.sizeLongString(L);const z=u.alloc(11,P,j);return z.writeLongString(L),z.buffer}static deserializeReplyErrError(P){const O=P.readLongString();return JSON.parse(O)}static h(P){return u.alloc(12,P,0).buffer}}var $;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var f;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(f||(f={}))}),define(De[342],Ce([1,0,4,42,41,5]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.OutputChannelUpdateMode=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=void 0,e.$lJ="text/x-code-output",e.$mJ="output",e.$nJ="Log",e.$oJ="text/x-code-log-output",e.$pJ="log",e.$qJ="workbench.panel.output",e.$rJ=new d.$5i("inOutput",!1),e.$sJ=new d.$5i("activeLogOutput",!1),e.$tJ=new d.$5i("outputView.scrollLock",!1),e.$uJ=(0,M.$Nh)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$vJ={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new C.$Md,this.onDidRegisterChannel=this.b.event,this.c=new C.$Md,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(R=>w.push(R)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}F.$cn.add(e.$vJ.OutputChannels,new b),e.$wJ=new d.$5i("activeOutputChannel","")}),define(De[152],Ce([1,0,6,5,20,25,13,342,71,27,55,178,22,18,30,4,3]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=e.$Ccc=void 0;class c extends A.$bj{get disposed(){return this.n}constructor(h,t,n,a,i){super(),this.id=h,this.name=t,this.r=n,this.s=a,this.extension=i,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=v.$ae.fromString(t).byteLength,(0,A.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends c{appendLine(h){this.append(h)}}let o=class{constructor(h,t,n,a,i,s){this.i=t,this.j=n,this.k=a,this.l=i,this.m=s,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(C.$aK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$bm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,n]of this.g)n.visible=t===this.h}createOutputChannel(h,t,n){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,i=(0,y.$xf)(t)?t:void 0;if((0,y.$xf)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const u=this.i.environment.extensionLogLevel?.find(([k])=>M.$3l.equals(n.identifier,k))?.[1];u&&(s=(0,A.$lj)(u));const S=a?this.o(h,s,n):this.n(h,i,n);return S.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),a?this.r(h,s??this.m.getLevel(),S):this.q(h,S)}async n(h,t,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,i=this.k.extUri.joinPath(a,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),u=await this.a.$register(h,i,t,n.identifier.value);return new c(u,h,s,this.a,n)}async o(h,t,n){const a=await this.p(n),i=h.replace(/[\\/:\*\?"<>\|]/g,""),s=this.k.extUri.joinPath(a,`${i}.log`),u=`${n.identifier.value}.${i}`,S=this.l.createLogger(s,{id:u,name:h,logLevel:t,extensionId:n.identifier.value});return new r(u,h,S,this.a,n)}p(h){let t=this.d.get(h.identifier.value);if(!t){const n=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(n)}catch(a){if((0,D.$mk)(a)!==D.FileSystemProviderErrorCode.FileExists)throw a}return n})())}return t}q(h,t){let n=!1;const a=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return h},append(i){a(),t.then(s=>s.append(i))},appendLine(i){a(),t.then(s=>s.appendLine(i))},clear(){a(),t.then(i=>i.clear())},replace(i){a(),t.then(s=>s.replace(i))},show(i,s){a(),t.then(u=>u.show(i,s))},hide(){a(),t.then(i=>i.hide())},dispose(){n=!0,t.then(i=>i.dispose())}}}r(h,t,n){const a=new l.$Qc,i=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},s=a.add(new p.$Md);function u(S){t=S,s.fire(S)}return n.then(S=>{a.add(S),S.logLevel!==t&&u(S.logLevel),a.add(S.onDidChangeLogLevel(k=>u(k)))}),{...this.q(h,n),get logLevel(){return t},onDidChangeLogLevel:s.event,trace(S,...k){i(),n.then($=>$.trace(S,...k))},debug(S,...k){i(),n.then($=>$.debug(S,...k))},info(S,...k){i(),n.then($=>$.info(S,...k))},warn(S,...k){i(),n.then($=>$.warn(S,...k))},error(S,...k){i(),n.then($=>$.error(S,...k))},dispose(){a.dispose()}}}};e.$Ccc=o,e.$Ccc=o=He([Be(0,d.$bM),Be(1,w.$rM),Be(2,E.$fcc),Be(3,R.$Mbc),Be(4,A.$9i),Be(5,A.$8i)],o),e.$Dcc=(0,F.$Nh)("IExtHostOutputService")}),define(De[343],Ce([1,0,5,9]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=void 0,e.$qm=(0,C.$Nh)("remoteAgentService"),e.$rm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(d){let M=1/0;for(let b=0;b<this.maxSampleCount;b++){const E=await d.getRoundTripTime();if(E===void 0)return;M=Math.min(M,E/2),await(0,F.$Tg)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(M):A=this.initial.reduce((b,E)=>b+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:M,average:this.average.reduce((b,E)=>b+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[344],Ce([1,0,32,17,16,12,23,2,5,258,43,147,343]),function($e,e,C,F,d,M,A,b,E,w,R,I,v){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$PJ=e.$OJ=void 0,e.$OJ=(0,E.$Nh)("pathService");let D=y=class{constructor(l,c,r,o){this.d=l,this.e=c,this.f=r,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const m=await this.e.getEnvironment();return this.c=m?.userHome??l})()}hasValidBasename(l,c,r){return typeof c=="string"||typeof c>"u"?this.a.then(o=>this.h(l,o,c)):this.h(l,c,r)}h(l,c,r){return l.scheme===F.Schemas.file||l.scheme===F.Schemas.vscodeRemote?(0,C.$Uf)(r??(0,A.$rg)(l),c===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(l,c){if(l.remoteAuthority)return F.Schemas.vscodeRemote;const r=(0,w.$LJ)(c.getWorkspace());if(r)return r;const o=c.getWorkspace().folders[0];if(o)return o.uri.scheme;const m=c.getWorkspace().configuration;return m?m.scheme:F.Schemas.file}userHome(l){return l?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(l=>l===1?d.$ec:d.$fc)}async fileURI(l){let c="";if(await this.a===1&&(l=l.replace(/\\/g,"/")),l[0]==="/"&&l[1]==="/"){const o=l.indexOf("/",2);o===-1?(c=l.substring(2),l="/"):(c=l.substring(2,o),l=l.substring(o)||"/")}return b.URI.from({scheme:F.Schemas.file,authority:c,path:l,query:"",fragment:""})}};e.$PJ=D,e.$PJ=D=y=He([Be(1,v.$qm),Be(2,I.$xJ),Be(3,R.$Wh)],D)}),define(De[345],Ce([1,0,225,19,57,4,52,3,2,50,230,13,64,260,86,43,147,26,21,18,24,41]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IJ=e.$HJ=e.$GJ=e.OnPortForward=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.TunnelSource=e.TunnelCloseReason=e.$AJ=e.$zJ=e.$yJ=void 0;const t=10*1e3,n="remote.tunnels.toRestore";e.$yJ="onTunnel",e.$zJ=new h.$5i("forwardedPortsViewEnabled",!1,C.localize(0,null));function a(O){const N=O.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(N)return{host:N[1]?.substring(0,N[1].length-1)||"localhost",port:Number(N[2])}}e.$AJ=a;var i;(function(O){O.Other="Other",O.User="User",O.AutoForwardEnd="AutoForwardEnd"})(i||(e.TunnelCloseReason=i={}));var s;(function(O){O[O.User=0]="User",O[O.Auto=1]="Auto",O[O.Extension=2]="Extension"})(s||(e.TunnelSource=s={})),e.$BJ={source:s.User,description:C.localize(1,null)},e.$CJ={source:s.Auto,description:C.localize(2,null)};function u(O,N,L){const j=O.get(k(N,L));if(j)return j;if((0,D.$0u)(N))for(const z of D.$9u){const T=k(z,L);if(O.has(T))return O.get(T)}else if((0,D.$_u)(N))for(const z of D.$$u){const T=k(z,L);if(O.has(T))return O.get(T)}}e.$DJ=u;function S(O,N,L){const j=u(O,N,L);if(j)return j;const z=(0,D.$_u)(N)?"localhost":(0,D.$0u)(N)?"0.0.0.0":void 0;if(z)return u(O,z,L)}e.$EJ=S;function k(O,N){return O+":"+N}e.$FJ=k;var $;(function(O){O.Notify="notify",O.OpenBrowser="openBrowser",O.OpenBrowserOnce="openBrowserOnce",O.OpenPreview="openPreview",O.Silent="silent",O.Ignore="ignore"})($||(e.OnPortForward=$={}));function f(O){return O&&"host"in O&&typeof O.host=="string"&&"port"in O&&typeof O.port=="number"&&(!("detail"in O)||typeof O.detail=="string")&&(!("pid"in O)||typeof O.pid=="string")}e.$GJ=f;class g extends b.$Rc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(N){super(),this.r=N,this.j=[],this.n=new M.$Md,this.onDidChangeAttributes=this.n.event,this.B(N.onDidChangeConfiguration(L=>{(L.affectsConfiguration(g.c)||L.affectsConfiguration(g.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(N,L,j){let z=this.w(N,L,j,this.j,0);const T={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;z>=0;){const K=this.j[z];K.key===N?(T.onAutoForward=K.onAutoForward??T.onAutoForward,T.elevateIfNeeded=K.elevateIfNeeded!==void 0?K.elevateIfNeeded:T.elevateIfNeeded,T.label=K.label??T.label,T.requireLocalPort=K.requireLocalPort,T.protocol=K.protocol):(T.onAutoForward=T.onAutoForward??K.onAutoForward,T.elevateIfNeeded=T.elevateIfNeeded!==void 0?T.elevateIfNeeded:K.elevateIfNeeded,T.label=T.label??K.label,T.requireLocalPort=T.requireLocalPort!==void 0?T.requireLocalPort:void 0,T.protocol=T.protocol??K.protocol),z=this.w(N,L,j,this.j,z+1)}return T.onAutoForward!==void 0||T.elevateIfNeeded!==void 0||T.label!==void 0||T.requireLocalPort!==void 0||T.protocol!==void 0?T:this.C()}t(N){return N.start!==void 0&&N.end!==void 0}u(N){return N.host!==void 0&&N.port!==void 0&&(0,o.$xf)(N.host)&&(0,o.$Bf)(N.port)}w(N,L,j,z,T){if(T>=z.length)return-1;const K=!(0,D.$0u)(L)&&!(0,D.$_u)(L),fe=z.slice(T).findIndex(X=>(0,o.$Bf)(X.key)?K?!1:X.key===N:this.t(X.key)?K?!1:N>=X.key.start&&N<=X.key.end:this.u(X.key)?N===X.key.port&&L===X.key.host:j?X.key.test(j):!1);return fe>=0?fe+T:-1}y(){const N=this.r.getValue(g.c);if(!N||!(0,o.$zf)(N))return[];const L=[];for(const z in N){if(z===void 0)continue;const T=N[z];let K;if(Number(z))K=Number(z);else if((0,o.$xf)(z))if(g.g.test(z)){const V=z.match(g.g);K={start:Number(V[1]),end:Number(V[2])}}else if(g.h.test(z)){const V=z.match(g.h);K={host:V[1],port:Number(V[2])}}else{let V;try{V=RegExp(z)}catch{}V&&(K=V)}K&&L.push({key:K,elevateIfNeeded:T.elevateIfNeeded,onAutoForward:T.onAutoForward,label:T.label,requireLocalPort:T.requireLocalPort,protocol:T.protocol})}const j=this.r.getValue(g.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(L)}z(N){function L(j,z){return(0,o.$Bf)(j.key)?j.key:z.t(j.key)?j.key.start:z.u(j.key)?j.key.port:Number.MAX_VALUE}return N.sort((j,z)=>L(j,this)-L(z,this))}C(){return this.m}static providedActionToAction(N){switch(N){case D.ProvidedOnAutoForward.Notify:return $.Notify;case D.ProvidedOnAutoForward.OpenBrowser:return $.OpenBrowser;case D.ProvidedOnAutoForward.OpenBrowserOnce:return $.OpenBrowserOnce;case D.ProvidedOnAutoForward.OpenPreview:return $.OpenPreview;case D.ProvidedOnAutoForward.Silent:return $.Silent;case D.ProvidedOnAutoForward.Ignore:return $.Ignore;default:return}}async addAttributes(N,L,j){const T=this.r.inspect(g.c).userRemoteValue;let K;!T||!(0,o.$zf)(T)?K={}:K=(0,m.$3m)(T),K[`${N}`]||(K[`${N}`]={});for(const V in L)K[`${N}`][V]=L[V];return this.r.updateValue(g.c,K,j)}}e.$HJ=g;let P=class extends b.$Rc{constructor(N,L,j,z,T,K,V,fe,X,Q){super(),this.H=N,this.I=L,this.J=j,this.L=z,this.M=T,this.N=K,this.O=V,this.P=fe,this.Q=X,this.R=Q,this.c=new Map,this.g=new M.$Md,this.onForwardPort=this.g.event,this.h=new M.$Md,this.onClosePort=this.h.event,this.j=new M.$Md,this.onPortName=this.j.event,this.n=new M.$Md,this.onCandidatesChanged=this.n.event,this.t=new M.$Md,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new M.$Md,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new g(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async Z=>{const oe=await this.getAttributes(Z.map(x=>({port:x.tunnelRemotePort,host:x.tunnelRemoteHost})));for(const x of Z)if(x.localAddress){const ae=k(x.tunnelRemoteHost,x.tunnelRemotePort),ve=S(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort);this.forwarded.set(ae,{remotePort:x.tunnelRemotePort,remoteHost:x.tunnelRemoteHost,localAddress:x.localAddress,protocol:oe?.get(x.tunnelRemotePort)?.protocol??D.TunnelProtocol.Http,localUri:await this.X(x.localAddress,oe?.get(x.tunnelRemotePort)),localPort:x.tunnelLocalPort,runningProcess:ve?.detail,hasRunningProcess:!!ve,pid:ve?.pid,privacy:x.privacy,source:e.$BJ}),this.f.set(ae,x)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async Z=>{const oe=k(Z.tunnelRemoteHost,Z.tunnelRemotePort);if(!S(this.forwarded,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&!S(this.detected,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&!S(this.c,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&Z.localAddress){const x=S(this.m??new Map,Z.tunnelRemoteHost,Z.tunnelRemotePort),ae=(await this.getAttributes([{port:Z.tunnelRemotePort,host:Z.tunnelRemoteHost}]))?.get(Z.tunnelRemotePort);this.forwarded.set(oe,{remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localAddress:Z.localAddress,protocol:ae?.protocol??D.TunnelProtocol.Http,localUri:await this.X(Z.localAddress,ae),localPort:Z.tunnelLocalPort,closeable:!0,runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,privacy:Z.privacy,source:e.$BJ})}await this.$(),this.f.set(oe,Z),this.g.fire(this.forwarded.get(oe))})),this.B(this.H.onTunnelClosed(Z=>this.W(Z,i.Other))),this.U()}S(){return this.Q.extensions.find(N=>N.activationEvents?.includes(e.$yJ))?(this.R.createKey(e.$zJ.key,!0),!0):!1}U(){if(this.S())return;const N=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&N.dispose()}))}async W(N,L){const j=k(N.host,N.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(N))}X(N,L){if(N.startsWith("http"))return E.URI.parse(N);const j=L?.protocol??"http";return E.URI.parse(`${j}://${N}`)}async Y(){const N=this.N.getWorkspace(),L=N.configuration?(0,A.$Bi)(N.configuration.path):N.folders.length>0?(0,A.$Bi)(N.folders[0].uri.path):void 0;if(L===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${n}.${this.L.remoteAuthority}.${L}`}async Z(){const N=this.I.get(n,1);if(N)return this.I.remove(n,1),await this.$(),N;const L=await this.Y();if(L)return this.I.get(L,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const N=await this.s;if(N&&N!==this.y){const L=JSON.parse(N)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${L.map(j=>j.remotePort).join(", ")}`);for(const j of L){const z=S(this.detected,j.remoteHost,j.remotePort);j.source.source!==s.Extension&&!z||j.source.source===s.Extension&&z?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===s.Extension&&!z&&this.D.set(k(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const N=await this.Y();this.w=this.B(new b.$Qc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async L=>{L.key===N&&(this.s=Promise.resolve(this.I.get(N,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const N=JSON.stringify(Array.from(this.forwarded.values()));if(N!==this.y){this.y=N;const L=await this.Y();L&&this.I.store(L,this.y,0,0)}}}async bb(N,L,j){if(!N.tunnelLocalPort||!j?.requireLocalPort||N.tunnelLocalPort===L)return;const z=new Date;if(this.ab.getTime()+t>z.getTime())return;this.ab=z;const T=C.localize(3,null,L,N.tunnelRemotePort,N.tunnelLocalPort);return this.P.info(T)}async forward(N,L){return!this.z&&this.L.remoteAuthority&&await M.Event.toPromise(this.C.event),this.cb(N,L)}async cb(N,L){await this.Q.activateByEvent(e.$yJ);const j=S(this.forwarded,N.remote.host,N.remote.port);L=L??(L!==null?(await this.getAttributes([N.remote]))?.get(N.remote.port):void 0);const z=N.local!==void 0?N.local:N.remote.port;let T;if(j)return this.eb(j,N,L);{const K=this.L.remoteAuthority,V=K?{getAddress:async()=>(await this.M.resolveAuthority(K)).authority}:void 0,fe=k(N.remote.host,N.remote.port);this.c.set(fe,!0),N=this.db(fe,N);const X=await this.H.openTunnel(V,N.remote.host,N.remote.port,void 0,z,N.elevateIfNeeded?N.elevateIfNeeded:L?.elevateIfNeeded,N.privacy,L?.protocol);if(typeof X=="string")T=X;else if(X&&X.localAddress){const Q=S(this.m??new Map,N.remote.host,N.remote.port),Z=X.protocol?X.protocol===D.TunnelProtocol.Https?D.TunnelProtocol.Https:D.TunnelProtocol.Http:L?.protocol??D.TunnelProtocol.Http,oe={remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localPort:X.tunnelLocalPort,name:L?.label??N.name,closeable:!0,localAddress:X.localAddress,protocol:Z,localUri:await this.X(X.localAddress,L),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:N.source??e.$BJ,privacy:X.privacy};return this.forwarded.set(fe,oe),this.f.set(fe,X),this.c.delete(fe),await this.$(),await this.bb(X,z,L),this.g.fire(oe),X}this.c.delete(fe)}return T}db(N,L){const j=this.D.has(N)?this.D:this.F.has(N)?this.F:void 0;if(j){const z=j.get(N);j.delete(N),z&&(L.name=z.name??L.name,L.local=("local"in z?z.local:"localPort"in z?z.localPort:void 0)??L.local,L.privacy=z.privacy??L.privacy)}return L}async eb(N,L,j){const z=j?.label??L.name;let T;(function(V){V[V.None=0]="None",V[V.Fire=1]="Fire",V[V.Reopen=2]="Reopen"})(T||(T={}));let K=T.None;switch(z!==N.name&&(N.name=z,K=T.Fire),(j?.protocol||N.protocol!==D.TunnelProtocol.Http)&&j?.protocol!==N.protocol&&(L.source=N.source,K=T.Reopen),L.privacy&&N.privacy!==L.privacy&&(K=T.Reopen),K){case T.Fire:{this.g.fire();break}case T.Reopen:await this.close(N.remoteHost,N.remotePort,i.User),await this.cb(L,j)}return S(this.f,L.remote.host,L.remote.port)}async name(N,L,j){const z=S(this.forwarded,N,L),T=k(N,L);if(z){z.name=j,await this.$(),this.j.fire({host:N,port:L});return}else this.detected.has(T)&&(this.detected.get(T).name=j,this.j.fire({host:N,port:L}))}async close(N,L,j){const z=k(N,L),T=this.forwarded.get(z);return j===i.AutoForwardEnd&&T&&T.source.source===s.Auto&&this.F.set(z,{local:T.localPort,name:T.name,privacy:T.privacy}),await this.H.closeTunnel(N,L),this.W({host:N,port:L},j)}address(N,L){const j=k(N,L);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(N){if(N)for(const L of N){const j=S(this.m??new Map,L.remoteAddress.host,L.remoteAddress.port),z=typeof L.localAddress=="string"?L.localAddress:k(L.localAddress.host,L.localAddress.port);this.detected.set(k(L.remoteAddress.host,L.remoteAddress.port),{remoteHost:L.remoteAddress.host,remotePort:L.remoteAddress.port,localAddress:z,protocol:D.TunnelProtocol.Http,localUri:this.X(z),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:D.TunnelPrivacyId.ConstantPrivate,source:{source:s.Extension,description:C.localize(4,null)}}),this.H.setEnvironmentTunnel(L.remoteAddress.host,L.remoteAddress.port,z,D.TunnelPrivacyId.ConstantPrivate,D.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(N){this.r=N}async setCandidates(N){let L=N;this.r&&(L=await this.r(N));const j=this.fb(L);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(z=>z.port).join(", ")}`),this.n.fire(j)}fb(N){const L=this.m??new Map,j=new Map;return this.m=j,N.forEach(z=>{const T=k(z.host,z.port);j.set(T,{host:z.host,port:z.port,detail:z.detail,pid:z.pid}),L.has(T)&&L.delete(T);const K=S(this.forwarded,z.host,z.port);K&&(K.runningProcess=z.detail,K.hasRunningProcess=!0,K.pid=z.pid)}),L.forEach((z,T)=>{const K=a(T);if(!K)return;const V=S(this.forwarded,K.host,K.port);V&&(V.runningProcess=void 0,V.hasRunningProcess=!1,V.pid=void 0);const fe=S(this.detected,K.host,K.port);fe&&(fe.runningProcess=void 0,fe.hasRunningProcess=!1,fe.pid=void 0)}),L}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const N=Array.from(this.forwarded.values()),L=await this.getAttributes(N.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(L)for(const j of N){const z=L.get(j.remotePort);(z?.protocol||j.protocol!==D.TunnelProtocol.Http)&&z?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},z),z&&z.label&&z.label!==j.name&&await this.name(j.remoteHost,j.remotePort,z.label)}}async getAttributes(N,L=!0){const j=new Map,z=new Map;N.forEach(X=>{const Q=S(this.m??new Map,D.$9u[0],X.port)??X;if(Q){j.set(X.port,Q);const Z=f(Q)?Q.pid:void 0;z.has(Z)||z.set(Z,[]),z.get(Z)?.push(X.port)}});const T=new Map;if(N.forEach(X=>{const Q=this.configPortsAttributes.getAttributes(X.port,X.host,j.get(X.port)?.detail);Q&&T.set(X.port,Q)}),this.G.length===0||!L)return T.size>0?T:void 0;const K=await Promise.all((0,F.$Qb)(this.G.map(X=>Array.from(z.entries()).map(Q=>{const Z=Q[1],oe=j.get(Z[0]);return X.providePortAttributes(Z,oe?.pid,oe?.detail,new r.$Wd().token)})))),V=new Map;if(K.forEach(X=>X.forEach(Q=>{Q&&V.set(Q.port,Q)})),!T&&!V)return;const fe=new Map;return N.forEach(X=>{const Q=T.get(X.port),Z=V.get(X.port);fe.set(X.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??g.providedActionToAction(Z?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),fe}addAttributesProvider(N){this.G.push(N)}};e.$IJ=P,He([(0,d.$gh)(1e3)],P.prototype,"$",null),e.$IJ=P=He([Be(0,D.$5u),Be(1,y.$3o),Be(2,w.$hi),Be(3,l.$xJ),Be(4,v.$Nk),Be(5,p.$Wh),Be(6,I.$8i),Be(7,R.$wv),Be(8,c.$9E),Be(9,h.$6i)],P)}),define(De[92],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$yI=e.$xI=void 0;class C{constructor(A,b){this.line=A,this.character=b}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,b){return new C(0,0)}with(A){return new C(0,0)}}e.$xI=C;class F{constructor(A,b,E,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(A,b),this.end=new C(E,w)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.$yI=F;var d;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(d||(e.TextSearchCompleteMessageType=d={}))}),define(De[36],Ce([1,0,19,35,24,32,15,5,16,8,92,9]),function($e,e,C,F,d,M,A,b,E,w,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.SearchErrorCode=e.$NI=e.$MI=e.SearchSortOrder=e.ViewMode=e.$LI=e.$KI=e.$JI=e.$II=e.SearchCompletionExitCode=e.$HI=e.$GI=e.$FI=e.QueryType=e.SearchProviderType=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$zI="workbench.view.search",e.$AI="workbench.panel.search",e.$BI="workbench.view.search",e.$CI="search-result",e.$DI="search.exclude";const v="\u27EA ",y=" characters skipped \u27EB",D=(v.length+y.length+5)*2;e.$EI=(0,b.$Nh)("searchService");var p;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text"})(p||(e.SearchProviderType=p={}));var l;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text"})(l||(e.QueryType=l={}));function c(Z){return!!Z.preview}e.$FI=c;function r(Z){return!!Z.resource}e.$GI=r;function o(Z){return!!Z.message}e.$HI=o;var m;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(m||(e.SearchCompletionExitCode=m={}));class h{constructor(oe){this.resource=oe,this.results=[]}}e.$II=h;class t{constructor(oe,x,ae,ve){this.ranges=x,this.webviewIndex=ve;const G=Array.isArray(x)?x:[x];if(ae&&ae.matchLines===1&&n(G)){oe=(0,A.$qf)(oe,ae.matchLines);let U="",q=0,me=0;const _=Math.floor(ae.charsPerLine/5),ie=[];for(const re of G){const Ee=Math.max(re.startColumn-_,0),ce=re.startColumn+ae.charsPerLine;if(Ee>me+_+D){const de=v+(Ee-me)+y;U+=de+oe.slice(Ee,ce),q+=Ee-(me+de.length)}else U+=oe.slice(me,ce);ie.push(new i(0,re.startColumn-q,re.endColumn-q)),me=ce}this.preview={text:U,matches:Array.isArray(this.ranges)?ie:ie[0]}}else{const U=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:oe,matches:(0,C.$1b)(x,q=>new a(q.startLineNumber-U,q.startColumn,q.endLineNumber-U,q.endColumn))}}}}e.$JI=t;function n(Z){const oe=Z[0].startLineNumber;for(const x of Z)if(x.startLineNumber!==oe||x.endLineNumber!==oe)return!1;return!0}class a{constructor(oe,x,ae,ve){this.startLineNumber=oe,this.startColumn=x,this.endLineNumber=ae,this.endColumn=ve}}e.$KI=a;class i extends a{constructor(oe,x,ae){super(oe,x,oe,ae)}}e.$LI=i;var s;(function(Z){Z.List="list",Z.Tree="tree"})(s||(e.ViewMode=s={}));var u;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(u||(e.SearchSortOrder=u={}));function S(Z,oe=!0){const x=Z&&Z.files&&Z.files.exclude,ae=oe&&Z&&Z.search&&Z.search.exclude;if(!x&&!ae)return;if(!x||!ae)return x||ae;let ve=Object.create(null);return ve=d.$6m(ve,d.$3m(x)),ve=d.$6m(ve,d.$3m(ae),!0),ve}e.$MI=S;function k(Z,oe){return Z.excludePattern&&F.$tj(Z.excludePattern,oe)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&F.$tj(Z.includePattern,oe)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(x=>{const ae=x.folder.fsPath;if(M.$Wf(oe,ae)){const ve=E.$kc(ae,oe);return!x.includePattern||!!F.$tj(x.includePattern,ve)}else return!1}):!1:!0}e.$NI=k;var $;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class f extends Error{constructor(oe,x){super(oe),this.code=x}}e.$OI=f;function g(Z){const oe=Z.message;if((0,w.$3)(Z))return new f(oe,$.canceled);try{const x=JSON.parse(oe);return new f(x.message,x.code)}catch{return new f(oe,$.other)}}e.$PI=g;function P(Z){const oe={message:Z.message,code:Z.code};return new Error(JSON.stringify(oe))}e.$QI=P;function O(Z){return Z.type==="error"?!0:Z.type==="success"}e.$RI=O;function N(Z){return Z.type==="success"}e.$SI=N;function L(Z){return!!Z.path}e.$TI=L;function j(Z,oe){const x=Z.searchPath?Z.searchPath:Z.relativePath;return(0,A.$nf)(x,oe)}e.$UI=j;class z{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$VI=z;function T(Z,oe){const x={...Z||{},...oe||{}};return Object.keys(x).filter(ae=>{const ve=x[ae];return typeof ve=="boolean"&&ve})}e.$WI=T;class K{constructor(oe,x){this.c=null,this.a={...oe.excludePattern||{},...x.excludePattern||{}},this.b=F.$uj(this.a);let ae=oe.includePattern;x.includePattern&&(ae?ae={...ae,...x.includePattern}:ae=x.includePattern),ae&&(this.c=F.$uj(ae))}matchesExcludesSync(oe,x,ae){return!!(this.b&&this.b(oe,x,ae))}includedInQuerySync(oe,x,ae){return!(this.b&&this.b(oe,x,ae)||this.c&&!this.c(oe,x,ae))}includedInQuery(oe,x,ae){const ve=this.b(oe,x,ae),G=()=>this.c?!!this.c(oe,x,ae):!0;return(0,I.$Fg)(ve)?ve.then(U=>U?!1:G()):G()}hasSiblingExcludeClauses(){return V(this.a)}}e.$XI=K;function V(Z){for(const oe in Z)if(typeof Z[oe]!="boolean")return!0;return!1}function fe(Z){if(!Z)return;let oe;return x=>(oe||(oe=(Z()||Promise.resolve([])).then(ae=>ae?Q(ae):{})),oe.then(ae=>!!ae[x]))}e.$YI=fe;function X(Z){if(!Z)return;let oe;return x=>{if(!oe){const ae=Z();oe=ae?Q(ae):{}}return!!oe[x]}}e.$ZI=X;function Q(Z){const oe={};for(const x of Z)oe[x]=!0;return oe}}),define(De[39],Ce([1,0,19,9,21,4,3,77,17,120,23,15,2,214,5,13,243,43,55,27,20,14,7,66,36,6]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m,h,t,n,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=void 0;function s(O,N,L){return new R.$jg(j=>$(j,L)).isEqual(O,N)}function u(O,N,L){return s(O.uri,N.uri,L)?0:(0,I.$Te)(O.uri.toString(),N.uri.toString())}function S(O,N,L){return O.index!==N.index?O.index<N.index?-1:1:s(O.uri,N.uri,L)?(0,I.$Te)(O.name,N.name):(0,I.$Te)(O.uri.toString(),N.uri.toString())}function k(O,N,L,j){const z=O.slice(0).sort((K,V)=>L(K,V,j)),T=N.slice(0).sort((K,V)=>L(K,V,j));return(0,C.$Db)(z,T,(K,V)=>L(K,V,j))}function $(O,N){const L=N.getCapabilities(O.scheme);return!(L&&L&1024)}class f extends c.$7h{static toExtHostWorkspace(N,L,j,z){if(!N)return{workspace:null,added:[],removed:[]};const{id:T,name:K,folders:V,configuration:fe,transient:X,isUntitled:Q}=N,Z=[],oe=L;L?V.forEach((G,U)=>{const q=v.URI.revive(G.uri),me=f.o(j||L,q,z);me?(me.name=G.name,me.index=G.index,Z.push(me)):Z.push({uri:q,name:G.name,index:U})}):Z.push(...V.map(({uri:G,name:U,index:q})=>({uri:v.URI.revive(G),name:U,index:q}))),Z.sort((G,U)=>G.index<U.index?-1:1);const x=new f(T,K,Z,!!X,fe?v.URI.revive(fe):null,!!Q,G=>$(G,z)),{added:ae,removed:ve}=k(oe?oe.workspaceFolders:[],x.workspaceFolders,u,z);return{workspace:x,added:ae,removed:ve}}static o(N,L,j){for(let z=0;z<N.folders.length;z++){const T=N.workspaceFolders[z];if(s(T.uri,L,j))return T}}constructor(N,L,j,z,T,K,V){super(N,j.map(fe=>new c.$8h(fe)),z,T,V),this.t=L,this.u=K,this.q=[],this.s=b.$Th.forUris(V),j.forEach(fe=>{this.q.push(fe),this.s.set(fe.uri,fe)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(N,L){return L&&this.s.get(N)&&(N=(0,R.$tg)(N)),this.s.findSubstr(N)}resolveWorkspaceFolder(N){return this.s.get(N)}}let g=class{constructor(N,L,j,z,T){this.c=new M.$Md,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Md,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Od,this.B=new Map,this.h=z,this.s=j,this.t=T,this.j=new w.$Nl,this.k=new F.$Rg,this.o=N.getProxy(i.$aK.MainThreadWorkspace),this.q=N.getProxy(i.$aK.MainThreadMessageService);const K=L.workspace;this.l=K?new f(K.id,K.name,[],!!K.transient,K.configuration?v.URI.revive(K.configuration):null,!!K.isUntitled,V=>$(V,j)):void 0}$initializeWorkspace(N,L){this.v=L,this.$acceptWorkspaceData(N),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?v.URI.from({scheme:E.Schemas.untitled,path:(0,R.$rg)((0,R.$tg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(N,L,j,...z){const T=[];if(Array.isArray(z)&&z.forEach(Q=>{v.URI.isUri(Q.uri)&&!T.some(Z=>s(Z.uri,Q.uri,this.s))&&T.push({uri:Q.uri,name:Q.name||(0,R.$qg)(Q.uri)})}),this.n||[L,j].some(Q=>typeof Q!="number"||Q<0)||j===0&&T.length===0)return!1;const K=this.x?this.x.workspaceFolders:[];if(L+j>K.length)return!1;const V=K.slice(0);V.splice(L,j,...T.map(Q=>({uri:Q.uri,name:Q.name||(0,R.$qg)(Q.uri),index:void 0})));for(let Q=0;Q<V.length;Q++){const Z=V[Q];if(V.some((oe,x)=>x!==Q&&s(Z.uri,oe.uri,this.s)))return!1}V.forEach((Q,Z)=>Q.index=Z);const{added:fe,removed:X}=k(K,V,S,this.s);if(fe.length===0&&X.length===0)return!1;if(this.o){const Q=N.displayName||N.name;this.o.$updateWorkspaceFolders(Q,L,j,T).then(void 0,Z=>{this.n=void 0;const oe={source:{identifier:N.identifier,label:N.displayName||N.name}};this.q.$showMessage(l.Severity.Error,(0,y.localize)(0,null,Q,Z.toString()),oe,[])})}return this.y(V),!0}getWorkspaceFolder(N,L){if(this.x)return this.x.getWorkspaceFolder(N,L)}async getWorkspaceFolder2(N,L){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(N,L)}async resolveWorkspaceFolder(N){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(N)}getPath(){if(!this.x)return;const{folders:N}=this.x;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,L){let j,z="";if(typeof N=="string"?(j=v.URI.file(N),z=N):typeof N<"u"&&(j=N,z=N.fsPath),!j)return z;const T=this.getWorkspaceFolder(j,!0);if(!T)return z;typeof L>"u"&&this.x&&(L=this.x.folders.length>1);let K=(0,R.$wg)(T.uri,j);return L&&T.name&&(K=`${T.name}/${K}`),K}y(N){this.x&&(this.n=f.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:N,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:L,added:j,removed:z}=f.toExtHostWorkspace(N,this.l,this.n,this.s);this.l=L||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:z}))}findFiles(N,L,j,z,T=d.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let K;if(L===null?K=!1:L&&(typeof L=="string"?K=L:K=L.pattern),T&&T.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:fe}=P(h.GlobPattern.from(N));return this.o.$startFileSearch(V??null,fe??null,K??null,j??null,T).then(X=>Array.isArray(X)?X.map(Q=>v.URI.revive(Q)):[])}async findTextInFiles(N,L,j,z,T=d.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const K=this.j.getNext(),V=typeof L.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:fe,folder:X}=P(h.GlobPattern.from(L.include)),Q=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,Z={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:V,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:fe,excludePattern:Q},oe=!1;if(this.u[K]=x=>{if(oe)return;const ae=v.URI.revive(x.resource);x.results.forEach(ve=>{(0,a.$FI)(ve)?j({uri:ae,preview:{text:ve.preview.text,matches:(0,C.$1b)(ve.preview.matches,G=>new t.$eK(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))},ranges:(0,C.$1b)(ve.ranges,G=>new t.$eK(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))}):j({uri:ae,text:ve.text,lineNumber:ve.lineNumber})})},T.isCancellationRequested)return{};try{const x=await this.o.$startTextSearch(N,X??null,Z,K,T);return delete this.u[K],x||{}}catch(x){throw delete this.u[K],x}}$handleTextSearchResult(N,L){this.u[L]?.(N)}async save(N){const L=await this.o.$save(N,{saveAs:!1});return v.URI.revive(L)}async saveAs(N){const L=await this.o.$save(N,{saveAs:!0});return v.URI.revive(L)}saveAll(N){return this.o.$saveAll(N)}resolveProxy(N){return this.o.$resolveProxy(N)}get trusted(){return this.v}requestWorkspaceTrust(N){return this.o.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(N,L){if(this.w.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.w.set(N,L);const j=this.t.transformOutgoingScheme(N),z=this.z++;return this.o.$registerEditSessionIdentityProvider(z,j),(0,A.$Pc)(()=>{this.w.delete(N),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(N,L){this.h.info("Getting edit session identifier for workspaceFolder",N);const j=await this.resolveWorkspaceFolder(v.URI.revive(N));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const z=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!z),!z)return;const T=await z.provideEditSessionIdentity(j,L);if(this.h.info("Provider returned edit session identifier: ",T),!!T)return T}async $provideEditSessionIdentityMatch(N,L,j,z){this.h.info("Getting edit session identifier for workspaceFolder",N);const T=await this.resolveWorkspaceFolder(v.URI.revive(N));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const K=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!K),!K)return;const V=await K.provideEditSessionIdentityMatch?.(L,j,z);if(this.h.info("Provider returned edit session identifier match result: ",V),!!V)return V}getOnWillCreateEditSessionIdentityEvent(N){return(L,j,z)=>{const T=function(V){L.call(j,V)};return T.extension=N,this.A.event(T,void 0,z)}}async $onWillCreateEditSessionIdentity(N,L,j){const z=await this.resolveWorkspaceFolder(v.URI.revive(N));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:z},L,async(T,K)=>{const V=Date.now();await Promise.resolve(T),Date.now()-V>j&&this.h.warn("SLOW edit session create-participant",K.extension.identifier)}),L.isCancellationRequested}registerCanonicalUriProvider(N,L){if(this.B.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.B.set(N,L);const j=this.t.transformOutgoingScheme(N),z=this.z++;return this.o.$registerCanonicalUriProvider(z,j),(0,A.$Pc)(()=>{this.B.delete(N),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(N,L,j){const z=this.B.get(N.scheme);if(!z)return;const T=await z.provideCanonicalUri?.(v.URI.revive(N),L,j);if(T)return T}async $provideCanonicalUri(N,L,j){return this.provideCanonicalUri(v.URI.revive(N),{targetScheme:L},j)}};e.$Ybc=g,e.$Ybc=g=He([Be(0,m.$bM),Be(1,o.$rM),Be(2,r.$Mbc),Be(3,p.$8i),Be(4,n.$Wbc)],g),e.$Zbc=(0,D.$Nh)("IExtHostWorkspace");function P(O){let N,L;return O&&(typeof O=="string"?N=O:(N=O.pattern,L=v.URI.revive(O.baseUri))),{includePattern:N,folder:L}}}),define(De[40],Ce([1,0,24,4,39,6,7,245,136,18,9,5,20,13,2]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=e.$1bc=void 0;function p(n,a){if(a){const i=a.split(".");let s=n;for(let u=0;s&&u<i.length;u++)s=s[i[u]];return s}}function l(n){return n instanceof D.URI}function c(n){return n&&n.uri instanceof D.URI&&n.languageId&&typeof n.languageId=="string"}function r(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function o(n){return n&&n.uri instanceof D.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function m(n){if(l(n))return{resource:n};if(c(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(r(n))return{overrideIdentifier:n.languageId};if(o(n))return{resource:n.uri};if(n===null)return{resource:null}}let h=class{constructor(a,i,s){this.a=a.getProxy(M.$aK.MainThreadConfiguration),this.c=i,this.b=s,this.d=new R.$Rg,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,i){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(a,i))}};e.$1bc=h,e.$1bc=h=He([Be(0,v.$bM),Be(1,d.$Zbc),Be(2,y.$8i)],h);class t{constructor(a,i,s,u){this.a=new F.$Md,this.b=a,this.f=u,this.c=i,this.e=b.$An.parse(s),this.d=this.k(s.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,i){const s={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$An.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(i,s))}getConfiguration(a,i,s){const u=m(i)||{},S=this.g(a?p(this.e.getValue(void 0,u,this.c.workspace),a):this.e.getValue(void 0,u,this.c.workspace));a&&this.h(a,u,s?.identifier);function k(f){if(f==null)return null;if(typeof f=="boolean")return f?2:5;switch(f){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(f){return typeof p(S,f)<"u"},get:(f,g)=>{this.h(a?`${a}.${f}`:f,u,s?.identifier);let P=p(S,f);if(typeof P>"u")P=g;else{let O;const N=(L,j)=>{if((0,w.$zf)(L)){let z;const T=()=>{O=O||(0,C.$3m)(S),z=z||p(O,j)};return new Proxy(L,{get:(K,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return T(),()=>z;if(O)return z=z||p(O,j),z[V];const fe=K[V];return typeof V=="string"?N(fe,`${j}.${V}`):fe},set:(K,V,fe)=>(T(),z&&(z[V]=fe),!0),deleteProperty:(K,V)=>(T(),z&&delete z[V],!0),defineProperty:(K,V,fe)=>(T(),z&&Object.defineProperty(z,V,fe),!0)})}return Array.isArray(L)?(0,C.$3m)(L):L};P=N(P,f)}return P},update:(f,g,P,O)=>{f=a?`${a}.${f}`:f;const N=k(P);return g!==void 0?this.b.$updateConfigurationOption(N,f,g,u,O):this.b.$removeConfigurationOption(N,f,u,O)},inspect:f=>{f=a?`${a}.${f}`:f;const g=this.e.inspect(f,u,this.c.workspace);if(g)return{key:f,defaultValue:(0,C.$3m)(g.policy?.value??g.default?.value),globalValue:(0,C.$3m)(g.user?.value??g.application?.value),workspaceValue:(0,C.$3m)(g.workspace?.value),workspaceFolderValue:(0,C.$3m)(g.workspaceFolder?.value),defaultLanguageValue:(0,C.$3m)(g.default?.override),globalLanguageValue:(0,C.$3m)(g.user?.override??g.application?.override),workspaceLanguageValue:(0,C.$3m)(g.workspace?.override),workspaceFolderLanguageValue:(0,C.$3m)(g.workspaceFolder?.override),languageIds:(0,C.$3m)(g.overrideIdentifiers)}}};return typeof S=="object"&&(0,C.$6m)($,S,!1),Object.freeze($)}g(a){const i=s=>(0,w.$zf)(s)?new Proxy(s,{get:(u,S)=>i(u[S]),set:(u,S,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(u,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(u,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return i(a)}h(a,i,s){const u=E.$rn.test(a)?4:this.d.get(a),S=s?`[${s.value}] `:"";if(u===4){typeof i?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){i?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,i){const s=new b.$Cn(a,i,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,S)=>s.affectsConfiguration(u,m(S))})}k(a){return a.reduce((i,s)=>(i.set(s[0],s[1]),i),new Map)}}e.$2bc=t,e.$3bc=(0,I.$Nh)("IExtHostConfiguration")}),define(De[93],Ce([1,0,2,9,4,6,7,39,69,40,21,44,20,27,5,17,12,13,89,291,8]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=e.$Ycc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(N){function L(z){if(z!=null)return z}N.from=L;function j(z){if(z!=null)return z}N.to=j})(h||(h={}));var t;(function(N){function L(z){if(z!=null)return z}N.from=L;function j(z){if(z!=null)return z}N.to=j})(t||(t={}));var n;(function(N){function L(z){if(z!=null)return z}N.from=L;function j(z){if(z!=null)return z}N.to=j})(n||(n={}));var a;(function(N){function L(T){if(T){const K=T;return K&&!!K.process}else return!1}N.is=L;function j(T){if(T==null)return;const K={process:T.process,args:T.args};return T.options&&(K.options=n.from(T.options)),K}N.from=j;function z(T){if(T!=null)return new A.$WK(T.process,T.args,T.options)}N.to=z})(a||(a={}));var i;(function(N){function L(z){if(z!=null)return z}N.from=L;function j(z){if(z!=null)return z}N.to=j})(i||(i={}));var s;(function(N){function L(T){if(T){const K=T;return K&&(!!K.commandLine||!!K.command)}else return!1}N.is=L;function j(T){if(T==null)return;const K={};return T.commandLine!==void 0?K.commandLine=T.commandLine:(K.command=T.command,K.args=T.args),T.options&&(K.options=i.from(T.options)),K}N.from=j;function z(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new A.$XK(T.commandLine,T.options):new A.$XK(T.command,T.args?T.args:[],T.options)}N.to=z})(s||(s={}));var u;(function(N){function L(T){if(T){const K=T;return K&&K.customExecution==="customExecution"}else return!1}N.is=L;function j(T){return{customExecution:"customExecution"}}N.from=j;function z(T,K){return K.get(T)}N.to=z})(u||(e.CustomExecutionDTO=u={}));var S;(function(N){function L(j,z){let T;return j.scope!==void 0&&typeof j.scope!="number"?T=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===A.TaskScope.Workspace&&z&&z.workspaceFile?T=z.workspaceFile:T=o.$OF),{id:j._id,workspaceFolder:T}}N.from=L})(S||(e.TaskHandleDTO=S={}));var k;(function(N){function L(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}N.from=L})(k||(k={}));var $;(function(N){function L(T,K){if(T==null)return[];const V=[];for(const fe of T){const X=j(fe,K);X&&V.push(X)}return V}N.fromMany=L;function j(T,K){if(T==null)return;let V;T.execution instanceof A.$WK?V=a.from(T.execution):T.execution instanceof A.$XK?V=s.from(T.execution):T.execution&&T.execution instanceof A.$YK&&(V=u.from(T.execution));const fe=h.from(T.definition);let X;return T.scope?typeof T.scope=="number"?X=T.scope:X=T.scope.uri:X=A.TaskScope.Workspace,!fe||!X?void 0:{_id:T._id,definition:fe,name:T.name,source:{extensionId:K.identifier.value,label:T.source,scope:X},execution:V,isBackground:T.isBackground,group:k.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}N.from=j;async function z(T,K,V){if(T==null)return;let fe;a.is(T.execution)?fe=a.to(T.execution):s.is(T.execution)?fe=s.to(T.execution):u.is(T.execution)&&(fe=u.to(T._id,V));const X=h.to(T.definition);let Q;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Q=T.source.scope:Q=await K.resolveWorkspaceFolder(C.URI.revive(T.source.scope)):Q=A.TaskScope.Workspace),!X||!Q)return;const Z=new A.$ZK(X,Q,T.name,T.source.label,fe,T.problemMatchers);return T.isBackground!==void 0&&(Z.isBackground=T.isBackground),T.group!==void 0&&(Z.group=A.$VK.from(T.group._id),Z.group&&T.group.isDefault&&(Z.group=new A.$VK(Z.group.id,Z.group.label),T.group.isDefault===!0&&(Z.group.isDefault=T.group.isDefault))),T.presentationOptions&&(Z.presentationOptions=t.to(T.presentationOptions)),T._id&&(Z._id=T._id),T.detail&&(Z.detail=T.detail),Z}N.to=z})($||(e.TaskDTO=$={}));var f;(function(N){function L(z){return z}N.from=L;function j(z){if(z)return Object.assign(Object.create(null),z)}N.to=j})(f||(f={}));class g{#e;constructor(L,j,z){this._id=j,this.a=z,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let P=class{constructor(L,j,z,T,K,V,fe,X){this.q=new d.$Md,this.r=new d.$Md,this.s=new d.$Md,this.t=new d.$Md,this.a=L.getProxy(M.$aK.MainThreadTask),this.b=z,this.c=T,this.d=K,this.e=V,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=X,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,j,z){if(!z)return new A.$cK(()=>{});const T=this.w();return this.j.set(T,{type:j,provider:z,extension:L}),this.a.$registerTaskProvider(T,j),new A.$cK(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(L,j){this.a.$registerTaskSystem(L,j)}fetchTasks(L){return this.a.$fetchTasks(f.from(L)).then(async j=>{const z=[];for(const T of j){const K=await $.to(T,this.b,this.m);K&&z.push(K)}return z})}get taskExecutions(){const L=[];return this.k.forEach(j=>L.push(j)),L}terminateTask(L){if(!(L instanceof g))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,j,z){const T=this.m.get(L.id);T&&(this.o.set(L.id,T),this.e.attachPtyToTerminal(j,await T.callback(z))),this.p=L.id,this.q.fire({execution:await this.y(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){const j=await this.y(L);this.l.delete(L.id),this.k.delete(L.id),this.A(L),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const j=await this.y(L.id);this.s.fire({execution:j,processId:L.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(L){const j=await this.y(L.id);this.t.fire({execution:j,exitCode:L.exitCode})}$provideTasks(L,j){const z=this.j.get(L);if(!z)return Promise.reject(new Error("no handler found"));const T=[],K=(0,F.$Lg)(()=>z.provider.provideTasks(R.CancellationToken.None)).then(V=>this.u(j,T,z,V));return new Promise(V=>{K.then(fe=>{Promise.all(T).then(()=>{V(fe)})})})}async $resolveTask(L,j){const z=this.j.get(L);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const T=await $.to(j,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const K=await z.provider.resolveTask(T,R.CancellationToken.None);if(!K)return;this.z(K,z);const V=$.from(K,z.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(V.execution)&&await this.x(V,K,!0),await this.v(V)}w(){return this.h++}async x(L,j,z){const T=await this.a.$createTaskId(L);!z&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,j.execution)),this.m.set(T,j.execution)}async y(L,j){if(typeof L=="string"){const K=this.l.get(L);if(!K)throw new m.$ab("Unexpected: The specified task is missing an execution");return K}const z=this.l.get(L.id);if(z)return z;const T=new Promise((K,V)=>{function fe(X,Q,Z){Z?K(new g(X,Q.id,Z)):V("Unexpected: Task does not exist.")}j?fe(this,L,j):$.to(L.task,this.b,this.m).then(X=>fe(this,L,X))});return this.l.set(L.id,T),T.then(K=>(this.k.set(L.id,K),K),K=>Promise.reject(K))}z(L,j){L._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const z=this.n.values();let T=z.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=z.next()}};e.$Ycc=P,e.$Ycc=P=He([Be(0,v.$bM),Be(1,y.$rM),Be(2,b.$Zbc),Be(3,E.$mM),Be(4,w.$3bc),Be(5,I.$icc),Be(6,c.$8i),Be(7,r.$Pbc)],P);let O=class extends P{constructor(L,j,z,T,K,V,fe,X){super(L,j,z,T,K,V,fe,X),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:l.$i(0)})}async executeTask(L,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=$.from(j,L);if(z===void 0)throw new Error("Task is not valid");if(u.is(z.execution))await this.x(z,j,!1);else throw new m.$$;const T=await this.y(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(K=>{throw new Error(K)}),T}u(L,j,z,T){const K=[];if(T)for(const V of T){this.z(V,z),(!V.definition||!L[V.definition.type])&&this.f.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const fe=$.from(V,z.extension);fe&&u.is(fe.execution)?(K.push(fe),j.push(this.x(fe,V,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:z.extension}}async v(L){if(u.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,j,z){}};e.$Zcc=O,e.$Zcc=O=He([Be(0,v.$bM),Be(1,y.$rM),Be(2,b.$Zbc),Be(3,E.$mM),Be(4,w.$3bc),Be(5,I.$icc),Be(6,c.$8i),Be(7,r.$Pbc)],O),e.$1cc=(0,D.$Nh)("IExtHostTask")}),define(De[346],Ce([1,0,16,21,47,35,23,37,36]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class w{constructor(v,y,D){this.k=v,this.l=y,this.o=D,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&M.$uj(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&M.$uj(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const y=this.k.folderQueries||[];return new Promise((D,p)=>{const l=c=>{this.f++,v(c)};if(this.g)return D({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const r=c.toString(),o=C.$mc(r);this.j&&this.j(r,o)||this.v(l,{base:c,basename:o})}),Promise.all(y.map(c=>this.p(c,l))).then(c=>{D({limitHit:this.e,stats:c[0]||void 0})},c=>{p(new Error((0,d.$yi)(c)))})})}async p(v,y){const D=new F.$Wd,p=this.q(v),l=this.r(),c=new E.$XI(this.k,v),r=!c.hasSiblingExcludeClauses();let o;try{this.h.add(D),o=b.$Id.create();const m=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},p,D.token),h=o.elapsed(),t=b.$Id.create();return this.g&&!this.e||(m&&m.forEach(n=>{const a=C.$fc.relative(v.folder.path,n.path);if(r){const i=C.$mc(n.path);this.v(y,{base:v.folder,relativePath:a,basename:i});return}this.s(l,v.folder,a,y)}),this.g&&!this.e)?null:(this.u(l,c,y),{providerTime:h,postProcessTime:t.elapsed()})}finally{D.dispose(),this.h.delete(D)}}q(v){const y=(0,E.$WI)(this.k.includePattern,v.includePattern),D=(0,E.$WI)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:D,includes:y,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},y,D,p){if(D===this.a){const c=C.$mc(this.a);this.v(p,{base:y,relativePath:this.a,basename:c})}function l(c){const r=C.$mc(c),o=C.$lc(c);let m=v[o];m||(m=v[o]=[],l(o)),m.push({base:y,relativePath:c,basename:r})}l(D)}u({rootEntries:v,pathToEntries:y},D,p){const l=this,c=this.a;function r(o){const m=(0,E.$ZI)(()=>o.map(h=>h.basename));for(let h=0,t=o.length;h<t;h++){const n=o[h],{relativePath:a,basename:i}=n;if(D.matchesExcludesSync(a,i,c!==i?m:void 0))continue;const s=y[a];if(s)r(s);else{if(a===c)continue;l.v(p,n)}if(l.e)break}}r(v)}v(v,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(y))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(v,y,D,p){const l=this.c(v.cacheKey),c=new w(v,y,l&&l.token);let r=0;const o=m=>{r+=m.length,D(m.map(h=>this.d(h)))};return this.e(c,R.a,o,p).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:m.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(v)return this.b.has(v)||this.b.set(v,new F.$Wd),this.b.get(v)}d(v){return v.relativePath?{resource:A.$ug(v.base,v.relativePath)}:{resource:v.base}}e(v,y,D,p){const l=p.onCancellationRequested(()=>{v.cancel()}),c=o=>{o&&(r.push(o),y>0&&r.length>=y&&(D(r),r=[]))};let r=[];return v.search(c).then(o=>(r.length&&D(r),l.dispose(),o),o=>(r.length&&D(r),l.dispose(),Promise.reject(o)))}}e.$$cc=R}),define(De[347],Ce([1,0,19,73,35,99,28,17,16,23,15,18,2,172,226,50,13,43,143,344,36]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RJ=e.$QJ=void 0;let h=class{constructor(f,g,P,O,N){this.a=f,this.b=g,this.c=P,this.d=O,this.e=N}text(f,g,P={}){f=this.f(f,P);const O=this.a.getValue(),N=g&&g.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(g?.map(c.$9h),P),type:2,contentPattern:f,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:O.search.usePCRE2||N||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(f,g){const P=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const O={...f,wordSeparators:P.editor.wordSeparators};return this.j(f,g)&&(O.isCaseSensitive=!0),this.k(f)&&(O.isMultiline=!0),g.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=g.notebookSearchConfig.includeMarkupInput),g.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=g.notebookSearchConfig.includeMarkupPreview),g.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=g.notebookSearchConfig.includeCodeInput),g.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=g.notebookSearchConfig.includeOutput),O}file(f,g={}){return{...this.h(f,g),type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey}}g(f,g){return f?(f=Array.isArray(f)?f.map(s):s(f),g?this.parseSearchPaths(f):{pattern:n(...Array.isArray(f)?f:[f])}):{}}h(f=[],g={}){const P=this.g(g.includePattern,g.expandPatterns),O=this.g(g.excludePattern,g.expandPatterns),N=f.length>1,L=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(T=>this.q(T,g,O)):f.map(T=>this.r(T,g,O,N))).filter(T=>!!T),j={_reason:g._reason,folderQueries:L,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:O.pattern,includePattern:P.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const T=C.$Gb(C.$Qb(this.c.groups.map(fe=>fe.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const K=T.filter(fe=>(0,m.$NI)(j,fe.fsPath)),V=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...j,...V}}const z=g.extraFileResources&&g.extraFileResources.filter(T=>(0,m.$NI)(j,T.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(f){const g=[],P=new A.$zc,O={};let N=!1;return f.forEach(L=>{if(L.scheme===b.Schemas.walkThrough)return;if((0,w.$yg)(L)){const z=this.b.getWorkspaceFolder(L)?.uri??L.with({path:E.$lc(L.fsPath)});let T=P.get(z);T||(N=!0,T={folder:z,includePattern:{}},g.push(T),P.set(z,T));const K=E.$kc(z.fsPath,L.fsPath);(0,I.$If)(T.includePattern)[K.replace(/\\/g,"/")]=!0}else L.fsPath&&(N=!0,O[L.fsPath]=!0)}),{folderQueries:g,includePattern:O,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(f,g){if(g.isSmartCase){if(f.isRegExp){if(R.$of(f.pattern,!0))return!0}else if(R.$of(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,y.$pB)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const g=V=>E.$hc(V)||/^\.\.?([\/\\]|$)/.test(V),O=(Array.isArray(f)?f:a(f)).map(V=>{const fe=this.e.resolvedUserHome;return fe?(0,M.$pv)(V,fe.scheme===b.Schemas.file?fe.fsPath:fe.path):V}),N=F.$J(O,V=>g(V)?"searchPaths":"exprSegments"),L=(N.exprSegments||[]).map(V=>R.$Je(V,"/")).map(V=>R.$Je(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),i(V))),j={},z=this.m(N.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const T=C.$Qb(L),K=n(...T);return K&&(j.pattern=K),j}l(f,g){return g.disregardExcludeSettings?void 0:(0,m.$MI)(f,!g.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const g=f.flatMap(O=>{let{pathPortion:N,globPortion:L}=t(O);return L&&(L=u(L)),this.n(N).flatMap(z=>this.o(z,L))}),P=new Map;return g.forEach(O=>{const N=O.searchPath.toString(),L=P.get(N);L?O.pattern&&(L.pattern=L.pattern||{},L.pattern[O.pattern]=!0):P.set(N,{searchPath:O.searchPath,pattern:O.pattern?n(O.pattern):void 0})}),Array.from(P.values())}n(f){if(E.$hc(f)){const g=this.b.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==b.Schemas.file?[{searchPath:g[0].uri.with({path:f})}]:[{searchPath:v.URI.file(E.$gc(f))}]}if(this.b.getWorkbenchState()===2){const g=this.b.getWorkspace().folders[0].uri;if(f=s(f),f.startsWith("../")||f===".."){const O=E.$fc.resolve(g.path,f);return[{searchPath:g.with({path:O})}]}const P=u(f);return[{searchPath:g,pattern:P}]}else{if(f==="./"||f===".\\")return[];{const g=f.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(N=>{const L=g.match(new RegExp(`^${R.$Ee(N.name)}(?:/(.*)|$)`));return L?{match:L,folder:N}:null}).filter(I.$Ff);if(O.length)return O.map(N=>{const L=N.match[1];return{searchPath:N.folder.uri,pattern:L&&u(L)}});{const N=f.match(/\.[\/\\](.+)[\/\\]?/),L=N?N[1]:f,j=D.localize(0,null,L);throw new Error(j)}}}}o(f,g){const P=f.pattern&&g?`${f.pattern}/${g}`:f.pattern||g,O=[{searchPath:f.searchPath,pattern:P}];return P&&!P.endsWith("**")&&O.push({searchPath:f.searchPath,pattern:P+"/**"}),O}q(f,g,P){const O=this.r((0,c.$9h)(f.searchPath),g,P,!1);return O?{...O,includePattern:f.pattern}:null}r(f,g,P,O){let N;const L=v.URI.isUri(f)?f:f.uri;if(P.searchPaths){const V=P.searchPaths.filter(fe=>(0,w.$ng)(fe.searchPath,L))[0];if(V&&!V.pattern)return null;V&&(N=V.pattern)}const j=this.a.getValue({resource:L}),T={...this.l(j,g)||{},...N||{}},K=v.URI.isUri(f)?(0,w.$rg)(f):f.name;return{folder:L,folderName:O?K:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof g.disregardParentIgnoreFiles=="boolean"?g.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!j.search.followSymlinks}}};e.$QJ=h,e.$QJ=h=He([Be(0,p.$hi),Be(1,c.$Wh),Be(2,r.$_B),Be(3,l.$8i),Be(4,o.$OJ)],h);function t($){const f=$.match(/[\*\{\}\(\)\[\]\?]/);if(f){const g=f.index,P=$.substr(0,g).match(/[/|\\][^/\\]*$/);if(P){let O=$.substr(0,P.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:$.substr((P.index||0)+1)}}}return{pathPortion:$}}function n(...$){return $.length?$.reduce((f,g)=>(f[g]=!0,f),Object.create(null)):void 0}function a($){return d.$sj($,",").map(f=>f.trim()).filter(f=>!!f.length)}function i($){return[`**/${$}/**`,`**/${$}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function s($){return $.replace(/\\/g,"/")}function u($){return s($).replace(/^\.\//,"").replace(/\/+$/g,"")}function S($){return $.replace(/([?*[\]])/g,"[$1]")}function k($,f){$=C.$Lb($,O=>O.toString());const g=[],P=f.getWorkspace();return $&&$.forEach(O=>{let N;if(f.getWorkbenchState()===2)N=(0,w.$wg)(P.folders[0].uri,O),N&&N!=="."&&(N="./"+N);else{const L=f.getWorkspaceFolder(O);if(L){const j=L.name;if(P.folders.filter(T=>T.name===j).length===1){const T=(0,w.$wg)(L.uri,O);T===""?N=`./${L.name}`:N=`./${L.name}/${T}`}else N=O.fsPath}}N&&g.push(S(N))}),g}e.$RJ=k}),define(De[348],Ce([1,0,23,2,21,8,5,347,36,43]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slb=e.$rlb=void 0;const R=7e3;function I(p,l){const c=l.activationEvents;if(!c)return Promise.resolve(void 0);const r=[],o=[];for(const i of c)if(/^workspaceContains:/.test(i)){const s=i.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||p.forceUsingSearch?o.push(s):r.push(s)}if(r.length===0&&o.length===0)return Promise.resolve(void 0);let m;const h=new Promise((i,s)=>{m=i}),t=i=>m({activationEvent:i}),n=Promise.all(r.map(i=>v(p,i,t))).then(()=>{}),a=y(p,l.identifier,o,t);return Promise.all([n,a]).then(()=>{m(void 0)}),h}e.$rlb=I;async function v(p,l,c){for(const r of p.folders)if(await p.exists(C.$ug(F.URI.revive(r),l))){c(`workspaceContains:${l}`);return}}async function y(p,l,c,r){if(c.length===0)return Promise.resolve(void 0);const o=new d.$Wd,m=p.checkExists(p.folders,c,o.token),h=setTimeout(async()=>{o.cancel(),p.logService.info(`Not activating extension '${l.value}': Timed out while searching for 'workspaceContains' pattern ${c.join(",")}`)},R);let t=!1;try{t=await m}catch(n){M.$3(n)||M.$Z(n)}o.dispose(),clearTimeout(h),t&&r(`workspaceContains:${c.join(",")}`)}function D(p,l,c,r){const o=p.get(A.$Mh),m=p.get(E.$EI),t=o.createInstance(b.$QJ).file(l.map(n=>(0,w.$9h)(F.URI.revive(n))),{_reason:"checkExists",includePattern:c,exists:!0});return m.fileSearch(t,r).then(n=>!!n.limitHit,n=>M.$3(n)?!1:Promise.reject(n))}e.$slb=D}),define(De[45],Ce([1,0,204,16,54,23,9,3,77,2,13,6,40,286,115,39,26,148,8,25,22,262,7,64,5,27,90,20,104,72,44,4,348,114,264,17,112,37,12,113]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m,h,t,n,a,i,s,u,S,k,$,f,g,P,O,N,L,j,z,T){"use strict";var K;Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=e.$vcc=e.$ucc=e.$tcc=void 0,e.$tcc=(0,a.$Nh)("IHostUtils");let V=K=class extends b.$Rc{constructor(G,U,q,me,_,ie,re,Ee,ce,de,ee,he){super(),this.X=he,this.a=this.B(new f.$Md),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=q,this.f=re,this.j=me,this.m=_,this.s=ie,this.t=ce,this.u=de,this.w=ee,this.y=this.g.getProxy(I.$aK.MainThreadWorkspace),this.z=this.g.getProxy(I.$aK.MainThreadTelemetry),this.C=this.g.getProxy(I.$aK.MainThreadExtensionService),this.D=new A.$Rg,this.F=new A.$Rg,this.G=new A.$Rg,this.H=new A.$Rg,this.I=new ae(this.f.extensions.activationEvents),this.L=new c.$_3b(this.I,this.f.extensions.allExtensions);const be=new o.$4l(this.f.extensions.myExtensions);this.J=new c.$_3b(this.I,oe(this.L,be)),z.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new D.$acc(this.g,this.s),this.N=new P.$mcc(this.g),this.O=Ee,this.h=G.createChild(new S.$Lh([D.$bcc,this.M],[P.$ncc,this.N])),this.P=this.B(new y.$_bc(this.J,this.L,{onExtensionActivationError:(Pe,B,J)=>{this.C.$onExtensionActivationError(Pe,r.$2(B),J)},actualActivateExtension:async(Pe,B)=>{if(c.$_3b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,B),new y.$$bc;const J=this.J.getExtensionDescription(Pe);return this.db(J,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),d.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(G){r.$Z(G)}}async Y(){this.O.onWillDeactivateAll();let G=[];try{G=this.J.getAllExtensionDescriptions().map(_=>_.identifier).filter(_=>this.isActivated(_)).map(_=>this.cb(_))}catch{}await Promise.all(G)}terminate(G,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${G}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(me=>{this.s.error(me)}),this.g.dispose();const q=this.Y();Promise.race([(0,A.$Tg)(5e3),q]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(G){return this.G.isOpen()?this.P.isActivated(G):!1}async getExtension(G){const U=await this.C.$getExtension(G);return U&&{...U,identifier:new o.$3l(U.identifier.value),extensionLocation:w.URI.revive(U.extensionLocation)}}Z(G,U){return this.P.activateByEvent(G,U)}$(G,U){return this.P.activateById(G,U)}activateByIdWithErrors(G,U){return this.$(G,U).then(()=>{const q=this.P.getActivatedExtension(G);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(G=>this.J)}getExtensionExports(G){if(this.G.isOpen())return this.P.getActivatedExtension(G).exports;try{return this.P.getActivatedExtension(G).exports}catch{return null}}async ab(G){if(G.scheme===N.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(G.fsPath);return w.URI.file(U)}return G}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(G=>new x(G))),this.Q}async bb(G){const U=E.$Th.forUris(q=>M.$lg.ignorePathCasing(q));return await Promise.all(G.map(async q=>{if(this.ub(q)){const me=await this.ab(q.extensionLocation);U.set(me,q)}})),U}cb(G){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(G))return U;const q=this.P.getActivatedExtension(G);if(!q)return U;try{typeof q.module.deactivate=="function"&&(U=Promise.resolve(q.module.deactivate()).then(void 0,me=>(this.s.error(me),Promise.resolve(void 0))))}catch(me){this.s.error(`An error occurred when deactivating the extension '${G.value}':`),this.s.error(me)}try{(0,b.$Mc)(q.subscriptions)}catch(me){this.s.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this.s.error(me)}return U}async db(G,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(G.identifier):await this.C.$onWillActivateExtension(G.identifier),this.fb(G,U).then(q=>{const me=q.activationTimes;return this.C.$onDidActivateExtension(G.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,U),this.eb(G,U,"success",me),q},q=>{throw this.eb(G,U,"failure"),q})}eb(G,U,q,me){const _=X(G,U);this.z.$publicLog2("extensionActivationTimes",{..._,...me||{},outcome:q})}fb(G,U){const q=X(G,U);this.z.$publicLog2("activatePlugin",q);const me=this.ub(G);if(!me)return Promise.resolve(new y.$0bc(y.$7bc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${G.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const _=new y.$8bc(U.startup);return Promise.all([this.vb(G,(0,M.$ug)(G.extensionLocation,me),_),this.gb(G)]).then(ie=>(d.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),K.hb(this.s,G.identifier,ie[0],ie[1],_))).then(ie=>(d.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),ie))}gb(G){const U=new h.$dcc(G,this.M),q=new h.$ccc(G.identifier.value,!1,this.M),me=new O.$occ(G,this.N),_=G.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ie=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([U.whenReady,q.whenReady,this.O.whenReady]).then(()=>{const re=this;let Ee,ce;const de=(0,l.$_E)(G,"ipc")?this.f.messagePorts?.get(o.$3l.toKey(G.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:q,secrets:me,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(ee){return F.$ic(G.extensionLocation.fsPath,ee)},get storagePath(){return re.O.workspaceValue(G)?.fsPath},get globalStoragePath(){return re.O.globalValue(G).fsPath},get logPath(){return F.$ic(re.f.logsLocation.fsPath,G.identifier.value)},get logUri(){return w.URI.joinPath(re.f.logsLocation,G.identifier.value)},get storageUri(){return re.O.workspaceValue(G)},get globalStorageUri(){return re.O.globalValue(G)},get extensionMode(){return _},get extension(){return Ee===void 0&&(Ee=new Z(re,G.identifier,G,ie,!1)),Ee},get extensionRuntime(){return(0,l.$aF)(G,"extensionRuntime"),re.extensionRuntime},get environmentVariableCollection(){return re.u.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!ce){if(!de)return;const ee=f.Event.buffer(f.Event.fromDOMEventEmitter(de,"message",he=>he.data));de.start(),ce={onDidReceiveMessage:ee,postMessage:de.postMessage.bind(de)}}return ce}})})}static hb(G,U,q,me,_){return q=q||{activate:void 0,deactivate:void 0},this.ib(G,U,q,me,_).then(ie=>new y.$9bc(!1,null,_.build(),q,ie,me.subscriptions))}static ib(G,U,q,me,_){if(typeof q.activate=="function")try{_.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${U.value}`);const ie=typeof global=="object"?global:self,re=q.activate.apply(ie,[me]);return _.activateCallStop(),_.activateResolveStart(),Promise.resolve(re).then(Ee=>(_.activateResolveStop(),Ee))}catch(ie){return Promise.reject(ie)}else return Promise.resolve(q)}jb(G,U){this.$(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:U}).then(void 0,q=>{this.s.error(q)})}kb(G,U=0){const me=Date.now();(0,z.$B)(()=>{for(let _=U;_<G.length;_+=1){const ie=G[_];for(const re of ie.activationEvents??[])if(re==="onStartupFinished")if(Date.now()-me>50){this.kb(G,_);break}else this.jb(ie,re)}})}lb(){this.C.$setPerformanceMarks(d.getMarks()),this.m.getConfigProvider().then(G=>{const U=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),q=this.J.getAllExtensionDescriptions();if(U)this.kb(q);else for(const me of q)if(me.activationEvents)for(const _ of me.activationEvents)_==="onStartupFinished"&&this.jb(me,_)})}mb(){const G=this.Z("*",!0).then(void 0,ie=>{this.s.error(ie)});this.B(this.j.onDidChangeWorkspace(ie=>this.nb(ie.added)));const U=this.j.workspace?this.j.workspace.folders:[],q=this.nb(U),me=this.pb(),_=Promise.all([me,G,q]).then(()=>{});return Promise.race([_,(0,A.$Tg)(1e4)]).then(()=>{this.lb()}),_}nb(G){return G.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(G,U))).then(()=>{})}async ob(G,U){if(this.isActivated(U.identifier))return;const q=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.s,folders:G.map(ie=>ie.uri),forceUsingSearch:q||!this.c.fsExists,exists:ie=>this.c.fsExists(ie.fsPath),checkExists:(ie,re,Ee)=>this.y.$checkExists(ie,re,Ee)},_=await(0,g.$rlb)(me,U);if(_)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:_.activationEvent}).then(void 0,ie=>this.s.error(ie))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(G){throw console.error(G),G}}async qb(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:U}=this.f.environment;if(!G||!U)throw new Error(C.localize(0,null));const q=await this.vb(null,U,new y.$8bc(!1));if(!q||typeof q.run!="function")throw new Error(C.localize(1,null,U.toString()));return new Promise((me,_)=>{const ie=(ce,de)=>{ce?(z.$t&&this.s.error("Test runner called back with error",ce),_(ce)):(z.$t&&(de?this.s.info(`Test runner called back with ${de} failures.`):this.s.info("Test runner called back with successful outcome.")),me(typeof de=="number"&&de>0?1:0))},re=(0,M.$ig)(U),Ee=q.run(re,ie);Ee&&Ee.then&&Ee.then(()=>{z.$t&&this.s.info("Test runner finished successfully."),me(0)}).catch(ce=>{z.$t&&this.s.error("Test runner finished with error",ce),_(ce instanceof Error&&ce.stack?ce.stack:String(ce))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Tg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,U){return this.R[G]=U,(0,b.$Pc)(()=>{delete this.R[G]})}async getRemoteExecServer(G){const{resolver:U}=await this.sb(G);return U?.resolveExecServer?.(G,{resolveAttempt:0})}async sb(G){const U=G.indexOf("+");if(U===-1)throw new t.$iK("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const q=G.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this.R[q]}}async $resolveAuthority(G,U){const q=j.$Id.create(!1),me=()=>`[resolveAuthority(${(0,n.$Rk)(G)},${U})][${q.elapsed()}ms] `,_=se=>this.s.info(`${me()}${se}`),ie=se=>this.s.warn(`${me()}${se}`),re=(se,Y=void 0)=>this.s.error(`${me()}${se}`,Y),Ee=se=>{if(se instanceof t.$iK)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se},ce=async se=>{_(`activating resolver for ${se}...`);const{resolver:Y,authorityPrefix:ge}=await this.sb(se);if(!Y)throw re(`no resolver for ${ge}`),new t.$iK(`No remote extension installed to resolve ${ge}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Y,authorityPrefix:ge,remoteAuthority:se}},de=G.split(/@|%40/g).reverse();_(`activating remote resolvers ${de.join(" -> ")}`);let ee;try{ee=await Promise.all(de.map(ce)).catch(async se=>{if(!(se instanceof t.$iK)||se._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw se;return ie(`resolving nested authorities failed: ${se.message}`),[await ce(G)]})}catch(se){return Ee(se)}const he=new A.$4g;he.cancelAndSet(()=>_("waiting..."),1e3);let be,Pe;for(const[se,{authorityPrefix:Y,resolver:ge,remoteAuthority:ye}]of ee.entries())try{if(se===ee.length-1)_("invoking final resolve()..."),d.mark(`code/extHost/willResolveAuthority/${Y}`),be=await ge.resolve(ye,{resolveAttempt:U,execServer:Pe}),d.mark(`code/extHost/didResolveAuthorityOK/${Y}`),_("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ge,t.$hK.isManagedResolvedAuthority(be)?be:void 0));else{if(_(`invoking resolveExecServer() for ${ye}`),d.mark(`code/extHost/willResolveExecServer/${Y}`),Pe=await ge.resolveExecServer?.(ye,{resolveAttempt:U,execServer:Pe}),!Pe)throw new t.$iK(`Exec server was not available for ${ye}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);d.mark(`code/extHost/didResolveExecServerOK/${Y}`)}}catch(je){return d.mark(`code/extHost/didResolveAuthorityError/${Y}`),re("returned an error",je),he.dispose(),Ee(je)}he.dispose();const B={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},J={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};_(`returned ${t.$hK.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let te;if(t.$hK.isManagedResolvedAuthority(be)){const se=U;this.X.setFactory(se,be.makeConnection),te={authority:G,connectTo:new n.$Ok(se),connectionToken:be.connectionToken}}else te={authority:G,connectTo:new n.$Pk(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:te,options:J,tunnelInformation:B}}}async $getCanonicalURI(G,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Rk)(G)})`);const{resolver:q}=await this.sb(G);if(!q)return null;const me=w.URI.revive(U);if(typeof q.getCanonicalURI>"u")return me;const _=await(0,A.$Lg)(()=>q.getCanonicalURI(me));return _||me}$startExtensionHost(G){G.toAdd.forEach(me=>me.extensionLocation=w.URI.revive(me.extensionLocation));const{globalRegistry:U,myExtensions:q}=fe(this.I,this.L,this.J,G);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(q),z.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.rb()}$activateByEvent(G,U){return U===1?this.D.wait().then(q=>this.Z(G,!1)):this.G.wait().then(q=>this.Z(G,!1))}async $activate(G,U){return await this.G.wait(),this.J.getExtensionDescription(G)?(await this.$(G,U),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(ie=>ie.extensionLocation=w.URI.revive(ie.extensionLocation));const{globalRegistry:U,myExtensions:q}=fe(this.I,this.L,this.J,G),me=await this.bb(q);return(await this.getExtensionPathIndex()).setSearchTree(me),this.L.set(U.getAllExtensionDescriptions()),this.J.set(q),z.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const U=m.$ae.alloc(G),q=Math.random()%256;for(let me=0;me<G;me++)U.writeUInt8(q,me);return U}async $updateRemoteConnectionData(G){this.W=G,this.a.fire()}};e.$ucc=V,e.$ucc=V=K=He([Be(0,a.$Mh),Be(1,e.$tcc),Be(2,u.$bM),Be(3,p.$Zbc),Be(4,v.$3bc),Be(5,R.$8i),Be(6,i.$rM),Be(7,s.$gcc),Be(8,k.$Wvb),Be(9,$.$icc),Be(10,L.$qcc),Be(11,T.$rcc)],V);function fe(ve,G,U,q){ve.addActivationEvents(q.addActivationEvents);const me=new c.$_3b(ve,G.getAllExtensionDescriptions());me.deltaExtensions(q.toAdd,q.toRemove);const _=new o.$4l(U.getAllExtensionDescriptions().map(re=>re.identifier));for(const re of q.myToRemove)_.delete(re);for(const re of q.myToAdd)_.add(re);const ie=oe(me,_);return{globalRegistry:me,myExtensions:ie}}function X(ve,G){return{id:ve.identifier.value,name:ve.name,extensionVersion:ve.version,publisherDisplayName:ve.publisher,activationEvents:ve.activationEvents?ve.activationEvents.join(","):null,isBuiltin:ve.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function Q(ve){return ve.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.$vcc=(0,a.$Nh)("IExtHostExtensionService");class Z{#e;#t;#i;constructor(G,U,q,me,_){this.#e=G,this.#t=U,this.#i=q.identifier,this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=F.$gc((0,M.$ig)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=me,this.isFromDifferentExtensionHost=_}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$wcc=Z;function oe(ve,G){return ve.getAllExtensionDescriptions().filter(U=>G.has(U.identifier))}class x{constructor(G){this.a=G}setSearchTree(G){this.a=G}findSubstr(G){return this.a.findSubstr(G)}forEach(G){return this.a.forEach(G)}}e.$xcc=x;class ae{constructor(G){this.a=new o.$5l,this.addActivationEvents(G)}readActivationEvents(G){return this.a.get(G.identifier)}addActivationEvents(G){for(const U of Object.keys(G))this.a.set(U,G[U])}}}),define(De[349],Ce([1,0,54,2,6,40,26,25,20,27,5,45,13,15]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;let p=class{constructor(m,h,t,n,a,i,s){this.c=m,this.d=h,this.e=t,this.f=n,this.g=a,this.h=i,this.i=s,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const m=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new c(this.c,h,this.d,m,this.i)),this.register(this.e.createInstance(l)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,h,this.h.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const h of m.nodeModuleName)this.a.set(h,m);else this.a.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this.b.push(h=>m.alternativeModuleName(h))}};e.$Tdc=p,e.$Tdc=p=He([Be(2,R.$Mh),Be(3,M.$3bc),Be(4,I.$vcc),Be(5,w.$rM),Be(6,v.$8i)],p);let l=class{static{D=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(m){if(m.environment.appRoot&&D.a.size){const h=(0,y.$Ee)(this.c(m.environment.appRoot.fsPath)),t="[a-z0-9_.-]",n=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${a}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(m){if(!this.b)return;const h=this.b.exec(this.c(m));if(!h)return;const[,t,n,a]=h,i=D.a.get(n);if(i!==void 0)return console.warn(`${n} as been renamed to ${i}, please update your imports`),t+i+a}c(m){return m.replace(/\\/g,"/")}};l=D=He([Be(0,w.$rM)],l);class c{constructor(m,h,t,n,a){this.c=m,this.d=h,this.e=t,this.f=n,this.g=a,this.nodeModuleName="vscode",this.a=new b.$5l}load(m,h){const t=this.d.findSubstr(h);if(t){let n=this.a.get(t.identifier);return n||(n=this.c(t,this.e,this.f),this.a.set(t.identifier,n)),n}if(!this.b){let n="";this.d.forEach((a,i)=>n+=`	${i} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${n}`),this.b=this.c(A.$7E,this.e,this.f)}return this.b}}let r=class{constructor(m,h,t){this.e=m,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(d.$aK.MainThreadTelemetry);const n=t.getProxy(d.$aK.MainThreadWindow);this.c=(a,i)=>{const s=F.URI.parse(a);return i?this.g(a,i):s.scheme==="http"||s.scheme==="https"?n.$openUri(s,a,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this.f?n.$openUri(s,a,{}):this.g(a,i)}}load(m,h,t){const n=this.e.findSubstr(h);return n&&(this.a=n.identifier.value,this.h()),this.b=t(m),this.c}g(m,h){return this.i(),this.b(m,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=He([Be(2,E.$bM)],r)}),define(De[56],Ce([1,0,46,3,16,48,5,69,70,45,7,39,278,40]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=void 0,e.$4cc=(0,A.$Nh)("IExtHostVariableResolverProvider");class D extends v.$cN{constructor(c,r,o,m,h,t,n){function a(){if(o){const i=o.activeEditor();if(i)return i.document.uri;const s=m.tabGroups.all.find(u=>u.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof R.$UL||s.input instanceof R.$ZL)return s.input.modified;if(s.input instanceof R.$TL||s.input instanceof R.$YL||s.input instanceof R.$WL)return s.input.uri}}}super({getFolderUri:i=>{const s=t.folders.filter(u=>u.name===i);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,s)=>h.getConfiguration(void 0,i).get(s),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=a();if(i)return d.$gc(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const i=a();if(i){const s=r.getWorkspaceFolder(i);if(s)return d.$gc(s.uri.fsPath)}}},getSelectedText:()=>{if(o){const i=o.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(o){const i=o.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>c.getExtension(i)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(M.env))}}let p=class extends F.$Rc{constructor(c,r,o,m,h){super(),this.b=c,this.c=r,this.g=o,this.h=m,this.j=h,this.a=new C.$U(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async i=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new D(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$5cc=p,e.$5cc=p=He([Be(0,w.$vcc),Be(1,I.$Zbc),Be(2,b.$mM),Be(3,y.$3bc),Be(4,E.$2cc)],p)}),define(De[94],Ce([1,0,9,4,2,5,6,70,45,20,7,39,140,271,40,56]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=e.$9cc=e.$8cc=e.$7cc=e.$6cc=void 0,e.$6cc=(0,M.$Nh)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,a,i,s,u,S){this.E=a,this.F=i,this.G=s,this.H=u,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$Md,this.n=new F.$Md,this.o=new F.$Md,this.u=new F.$Md,this.k=n.getProxy(A.$aK.MainThreadDebugService),this.y=new F.$Md,this.A=new F.$Md,this.v=new r(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange($=>{this.J(k)}),this.J(k)})}asDebugSourceUri(n,a){const i=n;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let s=`debug:${encodeURIComponent(i.path||"")}`,u="?";return a&&(s+=`${u}session=${encodeURIComponent(a.id)}`,u="&"),s+=`${u}ref=${i.sourceReference}`,d.URI.parse(s)}else{if(i.path)return d.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(n){const a=[];for(const i of n.getAllExtensionDescriptions())if(i.contributes){const s=i.contributes.debuggers;if(s&&s.length>0)for(const u of s)(0,y.$rF)(u)&&a.push(u.type)}this.k.$registerDebugTypes(a)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const n=[];return this.w.forEach(a=>n.push(a)),n}addBreakpoints(n){const a=n.filter(u=>{const S=u.id;return this.w.has(S)?!1:(this.w.set(S,u),!0)});this.U(a,[],[]);const i=[],s=new Map;for(const u of a)if(u instanceof R.$bL){let S=s.get(u.location.uri.toString());S||(S={type:"sourceMulti",uri:u.location.uri,lines:[]},s.set(u.location.uri.toString(),S),i.push(S)),S.lines.push({id:u.id,enabled:u.enabled,condition:u.condition,hitCondition:u.hitCondition,logMessage:u.logMessage,line:u.location.range.start.line,character:u.location.range.start.character})}else u instanceof R.$cL&&i.push({type:"function",id:u.id,enabled:u.enabled,hitCondition:u.hitCondition,logMessage:u.logMessage,condition:u.condition,functionName:u.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(n){const a=n.filter(S=>this.w.delete(S.id));this.U([],a,[]);const i=a.filter(S=>S instanceof R.$bL).map(S=>S.id),s=a.filter(S=>S instanceof R.$cL).map(S=>S.id),u=a.filter(S=>S instanceof R.$dL).map(S=>S.id);return this.k.$unregisterBreakpoints(i,s,u)}startDebugging(n,a,i){return this.k.$startDebugging(n?n.uri:void 0,a,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,a,i){if(!a)return new R.$cK(()=>{});const s=this.d++;return this.f.push({type:n,handle:s,provider:a}),this.k.$registerDebugConfigurationProvider(n,i,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,s),new R.$cK(()=>{this.f=this.f.filter(u=>u.provider!==a),this.k.$unregisterDebugConfigurationProvider(s)})}registerDebugAdapterDescriptorFactory(n,a,i){if(!i)return new R.$cK(()=>{});if(!this.Q(n,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.N(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const s=this.g++;return this.h.push({type:a,handle:s,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(a,s),new R.$cK(()=>{this.h=this.h.filter(u=>u.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(s)})}registerDebugAdapterTrackerFactory(n,a){if(!a)return new R.$cK(()=>{});const i=this.i++;return this.j.push({type:n,handle:i,factory:a}),new R.$cK(()=>{this.j=this.j.filter(s=>s.factory!==a)})}async $runInTerminal(n,a){return Promise.resolve(void 0)}async $substituteVariables(n,a){let i;const s=await this.W(n);return s&&(i={uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(i,a)}K(n,a){if(n.type==="implementation")return new m(n.implementation)}L(){}async $startDASession(n,a){const i=this,s=await this.V(a);return this.S(this.N(s.type),s).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}' (extension might have failed to activate)`);const S=this.M(u),k=this.K(S,s);if(!k)throw new Error(`Couldn't create a debug adapter for type '${s.type}'.`);const $=k;return this.B.set(n,$),this.R(s).then(f=>(f&&this.C.set(n,f),$.onMessage(async g=>{if(g.type==="request"&&g.command==="handshake"){const P=g,O={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const N=await this.D.sign(P.arguments.value);O.body={signature:N},$.sendResponse(O)}else throw new Error("no signer")}catch(N){O.success=!1,O.message=N.message,$.sendResponse(O)}}else f&&f.onDidSendMessage&&f.onDidSendMessage(g),g=(0,y.$wF)(g,!0),i.k.$acceptDAMessage(n,g)}),$.onError(g=>{f&&f.onError&&f.onError(g),this.k.$acceptDAError(n,g.name,g.message,g.stack)}),$.onExit(g=>{f&&f.onExit&&f.onExit(g??void 0,void 0),this.k.$acceptDAExit(n,g??void 0,void 0)}),f&&f.onWillStartSession&&f.onWillStartSession(),$.startSession()))})}$sendDAMessage(n,a){a=(0,y.$vF)(a,!1);const i=this.C.get(n);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(a),this.B.get(n)?.sendMessage(a)}$stopDASession(n){const a=this.C.get(n);this.C.delete(n),a&&a.onWillStopSession&&a.onWillStopSession();const i=this.B.get(n);return this.B.delete(n),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const a=[],i=[],s=[];if(n.added)for(const u of n.added){const S=u.id;if(S&&!this.w.has(S)){let k;if(u.type==="function")k=new R.$cL(u.functionName,u.enabled,u.condition,u.hitCondition,u.logMessage);else if(u.type==="data")k=new R.$dL(u.label,u.dataId,u.canPersist,u.enabled,u.hitCondition,u.condition,u.logMessage);else{const $=d.URI.revive(u.uri);k=new R.$bL(new R.$oK($,new R.$dK(u.line,u.character)),u.enabled,u.condition,u.hitCondition,u.logMessage)}(0,R.$_K)(k,S),this.w.set(S,k),a.push(k)}}if(n.removed)for(const u of n.removed){const S=this.w.get(u);S&&(this.w.delete(u),i.push(S))}if(n.changed){for(const u of n.changed)if(u.id){const S=this.w.get(u.id);if(S){if(S instanceof R.$cL&&u.type==="function"){const k=S;k.enabled=u.enabled,k.condition=u.condition,k.hitCondition=u.hitCondition,k.logMessage=u.logMessage,k.functionName=u.functionName}else if(S instanceof R.$bL&&u.type==="source"){const k=S;k.enabled=u.enabled,k.condition=u.condition,k.hitCondition=u.hitCondition,k.logMessage=u.logMessage,k.location=new R.$oK(d.URI.revive(u.uri),new R.$dK(u.line,u.character))}s.push(S)}}}this.U(a,i,s)}async $acceptStackFrameFocus(n){let a;const i=n.sessionId?await this.V(n.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?a=new R.$jL(i,n.threadId):a=new R.$iL(i,n.threadId,n.frameId),this.z=a,this.A.fire(this.z)}$provideDebugConfigurations(n,a,i){return(0,C.$Lg)(async()=>{const s=this.P(n);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const u=await this.W(a);return s.provideDebugConfigurations(u,i)}).then(s=>{if(!s)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return s})}$resolveDebugConfiguration(n,a,i,s){return(0,C.$Lg)(async()=>{const u=this.P(n);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(a);return u.resolveDebugConfiguration(S,i,s)})}$resolveDebugConfigurationWithSubstitutedVariables(n,a,i,s){return(0,C.$Lg)(async()=>{const u=this.P(n);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(a);return u.resolveDebugConfigurationWithSubstitutedVariables(S,i,s)})}async $provideDebugAdapter(n,a){const i=this.O(n);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const s=await this.V(a);return this.S(i,s).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}'`);return this.M(u)})}async $acceptDebugSessionStarted(n){const a=await this.V(n);this.m.fire(a)}async $acceptDebugSessionTerminated(n){const a=await this.V(n);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,a){(await this.V(n))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(n,a){const s={session:await this.V(n),event:a.event,body:a.body};this.u.fire(s)}M(n){if(n instanceof R.$eL)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof R.$fL)return{type:"server",port:n.port,host:n.host};if(n instanceof R.$gL)return{type:"pipeServer",path:n.path};if(n instanceof R.$hL)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}N(n){const a=this.h.filter(i=>i.type===n);if(a.length>0)return a[0].factory}O(n){const a=this.h.filter(i=>i.handle===n);if(a.length>0)return a[0].factory}P(n){const a=this.f.filter(i=>i.handle===n);if(a.length>0)return a[0].provider}Q(n,a){if(n.contributes){const i=n.contributes.debuggers;if(i&&i.length>0){for(const s of i)if(s.label&&s.type&&s.type===a)return!0}}return!1}R(n){const i=n.configuration.type,s=this.j.filter(u=>u.type===i||u.type==="*").map(u=>(0,C.$Lg)(()=>u.factory.createDebugAdapterTracker(n)).then(S=>S,S=>null));return Promise.race([Promise.all(s).then(u=>{const S=u.filter(k=>!!k);if(S.length>0)return new o(S)}),new Promise(u=>setTimeout(()=>u(void 0),1e3))]).catch(u=>{})}async S(n,a){const i=a.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new R.$fL(i));if(n){const u=await this.F.getExtensionRegistry();return(0,C.$Lg)(()=>n.createDebugAdapterDescriptor(a,this.T(a,u))).then(S=>{if(S)return S})}const s=await this.F.getExtensionRegistry();return Promise.resolve(this.T(a,s))}T(n,a){}U(n,a,i){(n.length>0||a.length>0||i.length>0)&&this.y.fire(Object.freeze({added:n,removed:a,changed:i}))}async V(n){if(n)if(typeof n=="string"){const a=this.l.get(n);if(a)return a}else{let a=this.l.get(n.id);if(!a){const i=await this.W(n.folderUri),s=n.parent?this.l.get(n.parent):void 0;a=new c(this.k,n.id,n.type,n.name,i,n.configuration,s),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(n){if(n){const a=d.URI.revive(n);return this.E.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.$7cc=l,e.$7cc=l=He([Be(0,w.$bM),Be(1,I.$Zbc),Be(2,E.$vcc),Be(3,D.$3bc),Be(4,b.$2cc),Be(5,p.$4cc)],l);class c{constructor(n,a,i,s,u,S,k){this.d=n,this.f=a,this.g=i,this.h=s,this.i=u,this.j=S,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,a){return this.d.$customDebugAdapterRequest(this.f,n,a)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$8cc=c;class r{constructor(n){this.value=Object.freeze({append(a){n.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.$9cc=r;class o{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(a=>a.onError?a.onError(n):void 0)}onExit(n,a){this.d.forEach(i=>i.onExit?i.onExit(n,a):void 0)}}class m extends v.$Ycb{constructor(n){super(),this.h=n,n.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends l{constructor(n,a,i,s,u,S){super(n,a,i,s,u,S)}};e.$0cc=h,e.$0cc=h=He([Be(0,w.$bM),Be(1,I.$Zbc),Be(2,E.$vcc),Be(3,D.$3bc),Be(4,b.$2cc),Be(5,p.$4cc)],h)}),define(De[350],Ce([1,0,8,54,2,6,341,13,103,104,27,238,20,66,45,88]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=e.$Udc=void 0;class l{static async installEarlyHandler(o){Error.stackTraceLimit=100;const m=o.get(b.$8i),t=o.get(v.$bM).getProxy(M.$aK.MainThreadErrors);C.setUnexpectedErrorHandler(n=>{m.error(n);const a=C.$2(n);t.$onUnexpectedError(a)})}static async installFullHandler(o){const m=o.get(b.$8i),h=o.get(v.$bM),t=o.get(D.$vcc),n=o.get(p.$vM),a=h.getProxy(M.$aK.MainThreadExtensionService),i=h.getProxy(M.$aK.MainThreadErrors),s=await t.getExtensionPathIndex(),u=new WeakMap;function S(f,g){if(u.has(f))return u.get(f).stack;let P="",O,N;for(const j of g)P+=`
	at ${j.toString()}`,N=j.getFileName(),!O&&N&&(O=s.findSubstr(d.URI.file(N)));const L=`${f.name||"Error"}: ${f.message||""}${P}`;return u.set(f,{extensionIdentifier:O?.identifier,stack:L}),L}const k=Symbol("prepareStackTrace wrapped");let $=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(f){if(f===S||!f||f[k]){$=f||S;return}$=function(g,P){return S(g,P),f.call(Error,g,P)},Object.assign($,{[k]:!0})}}),C.setUnexpectedErrorHandler(f=>{m.error(f);const g=C.$2(f),P=u.get(f);if(!P?.extensionIdentifier){i.$onUnexpectedError(g);return}a.$onExtensionRuntimeError(P.extensionIdentifier,g);const O=n.onExtensionError(P.extensionIdentifier,f);m.trace("forwarded error to extension?",O,P)})}}e.$Udc=l;class c{constructor(o,m,h,t,n){this.a=h,this.b=new A.$i4b(o,null,t),m=c.e(m,this.b);const a=new w.$Lh(...(0,E.$ur)());a.set(R.$rM,{_serviceBrand:void 0,...m,messagePorts:n}),a.set(v.$bM,new v.$cM(this.b)),a.set(y.$Wbc,new y.$Xbc(t)),a.set(D.$tcc,h);const i=new I.$aq(a,!0);i.invokeFunction(l.installEarlyHandler),this.d=i.invokeFunction(s=>s.get(b.$8i)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",m),this.c=i.invokeFunction(s=>s.get(D.$vcc)),this.c.initialize(),i.invokeFunction(l.installFullHandler)}async asBrowserUri(o){const m=this.b.getProxy(M.$aK.MainThreadExtensionService);return d.URI.revive(await m.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,m){o.extensions.allExtensions.forEach(t=>{t.extensionLocation=d.URI.revive(m.transformIncomingURIs(t.extensionLocation))}),o.environment.appRoot=d.URI.revive(m.transformIncomingURIs(o.environment.appRoot));const h=o.environment.extensionDevelopmentLocationURI;return h&&(o.environment.extensionDevelopmentLocationURI=h.map(t=>d.URI.revive(m.transformIncomingURIs(t)))),o.environment.extensionTestsLocationURI=d.URI.revive(m.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=d.URI.revive(m.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=d.URI.revive(m.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=d.URI.revive(m.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=d.URI.revive(m.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=d.URI.revive(m.transformIncomingURIs(o.logsLocation)),o.workspace=m.transformIncomingURIs(o.workspace),o}}e.$Vdc=c}),define(De[351],Ce([1,0,9,12,215,232,138,94,70,45,20,44,7,56,39,272,273,40]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;let r=class extends b.$7cc{constructor(n,a,i,s,u,S,k){super(n,a,i,s,S,k),this.Z=u,this.X=new h}K(n,a){switch(n.type){case"server":return new p.$1dc(n);case"pipeServer":return new p.$2dc(n);case"executable":return new p.$3dc(n,a.type)}return super.K(n,a)}T(n,a){const i=p.$3dc.platformAdapterExecutable(a.getAllExtensionDescriptions(),n.type);if(i)return new v.$eL(i.command,i.args,i.options)}L(){return new A.$Y7b}async $runInTerminal(n,a){if(n.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(L=>{this.X.onTerminalClosed(L)}));const i=await this.G.getConfigProvider(),s=this.Z.getDefaultShell(!0),u=this.Z.getDefaultShellArgs(!0),S=n.title||d.localize(0,null),k=JSON.stringify({shell:s,shellArgs:u});let $=await this.X.checkout(k,S),f,g=!1;if($)f=n.cwd;else{const L={shellPath:s,shellArgs:u,cwd:n.cwd,name:S,iconPath:new v.$9K("debug")};g=!0,$=this.Z.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert($,k)}$.show(!0);const P=await $.processId;g?await new Promise(L=>setTimeout(L,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?$.sendText("cls"):s.indexOf("bash")>=0?$.sendText("clear"):F.$j?$.sendText("cls"):$.sendText("clear"));const O=(0,l.$5dc)(s,n.args,!!n.argsCanBeInterpretedByShell,f,n.env);$.sendText(O);const N=this.onDidTerminateDebugSession(L=>{L.id===a&&(this.X.free($),N.dispose())});return P}else if(n.kind==="external")return m(n,await this.G.getConfigProvider());return super.$runInTerminal(n,a)}};e.$6dc=r,e.$6dc=r=He([Be(0,R.$bM),Be(1,D.$Zbc),Be(2,w.$vcc),Be(3,c.$3bc),Be(4,I.$icc),Be(5,E.$2cc),Be(6,y.$4cc)],r);let o;function m(t,n){if(!o)if(F.$j)o=new M.$I6b;else if(F.$k)o=new M.$J6b;else if(F.$l)o=new M.$K6b;else throw new Error("external terminals not supported on this platform");const a=n.getConfiguration("terminal");return o.runInTerminal(t.title,t.cwd,t.args,t.env||{},a.external||{})}class h{constructor(){this.b=new Map}static{this.a=1e3}async checkout(n,a){const s=[...this.b.entries()].map(([u,S])=>(0,C.$Gg)(async k=>{if(u.name!==a||S.lastUsedAt!==-1&&await(0,l.$4dc)(await u.processId))return null;const $=Date.now();return S.lastUsedAt+h.a>$||k.isCancellationRequested||S.config!==n?null:(S.lastUsedAt=$,u)}));return await(0,C.$Xg)(s,u=>!!u)}insert(n,a){this.b.set(n,{lastUsedAt:Date.now(),config:a})}free(n){const a=this.b.get(n);a&&(a.lastUsedAt=-1)}onTerminalClosed(n){this.b.delete(n)}}}),define(De[352],Ce([1,0,16,2,101,39,69,40,43,44,20,27,93,17,13,89,23,63,56]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=void 0;let o=class extends v.$Ycc{constructor(h,t,n,a,i,s,u,S,k){super(h,t,n,a,i,s,u,S),this.B=n,this.C=k,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(h,t){const n=t;if(!t.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const a=v.TaskHandleDTO.from(n,this.B),i=await this.a.$getTaskExecution(a);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.y(i,t);return this.a.$executeTask(a).catch(()=>{}),s}else{const a=v.TaskDTO.from(t,h);if(a===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(a.execution)&&await this.x(a,t,!1);const i=await this.y(await this.a.$getTaskExecution(a),t);return this.a.$executeTask(a).catch(()=>{}),i}}u(h,t,n,a){const i=[];if(a)for(const s of a){this.z(s,n),(!s.definition||!h[s.definition.type])&&this.f.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const u=v.TaskDTO.from(s,n.extension);u&&(i.push(u),v.CustomExecutionDTO.is(u.execution)&&t.push(this.x(u,s,!0)))}return{tasks:i,extension:n.extension}}async v(h){return h}async F(h){let t=h&&h.length>0?h[0]:void 0;if(!t){const n=F.URI.file((0,c.homedir)());t=new E.$8h({uri:n,name:l.$rg(n),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(h,t){const n=F.URI.revive(h),a={process:void 0,variables:Object.create(null)},i=await this.b.resolveWorkspaceFolder(n),s=await this.b.getWorkspaceFolders2()??[],u=await this.C.getResolver(),S=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(s);for(const k of t.variables)a.variables[k]=await u.resolveAsync(S,k);if(t.process!==void 0){let k;if(t.process.path!==void 0){k=t.process.path.split(C.$sc);for(let $=0;$<k.length;$++)k[$]=await u.resolveAsync(S,k[$])}a.process=await d.win32.findExecutable(await u.resolveAsync(S,t.process.name),t.process.cwd!==void 0?await u.resolveAsync(S,t.process.cwd):void 0,k)}return a}async $jsonTasksSupported(){return!0}async $findExecutable(h,t,n){return d.win32.findExecutable(h,t,n)}};e.$Xdc=o,e.$Xdc=o=He([Be(0,R.$bM),Be(1,I.$rM),Be(2,M.$Zbc),Be(3,A.$mM),Be(4,b.$3bc),Be(5,w.$icc),Be(6,D.$8i),Be(7,p.$Pbc),Be(8,r.$4cc)],o)}),define(De[353],Ce([1,0,63,56]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;class d extends F.$5cc{m(){return(0,C.homedir)()}}e.$Dec=d}),define(De[153],Ce([1,0,19,9,21,47,17,16,23,2,36]),function($e,e,C,F,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=e.$bdc=e.$adc=e.$_cc=void 0;class I{constructor(r,o,m,h){this.d=r,this.e=o,this.f=m,this.g=h,this.a=null,this.b=!1,this.c=0}search(r,o){const m=this.d.folderQueries||[],h=new d.$Wd(o);return new Promise((t,n)=>{this.a=new y(r);let a=!1;const i=(s,u)=>{if(!a&&!this.b){const S=this.h(s);p(s)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,a=!0,h.cancel(),s=this.j(s,this.d.maxResults-this.c));const k=this.h(s);this.c+=k,(k>0||!p(s))&&this.a.add(s,u)}};Promise.all(m.map((s,u)=>this.k(s,S=>i(S,u),h.token))).then(s=>{h.dispose(),this.a.flush();const u=s.some(S=>!!S&&!!S.limitHit);t({limitHit:this.b||u,messages:(0,C.$Qb)(s.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},s=>{h.dispose();const u=(0,M.$yi)(s);n(new Error(u))})})}h(r){return p(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,o){const m=Array.isArray(r.ranges)?r.ranges:[r.ranges],h=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:m.slice(0,o),preview:{matches:h.slice(0,o),text:r.preview.text},uri:r.uri}}async k(r,o,m){const h=new R.$XI(this.d,r),t=[],n={report:s=>{if(!this.l(s))return;const u=r.folder.scheme===A.Schemas.file?(0,R.$YI)(()=>this.f.readdir(E.$tg(s.uri))):void 0,S=E.$wg(r.folder,s.uri);if(S){const k=h.includedInQuery(S,b.$mc(S),u);(0,F.$Fg)(k)?t.push(k.then($=>{$&&o(s)})):k&&o(s)}}},a=this.n(r),i=await this.e.provideTextSearchResults(v(this.d.contentPattern),a,n,m);return t.length&&await Promise.all(t),i}l(r){if(p(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const o=(0,R.$WI)(this.d.includePattern,r.includePattern),m=(0,R.$WI)(this.d.excludePattern,r.excludePattern),h={folder:w.URI.from(r.folder),excludes:m,includes:o,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.f.toCanonicalName(r.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$_cc=I;function v(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class y{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new l(512,o=>this.g(o))}add(r,o){this.d&&(this.b!==o||!E.$ng(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:r.uri,results:[]}),this.d.results.push(D(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$adc=y;function D(c){return p(c)?{preview:{matches:(0,C.$1b)(c.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:c.preview.text},ranges:(0,C.$1b)(c.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function p(c){return!!c.preview}e.$bdc=p;class l{static{this.a=4e3}static{this.b=50}constructor(r,o){this.g=r,this.h=o,this.c=0,this.d=[],this.e=0}addItem(r,o){r&&this.j(r,o)}addItems(r,o){r&&this.k(r,o)}j(r,o){this.d.push(r),this.e+=o,this.l()}k(r,o){this.d=this.d.concat(r),this.e+=o,this.l()}l(){this.c<l.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},l.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$cdc=l}),define(De[95],Ce([1,0,3,6,5,346,20,66,13,2,153]),function($e,e,C,F,d,M,A,b,E,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=e.$ddc=void 0,e.$ddc=(0,d.$Nh)("IExtHostSearch");let I=class{constructor(p,l,c){this.k=p,this.l=l,this.n=c,this.c=this.k.getProxy(F.$aK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$$cc}o(p){return this.l.transformOutgoingScheme(p)}registerTextSearchProvider(p,l){if(this.g.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this.g.add(p);const c=this.d++;return this.e.set(c,l),this.c.$registerTextSearchProvider(c,this.o(p)),(0,C.$Pc)(()=>{this.g.delete(p),this.e.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(p,l){if(this.i.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this.i.add(p);const c=this.d++;return this.h.set(c,l),this.c.$registerFileSearchProvider(c,this.o(p)),(0,C.$Pc)(()=>{this.i.delete(p),this.h.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(p,l,c,r){const o=v(c),m=this.h.get(p);if(m)return this.j.fileSearch(o,m,h=>{this.c.$handleFileMatch(p,l,h.map(t=>t.resource))},r);throw new Error("unknown provider: "+p)}$clearCache(p){return this.j.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,l,c,r){const o=this.e.get(p);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const m=v(c);return this.q(m,o).search(t=>this.c.$handleTextMatch(p,l,t),r)}$enableExtensionHostSearch(){}q(p,l){return new R.$_cc(p,l,{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}};e.$edc=I,e.$edc=I=He([Be(0,A.$bM),Be(1,b.$Wbc),Be(2,E.$8i)],I);function v(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(y),extraFileResources:D.extraFileResources&&D.extraFileResources.map(p=>w.URI.revive(p))}}e.$fdc=v;function y(D){return{...D,folder:w.URI.revive(D.folder)}}}),define(De[354],Ce([1,0,21,8,4,38,2,130,125,168,185,30,6,111,301,300,33,302,40,304,305,306,280,307,69,45,309,310,315,316,317,152,284,323,324,326,115,44,328,287,14,7,85,331,91,151,39,25,276,314,65,149,93,94,95,13,66,20,27,318,274,72,89,294,329,90,71,334,332,333,295,55,327,330,114,70,88,319,92,320,17,134,283,263,312,3,26,270,112,257,321,322,296,311,282,313,113,325,298,299,293,308,297]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m,h,t,n,a,i,s,u,S,k,$,f,g,P,O,N,L,j,z,T,K,V,fe,X,Q,Z,oe,x,ae,ve,G,U,q,me,_,ie,re,Ee,ce,de,ee,he,be,Pe,B,J,te,se,Y,ge,ye,je,We,_e,Ye,it,et,Ae,Oe,qe,Me,Ze,le,ue,Ie,Ve,ze,Xe,rt,ot,wt,Et,Yt,Kt,pt,Ut,Tt,Bt,Pt,At,Ot,Wt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;function qt(ct){const lt=ct.get(ce.$rM),Jt=ct.get(je.$Mbc),It=ct.get(te.$fcc),kt=ct.get(i.$vcc),ft=ct.get(oe.$Zbc),Dt=ct.get(et.$vM),Ft=ct.get(r.$3bc),yt=ct.get(re.$Wbc),Ge=ct.get(Ee.$bM),Nt=ct.get(L.$bcc),jt=ct.get(J.$gcc),Le=ct.get(ie.$9i),Fe=ct.get(ie.$8i),Se=ct.get(he.$Wvb),ne=ct.get(be.$Pbc),Te=ct.get(Z.$Tcc),Ke=ct.get(Ye.$ncc),xe=ct.get(it.$2cc),Je=ct.get(Tt.$rcc);Ge.set(v.$bK.ExtHostFileSystemInfo,Jt),Ge.set(v.$bK.ExtHostLogLevelServiceShape,Le),Ge.set(v.$bK.ExtHostWorkspace,ft),Ge.set(v.$bK.ExtHostConfiguration,Ft),Ge.set(v.$bK.ExtHostExtensionService,kt),Ge.set(v.$bK.ExtHostStorage,Nt),Ge.set(v.$bK.ExtHostTunnelService,Se),Ge.set(v.$bK.ExtHostWindow,Te),Ge.set(v.$bK.ExtHostSecretState,Ke),Ge.set(v.$bK.ExtHostTelemetry,Dt),Ge.set(v.$bK.ExtHostEditorTabs,xe),Ge.set(v.$bK.ExtHostManagedSockets,Je);const nt=Ge.set(v.$bK.ExtHostDecorations,ct.get(U.$Xcc)),mt=Ge.set(v.$bK.ExtHostDocumentsAndEditors,ct.get(a.$mM)),gt=Ge.set(v.$bK.ExtHostCommands,ct.get(l.$xM)),bt=Ge.set(v.$bK.ExtHostTerminalService,ct.get(j.$icc)),dt=Ge.set(v.$bK.ExtHostDebugService,ct.get(me.$6cc)),Rt=Ge.set(v.$bK.ExtHostSearch,ct.get(_.$ddc)),Gt=Ge.set(v.$bK.ExtHostTask,ct.get(q.$1cc)),Ei=Ge.set(v.$bK.ExtHostOutputService,ct.get(f.$Dcc)),Vt=Ge.set(v.$bK.ExtHostLocalization,ct.get(rt.$qcc)),mi=Ge.set(v.$bK.ExtHostUrls,new X.$Mcc(Ge)),Ct=Ge.set(v.$bK.ExtHostDocuments,new n.$Kbc(Ge,mt)),ki=Ge.set(v.$bK.ExtHostDocumentContentProviders,new h.$5bc(Ge,mt,Fe)),qi=Ge.set(v.$bK.ExtHostDocumentSaveParticipant,new t.$6bc(Fe,Ct,Ge.getProxy(v.$aK.MainThreadBulkEdits))),St=Ge.set(v.$bK.ExtHostNotebook,new de.$jdc(Ge,gt,mt,Ct,It)),ii=Ge.set(v.$bK.ExtHostNotebookDocuments,new ue.$Bdc(St)),$i=Ge.set(v.$bK.ExtHostNotebookEditors,new le.$Adc(Fe,St)),oi=Ge.set(v.$bK.ExtHostNotebookKernels,new Ae.$xdc(Ge,lt,St,gt,Fe)),Si=Ge.set(v.$bK.ExtHostNotebookRenderers,new qe.$zdc(Ge,St)),Di=Ge.set(v.$bK.ExtHostNotebookDocumentSaveParticipant,new pt.$Hdc(Fe,St,Ge.getProxy(v.$aK.MainThreadBulkEdits))),Mt=Ge.set(v.$bK.ExtHostEditors,new z.$Kcc(Ge,mt)),bi=Ge.set(v.$bK.ExtHostTreeViews,new T.$Lcc(Ge.getProxy(v.$aK.MainThreadTreeViews),gt,Fe)),Ci=Ge.set(v.$bK.ExtHostEditorInsets,new ae.$Ucc(Ge.getProxy(v.$aK.MainThreadEditorInsets),Mt,lt.remote)),ai=Ge.set(v.$bK.ExtHostDiagnostics,new o.$Obc(Ge,Fe,Jt,mt)),ci=Ge.set(v.$bK.ExtHostLanguages,new k.$Acc(Ge,Ct,gt.converter,yt)),ut=Ge.set(v.$bK.ExtHostLanguageFeatures,new S.$Sbc(Ge,yt,Ct,gt,ai,Fe,ne,Dt)),Vi=Ge.set(v.$bK.ExtHostFileSystem,new s.$ycc(Ge,ut)),Xt=Ge.set(v.$bK.ExtHostFileSystemEventService,new u.$zcc(Ge,Fe,mt)),ni=Ge.set(v.$bK.ExtHostQuickOpen,(0,P.$Fcc)(Ge,ft,gt)),wi=Ge.set(v.$bK.ExtHostSCM,new O.$Hcc(Ge,gt,Ct,Fe)),Ii=Ge.set(v.$bK.ExtHostQuickDiff,new Et.$Edc(Ge,yt)),Ki=Ge.set(v.$bK.ExtHostShare,new Bt.$Jdc(Ge,yt)),Pi=Ge.set(v.$bK.ExtHostComments,(0,c.$Vbc)(Ge,gt,Ct)),vi=Ge.set(v.$bK.ExtHostProgress,new g.$Ecc(Ge.getProxy(v.$aK.MainThreadProgress))),Hi=Ge.set(v.$bK.ExtHosLabelService,new ve.$Vcc(Ge)),Ai=Ge.set(v.$bK.ExtHostTheming,new ee.$kdc(Ge)),ui=Ge.set(v.$bK.ExtHostAuthentication,new Pe.$ldc(Ge)),Gi=Ge.set(v.$bK.ExtHostTimeline,new B.$ndc(Ge,gt)),pi=Ge.set(v.$bK.ExtHostWebviews,new Q.$Pcc(Ge,lt.remote,ft,Fe,ne)),Ri=Ge.set(v.$bK.ExtHostWebviewPanels,new ge.$pdc(Ge,pi,ft)),cn=Ge.set(v.$bK.ExtHostCustomEditors,new Y.$qdc(Ge,Ct,jt,pi,Ri)),Mi=Ge.set(v.$bK.ExtHostWebviewViews,new se.$odc(Ge,pi)),ri=Ge.set(v.$bK.ExtHostTesting,new We.$sdc(Ge,gt,mt)),un=Ge.set(v.$bK.ExtHostUriOpeners,new _e.$wdc(Ge)),ln=Ge.set(v.$bK.ExtHostProfileContentHandlers,new wt.$Ddc(Ge));Ge.set(v.$bK.ExtHostInteractive,new Ie.$Cdc(Ge,St,mt,gt,Fe));const Ji=Ge.set(v.$bK.ExtHostInlineChat,new Kt.$Gdc(Ge,gt,Ct,Fe)),fi=Ge.set(v.$bK.ExtHostChatProvider,new Pt.$Kdc(Ge,Fe)),Qi=Ge.set(v.$bK.ExtHostChatAgents,new Ht.$Odc(Ge,fi,Fe)),Zi=Ge.set(v.$bK.ExtHostChatVariables,new At.$Ldc(Ge)),gi=Ge.set(v.$bK.ExtHostChat,new Yt.$Fdc(Ge,Fe)),Yi=Ge.set(v.$bK.ExtHostAiRelatedInformation,new Ot.$Mdc(Ge)),Li=Ge.set(v.$bK.ExtHostAiEmbeddingVector,new Wt.$Ndc(Ge)),Xi=Ge.set(v.$bK.ExtHostIssueReporter,new Ut.$Idc(Ge)),xt=Ge.set(v.$bK.ExtHostStatusBar,new N.$Jcc(Ge,gt.converter)),yi=Object.values(v.$bK);Ge.assertRegistered(yi);const hn=new ye.$rdc(Ge,mt),Qt=new p.$Ubc(Ge),li=new $.$Bcc(Ge,Fe),Fi=new m.$4bc(Ge);return D.$Tbc.register(gt),function(Ue,_t,Ti){const $t=function(){let we=!Ue.isUnderDevelopment;function ke(){we||(Fe.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")ke();else{const vt=st;typeof vt.scheme>"u"&&ke(),typeof vt.exclusive=="boolean"&&(0,ze.$aF)(Ue,"documentFiltersExclusive")}return st}}(),xi={getSession(we,ke,Ne){return ui.getSession(Ue,we,ke,Ne)},getSessions(we,ke){return(0,ze.$aF)(Ue,"authGetSessions"),ui.getSessions(Ue,we,ke)},async hasSession(we,ke){return(0,ze.$aF)(Ue,"authSession"),!!await ui.getSession(Ue,we,ke,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(we,ke,Ne,st){return ui.registerAuthenticationProvider(we,ke,Ne,st)}},_i={registerCommand(we,ke,Ne){return gt.registerCommand(!0,we,ke,Ne,void 0,Ue)},registerTextEditorCommand(we,ke,Ne){return gt.registerCommand(!0,we,(...st)=>{const vt=Mt.getActiveTextEditor();if(!vt){Fe.warn("Cannot execute "+we+" because there is no active text editor.");return}return vt.edit(Lt=>{ke.apply(Ne,[vt,Lt,...st])}).then(Lt=>{Lt||Fe.warn("Edits from command "+we+" were not applied.")},Lt=>{Fe.warn("An error occurred while running command "+we,Lt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(we,ke,Ne)=>((0,ze.$aF)(Ue,"diffCommand"),gt.registerCommand(!0,we,async(...st)=>{const vt=mt.activeEditor(!0);if(!vt){Fe.warn("Cannot execute "+we+" because there is no active text editor.");return}const Lt=await Mt.getDiffInformation(vt.id);ke.apply(Ne,[Lt,...st])},void 0,void 0,Ue)),executeCommand(we,...ke){return gt.executeCommand(we,...ke)},getCommands(we=!1){return gt.getCommands(we)}},en={get machineId(){return lt.telemetryInfo.machineId},get sessionId(){return lt.telemetryInfo.sessionId},get language(){return lt.environment.appLanguage},get appName(){return lt.environment.appName},get appRoot(){return lt.environment.appRoot?.fsPath??""},get appHost(){return lt.environment.appHost},get uriScheme(){return lt.environment.appUriScheme},get clipboard(){return Qt.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return bt.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.$aF)(Ue,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.$aF)(Ue,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.$uM)(lt.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,ke){return et.$tM.validateSender(we),Dt.instantiateLogger(Ue,we,ke)},openExternal(we,ke){return Te.openUri(we,{allowTunneling:!!lt.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===lt.environment.appUriScheme)return mi.createAppUri(we);try{return await Te.asExternalUri(we,{allowTunneling:!!lt.remote.authority})}catch(ke){if((0,Ze.$0T)(we,Me.Schemas.http)||(0,Ze.$0T)(we,Me.Schemas.https))return we;throw ke}},get remoteName(){return(0,G.$Tk)(lt.remote.authority)},get remoteAuthority(){return(0,ze.$aF)(Ue,"resolvers"),lt.remote.authority},get uiKind(){return lt.uiKind},get logLevel(){return Fe.getLevel()},get onDidChangeLogLevel(){return Fe.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,ze.$aF)(Ue,"handleIssueUri"),Xi.registerIssueUriRequestHandler(Ue,we)},get appQuality(){return(0,ze.$aF)(Ue,"resolvers"),lt.quality},get appCommit(){return(0,ze.$aF)(Ue,"resolvers"),lt.commit}};lt.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(we,ke,Ne){return ri.createTestController(Ue,we,ke,Ne)},createTestObserver(){return(0,ze.$aF)(Ue,"testObserver"),ri.createTestObserver()},runTests(we){return(0,ze.$aF)(Ue,"testObserver"),ri.runTests(we)},get onDidChangeTestResults(){return(0,ze.$aF)(Ue,"testObserver"),ri.onResultsChanged},get testResults(){return(0,ze.$aF)(Ue,"testObserver"),ri.results}},hi=lt.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,tn={getExtension(we,ke){(0,ze.$_E)(Ue,"extensionsAny")||(ke=!1);const Ne=_t.mine.getExtensionDescription(we);if(Ne)return new i.$wcc(kt,Ue.identifier,Ne,hi,!1);if(ke){const st=_t.all.getExtensionDescription(we);if(st)return new i.$wcc(kt,Ue.identifier,st,hi,!0)}},get all(){const we=[];for(const ke of _t.mine.getAllExtensionDescriptions())we.push(new i.$wcc(kt,Ue.identifier,ke,hi,!1));return we},get allAcrossExtensionHosts(){(0,ze.$aF)(Ue,"extensionsAny");const we=new x.$4l(_t.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),ke=[];for(const Ne of _t.all.getAllExtensionDescriptions()){const st=!we.has(Ne.identifier);ke.push(new i.$wcc(kt,Ue.identifier,Ne,hi,st))}return ke},get onDidChange(){return(0,ze.$_E)(Ue,"extensionsAny")?d.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},nn={createDiagnosticCollection(we){return ai.createDiagnosticCollection(Ue.identifier,we)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:we=>ai.getDiagnostics(we),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(we,ke){return ci.changeLanguage(we.uri,ke)},match(we,ke){const Ne=Ct.getDocumentData(ke.uri)?.notebook;return(0,R.$nE)(K.LanguageSelector.from(we),ke.uri,ke.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(we,ke,Ne){return ut.registerCodeActionProvider(Ue,$t(we),ke,Ne)},registerDocumentPasteEditProvider(we,ke,Ne){return(0,ze.$aF)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,$t(we),ke,Ne)},registerCodeLensProvider(we,ke){return ut.registerCodeLensProvider(Ue,$t(we),ke)},registerDefinitionProvider(we,ke){return ut.registerDefinitionProvider(Ue,$t(we),ke)},registerDeclarationProvider(we,ke){return ut.registerDeclarationProvider(Ue,$t(we),ke)},registerImplementationProvider(we,ke){return ut.registerImplementationProvider(Ue,$t(we),ke)},registerTypeDefinitionProvider(we,ke){return ut.registerTypeDefinitionProvider(Ue,$t(we),ke)},registerHoverProvider(we,ke){return ut.registerHoverProvider(Ue,$t(we),ke,Ue.identifier)},registerEvaluatableExpressionProvider(we,ke){return ut.registerEvaluatableExpressionProvider(Ue,$t(we),ke,Ue.identifier)},registerInlineValuesProvider(we,ke){return ut.registerInlineValuesProvider(Ue,$t(we),ke,Ue.identifier)},registerDocumentHighlightProvider(we,ke){return ut.registerDocumentHighlightProvider(Ue,$t(we),ke)},registerLinkedEditingRangeProvider(we,ke){return ut.registerLinkedEditingRangeProvider(Ue,$t(we),ke)},registerReferenceProvider(we,ke){return ut.registerReferenceProvider(Ue,$t(we),ke)},registerRenameProvider(we,ke){return ut.registerRenameProvider(Ue,$t(we),ke)},registerDocumentSymbolProvider(we,ke,Ne){return ut.registerDocumentSymbolProvider(Ue,$t(we),ke,Ne)},registerWorkspaceSymbolProvider(we){return ut.registerWorkspaceSymbolProvider(Ue,we)},registerDocumentFormattingEditProvider(we,ke){return ut.registerDocumentFormattingEditProvider(Ue,$t(we),ke)},registerDocumentRangeFormattingEditProvider(we,ke){return ut.registerDocumentRangeFormattingEditProvider(Ue,$t(we),ke)},registerOnTypeFormattingEditProvider(we,ke,Ne,...st){return ut.registerOnTypeFormattingEditProvider(Ue,$t(we),ke,[Ne].concat(st))},registerDocumentSemanticTokensProvider(we,ke,Ne){return ut.registerDocumentSemanticTokensProvider(Ue,$t(we),ke,Ne)},registerDocumentRangeSemanticTokensProvider(we,ke,Ne){return ut.registerDocumentRangeSemanticTokensProvider(Ue,$t(we),ke,Ne)},registerSignatureHelpProvider(we,ke,Ne,...st){return typeof Ne=="object"?ut.registerSignatureHelpProvider(Ue,$t(we),ke,Ne):ut.registerSignatureHelpProvider(Ue,$t(we),ke,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(we,ke,...Ne){return ut.registerCompletionItemProvider(Ue,$t(we),ke,Ne)},registerInlineCompletionItemProvider(we,ke,Ne){return ke.handleDidShowCompletionItem&&(0,ze.$aF)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,ze.$aF)(Ue,"inlineCompletionsAdditions"),Ne&&(0,ze.$aF)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,$t(we),ke,Ne)},registerDocumentLinkProvider(we,ke){return ut.registerDocumentLinkProvider(Ue,$t(we),ke)},registerColorProvider(we,ke){return ut.registerColorProvider(Ue,$t(we),ke)},registerFoldingRangeProvider(we,ke){return ut.registerFoldingRangeProvider(Ue,$t(we),ke)},registerSelectionRangeProvider(we,ke){return ut.registerSelectionRangeProvider(Ue,we,ke)},registerCallHierarchyProvider(we,ke){return ut.registerCallHierarchyProvider(Ue,we,ke)},registerTypeHierarchyProvider(we,ke){return ut.registerTypeHierarchyProvider(Ue,we,ke)},setLanguageConfiguration:(we,ke)=>ut.setLanguageConfiguration(Ue,we,ke),getTokenInformationAtPosition(we,ke){return(0,ze.$aF)(Ue,"tokenInformation"),ci.tokenAtPosition(we,ke)},registerInlayHintsProvider(we,ke){return ut.registerInlayHintsProvider(Ue,we,ke)},createLanguageStatusItem(we,ke){return ci.createLanguageStatusItem(Ue,we,ke)},registerDocumentDropEditProvider(we,ke,Ne){return ut.registerDocumentOnDropEditProvider(Ue,we,ke,(0,ze.$_E)(Ue,"dropMetadata")?Ne:void 0)}},rn={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(we,ke,Ne){const st=await(A.URI.isUri(we)?Promise.resolve(sn.openTextDocument(we)):Promise.resolve(we));return Mt.showTextDocument(st,ke,Ne)},createTextEditorDecorationType(we){return Mt.createTextEditorDecorationType(Ue,we)},onDidChangeActiveTextEditor(we,ke,Ne){return Mt.onDidChangeActiveTextEditor(we,ke,Ne)},onDidChangeVisibleTextEditors(we,ke,Ne){return Mt.onDidChangeVisibleTextEditors(we,ke,Ne)},onDidChangeTextEditorSelection(we,ke,Ne){return Mt.onDidChangeTextEditorSelection(we,ke,Ne)},onDidChangeTextEditorOptions(we,ke,Ne){return Mt.onDidChangeTextEditorOptions(we,ke,Ne)},onDidChangeTextEditorVisibleRanges(we,ke,Ne){return Mt.onDidChangeTextEditorVisibleRanges(we,ke,Ne)},onDidChangeTextEditorViewColumn(we,ke,Ne){return Mt.onDidChangeTextEditorViewColumn(we,ke,Ne)},onDidCloseTerminal(we,ke,Ne){return bt.onDidCloseTerminal(we,ke,Ne)},onDidOpenTerminal(we,ke,Ne){return bt.onDidOpenTerminal(we,ke,Ne)},onDidChangeActiveTerminal(we,ke,Ne){return bt.onDidChangeActiveTerminal(we,ke,Ne)},onDidChangeTerminalDimensions(we,ke,Ne){return(0,ze.$aF)(Ue,"terminalDimensions"),bt.onDidChangeTerminalDimensions(we,ke,Ne)},onDidChangeTerminalState(we,ke,Ne){return bt.onDidChangeTerminalState(we,ke,Ne)},onDidWriteTerminalData(we,ke,Ne){return(0,ze.$aF)(Ue,"terminalDataWriteEvent"),bt.onDidWriteTerminalData(we,ke,Ne)},onDidExecuteTerminalCommand(we,ke,Ne){return(0,ze.$aF)(Ue,"terminalExecuteCommandEvent"),bt.onDidExecuteTerminalCommand(we,ke,Ne)},get state(){return Te.getState(Ue)},onDidChangeWindowState(we,ke,Ne){return Te.onDidChangeWindowState(we,ke,Ne)},showInformationMessage(we,...ke){return li.showMessage(Ue,M.default.Info,we,ke[0],ke.slice(1))},showWarningMessage(we,...ke){return li.showMessage(Ue,M.default.Warning,we,ke[0],ke.slice(1))},showErrorMessage(we,...ke){return li.showMessage(Ue,M.default.Error,we,ke[0],ke.slice(1))},showQuickPick(we,ke,Ne){return ni.showQuickPick(Ue,we,ke,Ne)},showWorkspaceFolderPick(we){return ni.showWorkspaceFolderPick(we)},showInputBox(we,ke){return ni.showInput(we,ke)},showOpenDialog(we){return Fi.showOpenDialog(Ue,we)},showSaveDialog(we){return Fi.showSaveDialog(we)},createStatusBarItem(we,ke,Ne){let st,vt,Lt;return typeof we=="string"?(st=we,vt=ke,Lt=Ne):(vt=we,Lt=ke),xt.createStatusBarEntry(Ue,st,vt,Lt)},setStatusBarMessage(we,ke){return xt.setStatusBarMessage(we,ke)},withScmProgress(we){return ne.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),vi.withProgress(Ue,{location:V.ProgressLocation.SourceControl},(ke,Ne)=>we({report(st){}}))},withProgress(we,ke){return vi.withProgress(Ue,we,ke)},createOutputChannel(we,ke){return Ei.createOutputChannel(we,ke,Ue)},createWebviewPanel(we,ke,Ne,st){return Ri.createWebviewPanel(Ue,we,ke,Ne,st)},createWebviewTextEditorInset(we,ke,Ne,st){return(0,ze.$aF)(Ue,"editorInsets"),Ci.createWebviewEditorInset(we,ke,Ne,st,Ue)},createTerminal(we,ke,Ne){return typeof we=="object"?"pty"in we?bt.createExtensionTerminal(we):bt.createTerminalFromOptions(we):bt.createTerminal(we,ke,Ne)},registerTerminalLinkProvider(we){return bt.registerLinkProvider(we)},registerTerminalProfileProvider(we,ke){return bt.registerProfileProvider(Ue,we,ke)},registerTerminalQuickFixProvider(we,ke){return(0,ze.$aF)(Ue,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(we,Ue.identifier.value,ke)},registerTreeDataProvider(we,ke){return bi.registerTreeDataProvider(we,ke,Ue)},createTreeView(we,ke){return bi.createTreeView(we,ke,Ue)},registerWebviewPanelSerializer:(we,ke)=>Ri.registerWebviewPanelSerializer(Ue,we,ke),registerCustomEditorProvider:(we,ke,Ne={})=>cn.registerCustomEditorProvider(Ue,we,ke,Ne),registerFileDecorationProvider(we){return nt.registerFileDecorationProvider(we,Ue)},registerUriHandler(we){return mi.registerUriHandler(Ue,we)},createQuickPick(){return ni.createQuickPick(Ue)},createInputBox(){return ni.createInputBox(Ue)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(we,ke,Ne){return Ai.onDidChangeActiveColorTheme(we,ke,Ne)},registerWebviewViewProvider(we,ke,Ne){return Mi.registerWebviewViewProvider(Ue,we,ke,Ne?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,ke,Ne){return St.onDidChangeActiveNotebookEditor(we,ke,Ne)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,ke,Ne){return $i.onDidChangeNotebookEditorSelection(we,ke,Ne)},onDidChangeNotebookEditorVisibleRanges(we,ke,Ne){return $i.onDidChangeNotebookEditorVisibleRanges(we,ke,Ne)},showNotebookDocument(we,ke){return St.showNotebookDocument(we,ke)},registerExternalUriOpener(we,ke,Ne){return(0,ze.$aF)(Ue,"externalUriOpener"),un.registerExternalUriOpener(Ue.identifier,we,ke,Ne)},registerProfileContentHandler(we,ke){return(0,ze.$aF)(Ue,"profileContentHandlers"),ln.registrProfileContentHandler(Ue,we,ke)},registerQuickDiffProvider(we,ke,Ne,st){return(0,ze.$aF)(Ue,"quickDiffProvider"),Ii.registerQuickDiffProvider($t(we),ke,Ne,st)},get tabGroups(){return xe.tabGroups},registerShareProvider(we,ke){return(0,ze.$aF)(Ue,"shareProvider"),Ki.registerShareProvider($t(we),ke)}},sn={get rootPath(){return ne.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(we){throw new F.$8("rootPath")},getWorkspaceFolder(we){return ft.getWorkspaceFolder(we)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(we){throw new F.$8("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(we){throw new F.$8("workspaceFile")},updateWorkspaceFolders:(we,ke,...Ne)=>ft.updateWorkspaceFolders(Ue,we,ke||0,...Ne),onDidChangeWorkspaceFolders:function(we,ke,Ne){return ft.onDidChangeWorkspace(we,ke,Ne)},asRelativePath:(we,ke)=>ft.getRelativePath(we,ke),findFiles:(we,ke,Ne,st)=>ft.findFiles(we,ke,Ne,Ue.identifier,st),findTextInFiles:(we,ke,Ne,st)=>{(0,ze.$aF)(Ue,"findTextInFiles");let vt,Lt;return typeof ke=="object"?(vt=ke,Lt=Ne):(vt={},Lt=ke,st=Ne),ft.findTextInFiles(we,vt||{},Lt,Ue.identifier,st)},save:we=>((0,ze.$aF)(Ue,"saveEditor"),ft.save(we)),saveAs:we=>((0,ze.$aF)(Ue,"saveEditor"),ft.saveAs(we)),saveAll:we=>ft.saveAll(we),applyEdit(we,ke){return hn.applyWorkspaceEdit(we,Ue,ke)},createFileSystemWatcher:(we,ke,Ne,st)=>{let vt;return typeof ke=="boolean"?vt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!st}:ke&&((0,ze.$aF)(Ue,"createFileSystemWatcher"),vt=ke),Xt.createFileSystemWatcher(ft,Ue,we,vt)},get textDocuments(){return Ct.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new F.$8("textDocuments")},openTextDocument(we){let ke;const Ne=we;if(typeof we=="string")ke=Promise.resolve(A.URI.file(we));else if(A.URI.isUri(we))ke=Promise.resolve(we);else if(!Ne||typeof Ne=="object")ke=Ct.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>Ct.ensureDocumentData(st).then(vt=>vt.document))},onDidOpenTextDocument:(we,ke,Ne)=>Ct.onDidAddDocument(we,ke,Ne),onDidCloseTextDocument:(we,ke,Ne)=>Ct.onDidRemoveDocument(we,ke,Ne),onDidChangeTextDocument:(we,ke,Ne)=>Ct.onDidChangeDocument(we,ke,Ne),onDidSaveTextDocument:(we,ke,Ne)=>Ct.onDidSaveDocument(we,ke,Ne),onWillSaveTextDocument:(we,ke,Ne)=>qi.getOnWillSaveTextDocumentEvent(Ue)(we,ke,Ne),get notebookDocuments(){return St.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,ke){let Ne;if(A.URI.isUri(we))Ne=we,await St.openNotebookDocument(we);else if(typeof we=="string")Ne=A.URI.revive(await St.createNotebookDocument({viewType:we,content:ke}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(we,ke,Ne){return ii.onDidSaveNotebookDocument(we,ke,Ne)},onDidChangeNotebookDocument(we,ke,Ne){return ii.onDidChangeNotebookDocument(we,ke,Ne)},onWillSaveNotebookDocument(we,ke,Ne){return Di.getOnWillSaveNotebookDocumentEvent(Ue)(we,ke,Ne)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(we,ke,Ne,st){return St.registerNotebookSerializer(Ue,we,ke,Ne,(0,ze.$_E)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(we,ke,Ne)=>Ti.onDidChangeConfiguration(we,ke,Ne),getConfiguration(we,ke){return ke=arguments.length===1?void 0:ke,Ti.getConfiguration(we,ke,Ue)},registerTextDocumentContentProvider(we,ke){return ki.registerTextDocumentContentProvider(we,ke)},registerTaskProvider:(we,ke)=>(ne.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(Ue,we,ke)),registerFileSystemProvider(we,ke,Ne){return(0,Ve.$Oc)(Vi.registerFileSystemProvider(Ue,we,ke,Ne),It.addFileSystemProvider(we,ke,Ne))},get fs(){return It.value},registerFileSearchProvider:(we,ke)=>((0,ze.$aF)(Ue,"fileSearchProvider"),Rt.registerFileSearchProvider(we,ke)),registerTextSearchProvider:(we,ke)=>((0,ze.$aF)(Ue,"textSearchProvider"),Rt.registerTextSearchProvider(we,ke)),registerRemoteAuthorityResolver:(we,ke)=>((0,ze.$aF)(Ue,"resolvers"),kt.registerRemoteAuthorityResolver(we,ke)),registerResourceLabelFormatter:we=>((0,ze.$aF)(Ue,"resolvers"),Hi.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,ze.$aF)(Ue,"resolvers"),kt.getRemoteExecServer(we)),onDidCreateFiles:(we,ke,Ne)=>Xt.onDidCreateFile(we,ke,Ne),onDidDeleteFiles:(we,ke,Ne)=>Xt.onDidDeleteFile(we,ke,Ne),onDidRenameFiles:(we,ke,Ne)=>Xt.onDidRenameFile(we,ke,Ne),onWillCreateFiles:(we,ke,Ne)=>Xt.getOnWillCreateFileEvent(Ue)(we,ke,Ne),onWillDeleteFiles:(we,ke,Ne)=>Xt.getOnWillDeleteFileEvent(Ue)(we,ke,Ne),onWillRenameFiles:(we,ke,Ne)=>Xt.getOnWillRenameFileEvent(Ue)(we,ke,Ne),openTunnel:we=>((0,ze.$aF)(Ue,"tunnels"),Se.openTunnel(Ue,we).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,ze.$aF)(Ue,"tunnels"),Se.getTunnels()},onDidChangeTunnels:(we,ke,Ne)=>((0,ze.$aF)(Ue,"tunnels"),Se.onDidChangeTunnels(we,ke,Ne)),registerPortAttributesProvider:(we,ke)=>((0,ze.$aF)(Ue,"portsAttributes"),Se.registerPortsAttributesProvider(we,ke)),registerTunnelProvider:(we,ke)=>((0,ze.$aF)(Ue,"tunnelFactory"),Se.registerTunnelProvider(we,ke)),registerTimelineProvider:(we,ke)=>((0,ze.$aF)(Ue,"timeline"),Gi.registerTimelineProvider(we,ke,Ue.identifier,gt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:we=>((0,ze.$aF)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,ke,Ne)=>ft.onDidGrantWorkspaceTrust(we,ke,Ne),registerEditSessionIdentityProvider:(we,ke)=>((0,ze.$aF)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(we,ke)),onWillCreateEditSessionIdentity:(we,ke,Ne)=>((0,ze.$aF)(Ue,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Ue)(we,ke,Ne)),registerCanonicalUriProvider:(we,ke)=>((0,ze.$aF)(Ue,"canonicalUriProvider"),ft.registerCanonicalUriProvider(we,ke)),getCanonicalUri:(we,ke,Ne)=>((0,ze.$aF)(Ue,"canonicalUriProvider"),ft.provideCanonicalUri(we,ke,Ne))},fn={get inputBox(){return ne.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),wi.getLastInputBox(Ue)},createSourceControl(we,ke,Ne){return wi.createSourceControl(Ue,we,ke,Ne)}},on={createCommentController(we,ke){return Pi.createCommentController(Ue,we,ke)}},an={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},get stackFrameFocus(){return dt.stackFrameFocus},onDidStartDebugSession(we,ke,Ne){return dt.onDidStartDebugSession(we,ke,Ne)},onDidTerminateDebugSession(we,ke,Ne){return dt.onDidTerminateDebugSession(we,ke,Ne)},onDidChangeActiveDebugSession(we,ke,Ne){return dt.onDidChangeActiveDebugSession(we,ke,Ne)},onDidReceiveDebugSessionCustomEvent(we,ke,Ne){return dt.onDidReceiveDebugSessionCustomEvent(we,ke,Ne)},onDidChangeBreakpoints(we,ke,Ne){return dt.onDidChangeBreakpoints(we,ke,Ne)},onDidChangeStackFrameFocus(we,ke,Ne){return(0,ze.$aF)(Ue,"debugFocus"),dt.onDidChangeStackFrameFocus(we,ke,Ne)},registerDebugConfigurationProvider(we,ke,Ne){return dt.registerDebugConfigurationProvider(we,ke,Ne||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,ke){return dt.registerDebugAdapterDescriptorFactory(Ue,we,ke)},registerDebugAdapterTrackerFactory(we,ke){return dt.registerDebugAdapterTrackerFactory(we,ke)},startDebugging(we,ke,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?dt.startDebugging(we,ke,{parentSession:Ne}):dt.startDebugging(we,ke,Ne||{})},stopDebugging(we){return dt.stopDebugging(we)},addBreakpoints(we){return dt.addBreakpoints(we)},removeBreakpoints(we){return dt.removeBreakpoints(we)},asDebugSourceUri(we,ke){return dt.asDebugSourceUri(we,ke)}},Oi={registerTaskProvider:(we,ke)=>Gt.registerTaskProvider(Ue,we,ke),fetchTasks:we=>Gt.fetchTasks(we),executeTask:we=>Gt.executeTask(Ue,we),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(we,ke,Ne)=>Gt.onDidStartTask(we,ke,Ne),onDidEndTask:(we,ke,Ne)=>Gt.onDidEndTask(we,ke,Ne),onDidStartTaskProcess:(we,ke,Ne)=>Gt.onDidStartTaskProcess(we,ke,Ne),onDidEndTaskProcess:(we,ke,Ne)=>Gt.onDidEndTaskProcess(we,ke,Ne)},Ni={createNotebookController(we,ke,Ne,st,vt){return oi.createNotebookController(Ue,we,ke,Ne,st,(0,ze.$_E)(Ue,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(we,ke)=>St.registerNotebookCellStatusBarItemProvider(Ue,we,ke),createRendererMessaging(we){return Si.createRendererMessaging(Ue,we)},createNotebookControllerDetectionTask(we){return(0,ze.$aF)(Ue,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Ue,we)},registerKernelSourceActionProvider(we,ke){return(0,ze.$aF)(Ue,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Ue,we,ke)},onDidChangeNotebookCellExecutionState(we,ke,Ne){return(0,ze.$aF)(Ue,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(we,ke,Ne)}},ji={t(...we){if(typeof we[0]=="string"){const ke=we.shift(),Ne=!we||typeof we[0]!="object"?we:we[0];return Vt.getMessage(Ue.identifier.value,{message:ke,args:Ne})}return Vt.getMessage(Ue.identifier.value,we[0])},get bundle(){return Vt.getBundle(Ue.identifier.value)},get uri(){return Vt.getBundleUri(Ue.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(we,ke){return(0,ze.$aF)(Ue,"interactive"),Ji.registerProvider(Ue,we,ke={label:ke?.label??Ue.displayName??Ue.name})},registerInteractiveSessionProvider(we,ke){return(0,ze.$aF)(Ue,"interactive"),gi.registerChatProvider(Ue,we,ke)},sendInteractiveRequestToProvider(we,ke){return(0,ze.$aF)(Ue,"interactive"),gi.sendInteractiveRequestToProvider(we,ke)},get onDidPerformUserAction(){return(0,ze.$aF)(Ue,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(we,ke){return(0,ze.$aF)(Ue,"interactive"),gi.transferChatSession(we,ke)}},zi={getRelatedInformation(we,ke){return(0,ze.$aF)(Ue,"aiRelatedInformation"),Yi.getRelatedInformation(Ue,we,ke)},registerRelatedInformationProvider(we,ke){return(0,ze.$aF)(Ue,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(Ue,we,ke)},registerEmbeddingVectorProvider(we,ke){return(0,ze.$aF)(Ue,"aiRelatedInformation"),Li.registerEmbeddingVectorProvider(Ue,we,ke)}},Ui={registerChatResponseProvider(we,ke,Ne){return(0,ze.$aF)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,we,ke,Ne)},requestChatAccess(we){return(0,ze.$aF)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,we)},registerVariable(we,ke,Ne){return(0,ze.$aF)(Ue,"chatVariables"),Zi.registerVariableResolver(Ue,we,ke,Ne)},registerMappedEditsProvider(we,ke){return(0,ze.$aF)(Ue,"mappedEditsProvider"),ut.registerMappedEditsProvider(Ue,we,ke)},registerAgent(we,ke,Ne){return(0,ze.$aF)(Ue,"chatAgents"),Qi.registerAgent(Ue.identifier,we,ke,Ne)}};return{version:lt.version,ai:zi,authentication:xi,commands:_i,comments:on,chat:Ui,debug:an,env:en,extensions:tn,interactive:di,l10n:ji,languages:nn,notebooks:Ni,scm:fn,tasks:Oi,tests:dn,window:rn,workspace:sn,Breakpoint:V.$aL,TerminalOutputAnchor:V.TerminalOutputAnchor,ChatMessage:V.$3L,ChatMessageRole:V.ChatMessageRole,ChatVariableLevel:V.ChatVariableLevel,CallHierarchyIncomingCall:V.$zK,CallHierarchyItem:V.$yK,CallHierarchyOutgoingCall:V.$AK,CancellationError:F.$4,CancellationTokenSource:C.$Wd,CandidatePortSource:v.CandidatePortSource,CodeAction:V.$vK,CodeActionKind:V.$wK,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.$BK,Color:V.$OK,ColorInformation:V.$PK,ColorPresentation:V.$QK,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentState:V.CommentState,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.$IK,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.$JK,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.$YK,DebugAdapterExecutable:V.$eL,DebugAdapterInlineImplementation:V.$hL,DebugAdapterNamedPipeServer:V.$gL,DebugAdapterServer:V.$fL,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.$qK,DiagnosticRelatedInformation:V.$pK,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.$cK,DocumentHighlight:V.$sK,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.$NK,DocumentSymbol:V.$uK,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.$kL,InlineValueText:V.$lL,InlineValueVariableLookup:V.$mL,InlineValueEvaluatableExpression:V.$nL,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:d.$Md,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.$xL,FileDecoration2:V.$xL,FileSystemError:V.$pL,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:V.$qL,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.$cL,InlineCompletionItem:V.$KK,InlineCompletionList:V.$LK,Hover:V.$rK,IndentAction:w.IndentAction,Location:V.$oK,MarkdownString:V.$CK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:V.$DK,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.$dK,ProcessExecution:V.$WK,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.$wL,Range:V.$eK,RelativePattern:V.$$K,Selection:V.$fK,SelectionRange:V.$xK,SemanticTokens:V.$tL,SemanticTokensBuilder:V.$sL,SemanticTokensEdit:V.$uL,SemanticTokensEdits:V.$vL,SemanticTokensLegend:V.$rL,ShellExecution:V.$XK,ShellQuoting:V.ShellQuoting,SignatureHelp:V.$FK,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.$EK,SnippetString:V.$nK,SourceBreakpoint:V.$bL,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.$tK,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.$ZK,TaskGroup:V.$VK,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.$RK,TerminalQuickFixExecuteTerminalCommand:V.$TK,TerminalQuickFixOpener:V.$SK,TerminalLocation:V.TerminalLocation,TerminalProfile:V.$UK,TerminalExitReason:V.TerminalExitReason,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.$jK,SnippetTextEdit:V.$lK,TextEditorCursorStyle:b.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,SyntaxTokenType:V.SyntaxTokenType,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.$0K,ThemeIcon:V.$9K,TreeItem:V.$1K,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.$SL,UIKind:y.UIKind,Uri:A.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.$mK,DocumentDropEdit:V.$7K,DocumentPasteEdit:V.$8K,InlayHint:V.$HK,InlayHintLabelPart:V.$GK,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.$iK,ResolvedAuthority:V.$gK,ManagedResolvedAuthority:V.$hK,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.$HL,NotebookRange:V.$zL,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.$AL,NotebookData:V.$BL,NotebookRendererScript:V.$FL,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.$DL,NotebookCellOutputItem:V.$CL,NotebookCellStatusBarItem:V.$EL,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.$kK,NotebookKernelSourceAction:V.$GL,PortAttributes:V.$JL,LinkedEditingRanges:V.$IL,TestResultState:V.TestResultState,TestRunRequest:V.$KL,TestMessage:V.$LL,TestMessage2:V.$LL,TestTag:V.$ML,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:Oe.TextSearchCompleteMessageType,DataTransfer:V.$6K,DataTransferItem:V.$2K,CoveredCount:V.$NL,FileCoverage:V.$OL,StatementCoverage:V.$PL,BranchCoverage:V.$QL,FunctionCoverage:V.$RL,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.$TL,TabInputTextDiff:V.$UL,TabInputTextMerge:V.$VL,TabInputCustom:V.$WL,TabInputNotebook:V.$YL,TabInputNotebookDiff:V.$ZL,TabInputWebview:V.$XL,TabInputTerminal:V.$1L,TabInputInteractiveWindow:V.$2L,TelemetryTrustedValue:fe.$go,LogLevel:ie.LogLevel,EditSessionIdentityMatch:ot.EditSessionIdentityMatch,InteractiveSessionVoteDirection:V.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:V.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:V.InteractiveEditorResponseFeedbackKind,StackFrameFocus:V.$iL,ThreadFocus:V.$jL,RelatedInformationType:V.RelatedInformationType}}}e.$Pdc=qt}),define(De[355],Ce([1,0,103,152,39,149,40,33,69,44,93,94,95,115,72,89,151,71,55,114,88,70,150,13,56,112,113]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m,h,t,n,a,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$tr)(i.$qcc,i.$pcc,1),(0,C.$tr)(n.$9i,t.$Qdc,1),(0,C.$tr)(p.$Pbc,p.$Qbc,1),(0,C.$tr)(b.$xM,b.$wM,0),(0,C.$tr)(A.$3bc,A.$1bc,0),(0,C.$tr)(c.$fcc,c.$ecc,0),(0,C.$tr)(I.$6cc,I.$0cc,0),(0,C.$tr)(M.$Xcc,M.$Wcc,0),(0,C.$tr)(E.$mM,E.$lM,0),(0,C.$tr)(s.$rcc,s.$scc,0),(0,C.$tr)(r.$Mbc,r.$Lbc,0),(0,C.$tr)(F.$Dcc,F.$Ccc,1),(0,C.$tr)(v.$ddc,v.$edc,0),(0,C.$tr)(y.$bcc,y.$acc,0),(0,C.$tr)(R.$1cc,R.$Zcc,0),(0,C.$tr)(w.$icc,w.$lcc,0),(0,C.$tr)(D.$Wvb,D.$Xvb,0),(0,C.$tr)(l.$Tcc,l.$Scc,0),(0,C.$tr)(d.$Zbc,d.$Ybc,0),(0,C.$tr)(o.$ncc,o.$mcc,0),(0,C.$tr)(m.$vM,m.$sM,0),(0,C.$tr)(h.$2cc,h.$3cc,0),(0,C.$tr)(a.$4cc,a.$5cc,0)}),define(De[116],Ce([1,0,19,13,36,92]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=e.$8dc=e.$7dc=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$7dc=A;function b(I,v,y,D){const p=(0,C.$1b)(y,E),l=new d.$JI(v,p,D),c=l.preview.matches;return{ranges:(0,C.$1b)(p,w),uri:I,preview:{text:l.preview.text,matches:(0,C.$1b)(c,w)}}}e.$8dc=b;function E(I){return new d.$KI(I.start.line,I.start.character,I.end.line,I.end.character)}function w(I){return new M.$yI(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let R=class{constructor(v,y){this.a=v,this.b=y}appendLine(v){this.b.debug(`${this.a}#search`,v)}};e.$9dc=R,e.$9dc=R=He([Be(1,F.$8i)],R)}),define(De[356],Ce([1,0,49,16,76,32,12,15,116,357]),function($e,e,C,F,d,M,A,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=e.$$dc=e.$0dc=void 0;const R=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(o,m,h,t){const n=v(o,m,h,t),a=m.folder.fsPath;return{cmd:C.spawn(R,n.args,{cwd:a}),rgDiskPath:R,siblingClauses:n.siblingClauses,rgArgs:n,cwd:a}}e.$0dc=I;function v(o,m,h,t){const n=["--files","--hidden","--case-sensitive","--no-require-git"];D([m],h,!1).forEach(i=>{const s=(0,E.$7dc)(i);if(n.push("-g",s),A.$k){const u=(0,d.$ml)(s);u!==s&&n.push("-g",u)}});const a=y([m],t,void 0,!1);return a.globArgs.forEach(i=>{const s=`!${(0,E.$7dc)(i)}`;if(n.push("-g",s),A.$k){const u=(0,d.$ml)(s);u!==s&&n.push("-g",u)}}),m.disregardIgnoreFiles!==!1?n.push("--no-ignore"):m.disregardParentIgnoreFiles!==!1&&n.push("--no-ignore-parent"),m.ignoreSymlinks||n.push("--follow"),o.exists&&n.push("--quiet"),n.push("--no-config"),m.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:a.siblingClauses}}function y(o,m,h,t=!0){const n=[];let a={};return o.forEach(i=>{const s=Object.assign({},i.excludePattern||{},m||{}),u=p(s,t?i.folder.fsPath:void 0,h);n.push(...u.globArgs),u.siblingClauses&&(a=Object.assign(a,u.siblingClauses))}),{globArgs:n,siblingClauses:a}}function D(o,m,h=!0){const t=[];return o.forEach(n=>{const a=Object.assign({},m||{},n.includePattern||{}),i=p(a,h?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function p(o,m,h){const t=[],n={};return Object.keys(o).forEach(a=>{if(h&&h.has(a)||!a)return;const i=o[a];a=c(m?l(m,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof i=="boolean"&&i?(a.startsWith("\\\\")&&(a+="**"),t.push(r(a))):i&&i.when&&(n[a]=i)}),{globArgs:t,siblingClauses:n}}function l(o,m){return F.$hc(m)?m:F.$ic(o,m)}e.$$dc=l;function c(o){return o=b.$Je(o,"\\"),b.$Je(o,"/")}function r(o){return M.$Sf(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.$_dc=r}),define(De[358],Ce([1,0,49,53,16,359,19,47,35,76,32,12,37,15,18,29,36,356,127]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=e.$aec=void 0;const o=new Set;process.on("exit",()=>{o.forEach(a=>a())});class m{constructor(i){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=i,this.b=i.filePattern||"",this.d=i.includePattern&&E.$uj(i.includePattern),this.f=i.maxResults||null,this.g=!!i.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,r.$vq)(this.b).normalizedLowercase),this.u=i.excludePattern&&E.$uj(i.excludePattern),this.t=new Map,i.folderQueries.forEach(s=>{const u=Object.assign({},s.excludePattern||{},this.a.excludePattern||{}),S=s.folder.fsPath;i.folderQueries.map(k=>k.folder.fsPath).filter(k=>k!==S).forEach(k=>{(0,R.$Wf)(k,S)&&(u[d.$kc(S,k)]=!0)}),this.t.set(S,new t(u,S))})}cancel(){this.l=!0,o.forEach(i=>i())}walk(i,s,u,S,k){if(this.m=v.$Id.create(!1),this.l)return k(null,this.j);s.forEach($=>{const f=d.$mc($.fsPath);this.u&&this.u($.fsPath,f)||this.J(u,{relativePath:$.fsPath,searchPath:void 0})}),this.r=v.$Id.create(!1),this.w(i,($,f)=>{this.x(this.y,this,$,u,S,g=>{if(g){const P=(0,b.$yi)(g);console.error(P),this.q.push(P),f(g,void 0)}else f(null,void 0)})},($,f)=>{this.m.stop();const g=$?A.$Gb($)[0]:null;k(g,this.j)})}w(i,s,u){const S=new Array(i.length),k=new Array(i.length);let $=!1,f=0;if(i.length===0)return u(null,[]);i.forEach((g,P)=>{s(g,(O,N)=>{if(O?($=!0,S[P]=null,k[P]=O):(S[P]=N,k[P]=null),++f===i.length)return u($?k:null,S)})})}x(i,s,...u){try{i.apply(s,u)}catch(S){u[u.length-1](S)}}y(i,s,u,S){const k=i.folder.fsPath,$=I.$k,f=()=>L&&L.kill();o.add(f);let g=K=>{o.delete(f),g=()=>{},S(K)},P="";const O=this.D(),N=(0,c.$0dc)(this.a,i,this.a.includePattern,this.t.get(i.folder.fsPath).expression),L=N.cmd,j=!Object.keys(N.siblingClauses).length,z=N.rgArgs.args.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");let T=`${N.rgDiskPath} ${z}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),u({message:T}),this.s=0,this.z(L,"utf8",u,(K,V,fe)=>{if(K){g(K);return}if(this.j){g();return}const Q=(P+($?w.$ll(V||""):V)).split(`
`);if(fe){const Z=Q.length;Q[Z-1]=Q[Z-1].trim(),Q[Z-1]||Q.pop()}else P=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){g(new Error("Splitting up files failed"));return}if(this.s+=Q.length,j){for(const Z of Q)if(this.J(s,{base:k,relativePath:Z,searchPath:this.N(i,Z)}),this.j){f();break}(fe||this.j)&&g();return}this.G(i,O,k,Q,s),fe&&(this.H(O,k,s),g())})}spawnFindCmd(i){const s=this.t.get(i.folder.fsPath),u=s.getBasenameTerms(),S=s.getPathTerms(),k=["-L","."];if(u.length||S.length){k.push("-not","(","(");for(const $ of u)k.push("-name",$),k.push("-o");for(const $ of S)k.push("-path",$),k.push("-o");k.pop(),k.push(")","-prune",")")}return k.push("-type","f"),C.spawn("find",k,{cwd:i.folder.fsPath})}readStdout(i,s,u){let S="";this.z(i,s,()=>{},(k,$,f)=>{if(k){u(k);return}S+=$,f&&u(null,S)})}z(i,s,u,S){let k=(g,P,O)=>{(g||O)&&(k=()=>{},this.r?.stop()),S(g,P,O)},$=!1;i.stdout?(this.A(i.stdout,s,k),i.stdout.once("data",()=>$=!0)):u({message:"stdout is null"});let f;i.stderr?f=this.B(i.stderr):u({message:"stderr is null"}),i.on("error",g=>{k(g)}),i.on("close",g=>{let P;!$&&(P=this.C(f,s))&&n(P)?k(new Error(`command failed with error code ${g}: ${this.C(f,s)}`)):(this.g&&g===0&&(this.j=!0),k(null,"",!0))})}A(i,s,u){const S=new M.StringDecoder(s);return i.on("data",k=>{u(null,S.write(k))}),S}B(i){const s=[];return i.on("data",u=>{s.push(u)}),s}C(i,s){const u=new M.StringDecoder(s);return i.map(S=>u.write(S)).join("")}D(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}G(i,{pathToEntries:s},u,S,k){S.indexOf(this.b)!==-1&&this.J(k,{base:u,relativePath:this.b,searchPath:this.N(i,this.b)});const $=f=>{const g=d.$mc(f),P=d.$lc(f);let O=s[P];O||(O=s[P]=[],$(P)),O.push({base:u,relativePath:f,basename:g,searchPath:this.N(i,f)})};S.forEach($)}H({rootEntries:i,pathToEntries:s},u,S){const k=this,$=this.t.get(u),f=this.b;function g(P){k.o++;const O=(0,l.$ZI)(()=>P.map(N=>N.basename));for(let N=0,L=P.length;N<L;N++){const j=P[N],{relativePath:z,basename:T}=j;if($.test(z,T,f!==T?O:void 0))continue;const K=s[z];if(K)g(K);else{if(k.p++,z===f)continue;k.J(S,j)}if(k.j)break}}g(i)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(i,s,u,S,k){const $=i.folder,f=(0,l.$ZI)(()=>u);this.w(u,(g,P)=>{if(this.l||this.j)return P(null);const O=s?[s,g].join(d.sep):g;if(this.t.get(i.folder.fsPath).test(O,g,this.a.filePattern!==g?f:void 0))return P(null);const N=[$.fsPath,O].join(d.sep);F.lstat(N,(L,j)=>{if(L||this.l||this.j)return P(null);this.L(N,j,(z,T)=>z||this.l||this.j?P(null):T.isDirectory()?(this.o++,this.M(N,j,(K,V)=>K||this.l||this.j||(V=V||"",this.v[V])?P(null):(this.v[V]=!0,p.Promises.readdir(N).then(fe=>{if(this.l||this.j)return P(null);this.I(i,O,fe,S,X=>P(X||null))},fe=>{P(null)})))):(this.p++,O===this.b||this.h&&D.$Bf(T.size)&&T.size>this.h||this.J(S,{base:$.fsPath,relativePath:O,searchPath:this.N(i,O)}),P(null,void 0)))})},g=>{const P=g&&A.$Gb(g);return k(P&&P.length>0?P[0]:void 0)})}J(i,s){this.K(s)&&(!this.d||this.d(s.relativePath,d.$mc(s.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||i(s))}K(i){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,l.$UI)(i,this.c)}return!0}L(i,s,u){return s.isSymbolicLink()?F.stat(i,u):u(null,s)}M(i,s,u){return s.isSymbolicLink()?F.realpath(i,(S,k)=>S?u(S):u(null,k)):u(null,i)}N(i,s){return i.folderName?d.$ic(i.folderName,s):s}}e.$aec=m;class h{constructor(i){this.a=i.folderQueries,this.b=i.extraFileResources||[],this.c=new m(i)}search(i,s,u){this.c.walk(this.a,this.b,i,s,(S,k)=>{u(S,{limitHit:k,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$bec=h;class t{constructor(i,s){this.expression=i,this.c=s,this.d(i)}d(i){let s,u;Object.keys(i).filter(S=>i[S]).forEach(S=>{d.$hc(S)?(s=s||E.$pj(),s[S]=i[S]):(u=u||E.$pj(),u[S]=i[S])}),this.a=s&&E.$uj(s,{trimForExclusions:!0}),this.b=u&&E.$uj(u,{trimForExclusions:!0})}test(i,s,u){return this.b&&this.b(i,s,u)||this.a&&this.a(d.$ic(this.c,i),s,u)}getBasenameTerms(){const i=[];return this.a&&i.push(...E.$wj(this.a)),this.b&&i.push(...E.$wj(this.b)),i}getPathTerms(){const i=[];return this.a&&i.push(...E.$xj(this.a)),this.b&&i.push(...E.$xj(this.b)),i}}function n(a){const i=a.trim().split(`
`),s=i[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return y.$pf(i[i.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}}),define(De[360],Ce([1,0,96,22,182,21]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=e.$xC=e.$wC=e.$vC=e.$uC=e.$tC=e.$sC=e.$rC=e.$qC=e.DecodeStreamErrorKind=e.$pC=e.$oC=e.$nC=e.$mC=e.$lC=e.$kC=e.$jC=e.$iC=void 0,e.$iC="utf8",e.$jC="utf8bom",e.$kC="utf16be",e.$lC="utf16le";function A(s){return[e.$iC,e.$jC,e.$kC,e.$lC].some(u=>u===s)}e.$mC=A,e.$nC=[254,255],e.$oC=[255,254],e.$pC=[239,187,191];const b=512,E=512,w=512*8,R=512*128;var I;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class v extends Error{constructor(u,S){super(u),this.decodeStreamErrorKind=S}}e.$qC=v;class y{static async create(u){let S;if(u!==e.$iC)S=(await(0,d.$hC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(c(u));else{const k=new TextDecoder;S={write($){return k.decode($,{stream:!0})},end(){return k.decode()}}}return new y(S)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function D(s,u){const S=u.minBytesRequiredForDetection??u.guessEncoding?w:E;return new Promise((k,$)=>{const f=(0,C.$1d)(j=>j.join("")),g=[];let P=0,O;const N=new M.$Wd,L=async()=>{try{const j=await i({buffer:F.$ae.concat(g),bytesRead:P},u.guessEncoding);if(j.seemsBinary&&u.acceptTextOnly)throw new v("Stream is binary but only text is accepted for decoding",1);j.encoding=await u.overwriteEncoding(j.encoding),O=await y.create(j.encoding);const z=O.write(F.$ae.concat(g).buffer);f.write(z),g.length=0,P=0,k({stream:f,detected:j})}catch(j){N.cancel(),f.destroy(),$(j)}};(0,C.$5d)(s,{onData:async j=>{O?f.write(O.write(j.buffer)):(g.push(j),P+=j.byteLength,P>=S&&(s.pause(),await L(),setTimeout(()=>s.resume())))},onError:j=>f.error(j),onEnd:async()=>{O||await L(),f.end(O?.end())}},N.token)})}e.$rC=D;async function p(s,u,S){const $=(await(0,d.$hC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(c(u),S);let f=!1,g=!1;return{read(){if(g)return null;const P=s.read();if(typeof P!="string"){if(g=!0,!f&&S?.addBOM)switch(u){case e.$iC:case e.$jC:return F.$ae.wrap(Uint8Array.from(e.$pC));case e.$kC:return F.$ae.wrap(Uint8Array.from(e.$nC));case e.$lC:return F.$ae.wrap(Uint8Array.from(e.$oC))}const O=$.end();return O&&O.length>0?(f=!0,F.$ae.wrap(O)):null}return f=!0,F.$ae.wrap($.write(P))}}}e.$sC=p;async function l(s){return(await(0,d.$hC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(c(s))}e.$tC=l;function c(s){return s===e.$jC||s===null?e.$iC:s}e.$uC=c;function r(s,u){if(!s||u<e.$nC.length)return null;const S=s.readUInt8(0),k=s.readUInt8(1);if(S===e.$nC[0]&&k===e.$nC[1])return e.$kC;if(S===e.$oC[0]&&k===e.$oC[1])return e.$lC;if(u<e.$pC.length)return null;const $=s.readUInt8(2);return S===e.$pC[0]&&k===e.$pC[1]&&$===e.$pC[2]?e.$jC:null}e.$vC=r;const o=["ascii","utf-16","utf-32"];async function m(s){const u=await(0,d.$hC)("jschardet","dist/jschardet.min.js"),S=s.slice(0,R),k=n(S.buffer),$=u.detect(k);if(!$||!$.encoding)return null;const f=$.encoding.toLowerCase();return 0<=o.indexOf(f)?null:t($.encoding)}const h={ibm866:"cp866",big5:"cp950"};function t(s){const u=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return h[u]||u}function n(s){let u="";for(let S=0;S<s.length;S++)u+=String.fromCharCode(s[S]);return u}function a(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=s.match(/windows(\d+)/);return u?"windows-"+u[1]:s}}}e.$wC=a;function i({buffer:s,bytesRead:u},S){let k=r(s,u),$=!1;if(k!==e.$kC&&k!==e.$lC&&s){let f=!0,g=!0,P=!1;for(let O=0;O<u&&O<b;O++){const N=O%2===1,L=s.readUInt8(O)===0;if(L&&(P=!0),f&&(N&&!L||!N&&L)&&(f=!1),g&&(N&&L||!N&&!L)&&(g=!1),L&&!f&&!g)break}P&&(f?k=e.$lC:g?k=e.$kC:$=!0)}return S&&!$&&!k&&s?m(s.slice(0,u)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:$,encoding:k}}e.$xC=i,e.$yC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[154],Ce([1,0,360,29,153]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class M extends d.$_cc{constructor(b,E,w=F,R="searchProcess"){super(b,E,{readdir:I=>w.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,C.$wC)(I)},R)}}e.$jec=M}),define(De[155],Ce([1,0,49,376,359,19,73,35,16,15,2,36,92,377,357,116]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=e.$hec=e.$gec=e.$fec=e.$eec=e.$dec=e.$cec=void 0;const l=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class c{constructor(g){this.a=g}provideTextSearchResults(g,P,O,N){return this.a.appendLine(`provideTextSearchResults ${g.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((L,j)=>{N.onCancellationRequested(()=>Z());const z=n(g,P),T=P.folder.fsPath,K=z.map(G=>G.match(/^-/)?G:`'${G}'`).join(" ");this.a.appendLine(`${l} ${K}
 - cwd: ${T}`);let V=C.spawn(l,z,{cwd:T});V.on("error",G=>{console.error(G),this.a.appendLine("Error: "+(G&&G.message)),j((0,I.$QI)(new I.$OI(G&&G.message,I.SearchErrorCode.rgProcessError)))});let fe=!1;const X=new m(P.maxResults,T,P.previewOptions);X.on("result",G=>{fe=!0,x="",O.report(G)});let Q=!1;const Z=()=>{Q=!0,V?.kill(),X?.cancel()};let oe=!1;X.on("hitLimit",()=>{oe=!0,Z()});let x="";V.stdout.on("data",G=>{X.handleData(G),fe||(x+=G)});let ae=!1;V.stdout.once("data",()=>ae=!0);let ve="";V.stderr.on("data",G=>{const U=G.toString();this.a.appendLine(U),ve.length+U.length<1e6&&(ve+=U)}),V.on("close",()=>{if(this.a.appendLine(ae?"Got data from stdout":"No data from stdout"),this.a.appendLine(fe?"Got result from parser":"No result from parser"),x&&this.a.appendLine(`Got data without result: ${x}`),this.a.appendLine(""),Q)L({limitHit:oe});else{X.flush(),V=null;let G;ve&&!ae&&(G=r(ve))?j((0,I.$QI)(new I.$OI(G.message,G.code))):L({limitHit:oe})}})})}}e.$cec=c;function r(f){const g=f.split(`
`),P=g[0].trim();if(g.some(N=>N.startsWith("regex parse error")))return new I.$OI(o(g),I.SearchErrorCode.regexParseError);const O=P.match(/grep config error: unknown encoding: (.*)/);if(O)return new I.$OI(`Unknown encoding: ${O[1]}`,I.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new I.$OI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new I.$OI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new I.$OI(P,I.SearchErrorCode.regexParseError)}function o(f){const g=["Regex parse error"],P=f.filter(O=>O.startsWith("PCRE2:"));if(P.length>=1){const O=P[0].replace("PCRE2:","");if(O.indexOf(":")!==-1&&O.split(":").length>=2){const N=O.split(":")[1];g.push(":"+N)}}return g.join("")}class m extends F.EventEmitter{constructor(g,P,O){super(),this.g=g,this.h=P,this.j=O,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new d.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(g,P){return super.on(g,P),this}handleData(g){if(this.b)return;const P=typeof g=="string"?g:this.d.write(g);this.k(P)}k(g){let P=g.indexOf(`
`);const O=this.a+g;if(P>=0)P+=this.a.length;else{this.a=O;return}let N=0;for(;P>=0;)this.m(O.substring(N,P).trim()),N=P+1,P=O.indexOf(`
`,N);this.a=O.substring(N)}m(g){if(this.b||!g)return;let P;try{P=JSON.parse(g)}catch{throw new Error(`malformed line from rg: ${g}`)}if(P.type==="match"){const O=h(P.data.path),N=R.URI.file(E.$ic(this.h,O)),L=this.n(P.data,N);this.p(L),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const O=h(P.data.path),N=R.URI.file(E.$ic(this.h,O));this.o(P.data,N).forEach(j=>this.p(j))}}n(g,P){const O=g.line_number-1,N=h(g.lines),L=Buffer.from(N);let j=0,z=0,T=O;g.submatches.length===0&&g.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const K=(0,M.$Gb)(g.submatches.map((V,fe)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const X=h(V.match),Q=L.slice(j,V.start).toString(),Z=t(Q),oe=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+z,x=t(X),ae=Z.numLines+T,ve=x.numLines+ae,G=x.numLines>0?x.lastLineLength:x.lastLineLength+oe;return j=V.end,z=G,T=ve,new v.$yI(ae,oe,ve,G)}));return(0,p.$8dc)(P,N,K,this.j)}o(g,P){const O=h(g.lines),N=g.line_number;return O.replace(/\r?\n$/,"").split(`
`).map((L,j)=>({text:L,uri:P,lineNumber:N+j}))}p(g){this.emit("result",g)}}e.$dec=m;function h(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function t(f){const g=/\n/g;let P=0,O=-1,N;for(;N=g.exec(f);)P++,O=N.index;const L=O>=0?f.length-O-1:f.length;return{numLines:P,lastLineLength:L}}function n(f,g){const P=["--hidden","--no-require-git"];P.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:O,otherIncludes:N}=(0,A.$J)(g.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const j=new Set;N.forEach(z=>{j.add(z)}),P.push("-g","!*"),j.forEach(z=>{a(z).map(p.$7dc).forEach(T=>{P.push("-g",T)})})}O&&O.length&&O.forEach(j=>{P.push("-g",j)}),g.excludes.map(p.$7dc).forEach(j=>P.push("-g",`!${j}`)),g.maxFileSize&&P.push("--max-filesize",g.maxFileSize+""),g.useIgnoreFiles?g.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),g.followSymlinks&&P.push("--follow"),g.encoding&&g.encoding!=="utf8"&&P.push("--encoding",g.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,w.$Ee)(f.pattern),f.isRegExp=!0),g.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),f.isRegExp&&(f.pattern=i(f.pattern),P.push("--engine","auto"));let L;if(f.isWordMatch){const z=(0,w.$Me)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",z)}else if(f.isRegExp){let j=u(f.pattern);j=S(j),P.push("--regexp",j)}else L=f.pattern,P.push("--fixed-strings");return P.push("--no-config"),g.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),f.isMultiline&&P.push("--multiline"),g.beforeContext&&P.push("--before-context",g.beforeContext+""),g.afterContext&&P.push("--after-context",g.afterContext+""),P.push("--"),L&&P.push(L),P.push("."),P}e.$eec=n;function a(f){return $(f).flatMap(P=>{const O=(0,b.$sj)(P,"/");return O.map((N,L)=>O.slice(0,L+1).join("/"))})}function i(f){const g=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(g);)f=f.replace(g,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(P);)f=f.replace(P,"$1\\x{$2}");return f}e.$fec=i;const s=f=>f.type==="Assertion"&&f.kind==="lookbehind";function u(f){let g;try{g=new y.RegExpParser().parsePattern(f)}catch{return f}let P="",O=0;const N=(z,T,K)=>{P+=f.slice(O,z)+K,O=T},L=[];return new y.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const T=L[0];if(!T)N(z.start,z.end,"\\r?\\n");else if(!L.some(s))if(T.type==="CharacterClass")if(T.negate){const K=f.slice(T.start+2,z.start)+f.slice(z.end,T.end-1);T.parent?.type==="Quantifier"?N(T.start,T.end,K?`[^${K}]`:"."):N(T.start,T.end,"(?!\\r?\\n"+(K?`|[${K}]`:"")+")")}else{const K=f.slice(T.start+1,z.start)+f.slice(z.end,T.end-1);N(T.start,T.end,K===""?"\\r?\\n":`(?:[${K}]|\\r?\\n)`)}else T.type==="Quantifier"&&N(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){L.unshift(z)},onQuantifierLeave(){L.shift()},onCharacterClassRangeEnter(z){L.unshift(z)},onCharacterClassRangeLeave(){L.shift()},onCharacterClassEnter(z){L.unshift(z)},onCharacterClassLeave(){L.shift()},onAssertionEnter(z){s(z)&&L.push(z)},onAssertionLeave(z){L[0]===z&&L.shift()}}).visit(g),P+=f.slice(O),P}e.$gec=u;function S(f){return f.replace(/\n/g,"\\r?\\n")}e.$hec=S;function k(f){let g=!1,P=!1,O="",N="";for(let L=0;L<f.length;L++){const j=f[L];switch(j){case"\\":P?(g?N+="\\"+j:O+="\\"+j,P=!1):P=!0;break;case"{":if(P)g?N+=j:O+=j,P=!1;else{if(g)return{strInBraces:O+"{"+N+"{"+f.substring(L+1)};g=!0}break;case"}":if(P)g?N+=j:O+=j,P=!1;else{if(g)return{fixedStart:O,strInBraces:N,fixedEnd:f.substring(L+1)};O+=j}break;default:g?N+=(P?"\\":"")+j:O+=(P?"\\":"")+j,P=!1;break}}return{strInBraces:O+(g?"{"+N:"")}}function $(f){const{fixedStart:g,strInBraces:P,fixedEnd:O}=k(f);if(g===void 0||O===void 0)return[P];let N=(0,b.$sj)(P,",");N.length||(N=[""]);const L=$(O);return N.flatMap(j=>{const z=g+j;return L.map(T=>z+T)})}e.$iec=$}),define(De[361],Ce([1,0,21,155,84,17]),function($e,e,C,F,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;class A{constructor(w){this.b=w,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(w,R,I,v){const y=new F.$cec(this.b);if(R.folder.scheme===M.Schemas.vscodeUserData){const D={...R,folder:R.folder.with({scheme:M.Schemas.file})},p=new d.$1u(l=>I.report({...l,uri:l.uri.with({scheme:R.folder.scheme})}));return this.c(v,l=>y.provideTextSearchResults(w,D,p,l))}else return this.c(v,D=>y.provideTextSearchResults(w,R,I,D))}async c(w,R){const I=b(w);this.a.add(I);const v=await R(I.token);return this.a.delete(I),v}d(){this.a.forEach(w=>w.cancel())}}e.$mec=A;function b(E){const w=new C.$Wd;return E.onCancellationRequested(()=>w.cancel()),w}}),define(De[362],Ce([1,0,29,155,154]),function($e,e,C,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;class M{constructor(E){this.a=E}search(E,w,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(y){R({message:y})}},v=new d.$jec(this.a,new F.$cec(I),C);return new Promise((y,D)=>v.search(p=>{w(p.map(A))},E).then(p=>y({limitHit:p.limitHit,type:"success",stats:p.stats}),D))}}e.$kec=M;function A(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((E,w)=>{if(w.ranges){const R=w;return E+(Array.isArray(R.ranges)?R.ranges.length:1)}else return E+1},0)}}}),define(De[363],Ce([1,0,19,9,8,4,127,16,37,2,30,36,358,362]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;class D{static{this.a=512}constructor(m="searchProcess"){this.d=m,this.b=Object.create(null)}fileSearch(m){let h;const t=c(m),n=new M.$Md({onDidAddFirstListener:()=>{h=(0,F.$Gg)(a=>this.doFileSearchWithEngine(v.$bec,t,i=>n.fire(i),a)),h.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{h.cancel()}});return n.event}textSearch(m){let h;const t=c(m),n=new M.$Md({onDidAddFirstListener:()=>{h=(0,F.$Gg)(a=>this.f(t,i=>n.fire(i),a)),h.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{h.cancel()}});return n.event}f(m,h,t){return m.maxFileSize=this.g().maxFileSize,new y.$kec(m).search(t,h,h)}g(){return{maxFileSize:process.arch==="ia32"?300*R.$Ek.MB:16*R.$Ek.GB}}doFileSearch(m,h,t){return this.doFileSearchWithEngine(v.$bec,m,h,t)}doFileSearchWithEngine(m,h,t,n,a=D.a){let i=0;const s=S=>{Array.isArray(S)?(i+=S.length,t(S.map(k=>this.h(k)))):S.relativePath?(i++,t(this.h(S))):t(S)};if(h.sortByScore){let S=this.l(h,s,n);if(!S){const k=h.maxResults?Object.assign({},h,{maxResults:null}):h,$=new m(k);S=this.j($,h,t,s,n)}return new Promise((k,$)=>{S.then(([f,g])=>{const P=g.map(O=>this.h(O));this.o(P,t,a),k(f)},$)})}const u=new m(h);return this.r(u,s,a,n).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:this.d,fromCache:!1,resultCount:i,sortingTime:void 0}}))}h(m){return{path:m.base?(0,b.$ic)(m.base,m.relativePath):m.relativePath}}j(m,h,t,n,a){const i=new M.$Md;let s=(0,F.$Gg)(S=>{let k=[];const $=f=>{Array.isArray(f)?k=f:(n(f),i.fire(f))};return this.r(m,$,-1,S).then(f=>[f,k])}),u;if(h.cacheKey){u=this.k(h.cacheKey);const S={promise:s,event:i.event,resolved:!1};u.resultsToSearchCache[h.filePattern||""]=S,s.then(()=>{S.resolved=!0},k=>{delete u.resultsToSearchCache[h.filePattern||""]}),s=this.s(s)}return s.then(([S,k])=>{const $=u?u.scorerCache:Object.create(null),f=(typeof h.maxResults!="number"||h.maxResults>0)&&E.$Id.create(!1);return this.n(h,k,$,a).then(g=>{const P=f?f.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:h.folderQueries.length,resultCount:g.length},messages:S.messages,limitHit:S.limitHit||typeof h.maxResults=="number"&&k.length>h.maxResults},g]})})}k(m){const h=this.b[m];return h||(this.b[m]=new p)}l(m,h,t){const n=m.cacheKey&&this.b[m.cacheKey];if(!n)return;const a=this.q(n,m.filePattern||"",h,t);if(a)return a.then(([i,s,u])=>{const S=E.$Id.create(!1);return this.n(m,s,n.scorerCache,t).then(k=>{const $=S.elapsed(),f={fromCache:!0,detailStats:u,type:this.d,resultCount:s.length,sortingTime:$};return[{type:"success",limitHit:i.limitHit||typeof m.maxResults=="number"&&s.length>m.maxResults,stats:f},k]})})}n(m,h,t,n){const a=(0,A.$vq)(m.filePattern||""),i=(u,S)=>(0,A.$uq)(u,S,a,!0,l,t),s=typeof m.maxResults=="number"?m.maxResults:Number.MAX_VALUE;return C.$Fb(h,i,s,1e4,n)}o(m,h,t){if(t&&t>0)for(let n=0;n<m.length;n+=t)h(m.slice(n,n+t));else h(m)}q(m,h,t,n){const a=E.$Id.create(!1),i=h.indexOf(b.sep)>=0;let s;for(const $ in m.resultsToSearchCache)if(h.startsWith($)){if(i&&$.indexOf(b.sep)<0&&$!=="")continue;const f=m.resultsToSearchCache[$];s={promise:this.s(f.promise),event:f.event,resolved:f.resolved};break}if(!s)return null;const u=a.elapsed(),S=E.$Id.create(!1),k=s.event(t);return n&&n.onCancellationRequested(()=>{k.dispose()}),s.promise.then(([$,f])=>{if(n&&n.isCancellationRequested)throw(0,d.$5)();const g=[],P=(0,A.$vq)(h).normalizedLowercase;for(const O of f)(0,I.$UI)(O,P)&&g.push(O);return[$,g,{cacheWasResolved:s.resolved,cacheLookupTime:u,cacheFilterTime:S.elapsed(),cacheEntryCount:f.length}]})}r(m,h,t,n){return new Promise((a,i)=>{let s=[];n?.onCancellationRequested(()=>m.cancel()),m.search(u=>{u&&(t?(s.push(u),t>0&&s.length>=t&&(h(s),s=[])):h(u))},u=>{h(u)},(u,S)=>{s.length&&h(s),u?i(u):a(S)})})}clearCache(m){return delete this.b[m],Promise.resolve(void 0)}s(m){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(h,t){return m.then(h,t)}catch(h){return this.then(void 0,h)}finally(h){return m.finally(h)}}}}e.$lec=D;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const l=new class{getItemLabel(o){return(0,b.$mc)(o.relativePath)}getItemDescription(o){return(0,b.$lc)(o.relativePath)}getItemPath(o){return o.relativePath}};function c(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(r),extraFileResources:o.extraFileResources&&o.extraFileResources.map(m=>w.URI.revive(m))}}function r(o){return{...o,folder:w.URI.revive(o.folder)}}}),define(De[364],Ce([1,0,3,17,2,29,13,27,20,95,66,36,363,361,116,154]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;let l=class extends w.$edc{constructor(r,o,m,h){super(r,m,h),this.s=M,this.t=-1,this.v=null,this.w=!1,this.x=new C.$Qc;const t=new D.$9dc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new y.$mec(t))),o.remote.isRemote&&o.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const r=new D.$9dc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.file,new y.$mec(r))),this.x.add(this.z(F.Schemas.file,new v.$lec("fileSearchProvider")))}z(r,o){const m=this.d++;return this.v=o,this.t=m,this.c.$registerFileSearchProvider(m,this.o(r)),(0,C.$Pc)(()=>{this.v=null,this.c.$unregisterProvider(m)})}$provideFileSearchResults(r,o,m,h){const t=(0,w.$fdc)(m);return r===this.t?this.A(r,o,t,h):super.$provideFileSearchResults(r,o,m,h)}A(r,o,m,h){const t=n=>{if((0,I.$TI)(n)&&(n=[n]),Array.isArray(n)){this.c.$handleFileMatch(r,o,n.map(a=>d.URI.file(a.path)));return}n.message&&this.n.debug("ExtHostSearch",n.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(m,t,h)}$clearCache(r){return this.v?.clearCache(r),super.$clearCache(r)}q(r,o){return new p.$jec(r,o,void 0,"textSearchProvider")}};e.$nec=l,e.$nec=l=He([Be(0,E.$bM),Be(1,b.$rM),Be(2,R.$Wbc),Be(3,A.$8i)],l)}),define(De[117],Ce([1,0,378,60,63,379,22,8,4,3,16,12,31,80,81]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class p{traceSocketEvent(f,g){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,g)}constructor(f,g=""){this.f=!0,this.debugLabel=g,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.$Z)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const g=P=>{this.traceSocketEvent("read",P),f(A.$ae.wrap(P))};return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(f){const g=P=>{f({type:0,hadError:P,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(f){const g=()=>{f()};return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,b.$Z)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,b.$Z)(g)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,g)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Ch=p;var l;(function($){$[$.MinHeaderByteSize=2]="MinHeaderByteSize",$[$.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(l||(l={}));var c;(function($){$[$.PeekHeader=1]="PeekHeader",$[$.ReadHeader=2]="ReadHeader",$[$.ReadBody=3]="ReadBody",$[$.Fin=4]="Fin"})(c||(c={}));class r extends w.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,g){this.socket.traceSocketEvent(f,g)}constructor(f,g,P,O){super(),this.f=this.B(new E.$Md),this.g=this.B(new E.$Md),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:g,inflateBytesLength:P?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new o(this,g,P,O,this.f,(N,L)=>this.m(N,L))),this.B(this.a.onError(N=>{console.error(N),(0,b.$Z)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new D.$xh,this.B(this.socket.onData(N=>this.n(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let g=0;for(;g<f.byteLength;)this.a.writeMessage(f.slice(g,Math.min(g+262144,f.byteLength)),{compressed:!0,opcode:2}),g+=262144}m(f,{compressed:g,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let O=2;f.byteLength<126?O+=0:f.byteLength<2**16?O+=2:O+=8;const N=A.$ae.alloc(O),L=g?64:0,j=P&15;if(N.writeUInt8(128|L|j,0),f.byteLength<126)N.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){N.writeUInt8(126,1);let z=1;N.writeUInt8(f.byteLength>>>8&255,++z),N.writeUInt8(f.byteLength>>>0&255,++z)}else{N.writeUInt8(127,1);let z=1;N.writeUInt8(0,++z),N.writeUInt8(0,++z),N.writeUInt8(0,++z),N.writeUInt8(0,++z),N.writeUInt8(f.byteLength>>>24&255,++z),N.writeUInt8(f.byteLength>>>16&255,++z),N.writeUInt8(f.byteLength>>>8&255,++z),N.writeUInt8(f.byteLength>>>0&255,++z)}this.socket.write(A.$ae.concat([N,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const g=this.b.peek(this.j.readLen),P=g.readUInt8(0),O=(P&128)>>>7,N=(P&64)>>>6,L=P&15,j=g.readUInt8(1),z=(j&128)>>>7,T=j&127;this.j.state=2,this.j.readLen=2+(z?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.j.opcode=L,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const g=this.b.read(this.j.readLen),P=g.readUInt8(1),O=(P&128)>>>7;let N=P&127,L=1;N===126?N=g.readUInt8(++L)*2**8+g.readUInt8(++L):N===127&&(N=g.readUInt8(++L)*0+g.readUInt8(++L)*0+g.readUInt8(++L)*0+g.readUInt8(++L)*0+g.readUInt8(++L)*2**24+g.readUInt8(++L)*2**16+g.readUInt8(++L)*2**8+g.readUInt8(++L));let j=0;O&&(j=g.readUInt8(++L)*2**24+g.readUInt8(++L)*2**16+g.readUInt8(++L)*2**8+g.readUInt8(++L)),this.j.state=3,this.j.readLen=N,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const g=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",g),t(g,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",g),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(g,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(g,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Dh=r;class o extends w.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$ae.alloc(0)}constructor(f,g,P,O,N,L){super(),this.n=f,this.r=N,this.s=L,this.a=this.B(new E.$Md),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$Md),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$Md),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,g?(this.b=this.B(new m(this.n,O,P,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(f,g){this.g.push({data:f,options:g}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:g}=this.g.shift();if(this.f&&g.compressed){const P=await this.w(this.f,f);this.s(P,g)}else this.s(f,{...g,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,g){return new Promise((P,O)=>{f.write(g),f.flush(N=>P(N))})}acceptFrame(f,g,P){this.h.push({data:f,isCompressed:g,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const g=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(g)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,g,P){return new Promise((O,N)=>{f.write(g),P&&f.write(A.$ae.fromByteArray([0,0,255,255])),f.flush(L=>O(L))})}}class m extends w.$Rc{get recordedInflateBytes(){return this.j?A.$ae.concat(this.f):A.$ae.alloc(0)}constructor(f,g,P,O){super(),this.h=f,this.j=g,this.a=this.B(new E.$Md),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(O),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(A.$ae.wrap(N))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const g=A.$ae.concat(this.g);this.g.length=0,f(g)})}}class h extends w.$Rc{constructor(f,g){super(),this.g=f,this.a=this.B(new E.$Md),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(A.$ae.wrap(P))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let g=A.$ae.concat(this.f);this.f.length=0,g=g.slice(0,g.byteLength-4),f(g)})}}function t($,f){if(f===0)return;const g=$.byteLength>>>2;for(let z=0;z<g;z++){const T=$.readUInt32BE(z*4);$.writeUInt32BE(T^f,z*4)}const P=g*4,O=$.byteLength-P,N=f>>>24&255,L=f>>>16&255,j=f>>>8&255;O>=1&&$.writeUInt8($.readUInt8(P)^N,P),O>=2&&$.writeUInt8($.readUInt8(P+1)^L,P+1),O>=3&&$.writeUInt8($.readUInt8(P+2)^j,P+2)}e.$Eh=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function a(){const $=(0,v.$dg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${$}-sock`;const f=process.platform!=="darwin"&&e.$Eh?e.$Eh:(0,d.tmpdir)(),g=(0,R.$ic)(f,`vscode-ipc-${$}.sock`);return s(g),g}e.$Fh=a;function i($,f,g){const P=(0,C.createHash)("md5").update($).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${g}-${f}-sock`;const O=g.substr(0,4),N=f.substr(0,6),L=P.substr(0,8);let j;return process.platform!=="darwin"&&e.$Eh&&!process.env.VSCODE_PORTABLE?j=(0,R.$ic)(e.$Eh,`vscode-${L}-${O}-${N}.sock`):j=(0,R.$ic)($,`${O}-${N}.sock`),s(j),j}e.$Gh=i;function s($){const f=n[I.$u];typeof f=="number"&&$.length>=f&&console.warn(`WARNING: IPC handle "${$}" is longer than ${f} chars, try a shorter --user-data-dir`)}class u extends y.$rh{static b(f){const g=E.Event.fromNodeEventEmitter(f,"connection");return E.Event.map(g,P=>({protocol:new D.$yh(new p(P,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(P,"close"))}))}constructor(f){super(u.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Hh=u;function S($){return new Promise((f,g)=>{const P=(0,F.createServer)();P.on("error",g),P.listen($,()=>{P.removeListener("error",g),f(new u(P))})})}e.$Ih=S;function k($,f){return new Promise((g,P)=>{const O=(0,F.createConnection)($,()=>{O.removeListener("error",P),g(D.$zh.fromSocket(new p(O,`ipc-client${f}`),f))});O.once("error",P)})}e.$Jh=k}),define(De[365],Ce([1,0,60,63,163,117,9,3,12,50,13,135,247,248,106,86,22]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W7b=e.$V7b=e.$U7b=e.$T7b=void 0;async function c(t,n,a,i,s){let u;for(let S=3;S&&(u?.dispose(),u=await new r(t,n,a,i,s).waitForReady(),!(s&&d.$gg[s]||!d.$gg[u.tunnelLocalPort]));S--);return u}class r extends b.$Rc{constructor(n,a,i,s,u){super(),this.m=a,this.n=u,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=C.createServer(),this.c=new A.$Rg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(a=>{a()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,a=(0,p.$_u)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,d.$hg)(n,2,1e3,a),s=null;return this.b.listen(i,this.m),await this.c.wait(),s=this.b.address(),s||(i=0,this.b.listen(i,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(n){n.pause();const a=(0,p.$0u)(this.tunnelRemoteHost)||(0,p.$_u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.$4k)(this.a,a,this.tunnelRemotePort),s=i.getSocket(),u=i.readEntireBuffer();i.dispose(),u.byteLength>0&&n.write(u.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),s.end()}),n.on("close",()=>s.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),s instanceof M.$Ch?s.socket.destroy():s.end()}),s instanceof M.$Ch?this.t(n,s):this.s(n,s),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),s.end()})}s(n,a){a.onClose(()=>n.destroy()),a.onEnd(()=>n.end()),a.onData(i=>n.write(i.buffer)),n.on("data",i=>a.write(l.$ae.wrap(i))),n.resume()}t(n,a){const i=a.socket;i.on("end",()=>n.end()),i.on("close",()=>n.end()),i.on("error",()=>{n.destroy()}),i.pipe(n),n.pipe(i)}}e.$T7b=r;let o=class extends p.$cv{constructor(n,a,i,s,u){super(a,u),this.u=n,this.v=i,this.w=s}isPortPrivileged(n){return(0,p.$av)(n,this.l,E.OS,F.release())}s(n,a,i,s,u,S,k,$){const f=this.r(a,i);if(f)return++f.refcount,f.value;if((0,p.$7u)(n))return this.t(n,a,i,u,S,k,$);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${i} on local port ${u}.`);const g={commit:this.w.commit,quality:this.w.quality,addressProvider:n,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},P=c(g,s,a,i,u);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(a,i,P),P}}};e.$U7b=o,e.$U7b=o=He([Be(0,y.$Xk),Be(1,R.$8i),Be(2,D.$1k),Be(3,I.$nj),Be(4,w.$hi)],o);let m=class extends o{constructor(n,a,i,s,u){super(n,a,i,s,u)}};e.$V7b=m,e.$V7b=m=He([Be(0,y.$Xk),Be(1,R.$8i),Be(2,D.$1k),Be(3,I.$nj),Be(4,w.$hi)],m);let h=class extends b.$Rc{constructor(n,a,i,s,u){super(),this.b=n,this.c=a,this.f=i,this.g=s,this.h=u,this.a=new Map}async openTunnel(n,a,i,s,u,S,k,$,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${s} on local port ${S}.`),!this.a.has(n)){const g=new m(this.b,this.c,this.g,this.f,this.h);this.B(g),this.a.set(n,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(a,i,s,u,S,k,$,f)}};e.$W7b=h,e.$W7b=h=He([Be(0,y.$Xk),Be(1,R.$8i),Be(2,I.$nj),Be(3,D.$1k),Be(4,w.$hi)],h)}),define(De[366],Ce([1,0,117,267,53,33,2,13,43]),function($e,e,C,F,d,M,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=void 0;class w{constructor(v,y,D){this.b=v,this.c=y,this.f=D,this.a=F.createServer((p,l)=>this.h(p,l)),this.g().catch(p=>(y.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,y){const D=(l,c)=>{y.writeHead(l,{"content-type":"application/json"}),y.end(JSON.stringify(c||null),r=>r&&this.c.error(r))},p=[];v.setEncoding("utf8"),v.on("data",l=>p.push(l)),v.on("end",async()=>{try{const l=JSON.parse(p.join(""));let c;switch(l.type){case"open":c=await this.i(l);break;case"openExternal":c=await this.j(l);break;case"status":c=await this.l(l);break;case"extensionManagement":c=await this.k(l);break;default:D(404,`Unknown message type: ${l.type}`);break}D(200,c)}catch(l){const c=l instanceof Error?l.message:JSON.stringify(l);D(500,c),this.c.error("Error while processing pipe request",l)}})}async i(v){const{fileURIs:y,folderURIs:D,forceNewWindow:p,diffMode:l,mergeMode:c,addMode:r,forceReuseWindow:o,gotoLineMode:m,waitMarkerFilePath:h,remoteAuthority:t}=v,n=[];if(Array.isArray(D))for(const u of D)try{n.push({folderUri:A.URI.parse(u)})}catch{}if(Array.isArray(y))for(const u of y)try{(0,E.$gi)(u)?n.push({workspaceUri:A.URI.parse(u)}):n.push({fileUri:A.URI.parse(u)})}catch{}const a=h?A.URI.file(h):void 0,s={forceNewWindow:p,diffMode:l,mergeMode:c,addMode:r,gotoLineMode:m,forceReuseWindow:o,preferNewWindow:!o&&!a&&!r,waitMarkerFileURI:a,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",n,s)}async j(v){for(const y of v.uris){const D=A.URI.parse(y),p=D.scheme==="file"?D:y;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k(v){const y=p=>p?.map(l=>/\.vsix$/i.test(l)?A.URI.parse(l):l),D={list:v.list,install:y(v.install),uninstall:y(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",D)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&d.existsSync(this.f)&&d.unlinkSync(this.f)}}e.$CM=w;let R=class extends w{constructor(v,y){super(v,y,(0,C.$Fh)())}};e.$DM=R,e.$DM=R=He([Be(0,M.$xM),Be(1,b.$8i)],R)}),define(De[367],Ce([1,0,54,354,349,266,45,337,2,17,7,366,100,335,336]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;class p extends d.$Tdc{j(){const r=this,o=globalThis._VSCODE_NODE_MODULES.module,m=o._load;o._load=function(a,i,s){return a=t(a),r.a.has(a)?r.a.get(a).load(a,E.URI.file((0,v.$5p)(i.filename)),u=>m.apply(this,[u,i,s])):m.apply(this,arguments)};const h=o._resolveLookupPaths;o._resolveLookupPaths=(n,a)=>h.call(this,t(n),a);const t=n=>{for(const a of r.b){const i=a(n);if(i){n=i;break}}return n}}}class l extends A.$ucc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async tb(){this.h.createInstance(y.$qec);const r=this.h.invokeFunction(F.$Pdc);if(this.h.createInstance(b.$pec),this.f.remote.isRemote&&this.f.remote.authority){const h=this.h.createInstance(I.$DM);process.env.VSCODE_IPC_HOOK_CLI=h.ipcHandlePath}this.h.createInstance(D.$rec),await this.h.createInstance(p,r,{mine:this.J,all:this.L}).install(),C.mark("code/extHost/didInitAPI");const m=await this.m.getConfigProvider();await(0,M.$oec)(this.j,m,this,this.s,this.z,this.f),C.mark("code/extHost/didInitProxyResolver")}ub(r){return r.main}async vb(r,o,m){if(o.scheme!==w.Schemas.file)throw new Error(`Cannot load URI: '${o}', must be of file-scheme`);let h=null;m.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${o.toString(!0)}`),this.s.flush();const t=r?.identifier.value;r&&await this.w.initializeLocalizedMessages(r);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),h=$e.__$__nodeRequire(o.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),m.codeLoadingStop()}return h}async $setRemoteEnvironment(r){if(this.f.remote.isRemote)for(const o in r){const m=r[o];m===null?delete process.env[o]:process.env[o]=m}}}e.$sec=l}),define(De[368],Ce([1,0,49,22,4,3,120,12,23,2,29,13,246,64,106,86,365,27,20,72,345]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=e.$zec=e.$yec=e.$xec=e.$wec=e.$vec=e.$uec=e.$tec=void 0;function h(f){const g=f.trim().split(`
`),P=[];return g.forEach(N=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(N);L&&L.length>=3&&P.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),P.reduce((N,L)=>(N[L.socket]=L,N),{})}e.$tec=h;function t(...f){const g=[].concat(...f.map(a));return[...new Map(g.filter(P=>P.st==="0A").map(P=>{const O=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:n(O[0]),port:parseInt(O[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$uec=t;function n(f){let g="";if(f.length===8)for(let P=f.length-2;P>=0;P-=2)g+=parseInt(f.substr(P,2),16),P!==0&&(g+=".");else for(let P=0;P<f.length;P+=8){const O=f.substring(P,P+8);let N="";for(let L=8;L>=2;L-=2)N+=O.substring(L-2,L),(L===6||L===2)&&(N=parseInt(N,16).toString(16),g+=`${N}`,N="",P+L!==f.length-6&&(g+=":"))}return g}e.$vec=n;function a(f){const g=f.trim().split(`
`),P=g.shift().trim().split(/\s+/).filter(N=>N!=="rx_queue"&&N!=="tm->when");return g.map(N=>N.trim().split(/\s+/).reduce((L,j,z)=>(L[P[z]||z]=j,L),{}))}e.$wec=a;function i(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/server-main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function s(f){const g=f.trim().split(`
`),P=[];return g.forEach(O=>{const N=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);N&&N.length>=4&&P.push({pid:parseInt(N[1],10),ppid:parseInt(N[2]),cmd:N[3]})}),P}e.$xec=s;async function u(f,g,P){const O=P.reduce((L,j)=>(L[j.pid]=j,L),{}),N=[];return f.forEach(({socket:L,ip:j,port:z})=>{const T=g[L]?g[L].pid:void 0,K=T?O[T]?.cmd:void 0;T&&K&&!i(K)&&N.push({host:j,port:z,detail:K,pid:T})}),N}e.$yec=u;function S(f,g,P){const O=new Map,N=s(g);for(const L of f){const j=P.get(L.port);if(j){O.set(L.port,j);continue}const z=N.find(T=>T.cmd.includes(`${L.port}`));if(z){let T=z,K;do K=N.find(V=>V.ppid===T.pid),K&&(T=K);while(K);O.set(L.port,{host:L.ip,port:L.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else O.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return O}e.$zec=S;let k=class extends o.$Xvb{constructor(g,P,O,N){super(g,P,O),this.D=P,this.F=N,this.y=void 0,this.z=new Map,this.C=!1,b.$l&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(g){if(g&&this.C)return;this.C=g;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new A.$Ol;let N=0;for(;this.C;){const L=new Date().getTime(),j=(await this.I()).filter(K=>(0,p.$0u)(K.host)||(0,p.$_u)(K.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(K=>K.port).join(", ")}`);const z=new Date().getTime()-L;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${z} ms.`),N++>3&&O.update(z),(!P||JSON.stringify(P)!==JSON.stringify(j))&&(P=j,await this.a.$onFoundNewCandidates(P));const T=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(K=>setTimeout(()=>K(),T))}}G(g){return Math.max(g*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(g=>g.port).join(", ")}`)}async I(){let g="",P="";try{g=await R.Promises.readFile("/proc/net/tcp","utf8"),P=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=t(g,P),N=await new Promise(X=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,Z,oe)=>{X(Z)})}),L=h(N),j=await R.Promises.readdir("/proc"),z=[];for(const X of j)try{const Q=Number(X),Z=E.$ug(w.URI.file("/proc"),X);if((await R.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(Q)){const x=await R.Promises.readlink(E.$ug(Z,"cwd").fsPath),ae=await R.Promises.readFile(E.$ug(Z,"cmdline").fsPath,"utf8");z.push({pid:Q,cwd:x,cmd:ae})}}catch{}const T=[],K=O.filter(X=>{const Q=L[X.socket];return Q||T.push(X),Q}),V=u(K,L,z);let fe;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const X=await new Promise(Q=>{(0,C.exec)("ps -F -A -l | grep root",(Z,oe,x)=>{Q(oe)})});this.z=S(T,X,this.z),fe=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${fe.map(Q=>Q.port).join(", ")}`)}return V.then(X=>fe?X.concat(fe):X)}w(g){return async P=>{const O=new l.$T7b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(L,j,z,T){const K=await g.makeConnection();return $.connect(K,j,z,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Ok(0),connectionToken:g.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await O.waitForReady();const N=new d.$Md;return{localAddress:(0,m.$AJ)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:N.event,dispose:()=>{O.dispose(),N.fire(),N.dispose()}}}}};e.$Aec=k,e.$Aec=k=He([Be(0,r.$bM),Be(1,c.$rM),Be(2,I.$8i),Be(3,D.$1k)],k);class $ extends v.$vkb{static connect(g,P,O,N){const L=new M.$Qc,j={onClose:L.add(new d.$Md),onData:L.add(new d.$Md),onEnd:L.add(new d.$Md)};L.add(g.onDidReceiveMessage(T=>j.onData.fire(F.$ae.wrap(T)))),L.add(g.onDidEnd(()=>j.onEnd.fire())),L.add(g.onDidClose(T=>j.onClose.fire({type:0,error:T,hadError:!!T})));const z=new $(g,N,j);return z.B(L),(0,v.$ukb)(z,P,O,N,j)}constructor(g,P,O){super(P,O),this.n=g}write(g){this.n.send(g.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(De[369],Ce([1,0,103,340,352,351,364,367,368,94,45,95,93,44,72,90,339,338,13,353,56,261,102,106,138]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c,r,o,m,h,t,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$tr)(R.$vcc,b.$sec,0),(0,C.$tr)(r.$9i,c.$Cec,1),(0,C.$tr)(r.$8i,new t.$Kh(h.$Sdc,[!1],!0)),(0,C.$tr)(n.$1k,a.$Y7b,1),(0,C.$tr)(p.$gcc,l.$Bec,0),(0,C.$tr)(w.$6cc,M.$6dc,0),(0,C.$tr)(I.$ddc,A.$nec,0),(0,C.$tr)(v.$1cc,d.$Xdc,0),(0,C.$tr)(y.$icc,F.$Wdc,0),(0,C.$tr)(D.$Wvb,E.$Aec,0),(0,C.$tr)(m.$4cc,o.$Dec,0)}),define(De[380],Ce([1,0,60,381,54,8,81,117,244,111,350,22,29,100,9,130,268,285,355,369]),function($e,e,C,F,d,M,A,b,E,w,R,I,v,y,D,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const r=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const s=globalThis._VSCODE_NODE_MODULES.module,u=s._load;s._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return u.apply(this,arguments)}})();const o=process.exit.bind(process);function m(s){process.exit=function(u){if(s)o(u);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let h=function(s){o()};function t(){const s=(0,c.$ym)(process.env);if(s.type===3)return new Promise((u,S)=>{const k=$=>{const f=$[0],g=new A.$Ah;f.on("message",P=>g.fire(I.$ae.wrap(P.data))),f.on("close",()=>{h("renderer closed the MessagePort")}),f.start(),u({onMessage:g.event,send:P=>f.postMessage(P.buffer)})};process.parentPort.on("message",$=>k($.ports))});if(s.type===2)return new Promise((u,S)=>{let k=null;const $=setTimeout(()=>{h("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),f=108e5,g=3e5,P=new D.$6g(()=>h("renderer disconnected for too long (1)"),f),O=new D.$6g(()=>h("renderer disconnected for too long (2)"),g);process.on("message",(L,j)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const z=I.$ae.wrap(Buffer.from(L.initialDataChunk,"base64"));let T;if(L.skipWebSocketFrames)T=new b.$Ch(j,"extHost-socket");else{const K=I.$ae.wrap(Buffer.from(L.inflateBytes,"base64"));T=new b.$Dh(new b.$Ch(j,"extHost-socket"),L.permessageDeflate,K,!1)}k?(P.cancel(),O.cancel(),k.beginAcceptReconnection(T,z),k.endAcceptReconnection(),k.sendResume()):(clearTimeout($),k=new A.$Bh({socket:T,initialChunk:z}),k.sendResume(),k.onDidDispose(()=>h("renderer disconnected")),u(k),k.onSocketClose(()=>{P.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;P.isScheduled()&&O.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const u=s.pipeName;return new Promise((S,k)=>{const $=C.createConnection(u,()=>{$.removeListener("error",k);const f=new A.$Bh({socket:new b.$Ch($,"extHost-renderer")});f.sendResume(),S(f)});$.once("error",k),$.on("close",()=>{h("renderer closed the socket")})})}}async function n(){const s=await t();return new class{constructor(){this.a=new A.$Ah,this.onMessage=this.a.event,this.b=!1,s.onMessage(u=>{(0,w.$_l)(u,2)?(this.b=!0,h("received terminate message from renderer")):this.a.fire(u)})}send(u){this.b||s.send(u)}async drain(){if(s.drain)return s.drain()}}}function a(s){return new Promise(u=>{const S=s.onMessage(k=>{S.dispose();const $=JSON.parse(k.toString()),f=$.commit,g=E.default.commit;if(f&&g&&f!==g&&o(55),$.parentPid){let P=0;setInterval(function(){try{process.kill($.parentPid,0),P=0}catch(N){N&&N.code==="EPERM"?(P++,P>=3&&h(`parent process ${$.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):h(`parent process ${$.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let O;try{O=globalThis._VSCODE_NODE_MODULES["native-watchdog"],O.start($.parentPid)}catch(N){(0,M.$Z)(N)}}s.send((0,w.$$l)(0)),u({protocol:s,initData:$})});s.send((0,w.$$l)(1))})}async function i(){const s=[];process.on("unhandledRejection",(P,O)=>{s.push(O),setTimeout(()=>{const N=s.indexOf(O);N>=0&&O.catch(L=>{s.splice(N,1),(0,M.$3)(L)||(console.warn(`rejected promise not handled within 1 second: ${L}`),L&&L.stack&&console.warn(`stack trace: ${L.stack}`),P&&(0,M.$Z)(P))})},1e3)}),process.on("rejectionHandled",P=>{const O=s.indexOf(P);O>=0&&s.splice(O,1)}),process.on("uncaughtException",function(P){(0,M.$Y)(P)||(0,M.$Z)(P)}),d.mark("code/extHost/willConnectToRenderer");const u=await n();d.mark("code/extHost/didConnectToRenderer");const S=await a(u);d.mark("code/extHost/didWaitForInitData");const{initData:k}=S;m(!!k.environment.extensionTestsLocationURI),k.environment.useHostProxy=r.useHostProxy!==void 0?r.useHostProxy!=="false":void 0,k.environment.skipWorkspaceStorageLock=(0,p.boolean)(r.skipWorkspaceStorageLock,!1);const $=new class{constructor(){this.pid=process.pid}exit(O){o(O)}fsExists(O){return v.Promises.exists(O)}fsRealpath(O){return(0,y.$4p)(O)}};let f=null;k.remote.authority&&r.transformURIs&&(f=(0,l.$xr)(k.remote.authority));const g=new R.$Vdc(S.protocol,k,$,f);h=P=>g.terminate(P)}i().catch(s=>console.log(s))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b63441dbc9f729977e8e97321f536a06521496f7/core/vs/workbench/api/node/extensionHostProcess.js.map
